#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2921
#define LARGE_STATE_COUNT 447
#define SYMBOL_COUNT 449
#define ALIAS_COUNT 23
#define TOKEN_COUNT 211
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 19
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 114

enum ts_symbol_identifiers {
  aux_sym_program_statement_token1 = 1,
  aux_sym_end_program_statement_token1 = 2,
  aux_sym_end_program_statement_token2 = 3,
  aux_sym_module_statement_token1 = 4,
  aux_sym_end_module_statement_token1 = 5,
  aux_sym_submodule_statement_token1 = 6,
  anon_sym_LPAREN = 7,
  anon_sym_COLON = 8,
  anon_sym_RPAREN = 9,
  aux_sym_end_submodule_statement_token1 = 10,
  aux_sym_interface_statement_token1 = 11,
  aux_sym_end_interface_statement_token1 = 12,
  aux_sym_assignment_token1 = 13,
  anon_sym_EQ = 14,
  aux_sym_operator_token1 = 15,
  aux_sym_operator_token2 = 16,
  aux_sym_defined_io_procedure_token1 = 17,
  aux_sym_defined_io_procedure_token2 = 18,
  aux_sym_defined_io_procedure_token3 = 19,
  aux_sym_defined_io_procedure_token4 = 20,
  aux_sym_subroutine_statement_token1 = 21,
  aux_sym_end_subroutine_statement_token1 = 22,
  aux_sym_module_procedure_statement_token1 = 23,
  aux_sym_end_module_procedure_statement_token1 = 24,
  aux_sym_function_statement_token1 = 25,
  aux_sym_language_binding_token1 = 26,
  anon_sym_COMMA = 27,
  aux_sym_procedure_attributes_token1 = 28,
  aux_sym_procedure_attributes_token2 = 29,
  aux_sym_procedure_attributes_token3 = 30,
  aux_sym_procedure_attributes_token4 = 31,
  aux_sym_procedure_attributes_token5 = 32,
  aux_sym_end_function_statement_token1 = 33,
  aux_sym_function_result_token1 = 34,
  aux_sym_contains_statement_token1 = 35,
  aux_sym_use_statement_token1 = 36,
  aux_sym_use_statement_token2 = 37,
  aux_sym_use_statement_token3 = 38,
  anon_sym_COLON_COLON = 39,
  aux_sym_included_items_token1 = 40,
  anon_sym_EQ_GT = 41,
  aux_sym_implicit_statement_token1 = 42,
  aux_sym_implicit_statement_token2 = 43,
  aux_sym_implicit_statement_token3 = 44,
  aux_sym_implicit_statement_token4 = 45,
  aux_sym_save_statement_token1 = 46,
  anon_sym_SLASH = 47,
  aux_sym_private_statement_token1 = 48,
  aux_sym_public_statement_token1 = 49,
  aux_sym_namelist_statement_token1 = 50,
  aux_sym_common_statement_token1 = 51,
  aux_sym_implicit_range_token1 = 52,
  anon_sym_DASH = 53,
  aux_sym_import_statement_token1 = 54,
  aux_sym__import_names_token1 = 55,
  aux_sym_derived_type_definition_token1 = 56,
  aux_sym_abstract_specifier_token1 = 57,
  aux_sym_base_type_specifier_token1 = 58,
  aux_sym_end_type_statement_token1 = 59,
  aux_sym__procedure_kind_token1 = 60,
  aux_sym__procedure_kind_token2 = 61,
  aux_sym__procedure_kind_token3 = 62,
  aux_sym__procedure_kind_token4 = 63,
  aux_sym_procedure_attribute_token1 = 64,
  aux_sym_procedure_attribute_token2 = 65,
  aux_sym_procedure_attribute_token3 = 66,
  aux_sym_procedure_attribute_token4 = 67,
  aux_sym_procedure_attribute_token5 = 68,
  aux_sym_procedure_attribute_token6 = 69,
  aux_sym_variable_attributes_token1 = 70,
  aux_sym_variable_attributes_token2 = 71,
  aux_sym_variable_attributes_token3 = 72,
  aux_sym_variable_attributes_token4 = 73,
  aux_sym_variable_attributes_token5 = 74,
  aux_sym_intrinsic_type_token1 = 75,
  aux_sym_intrinsic_type_token2 = 76,
  aux_sym_intrinsic_type_token3 = 77,
  aux_sym_intrinsic_type_token4 = 78,
  aux_sym_intrinsic_type_token5 = 79,
  aux_sym_intrinsic_type_token6 = 80,
  aux_sym_intrinsic_type_token7 = 81,
  aux_sym_intrinsic_type_token8 = 82,
  aux_sym_intrinsic_type_token9 = 83,
  aux_sym_intrinsic_type_token10 = 84,
  aux_sym_derived_type_token1 = 85,
  anon_sym_STAR = 86,
  aux_sym_size_token1 = 87,
  aux_sym_type_qualifier_token1 = 88,
  aux_sym_type_qualifier_token2 = 89,
  aux_sym_type_qualifier_token3 = 90,
  aux_sym_type_qualifier_token4 = 91,
  aux_sym_type_qualifier_token5 = 92,
  aux_sym_type_qualifier_token6 = 93,
  aux_sym_type_qualifier_token7 = 94,
  aux_sym_type_qualifier_token8 = 95,
  aux_sym_type_qualifier_token9 = 96,
  aux_sym_type_qualifier_token10 = 97,
  aux_sym_type_qualifier_token11 = 98,
  aux_sym_type_qualifier_token12 = 99,
  aux_sym_type_qualifier_token13 = 100,
  aux_sym_type_qualifier_token14 = 101,
  aux_sym_type_qualifier_token15 = 102,
  aux_sym_procedure_qualifier_token1 = 103,
  aux_sym_procedure_qualifier_token2 = 104,
  aux_sym_procedure_qualifier_token3 = 105,
  aux_sym_procedure_qualifier_token4 = 106,
  aux_sym_equivalence_statement_token1 = 107,
  aux_sym_stop_statement_token1 = 108,
  aux_sym_stop_statement_token2 = 109,
  aux_sym_stop_statement_token3 = 110,
  aux_sym_subroutine_call_token1 = 111,
  anon_sym_LT_LT_LT = 112,
  anon_sym_GT_GT_GT = 113,
  aux_sym_keyword_statement_token1 = 114,
  aux_sym_keyword_statement_token2 = 115,
  aux_sym_keyword_statement_token3 = 116,
  aux_sym_keyword_statement_token4 = 117,
  aux_sym_keyword_statement_token5 = 118,
  aux_sym_keyword_statement_token6 = 119,
  aux_sym_keyword_statement_token7 = 120,
  aux_sym_include_statement_token1 = 121,
  aux_sym_data_statement_token1 = 122,
  aux_sym_do_loop_statement_token1 = 123,
  aux_sym_end_do_loop_statement_token1 = 124,
  aux_sym_while_statement_token1 = 125,
  aux_sym_concurrent_header_token1 = 126,
  aux_sym_concurrent_locality_token1 = 127,
  aux_sym_concurrent_locality_token2 = 128,
  aux_sym_concurrent_locality_token3 = 129,
  aux_sym__inline_if_statement_token1 = 130,
  aux_sym__block_if_statement_token1 = 131,
  aux_sym_end_if_statement_token1 = 132,
  aux_sym_elseif_clause_token1 = 133,
  aux_sym_elseif_clause_token2 = 134,
  aux_sym__inline_where_statement_token1 = 135,
  aux_sym_end_where_statement_token1 = 136,
  aux_sym_elsewhere_clause_token1 = 137,
  aux_sym__forall_control_expression_token1 = 138,
  aux_sym_end_forall_statement_token1 = 139,
  aux_sym_select_case_statement_token1 = 140,
  aux_sym_select_case_statement_token2 = 141,
  aux_sym_select_case_statement_token3 = 142,
  aux_sym_select_type_statement_token1 = 143,
  aux_sym_select_rank_statement_token1 = 144,
  aux_sym_select_rank_statement_token2 = 145,
  aux_sym_end_select_statement_token1 = 146,
  aux_sym_type_statement_token1 = 147,
  aux_sym_type_statement_token2 = 148,
  aux_sym_type_statement_token3 = 149,
  aux_sym__class_default_token1 = 150,
  aux_sym_block_construct_token1 = 151,
  aux_sym_end_block_construct_statement_token1 = 152,
  aux_sym_associate_statement_token1 = 153,
  aux_sym_end_associate_statement_token1 = 154,
  aux_sym_format_statement_token1 = 155,
  sym_edit_descriptor = 156,
  aux_sym_hollerith_constant_token1 = 157,
  aux_sym_print_statement_token1 = 158,
  aux_sym_open_statement_token1 = 159,
  aux_sym_close_statement_token1 = 160,
  aux_sym_inquire_statement_token1 = 161,
  aux_sym_enum_statement_token1 = 162,
  aux_sym_enumerator_statement_token1 = 163,
  aux_sym_end_enum_statement_token1 = 164,
  aux_sym_file_position_statement_token1 = 165,
  aux_sym_file_position_statement_token2 = 166,
  aux_sym_file_position_statement_token3 = 167,
  aux_sym_file_position_statement_token4 = 168,
  anon_sym_PERCENT = 169,
  aux_sym_logical_expression_token1 = 170,
  aux_sym_logical_expression_token2 = 171,
  aux_sym_logical_expression_token3 = 172,
  aux_sym_logical_expression_token4 = 173,
  aux_sym_logical_expression_token5 = 174,
  anon_sym_LT = 175,
  aux_sym_relational_expression_token1 = 176,
  anon_sym_GT = 177,
  aux_sym_relational_expression_token2 = 178,
  anon_sym_LT_EQ = 179,
  aux_sym_relational_expression_token3 = 180,
  anon_sym_GT_EQ = 181,
  aux_sym_relational_expression_token4 = 182,
  anon_sym_EQ_EQ = 183,
  aux_sym_relational_expression_token5 = 184,
  anon_sym_SLASH_EQ = 185,
  aux_sym_relational_expression_token6 = 186,
  anon_sym_SLASH_SLASH = 187,
  anon_sym_PLUS = 188,
  anon_sym_STAR_STAR = 189,
  anon_sym_DOT = 190,
  aux_sym_user_defined_operator_token1 = 191,
  sym_assumed_rank = 192,
  anon_sym_LPAREN_SLASH = 193,
  anon_sym_SLASH_RPAREN = 194,
  anon_sym_LBRACK = 195,
  anon_sym_RBRACK = 196,
  sym_boolean_literal = 197,
  aux_sym_null_literal_token1 = 198,
  anon_sym_POUND = 199,
  aux_sym_preproc_file_line_token1 = 200,
  aux_sym_identifier_token1 = 201,
  sym_comment = 202,
  anon_sym_SEMI = 203,
  anon_sym_LF = 204,
  anon_sym_AMP = 205,
  sym__integer_literal = 206,
  sym__float_literal = 207,
  sym__boz_literal = 208,
  sym_string_literal = 209,
  sym__end_of_statement = 210,
  sym_translation_unit = 211,
  sym_program = 212,
  sym_program_statement = 213,
  sym_end_program_statement = 214,
  sym_module = 215,
  sym_module_statement = 216,
  sym_end_module_statement = 217,
  sym_submodule = 218,
  sym_submodule_statement = 219,
  sym_end_submodule_statement = 220,
  sym_module_name = 221,
  sym_interface = 222,
  sym_interface_statement = 223,
  sym_end_interface_statement = 224,
  sym_assignment = 225,
  sym_operator = 226,
  sym_defined_io_procedure = 227,
  sym__generic_procedure = 228,
  sym_subroutine = 229,
  sym_subroutine_statement = 230,
  sym_end_subroutine_statement = 231,
  sym_module_procedure = 232,
  sym_module_procedure_statement = 233,
  sym_end_module_procedure_statement = 234,
  sym_function = 235,
  sym_function_statement = 236,
  sym_language_binding = 237,
  aux_sym__callable_interface_qualifers = 238,
  sym_procedure_attributes = 239,
  sym_end_function_statement = 240,
  sym_function_result = 241,
  sym__name = 242,
  sym__parameters = 243,
  sym_parameters = 244,
  sym_internal_procedures = 245,
  sym_contains_statement = 246,
  sym__specification_part = 247,
  sym_use_statement = 248,
  sym_included_items = 249,
  sym_use_alias = 250,
  sym_implicit_statement = 251,
  sym_save_statement = 252,
  sym_private_statement = 253,
  sym_public_statement = 254,
  sym_namelist_statement = 255,
  sym_common_statement = 256,
  sym_variable_group = 257,
  sym_implicit_range = 258,
  sym_import_statement = 259,
  sym__import_names = 260,
  sym_derived_type_definition = 261,
  sym_abstract_specifier = 262,
  sym_access_specifier = 263,
  sym_base_type_specifier = 264,
  sym__derived_type_qualifier = 265,
  sym_derived_type_statement = 266,
  sym_end_type_statement = 267,
  sym__type_name = 268,
  sym_derived_type_procedures = 269,
  sym_procedure_statement = 270,
  sym_binding_name = 271,
  sym_method_name = 272,
  sym__procedure_kind = 273,
  sym_procedure_attribute = 274,
  sym_variable_declaration = 275,
  sym_procedure_declaration = 276,
  sym_variable_modification = 277,
  sym_variable_attributes = 278,
  sym__declaration_targets = 279,
  sym__intrinsic_type = 280,
  sym_intrinsic_type = 281,
  sym_derived_type = 282,
  sym_unlimited_polymorphic = 283,
  sym_size = 284,
  sym_character_length = 285,
  sym_type_qualifier = 286,
  sym_procedure_qualifier = 287,
  sym_parameter_statement = 288,
  sym_parameter_assignment = 289,
  sym_equivalence_statement = 290,
  sym_equivalence_set = 291,
  sym__statements = 292,
  sym_statement_label = 293,
  sym_statement_label_reference = 294,
  sym_stop_statement = 295,
  sym_assignment_statement = 296,
  sym_pointer_association_statement = 297,
  sym_subroutine_call = 298,
  sym_cuda_kernel_argument_list = 299,
  sym_keyword_statement = 300,
  sym_include_statement = 301,
  sym_data_statement = 302,
  sym_data_set = 303,
  sym_data_value = 304,
  sym_do_loop_statement = 305,
  sym_do_label_statement = 306,
  sym_end_do_loop_statement = 307,
  sym_while_statement = 308,
  sym_concurrent_statement = 309,
  sym_concurrent_header = 310,
  sym_concurrent_control = 311,
  sym_concurrent_locality = 312,
  sym_if_statement = 313,
  sym__inline_if_statement = 314,
  sym_arithmetic_if_statement = 315,
  sym__block_if_statement = 316,
  sym_end_if_statement = 317,
  sym_elseif_clause = 318,
  sym_else_clause = 319,
  sym_where_statement = 320,
  sym__inline_where_statement = 321,
  sym__block_where_statement = 322,
  sym_end_where_statement = 323,
  sym_elsewhere_clause = 324,
  sym_forall_statement = 325,
  sym_triplet_spec = 326,
  sym__forall_control_expression = 327,
  sym__inline_forall_statement = 328,
  sym__block_forall_statement = 329,
  sym_end_forall_statement = 330,
  sym_select_case_statement = 331,
  sym_select_type_statement = 332,
  sym_select_rank_statement = 333,
  sym_end_select_statement = 334,
  sym_selector = 335,
  sym_case_statement = 336,
  sym_type_statement = 337,
  sym__class_default = 338,
  sym_case_value_range_list = 339,
  sym_rank_statement = 340,
  sym_block_construct = 341,
  sym_end_block_construct_statement = 342,
  sym_associate_statement = 343,
  sym_association = 344,
  sym_end_associate_statement = 345,
  sym_format_statement = 346,
  sym__transfer_item = 347,
  sym__transfer_items = 348,
  sym_hollerith_constant = 349,
  sym__io_arguments = 350,
  sym_read_statement = 351,
  sym__simple_read_statement = 352,
  sym__parameterized_read_statement = 353,
  sym_print_statement = 354,
  sym_open_statement = 355,
  sym_close_statement = 356,
  sym_write_statement = 357,
  sym_inquire_statement = 358,
  sym_enum = 359,
  sym_enum_statement = 360,
  sym_enumerator_statement = 361,
  sym_end_enum_statement = 362,
  sym_unit_identifier = 363,
  sym_format_identifier = 364,
  sym__file_position_spec = 365,
  sym_file_position_statement = 366,
  sym__io_expressions = 367,
  sym_input_item_list = 368,
  sym_output_item_list = 369,
  sym__expression = 370,
  sym_parenthesized_expression = 371,
  sym_derived_type_member_expression = 372,
  sym_logical_expression = 373,
  sym_relational_expression = 374,
  sym_concatenation_expression = 375,
  sym_math_expression = 376,
  sym_unary_expression = 377,
  sym_user_defined_operator = 378,
  sym_call_expression = 379,
  sym_implied_do_loop_expression = 380,
  sym_argument_list = 381,
  sym_keyword_argument = 382,
  sym_extent_specifier = 383,
  sym_assumed_size = 384,
  sym_assumed_shape = 385,
  sym_block_label_start_expression = 386,
  sym__block_label = 387,
  sym_loop_control_expression = 388,
  sym_array_literal = 389,
  sym__array_constructor_legacy = 390,
  sym__array_constructor_f2003 = 391,
  sym__type_spec = 392,
  sym__ac_value_list = 393,
  sym_complex_literal = 394,
  sym_number_literal = 395,
  sym_null_literal = 396,
  sym_preproc_file_line = 397,
  sym_identifier = 398,
  sym__newline = 399,
  aux_sym_translation_unit_repeat1 = 400,
  aux_sym_program_repeat1 = 401,
  aux_sym_program_repeat2 = 402,
  aux_sym_interface_repeat1 = 403,
  aux_sym_function_statement_repeat1 = 404,
  aux_sym_procedure_attributes_repeat1 = 405,
  aux_sym_parameters_repeat1 = 406,
  aux_sym_internal_procedures_repeat1 = 407,
  aux_sym_use_statement_repeat1 = 408,
  aux_sym_included_items_repeat1 = 409,
  aux_sym_implicit_statement_repeat1 = 410,
  aux_sym_implicit_statement_repeat2 = 411,
  aux_sym_implicit_statement_repeat3 = 412,
  aux_sym_save_statement_repeat1 = 413,
  aux_sym_private_statement_repeat1 = 414,
  aux_sym_namelist_statement_repeat1 = 415,
  aux_sym_common_statement_repeat1 = 416,
  aux_sym_derived_type_definition_repeat1 = 417,
  aux_sym_derived_type_statement_repeat1 = 418,
  aux_sym_derived_type_procedures_repeat1 = 419,
  aux_sym_procedure_statement_repeat1 = 420,
  aux_sym_procedure_statement_repeat2 = 421,
  aux_sym_variable_declaration_repeat1 = 422,
  aux_sym_variable_modification_repeat1 = 423,
  aux_sym__declaration_targets_repeat1 = 424,
  aux_sym_parameter_statement_repeat1 = 425,
  aux_sym_equivalence_statement_repeat1 = 426,
  aux_sym_equivalence_set_repeat1 = 427,
  aux_sym_cuda_kernel_argument_list_repeat1 = 428,
  aux_sym_keyword_statement_repeat1 = 429,
  aux_sym_data_statement_repeat1 = 430,
  aux_sym_data_set_repeat1 = 431,
  aux_sym_data_value_repeat1 = 432,
  aux_sym_concurrent_statement_repeat1 = 433,
  aux_sym_concurrent_header_repeat1 = 434,
  aux_sym__block_if_statement_repeat1 = 435,
  aux_sym__block_where_statement_repeat1 = 436,
  aux_sym__forall_control_expression_repeat1 = 437,
  aux_sym_select_case_statement_repeat1 = 438,
  aux_sym_select_type_statement_repeat1 = 439,
  aux_sym_select_rank_statement_repeat1 = 440,
  aux_sym_case_value_range_list_repeat1 = 441,
  aux_sym_associate_statement_repeat1 = 442,
  aux_sym__transfer_items_repeat1 = 443,
  aux_sym__io_arguments_repeat1 = 444,
  aux_sym_enum_repeat1 = 445,
  aux_sym_enumerator_statement_repeat1 = 446,
  aux_sym_call_expression_repeat1 = 447,
  aux_sym_argument_list_repeat1 = 448,
  alias_sym_block_label = 449,
  anon_alias_sym_class = 450,
  alias_sym_concurrent_mask = 451,
  anon_alias_sym_default = 452,
  anon_alias_sym_double = 453,
  anon_alias_sym_else = 454,
  anon_alias_sym_end = 455,
  alias_sym_filename = 456,
  anon_alias_sym_label = 457,
  alias_sym_local_name = 458,
  anon_alias_sym_method_name = 459,
  alias_sym_name = 460,
  anon_alias_sym_none = 461,
  alias_sym_preproc_line_number = 462,
  alias_sym_procedure_interface = 463,
  anon_alias_sym_program = 464,
  anon_alias_sym_select = 465,
  anon_alias_sym_sequence = 466,
  anon_alias_sym_statement_label = 467,
  anon_alias_sym_statement_label_reference = 468,
  alias_sym_transfer_items = 469,
  alias_sym_type_member = 470,
  alias_sym_type_name = 471,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [aux_sym_program_statement_token1] = "endprogram",
  [aux_sym_end_program_statement_token1] = "endprogram",
  [aux_sym_end_program_statement_token2] = "endprogram",
  [aux_sym_module_statement_token1] = "module",
  [aux_sym_end_module_statement_token1] = "endmodule",
  [aux_sym_submodule_statement_token1] = "submodule",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COLON] = ":",
  [anon_sym_RPAREN] = ")",
  [aux_sym_end_submodule_statement_token1] = "endsubmodule",
  [aux_sym_interface_statement_token1] = "interface",
  [aux_sym_end_interface_statement_token1] = "endinterface",
  [aux_sym_assignment_token1] = "assignment",
  [anon_sym_EQ] = "=",
  [aux_sym_operator_token1] = "operator",
  [aux_sym_operator_token2] = "operator_token2",
  [aux_sym_defined_io_procedure_token1] = "read",
  [aux_sym_defined_io_procedure_token2] = "write",
  [aux_sym_defined_io_procedure_token3] = "formatted",
  [aux_sym_defined_io_procedure_token4] = "unformatted",
  [aux_sym_subroutine_statement_token1] = "subroutine",
  [aux_sym_end_subroutine_statement_token1] = "endsubroutine",
  [aux_sym_module_procedure_statement_token1] = "procedure",
  [aux_sym_end_module_procedure_statement_token1] = "endprocedure",
  [aux_sym_function_statement_token1] = "function",
  [aux_sym_language_binding_token1] = "bind",
  [anon_sym_COMMA] = ",",
  [aux_sym_procedure_attributes_token1] = "attributes",
  [aux_sym_procedure_attributes_token2] = "global",
  [aux_sym_procedure_attributes_token3] = "device",
  [aux_sym_procedure_attributes_token4] = "host",
  [aux_sym_procedure_attributes_token5] = "grid_global",
  [aux_sym_end_function_statement_token1] = "endfunction",
  [aux_sym_function_result_token1] = "result",
  [aux_sym_contains_statement_token1] = "contains",
  [aux_sym_use_statement_token1] = "use",
  [aux_sym_use_statement_token2] = "intrinsic",
  [aux_sym_use_statement_token3] = "non_intrinsic",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_included_items_token1] = "only",
  [anon_sym_EQ_GT] = "=>",
  [aux_sym_implicit_statement_token1] = "implicit",
  [aux_sym_implicit_statement_token2] = "none",
  [aux_sym_implicit_statement_token3] = "type",
  [aux_sym_implicit_statement_token4] = "external",
  [aux_sym_save_statement_token1] = "save",
  [anon_sym_SLASH] = "/",
  [aux_sym_private_statement_token1] = "private",
  [aux_sym_public_statement_token1] = "public",
  [aux_sym_namelist_statement_token1] = "namelist",
  [aux_sym_common_statement_token1] = "common",
  [aux_sym_implicit_range_token1] = "implicit_range_token1",
  [anon_sym_DASH] = "-",
  [aux_sym_import_statement_token1] = "import",
  [aux_sym__import_names_token1] = "all",
  [aux_sym_derived_type_definition_token1] = "sequence_statement",
  [aux_sym_abstract_specifier_token1] = "abstract",
  [aux_sym_base_type_specifier_token1] = "extends",
  [aux_sym_end_type_statement_token1] = "endtype",
  [aux_sym__procedure_kind_token1] = "generic",
  [aux_sym__procedure_kind_token2] = "initial",
  [aux_sym__procedure_kind_token3] = "property",
  [aux_sym__procedure_kind_token4] = "final",
  [aux_sym_procedure_attribute_token1] = "deferred",
  [aux_sym_procedure_attribute_token2] = "pass",
  [aux_sym_procedure_attribute_token3] = "nopass",
  [aux_sym_procedure_attribute_token4] = "non_overridable",
  [aux_sym_procedure_attribute_token5] = "family",
  [aux_sym_procedure_attribute_token6] = "pointer",
  [aux_sym_variable_attributes_token1] = "managed",
  [aux_sym_variable_attributes_token2] = "constant",
  [aux_sym_variable_attributes_token3] = "shared",
  [aux_sym_variable_attributes_token4] = "pinned",
  [aux_sym_variable_attributes_token5] = "texture",
  [aux_sym_intrinsic_type_token1] = "byte",
  [aux_sym_intrinsic_type_token2] = "integer",
  [aux_sym_intrinsic_type_token3] = "real",
  [aux_sym_intrinsic_type_token4] = "doubleprecision",
  [aux_sym_intrinsic_type_token5] = "doubleprecision",
  [aux_sym_intrinsic_type_token6] = "doubleprecision",
  [aux_sym_intrinsic_type_token7] = "complex",
  [aux_sym_intrinsic_type_token8] = "doublecomplex",
  [aux_sym_intrinsic_type_token9] = "logical",
  [aux_sym_intrinsic_type_token10] = "character",
  [aux_sym_derived_type_token1] = "derived_type_token1",
  [anon_sym_STAR] = "*",
  [aux_sym_size_token1] = "size_token1",
  [aux_sym_type_qualifier_token1] = "allocatable",
  [aux_sym_type_qualifier_token2] = "automatic",
  [aux_sym_type_qualifier_token3] = "dimension",
  [aux_sym_type_qualifier_token4] = "contiguous",
  [aux_sym_type_qualifier_token5] = "intent",
  [aux_sym_type_qualifier_token6] = "in",
  [aux_sym_type_qualifier_token7] = "out",
  [aux_sym_type_qualifier_token8] = "inout",
  [aux_sym_type_qualifier_token9] = "optional",
  [aux_sym_type_qualifier_token10] = "parameter",
  [aux_sym_type_qualifier_token11] = "protected",
  [aux_sym_type_qualifier_token12] = "static",
  [aux_sym_type_qualifier_token13] = "target",
  [aux_sym_type_qualifier_token14] = "value",
  [aux_sym_type_qualifier_token15] = "volatile",
  [aux_sym_procedure_qualifier_token1] = "elemental",
  [aux_sym_procedure_qualifier_token2] = "impure",
  [aux_sym_procedure_qualifier_token3] = "pure",
  [aux_sym_procedure_qualifier_token4] = "recursive",
  [aux_sym_equivalence_statement_token1] = "equivalence",
  [aux_sym_stop_statement_token1] = "error",
  [aux_sym_stop_statement_token2] = "stop",
  [aux_sym_stop_statement_token3] = "quiet",
  [aux_sym_subroutine_call_token1] = "call",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_GT_GT_GT] = ">>>",
  [aux_sym_keyword_statement_token1] = "continue",
  [aux_sym_keyword_statement_token2] = "cycle",
  [aux_sym_keyword_statement_token3] = "exit",
  [aux_sym_keyword_statement_token4] = "goto",
  [aux_sym_keyword_statement_token5] = "goto",
  [aux_sym_keyword_statement_token6] = "goto",
  [aux_sym_keyword_statement_token7] = "return",
  [aux_sym_include_statement_token1] = "include",
  [aux_sym_data_statement_token1] = "data",
  [aux_sym_do_loop_statement_token1] = "do",
  [aux_sym_end_do_loop_statement_token1] = "enddo",
  [aux_sym_while_statement_token1] = "while",
  [aux_sym_concurrent_header_token1] = "concurrent",
  [aux_sym_concurrent_locality_token1] = "local",
  [aux_sym_concurrent_locality_token2] = "local_init",
  [aux_sym_concurrent_locality_token3] = "concurrent_locality_token3",
  [aux_sym__inline_if_statement_token1] = "if",
  [aux_sym__block_if_statement_token1] = "then",
  [aux_sym_end_if_statement_token1] = "endif",
  [aux_sym_elseif_clause_token1] = "elsewhere",
  [aux_sym_elseif_clause_token2] = "elseif",
  [aux_sym__inline_where_statement_token1] = "where",
  [aux_sym_end_where_statement_token1] = "endwhere",
  [aux_sym_elsewhere_clause_token1] = "elsewhere",
  [aux_sym__forall_control_expression_token1] = "forall",
  [aux_sym_end_forall_statement_token1] = "endforall",
  [aux_sym_select_case_statement_token1] = "selectcase",
  [aux_sym_select_case_statement_token2] = "case",
  [aux_sym_select_case_statement_token3] = "selectcase",
  [aux_sym_select_type_statement_token1] = "selecttype",
  [aux_sym_select_rank_statement_token1] = "rank",
  [aux_sym_select_rank_statement_token2] = "selectrank",
  [aux_sym_end_select_statement_token1] = "endselect",
  [aux_sym_type_statement_token1] = "typeis",
  [aux_sym_type_statement_token2] = "typeis",
  [aux_sym_type_statement_token3] = "classis",
  [aux_sym__class_default_token1] = "_class_default_token1",
  [aux_sym_block_construct_token1] = "block",
  [aux_sym_end_block_construct_statement_token1] = "endblock",
  [aux_sym_associate_statement_token1] = "associate",
  [aux_sym_end_associate_statement_token1] = "endassociate",
  [aux_sym_format_statement_token1] = "format",
  [sym_edit_descriptor] = "edit_descriptor",
  [aux_sym_hollerith_constant_token1] = "hollerith_constant_token1",
  [aux_sym_print_statement_token1] = "print",
  [aux_sym_open_statement_token1] = "open",
  [aux_sym_close_statement_token1] = "close",
  [aux_sym_inquire_statement_token1] = "inquire",
  [aux_sym_enum_statement_token1] = "enum",
  [aux_sym_enumerator_statement_token1] = "enumerator",
  [aux_sym_end_enum_statement_token1] = "endenum",
  [aux_sym_file_position_statement_token1] = "backspace",
  [aux_sym_file_position_statement_token2] = "endfile",
  [aux_sym_file_position_statement_token3] = "rewind",
  [aux_sym_file_position_statement_token4] = "pause",
  [anon_sym_PERCENT] = "%",
  [aux_sym_logical_expression_token1] = "\\.or\\.",
  [aux_sym_logical_expression_token2] = "\\.and\\.",
  [aux_sym_logical_expression_token3] = "\\.eqv\\.",
  [aux_sym_logical_expression_token4] = "\\.neqv\\.",
  [aux_sym_logical_expression_token5] = "\\.not\\.",
  [anon_sym_LT] = "<",
  [aux_sym_relational_expression_token1] = "\\.lt\\.",
  [anon_sym_GT] = ">",
  [aux_sym_relational_expression_token2] = "\\.gt\\.",
  [anon_sym_LT_EQ] = "<=",
  [aux_sym_relational_expression_token3] = "\\.le\\.",
  [anon_sym_GT_EQ] = ">=",
  [aux_sym_relational_expression_token4] = "\\.ge\\.",
  [anon_sym_EQ_EQ] = "==",
  [aux_sym_relational_expression_token5] = "\\.eq\\.",
  [anon_sym_SLASH_EQ] = "/=",
  [aux_sym_relational_expression_token6] = "\\.ne\\.",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_DOT] = ".",
  [aux_sym_user_defined_operator_token1] = "user_defined_operator_token1",
  [sym_assumed_rank] = "assumed_rank",
  [anon_sym_LPAREN_SLASH] = "(/",
  [anon_sym_SLASH_RPAREN] = "/)",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_boolean_literal] = "boolean_literal",
  [aux_sym_null_literal_token1] = "null",
  [anon_sym_POUND] = "#",
  [aux_sym_preproc_file_line_token1] = "preproc_filename",
  [aux_sym_identifier_token1] = "identifier_token1",
  [sym_comment] = "comment",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym__integer_literal] = "_integer_literal",
  [sym__float_literal] = "_float_literal",
  [sym__boz_literal] = "_boz_literal",
  [sym_string_literal] = "string_literal",
  [sym__end_of_statement] = "_end_of_statement",
  [sym_translation_unit] = "translation_unit",
  [sym_program] = "program",
  [sym_program_statement] = "program_statement",
  [sym_end_program_statement] = "end_program_statement",
  [sym_module] = "module",
  [sym_module_statement] = "module_statement",
  [sym_end_module_statement] = "end_module_statement",
  [sym_submodule] = "submodule",
  [sym_submodule_statement] = "submodule_statement",
  [sym_end_submodule_statement] = "end_submodule_statement",
  [sym_module_name] = "module_name",
  [sym_interface] = "interface",
  [sym_interface_statement] = "interface_statement",
  [sym_end_interface_statement] = "end_interface_statement",
  [sym_assignment] = "assignment",
  [sym_operator] = "operator",
  [sym_defined_io_procedure] = "defined_io_procedure",
  [sym__generic_procedure] = "_generic_procedure",
  [sym_subroutine] = "subroutine",
  [sym_subroutine_statement] = "subroutine_statement",
  [sym_end_subroutine_statement] = "end_subroutine_statement",
  [sym_module_procedure] = "module_procedure",
  [sym_module_procedure_statement] = "module_procedure_statement",
  [sym_end_module_procedure_statement] = "end_module_procedure_statement",
  [sym_function] = "function",
  [sym_function_statement] = "function_statement",
  [sym_language_binding] = "language_binding",
  [aux_sym__callable_interface_qualifers] = "_callable_interface_qualifers",
  [sym_procedure_attributes] = "procedure_attributes",
  [sym_end_function_statement] = "end_function_statement",
  [sym_function_result] = "function_result",
  [sym__name] = "_name",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_internal_procedures] = "internal_procedures",
  [sym_contains_statement] = "contains_statement",
  [sym__specification_part] = "_specification_part",
  [sym_use_statement] = "use_statement",
  [sym_included_items] = "included_items",
  [sym_use_alias] = "use_alias",
  [sym_implicit_statement] = "implicit_statement",
  [sym_save_statement] = "save_statement",
  [sym_private_statement] = "private_statement",
  [sym_public_statement] = "public_statement",
  [sym_namelist_statement] = "namelist_statement",
  [sym_common_statement] = "common_statement",
  [sym_variable_group] = "variable_group",
  [sym_implicit_range] = "implicit_range",
  [sym_import_statement] = "import_statement",
  [sym__import_names] = "_import_names",
  [sym_derived_type_definition] = "derived_type_definition",
  [sym_abstract_specifier] = "abstract_specifier",
  [sym_access_specifier] = "access_specifier",
  [sym_base_type_specifier] = "base_type_specifier",
  [sym__derived_type_qualifier] = "_derived_type_qualifier",
  [sym_derived_type_statement] = "derived_type_statement",
  [sym_end_type_statement] = "end_type_statement",
  [sym__type_name] = "_type_name",
  [sym_derived_type_procedures] = "derived_type_procedures",
  [sym_procedure_statement] = "procedure_statement",
  [sym_binding_name] = "binding_name",
  [sym_method_name] = "method_name",
  [sym__procedure_kind] = "_procedure_kind",
  [sym_procedure_attribute] = "procedure_attribute",
  [sym_variable_declaration] = "variable_declaration",
  [sym_procedure_declaration] = "procedure",
  [sym_variable_modification] = "variable_modification",
  [sym_variable_attributes] = "variable_attributes",
  [sym__declaration_targets] = "_declaration_targets",
  [sym__intrinsic_type] = "_intrinsic_type",
  [sym_intrinsic_type] = "intrinsic_type",
  [sym_derived_type] = "derived_type",
  [sym_unlimited_polymorphic] = "unlimited_polymorphic",
  [sym_size] = "size",
  [sym_character_length] = "character_length",
  [sym_type_qualifier] = "type_qualifier",
  [sym_procedure_qualifier] = "procedure_qualifier",
  [sym_parameter_statement] = "parameter_statement",
  [sym_parameter_assignment] = "parameter_assignment",
  [sym_equivalence_statement] = "equivalence_statement",
  [sym_equivalence_set] = "equivalence_set",
  [sym__statements] = "_statements",
  [sym_statement_label] = "statement_label",
  [sym_statement_label_reference] = "statement_label_reference",
  [sym_stop_statement] = "stop_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_pointer_association_statement] = "pointer_association_statement",
  [sym_subroutine_call] = "subroutine_call",
  [sym_cuda_kernel_argument_list] = "cuda_kernel_argument_list",
  [sym_keyword_statement] = "keyword_statement",
  [sym_include_statement] = "include_statement",
  [sym_data_statement] = "data_statement",
  [sym_data_set] = "data_set",
  [sym_data_value] = "data_value",
  [sym_do_loop_statement] = "do_loop_statement",
  [sym_do_label_statement] = "do_label_statement",
  [sym_end_do_loop_statement] = "end_do_loop_statement",
  [sym_while_statement] = "while_statement",
  [sym_concurrent_statement] = "concurrent_statement",
  [sym_concurrent_header] = "concurrent_header",
  [sym_concurrent_control] = "concurrent_control",
  [sym_concurrent_locality] = "concurrent_locality",
  [sym_if_statement] = "if_statement",
  [sym__inline_if_statement] = "_inline_if_statement",
  [sym_arithmetic_if_statement] = "arithmetic_if_statement",
  [sym__block_if_statement] = "_block_if_statement",
  [sym_end_if_statement] = "end_if_statement",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym_where_statement] = "where_statement",
  [sym__inline_where_statement] = "_inline_where_statement",
  [sym__block_where_statement] = "_block_where_statement",
  [sym_end_where_statement] = "end_where_statement",
  [sym_elsewhere_clause] = "elsewhere_clause",
  [sym_forall_statement] = "forall_statement",
  [sym_triplet_spec] = "triplet_spec",
  [sym__forall_control_expression] = "_forall_control_expression",
  [sym__inline_forall_statement] = "_inline_forall_statement",
  [sym__block_forall_statement] = "_block_forall_statement",
  [sym_end_forall_statement] = "end_forall_statement",
  [sym_select_case_statement] = "select_case_statement",
  [sym_select_type_statement] = "select_type_statement",
  [sym_select_rank_statement] = "select_rank_statement",
  [sym_end_select_statement] = "end_select_statement",
  [sym_selector] = "selector",
  [sym_case_statement] = "case_statement",
  [sym_type_statement] = "type_statement",
  [sym__class_default] = "default",
  [sym_case_value_range_list] = "case_value_range_list",
  [sym_rank_statement] = "rank_statement",
  [sym_block_construct] = "block_construct",
  [sym_end_block_construct_statement] = "end_block_construct_statement",
  [sym_associate_statement] = "associate_statement",
  [sym_association] = "association",
  [sym_end_associate_statement] = "end_associate_statement",
  [sym_format_statement] = "format_statement",
  [sym__transfer_item] = "_transfer_item",
  [sym__transfer_items] = "_transfer_items",
  [sym_hollerith_constant] = "hollerith_constant",
  [sym__io_arguments] = "_io_arguments",
  [sym_read_statement] = "read_statement",
  [sym__simple_read_statement] = "_simple_read_statement",
  [sym__parameterized_read_statement] = "_parameterized_read_statement",
  [sym_print_statement] = "print_statement",
  [sym_open_statement] = "open_statement",
  [sym_close_statement] = "close_statement",
  [sym_write_statement] = "write_statement",
  [sym_inquire_statement] = "inquire_statement",
  [sym_enum] = "enum",
  [sym_enum_statement] = "enum_statement",
  [sym_enumerator_statement] = "enumerator_statement",
  [sym_end_enum_statement] = "end_enum_statement",
  [sym_unit_identifier] = "unit_identifier",
  [sym_format_identifier] = "format_identifier",
  [sym__file_position_spec] = "_file_position_spec",
  [sym_file_position_statement] = "file_position_statement",
  [sym__io_expressions] = "_io_expressions",
  [sym_input_item_list] = "input_item_list",
  [sym_output_item_list] = "output_item_list",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_derived_type_member_expression] = "derived_type_member_expression",
  [sym_logical_expression] = "logical_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_concatenation_expression] = "concatenation_expression",
  [sym_math_expression] = "math_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_user_defined_operator] = "user_defined_operator",
  [sym_call_expression] = "call_expression",
  [sym_implied_do_loop_expression] = "implied_do_loop_expression",
  [sym_argument_list] = "argument_list",
  [sym_keyword_argument] = "keyword_argument",
  [sym_extent_specifier] = "extent_specifier",
  [sym_assumed_size] = "assumed_size",
  [sym_assumed_shape] = "assumed_shape",
  [sym_block_label_start_expression] = "block_label_start_expression",
  [sym__block_label] = "_block_label",
  [sym_loop_control_expression] = "loop_control_expression",
  [sym_array_literal] = "array_literal",
  [sym__array_constructor_legacy] = "_array_constructor_legacy",
  [sym__array_constructor_f2003] = "_array_constructor_f2003",
  [sym__type_spec] = "_type_spec",
  [sym__ac_value_list] = "_ac_value_list",
  [sym_complex_literal] = "complex_literal",
  [sym_number_literal] = "number_literal",
  [sym_null_literal] = "null_literal",
  [sym_preproc_file_line] = "preproc_file_line",
  [sym_identifier] = "identifier",
  [sym__newline] = "_newline",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_program_repeat2] = "program_repeat2",
  [aux_sym_interface_repeat1] = "interface_repeat1",
  [aux_sym_function_statement_repeat1] = "function_statement_repeat1",
  [aux_sym_procedure_attributes_repeat1] = "procedure_attributes_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_internal_procedures_repeat1] = "internal_procedures_repeat1",
  [aux_sym_use_statement_repeat1] = "use_statement_repeat1",
  [aux_sym_included_items_repeat1] = "included_items_repeat1",
  [aux_sym_implicit_statement_repeat1] = "implicit_statement_repeat1",
  [aux_sym_implicit_statement_repeat2] = "implicit_statement_repeat2",
  [aux_sym_implicit_statement_repeat3] = "implicit_statement_repeat3",
  [aux_sym_save_statement_repeat1] = "save_statement_repeat1",
  [aux_sym_private_statement_repeat1] = "private_statement_repeat1",
  [aux_sym_namelist_statement_repeat1] = "namelist_statement_repeat1",
  [aux_sym_common_statement_repeat1] = "common_statement_repeat1",
  [aux_sym_derived_type_definition_repeat1] = "derived_type_definition_repeat1",
  [aux_sym_derived_type_statement_repeat1] = "derived_type_statement_repeat1",
  [aux_sym_derived_type_procedures_repeat1] = "derived_type_procedures_repeat1",
  [aux_sym_procedure_statement_repeat1] = "procedure_statement_repeat1",
  [aux_sym_procedure_statement_repeat2] = "procedure_statement_repeat2",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_variable_modification_repeat1] = "variable_modification_repeat1",
  [aux_sym__declaration_targets_repeat1] = "_declaration_targets_repeat1",
  [aux_sym_parameter_statement_repeat1] = "parameter_statement_repeat1",
  [aux_sym_equivalence_statement_repeat1] = "equivalence_statement_repeat1",
  [aux_sym_equivalence_set_repeat1] = "equivalence_set_repeat1",
  [aux_sym_cuda_kernel_argument_list_repeat1] = "cuda_kernel_argument_list_repeat1",
  [aux_sym_keyword_statement_repeat1] = "keyword_statement_repeat1",
  [aux_sym_data_statement_repeat1] = "data_statement_repeat1",
  [aux_sym_data_set_repeat1] = "data_set_repeat1",
  [aux_sym_data_value_repeat1] = "data_value_repeat1",
  [aux_sym_concurrent_statement_repeat1] = "concurrent_statement_repeat1",
  [aux_sym_concurrent_header_repeat1] = "concurrent_header_repeat1",
  [aux_sym__block_if_statement_repeat1] = "_block_if_statement_repeat1",
  [aux_sym__block_where_statement_repeat1] = "_block_where_statement_repeat1",
  [aux_sym__forall_control_expression_repeat1] = "_forall_control_expression_repeat1",
  [aux_sym_select_case_statement_repeat1] = "select_case_statement_repeat1",
  [aux_sym_select_type_statement_repeat1] = "select_type_statement_repeat1",
  [aux_sym_select_rank_statement_repeat1] = "select_rank_statement_repeat1",
  [aux_sym_case_value_range_list_repeat1] = "case_value_range_list_repeat1",
  [aux_sym_associate_statement_repeat1] = "associate_statement_repeat1",
  [aux_sym__transfer_items_repeat1] = "_transfer_items_repeat1",
  [aux_sym__io_arguments_repeat1] = "_io_arguments_repeat1",
  [aux_sym_enum_repeat1] = "enum_repeat1",
  [aux_sym_enumerator_statement_repeat1] = "enumerator_statement_repeat1",
  [aux_sym_call_expression_repeat1] = "call_expression_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [alias_sym_block_label] = "block_label",
  [anon_alias_sym_class] = "class",
  [alias_sym_concurrent_mask] = "concurrent_mask",
  [anon_alias_sym_default] = "default",
  [anon_alias_sym_double] = "double",
  [anon_alias_sym_else] = "else",
  [anon_alias_sym_end] = "end",
  [alias_sym_filename] = "filename",
  [anon_alias_sym_label] = "label",
  [alias_sym_local_name] = "local_name",
  [anon_alias_sym_method_name] = "method_name",
  [alias_sym_name] = "name",
  [anon_alias_sym_none] = "none",
  [alias_sym_preproc_line_number] = "preproc_line_number",
  [alias_sym_procedure_interface] = "procedure_interface",
  [anon_alias_sym_program] = "program",
  [anon_alias_sym_select] = "select",
  [anon_alias_sym_sequence] = "sequence",
  [anon_alias_sym_statement_label] = "statement_label",
  [anon_alias_sym_statement_label_reference] = "statement_label_reference",
  [alias_sym_transfer_items] = "transfer_items",
  [alias_sym_type_member] = "type_member",
  [alias_sym_type_name] = "type_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [aux_sym_program_statement_token1] = aux_sym_program_statement_token1,
  [aux_sym_end_program_statement_token1] = aux_sym_program_statement_token1,
  [aux_sym_end_program_statement_token2] = aux_sym_program_statement_token1,
  [aux_sym_module_statement_token1] = aux_sym_module_statement_token1,
  [aux_sym_end_module_statement_token1] = aux_sym_end_module_statement_token1,
  [aux_sym_submodule_statement_token1] = aux_sym_submodule_statement_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_end_submodule_statement_token1] = aux_sym_end_submodule_statement_token1,
  [aux_sym_interface_statement_token1] = aux_sym_interface_statement_token1,
  [aux_sym_end_interface_statement_token1] = aux_sym_end_interface_statement_token1,
  [aux_sym_assignment_token1] = aux_sym_assignment_token1,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_operator_token1] = aux_sym_operator_token1,
  [aux_sym_operator_token2] = aux_sym_operator_token2,
  [aux_sym_defined_io_procedure_token1] = aux_sym_defined_io_procedure_token1,
  [aux_sym_defined_io_procedure_token2] = aux_sym_defined_io_procedure_token2,
  [aux_sym_defined_io_procedure_token3] = aux_sym_defined_io_procedure_token3,
  [aux_sym_defined_io_procedure_token4] = aux_sym_defined_io_procedure_token4,
  [aux_sym_subroutine_statement_token1] = aux_sym_subroutine_statement_token1,
  [aux_sym_end_subroutine_statement_token1] = aux_sym_end_subroutine_statement_token1,
  [aux_sym_module_procedure_statement_token1] = aux_sym_module_procedure_statement_token1,
  [aux_sym_end_module_procedure_statement_token1] = aux_sym_end_module_procedure_statement_token1,
  [aux_sym_function_statement_token1] = aux_sym_function_statement_token1,
  [aux_sym_language_binding_token1] = aux_sym_language_binding_token1,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_procedure_attributes_token1] = aux_sym_procedure_attributes_token1,
  [aux_sym_procedure_attributes_token2] = aux_sym_procedure_attributes_token2,
  [aux_sym_procedure_attributes_token3] = aux_sym_procedure_attributes_token3,
  [aux_sym_procedure_attributes_token4] = aux_sym_procedure_attributes_token4,
  [aux_sym_procedure_attributes_token5] = aux_sym_procedure_attributes_token5,
  [aux_sym_end_function_statement_token1] = aux_sym_end_function_statement_token1,
  [aux_sym_function_result_token1] = aux_sym_function_result_token1,
  [aux_sym_contains_statement_token1] = aux_sym_contains_statement_token1,
  [aux_sym_use_statement_token1] = aux_sym_use_statement_token1,
  [aux_sym_use_statement_token2] = aux_sym_use_statement_token2,
  [aux_sym_use_statement_token3] = aux_sym_use_statement_token3,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_included_items_token1] = aux_sym_included_items_token1,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [aux_sym_implicit_statement_token1] = aux_sym_implicit_statement_token1,
  [aux_sym_implicit_statement_token2] = aux_sym_implicit_statement_token2,
  [aux_sym_implicit_statement_token3] = aux_sym_implicit_statement_token3,
  [aux_sym_implicit_statement_token4] = aux_sym_implicit_statement_token4,
  [aux_sym_save_statement_token1] = aux_sym_save_statement_token1,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [aux_sym_private_statement_token1] = aux_sym_private_statement_token1,
  [aux_sym_public_statement_token1] = aux_sym_public_statement_token1,
  [aux_sym_namelist_statement_token1] = aux_sym_namelist_statement_token1,
  [aux_sym_common_statement_token1] = aux_sym_common_statement_token1,
  [aux_sym_implicit_range_token1] = aux_sym_implicit_range_token1,
  [anon_sym_DASH] = anon_sym_DASH,
  [aux_sym_import_statement_token1] = aux_sym_import_statement_token1,
  [aux_sym__import_names_token1] = aux_sym__import_names_token1,
  [aux_sym_derived_type_definition_token1] = aux_sym_derived_type_definition_token1,
  [aux_sym_abstract_specifier_token1] = aux_sym_abstract_specifier_token1,
  [aux_sym_base_type_specifier_token1] = aux_sym_base_type_specifier_token1,
  [aux_sym_end_type_statement_token1] = aux_sym_end_type_statement_token1,
  [aux_sym__procedure_kind_token1] = aux_sym__procedure_kind_token1,
  [aux_sym__procedure_kind_token2] = aux_sym__procedure_kind_token2,
  [aux_sym__procedure_kind_token3] = aux_sym__procedure_kind_token3,
  [aux_sym__procedure_kind_token4] = aux_sym__procedure_kind_token4,
  [aux_sym_procedure_attribute_token1] = aux_sym_procedure_attribute_token1,
  [aux_sym_procedure_attribute_token2] = aux_sym_procedure_attribute_token2,
  [aux_sym_procedure_attribute_token3] = aux_sym_procedure_attribute_token3,
  [aux_sym_procedure_attribute_token4] = aux_sym_procedure_attribute_token4,
  [aux_sym_procedure_attribute_token5] = aux_sym_procedure_attribute_token5,
  [aux_sym_procedure_attribute_token6] = aux_sym_procedure_attribute_token6,
  [aux_sym_variable_attributes_token1] = aux_sym_variable_attributes_token1,
  [aux_sym_variable_attributes_token2] = aux_sym_variable_attributes_token2,
  [aux_sym_variable_attributes_token3] = aux_sym_variable_attributes_token3,
  [aux_sym_variable_attributes_token4] = aux_sym_variable_attributes_token4,
  [aux_sym_variable_attributes_token5] = aux_sym_variable_attributes_token5,
  [aux_sym_intrinsic_type_token1] = aux_sym_intrinsic_type_token1,
  [aux_sym_intrinsic_type_token2] = aux_sym_intrinsic_type_token2,
  [aux_sym_intrinsic_type_token3] = aux_sym_intrinsic_type_token3,
  [aux_sym_intrinsic_type_token4] = aux_sym_intrinsic_type_token4,
  [aux_sym_intrinsic_type_token5] = aux_sym_intrinsic_type_token4,
  [aux_sym_intrinsic_type_token6] = aux_sym_intrinsic_type_token4,
  [aux_sym_intrinsic_type_token7] = aux_sym_intrinsic_type_token7,
  [aux_sym_intrinsic_type_token8] = aux_sym_intrinsic_type_token8,
  [aux_sym_intrinsic_type_token9] = aux_sym_intrinsic_type_token9,
  [aux_sym_intrinsic_type_token10] = aux_sym_intrinsic_type_token10,
  [aux_sym_derived_type_token1] = aux_sym_derived_type_token1,
  [anon_sym_STAR] = anon_sym_STAR,
  [aux_sym_size_token1] = aux_sym_size_token1,
  [aux_sym_type_qualifier_token1] = aux_sym_type_qualifier_token1,
  [aux_sym_type_qualifier_token2] = aux_sym_type_qualifier_token2,
  [aux_sym_type_qualifier_token3] = aux_sym_type_qualifier_token3,
  [aux_sym_type_qualifier_token4] = aux_sym_type_qualifier_token4,
  [aux_sym_type_qualifier_token5] = aux_sym_type_qualifier_token5,
  [aux_sym_type_qualifier_token6] = aux_sym_type_qualifier_token6,
  [aux_sym_type_qualifier_token7] = aux_sym_type_qualifier_token7,
  [aux_sym_type_qualifier_token8] = aux_sym_type_qualifier_token8,
  [aux_sym_type_qualifier_token9] = aux_sym_type_qualifier_token9,
  [aux_sym_type_qualifier_token10] = aux_sym_type_qualifier_token10,
  [aux_sym_type_qualifier_token11] = aux_sym_type_qualifier_token11,
  [aux_sym_type_qualifier_token12] = aux_sym_type_qualifier_token12,
  [aux_sym_type_qualifier_token13] = aux_sym_type_qualifier_token13,
  [aux_sym_type_qualifier_token14] = aux_sym_type_qualifier_token14,
  [aux_sym_type_qualifier_token15] = aux_sym_type_qualifier_token15,
  [aux_sym_procedure_qualifier_token1] = aux_sym_procedure_qualifier_token1,
  [aux_sym_procedure_qualifier_token2] = aux_sym_procedure_qualifier_token2,
  [aux_sym_procedure_qualifier_token3] = aux_sym_procedure_qualifier_token3,
  [aux_sym_procedure_qualifier_token4] = aux_sym_procedure_qualifier_token4,
  [aux_sym_equivalence_statement_token1] = aux_sym_equivalence_statement_token1,
  [aux_sym_stop_statement_token1] = aux_sym_stop_statement_token1,
  [aux_sym_stop_statement_token2] = aux_sym_stop_statement_token2,
  [aux_sym_stop_statement_token3] = aux_sym_stop_statement_token3,
  [aux_sym_subroutine_call_token1] = aux_sym_subroutine_call_token1,
  [anon_sym_LT_LT_LT] = anon_sym_LT_LT_LT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [aux_sym_keyword_statement_token1] = aux_sym_keyword_statement_token1,
  [aux_sym_keyword_statement_token2] = aux_sym_keyword_statement_token2,
  [aux_sym_keyword_statement_token3] = aux_sym_keyword_statement_token3,
  [aux_sym_keyword_statement_token4] = aux_sym_keyword_statement_token4,
  [aux_sym_keyword_statement_token5] = aux_sym_keyword_statement_token4,
  [aux_sym_keyword_statement_token6] = aux_sym_keyword_statement_token4,
  [aux_sym_keyword_statement_token7] = aux_sym_keyword_statement_token7,
  [aux_sym_include_statement_token1] = aux_sym_include_statement_token1,
  [aux_sym_data_statement_token1] = aux_sym_data_statement_token1,
  [aux_sym_do_loop_statement_token1] = aux_sym_do_loop_statement_token1,
  [aux_sym_end_do_loop_statement_token1] = aux_sym_end_do_loop_statement_token1,
  [aux_sym_while_statement_token1] = aux_sym_while_statement_token1,
  [aux_sym_concurrent_header_token1] = aux_sym_concurrent_header_token1,
  [aux_sym_concurrent_locality_token1] = aux_sym_concurrent_locality_token1,
  [aux_sym_concurrent_locality_token2] = aux_sym_concurrent_locality_token2,
  [aux_sym_concurrent_locality_token3] = aux_sym_concurrent_locality_token3,
  [aux_sym__inline_if_statement_token1] = aux_sym__inline_if_statement_token1,
  [aux_sym__block_if_statement_token1] = aux_sym__block_if_statement_token1,
  [aux_sym_end_if_statement_token1] = aux_sym_end_if_statement_token1,
  [aux_sym_elseif_clause_token1] = aux_sym_elseif_clause_token1,
  [aux_sym_elseif_clause_token2] = aux_sym_elseif_clause_token2,
  [aux_sym__inline_where_statement_token1] = aux_sym__inline_where_statement_token1,
  [aux_sym_end_where_statement_token1] = aux_sym_end_where_statement_token1,
  [aux_sym_elsewhere_clause_token1] = aux_sym_elseif_clause_token1,
  [aux_sym__forall_control_expression_token1] = aux_sym__forall_control_expression_token1,
  [aux_sym_end_forall_statement_token1] = aux_sym_end_forall_statement_token1,
  [aux_sym_select_case_statement_token1] = aux_sym_select_case_statement_token1,
  [aux_sym_select_case_statement_token2] = aux_sym_select_case_statement_token2,
  [aux_sym_select_case_statement_token3] = aux_sym_select_case_statement_token1,
  [aux_sym_select_type_statement_token1] = aux_sym_select_type_statement_token1,
  [aux_sym_select_rank_statement_token1] = aux_sym_select_rank_statement_token1,
  [aux_sym_select_rank_statement_token2] = aux_sym_select_rank_statement_token2,
  [aux_sym_end_select_statement_token1] = aux_sym_end_select_statement_token1,
  [aux_sym_type_statement_token1] = aux_sym_type_statement_token1,
  [aux_sym_type_statement_token2] = aux_sym_type_statement_token1,
  [aux_sym_type_statement_token3] = aux_sym_type_statement_token3,
  [aux_sym__class_default_token1] = aux_sym__class_default_token1,
  [aux_sym_block_construct_token1] = aux_sym_block_construct_token1,
  [aux_sym_end_block_construct_statement_token1] = aux_sym_end_block_construct_statement_token1,
  [aux_sym_associate_statement_token1] = aux_sym_associate_statement_token1,
  [aux_sym_end_associate_statement_token1] = aux_sym_end_associate_statement_token1,
  [aux_sym_format_statement_token1] = aux_sym_format_statement_token1,
  [sym_edit_descriptor] = sym_edit_descriptor,
  [aux_sym_hollerith_constant_token1] = aux_sym_hollerith_constant_token1,
  [aux_sym_print_statement_token1] = aux_sym_print_statement_token1,
  [aux_sym_open_statement_token1] = aux_sym_open_statement_token1,
  [aux_sym_close_statement_token1] = aux_sym_close_statement_token1,
  [aux_sym_inquire_statement_token1] = aux_sym_inquire_statement_token1,
  [aux_sym_enum_statement_token1] = aux_sym_enum_statement_token1,
  [aux_sym_enumerator_statement_token1] = aux_sym_enumerator_statement_token1,
  [aux_sym_end_enum_statement_token1] = aux_sym_end_enum_statement_token1,
  [aux_sym_file_position_statement_token1] = aux_sym_file_position_statement_token1,
  [aux_sym_file_position_statement_token2] = aux_sym_file_position_statement_token2,
  [aux_sym_file_position_statement_token3] = aux_sym_file_position_statement_token3,
  [aux_sym_file_position_statement_token4] = aux_sym_file_position_statement_token4,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_logical_expression_token1] = aux_sym_logical_expression_token1,
  [aux_sym_logical_expression_token2] = aux_sym_logical_expression_token2,
  [aux_sym_logical_expression_token3] = aux_sym_logical_expression_token3,
  [aux_sym_logical_expression_token4] = aux_sym_logical_expression_token4,
  [aux_sym_logical_expression_token5] = aux_sym_logical_expression_token5,
  [anon_sym_LT] = anon_sym_LT,
  [aux_sym_relational_expression_token1] = aux_sym_relational_expression_token1,
  [anon_sym_GT] = anon_sym_GT,
  [aux_sym_relational_expression_token2] = aux_sym_relational_expression_token2,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [aux_sym_relational_expression_token3] = aux_sym_relational_expression_token3,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [aux_sym_relational_expression_token4] = aux_sym_relational_expression_token4,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [aux_sym_relational_expression_token5] = aux_sym_relational_expression_token5,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [aux_sym_relational_expression_token6] = aux_sym_relational_expression_token6,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym_user_defined_operator_token1] = aux_sym_user_defined_operator_token1,
  [sym_assumed_rank] = sym_assumed_rank,
  [anon_sym_LPAREN_SLASH] = anon_sym_LPAREN_SLASH,
  [anon_sym_SLASH_RPAREN] = anon_sym_SLASH_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym_boolean_literal] = sym_boolean_literal,
  [aux_sym_null_literal_token1] = aux_sym_null_literal_token1,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_preproc_file_line_token1] = aux_sym_preproc_file_line_token1,
  [aux_sym_identifier_token1] = aux_sym_identifier_token1,
  [sym_comment] = sym_comment,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_AMP] = anon_sym_AMP,
  [sym__integer_literal] = sym__integer_literal,
  [sym__float_literal] = sym__float_literal,
  [sym__boz_literal] = sym__boz_literal,
  [sym_string_literal] = sym_string_literal,
  [sym__end_of_statement] = sym__end_of_statement,
  [sym_translation_unit] = sym_translation_unit,
  [sym_program] = sym_program,
  [sym_program_statement] = sym_program_statement,
  [sym_end_program_statement] = sym_end_program_statement,
  [sym_module] = sym_module,
  [sym_module_statement] = sym_module_statement,
  [sym_end_module_statement] = sym_end_module_statement,
  [sym_submodule] = sym_submodule,
  [sym_submodule_statement] = sym_submodule_statement,
  [sym_end_submodule_statement] = sym_end_submodule_statement,
  [sym_module_name] = sym_module_name,
  [sym_interface] = sym_interface,
  [sym_interface_statement] = sym_interface_statement,
  [sym_end_interface_statement] = sym_end_interface_statement,
  [sym_assignment] = sym_assignment,
  [sym_operator] = sym_operator,
  [sym_defined_io_procedure] = sym_defined_io_procedure,
  [sym__generic_procedure] = sym__generic_procedure,
  [sym_subroutine] = sym_subroutine,
  [sym_subroutine_statement] = sym_subroutine_statement,
  [sym_end_subroutine_statement] = sym_end_subroutine_statement,
  [sym_module_procedure] = sym_module_procedure,
  [sym_module_procedure_statement] = sym_module_procedure_statement,
  [sym_end_module_procedure_statement] = sym_end_module_procedure_statement,
  [sym_function] = sym_function,
  [sym_function_statement] = sym_function_statement,
  [sym_language_binding] = sym_language_binding,
  [aux_sym__callable_interface_qualifers] = aux_sym__callable_interface_qualifers,
  [sym_procedure_attributes] = sym_procedure_attributes,
  [sym_end_function_statement] = sym_end_function_statement,
  [sym_function_result] = sym_function_result,
  [sym__name] = sym__name,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_internal_procedures] = sym_internal_procedures,
  [sym_contains_statement] = sym_contains_statement,
  [sym__specification_part] = sym__specification_part,
  [sym_use_statement] = sym_use_statement,
  [sym_included_items] = sym_included_items,
  [sym_use_alias] = sym_use_alias,
  [sym_implicit_statement] = sym_implicit_statement,
  [sym_save_statement] = sym_save_statement,
  [sym_private_statement] = sym_private_statement,
  [sym_public_statement] = sym_public_statement,
  [sym_namelist_statement] = sym_namelist_statement,
  [sym_common_statement] = sym_common_statement,
  [sym_variable_group] = sym_variable_group,
  [sym_implicit_range] = sym_implicit_range,
  [sym_import_statement] = sym_import_statement,
  [sym__import_names] = sym__import_names,
  [sym_derived_type_definition] = sym_derived_type_definition,
  [sym_abstract_specifier] = sym_abstract_specifier,
  [sym_access_specifier] = sym_access_specifier,
  [sym_base_type_specifier] = sym_base_type_specifier,
  [sym__derived_type_qualifier] = sym__derived_type_qualifier,
  [sym_derived_type_statement] = sym_derived_type_statement,
  [sym_end_type_statement] = sym_end_type_statement,
  [sym__type_name] = sym__type_name,
  [sym_derived_type_procedures] = sym_derived_type_procedures,
  [sym_procedure_statement] = sym_procedure_statement,
  [sym_binding_name] = sym_binding_name,
  [sym_method_name] = sym_method_name,
  [sym__procedure_kind] = sym__procedure_kind,
  [sym_procedure_attribute] = sym_procedure_attribute,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_procedure_declaration] = sym_procedure_declaration,
  [sym_variable_modification] = sym_variable_modification,
  [sym_variable_attributes] = sym_variable_attributes,
  [sym__declaration_targets] = sym__declaration_targets,
  [sym__intrinsic_type] = sym__intrinsic_type,
  [sym_intrinsic_type] = sym_intrinsic_type,
  [sym_derived_type] = sym_derived_type,
  [sym_unlimited_polymorphic] = sym_unlimited_polymorphic,
  [sym_size] = sym_size,
  [sym_character_length] = sym_character_length,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_procedure_qualifier] = sym_procedure_qualifier,
  [sym_parameter_statement] = sym_parameter_statement,
  [sym_parameter_assignment] = sym_parameter_assignment,
  [sym_equivalence_statement] = sym_equivalence_statement,
  [sym_equivalence_set] = sym_equivalence_set,
  [sym__statements] = sym__statements,
  [sym_statement_label] = sym_statement_label,
  [sym_statement_label_reference] = sym_statement_label_reference,
  [sym_stop_statement] = sym_stop_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_pointer_association_statement] = sym_pointer_association_statement,
  [sym_subroutine_call] = sym_subroutine_call,
  [sym_cuda_kernel_argument_list] = sym_cuda_kernel_argument_list,
  [sym_keyword_statement] = sym_keyword_statement,
  [sym_include_statement] = sym_include_statement,
  [sym_data_statement] = sym_data_statement,
  [sym_data_set] = sym_data_set,
  [sym_data_value] = sym_data_value,
  [sym_do_loop_statement] = sym_do_loop_statement,
  [sym_do_label_statement] = sym_do_label_statement,
  [sym_end_do_loop_statement] = sym_end_do_loop_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_concurrent_statement] = sym_concurrent_statement,
  [sym_concurrent_header] = sym_concurrent_header,
  [sym_concurrent_control] = sym_concurrent_control,
  [sym_concurrent_locality] = sym_concurrent_locality,
  [sym_if_statement] = sym_if_statement,
  [sym__inline_if_statement] = sym__inline_if_statement,
  [sym_arithmetic_if_statement] = sym_arithmetic_if_statement,
  [sym__block_if_statement] = sym__block_if_statement,
  [sym_end_if_statement] = sym_end_if_statement,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_where_statement] = sym_where_statement,
  [sym__inline_where_statement] = sym__inline_where_statement,
  [sym__block_where_statement] = sym__block_where_statement,
  [sym_end_where_statement] = sym_end_where_statement,
  [sym_elsewhere_clause] = sym_elsewhere_clause,
  [sym_forall_statement] = sym_forall_statement,
  [sym_triplet_spec] = sym_triplet_spec,
  [sym__forall_control_expression] = sym__forall_control_expression,
  [sym__inline_forall_statement] = sym__inline_forall_statement,
  [sym__block_forall_statement] = sym__block_forall_statement,
  [sym_end_forall_statement] = sym_end_forall_statement,
  [sym_select_case_statement] = sym_select_case_statement,
  [sym_select_type_statement] = sym_select_type_statement,
  [sym_select_rank_statement] = sym_select_rank_statement,
  [sym_end_select_statement] = sym_end_select_statement,
  [sym_selector] = sym_selector,
  [sym_case_statement] = sym_case_statement,
  [sym_type_statement] = sym_type_statement,
  [sym__class_default] = sym__class_default,
  [sym_case_value_range_list] = sym_case_value_range_list,
  [sym_rank_statement] = sym_rank_statement,
  [sym_block_construct] = sym_block_construct,
  [sym_end_block_construct_statement] = sym_end_block_construct_statement,
  [sym_associate_statement] = sym_associate_statement,
  [sym_association] = sym_association,
  [sym_end_associate_statement] = sym_end_associate_statement,
  [sym_format_statement] = sym_format_statement,
  [sym__transfer_item] = sym__transfer_item,
  [sym__transfer_items] = sym__transfer_items,
  [sym_hollerith_constant] = sym_hollerith_constant,
  [sym__io_arguments] = sym__io_arguments,
  [sym_read_statement] = sym_read_statement,
  [sym__simple_read_statement] = sym__simple_read_statement,
  [sym__parameterized_read_statement] = sym__parameterized_read_statement,
  [sym_print_statement] = sym_print_statement,
  [sym_open_statement] = sym_open_statement,
  [sym_close_statement] = sym_close_statement,
  [sym_write_statement] = sym_write_statement,
  [sym_inquire_statement] = sym_inquire_statement,
  [sym_enum] = sym_enum,
  [sym_enum_statement] = sym_enum_statement,
  [sym_enumerator_statement] = sym_enumerator_statement,
  [sym_end_enum_statement] = sym_end_enum_statement,
  [sym_unit_identifier] = sym_unit_identifier,
  [sym_format_identifier] = sym_format_identifier,
  [sym__file_position_spec] = sym__file_position_spec,
  [sym_file_position_statement] = sym_file_position_statement,
  [sym__io_expressions] = sym__io_expressions,
  [sym_input_item_list] = sym_input_item_list,
  [sym_output_item_list] = sym_output_item_list,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_derived_type_member_expression] = sym_derived_type_member_expression,
  [sym_logical_expression] = sym_logical_expression,
  [sym_relational_expression] = sym_relational_expression,
  [sym_concatenation_expression] = sym_concatenation_expression,
  [sym_math_expression] = sym_math_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_user_defined_operator] = sym_user_defined_operator,
  [sym_call_expression] = sym_call_expression,
  [sym_implied_do_loop_expression] = sym_implied_do_loop_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_extent_specifier] = sym_extent_specifier,
  [sym_assumed_size] = sym_assumed_size,
  [sym_assumed_shape] = sym_assumed_shape,
  [sym_block_label_start_expression] = sym_block_label_start_expression,
  [sym__block_label] = sym__block_label,
  [sym_loop_control_expression] = sym_loop_control_expression,
  [sym_array_literal] = sym_array_literal,
  [sym__array_constructor_legacy] = sym__array_constructor_legacy,
  [sym__array_constructor_f2003] = sym__array_constructor_f2003,
  [sym__type_spec] = sym__type_spec,
  [sym__ac_value_list] = sym__ac_value_list,
  [sym_complex_literal] = sym_complex_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_null_literal] = sym_null_literal,
  [sym_preproc_file_line] = sym_preproc_file_line,
  [sym_identifier] = sym_identifier,
  [sym__newline] = sym__newline,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_program_repeat2] = aux_sym_program_repeat2,
  [aux_sym_interface_repeat1] = aux_sym_interface_repeat1,
  [aux_sym_function_statement_repeat1] = aux_sym_function_statement_repeat1,
  [aux_sym_procedure_attributes_repeat1] = aux_sym_procedure_attributes_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_internal_procedures_repeat1] = aux_sym_internal_procedures_repeat1,
  [aux_sym_use_statement_repeat1] = aux_sym_use_statement_repeat1,
  [aux_sym_included_items_repeat1] = aux_sym_included_items_repeat1,
  [aux_sym_implicit_statement_repeat1] = aux_sym_implicit_statement_repeat1,
  [aux_sym_implicit_statement_repeat2] = aux_sym_implicit_statement_repeat2,
  [aux_sym_implicit_statement_repeat3] = aux_sym_implicit_statement_repeat3,
  [aux_sym_save_statement_repeat1] = aux_sym_save_statement_repeat1,
  [aux_sym_private_statement_repeat1] = aux_sym_private_statement_repeat1,
  [aux_sym_namelist_statement_repeat1] = aux_sym_namelist_statement_repeat1,
  [aux_sym_common_statement_repeat1] = aux_sym_common_statement_repeat1,
  [aux_sym_derived_type_definition_repeat1] = aux_sym_derived_type_definition_repeat1,
  [aux_sym_derived_type_statement_repeat1] = aux_sym_derived_type_statement_repeat1,
  [aux_sym_derived_type_procedures_repeat1] = aux_sym_derived_type_procedures_repeat1,
  [aux_sym_procedure_statement_repeat1] = aux_sym_procedure_statement_repeat1,
  [aux_sym_procedure_statement_repeat2] = aux_sym_procedure_statement_repeat2,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_variable_modification_repeat1] = aux_sym_variable_modification_repeat1,
  [aux_sym__declaration_targets_repeat1] = aux_sym__declaration_targets_repeat1,
  [aux_sym_parameter_statement_repeat1] = aux_sym_parameter_statement_repeat1,
  [aux_sym_equivalence_statement_repeat1] = aux_sym_equivalence_statement_repeat1,
  [aux_sym_equivalence_set_repeat1] = aux_sym_equivalence_set_repeat1,
  [aux_sym_cuda_kernel_argument_list_repeat1] = aux_sym_cuda_kernel_argument_list_repeat1,
  [aux_sym_keyword_statement_repeat1] = aux_sym_keyword_statement_repeat1,
  [aux_sym_data_statement_repeat1] = aux_sym_data_statement_repeat1,
  [aux_sym_data_set_repeat1] = aux_sym_data_set_repeat1,
  [aux_sym_data_value_repeat1] = aux_sym_data_value_repeat1,
  [aux_sym_concurrent_statement_repeat1] = aux_sym_concurrent_statement_repeat1,
  [aux_sym_concurrent_header_repeat1] = aux_sym_concurrent_header_repeat1,
  [aux_sym__block_if_statement_repeat1] = aux_sym__block_if_statement_repeat1,
  [aux_sym__block_where_statement_repeat1] = aux_sym__block_where_statement_repeat1,
  [aux_sym__forall_control_expression_repeat1] = aux_sym__forall_control_expression_repeat1,
  [aux_sym_select_case_statement_repeat1] = aux_sym_select_case_statement_repeat1,
  [aux_sym_select_type_statement_repeat1] = aux_sym_select_type_statement_repeat1,
  [aux_sym_select_rank_statement_repeat1] = aux_sym_select_rank_statement_repeat1,
  [aux_sym_case_value_range_list_repeat1] = aux_sym_case_value_range_list_repeat1,
  [aux_sym_associate_statement_repeat1] = aux_sym_associate_statement_repeat1,
  [aux_sym__transfer_items_repeat1] = aux_sym__transfer_items_repeat1,
  [aux_sym__io_arguments_repeat1] = aux_sym__io_arguments_repeat1,
  [aux_sym_enum_repeat1] = aux_sym_enum_repeat1,
  [aux_sym_enumerator_statement_repeat1] = aux_sym_enumerator_statement_repeat1,
  [aux_sym_call_expression_repeat1] = aux_sym_call_expression_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [alias_sym_block_label] = alias_sym_block_label,
  [anon_alias_sym_class] = anon_alias_sym_class,
  [alias_sym_concurrent_mask] = alias_sym_concurrent_mask,
  [anon_alias_sym_default] = anon_alias_sym_default,
  [anon_alias_sym_double] = anon_alias_sym_double,
  [anon_alias_sym_else] = anon_alias_sym_else,
  [anon_alias_sym_end] = anon_alias_sym_end,
  [alias_sym_filename] = alias_sym_filename,
  [anon_alias_sym_label] = anon_alias_sym_label,
  [alias_sym_local_name] = alias_sym_local_name,
  [anon_alias_sym_method_name] = anon_alias_sym_method_name,
  [alias_sym_name] = alias_sym_name,
  [anon_alias_sym_none] = anon_alias_sym_none,
  [alias_sym_preproc_line_number] = alias_sym_preproc_line_number,
  [alias_sym_procedure_interface] = alias_sym_procedure_interface,
  [anon_alias_sym_program] = anon_alias_sym_program,
  [anon_alias_sym_select] = anon_alias_sym_select,
  [anon_alias_sym_sequence] = anon_alias_sym_sequence,
  [anon_alias_sym_statement_label] = anon_alias_sym_statement_label,
  [anon_alias_sym_statement_label_reference] = anon_alias_sym_statement_label_reference,
  [alias_sym_transfer_items] = alias_sym_transfer_items,
  [alias_sym_type_member] = alias_sym_type_member,
  [alias_sym_type_name] = alias_sym_type_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_program_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_program_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_program_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_module_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_module_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_submodule_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_submodule_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interface_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_interface_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_assignment_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_operator_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_defined_io_procedure_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_defined_io_procedure_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_defined_io_procedure_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_defined_io_procedure_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_subroutine_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_subroutine_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_module_procedure_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_module_procedure_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_function_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_language_binding_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attributes_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attributes_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attributes_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attributes_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attributes_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_function_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_function_result_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_contains_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_use_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_use_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_use_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_included_items_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_implicit_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_implicit_statement_token2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_implicit_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_implicit_statement_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_save_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_private_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_public_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namelist_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_common_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_implicit_range_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__import_names_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_derived_type_definition_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_abstract_specifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_base_type_specifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_type_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__procedure_kind_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__procedure_kind_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__procedure_kind_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__procedure_kind_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_attribute_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_attributes_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_attributes_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_attributes_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_attributes_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_variable_attributes_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token7] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token8] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token9] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_intrinsic_type_token10] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_derived_type_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_size_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_qualifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token7] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token8] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token9] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token10] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token11] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token12] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token13] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token14] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_qualifier_token15] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_qualifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_qualifier_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_qualifier_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_qualifier_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_equivalence_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_stop_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_stop_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_stop_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_subroutine_call_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token6] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyword_statement_token7] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_data_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_do_loop_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_do_loop_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_concurrent_header_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_concurrent_locality_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_concurrent_locality_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_concurrent_locality_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__inline_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__block_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_elseif_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_elseif_clause_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__inline_where_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_where_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_elsewhere_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__forall_control_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_forall_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_case_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_case_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_case_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_type_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_rank_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_select_rank_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_select_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_type_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__class_default_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_construct_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_block_construct_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_associate_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_associate_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_edit_descriptor] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_hollerith_constant_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_open_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_close_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_inquire_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enumerator_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_enum_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_file_position_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_file_position_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_file_position_statement_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_file_position_statement_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_expression_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_expression_token5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_expression_token6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_user_defined_operator_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_assumed_rank] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_null_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_file_line_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym__integer_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__float_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__boz_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__end_of_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_program_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_program_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_module_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_module_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_submodule] = {
    .visible = true,
    .named = true,
  },
  [sym_submodule_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_submodule_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_module_name] = {
    .visible = true,
    .named = true,
  },
  [sym_interface] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_interface_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_defined_io_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym__generic_procedure] = {
    .visible = false,
    .named = true,
  },
  [sym_subroutine] = {
    .visible = true,
    .named = true,
  },
  [sym_subroutine_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_subroutine_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_module_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_module_procedure_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_module_procedure_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_language_binding] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__callable_interface_qualifers] = {
    .visible = false,
    .named = false,
  },
  [sym_procedure_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_end_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_result] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_procedures] = {
    .visible = true,
    .named = true,
  },
  [sym_contains_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__specification_part] = {
    .visible = false,
    .named = true,
  },
  [sym_use_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_included_items] = {
    .visible = true,
    .named = true,
  },
  [sym_use_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_save_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_private_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_public_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namelist_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_common_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_group] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_range] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_names] = {
    .visible = false,
    .named = true,
  },
  [sym_derived_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__derived_type_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_derived_type_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_type_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_name] = {
    .visible = false,
    .named = true,
  },
  [sym_derived_type_procedures] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_binding_name] = {
    .visible = true,
    .named = true,
  },
  [sym_method_name] = {
    .visible = true,
    .named = true,
  },
  [sym__procedure_kind] = {
    .visible = false,
    .named = true,
  },
  [sym_procedure_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_modification] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_targets] = {
    .visible = false,
    .named = true,
  },
  [sym__intrinsic_type] = {
    .visible = false,
    .named = true,
  },
  [sym_intrinsic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_derived_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unlimited_polymorphic] = {
    .visible = true,
    .named = true,
  },
  [sym_size] = {
    .visible = true,
    .named = true,
  },
  [sym_character_length] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_equivalence_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_equivalence_set] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_statement_label] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_label_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_stop_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_association_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subroutine_call] = {
    .visible = true,
    .named = true,
  },
  [sym_cuda_kernel_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_include_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_data_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_data_set] = {
    .visible = true,
    .named = true,
  },
  [sym_data_value] = {
    .visible = true,
    .named = true,
  },
  [sym_do_loop_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_do_loop_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_concurrent_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_concurrent_header] = {
    .visible = true,
    .named = true,
  },
  [sym_concurrent_control] = {
    .visible = true,
    .named = true,
  },
  [sym_concurrent_locality] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_if_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_arithmetic_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__block_if_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_end_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_where_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__block_where_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_end_where_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elsewhere_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_forall_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_triplet_spec] = {
    .visible = true,
    .named = true,
  },
  [sym__forall_control_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_forall_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__block_forall_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_end_forall_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_select_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_select_type_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_select_rank_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__class_default] = {
    .visible = true,
    .named = true,
  },
  [sym_case_value_range_list] = {
    .visible = true,
    .named = true,
  },
  [sym_rank_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_block_construct] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block_construct_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_associate_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_association] = {
    .visible = true,
    .named = true,
  },
  [sym_end_associate_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_format_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__transfer_item] = {
    .visible = false,
    .named = true,
  },
  [sym__transfer_items] = {
    .visible = false,
    .named = true,
  },
  [sym_hollerith_constant] = {
    .visible = true,
    .named = true,
  },
  [sym__io_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_read_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_read_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__parameterized_read_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_open_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_close_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_write_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inquire_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_end_enum_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_format_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__file_position_spec] = {
    .visible = false,
    .named = true,
  },
  [sym_file_position_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__io_expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_input_item_list] = {
    .visible = true,
    .named = true,
  },
  [sym_output_item_list] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_derived_type_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implied_do_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_extent_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_assumed_size] = {
    .visible = true,
    .named = true,
  },
  [sym_assumed_shape] = {
    .visible = true,
    .named = true,
  },
  [sym_block_label_start_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__block_label] = {
    .visible = false,
    .named = true,
  },
  [sym_loop_control_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__array_constructor_legacy] = {
    .visible = false,
    .named = true,
  },
  [sym__array_constructor_f2003] = {
    .visible = false,
    .named = true,
  },
  [sym__type_spec] = {
    .visible = false,
    .named = true,
  },
  [sym__ac_value_list] = {
    .visible = false,
    .named = true,
  },
  [sym_complex_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_file_line] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_procedure_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_internal_procedures_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_included_items_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implicit_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implicit_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implicit_statement_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_save_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_private_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namelist_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_common_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_derived_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_derived_type_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_derived_type_procedures_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_procedure_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_procedure_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_modification_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_targets_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_equivalence_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_equivalence_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cuda_kernel_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyword_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concurrent_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concurrent_header_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__block_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__block_where_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__forall_control_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_type_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_rank_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_value_range_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_associate_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__transfer_items_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__io_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_block_label] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_class] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_concurrent_mask] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_end] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_filename] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_label] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_local_name] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_method_name] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_name] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_none] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_preproc_line_number] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_procedure_interface] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_program] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_sequence] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_statement_label] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_statement_label_reference] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_transfer_items] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_member] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_name] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_access = 1,
  field_ancestor = 2,
  field_argument = 3,
  field_base = 4,
  field_final = 5,
  field_initial = 6,
  field_left = 7,
  field_name = 8,
  field_operator = 9,
  field_parameters = 10,
  field_parent = 11,
  field_path = 12,
  field_repeat = 13,
  field_right = 14,
  field_selector = 15,
  field_step = 16,
  field_subroutine = 17,
  field_type = 18,
  field_value = 19,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_access] = "access",
  [field_ancestor] = "ancestor",
  [field_argument] = "argument",
  [field_base] = "base",
  [field_final] = "final",
  [field_initial] = "initial",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_parent] = "parent",
  [field_path] = "path",
  [field_repeat] = "repeat",
  [field_right] = "right",
  [field_selector] = "selector",
  [field_step] = "step",
  [field_subroutine] = "subroutine",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [7] = {.index = 0, .length = 1},
  [11] = {.index = 1, .length = 1},
  [14] = {.index = 2, .length = 2},
  [16] = {.index = 4, .length = 1},
  [17] = {.index = 5, .length = 1},
  [18] = {.index = 6, .length = 1},
  [21] = {.index = 7, .length = 2},
  [23] = {.index = 9, .length = 1},
  [24] = {.index = 10, .length = 1},
  [28] = {.index = 11, .length = 1},
  [33] = {.index = 12, .length = 1},
  [38] = {.index = 13, .length = 2},
  [39] = {.index = 15, .length = 3},
  [55] = {.index = 18, .length = 2},
  [58] = {.index = 20, .length = 1},
  [59] = {.index = 21, .length = 2},
  [61] = {.index = 23, .length = 2},
  [62] = {.index = 25, .length = 4},
  [69] = {.index = 29, .length = 2},
  [73] = {.index = 31, .length = 2},
  [74] = {.index = 33, .length = 1},
  [75] = {.index = 34, .length = 2},
  [87] = {.index = 36, .length = 1},
  [90] = {.index = 37, .length = 2},
  [91] = {.index = 39, .length = 4},
  [92] = {.index = 43, .length = 1},
  [93] = {.index = 44, .length = 1},
  [97] = {.index = 45, .length = 2},
  [101] = {.index = 47, .length = 2},
  [103] = {.index = 49, .length = 2},
  [105] = {.index = 44, .length = 1},
  [106] = {.index = 44, .length = 1},
  [107] = {.index = 51, .length = 4},
  [108] = {.index = 44, .length = 1},
  [110] = {.index = 55, .length = 1},
  [111] = {.index = 55, .length = 1},
  [112] = {.index = 44, .length = 1},
  [113] = {.index = 56, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0, .inherited = true},
  [1] =
    {field_name, 1},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_subroutine, 1},
  [5] =
    {field_path, 1},
  [6] =
    {field_type, 0},
  [7] =
    {field_name, 1},
    {field_parameters, 2},
  [9] =
    {field_access, 0},
  [10] =
    {field_base, 0},
  [11] =
    {field_type, 1, .inherited = true},
  [12] =
    {field_name, 2},
  [13] =
    {field_left, 0},
    {field_right, 2},
  [15] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [18] =
    {field_name, 2},
    {field_parameters, 3},
  [20] =
    {field_ancestor, 2},
  [21] =
    {field_name, 0},
    {field_value, 2},
  [23] =
    {field_access, 1, .inherited = true},
    {field_base, 1, .inherited = true},
  [25] =
    {field_access, 0, .inherited = true},
    {field_access, 1, .inherited = true},
    {field_base, 0, .inherited = true},
    {field_base, 1, .inherited = true},
  [29] =
    {field_name, 0},
    {field_selector, 2},
  [31] =
    {field_access, 2, .inherited = true},
    {field_base, 2, .inherited = true},
  [33] =
    {field_repeat, 2, .inherited = true},
  [34] =
    {field_repeat, 0, .inherited = true},
    {field_repeat, 1, .inherited = true},
  [36] =
    {field_name, 3},
  [37] =
    {field_ancestor, 2},
    {field_parent, 4},
  [39] =
    {field_access, 2, .inherited = true},
    {field_access, 3, .inherited = true},
    {field_base, 2, .inherited = true},
    {field_base, 3, .inherited = true},
  [43] =
    {field_repeat, 1},
  [44] =
    {field_type, 2},
  [45] =
    {field_access, 3, .inherited = true},
    {field_base, 3, .inherited = true},
  [47] =
    {field_repeat, 1},
    {field_repeat, 4, .inherited = true},
  [49] =
    {field_final, 4},
    {field_initial, 2},
  [51] =
    {field_access, 3, .inherited = true},
    {field_access, 4, .inherited = true},
    {field_base, 3, .inherited = true},
    {field_base, 4, .inherited = true},
  [55] =
    {field_type, 3},
  [56] =
    {field_final, 4},
    {field_initial, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = anon_alias_sym_statement_label,
  },
  [2] = {
    [0] = anon_alias_sym_end,
  },
  [3] = {
    [0] = anon_alias_sym_sequence,
  },
  [4] = {
    [0] = anon_alias_sym_double,
  },
  [5] = {
    [0] = aux_sym_intrinsic_type_token8,
  },
  [6] = {
    [0] = anon_alias_sym_select,
  },
  [8] = {
    [0] = anon_alias_sym_program,
  },
  [9] = {
    [0] = alias_sym_name,
  },
  [10] = {
    [0] = anon_alias_sym_statement_label_reference,
  },
  [12] = {
    [1] = sym_module_name,
  },
  [13] = {
    [0] = alias_sym_type_name,
  },
  [15] = {
    [0] = aux_sym_intrinsic_type_token8,
    [1] = aux_sym_intrinsic_type_token8,
  },
  [17] = {
    [1] = alias_sym_filename,
  },
  [19] = {
    [0] = aux_sym_end_enum_statement_token1,
  },
  [20] = {
    [0] = anon_alias_sym_label,
  },
  [22] = {
    [2] = sym_module_name,
  },
  [25] = {
    [1] = anon_alias_sym_none,
  },
  [26] = {
    [0] = aux_sym_end_do_loop_statement_token1,
  },
  [27] = {
    [0] = aux_sym_end_block_construct_statement_token1,
  },
  [29] = {
    [0] = aux_sym_end_module_statement_token1,
  },
  [30] = {
    [0] = aux_sym_end_submodule_statement_token1,
  },
  [31] = {
    [0] = aux_sym_end_interface_statement_token1,
  },
  [32] = {
    [0] = anon_alias_sym_method_name,
  },
  [34] = {
    [0] = aux_sym_end_type_statement_token1,
  },
  [35] = {
    [0] = sym_assumed_size,
  },
  [36] = {
    [0] = aux_sym_end_forall_statement_token1,
  },
  [37] = {
    [0] = aux_sym_end_enum_statement_token1,
    [1] = aux_sym_end_enum_statement_token1,
  },
  [40] = {
    [2] = alias_sym_type_member,
  },
  [41] = {
    [1] = alias_sym_preproc_line_number,
  },
  [42] = {
    [2] = alias_sym_procedure_interface,
  },
  [43] = {
    [0] = anon_alias_sym_class,
  },
  [44] = {
    [2] = aux_sym_type_qualifier_token8,
  },
  [45] = {
    [0] = aux_sym_end_do_loop_statement_token1,
    [1] = aux_sym_end_do_loop_statement_token1,
  },
  [46] = {
    [0] = alias_sym_block_label,
  },
  [47] = {
    [0] = aux_sym_end_where_statement_token1,
  },
  [48] = {
    [0] = aux_sym_end_block_construct_statement_token1,
    [1] = aux_sym_end_block_construct_statement_token1,
  },
  [49] = {
    [2] = alias_sym_transfer_items,
  },
  [50] = {
    [0] = aux_sym_end_module_statement_token1,
    [1] = aux_sym_end_module_statement_token1,
  },
  [51] = {
    [0] = aux_sym_end_submodule_statement_token1,
    [1] = aux_sym_end_submodule_statement_token1,
  },
  [52] = {
    [0] = aux_sym_end_interface_statement_token1,
    [1] = aux_sym_end_interface_statement_token1,
  },
  [53] = {
    [0] = aux_sym_end_subroutine_statement_token1,
  },
  [54] = {
    [0] = aux_sym_end_function_statement_token1,
  },
  [56] = {
    [0] = aux_sym_end_type_statement_token1,
    [1] = aux_sym_end_type_statement_token1,
  },
  [57] = {
    [0] = aux_sym_end_forall_statement_token1,
    [1] = aux_sym_end_forall_statement_token1,
  },
  [60] = {
    [4] = sym_module_name,
  },
  [63] = {
    [2] = aux_sym_type_qualifier_token8,
    [3] = aux_sym_type_qualifier_token8,
  },
  [64] = {
    [0] = aux_sym_end_if_statement_token1,
  },
  [65] = {
    [0] = aux_sym_end_where_statement_token1,
    [1] = aux_sym_end_where_statement_token1,
  },
  [66] = {
    [0] = aux_sym_end_select_statement_token1,
  },
  [67] = {
    [0] = aux_sym_select_type_statement_token1,
  },
  [68] = {
    [0] = aux_sym_select_rank_statement_token2,
  },
  [70] = {
    [0] = aux_sym_end_subroutine_statement_token1,
    [1] = aux_sym_end_subroutine_statement_token1,
  },
  [71] = {
    [0] = aux_sym_end_function_statement_token1,
    [1] = aux_sym_end_function_statement_token1,
  },
  [72] = {
    [0] = alias_sym_local_name,
  },
  [76] = {
    [0] = anon_alias_sym_default,
    [2] = anon_alias_sym_none,
  },
  [77] = {
    [0] = aux_sym_end_if_statement_token1,
    [1] = aux_sym_end_if_statement_token1,
  },
  [78] = {
    [0] = anon_alias_sym_else,
  },
  [79] = {
    [1] = aux_sym_elseif_clause_token1,
  },
  [80] = {
    [0] = aux_sym_select_type_statement_token1,
    [1] = aux_sym_select_type_statement_token1,
  },
  [81] = {
    [1] = aux_sym_select_case_statement_token1,
  },
  [82] = {
    [0] = aux_sym_select_rank_statement_token2,
    [1] = aux_sym_select_rank_statement_token2,
  },
  [83] = {
    [1] = sym__class_default,
  },
  [84] = {
    [0] = aux_sym_end_select_statement_token1,
    [1] = aux_sym_end_select_statement_token1,
  },
  [85] = {
    [0] = aux_sym_end_associate_statement_token1,
  },
  [86] = {
    [0] = aux_sym_end_module_procedure_statement_token1,
  },
  [88] = {
    [1] = aux_sym_select_type_statement_token1,
  },
  [89] = {
    [1] = aux_sym_select_rank_statement_token2,
  },
  [94] = {
    [4] = alias_sym_concurrent_mask,
  },
  [95] = {
    [0] = aux_sym_end_associate_statement_token1,
    [1] = aux_sym_end_associate_statement_token1,
  },
  [96] = {
    [0] = aux_sym_end_module_procedure_statement_token1,
    [1] = aux_sym_end_module_procedure_statement_token1,
  },
  [98] = {
    [1] = aux_sym_select_type_statement_token1,
    [2] = aux_sym_select_type_statement_token1,
  },
  [99] = {
    [1] = aux_sym_select_case_statement_token1,
    [2] = aux_sym_select_case_statement_token1,
  },
  [100] = {
    [1] = aux_sym_select_rank_statement_token2,
    [2] = aux_sym_select_rank_statement_token2,
  },
  [102] = {
    [5] = alias_sym_concurrent_mask,
  },
  [104] = {
    [0] = aux_sym_elseif_clause_token2,
  },
  [105] = {
    [0] = aux_sym_type_statement_token1,
  },
  [106] = {
    [0] = aux_sym_type_statement_token3,
  },
  [108] = {
    [6] = alias_sym_concurrent_mask,
  },
  [109] = {
    [0] = aux_sym_elseif_clause_token2,
    [1] = aux_sym_elseif_clause_token2,
  },
  [110] = {
    [0] = aux_sym_type_statement_token1,
  },
  [111] = {
    [0] = aux_sym_type_statement_token3,
    [1] = aux_sym_type_statement_token3,
  },
  [112] = {
    [7] = alias_sym_concurrent_mask,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_statement_label, 2,
    sym_statement_label,
    anon_alias_sym_statement_label_reference,
  sym__transfer_items, 2,
    sym__transfer_items,
    alias_sym_transfer_items,
  sym__expression, 2,
    sym__expression,
    alias_sym_concurrent_mask,
  sym_identifier, 10,
    sym_identifier,
    alias_sym_block_label,
    alias_sym_local_name,
    alias_sym_name,
    alias_sym_procedure_interface,
    alias_sym_type_member,
    alias_sym_type_name,
    anon_alias_sym_label,
    anon_alias_sym_method_name,
    sym_module_name,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 4,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 11,
  [15] = 8,
  [16] = 10,
  [17] = 11,
  [18] = 12,
  [19] = 13,
  [20] = 4,
  [21] = 8,
  [22] = 10,
  [23] = 11,
  [24] = 12,
  [25] = 13,
  [26] = 4,
  [27] = 8,
  [28] = 10,
  [29] = 11,
  [30] = 12,
  [31] = 13,
  [32] = 4,
  [33] = 8,
  [34] = 10,
  [35] = 11,
  [36] = 12,
  [37] = 13,
  [38] = 8,
  [39] = 10,
  [40] = 11,
  [41] = 12,
  [42] = 13,
  [43] = 4,
  [44] = 8,
  [45] = 10,
  [46] = 11,
  [47] = 4,
  [48] = 8,
  [49] = 10,
  [50] = 4,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 55,
  [57] = 55,
  [58] = 55,
  [59] = 55,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 85,
  [96] = 94,
  [97] = 85,
  [98] = 98,
  [99] = 99,
  [100] = 87,
  [101] = 90,
  [102] = 94,
  [103] = 85,
  [104] = 98,
  [105] = 99,
  [106] = 106,
  [107] = 87,
  [108] = 90,
  [109] = 109,
  [110] = 94,
  [111] = 85,
  [112] = 98,
  [113] = 99,
  [114] = 87,
  [115] = 90,
  [116] = 94,
  [117] = 85,
  [118] = 98,
  [119] = 99,
  [120] = 87,
  [121] = 90,
  [122] = 98,
  [123] = 94,
  [124] = 98,
  [125] = 99,
  [126] = 99,
  [127] = 87,
  [128] = 90,
  [129] = 94,
  [130] = 85,
  [131] = 98,
  [132] = 99,
  [133] = 94,
  [134] = 85,
  [135] = 98,
  [136] = 99,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 83,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 83,
  [157] = 83,
  [158] = 158,
  [159] = 83,
  [160] = 83,
  [161] = 83,
  [162] = 162,
  [163] = 163,
  [164] = 83,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 83,
  [198] = 198,
  [199] = 83,
  [200] = 83,
  [201] = 201,
  [202] = 83,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 83,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 83,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 227,
  [229] = 227,
  [230] = 227,
  [231] = 227,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 232,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 232,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 232,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 232,
  [281] = 281,
  [282] = 232,
  [283] = 283,
  [284] = 232,
  [285] = 285,
  [286] = 232,
  [287] = 232,
  [288] = 288,
  [289] = 232,
  [290] = 232,
  [291] = 232,
  [292] = 232,
  [293] = 232,
  [294] = 294,
  [295] = 295,
  [296] = 283,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 300,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 297,
  [315] = 298,
  [316] = 267,
  [317] = 295,
  [318] = 299,
  [319] = 304,
  [320] = 270,
  [321] = 272,
  [322] = 301,
  [323] = 302,
  [324] = 300,
  [325] = 304,
  [326] = 243,
  [327] = 247,
  [328] = 305,
  [329] = 306,
  [330] = 307,
  [331] = 308,
  [332] = 283,
  [333] = 309,
  [334] = 310,
  [335] = 311,
  [336] = 312,
  [337] = 313,
  [338] = 297,
  [339] = 298,
  [340] = 267,
  [341] = 295,
  [342] = 299,
  [343] = 270,
  [344] = 272,
  [345] = 302,
  [346] = 300,
  [347] = 304,
  [348] = 243,
  [349] = 247,
  [350] = 305,
  [351] = 306,
  [352] = 307,
  [353] = 308,
  [354] = 283,
  [355] = 309,
  [356] = 310,
  [357] = 311,
  [358] = 312,
  [359] = 313,
  [360] = 267,
  [361] = 270,
  [362] = 272,
  [363] = 243,
  [364] = 247,
  [365] = 283,
  [366] = 311,
  [367] = 295,
  [368] = 299,
  [369] = 297,
  [370] = 298,
  [371] = 312,
  [372] = 305,
  [373] = 306,
  [374] = 307,
  [375] = 308,
  [376] = 313,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 301,
  [383] = 309,
  [384] = 310,
  [385] = 385,
  [386] = 267,
  [387] = 302,
  [388] = 270,
  [389] = 272,
  [390] = 243,
  [391] = 247,
  [392] = 301,
  [393] = 267,
  [394] = 243,
  [395] = 247,
  [396] = 308,
  [397] = 309,
  [398] = 310,
  [399] = 311,
  [400] = 283,
  [401] = 312,
  [402] = 313,
  [403] = 299,
  [404] = 301,
  [405] = 295,
  [406] = 302,
  [407] = 300,
  [408] = 270,
  [409] = 272,
  [410] = 304,
  [411] = 305,
  [412] = 306,
  [413] = 307,
  [414] = 297,
  [415] = 298,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 55,
  [423] = 420,
  [424] = 55,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 426,
  [429] = 426,
  [430] = 430,
  [431] = 426,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 435,
  [438] = 436,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 378,
  [453] = 385,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 432,
  [463] = 379,
  [464] = 464,
  [465] = 377,
  [466] = 466,
  [467] = 466,
  [468] = 466,
  [469] = 469,
  [470] = 466,
  [471] = 466,
  [472] = 469,
  [473] = 469,
  [474] = 466,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 455,
  [481] = 454,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 455,
  [486] = 454,
  [487] = 455,
  [488] = 488,
  [489] = 454,
  [490] = 455,
  [491] = 455,
  [492] = 492,
  [493] = 454,
  [494] = 494,
  [495] = 454,
  [496] = 496,
  [497] = 454,
  [498] = 498,
  [499] = 455,
  [500] = 454,
  [501] = 455,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 454,
  [506] = 506,
  [507] = 455,
  [508] = 454,
  [509] = 455,
  [510] = 510,
  [511] = 455,
  [512] = 512,
  [513] = 513,
  [514] = 460,
  [515] = 455,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 454,
  [522] = 454,
  [523] = 523,
  [524] = 519,
  [525] = 455,
  [526] = 456,
  [527] = 459,
  [528] = 528,
  [529] = 454,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 531,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 454,
  [542] = 455,
  [543] = 536,
  [544] = 531,
  [545] = 535,
  [546] = 536,
  [547] = 531,
  [548] = 535,
  [549] = 549,
  [550] = 536,
  [551] = 531,
  [552] = 552,
  [553] = 535,
  [554] = 536,
  [555] = 531,
  [556] = 535,
  [557] = 536,
  [558] = 531,
  [559] = 535,
  [560] = 536,
  [561] = 531,
  [562] = 536,
  [563] = 563,
  [564] = 310,
  [565] = 311,
  [566] = 312,
  [567] = 313,
  [568] = 385,
  [569] = 267,
  [570] = 570,
  [571] = 571,
  [572] = 270,
  [573] = 272,
  [574] = 574,
  [575] = 575,
  [576] = 243,
  [577] = 247,
  [578] = 307,
  [579] = 579,
  [580] = 308,
  [581] = 581,
  [582] = 283,
  [583] = 583,
  [584] = 385,
  [585] = 377,
  [586] = 378,
  [587] = 379,
  [588] = 381,
  [589] = 589,
  [590] = 309,
  [591] = 591,
  [592] = 310,
  [593] = 305,
  [594] = 311,
  [595] = 595,
  [596] = 596,
  [597] = 312,
  [598] = 598,
  [599] = 313,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 297,
  [607] = 306,
  [608] = 377,
  [609] = 378,
  [610] = 379,
  [611] = 611,
  [612] = 381,
  [613] = 613,
  [614] = 267,
  [615] = 615,
  [616] = 616,
  [617] = 295,
  [618] = 618,
  [619] = 299,
  [620] = 270,
  [621] = 272,
  [622] = 622,
  [623] = 623,
  [624] = 301,
  [625] = 302,
  [626] = 300,
  [627] = 304,
  [628] = 297,
  [629] = 298,
  [630] = 243,
  [631] = 247,
  [632] = 295,
  [633] = 305,
  [634] = 299,
  [635] = 306,
  [636] = 307,
  [637] = 308,
  [638] = 283,
  [639] = 309,
  [640] = 301,
  [641] = 302,
  [642] = 300,
  [643] = 622,
  [644] = 604,
  [645] = 613,
  [646] = 581,
  [647] = 304,
  [648] = 298,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 650,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 459,
  [675] = 675,
  [676] = 656,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 669,
  [681] = 671,
  [682] = 682,
  [683] = 683,
  [684] = 650,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 672,
  [689] = 673,
  [690] = 690,
  [691] = 682,
  [692] = 692,
  [693] = 693,
  [694] = 683,
  [695] = 685,
  [696] = 661,
  [697] = 686,
  [698] = 698,
  [699] = 650,
  [700] = 650,
  [701] = 687,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 650,
  [707] = 661,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 667,
  [712] = 669,
  [713] = 671,
  [714] = 714,
  [715] = 672,
  [716] = 673,
  [717] = 682,
  [718] = 683,
  [719] = 685,
  [720] = 720,
  [721] = 686,
  [722] = 687,
  [723] = 723,
  [724] = 724,
  [725] = 456,
  [726] = 693,
  [727] = 670,
  [728] = 728,
  [729] = 724,
  [730] = 730,
  [731] = 731,
  [732] = 670,
  [733] = 733,
  [734] = 663,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 655,
  [739] = 724,
  [740] = 670,
  [741] = 460,
  [742] = 661,
  [743] = 669,
  [744] = 671,
  [745] = 672,
  [746] = 673,
  [747] = 682,
  [748] = 683,
  [749] = 685,
  [750] = 686,
  [751] = 687,
  [752] = 752,
  [753] = 519,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 756,
  [758] = 755,
  [759] = 756,
  [760] = 755,
  [761] = 756,
  [762] = 755,
  [763] = 755,
  [764] = 756,
  [765] = 756,
  [766] = 755,
  [767] = 755,
  [768] = 756,
  [769] = 756,
  [770] = 755,
  [771] = 771,
  [772] = 772,
  [773] = 520,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 616,
  [779] = 779,
  [780] = 615,
  [781] = 618,
  [782] = 782,
  [783] = 600,
  [784] = 446,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 519,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 456,
  [795] = 795,
  [796] = 796,
  [797] = 708,
  [798] = 460,
  [799] = 799,
  [800] = 800,
  [801] = 459,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 447,
  [809] = 448,
  [810] = 810,
  [811] = 449,
  [812] = 735,
  [813] = 813,
  [814] = 736,
  [815] = 815,
  [816] = 451,
  [817] = 817,
  [818] = 752,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 659,
  [826] = 660,
  [827] = 827,
  [828] = 662,
  [829] = 829,
  [830] = 664,
  [831] = 657,
  [832] = 832,
  [833] = 464,
  [834] = 461,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 848,
  [851] = 851,
  [852] = 848,
  [853] = 853,
  [854] = 854,
  [855] = 853,
  [856] = 853,
  [857] = 857,
  [858] = 847,
  [859] = 847,
  [860] = 848,
  [861] = 857,
  [862] = 848,
  [863] = 848,
  [864] = 853,
  [865] = 854,
  [866] = 847,
  [867] = 847,
  [868] = 849,
  [869] = 853,
  [870] = 870,
  [871] = 871,
  [872] = 870,
  [873] = 851,
  [874] = 874,
  [875] = 875,
  [876] = 870,
  [877] = 871,
  [878] = 871,
  [879] = 874,
  [880] = 880,
  [881] = 847,
  [882] = 853,
  [883] = 883,
  [884] = 883,
  [885] = 844,
  [886] = 837,
  [887] = 840,
  [888] = 888,
  [889] = 841,
  [890] = 843,
  [891] = 842,
  [892] = 789,
  [893] = 893,
  [894] = 894,
  [895] = 777,
  [896] = 896,
  [897] = 377,
  [898] = 839,
  [899] = 845,
  [900] = 836,
  [901] = 901,
  [902] = 379,
  [903] = 903,
  [904] = 901,
  [905] = 896,
  [906] = 842,
  [907] = 893,
  [908] = 893,
  [909] = 893,
  [910] = 838,
  [911] = 911,
  [912] = 896,
  [913] = 913,
  [914] = 893,
  [915] = 385,
  [916] = 893,
  [917] = 846,
  [918] = 918,
  [919] = 378,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 921,
  [931] = 842,
  [932] = 921,
  [933] = 921,
  [934] = 928,
  [935] = 935,
  [936] = 922,
  [937] = 922,
  [938] = 928,
  [939] = 846,
  [940] = 940,
  [941] = 924,
  [942] = 921,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 921,
  [947] = 921,
  [948] = 927,
  [949] = 922,
  [950] = 926,
  [951] = 951,
  [952] = 846,
  [953] = 953,
  [954] = 923,
  [955] = 955,
  [956] = 838,
  [957] = 839,
  [958] = 836,
  [959] = 837,
  [960] = 960,
  [961] = 841,
  [962] = 843,
  [963] = 844,
  [964] = 845,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 926,
  [969] = 922,
  [970] = 928,
  [971] = 838,
  [972] = 929,
  [973] = 973,
  [974] = 951,
  [975] = 839,
  [976] = 836,
  [977] = 837,
  [978] = 840,
  [979] = 841,
  [980] = 843,
  [981] = 844,
  [982] = 845,
  [983] = 953,
  [984] = 984,
  [985] = 985,
  [986] = 922,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 928,
  [991] = 922,
  [992] = 928,
  [993] = 921,
  [994] = 928,
  [995] = 922,
  [996] = 996,
  [997] = 973,
  [998] = 842,
  [999] = 840,
  [1000] = 913,
  [1001] = 1001,
  [1002] = 823,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 903,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1005,
  [1016] = 777,
  [1017] = 456,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 460,
  [1022] = 459,
  [1023] = 381,
  [1024] = 789,
  [1025] = 385,
  [1026] = 377,
  [1027] = 378,
  [1028] = 379,
  [1029] = 913,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 432,
  [1071] = 824,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1061,
  [1080] = 1019,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1048,
  [1088] = 842,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 426,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1075,
  [1101] = 1076,
  [1102] = 1102,
  [1103] = 1061,
  [1104] = 1104,
  [1105] = 1095,
  [1106] = 1098,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1102,
  [1111] = 1061,
  [1112] = 1112,
  [1113] = 1102,
  [1114] = 1102,
  [1115] = 1102,
  [1116] = 1102,
  [1117] = 1117,
  [1118] = 1102,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 807,
  [1128] = 820,
  [1129] = 791,
  [1130] = 1130,
  [1131] = 792,
  [1132] = 793,
  [1133] = 824,
  [1134] = 810,
  [1135] = 821,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 796,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 456,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 460,
  [1148] = 459,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1136,
  [1153] = 1153,
  [1154] = 790,
  [1155] = 1137,
  [1156] = 800,
  [1157] = 1157,
  [1158] = 804,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 274,
  [1163] = 238,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 426,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1161,
  [1174] = 1174,
  [1175] = 248,
  [1176] = 252,
  [1177] = 1177,
  [1178] = 255,
  [1179] = 259,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 819,
  [1185] = 1185,
  [1186] = 786,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1180,
  [1191] = 233,
  [1192] = 234,
  [1193] = 294,
  [1194] = 1183,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 269,
  [1198] = 1180,
  [1199] = 271,
  [1200] = 1183,
  [1201] = 1180,
  [1202] = 1180,
  [1203] = 1203,
  [1204] = 1183,
  [1205] = 1205,
  [1206] = 1160,
  [1207] = 245,
  [1208] = 246,
  [1209] = 754,
  [1210] = 1180,
  [1211] = 250,
  [1212] = 1183,
  [1213] = 257,
  [1214] = 1180,
  [1215] = 1183,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1160,
  [1219] = 1183,
  [1220] = 1220,
  [1221] = 1188,
  [1222] = 1195,
  [1223] = 268,
  [1224] = 1224,
  [1225] = 1224,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1229,
  [1236] = 1229,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1237,
  [1240] = 1229,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1237,
  [1248] = 1244,
  [1249] = 1238,
  [1250] = 1224,
  [1251] = 1226,
  [1252] = 1224,
  [1253] = 1230,
  [1254] = 1231,
  [1255] = 1234,
  [1256] = 1226,
  [1257] = 1237,
  [1258] = 1229,
  [1259] = 1238,
  [1260] = 1260,
  [1261] = 1169,
  [1262] = 1241,
  [1263] = 1263,
  [1264] = 1245,
  [1265] = 1246,
  [1266] = 1228,
  [1267] = 1224,
  [1268] = 1226,
  [1269] = 1230,
  [1270] = 1231,
  [1271] = 1234,
  [1272] = 1229,
  [1273] = 806,
  [1274] = 1238,
  [1275] = 1237,
  [1276] = 1276,
  [1277] = 1241,
  [1278] = 1245,
  [1279] = 1246,
  [1280] = 1231,
  [1281] = 1241,
  [1282] = 1224,
  [1283] = 1226,
  [1284] = 1237,
  [1285] = 1013,
  [1286] = 1237,
  [1287] = 1230,
  [1288] = 1231,
  [1289] = 1229,
  [1290] = 1234,
  [1291] = 1238,
  [1292] = 1238,
  [1293] = 1237,
  [1294] = 1234,
  [1295] = 1241,
  [1296] = 1233,
  [1297] = 1245,
  [1298] = 1246,
  [1299] = 1241,
  [1300] = 1244,
  [1301] = 1224,
  [1302] = 1226,
  [1303] = 1230,
  [1304] = 1231,
  [1305] = 1234,
  [1306] = 1238,
  [1307] = 835,
  [1308] = 1244,
  [1309] = 1241,
  [1310] = 1245,
  [1311] = 1246,
  [1312] = 1312,
  [1313] = 1245,
  [1314] = 1244,
  [1315] = 1226,
  [1316] = 1230,
  [1317] = 1231,
  [1318] = 1234,
  [1319] = 1319,
  [1320] = 1246,
  [1321] = 1321,
  [1322] = 1245,
  [1323] = 1244,
  [1324] = 1324,
  [1325] = 1246,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1230,
  [1329] = 815,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1229,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 385,
  [1340] = 377,
  [1341] = 378,
  [1342] = 379,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1350,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1333,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1357,
  [1364] = 1364,
  [1365] = 1351,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1333,
  [1369] = 1369,
  [1370] = 1347,
  [1371] = 520,
  [1372] = 1372,
  [1373] = 1350,
  [1374] = 1351,
  [1375] = 1352,
  [1376] = 1376,
  [1377] = 1357,
  [1378] = 1333,
  [1379] = 1364,
  [1380] = 1352,
  [1381] = 1381,
  [1382] = 1366,
  [1383] = 1003,
  [1384] = 1384,
  [1385] = 1350,
  [1386] = 1347,
  [1387] = 1351,
  [1388] = 1352,
  [1389] = 1389,
  [1390] = 1357,
  [1391] = 1391,
  [1392] = 1333,
  [1393] = 1393,
  [1394] = 1364,
  [1395] = 1366,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1347,
  [1399] = 1350,
  [1400] = 1351,
  [1401] = 1352,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1357,
  [1405] = 1333,
  [1406] = 1364,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1366,
  [1410] = 1410,
  [1411] = 1347,
  [1412] = 1412,
  [1413] = 1350,
  [1414] = 1351,
  [1415] = 1352,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1357,
  [1419] = 1333,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1364,
  [1423] = 1366,
  [1424] = 1424,
  [1425] = 1347,
  [1426] = 1081,
  [1427] = 1350,
  [1428] = 1351,
  [1429] = 1352,
  [1430] = 1357,
  [1431] = 1366,
  [1432] = 1364,
  [1433] = 377,
  [1434] = 378,
  [1435] = 1350,
  [1436] = 1351,
  [1437] = 379,
  [1438] = 1357,
  [1439] = 1333,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 385,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1347,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1144,
  [1458] = 1145,
  [1459] = 1146,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1455,
  [1470] = 1464,
  [1471] = 1453,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 1475,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1142,
  [1480] = 1462,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1463,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1494,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1472,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1502,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1454,
  [1516] = 1506,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1467,
  [1520] = 1517,
  [1521] = 1521,
  [1522] = 1504,
  [1523] = 1488,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1530,
  [1535] = 1535,
  [1536] = 1530,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1540,
  [1542] = 1542,
  [1543] = 1533,
  [1544] = 600,
  [1545] = 1525,
  [1546] = 1529,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 618,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1532,
  [1555] = 615,
  [1556] = 1556,
  [1557] = 1526,
  [1558] = 616,
  [1559] = 1526,
  [1560] = 708,
  [1561] = 736,
  [1562] = 657,
  [1563] = 735,
  [1564] = 1564,
  [1565] = 274,
  [1566] = 238,
  [1567] = 1567,
  [1568] = 248,
  [1569] = 252,
  [1570] = 255,
  [1571] = 259,
  [1572] = 233,
  [1573] = 234,
  [1574] = 294,
  [1575] = 268,
  [1576] = 269,
  [1577] = 271,
  [1578] = 1578,
  [1579] = 245,
  [1580] = 246,
  [1581] = 250,
  [1582] = 257,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1564,
  [1590] = 1578,
  [1591] = 274,
  [1592] = 238,
  [1593] = 248,
  [1594] = 252,
  [1595] = 255,
  [1596] = 259,
  [1597] = 233,
  [1598] = 234,
  [1599] = 294,
  [1600] = 268,
  [1601] = 269,
  [1602] = 271,
  [1603] = 245,
  [1604] = 246,
  [1605] = 250,
  [1606] = 257,
  [1607] = 1585,
  [1608] = 1586,
  [1609] = 274,
  [1610] = 238,
  [1611] = 1587,
  [1612] = 248,
  [1613] = 252,
  [1614] = 255,
  [1615] = 259,
  [1616] = 233,
  [1617] = 234,
  [1618] = 294,
  [1619] = 268,
  [1620] = 269,
  [1621] = 271,
  [1622] = 245,
  [1623] = 246,
  [1624] = 250,
  [1625] = 257,
  [1626] = 1583,
  [1627] = 1584,
  [1628] = 1585,
  [1629] = 1586,
  [1630] = 1587,
  [1631] = 1567,
  [1632] = 752,
  [1633] = 1588,
  [1634] = 1564,
  [1635] = 1578,
  [1636] = 1583,
  [1637] = 1584,
  [1638] = 1588,
  [1639] = 1564,
  [1640] = 274,
  [1641] = 238,
  [1642] = 248,
  [1643] = 1567,
  [1644] = 252,
  [1645] = 255,
  [1646] = 259,
  [1647] = 233,
  [1648] = 234,
  [1649] = 294,
  [1650] = 268,
  [1651] = 269,
  [1652] = 271,
  [1653] = 1578,
  [1654] = 245,
  [1655] = 246,
  [1656] = 250,
  [1657] = 257,
  [1658] = 1583,
  [1659] = 1584,
  [1660] = 1585,
  [1661] = 1586,
  [1662] = 1587,
  [1663] = 1588,
  [1664] = 1564,
  [1665] = 274,
  [1666] = 238,
  [1667] = 1567,
  [1668] = 248,
  [1669] = 252,
  [1670] = 255,
  [1671] = 259,
  [1672] = 233,
  [1673] = 234,
  [1674] = 294,
  [1675] = 268,
  [1676] = 269,
  [1677] = 271,
  [1678] = 1578,
  [1679] = 245,
  [1680] = 246,
  [1681] = 250,
  [1682] = 257,
  [1683] = 1583,
  [1684] = 1584,
  [1685] = 1585,
  [1686] = 1586,
  [1687] = 1587,
  [1688] = 1588,
  [1689] = 1564,
  [1690] = 274,
  [1691] = 238,
  [1692] = 1567,
  [1693] = 248,
  [1694] = 252,
  [1695] = 255,
  [1696] = 259,
  [1697] = 233,
  [1698] = 234,
  [1699] = 294,
  [1700] = 268,
  [1701] = 269,
  [1702] = 271,
  [1703] = 1578,
  [1704] = 245,
  [1705] = 246,
  [1706] = 250,
  [1707] = 257,
  [1708] = 1583,
  [1709] = 1584,
  [1710] = 1585,
  [1711] = 1586,
  [1712] = 1587,
  [1713] = 1588,
  [1714] = 1567,
  [1715] = 1715,
  [1716] = 659,
  [1717] = 660,
  [1718] = 662,
  [1719] = 1719,
  [1720] = 664,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1003,
  [1750] = 1052,
  [1751] = 1038,
  [1752] = 1059,
  [1753] = 1753,
  [1754] = 1060,
  [1755] = 1062,
  [1756] = 1058,
  [1757] = 1757,
  [1758] = 1104,
  [1759] = 1123,
  [1760] = 1760,
  [1761] = 1065,
  [1762] = 1066,
  [1763] = 1108,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1057,
  [1767] = 1084,
  [1768] = 1042,
  [1769] = 1043,
  [1770] = 1044,
  [1771] = 1045,
  [1772] = 1067,
  [1773] = 1068,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1119,
  [1777] = 1069,
  [1778] = 1778,
  [1779] = 1063,
  [1780] = 1120,
  [1781] = 1050,
  [1782] = 1054,
  [1783] = 1051,
  [1784] = 1072,
  [1785] = 1053,
  [1786] = 1064,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1083,
  [1790] = 1157,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1795,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1794,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1150,
  [1805] = 1803,
  [1806] = 1149,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1839,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1839,
  [1855] = 1850,
  [1856] = 1839,
  [1857] = 1850,
  [1858] = 1839,
  [1859] = 1850,
  [1860] = 1839,
  [1861] = 1850,
  [1862] = 1839,
  [1863] = 1850,
  [1864] = 1850,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 432,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1013,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1493,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1232,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1902,
  [1915] = 1915,
  [1916] = 381,
  [1917] = 1902,
  [1918] = 1918,
  [1919] = 1227,
  [1920] = 1003,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1486,
  [1959] = 1334,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1082,
  [1963] = 1935,
  [1964] = 1964,
  [1965] = 1938,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1940,
  [1971] = 1971,
  [1972] = 1943,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1946,
  [1977] = 1947,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1935,
  [1991] = 1938,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1940,
  [1995] = 1995,
  [1996] = 1996,
  [1997] = 1943,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 1946,
  [2002] = 2002,
  [2003] = 1947,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 1935,
  [2015] = 1946,
  [2016] = 1938,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 1940,
  [2022] = 2022,
  [2023] = 1943,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 1074,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 1935,
  [2031] = 2031,
  [2032] = 1938,
  [2033] = 1869,
  [2034] = 2034,
  [2035] = 1940,
  [2036] = 2036,
  [2037] = 1943,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2022,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 1935,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 1938,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 1974,
  [2060] = 2060,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 1892,
  [2066] = 2066,
  [2067] = 1967,
  [2068] = 2018,
  [2069] = 2069,
  [2070] = 2061,
  [2071] = 2071,
  [2072] = 1942,
  [2073] = 1964,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 1940,
  [2077] = 2020,
  [2078] = 2078,
  [2079] = 1935,
  [2080] = 1943,
  [2081] = 2081,
  [2082] = 1938,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2053,
  [2087] = 2062,
  [2088] = 2056,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2061,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2062,
  [2095] = 1466,
  [2096] = 2063,
  [2097] = 2097,
  [2098] = 1946,
  [2099] = 1967,
  [2100] = 1410,
  [2101] = 2071,
  [2102] = 2102,
  [2103] = 2071,
  [2104] = 1942,
  [2105] = 1964,
  [2106] = 1947,
  [2107] = 2107,
  [2108] = 2078,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2053,
  [2113] = 2056,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2061,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 1947,
  [2120] = 2062,
  [2121] = 2121,
  [2122] = 2078,
  [2123] = 2063,
  [2124] = 1967,
  [2125] = 1086,
  [2126] = 2071,
  [2127] = 1942,
  [2128] = 2128,
  [2129] = 1964,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2020,
  [2133] = 2133,
  [2134] = 2078,
  [2135] = 1077,
  [2136] = 2136,
  [2137] = 1880,
  [2138] = 2053,
  [2139] = 2056,
  [2140] = 2140,
  [2141] = 2063,
  [2142] = 2061,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2053,
  [2146] = 2062,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2063,
  [2150] = 1078,
  [2151] = 1967,
  [2152] = 2152,
  [2153] = 2071,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 1942,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 1964,
  [2160] = 2020,
  [2161] = 2161,
  [2162] = 2078,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2053,
  [2166] = 2056,
  [2167] = 2167,
  [2168] = 2061,
  [2169] = 2169,
  [2170] = 2062,
  [2171] = 2171,
  [2172] = 2063,
  [2173] = 1967,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2071,
  [2177] = 2056,
  [2178] = 2178,
  [2179] = 1942,
  [2180] = 2180,
  [2181] = 1964,
  [2182] = 2182,
  [2183] = 2020,
  [2184] = 2078,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2053,
  [2188] = 2188,
  [2189] = 2061,
  [2190] = 2190,
  [2191] = 2062,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2063,
  [2196] = 1940,
  [2197] = 2071,
  [2198] = 1935,
  [2199] = 2199,
  [2200] = 1964,
  [2201] = 2020,
  [2202] = 1938,
  [2203] = 2078,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2061,
  [2208] = 1353,
  [2209] = 1126,
  [2210] = 2062,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2060,
  [2216] = 2216,
  [2217] = 2017,
  [2218] = 1940,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 1943,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2017,
  [2228] = 2017,
  [2229] = 1946,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2017,
  [2233] = 2233,
  [2234] = 2017,
  [2235] = 2235,
  [2236] = 1947,
  [2237] = 2017,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 1943,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2020,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 1142,
  [2260] = 1473,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2244,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2283,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 1483,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2251,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2269,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2277,
  [2318] = 2318,
  [2319] = 1144,
  [2320] = 2320,
  [2321] = 1145,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 1146,
  [2331] = 2269,
  [2332] = 2332,
  [2333] = 1493,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2288,
  [2353] = 2257,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 506,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2362,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2363,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 528,
  [2439] = 2387,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2437,
  [2443] = 2443,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2370,
  [2458] = 2365,
  [2459] = 2459,
  [2460] = 2365,
  [2461] = 2461,
  [2462] = 2372,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2381,
  [2467] = 2382,
  [2468] = 2468,
  [2469] = 2384,
  [2470] = 2470,
  [2471] = 2386,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2384,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2371,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2398,
  [2483] = 2399,
  [2484] = 2400,
  [2485] = 2485,
  [2486] = 2372,
  [2487] = 2409,
  [2488] = 2488,
  [2489] = 2411,
  [2490] = 2490,
  [2491] = 1753,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2423,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 1493,
  [2506] = 2429,
  [2507] = 2507,
  [2508] = 2434,
  [2509] = 2509,
  [2510] = 2436,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2387,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2437,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2447,
  [2521] = 2448,
  [2522] = 1185,
  [2523] = 2523,
  [2524] = 1165,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2365,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2372,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2381,
  [2539] = 2382,
  [2540] = 2423,
  [2541] = 2384,
  [2542] = 2542,
  [2543] = 2386,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 1187,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2398,
  [2555] = 2399,
  [2556] = 2400,
  [2557] = 2409,
  [2558] = 2558,
  [2559] = 2409,
  [2560] = 2560,
  [2561] = 2411,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 2570,
  [2571] = 2571,
  [2572] = 2423,
  [2573] = 2573,
  [2574] = 2574,
  [2575] = 2381,
  [2576] = 2576,
  [2577] = 2429,
  [2578] = 2578,
  [2579] = 2434,
  [2580] = 2580,
  [2581] = 2436,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2387,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 2437,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2590,
  [2591] = 2447,
  [2592] = 2448,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2598,
  [2599] = 2375,
  [2600] = 2600,
  [2601] = 2404,
  [2602] = 2365,
  [2603] = 2603,
  [2604] = 2369,
  [2605] = 2605,
  [2606] = 2372,
  [2607] = 2607,
  [2608] = 2608,
  [2609] = 2381,
  [2610] = 2382,
  [2611] = 2611,
  [2612] = 2384,
  [2613] = 2411,
  [2614] = 2614,
  [2615] = 2405,
  [2616] = 2616,
  [2617] = 2617,
  [2618] = 2618,
  [2619] = 2619,
  [2620] = 513,
  [2621] = 2621,
  [2622] = 2386,
  [2623] = 2623,
  [2624] = 2398,
  [2625] = 2400,
  [2626] = 2626,
  [2627] = 2627,
  [2628] = 2409,
  [2629] = 2629,
  [2630] = 2411,
  [2631] = 2631,
  [2632] = 2447,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2382,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2381,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 2641,
  [2642] = 2423,
  [2643] = 2382,
  [2644] = 2644,
  [2645] = 2384,
  [2646] = 2646,
  [2647] = 2429,
  [2648] = 2648,
  [2649] = 2434,
  [2650] = 2650,
  [2651] = 2436,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2387,
  [2655] = 2429,
  [2656] = 2656,
  [2657] = 2437,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 2447,
  [2662] = 2448,
  [2663] = 2663,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2336,
  [2667] = 2667,
  [2668] = 2451,
  [2669] = 2432,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2365,
  [2673] = 2493,
  [2674] = 2496,
  [2675] = 2386,
  [2676] = 2372,
  [2677] = 2677,
  [2678] = 2354,
  [2679] = 2382,
  [2680] = 2680,
  [2681] = 2384,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2688,
  [2689] = 2689,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2398,
  [2693] = 2400,
  [2694] = 2409,
  [2695] = 2695,
  [2696] = 2411,
  [2697] = 2697,
  [2698] = 2698,
  [2699] = 2468,
  [2700] = 2700,
  [2701] = 2398,
  [2702] = 2399,
  [2703] = 2703,
  [2704] = 2400,
  [2705] = 2705,
  [2706] = 2402,
  [2707] = 2403,
  [2708] = 2423,
  [2709] = 2709,
  [2710] = 2519,
  [2711] = 2404,
  [2712] = 2712,
  [2713] = 2429,
  [2714] = 2434,
  [2715] = 2405,
  [2716] = 2436,
  [2717] = 2717,
  [2718] = 2718,
  [2719] = 2387,
  [2720] = 2720,
  [2721] = 2437,
  [2722] = 2722,
  [2723] = 2671,
  [2724] = 2712,
  [2725] = 2447,
  [2726] = 2448,
  [2727] = 2727,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2409,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2384,
  [2735] = 2411,
  [2736] = 2736,
  [2737] = 2709,
  [2738] = 2738,
  [2739] = 2398,
  [2740] = 2740,
  [2741] = 2411,
  [2742] = 2402,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2434,
  [2746] = 2746,
  [2747] = 2403,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2434,
  [2753] = 2376,
  [2754] = 2436,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2387,
  [2758] = 2758,
  [2759] = 2447,
  [2760] = 2448,
  [2761] = 2384,
  [2762] = 2398,
  [2763] = 2384,
  [2764] = 2398,
  [2765] = 2384,
  [2766] = 2398,
  [2767] = 2384,
  [2768] = 2398,
  [2769] = 2384,
  [2770] = 2398,
  [2771] = 2384,
  [2772] = 2398,
  [2773] = 2773,
  [2774] = 2774,
  [2775] = 2775,
  [2776] = 2670,
  [2777] = 2686,
  [2778] = 2778,
  [2779] = 2423,
  [2780] = 2374,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2354,
  [2788] = 2473,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2429,
  [2792] = 2792,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2441,
  [2796] = 2398,
  [2797] = 2797,
  [2798] = 2476,
  [2799] = 2553,
  [2800] = 2800,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2430,
  [2804] = 2399,
  [2805] = 2431,
  [2806] = 2432,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2810,
  [2811] = 2811,
  [2812] = 2536,
  [2813] = 2465,
  [2814] = 2814,
  [2815] = 2815,
  [2816] = 2434,
  [2817] = 2749,
  [2818] = 2818,
  [2819] = 2774,
  [2820] = 2670,
  [2821] = 2686,
  [2822] = 2822,
  [2823] = 2448,
  [2824] = 2824,
  [2825] = 2825,
  [2826] = 2826,
  [2827] = 2436,
  [2828] = 2354,
  [2829] = 2473,
  [2830] = 2830,
  [2831] = 2792,
  [2832] = 2793,
  [2833] = 2833,
  [2834] = 2476,
  [2835] = 2553,
  [2836] = 2465,
  [2837] = 516,
  [2838] = 2670,
  [2839] = 2686,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2387,
  [2843] = 2354,
  [2844] = 2473,
  [2845] = 2845,
  [2846] = 2476,
  [2847] = 2553,
  [2848] = 2465,
  [2849] = 2849,
  [2850] = 2670,
  [2851] = 2686,
  [2852] = 2792,
  [2853] = 2437,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2473,
  [2857] = 2857,
  [2858] = 2476,
  [2859] = 2553,
  [2860] = 2465,
  [2861] = 2861,
  [2862] = 2670,
  [2863] = 2686,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2354,
  [2867] = 2473,
  [2868] = 2868,
  [2869] = 2476,
  [2870] = 2553,
  [2871] = 2465,
  [2872] = 2872,
  [2873] = 2670,
  [2874] = 2686,
  [2875] = 2586,
  [2876] = 2876,
  [2877] = 2354,
  [2878] = 2473,
  [2879] = 2640,
  [2880] = 2553,
  [2881] = 2465,
  [2882] = 2882,
  [2883] = 2670,
  [2884] = 2686,
  [2885] = 2354,
  [2886] = 2400,
  [2887] = 2793,
  [2888] = 2888,
  [2889] = 2690,
  [2890] = 2500,
  [2891] = 2447,
  [2892] = 2568,
  [2893] = 2633,
  [2894] = 2773,
  [2895] = 2895,
  [2896] = 2794,
  [2897] = 2830,
  [2898] = 2470,
  [2899] = 2899,
  [2900] = 2420,
  [2901] = 2901,
  [2902] = 2448,
  [2903] = 2903,
  [2904] = 2904,
  [2905] = 2802,
  [2906] = 2430,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2431,
  [2910] = 2910,
  [2911] = 2385,
  [2912] = 2436,
  [2913] = 2568,
  [2914] = 2830,
  [2915] = 2470,
  [2916] = 2916,
  [2917] = 2917,
  [2918] = 2918,
  [2919] = 2919,
  [2920] = 2920,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(875);
      ADVANCE_MAP(
        '!', 1989,
        '"', 72,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1270,
        '/', 981,
        ':', 914,
        ';', 1990,
        '<', 1252,
        '=', 924,
        '>', 1256,
        '[', 1279,
        ']', 1280,
        'A', 1006,
        'a', 1006,
        'B', 992,
        'b', 992,
        'C', 993,
        'c', 993,
        'D', 1000,
        'd', 1000,
        'E', 1013,
        'e', 1013,
        'F', 996,
        'f', 996,
        'G', 1007,
        'g', 1007,
        'H', 1020,
        'h', 1020,
        'I', 1010,
        'i', 1010,
        'L', 1018,
        'l', 1018,
        'M', 1002,
        'm', 1002,
        'N', 1005,
        'n', 1005,
        'O', 1017,
        'o', 1017,
        'P', 994,
        'p', 994,
        'Q', 1022,
        'q', 1022,
        'R', 1004,
        'r', 1004,
        'S', 995,
        's', 995,
        'T', 1003,
        't', 1003,
        'U', 1016,
        'u', 1016,
        'V', 999,
        'v', 999,
        'W', 1012,
        'w', 1012,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0);
      if (('J' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(991);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1088);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(1991);
      if (lookahead == '!') ADVANCE(1989);
      if (lookahead == '#') ADVANCE(1285);
      if (lookahead == '&') ADVANCE(1992);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1088);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1272,
        '/', 982,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1272,
        '/', 982,
        ':', 914,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1368,
        'a', 1368,
        'B', 1647,
        'b', 1647,
        'C', 1787,
        'c', 1787,
        'D', 1319,
        'd', 1319,
        'E', 1689,
        'e', 1689,
        'F', 1784,
        'f', 1784,
        'I', 1552,
        'i', 1552,
        'M', 1307,
        'm', 1307,
        'N', 1964,
        'n', 1964,
        'O', 1810,
        'o', 1810,
        'P', 1340,
        'p', 1340,
        'R', 1518,
        'r', 1518,
        'S', 1305,
        's', 1305,
        'T', 1311,
        't', 1311,
        'V', 1308,
        'v', 1308,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1272,
        '/', 982,
        ':', 914,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1899,
        'a', 1899,
        'B', 1647,
        'b', 1647,
        'C', 1574,
        'c', 1574,
        'D', 1322,
        'd', 1322,
        'E', 1635,
        'e', 1635,
        'F', 1783,
        'f', 1783,
        'I', 1548,
        'i', 1548,
        'L', 1762,
        'l', 1762,
        'M', 1763,
        'm', 1763,
        'N', 1964,
        'n', 1964,
        'P', 1973,
        'p', 1973,
        'R', 1491,
        'r', 1491,
        'S', 1543,
        's', 1543,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1272,
        '/', 982,
        ':', 914,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1272,
        '/', 982,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1687,
        'e', 1687,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1272,
        '/', 982,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1688,
        'e', 1688,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1272,
        '/', 982,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1683,
        'e', 1683,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 912,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1272,
        '/', 982,
        '<', 1253,
        '=', 924,
        '>', 1255,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1683,
        'e', 1683,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 981,
        ':', 913,
        '<', 1252,
        '=', 924,
        '>', 1256,
        ']', 1280,
        'A', 166,
        'a', 166,
        'B', 425,
        'b', 425,
        'C', 156,
        'c', 156,
        'D', 101,
        'd', 101,
        'E', 500,
        'e', 500,
        'F', 97,
        'f', 97,
        'G', 470,
        'g', 470,
        'H', 625,
        'h', 625,
        'I', 369,
        'i', 369,
        'L', 598,
        'l', 598,
        'M', 103,
        'm', 103,
        'N', 136,
        'n', 136,
        'O', 649,
        'o', 649,
        'P', 96,
        'p', 96,
        'Q', 819,
        'q', 819,
        'R', 109,
        'r', 109,
        'S', 93,
        's', 93,
        'T', 104,
        't', 104,
        'U', 726,
        'u', 726,
        'V', 100,
        'v', 100,
        'W', 394,
        'w', 394,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1088);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 981,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1256,
        ']', 1280,
        'A', 489,
        'a', 489,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 503,
        'e', 503,
        'F', 397,
        'f', 397,
        'G', 317,
        'g', 317,
        'I', 530,
        'i', 530,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'N', 630,
        'n', 630,
        'O', 561,
        'o', 561,
        'P', 684,
        'p', 684,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 981,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1256,
        ']', 1280,
        'A', 751,
        'a', 751,
        'B', 452,
        'b', 452,
        'C', 509,
        'c', 509,
        'D', 603,
        'd', 603,
        'E', 565,
        'e', 565,
        'F', 633,
        'f', 633,
        'I', 370,
        'i', 370,
        'O', 820,
        'o', 820,
        'S', 365,
        's', 365,
        'T', 389,
        't', 389,
        'W', 394,
        'w', 394,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 981,
        ':', 86,
        '<', 1253,
        '=', 924,
        '>', 1256,
        ']', 1280,
        'A', 752,
        'a', 752,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 502,
        'e', 502,
        'F', 818,
        'f', 818,
        'I', 531,
        'i', 531,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 849,
        'p', 849,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        ')', 915,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 981,
        ':', 86,
        '<', 1253,
        '=', 923,
        '>', 1255,
        ']', 1280,
        'A', 167,
        'a', 167,
        'B', 868,
        'b', 868,
        'C', 390,
        'c', 390,
        'D', 102,
        'd', 102,
        'E', 501,
        'e', 501,
        'F', 637,
        'f', 637,
        'I', 519,
        'i', 519,
        'L', 608,
        'l', 608,
        'M', 103,
        'm', 103,
        'N', 135,
        'n', 135,
        'O', 648,
        'o', 648,
        'P', 129,
        'p', 129,
        'R', 309,
        'r', 309,
        'S', 92,
        's', 92,
        'T', 105,
        't', 105,
        'U', 547,
        'u', 547,
        'V', 100,
        'v', 100,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        '*', 1087,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1273,
        '/', 982,
        ':', 913,
        '<', 1252,
        '=', 924,
        '>', 1255,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1273,
        '/', 982,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1255,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1783,
        'f', 1783,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1273,
        '/', 982,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1255,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'P', 1861,
        'p', 1861,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1273,
        '/', 982,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1255,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'P', 1865,
        'p', 1865,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '%', 1246,
        '&', 1992,
        '(', 911,
        '*', 1087,
        '+', 1267,
        '-', 1026,
        '.', 1273,
        '/', 982,
        ':', 913,
        '<', 1253,
        '=', 924,
        '>', 1255,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1543,
        's', 1543,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        ')', 915,
        '*', 1086,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1274,
        ':', 913,
        '[', 1279,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        ')', 915,
        '*', 1086,
        '+', 1267,
        '-', 1026,
        '.', 1271,
        ':', 913,
        '[', 1279,
        '_', 1988,
        'B', 1014,
        'b', 1014,
        'C', 1024,
        'c', 1024,
        'D', 1001,
        'd', 1001,
        'E', 1015,
        'e', 1015,
        'F', 1019,
        'f', 1019,
        'I', 1011,
        'i', 1011,
        'N', 1023,
        'n', 1023,
        'R', 1008,
        'r', 1008,
        'S', 1009,
        's', 1009,
        'T', 998,
        't', 998,
        'V', 997,
        'v', 997,
        'W', 1021,
        'w', 1021,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1025);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        ')', 915,
        '*', 1086,
        '+', 1267,
        '-', 1026,
        '.', 1271,
        ':', 913,
        '[', 1279,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '*', 1086,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1274,
        '/', 73,
        ':', 86,
        '[', 1279,
        ']', 1280,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '*', 1086,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1274,
        ':', 86,
        '[', 1279,
        'A', 1899,
        'a', 1899,
        'B', 1647,
        'b', 1647,
        'C', 1574,
        'c', 1574,
        'D', 1322,
        'd', 1322,
        'E', 1635,
        'e', 1635,
        'F', 1783,
        'f', 1783,
        'I', 1548,
        'i', 1548,
        'L', 1762,
        'l', 1762,
        'M', 1763,
        'm', 1763,
        'N', 1964,
        'n', 1964,
        'P', 1973,
        'p', 1973,
        'R', 1491,
        'r', 1491,
        'S', 1543,
        's', 1543,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '/', 980,
        ':', 86,
        '[', 1279,
        'A', 1368,
        'a', 1368,
        'B', 1647,
        'b', 1647,
        'C', 1787,
        'c', 1787,
        'D', 1319,
        'd', 1319,
        'E', 1689,
        'e', 1689,
        'F', 1784,
        'f', 1784,
        'I', 1552,
        'i', 1552,
        'M', 1307,
        'm', 1307,
        'N', 1964,
        'n', 1964,
        'O', 1810,
        'o', 1810,
        'P', 1340,
        'p', 1340,
        'R', 1518,
        'r', 1518,
        'S', 1305,
        's', 1305,
        'T', 1311,
        't', 1311,
        'V', 1308,
        'v', 1308,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        ':', 86,
        '[', 1279,
        'A', 1368,
        'a', 1368,
        'B', 1647,
        'b', 1647,
        'C', 1787,
        'c', 1787,
        'D', 1319,
        'd', 1319,
        'E', 1689,
        'e', 1689,
        'F', 1784,
        'f', 1784,
        'I', 1555,
        'i', 1555,
        'M', 1307,
        'm', 1307,
        'N', 1964,
        'n', 1964,
        'O', 1810,
        'o', 1810,
        'P', 1340,
        'p', 1340,
        'R', 1518,
        'r', 1518,
        'S', 1305,
        's', 1305,
        'T', 1311,
        't', 1311,
        'V', 1308,
        'v', 1308,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        ':', 86,
        '[', 1279,
        'A', 1368,
        'a', 1368,
        'B', 1647,
        'b', 1647,
        'C', 1573,
        'c', 1573,
        'D', 1320,
        'd', 1320,
        'E', 1634,
        'e', 1634,
        'F', 1783,
        'f', 1783,
        'I', 1549,
        'i', 1549,
        'L', 1762,
        'l', 1762,
        'M', 1306,
        'm', 1306,
        'N', 1964,
        'n', 1964,
        'O', 1810,
        'o', 1810,
        'P', 1339,
        'p', 1339,
        'R', 1491,
        'r', 1491,
        'S', 1304,
        's', 1304,
        'T', 1310,
        't', 1310,
        'V', 1308,
        'v', 1308,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1297,
        'c', 1297,
        'D', 1318,
        'd', 1318,
        'E', 1677,
        'e', 1677,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1547,
        'i', 1547,
        'L', 1762,
        'l', 1762,
        'M', 1307,
        'm', 1307,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1290,
        'p', 1290,
        'R', 1480,
        'r', 1480,
        'S', 1303,
        's', 1303,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1297,
        'c', 1297,
        'D', 1318,
        'd', 1318,
        'E', 1676,
        'e', 1676,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1547,
        'i', 1547,
        'L', 1762,
        'l', 1762,
        'M', 1307,
        'm', 1307,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1290,
        'p', 1290,
        'R', 1480,
        'r', 1480,
        'S', 1303,
        's', 1303,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1297,
        'c', 1297,
        'D', 1318,
        'd', 1318,
        'E', 1678,
        'e', 1678,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1547,
        'i', 1547,
        'L', 1762,
        'l', 1762,
        'M', 1307,
        'm', 1307,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1290,
        'p', 1290,
        'R', 1480,
        'r', 1480,
        'S', 1303,
        's', 1303,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(30);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1297,
        'c', 1297,
        'D', 1318,
        'd', 1318,
        'E', 1692,
        'e', 1692,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1547,
        'i', 1547,
        'L', 1762,
        'l', 1762,
        'M', 1307,
        'm', 1307,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1290,
        'p', 1290,
        'R', 1480,
        'r', 1480,
        'S', 1303,
        's', 1303,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1298,
        'c', 1298,
        'D', 1318,
        'd', 1318,
        'E', 1679,
        'e', 1679,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1547,
        'i', 1547,
        'L', 1762,
        'l', 1762,
        'M', 1307,
        'm', 1307,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1290,
        'p', 1290,
        'R', 1480,
        'r', 1480,
        'S', 1303,
        's', 1303,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(32);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1693,
        'e', 1693,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(33);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1680,
        'e', 1680,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1341,
        'r', 1341,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(34);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1694,
        'e', 1694,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(35);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1685,
        'e', 1685,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(36);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1686,
        'e', 1686,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(37);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1687,
        'e', 1687,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(38);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1688,
        'e', 1688,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1683,
        'e', 1683,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1312,
        't', 1312,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(40);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1683,
        'e', 1683,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(41);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1299,
        'c', 1299,
        'D', 1323,
        'd', 1323,
        'E', 1683,
        'e', 1683,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(42);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1301,
        'c', 1301,
        'D', 1323,
        'd', 1323,
        'E', 1680,
        'e', 1680,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1314,
        't', 1314,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(43);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1296,
        'c', 1296,
        'D', 1323,
        'd', 1323,
        'E', 1680,
        'e', 1680,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(44);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1300,
        'c', 1300,
        'D', 1323,
        'd', 1323,
        'E', 1681,
        'e', 1681,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(45);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1300,
        'c', 1300,
        'D', 1323,
        'd', 1323,
        'E', 1682,
        'e', 1682,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(46);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1300,
        'c', 1300,
        'D', 1323,
        'd', 1323,
        'E', 1684,
        'e', 1684,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(47);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'A', 1874,
        'a', 1874,
        'B', 1288,
        'b', 1288,
        'C', 1300,
        'c', 1300,
        'D', 1323,
        'd', 1323,
        'E', 1691,
        'e', 1691,
        'F', 1768,
        'f', 1768,
        'G', 1761,
        'g', 1761,
        'I', 1551,
        'i', 1551,
        'N', 1964,
        'n', 1964,
        'O', 1807,
        'o', 1807,
        'P', 1332,
        'p', 1332,
        'R', 1480,
        'r', 1480,
        'S', 1537,
        's', 1537,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(48);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        '+', 1267,
        '-', 1026,
        '.', 1274,
        '[', 1279,
        'B', 1647,
        'b', 1647,
        'C', 1574,
        'c', 1574,
        'D', 1322,
        'd', 1322,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1554,
        'i', 1554,
        'L', 1762,
        'l', 1762,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 50:
      if (lookahead == '!') ADVANCE(1989);
      if (lookahead == '#') ADVANCE(1285);
      if (lookahead == '&') ADVANCE(1992);
      if (lookahead == '(') ADVANCE(911);
      if (lookahead == ')') ADVANCE(915);
      if (lookahead == ',') ADVANCE(947);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1222);
      if (lookahead == '$' ||
          lookahead == '*' ||
          ('.' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'G') ||
          ('I' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'g') ||
          ('i' <= lookahead && lookahead <= 'z')) ADVANCE(1223);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 911,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1269,
        ':', 86,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(51);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 911,
        ',', 947,
        ':', 86,
        '=', 88,
        'B', 868,
        'b', 868,
        'C', 391,
        'c', 391,
        'D', 615,
        'd', 615,
        'E', 576,
        'e', 576,
        'F', 396,
        'f', 396,
        'G', 317,
        'g', 317,
        'I', 558,
        'i', 558,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 668,
        'p', 668,
        'R', 360,
        'r', 360,
        'S', 312,
        's', 312,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(52);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 911,
        ',', 947,
        ':', 86,
        'A', 1893,
        'a', 1893,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'O', 1811,
        'o', 1811,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(53);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '*', 1086,
        'B', 1647,
        'b', 1647,
        'C', 1575,
        'c', 1575,
        'D', 1322,
        'd', 1322,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1554,
        'i', 1554,
        'L', 1762,
        'l', 1762,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(54);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '+', 1267,
        '-', 1026,
        '.', 1269,
        'A', 1892,
        'a', 1892,
        'B', 1647,
        'b', 1647,
        'C', 1574,
        'c', 1574,
        'D', 1322,
        'd', 1322,
        'E', 1636,
        'e', 1636,
        'F', 1626,
        'f', 1626,
        'G', 1519,
        'g', 1519,
        'I', 1550,
        'i', 1550,
        'L', 1762,
        'l', 1762,
        'M', 1763,
        'm', 1763,
        'N', 1964,
        'n', 1964,
        'O', 1811,
        'o', 1811,
        'P', 1841,
        'p', 1841,
        'R', 1491,
        'r', 1491,
        'S', 1543,
        's', 1543,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(55);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        ',', 947,
        ':', 86,
        'A', 1899,
        'a', 1899,
        'B', 1647,
        'b', 1647,
        'C', 1574,
        'c', 1574,
        'D', 1322,
        'd', 1322,
        'E', 1636,
        'e', 1636,
        'F', 1626,
        'f', 1626,
        'G', 1519,
        'g', 1519,
        'I', 1550,
        'i', 1550,
        'L', 1762,
        'l', 1762,
        'M', 1763,
        'm', 1763,
        'N', 1964,
        'n', 1964,
        'P', 1841,
        'p', 1841,
        'R', 1491,
        'r', 1491,
        'S', 1543,
        's', 1543,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(56);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        ',', 947,
        'B', 1647,
        'b', 1647,
        'C', 1791,
        'c', 1791,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1579,
        'w', 1579,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'A', 752,
        'a', 752,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 504,
        'e', 504,
        'F', 818,
        'f', 818,
        'I', 531,
        'i', 531,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 849,
        'p', 849,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'A', 752,
        'a', 752,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 505,
        'e', 505,
        'F', 818,
        'f', 818,
        'I', 531,
        'i', 531,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 849,
        'p', 849,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'A', 752,
        'a', 752,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 506,
        'e', 506,
        'F', 818,
        'f', 818,
        'I', 531,
        'i', 531,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 849,
        'p', 849,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(60);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'A', 752,
        'a', 752,
        'B', 868,
        'b', 868,
        'C', 392,
        'c', 392,
        'D', 615,
        'd', 615,
        'E', 507,
        'e', 507,
        'F', 818,
        'f', 818,
        'I', 531,
        'i', 531,
        'L', 608,
        'l', 608,
        'M', 599,
        'm', 599,
        'P', 849,
        'p', 849,
        'R', 309,
        'r', 309,
        'S', 822,
        's', 822,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(61);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'M', 1763,
        'm', 1763,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(62);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'O', 1742,
        'o', 1742,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(63);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1542,
        's', 1542,
        'T', 1315,
        't', 1315,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(64);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'B', 1647,
        'b', 1647,
        'C', 1986,
        'c', 1986,
        'D', 1321,
        'd', 1321,
        'E', 1690,
        'e', 1690,
        'F', 1784,
        'f', 1784,
        'I', 1553,
        'i', 1553,
        'N', 1964,
        'n', 1964,
        'R', 1518,
        'r', 1518,
        'S', 1544,
        's', 1544,
        'T', 1313,
        't', 1313,
        'V', 1309,
        'v', 1309,
        'W', 1827,
        'w', 1827,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(65);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'C', 157,
        'c', 157,
        'E', 577,
        'e', 577,
        'R', 108,
        'r', 108,
        'T', 867,
        't', 867,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(66);
      END_STATE();
    case 67:
      if (lookahead == '!') ADVANCE(1989);
      if (lookahead == '#') ADVANCE(1285);
      if (lookahead == '&') ADVANCE(1992);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(512);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(67);
      END_STATE();
    case 68:
      if (lookahead == '!') ADVANCE(1989);
      if (lookahead == '#') ADVANCE(1285);
      if (lookahead == '&') ADVANCE(1992);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(513);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(68);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        'E', 577,
        'e', 577,
        'F', 640,
        'f', 640,
        'T', 871,
        't', 871,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(69);
      END_STATE();
    case 70:
      if (lookahead == '!') ADVANCE(1989);
      if (lookahead == '#') ADVANCE(1285);
      if (lookahead == '&') ADVANCE(1992);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(70);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1275);
      END_STATE();
    case 71:
      if (lookahead == '!') ADVANCE(927);
      if (lookahead == '#') ADVANCE(1286);
      if (lookahead == '&') ADVANCE(1993);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(928);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(929);
      END_STATE();
    case 72:
      if (lookahead == '"') ADVANCE(1287);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(72);
      END_STATE();
    case 73:
      if (lookahead == ')') ADVANCE(1278);
      END_STATE();
    case 74:
      if (lookahead == '.') ADVANCE(1263);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(82);
      END_STATE();
    case 75:
      if (lookahead == '.') ADVANCE(1261);
      END_STATE();
    case 76:
      if (lookahead == '.') ADVANCE(1257);
      END_STATE();
    case 77:
      if (lookahead == '.') ADVANCE(1259);
      END_STATE();
    case 78:
      if (lookahead == '.') ADVANCE(1254);
      END_STATE();
    case 79:
      if (lookahead == '.') ADVANCE(1265);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(855);
      END_STATE();
    case 80:
      if (lookahead == '.') ADVANCE(1247);
      END_STATE();
    case 81:
      if (lookahead == '.') ADVANCE(1248);
      END_STATE();
    case 82:
      if (lookahead == '.') ADVANCE(1249);
      END_STATE();
    case 83:
      if (lookahead == '.') ADVANCE(1251);
      END_STATE();
    case 84:
      if (lookahead == '.') ADVANCE(1250);
      END_STATE();
    case 85:
      if (lookahead == '.') ADVANCE(1281);
      END_STATE();
    case 86:
      if (lookahead == ':') ADVANCE(965);
      END_STATE();
    case 87:
      if (lookahead == '<') ADVANCE(1134);
      END_STATE();
    case 88:
      if (lookahead == '>') ADVANCE(968);
      END_STATE();
    case 89:
      if (lookahead == '>') ADVANCE(1135);
      END_STATE();
    case 90:
      if (lookahead == '_') ADVANCE(420);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(971);
      END_STATE();
    case 91:
      if (lookahead == '_') ADVANCE(382);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        'A', 857,
        'a', 857,
        'E', 656,
        'e', 656,
        'H', 111,
        'h', 111,
        'T', 114,
        't', 114,
        'U', 173,
        'u', 173,
      );
      END_STATE();
    case 93:
      ADVANCE_MAP(
        'A', 857,
        'a', 857,
        'E', 517,
        'e', 517,
        'H', 111,
        'h', 111,
        'T', 115,
        't', 115,
        'U', 173,
        'u', 173,
      );
      END_STATE();
    case 94:
      ADVANCE_MAP(
        'A', 224,
        'a', 224,
        'C', 826,
        'c', 826,
        'S', 834,
        's', 834,
        'T', 830,
        't', 830,
        'W', 428,
        'w', 428,
      );
      END_STATE();
    case 95:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1151);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        'A', 671,
        'a', 671,
        'I', 586,
        'i', 586,
        'O', 407,
        'o', 407,
        'R', 319,
        'r', 319,
        'U', 172,
        'u', 172,
      );
      END_STATE();
    case 97:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(529);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(657);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      END_STATE();
    case 98:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(729);
      END_STATE();
    case 99:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(729);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(736);
      END_STATE();
    case 100:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(508);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(472);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        'A', 776,
        'a', 776,
        'E', 371,
        'e', 371,
        'I', 535,
        'i', 535,
        'O', 817,
        'o', 817,
      );
      END_STATE();
    case 102:
      ADVANCE_MAP(
        'A', 776,
        'a', 776,
        'E', 854,
        'e', 854,
        'I', 535,
        'i', 535,
        'O', 817,
        'o', 817,
      );
      END_STATE();
    case 103:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(564);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        'A', 658,
        'a', 658,
        'E', 863,
        'e', 863,
        'H', 321,
        'h', 321,
        'O', 1144,
        'o', 1144,
        'Y', 651,
        'y', 651,
      );
      END_STATE();
    case 105:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(658);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(863);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(651);
      END_STATE();
    case 106:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(510);
      END_STATE();
    case 107:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(524);
      END_STATE();
    case 108:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(560);
      END_STATE();
    case 109:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(560);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 110:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(673);
      END_STATE();
    case 111:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(685);
      END_STATE();
    case 112:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(216);
      END_STATE();
    case 113:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(525);
      END_STATE();
    case 114:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(804);
      END_STATE();
    case 115:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(804);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(643);
      END_STATE();
    case 116:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(458);
      END_STATE();
    case 117:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(459);
      END_STATE();
    case 118:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(800);
      END_STATE();
    case 119:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(759);
      END_STATE();
    case 120:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(461);
      END_STATE();
    case 121:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(516);
      END_STATE();
    case 122:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(462);
      END_STATE();
    case 123:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(567);
      END_STATE();
    case 124:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(463);
      END_STATE();
    case 125:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(786);
      END_STATE();
    case 126:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(464);
      END_STATE();
    case 127:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(465);
      END_STATE();
    case 128:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(466);
      END_STATE();
    case 129:
      ADVANCE_MAP(
        'A', 670,
        'a', 670,
        'I', 586,
        'i', 586,
        'O', 407,
        'o', 407,
        'R', 402,
        'r', 402,
        'U', 172,
        'u', 172,
      );
      END_STATE();
    case 130:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(468);
      END_STATE();
    case 131:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(457);
      END_STATE();
    case 132:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(457);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(826);
      END_STATE();
    case 133:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(457);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(826);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(834);
      END_STATE();
    case 134:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(810);
      END_STATE();
    case 135:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(532);
      END_STATE();
    case 136:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(532);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(548);
      END_STATE();
    case 137:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(383);
      END_STATE();
    case 138:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(482);
      END_STATE();
    case 139:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(482);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(119);
      END_STATE();
    case 140:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(801);
      END_STATE();
    case 141:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(579);
      END_STATE();
    case 142:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(533);
      END_STATE();
    case 143:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(487);
      END_STATE();
    case 144:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(421);
      END_STATE();
    case 145:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(421);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 146:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(421);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(379);
      END_STATE();
    case 147:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(732);
      END_STATE();
    case 148:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 149:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(838);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(702);
      END_STATE();
    case 150:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 151:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(738);
      END_STATE();
    case 152:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(791);
      END_STATE();
    case 153:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(741);
      END_STATE();
    case 154:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(840);
      END_STATE();
    case 155:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(206);
      END_STATE();
    case 156:
      ADVANCE_MAP(
        'A', 728,
        'a', 728,
        'H', 110,
        'h', 110,
        'L', 151,
        'l', 151,
        'O', 521,
        'o', 521,
      );
      END_STATE();
    case 157:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(728);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 158:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(793);
      END_STATE();
    case 159:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(796);
      END_STATE();
    case 161:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 162:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(808);
      END_STATE();
    case 163:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(814);
      END_STATE();
    case 164:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(802);
      END_STATE();
    case 165:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(178);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        'B', 744,
        'b', 744,
        'L', 480,
        'l', 480,
        'S', 750,
        's', 750,
        'T', 780,
        't', 780,
        'U', 777,
        'u', 777,
      );
      END_STATE();
    case 167:
      ADVANCE_MAP(
        'B', 744,
        'b', 744,
        'L', 480,
        'l', 480,
        'T', 780,
        't', 780,
        'U', 777,
        'u', 777,
      );
      END_STATE();
    case 168:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(544);
      END_STATE();
    case 169:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(844);
      END_STATE();
    case 170:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(545);
      END_STATE();
    case 171:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(511);
      END_STATE();
    case 172:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(511);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 173:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(675);
      END_STATE();
    case 174:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(120);
      END_STATE();
    case 175:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(488);
      END_STATE();
    case 176:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(496);
      END_STATE();
    case 177:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(130);
      END_STATE();
    case 178:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(499);
      END_STATE();
    case 179:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(714);
      END_STATE();
    case 180:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(546);
      END_STATE();
    case 181:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(451);
      END_STATE();
    case 182:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(985);
      END_STATE();
    case 183:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1109);
      END_STATE();
    case 184:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1037);
      END_STATE();
    case 185:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1091);
      END_STATE();
    case 186:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(962);
      END_STATE();
    case 187:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(964);
      END_STATE();
    case 188:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 189:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(449);
      END_STATE();
    case 190:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(479);
      END_STATE();
    case 191:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(474);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(785);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(350);
      END_STATE();
    case 192:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(474);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(263);
      END_STATE();
    case 193:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(445);
      END_STATE();
    case 194:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(442);
      END_STATE();
    case 195:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        'C', 342,
        'c', 342,
        'G', 679,
        'g', 679,
        'P', 348,
        'p', 348,
        'T', 363,
        't', 363,
      );
      END_STATE();
    case 197:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(342);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(348);
      END_STATE();
    case 198:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(342);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(363);
      END_STATE();
    case 199:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(763);
      END_STATE();
    case 200:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(275);
      END_STATE();
    case 201:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(766);
      END_STATE();
    case 202:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(770);
      END_STATE();
    case 203:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(775);
      END_STATE();
    case 204:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(287);
      END_STATE();
    case 205:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(290);
      END_STATE();
    case 206:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(293);
      END_STATE();
    case 207:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(301);
      END_STATE();
    case 208:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(303);
      END_STATE();
    case 209:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(787);
      END_STATE();
    case 210:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(117);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(406);
      END_STATE();
    case 211:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(832);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(784);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(145);
      END_STATE();
    case 212:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 213:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(792);
      END_STATE();
    case 214:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 215:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(816);
      END_STATE();
    case 216:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(811);
      END_STATE();
    case 217:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(444);
      END_STATE();
    case 218:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(446);
      END_STATE();
    case 219:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(367);
      END_STATE();
    case 220:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(367);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(681);
      END_STATE();
    case 221:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(878);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(522);
      END_STATE();
    case 222:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(946);
      END_STATE();
    case 223:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(91);
      END_STATE();
    case 224:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(930);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1066);
      END_STATE();
    case 225:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1058);
      END_STATE();
    case 226:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1242);
      END_STATE();
    case 227:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1056);
      END_STATE();
    case 228:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1052);
      END_STATE();
    case 229:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1045);
      END_STATE();
    case 230:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1107);
      END_STATE();
    case 231:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(935);
      END_STATE();
    case 232:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(896);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(526);
      END_STATE();
    case 233:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(899);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(526);
      END_STATE();
    case 234:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(934);
      END_STATE();
    case 235:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(895);
      END_STATE();
    case 236:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(882);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(534);
      END_STATE();
    case 237:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(897);
      END_STATE();
    case 238:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(891);
      END_STATE();
    case 239:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(902);
      END_STATE();
    case 240:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(903);
      END_STATE();
    case 241:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(900);
      END_STATE();
    case 242:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(893);
      END_STATE();
    case 243:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(842);
      END_STATE();
    case 244:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(81);
      END_STATE();
    case 245:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(721);
      END_STATE();
    case 246:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(281);
      END_STATE();
    case 247:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(901);
      END_STATE();
    case 248:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(898);
      END_STATE();
    case 249:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(845);
      END_STATE();
    case 250:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(846);
      END_STATE();
    case 251:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(847);
      END_STATE();
    case 252:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(848);
      END_STATE();
    case 253:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(850);
      END_STATE();
    case 254:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 255:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(75);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(76);
      END_STATE();
    case 256:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(79);
      END_STATE();
    case 257:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(79);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(783);
      END_STATE();
    case 258:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(549);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(410);
      END_STATE();
    case 259:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(960);
      END_STATE();
    case 260:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1062);
      END_STATE();
    case 261:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1193);
      END_STATE();
    case 262:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1173);
      END_STATE();
    case 263:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(387);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 264:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(971);
      END_STATE();
    case 265:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1121);
      END_STATE();
    case 266:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(978);
      END_STATE();
    case 267:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(973);
      END_STATE();
    case 268:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1229);
      END_STATE();
    case 269:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1138);
      END_STATE();
    case 270:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1244);
      END_STATE();
    case 271:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1113);
      END_STATE();
    case 272:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1179);
      END_STATE();
    case 273:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1159);
      END_STATE();
    case 274:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(932);
      END_STATE();
    case 275:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(951);
      END_STATE();
    case 276:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1069);
      END_STATE();
    case 277:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1119);
      END_STATE();
    case 278:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(906);
      END_STATE();
    case 279:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1240);
      END_STATE();
    case 280:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1036);
      END_STATE();
    case 281:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1149);
      END_STATE();
    case 282:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1231);
      END_STATE();
    case 283:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(983);
      END_STATE();
    case 284:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1060);
      END_STATE();
    case 285:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1136);
      END_STATE();
    case 286:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1181);
      END_STATE();
    case 287:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1031);
      END_STATE();
    case 288:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1115);
      END_STATE();
    case 289:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1216);
      END_STATE();
    case 290:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1238);
      END_STATE();
    case 291:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1183);
      END_STATE();
    case 292:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(908);
      END_STATE();
    case 293:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(917);
      END_STATE();
    case 294:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(940);
      END_STATE();
    case 295:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1123);
      END_STATE();
    case 296:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(909);
      END_STATE();
    case 297:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1195);
      END_STATE();
    case 298:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1197);
      END_STATE();
    case 299:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(936);
      END_STATE();
    case 300:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1089);
      END_STATE();
    case 301:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1125);
      END_STATE();
    case 302:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1218);
      END_STATE();
    case 303:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(919);
      END_STATE();
    case 304:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(942);
      END_STATE();
    case 305:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(916);
      END_STATE();
    case 306:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(938);
      END_STATE();
    case 307:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1048);
      END_STATE();
    case 308:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(972);
      END_STATE();
    case 309:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 310:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1172);
      END_STATE();
    case 311:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1176);
      END_STATE();
    case 312:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(656);
      END_STATE();
    case 313:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(861);
      END_STATE();
    case 314:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(566);
      END_STATE();
    case 315:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(862);
      END_STATE();
    case 316:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(77);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(78);
      END_STATE();
    case 317:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 318:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(193);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(573);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(196);
      END_STATE();
    case 319:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(193);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(856);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 320:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 321:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 322:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 323:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(569);
      END_STATE();
    case 324:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 325:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 326:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(703);
      END_STATE();
    case 327:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 328:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 329:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(578);
      END_STATE();
    case 330:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 331:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(758);
      END_STATE();
    case 332:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 333:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(723);
      END_STATE();
    case 334:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(481);
      END_STATE();
    case 335:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(660);
      END_STATE();
    case 336:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(661);
      END_STATE();
    case 337:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(712);
      END_STATE();
    case 338:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(764);
      END_STATE();
    case 339:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(663);
      END_STATE();
    case 340:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(664);
      END_STATE();
    case 341:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(707);
      END_STATE();
    case 342:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 343:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 344:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 345:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 346:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(687);
      END_STATE();
    case 347:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(687);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 348:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(690);
      END_STATE();
    case 349:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(689);
      END_STATE();
    case 350:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 351:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 352:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 353:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(713);
      END_STATE();
    case 354:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(581);
      END_STATE();
    case 355:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 356:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(695);
      END_STATE();
    case 357:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 358:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(515);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(180);
      END_STATE();
    case 359:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(697);
      END_STATE();
    case 360:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 361:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 362:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(537);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      END_STATE();
    case 363:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 364:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 365:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 366:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(812);
      END_STATE();
    case 367:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 368:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 369:
      ADVANCE_MAP(
        'F', 1166,
        'f', 1166,
        'M', 642,
        'm', 642,
        'N', 192,
        'n', 192,
        'S', 1205,
        's', 1205,
      );
      END_STATE();
    case 370:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1166);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1100);
      END_STATE();
    case 371:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(149);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(404);
      END_STATE();
    case 372:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1170);
      END_STATE();
    case 373:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1170);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(809);
      END_STATE();
    case 374:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1177);
      END_STATE();
    case 375:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(154);
      END_STATE();
    case 376:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(617);
      END_STATE();
    case 377:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(155);
      END_STATE();
    case 378:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(159);
      END_STATE();
    case 379:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(828);
      END_STATE();
    case 380:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(828);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(837);
      END_STATE();
    case 381:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(596);
      END_STATE();
    case 382:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(518);
      END_STATE();
    case 383:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(324);
      END_STATE();
    case 384:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(406);
      END_STATE();
    case 385:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(338);
      END_STATE();
    case 386:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(335);
      END_STATE();
    case 387:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(335);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(761);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(377);
      END_STATE();
    case 388:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(681);
      END_STATE();
    case 389:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(321);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(645);
      END_STATE();
    case 390:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(110);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(151);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(521);
      END_STATE();
    case 391:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(110);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(151);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(542);
      END_STATE();
    case 392:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(110);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(151);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(541);
      END_STATE();
    case 393:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(356);
      END_STATE();
    case 394:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(346);
      END_STATE();
    case 395:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(359);
      END_STATE();
    case 396:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(585);
      END_STATE();
    case 397:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(585);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      END_STATE();
    case 398:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(381);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 399:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(859);
      END_STATE();
    case 400:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(223);
      END_STATE();
    case 401:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(856);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(197);
      END_STATE();
    case 402:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(856);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 403:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 404:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 405:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(754);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(314);
      END_STATE();
    case 406:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 407:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(590);
      END_STATE();
    case 408:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(785);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(350);
      END_STATE();
    case 409:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 410:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(635);
      END_STATE();
    case 411:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 412:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(331);
      END_STATE();
    case 413:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 414:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 415:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(471);
      END_STATE();
    case 416:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 417:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(254);
      END_STATE();
    case 418:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 419:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(572);
      END_STATE();
    case 420:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(589);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(860);
      END_STATE();
    case 421:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(574);
      END_STATE();
    case 422:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(588);
      END_STATE();
    case 423:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(768);
      END_STATE();
    case 424:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(773);
      END_STATE();
    case 425:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(563);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(626);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(778);
      END_STATE();
    case 426:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(790);
      END_STATE();
    case 427:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(618);
      END_STATE();
    case 428:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(571);
      END_STATE();
    case 429:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(740);
      END_STATE();
    case 430:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(858);
      END_STATE();
    case 431:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(582);
      END_STATE();
    case 432:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 433:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(619);
      END_STATE();
    case 434:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(583);
      END_STATE();
    case 435:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(620);
      END_STATE();
    case 436:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(622);
      END_STATE();
    case 437:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(693);
      END_STATE();
    case 438:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 439:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(623);
      END_STATE();
    case 440:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(491);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(705);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(597);
      END_STATE();
    case 441:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(493);
      END_STATE();
    case 442:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 443:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(594);
      END_STATE();
    case 444:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 445:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(748);
      END_STATE();
    case 446:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(749);
      END_STATE();
    case 447:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1199);
      END_STATE();
    case 448:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1212);
      END_STATE();
    case 449:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1214);
      END_STATE();
    case 450:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1201);
      END_STATE();
    case 451:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(727);
      END_STATE();
    case 452:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(626);
      END_STATE();
    case 453:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1030);
      END_STATE();
    case 454:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(864);
      END_STATE();
    case 455:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1132);
      END_STATE();
    case 456:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1283);
      END_STATE();
    case 457:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1066);
      END_STATE();
    case 458:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1043);
      END_STATE();
    case 459:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1163);
      END_STATE();
    case 460:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1185);
      END_STATE();
    case 461:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(950);
      END_STATE();
    case 462:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1039);
      END_STATE();
    case 463:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1078);
      END_STATE();
    case 464:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(976);
      END_STATE();
    case 465:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1103);
      END_STATE();
    case 466:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1117);
      END_STATE();
    case 467:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1187);
      END_STATE();
    case 468:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(954);
      END_STATE();
    case 469:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1029);
      END_STATE();
    case 470:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(605);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(400);
      END_STATE();
    case 471:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(865);
      END_STATE();
    case 472:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 473:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(455);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(261);
      END_STATE();
    case 474:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(824);
      END_STATE();
    case 475:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(456);
      END_STATE();
    case 476:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(432);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(683);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(691);
      END_STATE();
    case 477:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 478:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(344);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(841);
      END_STATE();
    case 479:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(269);
      END_STATE();
    case 480:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(607);
      END_STATE();
    case 481:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(429);
      END_STATE();
    case 482:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(460);
      END_STATE();
    case 483:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(762);
      END_STATE();
    case 484:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(765);
      END_STATE();
    case 485:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(273);
      END_STATE();
    case 486:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(313);
      END_STATE();
    case 487:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(467);
      END_STATE();
    case 488:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(276);
      END_STATE();
    case 489:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(469);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(780);
      END_STATE();
    case 490:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(278);
      END_STATE();
    case 491:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 492:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(774);
      END_STATE();
    case 493:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 494:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(292);
      END_STATE();
    case 495:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(296);
      END_STATE();
    case 496:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(300);
      END_STATE();
    case 497:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(315);
      END_STATE();
    case 498:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(305);
      END_STATE();
    case 499:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 500:
      ADVANCE_MAP(
        'L', 361,
        'l', 361,
        'N', 232,
        'n', 232,
        'Q', 823,
        'q', 823,
        'X', 781,
        'x', 781,
      );
      END_STATE();
    case 501:
      ADVANCE_MAP(
        'L', 361,
        'l', 361,
        'N', 233,
        'n', 233,
        'Q', 823,
        'q', 823,
        'X', 815,
        'x', 815,
      );
      END_STATE();
    case 502:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 503:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(235);
      END_STATE();
    case 504:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 505:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(247);
      END_STATE();
    case 506:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(238);
      END_STATE();
    case 507:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(361);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 508:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(835);
      END_STATE();
    case 509:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 510:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(735);
      END_STATE();
    case 511:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(409);
      END_STATE();
    case 512:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(742);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 513:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(743);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 514:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(629);
      END_STATE();
    case 515:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(352);
      END_STATE();
    case 516:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(364);
      END_STATE();
    case 517:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(355);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(841);
      END_STATE();
    case 518:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(632);
      END_STATE();
    case 519:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(642);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(192);
      END_STATE();
    case 520:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(528);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 521:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(528);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(733);
      END_STATE();
    case 522:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1234);
      END_STATE();
    case 523:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1237);
      END_STATE();
    case 524:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(876);
      END_STATE();
    case 525:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(904);
      END_STATE();
    case 526:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1233);
      END_STATE();
    case 527:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(654);
      END_STATE();
    case 528:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(616);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(486);
      END_STATE();
    case 529:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(415);
      END_STATE();
    case 530:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(644);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(408);
      END_STATE();
    case 531:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(653);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(798);
      END_STATE();
    case 532:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(334);
      END_STATE();
    case 533:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(366);
      END_STATE();
    case 534:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(353);
      END_STATE();
    case 535:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(323);
      END_STATE();
    case 536:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(119);
      END_STATE();
    case 537:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(329);
      END_STATE();
    case 538:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(162);
      END_STATE();
    case 539:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(351);
      END_STATE();
    case 540:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(134);
      END_STATE();
    case 541:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(652);
      END_STATE();
    case 542:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(652);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(788);
      END_STATE();
    case 543:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(163);
      END_STATE();
    case 544:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(639);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(627);
      END_STATE();
    case 545:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(641);
      END_STATE();
    case 546:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(641);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(634);
      END_STATE();
    case 547:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(376);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      END_STATE();
    case 548:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(90);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(147);
      END_STATE();
    case 549:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1227);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 550:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1168);
      END_STATE();
    case 551:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(989);
      END_STATE();
    case 552:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1147);
      END_STATE();
    case 553:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(944);
      END_STATE();
    case 554:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1093);
      END_STATE();
    case 555:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1071);
      END_STATE();
    case 556:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(955);
      END_STATE();
    case 557:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1072);
      END_STATE();
    case 558:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(191);
      END_STATE();
    case 559:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 560:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(447);
      END_STATE();
    case 561:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(454);
      END_STATE();
    case 562:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(209);
      END_STATE();
    case 563:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(222);
      END_STATE();
    case 564:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(137);
      END_STATE();
    case 565:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 566:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(245);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 567:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(450);
      END_STATE();
    case 568:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(326);
      END_STATE();
    case 569:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(747);
      END_STATE();
    case 570:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(821);
      END_STATE();
    case 571:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(226);
      END_STATE();
    case 572:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(745);
      END_STATE();
    case 573:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(757);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(152);
      END_STATE();
    case 574:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(722);
      END_STATE();
    case 575:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 576:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(239);
      END_STATE();
    case 577:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 578:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(813);
      END_STATE();
    case 579:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(767);
      END_STATE();
    case 580:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(771);
      END_STATE();
    case 581:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(772);
      END_STATE();
    case 582:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 583:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 584:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      END_STATE();
    case 585:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 586:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(575);
      END_STATE();
    case 587:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 588:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(424);
      END_STATE();
    case 589:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(789);
      END_STATE();
    case 590:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(806);
      END_STATE();
    case 591:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(207);
      END_STATE();
    case 592:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 593:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 594:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(746);
      END_STATE();
    case 595:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(809);
      END_STATE();
    case 596:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(539);
      END_STATE();
    case 597:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(215);
      END_STATE();
    case 598:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 599:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 600:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1145);
      END_STATE();
    case 601:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1157);
      END_STATE();
    case 602:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(197);
      END_STATE();
    case 603:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1153);
      END_STATE();
    case 604:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(220);
      END_STATE();
    case 605:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 606:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(538);
      END_STATE();
    case 607:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(212);
      END_STATE();
    case 608:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(384);
      END_STATE();
    case 609:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(783);
      END_STATE();
    case 610:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(388);
      END_STATE();
    case 611:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(527);
      END_STATE();
    case 612:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(659);
      END_STATE();
    case 613:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(833);
      END_STATE();
    case 614:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(683);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(691);
      END_STATE();
    case 615:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(817);
      END_STATE();
    case 616:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(551);
      END_STATE();
    case 617:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(708);
      END_STATE();
    case 618:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(553);
      END_STATE();
    case 619:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(554);
      END_STATE();
    case 620:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(555);
      END_STATE();
    case 621:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(662);
      END_STATE();
    case 622:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(556);
      END_STATE();
    case 623:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(557);
      END_STATE();
    case 624:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(665);
      END_STATE();
    case 625:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(730);
      END_STATE();
    case 626:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(188);
      END_STATE();
    case 627:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(836);
      END_STATE();
    case 628:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 629:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 630:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(584);
      END_STATE();
    case 631:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(219);
      END_STATE();
    case 632:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(177);
      END_STATE();
    case 633:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(706);
      END_STATE();
    case 634:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(851);
      END_STATE();
    case 635:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(593);
      END_STATE();
    case 636:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(249);
      END_STATE();
    case 637:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(710);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      END_STATE();
    case 638:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(217);
      END_STATE();
    case 639:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(251);
      END_STATE();
    case 640:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(711);
      END_STATE();
    case 641:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(253);
      END_STATE();
    case 642:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(476);
      END_STATE();
    case 643:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1129);
      END_STATE();
    case 644:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(614);
      END_STATE();
    case 645:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(267);
      END_STATE();
    case 646:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 647:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(280);
      END_STATE();
    case 648:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(782);
      END_STATE();
    case 649:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(782);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(753);
      END_STATE();
    case 650:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(298);
      END_STATE();
    case 651:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(308);
      END_STATE();
    case 652:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(486);
      END_STATE();
    case 653:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(839);
      END_STATE();
    case 654:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(497);
      END_STATE();
    case 655:
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(74);
      END_STATE();
    case 656:
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(841);
      END_STATE();
    case 657:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 658:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(385);
      END_STATE();
    case 659:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1127);
      END_STATE();
    case 660:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1064);
      END_STATE();
    case 661:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1050);
      END_STATE();
    case 662:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(925);
      END_STATE();
    case 663:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1080);
      END_STATE();
    case 664:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1105);
      END_STATE();
    case 665:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1236);
      END_STATE();
    case 666:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(831);
      END_STATE();
    case 667:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(612);
      END_STATE();
    case 668:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(401);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 669:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 670:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(142);
      END_STATE();
    case 671:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(142);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(716);
      END_STATE();
    case 672:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(142);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(716);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(737);
      END_STATE();
    case 673:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 674:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 675:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(627);
      END_STATE();
    case 676:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(403);
      END_STATE();
    case 677:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 678:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(604);
      END_STATE();
    case 679:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 680:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(552);
      END_STATE();
    case 681:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 682:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(704);
      END_STATE();
    case 683:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(760);
      END_STATE();
    case 684:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(602);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(674);
      END_STATE();
    case 685:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 686:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(631);
      END_STATE();
    case 687:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(272);
      END_STATE();
    case 688:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(610);
      END_STATE();
    case 689:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(700);
      END_STATE();
    case 690:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(779);
      END_STATE();
    case 691:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(277);
      END_STATE();
    case 692:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 693:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 694:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 695:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(286);
      END_STATE();
    case 696:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 697:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 698:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(294);
      END_STATE();
    case 699:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 700:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(417);
      END_STATE();
    case 701:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(739);
      END_STATE();
    case 702:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(692);
      END_STATE();
    case 703:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 704:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(354);
      END_STATE();
    case 705:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 706:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 707:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 708:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(540);
      END_STATE();
    case 709:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(443);
      END_STATE();
    case 710:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(543);
      END_STATE();
    case 711:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(536);
      END_STATE();
    case 712:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(378);
      END_STATE();
    case 713:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 714:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(634);
      END_STATE();
    case 715:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(398);
      END_STATE();
    case 716:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1046);
      END_STATE();
    case 717:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1083);
      END_STATE();
    case 718:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1047);
      END_STATE();
    case 719:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1206);
      END_STATE();
    case 720:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1208);
      END_STATE();
    case 721:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1035);
      END_STATE();
    case 722:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(958);
      END_STATE();
    case 723:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(948);
      END_STATE();
    case 724:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1095);
      END_STATE();
    case 725:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1082);
      END_STATE();
    case 726:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      END_STATE();
    case 727:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(646);
      END_STATE();
    case 728:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(261);
      END_STATE();
    case 729:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(717);
      END_STATE();
    case 730:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(755);
      END_STATE();
    case 731:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(734);
      END_STATE();
    case 732:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(718);
      END_STATE();
    case 733:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(784);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(146);
      END_STATE();
    case 734:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(638);
      END_STATE();
    case 735:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(325);
      END_STATE();
    case 736:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(268);
      END_STATE();
    case 737:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(270);
      END_STATE();
    case 738:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(725);
      END_STATE();
    case 739:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(430);
      END_STATE();
    case 740:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(769);
      END_STATE();
    case 741:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(297);
      END_STATE();
    case 742:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(310);
      END_STATE();
    case 743:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(311);
      END_STATE();
    case 744:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(799);
      END_STATE();
    case 745:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(416);
      END_STATE();
    case 746:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(418);
      END_STATE();
    case 747:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(433);
      END_STATE();
    case 748:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(435);
      END_STATE();
    case 749:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(439);
      END_STATE();
    case 750:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(628);
      END_STATE();
    case 751:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(750);
      END_STATE();
    case 752:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(780);
      END_STATE();
    case 753:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1101);
      END_STATE();
    case 754:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1140);
      END_STATE();
    case 755:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(953);
      END_STATE();
    case 756:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1102);
      END_STATE();
    case 757:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1225);
      END_STATE();
    case 758:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1131);
      END_STATE();
    case 759:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1220);
      END_STATE();
    case 760:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1027);
      END_STATE();
    case 761:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1097);
      END_STATE();
    case 762:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(957);
      END_STATE();
    case 763:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1191);
      END_STATE();
    case 764:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1111);
      END_STATE();
    case 765:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1165);
      END_STATE();
    case 766:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1033);
      END_STATE();
    case 767:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1054);
      END_STATE();
    case 768:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(969);
      END_STATE();
    case 769:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(987);
      END_STATE();
    case 770:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1203);
      END_STATE();
    case 771:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(921);
      END_STATE();
    case 772:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1161);
      END_STATE();
    case 773:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1164);
      END_STATE();
    case 774:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1210);
      END_STATE();
    case 775:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1189);
      END_STATE();
    case 776:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(95);
      END_STATE();
    case 777:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(606);
      END_STATE();
    case 778:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(260);
      END_STATE();
    case 779:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(866);
      END_STATE();
    case 780:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(676);
      END_STATE();
    case 781:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(314);
      END_STATE();
    case 782:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(410);
      END_STATE();
    case 783:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(83);
      END_STATE();
    case 784:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(141);
      END_STATE();
    case 785:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(438);
      END_STATE();
    case 786:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(161);
      END_STATE();
    case 787:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(427);
      END_STATE();
    case 788:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(144);
      END_STATE();
    case 789:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(709);
      END_STATE();
    case 790:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(274);
      END_STATE();
    case 791:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(283);
      END_STATE();
    case 792:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(328);
      END_STATE();
    case 793:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(289);
      END_STATE();
    case 794:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(333);
      END_STATE();
    case 795:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(330);
      END_STATE();
    case 796:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(302);
      END_STATE();
    case 797:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(332);
      END_STATE();
    case 798:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(350);
      END_STATE();
    case 799:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(677);
      END_STATE();
    case 800:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(441);
      END_STATE();
    case 801:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(621);
      END_STATE();
    case 802:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(624);
      END_STATE();
    case 803:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(843);
      END_STATE();
    case 804:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(411);
      END_STATE();
    case 805:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(431);
      END_STATE();
    case 806:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(336);
      END_STATE();
    case 807:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(434);
      END_STATE();
    case 808:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(414);
      END_STATE();
    case 809:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(337);
      END_STATE();
    case 810:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(795);
      END_STATE();
    case 811:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(339);
      END_STATE();
    case 812:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(340);
      END_STATE();
    case 813:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(128);
      END_STATE();
    case 814:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(797);
      END_STATE();
    case 815:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(341);
      END_STATE();
    case 816:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(436);
      END_STATE();
    case 817:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 818:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(562);
      END_STATE();
    case 819:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(412);
      END_STATE();
    case 820:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(753);
      END_STATE();
    case 821:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(523);
      END_STATE();
    case 822:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(173);
      END_STATE();
    case 823:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(399);
      END_STATE();
    case 824:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(246);
      END_STATE();
    case 825:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(170);
      END_STATE();
    case 826:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(701);
      END_STATE();
    case 827:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(756);
      END_STATE();
    case 828:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(613);
      END_STATE();
    case 829:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(437);
      END_STATE();
    case 830:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 831:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(325);
      END_STATE();
    case 832:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(682);
      END_STATE();
    case 833:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(724);
      END_STATE();
    case 834:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(483);
      END_STATE();
    case 835:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(271);
      END_STATE();
    case 836:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(805);
      END_STATE();
    case 837:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(285);
      END_STATE();
    case 838:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(484);
      END_STATE();
    case 839:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(691);
      END_STATE();
    case 840:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(492);
      END_STATE();
    case 841:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(343);
      END_STATE();
    case 842:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(490);
      END_STATE();
    case 843:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(694);
      END_STATE();
    case 844:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(794);
      END_STATE();
    case 845:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(494);
      END_STATE();
    case 846:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(698);
      END_STATE();
    case 847:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(495);
      END_STATE();
    case 848:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(699);
      END_STATE();
    case 849:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(674);
      END_STATE();
    case 850:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(498);
      END_STATE();
    case 851:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(807);
      END_STATE();
    case 852:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(597);
      END_STATE();
    case 853:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(179);
      END_STATE();
    case 854:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(404);
      END_STATE();
    case 855:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(84);
      END_STATE();
    case 856:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(152);
      END_STATE();
    case 857:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(266);
      END_STATE();
    case 858:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(295);
      END_STATE();
    case 859:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(121);
      END_STATE();
    case 860:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(349);
      END_STATE();
    case 861:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(1074);
      END_STATE();
    case 862:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(1076);
      END_STATE();
    case 863:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(803);
      END_STATE();
    case 864:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(966);
      END_STATE();
    case 865:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1049);
      END_STATE();
    case 866:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1041);
      END_STATE();
    case 867:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(645);
      END_STATE();
    case 868:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(778);
      END_STATE();
    case 869:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(647);
      END_STATE();
    case 870:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(650);
      END_STATE();
    case 871:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(651);
      END_STATE();
    case 872:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1282);
      END_STATE();
    case 873:
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '/') ADVANCE(1224);
      END_STATE();
    case 874:
      if (eof) ADVANCE(875);
      ADVANCE_MAP(
        '!', 1989,
        '#', 1285,
        '&', 1992,
        '(', 912,
        ')', 915,
        '+', 1267,
        ',', 947,
        '-', 1026,
        '.', 1274,
        ':', 913,
        '[', 1279,
        'A', 1367,
        'a', 1367,
        'B', 1288,
        'b', 1288,
        'C', 1297,
        'c', 1297,
        'D', 1318,
        'd', 1318,
        'E', 1633,
        'e', 1633,
        'F', 1767,
        'f', 1767,
        'G', 1761,
        'g', 1761,
        'I', 1546,
        'i', 1546,
        'L', 1762,
        'l', 1762,
        'M', 1306,
        'm', 1306,
        'N', 1342,
        'n', 1342,
        'O', 1799,
        'o', 1799,
        'P', 1289,
        'p', 1289,
        'R', 1444,
        'r', 1444,
        'S', 1302,
        's', 1302,
        'T', 1310,
        't', 1310,
        'U', 1873,
        'u', 1873,
        'V', 1308,
        'v', 1308,
        'W', 1576,
        'w', 1576,
      );
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(874);
      if (('H' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('h' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(aux_sym_program_statement_token1);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(aux_sym_program_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      ADVANCE_MAP(
        'A', 731,
        'a', 731,
        'B', 514,
        'b', 514,
        'D', 601,
        'd', 601,
        'E', 570,
        'e', 570,
        'F', 440,
        'f', 440,
        'I', 373,
        'i', 373,
        'M', 636,
        'm', 636,
        'P', 678,
        'p', 678,
        'S', 358,
        's', 358,
        'T', 869,
        't', 869,
        'W', 393,
        'w', 393,
      );
      END_STATE();
    case 879:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1898);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1695);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1765);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(570);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1617);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1616);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1838);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1857);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1952);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1540);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(1577);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1618);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(852);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1556);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(595);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(636);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(686);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(688);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(825);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(357);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(853);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(869);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token1);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(393);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token2);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(aux_sym_end_program_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(aux_sym_module_statement_token1);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(aux_sym_module_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(aux_sym_end_module_statement_token1);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(aux_sym_submodule_statement_token1);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(aux_sym_submodule_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '/') ADVANCE(1277);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(965);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(aux_sym_end_submodule_statement_token1);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(aux_sym_interface_statement_token1);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(aux_sym_interface_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(aux_sym_end_interface_statement_token1);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(aux_sym_end_interface_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(aux_sym_assignment_token1);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(aux_sym_assignment_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(1262);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(1262);
      if (lookahead == '>') ADVANCE(968);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(aux_sym_operator_token1);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(aux_sym_operator_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(aux_sym_operator_token2);
      if (lookahead == '\n') ADVANCE(929);
      if (lookahead == '(' ||
          lookahead == ')') ADVANCE(1989);
      if (lookahead != 0) ADVANCE(927);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(aux_sym_operator_token2);
      if (lookahead == '!') ADVANCE(927);
      if (lookahead == '#') ADVANCE(1286);
      if (lookahead == '&') ADVANCE(1993);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(928);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(929);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(aux_sym_operator_token2);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(929);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token1);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token2);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token3);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(aux_sym_defined_io_procedure_token4);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(aux_sym_subroutine_statement_token1);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(aux_sym_subroutine_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(aux_sym_end_subroutine_statement_token1);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(aux_sym_end_subroutine_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(aux_sym_module_procedure_statement_token1);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(aux_sym_module_procedure_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(aux_sym_end_module_procedure_statement_token1);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(aux_sym_end_module_procedure_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(aux_sym_function_statement_token1);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(aux_sym_function_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(aux_sym_language_binding_token1);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token1);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token2);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token3);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token4);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(aux_sym_procedure_attributes_token5);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(aux_sym_end_function_statement_token1);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(aux_sym_end_function_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(aux_sym_function_result_token1);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(aux_sym_contains_statement_token1);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(aux_sym_contains_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(aux_sym_use_statement_token1);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(aux_sym_use_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(aux_sym_use_statement_token2);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(aux_sym_use_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(aux_sym_use_statement_token3);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(aux_sym_included_items_token1);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(aux_sym_included_items_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token1);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token2);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token3);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token3);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(719);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token3);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1871);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token4);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(aux_sym_implicit_statement_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(aux_sym_save_statement_token1);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(aux_sym_save_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == ')') ADVANCE(1278);
      if (lookahead == '/') ADVANCE(1266);
      if (lookahead == '=') ADVANCE(1264);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(1266);
      if (lookahead == '=') ADVANCE(1264);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(aux_sym_private_statement_token1);
      END_STATE();
    case 984:
      ACCEPT_TOKEN(aux_sym_private_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 985:
      ACCEPT_TOKEN(aux_sym_public_statement_token1);
      END_STATE();
    case 986:
      ACCEPT_TOKEN(aux_sym_public_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 987:
      ACCEPT_TOKEN(aux_sym_namelist_statement_token1);
      END_STATE();
    case 988:
      ACCEPT_TOKEN(aux_sym_namelist_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(aux_sym_common_statement_token1);
      END_STATE();
    case 990:
      ACCEPT_TOKEN(aux_sym_common_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 991:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      END_STATE();
    case 992:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 181,
        'a', 181,
        'I', 563,
        'i', 563,
        'L', 626,
        'l', 626,
        'Y', 778,
        'y', 778,
      );
      END_STATE();
    case 993:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 473,
        'a', 473,
        'H', 110,
        'h', 110,
        'L', 99,
        'l', 99,
        'O', 520,
        'o', 520,
        'Y', 190,
        'y', 190,
      );
      END_STATE();
    case 994:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 672,
        'a', 672,
        'I', 586,
        'i', 586,
        'O', 407,
        'o', 407,
        'R', 318,
        'r', 318,
        'U', 172,
        'u', 172,
      );
      END_STATE();
    case 995:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 857,
        'a', 857,
        'E', 478,
        'e', 478,
        'H', 111,
        'h', 111,
        'T', 115,
        't', 115,
        'U', 168,
        'u', 168,
      );
      END_STATE();
    case 996:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 529,
        'a', 529,
        'I', 585,
        'i', 585,
        'O', 657,
        'o', 657,
        'U', 562,
        'u', 562,
      );
      END_STATE();
    case 997:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1672);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 998:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 999:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(508);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(472);
      END_STATE();
    case 1000:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 776,
        'a', 776,
        'E', 371,
        'e', 371,
        'I', 535,
        'i', 535,
        'O', 1154,
        'o', 1154,
      );
      END_STATE();
    case 1001:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1916);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1975);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(564);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 1003:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'A', 658,
        'a', 658,
        'E', 863,
        'e', 863,
        'H', 321,
        'h', 321,
        'O', 1144,
        'o', 1144,
        'Y', 645,
        'y', 645,
      );
      END_STATE();
    case 1004:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(560);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(532);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(548);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(475);
      END_STATE();
    case 1006:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'B', 744,
        'b', 744,
        'L', 453,
        'l', 453,
        'S', 715,
        's', 715,
        'T', 780,
        't', 780,
        'U', 777,
        'u', 777,
      );
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'E', 568,
        'e', 568,
        'L', 605,
        'l', 605,
        'O', 1142,
        'o', 1142,
        'R', 400,
        'r', 400,
      );
      END_STATE();
    case 1008:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1009:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1698);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1771);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'F', 1166,
        'f', 1166,
        'M', 642,
        'm', 642,
        'N', 1099,
        'n', 1099,
        'S', 1205,
        's', 1205,
      );
      END_STATE();
    case 1011:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1818);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1012:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(347);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(426);
      END_STATE();
    case 1013:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'L', 362,
        'l', 362,
        'N', 221,
        'n', 221,
        'Q', 823,
        'q', 823,
        'R', 667,
        'r', 667,
        'X', 405,
        'x', 405,
      );
      END_STATE();
    case 1014:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1789);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1919);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1015:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1432,
        'n', 1432,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1016:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(376);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      END_STATE();
    case 1017:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(454);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(258);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(753);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1859);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1020:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(730);
      END_STATE();
    case 1021:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1607);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1022:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(412);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(aux_sym_implicit_range_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1026:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(aux_sym_import_statement_token1);
      END_STATE();
    case 1028:
      ACCEPT_TOKEN(aux_sym_import_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1029:
      ACCEPT_TOKEN(aux_sym__import_names_token1);
      END_STATE();
    case 1030:
      ACCEPT_TOKEN(aux_sym__import_names_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(212);
      END_STATE();
    case 1031:
      ACCEPT_TOKEN(aux_sym_derived_type_definition_token1);
      END_STATE();
    case 1032:
      ACCEPT_TOKEN(aux_sym_derived_type_definition_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1033:
      ACCEPT_TOKEN(aux_sym_abstract_specifier_token1);
      END_STATE();
    case 1034:
      ACCEPT_TOKEN(aux_sym_abstract_specifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1035:
      ACCEPT_TOKEN(aux_sym_base_type_specifier_token1);
      END_STATE();
    case 1036:
      ACCEPT_TOKEN(aux_sym_end_type_statement_token1);
      END_STATE();
    case 1037:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token1);
      END_STATE();
    case 1038:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1039:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token2);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1041:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token3);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1043:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token4);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(aux_sym__procedure_kind_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token1);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token2);
      END_STATE();
    case 1047:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token3);
      END_STATE();
    case 1048:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token4);
      END_STATE();
    case 1049:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token5);
      END_STATE();
    case 1050:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token6);
      END_STATE();
    case 1051:
      ACCEPT_TOKEN(aux_sym_procedure_attribute_token6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1052:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token1);
      END_STATE();
    case 1053:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1054:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token2);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1056:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token3);
      END_STATE();
    case 1057:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token4);
      END_STATE();
    case 1059:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1060:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token5);
      END_STATE();
    case 1061:
      ACCEPT_TOKEN(aux_sym_variable_attributes_token5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token1);
      END_STATE();
    case 1063:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1064:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token2);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token3);
      END_STATE();
    case 1067:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token4);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1774);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1851);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token4);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(611);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(696);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1071:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token5);
      END_STATE();
    case 1072:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token6);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1074:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token7);
      END_STATE();
    case 1075:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1076:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token8);
      END_STATE();
    case 1077:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token8);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token9);
      END_STATE();
    case 1079:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1080:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token10);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(aux_sym_intrinsic_type_token10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(aux_sym_derived_type_token1);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(aux_sym_derived_type_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(345);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(720);
      END_STATE();
    case 1084:
      ACCEPT_TOKEN(aux_sym_derived_type_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1523);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1872);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1085:
      ACCEPT_TOKEN(aux_sym_derived_type_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(1268);
      END_STATE();
    case 1088:
      ACCEPT_TOKEN(aux_sym_size_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1088);
      END_STATE();
    case 1089:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token1);
      END_STATE();
    case 1090:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1091:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token2);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token3);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token4);
      END_STATE();
    case 1096:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1097:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token5);
      END_STATE();
    case 1098:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token5);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1099:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token6);
      ADVANCE_MAP(
        'C', 474,
        'c', 474,
        'I', 785,
        'i', 785,
        'O', 827,
        'o', 827,
        'Q', 829,
        'q', 829,
        'T', 263,
        't', 263,
      );
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token6);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(827);
      END_STATE();
    case 1101:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token7);
      END_STATE();
    case 1102:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token8);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token9);
      END_STATE();
    case 1104:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token9);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1105:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token10);
      END_STATE();
    case 1106:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token10);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1107:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token11);
      END_STATE();
    case 1108:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token11);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1109:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token12);
      END_STATE();
    case 1110:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1111:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token13);
      END_STATE();
    case 1112:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token13);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1113:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token14);
      END_STATE();
    case 1114:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token14);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1115:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token15);
      END_STATE();
    case 1116:
      ACCEPT_TOKEN(aux_sym_type_qualifier_token15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token1);
      END_STATE();
    case 1118:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1119:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token2);
      END_STATE();
    case 1120:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token3);
      END_STATE();
    case 1122:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1123:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token4);
      END_STATE();
    case 1124:
      ACCEPT_TOKEN(aux_sym_procedure_qualifier_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(aux_sym_equivalence_statement_token1);
      END_STATE();
    case 1126:
      ACCEPT_TOKEN(aux_sym_equivalence_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1127:
      ACCEPT_TOKEN(aux_sym_stop_statement_token1);
      END_STATE();
    case 1128:
      ACCEPT_TOKEN(aux_sym_stop_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1129:
      ACCEPT_TOKEN(aux_sym_stop_statement_token2);
      END_STATE();
    case 1130:
      ACCEPT_TOKEN(aux_sym_stop_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(aux_sym_stop_statement_token3);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(aux_sym_subroutine_call_token1);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(aux_sym_subroutine_call_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1134:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 1135:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token1);
      END_STATE();
    case 1137:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1138:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token2);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1140:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token3);
      END_STATE();
    case 1141:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token4);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(600);
      END_STATE();
    case 1143:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token4);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1764);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1144:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token5);
      END_STATE();
    case 1145:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token6);
      END_STATE();
    case 1146:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token7);
      END_STATE();
    case 1148:
      ACCEPT_TOKEN(aux_sym_keyword_statement_token7);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(aux_sym_include_statement_token1);
      END_STATE();
    case 1150:
      ACCEPT_TOKEN(aux_sym_include_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1151:
      ACCEPT_TOKEN(aux_sym_data_statement_token1);
      END_STATE();
    case 1152:
      ACCEPT_TOKEN(aux_sym_data_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1153:
      ACCEPT_TOKEN(aux_sym_do_loop_statement_token1);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(aux_sym_do_loop_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(aux_sym_do_loop_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1156:
      ACCEPT_TOKEN(aux_sym_do_loop_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(aux_sym_end_do_loop_statement_token1);
      END_STATE();
    case 1158:
      ACCEPT_TOKEN(aux_sym_end_do_loop_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(aux_sym_while_statement_token1);
      END_STATE();
    case 1160:
      ACCEPT_TOKEN(aux_sym_while_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1161:
      ACCEPT_TOKEN(aux_sym_concurrent_header_token1);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(aux_sym_concurrent_header_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(aux_sym_concurrent_locality_token1);
      if (lookahead == '_') ADVANCE(422);
      END_STATE();
    case 1164:
      ACCEPT_TOKEN(aux_sym_concurrent_locality_token2);
      END_STATE();
    case 1165:
      ACCEPT_TOKEN(aux_sym_concurrent_locality_token3);
      END_STATE();
    case 1166:
      ACCEPT_TOKEN(aux_sym__inline_if_statement_token1);
      END_STATE();
    case 1167:
      ACCEPT_TOKEN(aux_sym__inline_if_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(aux_sym__block_if_statement_token1);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(aux_sym__block_if_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(aux_sym_end_if_statement_token1);
      END_STATE();
    case 1171:
      ACCEPT_TOKEN(aux_sym_end_if_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(374);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(395);
      END_STATE();
    case 1174:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1558);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(1578);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1175:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1558);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1176:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token1);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(395);
      END_STATE();
    case 1177:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token2);
      END_STATE();
    case 1178:
      ACCEPT_TOKEN(aux_sym_elseif_clause_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1179:
      ACCEPT_TOKEN(aux_sym__inline_where_statement_token1);
      END_STATE();
    case 1180:
      ACCEPT_TOKEN(aux_sym__inline_where_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(aux_sym_end_where_statement_token1);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(aux_sym_end_where_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1183:
      ACCEPT_TOKEN(aux_sym_elsewhere_clause_token1);
      END_STATE();
    case 1184:
      ACCEPT_TOKEN(aux_sym_elsewhere_clause_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1185:
      ACCEPT_TOKEN(aux_sym__forall_control_expression_token1);
      END_STATE();
    case 1186:
      ACCEPT_TOKEN(aux_sym__forall_control_expression_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1187:
      ACCEPT_TOKEN(aux_sym_end_forall_statement_token1);
      END_STATE();
    case 1188:
      ACCEPT_TOKEN(aux_sym_end_forall_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token1);
      END_STATE();
    case 1190:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1354);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1336);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1987);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(153);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(123);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(870);
      END_STATE();
    case 1192:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1193:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token2);
      END_STATE();
    case 1194:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1195:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token3);
      END_STATE();
    case 1196:
      ACCEPT_TOKEN(aux_sym_select_case_statement_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1197:
      ACCEPT_TOKEN(aux_sym_select_type_statement_token1);
      END_STATE();
    case 1198:
      ACCEPT_TOKEN(aux_sym_select_type_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(aux_sym_select_rank_statement_token1);
      END_STATE();
    case 1200:
      ACCEPT_TOKEN(aux_sym_select_rank_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(aux_sym_select_rank_statement_token2);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(aux_sym_select_rank_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(aux_sym_end_select_statement_token1);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(aux_sym_end_select_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1205:
      ACCEPT_TOKEN(aux_sym_type_statement_token1);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(aux_sym_type_statement_token2);
      END_STATE();
    case 1207:
      ACCEPT_TOKEN(aux_sym_type_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1208:
      ACCEPT_TOKEN(aux_sym_type_statement_token3);
      END_STATE();
    case 1209:
      ACCEPT_TOKEN(aux_sym_type_statement_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1210:
      ACCEPT_TOKEN(aux_sym__class_default_token1);
      END_STATE();
    case 1211:
      ACCEPT_TOKEN(aux_sym__class_default_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(aux_sym_block_construct_token1);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(aux_sym_block_construct_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1214:
      ACCEPT_TOKEN(aux_sym_end_block_construct_statement_token1);
      END_STATE();
    case 1215:
      ACCEPT_TOKEN(aux_sym_end_block_construct_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1216:
      ACCEPT_TOKEN(aux_sym_associate_statement_token1);
      END_STATE();
    case 1217:
      ACCEPT_TOKEN(aux_sym_associate_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(aux_sym_end_associate_statement_token1);
      END_STATE();
    case 1219:
      ACCEPT_TOKEN(aux_sym_end_associate_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1220:
      ACCEPT_TOKEN(aux_sym_format_statement_token1);
      END_STATE();
    case 1221:
      ACCEPT_TOKEN(aux_sym_format_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(sym_edit_descriptor);
      if (lookahead == 'H') ADVANCE(873);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1222);
      if (lookahead == '$' ||
          lookahead == '*' ||
          ('.' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'g') ||
          ('i' <= lookahead && lookahead <= 'z')) ADVANCE(1223);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(sym_edit_descriptor);
      if (lookahead == '$' ||
          lookahead == '*' ||
          ('.' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'G') ||
          ('I' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'g') ||
          ('i' <= lookahead && lookahead <= 'z')) ADVANCE(1223);
      END_STATE();
    case 1224:
      ACCEPT_TOKEN(aux_sym_hollerith_constant_token1);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ',' &&
          lookahead != '/') ADVANCE(1224);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(aux_sym_print_statement_token1);
      END_STATE();
    case 1226:
      ACCEPT_TOKEN(aux_sym_print_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(aux_sym_open_statement_token1);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(aux_sym_open_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1229:
      ACCEPT_TOKEN(aux_sym_close_statement_token1);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(aux_sym_close_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1231:
      ACCEPT_TOKEN(aux_sym_inquire_statement_token1);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(aux_sym_inquire_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1233:
      ACCEPT_TOKEN(aux_sym_enum_statement_token1);
      END_STATE();
    case 1234:
      ACCEPT_TOKEN(aux_sym_enum_statement_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(713);
      END_STATE();
    case 1235:
      ACCEPT_TOKEN(aux_sym_enum_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1236:
      ACCEPT_TOKEN(aux_sym_enumerator_statement_token1);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(aux_sym_end_enum_statement_token1);
      END_STATE();
    case 1238:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token1);
      END_STATE();
    case 1239:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token2);
      END_STATE();
    case 1241:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1242:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token3);
      END_STATE();
    case 1243:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1244:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token4);
      END_STATE();
    case 1245:
      ACCEPT_TOKEN(aux_sym_file_position_statement_token4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1246:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(aux_sym_logical_expression_token1);
      END_STATE();
    case 1248:
      ACCEPT_TOKEN(aux_sym_logical_expression_token2);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(aux_sym_logical_expression_token3);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(aux_sym_logical_expression_token4);
      END_STATE();
    case 1251:
      ACCEPT_TOKEN(aux_sym_logical_expression_token5);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(87);
      if (lookahead == '=') ADVANCE(1258);
      END_STATE();
    case 1253:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(1258);
      END_STATE();
    case 1254:
      ACCEPT_TOKEN(aux_sym_relational_expression_token1);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(1260);
      END_STATE();
    case 1256:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(1260);
      if (lookahead == '>') ADVANCE(89);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(aux_sym_relational_expression_token2);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(aux_sym_relational_expression_token3);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 1261:
      ACCEPT_TOKEN(aux_sym_relational_expression_token4);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 1263:
      ACCEPT_TOKEN(aux_sym_relational_expression_token5);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(aux_sym_relational_expression_token6);
      END_STATE();
    case 1266:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 1267:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 1269:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 1270:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '.', 1276,
        'A', 559,
        'a', 559,
        'E', 655,
        'e', 655,
        'F', 106,
        'f', 106,
        'G', 255,
        'g', 255,
        'L', 316,
        'l', 316,
        'N', 257,
        'n', 257,
        'O', 669,
        'o', 669,
        'T', 666,
        't', 666,
      );
      END_STATE();
    case 1271:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(1276);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(106);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(609);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(666);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        'A', 559,
        'a', 559,
        'E', 655,
        'e', 655,
        'F', 106,
        'f', 106,
        'G', 255,
        'g', 255,
        'L', 316,
        'l', 316,
        'N', 257,
        'n', 257,
        'O', 669,
        'o', 669,
        'T', 666,
        't', 666,
      );
      END_STATE();
    case 1273:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        'A', 559,
        'a', 559,
        'E', 655,
        'e', 655,
        'G', 255,
        'g', 255,
        'L', 316,
        'l', 316,
        'N', 256,
        'n', 256,
        'O', 669,
        'o', 669,
      );
      END_STATE();
    case 1274:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(106);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(609);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(666);
      END_STATE();
    case 1275:
      ACCEPT_TOKEN(aux_sym_user_defined_operator_token1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1275);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(sym_assumed_rank);
      END_STATE();
    case 1277:
      ACCEPT_TOKEN(anon_sym_LPAREN_SLASH);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(anon_sym_SLASH_RPAREN);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 1280:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(sym_boolean_literal);
      if (lookahead == '_') ADVANCE(872);
      END_STATE();
    case 1282:
      ACCEPT_TOKEN(sym_boolean_literal);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1282);
      END_STATE();
    case 1283:
      ACCEPT_TOKEN(aux_sym_null_literal_token1);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(aux_sym_null_literal_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1285:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 1286:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(929);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(aux_sym_preproc_file_line_token1);
      END_STATE();
    case 1288:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1378);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1789);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1919);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1289:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1828,
        'a', 1828,
        'I', 1730,
        'i', 1730,
        'O', 1591,
        'o', 1591,
        'R', 1580,
        'r', 1580,
        'U', 1371,
        'u', 1371,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1290:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1828,
        'a', 1828,
        'I', 1730,
        'i', 1730,
        'O', 1591,
        'o', 1591,
        'R', 1581,
        'r', 1581,
        'U', 1372,
        'u', 1372,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1291:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1417,
        'a', 1417,
        'C', 1954,
        'c', 1954,
        'T', 1955,
        't', 1955,
        'W', 1593,
        'w', 1593,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1292:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1417);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1954);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1293:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1417);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1955);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(1593);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1417);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1295:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1296:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1650,
        'a', 1650,
        'L', 1788,
        'l', 1788,
        'O', 1759,
        'o', 1759,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1651,
        'a', 1651,
        'H', 1325,
        'h', 1325,
        'L', 1316,
        'l', 1316,
        'O', 1700,
        'o', 1700,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1298:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1651,
        'a', 1651,
        'H', 1325,
        'h', 1325,
        'L', 1316,
        'l', 1316,
        'O', 1701,
        'o', 1701,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1651,
        'a', 1651,
        'L', 1788,
        'l', 1788,
        'O', 1759,
        'o', 1759,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1300:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1651,
        'a', 1651,
        'L', 1788,
        'l', 1788,
        'O', 1744,
        'o', 1744,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1651,
        'a', 1651,
        'L', 1346,
        'l', 1346,
        'O', 1759,
        'o', 1759,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1302:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1978,
        'a', 1978,
        'E', 1655,
        'e', 1655,
        'H', 1328,
        'h', 1328,
        'T', 1326,
        't', 1326,
        'U', 1366,
        'u', 1366,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1303:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1978,
        'a', 1978,
        'E', 1655,
        'e', 1655,
        'H', 1328,
        'h', 1328,
        'T', 1326,
        't', 1326,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1304:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1978,
        'a', 1978,
        'E', 1697,
        'e', 1697,
        'H', 1328,
        'h', 1328,
        'T', 1326,
        't', 1326,
        'U', 1377,
        'u', 1377,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1305:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1978,
        'a', 1978,
        'E', 1697,
        'e', 1697,
        'H', 1328,
        'h', 1328,
        'T', 1326,
        't', 1326,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1306:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1727);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1433);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1307:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1727);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1308:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1672);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1652);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1309:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1672);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1310:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1983);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1804);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1311:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1983);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1312:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1517);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1313:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1804);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1314:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1808);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1315:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1826);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1316:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1877);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1881);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1317:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1877);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1318:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1916,
        'a', 1916,
        'E', 1976,
        'e', 1976,
        'I', 1705,
        'i', 1705,
        'O', 1155,
        'o', 1155,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1319:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1916,
        'a', 1916,
        'E', 1976,
        'e', 1976,
        'I', 1705,
        'i', 1705,
        'O', 1975,
        'o', 1975,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1320:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1916,
        'a', 1916,
        'E', 1976,
        'e', 1976,
        'I', 1705,
        'i', 1705,
        'O', 1950,
        'o', 1950,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1321:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1916);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1975);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1322:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1916);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1950);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1323:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1916);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1324:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1703);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1325:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1831);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1326:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1940);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1801);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1327:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1328:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1842);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1329:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1640);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1330:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1641);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1331:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1946);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1332:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1965);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1619);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1333:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1642);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1334:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1902);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1335:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1336:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1728);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1337:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1645);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1338:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1646);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1339:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1829,
        'a', 1829,
        'I', 1730,
        'i', 1730,
        'O', 1591,
        'o', 1591,
        'R', 1608,
        'r', 1608,
        'U', 1371,
        'u', 1371,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1340:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'A', 1829,
        'a', 1829,
        'I', 1730,
        'i', 1730,
        'O', 1591,
        'o', 1591,
        'R', 1608,
        'r', 1608,
        'U', 1372,
        'u', 1372,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1341:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1731);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1342:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1707);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1343:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1935);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1344:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1958);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1345:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1566);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1346:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1884);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1881);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1347:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1924);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1348:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1711);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1349:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1657);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1350:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1928);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1351:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1411);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1352:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1353:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1743);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1354:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1887);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1355:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1601);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1562);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1356:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1601);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1752);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1357:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1660);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1358:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1359:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1402);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1360:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1930);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1361:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1699);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1362:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1932);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1363:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1404);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1364:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1375);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1365:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(1943);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1366:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1709);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1367:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'B', 1890,
        'b', 1890,
        'L', 1648,
        'l', 1648,
        'S', 1891,
        's', 1891,
        'T', 1920,
        't', 1920,
        'U', 1921,
        'u', 1921,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1368:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'B', 1890,
        'b', 1890,
        'L', 1648,
        'l', 1648,
        'T', 1920,
        't', 1920,
        'U', 1921,
        'u', 1921,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1369:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1710);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1370:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1969);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1371:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1675);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1448);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1372:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1675);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1373:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1864);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1374:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1663);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1375:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1668);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1376:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1670);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1377:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(1835);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1378:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1632);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1379:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(986);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1380:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1381:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1382:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1383:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1038);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1384:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1628);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1385:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1630);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1386:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1659);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1387:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1933);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1388:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1329);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1389:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1624);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1390:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1627);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1391:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1521);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1836);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1506);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1392:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1521);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1527);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1393:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1521);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1506);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1394:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1521);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1395:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1905);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1396:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1907);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1397:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1911);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1398:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1457);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1399:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1913);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1400:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1467);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1401:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1470);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1402:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1471);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1403:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1479);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1404:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1493);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1405:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1604);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1406:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1653);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1447);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1407:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1653);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1408:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1409:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1929);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1410:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1962);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1411:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1939);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1412:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1947);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1413:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1625);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1414:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(1545);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1415:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(885);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1416:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(885);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1417:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(931);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1067);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1418:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1059);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1419:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1243);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1420:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1057);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1421:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1053);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1422:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1423:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(887);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1424:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(887);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1425:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(883);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1426:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(883);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1427:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(880);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1428:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(880);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1429:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(889);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1430:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(879);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1431:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(881);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1432:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(892);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1433:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1967);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1434:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(888);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1435:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(890);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1436:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(894);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1437:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(884);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1438:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1462);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1439:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(886);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1440:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(886);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1441:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1971);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1442:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1970);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1443:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(1972);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1444:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1445:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(961);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1446:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1063);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1447:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1569);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1448:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1449:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(979);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1450:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(975);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1451:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1230);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1452:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1453:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1454:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1455:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1456:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(933);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1457:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(952);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1458:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1068);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1459:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1460:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(907);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1461:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1241);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1462:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1463:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1232);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1464:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(984);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1465:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1061);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1466:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1467:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1032);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1468:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1469:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1470:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1471:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(918);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1472:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(941);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1473:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1474:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(910);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1475:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1476:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1477:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(937);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1478:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1090);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1479:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1480:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1481:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(939);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1482:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(943);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1483:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1484:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1070);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1485:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1486:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1487:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(974);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1488:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1489:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1490:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1491:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1292);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1492:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1740);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1493:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(920);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1494:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1495:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1981);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1496:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1570);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1497:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1418);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1498:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1982);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1499:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1718);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1594);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1500:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1718);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1501:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1420);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1502:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1421);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1503:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1732);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1504:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1422);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1505:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1583);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1506:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1409);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1507:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1856);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1508:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1658);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1509:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1868);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1510:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1821);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1511:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1822);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1512:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1823);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1513:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1824);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1514:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1906);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1515:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1858);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1516:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1863);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1517:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1725);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1518:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1519:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1520:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1750);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1521:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1442);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1522:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1523:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1559);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1524:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1525:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1844);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1526:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1753);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1527:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1848);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1528:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1529:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1530:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1845);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1531:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1532:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1741);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1533:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1745);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1534:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1854);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1535:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1746);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1536:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1855);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1537:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1656);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1771);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1538:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1712);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1505);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1539:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1755);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1540:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1541:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1942);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1542:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1698);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1771);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1369);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1543:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1698);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1771);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1544:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1698);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1771);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1545:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1443);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1546:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1800);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1547:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1802);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1548:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1813);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1817);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1549:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1813);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1815);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1550:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1803);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1605);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1551:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1407);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1552:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1814);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1553:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1818);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1554:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1817);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1555:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1167);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1816);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1556:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1171);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1945);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1557:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1558:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1559:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1560:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1359);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1561:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(1363);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1562:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1956);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1563:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1956);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1564:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1514);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1565:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1758);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1566:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1502);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1567:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1609);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1568:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1836);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1569:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1510);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1904);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1560);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1570:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1510);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1904);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1571:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1510);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1572:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(1840);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1573:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'H', 1325,
        'h', 1325,
        'L', 1317,
        'l', 1317,
        'O', 1715,
        'o', 1715,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1574:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'H', 1325,
        'h', 1325,
        'L', 1317,
        'l', 1317,
        'O', 1716,
        'o', 1716,
        'Y', 1386,
        'y', 1386,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1575:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1325);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1716);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1576:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1525);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1607);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1577:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1534);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1578:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1536);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1579:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(1623);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1607);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1580:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1736);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1581:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1736);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1582:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1562);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1583:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1558);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1584:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1979);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1585:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1586:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1563);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1587:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1900);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1507);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1588:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1900);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1589:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1565);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1590:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1591:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1734);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1592:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1405);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1593:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1729);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1594:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1794);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1595:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1596:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1886);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1597:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1598:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1733);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1599:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1381);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1600:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1601:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1602:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1383);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1603:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1752);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1604:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1909);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1605:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1926);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1528);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1606:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1980);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1607:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1927);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1608:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1977);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1925);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1609:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1610:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1747);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1611:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1780);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1612:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1748);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1613:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1781);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1614:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1849);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1615:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1782);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1616:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1665);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1843);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1617:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1665);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1760);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1618:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1665);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1619:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1737);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1620:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1621:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1338);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1622:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1666);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1623:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1671);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1624:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1625:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1362);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1626:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1756);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1859);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1726);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1627:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(1896);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1628:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1629:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1630:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1631:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1200);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1632:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(1875);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1633:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1538,
        'l', 1538,
        'N', 1415,
        'n', 1415,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1634:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1538,
        'l', 1538,
        'N', 1432,
        'n', 1432,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1635:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1538,
        'l', 1538,
        'N', 1432,
        'n', 1432,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1636:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1538,
        'l', 1538,
        'N', 1436,
        'n', 1436,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1637:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1638:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1639:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1640:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1079);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1641:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(977);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1642:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1643:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1644:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1645:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1044);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1646:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1040);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1647:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1789);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1919);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1648:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1772);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1649:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1985);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1650:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1637);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1490);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1651:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1637);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1652:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1331);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1653:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1949);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1654:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1655:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1522);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1959);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1656:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1522);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1657:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1639);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1658:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1596);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1659:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1452);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1660:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1644);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1661:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1495);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1662:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1912);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1663:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1458);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1664:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1460);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1665:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1461);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1666:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1468);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1667:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1668:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1478);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1669:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1498);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1670:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1484);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1671:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1494);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1672:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1961);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1673:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1592);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1839);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1847);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1674:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1592);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1839);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1675:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1595);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1676:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1415,
        'n', 1415,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1677:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1423,
        'n', 1423,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1678:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1425,
        'n', 1425,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1679:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1427,
        'n', 1427,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1680:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1434,
        'n', 1434,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1681:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1426,
        'n', 1426,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1682:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1416,
        'n', 1416,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1683:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1435,
        'n', 1435,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1684:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1424,
        'n', 1424,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1685:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1430,
        'n', 1430,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1686:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1428,
        'n', 1428,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1687:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1437,
        'n', 1437,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1688:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1431,
        'n', 1431,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1689:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1432,
        'n', 1432,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1690:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1432,
        'n', 1432,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1691:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1440,
        'n', 1440,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1692:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1876,
        'l', 1876,
        'N', 1439,
        'n', 1439,
        'Q', 1951,
        'q', 1951,
        'R', 1830,
        'r', 1830,
        'X', 1587,
        'x', 1587,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1693:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1888,
        'l', 1888,
        'N', 1429,
        'n', 1429,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1694:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      ADVANCE_MAP(
        'L', 1889,
        'l', 1889,
        'N', 1435,
        'n', 1435,
        'R', 1830,
        'r', 1830,
        'X', 1588,
        'x', 1588,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1695:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1790);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1696:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1529);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1697:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1531);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1959);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1698:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1531);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1699:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(1539);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1700:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1708);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1878);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1701:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1708);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1879);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1702:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1703:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(877);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1704:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(905);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1705:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1503);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1706:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1812);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1707:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1508);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1708:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1779);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1709:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1795);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1775);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1710:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1795);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1711:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1541);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1712:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1526);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1713:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1714:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1715:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1809);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1880);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1716:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1809);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1717:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(1533);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1718:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1228);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1719:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(990);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1720:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1148);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1721:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(945);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1722:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1094);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1723:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1073);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1724:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(956);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1725:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1726:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1727:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1345);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1728:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1629);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1729:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1419);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1730:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1739);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1731:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1631);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1732:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1895);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1733:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1894);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1734:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1936);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1735:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1867);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1736:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1901);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1737:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1901);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1738:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1410);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1739:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1497);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1740:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1904);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1560);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1741:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1904);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1742:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1649);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1743:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1908);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1744:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1917);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1745:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1914);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1746:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1915);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1747:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1477);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1748:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1481);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1749:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1880);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1750:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1400);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1751:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1330);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1752:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1963);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1753:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1937);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1754:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1333);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1755:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1756:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1757:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1515);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1758:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1717);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1759:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1944);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1760:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(1412);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1761:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1762:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1567);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1763:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1433);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1764:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1146);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1765:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1766:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1767:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1819);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1726);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1768:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1819);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1769:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1714);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1770:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1572);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1771:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1801);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1772:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1408);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1773:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1774:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1775:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1960);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1776:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1820);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1777:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1957);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1778:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1839);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1847);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1779:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1719);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1780:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1721);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1781:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1722);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1782:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1723);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1783:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1859);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1726);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1784:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1859);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1785:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1724);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1786:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1825);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1787:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1749);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1788:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1881);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1789:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1384);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1790:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1385);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1791:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1738);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1792:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1414);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1793:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1568);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1794:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1754);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1795:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1441);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1796:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1974);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1797:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1413);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1798:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(1394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1799:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1499);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1800:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1673);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1801:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1802:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1674);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1803:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1778);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1804:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1450);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1805:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1806:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1476);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1807:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1500);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1808:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1487);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1809:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1810:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1922);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1811:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1530);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1812:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1669);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1813:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1966);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1814:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1532);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1815:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1816:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1492);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1817:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1528);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1818:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(1953);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1819:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1349);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1820:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1821:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1065);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1822:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1051);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1823:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1081);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1824:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1825:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(926);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1826:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1564);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1827:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1607);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1828:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1348);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1883);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1829:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1830:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1776);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1831:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1351);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1832:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1585);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1833:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1448);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1834:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1882);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1835:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1775);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1836:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1324);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1837:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1720);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1838:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1770);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1839:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1903);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1840:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1327);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1841:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1766);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1833);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1842:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1501);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1843:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1357);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1844:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1455);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1845:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1343);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1846:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1862);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1847:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1459);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1848:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1918);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1849:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1463);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1850:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1465);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1851:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1524);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1852:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1472);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1853:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1482);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1854:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1485);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1855:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1486);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1856:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1751);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1857:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1792);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1858:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1602);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1859:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1713);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1860:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1861:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1793);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1862:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1535);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1863:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1561);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1864:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1796);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1865:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(1798);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1866:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1085);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1867:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(959);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1868:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(949);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1869:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1096);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1870:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1084);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1871:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1207);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1872:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1873:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1445);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1874:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1891);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1875:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1805);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1876:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1505);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1877:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1866);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1878:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1923);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1879:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1923);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1582);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1880:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1923);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1586);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1881:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1451);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1882:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1606);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1883:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1453);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1884:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1870);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1885:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1589);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1886:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1910);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1887:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1475);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1888:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1483);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1889:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1488);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1890:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1948);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1891:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1773);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1892:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1885);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1920);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1893:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1885);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1894:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1600);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1895:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1613);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1896:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1615);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1897:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1797);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1898:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(1897);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1899:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1920);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1900:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1901:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1902:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1903:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1028);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1904:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1098);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1905:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1906:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1907:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1034);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1908:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1055);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1909:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(970);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1910:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(988);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1911:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1204);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1912:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1913:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1914:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(922);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1915:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1916:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1295);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1917:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1918:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1984);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1919:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1446);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1920:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1832);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1921:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1769);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1922:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1594);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1923:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1353);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1924:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1925:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1506);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1926:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1621);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1927:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1456);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1928:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1464);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1929:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1504);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1930:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1469);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1931:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1509);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1932:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1489);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1933:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1611);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1934:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1968);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1935:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1786);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1936:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1511);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1937:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1938:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1610);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1939:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1512);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1940:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1597);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1941:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1612);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1942:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1513);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1943:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1599);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1944:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1603);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1945:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1516);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1946:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1622);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1947:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1620);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1948:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(1860);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1949:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1438);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1950:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1951:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1584);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1952:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1953:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1614);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1954:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1834);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1955:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1837);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1956:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1777);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1957:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1869);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1958:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1662);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1959:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1520);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1960:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1938);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1961:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1454);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1962:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1963:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1466);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1964:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1965:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1883);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1966:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1847);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1967:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1664);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1968:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1850);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1969:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1931);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1970:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1852);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1971:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1667);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1972:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1853);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1973:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1833);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1974:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1941);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1975:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(1376);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1976:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1590);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1977:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1978:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1449);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1979:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1361);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1980:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(1473);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1981:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(1075);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1982:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(1077);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1983:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(1934);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1984:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1042);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1985:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(967);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1986:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1987:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(1806);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1988:
      ACCEPT_TOKEN(aux_sym_identifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1988);
      END_STATE();
    case 1989:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(1989);
      END_STATE();
    case 1990:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 1991:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(1991);
      END_STATE();
    case 1992:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 1993:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')') ADVANCE(929);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 874, .external_lex_state = 2},
  [2] = {.lex_state = 874, .external_lex_state = 2},
  [3] = {.lex_state = 874, .external_lex_state = 2},
  [4] = {.lex_state = 28, .external_lex_state = 2},
  [5] = {.lex_state = 29, .external_lex_state = 2},
  [6] = {.lex_state = 29, .external_lex_state = 2},
  [7] = {.lex_state = 28, .external_lex_state = 2},
  [8] = {.lex_state = 30, .external_lex_state = 2},
  [9] = {.lex_state = 29, .external_lex_state = 2},
  [10] = {.lex_state = 28, .external_lex_state = 2},
  [11] = {.lex_state = 30, .external_lex_state = 2},
  [12] = {.lex_state = 31, .external_lex_state = 2},
  [13] = {.lex_state = 31, .external_lex_state = 2},
  [14] = {.lex_state = 30, .external_lex_state = 2},
  [15] = {.lex_state = 30, .external_lex_state = 2},
  [16] = {.lex_state = 28, .external_lex_state = 2},
  [17] = {.lex_state = 30, .external_lex_state = 2},
  [18] = {.lex_state = 31, .external_lex_state = 2},
  [19] = {.lex_state = 31, .external_lex_state = 2},
  [20] = {.lex_state = 28, .external_lex_state = 2},
  [21] = {.lex_state = 30, .external_lex_state = 2},
  [22] = {.lex_state = 28, .external_lex_state = 2},
  [23] = {.lex_state = 30, .external_lex_state = 2},
  [24] = {.lex_state = 31, .external_lex_state = 2},
  [25] = {.lex_state = 31, .external_lex_state = 2},
  [26] = {.lex_state = 28, .external_lex_state = 2},
  [27] = {.lex_state = 30, .external_lex_state = 2},
  [28] = {.lex_state = 28, .external_lex_state = 2},
  [29] = {.lex_state = 30, .external_lex_state = 2},
  [30] = {.lex_state = 31, .external_lex_state = 2},
  [31] = {.lex_state = 31, .external_lex_state = 2},
  [32] = {.lex_state = 28, .external_lex_state = 2},
  [33] = {.lex_state = 30, .external_lex_state = 2},
  [34] = {.lex_state = 28, .external_lex_state = 2},
  [35] = {.lex_state = 30, .external_lex_state = 2},
  [36] = {.lex_state = 31, .external_lex_state = 2},
  [37] = {.lex_state = 31, .external_lex_state = 2},
  [38] = {.lex_state = 30, .external_lex_state = 2},
  [39] = {.lex_state = 28, .external_lex_state = 2},
  [40] = {.lex_state = 30, .external_lex_state = 2},
  [41] = {.lex_state = 31, .external_lex_state = 2},
  [42] = {.lex_state = 31, .external_lex_state = 2},
  [43] = {.lex_state = 28, .external_lex_state = 2},
  [44] = {.lex_state = 30, .external_lex_state = 2},
  [45] = {.lex_state = 28, .external_lex_state = 2},
  [46] = {.lex_state = 30, .external_lex_state = 2},
  [47] = {.lex_state = 28, .external_lex_state = 2},
  [48] = {.lex_state = 30, .external_lex_state = 2},
  [49] = {.lex_state = 28, .external_lex_state = 2},
  [50] = {.lex_state = 28, .external_lex_state = 2},
  [51] = {.lex_state = 32, .external_lex_state = 2},
  [52] = {.lex_state = 32, .external_lex_state = 2},
  [53] = {.lex_state = 32, .external_lex_state = 2},
  [54] = {.lex_state = 32, .external_lex_state = 2},
  [55] = {.lex_state = 28, .external_lex_state = 2},
  [56] = {.lex_state = 31, .external_lex_state = 2},
  [57] = {.lex_state = 30, .external_lex_state = 2},
  [58] = {.lex_state = 29, .external_lex_state = 2},
  [59] = {.lex_state = 32, .external_lex_state = 2},
  [60] = {.lex_state = 33, .external_lex_state = 2},
  [61] = {.lex_state = 33, .external_lex_state = 2},
  [62] = {.lex_state = 33, .external_lex_state = 2},
  [63] = {.lex_state = 43, .external_lex_state = 2},
  [64] = {.lex_state = 43, .external_lex_state = 2},
  [65] = {.lex_state = 43, .external_lex_state = 2},
  [66] = {.lex_state = 43, .external_lex_state = 2},
  [67] = {.lex_state = 43, .external_lex_state = 2},
  [68] = {.lex_state = 43, .external_lex_state = 2},
  [69] = {.lex_state = 43, .external_lex_state = 2},
  [70] = {.lex_state = 43, .external_lex_state = 2},
  [71] = {.lex_state = 43, .external_lex_state = 2},
  [72] = {.lex_state = 43, .external_lex_state = 2},
  [73] = {.lex_state = 43, .external_lex_state = 2},
  [74] = {.lex_state = 43, .external_lex_state = 2},
  [75] = {.lex_state = 43, .external_lex_state = 2},
  [76] = {.lex_state = 43, .external_lex_state = 2},
  [77] = {.lex_state = 43, .external_lex_state = 2},
  [78] = {.lex_state = 43, .external_lex_state = 2},
  [79] = {.lex_state = 43, .external_lex_state = 2},
  [80] = {.lex_state = 33, .external_lex_state = 2},
  [81] = {.lex_state = 43, .external_lex_state = 2},
  [82] = {.lex_state = 43, .external_lex_state = 2},
  [83] = {.lex_state = 43, .external_lex_state = 2},
  [84] = {.lex_state = 43, .external_lex_state = 2},
  [85] = {.lex_state = 45, .external_lex_state = 2},
  [86] = {.lex_state = 46, .external_lex_state = 2},
  [87] = {.lex_state = 48, .external_lex_state = 2},
  [88] = {.lex_state = 35, .external_lex_state = 2},
  [89] = {.lex_state = 35, .external_lex_state = 2},
  [90] = {.lex_state = 48, .external_lex_state = 2},
  [91] = {.lex_state = 35, .external_lex_state = 2},
  [92] = {.lex_state = 35, .external_lex_state = 2},
  [93] = {.lex_state = 46, .external_lex_state = 2},
  [94] = {.lex_state = 47, .external_lex_state = 2},
  [95] = {.lex_state = 45, .external_lex_state = 2},
  [96] = {.lex_state = 47, .external_lex_state = 2},
  [97] = {.lex_state = 45, .external_lex_state = 2},
  [98] = {.lex_state = 47, .external_lex_state = 2},
  [99] = {.lex_state = 45, .external_lex_state = 2},
  [100] = {.lex_state = 48, .external_lex_state = 2},
  [101] = {.lex_state = 48, .external_lex_state = 2},
  [102] = {.lex_state = 47, .external_lex_state = 2},
  [103] = {.lex_state = 45, .external_lex_state = 2},
  [104] = {.lex_state = 47, .external_lex_state = 2},
  [105] = {.lex_state = 45, .external_lex_state = 2},
  [106] = {.lex_state = 35, .external_lex_state = 2},
  [107] = {.lex_state = 48, .external_lex_state = 2},
  [108] = {.lex_state = 48, .external_lex_state = 2},
  [109] = {.lex_state = 35, .external_lex_state = 2},
  [110] = {.lex_state = 47, .external_lex_state = 2},
  [111] = {.lex_state = 45, .external_lex_state = 2},
  [112] = {.lex_state = 47, .external_lex_state = 2},
  [113] = {.lex_state = 45, .external_lex_state = 2},
  [114] = {.lex_state = 48, .external_lex_state = 2},
  [115] = {.lex_state = 48, .external_lex_state = 2},
  [116] = {.lex_state = 47, .external_lex_state = 2},
  [117] = {.lex_state = 45, .external_lex_state = 2},
  [118] = {.lex_state = 47, .external_lex_state = 2},
  [119] = {.lex_state = 45, .external_lex_state = 2},
  [120] = {.lex_state = 48, .external_lex_state = 2},
  [121] = {.lex_state = 48, .external_lex_state = 2},
  [122] = {.lex_state = 47, .external_lex_state = 2},
  [123] = {.lex_state = 47, .external_lex_state = 2},
  [124] = {.lex_state = 47, .external_lex_state = 2},
  [125] = {.lex_state = 45, .external_lex_state = 2},
  [126] = {.lex_state = 45, .external_lex_state = 2},
  [127] = {.lex_state = 48, .external_lex_state = 2},
  [128] = {.lex_state = 48, .external_lex_state = 2},
  [129] = {.lex_state = 47, .external_lex_state = 2},
  [130] = {.lex_state = 45, .external_lex_state = 2},
  [131] = {.lex_state = 47, .external_lex_state = 2},
  [132] = {.lex_state = 45, .external_lex_state = 2},
  [133] = {.lex_state = 47, .external_lex_state = 2},
  [134] = {.lex_state = 45, .external_lex_state = 2},
  [135] = {.lex_state = 47, .external_lex_state = 2},
  [136] = {.lex_state = 45, .external_lex_state = 2},
  [137] = {.lex_state = 46, .external_lex_state = 2},
  [138] = {.lex_state = 33, .external_lex_state = 2},
  [139] = {.lex_state = 33, .external_lex_state = 2},
  [140] = {.lex_state = 33, .external_lex_state = 2},
  [141] = {.lex_state = 33, .external_lex_state = 2},
  [142] = {.lex_state = 33, .external_lex_state = 2},
  [143] = {.lex_state = 33, .external_lex_state = 2},
  [144] = {.lex_state = 33, .external_lex_state = 2},
  [145] = {.lex_state = 33, .external_lex_state = 2},
  [146] = {.lex_state = 33, .external_lex_state = 2},
  [147] = {.lex_state = 33, .external_lex_state = 2},
  [148] = {.lex_state = 33, .external_lex_state = 2},
  [149] = {.lex_state = 33, .external_lex_state = 2},
  [150] = {.lex_state = 33, .external_lex_state = 2},
  [151] = {.lex_state = 34, .external_lex_state = 2},
  [152] = {.lex_state = 36, .external_lex_state = 2},
  [153] = {.lex_state = 44, .external_lex_state = 2},
  [154] = {.lex_state = 37, .external_lex_state = 2},
  [155] = {.lex_state = 34, .external_lex_state = 2},
  [156] = {.lex_state = 47, .external_lex_state = 2},
  [157] = {.lex_state = 45, .external_lex_state = 2},
  [158] = {.lex_state = 44, .external_lex_state = 2},
  [159] = {.lex_state = 48, .external_lex_state = 2},
  [160] = {.lex_state = 44, .external_lex_state = 2},
  [161] = {.lex_state = 34, .external_lex_state = 2},
  [162] = {.lex_state = 36, .external_lex_state = 2},
  [163] = {.lex_state = 44, .external_lex_state = 2},
  [164] = {.lex_state = 46, .external_lex_state = 2},
  [165] = {.lex_state = 38, .external_lex_state = 2},
  [166] = {.lex_state = 44, .external_lex_state = 2},
  [167] = {.lex_state = 38, .external_lex_state = 2},
  [168] = {.lex_state = 38, .external_lex_state = 2},
  [169] = {.lex_state = 39, .external_lex_state = 2},
  [170] = {.lex_state = 36, .external_lex_state = 2},
  [171] = {.lex_state = 36, .external_lex_state = 2},
  [172] = {.lex_state = 39, .external_lex_state = 2},
  [173] = {.lex_state = 39, .external_lex_state = 2},
  [174] = {.lex_state = 37, .external_lex_state = 2},
  [175] = {.lex_state = 39, .external_lex_state = 2},
  [176] = {.lex_state = 39, .external_lex_state = 2},
  [177] = {.lex_state = 34, .external_lex_state = 2},
  [178] = {.lex_state = 44, .external_lex_state = 2},
  [179] = {.lex_state = 44, .external_lex_state = 2},
  [180] = {.lex_state = 34, .external_lex_state = 2},
  [181] = {.lex_state = 34, .external_lex_state = 2},
  [182] = {.lex_state = 36, .external_lex_state = 2},
  [183] = {.lex_state = 37, .external_lex_state = 2},
  [184] = {.lex_state = 36, .external_lex_state = 2},
  [185] = {.lex_state = 34, .external_lex_state = 2},
  [186] = {.lex_state = 44, .external_lex_state = 2},
  [187] = {.lex_state = 44, .external_lex_state = 2},
  [188] = {.lex_state = 39, .external_lex_state = 2},
  [189] = {.lex_state = 34, .external_lex_state = 2},
  [190] = {.lex_state = 38, .external_lex_state = 2},
  [191] = {.lex_state = 39, .external_lex_state = 2},
  [192] = {.lex_state = 34, .external_lex_state = 2},
  [193] = {.lex_state = 39, .external_lex_state = 2},
  [194] = {.lex_state = 35, .external_lex_state = 2},
  [195] = {.lex_state = 35, .external_lex_state = 2},
  [196] = {.lex_state = 40, .external_lex_state = 2},
  [197] = {.lex_state = 38, .external_lex_state = 2},
  [198] = {.lex_state = 35, .external_lex_state = 2},
  [199] = {.lex_state = 35, .external_lex_state = 2},
  [200] = {.lex_state = 39, .external_lex_state = 2},
  [201] = {.lex_state = 35, .external_lex_state = 2},
  [202] = {.lex_state = 36, .external_lex_state = 2},
  [203] = {.lex_state = 35, .external_lex_state = 2},
  [204] = {.lex_state = 35, .external_lex_state = 2},
  [205] = {.lex_state = 35, .external_lex_state = 2},
  [206] = {.lex_state = 37, .external_lex_state = 2},
  [207] = {.lex_state = 35, .external_lex_state = 2},
  [208] = {.lex_state = 41, .external_lex_state = 2},
  [209] = {.lex_state = 41, .external_lex_state = 2},
  [210] = {.lex_state = 41, .external_lex_state = 2},
  [211] = {.lex_state = 39, .external_lex_state = 2},
  [212] = {.lex_state = 41, .external_lex_state = 2},
  [213] = {.lex_state = 38, .external_lex_state = 2},
  [214] = {.lex_state = 38, .external_lex_state = 2},
  [215] = {.lex_state = 39, .external_lex_state = 2},
  [216] = {.lex_state = 38, .external_lex_state = 2},
  [217] = {.lex_state = 39, .external_lex_state = 2},
  [218] = {.lex_state = 39, .external_lex_state = 2},
  [219] = {.lex_state = 39, .external_lex_state = 2},
  [220] = {.lex_state = 41, .external_lex_state = 2},
  [221] = {.lex_state = 41, .external_lex_state = 2},
  [222] = {.lex_state = 41, .external_lex_state = 1},
  [223] = {.lex_state = 41, .external_lex_state = 1},
  [224] = {.lex_state = 41, .external_lex_state = 2},
  [225] = {.lex_state = 41, .external_lex_state = 2},
  [226] = {.lex_state = 41, .external_lex_state = 2},
  [227] = {.lex_state = 42, .external_lex_state = 2},
  [228] = {.lex_state = 42, .external_lex_state = 2},
  [229] = {.lex_state = 42, .external_lex_state = 2},
  [230] = {.lex_state = 42, .external_lex_state = 2},
  [231] = {.lex_state = 42, .external_lex_state = 2},
  [232] = {.lex_state = 41, .external_lex_state = 2},
  [233] = {.lex_state = 874, .external_lex_state = 2},
  [234] = {.lex_state = 874, .external_lex_state = 2},
  [235] = {.lex_state = 874, .external_lex_state = 2},
  [236] = {.lex_state = 874, .external_lex_state = 2},
  [237] = {.lex_state = 874, .external_lex_state = 2},
  [238] = {.lex_state = 874, .external_lex_state = 2},
  [239] = {.lex_state = 874, .external_lex_state = 2},
  [240] = {.lex_state = 874, .external_lex_state = 2},
  [241] = {.lex_state = 874, .external_lex_state = 2},
  [242] = {.lex_state = 874, .external_lex_state = 2},
  [243] = {.lex_state = 874, .external_lex_state = 2},
  [244] = {.lex_state = 41, .external_lex_state = 2},
  [245] = {.lex_state = 874, .external_lex_state = 2},
  [246] = {.lex_state = 874, .external_lex_state = 2},
  [247] = {.lex_state = 874, .external_lex_state = 2},
  [248] = {.lex_state = 874, .external_lex_state = 2},
  [249] = {.lex_state = 874, .external_lex_state = 2},
  [250] = {.lex_state = 874, .external_lex_state = 2},
  [251] = {.lex_state = 874, .external_lex_state = 2},
  [252] = {.lex_state = 874, .external_lex_state = 2},
  [253] = {.lex_state = 874, .external_lex_state = 2},
  [254] = {.lex_state = 874, .external_lex_state = 2},
  [255] = {.lex_state = 874, .external_lex_state = 2},
  [256] = {.lex_state = 874, .external_lex_state = 2},
  [257] = {.lex_state = 874, .external_lex_state = 2},
  [258] = {.lex_state = 874, .external_lex_state = 2},
  [259] = {.lex_state = 874, .external_lex_state = 2},
  [260] = {.lex_state = 41, .external_lex_state = 2},
  [261] = {.lex_state = 874, .external_lex_state = 2},
  [262] = {.lex_state = 874, .external_lex_state = 2},
  [263] = {.lex_state = 874, .external_lex_state = 2},
  [264] = {.lex_state = 874, .external_lex_state = 2},
  [265] = {.lex_state = 874, .external_lex_state = 2},
  [266] = {.lex_state = 41, .external_lex_state = 2},
  [267] = {.lex_state = 874, .external_lex_state = 2},
  [268] = {.lex_state = 874, .external_lex_state = 2},
  [269] = {.lex_state = 874, .external_lex_state = 2},
  [270] = {.lex_state = 874, .external_lex_state = 2},
  [271] = {.lex_state = 874, .external_lex_state = 2},
  [272] = {.lex_state = 874, .external_lex_state = 2},
  [273] = {.lex_state = 874, .external_lex_state = 2},
  [274] = {.lex_state = 874, .external_lex_state = 2},
  [275] = {.lex_state = 874, .external_lex_state = 2},
  [276] = {.lex_state = 874, .external_lex_state = 2},
  [277] = {.lex_state = 874, .external_lex_state = 2},
  [278] = {.lex_state = 874, .external_lex_state = 2},
  [279] = {.lex_state = 874, .external_lex_state = 2},
  [280] = {.lex_state = 41, .external_lex_state = 2},
  [281] = {.lex_state = 874, .external_lex_state = 2},
  [282] = {.lex_state = 41, .external_lex_state = 2},
  [283] = {.lex_state = 874, .external_lex_state = 2},
  [284] = {.lex_state = 41, .external_lex_state = 2},
  [285] = {.lex_state = 874, .external_lex_state = 2},
  [286] = {.lex_state = 41, .external_lex_state = 2},
  [287] = {.lex_state = 41, .external_lex_state = 2},
  [288] = {.lex_state = 874, .external_lex_state = 2},
  [289] = {.lex_state = 41, .external_lex_state = 2},
  [290] = {.lex_state = 41, .external_lex_state = 2},
  [291] = {.lex_state = 41, .external_lex_state = 2},
  [292] = {.lex_state = 41, .external_lex_state = 2},
  [293] = {.lex_state = 41, .external_lex_state = 2},
  [294] = {.lex_state = 874, .external_lex_state = 2},
  [295] = {.lex_state = 28, .external_lex_state = 2},
  [296] = {.lex_state = 29, .external_lex_state = 2},
  [297] = {.lex_state = 28, .external_lex_state = 2},
  [298] = {.lex_state = 28, .external_lex_state = 2},
  [299] = {.lex_state = 28, .external_lex_state = 2},
  [300] = {.lex_state = 29, .external_lex_state = 2},
  [301] = {.lex_state = 28, .external_lex_state = 2},
  [302] = {.lex_state = 28, .external_lex_state = 2},
  [303] = {.lex_state = 28, .external_lex_state = 2},
  [304] = {.lex_state = 28, .external_lex_state = 2},
  [305] = {.lex_state = 28, .external_lex_state = 2},
  [306] = {.lex_state = 28, .external_lex_state = 2},
  [307] = {.lex_state = 28, .external_lex_state = 2},
  [308] = {.lex_state = 28, .external_lex_state = 2},
  [309] = {.lex_state = 28, .external_lex_state = 2},
  [310] = {.lex_state = 28, .external_lex_state = 2},
  [311] = {.lex_state = 28, .external_lex_state = 2},
  [312] = {.lex_state = 28, .external_lex_state = 2},
  [313] = {.lex_state = 28, .external_lex_state = 2},
  [314] = {.lex_state = 30, .external_lex_state = 2},
  [315] = {.lex_state = 30, .external_lex_state = 2},
  [316] = {.lex_state = 28, .external_lex_state = 2},
  [317] = {.lex_state = 30, .external_lex_state = 2},
  [318] = {.lex_state = 30, .external_lex_state = 2},
  [319] = {.lex_state = 29, .external_lex_state = 2},
  [320] = {.lex_state = 28, .external_lex_state = 2},
  [321] = {.lex_state = 28, .external_lex_state = 2},
  [322] = {.lex_state = 30, .external_lex_state = 2},
  [323] = {.lex_state = 30, .external_lex_state = 2},
  [324] = {.lex_state = 30, .external_lex_state = 2},
  [325] = {.lex_state = 30, .external_lex_state = 2},
  [326] = {.lex_state = 28, .external_lex_state = 2},
  [327] = {.lex_state = 28, .external_lex_state = 2},
  [328] = {.lex_state = 30, .external_lex_state = 2},
  [329] = {.lex_state = 30, .external_lex_state = 2},
  [330] = {.lex_state = 30, .external_lex_state = 2},
  [331] = {.lex_state = 30, .external_lex_state = 2},
  [332] = {.lex_state = 28, .external_lex_state = 2},
  [333] = {.lex_state = 30, .external_lex_state = 2},
  [334] = {.lex_state = 30, .external_lex_state = 2},
  [335] = {.lex_state = 30, .external_lex_state = 2},
  [336] = {.lex_state = 30, .external_lex_state = 2},
  [337] = {.lex_state = 30, .external_lex_state = 2},
  [338] = {.lex_state = 31, .external_lex_state = 2},
  [339] = {.lex_state = 31, .external_lex_state = 2},
  [340] = {.lex_state = 30, .external_lex_state = 2},
  [341] = {.lex_state = 31, .external_lex_state = 2},
  [342] = {.lex_state = 31, .external_lex_state = 2},
  [343] = {.lex_state = 30, .external_lex_state = 2},
  [344] = {.lex_state = 30, .external_lex_state = 2},
  [345] = {.lex_state = 31, .external_lex_state = 2},
  [346] = {.lex_state = 31, .external_lex_state = 2},
  [347] = {.lex_state = 31, .external_lex_state = 2},
  [348] = {.lex_state = 30, .external_lex_state = 2},
  [349] = {.lex_state = 30, .external_lex_state = 2},
  [350] = {.lex_state = 31, .external_lex_state = 2},
  [351] = {.lex_state = 31, .external_lex_state = 2},
  [352] = {.lex_state = 31, .external_lex_state = 2},
  [353] = {.lex_state = 31, .external_lex_state = 2},
  [354] = {.lex_state = 30, .external_lex_state = 2},
  [355] = {.lex_state = 31, .external_lex_state = 2},
  [356] = {.lex_state = 31, .external_lex_state = 2},
  [357] = {.lex_state = 31, .external_lex_state = 2},
  [358] = {.lex_state = 31, .external_lex_state = 2},
  [359] = {.lex_state = 31, .external_lex_state = 2},
  [360] = {.lex_state = 31, .external_lex_state = 2},
  [361] = {.lex_state = 31, .external_lex_state = 2},
  [362] = {.lex_state = 31, .external_lex_state = 2},
  [363] = {.lex_state = 31, .external_lex_state = 2},
  [364] = {.lex_state = 31, .external_lex_state = 2},
  [365] = {.lex_state = 31, .external_lex_state = 2},
  [366] = {.lex_state = 29, .external_lex_state = 2},
  [367] = {.lex_state = 29, .external_lex_state = 2},
  [368] = {.lex_state = 29, .external_lex_state = 2},
  [369] = {.lex_state = 29, .external_lex_state = 2},
  [370] = {.lex_state = 29, .external_lex_state = 2},
  [371] = {.lex_state = 29, .external_lex_state = 2},
  [372] = {.lex_state = 29, .external_lex_state = 2},
  [373] = {.lex_state = 29, .external_lex_state = 2},
  [374] = {.lex_state = 29, .external_lex_state = 2},
  [375] = {.lex_state = 29, .external_lex_state = 2},
  [376] = {.lex_state = 29, .external_lex_state = 2},
  [377] = {.lex_state = 29, .external_lex_state = 2},
  [378] = {.lex_state = 29, .external_lex_state = 2},
  [379] = {.lex_state = 29, .external_lex_state = 2},
  [380] = {.lex_state = 29, .external_lex_state = 2},
  [381] = {.lex_state = 29, .external_lex_state = 2},
  [382] = {.lex_state = 29, .external_lex_state = 2},
  [383] = {.lex_state = 29, .external_lex_state = 2},
  [384] = {.lex_state = 29, .external_lex_state = 2},
  [385] = {.lex_state = 29, .external_lex_state = 2},
  [386] = {.lex_state = 29, .external_lex_state = 2},
  [387] = {.lex_state = 29, .external_lex_state = 2},
  [388] = {.lex_state = 29, .external_lex_state = 2},
  [389] = {.lex_state = 29, .external_lex_state = 2},
  [390] = {.lex_state = 29, .external_lex_state = 2},
  [391] = {.lex_state = 29, .external_lex_state = 2},
  [392] = {.lex_state = 31, .external_lex_state = 2},
  [393] = {.lex_state = 32, .external_lex_state = 2},
  [394] = {.lex_state = 32, .external_lex_state = 2},
  [395] = {.lex_state = 32, .external_lex_state = 2},
  [396] = {.lex_state = 32, .external_lex_state = 2},
  [397] = {.lex_state = 32, .external_lex_state = 2},
  [398] = {.lex_state = 32, .external_lex_state = 2},
  [399] = {.lex_state = 32, .external_lex_state = 2},
  [400] = {.lex_state = 32, .external_lex_state = 2},
  [401] = {.lex_state = 32, .external_lex_state = 2},
  [402] = {.lex_state = 32, .external_lex_state = 2},
  [403] = {.lex_state = 32, .external_lex_state = 2},
  [404] = {.lex_state = 32, .external_lex_state = 2},
  [405] = {.lex_state = 32, .external_lex_state = 2},
  [406] = {.lex_state = 32, .external_lex_state = 2},
  [407] = {.lex_state = 32, .external_lex_state = 2},
  [408] = {.lex_state = 32, .external_lex_state = 2},
  [409] = {.lex_state = 32, .external_lex_state = 2},
  [410] = {.lex_state = 32, .external_lex_state = 2},
  [411] = {.lex_state = 32, .external_lex_state = 2},
  [412] = {.lex_state = 32, .external_lex_state = 2},
  [413] = {.lex_state = 32, .external_lex_state = 2},
  [414] = {.lex_state = 32, .external_lex_state = 2},
  [415] = {.lex_state = 32, .external_lex_state = 2},
  [416] = {.lex_state = 10, .external_lex_state = 3},
  [417] = {.lex_state = 14, .external_lex_state = 3},
  [418] = {.lex_state = 14, .external_lex_state = 3},
  [419] = {.lex_state = 10, .external_lex_state = 3},
  [420] = {.lex_state = 3, .external_lex_state = 1},
  [421] = {.lex_state = 25, .external_lex_state = 2},
  [422] = {.lex_state = 10, .external_lex_state = 3},
  [423] = {.lex_state = 3, .external_lex_state = 2},
  [424] = {.lex_state = 14, .external_lex_state = 3},
  [425] = {.lex_state = 2, .external_lex_state = 2},
  [426] = {.lex_state = 6, .external_lex_state = 2},
  [427] = {.lex_state = 2, .external_lex_state = 1},
  [428] = {.lex_state = 9, .external_lex_state = 2},
  [429] = {.lex_state = 7, .external_lex_state = 2},
  [430] = {.lex_state = 2, .external_lex_state = 2},
  [431] = {.lex_state = 8, .external_lex_state = 2},
  [432] = {.lex_state = 4, .external_lex_state = 2},
  [433] = {.lex_state = 27, .external_lex_state = 2},
  [434] = {.lex_state = 24, .external_lex_state = 2},
  [435] = {.lex_state = 49, .external_lex_state = 2},
  [436] = {.lex_state = 49, .external_lex_state = 2},
  [437] = {.lex_state = 49, .external_lex_state = 2},
  [438] = {.lex_state = 49, .external_lex_state = 2},
  [439] = {.lex_state = 25, .external_lex_state = 1},
  [440] = {.lex_state = 25, .external_lex_state = 2},
  [441] = {.lex_state = 25, .external_lex_state = 1},
  [442] = {.lex_state = 25, .external_lex_state = 1},
  [443] = {.lex_state = 21, .external_lex_state = 2},
  [444] = {.lex_state = 26, .external_lex_state = 2},
  [445] = {.lex_state = 21, .external_lex_state = 2},
  [446] = {.lex_state = 25, .external_lex_state = 2},
  [447] = {.lex_state = 25, .external_lex_state = 2},
  [448] = {.lex_state = 25, .external_lex_state = 2},
  [449] = {.lex_state = 25, .external_lex_state = 2},
  [450] = {.lex_state = 25, .external_lex_state = 2},
  [451] = {.lex_state = 25, .external_lex_state = 2},
  [452] = {.lex_state = 11, .external_lex_state = 4},
  [453] = {.lex_state = 11, .external_lex_state = 4},
  [454] = {.lex_state = 43, .external_lex_state = 2},
  [455] = {.lex_state = 43, .external_lex_state = 2},
  [456] = {.lex_state = 25, .external_lex_state = 2},
  [457] = {.lex_state = 25, .external_lex_state = 2},
  [458] = {.lex_state = 25, .external_lex_state = 2},
  [459] = {.lex_state = 25, .external_lex_state = 2},
  [460] = {.lex_state = 25, .external_lex_state = 2},
  [461] = {.lex_state = 25, .external_lex_state = 2},
  [462] = {.lex_state = 5, .external_lex_state = 2},
  [463] = {.lex_state = 11, .external_lex_state = 4},
  [464] = {.lex_state = 25, .external_lex_state = 2},
  [465] = {.lex_state = 11, .external_lex_state = 4},
  [466] = {.lex_state = 22, .external_lex_state = 2},
  [467] = {.lex_state = 22, .external_lex_state = 2},
  [468] = {.lex_state = 22, .external_lex_state = 2},
  [469] = {.lex_state = 22, .external_lex_state = 2},
  [470] = {.lex_state = 22, .external_lex_state = 2},
  [471] = {.lex_state = 22, .external_lex_state = 2},
  [472] = {.lex_state = 22, .external_lex_state = 2},
  [473] = {.lex_state = 22, .external_lex_state = 2},
  [474] = {.lex_state = 22, .external_lex_state = 2},
  [475] = {.lex_state = 23, .external_lex_state = 2},
  [476] = {.lex_state = 23, .external_lex_state = 2},
  [477] = {.lex_state = 23, .external_lex_state = 2},
  [478] = {.lex_state = 22, .external_lex_state = 2},
  [479] = {.lex_state = 20, .external_lex_state = 2},
  [480] = {.lex_state = 33, .external_lex_state = 2},
  [481] = {.lex_state = 33, .external_lex_state = 2},
  [482] = {.lex_state = 20, .external_lex_state = 2},
  [483] = {.lex_state = 23, .external_lex_state = 2},
  [484] = {.lex_state = 23, .external_lex_state = 2},
  [485] = {.lex_state = 45, .external_lex_state = 2},
  [486] = {.lex_state = 48, .external_lex_state = 2},
  [487] = {.lex_state = 47, .external_lex_state = 2},
  [488] = {.lex_state = 23, .external_lex_state = 2},
  [489] = {.lex_state = 45, .external_lex_state = 2},
  [490] = {.lex_state = 46, .external_lex_state = 2},
  [491] = {.lex_state = 48, .external_lex_state = 2},
  [492] = {.lex_state = 23, .external_lex_state = 2},
  [493] = {.lex_state = 47, .external_lex_state = 2},
  [494] = {.lex_state = 23, .external_lex_state = 2},
  [495] = {.lex_state = 46, .external_lex_state = 2},
  [496] = {.lex_state = 20, .external_lex_state = 2},
  [497] = {.lex_state = 44, .external_lex_state = 2},
  [498] = {.lex_state = 23, .external_lex_state = 2},
  [499] = {.lex_state = 34, .external_lex_state = 2},
  [500] = {.lex_state = 34, .external_lex_state = 2},
  [501] = {.lex_state = 44, .external_lex_state = 2},
  [502] = {.lex_state = 23, .external_lex_state = 2},
  [503] = {.lex_state = 23, .external_lex_state = 1},
  [504] = {.lex_state = 23, .external_lex_state = 2},
  [505] = {.lex_state = 36, .external_lex_state = 2},
  [506] = {.lex_state = 41, .external_lex_state = 1},
  [507] = {.lex_state = 36, .external_lex_state = 2},
  [508] = {.lex_state = 39, .external_lex_state = 2},
  [509] = {.lex_state = 38, .external_lex_state = 2},
  [510] = {.lex_state = 23, .external_lex_state = 2},
  [511] = {.lex_state = 35, .external_lex_state = 2},
  [512] = {.lex_state = 23, .external_lex_state = 2},
  [513] = {.lex_state = 41, .external_lex_state = 1},
  [514] = {.lex_state = 13, .external_lex_state = 4},
  [515] = {.lex_state = 39, .external_lex_state = 2},
  [516] = {.lex_state = 41, .external_lex_state = 1},
  [517] = {.lex_state = 23, .external_lex_state = 2},
  [518] = {.lex_state = 20, .external_lex_state = 2},
  [519] = {.lex_state = 41, .external_lex_state = 1},
  [520] = {.lex_state = 24, .external_lex_state = 2},
  [521] = {.lex_state = 37, .external_lex_state = 2},
  [522] = {.lex_state = 35, .external_lex_state = 2},
  [523] = {.lex_state = 20, .external_lex_state = 2},
  [524] = {.lex_state = 40, .external_lex_state = 2},
  [525] = {.lex_state = 37, .external_lex_state = 2},
  [526] = {.lex_state = 13, .external_lex_state = 4},
  [527] = {.lex_state = 13, .external_lex_state = 4},
  [528] = {.lex_state = 41, .external_lex_state = 1},
  [529] = {.lex_state = 38, .external_lex_state = 2},
  [530] = {.lex_state = 17, .external_lex_state = 5},
  [531] = {.lex_state = 16, .external_lex_state = 5},
  [532] = {.lex_state = 23, .external_lex_state = 1},
  [533] = {.lex_state = 23, .external_lex_state = 1},
  [534] = {.lex_state = 23, .external_lex_state = 2},
  [535] = {.lex_state = 18, .external_lex_state = 5},
  [536] = {.lex_state = 19, .external_lex_state = 5},
  [537] = {.lex_state = 16, .external_lex_state = 5},
  [538] = {.lex_state = 23, .external_lex_state = 2},
  [539] = {.lex_state = 23, .external_lex_state = 1},
  [540] = {.lex_state = 20, .external_lex_state = 2},
  [541] = {.lex_state = 41, .external_lex_state = 2},
  [542] = {.lex_state = 41, .external_lex_state = 2},
  [543] = {.lex_state = 19, .external_lex_state = 5},
  [544] = {.lex_state = 16, .external_lex_state = 5},
  [545] = {.lex_state = 18, .external_lex_state = 5},
  [546] = {.lex_state = 19, .external_lex_state = 5},
  [547] = {.lex_state = 16, .external_lex_state = 5},
  [548] = {.lex_state = 18, .external_lex_state = 5},
  [549] = {.lex_state = 23, .external_lex_state = 1},
  [550] = {.lex_state = 19, .external_lex_state = 5},
  [551] = {.lex_state = 16, .external_lex_state = 5},
  [552] = {.lex_state = 23, .external_lex_state = 1},
  [553] = {.lex_state = 18, .external_lex_state = 5},
  [554] = {.lex_state = 19, .external_lex_state = 5},
  [555] = {.lex_state = 16, .external_lex_state = 5},
  [556] = {.lex_state = 18, .external_lex_state = 5},
  [557] = {.lex_state = 19, .external_lex_state = 5},
  [558] = {.lex_state = 16, .external_lex_state = 5},
  [559] = {.lex_state = 18, .external_lex_state = 5},
  [560] = {.lex_state = 19, .external_lex_state = 5},
  [561] = {.lex_state = 16, .external_lex_state = 5},
  [562] = {.lex_state = 19, .external_lex_state = 5},
  [563] = {.lex_state = 23, .external_lex_state = 2},
  [564] = {.lex_state = 14, .external_lex_state = 3},
  [565] = {.lex_state = 14, .external_lex_state = 3},
  [566] = {.lex_state = 14, .external_lex_state = 3},
  [567] = {.lex_state = 14, .external_lex_state = 3},
  [568] = {.lex_state = 10, .external_lex_state = 3},
  [569] = {.lex_state = 14, .external_lex_state = 3},
  [570] = {.lex_state = 23, .external_lex_state = 2},
  [571] = {.lex_state = 23, .external_lex_state = 2},
  [572] = {.lex_state = 14, .external_lex_state = 3},
  [573] = {.lex_state = 14, .external_lex_state = 3},
  [574] = {.lex_state = 23, .external_lex_state = 2},
  [575] = {.lex_state = 15, .external_lex_state = 5},
  [576] = {.lex_state = 14, .external_lex_state = 3},
  [577] = {.lex_state = 14, .external_lex_state = 3},
  [578] = {.lex_state = 10, .external_lex_state = 3},
  [579] = {.lex_state = 55, .external_lex_state = 4},
  [580] = {.lex_state = 10, .external_lex_state = 3},
  [581] = {.lex_state = 23, .external_lex_state = 2},
  [582] = {.lex_state = 14, .external_lex_state = 3},
  [583] = {.lex_state = 23, .external_lex_state = 2},
  [584] = {.lex_state = 14, .external_lex_state = 3},
  [585] = {.lex_state = 14, .external_lex_state = 3},
  [586] = {.lex_state = 14, .external_lex_state = 3},
  [587] = {.lex_state = 14, .external_lex_state = 3},
  [588] = {.lex_state = 14, .external_lex_state = 3},
  [589] = {.lex_state = 23, .external_lex_state = 2},
  [590] = {.lex_state = 10, .external_lex_state = 3},
  [591] = {.lex_state = 23, .external_lex_state = 2},
  [592] = {.lex_state = 10, .external_lex_state = 3},
  [593] = {.lex_state = 10, .external_lex_state = 3},
  [594] = {.lex_state = 10, .external_lex_state = 3},
  [595] = {.lex_state = 23, .external_lex_state = 2},
  [596] = {.lex_state = 10, .external_lex_state = 3},
  [597] = {.lex_state = 10, .external_lex_state = 3},
  [598] = {.lex_state = 55, .external_lex_state = 4},
  [599] = {.lex_state = 10, .external_lex_state = 3},
  [600] = {.lex_state = 24, .external_lex_state = 2},
  [601] = {.lex_state = 14, .external_lex_state = 3},
  [602] = {.lex_state = 23, .external_lex_state = 2},
  [603] = {.lex_state = 14, .external_lex_state = 3},
  [604] = {.lex_state = 23, .external_lex_state = 2},
  [605] = {.lex_state = 23, .external_lex_state = 2},
  [606] = {.lex_state = 14, .external_lex_state = 3},
  [607] = {.lex_state = 10, .external_lex_state = 3},
  [608] = {.lex_state = 10, .external_lex_state = 3},
  [609] = {.lex_state = 10, .external_lex_state = 3},
  [610] = {.lex_state = 10, .external_lex_state = 3},
  [611] = {.lex_state = 23, .external_lex_state = 2},
  [612] = {.lex_state = 10, .external_lex_state = 3},
  [613] = {.lex_state = 23, .external_lex_state = 2},
  [614] = {.lex_state = 10, .external_lex_state = 3},
  [615] = {.lex_state = 24, .external_lex_state = 2},
  [616] = {.lex_state = 24, .external_lex_state = 2},
  [617] = {.lex_state = 14, .external_lex_state = 3},
  [618] = {.lex_state = 24, .external_lex_state = 2},
  [619] = {.lex_state = 14, .external_lex_state = 3},
  [620] = {.lex_state = 10, .external_lex_state = 3},
  [621] = {.lex_state = 10, .external_lex_state = 3},
  [622] = {.lex_state = 23, .external_lex_state = 2},
  [623] = {.lex_state = 23, .external_lex_state = 2},
  [624] = {.lex_state = 14, .external_lex_state = 3},
  [625] = {.lex_state = 14, .external_lex_state = 3},
  [626] = {.lex_state = 14, .external_lex_state = 3},
  [627] = {.lex_state = 14, .external_lex_state = 3},
  [628] = {.lex_state = 10, .external_lex_state = 3},
  [629] = {.lex_state = 10, .external_lex_state = 3},
  [630] = {.lex_state = 10, .external_lex_state = 3},
  [631] = {.lex_state = 10, .external_lex_state = 3},
  [632] = {.lex_state = 10, .external_lex_state = 3},
  [633] = {.lex_state = 14, .external_lex_state = 3},
  [634] = {.lex_state = 10, .external_lex_state = 3},
  [635] = {.lex_state = 14, .external_lex_state = 3},
  [636] = {.lex_state = 14, .external_lex_state = 3},
  [637] = {.lex_state = 14, .external_lex_state = 3},
  [638] = {.lex_state = 10, .external_lex_state = 3},
  [639] = {.lex_state = 14, .external_lex_state = 3},
  [640] = {.lex_state = 10, .external_lex_state = 3},
  [641] = {.lex_state = 10, .external_lex_state = 3},
  [642] = {.lex_state = 10, .external_lex_state = 3},
  [643] = {.lex_state = 23, .external_lex_state = 2},
  [644] = {.lex_state = 23, .external_lex_state = 2},
  [645] = {.lex_state = 23, .external_lex_state = 2},
  [646] = {.lex_state = 23, .external_lex_state = 2},
  [647] = {.lex_state = 10, .external_lex_state = 3},
  [648] = {.lex_state = 14, .external_lex_state = 3},
  [649] = {.lex_state = 23, .external_lex_state = 2},
  [650] = {.lex_state = 23, .external_lex_state = 2},
  [651] = {.lex_state = 23, .external_lex_state = 2},
  [652] = {.lex_state = 23, .external_lex_state = 2},
  [653] = {.lex_state = 23, .external_lex_state = 2},
  [654] = {.lex_state = 23, .external_lex_state = 2},
  [655] = {.lex_state = 23, .external_lex_state = 2},
  [656] = {.lex_state = 23, .external_lex_state = 2},
  [657] = {.lex_state = 24, .external_lex_state = 2},
  [658] = {.lex_state = 23, .external_lex_state = 2},
  [659] = {.lex_state = 24, .external_lex_state = 2},
  [660] = {.lex_state = 24, .external_lex_state = 2},
  [661] = {.lex_state = 23, .external_lex_state = 2},
  [662] = {.lex_state = 24, .external_lex_state = 2},
  [663] = {.lex_state = 23, .external_lex_state = 2},
  [664] = {.lex_state = 24, .external_lex_state = 2},
  [665] = {.lex_state = 23, .external_lex_state = 2},
  [666] = {.lex_state = 23, .external_lex_state = 2},
  [667] = {.lex_state = 23, .external_lex_state = 2},
  [668] = {.lex_state = 23, .external_lex_state = 2},
  [669] = {.lex_state = 23, .external_lex_state = 2},
  [670] = {.lex_state = 23, .external_lex_state = 2},
  [671] = {.lex_state = 23, .external_lex_state = 2},
  [672] = {.lex_state = 23, .external_lex_state = 2},
  [673] = {.lex_state = 23, .external_lex_state = 2},
  [674] = {.lex_state = 24, .external_lex_state = 2},
  [675] = {.lex_state = 23, .external_lex_state = 2},
  [676] = {.lex_state = 23, .external_lex_state = 2},
  [677] = {.lex_state = 23, .external_lex_state = 2},
  [678] = {.lex_state = 23, .external_lex_state = 2},
  [679] = {.lex_state = 23, .external_lex_state = 2},
  [680] = {.lex_state = 23, .external_lex_state = 2},
  [681] = {.lex_state = 23, .external_lex_state = 2},
  [682] = {.lex_state = 23, .external_lex_state = 2},
  [683] = {.lex_state = 23, .external_lex_state = 2},
  [684] = {.lex_state = 23, .external_lex_state = 2},
  [685] = {.lex_state = 23, .external_lex_state = 2},
  [686] = {.lex_state = 23, .external_lex_state = 2},
  [687] = {.lex_state = 23, .external_lex_state = 2},
  [688] = {.lex_state = 23, .external_lex_state = 2},
  [689] = {.lex_state = 23, .external_lex_state = 2},
  [690] = {.lex_state = 23, .external_lex_state = 2},
  [691] = {.lex_state = 23, .external_lex_state = 2},
  [692] = {.lex_state = 23, .external_lex_state = 2},
  [693] = {.lex_state = 23, .external_lex_state = 2},
  [694] = {.lex_state = 23, .external_lex_state = 2},
  [695] = {.lex_state = 23, .external_lex_state = 2},
  [696] = {.lex_state = 23, .external_lex_state = 2},
  [697] = {.lex_state = 23, .external_lex_state = 2},
  [698] = {.lex_state = 23, .external_lex_state = 2},
  [699] = {.lex_state = 23, .external_lex_state = 2},
  [700] = {.lex_state = 23, .external_lex_state = 2},
  [701] = {.lex_state = 23, .external_lex_state = 2},
  [702] = {.lex_state = 23, .external_lex_state = 2},
  [703] = {.lex_state = 23, .external_lex_state = 2},
  [704] = {.lex_state = 15, .external_lex_state = 5},
  [705] = {.lex_state = 23, .external_lex_state = 2},
  [706] = {.lex_state = 23, .external_lex_state = 2},
  [707] = {.lex_state = 23, .external_lex_state = 2},
  [708] = {.lex_state = 24, .external_lex_state = 2},
  [709] = {.lex_state = 23, .external_lex_state = 2},
  [710] = {.lex_state = 23, .external_lex_state = 2},
  [711] = {.lex_state = 23, .external_lex_state = 2},
  [712] = {.lex_state = 23, .external_lex_state = 2},
  [713] = {.lex_state = 23, .external_lex_state = 2},
  [714] = {.lex_state = 23, .external_lex_state = 2},
  [715] = {.lex_state = 23, .external_lex_state = 2},
  [716] = {.lex_state = 23, .external_lex_state = 2},
  [717] = {.lex_state = 23, .external_lex_state = 2},
  [718] = {.lex_state = 23, .external_lex_state = 2},
  [719] = {.lex_state = 23, .external_lex_state = 2},
  [720] = {.lex_state = 23, .external_lex_state = 2},
  [721] = {.lex_state = 23, .external_lex_state = 2},
  [722] = {.lex_state = 23, .external_lex_state = 2},
  [723] = {.lex_state = 23, .external_lex_state = 2},
  [724] = {.lex_state = 23, .external_lex_state = 2},
  [725] = {.lex_state = 24, .external_lex_state = 2},
  [726] = {.lex_state = 23, .external_lex_state = 2},
  [727] = {.lex_state = 23, .external_lex_state = 2},
  [728] = {.lex_state = 23, .external_lex_state = 2},
  [729] = {.lex_state = 23, .external_lex_state = 2},
  [730] = {.lex_state = 23, .external_lex_state = 2},
  [731] = {.lex_state = 23, .external_lex_state = 2},
  [732] = {.lex_state = 23, .external_lex_state = 2},
  [733] = {.lex_state = 23, .external_lex_state = 2},
  [734] = {.lex_state = 23, .external_lex_state = 2},
  [735] = {.lex_state = 24, .external_lex_state = 2},
  [736] = {.lex_state = 24, .external_lex_state = 2},
  [737] = {.lex_state = 23, .external_lex_state = 2},
  [738] = {.lex_state = 23, .external_lex_state = 2},
  [739] = {.lex_state = 23, .external_lex_state = 2},
  [740] = {.lex_state = 23, .external_lex_state = 2},
  [741] = {.lex_state = 24, .external_lex_state = 2},
  [742] = {.lex_state = 23, .external_lex_state = 2},
  [743] = {.lex_state = 23, .external_lex_state = 2},
  [744] = {.lex_state = 23, .external_lex_state = 2},
  [745] = {.lex_state = 23, .external_lex_state = 2},
  [746] = {.lex_state = 23, .external_lex_state = 2},
  [747] = {.lex_state = 23, .external_lex_state = 2},
  [748] = {.lex_state = 23, .external_lex_state = 2},
  [749] = {.lex_state = 23, .external_lex_state = 2},
  [750] = {.lex_state = 23, .external_lex_state = 2},
  [751] = {.lex_state = 23, .external_lex_state = 2},
  [752] = {.lex_state = 24, .external_lex_state = 2},
  [753] = {.lex_state = 15, .external_lex_state = 5},
  [754] = {.lex_state = 56, .external_lex_state = 4},
  [755] = {.lex_state = 11, .external_lex_state = 4},
  [756] = {.lex_state = 11, .external_lex_state = 4},
  [757] = {.lex_state = 11, .external_lex_state = 4},
  [758] = {.lex_state = 11, .external_lex_state = 4},
  [759] = {.lex_state = 11, .external_lex_state = 4},
  [760] = {.lex_state = 11, .external_lex_state = 4},
  [761] = {.lex_state = 11, .external_lex_state = 4},
  [762] = {.lex_state = 11, .external_lex_state = 4},
  [763] = {.lex_state = 11, .external_lex_state = 4},
  [764] = {.lex_state = 11, .external_lex_state = 4},
  [765] = {.lex_state = 11, .external_lex_state = 4},
  [766] = {.lex_state = 11, .external_lex_state = 4},
  [767] = {.lex_state = 11, .external_lex_state = 4},
  [768] = {.lex_state = 11, .external_lex_state = 4},
  [769] = {.lex_state = 11, .external_lex_state = 4},
  [770] = {.lex_state = 11, .external_lex_state = 4},
  [771] = {.lex_state = 11, .external_lex_state = 4},
  [772] = {.lex_state = 4, .external_lex_state = 4},
  [773] = {.lex_state = 23, .external_lex_state = 2},
  [774] = {.lex_state = 23, .external_lex_state = 2},
  [775] = {.lex_state = 23, .external_lex_state = 2},
  [776] = {.lex_state = 23, .external_lex_state = 2},
  [777] = {.lex_state = 13, .external_lex_state = 4},
  [778] = {.lex_state = 23, .external_lex_state = 2},
  [779] = {.lex_state = 23, .external_lex_state = 2},
  [780] = {.lex_state = 23, .external_lex_state = 2},
  [781] = {.lex_state = 23, .external_lex_state = 2},
  [782] = {.lex_state = 23, .external_lex_state = 2},
  [783] = {.lex_state = 23, .external_lex_state = 2},
  [784] = {.lex_state = 23, .external_lex_state = 2},
  [785] = {.lex_state = 23, .external_lex_state = 2},
  [786] = {.lex_state = 23, .external_lex_state = 2},
  [787] = {.lex_state = 23, .external_lex_state = 2},
  [788] = {.lex_state = 12, .external_lex_state = 4},
  [789] = {.lex_state = 13, .external_lex_state = 4},
  [790] = {.lex_state = 12, .external_lex_state = 4},
  [791] = {.lex_state = 12, .external_lex_state = 4},
  [792] = {.lex_state = 12, .external_lex_state = 4},
  [793] = {.lex_state = 12, .external_lex_state = 4},
  [794] = {.lex_state = 23, .external_lex_state = 2},
  [795] = {.lex_state = 23, .external_lex_state = 1},
  [796] = {.lex_state = 12, .external_lex_state = 4},
  [797] = {.lex_state = 23, .external_lex_state = 2},
  [798] = {.lex_state = 23, .external_lex_state = 2},
  [799] = {.lex_state = 23, .external_lex_state = 2},
  [800] = {.lex_state = 12, .external_lex_state = 4},
  [801] = {.lex_state = 23, .external_lex_state = 2},
  [802] = {.lex_state = 23, .external_lex_state = 1},
  [803] = {.lex_state = 23, .external_lex_state = 2},
  [804] = {.lex_state = 12, .external_lex_state = 4},
  [805] = {.lex_state = 23, .external_lex_state = 1},
  [806] = {.lex_state = 23, .external_lex_state = 2},
  [807] = {.lex_state = 12, .external_lex_state = 4},
  [808] = {.lex_state = 23, .external_lex_state = 2},
  [809] = {.lex_state = 23, .external_lex_state = 2},
  [810] = {.lex_state = 12, .external_lex_state = 4},
  [811] = {.lex_state = 23, .external_lex_state = 2},
  [812] = {.lex_state = 23, .external_lex_state = 2},
  [813] = {.lex_state = 23, .external_lex_state = 2},
  [814] = {.lex_state = 23, .external_lex_state = 2},
  [815] = {.lex_state = 23, .external_lex_state = 2},
  [816] = {.lex_state = 23, .external_lex_state = 2},
  [817] = {.lex_state = 23, .external_lex_state = 2},
  [818] = {.lex_state = 23, .external_lex_state = 2},
  [819] = {.lex_state = 23, .external_lex_state = 2},
  [820] = {.lex_state = 12, .external_lex_state = 4},
  [821] = {.lex_state = 12, .external_lex_state = 4},
  [822] = {.lex_state = 23, .external_lex_state = 1},
  [823] = {.lex_state = 12, .external_lex_state = 4},
  [824] = {.lex_state = 12, .external_lex_state = 4},
  [825] = {.lex_state = 23, .external_lex_state = 2},
  [826] = {.lex_state = 23, .external_lex_state = 2},
  [827] = {.lex_state = 23, .external_lex_state = 1},
  [828] = {.lex_state = 23, .external_lex_state = 2},
  [829] = {.lex_state = 23, .external_lex_state = 2},
  [830] = {.lex_state = 23, .external_lex_state = 2},
  [831] = {.lex_state = 23, .external_lex_state = 2},
  [832] = {.lex_state = 23, .external_lex_state = 1},
  [833] = {.lex_state = 23, .external_lex_state = 2},
  [834] = {.lex_state = 23, .external_lex_state = 2},
  [835] = {.lex_state = 23, .external_lex_state = 2},
  [836] = {.lex_state = 10, .external_lex_state = 4},
  [837] = {.lex_state = 10, .external_lex_state = 4},
  [838] = {.lex_state = 10, .external_lex_state = 4},
  [839] = {.lex_state = 10, .external_lex_state = 4},
  [840] = {.lex_state = 10, .external_lex_state = 4},
  [841] = {.lex_state = 10, .external_lex_state = 4},
  [842] = {.lex_state = 10, .external_lex_state = 4},
  [843] = {.lex_state = 10, .external_lex_state = 4},
  [844] = {.lex_state = 10, .external_lex_state = 4},
  [845] = {.lex_state = 10, .external_lex_state = 4},
  [846] = {.lex_state = 10, .external_lex_state = 4},
  [847] = {.lex_state = 14, .external_lex_state = 4},
  [848] = {.lex_state = 58, .external_lex_state = 4},
  [849] = {.lex_state = 53, .external_lex_state = 4},
  [850] = {.lex_state = 59, .external_lex_state = 4},
  [851] = {.lex_state = 53, .external_lex_state = 4},
  [852] = {.lex_state = 14, .external_lex_state = 4},
  [853] = {.lex_state = 58, .external_lex_state = 4},
  [854] = {.lex_state = 53, .external_lex_state = 4},
  [855] = {.lex_state = 61, .external_lex_state = 4},
  [856] = {.lex_state = 60, .external_lex_state = 4},
  [857] = {.lex_state = 53, .external_lex_state = 4},
  [858] = {.lex_state = 61, .external_lex_state = 4},
  [859] = {.lex_state = 58, .external_lex_state = 4},
  [860] = {.lex_state = 60, .external_lex_state = 4},
  [861] = {.lex_state = 53, .external_lex_state = 4},
  [862] = {.lex_state = 10, .external_lex_state = 4},
  [863] = {.lex_state = 61, .external_lex_state = 4},
  [864] = {.lex_state = 59, .external_lex_state = 4},
  [865] = {.lex_state = 53, .external_lex_state = 4},
  [866] = {.lex_state = 60, .external_lex_state = 4},
  [867] = {.lex_state = 59, .external_lex_state = 4},
  [868] = {.lex_state = 53, .external_lex_state = 4},
  [869] = {.lex_state = 10, .external_lex_state = 4},
  [870] = {.lex_state = 54, .external_lex_state = 4},
  [871] = {.lex_state = 54, .external_lex_state = 4},
  [872] = {.lex_state = 54, .external_lex_state = 4},
  [873] = {.lex_state = 53, .external_lex_state = 4},
  [874] = {.lex_state = 53, .external_lex_state = 4},
  [875] = {.lex_state = 57, .external_lex_state = 6},
  [876] = {.lex_state = 54, .external_lex_state = 4},
  [877] = {.lex_state = 54, .external_lex_state = 4},
  [878] = {.lex_state = 54, .external_lex_state = 4},
  [879] = {.lex_state = 53, .external_lex_state = 4},
  [880] = {.lex_state = 23, .external_lex_state = 2},
  [881] = {.lex_state = 10, .external_lex_state = 4},
  [882] = {.lex_state = 14, .external_lex_state = 4},
  [883] = {.lex_state = 53, .external_lex_state = 4},
  [884] = {.lex_state = 53, .external_lex_state = 4},
  [885] = {.lex_state = 13, .external_lex_state = 4},
  [886] = {.lex_state = 13, .external_lex_state = 4},
  [887] = {.lex_state = 13, .external_lex_state = 4},
  [888] = {.lex_state = 54, .external_lex_state = 4},
  [889] = {.lex_state = 13, .external_lex_state = 4},
  [890] = {.lex_state = 13, .external_lex_state = 4},
  [891] = {.lex_state = 13, .external_lex_state = 4},
  [892] = {.lex_state = 10, .external_lex_state = 5},
  [893] = {.lex_state = 10, .external_lex_state = 4},
  [894] = {.lex_state = 10, .external_lex_state = 4},
  [895] = {.lex_state = 10, .external_lex_state = 5},
  [896] = {.lex_state = 10, .external_lex_state = 4},
  [897] = {.lex_state = 10, .external_lex_state = 5},
  [898] = {.lex_state = 13, .external_lex_state = 4},
  [899] = {.lex_state = 13, .external_lex_state = 4},
  [900] = {.lex_state = 13, .external_lex_state = 4},
  [901] = {.lex_state = 51, .external_lex_state = 7},
  [902] = {.lex_state = 10, .external_lex_state = 5},
  [903] = {.lex_state = 10, .external_lex_state = 4},
  [904] = {.lex_state = 51, .external_lex_state = 7},
  [905] = {.lex_state = 10, .external_lex_state = 4},
  [906] = {.lex_state = 13, .external_lex_state = 4},
  [907] = {.lex_state = 10, .external_lex_state = 4},
  [908] = {.lex_state = 10, .external_lex_state = 4},
  [909] = {.lex_state = 10, .external_lex_state = 4},
  [910] = {.lex_state = 13, .external_lex_state = 4},
  [911] = {.lex_state = 10, .external_lex_state = 4},
  [912] = {.lex_state = 10, .external_lex_state = 4},
  [913] = {.lex_state = 10, .external_lex_state = 4},
  [914] = {.lex_state = 10, .external_lex_state = 4},
  [915] = {.lex_state = 10, .external_lex_state = 5},
  [916] = {.lex_state = 10, .external_lex_state = 4},
  [917] = {.lex_state = 13, .external_lex_state = 4},
  [918] = {.lex_state = 10, .external_lex_state = 4},
  [919] = {.lex_state = 10, .external_lex_state = 5},
  [920] = {.lex_state = 54, .external_lex_state = 4},
  [921] = {.lex_state = 53, .external_lex_state = 5},
  [922] = {.lex_state = 53, .external_lex_state = 5},
  [923] = {.lex_state = 53, .external_lex_state = 4},
  [924] = {.lex_state = 53, .external_lex_state = 4},
  [925] = {.lex_state = 10, .external_lex_state = 5},
  [926] = {.lex_state = 10, .external_lex_state = 4},
  [927] = {.lex_state = 53, .external_lex_state = 4},
  [928] = {.lex_state = 52, .external_lex_state = 4},
  [929] = {.lex_state = 53, .external_lex_state = 4},
  [930] = {.lex_state = 53, .external_lex_state = 5},
  [931] = {.lex_state = 10, .external_lex_state = 5},
  [932] = {.lex_state = 53, .external_lex_state = 5},
  [933] = {.lex_state = 53, .external_lex_state = 5},
  [934] = {.lex_state = 52, .external_lex_state = 4},
  [935] = {.lex_state = 54, .external_lex_state = 4},
  [936] = {.lex_state = 53, .external_lex_state = 5},
  [937] = {.lex_state = 53, .external_lex_state = 5},
  [938] = {.lex_state = 52, .external_lex_state = 4},
  [939] = {.lex_state = 10, .external_lex_state = 5},
  [940] = {.lex_state = 10, .external_lex_state = 5},
  [941] = {.lex_state = 53, .external_lex_state = 4},
  [942] = {.lex_state = 53, .external_lex_state = 5},
  [943] = {.lex_state = 54, .external_lex_state = 4},
  [944] = {.lex_state = 10, .external_lex_state = 4},
  [945] = {.lex_state = 10, .external_lex_state = 4},
  [946] = {.lex_state = 53, .external_lex_state = 5},
  [947] = {.lex_state = 53, .external_lex_state = 5},
  [948] = {.lex_state = 53, .external_lex_state = 4},
  [949] = {.lex_state = 53, .external_lex_state = 5},
  [950] = {.lex_state = 10, .external_lex_state = 4},
  [951] = {.lex_state = 53, .external_lex_state = 4},
  [952] = {.lex_state = 10, .external_lex_state = 4},
  [953] = {.lex_state = 53, .external_lex_state = 4},
  [954] = {.lex_state = 53, .external_lex_state = 4},
  [955] = {.lex_state = 57, .external_lex_state = 5},
  [956] = {.lex_state = 10, .external_lex_state = 4},
  [957] = {.lex_state = 10, .external_lex_state = 4},
  [958] = {.lex_state = 10, .external_lex_state = 4},
  [959] = {.lex_state = 10, .external_lex_state = 4},
  [960] = {.lex_state = 10, .external_lex_state = 4},
  [961] = {.lex_state = 10, .external_lex_state = 4},
  [962] = {.lex_state = 10, .external_lex_state = 4},
  [963] = {.lex_state = 10, .external_lex_state = 4},
  [964] = {.lex_state = 10, .external_lex_state = 4},
  [965] = {.lex_state = 53, .external_lex_state = 5},
  [966] = {.lex_state = 10, .external_lex_state = 4},
  [967] = {.lex_state = 10, .external_lex_state = 5},
  [968] = {.lex_state = 10, .external_lex_state = 4},
  [969] = {.lex_state = 53, .external_lex_state = 5},
  [970] = {.lex_state = 52, .external_lex_state = 4},
  [971] = {.lex_state = 10, .external_lex_state = 5},
  [972] = {.lex_state = 53, .external_lex_state = 4},
  [973] = {.lex_state = 53, .external_lex_state = 4},
  [974] = {.lex_state = 53, .external_lex_state = 4},
  [975] = {.lex_state = 10, .external_lex_state = 5},
  [976] = {.lex_state = 10, .external_lex_state = 5},
  [977] = {.lex_state = 10, .external_lex_state = 5},
  [978] = {.lex_state = 10, .external_lex_state = 5},
  [979] = {.lex_state = 10, .external_lex_state = 5},
  [980] = {.lex_state = 10, .external_lex_state = 5},
  [981] = {.lex_state = 10, .external_lex_state = 5},
  [982] = {.lex_state = 10, .external_lex_state = 5},
  [983] = {.lex_state = 53, .external_lex_state = 4},
  [984] = {.lex_state = 10, .external_lex_state = 4},
  [985] = {.lex_state = 10, .external_lex_state = 5},
  [986] = {.lex_state = 53, .external_lex_state = 5},
  [987] = {.lex_state = 54, .external_lex_state = 4},
  [988] = {.lex_state = 10, .external_lex_state = 4},
  [989] = {.lex_state = 10, .external_lex_state = 4},
  [990] = {.lex_state = 52, .external_lex_state = 4},
  [991] = {.lex_state = 53, .external_lex_state = 5},
  [992] = {.lex_state = 52, .external_lex_state = 4},
  [993] = {.lex_state = 53, .external_lex_state = 5},
  [994] = {.lex_state = 52, .external_lex_state = 4},
  [995] = {.lex_state = 53, .external_lex_state = 5},
  [996] = {.lex_state = 10, .external_lex_state = 4},
  [997] = {.lex_state = 53, .external_lex_state = 4},
  [998] = {.lex_state = 10, .external_lex_state = 4},
  [999] = {.lex_state = 10, .external_lex_state = 4},
  [1000] = {.lex_state = 10, .external_lex_state = 4},
  [1001] = {.lex_state = 10, .external_lex_state = 4},
  [1002] = {.lex_state = 10, .external_lex_state = 5},
  [1003] = {.lex_state = 11, .external_lex_state = 4},
  [1004] = {.lex_state = 10, .external_lex_state = 4},
  [1005] = {.lex_state = 10, .external_lex_state = 5},
  [1006] = {.lex_state = 53, .external_lex_state = 4},
  [1007] = {.lex_state = 10, .external_lex_state = 4},
  [1008] = {.lex_state = 10, .external_lex_state = 5},
  [1009] = {.lex_state = 10, .external_lex_state = 4},
  [1010] = {.lex_state = 10, .external_lex_state = 4},
  [1011] = {.lex_state = 10, .external_lex_state = 4},
  [1012] = {.lex_state = 10, .external_lex_state = 5},
  [1013] = {.lex_state = 11, .external_lex_state = 4},
  [1014] = {.lex_state = 10, .external_lex_state = 5},
  [1015] = {.lex_state = 10, .external_lex_state = 4},
  [1016] = {.lex_state = 10, .external_lex_state = 4},
  [1017] = {.lex_state = 10, .external_lex_state = 5},
  [1018] = {.lex_state = 10, .external_lex_state = 5},
  [1019] = {.lex_state = 10, .external_lex_state = 5},
  [1020] = {.lex_state = 57, .external_lex_state = 5},
  [1021] = {.lex_state = 10, .external_lex_state = 5},
  [1022] = {.lex_state = 10, .external_lex_state = 5},
  [1023] = {.lex_state = 11, .external_lex_state = 4},
  [1024] = {.lex_state = 10, .external_lex_state = 4},
  [1025] = {.lex_state = 13, .external_lex_state = 4},
  [1026] = {.lex_state = 13, .external_lex_state = 4},
  [1027] = {.lex_state = 13, .external_lex_state = 4},
  [1028] = {.lex_state = 13, .external_lex_state = 4},
  [1029] = {.lex_state = 10, .external_lex_state = 4},
  [1030] = {.lex_state = 10, .external_lex_state = 4},
  [1031] = {.lex_state = 10, .external_lex_state = 5},
  [1032] = {.lex_state = 10, .external_lex_state = 4},
  [1033] = {.lex_state = 10, .external_lex_state = 5},
  [1034] = {.lex_state = 10, .external_lex_state = 4},
  [1035] = {.lex_state = 10, .external_lex_state = 4},
  [1036] = {.lex_state = 57, .external_lex_state = 5},
  [1037] = {.lex_state = 10, .external_lex_state = 5},
  [1038] = {.lex_state = 11, .external_lex_state = 4},
  [1039] = {.lex_state = 10, .external_lex_state = 5},
  [1040] = {.lex_state = 10, .external_lex_state = 5},
  [1041] = {.lex_state = 10, .external_lex_state = 4},
  [1042] = {.lex_state = 11, .external_lex_state = 4},
  [1043] = {.lex_state = 11, .external_lex_state = 4},
  [1044] = {.lex_state = 11, .external_lex_state = 4},
  [1045] = {.lex_state = 11, .external_lex_state = 4},
  [1046] = {.lex_state = 10, .external_lex_state = 5},
  [1047] = {.lex_state = 10, .external_lex_state = 4},
  [1048] = {.lex_state = 10, .external_lex_state = 5},
  [1049] = {.lex_state = 10, .external_lex_state = 4},
  [1050] = {.lex_state = 11, .external_lex_state = 4},
  [1051] = {.lex_state = 11, .external_lex_state = 4},
  [1052] = {.lex_state = 11, .external_lex_state = 4},
  [1053] = {.lex_state = 11, .external_lex_state = 4},
  [1054] = {.lex_state = 11, .external_lex_state = 4},
  [1055] = {.lex_state = 10, .external_lex_state = 4},
  [1056] = {.lex_state = 12, .external_lex_state = 4},
  [1057] = {.lex_state = 11, .external_lex_state = 4},
  [1058] = {.lex_state = 11, .external_lex_state = 4},
  [1059] = {.lex_state = 11, .external_lex_state = 4},
  [1060] = {.lex_state = 11, .external_lex_state = 4},
  [1061] = {.lex_state = 10, .external_lex_state = 4},
  [1062] = {.lex_state = 11, .external_lex_state = 4},
  [1063] = {.lex_state = 11, .external_lex_state = 4},
  [1064] = {.lex_state = 11, .external_lex_state = 4},
  [1065] = {.lex_state = 11, .external_lex_state = 4},
  [1066] = {.lex_state = 11, .external_lex_state = 4},
  [1067] = {.lex_state = 11, .external_lex_state = 4},
  [1068] = {.lex_state = 11, .external_lex_state = 4},
  [1069] = {.lex_state = 11, .external_lex_state = 4},
  [1070] = {.lex_state = 14, .external_lex_state = 4},
  [1071] = {.lex_state = 10, .external_lex_state = 5},
  [1072] = {.lex_state = 11, .external_lex_state = 4},
  [1073] = {.lex_state = 10, .external_lex_state = 4},
  [1074] = {.lex_state = 11, .external_lex_state = 4},
  [1075] = {.lex_state = 53, .external_lex_state = 4},
  [1076] = {.lex_state = 53, .external_lex_state = 4},
  [1077] = {.lex_state = 11, .external_lex_state = 4},
  [1078] = {.lex_state = 11, .external_lex_state = 4},
  [1079] = {.lex_state = 10, .external_lex_state = 4},
  [1080] = {.lex_state = 10, .external_lex_state = 4},
  [1081] = {.lex_state = 11, .external_lex_state = 4},
  [1082] = {.lex_state = 11, .external_lex_state = 4},
  [1083] = {.lex_state = 11, .external_lex_state = 4},
  [1084] = {.lex_state = 11, .external_lex_state = 4},
  [1085] = {.lex_state = 10, .external_lex_state = 5},
  [1086] = {.lex_state = 11, .external_lex_state = 4},
  [1087] = {.lex_state = 10, .external_lex_state = 4},
  [1088] = {.lex_state = 10, .external_lex_state = 4},
  [1089] = {.lex_state = 10, .external_lex_state = 4},
  [1090] = {.lex_state = 10, .external_lex_state = 4},
  [1091] = {.lex_state = 10, .external_lex_state = 4},
  [1092] = {.lex_state = 10, .external_lex_state = 5},
  [1093] = {.lex_state = 10, .external_lex_state = 4},
  [1094] = {.lex_state = 10, .external_lex_state = 4},
  [1095] = {.lex_state = 53, .external_lex_state = 4},
  [1096] = {.lex_state = 10, .external_lex_state = 4},
  [1097] = {.lex_state = 10, .external_lex_state = 4},
  [1098] = {.lex_state = 10, .external_lex_state = 4},
  [1099] = {.lex_state = 10, .external_lex_state = 4},
  [1100] = {.lex_state = 53, .external_lex_state = 4},
  [1101] = {.lex_state = 53, .external_lex_state = 4},
  [1102] = {.lex_state = 52, .external_lex_state = 4},
  [1103] = {.lex_state = 10, .external_lex_state = 4},
  [1104] = {.lex_state = 11, .external_lex_state = 4},
  [1105] = {.lex_state = 53, .external_lex_state = 4},
  [1106] = {.lex_state = 10, .external_lex_state = 4},
  [1107] = {.lex_state = 10, .external_lex_state = 4},
  [1108] = {.lex_state = 11, .external_lex_state = 4},
  [1109] = {.lex_state = 10, .external_lex_state = 4},
  [1110] = {.lex_state = 52, .external_lex_state = 4},
  [1111] = {.lex_state = 10, .external_lex_state = 4},
  [1112] = {.lex_state = 10, .external_lex_state = 5},
  [1113] = {.lex_state = 52, .external_lex_state = 4},
  [1114] = {.lex_state = 52, .external_lex_state = 4},
  [1115] = {.lex_state = 52, .external_lex_state = 4},
  [1116] = {.lex_state = 52, .external_lex_state = 4},
  [1117] = {.lex_state = 10, .external_lex_state = 4},
  [1118] = {.lex_state = 52, .external_lex_state = 4},
  [1119] = {.lex_state = 11, .external_lex_state = 4},
  [1120] = {.lex_state = 11, .external_lex_state = 4},
  [1121] = {.lex_state = 10, .external_lex_state = 5},
  [1122] = {.lex_state = 10, .external_lex_state = 5},
  [1123] = {.lex_state = 11, .external_lex_state = 4},
  [1124] = {.lex_state = 10, .external_lex_state = 4},
  [1125] = {.lex_state = 10, .external_lex_state = 4},
  [1126] = {.lex_state = 11, .external_lex_state = 4},
  [1127] = {.lex_state = 10, .external_lex_state = 5},
  [1128] = {.lex_state = 10, .external_lex_state = 5},
  [1129] = {.lex_state = 10, .external_lex_state = 5},
  [1130] = {.lex_state = 10, .external_lex_state = 4},
  [1131] = {.lex_state = 10, .external_lex_state = 5},
  [1132] = {.lex_state = 10, .external_lex_state = 5},
  [1133] = {.lex_state = 10, .external_lex_state = 5},
  [1134] = {.lex_state = 10, .external_lex_state = 5},
  [1135] = {.lex_state = 10, .external_lex_state = 5},
  [1136] = {.lex_state = 10, .external_lex_state = 4},
  [1137] = {.lex_state = 10, .external_lex_state = 4},
  [1138] = {.lex_state = 10, .external_lex_state = 5},
  [1139] = {.lex_state = 10, .external_lex_state = 4},
  [1140] = {.lex_state = 10, .external_lex_state = 5},
  [1141] = {.lex_state = 10, .external_lex_state = 4},
  [1142] = {.lex_state = 11, .external_lex_state = 4},
  [1143] = {.lex_state = 10, .external_lex_state = 4},
  [1144] = {.lex_state = 11, .external_lex_state = 4},
  [1145] = {.lex_state = 11, .external_lex_state = 4},
  [1146] = {.lex_state = 11, .external_lex_state = 4},
  [1147] = {.lex_state = 10, .external_lex_state = 4},
  [1148] = {.lex_state = 10, .external_lex_state = 4},
  [1149] = {.lex_state = 11, .external_lex_state = 4},
  [1150] = {.lex_state = 11, .external_lex_state = 4},
  [1151] = {.lex_state = 10, .external_lex_state = 4},
  [1152] = {.lex_state = 10, .external_lex_state = 4},
  [1153] = {.lex_state = 10, .external_lex_state = 4},
  [1154] = {.lex_state = 10, .external_lex_state = 5},
  [1155] = {.lex_state = 10, .external_lex_state = 4},
  [1156] = {.lex_state = 10, .external_lex_state = 5},
  [1157] = {.lex_state = 11, .external_lex_state = 4},
  [1158] = {.lex_state = 10, .external_lex_state = 5},
  [1159] = {.lex_state = 10, .external_lex_state = 5},
  [1160] = {.lex_state = 10, .external_lex_state = 4},
  [1161] = {.lex_state = 10, .external_lex_state = 4},
  [1162] = {.lex_state = 11, .external_lex_state = 4},
  [1163] = {.lex_state = 11, .external_lex_state = 4},
  [1164] = {.lex_state = 10, .external_lex_state = 4},
  [1165] = {.lex_state = 11, .external_lex_state = 4},
  [1166] = {.lex_state = 10, .external_lex_state = 5},
  [1167] = {.lex_state = 53, .external_lex_state = 4},
  [1168] = {.lex_state = 10, .external_lex_state = 4},
  [1169] = {.lex_state = 10, .external_lex_state = 4},
  [1170] = {.lex_state = 10, .external_lex_state = 4},
  [1171] = {.lex_state = 10, .external_lex_state = 4},
  [1172] = {.lex_state = 2, .external_lex_state = 5},
  [1173] = {.lex_state = 10, .external_lex_state = 4},
  [1174] = {.lex_state = 10, .external_lex_state = 4},
  [1175] = {.lex_state = 11, .external_lex_state = 4},
  [1176] = {.lex_state = 11, .external_lex_state = 4},
  [1177] = {.lex_state = 15, .external_lex_state = 5},
  [1178] = {.lex_state = 11, .external_lex_state = 4},
  [1179] = {.lex_state = 11, .external_lex_state = 4},
  [1180] = {.lex_state = 52, .external_lex_state = 4},
  [1181] = {.lex_state = 53, .external_lex_state = 4},
  [1182] = {.lex_state = 11, .external_lex_state = 4},
  [1183] = {.lex_state = 52, .external_lex_state = 4},
  [1184] = {.lex_state = 53, .external_lex_state = 4},
  [1185] = {.lex_state = 11, .external_lex_state = 4},
  [1186] = {.lex_state = 53, .external_lex_state = 4},
  [1187] = {.lex_state = 11, .external_lex_state = 4},
  [1188] = {.lex_state = 51, .external_lex_state = 4},
  [1189] = {.lex_state = 11, .external_lex_state = 4},
  [1190] = {.lex_state = 52, .external_lex_state = 4},
  [1191] = {.lex_state = 11, .external_lex_state = 4},
  [1192] = {.lex_state = 11, .external_lex_state = 4},
  [1193] = {.lex_state = 11, .external_lex_state = 4},
  [1194] = {.lex_state = 52, .external_lex_state = 4},
  [1195] = {.lex_state = 10, .external_lex_state = 4},
  [1196] = {.lex_state = 10, .external_lex_state = 4},
  [1197] = {.lex_state = 11, .external_lex_state = 4},
  [1198] = {.lex_state = 52, .external_lex_state = 4},
  [1199] = {.lex_state = 11, .external_lex_state = 4},
  [1200] = {.lex_state = 52, .external_lex_state = 4},
  [1201] = {.lex_state = 52, .external_lex_state = 4},
  [1202] = {.lex_state = 52, .external_lex_state = 4},
  [1203] = {.lex_state = 10, .external_lex_state = 4},
  [1204] = {.lex_state = 52, .external_lex_state = 4},
  [1205] = {.lex_state = 10, .external_lex_state = 4},
  [1206] = {.lex_state = 10, .external_lex_state = 5},
  [1207] = {.lex_state = 11, .external_lex_state = 4},
  [1208] = {.lex_state = 11, .external_lex_state = 4},
  [1209] = {.lex_state = 5, .external_lex_state = 5},
  [1210] = {.lex_state = 52, .external_lex_state = 4},
  [1211] = {.lex_state = 11, .external_lex_state = 4},
  [1212] = {.lex_state = 52, .external_lex_state = 4},
  [1213] = {.lex_state = 11, .external_lex_state = 4},
  [1214] = {.lex_state = 52, .external_lex_state = 4},
  [1215] = {.lex_state = 52, .external_lex_state = 4},
  [1216] = {.lex_state = 15, .external_lex_state = 5},
  [1217] = {.lex_state = 11, .external_lex_state = 4},
  [1218] = {.lex_state = 10, .external_lex_state = 4},
  [1219] = {.lex_state = 52, .external_lex_state = 4},
  [1220] = {.lex_state = 2, .external_lex_state = 5},
  [1221] = {.lex_state = 51, .external_lex_state = 4},
  [1222] = {.lex_state = 10, .external_lex_state = 4},
  [1223] = {.lex_state = 11, .external_lex_state = 4},
  [1224] = {.lex_state = 52, .external_lex_state = 4},
  [1225] = {.lex_state = 52, .external_lex_state = 4},
  [1226] = {.lex_state = 52, .external_lex_state = 4},
  [1227] = {.lex_state = 2, .external_lex_state = 5},
  [1228] = {.lex_state = 10, .external_lex_state = 4},
  [1229] = {.lex_state = 19, .external_lex_state = 5},
  [1230] = {.lex_state = 52, .external_lex_state = 4},
  [1231] = {.lex_state = 52, .external_lex_state = 4},
  [1232] = {.lex_state = 2, .external_lex_state = 5},
  [1233] = {.lex_state = 10, .external_lex_state = 4},
  [1234] = {.lex_state = 52, .external_lex_state = 4},
  [1235] = {.lex_state = 19, .external_lex_state = 5},
  [1236] = {.lex_state = 19, .external_lex_state = 5},
  [1237] = {.lex_state = 16, .external_lex_state = 5},
  [1238] = {.lex_state = 65, .external_lex_state = 5},
  [1239] = {.lex_state = 16, .external_lex_state = 5},
  [1240] = {.lex_state = 19, .external_lex_state = 5},
  [1241] = {.lex_state = 52, .external_lex_state = 4},
  [1242] = {.lex_state = 17, .external_lex_state = 5},
  [1243] = {.lex_state = 62, .external_lex_state = 5},
  [1244] = {.lex_state = 18, .external_lex_state = 5},
  [1245] = {.lex_state = 52, .external_lex_state = 4},
  [1246] = {.lex_state = 52, .external_lex_state = 4},
  [1247] = {.lex_state = 16, .external_lex_state = 5},
  [1248] = {.lex_state = 18, .external_lex_state = 5},
  [1249] = {.lex_state = 65, .external_lex_state = 5},
  [1250] = {.lex_state = 52, .external_lex_state = 4},
  [1251] = {.lex_state = 52, .external_lex_state = 4},
  [1252] = {.lex_state = 52, .external_lex_state = 4},
  [1253] = {.lex_state = 52, .external_lex_state = 4},
  [1254] = {.lex_state = 52, .external_lex_state = 4},
  [1255] = {.lex_state = 52, .external_lex_state = 4},
  [1256] = {.lex_state = 52, .external_lex_state = 4},
  [1257] = {.lex_state = 16, .external_lex_state = 5},
  [1258] = {.lex_state = 19, .external_lex_state = 5},
  [1259] = {.lex_state = 65, .external_lex_state = 5},
  [1260] = {.lex_state = 2, .external_lex_state = 4},
  [1261] = {.lex_state = 10, .external_lex_state = 5},
  [1262] = {.lex_state = 52, .external_lex_state = 4},
  [1263] = {.lex_state = 10, .external_lex_state = 4},
  [1264] = {.lex_state = 52, .external_lex_state = 4},
  [1265] = {.lex_state = 52, .external_lex_state = 4},
  [1266] = {.lex_state = 10, .external_lex_state = 4},
  [1267] = {.lex_state = 52, .external_lex_state = 4},
  [1268] = {.lex_state = 52, .external_lex_state = 4},
  [1269] = {.lex_state = 52, .external_lex_state = 4},
  [1270] = {.lex_state = 52, .external_lex_state = 4},
  [1271] = {.lex_state = 52, .external_lex_state = 4},
  [1272] = {.lex_state = 19, .external_lex_state = 5},
  [1273] = {.lex_state = 53, .external_lex_state = 4},
  [1274] = {.lex_state = 65, .external_lex_state = 5},
  [1275] = {.lex_state = 16, .external_lex_state = 5},
  [1276] = {.lex_state = 64, .external_lex_state = 5},
  [1277] = {.lex_state = 52, .external_lex_state = 4},
  [1278] = {.lex_state = 52, .external_lex_state = 4},
  [1279] = {.lex_state = 52, .external_lex_state = 4},
  [1280] = {.lex_state = 52, .external_lex_state = 4},
  [1281] = {.lex_state = 52, .external_lex_state = 4},
  [1282] = {.lex_state = 52, .external_lex_state = 4},
  [1283] = {.lex_state = 52, .external_lex_state = 4},
  [1284] = {.lex_state = 16, .external_lex_state = 5},
  [1285] = {.lex_state = 2, .external_lex_state = 5},
  [1286] = {.lex_state = 16, .external_lex_state = 5},
  [1287] = {.lex_state = 52, .external_lex_state = 4},
  [1288] = {.lex_state = 52, .external_lex_state = 4},
  [1289] = {.lex_state = 19, .external_lex_state = 5},
  [1290] = {.lex_state = 52, .external_lex_state = 4},
  [1291] = {.lex_state = 65, .external_lex_state = 5},
  [1292] = {.lex_state = 65, .external_lex_state = 5},
  [1293] = {.lex_state = 16, .external_lex_state = 5},
  [1294] = {.lex_state = 52, .external_lex_state = 4},
  [1295] = {.lex_state = 52, .external_lex_state = 4},
  [1296] = {.lex_state = 10, .external_lex_state = 4},
  [1297] = {.lex_state = 52, .external_lex_state = 4},
  [1298] = {.lex_state = 52, .external_lex_state = 4},
  [1299] = {.lex_state = 52, .external_lex_state = 4},
  [1300] = {.lex_state = 18, .external_lex_state = 5},
  [1301] = {.lex_state = 52, .external_lex_state = 4},
  [1302] = {.lex_state = 52, .external_lex_state = 4},
  [1303] = {.lex_state = 52, .external_lex_state = 4},
  [1304] = {.lex_state = 52, .external_lex_state = 4},
  [1305] = {.lex_state = 52, .external_lex_state = 4},
  [1306] = {.lex_state = 65, .external_lex_state = 5},
  [1307] = {.lex_state = 53, .external_lex_state = 4},
  [1308] = {.lex_state = 18, .external_lex_state = 5},
  [1309] = {.lex_state = 52, .external_lex_state = 4},
  [1310] = {.lex_state = 52, .external_lex_state = 4},
  [1311] = {.lex_state = 52, .external_lex_state = 4},
  [1312] = {.lex_state = 10, .external_lex_state = 4},
  [1313] = {.lex_state = 52, .external_lex_state = 4},
  [1314] = {.lex_state = 18, .external_lex_state = 5},
  [1315] = {.lex_state = 52, .external_lex_state = 4},
  [1316] = {.lex_state = 52, .external_lex_state = 4},
  [1317] = {.lex_state = 52, .external_lex_state = 4},
  [1318] = {.lex_state = 52, .external_lex_state = 4},
  [1319] = {.lex_state = 2, .external_lex_state = 5},
  [1320] = {.lex_state = 52, .external_lex_state = 4},
  [1321] = {.lex_state = 5, .external_lex_state = 4},
  [1322] = {.lex_state = 52, .external_lex_state = 4},
  [1323] = {.lex_state = 18, .external_lex_state = 5},
  [1324] = {.lex_state = 2, .external_lex_state = 5},
  [1325] = {.lex_state = 52, .external_lex_state = 4},
  [1326] = {.lex_state = 10, .external_lex_state = 4},
  [1327] = {.lex_state = 10, .external_lex_state = 4},
  [1328] = {.lex_state = 52, .external_lex_state = 4},
  [1329] = {.lex_state = 53, .external_lex_state = 4},
  [1330] = {.lex_state = 10, .external_lex_state = 4},
  [1331] = {.lex_state = 10, .external_lex_state = 4},
  [1332] = {.lex_state = 19, .external_lex_state = 5},
  [1333] = {.lex_state = 2, .external_lex_state = 5},
  [1334] = {.lex_state = 52, .external_lex_state = 4},
  [1335] = {.lex_state = 2, .external_lex_state = 5},
  [1336] = {.lex_state = 2, .external_lex_state = 5},
  [1337] = {.lex_state = 2, .external_lex_state = 5},
  [1338] = {.lex_state = 2, .external_lex_state = 5},
  [1339] = {.lex_state = 2, .external_lex_state = 5},
  [1340] = {.lex_state = 52, .external_lex_state = 4},
  [1341] = {.lex_state = 52, .external_lex_state = 4},
  [1342] = {.lex_state = 52, .external_lex_state = 4},
  [1343] = {.lex_state = 2, .external_lex_state = 5},
  [1344] = {.lex_state = 2, .external_lex_state = 5},
  [1345] = {.lex_state = 2, .external_lex_state = 5},
  [1346] = {.lex_state = 2, .external_lex_state = 5},
  [1347] = {.lex_state = 2, .external_lex_state = 5},
  [1348] = {.lex_state = 2, .external_lex_state = 5},
  [1349] = {.lex_state = 2, .external_lex_state = 5},
  [1350] = {.lex_state = 2, .external_lex_state = 5},
  [1351] = {.lex_state = 2, .external_lex_state = 5},
  [1352] = {.lex_state = 2, .external_lex_state = 5},
  [1353] = {.lex_state = 52, .external_lex_state = 4},
  [1354] = {.lex_state = 2, .external_lex_state = 5},
  [1355] = {.lex_state = 2, .external_lex_state = 5},
  [1356] = {.lex_state = 2, .external_lex_state = 5},
  [1357] = {.lex_state = 2, .external_lex_state = 5},
  [1358] = {.lex_state = 2, .external_lex_state = 5},
  [1359] = {.lex_state = 2, .external_lex_state = 5},
  [1360] = {.lex_state = 2, .external_lex_state = 5},
  [1361] = {.lex_state = 2, .external_lex_state = 5},
  [1362] = {.lex_state = 2, .external_lex_state = 5},
  [1363] = {.lex_state = 2, .external_lex_state = 5},
  [1364] = {.lex_state = 2, .external_lex_state = 5},
  [1365] = {.lex_state = 2, .external_lex_state = 5},
  [1366] = {.lex_state = 2, .external_lex_state = 5},
  [1367] = {.lex_state = 2, .external_lex_state = 5},
  [1368] = {.lex_state = 2, .external_lex_state = 5},
  [1369] = {.lex_state = 10, .external_lex_state = 4},
  [1370] = {.lex_state = 2, .external_lex_state = 5},
  [1371] = {.lex_state = 14, .external_lex_state = 4},
  [1372] = {.lex_state = 2, .external_lex_state = 5},
  [1373] = {.lex_state = 2, .external_lex_state = 5},
  [1374] = {.lex_state = 2, .external_lex_state = 5},
  [1375] = {.lex_state = 2, .external_lex_state = 5},
  [1376] = {.lex_state = 10, .external_lex_state = 4},
  [1377] = {.lex_state = 2, .external_lex_state = 5},
  [1378] = {.lex_state = 2, .external_lex_state = 5},
  [1379] = {.lex_state = 2, .external_lex_state = 5},
  [1380] = {.lex_state = 2, .external_lex_state = 5},
  [1381] = {.lex_state = 2, .external_lex_state = 5},
  [1382] = {.lex_state = 2, .external_lex_state = 5},
  [1383] = {.lex_state = 52, .external_lex_state = 4},
  [1384] = {.lex_state = 2, .external_lex_state = 5},
  [1385] = {.lex_state = 2, .external_lex_state = 5},
  [1386] = {.lex_state = 2, .external_lex_state = 5},
  [1387] = {.lex_state = 2, .external_lex_state = 5},
  [1388] = {.lex_state = 2, .external_lex_state = 5},
  [1389] = {.lex_state = 2, .external_lex_state = 4},
  [1390] = {.lex_state = 2, .external_lex_state = 5},
  [1391] = {.lex_state = 2, .external_lex_state = 5},
  [1392] = {.lex_state = 2, .external_lex_state = 5},
  [1393] = {.lex_state = 2, .external_lex_state = 5},
  [1394] = {.lex_state = 2, .external_lex_state = 5},
  [1395] = {.lex_state = 2, .external_lex_state = 5},
  [1396] = {.lex_state = 2, .external_lex_state = 5},
  [1397] = {.lex_state = 2, .external_lex_state = 5},
  [1398] = {.lex_state = 2, .external_lex_state = 5},
  [1399] = {.lex_state = 2, .external_lex_state = 5},
  [1400] = {.lex_state = 2, .external_lex_state = 5},
  [1401] = {.lex_state = 2, .external_lex_state = 5},
  [1402] = {.lex_state = 2, .external_lex_state = 5},
  [1403] = {.lex_state = 10, .external_lex_state = 4},
  [1404] = {.lex_state = 2, .external_lex_state = 5},
  [1405] = {.lex_state = 2, .external_lex_state = 5},
  [1406] = {.lex_state = 2, .external_lex_state = 5},
  [1407] = {.lex_state = 63, .external_lex_state = 4},
  [1408] = {.lex_state = 2, .external_lex_state = 4},
  [1409] = {.lex_state = 2, .external_lex_state = 5},
  [1410] = {.lex_state = 52, .external_lex_state = 4},
  [1411] = {.lex_state = 2, .external_lex_state = 5},
  [1412] = {.lex_state = 2, .external_lex_state = 5},
  [1413] = {.lex_state = 2, .external_lex_state = 5},
  [1414] = {.lex_state = 2, .external_lex_state = 5},
  [1415] = {.lex_state = 2, .external_lex_state = 5},
  [1416] = {.lex_state = 2, .external_lex_state = 5},
  [1417] = {.lex_state = 63, .external_lex_state = 4},
  [1418] = {.lex_state = 2, .external_lex_state = 5},
  [1419] = {.lex_state = 2, .external_lex_state = 5},
  [1420] = {.lex_state = 2, .external_lex_state = 5},
  [1421] = {.lex_state = 2, .external_lex_state = 5},
  [1422] = {.lex_state = 2, .external_lex_state = 5},
  [1423] = {.lex_state = 2, .external_lex_state = 5},
  [1424] = {.lex_state = 2, .external_lex_state = 4},
  [1425] = {.lex_state = 2, .external_lex_state = 5},
  [1426] = {.lex_state = 2, .external_lex_state = 5},
  [1427] = {.lex_state = 2, .external_lex_state = 5},
  [1428] = {.lex_state = 2, .external_lex_state = 5},
  [1429] = {.lex_state = 2, .external_lex_state = 5},
  [1430] = {.lex_state = 2, .external_lex_state = 5},
  [1431] = {.lex_state = 2, .external_lex_state = 5},
  [1432] = {.lex_state = 2, .external_lex_state = 5},
  [1433] = {.lex_state = 2, .external_lex_state = 5},
  [1434] = {.lex_state = 2, .external_lex_state = 5},
  [1435] = {.lex_state = 2, .external_lex_state = 5},
  [1436] = {.lex_state = 2, .external_lex_state = 5},
  [1437] = {.lex_state = 2, .external_lex_state = 5},
  [1438] = {.lex_state = 2, .external_lex_state = 5},
  [1439] = {.lex_state = 2, .external_lex_state = 5},
  [1440] = {.lex_state = 2, .external_lex_state = 5},
  [1441] = {.lex_state = 63, .external_lex_state = 4},
  [1442] = {.lex_state = 52, .external_lex_state = 4},
  [1443] = {.lex_state = 5, .external_lex_state = 4},
  [1444] = {.lex_state = 2, .external_lex_state = 5},
  [1445] = {.lex_state = 2, .external_lex_state = 5},
  [1446] = {.lex_state = 2, .external_lex_state = 5},
  [1447] = {.lex_state = 2, .external_lex_state = 5},
  [1448] = {.lex_state = 2, .external_lex_state = 5},
  [1449] = {.lex_state = 2, .external_lex_state = 5},
  [1450] = {.lex_state = 2, .external_lex_state = 5},
  [1451] = {.lex_state = 2, .external_lex_state = 4},
  [1452] = {.lex_state = 2, .external_lex_state = 4},
  [1453] = {.lex_state = 2, .external_lex_state = 4},
  [1454] = {.lex_state = 2, .external_lex_state = 4},
  [1455] = {.lex_state = 2, .external_lex_state = 4},
  [1456] = {.lex_state = 2, .external_lex_state = 4},
  [1457] = {.lex_state = 52, .external_lex_state = 4},
  [1458] = {.lex_state = 52, .external_lex_state = 4},
  [1459] = {.lex_state = 52, .external_lex_state = 4},
  [1460] = {.lex_state = 2, .external_lex_state = 4},
  [1461] = {.lex_state = 2, .external_lex_state = 4},
  [1462] = {.lex_state = 2, .external_lex_state = 4},
  [1463] = {.lex_state = 2, .external_lex_state = 4},
  [1464] = {.lex_state = 2, .external_lex_state = 4},
  [1465] = {.lex_state = 2, .external_lex_state = 4},
  [1466] = {.lex_state = 52, .external_lex_state = 4},
  [1467] = {.lex_state = 2, .external_lex_state = 4},
  [1468] = {.lex_state = 2, .external_lex_state = 4},
  [1469] = {.lex_state = 2, .external_lex_state = 4},
  [1470] = {.lex_state = 2, .external_lex_state = 4},
  [1471] = {.lex_state = 2, .external_lex_state = 4},
  [1472] = {.lex_state = 2, .external_lex_state = 4},
  [1473] = {.lex_state = 2, .external_lex_state = 4},
  [1474] = {.lex_state = 2, .external_lex_state = 4},
  [1475] = {.lex_state = 2, .external_lex_state = 4},
  [1476] = {.lex_state = 2, .external_lex_state = 4},
  [1477] = {.lex_state = 2, .external_lex_state = 4},
  [1478] = {.lex_state = 2, .external_lex_state = 4},
  [1479] = {.lex_state = 52, .external_lex_state = 4},
  [1480] = {.lex_state = 2, .external_lex_state = 4},
  [1481] = {.lex_state = 52, .external_lex_state = 4},
  [1482] = {.lex_state = 2, .external_lex_state = 4},
  [1483] = {.lex_state = 52, .external_lex_state = 4},
  [1484] = {.lex_state = 2, .external_lex_state = 4},
  [1485] = {.lex_state = 2, .external_lex_state = 4},
  [1486] = {.lex_state = 52, .external_lex_state = 4},
  [1487] = {.lex_state = 2, .external_lex_state = 4},
  [1488] = {.lex_state = 2, .external_lex_state = 4},
  [1489] = {.lex_state = 2, .external_lex_state = 4},
  [1490] = {.lex_state = 2, .external_lex_state = 4},
  [1491] = {.lex_state = 2, .external_lex_state = 4},
  [1492] = {.lex_state = 2, .external_lex_state = 4},
  [1493] = {.lex_state = 2, .external_lex_state = 4},
  [1494] = {.lex_state = 2, .external_lex_state = 4},
  [1495] = {.lex_state = 2, .external_lex_state = 4},
  [1496] = {.lex_state = 2, .external_lex_state = 4},
  [1497] = {.lex_state = 2, .external_lex_state = 4},
  [1498] = {.lex_state = 2, .external_lex_state = 4},
  [1499] = {.lex_state = 2, .external_lex_state = 4},
  [1500] = {.lex_state = 2, .external_lex_state = 4},
  [1501] = {.lex_state = 2, .external_lex_state = 4},
  [1502] = {.lex_state = 2, .external_lex_state = 4},
  [1503] = {.lex_state = 2, .external_lex_state = 4},
  [1504] = {.lex_state = 2, .external_lex_state = 4},
  [1505] = {.lex_state = 2, .external_lex_state = 4},
  [1506] = {.lex_state = 2, .external_lex_state = 4},
  [1507] = {.lex_state = 2, .external_lex_state = 4},
  [1508] = {.lex_state = 2, .external_lex_state = 4},
  [1509] = {.lex_state = 2, .external_lex_state = 4},
  [1510] = {.lex_state = 2, .external_lex_state = 4},
  [1511] = {.lex_state = 2, .external_lex_state = 4},
  [1512] = {.lex_state = 2, .external_lex_state = 4},
  [1513] = {.lex_state = 5, .external_lex_state = 4},
  [1514] = {.lex_state = 2, .external_lex_state = 4},
  [1515] = {.lex_state = 2, .external_lex_state = 4},
  [1516] = {.lex_state = 2, .external_lex_state = 4},
  [1517] = {.lex_state = 2, .external_lex_state = 4},
  [1518] = {.lex_state = 2, .external_lex_state = 5},
  [1519] = {.lex_state = 2, .external_lex_state = 4},
  [1520] = {.lex_state = 2, .external_lex_state = 4},
  [1521] = {.lex_state = 2, .external_lex_state = 4},
  [1522] = {.lex_state = 2, .external_lex_state = 4},
  [1523] = {.lex_state = 2, .external_lex_state = 4},
  [1524] = {.lex_state = 2, .external_lex_state = 4},
  [1525] = {.lex_state = 2, .external_lex_state = 4},
  [1526] = {.lex_state = 2, .external_lex_state = 4},
  [1527] = {.lex_state = 52, .external_lex_state = 4},
  [1528] = {.lex_state = 2, .external_lex_state = 5},
  [1529] = {.lex_state = 2, .external_lex_state = 4},
  [1530] = {.lex_state = 2, .external_lex_state = 4},
  [1531] = {.lex_state = 2, .external_lex_state = 4},
  [1532] = {.lex_state = 2, .external_lex_state = 4},
  [1533] = {.lex_state = 2, .external_lex_state = 4},
  [1534] = {.lex_state = 2, .external_lex_state = 4},
  [1535] = {.lex_state = 2, .external_lex_state = 5},
  [1536] = {.lex_state = 2, .external_lex_state = 4},
  [1537] = {.lex_state = 2, .external_lex_state = 4},
  [1538] = {.lex_state = 2, .external_lex_state = 4},
  [1539] = {.lex_state = 2, .external_lex_state = 4},
  [1540] = {.lex_state = 2, .external_lex_state = 4},
  [1541] = {.lex_state = 2, .external_lex_state = 4},
  [1542] = {.lex_state = 2, .external_lex_state = 4},
  [1543] = {.lex_state = 2, .external_lex_state = 4},
  [1544] = {.lex_state = 14, .external_lex_state = 4},
  [1545] = {.lex_state = 2, .external_lex_state = 4},
  [1546] = {.lex_state = 2, .external_lex_state = 4},
  [1547] = {.lex_state = 2, .external_lex_state = 4},
  [1548] = {.lex_state = 2, .external_lex_state = 4},
  [1549] = {.lex_state = 14, .external_lex_state = 4},
  [1550] = {.lex_state = 2, .external_lex_state = 4},
  [1551] = {.lex_state = 2, .external_lex_state = 4},
  [1552] = {.lex_state = 2, .external_lex_state = 4},
  [1553] = {.lex_state = 2, .external_lex_state = 4},
  [1554] = {.lex_state = 2, .external_lex_state = 4},
  [1555] = {.lex_state = 14, .external_lex_state = 4},
  [1556] = {.lex_state = 52, .external_lex_state = 4},
  [1557] = {.lex_state = 2, .external_lex_state = 4},
  [1558] = {.lex_state = 14, .external_lex_state = 4},
  [1559] = {.lex_state = 2, .external_lex_state = 4},
  [1560] = {.lex_state = 14, .external_lex_state = 4},
  [1561] = {.lex_state = 14, .external_lex_state = 4},
  [1562] = {.lex_state = 14, .external_lex_state = 4},
  [1563] = {.lex_state = 14, .external_lex_state = 4},
  [1564] = {.lex_state = 60, .external_lex_state = 4},
  [1565] = {.lex_state = 59, .external_lex_state = 4},
  [1566] = {.lex_state = 59, .external_lex_state = 4},
  [1567] = {.lex_state = 58, .external_lex_state = 4},
  [1568] = {.lex_state = 59, .external_lex_state = 4},
  [1569] = {.lex_state = 59, .external_lex_state = 4},
  [1570] = {.lex_state = 59, .external_lex_state = 4},
  [1571] = {.lex_state = 59, .external_lex_state = 4},
  [1572] = {.lex_state = 59, .external_lex_state = 4},
  [1573] = {.lex_state = 59, .external_lex_state = 4},
  [1574] = {.lex_state = 59, .external_lex_state = 4},
  [1575] = {.lex_state = 59, .external_lex_state = 4},
  [1576] = {.lex_state = 59, .external_lex_state = 4},
  [1577] = {.lex_state = 59, .external_lex_state = 4},
  [1578] = {.lex_state = 58, .external_lex_state = 4},
  [1579] = {.lex_state = 59, .external_lex_state = 4},
  [1580] = {.lex_state = 59, .external_lex_state = 4},
  [1581] = {.lex_state = 59, .external_lex_state = 4},
  [1582] = {.lex_state = 59, .external_lex_state = 4},
  [1583] = {.lex_state = 58, .external_lex_state = 4},
  [1584] = {.lex_state = 58, .external_lex_state = 4},
  [1585] = {.lex_state = 58, .external_lex_state = 4},
  [1586] = {.lex_state = 58, .external_lex_state = 4},
  [1587] = {.lex_state = 58, .external_lex_state = 4},
  [1588] = {.lex_state = 58, .external_lex_state = 4},
  [1589] = {.lex_state = 58, .external_lex_state = 4},
  [1590] = {.lex_state = 10, .external_lex_state = 4},
  [1591] = {.lex_state = 60, .external_lex_state = 4},
  [1592] = {.lex_state = 60, .external_lex_state = 4},
  [1593] = {.lex_state = 60, .external_lex_state = 4},
  [1594] = {.lex_state = 60, .external_lex_state = 4},
  [1595] = {.lex_state = 60, .external_lex_state = 4},
  [1596] = {.lex_state = 60, .external_lex_state = 4},
  [1597] = {.lex_state = 60, .external_lex_state = 4},
  [1598] = {.lex_state = 60, .external_lex_state = 4},
  [1599] = {.lex_state = 60, .external_lex_state = 4},
  [1600] = {.lex_state = 60, .external_lex_state = 4},
  [1601] = {.lex_state = 60, .external_lex_state = 4},
  [1602] = {.lex_state = 60, .external_lex_state = 4},
  [1603] = {.lex_state = 60, .external_lex_state = 4},
  [1604] = {.lex_state = 60, .external_lex_state = 4},
  [1605] = {.lex_state = 60, .external_lex_state = 4},
  [1606] = {.lex_state = 60, .external_lex_state = 4},
  [1607] = {.lex_state = 61, .external_lex_state = 4},
  [1608] = {.lex_state = 61, .external_lex_state = 4},
  [1609] = {.lex_state = 58, .external_lex_state = 4},
  [1610] = {.lex_state = 58, .external_lex_state = 4},
  [1611] = {.lex_state = 61, .external_lex_state = 4},
  [1612] = {.lex_state = 58, .external_lex_state = 4},
  [1613] = {.lex_state = 58, .external_lex_state = 4},
  [1614] = {.lex_state = 58, .external_lex_state = 4},
  [1615] = {.lex_state = 58, .external_lex_state = 4},
  [1616] = {.lex_state = 58, .external_lex_state = 4},
  [1617] = {.lex_state = 58, .external_lex_state = 4},
  [1618] = {.lex_state = 58, .external_lex_state = 4},
  [1619] = {.lex_state = 58, .external_lex_state = 4},
  [1620] = {.lex_state = 58, .external_lex_state = 4},
  [1621] = {.lex_state = 58, .external_lex_state = 4},
  [1622] = {.lex_state = 58, .external_lex_state = 4},
  [1623] = {.lex_state = 58, .external_lex_state = 4},
  [1624] = {.lex_state = 58, .external_lex_state = 4},
  [1625] = {.lex_state = 58, .external_lex_state = 4},
  [1626] = {.lex_state = 10, .external_lex_state = 4},
  [1627] = {.lex_state = 10, .external_lex_state = 4},
  [1628] = {.lex_state = 10, .external_lex_state = 4},
  [1629] = {.lex_state = 10, .external_lex_state = 4},
  [1630] = {.lex_state = 10, .external_lex_state = 4},
  [1631] = {.lex_state = 61, .external_lex_state = 4},
  [1632] = {.lex_state = 14, .external_lex_state = 4},
  [1633] = {.lex_state = 10, .external_lex_state = 4},
  [1634] = {.lex_state = 10, .external_lex_state = 4},
  [1635] = {.lex_state = 61, .external_lex_state = 4},
  [1636] = {.lex_state = 61, .external_lex_state = 4},
  [1637] = {.lex_state = 61, .external_lex_state = 4},
  [1638] = {.lex_state = 61, .external_lex_state = 4},
  [1639] = {.lex_state = 61, .external_lex_state = 4},
  [1640] = {.lex_state = 61, .external_lex_state = 4},
  [1641] = {.lex_state = 61, .external_lex_state = 4},
  [1642] = {.lex_state = 61, .external_lex_state = 4},
  [1643] = {.lex_state = 10, .external_lex_state = 4},
  [1644] = {.lex_state = 61, .external_lex_state = 4},
  [1645] = {.lex_state = 61, .external_lex_state = 4},
  [1646] = {.lex_state = 61, .external_lex_state = 4},
  [1647] = {.lex_state = 61, .external_lex_state = 4},
  [1648] = {.lex_state = 61, .external_lex_state = 4},
  [1649] = {.lex_state = 61, .external_lex_state = 4},
  [1650] = {.lex_state = 61, .external_lex_state = 4},
  [1651] = {.lex_state = 61, .external_lex_state = 4},
  [1652] = {.lex_state = 61, .external_lex_state = 4},
  [1653] = {.lex_state = 14, .external_lex_state = 4},
  [1654] = {.lex_state = 61, .external_lex_state = 4},
  [1655] = {.lex_state = 61, .external_lex_state = 4},
  [1656] = {.lex_state = 61, .external_lex_state = 4},
  [1657] = {.lex_state = 61, .external_lex_state = 4},
  [1658] = {.lex_state = 14, .external_lex_state = 4},
  [1659] = {.lex_state = 14, .external_lex_state = 4},
  [1660] = {.lex_state = 14, .external_lex_state = 4},
  [1661] = {.lex_state = 14, .external_lex_state = 4},
  [1662] = {.lex_state = 14, .external_lex_state = 4},
  [1663] = {.lex_state = 14, .external_lex_state = 4},
  [1664] = {.lex_state = 14, .external_lex_state = 4},
  [1665] = {.lex_state = 10, .external_lex_state = 4},
  [1666] = {.lex_state = 10, .external_lex_state = 4},
  [1667] = {.lex_state = 59, .external_lex_state = 4},
  [1668] = {.lex_state = 10, .external_lex_state = 4},
  [1669] = {.lex_state = 10, .external_lex_state = 4},
  [1670] = {.lex_state = 10, .external_lex_state = 4},
  [1671] = {.lex_state = 10, .external_lex_state = 4},
  [1672] = {.lex_state = 10, .external_lex_state = 4},
  [1673] = {.lex_state = 10, .external_lex_state = 4},
  [1674] = {.lex_state = 10, .external_lex_state = 4},
  [1675] = {.lex_state = 10, .external_lex_state = 4},
  [1676] = {.lex_state = 10, .external_lex_state = 4},
  [1677] = {.lex_state = 10, .external_lex_state = 4},
  [1678] = {.lex_state = 59, .external_lex_state = 4},
  [1679] = {.lex_state = 10, .external_lex_state = 4},
  [1680] = {.lex_state = 10, .external_lex_state = 4},
  [1681] = {.lex_state = 10, .external_lex_state = 4},
  [1682] = {.lex_state = 10, .external_lex_state = 4},
  [1683] = {.lex_state = 59, .external_lex_state = 4},
  [1684] = {.lex_state = 59, .external_lex_state = 4},
  [1685] = {.lex_state = 59, .external_lex_state = 4},
  [1686] = {.lex_state = 59, .external_lex_state = 4},
  [1687] = {.lex_state = 59, .external_lex_state = 4},
  [1688] = {.lex_state = 59, .external_lex_state = 4},
  [1689] = {.lex_state = 59, .external_lex_state = 4},
  [1690] = {.lex_state = 14, .external_lex_state = 4},
  [1691] = {.lex_state = 14, .external_lex_state = 4},
  [1692] = {.lex_state = 60, .external_lex_state = 4},
  [1693] = {.lex_state = 14, .external_lex_state = 4},
  [1694] = {.lex_state = 14, .external_lex_state = 4},
  [1695] = {.lex_state = 14, .external_lex_state = 4},
  [1696] = {.lex_state = 14, .external_lex_state = 4},
  [1697] = {.lex_state = 14, .external_lex_state = 4},
  [1698] = {.lex_state = 14, .external_lex_state = 4},
  [1699] = {.lex_state = 14, .external_lex_state = 4},
  [1700] = {.lex_state = 14, .external_lex_state = 4},
  [1701] = {.lex_state = 14, .external_lex_state = 4},
  [1702] = {.lex_state = 14, .external_lex_state = 4},
  [1703] = {.lex_state = 60, .external_lex_state = 4},
  [1704] = {.lex_state = 14, .external_lex_state = 4},
  [1705] = {.lex_state = 14, .external_lex_state = 4},
  [1706] = {.lex_state = 14, .external_lex_state = 4},
  [1707] = {.lex_state = 14, .external_lex_state = 4},
  [1708] = {.lex_state = 60, .external_lex_state = 4},
  [1709] = {.lex_state = 60, .external_lex_state = 4},
  [1710] = {.lex_state = 60, .external_lex_state = 4},
  [1711] = {.lex_state = 60, .external_lex_state = 4},
  [1712] = {.lex_state = 60, .external_lex_state = 4},
  [1713] = {.lex_state = 60, .external_lex_state = 4},
  [1714] = {.lex_state = 14, .external_lex_state = 4},
  [1715] = {.lex_state = 10, .external_lex_state = 4},
  [1716] = {.lex_state = 14, .external_lex_state = 4},
  [1717] = {.lex_state = 14, .external_lex_state = 4},
  [1718] = {.lex_state = 14, .external_lex_state = 4},
  [1719] = {.lex_state = 10, .external_lex_state = 4},
  [1720] = {.lex_state = 14, .external_lex_state = 4},
  [1721] = {.lex_state = 10, .external_lex_state = 4},
  [1722] = {.lex_state = 10, .external_lex_state = 4},
  [1723] = {.lex_state = 52, .external_lex_state = 4},
  [1724] = {.lex_state = 52, .external_lex_state = 4},
  [1725] = {.lex_state = 52, .external_lex_state = 4},
  [1726] = {.lex_state = 10, .external_lex_state = 4},
  [1727] = {.lex_state = 52, .external_lex_state = 4},
  [1728] = {.lex_state = 52, .external_lex_state = 4},
  [1729] = {.lex_state = 10, .external_lex_state = 4},
  [1730] = {.lex_state = 10, .external_lex_state = 4},
  [1731] = {.lex_state = 52, .external_lex_state = 4},
  [1732] = {.lex_state = 52, .external_lex_state = 4},
  [1733] = {.lex_state = 52, .external_lex_state = 4},
  [1734] = {.lex_state = 52, .external_lex_state = 4},
  [1735] = {.lex_state = 66, .external_lex_state = 3},
  [1736] = {.lex_state = 52, .external_lex_state = 4},
  [1737] = {.lex_state = 66, .external_lex_state = 3},
  [1738] = {.lex_state = 66, .external_lex_state = 3},
  [1739] = {.lex_state = 66, .external_lex_state = 3},
  [1740] = {.lex_state = 52, .external_lex_state = 4},
  [1741] = {.lex_state = 52, .external_lex_state = 4},
  [1742] = {.lex_state = 66, .external_lex_state = 3},
  [1743] = {.lex_state = 52, .external_lex_state = 4},
  [1744] = {.lex_state = 10, .external_lex_state = 4},
  [1745] = {.lex_state = 12, .external_lex_state = 4},
  [1746] = {.lex_state = 52, .external_lex_state = 4},
  [1747] = {.lex_state = 52, .external_lex_state = 4},
  [1748] = {.lex_state = 52, .external_lex_state = 4},
  [1749] = {.lex_state = 52, .external_lex_state = 4},
  [1750] = {.lex_state = 52, .external_lex_state = 4},
  [1751] = {.lex_state = 52, .external_lex_state = 4},
  [1752] = {.lex_state = 52, .external_lex_state = 4},
  [1753] = {.lex_state = 52, .external_lex_state = 4},
  [1754] = {.lex_state = 52, .external_lex_state = 4},
  [1755] = {.lex_state = 52, .external_lex_state = 4},
  [1756] = {.lex_state = 52, .external_lex_state = 4},
  [1757] = {.lex_state = 10, .external_lex_state = 4},
  [1758] = {.lex_state = 52, .external_lex_state = 4},
  [1759] = {.lex_state = 52, .external_lex_state = 4},
  [1760] = {.lex_state = 12, .external_lex_state = 4},
  [1761] = {.lex_state = 52, .external_lex_state = 4},
  [1762] = {.lex_state = 52, .external_lex_state = 4},
  [1763] = {.lex_state = 52, .external_lex_state = 4},
  [1764] = {.lex_state = 10, .external_lex_state = 4},
  [1765] = {.lex_state = 67, .external_lex_state = 3},
  [1766] = {.lex_state = 52, .external_lex_state = 4},
  [1767] = {.lex_state = 52, .external_lex_state = 4},
  [1768] = {.lex_state = 52, .external_lex_state = 4},
  [1769] = {.lex_state = 52, .external_lex_state = 4},
  [1770] = {.lex_state = 52, .external_lex_state = 4},
  [1771] = {.lex_state = 52, .external_lex_state = 4},
  [1772] = {.lex_state = 52, .external_lex_state = 4},
  [1773] = {.lex_state = 52, .external_lex_state = 4},
  [1774] = {.lex_state = 10, .external_lex_state = 4},
  [1775] = {.lex_state = 67, .external_lex_state = 3},
  [1776] = {.lex_state = 52, .external_lex_state = 4},
  [1777] = {.lex_state = 52, .external_lex_state = 4},
  [1778] = {.lex_state = 10, .external_lex_state = 4},
  [1779] = {.lex_state = 52, .external_lex_state = 4},
  [1780] = {.lex_state = 52, .external_lex_state = 4},
  [1781] = {.lex_state = 52, .external_lex_state = 4},
  [1782] = {.lex_state = 52, .external_lex_state = 4},
  [1783] = {.lex_state = 52, .external_lex_state = 4},
  [1784] = {.lex_state = 52, .external_lex_state = 4},
  [1785] = {.lex_state = 52, .external_lex_state = 4},
  [1786] = {.lex_state = 52, .external_lex_state = 4},
  [1787] = {.lex_state = 67, .external_lex_state = 3},
  [1788] = {.lex_state = 67, .external_lex_state = 3},
  [1789] = {.lex_state = 52, .external_lex_state = 4},
  [1790] = {.lex_state = 52, .external_lex_state = 4},
  [1791] = {.lex_state = 55, .external_lex_state = 7},
  [1792] = {.lex_state = 50, .external_lex_state = 8},
  [1793] = {.lex_state = 10, .external_lex_state = 5},
  [1794] = {.lex_state = 10, .external_lex_state = 4},
  [1795] = {.lex_state = 10, .external_lex_state = 4},
  [1796] = {.lex_state = 10, .external_lex_state = 4},
  [1797] = {.lex_state = 10, .external_lex_state = 4},
  [1798] = {.lex_state = 50, .external_lex_state = 8},
  [1799] = {.lex_state = 10, .external_lex_state = 4},
  [1800] = {.lex_state = 10, .external_lex_state = 4},
  [1801] = {.lex_state = 10, .external_lex_state = 5},
  [1802] = {.lex_state = 10, .external_lex_state = 4},
  [1803] = {.lex_state = 10, .external_lex_state = 4},
  [1804] = {.lex_state = 52, .external_lex_state = 4},
  [1805] = {.lex_state = 10, .external_lex_state = 4},
  [1806] = {.lex_state = 52, .external_lex_state = 4},
  [1807] = {.lex_state = 55, .external_lex_state = 7},
  [1808] = {.lex_state = 50, .external_lex_state = 8},
  [1809] = {.lex_state = 55, .external_lex_state = 7},
  [1810] = {.lex_state = 10, .external_lex_state = 4},
  [1811] = {.lex_state = 66, .external_lex_state = 3},
  [1812] = {.lex_state = 66, .external_lex_state = 3},
  [1813] = {.lex_state = 12, .external_lex_state = 4},
  [1814] = {.lex_state = 66, .external_lex_state = 3},
  [1815] = {.lex_state = 52, .external_lex_state = 4},
  [1816] = {.lex_state = 12, .external_lex_state = 4},
  [1817] = {.lex_state = 66, .external_lex_state = 3},
  [1818] = {.lex_state = 12, .external_lex_state = 4},
  [1819] = {.lex_state = 66, .external_lex_state = 3},
  [1820] = {.lex_state = 66, .external_lex_state = 3},
  [1821] = {.lex_state = 66, .external_lex_state = 3},
  [1822] = {.lex_state = 66, .external_lex_state = 3},
  [1823] = {.lex_state = 12, .external_lex_state = 4},
  [1824] = {.lex_state = 10, .external_lex_state = 5},
  [1825] = {.lex_state = 68, .external_lex_state = 4},
  [1826] = {.lex_state = 10, .external_lex_state = 5},
  [1827] = {.lex_state = 50, .external_lex_state = 8},
  [1828] = {.lex_state = 50, .external_lex_state = 8},
  [1829] = {.lex_state = 67, .external_lex_state = 3},
  [1830] = {.lex_state = 10, .external_lex_state = 5},
  [1831] = {.lex_state = 68, .external_lex_state = 4},
  [1832] = {.lex_state = 68, .external_lex_state = 4},
  [1833] = {.lex_state = 10, .external_lex_state = 5},
  [1834] = {.lex_state = 10, .external_lex_state = 5},
  [1835] = {.lex_state = 10, .external_lex_state = 5},
  [1836] = {.lex_state = 50, .external_lex_state = 8},
  [1837] = {.lex_state = 10, .external_lex_state = 5},
  [1838] = {.lex_state = 10, .external_lex_state = 5},
  [1839] = {.lex_state = 13, .external_lex_state = 4},
  [1840] = {.lex_state = 68, .external_lex_state = 4},
  [1841] = {.lex_state = 10, .external_lex_state = 5},
  [1842] = {.lex_state = 66, .external_lex_state = 3},
  [1843] = {.lex_state = 50, .external_lex_state = 8},
  [1844] = {.lex_state = 10, .external_lex_state = 5},
  [1845] = {.lex_state = 13, .external_lex_state = 4},
  [1846] = {.lex_state = 50, .external_lex_state = 8},
  [1847] = {.lex_state = 13, .external_lex_state = 4},
  [1848] = {.lex_state = 13, .external_lex_state = 4},
  [1849] = {.lex_state = 50, .external_lex_state = 8},
  [1850] = {.lex_state = 13, .external_lex_state = 4},
  [1851] = {.lex_state = 50, .external_lex_state = 8},
  [1852] = {.lex_state = 66, .external_lex_state = 3},
  [1853] = {.lex_state = 10, .external_lex_state = 5},
  [1854] = {.lex_state = 13, .external_lex_state = 4},
  [1855] = {.lex_state = 13, .external_lex_state = 4},
  [1856] = {.lex_state = 13, .external_lex_state = 4},
  [1857] = {.lex_state = 13, .external_lex_state = 4},
  [1858] = {.lex_state = 13, .external_lex_state = 4},
  [1859] = {.lex_state = 13, .external_lex_state = 4},
  [1860] = {.lex_state = 13, .external_lex_state = 4},
  [1861] = {.lex_state = 13, .external_lex_state = 4},
  [1862] = {.lex_state = 13, .external_lex_state = 4},
  [1863] = {.lex_state = 13, .external_lex_state = 4},
  [1864] = {.lex_state = 13, .external_lex_state = 4},
  [1865] = {.lex_state = 10, .external_lex_state = 5},
  [1866] = {.lex_state = 50, .external_lex_state = 8},
  [1867] = {.lex_state = 10, .external_lex_state = 4},
  [1868] = {.lex_state = 13, .external_lex_state = 4},
  [1869] = {.lex_state = 0, .external_lex_state = 4},
  [1870] = {.lex_state = 13, .external_lex_state = 4},
  [1871] = {.lex_state = 67, .external_lex_state = 3},
  [1872] = {.lex_state = 13, .external_lex_state = 4},
  [1873] = {.lex_state = 10, .external_lex_state = 5},
  [1874] = {.lex_state = 10, .external_lex_state = 5},
  [1875] = {.lex_state = 10, .external_lex_state = 5},
  [1876] = {.lex_state = 10, .external_lex_state = 5},
  [1877] = {.lex_state = 10, .external_lex_state = 5},
  [1878] = {.lex_state = 10, .external_lex_state = 5},
  [1879] = {.lex_state = 13, .external_lex_state = 4},
  [1880] = {.lex_state = 13, .external_lex_state = 4},
  [1881] = {.lex_state = 13, .external_lex_state = 4},
  [1882] = {.lex_state = 67, .external_lex_state = 3},
  [1883] = {.lex_state = 10, .external_lex_state = 5},
  [1884] = {.lex_state = 67, .external_lex_state = 3},
  [1885] = {.lex_state = 10, .external_lex_state = 5},
  [1886] = {.lex_state = 13, .external_lex_state = 4},
  [1887] = {.lex_state = 13, .external_lex_state = 4},
  [1888] = {.lex_state = 10, .external_lex_state = 5},
  [1889] = {.lex_state = 14, .external_lex_state = 4},
  [1890] = {.lex_state = 10, .external_lex_state = 5},
  [1891] = {.lex_state = 13, .external_lex_state = 4},
  [1892] = {.lex_state = 13, .external_lex_state = 4},
  [1893] = {.lex_state = 13, .external_lex_state = 4},
  [1894] = {.lex_state = 10, .external_lex_state = 5},
  [1895] = {.lex_state = 67, .external_lex_state = 3},
  [1896] = {.lex_state = 67, .external_lex_state = 3},
  [1897] = {.lex_state = 67, .external_lex_state = 3},
  [1898] = {.lex_state = 10, .external_lex_state = 5},
  [1899] = {.lex_state = 0, .external_lex_state = 5},
  [1900] = {.lex_state = 0, .external_lex_state = 4},
  [1901] = {.lex_state = 66, .external_lex_state = 3},
  [1902] = {.lex_state = 10, .external_lex_state = 4},
  [1903] = {.lex_state = 10, .external_lex_state = 3},
  [1904] = {.lex_state = 10, .external_lex_state = 4},
  [1905] = {.lex_state = 69, .external_lex_state = 4},
  [1906] = {.lex_state = 68, .external_lex_state = 4},
  [1907] = {.lex_state = 0, .external_lex_state = 4},
  [1908] = {.lex_state = 0, .external_lex_state = 5},
  [1909] = {.lex_state = 10, .external_lex_state = 4},
  [1910] = {.lex_state = 66, .external_lex_state = 3},
  [1911] = {.lex_state = 0, .external_lex_state = 5},
  [1912] = {.lex_state = 10, .external_lex_state = 5},
  [1913] = {.lex_state = 0, .external_lex_state = 5},
  [1914] = {.lex_state = 10, .external_lex_state = 4},
  [1915] = {.lex_state = 10, .external_lex_state = 4},
  [1916] = {.lex_state = 10, .external_lex_state = 5},
  [1917] = {.lex_state = 10, .external_lex_state = 4},
  [1918] = {.lex_state = 0, .external_lex_state = 4},
  [1919] = {.lex_state = 0, .external_lex_state = 5},
  [1920] = {.lex_state = 10, .external_lex_state = 5},
  [1921] = {.lex_state = 13, .external_lex_state = 4},
  [1922] = {.lex_state = 10, .external_lex_state = 4},
  [1923] = {.lex_state = 0, .external_lex_state = 5},
  [1924] = {.lex_state = 10, .external_lex_state = 3},
  [1925] = {.lex_state = 10, .external_lex_state = 4},
  [1926] = {.lex_state = 61, .external_lex_state = 4},
  [1927] = {.lex_state = 0, .external_lex_state = 4},
  [1928] = {.lex_state = 0, .external_lex_state = 5},
  [1929] = {.lex_state = 0, .external_lex_state = 5},
  [1930] = {.lex_state = 10, .external_lex_state = 5},
  [1931] = {.lex_state = 0, .external_lex_state = 4},
  [1932] = {.lex_state = 67, .external_lex_state = 4},
  [1933] = {.lex_state = 0, .external_lex_state = 4},
  [1934] = {.lex_state = 0, .external_lex_state = 5},
  [1935] = {.lex_state = 59, .external_lex_state = 4},
  [1936] = {.lex_state = 66, .external_lex_state = 4},
  [1937] = {.lex_state = 10, .external_lex_state = 5},
  [1938] = {.lex_state = 60, .external_lex_state = 4},
  [1939] = {.lex_state = 0, .external_lex_state = 4},
  [1940] = {.lex_state = 59, .external_lex_state = 4},
  [1941] = {.lex_state = 67, .external_lex_state = 4},
  [1942] = {.lex_state = 58, .external_lex_state = 4},
  [1943] = {.lex_state = 60, .external_lex_state = 4},
  [1944] = {.lex_state = 0, .external_lex_state = 4},
  [1945] = {.lex_state = 0, .external_lex_state = 4},
  [1946] = {.lex_state = 58, .external_lex_state = 4},
  [1947] = {.lex_state = 58, .external_lex_state = 4},
  [1948] = {.lex_state = 0, .external_lex_state = 5},
  [1949] = {.lex_state = 0, .external_lex_state = 4},
  [1950] = {.lex_state = 0, .external_lex_state = 4},
  [1951] = {.lex_state = 0, .external_lex_state = 4},
  [1952] = {.lex_state = 0, .external_lex_state = 3},
  [1953] = {.lex_state = 0, .external_lex_state = 4},
  [1954] = {.lex_state = 0, .external_lex_state = 5},
  [1955] = {.lex_state = 0, .external_lex_state = 5},
  [1956] = {.lex_state = 0, .external_lex_state = 5},
  [1957] = {.lex_state = 67, .external_lex_state = 4},
  [1958] = {.lex_state = 0, .external_lex_state = 5},
  [1959] = {.lex_state = 0, .external_lex_state = 5},
  [1960] = {.lex_state = 0, .external_lex_state = 4},
  [1961] = {.lex_state = 0, .external_lex_state = 4},
  [1962] = {.lex_state = 0, .external_lex_state = 5},
  [1963] = {.lex_state = 59, .external_lex_state = 4},
  [1964] = {.lex_state = 52, .external_lex_state = 4},
  [1965] = {.lex_state = 60, .external_lex_state = 4},
  [1966] = {.lex_state = 874, .external_lex_state = 4},
  [1967] = {.lex_state = 0, .external_lex_state = 4},
  [1968] = {.lex_state = 0, .external_lex_state = 4},
  [1969] = {.lex_state = 66, .external_lex_state = 4},
  [1970] = {.lex_state = 59, .external_lex_state = 4},
  [1971] = {.lex_state = 66, .external_lex_state = 4},
  [1972] = {.lex_state = 60, .external_lex_state = 4},
  [1973] = {.lex_state = 66, .external_lex_state = 4},
  [1974] = {.lex_state = 0, .external_lex_state = 4},
  [1975] = {.lex_state = 10, .external_lex_state = 5},
  [1976] = {.lex_state = 58, .external_lex_state = 4},
  [1977] = {.lex_state = 58, .external_lex_state = 4},
  [1978] = {.lex_state = 0, .external_lex_state = 4},
  [1979] = {.lex_state = 10, .external_lex_state = 5},
  [1980] = {.lex_state = 10, .external_lex_state = 4},
  [1981] = {.lex_state = 0, .external_lex_state = 4},
  [1982] = {.lex_state = 0, .external_lex_state = 4},
  [1983] = {.lex_state = 61, .external_lex_state = 4},
  [1984] = {.lex_state = 0, .external_lex_state = 5},
  [1985] = {.lex_state = 10, .external_lex_state = 4},
  [1986] = {.lex_state = 0, .external_lex_state = 4},
  [1987] = {.lex_state = 0, .external_lex_state = 3},
  [1988] = {.lex_state = 0, .external_lex_state = 4},
  [1989] = {.lex_state = 0, .external_lex_state = 5},
  [1990] = {.lex_state = 59, .external_lex_state = 4},
  [1991] = {.lex_state = 60, .external_lex_state = 4},
  [1992] = {.lex_state = 0, .external_lex_state = 4},
  [1993] = {.lex_state = 1, .external_lex_state = 4},
  [1994] = {.lex_state = 59, .external_lex_state = 4},
  [1995] = {.lex_state = 0, .external_lex_state = 5},
  [1996] = {.lex_state = 0, .external_lex_state = 4},
  [1997] = {.lex_state = 60, .external_lex_state = 4},
  [1998] = {.lex_state = 10, .external_lex_state = 5},
  [1999] = {.lex_state = 0, .external_lex_state = 4},
  [2000] = {.lex_state = 0, .external_lex_state = 4},
  [2001] = {.lex_state = 58, .external_lex_state = 4},
  [2002] = {.lex_state = 0, .external_lex_state = 4},
  [2003] = {.lex_state = 58, .external_lex_state = 4},
  [2004] = {.lex_state = 13, .external_lex_state = 4},
  [2005] = {.lex_state = 0, .external_lex_state = 4},
  [2006] = {.lex_state = 0, .external_lex_state = 4},
  [2007] = {.lex_state = 0, .external_lex_state = 4},
  [2008] = {.lex_state = 0, .external_lex_state = 3},
  [2009] = {.lex_state = 0, .external_lex_state = 4},
  [2010] = {.lex_state = 0, .external_lex_state = 4},
  [2011] = {.lex_state = 0, .external_lex_state = 4},
  [2012] = {.lex_state = 10, .external_lex_state = 4},
  [2013] = {.lex_state = 0, .external_lex_state = 4},
  [2014] = {.lex_state = 59, .external_lex_state = 4},
  [2015] = {.lex_state = 58, .external_lex_state = 4},
  [2016] = {.lex_state = 60, .external_lex_state = 4},
  [2017] = {.lex_state = 10, .external_lex_state = 4},
  [2018] = {.lex_state = 0, .external_lex_state = 4},
  [2019] = {.lex_state = 0, .external_lex_state = 5},
  [2020] = {.lex_state = 52, .external_lex_state = 4},
  [2021] = {.lex_state = 59, .external_lex_state = 4},
  [2022] = {.lex_state = 11, .external_lex_state = 4},
  [2023] = {.lex_state = 60, .external_lex_state = 4},
  [2024] = {.lex_state = 10, .external_lex_state = 4},
  [2025] = {.lex_state = 61, .external_lex_state = 4},
  [2026] = {.lex_state = 10, .external_lex_state = 4},
  [2027] = {.lex_state = 0, .external_lex_state = 5},
  [2028] = {.lex_state = 10, .external_lex_state = 4},
  [2029] = {.lex_state = 10, .external_lex_state = 4},
  [2030] = {.lex_state = 59, .external_lex_state = 4},
  [2031] = {.lex_state = 14, .external_lex_state = 4},
  [2032] = {.lex_state = 60, .external_lex_state = 4},
  [2033] = {.lex_state = 0, .external_lex_state = 5},
  [2034] = {.lex_state = 66, .external_lex_state = 4},
  [2035] = {.lex_state = 59, .external_lex_state = 4},
  [2036] = {.lex_state = 66, .external_lex_state = 4},
  [2037] = {.lex_state = 60, .external_lex_state = 4},
  [2038] = {.lex_state = 0, .external_lex_state = 4},
  [2039] = {.lex_state = 0, .external_lex_state = 4},
  [2040] = {.lex_state = 0, .external_lex_state = 4},
  [2041] = {.lex_state = 0, .external_lex_state = 5},
  [2042] = {.lex_state = 0, .external_lex_state = 5},
  [2043] = {.lex_state = 0, .external_lex_state = 4},
  [2044] = {.lex_state = 10, .external_lex_state = 4},
  [2045] = {.lex_state = 0, .external_lex_state = 4},
  [2046] = {.lex_state = 0, .external_lex_state = 5},
  [2047] = {.lex_state = 0, .external_lex_state = 5},
  [2048] = {.lex_state = 0, .external_lex_state = 5},
  [2049] = {.lex_state = 11, .external_lex_state = 4},
  [2050] = {.lex_state = 14, .external_lex_state = 4},
  [2051] = {.lex_state = 61, .external_lex_state = 4},
  [2052] = {.lex_state = 59, .external_lex_state = 4},
  [2053] = {.lex_state = 52, .external_lex_state = 4},
  [2054] = {.lex_state = 0, .external_lex_state = 4},
  [2055] = {.lex_state = 60, .external_lex_state = 4},
  [2056] = {.lex_state = 0, .external_lex_state = 4},
  [2057] = {.lex_state = 0, .external_lex_state = 4},
  [2058] = {.lex_state = 10, .external_lex_state = 5},
  [2059] = {.lex_state = 0, .external_lex_state = 4},
  [2060] = {.lex_state = 12, .external_lex_state = 4},
  [2061] = {.lex_state = 59, .external_lex_state = 4},
  [2062] = {.lex_state = 60, .external_lex_state = 4},
  [2063] = {.lex_state = 52, .external_lex_state = 4},
  [2064] = {.lex_state = 0, .external_lex_state = 4},
  [2065] = {.lex_state = 10, .external_lex_state = 5},
  [2066] = {.lex_state = 0, .external_lex_state = 4},
  [2067] = {.lex_state = 0, .external_lex_state = 4},
  [2068] = {.lex_state = 0, .external_lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 5},
  [2070] = {.lex_state = 59, .external_lex_state = 4},
  [2071] = {.lex_state = 52, .external_lex_state = 4},
  [2072] = {.lex_state = 58, .external_lex_state = 4},
  [2073] = {.lex_state = 52, .external_lex_state = 4},
  [2074] = {.lex_state = 10, .external_lex_state = 5},
  [2075] = {.lex_state = 67, .external_lex_state = 4},
  [2076] = {.lex_state = 59, .external_lex_state = 4},
  [2077] = {.lex_state = 52, .external_lex_state = 4},
  [2078] = {.lex_state = 52, .external_lex_state = 4},
  [2079] = {.lex_state = 59, .external_lex_state = 4},
  [2080] = {.lex_state = 60, .external_lex_state = 4},
  [2081] = {.lex_state = 0, .external_lex_state = 4},
  [2082] = {.lex_state = 60, .external_lex_state = 4},
  [2083] = {.lex_state = 0, .external_lex_state = 5},
  [2084] = {.lex_state = 0, .external_lex_state = 5},
  [2085] = {.lex_state = 0, .external_lex_state = 5},
  [2086] = {.lex_state = 52, .external_lex_state = 4},
  [2087] = {.lex_state = 60, .external_lex_state = 4},
  [2088] = {.lex_state = 0, .external_lex_state = 4},
  [2089] = {.lex_state = 10, .external_lex_state = 5},
  [2090] = {.lex_state = 66, .external_lex_state = 4},
  [2091] = {.lex_state = 59, .external_lex_state = 4},
  [2092] = {.lex_state = 0, .external_lex_state = 4},
  [2093] = {.lex_state = 0, .external_lex_state = 5},
  [2094] = {.lex_state = 60, .external_lex_state = 4},
  [2095] = {.lex_state = 0, .external_lex_state = 5},
  [2096] = {.lex_state = 52, .external_lex_state = 4},
  [2097] = {.lex_state = 0, .external_lex_state = 5},
  [2098] = {.lex_state = 58, .external_lex_state = 4},
  [2099] = {.lex_state = 0, .external_lex_state = 4},
  [2100] = {.lex_state = 0, .external_lex_state = 5},
  [2101] = {.lex_state = 52, .external_lex_state = 4},
  [2102] = {.lex_state = 0, .external_lex_state = 4},
  [2103] = {.lex_state = 52, .external_lex_state = 4},
  [2104] = {.lex_state = 58, .external_lex_state = 4},
  [2105] = {.lex_state = 52, .external_lex_state = 4},
  [2106] = {.lex_state = 58, .external_lex_state = 4},
  [2107] = {.lex_state = 0, .external_lex_state = 5},
  [2108] = {.lex_state = 52, .external_lex_state = 4},
  [2109] = {.lex_state = 0, .external_lex_state = 5},
  [2110] = {.lex_state = 0, .external_lex_state = 4},
  [2111] = {.lex_state = 0, .external_lex_state = 4},
  [2112] = {.lex_state = 52, .external_lex_state = 4},
  [2113] = {.lex_state = 0, .external_lex_state = 4},
  [2114] = {.lex_state = 0, .external_lex_state = 5},
  [2115] = {.lex_state = 0, .external_lex_state = 5},
  [2116] = {.lex_state = 59, .external_lex_state = 4},
  [2117] = {.lex_state = 10, .external_lex_state = 5},
  [2118] = {.lex_state = 0, .external_lex_state = 5},
  [2119] = {.lex_state = 58, .external_lex_state = 4},
  [2120] = {.lex_state = 60, .external_lex_state = 4},
  [2121] = {.lex_state = 0, .external_lex_state = 4},
  [2122] = {.lex_state = 52, .external_lex_state = 4},
  [2123] = {.lex_state = 52, .external_lex_state = 4},
  [2124] = {.lex_state = 0, .external_lex_state = 4},
  [2125] = {.lex_state = 0, .external_lex_state = 5},
  [2126] = {.lex_state = 52, .external_lex_state = 4},
  [2127] = {.lex_state = 58, .external_lex_state = 4},
  [2128] = {.lex_state = 66, .external_lex_state = 4},
  [2129] = {.lex_state = 52, .external_lex_state = 4},
  [2130] = {.lex_state = 66, .external_lex_state = 4},
  [2131] = {.lex_state = 66, .external_lex_state = 4},
  [2132] = {.lex_state = 52, .external_lex_state = 4},
  [2133] = {.lex_state = 0, .external_lex_state = 3},
  [2134] = {.lex_state = 52, .external_lex_state = 4},
  [2135] = {.lex_state = 0, .external_lex_state = 5},
  [2136] = {.lex_state = 0, .external_lex_state = 4},
  [2137] = {.lex_state = 10, .external_lex_state = 5},
  [2138] = {.lex_state = 52, .external_lex_state = 4},
  [2139] = {.lex_state = 0, .external_lex_state = 4},
  [2140] = {.lex_state = 10, .external_lex_state = 4},
  [2141] = {.lex_state = 52, .external_lex_state = 4},
  [2142] = {.lex_state = 59, .external_lex_state = 4},
  [2143] = {.lex_state = 0, .external_lex_state = 5},
  [2144] = {.lex_state = 0, .external_lex_state = 4},
  [2145] = {.lex_state = 52, .external_lex_state = 4},
  [2146] = {.lex_state = 60, .external_lex_state = 4},
  [2147] = {.lex_state = 0, .external_lex_state = 5},
  [2148] = {.lex_state = 0, .external_lex_state = 5},
  [2149] = {.lex_state = 52, .external_lex_state = 4},
  [2150] = {.lex_state = 0, .external_lex_state = 5},
  [2151] = {.lex_state = 0, .external_lex_state = 4},
  [2152] = {.lex_state = 0, .external_lex_state = 5},
  [2153] = {.lex_state = 52, .external_lex_state = 4},
  [2154] = {.lex_state = 0, .external_lex_state = 5},
  [2155] = {.lex_state = 0, .external_lex_state = 5},
  [2156] = {.lex_state = 58, .external_lex_state = 4},
  [2157] = {.lex_state = 0, .external_lex_state = 4},
  [2158] = {.lex_state = 0, .external_lex_state = 5},
  [2159] = {.lex_state = 52, .external_lex_state = 4},
  [2160] = {.lex_state = 52, .external_lex_state = 4},
  [2161] = {.lex_state = 0, .external_lex_state = 4},
  [2162] = {.lex_state = 52, .external_lex_state = 4},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 0, .external_lex_state = 4},
  [2165] = {.lex_state = 52, .external_lex_state = 4},
  [2166] = {.lex_state = 0, .external_lex_state = 4},
  [2167] = {.lex_state = 10, .external_lex_state = 5},
  [2168] = {.lex_state = 59, .external_lex_state = 4},
  [2169] = {.lex_state = 0, .external_lex_state = 4},
  [2170] = {.lex_state = 60, .external_lex_state = 4},
  [2171] = {.lex_state = 67, .external_lex_state = 4},
  [2172] = {.lex_state = 52, .external_lex_state = 4},
  [2173] = {.lex_state = 0, .external_lex_state = 4},
  [2174] = {.lex_state = 874, .external_lex_state = 4},
  [2175] = {.lex_state = 0, .external_lex_state = 5},
  [2176] = {.lex_state = 52, .external_lex_state = 4},
  [2177] = {.lex_state = 0, .external_lex_state = 4},
  [2178] = {.lex_state = 0, .external_lex_state = 5},
  [2179] = {.lex_state = 58, .external_lex_state = 4},
  [2180] = {.lex_state = 0, .external_lex_state = 4},
  [2181] = {.lex_state = 52, .external_lex_state = 4},
  [2182] = {.lex_state = 0, .external_lex_state = 5},
  [2183] = {.lex_state = 52, .external_lex_state = 4},
  [2184] = {.lex_state = 52, .external_lex_state = 4},
  [2185] = {.lex_state = 0, .external_lex_state = 5},
  [2186] = {.lex_state = 0, .external_lex_state = 5},
  [2187] = {.lex_state = 52, .external_lex_state = 4},
  [2188] = {.lex_state = 0, .external_lex_state = 4},
  [2189] = {.lex_state = 59, .external_lex_state = 4},
  [2190] = {.lex_state = 0, .external_lex_state = 5},
  [2191] = {.lex_state = 60, .external_lex_state = 4},
  [2192] = {.lex_state = 0, .external_lex_state = 4},
  [2193] = {.lex_state = 0, .external_lex_state = 4},
  [2194] = {.lex_state = 0, .external_lex_state = 4},
  [2195] = {.lex_state = 52, .external_lex_state = 4},
  [2196] = {.lex_state = 59, .external_lex_state = 4},
  [2197] = {.lex_state = 52, .external_lex_state = 4},
  [2198] = {.lex_state = 59, .external_lex_state = 4},
  [2199] = {.lex_state = 0, .external_lex_state = 4},
  [2200] = {.lex_state = 52, .external_lex_state = 4},
  [2201] = {.lex_state = 52, .external_lex_state = 4},
  [2202] = {.lex_state = 60, .external_lex_state = 4},
  [2203] = {.lex_state = 52, .external_lex_state = 4},
  [2204] = {.lex_state = 0, .external_lex_state = 4},
  [2205] = {.lex_state = 0, .external_lex_state = 5},
  [2206] = {.lex_state = 0, .external_lex_state = 5},
  [2207] = {.lex_state = 59, .external_lex_state = 4},
  [2208] = {.lex_state = 0, .external_lex_state = 5},
  [2209] = {.lex_state = 0, .external_lex_state = 5},
  [2210] = {.lex_state = 60, .external_lex_state = 4},
  [2211] = {.lex_state = 0, .external_lex_state = 4},
  [2212] = {.lex_state = 0, .external_lex_state = 4},
  [2213] = {.lex_state = 874, .external_lex_state = 4},
  [2214] = {.lex_state = 0, .external_lex_state = 5},
  [2215] = {.lex_state = 12, .external_lex_state = 4},
  [2216] = {.lex_state = 0, .external_lex_state = 4},
  [2217] = {.lex_state = 10, .external_lex_state = 4},
  [2218] = {.lex_state = 59, .external_lex_state = 4},
  [2219] = {.lex_state = 0, .external_lex_state = 4},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 60, .external_lex_state = 4},
  [2222] = {.lex_state = 0, .external_lex_state = 4},
  [2223] = {.lex_state = 0, .external_lex_state = 4},
  [2224] = {.lex_state = 0, .external_lex_state = 4},
  [2225] = {.lex_state = 0, .external_lex_state = 4},
  [2226] = {.lex_state = 66, .external_lex_state = 4},
  [2227] = {.lex_state = 10, .external_lex_state = 4},
  [2228] = {.lex_state = 10, .external_lex_state = 4},
  [2229] = {.lex_state = 58, .external_lex_state = 4},
  [2230] = {.lex_state = 0, .external_lex_state = 4},
  [2231] = {.lex_state = 0, .external_lex_state = 4},
  [2232] = {.lex_state = 10, .external_lex_state = 4},
  [2233] = {.lex_state = 13, .external_lex_state = 4},
  [2234] = {.lex_state = 10, .external_lex_state = 4},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 58, .external_lex_state = 4},
  [2237] = {.lex_state = 10, .external_lex_state = 4},
  [2238] = {.lex_state = 10, .external_lex_state = 5},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 60, .external_lex_state = 4},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 0, .external_lex_state = 3},
  [2243] = {.lex_state = 52, .external_lex_state = 4},
  [2244] = {.lex_state = 0, .external_lex_state = 5},
  [2245] = {.lex_state = 0, .external_lex_state = 5},
  [2246] = {.lex_state = 10, .external_lex_state = 4},
  [2247] = {.lex_state = 10, .external_lex_state = 4},
  [2248] = {.lex_state = 10, .external_lex_state = 4},
  [2249] = {.lex_state = 10, .external_lex_state = 4},
  [2250] = {.lex_state = 0, .external_lex_state = 4},
  [2251] = {.lex_state = 0, .external_lex_state = 4},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 0, .external_lex_state = 5},
  [2254] = {.lex_state = 0, .external_lex_state = 5},
  [2255] = {.lex_state = 0, .external_lex_state = 4},
  [2256] = {.lex_state = 0, .external_lex_state = 5},
  [2257] = {.lex_state = 10, .external_lex_state = 4},
  [2258] = {.lex_state = 0, .external_lex_state = 4},
  [2259] = {.lex_state = 0, .external_lex_state = 5},
  [2260] = {.lex_state = 0, .external_lex_state = 5},
  [2261] = {.lex_state = 0, .external_lex_state = 5},
  [2262] = {.lex_state = 10, .external_lex_state = 4},
  [2263] = {.lex_state = 0, .external_lex_state = 5},
  [2264] = {.lex_state = 10, .external_lex_state = 4},
  [2265] = {.lex_state = 10, .external_lex_state = 4},
  [2266] = {.lex_state = 10, .external_lex_state = 4},
  [2267] = {.lex_state = 0, .external_lex_state = 4},
  [2268] = {.lex_state = 10, .external_lex_state = 4},
  [2269] = {.lex_state = 14, .external_lex_state = 4},
  [2270] = {.lex_state = 0, .external_lex_state = 4},
  [2271] = {.lex_state = 10, .external_lex_state = 4},
  [2272] = {.lex_state = 10, .external_lex_state = 4},
  [2273] = {.lex_state = 0, .external_lex_state = 4},
  [2274] = {.lex_state = 0, .external_lex_state = 4},
  [2275] = {.lex_state = 21, .external_lex_state = 4},
  [2276] = {.lex_state = 0, .external_lex_state = 5},
  [2277] = {.lex_state = 10, .external_lex_state = 4},
  [2278] = {.lex_state = 0, .external_lex_state = 5},
  [2279] = {.lex_state = 0, .external_lex_state = 4},
  [2280] = {.lex_state = 10, .external_lex_state = 4},
  [2281] = {.lex_state = 0, .external_lex_state = 5},
  [2282] = {.lex_state = 10, .external_lex_state = 4},
  [2283] = {.lex_state = 0, .external_lex_state = 4},
  [2284] = {.lex_state = 0, .external_lex_state = 5},
  [2285] = {.lex_state = 0, .external_lex_state = 4},
  [2286] = {.lex_state = 10, .external_lex_state = 4},
  [2287] = {.lex_state = 0, .external_lex_state = 5},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 874, .external_lex_state = 4},
  [2290] = {.lex_state = 0, .external_lex_state = 5},
  [2291] = {.lex_state = 21, .external_lex_state = 4},
  [2292] = {.lex_state = 0, .external_lex_state = 5},
  [2293] = {.lex_state = 10, .external_lex_state = 4},
  [2294] = {.lex_state = 0, .external_lex_state = 5},
  [2295] = {.lex_state = 10, .external_lex_state = 4},
  [2296] = {.lex_state = 10, .external_lex_state = 4},
  [2297] = {.lex_state = 0, .external_lex_state = 5},
  [2298] = {.lex_state = 0, .external_lex_state = 5},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 0, .external_lex_state = 9},
  [2302] = {.lex_state = 10, .external_lex_state = 4},
  [2303] = {.lex_state = 10, .external_lex_state = 4},
  [2304] = {.lex_state = 0, .external_lex_state = 4},
  [2305] = {.lex_state = 0, .external_lex_state = 5},
  [2306] = {.lex_state = 0, .external_lex_state = 5},
  [2307] = {.lex_state = 0, .external_lex_state = 5},
  [2308] = {.lex_state = 0, .external_lex_state = 4},
  [2309] = {.lex_state = 0, .external_lex_state = 5},
  [2310] = {.lex_state = 0, .external_lex_state = 4},
  [2311] = {.lex_state = 0, .external_lex_state = 4},
  [2312] = {.lex_state = 0, .external_lex_state = 5},
  [2313] = {.lex_state = 0, .external_lex_state = 5},
  [2314] = {.lex_state = 14, .external_lex_state = 4},
  [2315] = {.lex_state = 10, .external_lex_state = 5},
  [2316] = {.lex_state = 0, .external_lex_state = 5},
  [2317] = {.lex_state = 10, .external_lex_state = 4},
  [2318] = {.lex_state = 10, .external_lex_state = 4},
  [2319] = {.lex_state = 0, .external_lex_state = 5},
  [2320] = {.lex_state = 0, .external_lex_state = 4},
  [2321] = {.lex_state = 0, .external_lex_state = 5},
  [2322] = {.lex_state = 0, .external_lex_state = 4},
  [2323] = {.lex_state = 10, .external_lex_state = 4},
  [2324] = {.lex_state = 0, .external_lex_state = 5},
  [2325] = {.lex_state = 1, .external_lex_state = 4},
  [2326] = {.lex_state = 0, .external_lex_state = 4},
  [2327] = {.lex_state = 10, .external_lex_state = 4},
  [2328] = {.lex_state = 10, .external_lex_state = 4},
  [2329] = {.lex_state = 10, .external_lex_state = 4},
  [2330] = {.lex_state = 0, .external_lex_state = 5},
  [2331] = {.lex_state = 14, .external_lex_state = 4},
  [2332] = {.lex_state = 0, .external_lex_state = 5},
  [2333] = {.lex_state = 67, .external_lex_state = 4},
  [2334] = {.lex_state = 874, .external_lex_state = 4},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 0, .external_lex_state = 4},
  [2337] = {.lex_state = 0, .external_lex_state = 4},
  [2338] = {.lex_state = 0, .external_lex_state = 4},
  [2339] = {.lex_state = 0, .external_lex_state = 4},
  [2340] = {.lex_state = 10, .external_lex_state = 5},
  [2341] = {.lex_state = 10, .external_lex_state = 4},
  [2342] = {.lex_state = 10, .external_lex_state = 4},
  [2343] = {.lex_state = 10, .external_lex_state = 5},
  [2344] = {.lex_state = 0, .external_lex_state = 4},
  [2345] = {.lex_state = 0, .external_lex_state = 5},
  [2346] = {.lex_state = 21, .external_lex_state = 4},
  [2347] = {.lex_state = 0, .external_lex_state = 5},
  [2348] = {.lex_state = 0, .external_lex_state = 4},
  [2349] = {.lex_state = 0, .external_lex_state = 5},
  [2350] = {.lex_state = 0, .external_lex_state = 4},
  [2351] = {.lex_state = 10, .external_lex_state = 4},
  [2352] = {.lex_state = 0, .external_lex_state = 4},
  [2353] = {.lex_state = 10, .external_lex_state = 4},
  [2354] = {.lex_state = 10, .external_lex_state = 4},
  [2355] = {.lex_state = 10, .external_lex_state = 4},
  [2356] = {.lex_state = 0, .external_lex_state = 4},
  [2357] = {.lex_state = 0, .external_lex_state = 5},
  [2358] = {.lex_state = 0, .external_lex_state = 5},
  [2359] = {.lex_state = 0, .external_lex_state = 5},
  [2360] = {.lex_state = 0, .external_lex_state = 4},
  [2361] = {.lex_state = 0, .external_lex_state = 4},
  [2362] = {.lex_state = 0, .external_lex_state = 4},
  [2363] = {.lex_state = 0, .external_lex_state = 4},
  [2364] = {.lex_state = 0, .external_lex_state = 4},
  [2365] = {.lex_state = 0, .external_lex_state = 5},
  [2366] = {.lex_state = 0, .external_lex_state = 5},
  [2367] = {.lex_state = 55, .external_lex_state = 4},
  [2368] = {.lex_state = 0, .external_lex_state = 4},
  [2369] = {.lex_state = 0, .external_lex_state = 4},
  [2370] = {.lex_state = 0, .external_lex_state = 4},
  [2371] = {.lex_state = 0, .external_lex_state = 4},
  [2372] = {.lex_state = 0, .external_lex_state = 5},
  [2373] = {.lex_state = 0, .external_lex_state = 8},
  [2374] = {.lex_state = 0, .external_lex_state = 4},
  [2375] = {.lex_state = 0, .external_lex_state = 4},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 0, .external_lex_state = 5},
  [2378] = {.lex_state = 0, .external_lex_state = 5},
  [2379] = {.lex_state = 0, .external_lex_state = 5},
  [2380] = {.lex_state = 0, .external_lex_state = 5},
  [2381] = {.lex_state = 0, .external_lex_state = 5},
  [2382] = {.lex_state = 0, .external_lex_state = 5},
  [2383] = {.lex_state = 0, .external_lex_state = 5},
  [2384] = {.lex_state = 0, .external_lex_state = 5},
  [2385] = {.lex_state = 10, .external_lex_state = 4},
  [2386] = {.lex_state = 0, .external_lex_state = 5},
  [2387] = {.lex_state = 0, .external_lex_state = 5},
  [2388] = {.lex_state = 0, .external_lex_state = 5},
  [2389] = {.lex_state = 0, .external_lex_state = 5},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 0, .external_lex_state = 5},
  [2392] = {.lex_state = 0, .external_lex_state = 5},
  [2393] = {.lex_state = 0, .external_lex_state = 5},
  [2394] = {.lex_state = 0, .external_lex_state = 4},
  [2395] = {.lex_state = 0, .external_lex_state = 4},
  [2396] = {.lex_state = 0, .external_lex_state = 5},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 0, .external_lex_state = 5},
  [2399] = {.lex_state = 0, .external_lex_state = 5},
  [2400] = {.lex_state = 0, .external_lex_state = 5},
  [2401] = {.lex_state = 0, .external_lex_state = 5},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 0, .external_lex_state = 4},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 0, .external_lex_state = 4},
  [2406] = {.lex_state = 0, .external_lex_state = 5},
  [2407] = {.lex_state = 0, .external_lex_state = 5},
  [2408] = {.lex_state = 0, .external_lex_state = 5},
  [2409] = {.lex_state = 0, .external_lex_state = 5},
  [2410] = {.lex_state = 0, .external_lex_state = 5},
  [2411] = {.lex_state = 0, .external_lex_state = 5},
  [2412] = {.lex_state = 0, .external_lex_state = 5},
  [2413] = {.lex_state = 0, .external_lex_state = 4},
  [2414] = {.lex_state = 0, .external_lex_state = 5},
  [2415] = {.lex_state = 0, .external_lex_state = 5},
  [2416] = {.lex_state = 0, .external_lex_state = 5},
  [2417] = {.lex_state = 10, .external_lex_state = 4},
  [2418] = {.lex_state = 0, .external_lex_state = 4},
  [2419] = {.lex_state = 10, .external_lex_state = 4},
  [2420] = {.lex_state = 10, .external_lex_state = 4},
  [2421] = {.lex_state = 0, .external_lex_state = 5},
  [2422] = {.lex_state = 0, .external_lex_state = 4},
  [2423] = {.lex_state = 0, .external_lex_state = 5},
  [2424] = {.lex_state = 0, .external_lex_state = 4},
  [2425] = {.lex_state = 0, .external_lex_state = 5},
  [2426] = {.lex_state = 0, .external_lex_state = 4},
  [2427] = {.lex_state = 0, .external_lex_state = 5},
  [2428] = {.lex_state = 0, .external_lex_state = 5},
  [2429] = {.lex_state = 0, .external_lex_state = 5},
  [2430] = {.lex_state = 0, .external_lex_state = 4},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 0, .external_lex_state = 5},
  [2434] = {.lex_state = 0, .external_lex_state = 5},
  [2435] = {.lex_state = 10, .external_lex_state = 4},
  [2436] = {.lex_state = 0, .external_lex_state = 5},
  [2437] = {.lex_state = 0, .external_lex_state = 5},
  [2438] = {.lex_state = 0, .external_lex_state = 5},
  [2439] = {.lex_state = 0, .external_lex_state = 5},
  [2440] = {.lex_state = 0, .external_lex_state = 5},
  [2441] = {.lex_state = 0, .external_lex_state = 4},
  [2442] = {.lex_state = 0, .external_lex_state = 5},
  [2443] = {.lex_state = 10, .external_lex_state = 4},
  [2444] = {.lex_state = 0, .external_lex_state = 5},
  [2445] = {.lex_state = 0, .external_lex_state = 5},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 0, .external_lex_state = 5},
  [2448] = {.lex_state = 0, .external_lex_state = 5},
  [2449] = {.lex_state = 0, .external_lex_state = 5},
  [2450] = {.lex_state = 0, .external_lex_state = 5},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 0, .external_lex_state = 4},
  [2453] = {.lex_state = 0, .external_lex_state = 5},
  [2454] = {.lex_state = 0, .external_lex_state = 5},
  [2455] = {.lex_state = 0, .external_lex_state = 5},
  [2456] = {.lex_state = 0, .external_lex_state = 5},
  [2457] = {.lex_state = 0, .external_lex_state = 4},
  [2458] = {.lex_state = 0, .external_lex_state = 5},
  [2459] = {.lex_state = 0, .external_lex_state = 5},
  [2460] = {.lex_state = 0, .external_lex_state = 5},
  [2461] = {.lex_state = 0, .external_lex_state = 5},
  [2462] = {.lex_state = 0, .external_lex_state = 5},
  [2463] = {.lex_state = 0, .external_lex_state = 5},
  [2464] = {.lex_state = 0, .external_lex_state = 5},
  [2465] = {.lex_state = 0, .external_lex_state = 5},
  [2466] = {.lex_state = 0, .external_lex_state = 5},
  [2467] = {.lex_state = 0, .external_lex_state = 5},
  [2468] = {.lex_state = 0, .external_lex_state = 5},
  [2469] = {.lex_state = 0, .external_lex_state = 5},
  [2470] = {.lex_state = 10, .external_lex_state = 4},
  [2471] = {.lex_state = 0, .external_lex_state = 5},
  [2472] = {.lex_state = 0, .external_lex_state = 5},
  [2473] = {.lex_state = 0, .external_lex_state = 5},
  [2474] = {.lex_state = 0, .external_lex_state = 5},
  [2475] = {.lex_state = 0, .external_lex_state = 5},
  [2476] = {.lex_state = 0, .external_lex_state = 5},
  [2477] = {.lex_state = 874, .external_lex_state = 4},
  [2478] = {.lex_state = 0, .external_lex_state = 4},
  [2479] = {.lex_state = 10, .external_lex_state = 4},
  [2480] = {.lex_state = 0, .external_lex_state = 5},
  [2481] = {.lex_state = 0, .external_lex_state = 5},
  [2482] = {.lex_state = 0, .external_lex_state = 5},
  [2483] = {.lex_state = 0, .external_lex_state = 5},
  [2484] = {.lex_state = 0, .external_lex_state = 5},
  [2485] = {.lex_state = 0, .external_lex_state = 5},
  [2486] = {.lex_state = 0, .external_lex_state = 5},
  [2487] = {.lex_state = 0, .external_lex_state = 5},
  [2488] = {.lex_state = 0, .external_lex_state = 5},
  [2489] = {.lex_state = 0, .external_lex_state = 5},
  [2490] = {.lex_state = 0, .external_lex_state = 4},
  [2491] = {.lex_state = 0, .external_lex_state = 5},
  [2492] = {.lex_state = 0, .external_lex_state = 5},
  [2493] = {.lex_state = 0, .external_lex_state = 4},
  [2494] = {.lex_state = 0, .external_lex_state = 5},
  [2495] = {.lex_state = 0, .external_lex_state = 5},
  [2496] = {.lex_state = 0, .external_lex_state = 4},
  [2497] = {.lex_state = 0, .external_lex_state = 5},
  [2498] = {.lex_state = 0, .external_lex_state = 5},
  [2499] = {.lex_state = 0, .external_lex_state = 5},
  [2500] = {.lex_state = 0, .external_lex_state = 4},
  [2501] = {.lex_state = 0, .external_lex_state = 5},
  [2502] = {.lex_state = 0, .external_lex_state = 4},
  [2503] = {.lex_state = 0, .external_lex_state = 4},
  [2504] = {.lex_state = 0, .external_lex_state = 5},
  [2505] = {.lex_state = 0, .external_lex_state = 5},
  [2506] = {.lex_state = 0, .external_lex_state = 5},
  [2507] = {.lex_state = 0, .external_lex_state = 5},
  [2508] = {.lex_state = 0, .external_lex_state = 5},
  [2509] = {.lex_state = 0, .external_lex_state = 5},
  [2510] = {.lex_state = 0, .external_lex_state = 5},
  [2511] = {.lex_state = 0, .external_lex_state = 5},
  [2512] = {.lex_state = 10, .external_lex_state = 4},
  [2513] = {.lex_state = 0, .external_lex_state = 5},
  [2514] = {.lex_state = 0, .external_lex_state = 5},
  [2515] = {.lex_state = 0, .external_lex_state = 5},
  [2516] = {.lex_state = 0, .external_lex_state = 5},
  [2517] = {.lex_state = 0, .external_lex_state = 5},
  [2518] = {.lex_state = 0, .external_lex_state = 4},
  [2519] = {.lex_state = 874, .external_lex_state = 4},
  [2520] = {.lex_state = 0, .external_lex_state = 5},
  [2521] = {.lex_state = 0, .external_lex_state = 5},
  [2522] = {.lex_state = 0, .external_lex_state = 5},
  [2523] = {.lex_state = 0, .external_lex_state = 5},
  [2524] = {.lex_state = 0, .external_lex_state = 5},
  [2525] = {.lex_state = 0, .external_lex_state = 5},
  [2526] = {.lex_state = 0, .external_lex_state = 5},
  [2527] = {.lex_state = 0, .external_lex_state = 5},
  [2528] = {.lex_state = 0, .external_lex_state = 5},
  [2529] = {.lex_state = 0, .external_lex_state = 5},
  [2530] = {.lex_state = 0, .external_lex_state = 5},
  [2531] = {.lex_state = 0, .external_lex_state = 5},
  [2532] = {.lex_state = 0, .external_lex_state = 5},
  [2533] = {.lex_state = 0, .external_lex_state = 5},
  [2534] = {.lex_state = 10, .external_lex_state = 4},
  [2535] = {.lex_state = 0, .external_lex_state = 5},
  [2536] = {.lex_state = 0, .external_lex_state = 4},
  [2537] = {.lex_state = 0, .external_lex_state = 5},
  [2538] = {.lex_state = 0, .external_lex_state = 5},
  [2539] = {.lex_state = 0, .external_lex_state = 5},
  [2540] = {.lex_state = 0, .external_lex_state = 5},
  [2541] = {.lex_state = 0, .external_lex_state = 5},
  [2542] = {.lex_state = 0, .external_lex_state = 5},
  [2543] = {.lex_state = 0, .external_lex_state = 5},
  [2544] = {.lex_state = 0, .external_lex_state = 5},
  [2545] = {.lex_state = 10, .external_lex_state = 4},
  [2546] = {.lex_state = 0, .external_lex_state = 5},
  [2547] = {.lex_state = 0, .external_lex_state = 5},
  [2548] = {.lex_state = 0, .external_lex_state = 5},
  [2549] = {.lex_state = 10, .external_lex_state = 4},
  [2550] = {.lex_state = 10, .external_lex_state = 4},
  [2551] = {.lex_state = 0, .external_lex_state = 5},
  [2552] = {.lex_state = 10, .external_lex_state = 4},
  [2553] = {.lex_state = 0, .external_lex_state = 5},
  [2554] = {.lex_state = 0, .external_lex_state = 5},
  [2555] = {.lex_state = 0, .external_lex_state = 5},
  [2556] = {.lex_state = 0, .external_lex_state = 5},
  [2557] = {.lex_state = 0, .external_lex_state = 5},
  [2558] = {.lex_state = 0, .external_lex_state = 5},
  [2559] = {.lex_state = 0, .external_lex_state = 5},
  [2560] = {.lex_state = 0, .external_lex_state = 5},
  [2561] = {.lex_state = 0, .external_lex_state = 5},
  [2562] = {.lex_state = 0, .external_lex_state = 5},
  [2563] = {.lex_state = 0, .external_lex_state = 5},
  [2564] = {.lex_state = 0, .external_lex_state = 4},
  [2565] = {.lex_state = 10, .external_lex_state = 4},
  [2566] = {.lex_state = 0, .external_lex_state = 5},
  [2567] = {.lex_state = 10, .external_lex_state = 4},
  [2568] = {.lex_state = 10, .external_lex_state = 4},
  [2569] = {.lex_state = 10, .external_lex_state = 4},
  [2570] = {.lex_state = 0, .external_lex_state = 4},
  [2571] = {.lex_state = 0, .external_lex_state = 4},
  [2572] = {.lex_state = 0, .external_lex_state = 5},
  [2573] = {.lex_state = 0, .external_lex_state = 4},
  [2574] = {.lex_state = 0, .external_lex_state = 5},
  [2575] = {.lex_state = 0, .external_lex_state = 5},
  [2576] = {.lex_state = 10, .external_lex_state = 4},
  [2577] = {.lex_state = 0, .external_lex_state = 5},
  [2578] = {.lex_state = 0, .external_lex_state = 5},
  [2579] = {.lex_state = 0, .external_lex_state = 5},
  [2580] = {.lex_state = 0, .external_lex_state = 5},
  [2581] = {.lex_state = 0, .external_lex_state = 5},
  [2582] = {.lex_state = 0, .external_lex_state = 5},
  [2583] = {.lex_state = 0, .external_lex_state = 5},
  [2584] = {.lex_state = 0, .external_lex_state = 5},
  [2585] = {.lex_state = 0, .external_lex_state = 5},
  [2586] = {.lex_state = 0, .external_lex_state = 4},
  [2587] = {.lex_state = 0, .external_lex_state = 5},
  [2588] = {.lex_state = 10, .external_lex_state = 4},
  [2589] = {.lex_state = 0, .external_lex_state = 5},
  [2590] = {.lex_state = 0, .external_lex_state = 5},
  [2591] = {.lex_state = 0, .external_lex_state = 5},
  [2592] = {.lex_state = 0, .external_lex_state = 5},
  [2593] = {.lex_state = 0, .external_lex_state = 5},
  [2594] = {.lex_state = 0, .external_lex_state = 5},
  [2595] = {.lex_state = 0, .external_lex_state = 5},
  [2596] = {.lex_state = 0, .external_lex_state = 5},
  [2597] = {.lex_state = 0, .external_lex_state = 5},
  [2598] = {.lex_state = 0, .external_lex_state = 5},
  [2599] = {.lex_state = 0, .external_lex_state = 4},
  [2600] = {.lex_state = 10, .external_lex_state = 4},
  [2601] = {.lex_state = 0, .external_lex_state = 4},
  [2602] = {.lex_state = 0, .external_lex_state = 5},
  [2603] = {.lex_state = 10, .external_lex_state = 4},
  [2604] = {.lex_state = 0, .external_lex_state = 4},
  [2605] = {.lex_state = 0, .external_lex_state = 5},
  [2606] = {.lex_state = 0, .external_lex_state = 5},
  [2607] = {.lex_state = 0, .external_lex_state = 5},
  [2608] = {.lex_state = 0, .external_lex_state = 4},
  [2609] = {.lex_state = 0, .external_lex_state = 5},
  [2610] = {.lex_state = 0, .external_lex_state = 5},
  [2611] = {.lex_state = 0, .external_lex_state = 5},
  [2612] = {.lex_state = 0, .external_lex_state = 5},
  [2613] = {.lex_state = 0, .external_lex_state = 5},
  [2614] = {.lex_state = 0, .external_lex_state = 4},
  [2615] = {.lex_state = 0, .external_lex_state = 4},
  [2616] = {.lex_state = 0, .external_lex_state = 5},
  [2617] = {.lex_state = 0, .external_lex_state = 4},
  [2618] = {.lex_state = 10, .external_lex_state = 4},
  [2619] = {.lex_state = 0, .external_lex_state = 4},
  [2620] = {.lex_state = 0, .external_lex_state = 5},
  [2621] = {.lex_state = 10, .external_lex_state = 4},
  [2622] = {.lex_state = 0, .external_lex_state = 5},
  [2623] = {.lex_state = 0, .external_lex_state = 5},
  [2624] = {.lex_state = 0, .external_lex_state = 5},
  [2625] = {.lex_state = 0, .external_lex_state = 5},
  [2626] = {.lex_state = 0, .external_lex_state = 5},
  [2627] = {.lex_state = 0, .external_lex_state = 5},
  [2628] = {.lex_state = 0, .external_lex_state = 5},
  [2629] = {.lex_state = 0, .external_lex_state = 5},
  [2630] = {.lex_state = 0, .external_lex_state = 5},
  [2631] = {.lex_state = 0, .external_lex_state = 5},
  [2632] = {.lex_state = 0, .external_lex_state = 5},
  [2633] = {.lex_state = 10, .external_lex_state = 4},
  [2634] = {.lex_state = 10, .external_lex_state = 4},
  [2635] = {.lex_state = 0, .external_lex_state = 5},
  [2636] = {.lex_state = 0, .external_lex_state = 5},
  [2637] = {.lex_state = 0, .external_lex_state = 5},
  [2638] = {.lex_state = 0, .external_lex_state = 5},
  [2639] = {.lex_state = 0, .external_lex_state = 5},
  [2640] = {.lex_state = 0, .external_lex_state = 4},
  [2641] = {.lex_state = 0, .external_lex_state = 5},
  [2642] = {.lex_state = 0, .external_lex_state = 5},
  [2643] = {.lex_state = 0, .external_lex_state = 5},
  [2644] = {.lex_state = 0, .external_lex_state = 5},
  [2645] = {.lex_state = 0, .external_lex_state = 5},
  [2646] = {.lex_state = 0, .external_lex_state = 5},
  [2647] = {.lex_state = 0, .external_lex_state = 5},
  [2648] = {.lex_state = 0, .external_lex_state = 5},
  [2649] = {.lex_state = 0, .external_lex_state = 5},
  [2650] = {.lex_state = 0, .external_lex_state = 5},
  [2651] = {.lex_state = 0, .external_lex_state = 5},
  [2652] = {.lex_state = 0, .external_lex_state = 5},
  [2653] = {.lex_state = 0, .external_lex_state = 4},
  [2654] = {.lex_state = 0, .external_lex_state = 5},
  [2655] = {.lex_state = 0, .external_lex_state = 5},
  [2656] = {.lex_state = 0, .external_lex_state = 4},
  [2657] = {.lex_state = 0, .external_lex_state = 5},
  [2658] = {.lex_state = 0, .external_lex_state = 4},
  [2659] = {.lex_state = 0, .external_lex_state = 4},
  [2660] = {.lex_state = 0, .external_lex_state = 4},
  [2661] = {.lex_state = 0, .external_lex_state = 5},
  [2662] = {.lex_state = 0, .external_lex_state = 5},
  [2663] = {.lex_state = 0, .external_lex_state = 5},
  [2664] = {.lex_state = 10, .external_lex_state = 4},
  [2665] = {.lex_state = 0, .external_lex_state = 5},
  [2666] = {.lex_state = 0, .external_lex_state = 5},
  [2667] = {.lex_state = 0, .external_lex_state = 5},
  [2668] = {.lex_state = 0, .external_lex_state = 4},
  [2669] = {.lex_state = 0, .external_lex_state = 4},
  [2670] = {.lex_state = 0, .external_lex_state = 5},
  [2671] = {.lex_state = 0, .external_lex_state = 4},
  [2672] = {.lex_state = 0, .external_lex_state = 5},
  [2673] = {.lex_state = 0, .external_lex_state = 4},
  [2674] = {.lex_state = 0, .external_lex_state = 4},
  [2675] = {.lex_state = 0, .external_lex_state = 5},
  [2676] = {.lex_state = 0, .external_lex_state = 5},
  [2677] = {.lex_state = 0, .external_lex_state = 5},
  [2678] = {.lex_state = 10, .external_lex_state = 4},
  [2679] = {.lex_state = 0, .external_lex_state = 5},
  [2680] = {.lex_state = 0, .external_lex_state = 5},
  [2681] = {.lex_state = 0, .external_lex_state = 5},
  [2682] = {.lex_state = 0, .external_lex_state = 5},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 0, .external_lex_state = 4},
  [2685] = {.lex_state = 0, .external_lex_state = 5},
  [2686] = {.lex_state = 0, .external_lex_state = 5},
  [2687] = {.lex_state = 0, .external_lex_state = 5},
  [2688] = {.lex_state = 0, .external_lex_state = 5},
  [2689] = {.lex_state = 0, .external_lex_state = 5},
  [2690] = {.lex_state = 0, .external_lex_state = 4},
  [2691] = {.lex_state = 10, .external_lex_state = 4},
  [2692] = {.lex_state = 0, .external_lex_state = 5},
  [2693] = {.lex_state = 0, .external_lex_state = 5},
  [2694] = {.lex_state = 0, .external_lex_state = 5},
  [2695] = {.lex_state = 0, .external_lex_state = 5},
  [2696] = {.lex_state = 0, .external_lex_state = 5},
  [2697] = {.lex_state = 0, .external_lex_state = 5},
  [2698] = {.lex_state = 10, .external_lex_state = 4},
  [2699] = {.lex_state = 0, .external_lex_state = 4},
  [2700] = {.lex_state = 21, .external_lex_state = 4},
  [2701] = {.lex_state = 0, .external_lex_state = 5},
  [2702] = {.lex_state = 0, .external_lex_state = 5},
  [2703] = {.lex_state = 0, .external_lex_state = 5},
  [2704] = {.lex_state = 0, .external_lex_state = 5},
  [2705] = {.lex_state = 0, .external_lex_state = 5},
  [2706] = {.lex_state = 0, .external_lex_state = 4},
  [2707] = {.lex_state = 0, .external_lex_state = 4},
  [2708] = {.lex_state = 0, .external_lex_state = 5},
  [2709] = {.lex_state = 0, .external_lex_state = 4},
  [2710] = {.lex_state = 874, .external_lex_state = 4},
  [2711] = {.lex_state = 0, .external_lex_state = 4},
  [2712] = {.lex_state = 0, .external_lex_state = 4},
  [2713] = {.lex_state = 0, .external_lex_state = 5},
  [2714] = {.lex_state = 0, .external_lex_state = 5},
  [2715] = {.lex_state = 0, .external_lex_state = 4},
  [2716] = {.lex_state = 0, .external_lex_state = 5},
  [2717] = {.lex_state = 0, .external_lex_state = 4},
  [2718] = {.lex_state = 0, .external_lex_state = 5},
  [2719] = {.lex_state = 0, .external_lex_state = 5},
  [2720] = {.lex_state = 0, .external_lex_state = 5},
  [2721] = {.lex_state = 0, .external_lex_state = 5},
  [2722] = {.lex_state = 0, .external_lex_state = 5},
  [2723] = {.lex_state = 0, .external_lex_state = 4},
  [2724] = {.lex_state = 0, .external_lex_state = 4},
  [2725] = {.lex_state = 0, .external_lex_state = 5},
  [2726] = {.lex_state = 0, .external_lex_state = 5},
  [2727] = {.lex_state = 0, .external_lex_state = 4},
  [2728] = {.lex_state = 0, .external_lex_state = 5},
  [2729] = {.lex_state = 0, .external_lex_state = 4},
  [2730] = {.lex_state = 0, .external_lex_state = 4},
  [2731] = {.lex_state = 0, .external_lex_state = 5},
  [2732] = {.lex_state = 10, .external_lex_state = 4},
  [2733] = {.lex_state = 0, .external_lex_state = 5},
  [2734] = {.lex_state = 0, .external_lex_state = 5},
  [2735] = {.lex_state = 0, .external_lex_state = 5},
  [2736] = {.lex_state = 0, .external_lex_state = 5},
  [2737] = {.lex_state = 0, .external_lex_state = 4},
  [2738] = {.lex_state = 0, .external_lex_state = 5},
  [2739] = {.lex_state = 0, .external_lex_state = 5},
  [2740] = {.lex_state = 0, .external_lex_state = 4},
  [2741] = {.lex_state = 0, .external_lex_state = 5},
  [2742] = {.lex_state = 0, .external_lex_state = 4},
  [2743] = {.lex_state = 0, .external_lex_state = 5},
  [2744] = {.lex_state = 0, .external_lex_state = 4},
  [2745] = {.lex_state = 0, .external_lex_state = 5},
  [2746] = {.lex_state = 0, .external_lex_state = 5},
  [2747] = {.lex_state = 0, .external_lex_state = 4},
  [2748] = {.lex_state = 0, .external_lex_state = 5},
  [2749] = {.lex_state = 0, .external_lex_state = 4},
  [2750] = {.lex_state = 0, .external_lex_state = 5},
  [2751] = {.lex_state = 0, .external_lex_state = 5},
  [2752] = {.lex_state = 0, .external_lex_state = 5},
  [2753] = {.lex_state = 0, .external_lex_state = 4},
  [2754] = {.lex_state = 0, .external_lex_state = 5},
  [2755] = {.lex_state = 0, .external_lex_state = 5},
  [2756] = {.lex_state = 0, .external_lex_state = 5},
  [2757] = {.lex_state = 0, .external_lex_state = 5},
  [2758] = {.lex_state = 0, .external_lex_state = 5},
  [2759] = {.lex_state = 0, .external_lex_state = 5},
  [2760] = {.lex_state = 0, .external_lex_state = 5},
  [2761] = {.lex_state = 0, .external_lex_state = 5},
  [2762] = {.lex_state = 0, .external_lex_state = 5},
  [2763] = {.lex_state = 0, .external_lex_state = 5},
  [2764] = {.lex_state = 0, .external_lex_state = 5},
  [2765] = {.lex_state = 0, .external_lex_state = 5},
  [2766] = {.lex_state = 0, .external_lex_state = 5},
  [2767] = {.lex_state = 0, .external_lex_state = 5},
  [2768] = {.lex_state = 0, .external_lex_state = 5},
  [2769] = {.lex_state = 0, .external_lex_state = 5},
  [2770] = {.lex_state = 0, .external_lex_state = 5},
  [2771] = {.lex_state = 0, .external_lex_state = 5},
  [2772] = {.lex_state = 0, .external_lex_state = 5},
  [2773] = {.lex_state = 10, .external_lex_state = 4},
  [2774] = {.lex_state = 0, .external_lex_state = 4},
  [2775] = {.lex_state = 10, .external_lex_state = 4},
  [2776] = {.lex_state = 0, .external_lex_state = 5},
  [2777] = {.lex_state = 0, .external_lex_state = 5},
  [2778] = {.lex_state = 0, .external_lex_state = 5},
  [2779] = {.lex_state = 0, .external_lex_state = 5},
  [2780] = {.lex_state = 0, .external_lex_state = 4},
  [2781] = {.lex_state = 0, .external_lex_state = 5},
  [2782] = {.lex_state = 0, .external_lex_state = 5},
  [2783] = {.lex_state = 0, .external_lex_state = 5},
  [2784] = {.lex_state = 0, .external_lex_state = 5},
  [2785] = {.lex_state = 0, .external_lex_state = 5},
  [2786] = {.lex_state = 0, .external_lex_state = 5},
  [2787] = {.lex_state = 10, .external_lex_state = 4},
  [2788] = {.lex_state = 0, .external_lex_state = 5},
  [2789] = {.lex_state = 10, .external_lex_state = 4},
  [2790] = {.lex_state = 0, .external_lex_state = 5},
  [2791] = {.lex_state = 0, .external_lex_state = 5},
  [2792] = {.lex_state = 0, .external_lex_state = 4},
  [2793] = {.lex_state = 71, .external_lex_state = 4},
  [2794] = {.lex_state = 0, .external_lex_state = 4},
  [2795] = {.lex_state = 0, .external_lex_state = 4},
  [2796] = {.lex_state = 0, .external_lex_state = 5},
  [2797] = {.lex_state = 0, .external_lex_state = 5},
  [2798] = {.lex_state = 0, .external_lex_state = 5},
  [2799] = {.lex_state = 0, .external_lex_state = 5},
  [2800] = {.lex_state = 0, .external_lex_state = 4},
  [2801] = {.lex_state = 0, .external_lex_state = 5},
  [2802] = {.lex_state = 0, .external_lex_state = 4},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 0, .external_lex_state = 5},
  [2805] = {.lex_state = 0, .external_lex_state = 4},
  [2806] = {.lex_state = 0, .external_lex_state = 4},
  [2807] = {.lex_state = 0, .external_lex_state = 4},
  [2808] = {.lex_state = 0, .external_lex_state = 5},
  [2809] = {.lex_state = 0, .external_lex_state = 5},
  [2810] = {.lex_state = 0, .external_lex_state = 5},
  [2811] = {.lex_state = 0, .external_lex_state = 5},
  [2812] = {.lex_state = 0, .external_lex_state = 4},
  [2813] = {.lex_state = 0, .external_lex_state = 5},
  [2814] = {.lex_state = 0, .external_lex_state = 5},
  [2815] = {.lex_state = 0, .external_lex_state = 5},
  [2816] = {.lex_state = 0, .external_lex_state = 5},
  [2817] = {.lex_state = 0, .external_lex_state = 4},
  [2818] = {.lex_state = 0, .external_lex_state = 5},
  [2819] = {.lex_state = 0, .external_lex_state = 4},
  [2820] = {.lex_state = 0, .external_lex_state = 5},
  [2821] = {.lex_state = 0, .external_lex_state = 5},
  [2822] = {.lex_state = 0, .external_lex_state = 5},
  [2823] = {.lex_state = 0, .external_lex_state = 5},
  [2824] = {.lex_state = 0, .external_lex_state = 5},
  [2825] = {.lex_state = 874, .external_lex_state = 4},
  [2826] = {.lex_state = 10, .external_lex_state = 4},
  [2827] = {.lex_state = 0, .external_lex_state = 5},
  [2828] = {.lex_state = 10, .external_lex_state = 4},
  [2829] = {.lex_state = 0, .external_lex_state = 5},
  [2830] = {.lex_state = 10, .external_lex_state = 4},
  [2831] = {.lex_state = 0, .external_lex_state = 4},
  [2832] = {.lex_state = 71, .external_lex_state = 4},
  [2833] = {.lex_state = 0, .external_lex_state = 5},
  [2834] = {.lex_state = 0, .external_lex_state = 5},
  [2835] = {.lex_state = 0, .external_lex_state = 5},
  [2836] = {.lex_state = 0, .external_lex_state = 5},
  [2837] = {.lex_state = 0, .external_lex_state = 5},
  [2838] = {.lex_state = 0, .external_lex_state = 5},
  [2839] = {.lex_state = 0, .external_lex_state = 5},
  [2840] = {.lex_state = 0, .external_lex_state = 5},
  [2841] = {.lex_state = 0, .external_lex_state = 4},
  [2842] = {.lex_state = 0, .external_lex_state = 5},
  [2843] = {.lex_state = 10, .external_lex_state = 4},
  [2844] = {.lex_state = 0, .external_lex_state = 5},
  [2845] = {.lex_state = 70, .external_lex_state = 4},
  [2846] = {.lex_state = 0, .external_lex_state = 5},
  [2847] = {.lex_state = 0, .external_lex_state = 5},
  [2848] = {.lex_state = 0, .external_lex_state = 5},
  [2849] = {.lex_state = 0, .external_lex_state = 5},
  [2850] = {.lex_state = 0, .external_lex_state = 5},
  [2851] = {.lex_state = 0, .external_lex_state = 5},
  [2852] = {.lex_state = 0, .external_lex_state = 4},
  [2853] = {.lex_state = 0, .external_lex_state = 5},
  [2854] = {.lex_state = 0, .external_lex_state = 5},
  [2855] = {.lex_state = 0, .external_lex_state = 5},
  [2856] = {.lex_state = 0, .external_lex_state = 5},
  [2857] = {.lex_state = 0, .external_lex_state = 5},
  [2858] = {.lex_state = 0, .external_lex_state = 5},
  [2859] = {.lex_state = 0, .external_lex_state = 5},
  [2860] = {.lex_state = 0, .external_lex_state = 5},
  [2861] = {.lex_state = 10, .external_lex_state = 4},
  [2862] = {.lex_state = 0, .external_lex_state = 5},
  [2863] = {.lex_state = 0, .external_lex_state = 5},
  [2864] = {.lex_state = 0, .external_lex_state = 5},
  [2865] = {.lex_state = 0, .external_lex_state = 4},
  [2866] = {.lex_state = 10, .external_lex_state = 4},
  [2867] = {.lex_state = 0, .external_lex_state = 5},
  [2868] = {.lex_state = 0, .external_lex_state = 5},
  [2869] = {.lex_state = 0, .external_lex_state = 5},
  [2870] = {.lex_state = 0, .external_lex_state = 5},
  [2871] = {.lex_state = 0, .external_lex_state = 5},
  [2872] = {.lex_state = 0, .external_lex_state = 5},
  [2873] = {.lex_state = 0, .external_lex_state = 5},
  [2874] = {.lex_state = 0, .external_lex_state = 5},
  [2875] = {.lex_state = 0, .external_lex_state = 4},
  [2876] = {.lex_state = 10, .external_lex_state = 4},
  [2877] = {.lex_state = 10, .external_lex_state = 4},
  [2878] = {.lex_state = 0, .external_lex_state = 5},
  [2879] = {.lex_state = 0, .external_lex_state = 4},
  [2880] = {.lex_state = 0, .external_lex_state = 5},
  [2881] = {.lex_state = 0, .external_lex_state = 5},
  [2882] = {.lex_state = 0, .external_lex_state = 4},
  [2883] = {.lex_state = 0, .external_lex_state = 5},
  [2884] = {.lex_state = 0, .external_lex_state = 5},
  [2885] = {.lex_state = 10, .external_lex_state = 4},
  [2886] = {.lex_state = 0, .external_lex_state = 5},
  [2887] = {.lex_state = 71, .external_lex_state = 4},
  [2888] = {.lex_state = 10, .external_lex_state = 4},
  [2889] = {.lex_state = 0, .external_lex_state = 4},
  [2890] = {.lex_state = 0, .external_lex_state = 4},
  [2891] = {.lex_state = 0, .external_lex_state = 5},
  [2892] = {.lex_state = 10, .external_lex_state = 4},
  [2893] = {.lex_state = 10, .external_lex_state = 4},
  [2894] = {.lex_state = 10, .external_lex_state = 4},
  [2895] = {.lex_state = 0, .external_lex_state = 4},
  [2896] = {.lex_state = 0, .external_lex_state = 4},
  [2897] = {.lex_state = 10, .external_lex_state = 4},
  [2898] = {.lex_state = 10, .external_lex_state = 4},
  [2899] = {.lex_state = 0, .external_lex_state = 5},
  [2900] = {.lex_state = 10, .external_lex_state = 4},
  [2901] = {.lex_state = 0, .external_lex_state = 5},
  [2902] = {.lex_state = 0, .external_lex_state = 5},
  [2903] = {.lex_state = 0, .external_lex_state = 5},
  [2904] = {.lex_state = 0, .external_lex_state = 5},
  [2905] = {.lex_state = 0, .external_lex_state = 4},
  [2906] = {.lex_state = 0, .external_lex_state = 4},
  [2907] = {.lex_state = 0, .external_lex_state = 4},
  [2908] = {.lex_state = 0, .external_lex_state = 5},
  [2909] = {.lex_state = 0, .external_lex_state = 4},
  [2910] = {.lex_state = 0, .external_lex_state = 5},
  [2911] = {.lex_state = 10, .external_lex_state = 4},
  [2912] = {.lex_state = 0, .external_lex_state = 5},
  [2913] = {.lex_state = 10, .external_lex_state = 4},
  [2914] = {.lex_state = 10, .external_lex_state = 4},
  [2915] = {.lex_state = 10, .external_lex_state = 4},
  [2916] = {.lex_state = 0, .external_lex_state = 5},
  [2917] = {.lex_state = 10, .external_lex_state = 4},
  [2918] = {.lex_state = 0, .external_lex_state = 5},
  [2919] = {(TSStateId)(-1)},
  [2920] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_preproc_file_line] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_program_statement_token1] = ACTIONS(1),
    [aux_sym_end_program_statement_token1] = ACTIONS(1),
    [aux_sym_end_program_statement_token2] = ACTIONS(1),
    [aux_sym_module_statement_token1] = ACTIONS(1),
    [aux_sym_end_module_statement_token1] = ACTIONS(1),
    [aux_sym_submodule_statement_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_end_submodule_statement_token1] = ACTIONS(1),
    [aux_sym_interface_statement_token1] = ACTIONS(1),
    [aux_sym_end_interface_statement_token1] = ACTIONS(1),
    [aux_sym_assignment_token1] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_operator_token1] = ACTIONS(1),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1),
    [aux_sym_defined_io_procedure_token4] = ACTIONS(1),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1),
    [aux_sym_function_statement_token1] = ACTIONS(1),
    [aux_sym_language_binding_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1),
    [aux_sym_procedure_attributes_token2] = ACTIONS(1),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1),
    [aux_sym_procedure_attributes_token4] = ACTIONS(1),
    [aux_sym_procedure_attributes_token5] = ACTIONS(1),
    [aux_sym_end_function_statement_token1] = ACTIONS(1),
    [aux_sym_function_result_token1] = ACTIONS(1),
    [aux_sym_contains_statement_token1] = ACTIONS(1),
    [aux_sym_use_statement_token1] = ACTIONS(1),
    [aux_sym_use_statement_token2] = ACTIONS(1),
    [aux_sym_use_statement_token3] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_included_items_token1] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [aux_sym_implicit_statement_token1] = ACTIONS(1),
    [aux_sym_implicit_statement_token2] = ACTIONS(1),
    [aux_sym_implicit_statement_token3] = ACTIONS(1),
    [aux_sym_implicit_statement_token4] = ACTIONS(1),
    [aux_sym_save_statement_token1] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [aux_sym_private_statement_token1] = ACTIONS(1),
    [aux_sym_public_statement_token1] = ACTIONS(1),
    [aux_sym_namelist_statement_token1] = ACTIONS(1),
    [aux_sym_common_statement_token1] = ACTIONS(1),
    [aux_sym_implicit_range_token1] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [aux_sym_import_statement_token1] = ACTIONS(1),
    [aux_sym__import_names_token1] = ACTIONS(1),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1),
    [aux_sym_base_type_specifier_token1] = ACTIONS(1),
    [aux_sym_end_type_statement_token1] = ACTIONS(1),
    [aux_sym__procedure_kind_token1] = ACTIONS(1),
    [aux_sym__procedure_kind_token2] = ACTIONS(1),
    [aux_sym__procedure_kind_token3] = ACTIONS(1),
    [aux_sym__procedure_kind_token4] = ACTIONS(1),
    [aux_sym_procedure_attribute_token1] = ACTIONS(1),
    [aux_sym_procedure_attribute_token2] = ACTIONS(1),
    [aux_sym_procedure_attribute_token3] = ACTIONS(1),
    [aux_sym_procedure_attribute_token4] = ACTIONS(1),
    [aux_sym_procedure_attribute_token5] = ACTIONS(1),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1),
    [aux_sym_variable_attributes_token1] = ACTIONS(1),
    [aux_sym_variable_attributes_token2] = ACTIONS(1),
    [aux_sym_variable_attributes_token3] = ACTIONS(1),
    [aux_sym_variable_attributes_token4] = ACTIONS(1),
    [aux_sym_variable_attributes_token5] = ACTIONS(1),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1),
    [aux_sym_intrinsic_type_token5] = ACTIONS(1),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1),
    [aux_sym_derived_type_token1] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [aux_sym_size_token1] = ACTIONS(1),
    [aux_sym_type_qualifier_token1] = ACTIONS(1),
    [aux_sym_type_qualifier_token2] = ACTIONS(1),
    [aux_sym_type_qualifier_token3] = ACTIONS(1),
    [aux_sym_type_qualifier_token4] = ACTIONS(1),
    [aux_sym_type_qualifier_token5] = ACTIONS(1),
    [aux_sym_type_qualifier_token6] = ACTIONS(1),
    [aux_sym_type_qualifier_token7] = ACTIONS(1),
    [aux_sym_type_qualifier_token8] = ACTIONS(1),
    [aux_sym_type_qualifier_token9] = ACTIONS(1),
    [aux_sym_type_qualifier_token10] = ACTIONS(1),
    [aux_sym_type_qualifier_token11] = ACTIONS(1),
    [aux_sym_type_qualifier_token12] = ACTIONS(1),
    [aux_sym_type_qualifier_token13] = ACTIONS(1),
    [aux_sym_type_qualifier_token14] = ACTIONS(1),
    [aux_sym_type_qualifier_token15] = ACTIONS(1),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1),
    [aux_sym_stop_statement_token1] = ACTIONS(1),
    [aux_sym_stop_statement_token2] = ACTIONS(1),
    [aux_sym_stop_statement_token3] = ACTIONS(1),
    [aux_sym_subroutine_call_token1] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [aux_sym_keyword_statement_token1] = ACTIONS(1),
    [aux_sym_keyword_statement_token2] = ACTIONS(1),
    [aux_sym_keyword_statement_token3] = ACTIONS(1),
    [aux_sym_keyword_statement_token4] = ACTIONS(1),
    [aux_sym_keyword_statement_token5] = ACTIONS(1),
    [aux_sym_keyword_statement_token6] = ACTIONS(1),
    [aux_sym_keyword_statement_token7] = ACTIONS(1),
    [aux_sym_include_statement_token1] = ACTIONS(1),
    [aux_sym_data_statement_token1] = ACTIONS(1),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(1),
    [aux_sym_while_statement_token1] = ACTIONS(1),
    [aux_sym_concurrent_header_token1] = ACTIONS(1),
    [aux_sym_concurrent_locality_token1] = ACTIONS(1),
    [aux_sym_concurrent_locality_token2] = ACTIONS(1),
    [aux_sym_concurrent_locality_token3] = ACTIONS(1),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1),
    [aux_sym__block_if_statement_token1] = ACTIONS(1),
    [aux_sym_end_if_statement_token1] = ACTIONS(1),
    [aux_sym_elseif_clause_token1] = ACTIONS(1),
    [aux_sym_elseif_clause_token2] = ACTIONS(1),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1),
    [aux_sym_end_where_statement_token1] = ACTIONS(1),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(1),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1),
    [aux_sym_end_forall_statement_token1] = ACTIONS(1),
    [aux_sym_select_case_statement_token1] = ACTIONS(1),
    [aux_sym_select_case_statement_token2] = ACTIONS(1),
    [aux_sym_select_case_statement_token3] = ACTIONS(1),
    [aux_sym_select_type_statement_token1] = ACTIONS(1),
    [aux_sym_select_rank_statement_token1] = ACTIONS(1),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1),
    [aux_sym_end_select_statement_token1] = ACTIONS(1),
    [aux_sym_type_statement_token1] = ACTIONS(1),
    [aux_sym_type_statement_token2] = ACTIONS(1),
    [aux_sym_type_statement_token3] = ACTIONS(1),
    [aux_sym__class_default_token1] = ACTIONS(1),
    [aux_sym_block_construct_token1] = ACTIONS(1),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1),
    [aux_sym_associate_statement_token1] = ACTIONS(1),
    [aux_sym_end_associate_statement_token1] = ACTIONS(1),
    [aux_sym_format_statement_token1] = ACTIONS(1),
    [aux_sym_print_statement_token1] = ACTIONS(1),
    [aux_sym_open_statement_token1] = ACTIONS(1),
    [aux_sym_close_statement_token1] = ACTIONS(1),
    [aux_sym_inquire_statement_token1] = ACTIONS(1),
    [aux_sym_enum_statement_token1] = ACTIONS(1),
    [aux_sym_enumerator_statement_token1] = ACTIONS(1),
    [aux_sym_end_enum_statement_token1] = ACTIONS(1),
    [aux_sym_file_position_statement_token1] = ACTIONS(1),
    [aux_sym_file_position_statement_token2] = ACTIONS(1),
    [aux_sym_file_position_statement_token3] = ACTIONS(1),
    [aux_sym_file_position_statement_token4] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [aux_sym_logical_expression_token1] = ACTIONS(1),
    [aux_sym_logical_expression_token2] = ACTIONS(1),
    [aux_sym_logical_expression_token3] = ACTIONS(1),
    [aux_sym_logical_expression_token4] = ACTIONS(1),
    [aux_sym_logical_expression_token5] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [aux_sym_relational_expression_token1] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [aux_sym_relational_expression_token2] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [aux_sym_relational_expression_token3] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [aux_sym_relational_expression_token4] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [aux_sym_relational_expression_token5] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [aux_sym_relational_expression_token6] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_assumed_rank] = ACTIONS(1),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_boolean_literal] = ACTIONS(1),
    [aux_sym_null_literal_token1] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_preproc_file_line_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1),
    [sym__float_literal] = ACTIONS(1),
    [sym__boz_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym__end_of_statement] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(2571),
    [sym_program] = STATE(258),
    [sym_program_statement] = STATE(9),
    [sym_end_program_statement] = STATE(251),
    [sym_module] = STATE(256),
    [sym_module_statement] = STATE(416),
    [sym_submodule] = STATE(256),
    [sym_submodule_statement] = STATE(417),
    [sym_interface] = STATE(288),
    [sym_interface_statement] = STATE(760),
    [sym_subroutine] = STATE(256),
    [sym_subroutine_statement] = STATE(2670),
    [sym_function] = STATE(256),
    [sym_function_statement] = STATE(2686),
    [aux_sym__callable_interface_qualifers] = STATE(1403),
    [sym_procedure_attributes] = STATE(1730),
    [sym_internal_procedures] = STATE(1926),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(434),
    [sym_intrinsic_type] = STATE(520),
    [sym_derived_type] = STATE(434),
    [sym_type_qualifier] = STATE(458),
    [sym_procedure_qualifier] = STATE(1730),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2682),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(1),
    [sym_identifier] = STATE(1151),
    [aux_sym_translation_unit_repeat1] = STATE(2),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_program_repeat2] = STATE(86),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [ts_builtin_sym_end] = ACTIONS(7),
    [aux_sym_program_statement_token1] = ACTIONS(9),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [aux_sym_module_statement_token1] = ACTIONS(15),
    [aux_sym_submodule_statement_token1] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_subroutine_statement_token1] = ACTIONS(27),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_function_statement_token1] = ACTIONS(31),
    [aux_sym_procedure_attributes_token1] = ACTIONS(33),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(43),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(63),
    [aux_sym_intrinsic_type_token2] = ACTIONS(65),
    [aux_sym_intrinsic_type_token3] = ACTIONS(63),
    [aux_sym_intrinsic_type_token4] = ACTIONS(67),
    [aux_sym_intrinsic_type_token6] = ACTIONS(65),
    [aux_sym_intrinsic_type_token7] = ACTIONS(65),
    [aux_sym_intrinsic_type_token8] = ACTIONS(69),
    [aux_sym_intrinsic_type_token9] = ACTIONS(65),
    [aux_sym_intrinsic_type_token10] = ACTIONS(65),
    [aux_sym_derived_type_token1] = ACTIONS(71),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(81),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [2] = {
    [sym_program] = STATE(279),
    [sym_program_statement] = STATE(9),
    [sym_end_program_statement] = STATE(251),
    [sym_module] = STATE(256),
    [sym_module_statement] = STATE(416),
    [sym_submodule] = STATE(256),
    [sym_submodule_statement] = STATE(417),
    [sym_interface] = STATE(288),
    [sym_interface_statement] = STATE(760),
    [sym_subroutine] = STATE(256),
    [sym_subroutine_statement] = STATE(2670),
    [sym_function] = STATE(256),
    [sym_function_statement] = STATE(2686),
    [aux_sym__callable_interface_qualifers] = STATE(1403),
    [sym_procedure_attributes] = STATE(1730),
    [sym_internal_procedures] = STATE(1926),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(434),
    [sym_intrinsic_type] = STATE(520),
    [sym_derived_type] = STATE(434),
    [sym_type_qualifier] = STATE(458),
    [sym_procedure_qualifier] = STATE(1730),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2682),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(2),
    [sym_identifier] = STATE(1151),
    [aux_sym_translation_unit_repeat1] = STATE(3),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_program_repeat2] = STATE(86),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [ts_builtin_sym_end] = ACTIONS(157),
    [aux_sym_program_statement_token1] = ACTIONS(9),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [aux_sym_module_statement_token1] = ACTIONS(15),
    [aux_sym_submodule_statement_token1] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_subroutine_statement_token1] = ACTIONS(27),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_function_statement_token1] = ACTIONS(31),
    [aux_sym_procedure_attributes_token1] = ACTIONS(33),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(43),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(63),
    [aux_sym_intrinsic_type_token2] = ACTIONS(65),
    [aux_sym_intrinsic_type_token3] = ACTIONS(63),
    [aux_sym_intrinsic_type_token4] = ACTIONS(67),
    [aux_sym_intrinsic_type_token6] = ACTIONS(65),
    [aux_sym_intrinsic_type_token7] = ACTIONS(65),
    [aux_sym_intrinsic_type_token8] = ACTIONS(69),
    [aux_sym_intrinsic_type_token9] = ACTIONS(65),
    [aux_sym_intrinsic_type_token10] = ACTIONS(65),
    [aux_sym_derived_type_token1] = ACTIONS(71),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(81),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(81),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [3] = {
    [sym_program] = STATE(256),
    [sym_program_statement] = STATE(9),
    [sym_end_program_statement] = STATE(251),
    [sym_module] = STATE(256),
    [sym_module_statement] = STATE(416),
    [sym_submodule] = STATE(256),
    [sym_submodule_statement] = STATE(417),
    [sym_interface] = STATE(288),
    [sym_interface_statement] = STATE(760),
    [sym_subroutine] = STATE(256),
    [sym_subroutine_statement] = STATE(2670),
    [sym_function] = STATE(256),
    [sym_function_statement] = STATE(2686),
    [aux_sym__callable_interface_qualifers] = STATE(1403),
    [sym_procedure_attributes] = STATE(1730),
    [sym_internal_procedures] = STATE(1926),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(434),
    [sym_intrinsic_type] = STATE(520),
    [sym_derived_type] = STATE(434),
    [sym_type_qualifier] = STATE(458),
    [sym_procedure_qualifier] = STATE(1730),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2682),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(3),
    [sym_identifier] = STATE(1151),
    [aux_sym_translation_unit_repeat1] = STATE(3),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_program_repeat2] = STATE(86),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [ts_builtin_sym_end] = ACTIONS(159),
    [aux_sym_program_statement_token1] = ACTIONS(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(164),
    [aux_sym_end_program_statement_token2] = ACTIONS(167),
    [aux_sym_module_statement_token1] = ACTIONS(170),
    [aux_sym_submodule_statement_token1] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(176),
    [aux_sym_interface_statement_token1] = ACTIONS(179),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(182),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(185),
    [aux_sym_subroutine_statement_token1] = ACTIONS(188),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(191),
    [aux_sym_function_statement_token1] = ACTIONS(194),
    [aux_sym_procedure_attributes_token1] = ACTIONS(197),
    [aux_sym_procedure_attributes_token3] = ACTIONS(200),
    [aux_sym_contains_statement_token1] = ACTIONS(203),
    [aux_sym_use_statement_token1] = ACTIONS(206),
    [aux_sym_use_statement_token2] = ACTIONS(200),
    [aux_sym_implicit_statement_token1] = ACTIONS(209),
    [aux_sym_implicit_statement_token3] = ACTIONS(212),
    [aux_sym_implicit_statement_token4] = ACTIONS(200),
    [aux_sym_save_statement_token1] = ACTIONS(215),
    [aux_sym_private_statement_token1] = ACTIONS(218),
    [aux_sym_public_statement_token1] = ACTIONS(221),
    [aux_sym_namelist_statement_token1] = ACTIONS(224),
    [aux_sym_common_statement_token1] = ACTIONS(227),
    [anon_sym_DASH] = ACTIONS(230),
    [aux_sym_import_statement_token1] = ACTIONS(233),
    [aux_sym_derived_type_definition_token1] = ACTIONS(236),
    [aux_sym_abstract_specifier_token1] = ACTIONS(239),
    [aux_sym_procedure_attribute_token6] = ACTIONS(200),
    [aux_sym_variable_attributes_token1] = ACTIONS(200),
    [aux_sym_variable_attributes_token2] = ACTIONS(200),
    [aux_sym_variable_attributes_token3] = ACTIONS(200),
    [aux_sym_variable_attributes_token4] = ACTIONS(200),
    [aux_sym_variable_attributes_token5] = ACTIONS(200),
    [aux_sym_intrinsic_type_token1] = ACTIONS(242),
    [aux_sym_intrinsic_type_token2] = ACTIONS(245),
    [aux_sym_intrinsic_type_token3] = ACTIONS(242),
    [aux_sym_intrinsic_type_token4] = ACTIONS(248),
    [aux_sym_intrinsic_type_token6] = ACTIONS(245),
    [aux_sym_intrinsic_type_token7] = ACTIONS(245),
    [aux_sym_intrinsic_type_token8] = ACTIONS(251),
    [aux_sym_intrinsic_type_token9] = ACTIONS(245),
    [aux_sym_intrinsic_type_token10] = ACTIONS(245),
    [aux_sym_derived_type_token1] = ACTIONS(254),
    [aux_sym_type_qualifier_token1] = ACTIONS(200),
    [aux_sym_type_qualifier_token2] = ACTIONS(200),
    [aux_sym_type_qualifier_token3] = ACTIONS(257),
    [aux_sym_type_qualifier_token4] = ACTIONS(200),
    [aux_sym_type_qualifier_token5] = ACTIONS(260),
    [aux_sym_type_qualifier_token9] = ACTIONS(200),
    [aux_sym_type_qualifier_token10] = ACTIONS(263),
    [aux_sym_type_qualifier_token11] = ACTIONS(200),
    [aux_sym_type_qualifier_token12] = ACTIONS(200),
    [aux_sym_type_qualifier_token13] = ACTIONS(266),
    [aux_sym_type_qualifier_token14] = ACTIONS(266),
    [aux_sym_type_qualifier_token15] = ACTIONS(200),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(269),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(269),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(269),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(269),
    [aux_sym_equivalence_statement_token1] = ACTIONS(272),
    [aux_sym_stop_statement_token1] = ACTIONS(275),
    [aux_sym_stop_statement_token2] = ACTIONS(278),
    [aux_sym_subroutine_call_token1] = ACTIONS(281),
    [aux_sym_keyword_statement_token1] = ACTIONS(284),
    [aux_sym_keyword_statement_token2] = ACTIONS(287),
    [aux_sym_keyword_statement_token3] = ACTIONS(287),
    [aux_sym_keyword_statement_token4] = ACTIONS(290),
    [aux_sym_keyword_statement_token6] = ACTIONS(293),
    [aux_sym_keyword_statement_token7] = ACTIONS(284),
    [aux_sym_include_statement_token1] = ACTIONS(296),
    [aux_sym_data_statement_token1] = ACTIONS(299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(302),
    [aux_sym__inline_if_statement_token1] = ACTIONS(305),
    [aux_sym_end_if_statement_token1] = ACTIONS(308),
    [aux_sym_elseif_clause_token2] = ACTIONS(308),
    [aux_sym__inline_where_statement_token1] = ACTIONS(311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(314),
    [aux_sym_select_case_statement_token1] = ACTIONS(317),
    [aux_sym_select_case_statement_token3] = ACTIONS(320),
    [aux_sym_select_type_statement_token1] = ACTIONS(323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(326),
    [aux_sym_block_construct_token1] = ACTIONS(329),
    [aux_sym_associate_statement_token1] = ACTIONS(332),
    [aux_sym_format_statement_token1] = ACTIONS(335),
    [aux_sym_print_statement_token1] = ACTIONS(338),
    [aux_sym_open_statement_token1] = ACTIONS(341),
    [aux_sym_close_statement_token1] = ACTIONS(344),
    [aux_sym_inquire_statement_token1] = ACTIONS(347),
    [aux_sym_enum_statement_token1] = ACTIONS(350),
    [aux_sym_file_position_statement_token1] = ACTIONS(353),
    [aux_sym_file_position_statement_token2] = ACTIONS(353),
    [aux_sym_file_position_statement_token3] = ACTIONS(353),
    [aux_sym_file_position_statement_token4] = ACTIONS(356),
    [aux_sym_logical_expression_token5] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(230),
    [anon_sym_DOT] = ACTIONS(362),
    [anon_sym_LPAREN_SLASH] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(368),
    [sym_boolean_literal] = ACTIONS(371),
    [aux_sym_null_literal_token1] = ACTIONS(374),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(308),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(377),
    [sym__float_literal] = ACTIONS(380),
    [sym__boz_literal] = ACTIONS(380),
    [sym_string_literal] = ACTIONS(371),
  },
  [4] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1565),
    [sym_internal_procedures] = STATE(2168),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(4),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(39),
    [aux_sym_program_repeat2] = STATE(123),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(385),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [5] = {
    [sym_end_program_statement] = STATE(242),
    [sym_interface] = STATE(370),
    [sym_interface_statement] = STATE(762),
    [sym_internal_procedures] = STATE(1983),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2622),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(5),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(58),
    [aux_sym_program_repeat2] = STATE(137),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [6] = {
    [sym_end_program_statement] = STATE(249),
    [sym_interface] = STATE(370),
    [sym_interface_statement] = STATE(762),
    [sym_internal_procedures] = STATE(2025),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2622),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(6),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(58),
    [aux_sym_program_repeat2] = STATE(93),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [7] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(274),
    [sym_internal_procedures] = STATE(2070),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(7),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_program_repeat2] = STATE(94),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(403),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [8] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(238),
    [sym_internal_procedures] = STATE(2087),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(8),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_program_repeat2] = STATE(95),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(407),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [9] = {
    [sym_end_program_statement] = STATE(242),
    [sym_interface] = STATE(370),
    [sym_interface_statement] = STATE(762),
    [sym_internal_procedures] = STATE(1983),
    [sym_contains_statement] = STATE(2575),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(227),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2622),
    [sym_data_statement] = STATE(2635),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(9),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_program_repeat2] = STATE(137),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [10] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(252),
    [sym_internal_procedures] = STATE(2079),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(10),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(122),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(403),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [11] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(259),
    [sym_internal_procedures] = STATE(2082),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(11),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(126),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(407),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [12] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1635),
    [sym_internal_procedures] = STATE(1942),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(12),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_program_repeat2] = STATE(87),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(411),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [13] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1637),
    [sym_internal_procedures] = STATE(2015),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(13),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(90),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(411),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [14] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1615),
    [sym_internal_procedures] = STATE(2032),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(14),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(136),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(415),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [15] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1163),
    [sym_internal_procedures] = STATE(2062),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(15),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_program_repeat2] = STATE(97),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(419),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [16] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1176),
    [sym_internal_procedures] = STATE(2052),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(16),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(98),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(423),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [17] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1179),
    [sym_internal_procedures] = STATE(2055),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(17),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(99),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(419),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [18] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1590),
    [sym_internal_procedures] = STATE(2072),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(18),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_program_repeat2] = STATE(100),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(427),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [19] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1627),
    [sym_internal_procedures] = STATE(2098),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(19),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(101),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(427),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [20] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1640),
    [sym_internal_procedures] = STATE(2091),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(20),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_program_repeat2] = STATE(102),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(431),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [21] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1641),
    [sym_internal_procedures] = STATE(2094),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(21),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_program_repeat2] = STATE(103),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(435),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [22] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1644),
    [sym_internal_procedures] = STATE(2198),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(22),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(104),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(431),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [23] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1646),
    [sym_internal_procedures] = STATE(2202),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(23),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(105),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(435),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [24] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1653),
    [sym_internal_procedures] = STATE(2104),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(24),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_program_repeat2] = STATE(107),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(439),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [25] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1659),
    [sym_internal_procedures] = STATE(2229),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(25),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(108),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(439),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [26] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1665),
    [sym_internal_procedures] = STATE(2116),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(26),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_program_repeat2] = STATE(110),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(443),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [27] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1666),
    [sym_internal_procedures] = STATE(2120),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(27),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_program_repeat2] = STATE(111),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(447),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [28] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1669),
    [sym_internal_procedures] = STATE(1935),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(28),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(112),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(443),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [29] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1671),
    [sym_internal_procedures] = STATE(1938),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(29),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(113),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(447),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [30] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1678),
    [sym_internal_procedures] = STATE(2127),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(30),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(31),
    [aux_sym_program_repeat2] = STATE(114),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(451),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [31] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1684),
    [sym_internal_procedures] = STATE(1946),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(31),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(115),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(451),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [32] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1690),
    [sym_internal_procedures] = STATE(2142),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(32),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(34),
    [aux_sym_program_repeat2] = STATE(116),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(455),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [33] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1691),
    [sym_internal_procedures] = STATE(2146),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(33),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(35),
    [aux_sym_program_repeat2] = STATE(117),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(459),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [34] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1694),
    [sym_internal_procedures] = STATE(1963),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(34),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(118),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(455),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [35] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1696),
    [sym_internal_procedures] = STATE(1965),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(35),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(119),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(459),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [36] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1703),
    [sym_internal_procedures] = STATE(2156),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(36),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(37),
    [aux_sym_program_repeat2] = STATE(120),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(463),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [37] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1709),
    [sym_internal_procedures] = STATE(1976),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(37),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(121),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(463),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [38] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1566),
    [sym_internal_procedures] = STATE(2170),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(38),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(40),
    [aux_sym_program_repeat2] = STATE(85),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(467),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [39] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1569),
    [sym_internal_procedures] = STATE(1990),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(39),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(124),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(385),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [40] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1571),
    [sym_internal_procedures] = STATE(1991),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(40),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(125),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(467),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [41] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1578),
    [sym_internal_procedures] = STATE(2179),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(41),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(42),
    [aux_sym_program_repeat2] = STATE(127),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(471),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [42] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym_end_module_procedure_statement] = STATE(1584),
    [sym_internal_procedures] = STATE(2001),
    [sym_contains_statement] = STATE(2609),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(231),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2543),
    [sym_data_statement] = STATE(2679),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(42),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_program_repeat2] = STATE(128),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(471),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [43] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1591),
    [sym_internal_procedures] = STATE(2189),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(43),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_program_repeat2] = STATE(129),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(475),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [44] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1592),
    [sym_internal_procedures] = STATE(2191),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(44),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(46),
    [aux_sym_program_repeat2] = STATE(130),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(479),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [45] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1594),
    [sym_internal_procedures] = STATE(2014),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(45),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(131),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(475),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [46] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1596),
    [sym_internal_procedures] = STATE(2016),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(46),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_program_repeat2] = STATE(132),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(479),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [47] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1609),
    [sym_internal_procedures] = STATE(2207),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(47),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(49),
    [aux_sym_program_repeat2] = STATE(133),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(483),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [48] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym_end_function_statement] = STATE(1610),
    [sym_internal_procedures] = STATE(2210),
    [sym_contains_statement] = STATE(2538),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(230),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2471),
    [sym_data_statement] = STATE(2610),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(48),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_program_repeat2] = STATE(134),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_end_function_statement_token1] = ACTIONS(415),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [49] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1613),
    [sym_internal_procedures] = STATE(2030),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(49),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_program_repeat2] = STATE(135),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(483),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [50] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym_end_subroutine_statement] = STATE(1162),
    [sym_internal_procedures] = STATE(2061),
    [sym_contains_statement] = STATE(2466),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(229),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2386),
    [sym_data_statement] = STATE(2539),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(50),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_program_repeat2] = STATE(96),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(423),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [51] = {
    [sym_interface] = STATE(415),
    [sym_interface_statement] = STATE(770),
    [sym__specification_part] = STATE(414),
    [sym_use_statement] = STATE(2467),
    [sym_implicit_statement] = STATE(2467),
    [sym_save_statement] = STATE(2467),
    [sym_private_statement] = STATE(2467),
    [sym_public_statement] = STATE(2467),
    [sym_namelist_statement] = STATE(2467),
    [sym_common_statement] = STATE(2467),
    [sym_import_statement] = STATE(2467),
    [sym_derived_type_definition] = STATE(415),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(990),
    [sym_variable_declaration] = STATE(2467),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2467),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2467),
    [sym_equivalence_statement] = STATE(2467),
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(228),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2675),
    [sym_data_statement] = STATE(2467),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2785),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(415),
    [sym_enum_statement] = STATE(1856),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(51),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(53),
    [aux_sym_program_repeat2] = STATE(154),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [52] = {
    [sym_interface] = STATE(415),
    [sym_interface_statement] = STATE(770),
    [sym__specification_part] = STATE(414),
    [sym_use_statement] = STATE(2467),
    [sym_implicit_statement] = STATE(2467),
    [sym_save_statement] = STATE(2467),
    [sym_private_statement] = STATE(2467),
    [sym_public_statement] = STATE(2467),
    [sym_namelist_statement] = STATE(2467),
    [sym_common_statement] = STATE(2467),
    [sym_import_statement] = STATE(2467),
    [sym_derived_type_definition] = STATE(415),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(990),
    [sym_variable_declaration] = STATE(2467),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2467),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2467),
    [sym_equivalence_statement] = STATE(2467),
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(228),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2675),
    [sym_data_statement] = STATE(2467),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2416),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(415),
    [sym_enum_statement] = STATE(1856),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(52),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_program_repeat2] = STATE(183),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [53] = {
    [sym_interface] = STATE(415),
    [sym_interface_statement] = STATE(770),
    [sym__specification_part] = STATE(414),
    [sym_use_statement] = STATE(2467),
    [sym_implicit_statement] = STATE(2467),
    [sym_save_statement] = STATE(2467),
    [sym_private_statement] = STATE(2467),
    [sym_public_statement] = STATE(2467),
    [sym_namelist_statement] = STATE(2467),
    [sym_common_statement] = STATE(2467),
    [sym_import_statement] = STATE(2467),
    [sym_derived_type_definition] = STATE(415),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(990),
    [sym_variable_declaration] = STATE(2467),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2467),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2467),
    [sym_equivalence_statement] = STATE(2467),
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(228),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2675),
    [sym_data_statement] = STATE(2467),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2607),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(415),
    [sym_enum_statement] = STATE(1856),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(53),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_program_repeat2] = STATE(174),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [54] = {
    [sym_interface] = STATE(415),
    [sym_interface_statement] = STATE(770),
    [sym__specification_part] = STATE(414),
    [sym_use_statement] = STATE(2467),
    [sym_implicit_statement] = STATE(2467),
    [sym_save_statement] = STATE(2467),
    [sym_private_statement] = STATE(2467),
    [sym_public_statement] = STATE(2467),
    [sym_namelist_statement] = STATE(2467),
    [sym_common_statement] = STATE(2467),
    [sym_import_statement] = STATE(2467),
    [sym_derived_type_definition] = STATE(415),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(990),
    [sym_variable_declaration] = STATE(2467),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2467),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2467),
    [sym_equivalence_statement] = STATE(2467),
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(228),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2675),
    [sym_data_statement] = STATE(2467),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2607),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_enum] = STATE(415),
    [sym_enum_statement] = STATE(1856),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(54),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat1] = STATE(52),
    [aux_sym_program_repeat2] = STATE(174),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_interface_statement_token1] = ACTIONS(21),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(29),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_use_statement_token1] = ACTIONS(39),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [aux_sym_implicit_statement_token1] = ACTIONS(41),
    [aux_sym_implicit_statement_token3] = ACTIONS(389),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(45),
    [aux_sym_private_statement_token1] = ACTIONS(47),
    [aux_sym_public_statement_token1] = ACTIONS(49),
    [aux_sym_namelist_statement_token1] = ACTIONS(51),
    [aux_sym_common_statement_token1] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_import_statement_token1] = ACTIONS(57),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(61),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(391),
    [aux_sym_intrinsic_type_token2] = ACTIONS(393),
    [aux_sym_intrinsic_type_token3] = ACTIONS(391),
    [aux_sym_intrinsic_type_token4] = ACTIONS(395),
    [aux_sym_intrinsic_type_token6] = ACTIONS(393),
    [aux_sym_intrinsic_type_token7] = ACTIONS(393),
    [aux_sym_intrinsic_type_token8] = ACTIONS(397),
    [aux_sym_intrinsic_type_token9] = ACTIONS(393),
    [aux_sym_intrinsic_type_token10] = ACTIONS(393),
    [aux_sym_derived_type_token1] = ACTIONS(399),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(77),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(79),
    [aux_sym_type_qualifier_token14] = ACTIONS(79),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_equivalence_statement_token1] = ACTIONS(83),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(101),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_enum_statement_token1] = ACTIONS(135),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(153),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [55] = {
    [sym_interface] = STATE(298),
    [sym_interface_statement] = STATE(758),
    [sym__specification_part] = STATE(297),
    [sym_use_statement] = STATE(2539),
    [sym_implicit_statement] = STATE(2539),
    [sym_save_statement] = STATE(2539),
    [sym_private_statement] = STATE(2539),
    [sym_public_statement] = STATE(2539),
    [sym_namelist_statement] = STATE(2539),
    [sym_common_statement] = STATE(2539),
    [sym_import_statement] = STATE(2539),
    [sym_derived_type_definition] = STATE(298),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(934),
    [sym_variable_declaration] = STATE(2539),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2539),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2539),
    [sym_equivalence_statement] = STATE(2539),
    [sym_statement_label] = STATE(2232),
    [sym_include_statement] = STATE(2539),
    [sym_data_statement] = STATE(2539),
    [sym_enum] = STATE(298),
    [sym_enum_statement] = STATE(1858),
    [sym_preproc_file_line] = STATE(55),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(489),
    [aux_sym_interface_statement_token1] = ACTIONS(491),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(489),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(489),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(489),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(494),
    [aux_sym_procedure_attributes_token1] = ACTIONS(497),
    [aux_sym_procedure_attributes_token3] = ACTIONS(500),
    [aux_sym_contains_statement_token1] = ACTIONS(489),
    [aux_sym_use_statement_token1] = ACTIONS(503),
    [aux_sym_use_statement_token2] = ACTIONS(500),
    [aux_sym_implicit_statement_token1] = ACTIONS(506),
    [aux_sym_implicit_statement_token3] = ACTIONS(509),
    [aux_sym_implicit_statement_token4] = ACTIONS(500),
    [aux_sym_save_statement_token1] = ACTIONS(512),
    [aux_sym_private_statement_token1] = ACTIONS(515),
    [aux_sym_public_statement_token1] = ACTIONS(518),
    [aux_sym_namelist_statement_token1] = ACTIONS(521),
    [aux_sym_common_statement_token1] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(527),
    [aux_sym_import_statement_token1] = ACTIONS(529),
    [aux_sym_derived_type_definition_token1] = ACTIONS(532),
    [aux_sym_abstract_specifier_token1] = ACTIONS(535),
    [aux_sym_procedure_attribute_token6] = ACTIONS(500),
    [aux_sym_variable_attributes_token1] = ACTIONS(500),
    [aux_sym_variable_attributes_token2] = ACTIONS(500),
    [aux_sym_variable_attributes_token3] = ACTIONS(500),
    [aux_sym_variable_attributes_token4] = ACTIONS(500),
    [aux_sym_variable_attributes_token5] = ACTIONS(500),
    [aux_sym_intrinsic_type_token1] = ACTIONS(538),
    [aux_sym_intrinsic_type_token2] = ACTIONS(538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(538),
    [aux_sym_intrinsic_type_token7] = ACTIONS(538),
    [aux_sym_intrinsic_type_token8] = ACTIONS(544),
    [aux_sym_intrinsic_type_token9] = ACTIONS(538),
    [aux_sym_intrinsic_type_token10] = ACTIONS(538),
    [aux_sym_derived_type_token1] = ACTIONS(547),
    [aux_sym_type_qualifier_token1] = ACTIONS(500),
    [aux_sym_type_qualifier_token2] = ACTIONS(500),
    [aux_sym_type_qualifier_token3] = ACTIONS(550),
    [aux_sym_type_qualifier_token4] = ACTIONS(500),
    [aux_sym_type_qualifier_token5] = ACTIONS(553),
    [aux_sym_type_qualifier_token9] = ACTIONS(500),
    [aux_sym_type_qualifier_token10] = ACTIONS(556),
    [aux_sym_type_qualifier_token11] = ACTIONS(500),
    [aux_sym_type_qualifier_token12] = ACTIONS(500),
    [aux_sym_type_qualifier_token13] = ACTIONS(500),
    [aux_sym_type_qualifier_token14] = ACTIONS(500),
    [aux_sym_type_qualifier_token15] = ACTIONS(500),
    [aux_sym_equivalence_statement_token1] = ACTIONS(559),
    [aux_sym_stop_statement_token1] = ACTIONS(489),
    [aux_sym_stop_statement_token2] = ACTIONS(489),
    [aux_sym_subroutine_call_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token2] = ACTIONS(489),
    [aux_sym_keyword_statement_token3] = ACTIONS(489),
    [aux_sym_keyword_statement_token4] = ACTIONS(489),
    [aux_sym_keyword_statement_token6] = ACTIONS(489),
    [aux_sym_keyword_statement_token7] = ACTIONS(489),
    [aux_sym_include_statement_token1] = ACTIONS(562),
    [aux_sym_data_statement_token1] = ACTIONS(565),
    [aux_sym_do_loop_statement_token1] = ACTIONS(489),
    [aux_sym__inline_if_statement_token1] = ACTIONS(489),
    [aux_sym_end_if_statement_token1] = ACTIONS(489),
    [aux_sym_elseif_clause_token2] = ACTIONS(489),
    [aux_sym__inline_where_statement_token1] = ACTIONS(489),
    [aux_sym__forall_control_expression_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token3] = ACTIONS(489),
    [aux_sym_select_type_statement_token1] = ACTIONS(489),
    [aux_sym_select_rank_statement_token2] = ACTIONS(489),
    [aux_sym_block_construct_token1] = ACTIONS(489),
    [aux_sym_associate_statement_token1] = ACTIONS(489),
    [aux_sym_format_statement_token1] = ACTIONS(489),
    [aux_sym_print_statement_token1] = ACTIONS(489),
    [aux_sym_open_statement_token1] = ACTIONS(489),
    [aux_sym_close_statement_token1] = ACTIONS(489),
    [aux_sym_inquire_statement_token1] = ACTIONS(489),
    [aux_sym_enum_statement_token1] = ACTIONS(568),
    [aux_sym_file_position_statement_token1] = ACTIONS(489),
    [aux_sym_file_position_statement_token2] = ACTIONS(489),
    [aux_sym_file_position_statement_token3] = ACTIONS(489),
    [aux_sym_file_position_statement_token4] = ACTIONS(489),
    [aux_sym_logical_expression_token5] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_LPAREN_SLASH] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [sym_boolean_literal] = ACTIONS(527),
    [aux_sym_null_literal_token1] = ACTIONS(489),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(489),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
    [sym__float_literal] = ACTIONS(527),
    [sym__boz_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(527),
  },
  [56] = {
    [sym_interface] = STATE(339),
    [sym_interface_statement] = STATE(755),
    [sym__specification_part] = STATE(338),
    [sym_use_statement] = STATE(2679),
    [sym_implicit_statement] = STATE(2679),
    [sym_save_statement] = STATE(2679),
    [sym_private_statement] = STATE(2679),
    [sym_public_statement] = STATE(2679),
    [sym_namelist_statement] = STATE(2679),
    [sym_common_statement] = STATE(2679),
    [sym_import_statement] = STATE(2679),
    [sym_derived_type_definition] = STATE(339),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(992),
    [sym_variable_declaration] = STATE(2679),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2679),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2679),
    [sym_equivalence_statement] = STATE(2679),
    [sym_statement_label] = STATE(2237),
    [sym_include_statement] = STATE(2679),
    [sym_data_statement] = STATE(2679),
    [sym_enum] = STATE(339),
    [sym_enum_statement] = STATE(1862),
    [sym_preproc_file_line] = STATE(56),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(489),
    [aux_sym_interface_statement_token1] = ACTIONS(491),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(489),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(489),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(494),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(489),
    [aux_sym_procedure_attributes_token1] = ACTIONS(497),
    [aux_sym_procedure_attributes_token3] = ACTIONS(500),
    [aux_sym_contains_statement_token1] = ACTIONS(489),
    [aux_sym_use_statement_token1] = ACTIONS(503),
    [aux_sym_use_statement_token2] = ACTIONS(500),
    [aux_sym_implicit_statement_token1] = ACTIONS(506),
    [aux_sym_implicit_statement_token3] = ACTIONS(509),
    [aux_sym_implicit_statement_token4] = ACTIONS(500),
    [aux_sym_save_statement_token1] = ACTIONS(512),
    [aux_sym_private_statement_token1] = ACTIONS(515),
    [aux_sym_public_statement_token1] = ACTIONS(518),
    [aux_sym_namelist_statement_token1] = ACTIONS(521),
    [aux_sym_common_statement_token1] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(527),
    [aux_sym_import_statement_token1] = ACTIONS(529),
    [aux_sym_derived_type_definition_token1] = ACTIONS(532),
    [aux_sym_abstract_specifier_token1] = ACTIONS(535),
    [aux_sym_procedure_attribute_token6] = ACTIONS(500),
    [aux_sym_variable_attributes_token1] = ACTIONS(500),
    [aux_sym_variable_attributes_token2] = ACTIONS(500),
    [aux_sym_variable_attributes_token3] = ACTIONS(500),
    [aux_sym_variable_attributes_token4] = ACTIONS(500),
    [aux_sym_variable_attributes_token5] = ACTIONS(500),
    [aux_sym_intrinsic_type_token1] = ACTIONS(538),
    [aux_sym_intrinsic_type_token2] = ACTIONS(538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(538),
    [aux_sym_intrinsic_type_token7] = ACTIONS(538),
    [aux_sym_intrinsic_type_token8] = ACTIONS(544),
    [aux_sym_intrinsic_type_token9] = ACTIONS(538),
    [aux_sym_intrinsic_type_token10] = ACTIONS(538),
    [aux_sym_derived_type_token1] = ACTIONS(547),
    [aux_sym_type_qualifier_token1] = ACTIONS(500),
    [aux_sym_type_qualifier_token2] = ACTIONS(500),
    [aux_sym_type_qualifier_token3] = ACTIONS(550),
    [aux_sym_type_qualifier_token4] = ACTIONS(500),
    [aux_sym_type_qualifier_token5] = ACTIONS(553),
    [aux_sym_type_qualifier_token9] = ACTIONS(500),
    [aux_sym_type_qualifier_token10] = ACTIONS(556),
    [aux_sym_type_qualifier_token11] = ACTIONS(500),
    [aux_sym_type_qualifier_token12] = ACTIONS(500),
    [aux_sym_type_qualifier_token13] = ACTIONS(500),
    [aux_sym_type_qualifier_token14] = ACTIONS(500),
    [aux_sym_type_qualifier_token15] = ACTIONS(500),
    [aux_sym_equivalence_statement_token1] = ACTIONS(559),
    [aux_sym_stop_statement_token1] = ACTIONS(489),
    [aux_sym_stop_statement_token2] = ACTIONS(489),
    [aux_sym_subroutine_call_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token2] = ACTIONS(489),
    [aux_sym_keyword_statement_token3] = ACTIONS(489),
    [aux_sym_keyword_statement_token4] = ACTIONS(489),
    [aux_sym_keyword_statement_token6] = ACTIONS(489),
    [aux_sym_keyword_statement_token7] = ACTIONS(489),
    [aux_sym_include_statement_token1] = ACTIONS(562),
    [aux_sym_data_statement_token1] = ACTIONS(565),
    [aux_sym_do_loop_statement_token1] = ACTIONS(489),
    [aux_sym__inline_if_statement_token1] = ACTIONS(489),
    [aux_sym_end_if_statement_token1] = ACTIONS(489),
    [aux_sym_elseif_clause_token2] = ACTIONS(489),
    [aux_sym__inline_where_statement_token1] = ACTIONS(489),
    [aux_sym__forall_control_expression_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token3] = ACTIONS(489),
    [aux_sym_select_type_statement_token1] = ACTIONS(489),
    [aux_sym_select_rank_statement_token2] = ACTIONS(489),
    [aux_sym_block_construct_token1] = ACTIONS(489),
    [aux_sym_associate_statement_token1] = ACTIONS(489),
    [aux_sym_format_statement_token1] = ACTIONS(489),
    [aux_sym_print_statement_token1] = ACTIONS(489),
    [aux_sym_open_statement_token1] = ACTIONS(489),
    [aux_sym_close_statement_token1] = ACTIONS(489),
    [aux_sym_inquire_statement_token1] = ACTIONS(489),
    [aux_sym_enum_statement_token1] = ACTIONS(568),
    [aux_sym_file_position_statement_token1] = ACTIONS(489),
    [aux_sym_file_position_statement_token2] = ACTIONS(489),
    [aux_sym_file_position_statement_token3] = ACTIONS(489),
    [aux_sym_file_position_statement_token4] = ACTIONS(489),
    [aux_sym_logical_expression_token5] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_LPAREN_SLASH] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [sym_boolean_literal] = ACTIONS(527),
    [aux_sym_null_literal_token1] = ACTIONS(489),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(489),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
    [sym__float_literal] = ACTIONS(527),
    [sym__boz_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(527),
  },
  [57] = {
    [sym_interface] = STATE(315),
    [sym_interface_statement] = STATE(767),
    [sym__specification_part] = STATE(314),
    [sym_use_statement] = STATE(2610),
    [sym_implicit_statement] = STATE(2610),
    [sym_save_statement] = STATE(2610),
    [sym_private_statement] = STATE(2610),
    [sym_public_statement] = STATE(2610),
    [sym_namelist_statement] = STATE(2610),
    [sym_common_statement] = STATE(2610),
    [sym_import_statement] = STATE(2610),
    [sym_derived_type_definition] = STATE(315),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(938),
    [sym_variable_declaration] = STATE(2610),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2610),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2610),
    [sym_equivalence_statement] = STATE(2610),
    [sym_statement_label] = STATE(2234),
    [sym_include_statement] = STATE(2610),
    [sym_data_statement] = STATE(2610),
    [sym_enum] = STATE(315),
    [sym_enum_statement] = STATE(1860),
    [sym_preproc_file_line] = STATE(57),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(489),
    [aux_sym_interface_statement_token1] = ACTIONS(491),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(489),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(489),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(494),
    [aux_sym_procedure_attributes_token1] = ACTIONS(497),
    [aux_sym_procedure_attributes_token3] = ACTIONS(500),
    [aux_sym_end_function_statement_token1] = ACTIONS(489),
    [aux_sym_contains_statement_token1] = ACTIONS(489),
    [aux_sym_use_statement_token1] = ACTIONS(503),
    [aux_sym_use_statement_token2] = ACTIONS(500),
    [aux_sym_implicit_statement_token1] = ACTIONS(506),
    [aux_sym_implicit_statement_token3] = ACTIONS(509),
    [aux_sym_implicit_statement_token4] = ACTIONS(500),
    [aux_sym_save_statement_token1] = ACTIONS(512),
    [aux_sym_private_statement_token1] = ACTIONS(515),
    [aux_sym_public_statement_token1] = ACTIONS(518),
    [aux_sym_namelist_statement_token1] = ACTIONS(521),
    [aux_sym_common_statement_token1] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(527),
    [aux_sym_import_statement_token1] = ACTIONS(529),
    [aux_sym_derived_type_definition_token1] = ACTIONS(532),
    [aux_sym_abstract_specifier_token1] = ACTIONS(535),
    [aux_sym_procedure_attribute_token6] = ACTIONS(500),
    [aux_sym_variable_attributes_token1] = ACTIONS(500),
    [aux_sym_variable_attributes_token2] = ACTIONS(500),
    [aux_sym_variable_attributes_token3] = ACTIONS(500),
    [aux_sym_variable_attributes_token4] = ACTIONS(500),
    [aux_sym_variable_attributes_token5] = ACTIONS(500),
    [aux_sym_intrinsic_type_token1] = ACTIONS(538),
    [aux_sym_intrinsic_type_token2] = ACTIONS(538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(538),
    [aux_sym_intrinsic_type_token7] = ACTIONS(538),
    [aux_sym_intrinsic_type_token8] = ACTIONS(544),
    [aux_sym_intrinsic_type_token9] = ACTIONS(538),
    [aux_sym_intrinsic_type_token10] = ACTIONS(538),
    [aux_sym_derived_type_token1] = ACTIONS(547),
    [aux_sym_type_qualifier_token1] = ACTIONS(500),
    [aux_sym_type_qualifier_token2] = ACTIONS(500),
    [aux_sym_type_qualifier_token3] = ACTIONS(550),
    [aux_sym_type_qualifier_token4] = ACTIONS(500),
    [aux_sym_type_qualifier_token5] = ACTIONS(553),
    [aux_sym_type_qualifier_token9] = ACTIONS(500),
    [aux_sym_type_qualifier_token10] = ACTIONS(556),
    [aux_sym_type_qualifier_token11] = ACTIONS(500),
    [aux_sym_type_qualifier_token12] = ACTIONS(500),
    [aux_sym_type_qualifier_token13] = ACTIONS(500),
    [aux_sym_type_qualifier_token14] = ACTIONS(500),
    [aux_sym_type_qualifier_token15] = ACTIONS(500),
    [aux_sym_equivalence_statement_token1] = ACTIONS(559),
    [aux_sym_stop_statement_token1] = ACTIONS(489),
    [aux_sym_stop_statement_token2] = ACTIONS(489),
    [aux_sym_subroutine_call_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token2] = ACTIONS(489),
    [aux_sym_keyword_statement_token3] = ACTIONS(489),
    [aux_sym_keyword_statement_token4] = ACTIONS(489),
    [aux_sym_keyword_statement_token6] = ACTIONS(489),
    [aux_sym_keyword_statement_token7] = ACTIONS(489),
    [aux_sym_include_statement_token1] = ACTIONS(562),
    [aux_sym_data_statement_token1] = ACTIONS(565),
    [aux_sym_do_loop_statement_token1] = ACTIONS(489),
    [aux_sym__inline_if_statement_token1] = ACTIONS(489),
    [aux_sym_end_if_statement_token1] = ACTIONS(489),
    [aux_sym_elseif_clause_token2] = ACTIONS(489),
    [aux_sym__inline_where_statement_token1] = ACTIONS(489),
    [aux_sym__forall_control_expression_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token3] = ACTIONS(489),
    [aux_sym_select_type_statement_token1] = ACTIONS(489),
    [aux_sym_select_rank_statement_token2] = ACTIONS(489),
    [aux_sym_block_construct_token1] = ACTIONS(489),
    [aux_sym_associate_statement_token1] = ACTIONS(489),
    [aux_sym_format_statement_token1] = ACTIONS(489),
    [aux_sym_print_statement_token1] = ACTIONS(489),
    [aux_sym_open_statement_token1] = ACTIONS(489),
    [aux_sym_close_statement_token1] = ACTIONS(489),
    [aux_sym_inquire_statement_token1] = ACTIONS(489),
    [aux_sym_enum_statement_token1] = ACTIONS(568),
    [aux_sym_file_position_statement_token1] = ACTIONS(489),
    [aux_sym_file_position_statement_token2] = ACTIONS(489),
    [aux_sym_file_position_statement_token3] = ACTIONS(489),
    [aux_sym_file_position_statement_token4] = ACTIONS(489),
    [aux_sym_logical_expression_token5] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_LPAREN_SLASH] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [sym_boolean_literal] = ACTIONS(527),
    [aux_sym_null_literal_token1] = ACTIONS(489),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(489),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
    [sym__float_literal] = ACTIONS(527),
    [sym__boz_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(527),
  },
  [58] = {
    [sym_interface] = STATE(370),
    [sym_interface_statement] = STATE(762),
    [sym__specification_part] = STATE(369),
    [sym_use_statement] = STATE(2635),
    [sym_implicit_statement] = STATE(2635),
    [sym_save_statement] = STATE(2635),
    [sym_private_statement] = STATE(2635),
    [sym_public_statement] = STATE(2635),
    [sym_namelist_statement] = STATE(2635),
    [sym_common_statement] = STATE(2635),
    [sym_import_statement] = STATE(2635),
    [sym_derived_type_definition] = STATE(370),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(970),
    [sym_variable_declaration] = STATE(2635),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2635),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2635),
    [sym_equivalence_statement] = STATE(2635),
    [sym_statement_label] = STATE(2227),
    [sym_include_statement] = STATE(2635),
    [sym_data_statement] = STATE(2635),
    [sym_enum] = STATE(370),
    [sym_enum_statement] = STATE(1839),
    [sym_preproc_file_line] = STATE(58),
    [aux_sym_program_repeat1] = STATE(58),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [aux_sym_end_program_statement_token2] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(489),
    [aux_sym_interface_statement_token1] = ACTIONS(491),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(489),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(489),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(494),
    [aux_sym_procedure_attributes_token1] = ACTIONS(497),
    [aux_sym_procedure_attributes_token3] = ACTIONS(500),
    [aux_sym_contains_statement_token1] = ACTIONS(489),
    [aux_sym_use_statement_token1] = ACTIONS(503),
    [aux_sym_use_statement_token2] = ACTIONS(500),
    [aux_sym_implicit_statement_token1] = ACTIONS(506),
    [aux_sym_implicit_statement_token3] = ACTIONS(509),
    [aux_sym_implicit_statement_token4] = ACTIONS(500),
    [aux_sym_save_statement_token1] = ACTIONS(512),
    [aux_sym_private_statement_token1] = ACTIONS(515),
    [aux_sym_public_statement_token1] = ACTIONS(518),
    [aux_sym_namelist_statement_token1] = ACTIONS(521),
    [aux_sym_common_statement_token1] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(527),
    [aux_sym_import_statement_token1] = ACTIONS(529),
    [aux_sym_derived_type_definition_token1] = ACTIONS(532),
    [aux_sym_abstract_specifier_token1] = ACTIONS(535),
    [aux_sym_procedure_attribute_token6] = ACTIONS(500),
    [aux_sym_variable_attributes_token1] = ACTIONS(500),
    [aux_sym_variable_attributes_token2] = ACTIONS(500),
    [aux_sym_variable_attributes_token3] = ACTIONS(500),
    [aux_sym_variable_attributes_token4] = ACTIONS(500),
    [aux_sym_variable_attributes_token5] = ACTIONS(500),
    [aux_sym_intrinsic_type_token1] = ACTIONS(538),
    [aux_sym_intrinsic_type_token2] = ACTIONS(538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(538),
    [aux_sym_intrinsic_type_token7] = ACTIONS(538),
    [aux_sym_intrinsic_type_token8] = ACTIONS(544),
    [aux_sym_intrinsic_type_token9] = ACTIONS(538),
    [aux_sym_intrinsic_type_token10] = ACTIONS(538),
    [aux_sym_derived_type_token1] = ACTIONS(547),
    [aux_sym_type_qualifier_token1] = ACTIONS(500),
    [aux_sym_type_qualifier_token2] = ACTIONS(500),
    [aux_sym_type_qualifier_token3] = ACTIONS(550),
    [aux_sym_type_qualifier_token4] = ACTIONS(500),
    [aux_sym_type_qualifier_token5] = ACTIONS(553),
    [aux_sym_type_qualifier_token9] = ACTIONS(500),
    [aux_sym_type_qualifier_token10] = ACTIONS(556),
    [aux_sym_type_qualifier_token11] = ACTIONS(500),
    [aux_sym_type_qualifier_token12] = ACTIONS(500),
    [aux_sym_type_qualifier_token13] = ACTIONS(500),
    [aux_sym_type_qualifier_token14] = ACTIONS(500),
    [aux_sym_type_qualifier_token15] = ACTIONS(500),
    [aux_sym_equivalence_statement_token1] = ACTIONS(559),
    [aux_sym_stop_statement_token1] = ACTIONS(489),
    [aux_sym_stop_statement_token2] = ACTIONS(489),
    [aux_sym_subroutine_call_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token2] = ACTIONS(489),
    [aux_sym_keyword_statement_token3] = ACTIONS(489),
    [aux_sym_keyword_statement_token4] = ACTIONS(489),
    [aux_sym_keyword_statement_token6] = ACTIONS(489),
    [aux_sym_keyword_statement_token7] = ACTIONS(489),
    [aux_sym_include_statement_token1] = ACTIONS(562),
    [aux_sym_data_statement_token1] = ACTIONS(565),
    [aux_sym_do_loop_statement_token1] = ACTIONS(489),
    [aux_sym__inline_if_statement_token1] = ACTIONS(489),
    [aux_sym_end_if_statement_token1] = ACTIONS(489),
    [aux_sym_elseif_clause_token2] = ACTIONS(489),
    [aux_sym__inline_where_statement_token1] = ACTIONS(489),
    [aux_sym__forall_control_expression_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token3] = ACTIONS(489),
    [aux_sym_select_type_statement_token1] = ACTIONS(489),
    [aux_sym_select_rank_statement_token2] = ACTIONS(489),
    [aux_sym_block_construct_token1] = ACTIONS(489),
    [aux_sym_associate_statement_token1] = ACTIONS(489),
    [aux_sym_format_statement_token1] = ACTIONS(489),
    [aux_sym_print_statement_token1] = ACTIONS(489),
    [aux_sym_open_statement_token1] = ACTIONS(489),
    [aux_sym_close_statement_token1] = ACTIONS(489),
    [aux_sym_inquire_statement_token1] = ACTIONS(489),
    [aux_sym_enum_statement_token1] = ACTIONS(568),
    [aux_sym_file_position_statement_token1] = ACTIONS(489),
    [aux_sym_file_position_statement_token2] = ACTIONS(489),
    [aux_sym_file_position_statement_token3] = ACTIONS(489),
    [aux_sym_file_position_statement_token4] = ACTIONS(489),
    [aux_sym_logical_expression_token5] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_LPAREN_SLASH] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [sym_boolean_literal] = ACTIONS(527),
    [aux_sym_null_literal_token1] = ACTIONS(489),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(489),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
    [sym__float_literal] = ACTIONS(527),
    [sym__boz_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(527),
  },
  [59] = {
    [sym_interface] = STATE(415),
    [sym_interface_statement] = STATE(770),
    [sym__specification_part] = STATE(414),
    [sym_use_statement] = STATE(2467),
    [sym_implicit_statement] = STATE(2467),
    [sym_save_statement] = STATE(2467),
    [sym_private_statement] = STATE(2467),
    [sym_public_statement] = STATE(2467),
    [sym_namelist_statement] = STATE(2467),
    [sym_common_statement] = STATE(2467),
    [sym_import_statement] = STATE(2467),
    [sym_derived_type_definition] = STATE(415),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(990),
    [sym_variable_declaration] = STATE(2467),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2467),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2467),
    [sym_equivalence_statement] = STATE(2467),
    [sym_statement_label] = STATE(2228),
    [sym_include_statement] = STATE(2467),
    [sym_data_statement] = STATE(2467),
    [sym_enum] = STATE(415),
    [sym_enum_statement] = STATE(1856),
    [sym_preproc_file_line] = STATE(59),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(489),
    [aux_sym_interface_statement_token1] = ACTIONS(491),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(489),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(489),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(494),
    [aux_sym_procedure_attributes_token1] = ACTIONS(497),
    [aux_sym_procedure_attributes_token3] = ACTIONS(500),
    [aux_sym_use_statement_token1] = ACTIONS(503),
    [aux_sym_use_statement_token2] = ACTIONS(500),
    [aux_sym_implicit_statement_token1] = ACTIONS(506),
    [aux_sym_implicit_statement_token3] = ACTIONS(509),
    [aux_sym_implicit_statement_token4] = ACTIONS(500),
    [aux_sym_save_statement_token1] = ACTIONS(512),
    [aux_sym_private_statement_token1] = ACTIONS(515),
    [aux_sym_public_statement_token1] = ACTIONS(518),
    [aux_sym_namelist_statement_token1] = ACTIONS(521),
    [aux_sym_common_statement_token1] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(527),
    [aux_sym_import_statement_token1] = ACTIONS(529),
    [aux_sym_derived_type_definition_token1] = ACTIONS(532),
    [aux_sym_abstract_specifier_token1] = ACTIONS(535),
    [aux_sym_procedure_attribute_token6] = ACTIONS(500),
    [aux_sym_variable_attributes_token1] = ACTIONS(500),
    [aux_sym_variable_attributes_token2] = ACTIONS(500),
    [aux_sym_variable_attributes_token3] = ACTIONS(500),
    [aux_sym_variable_attributes_token4] = ACTIONS(500),
    [aux_sym_variable_attributes_token5] = ACTIONS(500),
    [aux_sym_intrinsic_type_token1] = ACTIONS(538),
    [aux_sym_intrinsic_type_token2] = ACTIONS(538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(538),
    [aux_sym_intrinsic_type_token7] = ACTIONS(538),
    [aux_sym_intrinsic_type_token8] = ACTIONS(544),
    [aux_sym_intrinsic_type_token9] = ACTIONS(538),
    [aux_sym_intrinsic_type_token10] = ACTIONS(538),
    [aux_sym_derived_type_token1] = ACTIONS(547),
    [aux_sym_type_qualifier_token1] = ACTIONS(500),
    [aux_sym_type_qualifier_token2] = ACTIONS(500),
    [aux_sym_type_qualifier_token3] = ACTIONS(550),
    [aux_sym_type_qualifier_token4] = ACTIONS(500),
    [aux_sym_type_qualifier_token5] = ACTIONS(553),
    [aux_sym_type_qualifier_token9] = ACTIONS(500),
    [aux_sym_type_qualifier_token10] = ACTIONS(556),
    [aux_sym_type_qualifier_token11] = ACTIONS(500),
    [aux_sym_type_qualifier_token12] = ACTIONS(500),
    [aux_sym_type_qualifier_token13] = ACTIONS(500),
    [aux_sym_type_qualifier_token14] = ACTIONS(500),
    [aux_sym_type_qualifier_token15] = ACTIONS(500),
    [aux_sym_equivalence_statement_token1] = ACTIONS(559),
    [aux_sym_stop_statement_token1] = ACTIONS(489),
    [aux_sym_stop_statement_token2] = ACTIONS(489),
    [aux_sym_subroutine_call_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token1] = ACTIONS(489),
    [aux_sym_keyword_statement_token2] = ACTIONS(489),
    [aux_sym_keyword_statement_token3] = ACTIONS(489),
    [aux_sym_keyword_statement_token4] = ACTIONS(489),
    [aux_sym_keyword_statement_token6] = ACTIONS(489),
    [aux_sym_keyword_statement_token7] = ACTIONS(489),
    [aux_sym_include_statement_token1] = ACTIONS(562),
    [aux_sym_data_statement_token1] = ACTIONS(565),
    [aux_sym_do_loop_statement_token1] = ACTIONS(489),
    [aux_sym__inline_if_statement_token1] = ACTIONS(489),
    [aux_sym_end_if_statement_token1] = ACTIONS(489),
    [aux_sym_elseif_clause_token2] = ACTIONS(489),
    [aux_sym__inline_where_statement_token1] = ACTIONS(489),
    [aux_sym__forall_control_expression_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token1] = ACTIONS(489),
    [aux_sym_select_case_statement_token3] = ACTIONS(489),
    [aux_sym_select_type_statement_token1] = ACTIONS(489),
    [aux_sym_select_rank_statement_token2] = ACTIONS(489),
    [aux_sym_block_construct_token1] = ACTIONS(489),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(489),
    [aux_sym_associate_statement_token1] = ACTIONS(489),
    [aux_sym_format_statement_token1] = ACTIONS(489),
    [aux_sym_print_statement_token1] = ACTIONS(489),
    [aux_sym_open_statement_token1] = ACTIONS(489),
    [aux_sym_close_statement_token1] = ACTIONS(489),
    [aux_sym_inquire_statement_token1] = ACTIONS(489),
    [aux_sym_enum_statement_token1] = ACTIONS(568),
    [aux_sym_file_position_statement_token1] = ACTIONS(489),
    [aux_sym_file_position_statement_token2] = ACTIONS(489),
    [aux_sym_file_position_statement_token3] = ACTIONS(489),
    [aux_sym_file_position_statement_token4] = ACTIONS(489),
    [aux_sym_logical_expression_token5] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_LPAREN_SLASH] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [sym_boolean_literal] = ACTIONS(527),
    [aux_sym_null_literal_token1] = ACTIONS(489),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(489),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
    [sym__float_literal] = ACTIONS(527),
    [sym__boz_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(527),
  },
  [60] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_end_where_statement] = STATE(2652),
    [sym_elsewhere_clause] = STATE(1906),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(60),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym__block_where_statement_repeat1] = STATE(1831),
    [aux_sym_end_program_statement_token1] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(578),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(580),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(582),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [61] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_end_where_statement] = STATE(2652),
    [sym_elsewhere_clause] = STATE(1906),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(61),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(62),
    [aux_sym__block_where_statement_repeat1] = STATE(1831),
    [aux_sym_end_program_statement_token1] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(578),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(580),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(582),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [62] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_end_where_statement] = STATE(2379),
    [sym_elsewhere_clause] = STATE(1906),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(62),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym__block_where_statement_repeat1] = STATE(1832),
    [aux_sym_end_program_statement_token1] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(578),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(580),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(582),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [63] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(63),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(586),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(589),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(589),
    [aux_sym_type_statement_token2] = ACTIONS(589),
    [aux_sym_type_statement_token3] = ACTIONS(589),
    [aux_sym__class_default_token1] = ACTIONS(589),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(591),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [64] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(64),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(65),
    [aux_sym_end_program_statement_token1] = ACTIONS(586),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(589),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(589),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(589),
    [aux_sym_type_statement_token2] = ACTIONS(589),
    [aux_sym_type_statement_token3] = ACTIONS(589),
    [aux_sym__class_default_token1] = ACTIONS(589),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(591),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [65] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(65),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(597),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(597),
    [aux_sym_type_statement_token2] = ACTIONS(597),
    [aux_sym_type_statement_token3] = ACTIONS(597),
    [aux_sym__class_default_token1] = ACTIONS(597),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(599),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [66] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(66),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(70),
    [aux_sym_end_program_statement_token1] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(605),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(605),
    [aux_sym_type_statement_token2] = ACTIONS(605),
    [aux_sym_type_statement_token3] = ACTIONS(605),
    [aux_sym__class_default_token1] = ACTIONS(605),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(607),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [67] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(67),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(72),
    [aux_sym_end_program_statement_token1] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(613),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(613),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(613),
    [aux_sym_type_statement_token2] = ACTIONS(613),
    [aux_sym_type_statement_token3] = ACTIONS(613),
    [aux_sym__class_default_token1] = ACTIONS(613),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(615),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [68] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(68),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(76),
    [aux_sym_end_program_statement_token1] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(621),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(621),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(621),
    [aux_sym_type_statement_token2] = ACTIONS(621),
    [aux_sym_type_statement_token3] = ACTIONS(621),
    [aux_sym__class_default_token1] = ACTIONS(621),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(623),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [69] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(69),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(74),
    [aux_sym_end_program_statement_token1] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(629),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(629),
    [aux_sym_type_statement_token2] = ACTIONS(629),
    [aux_sym_type_statement_token3] = ACTIONS(629),
    [aux_sym__class_default_token1] = ACTIONS(629),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(631),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [70] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(70),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(637),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(637),
    [aux_sym_type_statement_token2] = ACTIONS(637),
    [aux_sym_type_statement_token3] = ACTIONS(637),
    [aux_sym__class_default_token1] = ACTIONS(637),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(639),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [71] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(71),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(75),
    [aux_sym_end_program_statement_token1] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(637),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(637),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(637),
    [aux_sym_type_statement_token2] = ACTIONS(637),
    [aux_sym_type_statement_token3] = ACTIONS(637),
    [aux_sym__class_default_token1] = ACTIONS(637),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(639),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [72] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(72),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(645),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(645),
    [aux_sym_type_statement_token2] = ACTIONS(645),
    [aux_sym_type_statement_token3] = ACTIONS(645),
    [aux_sym__class_default_token1] = ACTIONS(645),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(647),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [73] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(73),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(82),
    [aux_sym_end_program_statement_token1] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(645),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(645),
    [aux_sym_type_statement_token2] = ACTIONS(645),
    [aux_sym_type_statement_token3] = ACTIONS(645),
    [aux_sym__class_default_token1] = ACTIONS(645),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(647),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [74] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(74),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(653),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(653),
    [aux_sym_type_statement_token2] = ACTIONS(653),
    [aux_sym_type_statement_token3] = ACTIONS(653),
    [aux_sym__class_default_token1] = ACTIONS(653),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(655),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [75] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(75),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(661),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(661),
    [aux_sym_type_statement_token2] = ACTIONS(661),
    [aux_sym_type_statement_token3] = ACTIONS(661),
    [aux_sym__class_default_token1] = ACTIONS(661),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(663),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [76] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(76),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(669),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(669),
    [aux_sym_type_statement_token2] = ACTIONS(669),
    [aux_sym_type_statement_token3] = ACTIONS(669),
    [aux_sym__class_default_token1] = ACTIONS(669),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(671),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [77] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(77),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(78),
    [aux_sym_end_program_statement_token1] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(653),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(653),
    [aux_sym_type_statement_token2] = ACTIONS(653),
    [aux_sym_type_statement_token3] = ACTIONS(653),
    [aux_sym__class_default_token1] = ACTIONS(653),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(655),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [78] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(78),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(674),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(677),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(677),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(677),
    [aux_sym_type_statement_token2] = ACTIONS(677),
    [aux_sym_type_statement_token3] = ACTIONS(677),
    [aux_sym__class_default_token1] = ACTIONS(677),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(679),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [79] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(79),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(682),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(685),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(685),
    [aux_sym_type_statement_token2] = ACTIONS(685),
    [aux_sym_type_statement_token3] = ACTIONS(685),
    [aux_sym__class_default_token1] = ACTIONS(685),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(687),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [80] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_end_where_statement] = STATE(2445),
    [sym_elsewhere_clause] = STATE(1906),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(80),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(60),
    [aux_sym__block_where_statement_repeat1] = STATE(1825),
    [aux_sym_end_program_statement_token1] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(578),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(580),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(582),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [81] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(81),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(79),
    [aux_sym_end_program_statement_token1] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(669),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(669),
    [aux_sym_type_statement_token2] = ACTIONS(669),
    [aux_sym_type_statement_token3] = ACTIONS(669),
    [aux_sym__class_default_token1] = ACTIONS(669),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(671),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [82] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(82),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(693),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(693),
    [aux_sym_type_statement_token2] = ACTIONS(693),
    [aux_sym_type_statement_token3] = ACTIONS(693),
    [aux_sym__class_default_token1] = ACTIONS(693),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(695),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [83] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(83),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(83),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [aux_sym_implicit_statement_token3] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_derived_type_token1] = ACTIONS(710),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_end_select_statement_token1] = ACTIONS(710),
    [aux_sym_type_statement_token2] = ACTIONS(710),
    [aux_sym_type_statement_token3] = ACTIONS(710),
    [aux_sym__class_default_token1] = ACTIONS(710),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [84] = {
    [sym__statements] = STATE(2763),
    [sym_statement_label] = STATE(287),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(84),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(63),
    [aux_sym_end_program_statement_token1] = ACTIONS(820),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_derived_type_token1] = ACTIONS(823),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(823),
    [aux_sym_type_statement_token2] = ACTIONS(823),
    [aux_sym_type_statement_token3] = ACTIONS(823),
    [aux_sym__class_default_token1] = ACTIONS(823),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(825),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [85] = {
    [sym_end_function_statement] = STATE(1571),
    [sym_internal_procedures] = STATE(1991),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(85),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(467),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [86] = {
    [sym_end_program_statement] = STATE(242),
    [sym_internal_procedures] = STATE(1983),
    [sym_contains_statement] = STATE(2575),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(260),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(86),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(164),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [87] = {
    [sym_end_module_procedure_statement] = STATE(1637),
    [sym_internal_procedures] = STATE(2015),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(87),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(411),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [88] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(221),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2359),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1897),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(88),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym__block_if_statement_repeat1] = STATE(1788),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [89] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(224),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2697),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1884),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(89),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym__block_if_statement_repeat1] = STATE(1775),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [90] = {
    [sym_end_module_procedure_statement] = STATE(1611),
    [sym_internal_procedures] = STATE(2119),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(90),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(411),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [91] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(221),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2359),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1897),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(91),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(92),
    [aux_sym__block_if_statement_repeat1] = STATE(1788),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [92] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(226),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2641),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1871),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(92),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym__block_if_statement_repeat1] = STATE(1765),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [93] = {
    [sym_end_program_statement] = STATE(281),
    [sym_internal_procedures] = STATE(2051),
    [sym_contains_statement] = STATE(2575),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(260),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(93),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(164),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [94] = {
    [sym_end_subroutine_statement] = STATE(252),
    [sym_internal_procedures] = STATE(2079),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(94),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(403),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [95] = {
    [sym_end_function_statement] = STATE(259),
    [sym_internal_procedures] = STATE(2082),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(95),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(407),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [96] = {
    [sym_end_subroutine_statement] = STATE(1176),
    [sym_internal_procedures] = STATE(2052),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(96),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(423),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [97] = {
    [sym_end_function_statement] = STATE(1179),
    [sym_internal_procedures] = STATE(2055),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(97),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(419),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [98] = {
    [sym_end_subroutine_statement] = STATE(1193),
    [sym_internal_procedures] = STATE(2076),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(98),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(423),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [99] = {
    [sym_end_function_statement] = STATE(1199),
    [sym_internal_procedures] = STATE(2080),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(99),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(419),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [100] = {
    [sym_end_module_procedure_statement] = STATE(1627),
    [sym_internal_procedures] = STATE(2098),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(100),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(427),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [101] = {
    [sym_end_module_procedure_statement] = STATE(1630),
    [sym_internal_procedures] = STATE(2106),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(101),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(427),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [102] = {
    [sym_end_subroutine_statement] = STATE(1644),
    [sym_internal_procedures] = STATE(2198),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(102),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(431),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [103] = {
    [sym_end_function_statement] = STATE(1646),
    [sym_internal_procedures] = STATE(2202),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(103),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(435),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [104] = {
    [sym_end_subroutine_statement] = STATE(1649),
    [sym_internal_procedures] = STATE(2218),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(104),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(431),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [105] = {
    [sym_end_function_statement] = STATE(1652),
    [sym_internal_procedures] = STATE(2221),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(105),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(435),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [106] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(225),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2901),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1896),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(106),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(89),
    [aux_sym__block_if_statement_repeat1] = STATE(1787),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [107] = {
    [sym_end_module_procedure_statement] = STATE(1659),
    [sym_internal_procedures] = STATE(2229),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(107),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(439),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [108] = {
    [sym_end_module_procedure_statement] = STATE(1662),
    [sym_internal_procedures] = STATE(2236),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(108),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(439),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [109] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(224),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2697),
    [sym_elseif_clause] = STATE(1895),
    [sym_else_clause] = STATE(1884),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(109),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(88),
    [aux_sym__block_if_statement_repeat1] = STATE(1775),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token1] = ACTIONS(832),
    [aux_sym_elseif_clause_token2] = ACTIONS(834),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [110] = {
    [sym_end_subroutine_statement] = STATE(1669),
    [sym_internal_procedures] = STATE(1935),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(110),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(443),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [111] = {
    [sym_end_function_statement] = STATE(1671),
    [sym_internal_procedures] = STATE(1938),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(111),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(447),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [112] = {
    [sym_end_subroutine_statement] = STATE(1674),
    [sym_internal_procedures] = STATE(1940),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(112),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(443),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [113] = {
    [sym_end_function_statement] = STATE(1677),
    [sym_internal_procedures] = STATE(1943),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(113),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(447),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [114] = {
    [sym_end_module_procedure_statement] = STATE(1684),
    [sym_internal_procedures] = STATE(1946),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(114),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(451),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [115] = {
    [sym_end_module_procedure_statement] = STATE(1687),
    [sym_internal_procedures] = STATE(1947),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(115),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(451),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [116] = {
    [sym_end_subroutine_statement] = STATE(1694),
    [sym_internal_procedures] = STATE(1963),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(116),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(455),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [117] = {
    [sym_end_function_statement] = STATE(1696),
    [sym_internal_procedures] = STATE(1965),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(117),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(459),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [118] = {
    [sym_end_subroutine_statement] = STATE(1699),
    [sym_internal_procedures] = STATE(1970),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(118),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(455),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [119] = {
    [sym_end_function_statement] = STATE(1702),
    [sym_internal_procedures] = STATE(1972),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(119),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(459),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [120] = {
    [sym_end_module_procedure_statement] = STATE(1709),
    [sym_internal_procedures] = STATE(1976),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(120),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(463),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [121] = {
    [sym_end_module_procedure_statement] = STATE(1712),
    [sym_internal_procedures] = STATE(1977),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(121),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(463),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [122] = {
    [sym_end_subroutine_statement] = STATE(294),
    [sym_internal_procedures] = STATE(2196),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(122),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(403),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [123] = {
    [sym_end_subroutine_statement] = STATE(1569),
    [sym_internal_procedures] = STATE(1990),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(123),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(385),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [124] = {
    [sym_end_subroutine_statement] = STATE(1574),
    [sym_internal_procedures] = STATE(1994),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(124),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(385),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [125] = {
    [sym_end_function_statement] = STATE(1577),
    [sym_internal_procedures] = STATE(1997),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(125),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(467),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [126] = {
    [sym_end_function_statement] = STATE(271),
    [sym_internal_procedures] = STATE(2240),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(126),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(405),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(407),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [127] = {
    [sym_end_module_procedure_statement] = STATE(1584),
    [sym_internal_procedures] = STATE(2001),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(127),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(471),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [128] = {
    [sym_end_module_procedure_statement] = STATE(1587),
    [sym_internal_procedures] = STATE(2003),
    [sym_contains_statement] = STATE(2609),
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(128),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(471),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [129] = {
    [sym_end_subroutine_statement] = STATE(1594),
    [sym_internal_procedures] = STATE(2014),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(129),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(475),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [130] = {
    [sym_end_function_statement] = STATE(1596),
    [sym_internal_procedures] = STATE(2016),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(130),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(479),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [131] = {
    [sym_end_subroutine_statement] = STATE(1599),
    [sym_internal_procedures] = STATE(2021),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(131),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(475),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [132] = {
    [sym_end_function_statement] = STATE(1602),
    [sym_internal_procedures] = STATE(2023),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(132),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(479),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [133] = {
    [sym_end_subroutine_statement] = STATE(1613),
    [sym_internal_procedures] = STATE(2030),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(133),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(483),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [134] = {
    [sym_end_function_statement] = STATE(1615),
    [sym_internal_procedures] = STATE(2032),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(134),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(415),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [135] = {
    [sym_end_subroutine_statement] = STATE(1618),
    [sym_internal_procedures] = STATE(2035),
    [sym_contains_statement] = STATE(2466),
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(135),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(483),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [136] = {
    [sym_end_function_statement] = STATE(1621),
    [sym_internal_procedures] = STATE(2037),
    [sym_contains_statement] = STATE(2538),
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(136),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_end_function_statement_token1] = ACTIONS(415),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [137] = {
    [sym_end_program_statement] = STATE(249),
    [sym_internal_procedures] = STATE(2025),
    [sym_contains_statement] = STATE(2575),
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(260),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(137),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(164),
    [aux_sym_end_program_statement_token1] = ACTIONS(11),
    [aux_sym_end_program_statement_token2] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_contains_statement_token1] = ACTIONS(37),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [138] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(138),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(145),
    [aux_sym_end_program_statement_token1] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(839),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(839),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(839),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [139] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(139),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(841),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(844),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(844),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(844),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [140] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(140),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(849),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(849),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(849),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [141] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(141),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token1] = ACTIONS(710),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym_end_where_statement_token1] = ACTIONS(710),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(710),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [142] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(142),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(143),
    [aux_sym_end_program_statement_token1] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(854),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(854),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(854),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [143] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(143),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(856),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(859),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(859),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(859),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [144] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(144),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(147),
    [aux_sym_end_program_statement_token1] = ACTIONS(856),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(859),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(859),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(859),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [145] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(145),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(864),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(864),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(864),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [146] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(146),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(149),
    [aux_sym_end_program_statement_token1] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(864),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(864),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(864),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [147] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(147),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(869),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(869),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(869),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [148] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(148),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(139),
    [aux_sym_end_program_statement_token1] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(869),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(869),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(869),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [149] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(149),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(141),
    [aux_sym_end_program_statement_token1] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(874),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(874),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(874),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [150] = {
    [sym__statements] = STATE(2681),
    [sym_statement_label] = STATE(244),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(150),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(140),
    [aux_sym_end_program_statement_token1] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token1] = ACTIONS(874),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym_end_where_statement_token1] = ACTIONS(874),
    [aux_sym_elsewhere_clause_token1] = ACTIONS(874),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [151] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(151),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(180),
    [aux_sym_end_program_statement_token1] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(879),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(879),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(881),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [152] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2854),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(152),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(202),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [153] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(153),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(160),
    [aux_sym_end_program_statement_token1] = ACTIONS(888),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(891),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(891),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(893),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [154] = {
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(280),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2607),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(154),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(206),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [155] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(155),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(899),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(899),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(901),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [156] = {
    [sym__statements] = STATE(2469),
    [sym_statement_label] = STATE(282),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(156),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(156),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(710),
    [aux_sym_contains_statement_token1] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [157] = {
    [sym__statements] = STATE(2541),
    [sym_statement_label] = STATE(284),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(157),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(157),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [aux_sym_end_function_statement_token1] = ACTIONS(710),
    [aux_sym_contains_statement_token1] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [158] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(158),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(160),
    [aux_sym_end_program_statement_token1] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(907),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(907),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(909),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [159] = {
    [sym__statements] = STATE(2761),
    [sym_statement_label] = STATE(289),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(159),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(159),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(710),
    [aux_sym_contains_statement_token1] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [160] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(160),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(160),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token2] = ACTIONS(710),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_end_select_statement_token1] = ACTIONS(710),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [161] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(161),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token1] = ACTIONS(710),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_end_select_statement_token1] = ACTIONS(710),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [162] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2833),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(162),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(170),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [163] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(163),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(153),
    [aux_sym_end_program_statement_token1] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(907),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(907),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(909),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [164] = {
    [sym__statements] = STATE(2475),
    [sym_statement_label] = STATE(260),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(164),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(164),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [aux_sym_end_program_statement_token2] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [aux_sym_contains_statement_token1] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [165] = {
    [sym__statements] = STATE(2612),
    [sym_statement_label] = STATE(213),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2515),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(165),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(197),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(916),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [166] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(166),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(178),
    [aux_sym_end_program_statement_token1] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(921),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(921),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(923),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [167] = {
    [sym__statements] = STATE(2612),
    [sym_statement_label] = STATE(213),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2515),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(167),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(190),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(916),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [168] = {
    [sym__statements] = STATE(2612),
    [sym_statement_label] = STATE(214),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2627),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(168),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(165),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(916),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [169] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(218),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2824),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(169),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(200),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [170] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2450),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(170),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(202),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [171] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2450),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(171),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(182),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [172] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(218),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2824),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(172),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(191),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [173] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(217),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2797),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(173),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(193),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [174] = {
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(280),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2416),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(174),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(206),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [175] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(219),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2786),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(175),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(200),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [176] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(219),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2786),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(176),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(169),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [177] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(177),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(932),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(935),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(935),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(937),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [178] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(178),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(160),
    [aux_sym_end_program_statement_token1] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(943),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(943),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(945),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [179] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(179),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(187),
    [aux_sym_end_program_statement_token1] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(943),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(943),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(945),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [180] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(180),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(951),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(951),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(953),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [181] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(181),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(192),
    [aux_sym_end_program_statement_token1] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(951),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(951),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(953),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [182] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2758),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(182),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(202),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [183] = {
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(280),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_end_block_construct_statement] = STATE(2594),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(183),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(206),
    [aux_sym_end_program_statement_token1] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(487),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [184] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_end_associate_statement] = STATE(2758),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(184),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(152),
    [aux_sym_end_program_statement_token1] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_end_associate_statement_token1] = ACTIONS(886),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(584),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [185] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(185),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(155),
    [aux_sym_end_program_statement_token1] = ACTIONS(932),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(935),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(935),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(937),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [186] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(186),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(158),
    [aux_sym_end_program_statement_token1] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(959),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(959),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(961),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [187] = {
    [sym__statements] = STATE(2769),
    [sym_statement_label] = STATE(292),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(187),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(160),
    [aux_sym_end_program_statement_token1] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token2] = ACTIONS(967),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(967),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(969),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [188] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(211),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2583),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(188),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(175),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [189] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(189),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(177),
    [aux_sym_end_program_statement_token1] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(975),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(975),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(977),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [190] = {
    [sym__statements] = STATE(2612),
    [sym_statement_label] = STATE(216),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2433),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(190),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(197),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(916),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [191] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(217),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2797),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(191),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(200),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [192] = {
    [sym__statements] = STATE(2771),
    [sym_statement_label] = STATE(293),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(192),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(161),
    [aux_sym_end_program_statement_token1] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token1] = ACTIONS(983),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_end_select_statement_token1] = ACTIONS(983),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(985),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [193] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(215),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2790),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(193),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(200),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(930),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [194] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(194),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym_end_program_statement_token1] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(991),
    [aux_sym_elseif_clause_token1] = ACTIONS(994),
    [aux_sym_elseif_clause_token2] = ACTIONS(991),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(996),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [195] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(195),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(203),
    [aux_sym_end_program_statement_token1] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1002),
    [aux_sym_elseif_clause_token1] = ACTIONS(1005),
    [aux_sym_elseif_clause_token2] = ACTIONS(1002),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1007),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [196] = {
    [sym__statements] = STATE(2904),
    [sym_statement_label] = STATE(1473),
    [sym_statement_label_reference] = STATE(2356),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(196),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym__block_if_statement_token1] = ACTIONS(1012),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1014),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [197] = {
    [sym__statements] = STATE(2612),
    [sym_statement_label] = STATE(286),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(197),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(197),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_end_forall_statement_token1] = ACTIONS(710),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [198] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(198),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym_end_program_statement_token1] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1019),
    [aux_sym_elseif_clause_token1] = ACTIONS(1022),
    [aux_sym_elseif_clause_token2] = ACTIONS(1019),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1024),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [199] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(199),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token1] = ACTIONS(710),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [200] = {
    [sym__statements] = STATE(2645),
    [sym_statement_label] = STATE(266),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(200),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(200),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(710),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [201] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(201),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(205),
    [aux_sym_end_program_statement_token1] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1030),
    [aux_sym_elseif_clause_token1] = ACTIONS(1033),
    [aux_sym_elseif_clause_token2] = ACTIONS(1030),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1035),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [202] = {
    [sym__statements] = STATE(2765),
    [sym_statement_label] = STATE(232),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(202),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(202),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_end_associate_statement_token1] = ACTIONS(710),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [203] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(203),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym_end_program_statement_token1] = ACTIONS(1038),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1041),
    [aux_sym_elseif_clause_token1] = ACTIONS(1044),
    [aux_sym_elseif_clause_token2] = ACTIONS(1041),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1046),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [204] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(204),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(198),
    [aux_sym_end_program_statement_token1] = ACTIONS(1038),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1041),
    [aux_sym_elseif_clause_token1] = ACTIONS(1044),
    [aux_sym_elseif_clause_token2] = ACTIONS(1041),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1046),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [205] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(205),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(199),
    [aux_sym_end_program_statement_token1] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1052),
    [aux_sym_elseif_clause_token1] = ACTIONS(1055),
    [aux_sym_elseif_clause_token2] = ACTIONS(1052),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1057),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [206] = {
    [sym__statements] = STATE(2384),
    [sym_statement_label] = STATE(280),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(206),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(206),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(710),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [207] = {
    [sym__statements] = STATE(2734),
    [sym_statement_label] = STATE(291),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(207),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(194),
    [aux_sym_end_program_statement_token1] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1052),
    [aux_sym_elseif_clause_token1] = ACTIONS(1055),
    [aux_sym_elseif_clause_token2] = ACTIONS(1052),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1057),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [208] = {
    [sym__statements] = STATE(2767),
    [sym_statement_label] = STATE(290),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(208),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(220),
    [aux_sym_end_program_statement_token1] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1063),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1066),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [209] = {
    [sym__statements] = STATE(2767),
    [sym_statement_label] = STATE(290),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(209),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(210),
    [aux_sym_end_program_statement_token1] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1072),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1075),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [210] = {
    [sym__statements] = STATE(2767),
    [sym_statement_label] = STATE(290),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(210),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(212),
    [aux_sym_end_program_statement_token1] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1081),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1084),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [211] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2786),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(211),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [212] = {
    [sym__statements] = STATE(2767),
    [sym_statement_label] = STATE(290),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(212),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(212),
    [aux_sym_end_program_statement_token1] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(701),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(704),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(712),
    [aux_sym_intrinsic_type_token1] = ACTIONS(715),
    [aux_sym_intrinsic_type_token3] = ACTIONS(715),
    [aux_sym_intrinsic_type_token4] = ACTIONS(718),
    [aux_sym_type_qualifier_token13] = ACTIONS(715),
    [aux_sym_type_qualifier_token14] = ACTIONS(715),
    [aux_sym_stop_statement_token1] = ACTIONS(721),
    [aux_sym_stop_statement_token2] = ACTIONS(724),
    [aux_sym_subroutine_call_token1] = ACTIONS(727),
    [aux_sym_keyword_statement_token1] = ACTIONS(730),
    [aux_sym_keyword_statement_token2] = ACTIONS(733),
    [aux_sym_keyword_statement_token3] = ACTIONS(733),
    [aux_sym_keyword_statement_token4] = ACTIONS(736),
    [aux_sym_keyword_statement_token6] = ACTIONS(739),
    [aux_sym_keyword_statement_token7] = ACTIONS(730),
    [aux_sym_include_statement_token1] = ACTIONS(742),
    [aux_sym_data_statement_token1] = ACTIONS(715),
    [aux_sym_do_loop_statement_token1] = ACTIONS(745),
    [aux_sym__inline_if_statement_token1] = ACTIONS(748),
    [aux_sym_end_if_statement_token1] = ACTIONS(715),
    [aux_sym_elseif_clause_token2] = ACTIONS(715),
    [aux_sym__inline_where_statement_token1] = ACTIONS(751),
    [aux_sym__forall_control_expression_token1] = ACTIONS(754),
    [aux_sym_select_case_statement_token1] = ACTIONS(757),
    [aux_sym_select_case_statement_token3] = ACTIONS(760),
    [aux_sym_select_type_statement_token1] = ACTIONS(763),
    [aux_sym_select_rank_statement_token2] = ACTIONS(766),
    [aux_sym_block_construct_token1] = ACTIONS(769),
    [aux_sym_associate_statement_token1] = ACTIONS(772),
    [aux_sym_format_statement_token1] = ACTIONS(775),
    [aux_sym_print_statement_token1] = ACTIONS(778),
    [aux_sym_open_statement_token1] = ACTIONS(781),
    [aux_sym_close_statement_token1] = ACTIONS(784),
    [aux_sym_inquire_statement_token1] = ACTIONS(787),
    [aux_sym_file_position_statement_token1] = ACTIONS(790),
    [aux_sym_file_position_statement_token2] = ACTIONS(790),
    [aux_sym_file_position_statement_token3] = ACTIONS(790),
    [aux_sym_file_position_statement_token4] = ACTIONS(793),
    [aux_sym_logical_expression_token5] = ACTIONS(796),
    [anon_sym_PLUS] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_LPAREN_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_boolean_literal] = ACTIONS(808),
    [aux_sym_null_literal_token1] = ACTIONS(811),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(715),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(814),
    [sym__float_literal] = ACTIONS(817),
    [sym__boz_literal] = ACTIONS(817),
    [sym_string_literal] = ACTIONS(808),
  },
  [213] = {
    [sym__statements] = STATE(2624),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2433),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(213),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [214] = {
    [sym__statements] = STATE(2624),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2515),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(214),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [215] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2840),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(215),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [216] = {
    [sym__statements] = STATE(2624),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_end_forall_statement] = STATE(2596),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(216),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(912),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_end_forall_statement_token1] = ACTIONS(914),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [217] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2790),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(217),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [218] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2797),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(218),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [219] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_end_do_loop_statement] = STATE(2824),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(219),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(928),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [220] = {
    [sym__statements] = STATE(2767),
    [sym_statement_label] = STATE(290),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(220),
    [sym_identifier] = STATE(1151),
    [aux_sym_program_repeat2] = STATE(212),
    [aux_sym_end_program_statement_token1] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(1072),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1075),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [221] = {
    [sym__statements] = STATE(2739),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2641),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(221),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [222] = {
    [sym__statements] = STATE(2818),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(222),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
    [sym__end_of_statement] = ACTIONS(1087),
  },
  [223] = {
    [sym__statements] = STATE(2497),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(223),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
    [sym__end_of_statement] = ACTIONS(1089),
  },
  [224] = {
    [sym__statements] = STATE(2739),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2359),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(224),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [225] = {
    [sym__statements] = STATE(2739),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2697),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(225),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [226] = {
    [sym__statements] = STATE(2739),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_end_if_statement] = STATE(2410),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(226),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(830),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [227] = {
    [sym__statements] = STATE(2796),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2804),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(227),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [228] = {
    [sym__statements] = STATE(2398),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2702),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(228),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [229] = {
    [sym__statements] = STATE(2482),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2399),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(229),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [230] = {
    [sym__statements] = STATE(2554),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2483),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(230),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [231] = {
    [sym__statements] = STATE(2762),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2555),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(231),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [aux_sym_implicit_statement_token3] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [232] = {
    [sym__statements] = STATE(2766),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(232),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [233] = {
    [sym_preproc_file_line] = STATE(233),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [aux_sym_program_statement_token1] = ACTIONS(1095),
    [aux_sym_end_program_statement_token1] = ACTIONS(1095),
    [aux_sym_end_program_statement_token2] = ACTIONS(1095),
    [aux_sym_module_statement_token1] = ACTIONS(1095),
    [aux_sym_submodule_statement_token1] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [aux_sym_interface_statement_token1] = ACTIONS(1095),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1095),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1095),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1095),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1095),
    [aux_sym_function_statement_token1] = ACTIONS(1095),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1095),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1095),
    [aux_sym_contains_statement_token1] = ACTIONS(1095),
    [aux_sym_use_statement_token1] = ACTIONS(1095),
    [aux_sym_use_statement_token2] = ACTIONS(1095),
    [aux_sym_implicit_statement_token1] = ACTIONS(1095),
    [aux_sym_implicit_statement_token3] = ACTIONS(1095),
    [aux_sym_implicit_statement_token4] = ACTIONS(1095),
    [aux_sym_save_statement_token1] = ACTIONS(1095),
    [aux_sym_private_statement_token1] = ACTIONS(1095),
    [aux_sym_public_statement_token1] = ACTIONS(1095),
    [aux_sym_namelist_statement_token1] = ACTIONS(1095),
    [aux_sym_common_statement_token1] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1093),
    [aux_sym_import_statement_token1] = ACTIONS(1095),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1095),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1095),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1095),
    [aux_sym_variable_attributes_token1] = ACTIONS(1095),
    [aux_sym_variable_attributes_token2] = ACTIONS(1095),
    [aux_sym_variable_attributes_token3] = ACTIONS(1095),
    [aux_sym_variable_attributes_token4] = ACTIONS(1095),
    [aux_sym_variable_attributes_token5] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1095),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1095),
    [aux_sym_derived_type_token1] = ACTIONS(1095),
    [aux_sym_type_qualifier_token1] = ACTIONS(1095),
    [aux_sym_type_qualifier_token2] = ACTIONS(1095),
    [aux_sym_type_qualifier_token3] = ACTIONS(1095),
    [aux_sym_type_qualifier_token4] = ACTIONS(1095),
    [aux_sym_type_qualifier_token5] = ACTIONS(1095),
    [aux_sym_type_qualifier_token9] = ACTIONS(1095),
    [aux_sym_type_qualifier_token10] = ACTIONS(1095),
    [aux_sym_type_qualifier_token11] = ACTIONS(1095),
    [aux_sym_type_qualifier_token12] = ACTIONS(1095),
    [aux_sym_type_qualifier_token13] = ACTIONS(1095),
    [aux_sym_type_qualifier_token14] = ACTIONS(1095),
    [aux_sym_type_qualifier_token15] = ACTIONS(1095),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1095),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1095),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1095),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1095),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1095),
    [aux_sym_stop_statement_token1] = ACTIONS(1095),
    [aux_sym_stop_statement_token2] = ACTIONS(1095),
    [aux_sym_subroutine_call_token1] = ACTIONS(1095),
    [aux_sym_keyword_statement_token1] = ACTIONS(1095),
    [aux_sym_keyword_statement_token2] = ACTIONS(1095),
    [aux_sym_keyword_statement_token3] = ACTIONS(1095),
    [aux_sym_keyword_statement_token4] = ACTIONS(1095),
    [aux_sym_keyword_statement_token6] = ACTIONS(1095),
    [aux_sym_keyword_statement_token7] = ACTIONS(1095),
    [aux_sym_include_statement_token1] = ACTIONS(1095),
    [aux_sym_data_statement_token1] = ACTIONS(1095),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1095),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1095),
    [aux_sym_end_if_statement_token1] = ACTIONS(1095),
    [aux_sym_elseif_clause_token2] = ACTIONS(1095),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1095),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1095),
    [aux_sym_select_case_statement_token1] = ACTIONS(1095),
    [aux_sym_select_case_statement_token3] = ACTIONS(1095),
    [aux_sym_select_type_statement_token1] = ACTIONS(1095),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1095),
    [aux_sym_block_construct_token1] = ACTIONS(1095),
    [aux_sym_associate_statement_token1] = ACTIONS(1095),
    [aux_sym_format_statement_token1] = ACTIONS(1095),
    [aux_sym_print_statement_token1] = ACTIONS(1095),
    [aux_sym_open_statement_token1] = ACTIONS(1095),
    [aux_sym_close_statement_token1] = ACTIONS(1095),
    [aux_sym_inquire_statement_token1] = ACTIONS(1095),
    [aux_sym_enum_statement_token1] = ACTIONS(1095),
    [aux_sym_file_position_statement_token1] = ACTIONS(1095),
    [aux_sym_file_position_statement_token2] = ACTIONS(1095),
    [aux_sym_file_position_statement_token3] = ACTIONS(1095),
    [aux_sym_file_position_statement_token4] = ACTIONS(1095),
    [aux_sym_logical_expression_token5] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [sym_boolean_literal] = ACTIONS(1093),
    [aux_sym_null_literal_token1] = ACTIONS(1095),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1095),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__float_literal] = ACTIONS(1093),
    [sym__boz_literal] = ACTIONS(1093),
    [sym_string_literal] = ACTIONS(1093),
  },
  [234] = {
    [sym_preproc_file_line] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [aux_sym_program_statement_token1] = ACTIONS(1099),
    [aux_sym_end_program_statement_token1] = ACTIONS(1099),
    [aux_sym_end_program_statement_token2] = ACTIONS(1099),
    [aux_sym_module_statement_token1] = ACTIONS(1099),
    [aux_sym_submodule_statement_token1] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [aux_sym_interface_statement_token1] = ACTIONS(1099),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1099),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1099),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1099),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1099),
    [aux_sym_function_statement_token1] = ACTIONS(1099),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1099),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1099),
    [aux_sym_contains_statement_token1] = ACTIONS(1099),
    [aux_sym_use_statement_token1] = ACTIONS(1099),
    [aux_sym_use_statement_token2] = ACTIONS(1099),
    [aux_sym_implicit_statement_token1] = ACTIONS(1099),
    [aux_sym_implicit_statement_token3] = ACTIONS(1099),
    [aux_sym_implicit_statement_token4] = ACTIONS(1099),
    [aux_sym_save_statement_token1] = ACTIONS(1099),
    [aux_sym_private_statement_token1] = ACTIONS(1099),
    [aux_sym_public_statement_token1] = ACTIONS(1099),
    [aux_sym_namelist_statement_token1] = ACTIONS(1099),
    [aux_sym_common_statement_token1] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1097),
    [aux_sym_import_statement_token1] = ACTIONS(1099),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1099),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1099),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1099),
    [aux_sym_variable_attributes_token1] = ACTIONS(1099),
    [aux_sym_variable_attributes_token2] = ACTIONS(1099),
    [aux_sym_variable_attributes_token3] = ACTIONS(1099),
    [aux_sym_variable_attributes_token4] = ACTIONS(1099),
    [aux_sym_variable_attributes_token5] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1099),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1099),
    [aux_sym_derived_type_token1] = ACTIONS(1099),
    [aux_sym_type_qualifier_token1] = ACTIONS(1099),
    [aux_sym_type_qualifier_token2] = ACTIONS(1099),
    [aux_sym_type_qualifier_token3] = ACTIONS(1099),
    [aux_sym_type_qualifier_token4] = ACTIONS(1099),
    [aux_sym_type_qualifier_token5] = ACTIONS(1099),
    [aux_sym_type_qualifier_token9] = ACTIONS(1099),
    [aux_sym_type_qualifier_token10] = ACTIONS(1099),
    [aux_sym_type_qualifier_token11] = ACTIONS(1099),
    [aux_sym_type_qualifier_token12] = ACTIONS(1099),
    [aux_sym_type_qualifier_token13] = ACTIONS(1099),
    [aux_sym_type_qualifier_token14] = ACTIONS(1099),
    [aux_sym_type_qualifier_token15] = ACTIONS(1099),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1099),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1099),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1099),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1099),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1099),
    [aux_sym_stop_statement_token1] = ACTIONS(1099),
    [aux_sym_stop_statement_token2] = ACTIONS(1099),
    [aux_sym_subroutine_call_token1] = ACTIONS(1099),
    [aux_sym_keyword_statement_token1] = ACTIONS(1099),
    [aux_sym_keyword_statement_token2] = ACTIONS(1099),
    [aux_sym_keyword_statement_token3] = ACTIONS(1099),
    [aux_sym_keyword_statement_token4] = ACTIONS(1099),
    [aux_sym_keyword_statement_token6] = ACTIONS(1099),
    [aux_sym_keyword_statement_token7] = ACTIONS(1099),
    [aux_sym_include_statement_token1] = ACTIONS(1099),
    [aux_sym_data_statement_token1] = ACTIONS(1099),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1099),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1099),
    [aux_sym_end_if_statement_token1] = ACTIONS(1099),
    [aux_sym_elseif_clause_token2] = ACTIONS(1099),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1099),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1099),
    [aux_sym_select_case_statement_token1] = ACTIONS(1099),
    [aux_sym_select_case_statement_token3] = ACTIONS(1099),
    [aux_sym_select_type_statement_token1] = ACTIONS(1099),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1099),
    [aux_sym_block_construct_token1] = ACTIONS(1099),
    [aux_sym_associate_statement_token1] = ACTIONS(1099),
    [aux_sym_format_statement_token1] = ACTIONS(1099),
    [aux_sym_print_statement_token1] = ACTIONS(1099),
    [aux_sym_open_statement_token1] = ACTIONS(1099),
    [aux_sym_close_statement_token1] = ACTIONS(1099),
    [aux_sym_inquire_statement_token1] = ACTIONS(1099),
    [aux_sym_enum_statement_token1] = ACTIONS(1099),
    [aux_sym_file_position_statement_token1] = ACTIONS(1099),
    [aux_sym_file_position_statement_token2] = ACTIONS(1099),
    [aux_sym_file_position_statement_token3] = ACTIONS(1099),
    [aux_sym_file_position_statement_token4] = ACTIONS(1099),
    [aux_sym_logical_expression_token5] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_boolean_literal] = ACTIONS(1097),
    [aux_sym_null_literal_token1] = ACTIONS(1099),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1099),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1097),
    [sym__float_literal] = ACTIONS(1097),
    [sym__boz_literal] = ACTIONS(1097),
    [sym_string_literal] = ACTIONS(1097),
  },
  [235] = {
    [sym_preproc_file_line] = STATE(235),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [aux_sym_program_statement_token1] = ACTIONS(1103),
    [aux_sym_end_program_statement_token1] = ACTIONS(1103),
    [aux_sym_end_program_statement_token2] = ACTIONS(1103),
    [aux_sym_module_statement_token1] = ACTIONS(1103),
    [aux_sym_submodule_statement_token1] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [aux_sym_interface_statement_token1] = ACTIONS(1103),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1103),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1103),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1103),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1103),
    [aux_sym_function_statement_token1] = ACTIONS(1103),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1103),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1103),
    [aux_sym_contains_statement_token1] = ACTIONS(1103),
    [aux_sym_use_statement_token1] = ACTIONS(1103),
    [aux_sym_use_statement_token2] = ACTIONS(1103),
    [aux_sym_implicit_statement_token1] = ACTIONS(1103),
    [aux_sym_implicit_statement_token3] = ACTIONS(1103),
    [aux_sym_implicit_statement_token4] = ACTIONS(1103),
    [aux_sym_save_statement_token1] = ACTIONS(1103),
    [aux_sym_private_statement_token1] = ACTIONS(1103),
    [aux_sym_public_statement_token1] = ACTIONS(1103),
    [aux_sym_namelist_statement_token1] = ACTIONS(1103),
    [aux_sym_common_statement_token1] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1101),
    [aux_sym_import_statement_token1] = ACTIONS(1103),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1103),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1103),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1103),
    [aux_sym_variable_attributes_token1] = ACTIONS(1103),
    [aux_sym_variable_attributes_token2] = ACTIONS(1103),
    [aux_sym_variable_attributes_token3] = ACTIONS(1103),
    [aux_sym_variable_attributes_token4] = ACTIONS(1103),
    [aux_sym_variable_attributes_token5] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1103),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1103),
    [aux_sym_derived_type_token1] = ACTIONS(1103),
    [aux_sym_type_qualifier_token1] = ACTIONS(1103),
    [aux_sym_type_qualifier_token2] = ACTIONS(1103),
    [aux_sym_type_qualifier_token3] = ACTIONS(1103),
    [aux_sym_type_qualifier_token4] = ACTIONS(1103),
    [aux_sym_type_qualifier_token5] = ACTIONS(1103),
    [aux_sym_type_qualifier_token9] = ACTIONS(1103),
    [aux_sym_type_qualifier_token10] = ACTIONS(1103),
    [aux_sym_type_qualifier_token11] = ACTIONS(1103),
    [aux_sym_type_qualifier_token12] = ACTIONS(1103),
    [aux_sym_type_qualifier_token13] = ACTIONS(1103),
    [aux_sym_type_qualifier_token14] = ACTIONS(1103),
    [aux_sym_type_qualifier_token15] = ACTIONS(1103),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1103),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1103),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1103),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1103),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1103),
    [aux_sym_stop_statement_token1] = ACTIONS(1103),
    [aux_sym_stop_statement_token2] = ACTIONS(1103),
    [aux_sym_subroutine_call_token1] = ACTIONS(1103),
    [aux_sym_keyword_statement_token1] = ACTIONS(1103),
    [aux_sym_keyword_statement_token2] = ACTIONS(1103),
    [aux_sym_keyword_statement_token3] = ACTIONS(1103),
    [aux_sym_keyword_statement_token4] = ACTIONS(1103),
    [aux_sym_keyword_statement_token6] = ACTIONS(1103),
    [aux_sym_keyword_statement_token7] = ACTIONS(1103),
    [aux_sym_include_statement_token1] = ACTIONS(1103),
    [aux_sym_data_statement_token1] = ACTIONS(1103),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1103),
    [aux_sym_end_if_statement_token1] = ACTIONS(1103),
    [aux_sym_elseif_clause_token2] = ACTIONS(1103),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1103),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1103),
    [aux_sym_select_case_statement_token1] = ACTIONS(1103),
    [aux_sym_select_case_statement_token3] = ACTIONS(1103),
    [aux_sym_select_type_statement_token1] = ACTIONS(1103),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1103),
    [aux_sym_block_construct_token1] = ACTIONS(1103),
    [aux_sym_associate_statement_token1] = ACTIONS(1103),
    [aux_sym_format_statement_token1] = ACTIONS(1103),
    [aux_sym_print_statement_token1] = ACTIONS(1103),
    [aux_sym_open_statement_token1] = ACTIONS(1103),
    [aux_sym_close_statement_token1] = ACTIONS(1103),
    [aux_sym_inquire_statement_token1] = ACTIONS(1103),
    [aux_sym_enum_statement_token1] = ACTIONS(1103),
    [aux_sym_file_position_statement_token1] = ACTIONS(1103),
    [aux_sym_file_position_statement_token2] = ACTIONS(1103),
    [aux_sym_file_position_statement_token3] = ACTIONS(1103),
    [aux_sym_file_position_statement_token4] = ACTIONS(1103),
    [aux_sym_logical_expression_token5] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [sym_boolean_literal] = ACTIONS(1101),
    [aux_sym_null_literal_token1] = ACTIONS(1103),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1103),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1101),
    [sym__float_literal] = ACTIONS(1101),
    [sym__boz_literal] = ACTIONS(1101),
    [sym_string_literal] = ACTIONS(1101),
  },
  [236] = {
    [sym_preproc_file_line] = STATE(236),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [aux_sym_program_statement_token1] = ACTIONS(1107),
    [aux_sym_end_program_statement_token1] = ACTIONS(1107),
    [aux_sym_end_program_statement_token2] = ACTIONS(1107),
    [aux_sym_module_statement_token1] = ACTIONS(1107),
    [aux_sym_submodule_statement_token1] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [aux_sym_interface_statement_token1] = ACTIONS(1107),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1107),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1107),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1107),
    [aux_sym_function_statement_token1] = ACTIONS(1107),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1107),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1107),
    [aux_sym_contains_statement_token1] = ACTIONS(1107),
    [aux_sym_use_statement_token1] = ACTIONS(1107),
    [aux_sym_use_statement_token2] = ACTIONS(1107),
    [aux_sym_implicit_statement_token1] = ACTIONS(1107),
    [aux_sym_implicit_statement_token3] = ACTIONS(1107),
    [aux_sym_implicit_statement_token4] = ACTIONS(1107),
    [aux_sym_save_statement_token1] = ACTIONS(1107),
    [aux_sym_private_statement_token1] = ACTIONS(1107),
    [aux_sym_public_statement_token1] = ACTIONS(1107),
    [aux_sym_namelist_statement_token1] = ACTIONS(1107),
    [aux_sym_common_statement_token1] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1105),
    [aux_sym_import_statement_token1] = ACTIONS(1107),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1107),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1107),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1107),
    [aux_sym_variable_attributes_token1] = ACTIONS(1107),
    [aux_sym_variable_attributes_token2] = ACTIONS(1107),
    [aux_sym_variable_attributes_token3] = ACTIONS(1107),
    [aux_sym_variable_attributes_token4] = ACTIONS(1107),
    [aux_sym_variable_attributes_token5] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1107),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1107),
    [aux_sym_derived_type_token1] = ACTIONS(1107),
    [aux_sym_type_qualifier_token1] = ACTIONS(1107),
    [aux_sym_type_qualifier_token2] = ACTIONS(1107),
    [aux_sym_type_qualifier_token3] = ACTIONS(1107),
    [aux_sym_type_qualifier_token4] = ACTIONS(1107),
    [aux_sym_type_qualifier_token5] = ACTIONS(1107),
    [aux_sym_type_qualifier_token9] = ACTIONS(1107),
    [aux_sym_type_qualifier_token10] = ACTIONS(1107),
    [aux_sym_type_qualifier_token11] = ACTIONS(1107),
    [aux_sym_type_qualifier_token12] = ACTIONS(1107),
    [aux_sym_type_qualifier_token13] = ACTIONS(1107),
    [aux_sym_type_qualifier_token14] = ACTIONS(1107),
    [aux_sym_type_qualifier_token15] = ACTIONS(1107),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1107),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1107),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1107),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1107),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1107),
    [aux_sym_stop_statement_token1] = ACTIONS(1107),
    [aux_sym_stop_statement_token2] = ACTIONS(1107),
    [aux_sym_subroutine_call_token1] = ACTIONS(1107),
    [aux_sym_keyword_statement_token1] = ACTIONS(1107),
    [aux_sym_keyword_statement_token2] = ACTIONS(1107),
    [aux_sym_keyword_statement_token3] = ACTIONS(1107),
    [aux_sym_keyword_statement_token4] = ACTIONS(1107),
    [aux_sym_keyword_statement_token6] = ACTIONS(1107),
    [aux_sym_keyword_statement_token7] = ACTIONS(1107),
    [aux_sym_include_statement_token1] = ACTIONS(1107),
    [aux_sym_data_statement_token1] = ACTIONS(1107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1107),
    [aux_sym_end_if_statement_token1] = ACTIONS(1107),
    [aux_sym_elseif_clause_token2] = ACTIONS(1107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1107),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1107),
    [aux_sym_select_case_statement_token3] = ACTIONS(1107),
    [aux_sym_select_type_statement_token1] = ACTIONS(1107),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1107),
    [aux_sym_block_construct_token1] = ACTIONS(1107),
    [aux_sym_associate_statement_token1] = ACTIONS(1107),
    [aux_sym_format_statement_token1] = ACTIONS(1107),
    [aux_sym_print_statement_token1] = ACTIONS(1107),
    [aux_sym_open_statement_token1] = ACTIONS(1107),
    [aux_sym_close_statement_token1] = ACTIONS(1107),
    [aux_sym_inquire_statement_token1] = ACTIONS(1107),
    [aux_sym_enum_statement_token1] = ACTIONS(1107),
    [aux_sym_file_position_statement_token1] = ACTIONS(1107),
    [aux_sym_file_position_statement_token2] = ACTIONS(1107),
    [aux_sym_file_position_statement_token3] = ACTIONS(1107),
    [aux_sym_file_position_statement_token4] = ACTIONS(1107),
    [aux_sym_logical_expression_token5] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [sym_boolean_literal] = ACTIONS(1105),
    [aux_sym_null_literal_token1] = ACTIONS(1107),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1105),
    [sym__float_literal] = ACTIONS(1105),
    [sym__boz_literal] = ACTIONS(1105),
    [sym_string_literal] = ACTIONS(1105),
  },
  [237] = {
    [sym_preproc_file_line] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(1109),
    [aux_sym_program_statement_token1] = ACTIONS(1111),
    [aux_sym_end_program_statement_token1] = ACTIONS(1111),
    [aux_sym_end_program_statement_token2] = ACTIONS(1111),
    [aux_sym_module_statement_token1] = ACTIONS(1111),
    [aux_sym_submodule_statement_token1] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [aux_sym_interface_statement_token1] = ACTIONS(1111),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1111),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1111),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1111),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1111),
    [aux_sym_function_statement_token1] = ACTIONS(1111),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1111),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1111),
    [aux_sym_contains_statement_token1] = ACTIONS(1111),
    [aux_sym_use_statement_token1] = ACTIONS(1111),
    [aux_sym_use_statement_token2] = ACTIONS(1111),
    [aux_sym_implicit_statement_token1] = ACTIONS(1111),
    [aux_sym_implicit_statement_token3] = ACTIONS(1111),
    [aux_sym_implicit_statement_token4] = ACTIONS(1111),
    [aux_sym_save_statement_token1] = ACTIONS(1111),
    [aux_sym_private_statement_token1] = ACTIONS(1111),
    [aux_sym_public_statement_token1] = ACTIONS(1111),
    [aux_sym_namelist_statement_token1] = ACTIONS(1111),
    [aux_sym_common_statement_token1] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1109),
    [aux_sym_import_statement_token1] = ACTIONS(1111),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1111),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1111),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1111),
    [aux_sym_variable_attributes_token1] = ACTIONS(1111),
    [aux_sym_variable_attributes_token2] = ACTIONS(1111),
    [aux_sym_variable_attributes_token3] = ACTIONS(1111),
    [aux_sym_variable_attributes_token4] = ACTIONS(1111),
    [aux_sym_variable_attributes_token5] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1111),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1111),
    [aux_sym_derived_type_token1] = ACTIONS(1111),
    [aux_sym_type_qualifier_token1] = ACTIONS(1111),
    [aux_sym_type_qualifier_token2] = ACTIONS(1111),
    [aux_sym_type_qualifier_token3] = ACTIONS(1111),
    [aux_sym_type_qualifier_token4] = ACTIONS(1111),
    [aux_sym_type_qualifier_token5] = ACTIONS(1111),
    [aux_sym_type_qualifier_token9] = ACTIONS(1111),
    [aux_sym_type_qualifier_token10] = ACTIONS(1111),
    [aux_sym_type_qualifier_token11] = ACTIONS(1111),
    [aux_sym_type_qualifier_token12] = ACTIONS(1111),
    [aux_sym_type_qualifier_token13] = ACTIONS(1111),
    [aux_sym_type_qualifier_token14] = ACTIONS(1111),
    [aux_sym_type_qualifier_token15] = ACTIONS(1111),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1111),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1111),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1111),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1111),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1111),
    [aux_sym_stop_statement_token1] = ACTIONS(1111),
    [aux_sym_stop_statement_token2] = ACTIONS(1111),
    [aux_sym_subroutine_call_token1] = ACTIONS(1111),
    [aux_sym_keyword_statement_token1] = ACTIONS(1111),
    [aux_sym_keyword_statement_token2] = ACTIONS(1111),
    [aux_sym_keyword_statement_token3] = ACTIONS(1111),
    [aux_sym_keyword_statement_token4] = ACTIONS(1111),
    [aux_sym_keyword_statement_token6] = ACTIONS(1111),
    [aux_sym_keyword_statement_token7] = ACTIONS(1111),
    [aux_sym_include_statement_token1] = ACTIONS(1111),
    [aux_sym_data_statement_token1] = ACTIONS(1111),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1111),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1111),
    [aux_sym_end_if_statement_token1] = ACTIONS(1111),
    [aux_sym_elseif_clause_token2] = ACTIONS(1111),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1111),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1111),
    [aux_sym_select_case_statement_token1] = ACTIONS(1111),
    [aux_sym_select_case_statement_token3] = ACTIONS(1111),
    [aux_sym_select_type_statement_token1] = ACTIONS(1111),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1111),
    [aux_sym_block_construct_token1] = ACTIONS(1111),
    [aux_sym_associate_statement_token1] = ACTIONS(1111),
    [aux_sym_format_statement_token1] = ACTIONS(1111),
    [aux_sym_print_statement_token1] = ACTIONS(1111),
    [aux_sym_open_statement_token1] = ACTIONS(1111),
    [aux_sym_close_statement_token1] = ACTIONS(1111),
    [aux_sym_inquire_statement_token1] = ACTIONS(1111),
    [aux_sym_enum_statement_token1] = ACTIONS(1111),
    [aux_sym_file_position_statement_token1] = ACTIONS(1111),
    [aux_sym_file_position_statement_token2] = ACTIONS(1111),
    [aux_sym_file_position_statement_token3] = ACTIONS(1111),
    [aux_sym_file_position_statement_token4] = ACTIONS(1111),
    [aux_sym_logical_expression_token5] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [sym_boolean_literal] = ACTIONS(1109),
    [aux_sym_null_literal_token1] = ACTIONS(1111),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1111),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1109),
    [sym__float_literal] = ACTIONS(1109),
    [sym__boz_literal] = ACTIONS(1109),
    [sym_string_literal] = ACTIONS(1109),
  },
  [238] = {
    [sym_preproc_file_line] = STATE(238),
    [ts_builtin_sym_end] = ACTIONS(1113),
    [aux_sym_program_statement_token1] = ACTIONS(1115),
    [aux_sym_end_program_statement_token1] = ACTIONS(1115),
    [aux_sym_end_program_statement_token2] = ACTIONS(1115),
    [aux_sym_module_statement_token1] = ACTIONS(1115),
    [aux_sym_submodule_statement_token1] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1115),
    [aux_sym_interface_statement_token1] = ACTIONS(1115),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1115),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1115),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1115),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1115),
    [aux_sym_function_statement_token1] = ACTIONS(1115),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1115),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1115),
    [aux_sym_contains_statement_token1] = ACTIONS(1115),
    [aux_sym_use_statement_token1] = ACTIONS(1115),
    [aux_sym_use_statement_token2] = ACTIONS(1115),
    [aux_sym_implicit_statement_token1] = ACTIONS(1115),
    [aux_sym_implicit_statement_token3] = ACTIONS(1115),
    [aux_sym_implicit_statement_token4] = ACTIONS(1115),
    [aux_sym_save_statement_token1] = ACTIONS(1115),
    [aux_sym_private_statement_token1] = ACTIONS(1115),
    [aux_sym_public_statement_token1] = ACTIONS(1115),
    [aux_sym_namelist_statement_token1] = ACTIONS(1115),
    [aux_sym_common_statement_token1] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1113),
    [aux_sym_import_statement_token1] = ACTIONS(1115),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1115),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1115),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1115),
    [aux_sym_variable_attributes_token1] = ACTIONS(1115),
    [aux_sym_variable_attributes_token2] = ACTIONS(1115),
    [aux_sym_variable_attributes_token3] = ACTIONS(1115),
    [aux_sym_variable_attributes_token4] = ACTIONS(1115),
    [aux_sym_variable_attributes_token5] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1115),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1115),
    [aux_sym_derived_type_token1] = ACTIONS(1115),
    [aux_sym_type_qualifier_token1] = ACTIONS(1115),
    [aux_sym_type_qualifier_token2] = ACTIONS(1115),
    [aux_sym_type_qualifier_token3] = ACTIONS(1115),
    [aux_sym_type_qualifier_token4] = ACTIONS(1115),
    [aux_sym_type_qualifier_token5] = ACTIONS(1115),
    [aux_sym_type_qualifier_token9] = ACTIONS(1115),
    [aux_sym_type_qualifier_token10] = ACTIONS(1115),
    [aux_sym_type_qualifier_token11] = ACTIONS(1115),
    [aux_sym_type_qualifier_token12] = ACTIONS(1115),
    [aux_sym_type_qualifier_token13] = ACTIONS(1115),
    [aux_sym_type_qualifier_token14] = ACTIONS(1115),
    [aux_sym_type_qualifier_token15] = ACTIONS(1115),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1115),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1115),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1115),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1115),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1115),
    [aux_sym_stop_statement_token1] = ACTIONS(1115),
    [aux_sym_stop_statement_token2] = ACTIONS(1115),
    [aux_sym_subroutine_call_token1] = ACTIONS(1115),
    [aux_sym_keyword_statement_token1] = ACTIONS(1115),
    [aux_sym_keyword_statement_token2] = ACTIONS(1115),
    [aux_sym_keyword_statement_token3] = ACTIONS(1115),
    [aux_sym_keyword_statement_token4] = ACTIONS(1115),
    [aux_sym_keyword_statement_token6] = ACTIONS(1115),
    [aux_sym_keyword_statement_token7] = ACTIONS(1115),
    [aux_sym_include_statement_token1] = ACTIONS(1115),
    [aux_sym_data_statement_token1] = ACTIONS(1115),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1115),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1115),
    [aux_sym_end_if_statement_token1] = ACTIONS(1115),
    [aux_sym_elseif_clause_token2] = ACTIONS(1115),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1115),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1115),
    [aux_sym_select_case_statement_token1] = ACTIONS(1115),
    [aux_sym_select_case_statement_token3] = ACTIONS(1115),
    [aux_sym_select_type_statement_token1] = ACTIONS(1115),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1115),
    [aux_sym_block_construct_token1] = ACTIONS(1115),
    [aux_sym_associate_statement_token1] = ACTIONS(1115),
    [aux_sym_format_statement_token1] = ACTIONS(1115),
    [aux_sym_print_statement_token1] = ACTIONS(1115),
    [aux_sym_open_statement_token1] = ACTIONS(1115),
    [aux_sym_close_statement_token1] = ACTIONS(1115),
    [aux_sym_inquire_statement_token1] = ACTIONS(1115),
    [aux_sym_enum_statement_token1] = ACTIONS(1115),
    [aux_sym_file_position_statement_token1] = ACTIONS(1115),
    [aux_sym_file_position_statement_token2] = ACTIONS(1115),
    [aux_sym_file_position_statement_token3] = ACTIONS(1115),
    [aux_sym_file_position_statement_token4] = ACTIONS(1115),
    [aux_sym_logical_expression_token5] = ACTIONS(1113),
    [anon_sym_PLUS] = ACTIONS(1113),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [sym_boolean_literal] = ACTIONS(1113),
    [aux_sym_null_literal_token1] = ACTIONS(1115),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1115),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1113),
    [sym__float_literal] = ACTIONS(1113),
    [sym__boz_literal] = ACTIONS(1113),
    [sym_string_literal] = ACTIONS(1113),
  },
  [239] = {
    [sym_preproc_file_line] = STATE(239),
    [ts_builtin_sym_end] = ACTIONS(1117),
    [aux_sym_program_statement_token1] = ACTIONS(1119),
    [aux_sym_end_program_statement_token1] = ACTIONS(1119),
    [aux_sym_end_program_statement_token2] = ACTIONS(1119),
    [aux_sym_module_statement_token1] = ACTIONS(1119),
    [aux_sym_submodule_statement_token1] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [aux_sym_interface_statement_token1] = ACTIONS(1119),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1119),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1119),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1119),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1119),
    [aux_sym_function_statement_token1] = ACTIONS(1119),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1119),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1119),
    [aux_sym_contains_statement_token1] = ACTIONS(1119),
    [aux_sym_use_statement_token1] = ACTIONS(1119),
    [aux_sym_use_statement_token2] = ACTIONS(1119),
    [aux_sym_implicit_statement_token1] = ACTIONS(1119),
    [aux_sym_implicit_statement_token3] = ACTIONS(1119),
    [aux_sym_implicit_statement_token4] = ACTIONS(1119),
    [aux_sym_save_statement_token1] = ACTIONS(1119),
    [aux_sym_private_statement_token1] = ACTIONS(1119),
    [aux_sym_public_statement_token1] = ACTIONS(1119),
    [aux_sym_namelist_statement_token1] = ACTIONS(1119),
    [aux_sym_common_statement_token1] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [aux_sym_import_statement_token1] = ACTIONS(1119),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1119),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1119),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1119),
    [aux_sym_variable_attributes_token1] = ACTIONS(1119),
    [aux_sym_variable_attributes_token2] = ACTIONS(1119),
    [aux_sym_variable_attributes_token3] = ACTIONS(1119),
    [aux_sym_variable_attributes_token4] = ACTIONS(1119),
    [aux_sym_variable_attributes_token5] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1119),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1119),
    [aux_sym_derived_type_token1] = ACTIONS(1119),
    [aux_sym_type_qualifier_token1] = ACTIONS(1119),
    [aux_sym_type_qualifier_token2] = ACTIONS(1119),
    [aux_sym_type_qualifier_token3] = ACTIONS(1119),
    [aux_sym_type_qualifier_token4] = ACTIONS(1119),
    [aux_sym_type_qualifier_token5] = ACTIONS(1119),
    [aux_sym_type_qualifier_token9] = ACTIONS(1119),
    [aux_sym_type_qualifier_token10] = ACTIONS(1119),
    [aux_sym_type_qualifier_token11] = ACTIONS(1119),
    [aux_sym_type_qualifier_token12] = ACTIONS(1119),
    [aux_sym_type_qualifier_token13] = ACTIONS(1119),
    [aux_sym_type_qualifier_token14] = ACTIONS(1119),
    [aux_sym_type_qualifier_token15] = ACTIONS(1119),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1119),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1119),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1119),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1119),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1119),
    [aux_sym_stop_statement_token1] = ACTIONS(1119),
    [aux_sym_stop_statement_token2] = ACTIONS(1119),
    [aux_sym_subroutine_call_token1] = ACTIONS(1119),
    [aux_sym_keyword_statement_token1] = ACTIONS(1119),
    [aux_sym_keyword_statement_token2] = ACTIONS(1119),
    [aux_sym_keyword_statement_token3] = ACTIONS(1119),
    [aux_sym_keyword_statement_token4] = ACTIONS(1119),
    [aux_sym_keyword_statement_token6] = ACTIONS(1119),
    [aux_sym_keyword_statement_token7] = ACTIONS(1119),
    [aux_sym_include_statement_token1] = ACTIONS(1119),
    [aux_sym_data_statement_token1] = ACTIONS(1119),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1119),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1119),
    [aux_sym_end_if_statement_token1] = ACTIONS(1119),
    [aux_sym_elseif_clause_token2] = ACTIONS(1119),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1119),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1119),
    [aux_sym_select_case_statement_token1] = ACTIONS(1119),
    [aux_sym_select_case_statement_token3] = ACTIONS(1119),
    [aux_sym_select_type_statement_token1] = ACTIONS(1119),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1119),
    [aux_sym_block_construct_token1] = ACTIONS(1119),
    [aux_sym_associate_statement_token1] = ACTIONS(1119),
    [aux_sym_format_statement_token1] = ACTIONS(1119),
    [aux_sym_print_statement_token1] = ACTIONS(1119),
    [aux_sym_open_statement_token1] = ACTIONS(1119),
    [aux_sym_close_statement_token1] = ACTIONS(1119),
    [aux_sym_inquire_statement_token1] = ACTIONS(1119),
    [aux_sym_enum_statement_token1] = ACTIONS(1119),
    [aux_sym_file_position_statement_token1] = ACTIONS(1119),
    [aux_sym_file_position_statement_token2] = ACTIONS(1119),
    [aux_sym_file_position_statement_token3] = ACTIONS(1119),
    [aux_sym_file_position_statement_token4] = ACTIONS(1119),
    [aux_sym_logical_expression_token5] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [sym_boolean_literal] = ACTIONS(1117),
    [aux_sym_null_literal_token1] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1119),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__float_literal] = ACTIONS(1117),
    [sym__boz_literal] = ACTIONS(1117),
    [sym_string_literal] = ACTIONS(1117),
  },
  [240] = {
    [sym_preproc_file_line] = STATE(240),
    [ts_builtin_sym_end] = ACTIONS(1121),
    [aux_sym_program_statement_token1] = ACTIONS(1123),
    [aux_sym_end_program_statement_token1] = ACTIONS(1123),
    [aux_sym_end_program_statement_token2] = ACTIONS(1123),
    [aux_sym_module_statement_token1] = ACTIONS(1123),
    [aux_sym_submodule_statement_token1] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [aux_sym_interface_statement_token1] = ACTIONS(1123),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1123),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1123),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1123),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1123),
    [aux_sym_function_statement_token1] = ACTIONS(1123),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1123),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1123),
    [aux_sym_contains_statement_token1] = ACTIONS(1123),
    [aux_sym_use_statement_token1] = ACTIONS(1123),
    [aux_sym_use_statement_token2] = ACTIONS(1123),
    [aux_sym_implicit_statement_token1] = ACTIONS(1123),
    [aux_sym_implicit_statement_token3] = ACTIONS(1123),
    [aux_sym_implicit_statement_token4] = ACTIONS(1123),
    [aux_sym_save_statement_token1] = ACTIONS(1123),
    [aux_sym_private_statement_token1] = ACTIONS(1123),
    [aux_sym_public_statement_token1] = ACTIONS(1123),
    [aux_sym_namelist_statement_token1] = ACTIONS(1123),
    [aux_sym_common_statement_token1] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1121),
    [aux_sym_import_statement_token1] = ACTIONS(1123),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1123),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1123),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1123),
    [aux_sym_variable_attributes_token1] = ACTIONS(1123),
    [aux_sym_variable_attributes_token2] = ACTIONS(1123),
    [aux_sym_variable_attributes_token3] = ACTIONS(1123),
    [aux_sym_variable_attributes_token4] = ACTIONS(1123),
    [aux_sym_variable_attributes_token5] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1123),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1123),
    [aux_sym_derived_type_token1] = ACTIONS(1123),
    [aux_sym_type_qualifier_token1] = ACTIONS(1123),
    [aux_sym_type_qualifier_token2] = ACTIONS(1123),
    [aux_sym_type_qualifier_token3] = ACTIONS(1123),
    [aux_sym_type_qualifier_token4] = ACTIONS(1123),
    [aux_sym_type_qualifier_token5] = ACTIONS(1123),
    [aux_sym_type_qualifier_token9] = ACTIONS(1123),
    [aux_sym_type_qualifier_token10] = ACTIONS(1123),
    [aux_sym_type_qualifier_token11] = ACTIONS(1123),
    [aux_sym_type_qualifier_token12] = ACTIONS(1123),
    [aux_sym_type_qualifier_token13] = ACTIONS(1123),
    [aux_sym_type_qualifier_token14] = ACTIONS(1123),
    [aux_sym_type_qualifier_token15] = ACTIONS(1123),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1123),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1123),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1123),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1123),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1123),
    [aux_sym_stop_statement_token1] = ACTIONS(1123),
    [aux_sym_stop_statement_token2] = ACTIONS(1123),
    [aux_sym_subroutine_call_token1] = ACTIONS(1123),
    [aux_sym_keyword_statement_token1] = ACTIONS(1123),
    [aux_sym_keyword_statement_token2] = ACTIONS(1123),
    [aux_sym_keyword_statement_token3] = ACTIONS(1123),
    [aux_sym_keyword_statement_token4] = ACTIONS(1123),
    [aux_sym_keyword_statement_token6] = ACTIONS(1123),
    [aux_sym_keyword_statement_token7] = ACTIONS(1123),
    [aux_sym_include_statement_token1] = ACTIONS(1123),
    [aux_sym_data_statement_token1] = ACTIONS(1123),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1123),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1123),
    [aux_sym_end_if_statement_token1] = ACTIONS(1123),
    [aux_sym_elseif_clause_token2] = ACTIONS(1123),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1123),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1123),
    [aux_sym_select_case_statement_token1] = ACTIONS(1123),
    [aux_sym_select_case_statement_token3] = ACTIONS(1123),
    [aux_sym_select_type_statement_token1] = ACTIONS(1123),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1123),
    [aux_sym_block_construct_token1] = ACTIONS(1123),
    [aux_sym_associate_statement_token1] = ACTIONS(1123),
    [aux_sym_format_statement_token1] = ACTIONS(1123),
    [aux_sym_print_statement_token1] = ACTIONS(1123),
    [aux_sym_open_statement_token1] = ACTIONS(1123),
    [aux_sym_close_statement_token1] = ACTIONS(1123),
    [aux_sym_inquire_statement_token1] = ACTIONS(1123),
    [aux_sym_enum_statement_token1] = ACTIONS(1123),
    [aux_sym_file_position_statement_token1] = ACTIONS(1123),
    [aux_sym_file_position_statement_token2] = ACTIONS(1123),
    [aux_sym_file_position_statement_token3] = ACTIONS(1123),
    [aux_sym_file_position_statement_token4] = ACTIONS(1123),
    [aux_sym_logical_expression_token5] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [sym_boolean_literal] = ACTIONS(1121),
    [aux_sym_null_literal_token1] = ACTIONS(1123),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1123),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1121),
    [sym__float_literal] = ACTIONS(1121),
    [sym__boz_literal] = ACTIONS(1121),
    [sym_string_literal] = ACTIONS(1121),
  },
  [241] = {
    [sym_preproc_file_line] = STATE(241),
    [ts_builtin_sym_end] = ACTIONS(1125),
    [aux_sym_program_statement_token1] = ACTIONS(1127),
    [aux_sym_end_program_statement_token1] = ACTIONS(1127),
    [aux_sym_end_program_statement_token2] = ACTIONS(1127),
    [aux_sym_module_statement_token1] = ACTIONS(1127),
    [aux_sym_submodule_statement_token1] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [aux_sym_interface_statement_token1] = ACTIONS(1127),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1127),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1127),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1127),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1127),
    [aux_sym_function_statement_token1] = ACTIONS(1127),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1127),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1127),
    [aux_sym_contains_statement_token1] = ACTIONS(1127),
    [aux_sym_use_statement_token1] = ACTIONS(1127),
    [aux_sym_use_statement_token2] = ACTIONS(1127),
    [aux_sym_implicit_statement_token1] = ACTIONS(1127),
    [aux_sym_implicit_statement_token3] = ACTIONS(1127),
    [aux_sym_implicit_statement_token4] = ACTIONS(1127),
    [aux_sym_save_statement_token1] = ACTIONS(1127),
    [aux_sym_private_statement_token1] = ACTIONS(1127),
    [aux_sym_public_statement_token1] = ACTIONS(1127),
    [aux_sym_namelist_statement_token1] = ACTIONS(1127),
    [aux_sym_common_statement_token1] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1125),
    [aux_sym_import_statement_token1] = ACTIONS(1127),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1127),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1127),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1127),
    [aux_sym_variable_attributes_token1] = ACTIONS(1127),
    [aux_sym_variable_attributes_token2] = ACTIONS(1127),
    [aux_sym_variable_attributes_token3] = ACTIONS(1127),
    [aux_sym_variable_attributes_token4] = ACTIONS(1127),
    [aux_sym_variable_attributes_token5] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1127),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1127),
    [aux_sym_derived_type_token1] = ACTIONS(1127),
    [aux_sym_type_qualifier_token1] = ACTIONS(1127),
    [aux_sym_type_qualifier_token2] = ACTIONS(1127),
    [aux_sym_type_qualifier_token3] = ACTIONS(1127),
    [aux_sym_type_qualifier_token4] = ACTIONS(1127),
    [aux_sym_type_qualifier_token5] = ACTIONS(1127),
    [aux_sym_type_qualifier_token9] = ACTIONS(1127),
    [aux_sym_type_qualifier_token10] = ACTIONS(1127),
    [aux_sym_type_qualifier_token11] = ACTIONS(1127),
    [aux_sym_type_qualifier_token12] = ACTIONS(1127),
    [aux_sym_type_qualifier_token13] = ACTIONS(1127),
    [aux_sym_type_qualifier_token14] = ACTIONS(1127),
    [aux_sym_type_qualifier_token15] = ACTIONS(1127),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1127),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1127),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1127),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1127),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1127),
    [aux_sym_stop_statement_token1] = ACTIONS(1127),
    [aux_sym_stop_statement_token2] = ACTIONS(1127),
    [aux_sym_subroutine_call_token1] = ACTIONS(1127),
    [aux_sym_keyword_statement_token1] = ACTIONS(1127),
    [aux_sym_keyword_statement_token2] = ACTIONS(1127),
    [aux_sym_keyword_statement_token3] = ACTIONS(1127),
    [aux_sym_keyword_statement_token4] = ACTIONS(1127),
    [aux_sym_keyword_statement_token6] = ACTIONS(1127),
    [aux_sym_keyword_statement_token7] = ACTIONS(1127),
    [aux_sym_include_statement_token1] = ACTIONS(1127),
    [aux_sym_data_statement_token1] = ACTIONS(1127),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1127),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1127),
    [aux_sym_end_if_statement_token1] = ACTIONS(1127),
    [aux_sym_elseif_clause_token2] = ACTIONS(1127),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1127),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1127),
    [aux_sym_select_case_statement_token1] = ACTIONS(1127),
    [aux_sym_select_case_statement_token3] = ACTIONS(1127),
    [aux_sym_select_type_statement_token1] = ACTIONS(1127),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1127),
    [aux_sym_block_construct_token1] = ACTIONS(1127),
    [aux_sym_associate_statement_token1] = ACTIONS(1127),
    [aux_sym_format_statement_token1] = ACTIONS(1127),
    [aux_sym_print_statement_token1] = ACTIONS(1127),
    [aux_sym_open_statement_token1] = ACTIONS(1127),
    [aux_sym_close_statement_token1] = ACTIONS(1127),
    [aux_sym_inquire_statement_token1] = ACTIONS(1127),
    [aux_sym_enum_statement_token1] = ACTIONS(1127),
    [aux_sym_file_position_statement_token1] = ACTIONS(1127),
    [aux_sym_file_position_statement_token2] = ACTIONS(1127),
    [aux_sym_file_position_statement_token3] = ACTIONS(1127),
    [aux_sym_file_position_statement_token4] = ACTIONS(1127),
    [aux_sym_logical_expression_token5] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [sym_boolean_literal] = ACTIONS(1125),
    [aux_sym_null_literal_token1] = ACTIONS(1127),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1127),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1125),
    [sym__float_literal] = ACTIONS(1125),
    [sym__boz_literal] = ACTIONS(1125),
    [sym_string_literal] = ACTIONS(1125),
  },
  [242] = {
    [sym_preproc_file_line] = STATE(242),
    [ts_builtin_sym_end] = ACTIONS(1129),
    [aux_sym_program_statement_token1] = ACTIONS(1131),
    [aux_sym_end_program_statement_token1] = ACTIONS(1131),
    [aux_sym_end_program_statement_token2] = ACTIONS(1131),
    [aux_sym_module_statement_token1] = ACTIONS(1131),
    [aux_sym_submodule_statement_token1] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [aux_sym_interface_statement_token1] = ACTIONS(1131),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1131),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1131),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1131),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1131),
    [aux_sym_function_statement_token1] = ACTIONS(1131),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1131),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1131),
    [aux_sym_contains_statement_token1] = ACTIONS(1131),
    [aux_sym_use_statement_token1] = ACTIONS(1131),
    [aux_sym_use_statement_token2] = ACTIONS(1131),
    [aux_sym_implicit_statement_token1] = ACTIONS(1131),
    [aux_sym_implicit_statement_token3] = ACTIONS(1131),
    [aux_sym_implicit_statement_token4] = ACTIONS(1131),
    [aux_sym_save_statement_token1] = ACTIONS(1131),
    [aux_sym_private_statement_token1] = ACTIONS(1131),
    [aux_sym_public_statement_token1] = ACTIONS(1131),
    [aux_sym_namelist_statement_token1] = ACTIONS(1131),
    [aux_sym_common_statement_token1] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1129),
    [aux_sym_import_statement_token1] = ACTIONS(1131),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1131),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1131),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1131),
    [aux_sym_variable_attributes_token1] = ACTIONS(1131),
    [aux_sym_variable_attributes_token2] = ACTIONS(1131),
    [aux_sym_variable_attributes_token3] = ACTIONS(1131),
    [aux_sym_variable_attributes_token4] = ACTIONS(1131),
    [aux_sym_variable_attributes_token5] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1131),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1131),
    [aux_sym_derived_type_token1] = ACTIONS(1131),
    [aux_sym_type_qualifier_token1] = ACTIONS(1131),
    [aux_sym_type_qualifier_token2] = ACTIONS(1131),
    [aux_sym_type_qualifier_token3] = ACTIONS(1131),
    [aux_sym_type_qualifier_token4] = ACTIONS(1131),
    [aux_sym_type_qualifier_token5] = ACTIONS(1131),
    [aux_sym_type_qualifier_token9] = ACTIONS(1131),
    [aux_sym_type_qualifier_token10] = ACTIONS(1131),
    [aux_sym_type_qualifier_token11] = ACTIONS(1131),
    [aux_sym_type_qualifier_token12] = ACTIONS(1131),
    [aux_sym_type_qualifier_token13] = ACTIONS(1131),
    [aux_sym_type_qualifier_token14] = ACTIONS(1131),
    [aux_sym_type_qualifier_token15] = ACTIONS(1131),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1131),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1131),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1131),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1131),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1131),
    [aux_sym_stop_statement_token1] = ACTIONS(1131),
    [aux_sym_stop_statement_token2] = ACTIONS(1131),
    [aux_sym_subroutine_call_token1] = ACTIONS(1131),
    [aux_sym_keyword_statement_token1] = ACTIONS(1131),
    [aux_sym_keyword_statement_token2] = ACTIONS(1131),
    [aux_sym_keyword_statement_token3] = ACTIONS(1131),
    [aux_sym_keyword_statement_token4] = ACTIONS(1131),
    [aux_sym_keyword_statement_token6] = ACTIONS(1131),
    [aux_sym_keyword_statement_token7] = ACTIONS(1131),
    [aux_sym_include_statement_token1] = ACTIONS(1131),
    [aux_sym_data_statement_token1] = ACTIONS(1131),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1131),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1131),
    [aux_sym_end_if_statement_token1] = ACTIONS(1131),
    [aux_sym_elseif_clause_token2] = ACTIONS(1131),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1131),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1131),
    [aux_sym_select_case_statement_token1] = ACTIONS(1131),
    [aux_sym_select_case_statement_token3] = ACTIONS(1131),
    [aux_sym_select_type_statement_token1] = ACTIONS(1131),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1131),
    [aux_sym_block_construct_token1] = ACTIONS(1131),
    [aux_sym_associate_statement_token1] = ACTIONS(1131),
    [aux_sym_format_statement_token1] = ACTIONS(1131),
    [aux_sym_print_statement_token1] = ACTIONS(1131),
    [aux_sym_open_statement_token1] = ACTIONS(1131),
    [aux_sym_close_statement_token1] = ACTIONS(1131),
    [aux_sym_inquire_statement_token1] = ACTIONS(1131),
    [aux_sym_enum_statement_token1] = ACTIONS(1131),
    [aux_sym_file_position_statement_token1] = ACTIONS(1131),
    [aux_sym_file_position_statement_token2] = ACTIONS(1131),
    [aux_sym_file_position_statement_token3] = ACTIONS(1131),
    [aux_sym_file_position_statement_token4] = ACTIONS(1131),
    [aux_sym_logical_expression_token5] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [sym_boolean_literal] = ACTIONS(1129),
    [aux_sym_null_literal_token1] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1131),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1129),
    [sym__float_literal] = ACTIONS(1129),
    [sym__boz_literal] = ACTIONS(1129),
    [sym_string_literal] = ACTIONS(1129),
  },
  [243] = {
    [sym_preproc_file_line] = STATE(243),
    [ts_builtin_sym_end] = ACTIONS(1133),
    [aux_sym_program_statement_token1] = ACTIONS(1135),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [aux_sym_end_program_statement_token2] = ACTIONS(1135),
    [aux_sym_module_statement_token1] = ACTIONS(1135),
    [aux_sym_submodule_statement_token1] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_function_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_contains_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1135),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1135),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [244] = {
    [sym__statements] = STATE(2692),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(244),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [245] = {
    [sym_preproc_file_line] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(1137),
    [aux_sym_program_statement_token1] = ACTIONS(1139),
    [aux_sym_end_program_statement_token1] = ACTIONS(1139),
    [aux_sym_end_program_statement_token2] = ACTIONS(1139),
    [aux_sym_module_statement_token1] = ACTIONS(1139),
    [aux_sym_submodule_statement_token1] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [aux_sym_interface_statement_token1] = ACTIONS(1139),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1139),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1139),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1139),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1139),
    [aux_sym_function_statement_token1] = ACTIONS(1139),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1139),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1139),
    [aux_sym_contains_statement_token1] = ACTIONS(1139),
    [aux_sym_use_statement_token1] = ACTIONS(1139),
    [aux_sym_use_statement_token2] = ACTIONS(1139),
    [aux_sym_implicit_statement_token1] = ACTIONS(1139),
    [aux_sym_implicit_statement_token3] = ACTIONS(1139),
    [aux_sym_implicit_statement_token4] = ACTIONS(1139),
    [aux_sym_save_statement_token1] = ACTIONS(1139),
    [aux_sym_private_statement_token1] = ACTIONS(1139),
    [aux_sym_public_statement_token1] = ACTIONS(1139),
    [aux_sym_namelist_statement_token1] = ACTIONS(1139),
    [aux_sym_common_statement_token1] = ACTIONS(1139),
    [anon_sym_DASH] = ACTIONS(1137),
    [aux_sym_import_statement_token1] = ACTIONS(1139),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1139),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1139),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1139),
    [aux_sym_variable_attributes_token1] = ACTIONS(1139),
    [aux_sym_variable_attributes_token2] = ACTIONS(1139),
    [aux_sym_variable_attributes_token3] = ACTIONS(1139),
    [aux_sym_variable_attributes_token4] = ACTIONS(1139),
    [aux_sym_variable_attributes_token5] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1139),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1139),
    [aux_sym_derived_type_token1] = ACTIONS(1139),
    [aux_sym_type_qualifier_token1] = ACTIONS(1139),
    [aux_sym_type_qualifier_token2] = ACTIONS(1139),
    [aux_sym_type_qualifier_token3] = ACTIONS(1139),
    [aux_sym_type_qualifier_token4] = ACTIONS(1139),
    [aux_sym_type_qualifier_token5] = ACTIONS(1139),
    [aux_sym_type_qualifier_token9] = ACTIONS(1139),
    [aux_sym_type_qualifier_token10] = ACTIONS(1139),
    [aux_sym_type_qualifier_token11] = ACTIONS(1139),
    [aux_sym_type_qualifier_token12] = ACTIONS(1139),
    [aux_sym_type_qualifier_token13] = ACTIONS(1139),
    [aux_sym_type_qualifier_token14] = ACTIONS(1139),
    [aux_sym_type_qualifier_token15] = ACTIONS(1139),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1139),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1139),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1139),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1139),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1139),
    [aux_sym_stop_statement_token1] = ACTIONS(1139),
    [aux_sym_stop_statement_token2] = ACTIONS(1139),
    [aux_sym_subroutine_call_token1] = ACTIONS(1139),
    [aux_sym_keyword_statement_token1] = ACTIONS(1139),
    [aux_sym_keyword_statement_token2] = ACTIONS(1139),
    [aux_sym_keyword_statement_token3] = ACTIONS(1139),
    [aux_sym_keyword_statement_token4] = ACTIONS(1139),
    [aux_sym_keyword_statement_token6] = ACTIONS(1139),
    [aux_sym_keyword_statement_token7] = ACTIONS(1139),
    [aux_sym_include_statement_token1] = ACTIONS(1139),
    [aux_sym_data_statement_token1] = ACTIONS(1139),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1139),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1139),
    [aux_sym_end_if_statement_token1] = ACTIONS(1139),
    [aux_sym_elseif_clause_token2] = ACTIONS(1139),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1139),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1139),
    [aux_sym_select_case_statement_token1] = ACTIONS(1139),
    [aux_sym_select_case_statement_token3] = ACTIONS(1139),
    [aux_sym_select_type_statement_token1] = ACTIONS(1139),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1139),
    [aux_sym_block_construct_token1] = ACTIONS(1139),
    [aux_sym_associate_statement_token1] = ACTIONS(1139),
    [aux_sym_format_statement_token1] = ACTIONS(1139),
    [aux_sym_print_statement_token1] = ACTIONS(1139),
    [aux_sym_open_statement_token1] = ACTIONS(1139),
    [aux_sym_close_statement_token1] = ACTIONS(1139),
    [aux_sym_inquire_statement_token1] = ACTIONS(1139),
    [aux_sym_enum_statement_token1] = ACTIONS(1139),
    [aux_sym_file_position_statement_token1] = ACTIONS(1139),
    [aux_sym_file_position_statement_token2] = ACTIONS(1139),
    [aux_sym_file_position_statement_token3] = ACTIONS(1139),
    [aux_sym_file_position_statement_token4] = ACTIONS(1139),
    [aux_sym_logical_expression_token5] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_boolean_literal] = ACTIONS(1137),
    [aux_sym_null_literal_token1] = ACTIONS(1139),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1139),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1137),
    [sym__float_literal] = ACTIONS(1137),
    [sym__boz_literal] = ACTIONS(1137),
    [sym_string_literal] = ACTIONS(1137),
  },
  [246] = {
    [sym_preproc_file_line] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(1141),
    [aux_sym_program_statement_token1] = ACTIONS(1143),
    [aux_sym_end_program_statement_token1] = ACTIONS(1143),
    [aux_sym_end_program_statement_token2] = ACTIONS(1143),
    [aux_sym_module_statement_token1] = ACTIONS(1143),
    [aux_sym_submodule_statement_token1] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [aux_sym_interface_statement_token1] = ACTIONS(1143),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1143),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1143),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1143),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1143),
    [aux_sym_function_statement_token1] = ACTIONS(1143),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1143),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1143),
    [aux_sym_contains_statement_token1] = ACTIONS(1143),
    [aux_sym_use_statement_token1] = ACTIONS(1143),
    [aux_sym_use_statement_token2] = ACTIONS(1143),
    [aux_sym_implicit_statement_token1] = ACTIONS(1143),
    [aux_sym_implicit_statement_token3] = ACTIONS(1143),
    [aux_sym_implicit_statement_token4] = ACTIONS(1143),
    [aux_sym_save_statement_token1] = ACTIONS(1143),
    [aux_sym_private_statement_token1] = ACTIONS(1143),
    [aux_sym_public_statement_token1] = ACTIONS(1143),
    [aux_sym_namelist_statement_token1] = ACTIONS(1143),
    [aux_sym_common_statement_token1] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [aux_sym_import_statement_token1] = ACTIONS(1143),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1143),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1143),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1143),
    [aux_sym_variable_attributes_token1] = ACTIONS(1143),
    [aux_sym_variable_attributes_token2] = ACTIONS(1143),
    [aux_sym_variable_attributes_token3] = ACTIONS(1143),
    [aux_sym_variable_attributes_token4] = ACTIONS(1143),
    [aux_sym_variable_attributes_token5] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1143),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1143),
    [aux_sym_derived_type_token1] = ACTIONS(1143),
    [aux_sym_type_qualifier_token1] = ACTIONS(1143),
    [aux_sym_type_qualifier_token2] = ACTIONS(1143),
    [aux_sym_type_qualifier_token3] = ACTIONS(1143),
    [aux_sym_type_qualifier_token4] = ACTIONS(1143),
    [aux_sym_type_qualifier_token5] = ACTIONS(1143),
    [aux_sym_type_qualifier_token9] = ACTIONS(1143),
    [aux_sym_type_qualifier_token10] = ACTIONS(1143),
    [aux_sym_type_qualifier_token11] = ACTIONS(1143),
    [aux_sym_type_qualifier_token12] = ACTIONS(1143),
    [aux_sym_type_qualifier_token13] = ACTIONS(1143),
    [aux_sym_type_qualifier_token14] = ACTIONS(1143),
    [aux_sym_type_qualifier_token15] = ACTIONS(1143),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1143),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1143),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1143),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1143),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1143),
    [aux_sym_stop_statement_token1] = ACTIONS(1143),
    [aux_sym_stop_statement_token2] = ACTIONS(1143),
    [aux_sym_subroutine_call_token1] = ACTIONS(1143),
    [aux_sym_keyword_statement_token1] = ACTIONS(1143),
    [aux_sym_keyword_statement_token2] = ACTIONS(1143),
    [aux_sym_keyword_statement_token3] = ACTIONS(1143),
    [aux_sym_keyword_statement_token4] = ACTIONS(1143),
    [aux_sym_keyword_statement_token6] = ACTIONS(1143),
    [aux_sym_keyword_statement_token7] = ACTIONS(1143),
    [aux_sym_include_statement_token1] = ACTIONS(1143),
    [aux_sym_data_statement_token1] = ACTIONS(1143),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1143),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1143),
    [aux_sym_end_if_statement_token1] = ACTIONS(1143),
    [aux_sym_elseif_clause_token2] = ACTIONS(1143),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1143),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1143),
    [aux_sym_select_case_statement_token1] = ACTIONS(1143),
    [aux_sym_select_case_statement_token3] = ACTIONS(1143),
    [aux_sym_select_type_statement_token1] = ACTIONS(1143),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1143),
    [aux_sym_block_construct_token1] = ACTIONS(1143),
    [aux_sym_associate_statement_token1] = ACTIONS(1143),
    [aux_sym_format_statement_token1] = ACTIONS(1143),
    [aux_sym_print_statement_token1] = ACTIONS(1143),
    [aux_sym_open_statement_token1] = ACTIONS(1143),
    [aux_sym_close_statement_token1] = ACTIONS(1143),
    [aux_sym_inquire_statement_token1] = ACTIONS(1143),
    [aux_sym_enum_statement_token1] = ACTIONS(1143),
    [aux_sym_file_position_statement_token1] = ACTIONS(1143),
    [aux_sym_file_position_statement_token2] = ACTIONS(1143),
    [aux_sym_file_position_statement_token3] = ACTIONS(1143),
    [aux_sym_file_position_statement_token4] = ACTIONS(1143),
    [aux_sym_logical_expression_token5] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [sym_boolean_literal] = ACTIONS(1141),
    [aux_sym_null_literal_token1] = ACTIONS(1143),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1143),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__float_literal] = ACTIONS(1141),
    [sym__boz_literal] = ACTIONS(1141),
    [sym_string_literal] = ACTIONS(1141),
  },
  [247] = {
    [sym_preproc_file_line] = STATE(247),
    [ts_builtin_sym_end] = ACTIONS(1145),
    [aux_sym_program_statement_token1] = ACTIONS(1147),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [aux_sym_end_program_statement_token2] = ACTIONS(1147),
    [aux_sym_module_statement_token1] = ACTIONS(1147),
    [aux_sym_submodule_statement_token1] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_function_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_contains_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1147),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1147),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [248] = {
    [sym_preproc_file_line] = STATE(248),
    [ts_builtin_sym_end] = ACTIONS(1149),
    [aux_sym_program_statement_token1] = ACTIONS(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1151),
    [aux_sym_end_program_statement_token2] = ACTIONS(1151),
    [aux_sym_module_statement_token1] = ACTIONS(1151),
    [aux_sym_submodule_statement_token1] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [aux_sym_interface_statement_token1] = ACTIONS(1151),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1151),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1151),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1151),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1151),
    [aux_sym_function_statement_token1] = ACTIONS(1151),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1151),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1151),
    [aux_sym_contains_statement_token1] = ACTIONS(1151),
    [aux_sym_use_statement_token1] = ACTIONS(1151),
    [aux_sym_use_statement_token2] = ACTIONS(1151),
    [aux_sym_implicit_statement_token1] = ACTIONS(1151),
    [aux_sym_implicit_statement_token3] = ACTIONS(1151),
    [aux_sym_implicit_statement_token4] = ACTIONS(1151),
    [aux_sym_save_statement_token1] = ACTIONS(1151),
    [aux_sym_private_statement_token1] = ACTIONS(1151),
    [aux_sym_public_statement_token1] = ACTIONS(1151),
    [aux_sym_namelist_statement_token1] = ACTIONS(1151),
    [aux_sym_common_statement_token1] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1149),
    [aux_sym_import_statement_token1] = ACTIONS(1151),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1151),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1151),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1151),
    [aux_sym_variable_attributes_token1] = ACTIONS(1151),
    [aux_sym_variable_attributes_token2] = ACTIONS(1151),
    [aux_sym_variable_attributes_token3] = ACTIONS(1151),
    [aux_sym_variable_attributes_token4] = ACTIONS(1151),
    [aux_sym_variable_attributes_token5] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1151),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1151),
    [aux_sym_derived_type_token1] = ACTIONS(1151),
    [aux_sym_type_qualifier_token1] = ACTIONS(1151),
    [aux_sym_type_qualifier_token2] = ACTIONS(1151),
    [aux_sym_type_qualifier_token3] = ACTIONS(1151),
    [aux_sym_type_qualifier_token4] = ACTIONS(1151),
    [aux_sym_type_qualifier_token5] = ACTIONS(1151),
    [aux_sym_type_qualifier_token9] = ACTIONS(1151),
    [aux_sym_type_qualifier_token10] = ACTIONS(1151),
    [aux_sym_type_qualifier_token11] = ACTIONS(1151),
    [aux_sym_type_qualifier_token12] = ACTIONS(1151),
    [aux_sym_type_qualifier_token13] = ACTIONS(1151),
    [aux_sym_type_qualifier_token14] = ACTIONS(1151),
    [aux_sym_type_qualifier_token15] = ACTIONS(1151),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1151),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1151),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1151),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1151),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1151),
    [aux_sym_stop_statement_token1] = ACTIONS(1151),
    [aux_sym_stop_statement_token2] = ACTIONS(1151),
    [aux_sym_subroutine_call_token1] = ACTIONS(1151),
    [aux_sym_keyword_statement_token1] = ACTIONS(1151),
    [aux_sym_keyword_statement_token2] = ACTIONS(1151),
    [aux_sym_keyword_statement_token3] = ACTIONS(1151),
    [aux_sym_keyword_statement_token4] = ACTIONS(1151),
    [aux_sym_keyword_statement_token6] = ACTIONS(1151),
    [aux_sym_keyword_statement_token7] = ACTIONS(1151),
    [aux_sym_include_statement_token1] = ACTIONS(1151),
    [aux_sym_data_statement_token1] = ACTIONS(1151),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1151),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1151),
    [aux_sym_end_if_statement_token1] = ACTIONS(1151),
    [aux_sym_elseif_clause_token2] = ACTIONS(1151),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1151),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1151),
    [aux_sym_select_case_statement_token1] = ACTIONS(1151),
    [aux_sym_select_case_statement_token3] = ACTIONS(1151),
    [aux_sym_select_type_statement_token1] = ACTIONS(1151),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1151),
    [aux_sym_block_construct_token1] = ACTIONS(1151),
    [aux_sym_associate_statement_token1] = ACTIONS(1151),
    [aux_sym_format_statement_token1] = ACTIONS(1151),
    [aux_sym_print_statement_token1] = ACTIONS(1151),
    [aux_sym_open_statement_token1] = ACTIONS(1151),
    [aux_sym_close_statement_token1] = ACTIONS(1151),
    [aux_sym_inquire_statement_token1] = ACTIONS(1151),
    [aux_sym_enum_statement_token1] = ACTIONS(1151),
    [aux_sym_file_position_statement_token1] = ACTIONS(1151),
    [aux_sym_file_position_statement_token2] = ACTIONS(1151),
    [aux_sym_file_position_statement_token3] = ACTIONS(1151),
    [aux_sym_file_position_statement_token4] = ACTIONS(1151),
    [aux_sym_logical_expression_token5] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [sym_boolean_literal] = ACTIONS(1149),
    [aux_sym_null_literal_token1] = ACTIONS(1151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1151),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1149),
    [sym__float_literal] = ACTIONS(1149),
    [sym__boz_literal] = ACTIONS(1149),
    [sym_string_literal] = ACTIONS(1149),
  },
  [249] = {
    [sym_preproc_file_line] = STATE(249),
    [ts_builtin_sym_end] = ACTIONS(1153),
    [aux_sym_program_statement_token1] = ACTIONS(1155),
    [aux_sym_end_program_statement_token1] = ACTIONS(1155),
    [aux_sym_end_program_statement_token2] = ACTIONS(1155),
    [aux_sym_module_statement_token1] = ACTIONS(1155),
    [aux_sym_submodule_statement_token1] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [aux_sym_interface_statement_token1] = ACTIONS(1155),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1155),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1155),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1155),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1155),
    [aux_sym_function_statement_token1] = ACTIONS(1155),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1155),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1155),
    [aux_sym_contains_statement_token1] = ACTIONS(1155),
    [aux_sym_use_statement_token1] = ACTIONS(1155),
    [aux_sym_use_statement_token2] = ACTIONS(1155),
    [aux_sym_implicit_statement_token1] = ACTIONS(1155),
    [aux_sym_implicit_statement_token3] = ACTIONS(1155),
    [aux_sym_implicit_statement_token4] = ACTIONS(1155),
    [aux_sym_save_statement_token1] = ACTIONS(1155),
    [aux_sym_private_statement_token1] = ACTIONS(1155),
    [aux_sym_public_statement_token1] = ACTIONS(1155),
    [aux_sym_namelist_statement_token1] = ACTIONS(1155),
    [aux_sym_common_statement_token1] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1153),
    [aux_sym_import_statement_token1] = ACTIONS(1155),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1155),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1155),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1155),
    [aux_sym_variable_attributes_token1] = ACTIONS(1155),
    [aux_sym_variable_attributes_token2] = ACTIONS(1155),
    [aux_sym_variable_attributes_token3] = ACTIONS(1155),
    [aux_sym_variable_attributes_token4] = ACTIONS(1155),
    [aux_sym_variable_attributes_token5] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1155),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1155),
    [aux_sym_derived_type_token1] = ACTIONS(1155),
    [aux_sym_type_qualifier_token1] = ACTIONS(1155),
    [aux_sym_type_qualifier_token2] = ACTIONS(1155),
    [aux_sym_type_qualifier_token3] = ACTIONS(1155),
    [aux_sym_type_qualifier_token4] = ACTIONS(1155),
    [aux_sym_type_qualifier_token5] = ACTIONS(1155),
    [aux_sym_type_qualifier_token9] = ACTIONS(1155),
    [aux_sym_type_qualifier_token10] = ACTIONS(1155),
    [aux_sym_type_qualifier_token11] = ACTIONS(1155),
    [aux_sym_type_qualifier_token12] = ACTIONS(1155),
    [aux_sym_type_qualifier_token13] = ACTIONS(1155),
    [aux_sym_type_qualifier_token14] = ACTIONS(1155),
    [aux_sym_type_qualifier_token15] = ACTIONS(1155),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1155),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1155),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1155),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1155),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1155),
    [aux_sym_stop_statement_token1] = ACTIONS(1155),
    [aux_sym_stop_statement_token2] = ACTIONS(1155),
    [aux_sym_subroutine_call_token1] = ACTIONS(1155),
    [aux_sym_keyword_statement_token1] = ACTIONS(1155),
    [aux_sym_keyword_statement_token2] = ACTIONS(1155),
    [aux_sym_keyword_statement_token3] = ACTIONS(1155),
    [aux_sym_keyword_statement_token4] = ACTIONS(1155),
    [aux_sym_keyword_statement_token6] = ACTIONS(1155),
    [aux_sym_keyword_statement_token7] = ACTIONS(1155),
    [aux_sym_include_statement_token1] = ACTIONS(1155),
    [aux_sym_data_statement_token1] = ACTIONS(1155),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1155),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1155),
    [aux_sym_end_if_statement_token1] = ACTIONS(1155),
    [aux_sym_elseif_clause_token2] = ACTIONS(1155),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1155),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1155),
    [aux_sym_select_case_statement_token1] = ACTIONS(1155),
    [aux_sym_select_case_statement_token3] = ACTIONS(1155),
    [aux_sym_select_type_statement_token1] = ACTIONS(1155),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1155),
    [aux_sym_block_construct_token1] = ACTIONS(1155),
    [aux_sym_associate_statement_token1] = ACTIONS(1155),
    [aux_sym_format_statement_token1] = ACTIONS(1155),
    [aux_sym_print_statement_token1] = ACTIONS(1155),
    [aux_sym_open_statement_token1] = ACTIONS(1155),
    [aux_sym_close_statement_token1] = ACTIONS(1155),
    [aux_sym_inquire_statement_token1] = ACTIONS(1155),
    [aux_sym_enum_statement_token1] = ACTIONS(1155),
    [aux_sym_file_position_statement_token1] = ACTIONS(1155),
    [aux_sym_file_position_statement_token2] = ACTIONS(1155),
    [aux_sym_file_position_statement_token3] = ACTIONS(1155),
    [aux_sym_file_position_statement_token4] = ACTIONS(1155),
    [aux_sym_logical_expression_token5] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [sym_boolean_literal] = ACTIONS(1153),
    [aux_sym_null_literal_token1] = ACTIONS(1155),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1155),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1153),
    [sym__float_literal] = ACTIONS(1153),
    [sym__boz_literal] = ACTIONS(1153),
    [sym_string_literal] = ACTIONS(1153),
  },
  [250] = {
    [sym_preproc_file_line] = STATE(250),
    [ts_builtin_sym_end] = ACTIONS(1157),
    [aux_sym_program_statement_token1] = ACTIONS(1159),
    [aux_sym_end_program_statement_token1] = ACTIONS(1159),
    [aux_sym_end_program_statement_token2] = ACTIONS(1159),
    [aux_sym_module_statement_token1] = ACTIONS(1159),
    [aux_sym_submodule_statement_token1] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [aux_sym_interface_statement_token1] = ACTIONS(1159),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1159),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1159),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1159),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1159),
    [aux_sym_function_statement_token1] = ACTIONS(1159),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1159),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1159),
    [aux_sym_contains_statement_token1] = ACTIONS(1159),
    [aux_sym_use_statement_token1] = ACTIONS(1159),
    [aux_sym_use_statement_token2] = ACTIONS(1159),
    [aux_sym_implicit_statement_token1] = ACTIONS(1159),
    [aux_sym_implicit_statement_token3] = ACTIONS(1159),
    [aux_sym_implicit_statement_token4] = ACTIONS(1159),
    [aux_sym_save_statement_token1] = ACTIONS(1159),
    [aux_sym_private_statement_token1] = ACTIONS(1159),
    [aux_sym_public_statement_token1] = ACTIONS(1159),
    [aux_sym_namelist_statement_token1] = ACTIONS(1159),
    [aux_sym_common_statement_token1] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1157),
    [aux_sym_import_statement_token1] = ACTIONS(1159),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1159),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1159),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1159),
    [aux_sym_variable_attributes_token1] = ACTIONS(1159),
    [aux_sym_variable_attributes_token2] = ACTIONS(1159),
    [aux_sym_variable_attributes_token3] = ACTIONS(1159),
    [aux_sym_variable_attributes_token4] = ACTIONS(1159),
    [aux_sym_variable_attributes_token5] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1159),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1159),
    [aux_sym_derived_type_token1] = ACTIONS(1159),
    [aux_sym_type_qualifier_token1] = ACTIONS(1159),
    [aux_sym_type_qualifier_token2] = ACTIONS(1159),
    [aux_sym_type_qualifier_token3] = ACTIONS(1159),
    [aux_sym_type_qualifier_token4] = ACTIONS(1159),
    [aux_sym_type_qualifier_token5] = ACTIONS(1159),
    [aux_sym_type_qualifier_token9] = ACTIONS(1159),
    [aux_sym_type_qualifier_token10] = ACTIONS(1159),
    [aux_sym_type_qualifier_token11] = ACTIONS(1159),
    [aux_sym_type_qualifier_token12] = ACTIONS(1159),
    [aux_sym_type_qualifier_token13] = ACTIONS(1159),
    [aux_sym_type_qualifier_token14] = ACTIONS(1159),
    [aux_sym_type_qualifier_token15] = ACTIONS(1159),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1159),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1159),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1159),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1159),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1159),
    [aux_sym_stop_statement_token1] = ACTIONS(1159),
    [aux_sym_stop_statement_token2] = ACTIONS(1159),
    [aux_sym_subroutine_call_token1] = ACTIONS(1159),
    [aux_sym_keyword_statement_token1] = ACTIONS(1159),
    [aux_sym_keyword_statement_token2] = ACTIONS(1159),
    [aux_sym_keyword_statement_token3] = ACTIONS(1159),
    [aux_sym_keyword_statement_token4] = ACTIONS(1159),
    [aux_sym_keyword_statement_token6] = ACTIONS(1159),
    [aux_sym_keyword_statement_token7] = ACTIONS(1159),
    [aux_sym_include_statement_token1] = ACTIONS(1159),
    [aux_sym_data_statement_token1] = ACTIONS(1159),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1159),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1159),
    [aux_sym_end_if_statement_token1] = ACTIONS(1159),
    [aux_sym_elseif_clause_token2] = ACTIONS(1159),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1159),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1159),
    [aux_sym_select_case_statement_token1] = ACTIONS(1159),
    [aux_sym_select_case_statement_token3] = ACTIONS(1159),
    [aux_sym_select_type_statement_token1] = ACTIONS(1159),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1159),
    [aux_sym_block_construct_token1] = ACTIONS(1159),
    [aux_sym_associate_statement_token1] = ACTIONS(1159),
    [aux_sym_format_statement_token1] = ACTIONS(1159),
    [aux_sym_print_statement_token1] = ACTIONS(1159),
    [aux_sym_open_statement_token1] = ACTIONS(1159),
    [aux_sym_close_statement_token1] = ACTIONS(1159),
    [aux_sym_inquire_statement_token1] = ACTIONS(1159),
    [aux_sym_enum_statement_token1] = ACTIONS(1159),
    [aux_sym_file_position_statement_token1] = ACTIONS(1159),
    [aux_sym_file_position_statement_token2] = ACTIONS(1159),
    [aux_sym_file_position_statement_token3] = ACTIONS(1159),
    [aux_sym_file_position_statement_token4] = ACTIONS(1159),
    [aux_sym_logical_expression_token5] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [sym_boolean_literal] = ACTIONS(1157),
    [aux_sym_null_literal_token1] = ACTIONS(1159),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1159),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1157),
    [sym__float_literal] = ACTIONS(1157),
    [sym__boz_literal] = ACTIONS(1157),
    [sym_string_literal] = ACTIONS(1157),
  },
  [251] = {
    [sym_preproc_file_line] = STATE(251),
    [ts_builtin_sym_end] = ACTIONS(1161),
    [aux_sym_program_statement_token1] = ACTIONS(1163),
    [aux_sym_end_program_statement_token1] = ACTIONS(1163),
    [aux_sym_end_program_statement_token2] = ACTIONS(1163),
    [aux_sym_module_statement_token1] = ACTIONS(1163),
    [aux_sym_submodule_statement_token1] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [aux_sym_interface_statement_token1] = ACTIONS(1163),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1163),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1163),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1163),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1163),
    [aux_sym_function_statement_token1] = ACTIONS(1163),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1163),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1163),
    [aux_sym_contains_statement_token1] = ACTIONS(1163),
    [aux_sym_use_statement_token1] = ACTIONS(1163),
    [aux_sym_use_statement_token2] = ACTIONS(1163),
    [aux_sym_implicit_statement_token1] = ACTIONS(1163),
    [aux_sym_implicit_statement_token3] = ACTIONS(1163),
    [aux_sym_implicit_statement_token4] = ACTIONS(1163),
    [aux_sym_save_statement_token1] = ACTIONS(1163),
    [aux_sym_private_statement_token1] = ACTIONS(1163),
    [aux_sym_public_statement_token1] = ACTIONS(1163),
    [aux_sym_namelist_statement_token1] = ACTIONS(1163),
    [aux_sym_common_statement_token1] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1161),
    [aux_sym_import_statement_token1] = ACTIONS(1163),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1163),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1163),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1163),
    [aux_sym_variable_attributes_token1] = ACTIONS(1163),
    [aux_sym_variable_attributes_token2] = ACTIONS(1163),
    [aux_sym_variable_attributes_token3] = ACTIONS(1163),
    [aux_sym_variable_attributes_token4] = ACTIONS(1163),
    [aux_sym_variable_attributes_token5] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1163),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1163),
    [aux_sym_derived_type_token1] = ACTIONS(1163),
    [aux_sym_type_qualifier_token1] = ACTIONS(1163),
    [aux_sym_type_qualifier_token2] = ACTIONS(1163),
    [aux_sym_type_qualifier_token3] = ACTIONS(1163),
    [aux_sym_type_qualifier_token4] = ACTIONS(1163),
    [aux_sym_type_qualifier_token5] = ACTIONS(1163),
    [aux_sym_type_qualifier_token9] = ACTIONS(1163),
    [aux_sym_type_qualifier_token10] = ACTIONS(1163),
    [aux_sym_type_qualifier_token11] = ACTIONS(1163),
    [aux_sym_type_qualifier_token12] = ACTIONS(1163),
    [aux_sym_type_qualifier_token13] = ACTIONS(1163),
    [aux_sym_type_qualifier_token14] = ACTIONS(1163),
    [aux_sym_type_qualifier_token15] = ACTIONS(1163),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1163),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1163),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1163),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1163),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1163),
    [aux_sym_stop_statement_token1] = ACTIONS(1163),
    [aux_sym_stop_statement_token2] = ACTIONS(1163),
    [aux_sym_subroutine_call_token1] = ACTIONS(1163),
    [aux_sym_keyword_statement_token1] = ACTIONS(1163),
    [aux_sym_keyword_statement_token2] = ACTIONS(1163),
    [aux_sym_keyword_statement_token3] = ACTIONS(1163),
    [aux_sym_keyword_statement_token4] = ACTIONS(1163),
    [aux_sym_keyword_statement_token6] = ACTIONS(1163),
    [aux_sym_keyword_statement_token7] = ACTIONS(1163),
    [aux_sym_include_statement_token1] = ACTIONS(1163),
    [aux_sym_data_statement_token1] = ACTIONS(1163),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1163),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1163),
    [aux_sym_end_if_statement_token1] = ACTIONS(1163),
    [aux_sym_elseif_clause_token2] = ACTIONS(1163),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1163),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1163),
    [aux_sym_select_case_statement_token1] = ACTIONS(1163),
    [aux_sym_select_case_statement_token3] = ACTIONS(1163),
    [aux_sym_select_type_statement_token1] = ACTIONS(1163),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1163),
    [aux_sym_block_construct_token1] = ACTIONS(1163),
    [aux_sym_associate_statement_token1] = ACTIONS(1163),
    [aux_sym_format_statement_token1] = ACTIONS(1163),
    [aux_sym_print_statement_token1] = ACTIONS(1163),
    [aux_sym_open_statement_token1] = ACTIONS(1163),
    [aux_sym_close_statement_token1] = ACTIONS(1163),
    [aux_sym_inquire_statement_token1] = ACTIONS(1163),
    [aux_sym_enum_statement_token1] = ACTIONS(1163),
    [aux_sym_file_position_statement_token1] = ACTIONS(1163),
    [aux_sym_file_position_statement_token2] = ACTIONS(1163),
    [aux_sym_file_position_statement_token3] = ACTIONS(1163),
    [aux_sym_file_position_statement_token4] = ACTIONS(1163),
    [aux_sym_logical_expression_token5] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(1161),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [sym_boolean_literal] = ACTIONS(1161),
    [aux_sym_null_literal_token1] = ACTIONS(1163),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1163),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1161),
    [sym__float_literal] = ACTIONS(1161),
    [sym__boz_literal] = ACTIONS(1161),
    [sym_string_literal] = ACTIONS(1161),
  },
  [252] = {
    [sym_preproc_file_line] = STATE(252),
    [ts_builtin_sym_end] = ACTIONS(1165),
    [aux_sym_program_statement_token1] = ACTIONS(1167),
    [aux_sym_end_program_statement_token1] = ACTIONS(1167),
    [aux_sym_end_program_statement_token2] = ACTIONS(1167),
    [aux_sym_module_statement_token1] = ACTIONS(1167),
    [aux_sym_submodule_statement_token1] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [aux_sym_interface_statement_token1] = ACTIONS(1167),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1167),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1167),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1167),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1167),
    [aux_sym_function_statement_token1] = ACTIONS(1167),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1167),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1167),
    [aux_sym_contains_statement_token1] = ACTIONS(1167),
    [aux_sym_use_statement_token1] = ACTIONS(1167),
    [aux_sym_use_statement_token2] = ACTIONS(1167),
    [aux_sym_implicit_statement_token1] = ACTIONS(1167),
    [aux_sym_implicit_statement_token3] = ACTIONS(1167),
    [aux_sym_implicit_statement_token4] = ACTIONS(1167),
    [aux_sym_save_statement_token1] = ACTIONS(1167),
    [aux_sym_private_statement_token1] = ACTIONS(1167),
    [aux_sym_public_statement_token1] = ACTIONS(1167),
    [aux_sym_namelist_statement_token1] = ACTIONS(1167),
    [aux_sym_common_statement_token1] = ACTIONS(1167),
    [anon_sym_DASH] = ACTIONS(1165),
    [aux_sym_import_statement_token1] = ACTIONS(1167),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1167),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1167),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1167),
    [aux_sym_variable_attributes_token1] = ACTIONS(1167),
    [aux_sym_variable_attributes_token2] = ACTIONS(1167),
    [aux_sym_variable_attributes_token3] = ACTIONS(1167),
    [aux_sym_variable_attributes_token4] = ACTIONS(1167),
    [aux_sym_variable_attributes_token5] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1167),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1167),
    [aux_sym_derived_type_token1] = ACTIONS(1167),
    [aux_sym_type_qualifier_token1] = ACTIONS(1167),
    [aux_sym_type_qualifier_token2] = ACTIONS(1167),
    [aux_sym_type_qualifier_token3] = ACTIONS(1167),
    [aux_sym_type_qualifier_token4] = ACTIONS(1167),
    [aux_sym_type_qualifier_token5] = ACTIONS(1167),
    [aux_sym_type_qualifier_token9] = ACTIONS(1167),
    [aux_sym_type_qualifier_token10] = ACTIONS(1167),
    [aux_sym_type_qualifier_token11] = ACTIONS(1167),
    [aux_sym_type_qualifier_token12] = ACTIONS(1167),
    [aux_sym_type_qualifier_token13] = ACTIONS(1167),
    [aux_sym_type_qualifier_token14] = ACTIONS(1167),
    [aux_sym_type_qualifier_token15] = ACTIONS(1167),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1167),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1167),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1167),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1167),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1167),
    [aux_sym_stop_statement_token1] = ACTIONS(1167),
    [aux_sym_stop_statement_token2] = ACTIONS(1167),
    [aux_sym_subroutine_call_token1] = ACTIONS(1167),
    [aux_sym_keyword_statement_token1] = ACTIONS(1167),
    [aux_sym_keyword_statement_token2] = ACTIONS(1167),
    [aux_sym_keyword_statement_token3] = ACTIONS(1167),
    [aux_sym_keyword_statement_token4] = ACTIONS(1167),
    [aux_sym_keyword_statement_token6] = ACTIONS(1167),
    [aux_sym_keyword_statement_token7] = ACTIONS(1167),
    [aux_sym_include_statement_token1] = ACTIONS(1167),
    [aux_sym_data_statement_token1] = ACTIONS(1167),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1167),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1167),
    [aux_sym_end_if_statement_token1] = ACTIONS(1167),
    [aux_sym_elseif_clause_token2] = ACTIONS(1167),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1167),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1167),
    [aux_sym_select_case_statement_token1] = ACTIONS(1167),
    [aux_sym_select_case_statement_token3] = ACTIONS(1167),
    [aux_sym_select_type_statement_token1] = ACTIONS(1167),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1167),
    [aux_sym_block_construct_token1] = ACTIONS(1167),
    [aux_sym_associate_statement_token1] = ACTIONS(1167),
    [aux_sym_format_statement_token1] = ACTIONS(1167),
    [aux_sym_print_statement_token1] = ACTIONS(1167),
    [aux_sym_open_statement_token1] = ACTIONS(1167),
    [aux_sym_close_statement_token1] = ACTIONS(1167),
    [aux_sym_inquire_statement_token1] = ACTIONS(1167),
    [aux_sym_enum_statement_token1] = ACTIONS(1167),
    [aux_sym_file_position_statement_token1] = ACTIONS(1167),
    [aux_sym_file_position_statement_token2] = ACTIONS(1167),
    [aux_sym_file_position_statement_token3] = ACTIONS(1167),
    [aux_sym_file_position_statement_token4] = ACTIONS(1167),
    [aux_sym_logical_expression_token5] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1165),
    [sym_boolean_literal] = ACTIONS(1165),
    [aux_sym_null_literal_token1] = ACTIONS(1167),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1167),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1165),
    [sym__float_literal] = ACTIONS(1165),
    [sym__boz_literal] = ACTIONS(1165),
    [sym_string_literal] = ACTIONS(1165),
  },
  [253] = {
    [sym_preproc_file_line] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(1169),
    [aux_sym_program_statement_token1] = ACTIONS(1171),
    [aux_sym_end_program_statement_token1] = ACTIONS(1171),
    [aux_sym_end_program_statement_token2] = ACTIONS(1171),
    [aux_sym_module_statement_token1] = ACTIONS(1171),
    [aux_sym_submodule_statement_token1] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [aux_sym_interface_statement_token1] = ACTIONS(1171),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1171),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1171),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1171),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1171),
    [aux_sym_function_statement_token1] = ACTIONS(1171),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1171),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1171),
    [aux_sym_contains_statement_token1] = ACTIONS(1171),
    [aux_sym_use_statement_token1] = ACTIONS(1171),
    [aux_sym_use_statement_token2] = ACTIONS(1171),
    [aux_sym_implicit_statement_token1] = ACTIONS(1171),
    [aux_sym_implicit_statement_token3] = ACTIONS(1171),
    [aux_sym_implicit_statement_token4] = ACTIONS(1171),
    [aux_sym_save_statement_token1] = ACTIONS(1171),
    [aux_sym_private_statement_token1] = ACTIONS(1171),
    [aux_sym_public_statement_token1] = ACTIONS(1171),
    [aux_sym_namelist_statement_token1] = ACTIONS(1171),
    [aux_sym_common_statement_token1] = ACTIONS(1171),
    [anon_sym_DASH] = ACTIONS(1169),
    [aux_sym_import_statement_token1] = ACTIONS(1171),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1171),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1171),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1171),
    [aux_sym_variable_attributes_token1] = ACTIONS(1171),
    [aux_sym_variable_attributes_token2] = ACTIONS(1171),
    [aux_sym_variable_attributes_token3] = ACTIONS(1171),
    [aux_sym_variable_attributes_token4] = ACTIONS(1171),
    [aux_sym_variable_attributes_token5] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1171),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1171),
    [aux_sym_derived_type_token1] = ACTIONS(1171),
    [aux_sym_type_qualifier_token1] = ACTIONS(1171),
    [aux_sym_type_qualifier_token2] = ACTIONS(1171),
    [aux_sym_type_qualifier_token3] = ACTIONS(1171),
    [aux_sym_type_qualifier_token4] = ACTIONS(1171),
    [aux_sym_type_qualifier_token5] = ACTIONS(1171),
    [aux_sym_type_qualifier_token9] = ACTIONS(1171),
    [aux_sym_type_qualifier_token10] = ACTIONS(1171),
    [aux_sym_type_qualifier_token11] = ACTIONS(1171),
    [aux_sym_type_qualifier_token12] = ACTIONS(1171),
    [aux_sym_type_qualifier_token13] = ACTIONS(1171),
    [aux_sym_type_qualifier_token14] = ACTIONS(1171),
    [aux_sym_type_qualifier_token15] = ACTIONS(1171),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1171),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1171),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1171),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1171),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1171),
    [aux_sym_stop_statement_token1] = ACTIONS(1171),
    [aux_sym_stop_statement_token2] = ACTIONS(1171),
    [aux_sym_subroutine_call_token1] = ACTIONS(1171),
    [aux_sym_keyword_statement_token1] = ACTIONS(1171),
    [aux_sym_keyword_statement_token2] = ACTIONS(1171),
    [aux_sym_keyword_statement_token3] = ACTIONS(1171),
    [aux_sym_keyword_statement_token4] = ACTIONS(1171),
    [aux_sym_keyword_statement_token6] = ACTIONS(1171),
    [aux_sym_keyword_statement_token7] = ACTIONS(1171),
    [aux_sym_include_statement_token1] = ACTIONS(1171),
    [aux_sym_data_statement_token1] = ACTIONS(1171),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1171),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1171),
    [aux_sym_end_if_statement_token1] = ACTIONS(1171),
    [aux_sym_elseif_clause_token2] = ACTIONS(1171),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1171),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1171),
    [aux_sym_select_case_statement_token1] = ACTIONS(1171),
    [aux_sym_select_case_statement_token3] = ACTIONS(1171),
    [aux_sym_select_type_statement_token1] = ACTIONS(1171),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1171),
    [aux_sym_block_construct_token1] = ACTIONS(1171),
    [aux_sym_associate_statement_token1] = ACTIONS(1171),
    [aux_sym_format_statement_token1] = ACTIONS(1171),
    [aux_sym_print_statement_token1] = ACTIONS(1171),
    [aux_sym_open_statement_token1] = ACTIONS(1171),
    [aux_sym_close_statement_token1] = ACTIONS(1171),
    [aux_sym_inquire_statement_token1] = ACTIONS(1171),
    [aux_sym_enum_statement_token1] = ACTIONS(1171),
    [aux_sym_file_position_statement_token1] = ACTIONS(1171),
    [aux_sym_file_position_statement_token2] = ACTIONS(1171),
    [aux_sym_file_position_statement_token3] = ACTIONS(1171),
    [aux_sym_file_position_statement_token4] = ACTIONS(1171),
    [aux_sym_logical_expression_token5] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1169),
    [sym_boolean_literal] = ACTIONS(1169),
    [aux_sym_null_literal_token1] = ACTIONS(1171),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1171),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1169),
    [sym__float_literal] = ACTIONS(1169),
    [sym__boz_literal] = ACTIONS(1169),
    [sym_string_literal] = ACTIONS(1169),
  },
  [254] = {
    [sym_preproc_file_line] = STATE(254),
    [ts_builtin_sym_end] = ACTIONS(1173),
    [aux_sym_program_statement_token1] = ACTIONS(1175),
    [aux_sym_end_program_statement_token1] = ACTIONS(1175),
    [aux_sym_end_program_statement_token2] = ACTIONS(1175),
    [aux_sym_module_statement_token1] = ACTIONS(1175),
    [aux_sym_submodule_statement_token1] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [aux_sym_interface_statement_token1] = ACTIONS(1175),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1175),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1175),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1175),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1175),
    [aux_sym_function_statement_token1] = ACTIONS(1175),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1175),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1175),
    [aux_sym_contains_statement_token1] = ACTIONS(1175),
    [aux_sym_use_statement_token1] = ACTIONS(1175),
    [aux_sym_use_statement_token2] = ACTIONS(1175),
    [aux_sym_implicit_statement_token1] = ACTIONS(1175),
    [aux_sym_implicit_statement_token3] = ACTIONS(1175),
    [aux_sym_implicit_statement_token4] = ACTIONS(1175),
    [aux_sym_save_statement_token1] = ACTIONS(1175),
    [aux_sym_private_statement_token1] = ACTIONS(1175),
    [aux_sym_public_statement_token1] = ACTIONS(1175),
    [aux_sym_namelist_statement_token1] = ACTIONS(1175),
    [aux_sym_common_statement_token1] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1173),
    [aux_sym_import_statement_token1] = ACTIONS(1175),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1175),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1175),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1175),
    [aux_sym_variable_attributes_token1] = ACTIONS(1175),
    [aux_sym_variable_attributes_token2] = ACTIONS(1175),
    [aux_sym_variable_attributes_token3] = ACTIONS(1175),
    [aux_sym_variable_attributes_token4] = ACTIONS(1175),
    [aux_sym_variable_attributes_token5] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1175),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1175),
    [aux_sym_derived_type_token1] = ACTIONS(1175),
    [aux_sym_type_qualifier_token1] = ACTIONS(1175),
    [aux_sym_type_qualifier_token2] = ACTIONS(1175),
    [aux_sym_type_qualifier_token3] = ACTIONS(1175),
    [aux_sym_type_qualifier_token4] = ACTIONS(1175),
    [aux_sym_type_qualifier_token5] = ACTIONS(1175),
    [aux_sym_type_qualifier_token9] = ACTIONS(1175),
    [aux_sym_type_qualifier_token10] = ACTIONS(1175),
    [aux_sym_type_qualifier_token11] = ACTIONS(1175),
    [aux_sym_type_qualifier_token12] = ACTIONS(1175),
    [aux_sym_type_qualifier_token13] = ACTIONS(1175),
    [aux_sym_type_qualifier_token14] = ACTIONS(1175),
    [aux_sym_type_qualifier_token15] = ACTIONS(1175),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1175),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1175),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1175),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1175),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1175),
    [aux_sym_stop_statement_token1] = ACTIONS(1175),
    [aux_sym_stop_statement_token2] = ACTIONS(1175),
    [aux_sym_subroutine_call_token1] = ACTIONS(1175),
    [aux_sym_keyword_statement_token1] = ACTIONS(1175),
    [aux_sym_keyword_statement_token2] = ACTIONS(1175),
    [aux_sym_keyword_statement_token3] = ACTIONS(1175),
    [aux_sym_keyword_statement_token4] = ACTIONS(1175),
    [aux_sym_keyword_statement_token6] = ACTIONS(1175),
    [aux_sym_keyword_statement_token7] = ACTIONS(1175),
    [aux_sym_include_statement_token1] = ACTIONS(1175),
    [aux_sym_data_statement_token1] = ACTIONS(1175),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1175),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1175),
    [aux_sym_end_if_statement_token1] = ACTIONS(1175),
    [aux_sym_elseif_clause_token2] = ACTIONS(1175),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1175),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1175),
    [aux_sym_select_case_statement_token1] = ACTIONS(1175),
    [aux_sym_select_case_statement_token3] = ACTIONS(1175),
    [aux_sym_select_type_statement_token1] = ACTIONS(1175),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1175),
    [aux_sym_block_construct_token1] = ACTIONS(1175),
    [aux_sym_associate_statement_token1] = ACTIONS(1175),
    [aux_sym_format_statement_token1] = ACTIONS(1175),
    [aux_sym_print_statement_token1] = ACTIONS(1175),
    [aux_sym_open_statement_token1] = ACTIONS(1175),
    [aux_sym_close_statement_token1] = ACTIONS(1175),
    [aux_sym_inquire_statement_token1] = ACTIONS(1175),
    [aux_sym_enum_statement_token1] = ACTIONS(1175),
    [aux_sym_file_position_statement_token1] = ACTIONS(1175),
    [aux_sym_file_position_statement_token2] = ACTIONS(1175),
    [aux_sym_file_position_statement_token3] = ACTIONS(1175),
    [aux_sym_file_position_statement_token4] = ACTIONS(1175),
    [aux_sym_logical_expression_token5] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1173),
    [sym_boolean_literal] = ACTIONS(1173),
    [aux_sym_null_literal_token1] = ACTIONS(1175),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1175),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1173),
    [sym__float_literal] = ACTIONS(1173),
    [sym__boz_literal] = ACTIONS(1173),
    [sym_string_literal] = ACTIONS(1173),
  },
  [255] = {
    [sym_preproc_file_line] = STATE(255),
    [ts_builtin_sym_end] = ACTIONS(1177),
    [aux_sym_program_statement_token1] = ACTIONS(1179),
    [aux_sym_end_program_statement_token1] = ACTIONS(1179),
    [aux_sym_end_program_statement_token2] = ACTIONS(1179),
    [aux_sym_module_statement_token1] = ACTIONS(1179),
    [aux_sym_submodule_statement_token1] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [aux_sym_interface_statement_token1] = ACTIONS(1179),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1179),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1179),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1179),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1179),
    [aux_sym_function_statement_token1] = ACTIONS(1179),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1179),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1179),
    [aux_sym_contains_statement_token1] = ACTIONS(1179),
    [aux_sym_use_statement_token1] = ACTIONS(1179),
    [aux_sym_use_statement_token2] = ACTIONS(1179),
    [aux_sym_implicit_statement_token1] = ACTIONS(1179),
    [aux_sym_implicit_statement_token3] = ACTIONS(1179),
    [aux_sym_implicit_statement_token4] = ACTIONS(1179),
    [aux_sym_save_statement_token1] = ACTIONS(1179),
    [aux_sym_private_statement_token1] = ACTIONS(1179),
    [aux_sym_public_statement_token1] = ACTIONS(1179),
    [aux_sym_namelist_statement_token1] = ACTIONS(1179),
    [aux_sym_common_statement_token1] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [aux_sym_import_statement_token1] = ACTIONS(1179),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1179),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1179),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1179),
    [aux_sym_variable_attributes_token1] = ACTIONS(1179),
    [aux_sym_variable_attributes_token2] = ACTIONS(1179),
    [aux_sym_variable_attributes_token3] = ACTIONS(1179),
    [aux_sym_variable_attributes_token4] = ACTIONS(1179),
    [aux_sym_variable_attributes_token5] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1179),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1179),
    [aux_sym_derived_type_token1] = ACTIONS(1179),
    [aux_sym_type_qualifier_token1] = ACTIONS(1179),
    [aux_sym_type_qualifier_token2] = ACTIONS(1179),
    [aux_sym_type_qualifier_token3] = ACTIONS(1179),
    [aux_sym_type_qualifier_token4] = ACTIONS(1179),
    [aux_sym_type_qualifier_token5] = ACTIONS(1179),
    [aux_sym_type_qualifier_token9] = ACTIONS(1179),
    [aux_sym_type_qualifier_token10] = ACTIONS(1179),
    [aux_sym_type_qualifier_token11] = ACTIONS(1179),
    [aux_sym_type_qualifier_token12] = ACTIONS(1179),
    [aux_sym_type_qualifier_token13] = ACTIONS(1179),
    [aux_sym_type_qualifier_token14] = ACTIONS(1179),
    [aux_sym_type_qualifier_token15] = ACTIONS(1179),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1179),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1179),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1179),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1179),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1179),
    [aux_sym_stop_statement_token1] = ACTIONS(1179),
    [aux_sym_stop_statement_token2] = ACTIONS(1179),
    [aux_sym_subroutine_call_token1] = ACTIONS(1179),
    [aux_sym_keyword_statement_token1] = ACTIONS(1179),
    [aux_sym_keyword_statement_token2] = ACTIONS(1179),
    [aux_sym_keyword_statement_token3] = ACTIONS(1179),
    [aux_sym_keyword_statement_token4] = ACTIONS(1179),
    [aux_sym_keyword_statement_token6] = ACTIONS(1179),
    [aux_sym_keyword_statement_token7] = ACTIONS(1179),
    [aux_sym_include_statement_token1] = ACTIONS(1179),
    [aux_sym_data_statement_token1] = ACTIONS(1179),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1179),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1179),
    [aux_sym_end_if_statement_token1] = ACTIONS(1179),
    [aux_sym_elseif_clause_token2] = ACTIONS(1179),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1179),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1179),
    [aux_sym_select_case_statement_token1] = ACTIONS(1179),
    [aux_sym_select_case_statement_token3] = ACTIONS(1179),
    [aux_sym_select_type_statement_token1] = ACTIONS(1179),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1179),
    [aux_sym_block_construct_token1] = ACTIONS(1179),
    [aux_sym_associate_statement_token1] = ACTIONS(1179),
    [aux_sym_format_statement_token1] = ACTIONS(1179),
    [aux_sym_print_statement_token1] = ACTIONS(1179),
    [aux_sym_open_statement_token1] = ACTIONS(1179),
    [aux_sym_close_statement_token1] = ACTIONS(1179),
    [aux_sym_inquire_statement_token1] = ACTIONS(1179),
    [aux_sym_enum_statement_token1] = ACTIONS(1179),
    [aux_sym_file_position_statement_token1] = ACTIONS(1179),
    [aux_sym_file_position_statement_token2] = ACTIONS(1179),
    [aux_sym_file_position_statement_token3] = ACTIONS(1179),
    [aux_sym_file_position_statement_token4] = ACTIONS(1179),
    [aux_sym_logical_expression_token5] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1179),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [sym_boolean_literal] = ACTIONS(1177),
    [aux_sym_null_literal_token1] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1179),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__float_literal] = ACTIONS(1177),
    [sym__boz_literal] = ACTIONS(1177),
    [sym_string_literal] = ACTIONS(1177),
  },
  [256] = {
    [sym_preproc_file_line] = STATE(256),
    [ts_builtin_sym_end] = ACTIONS(1181),
    [aux_sym_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token2] = ACTIONS(1183),
    [aux_sym_module_statement_token1] = ACTIONS(1183),
    [aux_sym_submodule_statement_token1] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [aux_sym_interface_statement_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1183),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1183),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1183),
    [aux_sym_function_statement_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1183),
    [aux_sym_contains_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token2] = ACTIONS(1183),
    [aux_sym_implicit_statement_token1] = ACTIONS(1183),
    [aux_sym_implicit_statement_token3] = ACTIONS(1183),
    [aux_sym_implicit_statement_token4] = ACTIONS(1183),
    [aux_sym_save_statement_token1] = ACTIONS(1183),
    [aux_sym_private_statement_token1] = ACTIONS(1183),
    [aux_sym_public_statement_token1] = ACTIONS(1183),
    [aux_sym_namelist_statement_token1] = ACTIONS(1183),
    [aux_sym_common_statement_token1] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [aux_sym_import_statement_token1] = ACTIONS(1183),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1183),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1183),
    [aux_sym_variable_attributes_token1] = ACTIONS(1183),
    [aux_sym_variable_attributes_token2] = ACTIONS(1183),
    [aux_sym_variable_attributes_token3] = ACTIONS(1183),
    [aux_sym_variable_attributes_token4] = ACTIONS(1183),
    [aux_sym_variable_attributes_token5] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1183),
    [aux_sym_derived_type_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token2] = ACTIONS(1183),
    [aux_sym_type_qualifier_token3] = ACTIONS(1183),
    [aux_sym_type_qualifier_token4] = ACTIONS(1183),
    [aux_sym_type_qualifier_token5] = ACTIONS(1183),
    [aux_sym_type_qualifier_token9] = ACTIONS(1183),
    [aux_sym_type_qualifier_token10] = ACTIONS(1183),
    [aux_sym_type_qualifier_token11] = ACTIONS(1183),
    [aux_sym_type_qualifier_token12] = ACTIONS(1183),
    [aux_sym_type_qualifier_token13] = ACTIONS(1183),
    [aux_sym_type_qualifier_token14] = ACTIONS(1183),
    [aux_sym_type_qualifier_token15] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1183),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token2] = ACTIONS(1183),
    [aux_sym_subroutine_call_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token2] = ACTIONS(1183),
    [aux_sym_keyword_statement_token3] = ACTIONS(1183),
    [aux_sym_keyword_statement_token4] = ACTIONS(1183),
    [aux_sym_keyword_statement_token6] = ACTIONS(1183),
    [aux_sym_keyword_statement_token7] = ACTIONS(1183),
    [aux_sym_include_statement_token1] = ACTIONS(1183),
    [aux_sym_data_statement_token1] = ACTIONS(1183),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1183),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1183),
    [aux_sym_end_if_statement_token1] = ACTIONS(1183),
    [aux_sym_elseif_clause_token2] = ACTIONS(1183),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1183),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token3] = ACTIONS(1183),
    [aux_sym_select_type_statement_token1] = ACTIONS(1183),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1183),
    [aux_sym_block_construct_token1] = ACTIONS(1183),
    [aux_sym_associate_statement_token1] = ACTIONS(1183),
    [aux_sym_format_statement_token1] = ACTIONS(1183),
    [aux_sym_print_statement_token1] = ACTIONS(1183),
    [aux_sym_open_statement_token1] = ACTIONS(1183),
    [aux_sym_close_statement_token1] = ACTIONS(1183),
    [aux_sym_inquire_statement_token1] = ACTIONS(1183),
    [aux_sym_enum_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token2] = ACTIONS(1183),
    [aux_sym_file_position_statement_token3] = ACTIONS(1183),
    [aux_sym_file_position_statement_token4] = ACTIONS(1183),
    [aux_sym_logical_expression_token5] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [sym_boolean_literal] = ACTIONS(1181),
    [aux_sym_null_literal_token1] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1183),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1181),
    [sym__float_literal] = ACTIONS(1181),
    [sym__boz_literal] = ACTIONS(1181),
    [sym_string_literal] = ACTIONS(1181),
  },
  [257] = {
    [sym_preproc_file_line] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(1185),
    [aux_sym_program_statement_token1] = ACTIONS(1187),
    [aux_sym_end_program_statement_token1] = ACTIONS(1187),
    [aux_sym_end_program_statement_token2] = ACTIONS(1187),
    [aux_sym_module_statement_token1] = ACTIONS(1187),
    [aux_sym_submodule_statement_token1] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1187),
    [aux_sym_interface_statement_token1] = ACTIONS(1187),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1187),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1187),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1187),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1187),
    [aux_sym_function_statement_token1] = ACTIONS(1187),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1187),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1187),
    [aux_sym_contains_statement_token1] = ACTIONS(1187),
    [aux_sym_use_statement_token1] = ACTIONS(1187),
    [aux_sym_use_statement_token2] = ACTIONS(1187),
    [aux_sym_implicit_statement_token1] = ACTIONS(1187),
    [aux_sym_implicit_statement_token3] = ACTIONS(1187),
    [aux_sym_implicit_statement_token4] = ACTIONS(1187),
    [aux_sym_save_statement_token1] = ACTIONS(1187),
    [aux_sym_private_statement_token1] = ACTIONS(1187),
    [aux_sym_public_statement_token1] = ACTIONS(1187),
    [aux_sym_namelist_statement_token1] = ACTIONS(1187),
    [aux_sym_common_statement_token1] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1185),
    [aux_sym_import_statement_token1] = ACTIONS(1187),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1187),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1187),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1187),
    [aux_sym_variable_attributes_token1] = ACTIONS(1187),
    [aux_sym_variable_attributes_token2] = ACTIONS(1187),
    [aux_sym_variable_attributes_token3] = ACTIONS(1187),
    [aux_sym_variable_attributes_token4] = ACTIONS(1187),
    [aux_sym_variable_attributes_token5] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1187),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1187),
    [aux_sym_derived_type_token1] = ACTIONS(1187),
    [aux_sym_type_qualifier_token1] = ACTIONS(1187),
    [aux_sym_type_qualifier_token2] = ACTIONS(1187),
    [aux_sym_type_qualifier_token3] = ACTIONS(1187),
    [aux_sym_type_qualifier_token4] = ACTIONS(1187),
    [aux_sym_type_qualifier_token5] = ACTIONS(1187),
    [aux_sym_type_qualifier_token9] = ACTIONS(1187),
    [aux_sym_type_qualifier_token10] = ACTIONS(1187),
    [aux_sym_type_qualifier_token11] = ACTIONS(1187),
    [aux_sym_type_qualifier_token12] = ACTIONS(1187),
    [aux_sym_type_qualifier_token13] = ACTIONS(1187),
    [aux_sym_type_qualifier_token14] = ACTIONS(1187),
    [aux_sym_type_qualifier_token15] = ACTIONS(1187),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1187),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1187),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1187),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1187),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1187),
    [aux_sym_stop_statement_token1] = ACTIONS(1187),
    [aux_sym_stop_statement_token2] = ACTIONS(1187),
    [aux_sym_subroutine_call_token1] = ACTIONS(1187),
    [aux_sym_keyword_statement_token1] = ACTIONS(1187),
    [aux_sym_keyword_statement_token2] = ACTIONS(1187),
    [aux_sym_keyword_statement_token3] = ACTIONS(1187),
    [aux_sym_keyword_statement_token4] = ACTIONS(1187),
    [aux_sym_keyword_statement_token6] = ACTIONS(1187),
    [aux_sym_keyword_statement_token7] = ACTIONS(1187),
    [aux_sym_include_statement_token1] = ACTIONS(1187),
    [aux_sym_data_statement_token1] = ACTIONS(1187),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1187),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1187),
    [aux_sym_end_if_statement_token1] = ACTIONS(1187),
    [aux_sym_elseif_clause_token2] = ACTIONS(1187),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1187),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1187),
    [aux_sym_select_case_statement_token1] = ACTIONS(1187),
    [aux_sym_select_case_statement_token3] = ACTIONS(1187),
    [aux_sym_select_type_statement_token1] = ACTIONS(1187),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1187),
    [aux_sym_block_construct_token1] = ACTIONS(1187),
    [aux_sym_associate_statement_token1] = ACTIONS(1187),
    [aux_sym_format_statement_token1] = ACTIONS(1187),
    [aux_sym_print_statement_token1] = ACTIONS(1187),
    [aux_sym_open_statement_token1] = ACTIONS(1187),
    [aux_sym_close_statement_token1] = ACTIONS(1187),
    [aux_sym_inquire_statement_token1] = ACTIONS(1187),
    [aux_sym_enum_statement_token1] = ACTIONS(1187),
    [aux_sym_file_position_statement_token1] = ACTIONS(1187),
    [aux_sym_file_position_statement_token2] = ACTIONS(1187),
    [aux_sym_file_position_statement_token3] = ACTIONS(1187),
    [aux_sym_file_position_statement_token4] = ACTIONS(1187),
    [aux_sym_logical_expression_token5] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [sym_boolean_literal] = ACTIONS(1185),
    [aux_sym_null_literal_token1] = ACTIONS(1187),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1187),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1185),
    [sym__float_literal] = ACTIONS(1185),
    [sym__boz_literal] = ACTIONS(1185),
    [sym_string_literal] = ACTIONS(1185),
  },
  [258] = {
    [sym_preproc_file_line] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(1181),
    [aux_sym_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token2] = ACTIONS(1183),
    [aux_sym_module_statement_token1] = ACTIONS(1183),
    [aux_sym_submodule_statement_token1] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [aux_sym_interface_statement_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1183),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1183),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1183),
    [aux_sym_function_statement_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1183),
    [aux_sym_contains_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token2] = ACTIONS(1183),
    [aux_sym_implicit_statement_token1] = ACTIONS(1183),
    [aux_sym_implicit_statement_token3] = ACTIONS(1183),
    [aux_sym_implicit_statement_token4] = ACTIONS(1183),
    [aux_sym_save_statement_token1] = ACTIONS(1183),
    [aux_sym_private_statement_token1] = ACTIONS(1183),
    [aux_sym_public_statement_token1] = ACTIONS(1183),
    [aux_sym_namelist_statement_token1] = ACTIONS(1183),
    [aux_sym_common_statement_token1] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [aux_sym_import_statement_token1] = ACTIONS(1183),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1183),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1183),
    [aux_sym_variable_attributes_token1] = ACTIONS(1183),
    [aux_sym_variable_attributes_token2] = ACTIONS(1183),
    [aux_sym_variable_attributes_token3] = ACTIONS(1183),
    [aux_sym_variable_attributes_token4] = ACTIONS(1183),
    [aux_sym_variable_attributes_token5] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1183),
    [aux_sym_derived_type_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token2] = ACTIONS(1183),
    [aux_sym_type_qualifier_token3] = ACTIONS(1183),
    [aux_sym_type_qualifier_token4] = ACTIONS(1183),
    [aux_sym_type_qualifier_token5] = ACTIONS(1183),
    [aux_sym_type_qualifier_token9] = ACTIONS(1183),
    [aux_sym_type_qualifier_token10] = ACTIONS(1183),
    [aux_sym_type_qualifier_token11] = ACTIONS(1183),
    [aux_sym_type_qualifier_token12] = ACTIONS(1183),
    [aux_sym_type_qualifier_token13] = ACTIONS(1183),
    [aux_sym_type_qualifier_token14] = ACTIONS(1183),
    [aux_sym_type_qualifier_token15] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1183),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token2] = ACTIONS(1183),
    [aux_sym_subroutine_call_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token2] = ACTIONS(1183),
    [aux_sym_keyword_statement_token3] = ACTIONS(1183),
    [aux_sym_keyword_statement_token4] = ACTIONS(1183),
    [aux_sym_keyword_statement_token6] = ACTIONS(1183),
    [aux_sym_keyword_statement_token7] = ACTIONS(1183),
    [aux_sym_include_statement_token1] = ACTIONS(1183),
    [aux_sym_data_statement_token1] = ACTIONS(1183),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1183),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1183),
    [aux_sym_end_if_statement_token1] = ACTIONS(1183),
    [aux_sym_elseif_clause_token2] = ACTIONS(1183),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1183),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token3] = ACTIONS(1183),
    [aux_sym_select_type_statement_token1] = ACTIONS(1183),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1183),
    [aux_sym_block_construct_token1] = ACTIONS(1183),
    [aux_sym_associate_statement_token1] = ACTIONS(1183),
    [aux_sym_format_statement_token1] = ACTIONS(1183),
    [aux_sym_print_statement_token1] = ACTIONS(1183),
    [aux_sym_open_statement_token1] = ACTIONS(1183),
    [aux_sym_close_statement_token1] = ACTIONS(1183),
    [aux_sym_inquire_statement_token1] = ACTIONS(1183),
    [aux_sym_enum_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token2] = ACTIONS(1183),
    [aux_sym_file_position_statement_token3] = ACTIONS(1183),
    [aux_sym_file_position_statement_token4] = ACTIONS(1183),
    [aux_sym_logical_expression_token5] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [sym_boolean_literal] = ACTIONS(1181),
    [aux_sym_null_literal_token1] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1183),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1181),
    [sym__float_literal] = ACTIONS(1181),
    [sym__boz_literal] = ACTIONS(1181),
    [sym_string_literal] = ACTIONS(1181),
  },
  [259] = {
    [sym_preproc_file_line] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(1189),
    [aux_sym_program_statement_token1] = ACTIONS(1191),
    [aux_sym_end_program_statement_token1] = ACTIONS(1191),
    [aux_sym_end_program_statement_token2] = ACTIONS(1191),
    [aux_sym_module_statement_token1] = ACTIONS(1191),
    [aux_sym_submodule_statement_token1] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [aux_sym_interface_statement_token1] = ACTIONS(1191),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1191),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1191),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1191),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1191),
    [aux_sym_function_statement_token1] = ACTIONS(1191),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1191),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1191),
    [aux_sym_contains_statement_token1] = ACTIONS(1191),
    [aux_sym_use_statement_token1] = ACTIONS(1191),
    [aux_sym_use_statement_token2] = ACTIONS(1191),
    [aux_sym_implicit_statement_token1] = ACTIONS(1191),
    [aux_sym_implicit_statement_token3] = ACTIONS(1191),
    [aux_sym_implicit_statement_token4] = ACTIONS(1191),
    [aux_sym_save_statement_token1] = ACTIONS(1191),
    [aux_sym_private_statement_token1] = ACTIONS(1191),
    [aux_sym_public_statement_token1] = ACTIONS(1191),
    [aux_sym_namelist_statement_token1] = ACTIONS(1191),
    [aux_sym_common_statement_token1] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1189),
    [aux_sym_import_statement_token1] = ACTIONS(1191),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1191),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1191),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1191),
    [aux_sym_variable_attributes_token1] = ACTIONS(1191),
    [aux_sym_variable_attributes_token2] = ACTIONS(1191),
    [aux_sym_variable_attributes_token3] = ACTIONS(1191),
    [aux_sym_variable_attributes_token4] = ACTIONS(1191),
    [aux_sym_variable_attributes_token5] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1191),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1191),
    [aux_sym_derived_type_token1] = ACTIONS(1191),
    [aux_sym_type_qualifier_token1] = ACTIONS(1191),
    [aux_sym_type_qualifier_token2] = ACTIONS(1191),
    [aux_sym_type_qualifier_token3] = ACTIONS(1191),
    [aux_sym_type_qualifier_token4] = ACTIONS(1191),
    [aux_sym_type_qualifier_token5] = ACTIONS(1191),
    [aux_sym_type_qualifier_token9] = ACTIONS(1191),
    [aux_sym_type_qualifier_token10] = ACTIONS(1191),
    [aux_sym_type_qualifier_token11] = ACTIONS(1191),
    [aux_sym_type_qualifier_token12] = ACTIONS(1191),
    [aux_sym_type_qualifier_token13] = ACTIONS(1191),
    [aux_sym_type_qualifier_token14] = ACTIONS(1191),
    [aux_sym_type_qualifier_token15] = ACTIONS(1191),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1191),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1191),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1191),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1191),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1191),
    [aux_sym_stop_statement_token1] = ACTIONS(1191),
    [aux_sym_stop_statement_token2] = ACTIONS(1191),
    [aux_sym_subroutine_call_token1] = ACTIONS(1191),
    [aux_sym_keyword_statement_token1] = ACTIONS(1191),
    [aux_sym_keyword_statement_token2] = ACTIONS(1191),
    [aux_sym_keyword_statement_token3] = ACTIONS(1191),
    [aux_sym_keyword_statement_token4] = ACTIONS(1191),
    [aux_sym_keyword_statement_token6] = ACTIONS(1191),
    [aux_sym_keyword_statement_token7] = ACTIONS(1191),
    [aux_sym_include_statement_token1] = ACTIONS(1191),
    [aux_sym_data_statement_token1] = ACTIONS(1191),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1191),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1191),
    [aux_sym_end_if_statement_token1] = ACTIONS(1191),
    [aux_sym_elseif_clause_token2] = ACTIONS(1191),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1191),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1191),
    [aux_sym_select_case_statement_token1] = ACTIONS(1191),
    [aux_sym_select_case_statement_token3] = ACTIONS(1191),
    [aux_sym_select_type_statement_token1] = ACTIONS(1191),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1191),
    [aux_sym_block_construct_token1] = ACTIONS(1191),
    [aux_sym_associate_statement_token1] = ACTIONS(1191),
    [aux_sym_format_statement_token1] = ACTIONS(1191),
    [aux_sym_print_statement_token1] = ACTIONS(1191),
    [aux_sym_open_statement_token1] = ACTIONS(1191),
    [aux_sym_close_statement_token1] = ACTIONS(1191),
    [aux_sym_inquire_statement_token1] = ACTIONS(1191),
    [aux_sym_enum_statement_token1] = ACTIONS(1191),
    [aux_sym_file_position_statement_token1] = ACTIONS(1191),
    [aux_sym_file_position_statement_token2] = ACTIONS(1191),
    [aux_sym_file_position_statement_token3] = ACTIONS(1191),
    [aux_sym_file_position_statement_token4] = ACTIONS(1191),
    [aux_sym_logical_expression_token5] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [sym_boolean_literal] = ACTIONS(1189),
    [aux_sym_null_literal_token1] = ACTIONS(1191),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1191),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1189),
    [sym__float_literal] = ACTIONS(1189),
    [sym__boz_literal] = ACTIONS(1189),
    [sym_string_literal] = ACTIONS(1189),
  },
  [260] = {
    [sym__statements] = STATE(2796),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(260),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [261] = {
    [sym_preproc_file_line] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(1193),
    [aux_sym_program_statement_token1] = ACTIONS(1195),
    [aux_sym_end_program_statement_token1] = ACTIONS(1195),
    [aux_sym_end_program_statement_token2] = ACTIONS(1195),
    [aux_sym_module_statement_token1] = ACTIONS(1195),
    [aux_sym_submodule_statement_token1] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [aux_sym_interface_statement_token1] = ACTIONS(1195),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1195),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1195),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1195),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1195),
    [aux_sym_function_statement_token1] = ACTIONS(1195),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1195),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1195),
    [aux_sym_contains_statement_token1] = ACTIONS(1195),
    [aux_sym_use_statement_token1] = ACTIONS(1195),
    [aux_sym_use_statement_token2] = ACTIONS(1195),
    [aux_sym_implicit_statement_token1] = ACTIONS(1195),
    [aux_sym_implicit_statement_token3] = ACTIONS(1195),
    [aux_sym_implicit_statement_token4] = ACTIONS(1195),
    [aux_sym_save_statement_token1] = ACTIONS(1195),
    [aux_sym_private_statement_token1] = ACTIONS(1195),
    [aux_sym_public_statement_token1] = ACTIONS(1195),
    [aux_sym_namelist_statement_token1] = ACTIONS(1195),
    [aux_sym_common_statement_token1] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1193),
    [aux_sym_import_statement_token1] = ACTIONS(1195),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1195),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1195),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1195),
    [aux_sym_variable_attributes_token1] = ACTIONS(1195),
    [aux_sym_variable_attributes_token2] = ACTIONS(1195),
    [aux_sym_variable_attributes_token3] = ACTIONS(1195),
    [aux_sym_variable_attributes_token4] = ACTIONS(1195),
    [aux_sym_variable_attributes_token5] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1195),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1195),
    [aux_sym_derived_type_token1] = ACTIONS(1195),
    [aux_sym_type_qualifier_token1] = ACTIONS(1195),
    [aux_sym_type_qualifier_token2] = ACTIONS(1195),
    [aux_sym_type_qualifier_token3] = ACTIONS(1195),
    [aux_sym_type_qualifier_token4] = ACTIONS(1195),
    [aux_sym_type_qualifier_token5] = ACTIONS(1195),
    [aux_sym_type_qualifier_token9] = ACTIONS(1195),
    [aux_sym_type_qualifier_token10] = ACTIONS(1195),
    [aux_sym_type_qualifier_token11] = ACTIONS(1195),
    [aux_sym_type_qualifier_token12] = ACTIONS(1195),
    [aux_sym_type_qualifier_token13] = ACTIONS(1195),
    [aux_sym_type_qualifier_token14] = ACTIONS(1195),
    [aux_sym_type_qualifier_token15] = ACTIONS(1195),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1195),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1195),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1195),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1195),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1195),
    [aux_sym_stop_statement_token1] = ACTIONS(1195),
    [aux_sym_stop_statement_token2] = ACTIONS(1195),
    [aux_sym_subroutine_call_token1] = ACTIONS(1195),
    [aux_sym_keyword_statement_token1] = ACTIONS(1195),
    [aux_sym_keyword_statement_token2] = ACTIONS(1195),
    [aux_sym_keyword_statement_token3] = ACTIONS(1195),
    [aux_sym_keyword_statement_token4] = ACTIONS(1195),
    [aux_sym_keyword_statement_token6] = ACTIONS(1195),
    [aux_sym_keyword_statement_token7] = ACTIONS(1195),
    [aux_sym_include_statement_token1] = ACTIONS(1195),
    [aux_sym_data_statement_token1] = ACTIONS(1195),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1195),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1195),
    [aux_sym_end_if_statement_token1] = ACTIONS(1195),
    [aux_sym_elseif_clause_token2] = ACTIONS(1195),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1195),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1195),
    [aux_sym_select_case_statement_token1] = ACTIONS(1195),
    [aux_sym_select_case_statement_token3] = ACTIONS(1195),
    [aux_sym_select_type_statement_token1] = ACTIONS(1195),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1195),
    [aux_sym_block_construct_token1] = ACTIONS(1195),
    [aux_sym_associate_statement_token1] = ACTIONS(1195),
    [aux_sym_format_statement_token1] = ACTIONS(1195),
    [aux_sym_print_statement_token1] = ACTIONS(1195),
    [aux_sym_open_statement_token1] = ACTIONS(1195),
    [aux_sym_close_statement_token1] = ACTIONS(1195),
    [aux_sym_inquire_statement_token1] = ACTIONS(1195),
    [aux_sym_enum_statement_token1] = ACTIONS(1195),
    [aux_sym_file_position_statement_token1] = ACTIONS(1195),
    [aux_sym_file_position_statement_token2] = ACTIONS(1195),
    [aux_sym_file_position_statement_token3] = ACTIONS(1195),
    [aux_sym_file_position_statement_token4] = ACTIONS(1195),
    [aux_sym_logical_expression_token5] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [sym_boolean_literal] = ACTIONS(1193),
    [aux_sym_null_literal_token1] = ACTIONS(1195),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1195),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1193),
    [sym__float_literal] = ACTIONS(1193),
    [sym__boz_literal] = ACTIONS(1193),
    [sym_string_literal] = ACTIONS(1193),
  },
  [262] = {
    [sym_preproc_file_line] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(1197),
    [aux_sym_program_statement_token1] = ACTIONS(1199),
    [aux_sym_end_program_statement_token1] = ACTIONS(1199),
    [aux_sym_end_program_statement_token2] = ACTIONS(1199),
    [aux_sym_module_statement_token1] = ACTIONS(1199),
    [aux_sym_submodule_statement_token1] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [aux_sym_interface_statement_token1] = ACTIONS(1199),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1199),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1199),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1199),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1199),
    [aux_sym_function_statement_token1] = ACTIONS(1199),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1199),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1199),
    [aux_sym_contains_statement_token1] = ACTIONS(1199),
    [aux_sym_use_statement_token1] = ACTIONS(1199),
    [aux_sym_use_statement_token2] = ACTIONS(1199),
    [aux_sym_implicit_statement_token1] = ACTIONS(1199),
    [aux_sym_implicit_statement_token3] = ACTIONS(1199),
    [aux_sym_implicit_statement_token4] = ACTIONS(1199),
    [aux_sym_save_statement_token1] = ACTIONS(1199),
    [aux_sym_private_statement_token1] = ACTIONS(1199),
    [aux_sym_public_statement_token1] = ACTIONS(1199),
    [aux_sym_namelist_statement_token1] = ACTIONS(1199),
    [aux_sym_common_statement_token1] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1197),
    [aux_sym_import_statement_token1] = ACTIONS(1199),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1199),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1199),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1199),
    [aux_sym_variable_attributes_token1] = ACTIONS(1199),
    [aux_sym_variable_attributes_token2] = ACTIONS(1199),
    [aux_sym_variable_attributes_token3] = ACTIONS(1199),
    [aux_sym_variable_attributes_token4] = ACTIONS(1199),
    [aux_sym_variable_attributes_token5] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1199),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1199),
    [aux_sym_derived_type_token1] = ACTIONS(1199),
    [aux_sym_type_qualifier_token1] = ACTIONS(1199),
    [aux_sym_type_qualifier_token2] = ACTIONS(1199),
    [aux_sym_type_qualifier_token3] = ACTIONS(1199),
    [aux_sym_type_qualifier_token4] = ACTIONS(1199),
    [aux_sym_type_qualifier_token5] = ACTIONS(1199),
    [aux_sym_type_qualifier_token9] = ACTIONS(1199),
    [aux_sym_type_qualifier_token10] = ACTIONS(1199),
    [aux_sym_type_qualifier_token11] = ACTIONS(1199),
    [aux_sym_type_qualifier_token12] = ACTIONS(1199),
    [aux_sym_type_qualifier_token13] = ACTIONS(1199),
    [aux_sym_type_qualifier_token14] = ACTIONS(1199),
    [aux_sym_type_qualifier_token15] = ACTIONS(1199),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1199),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1199),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1199),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1199),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1199),
    [aux_sym_stop_statement_token1] = ACTIONS(1199),
    [aux_sym_stop_statement_token2] = ACTIONS(1199),
    [aux_sym_subroutine_call_token1] = ACTIONS(1199),
    [aux_sym_keyword_statement_token1] = ACTIONS(1199),
    [aux_sym_keyword_statement_token2] = ACTIONS(1199),
    [aux_sym_keyword_statement_token3] = ACTIONS(1199),
    [aux_sym_keyword_statement_token4] = ACTIONS(1199),
    [aux_sym_keyword_statement_token6] = ACTIONS(1199),
    [aux_sym_keyword_statement_token7] = ACTIONS(1199),
    [aux_sym_include_statement_token1] = ACTIONS(1199),
    [aux_sym_data_statement_token1] = ACTIONS(1199),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1199),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1199),
    [aux_sym_end_if_statement_token1] = ACTIONS(1199),
    [aux_sym_elseif_clause_token2] = ACTIONS(1199),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1199),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1199),
    [aux_sym_select_case_statement_token1] = ACTIONS(1199),
    [aux_sym_select_case_statement_token3] = ACTIONS(1199),
    [aux_sym_select_type_statement_token1] = ACTIONS(1199),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1199),
    [aux_sym_block_construct_token1] = ACTIONS(1199),
    [aux_sym_associate_statement_token1] = ACTIONS(1199),
    [aux_sym_format_statement_token1] = ACTIONS(1199),
    [aux_sym_print_statement_token1] = ACTIONS(1199),
    [aux_sym_open_statement_token1] = ACTIONS(1199),
    [aux_sym_close_statement_token1] = ACTIONS(1199),
    [aux_sym_inquire_statement_token1] = ACTIONS(1199),
    [aux_sym_enum_statement_token1] = ACTIONS(1199),
    [aux_sym_file_position_statement_token1] = ACTIONS(1199),
    [aux_sym_file_position_statement_token2] = ACTIONS(1199),
    [aux_sym_file_position_statement_token3] = ACTIONS(1199),
    [aux_sym_file_position_statement_token4] = ACTIONS(1199),
    [aux_sym_logical_expression_token5] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1197),
    [sym_boolean_literal] = ACTIONS(1197),
    [aux_sym_null_literal_token1] = ACTIONS(1199),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1199),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1197),
    [sym__float_literal] = ACTIONS(1197),
    [sym__boz_literal] = ACTIONS(1197),
    [sym_string_literal] = ACTIONS(1197),
  },
  [263] = {
    [sym_preproc_file_line] = STATE(263),
    [ts_builtin_sym_end] = ACTIONS(1201),
    [aux_sym_program_statement_token1] = ACTIONS(1203),
    [aux_sym_end_program_statement_token1] = ACTIONS(1203),
    [aux_sym_end_program_statement_token2] = ACTIONS(1203),
    [aux_sym_module_statement_token1] = ACTIONS(1203),
    [aux_sym_submodule_statement_token1] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1203),
    [aux_sym_interface_statement_token1] = ACTIONS(1203),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1203),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1203),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1203),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1203),
    [aux_sym_function_statement_token1] = ACTIONS(1203),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1203),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1203),
    [aux_sym_contains_statement_token1] = ACTIONS(1203),
    [aux_sym_use_statement_token1] = ACTIONS(1203),
    [aux_sym_use_statement_token2] = ACTIONS(1203),
    [aux_sym_implicit_statement_token1] = ACTIONS(1203),
    [aux_sym_implicit_statement_token3] = ACTIONS(1203),
    [aux_sym_implicit_statement_token4] = ACTIONS(1203),
    [aux_sym_save_statement_token1] = ACTIONS(1203),
    [aux_sym_private_statement_token1] = ACTIONS(1203),
    [aux_sym_public_statement_token1] = ACTIONS(1203),
    [aux_sym_namelist_statement_token1] = ACTIONS(1203),
    [aux_sym_common_statement_token1] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1201),
    [aux_sym_import_statement_token1] = ACTIONS(1203),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1203),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1203),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1203),
    [aux_sym_variable_attributes_token1] = ACTIONS(1203),
    [aux_sym_variable_attributes_token2] = ACTIONS(1203),
    [aux_sym_variable_attributes_token3] = ACTIONS(1203),
    [aux_sym_variable_attributes_token4] = ACTIONS(1203),
    [aux_sym_variable_attributes_token5] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1203),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1203),
    [aux_sym_derived_type_token1] = ACTIONS(1203),
    [aux_sym_type_qualifier_token1] = ACTIONS(1203),
    [aux_sym_type_qualifier_token2] = ACTIONS(1203),
    [aux_sym_type_qualifier_token3] = ACTIONS(1203),
    [aux_sym_type_qualifier_token4] = ACTIONS(1203),
    [aux_sym_type_qualifier_token5] = ACTIONS(1203),
    [aux_sym_type_qualifier_token9] = ACTIONS(1203),
    [aux_sym_type_qualifier_token10] = ACTIONS(1203),
    [aux_sym_type_qualifier_token11] = ACTIONS(1203),
    [aux_sym_type_qualifier_token12] = ACTIONS(1203),
    [aux_sym_type_qualifier_token13] = ACTIONS(1203),
    [aux_sym_type_qualifier_token14] = ACTIONS(1203),
    [aux_sym_type_qualifier_token15] = ACTIONS(1203),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1203),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1203),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1203),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1203),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1203),
    [aux_sym_stop_statement_token1] = ACTIONS(1203),
    [aux_sym_stop_statement_token2] = ACTIONS(1203),
    [aux_sym_subroutine_call_token1] = ACTIONS(1203),
    [aux_sym_keyword_statement_token1] = ACTIONS(1203),
    [aux_sym_keyword_statement_token2] = ACTIONS(1203),
    [aux_sym_keyword_statement_token3] = ACTIONS(1203),
    [aux_sym_keyword_statement_token4] = ACTIONS(1203),
    [aux_sym_keyword_statement_token6] = ACTIONS(1203),
    [aux_sym_keyword_statement_token7] = ACTIONS(1203),
    [aux_sym_include_statement_token1] = ACTIONS(1203),
    [aux_sym_data_statement_token1] = ACTIONS(1203),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1203),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1203),
    [aux_sym_end_if_statement_token1] = ACTIONS(1203),
    [aux_sym_elseif_clause_token2] = ACTIONS(1203),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1203),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1203),
    [aux_sym_select_case_statement_token1] = ACTIONS(1203),
    [aux_sym_select_case_statement_token3] = ACTIONS(1203),
    [aux_sym_select_type_statement_token1] = ACTIONS(1203),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1203),
    [aux_sym_block_construct_token1] = ACTIONS(1203),
    [aux_sym_associate_statement_token1] = ACTIONS(1203),
    [aux_sym_format_statement_token1] = ACTIONS(1203),
    [aux_sym_print_statement_token1] = ACTIONS(1203),
    [aux_sym_open_statement_token1] = ACTIONS(1203),
    [aux_sym_close_statement_token1] = ACTIONS(1203),
    [aux_sym_inquire_statement_token1] = ACTIONS(1203),
    [aux_sym_enum_statement_token1] = ACTIONS(1203),
    [aux_sym_file_position_statement_token1] = ACTIONS(1203),
    [aux_sym_file_position_statement_token2] = ACTIONS(1203),
    [aux_sym_file_position_statement_token3] = ACTIONS(1203),
    [aux_sym_file_position_statement_token4] = ACTIONS(1203),
    [aux_sym_logical_expression_token5] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1201),
    [sym_boolean_literal] = ACTIONS(1201),
    [aux_sym_null_literal_token1] = ACTIONS(1203),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1203),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1201),
    [sym__float_literal] = ACTIONS(1201),
    [sym__boz_literal] = ACTIONS(1201),
    [sym_string_literal] = ACTIONS(1201),
  },
  [264] = {
    [sym_preproc_file_line] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [aux_sym_program_statement_token1] = ACTIONS(1207),
    [aux_sym_end_program_statement_token1] = ACTIONS(1207),
    [aux_sym_end_program_statement_token2] = ACTIONS(1207),
    [aux_sym_module_statement_token1] = ACTIONS(1207),
    [aux_sym_submodule_statement_token1] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1207),
    [aux_sym_interface_statement_token1] = ACTIONS(1207),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1207),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1207),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1207),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1207),
    [aux_sym_function_statement_token1] = ACTIONS(1207),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1207),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1207),
    [aux_sym_contains_statement_token1] = ACTIONS(1207),
    [aux_sym_use_statement_token1] = ACTIONS(1207),
    [aux_sym_use_statement_token2] = ACTIONS(1207),
    [aux_sym_implicit_statement_token1] = ACTIONS(1207),
    [aux_sym_implicit_statement_token3] = ACTIONS(1207),
    [aux_sym_implicit_statement_token4] = ACTIONS(1207),
    [aux_sym_save_statement_token1] = ACTIONS(1207),
    [aux_sym_private_statement_token1] = ACTIONS(1207),
    [aux_sym_public_statement_token1] = ACTIONS(1207),
    [aux_sym_namelist_statement_token1] = ACTIONS(1207),
    [aux_sym_common_statement_token1] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1205),
    [aux_sym_import_statement_token1] = ACTIONS(1207),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1207),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1207),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1207),
    [aux_sym_variable_attributes_token1] = ACTIONS(1207),
    [aux_sym_variable_attributes_token2] = ACTIONS(1207),
    [aux_sym_variable_attributes_token3] = ACTIONS(1207),
    [aux_sym_variable_attributes_token4] = ACTIONS(1207),
    [aux_sym_variable_attributes_token5] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1207),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1207),
    [aux_sym_derived_type_token1] = ACTIONS(1207),
    [aux_sym_type_qualifier_token1] = ACTIONS(1207),
    [aux_sym_type_qualifier_token2] = ACTIONS(1207),
    [aux_sym_type_qualifier_token3] = ACTIONS(1207),
    [aux_sym_type_qualifier_token4] = ACTIONS(1207),
    [aux_sym_type_qualifier_token5] = ACTIONS(1207),
    [aux_sym_type_qualifier_token9] = ACTIONS(1207),
    [aux_sym_type_qualifier_token10] = ACTIONS(1207),
    [aux_sym_type_qualifier_token11] = ACTIONS(1207),
    [aux_sym_type_qualifier_token12] = ACTIONS(1207),
    [aux_sym_type_qualifier_token13] = ACTIONS(1207),
    [aux_sym_type_qualifier_token14] = ACTIONS(1207),
    [aux_sym_type_qualifier_token15] = ACTIONS(1207),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1207),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1207),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1207),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1207),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1207),
    [aux_sym_stop_statement_token1] = ACTIONS(1207),
    [aux_sym_stop_statement_token2] = ACTIONS(1207),
    [aux_sym_subroutine_call_token1] = ACTIONS(1207),
    [aux_sym_keyword_statement_token1] = ACTIONS(1207),
    [aux_sym_keyword_statement_token2] = ACTIONS(1207),
    [aux_sym_keyword_statement_token3] = ACTIONS(1207),
    [aux_sym_keyword_statement_token4] = ACTIONS(1207),
    [aux_sym_keyword_statement_token6] = ACTIONS(1207),
    [aux_sym_keyword_statement_token7] = ACTIONS(1207),
    [aux_sym_include_statement_token1] = ACTIONS(1207),
    [aux_sym_data_statement_token1] = ACTIONS(1207),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1207),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1207),
    [aux_sym_end_if_statement_token1] = ACTIONS(1207),
    [aux_sym_elseif_clause_token2] = ACTIONS(1207),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1207),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1207),
    [aux_sym_select_case_statement_token1] = ACTIONS(1207),
    [aux_sym_select_case_statement_token3] = ACTIONS(1207),
    [aux_sym_select_type_statement_token1] = ACTIONS(1207),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1207),
    [aux_sym_block_construct_token1] = ACTIONS(1207),
    [aux_sym_associate_statement_token1] = ACTIONS(1207),
    [aux_sym_format_statement_token1] = ACTIONS(1207),
    [aux_sym_print_statement_token1] = ACTIONS(1207),
    [aux_sym_open_statement_token1] = ACTIONS(1207),
    [aux_sym_close_statement_token1] = ACTIONS(1207),
    [aux_sym_inquire_statement_token1] = ACTIONS(1207),
    [aux_sym_enum_statement_token1] = ACTIONS(1207),
    [aux_sym_file_position_statement_token1] = ACTIONS(1207),
    [aux_sym_file_position_statement_token2] = ACTIONS(1207),
    [aux_sym_file_position_statement_token3] = ACTIONS(1207),
    [aux_sym_file_position_statement_token4] = ACTIONS(1207),
    [aux_sym_logical_expression_token5] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [sym_boolean_literal] = ACTIONS(1205),
    [aux_sym_null_literal_token1] = ACTIONS(1207),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1207),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1205),
    [sym__float_literal] = ACTIONS(1205),
    [sym__boz_literal] = ACTIONS(1205),
    [sym_string_literal] = ACTIONS(1205),
  },
  [265] = {
    [sym_preproc_file_line] = STATE(265),
    [ts_builtin_sym_end] = ACTIONS(1209),
    [aux_sym_program_statement_token1] = ACTIONS(1211),
    [aux_sym_end_program_statement_token1] = ACTIONS(1211),
    [aux_sym_end_program_statement_token2] = ACTIONS(1211),
    [aux_sym_module_statement_token1] = ACTIONS(1211),
    [aux_sym_submodule_statement_token1] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1211),
    [aux_sym_interface_statement_token1] = ACTIONS(1211),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1211),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1211),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1211),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1211),
    [aux_sym_function_statement_token1] = ACTIONS(1211),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1211),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1211),
    [aux_sym_contains_statement_token1] = ACTIONS(1211),
    [aux_sym_use_statement_token1] = ACTIONS(1211),
    [aux_sym_use_statement_token2] = ACTIONS(1211),
    [aux_sym_implicit_statement_token1] = ACTIONS(1211),
    [aux_sym_implicit_statement_token3] = ACTIONS(1211),
    [aux_sym_implicit_statement_token4] = ACTIONS(1211),
    [aux_sym_save_statement_token1] = ACTIONS(1211),
    [aux_sym_private_statement_token1] = ACTIONS(1211),
    [aux_sym_public_statement_token1] = ACTIONS(1211),
    [aux_sym_namelist_statement_token1] = ACTIONS(1211),
    [aux_sym_common_statement_token1] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1209),
    [aux_sym_import_statement_token1] = ACTIONS(1211),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1211),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1211),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1211),
    [aux_sym_variable_attributes_token1] = ACTIONS(1211),
    [aux_sym_variable_attributes_token2] = ACTIONS(1211),
    [aux_sym_variable_attributes_token3] = ACTIONS(1211),
    [aux_sym_variable_attributes_token4] = ACTIONS(1211),
    [aux_sym_variable_attributes_token5] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1211),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1211),
    [aux_sym_derived_type_token1] = ACTIONS(1211),
    [aux_sym_type_qualifier_token1] = ACTIONS(1211),
    [aux_sym_type_qualifier_token2] = ACTIONS(1211),
    [aux_sym_type_qualifier_token3] = ACTIONS(1211),
    [aux_sym_type_qualifier_token4] = ACTIONS(1211),
    [aux_sym_type_qualifier_token5] = ACTIONS(1211),
    [aux_sym_type_qualifier_token9] = ACTIONS(1211),
    [aux_sym_type_qualifier_token10] = ACTIONS(1211),
    [aux_sym_type_qualifier_token11] = ACTIONS(1211),
    [aux_sym_type_qualifier_token12] = ACTIONS(1211),
    [aux_sym_type_qualifier_token13] = ACTIONS(1211),
    [aux_sym_type_qualifier_token14] = ACTIONS(1211),
    [aux_sym_type_qualifier_token15] = ACTIONS(1211),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1211),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1211),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1211),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1211),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1211),
    [aux_sym_stop_statement_token1] = ACTIONS(1211),
    [aux_sym_stop_statement_token2] = ACTIONS(1211),
    [aux_sym_subroutine_call_token1] = ACTIONS(1211),
    [aux_sym_keyword_statement_token1] = ACTIONS(1211),
    [aux_sym_keyword_statement_token2] = ACTIONS(1211),
    [aux_sym_keyword_statement_token3] = ACTIONS(1211),
    [aux_sym_keyword_statement_token4] = ACTIONS(1211),
    [aux_sym_keyword_statement_token6] = ACTIONS(1211),
    [aux_sym_keyword_statement_token7] = ACTIONS(1211),
    [aux_sym_include_statement_token1] = ACTIONS(1211),
    [aux_sym_data_statement_token1] = ACTIONS(1211),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1211),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1211),
    [aux_sym_end_if_statement_token1] = ACTIONS(1211),
    [aux_sym_elseif_clause_token2] = ACTIONS(1211),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1211),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1211),
    [aux_sym_select_case_statement_token1] = ACTIONS(1211),
    [aux_sym_select_case_statement_token3] = ACTIONS(1211),
    [aux_sym_select_type_statement_token1] = ACTIONS(1211),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1211),
    [aux_sym_block_construct_token1] = ACTIONS(1211),
    [aux_sym_associate_statement_token1] = ACTIONS(1211),
    [aux_sym_format_statement_token1] = ACTIONS(1211),
    [aux_sym_print_statement_token1] = ACTIONS(1211),
    [aux_sym_open_statement_token1] = ACTIONS(1211),
    [aux_sym_close_statement_token1] = ACTIONS(1211),
    [aux_sym_inquire_statement_token1] = ACTIONS(1211),
    [aux_sym_enum_statement_token1] = ACTIONS(1211),
    [aux_sym_file_position_statement_token1] = ACTIONS(1211),
    [aux_sym_file_position_statement_token2] = ACTIONS(1211),
    [aux_sym_file_position_statement_token3] = ACTIONS(1211),
    [aux_sym_file_position_statement_token4] = ACTIONS(1211),
    [aux_sym_logical_expression_token5] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1209),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [sym_boolean_literal] = ACTIONS(1209),
    [aux_sym_null_literal_token1] = ACTIONS(1211),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1211),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1209),
    [sym__float_literal] = ACTIONS(1209),
    [sym__boz_literal] = ACTIONS(1209),
    [sym_string_literal] = ACTIONS(1209),
  },
  [266] = {
    [sym__statements] = STATE(2701),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(266),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [267] = {
    [sym_preproc_file_line] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(1213),
    [aux_sym_program_statement_token1] = ACTIONS(1215),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [aux_sym_end_program_statement_token2] = ACTIONS(1215),
    [aux_sym_module_statement_token1] = ACTIONS(1215),
    [aux_sym_submodule_statement_token1] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_function_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_contains_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1215),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1215),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [268] = {
    [sym_preproc_file_line] = STATE(268),
    [ts_builtin_sym_end] = ACTIONS(1217),
    [aux_sym_program_statement_token1] = ACTIONS(1219),
    [aux_sym_end_program_statement_token1] = ACTIONS(1219),
    [aux_sym_end_program_statement_token2] = ACTIONS(1219),
    [aux_sym_module_statement_token1] = ACTIONS(1219),
    [aux_sym_submodule_statement_token1] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1219),
    [aux_sym_interface_statement_token1] = ACTIONS(1219),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1219),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1219),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1219),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1219),
    [aux_sym_function_statement_token1] = ACTIONS(1219),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1219),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1219),
    [aux_sym_contains_statement_token1] = ACTIONS(1219),
    [aux_sym_use_statement_token1] = ACTIONS(1219),
    [aux_sym_use_statement_token2] = ACTIONS(1219),
    [aux_sym_implicit_statement_token1] = ACTIONS(1219),
    [aux_sym_implicit_statement_token3] = ACTIONS(1219),
    [aux_sym_implicit_statement_token4] = ACTIONS(1219),
    [aux_sym_save_statement_token1] = ACTIONS(1219),
    [aux_sym_private_statement_token1] = ACTIONS(1219),
    [aux_sym_public_statement_token1] = ACTIONS(1219),
    [aux_sym_namelist_statement_token1] = ACTIONS(1219),
    [aux_sym_common_statement_token1] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1217),
    [aux_sym_import_statement_token1] = ACTIONS(1219),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1219),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1219),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1219),
    [aux_sym_variable_attributes_token1] = ACTIONS(1219),
    [aux_sym_variable_attributes_token2] = ACTIONS(1219),
    [aux_sym_variable_attributes_token3] = ACTIONS(1219),
    [aux_sym_variable_attributes_token4] = ACTIONS(1219),
    [aux_sym_variable_attributes_token5] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1219),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1219),
    [aux_sym_derived_type_token1] = ACTIONS(1219),
    [aux_sym_type_qualifier_token1] = ACTIONS(1219),
    [aux_sym_type_qualifier_token2] = ACTIONS(1219),
    [aux_sym_type_qualifier_token3] = ACTIONS(1219),
    [aux_sym_type_qualifier_token4] = ACTIONS(1219),
    [aux_sym_type_qualifier_token5] = ACTIONS(1219),
    [aux_sym_type_qualifier_token9] = ACTIONS(1219),
    [aux_sym_type_qualifier_token10] = ACTIONS(1219),
    [aux_sym_type_qualifier_token11] = ACTIONS(1219),
    [aux_sym_type_qualifier_token12] = ACTIONS(1219),
    [aux_sym_type_qualifier_token13] = ACTIONS(1219),
    [aux_sym_type_qualifier_token14] = ACTIONS(1219),
    [aux_sym_type_qualifier_token15] = ACTIONS(1219),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1219),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1219),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1219),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1219),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1219),
    [aux_sym_stop_statement_token1] = ACTIONS(1219),
    [aux_sym_stop_statement_token2] = ACTIONS(1219),
    [aux_sym_subroutine_call_token1] = ACTIONS(1219),
    [aux_sym_keyword_statement_token1] = ACTIONS(1219),
    [aux_sym_keyword_statement_token2] = ACTIONS(1219),
    [aux_sym_keyword_statement_token3] = ACTIONS(1219),
    [aux_sym_keyword_statement_token4] = ACTIONS(1219),
    [aux_sym_keyword_statement_token6] = ACTIONS(1219),
    [aux_sym_keyword_statement_token7] = ACTIONS(1219),
    [aux_sym_include_statement_token1] = ACTIONS(1219),
    [aux_sym_data_statement_token1] = ACTIONS(1219),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1219),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1219),
    [aux_sym_end_if_statement_token1] = ACTIONS(1219),
    [aux_sym_elseif_clause_token2] = ACTIONS(1219),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1219),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1219),
    [aux_sym_select_case_statement_token1] = ACTIONS(1219),
    [aux_sym_select_case_statement_token3] = ACTIONS(1219),
    [aux_sym_select_type_statement_token1] = ACTIONS(1219),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1219),
    [aux_sym_block_construct_token1] = ACTIONS(1219),
    [aux_sym_associate_statement_token1] = ACTIONS(1219),
    [aux_sym_format_statement_token1] = ACTIONS(1219),
    [aux_sym_print_statement_token1] = ACTIONS(1219),
    [aux_sym_open_statement_token1] = ACTIONS(1219),
    [aux_sym_close_statement_token1] = ACTIONS(1219),
    [aux_sym_inquire_statement_token1] = ACTIONS(1219),
    [aux_sym_enum_statement_token1] = ACTIONS(1219),
    [aux_sym_file_position_statement_token1] = ACTIONS(1219),
    [aux_sym_file_position_statement_token2] = ACTIONS(1219),
    [aux_sym_file_position_statement_token3] = ACTIONS(1219),
    [aux_sym_file_position_statement_token4] = ACTIONS(1219),
    [aux_sym_logical_expression_token5] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DOT] = ACTIONS(1219),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [sym_boolean_literal] = ACTIONS(1217),
    [aux_sym_null_literal_token1] = ACTIONS(1219),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1219),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1217),
    [sym__float_literal] = ACTIONS(1217),
    [sym__boz_literal] = ACTIONS(1217),
    [sym_string_literal] = ACTIONS(1217),
  },
  [269] = {
    [sym_preproc_file_line] = STATE(269),
    [ts_builtin_sym_end] = ACTIONS(1221),
    [aux_sym_program_statement_token1] = ACTIONS(1223),
    [aux_sym_end_program_statement_token1] = ACTIONS(1223),
    [aux_sym_end_program_statement_token2] = ACTIONS(1223),
    [aux_sym_module_statement_token1] = ACTIONS(1223),
    [aux_sym_submodule_statement_token1] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [aux_sym_interface_statement_token1] = ACTIONS(1223),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1223),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1223),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1223),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1223),
    [aux_sym_function_statement_token1] = ACTIONS(1223),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1223),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1223),
    [aux_sym_contains_statement_token1] = ACTIONS(1223),
    [aux_sym_use_statement_token1] = ACTIONS(1223),
    [aux_sym_use_statement_token2] = ACTIONS(1223),
    [aux_sym_implicit_statement_token1] = ACTIONS(1223),
    [aux_sym_implicit_statement_token3] = ACTIONS(1223),
    [aux_sym_implicit_statement_token4] = ACTIONS(1223),
    [aux_sym_save_statement_token1] = ACTIONS(1223),
    [aux_sym_private_statement_token1] = ACTIONS(1223),
    [aux_sym_public_statement_token1] = ACTIONS(1223),
    [aux_sym_namelist_statement_token1] = ACTIONS(1223),
    [aux_sym_common_statement_token1] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1221),
    [aux_sym_import_statement_token1] = ACTIONS(1223),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1223),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1223),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1223),
    [aux_sym_variable_attributes_token1] = ACTIONS(1223),
    [aux_sym_variable_attributes_token2] = ACTIONS(1223),
    [aux_sym_variable_attributes_token3] = ACTIONS(1223),
    [aux_sym_variable_attributes_token4] = ACTIONS(1223),
    [aux_sym_variable_attributes_token5] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1223),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1223),
    [aux_sym_derived_type_token1] = ACTIONS(1223),
    [aux_sym_type_qualifier_token1] = ACTIONS(1223),
    [aux_sym_type_qualifier_token2] = ACTIONS(1223),
    [aux_sym_type_qualifier_token3] = ACTIONS(1223),
    [aux_sym_type_qualifier_token4] = ACTIONS(1223),
    [aux_sym_type_qualifier_token5] = ACTIONS(1223),
    [aux_sym_type_qualifier_token9] = ACTIONS(1223),
    [aux_sym_type_qualifier_token10] = ACTIONS(1223),
    [aux_sym_type_qualifier_token11] = ACTIONS(1223),
    [aux_sym_type_qualifier_token12] = ACTIONS(1223),
    [aux_sym_type_qualifier_token13] = ACTIONS(1223),
    [aux_sym_type_qualifier_token14] = ACTIONS(1223),
    [aux_sym_type_qualifier_token15] = ACTIONS(1223),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1223),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1223),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1223),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1223),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1223),
    [aux_sym_stop_statement_token1] = ACTIONS(1223),
    [aux_sym_stop_statement_token2] = ACTIONS(1223),
    [aux_sym_subroutine_call_token1] = ACTIONS(1223),
    [aux_sym_keyword_statement_token1] = ACTIONS(1223),
    [aux_sym_keyword_statement_token2] = ACTIONS(1223),
    [aux_sym_keyword_statement_token3] = ACTIONS(1223),
    [aux_sym_keyword_statement_token4] = ACTIONS(1223),
    [aux_sym_keyword_statement_token6] = ACTIONS(1223),
    [aux_sym_keyword_statement_token7] = ACTIONS(1223),
    [aux_sym_include_statement_token1] = ACTIONS(1223),
    [aux_sym_data_statement_token1] = ACTIONS(1223),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1223),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1223),
    [aux_sym_end_if_statement_token1] = ACTIONS(1223),
    [aux_sym_elseif_clause_token2] = ACTIONS(1223),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1223),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1223),
    [aux_sym_select_case_statement_token1] = ACTIONS(1223),
    [aux_sym_select_case_statement_token3] = ACTIONS(1223),
    [aux_sym_select_type_statement_token1] = ACTIONS(1223),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1223),
    [aux_sym_block_construct_token1] = ACTIONS(1223),
    [aux_sym_associate_statement_token1] = ACTIONS(1223),
    [aux_sym_format_statement_token1] = ACTIONS(1223),
    [aux_sym_print_statement_token1] = ACTIONS(1223),
    [aux_sym_open_statement_token1] = ACTIONS(1223),
    [aux_sym_close_statement_token1] = ACTIONS(1223),
    [aux_sym_inquire_statement_token1] = ACTIONS(1223),
    [aux_sym_enum_statement_token1] = ACTIONS(1223),
    [aux_sym_file_position_statement_token1] = ACTIONS(1223),
    [aux_sym_file_position_statement_token2] = ACTIONS(1223),
    [aux_sym_file_position_statement_token3] = ACTIONS(1223),
    [aux_sym_file_position_statement_token4] = ACTIONS(1223),
    [aux_sym_logical_expression_token5] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [sym_boolean_literal] = ACTIONS(1221),
    [aux_sym_null_literal_token1] = ACTIONS(1223),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1223),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1221),
    [sym__float_literal] = ACTIONS(1221),
    [sym__boz_literal] = ACTIONS(1221),
    [sym_string_literal] = ACTIONS(1221),
  },
  [270] = {
    [sym_preproc_file_line] = STATE(270),
    [ts_builtin_sym_end] = ACTIONS(1225),
    [aux_sym_program_statement_token1] = ACTIONS(1227),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [aux_sym_end_program_statement_token2] = ACTIONS(1227),
    [aux_sym_module_statement_token1] = ACTIONS(1227),
    [aux_sym_submodule_statement_token1] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_function_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_contains_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1227),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1227),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [271] = {
    [sym_preproc_file_line] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [aux_sym_program_statement_token1] = ACTIONS(1231),
    [aux_sym_end_program_statement_token1] = ACTIONS(1231),
    [aux_sym_end_program_statement_token2] = ACTIONS(1231),
    [aux_sym_module_statement_token1] = ACTIONS(1231),
    [aux_sym_submodule_statement_token1] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [aux_sym_interface_statement_token1] = ACTIONS(1231),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1231),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1231),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1231),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1231),
    [aux_sym_function_statement_token1] = ACTIONS(1231),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1231),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1231),
    [aux_sym_contains_statement_token1] = ACTIONS(1231),
    [aux_sym_use_statement_token1] = ACTIONS(1231),
    [aux_sym_use_statement_token2] = ACTIONS(1231),
    [aux_sym_implicit_statement_token1] = ACTIONS(1231),
    [aux_sym_implicit_statement_token3] = ACTIONS(1231),
    [aux_sym_implicit_statement_token4] = ACTIONS(1231),
    [aux_sym_save_statement_token1] = ACTIONS(1231),
    [aux_sym_private_statement_token1] = ACTIONS(1231),
    [aux_sym_public_statement_token1] = ACTIONS(1231),
    [aux_sym_namelist_statement_token1] = ACTIONS(1231),
    [aux_sym_common_statement_token1] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1229),
    [aux_sym_import_statement_token1] = ACTIONS(1231),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1231),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1231),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1231),
    [aux_sym_variable_attributes_token1] = ACTIONS(1231),
    [aux_sym_variable_attributes_token2] = ACTIONS(1231),
    [aux_sym_variable_attributes_token3] = ACTIONS(1231),
    [aux_sym_variable_attributes_token4] = ACTIONS(1231),
    [aux_sym_variable_attributes_token5] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1231),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1231),
    [aux_sym_derived_type_token1] = ACTIONS(1231),
    [aux_sym_type_qualifier_token1] = ACTIONS(1231),
    [aux_sym_type_qualifier_token2] = ACTIONS(1231),
    [aux_sym_type_qualifier_token3] = ACTIONS(1231),
    [aux_sym_type_qualifier_token4] = ACTIONS(1231),
    [aux_sym_type_qualifier_token5] = ACTIONS(1231),
    [aux_sym_type_qualifier_token9] = ACTIONS(1231),
    [aux_sym_type_qualifier_token10] = ACTIONS(1231),
    [aux_sym_type_qualifier_token11] = ACTIONS(1231),
    [aux_sym_type_qualifier_token12] = ACTIONS(1231),
    [aux_sym_type_qualifier_token13] = ACTIONS(1231),
    [aux_sym_type_qualifier_token14] = ACTIONS(1231),
    [aux_sym_type_qualifier_token15] = ACTIONS(1231),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1231),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1231),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1231),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1231),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1231),
    [aux_sym_stop_statement_token1] = ACTIONS(1231),
    [aux_sym_stop_statement_token2] = ACTIONS(1231),
    [aux_sym_subroutine_call_token1] = ACTIONS(1231),
    [aux_sym_keyword_statement_token1] = ACTIONS(1231),
    [aux_sym_keyword_statement_token2] = ACTIONS(1231),
    [aux_sym_keyword_statement_token3] = ACTIONS(1231),
    [aux_sym_keyword_statement_token4] = ACTIONS(1231),
    [aux_sym_keyword_statement_token6] = ACTIONS(1231),
    [aux_sym_keyword_statement_token7] = ACTIONS(1231),
    [aux_sym_include_statement_token1] = ACTIONS(1231),
    [aux_sym_data_statement_token1] = ACTIONS(1231),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1231),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1231),
    [aux_sym_end_if_statement_token1] = ACTIONS(1231),
    [aux_sym_elseif_clause_token2] = ACTIONS(1231),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1231),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1231),
    [aux_sym_select_case_statement_token1] = ACTIONS(1231),
    [aux_sym_select_case_statement_token3] = ACTIONS(1231),
    [aux_sym_select_type_statement_token1] = ACTIONS(1231),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1231),
    [aux_sym_block_construct_token1] = ACTIONS(1231),
    [aux_sym_associate_statement_token1] = ACTIONS(1231),
    [aux_sym_format_statement_token1] = ACTIONS(1231),
    [aux_sym_print_statement_token1] = ACTIONS(1231),
    [aux_sym_open_statement_token1] = ACTIONS(1231),
    [aux_sym_close_statement_token1] = ACTIONS(1231),
    [aux_sym_inquire_statement_token1] = ACTIONS(1231),
    [aux_sym_enum_statement_token1] = ACTIONS(1231),
    [aux_sym_file_position_statement_token1] = ACTIONS(1231),
    [aux_sym_file_position_statement_token2] = ACTIONS(1231),
    [aux_sym_file_position_statement_token3] = ACTIONS(1231),
    [aux_sym_file_position_statement_token4] = ACTIONS(1231),
    [aux_sym_logical_expression_token5] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [sym_boolean_literal] = ACTIONS(1229),
    [aux_sym_null_literal_token1] = ACTIONS(1231),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1231),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1229),
    [sym__float_literal] = ACTIONS(1229),
    [sym__boz_literal] = ACTIONS(1229),
    [sym_string_literal] = ACTIONS(1229),
  },
  [272] = {
    [sym_preproc_file_line] = STATE(272),
    [ts_builtin_sym_end] = ACTIONS(1233),
    [aux_sym_program_statement_token1] = ACTIONS(1235),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [aux_sym_end_program_statement_token2] = ACTIONS(1235),
    [aux_sym_module_statement_token1] = ACTIONS(1235),
    [aux_sym_submodule_statement_token1] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_function_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_contains_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1235),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1235),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [273] = {
    [sym_preproc_file_line] = STATE(273),
    [ts_builtin_sym_end] = ACTIONS(1237),
    [aux_sym_program_statement_token1] = ACTIONS(1239),
    [aux_sym_end_program_statement_token1] = ACTIONS(1239),
    [aux_sym_end_program_statement_token2] = ACTIONS(1239),
    [aux_sym_module_statement_token1] = ACTIONS(1239),
    [aux_sym_submodule_statement_token1] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [aux_sym_interface_statement_token1] = ACTIONS(1239),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1239),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1239),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1239),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1239),
    [aux_sym_function_statement_token1] = ACTIONS(1239),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1239),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1239),
    [aux_sym_contains_statement_token1] = ACTIONS(1239),
    [aux_sym_use_statement_token1] = ACTIONS(1239),
    [aux_sym_use_statement_token2] = ACTIONS(1239),
    [aux_sym_implicit_statement_token1] = ACTIONS(1239),
    [aux_sym_implicit_statement_token3] = ACTIONS(1239),
    [aux_sym_implicit_statement_token4] = ACTIONS(1239),
    [aux_sym_save_statement_token1] = ACTIONS(1239),
    [aux_sym_private_statement_token1] = ACTIONS(1239),
    [aux_sym_public_statement_token1] = ACTIONS(1239),
    [aux_sym_namelist_statement_token1] = ACTIONS(1239),
    [aux_sym_common_statement_token1] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [aux_sym_import_statement_token1] = ACTIONS(1239),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1239),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1239),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1239),
    [aux_sym_variable_attributes_token1] = ACTIONS(1239),
    [aux_sym_variable_attributes_token2] = ACTIONS(1239),
    [aux_sym_variable_attributes_token3] = ACTIONS(1239),
    [aux_sym_variable_attributes_token4] = ACTIONS(1239),
    [aux_sym_variable_attributes_token5] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1239),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1239),
    [aux_sym_derived_type_token1] = ACTIONS(1239),
    [aux_sym_type_qualifier_token1] = ACTIONS(1239),
    [aux_sym_type_qualifier_token2] = ACTIONS(1239),
    [aux_sym_type_qualifier_token3] = ACTIONS(1239),
    [aux_sym_type_qualifier_token4] = ACTIONS(1239),
    [aux_sym_type_qualifier_token5] = ACTIONS(1239),
    [aux_sym_type_qualifier_token9] = ACTIONS(1239),
    [aux_sym_type_qualifier_token10] = ACTIONS(1239),
    [aux_sym_type_qualifier_token11] = ACTIONS(1239),
    [aux_sym_type_qualifier_token12] = ACTIONS(1239),
    [aux_sym_type_qualifier_token13] = ACTIONS(1239),
    [aux_sym_type_qualifier_token14] = ACTIONS(1239),
    [aux_sym_type_qualifier_token15] = ACTIONS(1239),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1239),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1239),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1239),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1239),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1239),
    [aux_sym_stop_statement_token1] = ACTIONS(1239),
    [aux_sym_stop_statement_token2] = ACTIONS(1239),
    [aux_sym_subroutine_call_token1] = ACTIONS(1239),
    [aux_sym_keyword_statement_token1] = ACTIONS(1239),
    [aux_sym_keyword_statement_token2] = ACTIONS(1239),
    [aux_sym_keyword_statement_token3] = ACTIONS(1239),
    [aux_sym_keyword_statement_token4] = ACTIONS(1239),
    [aux_sym_keyword_statement_token6] = ACTIONS(1239),
    [aux_sym_keyword_statement_token7] = ACTIONS(1239),
    [aux_sym_include_statement_token1] = ACTIONS(1239),
    [aux_sym_data_statement_token1] = ACTIONS(1239),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1239),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1239),
    [aux_sym_end_if_statement_token1] = ACTIONS(1239),
    [aux_sym_elseif_clause_token2] = ACTIONS(1239),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1239),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1239),
    [aux_sym_select_case_statement_token1] = ACTIONS(1239),
    [aux_sym_select_case_statement_token3] = ACTIONS(1239),
    [aux_sym_select_type_statement_token1] = ACTIONS(1239),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1239),
    [aux_sym_block_construct_token1] = ACTIONS(1239),
    [aux_sym_associate_statement_token1] = ACTIONS(1239),
    [aux_sym_format_statement_token1] = ACTIONS(1239),
    [aux_sym_print_statement_token1] = ACTIONS(1239),
    [aux_sym_open_statement_token1] = ACTIONS(1239),
    [aux_sym_close_statement_token1] = ACTIONS(1239),
    [aux_sym_inquire_statement_token1] = ACTIONS(1239),
    [aux_sym_enum_statement_token1] = ACTIONS(1239),
    [aux_sym_file_position_statement_token1] = ACTIONS(1239),
    [aux_sym_file_position_statement_token2] = ACTIONS(1239),
    [aux_sym_file_position_statement_token3] = ACTIONS(1239),
    [aux_sym_file_position_statement_token4] = ACTIONS(1239),
    [aux_sym_logical_expression_token5] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [sym_boolean_literal] = ACTIONS(1237),
    [aux_sym_null_literal_token1] = ACTIONS(1239),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1239),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1237),
    [sym__float_literal] = ACTIONS(1237),
    [sym__boz_literal] = ACTIONS(1237),
    [sym_string_literal] = ACTIONS(1237),
  },
  [274] = {
    [sym_preproc_file_line] = STATE(274),
    [ts_builtin_sym_end] = ACTIONS(1241),
    [aux_sym_program_statement_token1] = ACTIONS(1243),
    [aux_sym_end_program_statement_token1] = ACTIONS(1243),
    [aux_sym_end_program_statement_token2] = ACTIONS(1243),
    [aux_sym_module_statement_token1] = ACTIONS(1243),
    [aux_sym_submodule_statement_token1] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1243),
    [aux_sym_interface_statement_token1] = ACTIONS(1243),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1243),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1243),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1243),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1243),
    [aux_sym_function_statement_token1] = ACTIONS(1243),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1243),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1243),
    [aux_sym_contains_statement_token1] = ACTIONS(1243),
    [aux_sym_use_statement_token1] = ACTIONS(1243),
    [aux_sym_use_statement_token2] = ACTIONS(1243),
    [aux_sym_implicit_statement_token1] = ACTIONS(1243),
    [aux_sym_implicit_statement_token3] = ACTIONS(1243),
    [aux_sym_implicit_statement_token4] = ACTIONS(1243),
    [aux_sym_save_statement_token1] = ACTIONS(1243),
    [aux_sym_private_statement_token1] = ACTIONS(1243),
    [aux_sym_public_statement_token1] = ACTIONS(1243),
    [aux_sym_namelist_statement_token1] = ACTIONS(1243),
    [aux_sym_common_statement_token1] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [aux_sym_import_statement_token1] = ACTIONS(1243),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1243),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1243),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1243),
    [aux_sym_variable_attributes_token1] = ACTIONS(1243),
    [aux_sym_variable_attributes_token2] = ACTIONS(1243),
    [aux_sym_variable_attributes_token3] = ACTIONS(1243),
    [aux_sym_variable_attributes_token4] = ACTIONS(1243),
    [aux_sym_variable_attributes_token5] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1243),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1243),
    [aux_sym_derived_type_token1] = ACTIONS(1243),
    [aux_sym_type_qualifier_token1] = ACTIONS(1243),
    [aux_sym_type_qualifier_token2] = ACTIONS(1243),
    [aux_sym_type_qualifier_token3] = ACTIONS(1243),
    [aux_sym_type_qualifier_token4] = ACTIONS(1243),
    [aux_sym_type_qualifier_token5] = ACTIONS(1243),
    [aux_sym_type_qualifier_token9] = ACTIONS(1243),
    [aux_sym_type_qualifier_token10] = ACTIONS(1243),
    [aux_sym_type_qualifier_token11] = ACTIONS(1243),
    [aux_sym_type_qualifier_token12] = ACTIONS(1243),
    [aux_sym_type_qualifier_token13] = ACTIONS(1243),
    [aux_sym_type_qualifier_token14] = ACTIONS(1243),
    [aux_sym_type_qualifier_token15] = ACTIONS(1243),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1243),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1243),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1243),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1243),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1243),
    [aux_sym_stop_statement_token1] = ACTIONS(1243),
    [aux_sym_stop_statement_token2] = ACTIONS(1243),
    [aux_sym_subroutine_call_token1] = ACTIONS(1243),
    [aux_sym_keyword_statement_token1] = ACTIONS(1243),
    [aux_sym_keyword_statement_token2] = ACTIONS(1243),
    [aux_sym_keyword_statement_token3] = ACTIONS(1243),
    [aux_sym_keyword_statement_token4] = ACTIONS(1243),
    [aux_sym_keyword_statement_token6] = ACTIONS(1243),
    [aux_sym_keyword_statement_token7] = ACTIONS(1243),
    [aux_sym_include_statement_token1] = ACTIONS(1243),
    [aux_sym_data_statement_token1] = ACTIONS(1243),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1243),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1243),
    [aux_sym_end_if_statement_token1] = ACTIONS(1243),
    [aux_sym_elseif_clause_token2] = ACTIONS(1243),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1243),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1243),
    [aux_sym_select_case_statement_token1] = ACTIONS(1243),
    [aux_sym_select_case_statement_token3] = ACTIONS(1243),
    [aux_sym_select_type_statement_token1] = ACTIONS(1243),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1243),
    [aux_sym_block_construct_token1] = ACTIONS(1243),
    [aux_sym_associate_statement_token1] = ACTIONS(1243),
    [aux_sym_format_statement_token1] = ACTIONS(1243),
    [aux_sym_print_statement_token1] = ACTIONS(1243),
    [aux_sym_open_statement_token1] = ACTIONS(1243),
    [aux_sym_close_statement_token1] = ACTIONS(1243),
    [aux_sym_inquire_statement_token1] = ACTIONS(1243),
    [aux_sym_enum_statement_token1] = ACTIONS(1243),
    [aux_sym_file_position_statement_token1] = ACTIONS(1243),
    [aux_sym_file_position_statement_token2] = ACTIONS(1243),
    [aux_sym_file_position_statement_token3] = ACTIONS(1243),
    [aux_sym_file_position_statement_token4] = ACTIONS(1243),
    [aux_sym_logical_expression_token5] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [sym_boolean_literal] = ACTIONS(1241),
    [aux_sym_null_literal_token1] = ACTIONS(1243),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1243),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1241),
    [sym__float_literal] = ACTIONS(1241),
    [sym__boz_literal] = ACTIONS(1241),
    [sym_string_literal] = ACTIONS(1241),
  },
  [275] = {
    [sym_preproc_file_line] = STATE(275),
    [ts_builtin_sym_end] = ACTIONS(1245),
    [aux_sym_program_statement_token1] = ACTIONS(1247),
    [aux_sym_end_program_statement_token1] = ACTIONS(1247),
    [aux_sym_end_program_statement_token2] = ACTIONS(1247),
    [aux_sym_module_statement_token1] = ACTIONS(1247),
    [aux_sym_submodule_statement_token1] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [aux_sym_interface_statement_token1] = ACTIONS(1247),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1247),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1247),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1247),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1247),
    [aux_sym_function_statement_token1] = ACTIONS(1247),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1247),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1247),
    [aux_sym_contains_statement_token1] = ACTIONS(1247),
    [aux_sym_use_statement_token1] = ACTIONS(1247),
    [aux_sym_use_statement_token2] = ACTIONS(1247),
    [aux_sym_implicit_statement_token1] = ACTIONS(1247),
    [aux_sym_implicit_statement_token3] = ACTIONS(1247),
    [aux_sym_implicit_statement_token4] = ACTIONS(1247),
    [aux_sym_save_statement_token1] = ACTIONS(1247),
    [aux_sym_private_statement_token1] = ACTIONS(1247),
    [aux_sym_public_statement_token1] = ACTIONS(1247),
    [aux_sym_namelist_statement_token1] = ACTIONS(1247),
    [aux_sym_common_statement_token1] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [aux_sym_import_statement_token1] = ACTIONS(1247),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1247),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1247),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1247),
    [aux_sym_variable_attributes_token1] = ACTIONS(1247),
    [aux_sym_variable_attributes_token2] = ACTIONS(1247),
    [aux_sym_variable_attributes_token3] = ACTIONS(1247),
    [aux_sym_variable_attributes_token4] = ACTIONS(1247),
    [aux_sym_variable_attributes_token5] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1247),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1247),
    [aux_sym_derived_type_token1] = ACTIONS(1247),
    [aux_sym_type_qualifier_token1] = ACTIONS(1247),
    [aux_sym_type_qualifier_token2] = ACTIONS(1247),
    [aux_sym_type_qualifier_token3] = ACTIONS(1247),
    [aux_sym_type_qualifier_token4] = ACTIONS(1247),
    [aux_sym_type_qualifier_token5] = ACTIONS(1247),
    [aux_sym_type_qualifier_token9] = ACTIONS(1247),
    [aux_sym_type_qualifier_token10] = ACTIONS(1247),
    [aux_sym_type_qualifier_token11] = ACTIONS(1247),
    [aux_sym_type_qualifier_token12] = ACTIONS(1247),
    [aux_sym_type_qualifier_token13] = ACTIONS(1247),
    [aux_sym_type_qualifier_token14] = ACTIONS(1247),
    [aux_sym_type_qualifier_token15] = ACTIONS(1247),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1247),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1247),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1247),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1247),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1247),
    [aux_sym_stop_statement_token1] = ACTIONS(1247),
    [aux_sym_stop_statement_token2] = ACTIONS(1247),
    [aux_sym_subroutine_call_token1] = ACTIONS(1247),
    [aux_sym_keyword_statement_token1] = ACTIONS(1247),
    [aux_sym_keyword_statement_token2] = ACTIONS(1247),
    [aux_sym_keyword_statement_token3] = ACTIONS(1247),
    [aux_sym_keyword_statement_token4] = ACTIONS(1247),
    [aux_sym_keyword_statement_token6] = ACTIONS(1247),
    [aux_sym_keyword_statement_token7] = ACTIONS(1247),
    [aux_sym_include_statement_token1] = ACTIONS(1247),
    [aux_sym_data_statement_token1] = ACTIONS(1247),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1247),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1247),
    [aux_sym_end_if_statement_token1] = ACTIONS(1247),
    [aux_sym_elseif_clause_token2] = ACTIONS(1247),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1247),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1247),
    [aux_sym_select_case_statement_token1] = ACTIONS(1247),
    [aux_sym_select_case_statement_token3] = ACTIONS(1247),
    [aux_sym_select_type_statement_token1] = ACTIONS(1247),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1247),
    [aux_sym_block_construct_token1] = ACTIONS(1247),
    [aux_sym_associate_statement_token1] = ACTIONS(1247),
    [aux_sym_format_statement_token1] = ACTIONS(1247),
    [aux_sym_print_statement_token1] = ACTIONS(1247),
    [aux_sym_open_statement_token1] = ACTIONS(1247),
    [aux_sym_close_statement_token1] = ACTIONS(1247),
    [aux_sym_inquire_statement_token1] = ACTIONS(1247),
    [aux_sym_enum_statement_token1] = ACTIONS(1247),
    [aux_sym_file_position_statement_token1] = ACTIONS(1247),
    [aux_sym_file_position_statement_token2] = ACTIONS(1247),
    [aux_sym_file_position_statement_token3] = ACTIONS(1247),
    [aux_sym_file_position_statement_token4] = ACTIONS(1247),
    [aux_sym_logical_expression_token5] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1245),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [sym_boolean_literal] = ACTIONS(1245),
    [aux_sym_null_literal_token1] = ACTIONS(1247),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1247),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1245),
    [sym__float_literal] = ACTIONS(1245),
    [sym__boz_literal] = ACTIONS(1245),
    [sym_string_literal] = ACTIONS(1245),
  },
  [276] = {
    [sym_preproc_file_line] = STATE(276),
    [ts_builtin_sym_end] = ACTIONS(1249),
    [aux_sym_program_statement_token1] = ACTIONS(1251),
    [aux_sym_end_program_statement_token1] = ACTIONS(1251),
    [aux_sym_end_program_statement_token2] = ACTIONS(1251),
    [aux_sym_module_statement_token1] = ACTIONS(1251),
    [aux_sym_submodule_statement_token1] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [aux_sym_interface_statement_token1] = ACTIONS(1251),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1251),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1251),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1251),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1251),
    [aux_sym_function_statement_token1] = ACTIONS(1251),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1251),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1251),
    [aux_sym_contains_statement_token1] = ACTIONS(1251),
    [aux_sym_use_statement_token1] = ACTIONS(1251),
    [aux_sym_use_statement_token2] = ACTIONS(1251),
    [aux_sym_implicit_statement_token1] = ACTIONS(1251),
    [aux_sym_implicit_statement_token3] = ACTIONS(1251),
    [aux_sym_implicit_statement_token4] = ACTIONS(1251),
    [aux_sym_save_statement_token1] = ACTIONS(1251),
    [aux_sym_private_statement_token1] = ACTIONS(1251),
    [aux_sym_public_statement_token1] = ACTIONS(1251),
    [aux_sym_namelist_statement_token1] = ACTIONS(1251),
    [aux_sym_common_statement_token1] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [aux_sym_import_statement_token1] = ACTIONS(1251),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1251),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1251),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1251),
    [aux_sym_variable_attributes_token1] = ACTIONS(1251),
    [aux_sym_variable_attributes_token2] = ACTIONS(1251),
    [aux_sym_variable_attributes_token3] = ACTIONS(1251),
    [aux_sym_variable_attributes_token4] = ACTIONS(1251),
    [aux_sym_variable_attributes_token5] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1251),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1251),
    [aux_sym_derived_type_token1] = ACTIONS(1251),
    [aux_sym_type_qualifier_token1] = ACTIONS(1251),
    [aux_sym_type_qualifier_token2] = ACTIONS(1251),
    [aux_sym_type_qualifier_token3] = ACTIONS(1251),
    [aux_sym_type_qualifier_token4] = ACTIONS(1251),
    [aux_sym_type_qualifier_token5] = ACTIONS(1251),
    [aux_sym_type_qualifier_token9] = ACTIONS(1251),
    [aux_sym_type_qualifier_token10] = ACTIONS(1251),
    [aux_sym_type_qualifier_token11] = ACTIONS(1251),
    [aux_sym_type_qualifier_token12] = ACTIONS(1251),
    [aux_sym_type_qualifier_token13] = ACTIONS(1251),
    [aux_sym_type_qualifier_token14] = ACTIONS(1251),
    [aux_sym_type_qualifier_token15] = ACTIONS(1251),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1251),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1251),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1251),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1251),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1251),
    [aux_sym_stop_statement_token1] = ACTIONS(1251),
    [aux_sym_stop_statement_token2] = ACTIONS(1251),
    [aux_sym_subroutine_call_token1] = ACTIONS(1251),
    [aux_sym_keyword_statement_token1] = ACTIONS(1251),
    [aux_sym_keyword_statement_token2] = ACTIONS(1251),
    [aux_sym_keyword_statement_token3] = ACTIONS(1251),
    [aux_sym_keyword_statement_token4] = ACTIONS(1251),
    [aux_sym_keyword_statement_token6] = ACTIONS(1251),
    [aux_sym_keyword_statement_token7] = ACTIONS(1251),
    [aux_sym_include_statement_token1] = ACTIONS(1251),
    [aux_sym_data_statement_token1] = ACTIONS(1251),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1251),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1251),
    [aux_sym_end_if_statement_token1] = ACTIONS(1251),
    [aux_sym_elseif_clause_token2] = ACTIONS(1251),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1251),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1251),
    [aux_sym_select_case_statement_token1] = ACTIONS(1251),
    [aux_sym_select_case_statement_token3] = ACTIONS(1251),
    [aux_sym_select_type_statement_token1] = ACTIONS(1251),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1251),
    [aux_sym_block_construct_token1] = ACTIONS(1251),
    [aux_sym_associate_statement_token1] = ACTIONS(1251),
    [aux_sym_format_statement_token1] = ACTIONS(1251),
    [aux_sym_print_statement_token1] = ACTIONS(1251),
    [aux_sym_open_statement_token1] = ACTIONS(1251),
    [aux_sym_close_statement_token1] = ACTIONS(1251),
    [aux_sym_inquire_statement_token1] = ACTIONS(1251),
    [aux_sym_enum_statement_token1] = ACTIONS(1251),
    [aux_sym_file_position_statement_token1] = ACTIONS(1251),
    [aux_sym_file_position_statement_token2] = ACTIONS(1251),
    [aux_sym_file_position_statement_token3] = ACTIONS(1251),
    [aux_sym_file_position_statement_token4] = ACTIONS(1251),
    [aux_sym_logical_expression_token5] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1249),
    [sym_boolean_literal] = ACTIONS(1249),
    [aux_sym_null_literal_token1] = ACTIONS(1251),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1251),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1249),
    [sym__float_literal] = ACTIONS(1249),
    [sym__boz_literal] = ACTIONS(1249),
    [sym_string_literal] = ACTIONS(1249),
  },
  [277] = {
    [sym_preproc_file_line] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(1253),
    [aux_sym_program_statement_token1] = ACTIONS(1255),
    [aux_sym_end_program_statement_token1] = ACTIONS(1255),
    [aux_sym_end_program_statement_token2] = ACTIONS(1255),
    [aux_sym_module_statement_token1] = ACTIONS(1255),
    [aux_sym_submodule_statement_token1] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [aux_sym_interface_statement_token1] = ACTIONS(1255),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1255),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1255),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1255),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1255),
    [aux_sym_function_statement_token1] = ACTIONS(1255),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1255),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1255),
    [aux_sym_contains_statement_token1] = ACTIONS(1255),
    [aux_sym_use_statement_token1] = ACTIONS(1255),
    [aux_sym_use_statement_token2] = ACTIONS(1255),
    [aux_sym_implicit_statement_token1] = ACTIONS(1255),
    [aux_sym_implicit_statement_token3] = ACTIONS(1255),
    [aux_sym_implicit_statement_token4] = ACTIONS(1255),
    [aux_sym_save_statement_token1] = ACTIONS(1255),
    [aux_sym_private_statement_token1] = ACTIONS(1255),
    [aux_sym_public_statement_token1] = ACTIONS(1255),
    [aux_sym_namelist_statement_token1] = ACTIONS(1255),
    [aux_sym_common_statement_token1] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [aux_sym_import_statement_token1] = ACTIONS(1255),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1255),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1255),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1255),
    [aux_sym_variable_attributes_token1] = ACTIONS(1255),
    [aux_sym_variable_attributes_token2] = ACTIONS(1255),
    [aux_sym_variable_attributes_token3] = ACTIONS(1255),
    [aux_sym_variable_attributes_token4] = ACTIONS(1255),
    [aux_sym_variable_attributes_token5] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1255),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1255),
    [aux_sym_derived_type_token1] = ACTIONS(1255),
    [aux_sym_type_qualifier_token1] = ACTIONS(1255),
    [aux_sym_type_qualifier_token2] = ACTIONS(1255),
    [aux_sym_type_qualifier_token3] = ACTIONS(1255),
    [aux_sym_type_qualifier_token4] = ACTIONS(1255),
    [aux_sym_type_qualifier_token5] = ACTIONS(1255),
    [aux_sym_type_qualifier_token9] = ACTIONS(1255),
    [aux_sym_type_qualifier_token10] = ACTIONS(1255),
    [aux_sym_type_qualifier_token11] = ACTIONS(1255),
    [aux_sym_type_qualifier_token12] = ACTIONS(1255),
    [aux_sym_type_qualifier_token13] = ACTIONS(1255),
    [aux_sym_type_qualifier_token14] = ACTIONS(1255),
    [aux_sym_type_qualifier_token15] = ACTIONS(1255),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1255),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1255),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1255),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1255),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1255),
    [aux_sym_stop_statement_token1] = ACTIONS(1255),
    [aux_sym_stop_statement_token2] = ACTIONS(1255),
    [aux_sym_subroutine_call_token1] = ACTIONS(1255),
    [aux_sym_keyword_statement_token1] = ACTIONS(1255),
    [aux_sym_keyword_statement_token2] = ACTIONS(1255),
    [aux_sym_keyword_statement_token3] = ACTIONS(1255),
    [aux_sym_keyword_statement_token4] = ACTIONS(1255),
    [aux_sym_keyword_statement_token6] = ACTIONS(1255),
    [aux_sym_keyword_statement_token7] = ACTIONS(1255),
    [aux_sym_include_statement_token1] = ACTIONS(1255),
    [aux_sym_data_statement_token1] = ACTIONS(1255),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1255),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1255),
    [aux_sym_end_if_statement_token1] = ACTIONS(1255),
    [aux_sym_elseif_clause_token2] = ACTIONS(1255),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1255),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1255),
    [aux_sym_select_case_statement_token1] = ACTIONS(1255),
    [aux_sym_select_case_statement_token3] = ACTIONS(1255),
    [aux_sym_select_type_statement_token1] = ACTIONS(1255),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1255),
    [aux_sym_block_construct_token1] = ACTIONS(1255),
    [aux_sym_associate_statement_token1] = ACTIONS(1255),
    [aux_sym_format_statement_token1] = ACTIONS(1255),
    [aux_sym_print_statement_token1] = ACTIONS(1255),
    [aux_sym_open_statement_token1] = ACTIONS(1255),
    [aux_sym_close_statement_token1] = ACTIONS(1255),
    [aux_sym_inquire_statement_token1] = ACTIONS(1255),
    [aux_sym_enum_statement_token1] = ACTIONS(1255),
    [aux_sym_file_position_statement_token1] = ACTIONS(1255),
    [aux_sym_file_position_statement_token2] = ACTIONS(1255),
    [aux_sym_file_position_statement_token3] = ACTIONS(1255),
    [aux_sym_file_position_statement_token4] = ACTIONS(1255),
    [aux_sym_logical_expression_token5] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [sym_boolean_literal] = ACTIONS(1253),
    [aux_sym_null_literal_token1] = ACTIONS(1255),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1255),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1253),
    [sym__float_literal] = ACTIONS(1253),
    [sym__boz_literal] = ACTIONS(1253),
    [sym_string_literal] = ACTIONS(1253),
  },
  [278] = {
    [sym_preproc_file_line] = STATE(278),
    [ts_builtin_sym_end] = ACTIONS(159),
    [aux_sym_program_statement_token1] = ACTIONS(1257),
    [aux_sym_end_program_statement_token1] = ACTIONS(1257),
    [aux_sym_end_program_statement_token2] = ACTIONS(1257),
    [aux_sym_module_statement_token1] = ACTIONS(1257),
    [aux_sym_submodule_statement_token1] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [aux_sym_interface_statement_token1] = ACTIONS(1257),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1257),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1257),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1257),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1257),
    [aux_sym_function_statement_token1] = ACTIONS(1257),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1257),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1257),
    [aux_sym_contains_statement_token1] = ACTIONS(1257),
    [aux_sym_use_statement_token1] = ACTIONS(1257),
    [aux_sym_use_statement_token2] = ACTIONS(1257),
    [aux_sym_implicit_statement_token1] = ACTIONS(1257),
    [aux_sym_implicit_statement_token3] = ACTIONS(1257),
    [aux_sym_implicit_statement_token4] = ACTIONS(1257),
    [aux_sym_save_statement_token1] = ACTIONS(1257),
    [aux_sym_private_statement_token1] = ACTIONS(1257),
    [aux_sym_public_statement_token1] = ACTIONS(1257),
    [aux_sym_namelist_statement_token1] = ACTIONS(1257),
    [aux_sym_common_statement_token1] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(159),
    [aux_sym_import_statement_token1] = ACTIONS(1257),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1257),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1257),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1257),
    [aux_sym_variable_attributes_token1] = ACTIONS(1257),
    [aux_sym_variable_attributes_token2] = ACTIONS(1257),
    [aux_sym_variable_attributes_token3] = ACTIONS(1257),
    [aux_sym_variable_attributes_token4] = ACTIONS(1257),
    [aux_sym_variable_attributes_token5] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1257),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1257),
    [aux_sym_derived_type_token1] = ACTIONS(1257),
    [aux_sym_type_qualifier_token1] = ACTIONS(1257),
    [aux_sym_type_qualifier_token2] = ACTIONS(1257),
    [aux_sym_type_qualifier_token3] = ACTIONS(1257),
    [aux_sym_type_qualifier_token4] = ACTIONS(1257),
    [aux_sym_type_qualifier_token5] = ACTIONS(1257),
    [aux_sym_type_qualifier_token9] = ACTIONS(1257),
    [aux_sym_type_qualifier_token10] = ACTIONS(1257),
    [aux_sym_type_qualifier_token11] = ACTIONS(1257),
    [aux_sym_type_qualifier_token12] = ACTIONS(1257),
    [aux_sym_type_qualifier_token13] = ACTIONS(1257),
    [aux_sym_type_qualifier_token14] = ACTIONS(1257),
    [aux_sym_type_qualifier_token15] = ACTIONS(1257),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1257),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1257),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1257),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1257),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1257),
    [aux_sym_stop_statement_token1] = ACTIONS(1257),
    [aux_sym_stop_statement_token2] = ACTIONS(1257),
    [aux_sym_subroutine_call_token1] = ACTIONS(1257),
    [aux_sym_keyword_statement_token1] = ACTIONS(1257),
    [aux_sym_keyword_statement_token2] = ACTIONS(1257),
    [aux_sym_keyword_statement_token3] = ACTIONS(1257),
    [aux_sym_keyword_statement_token4] = ACTIONS(1257),
    [aux_sym_keyword_statement_token6] = ACTIONS(1257),
    [aux_sym_keyword_statement_token7] = ACTIONS(1257),
    [aux_sym_include_statement_token1] = ACTIONS(1257),
    [aux_sym_data_statement_token1] = ACTIONS(1257),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1257),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1257),
    [aux_sym_end_if_statement_token1] = ACTIONS(1257),
    [aux_sym_elseif_clause_token2] = ACTIONS(1257),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1257),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1257),
    [aux_sym_select_case_statement_token1] = ACTIONS(1257),
    [aux_sym_select_case_statement_token3] = ACTIONS(1257),
    [aux_sym_select_type_statement_token1] = ACTIONS(1257),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1257),
    [aux_sym_block_construct_token1] = ACTIONS(1257),
    [aux_sym_associate_statement_token1] = ACTIONS(1257),
    [aux_sym_format_statement_token1] = ACTIONS(1257),
    [aux_sym_print_statement_token1] = ACTIONS(1257),
    [aux_sym_open_statement_token1] = ACTIONS(1257),
    [aux_sym_close_statement_token1] = ACTIONS(1257),
    [aux_sym_inquire_statement_token1] = ACTIONS(1257),
    [aux_sym_enum_statement_token1] = ACTIONS(1257),
    [aux_sym_file_position_statement_token1] = ACTIONS(1257),
    [aux_sym_file_position_statement_token2] = ACTIONS(1257),
    [aux_sym_file_position_statement_token3] = ACTIONS(1257),
    [aux_sym_file_position_statement_token4] = ACTIONS(1257),
    [aux_sym_logical_expression_token5] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_LPAREN_SLASH] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(159),
    [sym_boolean_literal] = ACTIONS(159),
    [aux_sym_null_literal_token1] = ACTIONS(1257),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1257),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(159),
    [sym__float_literal] = ACTIONS(159),
    [sym__boz_literal] = ACTIONS(159),
    [sym_string_literal] = ACTIONS(159),
  },
  [279] = {
    [sym_preproc_file_line] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(1181),
    [aux_sym_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token2] = ACTIONS(1183),
    [aux_sym_module_statement_token1] = ACTIONS(1183),
    [aux_sym_submodule_statement_token1] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [aux_sym_interface_statement_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1183),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1183),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1183),
    [aux_sym_function_statement_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1183),
    [aux_sym_contains_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token2] = ACTIONS(1183),
    [aux_sym_implicit_statement_token1] = ACTIONS(1183),
    [aux_sym_implicit_statement_token3] = ACTIONS(1183),
    [aux_sym_implicit_statement_token4] = ACTIONS(1183),
    [aux_sym_save_statement_token1] = ACTIONS(1183),
    [aux_sym_private_statement_token1] = ACTIONS(1183),
    [aux_sym_public_statement_token1] = ACTIONS(1183),
    [aux_sym_namelist_statement_token1] = ACTIONS(1183),
    [aux_sym_common_statement_token1] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [aux_sym_import_statement_token1] = ACTIONS(1183),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1183),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1183),
    [aux_sym_variable_attributes_token1] = ACTIONS(1183),
    [aux_sym_variable_attributes_token2] = ACTIONS(1183),
    [aux_sym_variable_attributes_token3] = ACTIONS(1183),
    [aux_sym_variable_attributes_token4] = ACTIONS(1183),
    [aux_sym_variable_attributes_token5] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1183),
    [aux_sym_derived_type_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token2] = ACTIONS(1183),
    [aux_sym_type_qualifier_token3] = ACTIONS(1183),
    [aux_sym_type_qualifier_token4] = ACTIONS(1183),
    [aux_sym_type_qualifier_token5] = ACTIONS(1183),
    [aux_sym_type_qualifier_token9] = ACTIONS(1183),
    [aux_sym_type_qualifier_token10] = ACTIONS(1183),
    [aux_sym_type_qualifier_token11] = ACTIONS(1183),
    [aux_sym_type_qualifier_token12] = ACTIONS(1183),
    [aux_sym_type_qualifier_token13] = ACTIONS(1183),
    [aux_sym_type_qualifier_token14] = ACTIONS(1183),
    [aux_sym_type_qualifier_token15] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1183),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token2] = ACTIONS(1183),
    [aux_sym_subroutine_call_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token2] = ACTIONS(1183),
    [aux_sym_keyword_statement_token3] = ACTIONS(1183),
    [aux_sym_keyword_statement_token4] = ACTIONS(1183),
    [aux_sym_keyword_statement_token6] = ACTIONS(1183),
    [aux_sym_keyword_statement_token7] = ACTIONS(1183),
    [aux_sym_include_statement_token1] = ACTIONS(1183),
    [aux_sym_data_statement_token1] = ACTIONS(1183),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1183),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1183),
    [aux_sym_end_if_statement_token1] = ACTIONS(1183),
    [aux_sym_elseif_clause_token2] = ACTIONS(1183),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1183),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token3] = ACTIONS(1183),
    [aux_sym_select_type_statement_token1] = ACTIONS(1183),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1183),
    [aux_sym_block_construct_token1] = ACTIONS(1183),
    [aux_sym_associate_statement_token1] = ACTIONS(1183),
    [aux_sym_format_statement_token1] = ACTIONS(1183),
    [aux_sym_print_statement_token1] = ACTIONS(1183),
    [aux_sym_open_statement_token1] = ACTIONS(1183),
    [aux_sym_close_statement_token1] = ACTIONS(1183),
    [aux_sym_inquire_statement_token1] = ACTIONS(1183),
    [aux_sym_enum_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token2] = ACTIONS(1183),
    [aux_sym_file_position_statement_token3] = ACTIONS(1183),
    [aux_sym_file_position_statement_token4] = ACTIONS(1183),
    [aux_sym_logical_expression_token5] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [sym_boolean_literal] = ACTIONS(1181),
    [aux_sym_null_literal_token1] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1183),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1181),
    [sym__float_literal] = ACTIONS(1181),
    [sym__boz_literal] = ACTIONS(1181),
    [sym_string_literal] = ACTIONS(1181),
  },
  [280] = {
    [sym__statements] = STATE(2398),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(280),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [281] = {
    [sym_preproc_file_line] = STATE(281),
    [ts_builtin_sym_end] = ACTIONS(1259),
    [aux_sym_program_statement_token1] = ACTIONS(1261),
    [aux_sym_end_program_statement_token1] = ACTIONS(1261),
    [aux_sym_end_program_statement_token2] = ACTIONS(1261),
    [aux_sym_module_statement_token1] = ACTIONS(1261),
    [aux_sym_submodule_statement_token1] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [aux_sym_interface_statement_token1] = ACTIONS(1261),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1261),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1261),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1261),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1261),
    [aux_sym_function_statement_token1] = ACTIONS(1261),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1261),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1261),
    [aux_sym_contains_statement_token1] = ACTIONS(1261),
    [aux_sym_use_statement_token1] = ACTIONS(1261),
    [aux_sym_use_statement_token2] = ACTIONS(1261),
    [aux_sym_implicit_statement_token1] = ACTIONS(1261),
    [aux_sym_implicit_statement_token3] = ACTIONS(1261),
    [aux_sym_implicit_statement_token4] = ACTIONS(1261),
    [aux_sym_save_statement_token1] = ACTIONS(1261),
    [aux_sym_private_statement_token1] = ACTIONS(1261),
    [aux_sym_public_statement_token1] = ACTIONS(1261),
    [aux_sym_namelist_statement_token1] = ACTIONS(1261),
    [aux_sym_common_statement_token1] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1259),
    [aux_sym_import_statement_token1] = ACTIONS(1261),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1261),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1261),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1261),
    [aux_sym_variable_attributes_token1] = ACTIONS(1261),
    [aux_sym_variable_attributes_token2] = ACTIONS(1261),
    [aux_sym_variable_attributes_token3] = ACTIONS(1261),
    [aux_sym_variable_attributes_token4] = ACTIONS(1261),
    [aux_sym_variable_attributes_token5] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1261),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1261),
    [aux_sym_derived_type_token1] = ACTIONS(1261),
    [aux_sym_type_qualifier_token1] = ACTIONS(1261),
    [aux_sym_type_qualifier_token2] = ACTIONS(1261),
    [aux_sym_type_qualifier_token3] = ACTIONS(1261),
    [aux_sym_type_qualifier_token4] = ACTIONS(1261),
    [aux_sym_type_qualifier_token5] = ACTIONS(1261),
    [aux_sym_type_qualifier_token9] = ACTIONS(1261),
    [aux_sym_type_qualifier_token10] = ACTIONS(1261),
    [aux_sym_type_qualifier_token11] = ACTIONS(1261),
    [aux_sym_type_qualifier_token12] = ACTIONS(1261),
    [aux_sym_type_qualifier_token13] = ACTIONS(1261),
    [aux_sym_type_qualifier_token14] = ACTIONS(1261),
    [aux_sym_type_qualifier_token15] = ACTIONS(1261),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1261),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1261),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1261),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1261),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1261),
    [aux_sym_stop_statement_token1] = ACTIONS(1261),
    [aux_sym_stop_statement_token2] = ACTIONS(1261),
    [aux_sym_subroutine_call_token1] = ACTIONS(1261),
    [aux_sym_keyword_statement_token1] = ACTIONS(1261),
    [aux_sym_keyword_statement_token2] = ACTIONS(1261),
    [aux_sym_keyword_statement_token3] = ACTIONS(1261),
    [aux_sym_keyword_statement_token4] = ACTIONS(1261),
    [aux_sym_keyword_statement_token6] = ACTIONS(1261),
    [aux_sym_keyword_statement_token7] = ACTIONS(1261),
    [aux_sym_include_statement_token1] = ACTIONS(1261),
    [aux_sym_data_statement_token1] = ACTIONS(1261),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1261),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1261),
    [aux_sym_end_if_statement_token1] = ACTIONS(1261),
    [aux_sym_elseif_clause_token2] = ACTIONS(1261),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1261),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1261),
    [aux_sym_select_case_statement_token1] = ACTIONS(1261),
    [aux_sym_select_case_statement_token3] = ACTIONS(1261),
    [aux_sym_select_type_statement_token1] = ACTIONS(1261),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1261),
    [aux_sym_block_construct_token1] = ACTIONS(1261),
    [aux_sym_associate_statement_token1] = ACTIONS(1261),
    [aux_sym_format_statement_token1] = ACTIONS(1261),
    [aux_sym_print_statement_token1] = ACTIONS(1261),
    [aux_sym_open_statement_token1] = ACTIONS(1261),
    [aux_sym_close_statement_token1] = ACTIONS(1261),
    [aux_sym_inquire_statement_token1] = ACTIONS(1261),
    [aux_sym_enum_statement_token1] = ACTIONS(1261),
    [aux_sym_file_position_statement_token1] = ACTIONS(1261),
    [aux_sym_file_position_statement_token2] = ACTIONS(1261),
    [aux_sym_file_position_statement_token3] = ACTIONS(1261),
    [aux_sym_file_position_statement_token4] = ACTIONS(1261),
    [aux_sym_logical_expression_token5] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1261),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [sym_boolean_literal] = ACTIONS(1259),
    [aux_sym_null_literal_token1] = ACTIONS(1261),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1261),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1259),
    [sym__float_literal] = ACTIONS(1259),
    [sym__boz_literal] = ACTIONS(1259),
    [sym_string_literal] = ACTIONS(1259),
  },
  [282] = {
    [sym__statements] = STATE(2482),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(282),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [283] = {
    [sym_preproc_file_line] = STATE(283),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [aux_sym_program_statement_token1] = ACTIONS(1265),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [aux_sym_end_program_statement_token2] = ACTIONS(1265),
    [aux_sym_module_statement_token1] = ACTIONS(1265),
    [aux_sym_submodule_statement_token1] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_function_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_contains_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1265),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1265),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [284] = {
    [sym__statements] = STATE(2554),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(284),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [285] = {
    [sym_preproc_file_line] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(1267),
    [aux_sym_program_statement_token1] = ACTIONS(1269),
    [aux_sym_end_program_statement_token1] = ACTIONS(1269),
    [aux_sym_end_program_statement_token2] = ACTIONS(1269),
    [aux_sym_module_statement_token1] = ACTIONS(1269),
    [aux_sym_submodule_statement_token1] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [aux_sym_interface_statement_token1] = ACTIONS(1269),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1269),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1269),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1269),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1269),
    [aux_sym_function_statement_token1] = ACTIONS(1269),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1269),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1269),
    [aux_sym_contains_statement_token1] = ACTIONS(1269),
    [aux_sym_use_statement_token1] = ACTIONS(1269),
    [aux_sym_use_statement_token2] = ACTIONS(1269),
    [aux_sym_implicit_statement_token1] = ACTIONS(1269),
    [aux_sym_implicit_statement_token3] = ACTIONS(1269),
    [aux_sym_implicit_statement_token4] = ACTIONS(1269),
    [aux_sym_save_statement_token1] = ACTIONS(1269),
    [aux_sym_private_statement_token1] = ACTIONS(1269),
    [aux_sym_public_statement_token1] = ACTIONS(1269),
    [aux_sym_namelist_statement_token1] = ACTIONS(1269),
    [aux_sym_common_statement_token1] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(1267),
    [aux_sym_import_statement_token1] = ACTIONS(1269),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1269),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1269),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1269),
    [aux_sym_variable_attributes_token1] = ACTIONS(1269),
    [aux_sym_variable_attributes_token2] = ACTIONS(1269),
    [aux_sym_variable_attributes_token3] = ACTIONS(1269),
    [aux_sym_variable_attributes_token4] = ACTIONS(1269),
    [aux_sym_variable_attributes_token5] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1269),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1269),
    [aux_sym_derived_type_token1] = ACTIONS(1269),
    [aux_sym_type_qualifier_token1] = ACTIONS(1269),
    [aux_sym_type_qualifier_token2] = ACTIONS(1269),
    [aux_sym_type_qualifier_token3] = ACTIONS(1269),
    [aux_sym_type_qualifier_token4] = ACTIONS(1269),
    [aux_sym_type_qualifier_token5] = ACTIONS(1269),
    [aux_sym_type_qualifier_token9] = ACTIONS(1269),
    [aux_sym_type_qualifier_token10] = ACTIONS(1269),
    [aux_sym_type_qualifier_token11] = ACTIONS(1269),
    [aux_sym_type_qualifier_token12] = ACTIONS(1269),
    [aux_sym_type_qualifier_token13] = ACTIONS(1269),
    [aux_sym_type_qualifier_token14] = ACTIONS(1269),
    [aux_sym_type_qualifier_token15] = ACTIONS(1269),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1269),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1269),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1269),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1269),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1269),
    [aux_sym_stop_statement_token1] = ACTIONS(1269),
    [aux_sym_stop_statement_token2] = ACTIONS(1269),
    [aux_sym_subroutine_call_token1] = ACTIONS(1269),
    [aux_sym_keyword_statement_token1] = ACTIONS(1269),
    [aux_sym_keyword_statement_token2] = ACTIONS(1269),
    [aux_sym_keyword_statement_token3] = ACTIONS(1269),
    [aux_sym_keyword_statement_token4] = ACTIONS(1269),
    [aux_sym_keyword_statement_token6] = ACTIONS(1269),
    [aux_sym_keyword_statement_token7] = ACTIONS(1269),
    [aux_sym_include_statement_token1] = ACTIONS(1269),
    [aux_sym_data_statement_token1] = ACTIONS(1269),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1269),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1269),
    [aux_sym_end_if_statement_token1] = ACTIONS(1269),
    [aux_sym_elseif_clause_token2] = ACTIONS(1269),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1269),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1269),
    [aux_sym_select_case_statement_token1] = ACTIONS(1269),
    [aux_sym_select_case_statement_token3] = ACTIONS(1269),
    [aux_sym_select_type_statement_token1] = ACTIONS(1269),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1269),
    [aux_sym_block_construct_token1] = ACTIONS(1269),
    [aux_sym_associate_statement_token1] = ACTIONS(1269),
    [aux_sym_format_statement_token1] = ACTIONS(1269),
    [aux_sym_print_statement_token1] = ACTIONS(1269),
    [aux_sym_open_statement_token1] = ACTIONS(1269),
    [aux_sym_close_statement_token1] = ACTIONS(1269),
    [aux_sym_inquire_statement_token1] = ACTIONS(1269),
    [aux_sym_enum_statement_token1] = ACTIONS(1269),
    [aux_sym_file_position_statement_token1] = ACTIONS(1269),
    [aux_sym_file_position_statement_token2] = ACTIONS(1269),
    [aux_sym_file_position_statement_token3] = ACTIONS(1269),
    [aux_sym_file_position_statement_token4] = ACTIONS(1269),
    [aux_sym_logical_expression_token5] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1269),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [sym_boolean_literal] = ACTIONS(1267),
    [aux_sym_null_literal_token1] = ACTIONS(1269),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1269),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1267),
    [sym__float_literal] = ACTIONS(1267),
    [sym__boz_literal] = ACTIONS(1267),
    [sym_string_literal] = ACTIONS(1267),
  },
  [286] = {
    [sym__statements] = STATE(2624),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(286),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [287] = {
    [sym__statements] = STATE(2764),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(287),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [288] = {
    [sym_preproc_file_line] = STATE(288),
    [ts_builtin_sym_end] = ACTIONS(1181),
    [aux_sym_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token1] = ACTIONS(1183),
    [aux_sym_end_program_statement_token2] = ACTIONS(1183),
    [aux_sym_module_statement_token1] = ACTIONS(1183),
    [aux_sym_submodule_statement_token1] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [aux_sym_interface_statement_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1183),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1183),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1183),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1183),
    [aux_sym_function_statement_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1183),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1183),
    [aux_sym_contains_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token1] = ACTIONS(1183),
    [aux_sym_use_statement_token2] = ACTIONS(1183),
    [aux_sym_implicit_statement_token1] = ACTIONS(1183),
    [aux_sym_implicit_statement_token3] = ACTIONS(1183),
    [aux_sym_implicit_statement_token4] = ACTIONS(1183),
    [aux_sym_save_statement_token1] = ACTIONS(1183),
    [aux_sym_private_statement_token1] = ACTIONS(1183),
    [aux_sym_public_statement_token1] = ACTIONS(1183),
    [aux_sym_namelist_statement_token1] = ACTIONS(1183),
    [aux_sym_common_statement_token1] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1181),
    [aux_sym_import_statement_token1] = ACTIONS(1183),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1183),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1183),
    [aux_sym_variable_attributes_token1] = ACTIONS(1183),
    [aux_sym_variable_attributes_token2] = ACTIONS(1183),
    [aux_sym_variable_attributes_token3] = ACTIONS(1183),
    [aux_sym_variable_attributes_token4] = ACTIONS(1183),
    [aux_sym_variable_attributes_token5] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1183),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1183),
    [aux_sym_derived_type_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token1] = ACTIONS(1183),
    [aux_sym_type_qualifier_token2] = ACTIONS(1183),
    [aux_sym_type_qualifier_token3] = ACTIONS(1183),
    [aux_sym_type_qualifier_token4] = ACTIONS(1183),
    [aux_sym_type_qualifier_token5] = ACTIONS(1183),
    [aux_sym_type_qualifier_token9] = ACTIONS(1183),
    [aux_sym_type_qualifier_token10] = ACTIONS(1183),
    [aux_sym_type_qualifier_token11] = ACTIONS(1183),
    [aux_sym_type_qualifier_token12] = ACTIONS(1183),
    [aux_sym_type_qualifier_token13] = ACTIONS(1183),
    [aux_sym_type_qualifier_token14] = ACTIONS(1183),
    [aux_sym_type_qualifier_token15] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1183),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1183),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token1] = ACTIONS(1183),
    [aux_sym_stop_statement_token2] = ACTIONS(1183),
    [aux_sym_subroutine_call_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token1] = ACTIONS(1183),
    [aux_sym_keyword_statement_token2] = ACTIONS(1183),
    [aux_sym_keyword_statement_token3] = ACTIONS(1183),
    [aux_sym_keyword_statement_token4] = ACTIONS(1183),
    [aux_sym_keyword_statement_token6] = ACTIONS(1183),
    [aux_sym_keyword_statement_token7] = ACTIONS(1183),
    [aux_sym_include_statement_token1] = ACTIONS(1183),
    [aux_sym_data_statement_token1] = ACTIONS(1183),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1183),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1183),
    [aux_sym_end_if_statement_token1] = ACTIONS(1183),
    [aux_sym_elseif_clause_token2] = ACTIONS(1183),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1183),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token1] = ACTIONS(1183),
    [aux_sym_select_case_statement_token3] = ACTIONS(1183),
    [aux_sym_select_type_statement_token1] = ACTIONS(1183),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1183),
    [aux_sym_block_construct_token1] = ACTIONS(1183),
    [aux_sym_associate_statement_token1] = ACTIONS(1183),
    [aux_sym_format_statement_token1] = ACTIONS(1183),
    [aux_sym_print_statement_token1] = ACTIONS(1183),
    [aux_sym_open_statement_token1] = ACTIONS(1183),
    [aux_sym_close_statement_token1] = ACTIONS(1183),
    [aux_sym_inquire_statement_token1] = ACTIONS(1183),
    [aux_sym_enum_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token1] = ACTIONS(1183),
    [aux_sym_file_position_statement_token2] = ACTIONS(1183),
    [aux_sym_file_position_statement_token3] = ACTIONS(1183),
    [aux_sym_file_position_statement_token4] = ACTIONS(1183),
    [aux_sym_logical_expression_token5] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [sym_boolean_literal] = ACTIONS(1181),
    [aux_sym_null_literal_token1] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1183),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1181),
    [sym__float_literal] = ACTIONS(1181),
    [sym__boz_literal] = ACTIONS(1181),
    [sym_string_literal] = ACTIONS(1181),
  },
  [289] = {
    [sym__statements] = STATE(2762),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(289),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [290] = {
    [sym__statements] = STATE(2768),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(290),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [291] = {
    [sym__statements] = STATE(2739),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(291),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [292] = {
    [sym__statements] = STATE(2770),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(292),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [293] = {
    [sym__statements] = STATE(2772),
    [sym_stop_statement] = STATE(2667),
    [sym_assignment_statement] = STATE(2667),
    [sym_pointer_association_statement] = STATE(2667),
    [sym_subroutine_call] = STATE(2667),
    [sym_keyword_statement] = STATE(2667),
    [sym_include_statement] = STATE(2667),
    [sym_do_loop_statement] = STATE(2667),
    [sym_do_label_statement] = STATE(2667),
    [sym_if_statement] = STATE(2667),
    [sym__inline_if_statement] = STATE(2738),
    [sym_arithmetic_if_statement] = STATE(2667),
    [sym__block_if_statement] = STATE(2738),
    [sym_where_statement] = STATE(2667),
    [sym__inline_where_statement] = STATE(2755),
    [sym__block_where_statement] = STATE(2755),
    [sym_forall_statement] = STATE(2667),
    [sym__forall_control_expression] = STATE(222),
    [sym__inline_forall_statement] = STATE(2872),
    [sym__block_forall_statement] = STATE(2872),
    [sym_select_case_statement] = STATE(2667),
    [sym_select_type_statement] = STATE(2667),
    [sym_select_rank_statement] = STATE(2667),
    [sym_block_construct] = STATE(2667),
    [sym_associate_statement] = STATE(2667),
    [sym_format_statement] = STATE(2667),
    [sym_read_statement] = STATE(2667),
    [sym__simple_read_statement] = STATE(2366),
    [sym__parameterized_read_statement] = STATE(2366),
    [sym_print_statement] = STATE(2667),
    [sym_open_statement] = STATE(2667),
    [sym_close_statement] = STATE(2667),
    [sym_write_statement] = STATE(2667),
    [sym_inquire_statement] = STATE(2667),
    [sym_file_position_statement] = STATE(2667),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1138),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_block_label_start_expression] = STATE(1745),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(293),
    [sym_identifier] = STATE(1151),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(23),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(85),
    [aux_sym_stop_statement_token2] = ACTIONS(87),
    [aux_sym_subroutine_call_token1] = ACTIONS(89),
    [aux_sym_keyword_statement_token1] = ACTIONS(91),
    [aux_sym_keyword_statement_token2] = ACTIONS(93),
    [aux_sym_keyword_statement_token3] = ACTIONS(93),
    [aux_sym_keyword_statement_token4] = ACTIONS(95),
    [aux_sym_keyword_statement_token6] = ACTIONS(97),
    [aux_sym_keyword_statement_token7] = ACTIONS(91),
    [aux_sym_include_statement_token1] = ACTIONS(99),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym_do_loop_statement_token1] = ACTIONS(103),
    [aux_sym__inline_if_statement_token1] = ACTIONS(105),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym__inline_where_statement_token1] = ACTIONS(109),
    [aux_sym__forall_control_expression_token1] = ACTIONS(111),
    [aux_sym_select_case_statement_token1] = ACTIONS(113),
    [aux_sym_select_case_statement_token3] = ACTIONS(115),
    [aux_sym_select_type_statement_token1] = ACTIONS(117),
    [aux_sym_select_rank_statement_token2] = ACTIONS(119),
    [aux_sym_block_construct_token1] = ACTIONS(121),
    [aux_sym_associate_statement_token1] = ACTIONS(123),
    [aux_sym_format_statement_token1] = ACTIONS(125),
    [aux_sym_print_statement_token1] = ACTIONS(127),
    [aux_sym_open_statement_token1] = ACTIONS(129),
    [aux_sym_close_statement_token1] = ACTIONS(131),
    [aux_sym_inquire_statement_token1] = ACTIONS(133),
    [aux_sym_file_position_statement_token1] = ACTIONS(137),
    [aux_sym_file_position_statement_token2] = ACTIONS(137),
    [aux_sym_file_position_statement_token3] = ACTIONS(137),
    [aux_sym_file_position_statement_token4] = ACTIONS(139),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [294] = {
    [sym_preproc_file_line] = STATE(294),
    [ts_builtin_sym_end] = ACTIONS(1271),
    [aux_sym_program_statement_token1] = ACTIONS(1273),
    [aux_sym_end_program_statement_token1] = ACTIONS(1273),
    [aux_sym_end_program_statement_token2] = ACTIONS(1273),
    [aux_sym_module_statement_token1] = ACTIONS(1273),
    [aux_sym_submodule_statement_token1] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [aux_sym_interface_statement_token1] = ACTIONS(1273),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1273),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1273),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1273),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1273),
    [aux_sym_function_statement_token1] = ACTIONS(1273),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1273),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1273),
    [aux_sym_contains_statement_token1] = ACTIONS(1273),
    [aux_sym_use_statement_token1] = ACTIONS(1273),
    [aux_sym_use_statement_token2] = ACTIONS(1273),
    [aux_sym_implicit_statement_token1] = ACTIONS(1273),
    [aux_sym_implicit_statement_token3] = ACTIONS(1273),
    [aux_sym_implicit_statement_token4] = ACTIONS(1273),
    [aux_sym_save_statement_token1] = ACTIONS(1273),
    [aux_sym_private_statement_token1] = ACTIONS(1273),
    [aux_sym_public_statement_token1] = ACTIONS(1273),
    [aux_sym_namelist_statement_token1] = ACTIONS(1273),
    [aux_sym_common_statement_token1] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1271),
    [aux_sym_import_statement_token1] = ACTIONS(1273),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1273),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1273),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1273),
    [aux_sym_variable_attributes_token1] = ACTIONS(1273),
    [aux_sym_variable_attributes_token2] = ACTIONS(1273),
    [aux_sym_variable_attributes_token3] = ACTIONS(1273),
    [aux_sym_variable_attributes_token4] = ACTIONS(1273),
    [aux_sym_variable_attributes_token5] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1273),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1273),
    [aux_sym_derived_type_token1] = ACTIONS(1273),
    [aux_sym_type_qualifier_token1] = ACTIONS(1273),
    [aux_sym_type_qualifier_token2] = ACTIONS(1273),
    [aux_sym_type_qualifier_token3] = ACTIONS(1273),
    [aux_sym_type_qualifier_token4] = ACTIONS(1273),
    [aux_sym_type_qualifier_token5] = ACTIONS(1273),
    [aux_sym_type_qualifier_token9] = ACTIONS(1273),
    [aux_sym_type_qualifier_token10] = ACTIONS(1273),
    [aux_sym_type_qualifier_token11] = ACTIONS(1273),
    [aux_sym_type_qualifier_token12] = ACTIONS(1273),
    [aux_sym_type_qualifier_token13] = ACTIONS(1273),
    [aux_sym_type_qualifier_token14] = ACTIONS(1273),
    [aux_sym_type_qualifier_token15] = ACTIONS(1273),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1273),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1273),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1273),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1273),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1273),
    [aux_sym_stop_statement_token1] = ACTIONS(1273),
    [aux_sym_stop_statement_token2] = ACTIONS(1273),
    [aux_sym_subroutine_call_token1] = ACTIONS(1273),
    [aux_sym_keyword_statement_token1] = ACTIONS(1273),
    [aux_sym_keyword_statement_token2] = ACTIONS(1273),
    [aux_sym_keyword_statement_token3] = ACTIONS(1273),
    [aux_sym_keyword_statement_token4] = ACTIONS(1273),
    [aux_sym_keyword_statement_token6] = ACTIONS(1273),
    [aux_sym_keyword_statement_token7] = ACTIONS(1273),
    [aux_sym_include_statement_token1] = ACTIONS(1273),
    [aux_sym_data_statement_token1] = ACTIONS(1273),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1273),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1273),
    [aux_sym_end_if_statement_token1] = ACTIONS(1273),
    [aux_sym_elseif_clause_token2] = ACTIONS(1273),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1273),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1273),
    [aux_sym_select_case_statement_token1] = ACTIONS(1273),
    [aux_sym_select_case_statement_token3] = ACTIONS(1273),
    [aux_sym_select_type_statement_token1] = ACTIONS(1273),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1273),
    [aux_sym_block_construct_token1] = ACTIONS(1273),
    [aux_sym_associate_statement_token1] = ACTIONS(1273),
    [aux_sym_format_statement_token1] = ACTIONS(1273),
    [aux_sym_print_statement_token1] = ACTIONS(1273),
    [aux_sym_open_statement_token1] = ACTIONS(1273),
    [aux_sym_close_statement_token1] = ACTIONS(1273),
    [aux_sym_inquire_statement_token1] = ACTIONS(1273),
    [aux_sym_enum_statement_token1] = ACTIONS(1273),
    [aux_sym_file_position_statement_token1] = ACTIONS(1273),
    [aux_sym_file_position_statement_token2] = ACTIONS(1273),
    [aux_sym_file_position_statement_token3] = ACTIONS(1273),
    [aux_sym_file_position_statement_token4] = ACTIONS(1273),
    [aux_sym_logical_expression_token5] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [sym_boolean_literal] = ACTIONS(1271),
    [aux_sym_null_literal_token1] = ACTIONS(1273),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1273),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1271),
    [sym__float_literal] = ACTIONS(1271),
    [sym__boz_literal] = ACTIONS(1271),
    [sym_string_literal] = ACTIONS(1271),
  },
  [295] = {
    [sym_preproc_file_line] = STATE(295),
    [aux_sym_end_program_statement_token1] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [aux_sym_interface_statement_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1275),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1275),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1275),
    [aux_sym_contains_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token2] = ACTIONS(1275),
    [aux_sym_implicit_statement_token1] = ACTIONS(1275),
    [aux_sym_implicit_statement_token3] = ACTIONS(1275),
    [aux_sym_implicit_statement_token4] = ACTIONS(1275),
    [aux_sym_save_statement_token1] = ACTIONS(1275),
    [aux_sym_private_statement_token1] = ACTIONS(1275),
    [aux_sym_public_statement_token1] = ACTIONS(1275),
    [aux_sym_namelist_statement_token1] = ACTIONS(1275),
    [aux_sym_common_statement_token1] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1277),
    [aux_sym_import_statement_token1] = ACTIONS(1275),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1275),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1275),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1275),
    [aux_sym_variable_attributes_token1] = ACTIONS(1275),
    [aux_sym_variable_attributes_token2] = ACTIONS(1275),
    [aux_sym_variable_attributes_token3] = ACTIONS(1275),
    [aux_sym_variable_attributes_token4] = ACTIONS(1275),
    [aux_sym_variable_attributes_token5] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1275),
    [aux_sym_derived_type_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token2] = ACTIONS(1275),
    [aux_sym_type_qualifier_token3] = ACTIONS(1275),
    [aux_sym_type_qualifier_token4] = ACTIONS(1275),
    [aux_sym_type_qualifier_token5] = ACTIONS(1275),
    [aux_sym_type_qualifier_token9] = ACTIONS(1275),
    [aux_sym_type_qualifier_token10] = ACTIONS(1275),
    [aux_sym_type_qualifier_token11] = ACTIONS(1275),
    [aux_sym_type_qualifier_token12] = ACTIONS(1275),
    [aux_sym_type_qualifier_token13] = ACTIONS(1275),
    [aux_sym_type_qualifier_token14] = ACTIONS(1275),
    [aux_sym_type_qualifier_token15] = ACTIONS(1275),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token2] = ACTIONS(1275),
    [aux_sym_subroutine_call_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token2] = ACTIONS(1275),
    [aux_sym_keyword_statement_token3] = ACTIONS(1275),
    [aux_sym_keyword_statement_token4] = ACTIONS(1275),
    [aux_sym_keyword_statement_token6] = ACTIONS(1275),
    [aux_sym_keyword_statement_token7] = ACTIONS(1275),
    [aux_sym_include_statement_token1] = ACTIONS(1275),
    [aux_sym_data_statement_token1] = ACTIONS(1275),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1275),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1275),
    [aux_sym_end_if_statement_token1] = ACTIONS(1275),
    [aux_sym_elseif_clause_token2] = ACTIONS(1275),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1275),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token3] = ACTIONS(1275),
    [aux_sym_select_type_statement_token1] = ACTIONS(1275),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1275),
    [aux_sym_block_construct_token1] = ACTIONS(1275),
    [aux_sym_associate_statement_token1] = ACTIONS(1275),
    [aux_sym_format_statement_token1] = ACTIONS(1275),
    [aux_sym_print_statement_token1] = ACTIONS(1275),
    [aux_sym_open_statement_token1] = ACTIONS(1275),
    [aux_sym_close_statement_token1] = ACTIONS(1275),
    [aux_sym_inquire_statement_token1] = ACTIONS(1275),
    [aux_sym_enum_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token2] = ACTIONS(1275),
    [aux_sym_file_position_statement_token3] = ACTIONS(1275),
    [aux_sym_file_position_statement_token4] = ACTIONS(1275),
    [aux_sym_logical_expression_token5] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [sym_boolean_literal] = ACTIONS(1277),
    [aux_sym_null_literal_token1] = ACTIONS(1275),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1275),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1277),
    [sym__float_literal] = ACTIONS(1277),
    [sym__boz_literal] = ACTIONS(1277),
    [sym_string_literal] = ACTIONS(1277),
  },
  [296] = {
    [sym_preproc_file_line] = STATE(296),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [aux_sym_end_program_statement_token2] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_contains_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [297] = {
    [sym_preproc_file_line] = STATE(297),
    [aux_sym_end_program_statement_token1] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [aux_sym_interface_statement_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1279),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1279),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1279),
    [aux_sym_contains_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token2] = ACTIONS(1279),
    [aux_sym_implicit_statement_token1] = ACTIONS(1279),
    [aux_sym_implicit_statement_token3] = ACTIONS(1279),
    [aux_sym_implicit_statement_token4] = ACTIONS(1279),
    [aux_sym_save_statement_token1] = ACTIONS(1279),
    [aux_sym_private_statement_token1] = ACTIONS(1279),
    [aux_sym_public_statement_token1] = ACTIONS(1279),
    [aux_sym_namelist_statement_token1] = ACTIONS(1279),
    [aux_sym_common_statement_token1] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1281),
    [aux_sym_import_statement_token1] = ACTIONS(1279),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1279),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1279),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1279),
    [aux_sym_variable_attributes_token1] = ACTIONS(1279),
    [aux_sym_variable_attributes_token2] = ACTIONS(1279),
    [aux_sym_variable_attributes_token3] = ACTIONS(1279),
    [aux_sym_variable_attributes_token4] = ACTIONS(1279),
    [aux_sym_variable_attributes_token5] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1279),
    [aux_sym_derived_type_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token2] = ACTIONS(1279),
    [aux_sym_type_qualifier_token3] = ACTIONS(1279),
    [aux_sym_type_qualifier_token4] = ACTIONS(1279),
    [aux_sym_type_qualifier_token5] = ACTIONS(1279),
    [aux_sym_type_qualifier_token9] = ACTIONS(1279),
    [aux_sym_type_qualifier_token10] = ACTIONS(1279),
    [aux_sym_type_qualifier_token11] = ACTIONS(1279),
    [aux_sym_type_qualifier_token12] = ACTIONS(1279),
    [aux_sym_type_qualifier_token13] = ACTIONS(1279),
    [aux_sym_type_qualifier_token14] = ACTIONS(1279),
    [aux_sym_type_qualifier_token15] = ACTIONS(1279),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token2] = ACTIONS(1279),
    [aux_sym_subroutine_call_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token2] = ACTIONS(1279),
    [aux_sym_keyword_statement_token3] = ACTIONS(1279),
    [aux_sym_keyword_statement_token4] = ACTIONS(1279),
    [aux_sym_keyword_statement_token6] = ACTIONS(1279),
    [aux_sym_keyword_statement_token7] = ACTIONS(1279),
    [aux_sym_include_statement_token1] = ACTIONS(1279),
    [aux_sym_data_statement_token1] = ACTIONS(1279),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1279),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1279),
    [aux_sym_end_if_statement_token1] = ACTIONS(1279),
    [aux_sym_elseif_clause_token2] = ACTIONS(1279),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1279),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token3] = ACTIONS(1279),
    [aux_sym_select_type_statement_token1] = ACTIONS(1279),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1279),
    [aux_sym_block_construct_token1] = ACTIONS(1279),
    [aux_sym_associate_statement_token1] = ACTIONS(1279),
    [aux_sym_format_statement_token1] = ACTIONS(1279),
    [aux_sym_print_statement_token1] = ACTIONS(1279),
    [aux_sym_open_statement_token1] = ACTIONS(1279),
    [aux_sym_close_statement_token1] = ACTIONS(1279),
    [aux_sym_inquire_statement_token1] = ACTIONS(1279),
    [aux_sym_enum_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token2] = ACTIONS(1279),
    [aux_sym_file_position_statement_token3] = ACTIONS(1279),
    [aux_sym_file_position_statement_token4] = ACTIONS(1279),
    [aux_sym_logical_expression_token5] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [sym_boolean_literal] = ACTIONS(1281),
    [aux_sym_null_literal_token1] = ACTIONS(1279),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1279),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1281),
    [sym__float_literal] = ACTIONS(1281),
    [sym__boz_literal] = ACTIONS(1281),
    [sym_string_literal] = ACTIONS(1281),
  },
  [298] = {
    [sym_preproc_file_line] = STATE(298),
    [aux_sym_end_program_statement_token1] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [aux_sym_interface_statement_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1283),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1283),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1283),
    [aux_sym_contains_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token2] = ACTIONS(1283),
    [aux_sym_implicit_statement_token1] = ACTIONS(1283),
    [aux_sym_implicit_statement_token3] = ACTIONS(1283),
    [aux_sym_implicit_statement_token4] = ACTIONS(1283),
    [aux_sym_save_statement_token1] = ACTIONS(1283),
    [aux_sym_private_statement_token1] = ACTIONS(1283),
    [aux_sym_public_statement_token1] = ACTIONS(1283),
    [aux_sym_namelist_statement_token1] = ACTIONS(1283),
    [aux_sym_common_statement_token1] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1285),
    [aux_sym_import_statement_token1] = ACTIONS(1283),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1283),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1283),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1283),
    [aux_sym_variable_attributes_token1] = ACTIONS(1283),
    [aux_sym_variable_attributes_token2] = ACTIONS(1283),
    [aux_sym_variable_attributes_token3] = ACTIONS(1283),
    [aux_sym_variable_attributes_token4] = ACTIONS(1283),
    [aux_sym_variable_attributes_token5] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1283),
    [aux_sym_derived_type_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token2] = ACTIONS(1283),
    [aux_sym_type_qualifier_token3] = ACTIONS(1283),
    [aux_sym_type_qualifier_token4] = ACTIONS(1283),
    [aux_sym_type_qualifier_token5] = ACTIONS(1283),
    [aux_sym_type_qualifier_token9] = ACTIONS(1283),
    [aux_sym_type_qualifier_token10] = ACTIONS(1283),
    [aux_sym_type_qualifier_token11] = ACTIONS(1283),
    [aux_sym_type_qualifier_token12] = ACTIONS(1283),
    [aux_sym_type_qualifier_token13] = ACTIONS(1283),
    [aux_sym_type_qualifier_token14] = ACTIONS(1283),
    [aux_sym_type_qualifier_token15] = ACTIONS(1283),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token2] = ACTIONS(1283),
    [aux_sym_subroutine_call_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token2] = ACTIONS(1283),
    [aux_sym_keyword_statement_token3] = ACTIONS(1283),
    [aux_sym_keyword_statement_token4] = ACTIONS(1283),
    [aux_sym_keyword_statement_token6] = ACTIONS(1283),
    [aux_sym_keyword_statement_token7] = ACTIONS(1283),
    [aux_sym_include_statement_token1] = ACTIONS(1283),
    [aux_sym_data_statement_token1] = ACTIONS(1283),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1283),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1283),
    [aux_sym_end_if_statement_token1] = ACTIONS(1283),
    [aux_sym_elseif_clause_token2] = ACTIONS(1283),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1283),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token3] = ACTIONS(1283),
    [aux_sym_select_type_statement_token1] = ACTIONS(1283),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1283),
    [aux_sym_block_construct_token1] = ACTIONS(1283),
    [aux_sym_associate_statement_token1] = ACTIONS(1283),
    [aux_sym_format_statement_token1] = ACTIONS(1283),
    [aux_sym_print_statement_token1] = ACTIONS(1283),
    [aux_sym_open_statement_token1] = ACTIONS(1283),
    [aux_sym_close_statement_token1] = ACTIONS(1283),
    [aux_sym_inquire_statement_token1] = ACTIONS(1283),
    [aux_sym_enum_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token2] = ACTIONS(1283),
    [aux_sym_file_position_statement_token3] = ACTIONS(1283),
    [aux_sym_file_position_statement_token4] = ACTIONS(1283),
    [aux_sym_logical_expression_token5] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [sym_boolean_literal] = ACTIONS(1285),
    [aux_sym_null_literal_token1] = ACTIONS(1283),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1285),
    [sym__float_literal] = ACTIONS(1285),
    [sym__boz_literal] = ACTIONS(1285),
    [sym_string_literal] = ACTIONS(1285),
  },
  [299] = {
    [sym_preproc_file_line] = STATE(299),
    [aux_sym_end_program_statement_token1] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [aux_sym_interface_statement_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1287),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1287),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1287),
    [aux_sym_contains_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token2] = ACTIONS(1287),
    [aux_sym_implicit_statement_token1] = ACTIONS(1287),
    [aux_sym_implicit_statement_token3] = ACTIONS(1287),
    [aux_sym_implicit_statement_token4] = ACTIONS(1287),
    [aux_sym_save_statement_token1] = ACTIONS(1287),
    [aux_sym_private_statement_token1] = ACTIONS(1287),
    [aux_sym_public_statement_token1] = ACTIONS(1287),
    [aux_sym_namelist_statement_token1] = ACTIONS(1287),
    [aux_sym_common_statement_token1] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1289),
    [aux_sym_import_statement_token1] = ACTIONS(1287),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1287),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1287),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1287),
    [aux_sym_variable_attributes_token1] = ACTIONS(1287),
    [aux_sym_variable_attributes_token2] = ACTIONS(1287),
    [aux_sym_variable_attributes_token3] = ACTIONS(1287),
    [aux_sym_variable_attributes_token4] = ACTIONS(1287),
    [aux_sym_variable_attributes_token5] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1287),
    [aux_sym_derived_type_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token2] = ACTIONS(1287),
    [aux_sym_type_qualifier_token3] = ACTIONS(1287),
    [aux_sym_type_qualifier_token4] = ACTIONS(1287),
    [aux_sym_type_qualifier_token5] = ACTIONS(1287),
    [aux_sym_type_qualifier_token9] = ACTIONS(1287),
    [aux_sym_type_qualifier_token10] = ACTIONS(1287),
    [aux_sym_type_qualifier_token11] = ACTIONS(1287),
    [aux_sym_type_qualifier_token12] = ACTIONS(1287),
    [aux_sym_type_qualifier_token13] = ACTIONS(1287),
    [aux_sym_type_qualifier_token14] = ACTIONS(1287),
    [aux_sym_type_qualifier_token15] = ACTIONS(1287),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token2] = ACTIONS(1287),
    [aux_sym_subroutine_call_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token2] = ACTIONS(1287),
    [aux_sym_keyword_statement_token3] = ACTIONS(1287),
    [aux_sym_keyword_statement_token4] = ACTIONS(1287),
    [aux_sym_keyword_statement_token6] = ACTIONS(1287),
    [aux_sym_keyword_statement_token7] = ACTIONS(1287),
    [aux_sym_include_statement_token1] = ACTIONS(1287),
    [aux_sym_data_statement_token1] = ACTIONS(1287),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1287),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1287),
    [aux_sym_end_if_statement_token1] = ACTIONS(1287),
    [aux_sym_elseif_clause_token2] = ACTIONS(1287),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1287),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token3] = ACTIONS(1287),
    [aux_sym_select_type_statement_token1] = ACTIONS(1287),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1287),
    [aux_sym_block_construct_token1] = ACTIONS(1287),
    [aux_sym_associate_statement_token1] = ACTIONS(1287),
    [aux_sym_format_statement_token1] = ACTIONS(1287),
    [aux_sym_print_statement_token1] = ACTIONS(1287),
    [aux_sym_open_statement_token1] = ACTIONS(1287),
    [aux_sym_close_statement_token1] = ACTIONS(1287),
    [aux_sym_inquire_statement_token1] = ACTIONS(1287),
    [aux_sym_enum_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token2] = ACTIONS(1287),
    [aux_sym_file_position_statement_token3] = ACTIONS(1287),
    [aux_sym_file_position_statement_token4] = ACTIONS(1287),
    [aux_sym_logical_expression_token5] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [sym_boolean_literal] = ACTIONS(1289),
    [aux_sym_null_literal_token1] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1287),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1289),
    [sym__float_literal] = ACTIONS(1289),
    [sym__boz_literal] = ACTIONS(1289),
    [sym_string_literal] = ACTIONS(1289),
  },
  [300] = {
    [sym_preproc_file_line] = STATE(300),
    [aux_sym_end_program_statement_token1] = ACTIONS(1291),
    [aux_sym_end_program_statement_token2] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [aux_sym_interface_statement_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1291),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1291),
    [aux_sym_contains_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token2] = ACTIONS(1291),
    [aux_sym_implicit_statement_token1] = ACTIONS(1291),
    [aux_sym_implicit_statement_token3] = ACTIONS(1291),
    [aux_sym_implicit_statement_token4] = ACTIONS(1291),
    [aux_sym_save_statement_token1] = ACTIONS(1291),
    [aux_sym_private_statement_token1] = ACTIONS(1291),
    [aux_sym_public_statement_token1] = ACTIONS(1291),
    [aux_sym_namelist_statement_token1] = ACTIONS(1291),
    [aux_sym_common_statement_token1] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1293),
    [aux_sym_import_statement_token1] = ACTIONS(1291),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1291),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1291),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1291),
    [aux_sym_variable_attributes_token1] = ACTIONS(1291),
    [aux_sym_variable_attributes_token2] = ACTIONS(1291),
    [aux_sym_variable_attributes_token3] = ACTIONS(1291),
    [aux_sym_variable_attributes_token4] = ACTIONS(1291),
    [aux_sym_variable_attributes_token5] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1291),
    [aux_sym_derived_type_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token2] = ACTIONS(1291),
    [aux_sym_type_qualifier_token3] = ACTIONS(1291),
    [aux_sym_type_qualifier_token4] = ACTIONS(1291),
    [aux_sym_type_qualifier_token5] = ACTIONS(1291),
    [aux_sym_type_qualifier_token9] = ACTIONS(1291),
    [aux_sym_type_qualifier_token10] = ACTIONS(1291),
    [aux_sym_type_qualifier_token11] = ACTIONS(1291),
    [aux_sym_type_qualifier_token12] = ACTIONS(1291),
    [aux_sym_type_qualifier_token13] = ACTIONS(1291),
    [aux_sym_type_qualifier_token14] = ACTIONS(1291),
    [aux_sym_type_qualifier_token15] = ACTIONS(1291),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token2] = ACTIONS(1291),
    [aux_sym_subroutine_call_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token2] = ACTIONS(1291),
    [aux_sym_keyword_statement_token3] = ACTIONS(1291),
    [aux_sym_keyword_statement_token4] = ACTIONS(1291),
    [aux_sym_keyword_statement_token6] = ACTIONS(1291),
    [aux_sym_keyword_statement_token7] = ACTIONS(1291),
    [aux_sym_include_statement_token1] = ACTIONS(1291),
    [aux_sym_data_statement_token1] = ACTIONS(1291),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1291),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1291),
    [aux_sym_end_if_statement_token1] = ACTIONS(1291),
    [aux_sym_elseif_clause_token2] = ACTIONS(1291),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1291),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token3] = ACTIONS(1291),
    [aux_sym_select_type_statement_token1] = ACTIONS(1291),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1291),
    [aux_sym_block_construct_token1] = ACTIONS(1291),
    [aux_sym_associate_statement_token1] = ACTIONS(1291),
    [aux_sym_format_statement_token1] = ACTIONS(1291),
    [aux_sym_print_statement_token1] = ACTIONS(1291),
    [aux_sym_open_statement_token1] = ACTIONS(1291),
    [aux_sym_close_statement_token1] = ACTIONS(1291),
    [aux_sym_inquire_statement_token1] = ACTIONS(1291),
    [aux_sym_enum_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token2] = ACTIONS(1291),
    [aux_sym_file_position_statement_token3] = ACTIONS(1291),
    [aux_sym_file_position_statement_token4] = ACTIONS(1291),
    [aux_sym_logical_expression_token5] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [sym_boolean_literal] = ACTIONS(1293),
    [aux_sym_null_literal_token1] = ACTIONS(1291),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1291),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1293),
    [sym__float_literal] = ACTIONS(1293),
    [sym__boz_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
  },
  [301] = {
    [sym_preproc_file_line] = STATE(301),
    [aux_sym_end_program_statement_token1] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [aux_sym_interface_statement_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1295),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1295),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1295),
    [aux_sym_contains_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token2] = ACTIONS(1295),
    [aux_sym_implicit_statement_token1] = ACTIONS(1295),
    [aux_sym_implicit_statement_token3] = ACTIONS(1295),
    [aux_sym_implicit_statement_token4] = ACTIONS(1295),
    [aux_sym_save_statement_token1] = ACTIONS(1295),
    [aux_sym_private_statement_token1] = ACTIONS(1295),
    [aux_sym_public_statement_token1] = ACTIONS(1295),
    [aux_sym_namelist_statement_token1] = ACTIONS(1295),
    [aux_sym_common_statement_token1] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1297),
    [aux_sym_import_statement_token1] = ACTIONS(1295),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1295),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1295),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1295),
    [aux_sym_variable_attributes_token1] = ACTIONS(1295),
    [aux_sym_variable_attributes_token2] = ACTIONS(1295),
    [aux_sym_variable_attributes_token3] = ACTIONS(1295),
    [aux_sym_variable_attributes_token4] = ACTIONS(1295),
    [aux_sym_variable_attributes_token5] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1295),
    [aux_sym_derived_type_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token2] = ACTIONS(1295),
    [aux_sym_type_qualifier_token3] = ACTIONS(1295),
    [aux_sym_type_qualifier_token4] = ACTIONS(1295),
    [aux_sym_type_qualifier_token5] = ACTIONS(1295),
    [aux_sym_type_qualifier_token9] = ACTIONS(1295),
    [aux_sym_type_qualifier_token10] = ACTIONS(1295),
    [aux_sym_type_qualifier_token11] = ACTIONS(1295),
    [aux_sym_type_qualifier_token12] = ACTIONS(1295),
    [aux_sym_type_qualifier_token13] = ACTIONS(1295),
    [aux_sym_type_qualifier_token14] = ACTIONS(1295),
    [aux_sym_type_qualifier_token15] = ACTIONS(1295),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token2] = ACTIONS(1295),
    [aux_sym_subroutine_call_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token2] = ACTIONS(1295),
    [aux_sym_keyword_statement_token3] = ACTIONS(1295),
    [aux_sym_keyword_statement_token4] = ACTIONS(1295),
    [aux_sym_keyword_statement_token6] = ACTIONS(1295),
    [aux_sym_keyword_statement_token7] = ACTIONS(1295),
    [aux_sym_include_statement_token1] = ACTIONS(1295),
    [aux_sym_data_statement_token1] = ACTIONS(1295),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1295),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1295),
    [aux_sym_end_if_statement_token1] = ACTIONS(1295),
    [aux_sym_elseif_clause_token2] = ACTIONS(1295),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1295),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token3] = ACTIONS(1295),
    [aux_sym_select_type_statement_token1] = ACTIONS(1295),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1295),
    [aux_sym_block_construct_token1] = ACTIONS(1295),
    [aux_sym_associate_statement_token1] = ACTIONS(1295),
    [aux_sym_format_statement_token1] = ACTIONS(1295),
    [aux_sym_print_statement_token1] = ACTIONS(1295),
    [aux_sym_open_statement_token1] = ACTIONS(1295),
    [aux_sym_close_statement_token1] = ACTIONS(1295),
    [aux_sym_inquire_statement_token1] = ACTIONS(1295),
    [aux_sym_enum_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token2] = ACTIONS(1295),
    [aux_sym_file_position_statement_token3] = ACTIONS(1295),
    [aux_sym_file_position_statement_token4] = ACTIONS(1295),
    [aux_sym_logical_expression_token5] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1295),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_boolean_literal] = ACTIONS(1297),
    [aux_sym_null_literal_token1] = ACTIONS(1295),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1295),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1297),
    [sym__float_literal] = ACTIONS(1297),
    [sym__boz_literal] = ACTIONS(1297),
    [sym_string_literal] = ACTIONS(1297),
  },
  [302] = {
    [sym_preproc_file_line] = STATE(302),
    [aux_sym_end_program_statement_token1] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [aux_sym_interface_statement_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1299),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1299),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1299),
    [aux_sym_contains_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token2] = ACTIONS(1299),
    [aux_sym_implicit_statement_token1] = ACTIONS(1299),
    [aux_sym_implicit_statement_token3] = ACTIONS(1299),
    [aux_sym_implicit_statement_token4] = ACTIONS(1299),
    [aux_sym_save_statement_token1] = ACTIONS(1299),
    [aux_sym_private_statement_token1] = ACTIONS(1299),
    [aux_sym_public_statement_token1] = ACTIONS(1299),
    [aux_sym_namelist_statement_token1] = ACTIONS(1299),
    [aux_sym_common_statement_token1] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1301),
    [aux_sym_import_statement_token1] = ACTIONS(1299),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1299),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1299),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1299),
    [aux_sym_variable_attributes_token1] = ACTIONS(1299),
    [aux_sym_variable_attributes_token2] = ACTIONS(1299),
    [aux_sym_variable_attributes_token3] = ACTIONS(1299),
    [aux_sym_variable_attributes_token4] = ACTIONS(1299),
    [aux_sym_variable_attributes_token5] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1299),
    [aux_sym_derived_type_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token2] = ACTIONS(1299),
    [aux_sym_type_qualifier_token3] = ACTIONS(1299),
    [aux_sym_type_qualifier_token4] = ACTIONS(1299),
    [aux_sym_type_qualifier_token5] = ACTIONS(1299),
    [aux_sym_type_qualifier_token9] = ACTIONS(1299),
    [aux_sym_type_qualifier_token10] = ACTIONS(1299),
    [aux_sym_type_qualifier_token11] = ACTIONS(1299),
    [aux_sym_type_qualifier_token12] = ACTIONS(1299),
    [aux_sym_type_qualifier_token13] = ACTIONS(1299),
    [aux_sym_type_qualifier_token14] = ACTIONS(1299),
    [aux_sym_type_qualifier_token15] = ACTIONS(1299),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token2] = ACTIONS(1299),
    [aux_sym_subroutine_call_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token2] = ACTIONS(1299),
    [aux_sym_keyword_statement_token3] = ACTIONS(1299),
    [aux_sym_keyword_statement_token4] = ACTIONS(1299),
    [aux_sym_keyword_statement_token6] = ACTIONS(1299),
    [aux_sym_keyword_statement_token7] = ACTIONS(1299),
    [aux_sym_include_statement_token1] = ACTIONS(1299),
    [aux_sym_data_statement_token1] = ACTIONS(1299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1299),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1299),
    [aux_sym_end_if_statement_token1] = ACTIONS(1299),
    [aux_sym_elseif_clause_token2] = ACTIONS(1299),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1299),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token3] = ACTIONS(1299),
    [aux_sym_select_type_statement_token1] = ACTIONS(1299),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1299),
    [aux_sym_block_construct_token1] = ACTIONS(1299),
    [aux_sym_associate_statement_token1] = ACTIONS(1299),
    [aux_sym_format_statement_token1] = ACTIONS(1299),
    [aux_sym_print_statement_token1] = ACTIONS(1299),
    [aux_sym_open_statement_token1] = ACTIONS(1299),
    [aux_sym_close_statement_token1] = ACTIONS(1299),
    [aux_sym_inquire_statement_token1] = ACTIONS(1299),
    [aux_sym_enum_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token2] = ACTIONS(1299),
    [aux_sym_file_position_statement_token3] = ACTIONS(1299),
    [aux_sym_file_position_statement_token4] = ACTIONS(1299),
    [aux_sym_logical_expression_token5] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [sym_boolean_literal] = ACTIONS(1301),
    [aux_sym_null_literal_token1] = ACTIONS(1299),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1299),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1301),
    [sym__float_literal] = ACTIONS(1301),
    [sym__boz_literal] = ACTIONS(1301),
    [sym_string_literal] = ACTIONS(1301),
  },
  [303] = {
    [sym_preproc_file_line] = STATE(303),
    [aux_sym_end_program_statement_token1] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [aux_sym_interface_statement_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1291),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1291),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1291),
    [aux_sym_contains_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token2] = ACTIONS(1291),
    [aux_sym_implicit_statement_token1] = ACTIONS(1291),
    [aux_sym_implicit_statement_token3] = ACTIONS(1291),
    [aux_sym_implicit_statement_token4] = ACTIONS(1291),
    [aux_sym_save_statement_token1] = ACTIONS(1291),
    [aux_sym_private_statement_token1] = ACTIONS(1291),
    [aux_sym_public_statement_token1] = ACTIONS(1291),
    [aux_sym_namelist_statement_token1] = ACTIONS(1291),
    [aux_sym_common_statement_token1] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1293),
    [aux_sym_import_statement_token1] = ACTIONS(1291),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1291),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1291),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1291),
    [aux_sym_variable_attributes_token1] = ACTIONS(1291),
    [aux_sym_variable_attributes_token2] = ACTIONS(1291),
    [aux_sym_variable_attributes_token3] = ACTIONS(1291),
    [aux_sym_variable_attributes_token4] = ACTIONS(1291),
    [aux_sym_variable_attributes_token5] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1291),
    [aux_sym_derived_type_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token2] = ACTIONS(1291),
    [aux_sym_type_qualifier_token3] = ACTIONS(1291),
    [aux_sym_type_qualifier_token4] = ACTIONS(1291),
    [aux_sym_type_qualifier_token5] = ACTIONS(1291),
    [aux_sym_type_qualifier_token9] = ACTIONS(1291),
    [aux_sym_type_qualifier_token10] = ACTIONS(1291),
    [aux_sym_type_qualifier_token11] = ACTIONS(1291),
    [aux_sym_type_qualifier_token12] = ACTIONS(1291),
    [aux_sym_type_qualifier_token13] = ACTIONS(1291),
    [aux_sym_type_qualifier_token14] = ACTIONS(1291),
    [aux_sym_type_qualifier_token15] = ACTIONS(1291),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token2] = ACTIONS(1291),
    [aux_sym_subroutine_call_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token2] = ACTIONS(1291),
    [aux_sym_keyword_statement_token3] = ACTIONS(1291),
    [aux_sym_keyword_statement_token4] = ACTIONS(1291),
    [aux_sym_keyword_statement_token6] = ACTIONS(1291),
    [aux_sym_keyword_statement_token7] = ACTIONS(1291),
    [aux_sym_include_statement_token1] = ACTIONS(1291),
    [aux_sym_data_statement_token1] = ACTIONS(1291),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1291),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1291),
    [aux_sym_end_if_statement_token1] = ACTIONS(1291),
    [aux_sym_elseif_clause_token2] = ACTIONS(1291),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1291),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token3] = ACTIONS(1291),
    [aux_sym_select_type_statement_token1] = ACTIONS(1291),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1291),
    [aux_sym_block_construct_token1] = ACTIONS(1291),
    [aux_sym_associate_statement_token1] = ACTIONS(1291),
    [aux_sym_format_statement_token1] = ACTIONS(1291),
    [aux_sym_print_statement_token1] = ACTIONS(1291),
    [aux_sym_open_statement_token1] = ACTIONS(1291),
    [aux_sym_close_statement_token1] = ACTIONS(1291),
    [aux_sym_inquire_statement_token1] = ACTIONS(1291),
    [aux_sym_enum_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token2] = ACTIONS(1291),
    [aux_sym_file_position_statement_token3] = ACTIONS(1291),
    [aux_sym_file_position_statement_token4] = ACTIONS(1291),
    [aux_sym_logical_expression_token5] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [sym_boolean_literal] = ACTIONS(1293),
    [aux_sym_null_literal_token1] = ACTIONS(1291),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1291),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1293),
    [sym__float_literal] = ACTIONS(1293),
    [sym__boz_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
  },
  [304] = {
    [sym_preproc_file_line] = STATE(304),
    [aux_sym_end_program_statement_token1] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_interface_statement_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1303),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1303),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1303),
    [aux_sym_contains_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token2] = ACTIONS(1303),
    [aux_sym_implicit_statement_token1] = ACTIONS(1303),
    [aux_sym_implicit_statement_token3] = ACTIONS(1303),
    [aux_sym_implicit_statement_token4] = ACTIONS(1303),
    [aux_sym_save_statement_token1] = ACTIONS(1303),
    [aux_sym_private_statement_token1] = ACTIONS(1303),
    [aux_sym_public_statement_token1] = ACTIONS(1303),
    [aux_sym_namelist_statement_token1] = ACTIONS(1303),
    [aux_sym_common_statement_token1] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1305),
    [aux_sym_import_statement_token1] = ACTIONS(1303),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1303),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1303),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1303),
    [aux_sym_variable_attributes_token1] = ACTIONS(1303),
    [aux_sym_variable_attributes_token2] = ACTIONS(1303),
    [aux_sym_variable_attributes_token3] = ACTIONS(1303),
    [aux_sym_variable_attributes_token4] = ACTIONS(1303),
    [aux_sym_variable_attributes_token5] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1303),
    [aux_sym_derived_type_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token2] = ACTIONS(1303),
    [aux_sym_type_qualifier_token3] = ACTIONS(1303),
    [aux_sym_type_qualifier_token4] = ACTIONS(1303),
    [aux_sym_type_qualifier_token5] = ACTIONS(1303),
    [aux_sym_type_qualifier_token9] = ACTIONS(1303),
    [aux_sym_type_qualifier_token10] = ACTIONS(1303),
    [aux_sym_type_qualifier_token11] = ACTIONS(1303),
    [aux_sym_type_qualifier_token12] = ACTIONS(1303),
    [aux_sym_type_qualifier_token13] = ACTIONS(1303),
    [aux_sym_type_qualifier_token14] = ACTIONS(1303),
    [aux_sym_type_qualifier_token15] = ACTIONS(1303),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token2] = ACTIONS(1303),
    [aux_sym_subroutine_call_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token2] = ACTIONS(1303),
    [aux_sym_keyword_statement_token3] = ACTIONS(1303),
    [aux_sym_keyword_statement_token4] = ACTIONS(1303),
    [aux_sym_keyword_statement_token6] = ACTIONS(1303),
    [aux_sym_keyword_statement_token7] = ACTIONS(1303),
    [aux_sym_include_statement_token1] = ACTIONS(1303),
    [aux_sym_data_statement_token1] = ACTIONS(1303),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1303),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1303),
    [aux_sym_end_if_statement_token1] = ACTIONS(1303),
    [aux_sym_elseif_clause_token2] = ACTIONS(1303),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1303),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token3] = ACTIONS(1303),
    [aux_sym_select_type_statement_token1] = ACTIONS(1303),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1303),
    [aux_sym_block_construct_token1] = ACTIONS(1303),
    [aux_sym_associate_statement_token1] = ACTIONS(1303),
    [aux_sym_format_statement_token1] = ACTIONS(1303),
    [aux_sym_print_statement_token1] = ACTIONS(1303),
    [aux_sym_open_statement_token1] = ACTIONS(1303),
    [aux_sym_close_statement_token1] = ACTIONS(1303),
    [aux_sym_inquire_statement_token1] = ACTIONS(1303),
    [aux_sym_enum_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token2] = ACTIONS(1303),
    [aux_sym_file_position_statement_token3] = ACTIONS(1303),
    [aux_sym_file_position_statement_token4] = ACTIONS(1303),
    [aux_sym_logical_expression_token5] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_boolean_literal] = ACTIONS(1305),
    [aux_sym_null_literal_token1] = ACTIONS(1303),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1303),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1305),
    [sym__float_literal] = ACTIONS(1305),
    [sym__boz_literal] = ACTIONS(1305),
    [sym_string_literal] = ACTIONS(1305),
  },
  [305] = {
    [sym_preproc_file_line] = STATE(305),
    [aux_sym_end_program_statement_token1] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [aux_sym_interface_statement_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1307),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1307),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1307),
    [aux_sym_contains_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token2] = ACTIONS(1307),
    [aux_sym_implicit_statement_token1] = ACTIONS(1307),
    [aux_sym_implicit_statement_token3] = ACTIONS(1307),
    [aux_sym_implicit_statement_token4] = ACTIONS(1307),
    [aux_sym_save_statement_token1] = ACTIONS(1307),
    [aux_sym_private_statement_token1] = ACTIONS(1307),
    [aux_sym_public_statement_token1] = ACTIONS(1307),
    [aux_sym_namelist_statement_token1] = ACTIONS(1307),
    [aux_sym_common_statement_token1] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1309),
    [aux_sym_import_statement_token1] = ACTIONS(1307),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1307),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1307),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1307),
    [aux_sym_variable_attributes_token1] = ACTIONS(1307),
    [aux_sym_variable_attributes_token2] = ACTIONS(1307),
    [aux_sym_variable_attributes_token3] = ACTIONS(1307),
    [aux_sym_variable_attributes_token4] = ACTIONS(1307),
    [aux_sym_variable_attributes_token5] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1307),
    [aux_sym_derived_type_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token2] = ACTIONS(1307),
    [aux_sym_type_qualifier_token3] = ACTIONS(1307),
    [aux_sym_type_qualifier_token4] = ACTIONS(1307),
    [aux_sym_type_qualifier_token5] = ACTIONS(1307),
    [aux_sym_type_qualifier_token9] = ACTIONS(1307),
    [aux_sym_type_qualifier_token10] = ACTIONS(1307),
    [aux_sym_type_qualifier_token11] = ACTIONS(1307),
    [aux_sym_type_qualifier_token12] = ACTIONS(1307),
    [aux_sym_type_qualifier_token13] = ACTIONS(1307),
    [aux_sym_type_qualifier_token14] = ACTIONS(1307),
    [aux_sym_type_qualifier_token15] = ACTIONS(1307),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token2] = ACTIONS(1307),
    [aux_sym_subroutine_call_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token2] = ACTIONS(1307),
    [aux_sym_keyword_statement_token3] = ACTIONS(1307),
    [aux_sym_keyword_statement_token4] = ACTIONS(1307),
    [aux_sym_keyword_statement_token6] = ACTIONS(1307),
    [aux_sym_keyword_statement_token7] = ACTIONS(1307),
    [aux_sym_include_statement_token1] = ACTIONS(1307),
    [aux_sym_data_statement_token1] = ACTIONS(1307),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1307),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1307),
    [aux_sym_end_if_statement_token1] = ACTIONS(1307),
    [aux_sym_elseif_clause_token2] = ACTIONS(1307),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1307),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token3] = ACTIONS(1307),
    [aux_sym_select_type_statement_token1] = ACTIONS(1307),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1307),
    [aux_sym_block_construct_token1] = ACTIONS(1307),
    [aux_sym_associate_statement_token1] = ACTIONS(1307),
    [aux_sym_format_statement_token1] = ACTIONS(1307),
    [aux_sym_print_statement_token1] = ACTIONS(1307),
    [aux_sym_open_statement_token1] = ACTIONS(1307),
    [aux_sym_close_statement_token1] = ACTIONS(1307),
    [aux_sym_inquire_statement_token1] = ACTIONS(1307),
    [aux_sym_enum_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token2] = ACTIONS(1307),
    [aux_sym_file_position_statement_token3] = ACTIONS(1307),
    [aux_sym_file_position_statement_token4] = ACTIONS(1307),
    [aux_sym_logical_expression_token5] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [sym_boolean_literal] = ACTIONS(1309),
    [aux_sym_null_literal_token1] = ACTIONS(1307),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1307),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1309),
    [sym__float_literal] = ACTIONS(1309),
    [sym__boz_literal] = ACTIONS(1309),
    [sym_string_literal] = ACTIONS(1309),
  },
  [306] = {
    [sym_preproc_file_line] = STATE(306),
    [aux_sym_end_program_statement_token1] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_interface_statement_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1311),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1311),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1311),
    [aux_sym_contains_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token2] = ACTIONS(1311),
    [aux_sym_implicit_statement_token1] = ACTIONS(1311),
    [aux_sym_implicit_statement_token3] = ACTIONS(1311),
    [aux_sym_implicit_statement_token4] = ACTIONS(1311),
    [aux_sym_save_statement_token1] = ACTIONS(1311),
    [aux_sym_private_statement_token1] = ACTIONS(1311),
    [aux_sym_public_statement_token1] = ACTIONS(1311),
    [aux_sym_namelist_statement_token1] = ACTIONS(1311),
    [aux_sym_common_statement_token1] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1313),
    [aux_sym_import_statement_token1] = ACTIONS(1311),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1311),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1311),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1311),
    [aux_sym_variable_attributes_token1] = ACTIONS(1311),
    [aux_sym_variable_attributes_token2] = ACTIONS(1311),
    [aux_sym_variable_attributes_token3] = ACTIONS(1311),
    [aux_sym_variable_attributes_token4] = ACTIONS(1311),
    [aux_sym_variable_attributes_token5] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1311),
    [aux_sym_derived_type_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token2] = ACTIONS(1311),
    [aux_sym_type_qualifier_token3] = ACTIONS(1311),
    [aux_sym_type_qualifier_token4] = ACTIONS(1311),
    [aux_sym_type_qualifier_token5] = ACTIONS(1311),
    [aux_sym_type_qualifier_token9] = ACTIONS(1311),
    [aux_sym_type_qualifier_token10] = ACTIONS(1311),
    [aux_sym_type_qualifier_token11] = ACTIONS(1311),
    [aux_sym_type_qualifier_token12] = ACTIONS(1311),
    [aux_sym_type_qualifier_token13] = ACTIONS(1311),
    [aux_sym_type_qualifier_token14] = ACTIONS(1311),
    [aux_sym_type_qualifier_token15] = ACTIONS(1311),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token2] = ACTIONS(1311),
    [aux_sym_subroutine_call_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token2] = ACTIONS(1311),
    [aux_sym_keyword_statement_token3] = ACTIONS(1311),
    [aux_sym_keyword_statement_token4] = ACTIONS(1311),
    [aux_sym_keyword_statement_token6] = ACTIONS(1311),
    [aux_sym_keyword_statement_token7] = ACTIONS(1311),
    [aux_sym_include_statement_token1] = ACTIONS(1311),
    [aux_sym_data_statement_token1] = ACTIONS(1311),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1311),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1311),
    [aux_sym_end_if_statement_token1] = ACTIONS(1311),
    [aux_sym_elseif_clause_token2] = ACTIONS(1311),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token3] = ACTIONS(1311),
    [aux_sym_select_type_statement_token1] = ACTIONS(1311),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1311),
    [aux_sym_block_construct_token1] = ACTIONS(1311),
    [aux_sym_associate_statement_token1] = ACTIONS(1311),
    [aux_sym_format_statement_token1] = ACTIONS(1311),
    [aux_sym_print_statement_token1] = ACTIONS(1311),
    [aux_sym_open_statement_token1] = ACTIONS(1311),
    [aux_sym_close_statement_token1] = ACTIONS(1311),
    [aux_sym_inquire_statement_token1] = ACTIONS(1311),
    [aux_sym_enum_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token2] = ACTIONS(1311),
    [aux_sym_file_position_statement_token3] = ACTIONS(1311),
    [aux_sym_file_position_statement_token4] = ACTIONS(1311),
    [aux_sym_logical_expression_token5] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [sym_boolean_literal] = ACTIONS(1313),
    [aux_sym_null_literal_token1] = ACTIONS(1311),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1311),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1313),
    [sym__float_literal] = ACTIONS(1313),
    [sym__boz_literal] = ACTIONS(1313),
    [sym_string_literal] = ACTIONS(1313),
  },
  [307] = {
    [sym_preproc_file_line] = STATE(307),
    [aux_sym_end_program_statement_token1] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [aux_sym_interface_statement_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1315),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1315),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1315),
    [aux_sym_contains_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token2] = ACTIONS(1315),
    [aux_sym_implicit_statement_token1] = ACTIONS(1315),
    [aux_sym_implicit_statement_token3] = ACTIONS(1315),
    [aux_sym_implicit_statement_token4] = ACTIONS(1315),
    [aux_sym_save_statement_token1] = ACTIONS(1315),
    [aux_sym_private_statement_token1] = ACTIONS(1315),
    [aux_sym_public_statement_token1] = ACTIONS(1315),
    [aux_sym_namelist_statement_token1] = ACTIONS(1315),
    [aux_sym_common_statement_token1] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1317),
    [aux_sym_import_statement_token1] = ACTIONS(1315),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1315),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1315),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1315),
    [aux_sym_variable_attributes_token1] = ACTIONS(1315),
    [aux_sym_variable_attributes_token2] = ACTIONS(1315),
    [aux_sym_variable_attributes_token3] = ACTIONS(1315),
    [aux_sym_variable_attributes_token4] = ACTIONS(1315),
    [aux_sym_variable_attributes_token5] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1315),
    [aux_sym_derived_type_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token2] = ACTIONS(1315),
    [aux_sym_type_qualifier_token3] = ACTIONS(1315),
    [aux_sym_type_qualifier_token4] = ACTIONS(1315),
    [aux_sym_type_qualifier_token5] = ACTIONS(1315),
    [aux_sym_type_qualifier_token9] = ACTIONS(1315),
    [aux_sym_type_qualifier_token10] = ACTIONS(1315),
    [aux_sym_type_qualifier_token11] = ACTIONS(1315),
    [aux_sym_type_qualifier_token12] = ACTIONS(1315),
    [aux_sym_type_qualifier_token13] = ACTIONS(1315),
    [aux_sym_type_qualifier_token14] = ACTIONS(1315),
    [aux_sym_type_qualifier_token15] = ACTIONS(1315),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token2] = ACTIONS(1315),
    [aux_sym_subroutine_call_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token2] = ACTIONS(1315),
    [aux_sym_keyword_statement_token3] = ACTIONS(1315),
    [aux_sym_keyword_statement_token4] = ACTIONS(1315),
    [aux_sym_keyword_statement_token6] = ACTIONS(1315),
    [aux_sym_keyword_statement_token7] = ACTIONS(1315),
    [aux_sym_include_statement_token1] = ACTIONS(1315),
    [aux_sym_data_statement_token1] = ACTIONS(1315),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1315),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1315),
    [aux_sym_end_if_statement_token1] = ACTIONS(1315),
    [aux_sym_elseif_clause_token2] = ACTIONS(1315),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1315),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token3] = ACTIONS(1315),
    [aux_sym_select_type_statement_token1] = ACTIONS(1315),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1315),
    [aux_sym_block_construct_token1] = ACTIONS(1315),
    [aux_sym_associate_statement_token1] = ACTIONS(1315),
    [aux_sym_format_statement_token1] = ACTIONS(1315),
    [aux_sym_print_statement_token1] = ACTIONS(1315),
    [aux_sym_open_statement_token1] = ACTIONS(1315),
    [aux_sym_close_statement_token1] = ACTIONS(1315),
    [aux_sym_inquire_statement_token1] = ACTIONS(1315),
    [aux_sym_enum_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token2] = ACTIONS(1315),
    [aux_sym_file_position_statement_token3] = ACTIONS(1315),
    [aux_sym_file_position_statement_token4] = ACTIONS(1315),
    [aux_sym_logical_expression_token5] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1315),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [sym_boolean_literal] = ACTIONS(1317),
    [aux_sym_null_literal_token1] = ACTIONS(1315),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1315),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1317),
    [sym__float_literal] = ACTIONS(1317),
    [sym__boz_literal] = ACTIONS(1317),
    [sym_string_literal] = ACTIONS(1317),
  },
  [308] = {
    [sym_preproc_file_line] = STATE(308),
    [aux_sym_end_program_statement_token1] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [aux_sym_interface_statement_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1319),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1319),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1319),
    [aux_sym_contains_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token2] = ACTIONS(1319),
    [aux_sym_implicit_statement_token1] = ACTIONS(1319),
    [aux_sym_implicit_statement_token3] = ACTIONS(1319),
    [aux_sym_implicit_statement_token4] = ACTIONS(1319),
    [aux_sym_save_statement_token1] = ACTIONS(1319),
    [aux_sym_private_statement_token1] = ACTIONS(1319),
    [aux_sym_public_statement_token1] = ACTIONS(1319),
    [aux_sym_namelist_statement_token1] = ACTIONS(1319),
    [aux_sym_common_statement_token1] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [aux_sym_import_statement_token1] = ACTIONS(1319),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1319),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1319),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1319),
    [aux_sym_variable_attributes_token1] = ACTIONS(1319),
    [aux_sym_variable_attributes_token2] = ACTIONS(1319),
    [aux_sym_variable_attributes_token3] = ACTIONS(1319),
    [aux_sym_variable_attributes_token4] = ACTIONS(1319),
    [aux_sym_variable_attributes_token5] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1319),
    [aux_sym_derived_type_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token2] = ACTIONS(1319),
    [aux_sym_type_qualifier_token3] = ACTIONS(1319),
    [aux_sym_type_qualifier_token4] = ACTIONS(1319),
    [aux_sym_type_qualifier_token5] = ACTIONS(1319),
    [aux_sym_type_qualifier_token9] = ACTIONS(1319),
    [aux_sym_type_qualifier_token10] = ACTIONS(1319),
    [aux_sym_type_qualifier_token11] = ACTIONS(1319),
    [aux_sym_type_qualifier_token12] = ACTIONS(1319),
    [aux_sym_type_qualifier_token13] = ACTIONS(1319),
    [aux_sym_type_qualifier_token14] = ACTIONS(1319),
    [aux_sym_type_qualifier_token15] = ACTIONS(1319),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token2] = ACTIONS(1319),
    [aux_sym_subroutine_call_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token2] = ACTIONS(1319),
    [aux_sym_keyword_statement_token3] = ACTIONS(1319),
    [aux_sym_keyword_statement_token4] = ACTIONS(1319),
    [aux_sym_keyword_statement_token6] = ACTIONS(1319),
    [aux_sym_keyword_statement_token7] = ACTIONS(1319),
    [aux_sym_include_statement_token1] = ACTIONS(1319),
    [aux_sym_data_statement_token1] = ACTIONS(1319),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1319),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1319),
    [aux_sym_end_if_statement_token1] = ACTIONS(1319),
    [aux_sym_elseif_clause_token2] = ACTIONS(1319),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1319),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token3] = ACTIONS(1319),
    [aux_sym_select_type_statement_token1] = ACTIONS(1319),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1319),
    [aux_sym_block_construct_token1] = ACTIONS(1319),
    [aux_sym_associate_statement_token1] = ACTIONS(1319),
    [aux_sym_format_statement_token1] = ACTIONS(1319),
    [aux_sym_print_statement_token1] = ACTIONS(1319),
    [aux_sym_open_statement_token1] = ACTIONS(1319),
    [aux_sym_close_statement_token1] = ACTIONS(1319),
    [aux_sym_inquire_statement_token1] = ACTIONS(1319),
    [aux_sym_enum_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token2] = ACTIONS(1319),
    [aux_sym_file_position_statement_token3] = ACTIONS(1319),
    [aux_sym_file_position_statement_token4] = ACTIONS(1319),
    [aux_sym_logical_expression_token5] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [sym_boolean_literal] = ACTIONS(1321),
    [aux_sym_null_literal_token1] = ACTIONS(1319),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1319),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1321),
    [sym__float_literal] = ACTIONS(1321),
    [sym__boz_literal] = ACTIONS(1321),
    [sym_string_literal] = ACTIONS(1321),
  },
  [309] = {
    [sym_preproc_file_line] = STATE(309),
    [aux_sym_end_program_statement_token1] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [aux_sym_interface_statement_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1323),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1323),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1323),
    [aux_sym_contains_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token2] = ACTIONS(1323),
    [aux_sym_implicit_statement_token1] = ACTIONS(1323),
    [aux_sym_implicit_statement_token3] = ACTIONS(1323),
    [aux_sym_implicit_statement_token4] = ACTIONS(1323),
    [aux_sym_save_statement_token1] = ACTIONS(1323),
    [aux_sym_private_statement_token1] = ACTIONS(1323),
    [aux_sym_public_statement_token1] = ACTIONS(1323),
    [aux_sym_namelist_statement_token1] = ACTIONS(1323),
    [aux_sym_common_statement_token1] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1325),
    [aux_sym_import_statement_token1] = ACTIONS(1323),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1323),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1323),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1323),
    [aux_sym_variable_attributes_token1] = ACTIONS(1323),
    [aux_sym_variable_attributes_token2] = ACTIONS(1323),
    [aux_sym_variable_attributes_token3] = ACTIONS(1323),
    [aux_sym_variable_attributes_token4] = ACTIONS(1323),
    [aux_sym_variable_attributes_token5] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1323),
    [aux_sym_derived_type_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token2] = ACTIONS(1323),
    [aux_sym_type_qualifier_token3] = ACTIONS(1323),
    [aux_sym_type_qualifier_token4] = ACTIONS(1323),
    [aux_sym_type_qualifier_token5] = ACTIONS(1323),
    [aux_sym_type_qualifier_token9] = ACTIONS(1323),
    [aux_sym_type_qualifier_token10] = ACTIONS(1323),
    [aux_sym_type_qualifier_token11] = ACTIONS(1323),
    [aux_sym_type_qualifier_token12] = ACTIONS(1323),
    [aux_sym_type_qualifier_token13] = ACTIONS(1323),
    [aux_sym_type_qualifier_token14] = ACTIONS(1323),
    [aux_sym_type_qualifier_token15] = ACTIONS(1323),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token2] = ACTIONS(1323),
    [aux_sym_subroutine_call_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token2] = ACTIONS(1323),
    [aux_sym_keyword_statement_token3] = ACTIONS(1323),
    [aux_sym_keyword_statement_token4] = ACTIONS(1323),
    [aux_sym_keyword_statement_token6] = ACTIONS(1323),
    [aux_sym_keyword_statement_token7] = ACTIONS(1323),
    [aux_sym_include_statement_token1] = ACTIONS(1323),
    [aux_sym_data_statement_token1] = ACTIONS(1323),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1323),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1323),
    [aux_sym_end_if_statement_token1] = ACTIONS(1323),
    [aux_sym_elseif_clause_token2] = ACTIONS(1323),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1323),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token3] = ACTIONS(1323),
    [aux_sym_select_type_statement_token1] = ACTIONS(1323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1323),
    [aux_sym_block_construct_token1] = ACTIONS(1323),
    [aux_sym_associate_statement_token1] = ACTIONS(1323),
    [aux_sym_format_statement_token1] = ACTIONS(1323),
    [aux_sym_print_statement_token1] = ACTIONS(1323),
    [aux_sym_open_statement_token1] = ACTIONS(1323),
    [aux_sym_close_statement_token1] = ACTIONS(1323),
    [aux_sym_inquire_statement_token1] = ACTIONS(1323),
    [aux_sym_enum_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token2] = ACTIONS(1323),
    [aux_sym_file_position_statement_token3] = ACTIONS(1323),
    [aux_sym_file_position_statement_token4] = ACTIONS(1323),
    [aux_sym_logical_expression_token5] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [sym_boolean_literal] = ACTIONS(1325),
    [aux_sym_null_literal_token1] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1323),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1325),
    [sym__float_literal] = ACTIONS(1325),
    [sym__boz_literal] = ACTIONS(1325),
    [sym_string_literal] = ACTIONS(1325),
  },
  [310] = {
    [sym_preproc_file_line] = STATE(310),
    [aux_sym_end_program_statement_token1] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [aux_sym_interface_statement_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1327),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1327),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1327),
    [aux_sym_contains_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token2] = ACTIONS(1327),
    [aux_sym_implicit_statement_token1] = ACTIONS(1327),
    [aux_sym_implicit_statement_token3] = ACTIONS(1327),
    [aux_sym_implicit_statement_token4] = ACTIONS(1327),
    [aux_sym_save_statement_token1] = ACTIONS(1327),
    [aux_sym_private_statement_token1] = ACTIONS(1327),
    [aux_sym_public_statement_token1] = ACTIONS(1327),
    [aux_sym_namelist_statement_token1] = ACTIONS(1327),
    [aux_sym_common_statement_token1] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1329),
    [aux_sym_import_statement_token1] = ACTIONS(1327),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1327),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1327),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1327),
    [aux_sym_variable_attributes_token1] = ACTIONS(1327),
    [aux_sym_variable_attributes_token2] = ACTIONS(1327),
    [aux_sym_variable_attributes_token3] = ACTIONS(1327),
    [aux_sym_variable_attributes_token4] = ACTIONS(1327),
    [aux_sym_variable_attributes_token5] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1327),
    [aux_sym_derived_type_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token2] = ACTIONS(1327),
    [aux_sym_type_qualifier_token3] = ACTIONS(1327),
    [aux_sym_type_qualifier_token4] = ACTIONS(1327),
    [aux_sym_type_qualifier_token5] = ACTIONS(1327),
    [aux_sym_type_qualifier_token9] = ACTIONS(1327),
    [aux_sym_type_qualifier_token10] = ACTIONS(1327),
    [aux_sym_type_qualifier_token11] = ACTIONS(1327),
    [aux_sym_type_qualifier_token12] = ACTIONS(1327),
    [aux_sym_type_qualifier_token13] = ACTIONS(1327),
    [aux_sym_type_qualifier_token14] = ACTIONS(1327),
    [aux_sym_type_qualifier_token15] = ACTIONS(1327),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token2] = ACTIONS(1327),
    [aux_sym_subroutine_call_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token2] = ACTIONS(1327),
    [aux_sym_keyword_statement_token3] = ACTIONS(1327),
    [aux_sym_keyword_statement_token4] = ACTIONS(1327),
    [aux_sym_keyword_statement_token6] = ACTIONS(1327),
    [aux_sym_keyword_statement_token7] = ACTIONS(1327),
    [aux_sym_include_statement_token1] = ACTIONS(1327),
    [aux_sym_data_statement_token1] = ACTIONS(1327),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1327),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1327),
    [aux_sym_end_if_statement_token1] = ACTIONS(1327),
    [aux_sym_elseif_clause_token2] = ACTIONS(1327),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1327),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token3] = ACTIONS(1327),
    [aux_sym_select_type_statement_token1] = ACTIONS(1327),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1327),
    [aux_sym_block_construct_token1] = ACTIONS(1327),
    [aux_sym_associate_statement_token1] = ACTIONS(1327),
    [aux_sym_format_statement_token1] = ACTIONS(1327),
    [aux_sym_print_statement_token1] = ACTIONS(1327),
    [aux_sym_open_statement_token1] = ACTIONS(1327),
    [aux_sym_close_statement_token1] = ACTIONS(1327),
    [aux_sym_inquire_statement_token1] = ACTIONS(1327),
    [aux_sym_enum_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token2] = ACTIONS(1327),
    [aux_sym_file_position_statement_token3] = ACTIONS(1327),
    [aux_sym_file_position_statement_token4] = ACTIONS(1327),
    [aux_sym_logical_expression_token5] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_boolean_literal] = ACTIONS(1329),
    [aux_sym_null_literal_token1] = ACTIONS(1327),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1327),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1329),
    [sym__float_literal] = ACTIONS(1329),
    [sym__boz_literal] = ACTIONS(1329),
    [sym_string_literal] = ACTIONS(1329),
  },
  [311] = {
    [sym_preproc_file_line] = STATE(311),
    [aux_sym_end_program_statement_token1] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1331),
    [aux_sym_interface_statement_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1331),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1331),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1331),
    [aux_sym_contains_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token2] = ACTIONS(1331),
    [aux_sym_implicit_statement_token1] = ACTIONS(1331),
    [aux_sym_implicit_statement_token3] = ACTIONS(1331),
    [aux_sym_implicit_statement_token4] = ACTIONS(1331),
    [aux_sym_save_statement_token1] = ACTIONS(1331),
    [aux_sym_private_statement_token1] = ACTIONS(1331),
    [aux_sym_public_statement_token1] = ACTIONS(1331),
    [aux_sym_namelist_statement_token1] = ACTIONS(1331),
    [aux_sym_common_statement_token1] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [aux_sym_import_statement_token1] = ACTIONS(1331),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1331),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1331),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1331),
    [aux_sym_variable_attributes_token1] = ACTIONS(1331),
    [aux_sym_variable_attributes_token2] = ACTIONS(1331),
    [aux_sym_variable_attributes_token3] = ACTIONS(1331),
    [aux_sym_variable_attributes_token4] = ACTIONS(1331),
    [aux_sym_variable_attributes_token5] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1331),
    [aux_sym_derived_type_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token2] = ACTIONS(1331),
    [aux_sym_type_qualifier_token3] = ACTIONS(1331),
    [aux_sym_type_qualifier_token4] = ACTIONS(1331),
    [aux_sym_type_qualifier_token5] = ACTIONS(1331),
    [aux_sym_type_qualifier_token9] = ACTIONS(1331),
    [aux_sym_type_qualifier_token10] = ACTIONS(1331),
    [aux_sym_type_qualifier_token11] = ACTIONS(1331),
    [aux_sym_type_qualifier_token12] = ACTIONS(1331),
    [aux_sym_type_qualifier_token13] = ACTIONS(1331),
    [aux_sym_type_qualifier_token14] = ACTIONS(1331),
    [aux_sym_type_qualifier_token15] = ACTIONS(1331),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token2] = ACTIONS(1331),
    [aux_sym_subroutine_call_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token2] = ACTIONS(1331),
    [aux_sym_keyword_statement_token3] = ACTIONS(1331),
    [aux_sym_keyword_statement_token4] = ACTIONS(1331),
    [aux_sym_keyword_statement_token6] = ACTIONS(1331),
    [aux_sym_keyword_statement_token7] = ACTIONS(1331),
    [aux_sym_include_statement_token1] = ACTIONS(1331),
    [aux_sym_data_statement_token1] = ACTIONS(1331),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1331),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1331),
    [aux_sym_end_if_statement_token1] = ACTIONS(1331),
    [aux_sym_elseif_clause_token2] = ACTIONS(1331),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1331),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token3] = ACTIONS(1331),
    [aux_sym_select_type_statement_token1] = ACTIONS(1331),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1331),
    [aux_sym_block_construct_token1] = ACTIONS(1331),
    [aux_sym_associate_statement_token1] = ACTIONS(1331),
    [aux_sym_format_statement_token1] = ACTIONS(1331),
    [aux_sym_print_statement_token1] = ACTIONS(1331),
    [aux_sym_open_statement_token1] = ACTIONS(1331),
    [aux_sym_close_statement_token1] = ACTIONS(1331),
    [aux_sym_inquire_statement_token1] = ACTIONS(1331),
    [aux_sym_enum_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token2] = ACTIONS(1331),
    [aux_sym_file_position_statement_token3] = ACTIONS(1331),
    [aux_sym_file_position_statement_token4] = ACTIONS(1331),
    [aux_sym_logical_expression_token5] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [sym_boolean_literal] = ACTIONS(1333),
    [aux_sym_null_literal_token1] = ACTIONS(1331),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1331),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1333),
    [sym__float_literal] = ACTIONS(1333),
    [sym__boz_literal] = ACTIONS(1333),
    [sym_string_literal] = ACTIONS(1333),
  },
  [312] = {
    [sym_preproc_file_line] = STATE(312),
    [aux_sym_end_program_statement_token1] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [aux_sym_interface_statement_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1335),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1335),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1335),
    [aux_sym_contains_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token2] = ACTIONS(1335),
    [aux_sym_implicit_statement_token1] = ACTIONS(1335),
    [aux_sym_implicit_statement_token3] = ACTIONS(1335),
    [aux_sym_implicit_statement_token4] = ACTIONS(1335),
    [aux_sym_save_statement_token1] = ACTIONS(1335),
    [aux_sym_private_statement_token1] = ACTIONS(1335),
    [aux_sym_public_statement_token1] = ACTIONS(1335),
    [aux_sym_namelist_statement_token1] = ACTIONS(1335),
    [aux_sym_common_statement_token1] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [aux_sym_import_statement_token1] = ACTIONS(1335),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1335),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1335),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1335),
    [aux_sym_variable_attributes_token1] = ACTIONS(1335),
    [aux_sym_variable_attributes_token2] = ACTIONS(1335),
    [aux_sym_variable_attributes_token3] = ACTIONS(1335),
    [aux_sym_variable_attributes_token4] = ACTIONS(1335),
    [aux_sym_variable_attributes_token5] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1335),
    [aux_sym_derived_type_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token2] = ACTIONS(1335),
    [aux_sym_type_qualifier_token3] = ACTIONS(1335),
    [aux_sym_type_qualifier_token4] = ACTIONS(1335),
    [aux_sym_type_qualifier_token5] = ACTIONS(1335),
    [aux_sym_type_qualifier_token9] = ACTIONS(1335),
    [aux_sym_type_qualifier_token10] = ACTIONS(1335),
    [aux_sym_type_qualifier_token11] = ACTIONS(1335),
    [aux_sym_type_qualifier_token12] = ACTIONS(1335),
    [aux_sym_type_qualifier_token13] = ACTIONS(1335),
    [aux_sym_type_qualifier_token14] = ACTIONS(1335),
    [aux_sym_type_qualifier_token15] = ACTIONS(1335),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token2] = ACTIONS(1335),
    [aux_sym_subroutine_call_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token2] = ACTIONS(1335),
    [aux_sym_keyword_statement_token3] = ACTIONS(1335),
    [aux_sym_keyword_statement_token4] = ACTIONS(1335),
    [aux_sym_keyword_statement_token6] = ACTIONS(1335),
    [aux_sym_keyword_statement_token7] = ACTIONS(1335),
    [aux_sym_include_statement_token1] = ACTIONS(1335),
    [aux_sym_data_statement_token1] = ACTIONS(1335),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1335),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1335),
    [aux_sym_end_if_statement_token1] = ACTIONS(1335),
    [aux_sym_elseif_clause_token2] = ACTIONS(1335),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1335),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token3] = ACTIONS(1335),
    [aux_sym_select_type_statement_token1] = ACTIONS(1335),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1335),
    [aux_sym_block_construct_token1] = ACTIONS(1335),
    [aux_sym_associate_statement_token1] = ACTIONS(1335),
    [aux_sym_format_statement_token1] = ACTIONS(1335),
    [aux_sym_print_statement_token1] = ACTIONS(1335),
    [aux_sym_open_statement_token1] = ACTIONS(1335),
    [aux_sym_close_statement_token1] = ACTIONS(1335),
    [aux_sym_inquire_statement_token1] = ACTIONS(1335),
    [aux_sym_enum_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token2] = ACTIONS(1335),
    [aux_sym_file_position_statement_token3] = ACTIONS(1335),
    [aux_sym_file_position_statement_token4] = ACTIONS(1335),
    [aux_sym_logical_expression_token5] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [sym_boolean_literal] = ACTIONS(1337),
    [aux_sym_null_literal_token1] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1335),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1337),
    [sym__float_literal] = ACTIONS(1337),
    [sym__boz_literal] = ACTIONS(1337),
    [sym_string_literal] = ACTIONS(1337),
  },
  [313] = {
    [sym_preproc_file_line] = STATE(313),
    [aux_sym_end_program_statement_token1] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [aux_sym_interface_statement_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1339),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1339),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1339),
    [aux_sym_contains_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token2] = ACTIONS(1339),
    [aux_sym_implicit_statement_token1] = ACTIONS(1339),
    [aux_sym_implicit_statement_token3] = ACTIONS(1339),
    [aux_sym_implicit_statement_token4] = ACTIONS(1339),
    [aux_sym_save_statement_token1] = ACTIONS(1339),
    [aux_sym_private_statement_token1] = ACTIONS(1339),
    [aux_sym_public_statement_token1] = ACTIONS(1339),
    [aux_sym_namelist_statement_token1] = ACTIONS(1339),
    [aux_sym_common_statement_token1] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1341),
    [aux_sym_import_statement_token1] = ACTIONS(1339),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1339),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1339),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1339),
    [aux_sym_variable_attributes_token1] = ACTIONS(1339),
    [aux_sym_variable_attributes_token2] = ACTIONS(1339),
    [aux_sym_variable_attributes_token3] = ACTIONS(1339),
    [aux_sym_variable_attributes_token4] = ACTIONS(1339),
    [aux_sym_variable_attributes_token5] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1339),
    [aux_sym_derived_type_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token2] = ACTIONS(1339),
    [aux_sym_type_qualifier_token3] = ACTIONS(1339),
    [aux_sym_type_qualifier_token4] = ACTIONS(1339),
    [aux_sym_type_qualifier_token5] = ACTIONS(1339),
    [aux_sym_type_qualifier_token9] = ACTIONS(1339),
    [aux_sym_type_qualifier_token10] = ACTIONS(1339),
    [aux_sym_type_qualifier_token11] = ACTIONS(1339),
    [aux_sym_type_qualifier_token12] = ACTIONS(1339),
    [aux_sym_type_qualifier_token13] = ACTIONS(1339),
    [aux_sym_type_qualifier_token14] = ACTIONS(1339),
    [aux_sym_type_qualifier_token15] = ACTIONS(1339),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token2] = ACTIONS(1339),
    [aux_sym_subroutine_call_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token2] = ACTIONS(1339),
    [aux_sym_keyword_statement_token3] = ACTIONS(1339),
    [aux_sym_keyword_statement_token4] = ACTIONS(1339),
    [aux_sym_keyword_statement_token6] = ACTIONS(1339),
    [aux_sym_keyword_statement_token7] = ACTIONS(1339),
    [aux_sym_include_statement_token1] = ACTIONS(1339),
    [aux_sym_data_statement_token1] = ACTIONS(1339),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1339),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1339),
    [aux_sym_end_if_statement_token1] = ACTIONS(1339),
    [aux_sym_elseif_clause_token2] = ACTIONS(1339),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1339),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token3] = ACTIONS(1339),
    [aux_sym_select_type_statement_token1] = ACTIONS(1339),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1339),
    [aux_sym_block_construct_token1] = ACTIONS(1339),
    [aux_sym_associate_statement_token1] = ACTIONS(1339),
    [aux_sym_format_statement_token1] = ACTIONS(1339),
    [aux_sym_print_statement_token1] = ACTIONS(1339),
    [aux_sym_open_statement_token1] = ACTIONS(1339),
    [aux_sym_close_statement_token1] = ACTIONS(1339),
    [aux_sym_inquire_statement_token1] = ACTIONS(1339),
    [aux_sym_enum_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token2] = ACTIONS(1339),
    [aux_sym_file_position_statement_token3] = ACTIONS(1339),
    [aux_sym_file_position_statement_token4] = ACTIONS(1339),
    [aux_sym_logical_expression_token5] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [sym_boolean_literal] = ACTIONS(1341),
    [aux_sym_null_literal_token1] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1339),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1341),
    [sym__float_literal] = ACTIONS(1341),
    [sym__boz_literal] = ACTIONS(1341),
    [sym_string_literal] = ACTIONS(1341),
  },
  [314] = {
    [sym_preproc_file_line] = STATE(314),
    [aux_sym_end_program_statement_token1] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [aux_sym_interface_statement_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1279),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1279),
    [aux_sym_end_function_statement_token1] = ACTIONS(1279),
    [aux_sym_contains_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token2] = ACTIONS(1279),
    [aux_sym_implicit_statement_token1] = ACTIONS(1279),
    [aux_sym_implicit_statement_token3] = ACTIONS(1279),
    [aux_sym_implicit_statement_token4] = ACTIONS(1279),
    [aux_sym_save_statement_token1] = ACTIONS(1279),
    [aux_sym_private_statement_token1] = ACTIONS(1279),
    [aux_sym_public_statement_token1] = ACTIONS(1279),
    [aux_sym_namelist_statement_token1] = ACTIONS(1279),
    [aux_sym_common_statement_token1] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1281),
    [aux_sym_import_statement_token1] = ACTIONS(1279),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1279),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1279),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1279),
    [aux_sym_variable_attributes_token1] = ACTIONS(1279),
    [aux_sym_variable_attributes_token2] = ACTIONS(1279),
    [aux_sym_variable_attributes_token3] = ACTIONS(1279),
    [aux_sym_variable_attributes_token4] = ACTIONS(1279),
    [aux_sym_variable_attributes_token5] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1279),
    [aux_sym_derived_type_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token2] = ACTIONS(1279),
    [aux_sym_type_qualifier_token3] = ACTIONS(1279),
    [aux_sym_type_qualifier_token4] = ACTIONS(1279),
    [aux_sym_type_qualifier_token5] = ACTIONS(1279),
    [aux_sym_type_qualifier_token9] = ACTIONS(1279),
    [aux_sym_type_qualifier_token10] = ACTIONS(1279),
    [aux_sym_type_qualifier_token11] = ACTIONS(1279),
    [aux_sym_type_qualifier_token12] = ACTIONS(1279),
    [aux_sym_type_qualifier_token13] = ACTIONS(1279),
    [aux_sym_type_qualifier_token14] = ACTIONS(1279),
    [aux_sym_type_qualifier_token15] = ACTIONS(1279),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token2] = ACTIONS(1279),
    [aux_sym_subroutine_call_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token2] = ACTIONS(1279),
    [aux_sym_keyword_statement_token3] = ACTIONS(1279),
    [aux_sym_keyword_statement_token4] = ACTIONS(1279),
    [aux_sym_keyword_statement_token6] = ACTIONS(1279),
    [aux_sym_keyword_statement_token7] = ACTIONS(1279),
    [aux_sym_include_statement_token1] = ACTIONS(1279),
    [aux_sym_data_statement_token1] = ACTIONS(1279),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1279),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1279),
    [aux_sym_end_if_statement_token1] = ACTIONS(1279),
    [aux_sym_elseif_clause_token2] = ACTIONS(1279),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1279),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token3] = ACTIONS(1279),
    [aux_sym_select_type_statement_token1] = ACTIONS(1279),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1279),
    [aux_sym_block_construct_token1] = ACTIONS(1279),
    [aux_sym_associate_statement_token1] = ACTIONS(1279),
    [aux_sym_format_statement_token1] = ACTIONS(1279),
    [aux_sym_print_statement_token1] = ACTIONS(1279),
    [aux_sym_open_statement_token1] = ACTIONS(1279),
    [aux_sym_close_statement_token1] = ACTIONS(1279),
    [aux_sym_inquire_statement_token1] = ACTIONS(1279),
    [aux_sym_enum_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token2] = ACTIONS(1279),
    [aux_sym_file_position_statement_token3] = ACTIONS(1279),
    [aux_sym_file_position_statement_token4] = ACTIONS(1279),
    [aux_sym_logical_expression_token5] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [sym_boolean_literal] = ACTIONS(1281),
    [aux_sym_null_literal_token1] = ACTIONS(1279),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1279),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1281),
    [sym__float_literal] = ACTIONS(1281),
    [sym__boz_literal] = ACTIONS(1281),
    [sym_string_literal] = ACTIONS(1281),
  },
  [315] = {
    [sym_preproc_file_line] = STATE(315),
    [aux_sym_end_program_statement_token1] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [aux_sym_interface_statement_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1283),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1283),
    [aux_sym_end_function_statement_token1] = ACTIONS(1283),
    [aux_sym_contains_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token2] = ACTIONS(1283),
    [aux_sym_implicit_statement_token1] = ACTIONS(1283),
    [aux_sym_implicit_statement_token3] = ACTIONS(1283),
    [aux_sym_implicit_statement_token4] = ACTIONS(1283),
    [aux_sym_save_statement_token1] = ACTIONS(1283),
    [aux_sym_private_statement_token1] = ACTIONS(1283),
    [aux_sym_public_statement_token1] = ACTIONS(1283),
    [aux_sym_namelist_statement_token1] = ACTIONS(1283),
    [aux_sym_common_statement_token1] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1285),
    [aux_sym_import_statement_token1] = ACTIONS(1283),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1283),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1283),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1283),
    [aux_sym_variable_attributes_token1] = ACTIONS(1283),
    [aux_sym_variable_attributes_token2] = ACTIONS(1283),
    [aux_sym_variable_attributes_token3] = ACTIONS(1283),
    [aux_sym_variable_attributes_token4] = ACTIONS(1283),
    [aux_sym_variable_attributes_token5] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1283),
    [aux_sym_derived_type_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token2] = ACTIONS(1283),
    [aux_sym_type_qualifier_token3] = ACTIONS(1283),
    [aux_sym_type_qualifier_token4] = ACTIONS(1283),
    [aux_sym_type_qualifier_token5] = ACTIONS(1283),
    [aux_sym_type_qualifier_token9] = ACTIONS(1283),
    [aux_sym_type_qualifier_token10] = ACTIONS(1283),
    [aux_sym_type_qualifier_token11] = ACTIONS(1283),
    [aux_sym_type_qualifier_token12] = ACTIONS(1283),
    [aux_sym_type_qualifier_token13] = ACTIONS(1283),
    [aux_sym_type_qualifier_token14] = ACTIONS(1283),
    [aux_sym_type_qualifier_token15] = ACTIONS(1283),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token2] = ACTIONS(1283),
    [aux_sym_subroutine_call_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token2] = ACTIONS(1283),
    [aux_sym_keyword_statement_token3] = ACTIONS(1283),
    [aux_sym_keyword_statement_token4] = ACTIONS(1283),
    [aux_sym_keyword_statement_token6] = ACTIONS(1283),
    [aux_sym_keyword_statement_token7] = ACTIONS(1283),
    [aux_sym_include_statement_token1] = ACTIONS(1283),
    [aux_sym_data_statement_token1] = ACTIONS(1283),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1283),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1283),
    [aux_sym_end_if_statement_token1] = ACTIONS(1283),
    [aux_sym_elseif_clause_token2] = ACTIONS(1283),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1283),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token3] = ACTIONS(1283),
    [aux_sym_select_type_statement_token1] = ACTIONS(1283),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1283),
    [aux_sym_block_construct_token1] = ACTIONS(1283),
    [aux_sym_associate_statement_token1] = ACTIONS(1283),
    [aux_sym_format_statement_token1] = ACTIONS(1283),
    [aux_sym_print_statement_token1] = ACTIONS(1283),
    [aux_sym_open_statement_token1] = ACTIONS(1283),
    [aux_sym_close_statement_token1] = ACTIONS(1283),
    [aux_sym_inquire_statement_token1] = ACTIONS(1283),
    [aux_sym_enum_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token2] = ACTIONS(1283),
    [aux_sym_file_position_statement_token3] = ACTIONS(1283),
    [aux_sym_file_position_statement_token4] = ACTIONS(1283),
    [aux_sym_logical_expression_token5] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [sym_boolean_literal] = ACTIONS(1285),
    [aux_sym_null_literal_token1] = ACTIONS(1283),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1285),
    [sym__float_literal] = ACTIONS(1285),
    [sym__boz_literal] = ACTIONS(1285),
    [sym_string_literal] = ACTIONS(1285),
  },
  [316] = {
    [sym_preproc_file_line] = STATE(316),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_contains_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [317] = {
    [sym_preproc_file_line] = STATE(317),
    [aux_sym_end_program_statement_token1] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [aux_sym_interface_statement_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1275),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1275),
    [aux_sym_end_function_statement_token1] = ACTIONS(1275),
    [aux_sym_contains_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token2] = ACTIONS(1275),
    [aux_sym_implicit_statement_token1] = ACTIONS(1275),
    [aux_sym_implicit_statement_token3] = ACTIONS(1275),
    [aux_sym_implicit_statement_token4] = ACTIONS(1275),
    [aux_sym_save_statement_token1] = ACTIONS(1275),
    [aux_sym_private_statement_token1] = ACTIONS(1275),
    [aux_sym_public_statement_token1] = ACTIONS(1275),
    [aux_sym_namelist_statement_token1] = ACTIONS(1275),
    [aux_sym_common_statement_token1] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1277),
    [aux_sym_import_statement_token1] = ACTIONS(1275),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1275),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1275),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1275),
    [aux_sym_variable_attributes_token1] = ACTIONS(1275),
    [aux_sym_variable_attributes_token2] = ACTIONS(1275),
    [aux_sym_variable_attributes_token3] = ACTIONS(1275),
    [aux_sym_variable_attributes_token4] = ACTIONS(1275),
    [aux_sym_variable_attributes_token5] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1275),
    [aux_sym_derived_type_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token2] = ACTIONS(1275),
    [aux_sym_type_qualifier_token3] = ACTIONS(1275),
    [aux_sym_type_qualifier_token4] = ACTIONS(1275),
    [aux_sym_type_qualifier_token5] = ACTIONS(1275),
    [aux_sym_type_qualifier_token9] = ACTIONS(1275),
    [aux_sym_type_qualifier_token10] = ACTIONS(1275),
    [aux_sym_type_qualifier_token11] = ACTIONS(1275),
    [aux_sym_type_qualifier_token12] = ACTIONS(1275),
    [aux_sym_type_qualifier_token13] = ACTIONS(1275),
    [aux_sym_type_qualifier_token14] = ACTIONS(1275),
    [aux_sym_type_qualifier_token15] = ACTIONS(1275),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token2] = ACTIONS(1275),
    [aux_sym_subroutine_call_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token2] = ACTIONS(1275),
    [aux_sym_keyword_statement_token3] = ACTIONS(1275),
    [aux_sym_keyword_statement_token4] = ACTIONS(1275),
    [aux_sym_keyword_statement_token6] = ACTIONS(1275),
    [aux_sym_keyword_statement_token7] = ACTIONS(1275),
    [aux_sym_include_statement_token1] = ACTIONS(1275),
    [aux_sym_data_statement_token1] = ACTIONS(1275),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1275),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1275),
    [aux_sym_end_if_statement_token1] = ACTIONS(1275),
    [aux_sym_elseif_clause_token2] = ACTIONS(1275),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1275),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token3] = ACTIONS(1275),
    [aux_sym_select_type_statement_token1] = ACTIONS(1275),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1275),
    [aux_sym_block_construct_token1] = ACTIONS(1275),
    [aux_sym_associate_statement_token1] = ACTIONS(1275),
    [aux_sym_format_statement_token1] = ACTIONS(1275),
    [aux_sym_print_statement_token1] = ACTIONS(1275),
    [aux_sym_open_statement_token1] = ACTIONS(1275),
    [aux_sym_close_statement_token1] = ACTIONS(1275),
    [aux_sym_inquire_statement_token1] = ACTIONS(1275),
    [aux_sym_enum_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token2] = ACTIONS(1275),
    [aux_sym_file_position_statement_token3] = ACTIONS(1275),
    [aux_sym_file_position_statement_token4] = ACTIONS(1275),
    [aux_sym_logical_expression_token5] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [sym_boolean_literal] = ACTIONS(1277),
    [aux_sym_null_literal_token1] = ACTIONS(1275),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1275),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1277),
    [sym__float_literal] = ACTIONS(1277),
    [sym__boz_literal] = ACTIONS(1277),
    [sym_string_literal] = ACTIONS(1277),
  },
  [318] = {
    [sym_preproc_file_line] = STATE(318),
    [aux_sym_end_program_statement_token1] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [aux_sym_interface_statement_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1287),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1287),
    [aux_sym_end_function_statement_token1] = ACTIONS(1287),
    [aux_sym_contains_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token2] = ACTIONS(1287),
    [aux_sym_implicit_statement_token1] = ACTIONS(1287),
    [aux_sym_implicit_statement_token3] = ACTIONS(1287),
    [aux_sym_implicit_statement_token4] = ACTIONS(1287),
    [aux_sym_save_statement_token1] = ACTIONS(1287),
    [aux_sym_private_statement_token1] = ACTIONS(1287),
    [aux_sym_public_statement_token1] = ACTIONS(1287),
    [aux_sym_namelist_statement_token1] = ACTIONS(1287),
    [aux_sym_common_statement_token1] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1289),
    [aux_sym_import_statement_token1] = ACTIONS(1287),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1287),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1287),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1287),
    [aux_sym_variable_attributes_token1] = ACTIONS(1287),
    [aux_sym_variable_attributes_token2] = ACTIONS(1287),
    [aux_sym_variable_attributes_token3] = ACTIONS(1287),
    [aux_sym_variable_attributes_token4] = ACTIONS(1287),
    [aux_sym_variable_attributes_token5] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1287),
    [aux_sym_derived_type_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token2] = ACTIONS(1287),
    [aux_sym_type_qualifier_token3] = ACTIONS(1287),
    [aux_sym_type_qualifier_token4] = ACTIONS(1287),
    [aux_sym_type_qualifier_token5] = ACTIONS(1287),
    [aux_sym_type_qualifier_token9] = ACTIONS(1287),
    [aux_sym_type_qualifier_token10] = ACTIONS(1287),
    [aux_sym_type_qualifier_token11] = ACTIONS(1287),
    [aux_sym_type_qualifier_token12] = ACTIONS(1287),
    [aux_sym_type_qualifier_token13] = ACTIONS(1287),
    [aux_sym_type_qualifier_token14] = ACTIONS(1287),
    [aux_sym_type_qualifier_token15] = ACTIONS(1287),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token2] = ACTIONS(1287),
    [aux_sym_subroutine_call_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token2] = ACTIONS(1287),
    [aux_sym_keyword_statement_token3] = ACTIONS(1287),
    [aux_sym_keyword_statement_token4] = ACTIONS(1287),
    [aux_sym_keyword_statement_token6] = ACTIONS(1287),
    [aux_sym_keyword_statement_token7] = ACTIONS(1287),
    [aux_sym_include_statement_token1] = ACTIONS(1287),
    [aux_sym_data_statement_token1] = ACTIONS(1287),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1287),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1287),
    [aux_sym_end_if_statement_token1] = ACTIONS(1287),
    [aux_sym_elseif_clause_token2] = ACTIONS(1287),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1287),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token3] = ACTIONS(1287),
    [aux_sym_select_type_statement_token1] = ACTIONS(1287),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1287),
    [aux_sym_block_construct_token1] = ACTIONS(1287),
    [aux_sym_associate_statement_token1] = ACTIONS(1287),
    [aux_sym_format_statement_token1] = ACTIONS(1287),
    [aux_sym_print_statement_token1] = ACTIONS(1287),
    [aux_sym_open_statement_token1] = ACTIONS(1287),
    [aux_sym_close_statement_token1] = ACTIONS(1287),
    [aux_sym_inquire_statement_token1] = ACTIONS(1287),
    [aux_sym_enum_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token2] = ACTIONS(1287),
    [aux_sym_file_position_statement_token3] = ACTIONS(1287),
    [aux_sym_file_position_statement_token4] = ACTIONS(1287),
    [aux_sym_logical_expression_token5] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [sym_boolean_literal] = ACTIONS(1289),
    [aux_sym_null_literal_token1] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1287),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1289),
    [sym__float_literal] = ACTIONS(1289),
    [sym__boz_literal] = ACTIONS(1289),
    [sym_string_literal] = ACTIONS(1289),
  },
  [319] = {
    [sym_preproc_file_line] = STATE(319),
    [aux_sym_end_program_statement_token1] = ACTIONS(1303),
    [aux_sym_end_program_statement_token2] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_interface_statement_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1303),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1303),
    [aux_sym_contains_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token2] = ACTIONS(1303),
    [aux_sym_implicit_statement_token1] = ACTIONS(1303),
    [aux_sym_implicit_statement_token3] = ACTIONS(1303),
    [aux_sym_implicit_statement_token4] = ACTIONS(1303),
    [aux_sym_save_statement_token1] = ACTIONS(1303),
    [aux_sym_private_statement_token1] = ACTIONS(1303),
    [aux_sym_public_statement_token1] = ACTIONS(1303),
    [aux_sym_namelist_statement_token1] = ACTIONS(1303),
    [aux_sym_common_statement_token1] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1305),
    [aux_sym_import_statement_token1] = ACTIONS(1303),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1303),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1303),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1303),
    [aux_sym_variable_attributes_token1] = ACTIONS(1303),
    [aux_sym_variable_attributes_token2] = ACTIONS(1303),
    [aux_sym_variable_attributes_token3] = ACTIONS(1303),
    [aux_sym_variable_attributes_token4] = ACTIONS(1303),
    [aux_sym_variable_attributes_token5] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1303),
    [aux_sym_derived_type_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token2] = ACTIONS(1303),
    [aux_sym_type_qualifier_token3] = ACTIONS(1303),
    [aux_sym_type_qualifier_token4] = ACTIONS(1303),
    [aux_sym_type_qualifier_token5] = ACTIONS(1303),
    [aux_sym_type_qualifier_token9] = ACTIONS(1303),
    [aux_sym_type_qualifier_token10] = ACTIONS(1303),
    [aux_sym_type_qualifier_token11] = ACTIONS(1303),
    [aux_sym_type_qualifier_token12] = ACTIONS(1303),
    [aux_sym_type_qualifier_token13] = ACTIONS(1303),
    [aux_sym_type_qualifier_token14] = ACTIONS(1303),
    [aux_sym_type_qualifier_token15] = ACTIONS(1303),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token2] = ACTIONS(1303),
    [aux_sym_subroutine_call_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token2] = ACTIONS(1303),
    [aux_sym_keyword_statement_token3] = ACTIONS(1303),
    [aux_sym_keyword_statement_token4] = ACTIONS(1303),
    [aux_sym_keyword_statement_token6] = ACTIONS(1303),
    [aux_sym_keyword_statement_token7] = ACTIONS(1303),
    [aux_sym_include_statement_token1] = ACTIONS(1303),
    [aux_sym_data_statement_token1] = ACTIONS(1303),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1303),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1303),
    [aux_sym_end_if_statement_token1] = ACTIONS(1303),
    [aux_sym_elseif_clause_token2] = ACTIONS(1303),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1303),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token3] = ACTIONS(1303),
    [aux_sym_select_type_statement_token1] = ACTIONS(1303),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1303),
    [aux_sym_block_construct_token1] = ACTIONS(1303),
    [aux_sym_associate_statement_token1] = ACTIONS(1303),
    [aux_sym_format_statement_token1] = ACTIONS(1303),
    [aux_sym_print_statement_token1] = ACTIONS(1303),
    [aux_sym_open_statement_token1] = ACTIONS(1303),
    [aux_sym_close_statement_token1] = ACTIONS(1303),
    [aux_sym_inquire_statement_token1] = ACTIONS(1303),
    [aux_sym_enum_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token2] = ACTIONS(1303),
    [aux_sym_file_position_statement_token3] = ACTIONS(1303),
    [aux_sym_file_position_statement_token4] = ACTIONS(1303),
    [aux_sym_logical_expression_token5] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_boolean_literal] = ACTIONS(1305),
    [aux_sym_null_literal_token1] = ACTIONS(1303),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1303),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1305),
    [sym__float_literal] = ACTIONS(1305),
    [sym__boz_literal] = ACTIONS(1305),
    [sym_string_literal] = ACTIONS(1305),
  },
  [320] = {
    [sym_preproc_file_line] = STATE(320),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_contains_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [321] = {
    [sym_preproc_file_line] = STATE(321),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_contains_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [322] = {
    [sym_preproc_file_line] = STATE(322),
    [aux_sym_end_program_statement_token1] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [aux_sym_interface_statement_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1295),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1295),
    [aux_sym_end_function_statement_token1] = ACTIONS(1295),
    [aux_sym_contains_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token2] = ACTIONS(1295),
    [aux_sym_implicit_statement_token1] = ACTIONS(1295),
    [aux_sym_implicit_statement_token3] = ACTIONS(1295),
    [aux_sym_implicit_statement_token4] = ACTIONS(1295),
    [aux_sym_save_statement_token1] = ACTIONS(1295),
    [aux_sym_private_statement_token1] = ACTIONS(1295),
    [aux_sym_public_statement_token1] = ACTIONS(1295),
    [aux_sym_namelist_statement_token1] = ACTIONS(1295),
    [aux_sym_common_statement_token1] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1297),
    [aux_sym_import_statement_token1] = ACTIONS(1295),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1295),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1295),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1295),
    [aux_sym_variable_attributes_token1] = ACTIONS(1295),
    [aux_sym_variable_attributes_token2] = ACTIONS(1295),
    [aux_sym_variable_attributes_token3] = ACTIONS(1295),
    [aux_sym_variable_attributes_token4] = ACTIONS(1295),
    [aux_sym_variable_attributes_token5] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1295),
    [aux_sym_derived_type_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token2] = ACTIONS(1295),
    [aux_sym_type_qualifier_token3] = ACTIONS(1295),
    [aux_sym_type_qualifier_token4] = ACTIONS(1295),
    [aux_sym_type_qualifier_token5] = ACTIONS(1295),
    [aux_sym_type_qualifier_token9] = ACTIONS(1295),
    [aux_sym_type_qualifier_token10] = ACTIONS(1295),
    [aux_sym_type_qualifier_token11] = ACTIONS(1295),
    [aux_sym_type_qualifier_token12] = ACTIONS(1295),
    [aux_sym_type_qualifier_token13] = ACTIONS(1295),
    [aux_sym_type_qualifier_token14] = ACTIONS(1295),
    [aux_sym_type_qualifier_token15] = ACTIONS(1295),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token2] = ACTIONS(1295),
    [aux_sym_subroutine_call_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token2] = ACTIONS(1295),
    [aux_sym_keyword_statement_token3] = ACTIONS(1295),
    [aux_sym_keyword_statement_token4] = ACTIONS(1295),
    [aux_sym_keyword_statement_token6] = ACTIONS(1295),
    [aux_sym_keyword_statement_token7] = ACTIONS(1295),
    [aux_sym_include_statement_token1] = ACTIONS(1295),
    [aux_sym_data_statement_token1] = ACTIONS(1295),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1295),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1295),
    [aux_sym_end_if_statement_token1] = ACTIONS(1295),
    [aux_sym_elseif_clause_token2] = ACTIONS(1295),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1295),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token3] = ACTIONS(1295),
    [aux_sym_select_type_statement_token1] = ACTIONS(1295),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1295),
    [aux_sym_block_construct_token1] = ACTIONS(1295),
    [aux_sym_associate_statement_token1] = ACTIONS(1295),
    [aux_sym_format_statement_token1] = ACTIONS(1295),
    [aux_sym_print_statement_token1] = ACTIONS(1295),
    [aux_sym_open_statement_token1] = ACTIONS(1295),
    [aux_sym_close_statement_token1] = ACTIONS(1295),
    [aux_sym_inquire_statement_token1] = ACTIONS(1295),
    [aux_sym_enum_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token2] = ACTIONS(1295),
    [aux_sym_file_position_statement_token3] = ACTIONS(1295),
    [aux_sym_file_position_statement_token4] = ACTIONS(1295),
    [aux_sym_logical_expression_token5] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1295),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_boolean_literal] = ACTIONS(1297),
    [aux_sym_null_literal_token1] = ACTIONS(1295),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1295),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1297),
    [sym__float_literal] = ACTIONS(1297),
    [sym__boz_literal] = ACTIONS(1297),
    [sym_string_literal] = ACTIONS(1297),
  },
  [323] = {
    [sym_preproc_file_line] = STATE(323),
    [aux_sym_end_program_statement_token1] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [aux_sym_interface_statement_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1299),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1299),
    [aux_sym_end_function_statement_token1] = ACTIONS(1299),
    [aux_sym_contains_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token2] = ACTIONS(1299),
    [aux_sym_implicit_statement_token1] = ACTIONS(1299),
    [aux_sym_implicit_statement_token3] = ACTIONS(1299),
    [aux_sym_implicit_statement_token4] = ACTIONS(1299),
    [aux_sym_save_statement_token1] = ACTIONS(1299),
    [aux_sym_private_statement_token1] = ACTIONS(1299),
    [aux_sym_public_statement_token1] = ACTIONS(1299),
    [aux_sym_namelist_statement_token1] = ACTIONS(1299),
    [aux_sym_common_statement_token1] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1301),
    [aux_sym_import_statement_token1] = ACTIONS(1299),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1299),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1299),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1299),
    [aux_sym_variable_attributes_token1] = ACTIONS(1299),
    [aux_sym_variable_attributes_token2] = ACTIONS(1299),
    [aux_sym_variable_attributes_token3] = ACTIONS(1299),
    [aux_sym_variable_attributes_token4] = ACTIONS(1299),
    [aux_sym_variable_attributes_token5] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1299),
    [aux_sym_derived_type_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token2] = ACTIONS(1299),
    [aux_sym_type_qualifier_token3] = ACTIONS(1299),
    [aux_sym_type_qualifier_token4] = ACTIONS(1299),
    [aux_sym_type_qualifier_token5] = ACTIONS(1299),
    [aux_sym_type_qualifier_token9] = ACTIONS(1299),
    [aux_sym_type_qualifier_token10] = ACTIONS(1299),
    [aux_sym_type_qualifier_token11] = ACTIONS(1299),
    [aux_sym_type_qualifier_token12] = ACTIONS(1299),
    [aux_sym_type_qualifier_token13] = ACTIONS(1299),
    [aux_sym_type_qualifier_token14] = ACTIONS(1299),
    [aux_sym_type_qualifier_token15] = ACTIONS(1299),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token2] = ACTIONS(1299),
    [aux_sym_subroutine_call_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token2] = ACTIONS(1299),
    [aux_sym_keyword_statement_token3] = ACTIONS(1299),
    [aux_sym_keyword_statement_token4] = ACTIONS(1299),
    [aux_sym_keyword_statement_token6] = ACTIONS(1299),
    [aux_sym_keyword_statement_token7] = ACTIONS(1299),
    [aux_sym_include_statement_token1] = ACTIONS(1299),
    [aux_sym_data_statement_token1] = ACTIONS(1299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1299),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1299),
    [aux_sym_end_if_statement_token1] = ACTIONS(1299),
    [aux_sym_elseif_clause_token2] = ACTIONS(1299),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1299),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token3] = ACTIONS(1299),
    [aux_sym_select_type_statement_token1] = ACTIONS(1299),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1299),
    [aux_sym_block_construct_token1] = ACTIONS(1299),
    [aux_sym_associate_statement_token1] = ACTIONS(1299),
    [aux_sym_format_statement_token1] = ACTIONS(1299),
    [aux_sym_print_statement_token1] = ACTIONS(1299),
    [aux_sym_open_statement_token1] = ACTIONS(1299),
    [aux_sym_close_statement_token1] = ACTIONS(1299),
    [aux_sym_inquire_statement_token1] = ACTIONS(1299),
    [aux_sym_enum_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token2] = ACTIONS(1299),
    [aux_sym_file_position_statement_token3] = ACTIONS(1299),
    [aux_sym_file_position_statement_token4] = ACTIONS(1299),
    [aux_sym_logical_expression_token5] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [sym_boolean_literal] = ACTIONS(1301),
    [aux_sym_null_literal_token1] = ACTIONS(1299),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1299),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1301),
    [sym__float_literal] = ACTIONS(1301),
    [sym__boz_literal] = ACTIONS(1301),
    [sym_string_literal] = ACTIONS(1301),
  },
  [324] = {
    [sym_preproc_file_line] = STATE(324),
    [aux_sym_end_program_statement_token1] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [aux_sym_interface_statement_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1291),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1291),
    [aux_sym_end_function_statement_token1] = ACTIONS(1291),
    [aux_sym_contains_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token2] = ACTIONS(1291),
    [aux_sym_implicit_statement_token1] = ACTIONS(1291),
    [aux_sym_implicit_statement_token3] = ACTIONS(1291),
    [aux_sym_implicit_statement_token4] = ACTIONS(1291),
    [aux_sym_save_statement_token1] = ACTIONS(1291),
    [aux_sym_private_statement_token1] = ACTIONS(1291),
    [aux_sym_public_statement_token1] = ACTIONS(1291),
    [aux_sym_namelist_statement_token1] = ACTIONS(1291),
    [aux_sym_common_statement_token1] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1293),
    [aux_sym_import_statement_token1] = ACTIONS(1291),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1291),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1291),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1291),
    [aux_sym_variable_attributes_token1] = ACTIONS(1291),
    [aux_sym_variable_attributes_token2] = ACTIONS(1291),
    [aux_sym_variable_attributes_token3] = ACTIONS(1291),
    [aux_sym_variable_attributes_token4] = ACTIONS(1291),
    [aux_sym_variable_attributes_token5] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1291),
    [aux_sym_derived_type_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token2] = ACTIONS(1291),
    [aux_sym_type_qualifier_token3] = ACTIONS(1291),
    [aux_sym_type_qualifier_token4] = ACTIONS(1291),
    [aux_sym_type_qualifier_token5] = ACTIONS(1291),
    [aux_sym_type_qualifier_token9] = ACTIONS(1291),
    [aux_sym_type_qualifier_token10] = ACTIONS(1291),
    [aux_sym_type_qualifier_token11] = ACTIONS(1291),
    [aux_sym_type_qualifier_token12] = ACTIONS(1291),
    [aux_sym_type_qualifier_token13] = ACTIONS(1291),
    [aux_sym_type_qualifier_token14] = ACTIONS(1291),
    [aux_sym_type_qualifier_token15] = ACTIONS(1291),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token2] = ACTIONS(1291),
    [aux_sym_subroutine_call_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token2] = ACTIONS(1291),
    [aux_sym_keyword_statement_token3] = ACTIONS(1291),
    [aux_sym_keyword_statement_token4] = ACTIONS(1291),
    [aux_sym_keyword_statement_token6] = ACTIONS(1291),
    [aux_sym_keyword_statement_token7] = ACTIONS(1291),
    [aux_sym_include_statement_token1] = ACTIONS(1291),
    [aux_sym_data_statement_token1] = ACTIONS(1291),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1291),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1291),
    [aux_sym_end_if_statement_token1] = ACTIONS(1291),
    [aux_sym_elseif_clause_token2] = ACTIONS(1291),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1291),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token3] = ACTIONS(1291),
    [aux_sym_select_type_statement_token1] = ACTIONS(1291),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1291),
    [aux_sym_block_construct_token1] = ACTIONS(1291),
    [aux_sym_associate_statement_token1] = ACTIONS(1291),
    [aux_sym_format_statement_token1] = ACTIONS(1291),
    [aux_sym_print_statement_token1] = ACTIONS(1291),
    [aux_sym_open_statement_token1] = ACTIONS(1291),
    [aux_sym_close_statement_token1] = ACTIONS(1291),
    [aux_sym_inquire_statement_token1] = ACTIONS(1291),
    [aux_sym_enum_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token2] = ACTIONS(1291),
    [aux_sym_file_position_statement_token3] = ACTIONS(1291),
    [aux_sym_file_position_statement_token4] = ACTIONS(1291),
    [aux_sym_logical_expression_token5] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [sym_boolean_literal] = ACTIONS(1293),
    [aux_sym_null_literal_token1] = ACTIONS(1291),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1291),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1293),
    [sym__float_literal] = ACTIONS(1293),
    [sym__boz_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
  },
  [325] = {
    [sym_preproc_file_line] = STATE(325),
    [aux_sym_end_program_statement_token1] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_interface_statement_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1303),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1303),
    [aux_sym_end_function_statement_token1] = ACTIONS(1303),
    [aux_sym_contains_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token2] = ACTIONS(1303),
    [aux_sym_implicit_statement_token1] = ACTIONS(1303),
    [aux_sym_implicit_statement_token3] = ACTIONS(1303),
    [aux_sym_implicit_statement_token4] = ACTIONS(1303),
    [aux_sym_save_statement_token1] = ACTIONS(1303),
    [aux_sym_private_statement_token1] = ACTIONS(1303),
    [aux_sym_public_statement_token1] = ACTIONS(1303),
    [aux_sym_namelist_statement_token1] = ACTIONS(1303),
    [aux_sym_common_statement_token1] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1305),
    [aux_sym_import_statement_token1] = ACTIONS(1303),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1303),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1303),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1303),
    [aux_sym_variable_attributes_token1] = ACTIONS(1303),
    [aux_sym_variable_attributes_token2] = ACTIONS(1303),
    [aux_sym_variable_attributes_token3] = ACTIONS(1303),
    [aux_sym_variable_attributes_token4] = ACTIONS(1303),
    [aux_sym_variable_attributes_token5] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1303),
    [aux_sym_derived_type_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token2] = ACTIONS(1303),
    [aux_sym_type_qualifier_token3] = ACTIONS(1303),
    [aux_sym_type_qualifier_token4] = ACTIONS(1303),
    [aux_sym_type_qualifier_token5] = ACTIONS(1303),
    [aux_sym_type_qualifier_token9] = ACTIONS(1303),
    [aux_sym_type_qualifier_token10] = ACTIONS(1303),
    [aux_sym_type_qualifier_token11] = ACTIONS(1303),
    [aux_sym_type_qualifier_token12] = ACTIONS(1303),
    [aux_sym_type_qualifier_token13] = ACTIONS(1303),
    [aux_sym_type_qualifier_token14] = ACTIONS(1303),
    [aux_sym_type_qualifier_token15] = ACTIONS(1303),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token2] = ACTIONS(1303),
    [aux_sym_subroutine_call_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token2] = ACTIONS(1303),
    [aux_sym_keyword_statement_token3] = ACTIONS(1303),
    [aux_sym_keyword_statement_token4] = ACTIONS(1303),
    [aux_sym_keyword_statement_token6] = ACTIONS(1303),
    [aux_sym_keyword_statement_token7] = ACTIONS(1303),
    [aux_sym_include_statement_token1] = ACTIONS(1303),
    [aux_sym_data_statement_token1] = ACTIONS(1303),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1303),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1303),
    [aux_sym_end_if_statement_token1] = ACTIONS(1303),
    [aux_sym_elseif_clause_token2] = ACTIONS(1303),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1303),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token3] = ACTIONS(1303),
    [aux_sym_select_type_statement_token1] = ACTIONS(1303),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1303),
    [aux_sym_block_construct_token1] = ACTIONS(1303),
    [aux_sym_associate_statement_token1] = ACTIONS(1303),
    [aux_sym_format_statement_token1] = ACTIONS(1303),
    [aux_sym_print_statement_token1] = ACTIONS(1303),
    [aux_sym_open_statement_token1] = ACTIONS(1303),
    [aux_sym_close_statement_token1] = ACTIONS(1303),
    [aux_sym_inquire_statement_token1] = ACTIONS(1303),
    [aux_sym_enum_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token2] = ACTIONS(1303),
    [aux_sym_file_position_statement_token3] = ACTIONS(1303),
    [aux_sym_file_position_statement_token4] = ACTIONS(1303),
    [aux_sym_logical_expression_token5] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_boolean_literal] = ACTIONS(1305),
    [aux_sym_null_literal_token1] = ACTIONS(1303),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1303),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1305),
    [sym__float_literal] = ACTIONS(1305),
    [sym__boz_literal] = ACTIONS(1305),
    [sym_string_literal] = ACTIONS(1305),
  },
  [326] = {
    [sym_preproc_file_line] = STATE(326),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_contains_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [327] = {
    [sym_preproc_file_line] = STATE(327),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_contains_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [328] = {
    [sym_preproc_file_line] = STATE(328),
    [aux_sym_end_program_statement_token1] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [aux_sym_interface_statement_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1307),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1307),
    [aux_sym_end_function_statement_token1] = ACTIONS(1307),
    [aux_sym_contains_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token2] = ACTIONS(1307),
    [aux_sym_implicit_statement_token1] = ACTIONS(1307),
    [aux_sym_implicit_statement_token3] = ACTIONS(1307),
    [aux_sym_implicit_statement_token4] = ACTIONS(1307),
    [aux_sym_save_statement_token1] = ACTIONS(1307),
    [aux_sym_private_statement_token1] = ACTIONS(1307),
    [aux_sym_public_statement_token1] = ACTIONS(1307),
    [aux_sym_namelist_statement_token1] = ACTIONS(1307),
    [aux_sym_common_statement_token1] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1309),
    [aux_sym_import_statement_token1] = ACTIONS(1307),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1307),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1307),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1307),
    [aux_sym_variable_attributes_token1] = ACTIONS(1307),
    [aux_sym_variable_attributes_token2] = ACTIONS(1307),
    [aux_sym_variable_attributes_token3] = ACTIONS(1307),
    [aux_sym_variable_attributes_token4] = ACTIONS(1307),
    [aux_sym_variable_attributes_token5] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1307),
    [aux_sym_derived_type_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token2] = ACTIONS(1307),
    [aux_sym_type_qualifier_token3] = ACTIONS(1307),
    [aux_sym_type_qualifier_token4] = ACTIONS(1307),
    [aux_sym_type_qualifier_token5] = ACTIONS(1307),
    [aux_sym_type_qualifier_token9] = ACTIONS(1307),
    [aux_sym_type_qualifier_token10] = ACTIONS(1307),
    [aux_sym_type_qualifier_token11] = ACTIONS(1307),
    [aux_sym_type_qualifier_token12] = ACTIONS(1307),
    [aux_sym_type_qualifier_token13] = ACTIONS(1307),
    [aux_sym_type_qualifier_token14] = ACTIONS(1307),
    [aux_sym_type_qualifier_token15] = ACTIONS(1307),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token2] = ACTIONS(1307),
    [aux_sym_subroutine_call_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token2] = ACTIONS(1307),
    [aux_sym_keyword_statement_token3] = ACTIONS(1307),
    [aux_sym_keyword_statement_token4] = ACTIONS(1307),
    [aux_sym_keyword_statement_token6] = ACTIONS(1307),
    [aux_sym_keyword_statement_token7] = ACTIONS(1307),
    [aux_sym_include_statement_token1] = ACTIONS(1307),
    [aux_sym_data_statement_token1] = ACTIONS(1307),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1307),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1307),
    [aux_sym_end_if_statement_token1] = ACTIONS(1307),
    [aux_sym_elseif_clause_token2] = ACTIONS(1307),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1307),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token3] = ACTIONS(1307),
    [aux_sym_select_type_statement_token1] = ACTIONS(1307),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1307),
    [aux_sym_block_construct_token1] = ACTIONS(1307),
    [aux_sym_associate_statement_token1] = ACTIONS(1307),
    [aux_sym_format_statement_token1] = ACTIONS(1307),
    [aux_sym_print_statement_token1] = ACTIONS(1307),
    [aux_sym_open_statement_token1] = ACTIONS(1307),
    [aux_sym_close_statement_token1] = ACTIONS(1307),
    [aux_sym_inquire_statement_token1] = ACTIONS(1307),
    [aux_sym_enum_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token2] = ACTIONS(1307),
    [aux_sym_file_position_statement_token3] = ACTIONS(1307),
    [aux_sym_file_position_statement_token4] = ACTIONS(1307),
    [aux_sym_logical_expression_token5] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [sym_boolean_literal] = ACTIONS(1309),
    [aux_sym_null_literal_token1] = ACTIONS(1307),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1307),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1309),
    [sym__float_literal] = ACTIONS(1309),
    [sym__boz_literal] = ACTIONS(1309),
    [sym_string_literal] = ACTIONS(1309),
  },
  [329] = {
    [sym_preproc_file_line] = STATE(329),
    [aux_sym_end_program_statement_token1] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_interface_statement_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1311),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1311),
    [aux_sym_end_function_statement_token1] = ACTIONS(1311),
    [aux_sym_contains_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token2] = ACTIONS(1311),
    [aux_sym_implicit_statement_token1] = ACTIONS(1311),
    [aux_sym_implicit_statement_token3] = ACTIONS(1311),
    [aux_sym_implicit_statement_token4] = ACTIONS(1311),
    [aux_sym_save_statement_token1] = ACTIONS(1311),
    [aux_sym_private_statement_token1] = ACTIONS(1311),
    [aux_sym_public_statement_token1] = ACTIONS(1311),
    [aux_sym_namelist_statement_token1] = ACTIONS(1311),
    [aux_sym_common_statement_token1] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1313),
    [aux_sym_import_statement_token1] = ACTIONS(1311),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1311),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1311),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1311),
    [aux_sym_variable_attributes_token1] = ACTIONS(1311),
    [aux_sym_variable_attributes_token2] = ACTIONS(1311),
    [aux_sym_variable_attributes_token3] = ACTIONS(1311),
    [aux_sym_variable_attributes_token4] = ACTIONS(1311),
    [aux_sym_variable_attributes_token5] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1311),
    [aux_sym_derived_type_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token2] = ACTIONS(1311),
    [aux_sym_type_qualifier_token3] = ACTIONS(1311),
    [aux_sym_type_qualifier_token4] = ACTIONS(1311),
    [aux_sym_type_qualifier_token5] = ACTIONS(1311),
    [aux_sym_type_qualifier_token9] = ACTIONS(1311),
    [aux_sym_type_qualifier_token10] = ACTIONS(1311),
    [aux_sym_type_qualifier_token11] = ACTIONS(1311),
    [aux_sym_type_qualifier_token12] = ACTIONS(1311),
    [aux_sym_type_qualifier_token13] = ACTIONS(1311),
    [aux_sym_type_qualifier_token14] = ACTIONS(1311),
    [aux_sym_type_qualifier_token15] = ACTIONS(1311),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token2] = ACTIONS(1311),
    [aux_sym_subroutine_call_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token2] = ACTIONS(1311),
    [aux_sym_keyword_statement_token3] = ACTIONS(1311),
    [aux_sym_keyword_statement_token4] = ACTIONS(1311),
    [aux_sym_keyword_statement_token6] = ACTIONS(1311),
    [aux_sym_keyword_statement_token7] = ACTIONS(1311),
    [aux_sym_include_statement_token1] = ACTIONS(1311),
    [aux_sym_data_statement_token1] = ACTIONS(1311),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1311),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1311),
    [aux_sym_end_if_statement_token1] = ACTIONS(1311),
    [aux_sym_elseif_clause_token2] = ACTIONS(1311),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token3] = ACTIONS(1311),
    [aux_sym_select_type_statement_token1] = ACTIONS(1311),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1311),
    [aux_sym_block_construct_token1] = ACTIONS(1311),
    [aux_sym_associate_statement_token1] = ACTIONS(1311),
    [aux_sym_format_statement_token1] = ACTIONS(1311),
    [aux_sym_print_statement_token1] = ACTIONS(1311),
    [aux_sym_open_statement_token1] = ACTIONS(1311),
    [aux_sym_close_statement_token1] = ACTIONS(1311),
    [aux_sym_inquire_statement_token1] = ACTIONS(1311),
    [aux_sym_enum_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token2] = ACTIONS(1311),
    [aux_sym_file_position_statement_token3] = ACTIONS(1311),
    [aux_sym_file_position_statement_token4] = ACTIONS(1311),
    [aux_sym_logical_expression_token5] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [sym_boolean_literal] = ACTIONS(1313),
    [aux_sym_null_literal_token1] = ACTIONS(1311),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1311),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1313),
    [sym__float_literal] = ACTIONS(1313),
    [sym__boz_literal] = ACTIONS(1313),
    [sym_string_literal] = ACTIONS(1313),
  },
  [330] = {
    [sym_preproc_file_line] = STATE(330),
    [aux_sym_end_program_statement_token1] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [aux_sym_interface_statement_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1315),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1315),
    [aux_sym_end_function_statement_token1] = ACTIONS(1315),
    [aux_sym_contains_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token2] = ACTIONS(1315),
    [aux_sym_implicit_statement_token1] = ACTIONS(1315),
    [aux_sym_implicit_statement_token3] = ACTIONS(1315),
    [aux_sym_implicit_statement_token4] = ACTIONS(1315),
    [aux_sym_save_statement_token1] = ACTIONS(1315),
    [aux_sym_private_statement_token1] = ACTIONS(1315),
    [aux_sym_public_statement_token1] = ACTIONS(1315),
    [aux_sym_namelist_statement_token1] = ACTIONS(1315),
    [aux_sym_common_statement_token1] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1317),
    [aux_sym_import_statement_token1] = ACTIONS(1315),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1315),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1315),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1315),
    [aux_sym_variable_attributes_token1] = ACTIONS(1315),
    [aux_sym_variable_attributes_token2] = ACTIONS(1315),
    [aux_sym_variable_attributes_token3] = ACTIONS(1315),
    [aux_sym_variable_attributes_token4] = ACTIONS(1315),
    [aux_sym_variable_attributes_token5] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1315),
    [aux_sym_derived_type_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token2] = ACTIONS(1315),
    [aux_sym_type_qualifier_token3] = ACTIONS(1315),
    [aux_sym_type_qualifier_token4] = ACTIONS(1315),
    [aux_sym_type_qualifier_token5] = ACTIONS(1315),
    [aux_sym_type_qualifier_token9] = ACTIONS(1315),
    [aux_sym_type_qualifier_token10] = ACTIONS(1315),
    [aux_sym_type_qualifier_token11] = ACTIONS(1315),
    [aux_sym_type_qualifier_token12] = ACTIONS(1315),
    [aux_sym_type_qualifier_token13] = ACTIONS(1315),
    [aux_sym_type_qualifier_token14] = ACTIONS(1315),
    [aux_sym_type_qualifier_token15] = ACTIONS(1315),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token2] = ACTIONS(1315),
    [aux_sym_subroutine_call_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token2] = ACTIONS(1315),
    [aux_sym_keyword_statement_token3] = ACTIONS(1315),
    [aux_sym_keyword_statement_token4] = ACTIONS(1315),
    [aux_sym_keyword_statement_token6] = ACTIONS(1315),
    [aux_sym_keyword_statement_token7] = ACTIONS(1315),
    [aux_sym_include_statement_token1] = ACTIONS(1315),
    [aux_sym_data_statement_token1] = ACTIONS(1315),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1315),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1315),
    [aux_sym_end_if_statement_token1] = ACTIONS(1315),
    [aux_sym_elseif_clause_token2] = ACTIONS(1315),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1315),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token3] = ACTIONS(1315),
    [aux_sym_select_type_statement_token1] = ACTIONS(1315),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1315),
    [aux_sym_block_construct_token1] = ACTIONS(1315),
    [aux_sym_associate_statement_token1] = ACTIONS(1315),
    [aux_sym_format_statement_token1] = ACTIONS(1315),
    [aux_sym_print_statement_token1] = ACTIONS(1315),
    [aux_sym_open_statement_token1] = ACTIONS(1315),
    [aux_sym_close_statement_token1] = ACTIONS(1315),
    [aux_sym_inquire_statement_token1] = ACTIONS(1315),
    [aux_sym_enum_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token2] = ACTIONS(1315),
    [aux_sym_file_position_statement_token3] = ACTIONS(1315),
    [aux_sym_file_position_statement_token4] = ACTIONS(1315),
    [aux_sym_logical_expression_token5] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1315),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [sym_boolean_literal] = ACTIONS(1317),
    [aux_sym_null_literal_token1] = ACTIONS(1315),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1315),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1317),
    [sym__float_literal] = ACTIONS(1317),
    [sym__boz_literal] = ACTIONS(1317),
    [sym_string_literal] = ACTIONS(1317),
  },
  [331] = {
    [sym_preproc_file_line] = STATE(331),
    [aux_sym_end_program_statement_token1] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [aux_sym_interface_statement_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1319),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1319),
    [aux_sym_end_function_statement_token1] = ACTIONS(1319),
    [aux_sym_contains_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token2] = ACTIONS(1319),
    [aux_sym_implicit_statement_token1] = ACTIONS(1319),
    [aux_sym_implicit_statement_token3] = ACTIONS(1319),
    [aux_sym_implicit_statement_token4] = ACTIONS(1319),
    [aux_sym_save_statement_token1] = ACTIONS(1319),
    [aux_sym_private_statement_token1] = ACTIONS(1319),
    [aux_sym_public_statement_token1] = ACTIONS(1319),
    [aux_sym_namelist_statement_token1] = ACTIONS(1319),
    [aux_sym_common_statement_token1] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [aux_sym_import_statement_token1] = ACTIONS(1319),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1319),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1319),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1319),
    [aux_sym_variable_attributes_token1] = ACTIONS(1319),
    [aux_sym_variable_attributes_token2] = ACTIONS(1319),
    [aux_sym_variable_attributes_token3] = ACTIONS(1319),
    [aux_sym_variable_attributes_token4] = ACTIONS(1319),
    [aux_sym_variable_attributes_token5] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1319),
    [aux_sym_derived_type_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token2] = ACTIONS(1319),
    [aux_sym_type_qualifier_token3] = ACTIONS(1319),
    [aux_sym_type_qualifier_token4] = ACTIONS(1319),
    [aux_sym_type_qualifier_token5] = ACTIONS(1319),
    [aux_sym_type_qualifier_token9] = ACTIONS(1319),
    [aux_sym_type_qualifier_token10] = ACTIONS(1319),
    [aux_sym_type_qualifier_token11] = ACTIONS(1319),
    [aux_sym_type_qualifier_token12] = ACTIONS(1319),
    [aux_sym_type_qualifier_token13] = ACTIONS(1319),
    [aux_sym_type_qualifier_token14] = ACTIONS(1319),
    [aux_sym_type_qualifier_token15] = ACTIONS(1319),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token2] = ACTIONS(1319),
    [aux_sym_subroutine_call_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token2] = ACTIONS(1319),
    [aux_sym_keyword_statement_token3] = ACTIONS(1319),
    [aux_sym_keyword_statement_token4] = ACTIONS(1319),
    [aux_sym_keyword_statement_token6] = ACTIONS(1319),
    [aux_sym_keyword_statement_token7] = ACTIONS(1319),
    [aux_sym_include_statement_token1] = ACTIONS(1319),
    [aux_sym_data_statement_token1] = ACTIONS(1319),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1319),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1319),
    [aux_sym_end_if_statement_token1] = ACTIONS(1319),
    [aux_sym_elseif_clause_token2] = ACTIONS(1319),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1319),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token3] = ACTIONS(1319),
    [aux_sym_select_type_statement_token1] = ACTIONS(1319),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1319),
    [aux_sym_block_construct_token1] = ACTIONS(1319),
    [aux_sym_associate_statement_token1] = ACTIONS(1319),
    [aux_sym_format_statement_token1] = ACTIONS(1319),
    [aux_sym_print_statement_token1] = ACTIONS(1319),
    [aux_sym_open_statement_token1] = ACTIONS(1319),
    [aux_sym_close_statement_token1] = ACTIONS(1319),
    [aux_sym_inquire_statement_token1] = ACTIONS(1319),
    [aux_sym_enum_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token2] = ACTIONS(1319),
    [aux_sym_file_position_statement_token3] = ACTIONS(1319),
    [aux_sym_file_position_statement_token4] = ACTIONS(1319),
    [aux_sym_logical_expression_token5] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [sym_boolean_literal] = ACTIONS(1321),
    [aux_sym_null_literal_token1] = ACTIONS(1319),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1319),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1321),
    [sym__float_literal] = ACTIONS(1321),
    [sym__boz_literal] = ACTIONS(1321),
    [sym_string_literal] = ACTIONS(1321),
  },
  [332] = {
    [sym_preproc_file_line] = STATE(332),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_end_subroutine_statement_token1] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_contains_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [333] = {
    [sym_preproc_file_line] = STATE(333),
    [aux_sym_end_program_statement_token1] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [aux_sym_interface_statement_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1323),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1323),
    [aux_sym_end_function_statement_token1] = ACTIONS(1323),
    [aux_sym_contains_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token2] = ACTIONS(1323),
    [aux_sym_implicit_statement_token1] = ACTIONS(1323),
    [aux_sym_implicit_statement_token3] = ACTIONS(1323),
    [aux_sym_implicit_statement_token4] = ACTIONS(1323),
    [aux_sym_save_statement_token1] = ACTIONS(1323),
    [aux_sym_private_statement_token1] = ACTIONS(1323),
    [aux_sym_public_statement_token1] = ACTIONS(1323),
    [aux_sym_namelist_statement_token1] = ACTIONS(1323),
    [aux_sym_common_statement_token1] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1325),
    [aux_sym_import_statement_token1] = ACTIONS(1323),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1323),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1323),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1323),
    [aux_sym_variable_attributes_token1] = ACTIONS(1323),
    [aux_sym_variable_attributes_token2] = ACTIONS(1323),
    [aux_sym_variable_attributes_token3] = ACTIONS(1323),
    [aux_sym_variable_attributes_token4] = ACTIONS(1323),
    [aux_sym_variable_attributes_token5] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1323),
    [aux_sym_derived_type_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token2] = ACTIONS(1323),
    [aux_sym_type_qualifier_token3] = ACTIONS(1323),
    [aux_sym_type_qualifier_token4] = ACTIONS(1323),
    [aux_sym_type_qualifier_token5] = ACTIONS(1323),
    [aux_sym_type_qualifier_token9] = ACTIONS(1323),
    [aux_sym_type_qualifier_token10] = ACTIONS(1323),
    [aux_sym_type_qualifier_token11] = ACTIONS(1323),
    [aux_sym_type_qualifier_token12] = ACTIONS(1323),
    [aux_sym_type_qualifier_token13] = ACTIONS(1323),
    [aux_sym_type_qualifier_token14] = ACTIONS(1323),
    [aux_sym_type_qualifier_token15] = ACTIONS(1323),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token2] = ACTIONS(1323),
    [aux_sym_subroutine_call_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token2] = ACTIONS(1323),
    [aux_sym_keyword_statement_token3] = ACTIONS(1323),
    [aux_sym_keyword_statement_token4] = ACTIONS(1323),
    [aux_sym_keyword_statement_token6] = ACTIONS(1323),
    [aux_sym_keyword_statement_token7] = ACTIONS(1323),
    [aux_sym_include_statement_token1] = ACTIONS(1323),
    [aux_sym_data_statement_token1] = ACTIONS(1323),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1323),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1323),
    [aux_sym_end_if_statement_token1] = ACTIONS(1323),
    [aux_sym_elseif_clause_token2] = ACTIONS(1323),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1323),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token3] = ACTIONS(1323),
    [aux_sym_select_type_statement_token1] = ACTIONS(1323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1323),
    [aux_sym_block_construct_token1] = ACTIONS(1323),
    [aux_sym_associate_statement_token1] = ACTIONS(1323),
    [aux_sym_format_statement_token1] = ACTIONS(1323),
    [aux_sym_print_statement_token1] = ACTIONS(1323),
    [aux_sym_open_statement_token1] = ACTIONS(1323),
    [aux_sym_close_statement_token1] = ACTIONS(1323),
    [aux_sym_inquire_statement_token1] = ACTIONS(1323),
    [aux_sym_enum_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token2] = ACTIONS(1323),
    [aux_sym_file_position_statement_token3] = ACTIONS(1323),
    [aux_sym_file_position_statement_token4] = ACTIONS(1323),
    [aux_sym_logical_expression_token5] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [sym_boolean_literal] = ACTIONS(1325),
    [aux_sym_null_literal_token1] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1323),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1325),
    [sym__float_literal] = ACTIONS(1325),
    [sym__boz_literal] = ACTIONS(1325),
    [sym_string_literal] = ACTIONS(1325),
  },
  [334] = {
    [sym_preproc_file_line] = STATE(334),
    [aux_sym_end_program_statement_token1] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [aux_sym_interface_statement_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1327),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1327),
    [aux_sym_end_function_statement_token1] = ACTIONS(1327),
    [aux_sym_contains_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token2] = ACTIONS(1327),
    [aux_sym_implicit_statement_token1] = ACTIONS(1327),
    [aux_sym_implicit_statement_token3] = ACTIONS(1327),
    [aux_sym_implicit_statement_token4] = ACTIONS(1327),
    [aux_sym_save_statement_token1] = ACTIONS(1327),
    [aux_sym_private_statement_token1] = ACTIONS(1327),
    [aux_sym_public_statement_token1] = ACTIONS(1327),
    [aux_sym_namelist_statement_token1] = ACTIONS(1327),
    [aux_sym_common_statement_token1] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1329),
    [aux_sym_import_statement_token1] = ACTIONS(1327),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1327),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1327),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1327),
    [aux_sym_variable_attributes_token1] = ACTIONS(1327),
    [aux_sym_variable_attributes_token2] = ACTIONS(1327),
    [aux_sym_variable_attributes_token3] = ACTIONS(1327),
    [aux_sym_variable_attributes_token4] = ACTIONS(1327),
    [aux_sym_variable_attributes_token5] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1327),
    [aux_sym_derived_type_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token2] = ACTIONS(1327),
    [aux_sym_type_qualifier_token3] = ACTIONS(1327),
    [aux_sym_type_qualifier_token4] = ACTIONS(1327),
    [aux_sym_type_qualifier_token5] = ACTIONS(1327),
    [aux_sym_type_qualifier_token9] = ACTIONS(1327),
    [aux_sym_type_qualifier_token10] = ACTIONS(1327),
    [aux_sym_type_qualifier_token11] = ACTIONS(1327),
    [aux_sym_type_qualifier_token12] = ACTIONS(1327),
    [aux_sym_type_qualifier_token13] = ACTIONS(1327),
    [aux_sym_type_qualifier_token14] = ACTIONS(1327),
    [aux_sym_type_qualifier_token15] = ACTIONS(1327),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token2] = ACTIONS(1327),
    [aux_sym_subroutine_call_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token2] = ACTIONS(1327),
    [aux_sym_keyword_statement_token3] = ACTIONS(1327),
    [aux_sym_keyword_statement_token4] = ACTIONS(1327),
    [aux_sym_keyword_statement_token6] = ACTIONS(1327),
    [aux_sym_keyword_statement_token7] = ACTIONS(1327),
    [aux_sym_include_statement_token1] = ACTIONS(1327),
    [aux_sym_data_statement_token1] = ACTIONS(1327),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1327),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1327),
    [aux_sym_end_if_statement_token1] = ACTIONS(1327),
    [aux_sym_elseif_clause_token2] = ACTIONS(1327),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1327),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token3] = ACTIONS(1327),
    [aux_sym_select_type_statement_token1] = ACTIONS(1327),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1327),
    [aux_sym_block_construct_token1] = ACTIONS(1327),
    [aux_sym_associate_statement_token1] = ACTIONS(1327),
    [aux_sym_format_statement_token1] = ACTIONS(1327),
    [aux_sym_print_statement_token1] = ACTIONS(1327),
    [aux_sym_open_statement_token1] = ACTIONS(1327),
    [aux_sym_close_statement_token1] = ACTIONS(1327),
    [aux_sym_inquire_statement_token1] = ACTIONS(1327),
    [aux_sym_enum_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token2] = ACTIONS(1327),
    [aux_sym_file_position_statement_token3] = ACTIONS(1327),
    [aux_sym_file_position_statement_token4] = ACTIONS(1327),
    [aux_sym_logical_expression_token5] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_boolean_literal] = ACTIONS(1329),
    [aux_sym_null_literal_token1] = ACTIONS(1327),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1327),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1329),
    [sym__float_literal] = ACTIONS(1329),
    [sym__boz_literal] = ACTIONS(1329),
    [sym_string_literal] = ACTIONS(1329),
  },
  [335] = {
    [sym_preproc_file_line] = STATE(335),
    [aux_sym_end_program_statement_token1] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1331),
    [aux_sym_interface_statement_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1331),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1331),
    [aux_sym_end_function_statement_token1] = ACTIONS(1331),
    [aux_sym_contains_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token2] = ACTIONS(1331),
    [aux_sym_implicit_statement_token1] = ACTIONS(1331),
    [aux_sym_implicit_statement_token3] = ACTIONS(1331),
    [aux_sym_implicit_statement_token4] = ACTIONS(1331),
    [aux_sym_save_statement_token1] = ACTIONS(1331),
    [aux_sym_private_statement_token1] = ACTIONS(1331),
    [aux_sym_public_statement_token1] = ACTIONS(1331),
    [aux_sym_namelist_statement_token1] = ACTIONS(1331),
    [aux_sym_common_statement_token1] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [aux_sym_import_statement_token1] = ACTIONS(1331),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1331),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1331),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1331),
    [aux_sym_variable_attributes_token1] = ACTIONS(1331),
    [aux_sym_variable_attributes_token2] = ACTIONS(1331),
    [aux_sym_variable_attributes_token3] = ACTIONS(1331),
    [aux_sym_variable_attributes_token4] = ACTIONS(1331),
    [aux_sym_variable_attributes_token5] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1331),
    [aux_sym_derived_type_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token2] = ACTIONS(1331),
    [aux_sym_type_qualifier_token3] = ACTIONS(1331),
    [aux_sym_type_qualifier_token4] = ACTIONS(1331),
    [aux_sym_type_qualifier_token5] = ACTIONS(1331),
    [aux_sym_type_qualifier_token9] = ACTIONS(1331),
    [aux_sym_type_qualifier_token10] = ACTIONS(1331),
    [aux_sym_type_qualifier_token11] = ACTIONS(1331),
    [aux_sym_type_qualifier_token12] = ACTIONS(1331),
    [aux_sym_type_qualifier_token13] = ACTIONS(1331),
    [aux_sym_type_qualifier_token14] = ACTIONS(1331),
    [aux_sym_type_qualifier_token15] = ACTIONS(1331),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token2] = ACTIONS(1331),
    [aux_sym_subroutine_call_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token2] = ACTIONS(1331),
    [aux_sym_keyword_statement_token3] = ACTIONS(1331),
    [aux_sym_keyword_statement_token4] = ACTIONS(1331),
    [aux_sym_keyword_statement_token6] = ACTIONS(1331),
    [aux_sym_keyword_statement_token7] = ACTIONS(1331),
    [aux_sym_include_statement_token1] = ACTIONS(1331),
    [aux_sym_data_statement_token1] = ACTIONS(1331),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1331),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1331),
    [aux_sym_end_if_statement_token1] = ACTIONS(1331),
    [aux_sym_elseif_clause_token2] = ACTIONS(1331),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1331),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token3] = ACTIONS(1331),
    [aux_sym_select_type_statement_token1] = ACTIONS(1331),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1331),
    [aux_sym_block_construct_token1] = ACTIONS(1331),
    [aux_sym_associate_statement_token1] = ACTIONS(1331),
    [aux_sym_format_statement_token1] = ACTIONS(1331),
    [aux_sym_print_statement_token1] = ACTIONS(1331),
    [aux_sym_open_statement_token1] = ACTIONS(1331),
    [aux_sym_close_statement_token1] = ACTIONS(1331),
    [aux_sym_inquire_statement_token1] = ACTIONS(1331),
    [aux_sym_enum_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token2] = ACTIONS(1331),
    [aux_sym_file_position_statement_token3] = ACTIONS(1331),
    [aux_sym_file_position_statement_token4] = ACTIONS(1331),
    [aux_sym_logical_expression_token5] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [sym_boolean_literal] = ACTIONS(1333),
    [aux_sym_null_literal_token1] = ACTIONS(1331),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1331),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1333),
    [sym__float_literal] = ACTIONS(1333),
    [sym__boz_literal] = ACTIONS(1333),
    [sym_string_literal] = ACTIONS(1333),
  },
  [336] = {
    [sym_preproc_file_line] = STATE(336),
    [aux_sym_end_program_statement_token1] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [aux_sym_interface_statement_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1335),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1335),
    [aux_sym_end_function_statement_token1] = ACTIONS(1335),
    [aux_sym_contains_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token2] = ACTIONS(1335),
    [aux_sym_implicit_statement_token1] = ACTIONS(1335),
    [aux_sym_implicit_statement_token3] = ACTIONS(1335),
    [aux_sym_implicit_statement_token4] = ACTIONS(1335),
    [aux_sym_save_statement_token1] = ACTIONS(1335),
    [aux_sym_private_statement_token1] = ACTIONS(1335),
    [aux_sym_public_statement_token1] = ACTIONS(1335),
    [aux_sym_namelist_statement_token1] = ACTIONS(1335),
    [aux_sym_common_statement_token1] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [aux_sym_import_statement_token1] = ACTIONS(1335),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1335),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1335),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1335),
    [aux_sym_variable_attributes_token1] = ACTIONS(1335),
    [aux_sym_variable_attributes_token2] = ACTIONS(1335),
    [aux_sym_variable_attributes_token3] = ACTIONS(1335),
    [aux_sym_variable_attributes_token4] = ACTIONS(1335),
    [aux_sym_variable_attributes_token5] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1335),
    [aux_sym_derived_type_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token2] = ACTIONS(1335),
    [aux_sym_type_qualifier_token3] = ACTIONS(1335),
    [aux_sym_type_qualifier_token4] = ACTIONS(1335),
    [aux_sym_type_qualifier_token5] = ACTIONS(1335),
    [aux_sym_type_qualifier_token9] = ACTIONS(1335),
    [aux_sym_type_qualifier_token10] = ACTIONS(1335),
    [aux_sym_type_qualifier_token11] = ACTIONS(1335),
    [aux_sym_type_qualifier_token12] = ACTIONS(1335),
    [aux_sym_type_qualifier_token13] = ACTIONS(1335),
    [aux_sym_type_qualifier_token14] = ACTIONS(1335),
    [aux_sym_type_qualifier_token15] = ACTIONS(1335),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token2] = ACTIONS(1335),
    [aux_sym_subroutine_call_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token2] = ACTIONS(1335),
    [aux_sym_keyword_statement_token3] = ACTIONS(1335),
    [aux_sym_keyword_statement_token4] = ACTIONS(1335),
    [aux_sym_keyword_statement_token6] = ACTIONS(1335),
    [aux_sym_keyword_statement_token7] = ACTIONS(1335),
    [aux_sym_include_statement_token1] = ACTIONS(1335),
    [aux_sym_data_statement_token1] = ACTIONS(1335),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1335),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1335),
    [aux_sym_end_if_statement_token1] = ACTIONS(1335),
    [aux_sym_elseif_clause_token2] = ACTIONS(1335),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1335),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token3] = ACTIONS(1335),
    [aux_sym_select_type_statement_token1] = ACTIONS(1335),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1335),
    [aux_sym_block_construct_token1] = ACTIONS(1335),
    [aux_sym_associate_statement_token1] = ACTIONS(1335),
    [aux_sym_format_statement_token1] = ACTIONS(1335),
    [aux_sym_print_statement_token1] = ACTIONS(1335),
    [aux_sym_open_statement_token1] = ACTIONS(1335),
    [aux_sym_close_statement_token1] = ACTIONS(1335),
    [aux_sym_inquire_statement_token1] = ACTIONS(1335),
    [aux_sym_enum_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token2] = ACTIONS(1335),
    [aux_sym_file_position_statement_token3] = ACTIONS(1335),
    [aux_sym_file_position_statement_token4] = ACTIONS(1335),
    [aux_sym_logical_expression_token5] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [sym_boolean_literal] = ACTIONS(1337),
    [aux_sym_null_literal_token1] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1335),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1337),
    [sym__float_literal] = ACTIONS(1337),
    [sym__boz_literal] = ACTIONS(1337),
    [sym_string_literal] = ACTIONS(1337),
  },
  [337] = {
    [sym_preproc_file_line] = STATE(337),
    [aux_sym_end_program_statement_token1] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [aux_sym_interface_statement_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1339),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1339),
    [aux_sym_end_function_statement_token1] = ACTIONS(1339),
    [aux_sym_contains_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token2] = ACTIONS(1339),
    [aux_sym_implicit_statement_token1] = ACTIONS(1339),
    [aux_sym_implicit_statement_token3] = ACTIONS(1339),
    [aux_sym_implicit_statement_token4] = ACTIONS(1339),
    [aux_sym_save_statement_token1] = ACTIONS(1339),
    [aux_sym_private_statement_token1] = ACTIONS(1339),
    [aux_sym_public_statement_token1] = ACTIONS(1339),
    [aux_sym_namelist_statement_token1] = ACTIONS(1339),
    [aux_sym_common_statement_token1] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1341),
    [aux_sym_import_statement_token1] = ACTIONS(1339),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1339),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1339),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1339),
    [aux_sym_variable_attributes_token1] = ACTIONS(1339),
    [aux_sym_variable_attributes_token2] = ACTIONS(1339),
    [aux_sym_variable_attributes_token3] = ACTIONS(1339),
    [aux_sym_variable_attributes_token4] = ACTIONS(1339),
    [aux_sym_variable_attributes_token5] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1339),
    [aux_sym_derived_type_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token2] = ACTIONS(1339),
    [aux_sym_type_qualifier_token3] = ACTIONS(1339),
    [aux_sym_type_qualifier_token4] = ACTIONS(1339),
    [aux_sym_type_qualifier_token5] = ACTIONS(1339),
    [aux_sym_type_qualifier_token9] = ACTIONS(1339),
    [aux_sym_type_qualifier_token10] = ACTIONS(1339),
    [aux_sym_type_qualifier_token11] = ACTIONS(1339),
    [aux_sym_type_qualifier_token12] = ACTIONS(1339),
    [aux_sym_type_qualifier_token13] = ACTIONS(1339),
    [aux_sym_type_qualifier_token14] = ACTIONS(1339),
    [aux_sym_type_qualifier_token15] = ACTIONS(1339),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token2] = ACTIONS(1339),
    [aux_sym_subroutine_call_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token2] = ACTIONS(1339),
    [aux_sym_keyword_statement_token3] = ACTIONS(1339),
    [aux_sym_keyword_statement_token4] = ACTIONS(1339),
    [aux_sym_keyword_statement_token6] = ACTIONS(1339),
    [aux_sym_keyword_statement_token7] = ACTIONS(1339),
    [aux_sym_include_statement_token1] = ACTIONS(1339),
    [aux_sym_data_statement_token1] = ACTIONS(1339),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1339),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1339),
    [aux_sym_end_if_statement_token1] = ACTIONS(1339),
    [aux_sym_elseif_clause_token2] = ACTIONS(1339),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1339),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token3] = ACTIONS(1339),
    [aux_sym_select_type_statement_token1] = ACTIONS(1339),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1339),
    [aux_sym_block_construct_token1] = ACTIONS(1339),
    [aux_sym_associate_statement_token1] = ACTIONS(1339),
    [aux_sym_format_statement_token1] = ACTIONS(1339),
    [aux_sym_print_statement_token1] = ACTIONS(1339),
    [aux_sym_open_statement_token1] = ACTIONS(1339),
    [aux_sym_close_statement_token1] = ACTIONS(1339),
    [aux_sym_inquire_statement_token1] = ACTIONS(1339),
    [aux_sym_enum_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token2] = ACTIONS(1339),
    [aux_sym_file_position_statement_token3] = ACTIONS(1339),
    [aux_sym_file_position_statement_token4] = ACTIONS(1339),
    [aux_sym_logical_expression_token5] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [sym_boolean_literal] = ACTIONS(1341),
    [aux_sym_null_literal_token1] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1339),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1341),
    [sym__float_literal] = ACTIONS(1341),
    [sym__boz_literal] = ACTIONS(1341),
    [sym_string_literal] = ACTIONS(1341),
  },
  [338] = {
    [sym_preproc_file_line] = STATE(338),
    [aux_sym_end_program_statement_token1] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [aux_sym_interface_statement_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1279),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1279),
    [aux_sym_contains_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token2] = ACTIONS(1279),
    [aux_sym_implicit_statement_token1] = ACTIONS(1279),
    [aux_sym_implicit_statement_token3] = ACTIONS(1279),
    [aux_sym_implicit_statement_token4] = ACTIONS(1279),
    [aux_sym_save_statement_token1] = ACTIONS(1279),
    [aux_sym_private_statement_token1] = ACTIONS(1279),
    [aux_sym_public_statement_token1] = ACTIONS(1279),
    [aux_sym_namelist_statement_token1] = ACTIONS(1279),
    [aux_sym_common_statement_token1] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1281),
    [aux_sym_import_statement_token1] = ACTIONS(1279),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1279),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1279),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1279),
    [aux_sym_variable_attributes_token1] = ACTIONS(1279),
    [aux_sym_variable_attributes_token2] = ACTIONS(1279),
    [aux_sym_variable_attributes_token3] = ACTIONS(1279),
    [aux_sym_variable_attributes_token4] = ACTIONS(1279),
    [aux_sym_variable_attributes_token5] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1279),
    [aux_sym_derived_type_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token2] = ACTIONS(1279),
    [aux_sym_type_qualifier_token3] = ACTIONS(1279),
    [aux_sym_type_qualifier_token4] = ACTIONS(1279),
    [aux_sym_type_qualifier_token5] = ACTIONS(1279),
    [aux_sym_type_qualifier_token9] = ACTIONS(1279),
    [aux_sym_type_qualifier_token10] = ACTIONS(1279),
    [aux_sym_type_qualifier_token11] = ACTIONS(1279),
    [aux_sym_type_qualifier_token12] = ACTIONS(1279),
    [aux_sym_type_qualifier_token13] = ACTIONS(1279),
    [aux_sym_type_qualifier_token14] = ACTIONS(1279),
    [aux_sym_type_qualifier_token15] = ACTIONS(1279),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token2] = ACTIONS(1279),
    [aux_sym_subroutine_call_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token2] = ACTIONS(1279),
    [aux_sym_keyword_statement_token3] = ACTIONS(1279),
    [aux_sym_keyword_statement_token4] = ACTIONS(1279),
    [aux_sym_keyword_statement_token6] = ACTIONS(1279),
    [aux_sym_keyword_statement_token7] = ACTIONS(1279),
    [aux_sym_include_statement_token1] = ACTIONS(1279),
    [aux_sym_data_statement_token1] = ACTIONS(1279),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1279),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1279),
    [aux_sym_end_if_statement_token1] = ACTIONS(1279),
    [aux_sym_elseif_clause_token2] = ACTIONS(1279),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1279),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token3] = ACTIONS(1279),
    [aux_sym_select_type_statement_token1] = ACTIONS(1279),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1279),
    [aux_sym_block_construct_token1] = ACTIONS(1279),
    [aux_sym_associate_statement_token1] = ACTIONS(1279),
    [aux_sym_format_statement_token1] = ACTIONS(1279),
    [aux_sym_print_statement_token1] = ACTIONS(1279),
    [aux_sym_open_statement_token1] = ACTIONS(1279),
    [aux_sym_close_statement_token1] = ACTIONS(1279),
    [aux_sym_inquire_statement_token1] = ACTIONS(1279),
    [aux_sym_enum_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token2] = ACTIONS(1279),
    [aux_sym_file_position_statement_token3] = ACTIONS(1279),
    [aux_sym_file_position_statement_token4] = ACTIONS(1279),
    [aux_sym_logical_expression_token5] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [sym_boolean_literal] = ACTIONS(1281),
    [aux_sym_null_literal_token1] = ACTIONS(1279),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1279),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1281),
    [sym__float_literal] = ACTIONS(1281),
    [sym__boz_literal] = ACTIONS(1281),
    [sym_string_literal] = ACTIONS(1281),
  },
  [339] = {
    [sym_preproc_file_line] = STATE(339),
    [aux_sym_end_program_statement_token1] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [aux_sym_interface_statement_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1283),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1283),
    [aux_sym_contains_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token2] = ACTIONS(1283),
    [aux_sym_implicit_statement_token1] = ACTIONS(1283),
    [aux_sym_implicit_statement_token3] = ACTIONS(1283),
    [aux_sym_implicit_statement_token4] = ACTIONS(1283),
    [aux_sym_save_statement_token1] = ACTIONS(1283),
    [aux_sym_private_statement_token1] = ACTIONS(1283),
    [aux_sym_public_statement_token1] = ACTIONS(1283),
    [aux_sym_namelist_statement_token1] = ACTIONS(1283),
    [aux_sym_common_statement_token1] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1285),
    [aux_sym_import_statement_token1] = ACTIONS(1283),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1283),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1283),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1283),
    [aux_sym_variable_attributes_token1] = ACTIONS(1283),
    [aux_sym_variable_attributes_token2] = ACTIONS(1283),
    [aux_sym_variable_attributes_token3] = ACTIONS(1283),
    [aux_sym_variable_attributes_token4] = ACTIONS(1283),
    [aux_sym_variable_attributes_token5] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1283),
    [aux_sym_derived_type_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token2] = ACTIONS(1283),
    [aux_sym_type_qualifier_token3] = ACTIONS(1283),
    [aux_sym_type_qualifier_token4] = ACTIONS(1283),
    [aux_sym_type_qualifier_token5] = ACTIONS(1283),
    [aux_sym_type_qualifier_token9] = ACTIONS(1283),
    [aux_sym_type_qualifier_token10] = ACTIONS(1283),
    [aux_sym_type_qualifier_token11] = ACTIONS(1283),
    [aux_sym_type_qualifier_token12] = ACTIONS(1283),
    [aux_sym_type_qualifier_token13] = ACTIONS(1283),
    [aux_sym_type_qualifier_token14] = ACTIONS(1283),
    [aux_sym_type_qualifier_token15] = ACTIONS(1283),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token2] = ACTIONS(1283),
    [aux_sym_subroutine_call_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token2] = ACTIONS(1283),
    [aux_sym_keyword_statement_token3] = ACTIONS(1283),
    [aux_sym_keyword_statement_token4] = ACTIONS(1283),
    [aux_sym_keyword_statement_token6] = ACTIONS(1283),
    [aux_sym_keyword_statement_token7] = ACTIONS(1283),
    [aux_sym_include_statement_token1] = ACTIONS(1283),
    [aux_sym_data_statement_token1] = ACTIONS(1283),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1283),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1283),
    [aux_sym_end_if_statement_token1] = ACTIONS(1283),
    [aux_sym_elseif_clause_token2] = ACTIONS(1283),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1283),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token3] = ACTIONS(1283),
    [aux_sym_select_type_statement_token1] = ACTIONS(1283),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1283),
    [aux_sym_block_construct_token1] = ACTIONS(1283),
    [aux_sym_associate_statement_token1] = ACTIONS(1283),
    [aux_sym_format_statement_token1] = ACTIONS(1283),
    [aux_sym_print_statement_token1] = ACTIONS(1283),
    [aux_sym_open_statement_token1] = ACTIONS(1283),
    [aux_sym_close_statement_token1] = ACTIONS(1283),
    [aux_sym_inquire_statement_token1] = ACTIONS(1283),
    [aux_sym_enum_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token2] = ACTIONS(1283),
    [aux_sym_file_position_statement_token3] = ACTIONS(1283),
    [aux_sym_file_position_statement_token4] = ACTIONS(1283),
    [aux_sym_logical_expression_token5] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [sym_boolean_literal] = ACTIONS(1285),
    [aux_sym_null_literal_token1] = ACTIONS(1283),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1285),
    [sym__float_literal] = ACTIONS(1285),
    [sym__boz_literal] = ACTIONS(1285),
    [sym_string_literal] = ACTIONS(1285),
  },
  [340] = {
    [sym_preproc_file_line] = STATE(340),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_end_function_statement_token1] = ACTIONS(1215),
    [aux_sym_contains_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [341] = {
    [sym_preproc_file_line] = STATE(341),
    [aux_sym_end_program_statement_token1] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [aux_sym_interface_statement_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1275),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1275),
    [aux_sym_contains_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token2] = ACTIONS(1275),
    [aux_sym_implicit_statement_token1] = ACTIONS(1275),
    [aux_sym_implicit_statement_token3] = ACTIONS(1275),
    [aux_sym_implicit_statement_token4] = ACTIONS(1275),
    [aux_sym_save_statement_token1] = ACTIONS(1275),
    [aux_sym_private_statement_token1] = ACTIONS(1275),
    [aux_sym_public_statement_token1] = ACTIONS(1275),
    [aux_sym_namelist_statement_token1] = ACTIONS(1275),
    [aux_sym_common_statement_token1] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1277),
    [aux_sym_import_statement_token1] = ACTIONS(1275),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1275),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1275),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1275),
    [aux_sym_variable_attributes_token1] = ACTIONS(1275),
    [aux_sym_variable_attributes_token2] = ACTIONS(1275),
    [aux_sym_variable_attributes_token3] = ACTIONS(1275),
    [aux_sym_variable_attributes_token4] = ACTIONS(1275),
    [aux_sym_variable_attributes_token5] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1275),
    [aux_sym_derived_type_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token2] = ACTIONS(1275),
    [aux_sym_type_qualifier_token3] = ACTIONS(1275),
    [aux_sym_type_qualifier_token4] = ACTIONS(1275),
    [aux_sym_type_qualifier_token5] = ACTIONS(1275),
    [aux_sym_type_qualifier_token9] = ACTIONS(1275),
    [aux_sym_type_qualifier_token10] = ACTIONS(1275),
    [aux_sym_type_qualifier_token11] = ACTIONS(1275),
    [aux_sym_type_qualifier_token12] = ACTIONS(1275),
    [aux_sym_type_qualifier_token13] = ACTIONS(1275),
    [aux_sym_type_qualifier_token14] = ACTIONS(1275),
    [aux_sym_type_qualifier_token15] = ACTIONS(1275),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token2] = ACTIONS(1275),
    [aux_sym_subroutine_call_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token2] = ACTIONS(1275),
    [aux_sym_keyword_statement_token3] = ACTIONS(1275),
    [aux_sym_keyword_statement_token4] = ACTIONS(1275),
    [aux_sym_keyword_statement_token6] = ACTIONS(1275),
    [aux_sym_keyword_statement_token7] = ACTIONS(1275),
    [aux_sym_include_statement_token1] = ACTIONS(1275),
    [aux_sym_data_statement_token1] = ACTIONS(1275),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1275),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1275),
    [aux_sym_end_if_statement_token1] = ACTIONS(1275),
    [aux_sym_elseif_clause_token2] = ACTIONS(1275),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1275),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token3] = ACTIONS(1275),
    [aux_sym_select_type_statement_token1] = ACTIONS(1275),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1275),
    [aux_sym_block_construct_token1] = ACTIONS(1275),
    [aux_sym_associate_statement_token1] = ACTIONS(1275),
    [aux_sym_format_statement_token1] = ACTIONS(1275),
    [aux_sym_print_statement_token1] = ACTIONS(1275),
    [aux_sym_open_statement_token1] = ACTIONS(1275),
    [aux_sym_close_statement_token1] = ACTIONS(1275),
    [aux_sym_inquire_statement_token1] = ACTIONS(1275),
    [aux_sym_enum_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token2] = ACTIONS(1275),
    [aux_sym_file_position_statement_token3] = ACTIONS(1275),
    [aux_sym_file_position_statement_token4] = ACTIONS(1275),
    [aux_sym_logical_expression_token5] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [sym_boolean_literal] = ACTIONS(1277),
    [aux_sym_null_literal_token1] = ACTIONS(1275),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1275),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1277),
    [sym__float_literal] = ACTIONS(1277),
    [sym__boz_literal] = ACTIONS(1277),
    [sym_string_literal] = ACTIONS(1277),
  },
  [342] = {
    [sym_preproc_file_line] = STATE(342),
    [aux_sym_end_program_statement_token1] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [aux_sym_interface_statement_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1287),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1287),
    [aux_sym_contains_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token2] = ACTIONS(1287),
    [aux_sym_implicit_statement_token1] = ACTIONS(1287),
    [aux_sym_implicit_statement_token3] = ACTIONS(1287),
    [aux_sym_implicit_statement_token4] = ACTIONS(1287),
    [aux_sym_save_statement_token1] = ACTIONS(1287),
    [aux_sym_private_statement_token1] = ACTIONS(1287),
    [aux_sym_public_statement_token1] = ACTIONS(1287),
    [aux_sym_namelist_statement_token1] = ACTIONS(1287),
    [aux_sym_common_statement_token1] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1289),
    [aux_sym_import_statement_token1] = ACTIONS(1287),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1287),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1287),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1287),
    [aux_sym_variable_attributes_token1] = ACTIONS(1287),
    [aux_sym_variable_attributes_token2] = ACTIONS(1287),
    [aux_sym_variable_attributes_token3] = ACTIONS(1287),
    [aux_sym_variable_attributes_token4] = ACTIONS(1287),
    [aux_sym_variable_attributes_token5] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1287),
    [aux_sym_derived_type_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token2] = ACTIONS(1287),
    [aux_sym_type_qualifier_token3] = ACTIONS(1287),
    [aux_sym_type_qualifier_token4] = ACTIONS(1287),
    [aux_sym_type_qualifier_token5] = ACTIONS(1287),
    [aux_sym_type_qualifier_token9] = ACTIONS(1287),
    [aux_sym_type_qualifier_token10] = ACTIONS(1287),
    [aux_sym_type_qualifier_token11] = ACTIONS(1287),
    [aux_sym_type_qualifier_token12] = ACTIONS(1287),
    [aux_sym_type_qualifier_token13] = ACTIONS(1287),
    [aux_sym_type_qualifier_token14] = ACTIONS(1287),
    [aux_sym_type_qualifier_token15] = ACTIONS(1287),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token2] = ACTIONS(1287),
    [aux_sym_subroutine_call_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token2] = ACTIONS(1287),
    [aux_sym_keyword_statement_token3] = ACTIONS(1287),
    [aux_sym_keyword_statement_token4] = ACTIONS(1287),
    [aux_sym_keyword_statement_token6] = ACTIONS(1287),
    [aux_sym_keyword_statement_token7] = ACTIONS(1287),
    [aux_sym_include_statement_token1] = ACTIONS(1287),
    [aux_sym_data_statement_token1] = ACTIONS(1287),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1287),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1287),
    [aux_sym_end_if_statement_token1] = ACTIONS(1287),
    [aux_sym_elseif_clause_token2] = ACTIONS(1287),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1287),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token3] = ACTIONS(1287),
    [aux_sym_select_type_statement_token1] = ACTIONS(1287),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1287),
    [aux_sym_block_construct_token1] = ACTIONS(1287),
    [aux_sym_associate_statement_token1] = ACTIONS(1287),
    [aux_sym_format_statement_token1] = ACTIONS(1287),
    [aux_sym_print_statement_token1] = ACTIONS(1287),
    [aux_sym_open_statement_token1] = ACTIONS(1287),
    [aux_sym_close_statement_token1] = ACTIONS(1287),
    [aux_sym_inquire_statement_token1] = ACTIONS(1287),
    [aux_sym_enum_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token2] = ACTIONS(1287),
    [aux_sym_file_position_statement_token3] = ACTIONS(1287),
    [aux_sym_file_position_statement_token4] = ACTIONS(1287),
    [aux_sym_logical_expression_token5] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [sym_boolean_literal] = ACTIONS(1289),
    [aux_sym_null_literal_token1] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1287),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1289),
    [sym__float_literal] = ACTIONS(1289),
    [sym__boz_literal] = ACTIONS(1289),
    [sym_string_literal] = ACTIONS(1289),
  },
  [343] = {
    [sym_preproc_file_line] = STATE(343),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_end_function_statement_token1] = ACTIONS(1227),
    [aux_sym_contains_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [344] = {
    [sym_preproc_file_line] = STATE(344),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_end_function_statement_token1] = ACTIONS(1235),
    [aux_sym_contains_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [345] = {
    [sym_preproc_file_line] = STATE(345),
    [aux_sym_end_program_statement_token1] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [aux_sym_interface_statement_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1299),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1299),
    [aux_sym_contains_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token2] = ACTIONS(1299),
    [aux_sym_implicit_statement_token1] = ACTIONS(1299),
    [aux_sym_implicit_statement_token3] = ACTIONS(1299),
    [aux_sym_implicit_statement_token4] = ACTIONS(1299),
    [aux_sym_save_statement_token1] = ACTIONS(1299),
    [aux_sym_private_statement_token1] = ACTIONS(1299),
    [aux_sym_public_statement_token1] = ACTIONS(1299),
    [aux_sym_namelist_statement_token1] = ACTIONS(1299),
    [aux_sym_common_statement_token1] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1301),
    [aux_sym_import_statement_token1] = ACTIONS(1299),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1299),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1299),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1299),
    [aux_sym_variable_attributes_token1] = ACTIONS(1299),
    [aux_sym_variable_attributes_token2] = ACTIONS(1299),
    [aux_sym_variable_attributes_token3] = ACTIONS(1299),
    [aux_sym_variable_attributes_token4] = ACTIONS(1299),
    [aux_sym_variable_attributes_token5] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1299),
    [aux_sym_derived_type_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token2] = ACTIONS(1299),
    [aux_sym_type_qualifier_token3] = ACTIONS(1299),
    [aux_sym_type_qualifier_token4] = ACTIONS(1299),
    [aux_sym_type_qualifier_token5] = ACTIONS(1299),
    [aux_sym_type_qualifier_token9] = ACTIONS(1299),
    [aux_sym_type_qualifier_token10] = ACTIONS(1299),
    [aux_sym_type_qualifier_token11] = ACTIONS(1299),
    [aux_sym_type_qualifier_token12] = ACTIONS(1299),
    [aux_sym_type_qualifier_token13] = ACTIONS(1299),
    [aux_sym_type_qualifier_token14] = ACTIONS(1299),
    [aux_sym_type_qualifier_token15] = ACTIONS(1299),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token2] = ACTIONS(1299),
    [aux_sym_subroutine_call_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token2] = ACTIONS(1299),
    [aux_sym_keyword_statement_token3] = ACTIONS(1299),
    [aux_sym_keyword_statement_token4] = ACTIONS(1299),
    [aux_sym_keyword_statement_token6] = ACTIONS(1299),
    [aux_sym_keyword_statement_token7] = ACTIONS(1299),
    [aux_sym_include_statement_token1] = ACTIONS(1299),
    [aux_sym_data_statement_token1] = ACTIONS(1299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1299),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1299),
    [aux_sym_end_if_statement_token1] = ACTIONS(1299),
    [aux_sym_elseif_clause_token2] = ACTIONS(1299),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1299),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token3] = ACTIONS(1299),
    [aux_sym_select_type_statement_token1] = ACTIONS(1299),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1299),
    [aux_sym_block_construct_token1] = ACTIONS(1299),
    [aux_sym_associate_statement_token1] = ACTIONS(1299),
    [aux_sym_format_statement_token1] = ACTIONS(1299),
    [aux_sym_print_statement_token1] = ACTIONS(1299),
    [aux_sym_open_statement_token1] = ACTIONS(1299),
    [aux_sym_close_statement_token1] = ACTIONS(1299),
    [aux_sym_inquire_statement_token1] = ACTIONS(1299),
    [aux_sym_enum_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token2] = ACTIONS(1299),
    [aux_sym_file_position_statement_token3] = ACTIONS(1299),
    [aux_sym_file_position_statement_token4] = ACTIONS(1299),
    [aux_sym_logical_expression_token5] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [sym_boolean_literal] = ACTIONS(1301),
    [aux_sym_null_literal_token1] = ACTIONS(1299),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1299),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1301),
    [sym__float_literal] = ACTIONS(1301),
    [sym__boz_literal] = ACTIONS(1301),
    [sym_string_literal] = ACTIONS(1301),
  },
  [346] = {
    [sym_preproc_file_line] = STATE(346),
    [aux_sym_end_program_statement_token1] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [aux_sym_interface_statement_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1291),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1291),
    [aux_sym_contains_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token2] = ACTIONS(1291),
    [aux_sym_implicit_statement_token1] = ACTIONS(1291),
    [aux_sym_implicit_statement_token3] = ACTIONS(1291),
    [aux_sym_implicit_statement_token4] = ACTIONS(1291),
    [aux_sym_save_statement_token1] = ACTIONS(1291),
    [aux_sym_private_statement_token1] = ACTIONS(1291),
    [aux_sym_public_statement_token1] = ACTIONS(1291),
    [aux_sym_namelist_statement_token1] = ACTIONS(1291),
    [aux_sym_common_statement_token1] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1293),
    [aux_sym_import_statement_token1] = ACTIONS(1291),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1291),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1291),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1291),
    [aux_sym_variable_attributes_token1] = ACTIONS(1291),
    [aux_sym_variable_attributes_token2] = ACTIONS(1291),
    [aux_sym_variable_attributes_token3] = ACTIONS(1291),
    [aux_sym_variable_attributes_token4] = ACTIONS(1291),
    [aux_sym_variable_attributes_token5] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1291),
    [aux_sym_derived_type_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token2] = ACTIONS(1291),
    [aux_sym_type_qualifier_token3] = ACTIONS(1291),
    [aux_sym_type_qualifier_token4] = ACTIONS(1291),
    [aux_sym_type_qualifier_token5] = ACTIONS(1291),
    [aux_sym_type_qualifier_token9] = ACTIONS(1291),
    [aux_sym_type_qualifier_token10] = ACTIONS(1291),
    [aux_sym_type_qualifier_token11] = ACTIONS(1291),
    [aux_sym_type_qualifier_token12] = ACTIONS(1291),
    [aux_sym_type_qualifier_token13] = ACTIONS(1291),
    [aux_sym_type_qualifier_token14] = ACTIONS(1291),
    [aux_sym_type_qualifier_token15] = ACTIONS(1291),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token2] = ACTIONS(1291),
    [aux_sym_subroutine_call_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token2] = ACTIONS(1291),
    [aux_sym_keyword_statement_token3] = ACTIONS(1291),
    [aux_sym_keyword_statement_token4] = ACTIONS(1291),
    [aux_sym_keyword_statement_token6] = ACTIONS(1291),
    [aux_sym_keyword_statement_token7] = ACTIONS(1291),
    [aux_sym_include_statement_token1] = ACTIONS(1291),
    [aux_sym_data_statement_token1] = ACTIONS(1291),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1291),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1291),
    [aux_sym_end_if_statement_token1] = ACTIONS(1291),
    [aux_sym_elseif_clause_token2] = ACTIONS(1291),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1291),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token3] = ACTIONS(1291),
    [aux_sym_select_type_statement_token1] = ACTIONS(1291),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1291),
    [aux_sym_block_construct_token1] = ACTIONS(1291),
    [aux_sym_associate_statement_token1] = ACTIONS(1291),
    [aux_sym_format_statement_token1] = ACTIONS(1291),
    [aux_sym_print_statement_token1] = ACTIONS(1291),
    [aux_sym_open_statement_token1] = ACTIONS(1291),
    [aux_sym_close_statement_token1] = ACTIONS(1291),
    [aux_sym_inquire_statement_token1] = ACTIONS(1291),
    [aux_sym_enum_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token2] = ACTIONS(1291),
    [aux_sym_file_position_statement_token3] = ACTIONS(1291),
    [aux_sym_file_position_statement_token4] = ACTIONS(1291),
    [aux_sym_logical_expression_token5] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [sym_boolean_literal] = ACTIONS(1293),
    [aux_sym_null_literal_token1] = ACTIONS(1291),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1291),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1293),
    [sym__float_literal] = ACTIONS(1293),
    [sym__boz_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
  },
  [347] = {
    [sym_preproc_file_line] = STATE(347),
    [aux_sym_end_program_statement_token1] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_interface_statement_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1303),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1303),
    [aux_sym_contains_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token2] = ACTIONS(1303),
    [aux_sym_implicit_statement_token1] = ACTIONS(1303),
    [aux_sym_implicit_statement_token3] = ACTIONS(1303),
    [aux_sym_implicit_statement_token4] = ACTIONS(1303),
    [aux_sym_save_statement_token1] = ACTIONS(1303),
    [aux_sym_private_statement_token1] = ACTIONS(1303),
    [aux_sym_public_statement_token1] = ACTIONS(1303),
    [aux_sym_namelist_statement_token1] = ACTIONS(1303),
    [aux_sym_common_statement_token1] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1305),
    [aux_sym_import_statement_token1] = ACTIONS(1303),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1303),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1303),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1303),
    [aux_sym_variable_attributes_token1] = ACTIONS(1303),
    [aux_sym_variable_attributes_token2] = ACTIONS(1303),
    [aux_sym_variable_attributes_token3] = ACTIONS(1303),
    [aux_sym_variable_attributes_token4] = ACTIONS(1303),
    [aux_sym_variable_attributes_token5] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1303),
    [aux_sym_derived_type_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token2] = ACTIONS(1303),
    [aux_sym_type_qualifier_token3] = ACTIONS(1303),
    [aux_sym_type_qualifier_token4] = ACTIONS(1303),
    [aux_sym_type_qualifier_token5] = ACTIONS(1303),
    [aux_sym_type_qualifier_token9] = ACTIONS(1303),
    [aux_sym_type_qualifier_token10] = ACTIONS(1303),
    [aux_sym_type_qualifier_token11] = ACTIONS(1303),
    [aux_sym_type_qualifier_token12] = ACTIONS(1303),
    [aux_sym_type_qualifier_token13] = ACTIONS(1303),
    [aux_sym_type_qualifier_token14] = ACTIONS(1303),
    [aux_sym_type_qualifier_token15] = ACTIONS(1303),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token2] = ACTIONS(1303),
    [aux_sym_subroutine_call_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token2] = ACTIONS(1303),
    [aux_sym_keyword_statement_token3] = ACTIONS(1303),
    [aux_sym_keyword_statement_token4] = ACTIONS(1303),
    [aux_sym_keyword_statement_token6] = ACTIONS(1303),
    [aux_sym_keyword_statement_token7] = ACTIONS(1303),
    [aux_sym_include_statement_token1] = ACTIONS(1303),
    [aux_sym_data_statement_token1] = ACTIONS(1303),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1303),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1303),
    [aux_sym_end_if_statement_token1] = ACTIONS(1303),
    [aux_sym_elseif_clause_token2] = ACTIONS(1303),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1303),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token3] = ACTIONS(1303),
    [aux_sym_select_type_statement_token1] = ACTIONS(1303),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1303),
    [aux_sym_block_construct_token1] = ACTIONS(1303),
    [aux_sym_associate_statement_token1] = ACTIONS(1303),
    [aux_sym_format_statement_token1] = ACTIONS(1303),
    [aux_sym_print_statement_token1] = ACTIONS(1303),
    [aux_sym_open_statement_token1] = ACTIONS(1303),
    [aux_sym_close_statement_token1] = ACTIONS(1303),
    [aux_sym_inquire_statement_token1] = ACTIONS(1303),
    [aux_sym_enum_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token2] = ACTIONS(1303),
    [aux_sym_file_position_statement_token3] = ACTIONS(1303),
    [aux_sym_file_position_statement_token4] = ACTIONS(1303),
    [aux_sym_logical_expression_token5] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_boolean_literal] = ACTIONS(1305),
    [aux_sym_null_literal_token1] = ACTIONS(1303),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1303),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1305),
    [sym__float_literal] = ACTIONS(1305),
    [sym__boz_literal] = ACTIONS(1305),
    [sym_string_literal] = ACTIONS(1305),
  },
  [348] = {
    [sym_preproc_file_line] = STATE(348),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_end_function_statement_token1] = ACTIONS(1135),
    [aux_sym_contains_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [349] = {
    [sym_preproc_file_line] = STATE(349),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_end_function_statement_token1] = ACTIONS(1147),
    [aux_sym_contains_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [350] = {
    [sym_preproc_file_line] = STATE(350),
    [aux_sym_end_program_statement_token1] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [aux_sym_interface_statement_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1307),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1307),
    [aux_sym_contains_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token2] = ACTIONS(1307),
    [aux_sym_implicit_statement_token1] = ACTIONS(1307),
    [aux_sym_implicit_statement_token3] = ACTIONS(1307),
    [aux_sym_implicit_statement_token4] = ACTIONS(1307),
    [aux_sym_save_statement_token1] = ACTIONS(1307),
    [aux_sym_private_statement_token1] = ACTIONS(1307),
    [aux_sym_public_statement_token1] = ACTIONS(1307),
    [aux_sym_namelist_statement_token1] = ACTIONS(1307),
    [aux_sym_common_statement_token1] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1309),
    [aux_sym_import_statement_token1] = ACTIONS(1307),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1307),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1307),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1307),
    [aux_sym_variable_attributes_token1] = ACTIONS(1307),
    [aux_sym_variable_attributes_token2] = ACTIONS(1307),
    [aux_sym_variable_attributes_token3] = ACTIONS(1307),
    [aux_sym_variable_attributes_token4] = ACTIONS(1307),
    [aux_sym_variable_attributes_token5] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1307),
    [aux_sym_derived_type_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token2] = ACTIONS(1307),
    [aux_sym_type_qualifier_token3] = ACTIONS(1307),
    [aux_sym_type_qualifier_token4] = ACTIONS(1307),
    [aux_sym_type_qualifier_token5] = ACTIONS(1307),
    [aux_sym_type_qualifier_token9] = ACTIONS(1307),
    [aux_sym_type_qualifier_token10] = ACTIONS(1307),
    [aux_sym_type_qualifier_token11] = ACTIONS(1307),
    [aux_sym_type_qualifier_token12] = ACTIONS(1307),
    [aux_sym_type_qualifier_token13] = ACTIONS(1307),
    [aux_sym_type_qualifier_token14] = ACTIONS(1307),
    [aux_sym_type_qualifier_token15] = ACTIONS(1307),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token2] = ACTIONS(1307),
    [aux_sym_subroutine_call_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token2] = ACTIONS(1307),
    [aux_sym_keyword_statement_token3] = ACTIONS(1307),
    [aux_sym_keyword_statement_token4] = ACTIONS(1307),
    [aux_sym_keyword_statement_token6] = ACTIONS(1307),
    [aux_sym_keyword_statement_token7] = ACTIONS(1307),
    [aux_sym_include_statement_token1] = ACTIONS(1307),
    [aux_sym_data_statement_token1] = ACTIONS(1307),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1307),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1307),
    [aux_sym_end_if_statement_token1] = ACTIONS(1307),
    [aux_sym_elseif_clause_token2] = ACTIONS(1307),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1307),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token3] = ACTIONS(1307),
    [aux_sym_select_type_statement_token1] = ACTIONS(1307),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1307),
    [aux_sym_block_construct_token1] = ACTIONS(1307),
    [aux_sym_associate_statement_token1] = ACTIONS(1307),
    [aux_sym_format_statement_token1] = ACTIONS(1307),
    [aux_sym_print_statement_token1] = ACTIONS(1307),
    [aux_sym_open_statement_token1] = ACTIONS(1307),
    [aux_sym_close_statement_token1] = ACTIONS(1307),
    [aux_sym_inquire_statement_token1] = ACTIONS(1307),
    [aux_sym_enum_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token2] = ACTIONS(1307),
    [aux_sym_file_position_statement_token3] = ACTIONS(1307),
    [aux_sym_file_position_statement_token4] = ACTIONS(1307),
    [aux_sym_logical_expression_token5] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [sym_boolean_literal] = ACTIONS(1309),
    [aux_sym_null_literal_token1] = ACTIONS(1307),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1307),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1309),
    [sym__float_literal] = ACTIONS(1309),
    [sym__boz_literal] = ACTIONS(1309),
    [sym_string_literal] = ACTIONS(1309),
  },
  [351] = {
    [sym_preproc_file_line] = STATE(351),
    [aux_sym_end_program_statement_token1] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_interface_statement_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1311),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1311),
    [aux_sym_contains_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token2] = ACTIONS(1311),
    [aux_sym_implicit_statement_token1] = ACTIONS(1311),
    [aux_sym_implicit_statement_token3] = ACTIONS(1311),
    [aux_sym_implicit_statement_token4] = ACTIONS(1311),
    [aux_sym_save_statement_token1] = ACTIONS(1311),
    [aux_sym_private_statement_token1] = ACTIONS(1311),
    [aux_sym_public_statement_token1] = ACTIONS(1311),
    [aux_sym_namelist_statement_token1] = ACTIONS(1311),
    [aux_sym_common_statement_token1] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1313),
    [aux_sym_import_statement_token1] = ACTIONS(1311),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1311),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1311),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1311),
    [aux_sym_variable_attributes_token1] = ACTIONS(1311),
    [aux_sym_variable_attributes_token2] = ACTIONS(1311),
    [aux_sym_variable_attributes_token3] = ACTIONS(1311),
    [aux_sym_variable_attributes_token4] = ACTIONS(1311),
    [aux_sym_variable_attributes_token5] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1311),
    [aux_sym_derived_type_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token2] = ACTIONS(1311),
    [aux_sym_type_qualifier_token3] = ACTIONS(1311),
    [aux_sym_type_qualifier_token4] = ACTIONS(1311),
    [aux_sym_type_qualifier_token5] = ACTIONS(1311),
    [aux_sym_type_qualifier_token9] = ACTIONS(1311),
    [aux_sym_type_qualifier_token10] = ACTIONS(1311),
    [aux_sym_type_qualifier_token11] = ACTIONS(1311),
    [aux_sym_type_qualifier_token12] = ACTIONS(1311),
    [aux_sym_type_qualifier_token13] = ACTIONS(1311),
    [aux_sym_type_qualifier_token14] = ACTIONS(1311),
    [aux_sym_type_qualifier_token15] = ACTIONS(1311),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token2] = ACTIONS(1311),
    [aux_sym_subroutine_call_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token2] = ACTIONS(1311),
    [aux_sym_keyword_statement_token3] = ACTIONS(1311),
    [aux_sym_keyword_statement_token4] = ACTIONS(1311),
    [aux_sym_keyword_statement_token6] = ACTIONS(1311),
    [aux_sym_keyword_statement_token7] = ACTIONS(1311),
    [aux_sym_include_statement_token1] = ACTIONS(1311),
    [aux_sym_data_statement_token1] = ACTIONS(1311),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1311),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1311),
    [aux_sym_end_if_statement_token1] = ACTIONS(1311),
    [aux_sym_elseif_clause_token2] = ACTIONS(1311),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token3] = ACTIONS(1311),
    [aux_sym_select_type_statement_token1] = ACTIONS(1311),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1311),
    [aux_sym_block_construct_token1] = ACTIONS(1311),
    [aux_sym_associate_statement_token1] = ACTIONS(1311),
    [aux_sym_format_statement_token1] = ACTIONS(1311),
    [aux_sym_print_statement_token1] = ACTIONS(1311),
    [aux_sym_open_statement_token1] = ACTIONS(1311),
    [aux_sym_close_statement_token1] = ACTIONS(1311),
    [aux_sym_inquire_statement_token1] = ACTIONS(1311),
    [aux_sym_enum_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token2] = ACTIONS(1311),
    [aux_sym_file_position_statement_token3] = ACTIONS(1311),
    [aux_sym_file_position_statement_token4] = ACTIONS(1311),
    [aux_sym_logical_expression_token5] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [sym_boolean_literal] = ACTIONS(1313),
    [aux_sym_null_literal_token1] = ACTIONS(1311),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1311),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1313),
    [sym__float_literal] = ACTIONS(1313),
    [sym__boz_literal] = ACTIONS(1313),
    [sym_string_literal] = ACTIONS(1313),
  },
  [352] = {
    [sym_preproc_file_line] = STATE(352),
    [aux_sym_end_program_statement_token1] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [aux_sym_interface_statement_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1315),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1315),
    [aux_sym_contains_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token2] = ACTIONS(1315),
    [aux_sym_implicit_statement_token1] = ACTIONS(1315),
    [aux_sym_implicit_statement_token3] = ACTIONS(1315),
    [aux_sym_implicit_statement_token4] = ACTIONS(1315),
    [aux_sym_save_statement_token1] = ACTIONS(1315),
    [aux_sym_private_statement_token1] = ACTIONS(1315),
    [aux_sym_public_statement_token1] = ACTIONS(1315),
    [aux_sym_namelist_statement_token1] = ACTIONS(1315),
    [aux_sym_common_statement_token1] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1317),
    [aux_sym_import_statement_token1] = ACTIONS(1315),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1315),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1315),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1315),
    [aux_sym_variable_attributes_token1] = ACTIONS(1315),
    [aux_sym_variable_attributes_token2] = ACTIONS(1315),
    [aux_sym_variable_attributes_token3] = ACTIONS(1315),
    [aux_sym_variable_attributes_token4] = ACTIONS(1315),
    [aux_sym_variable_attributes_token5] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1315),
    [aux_sym_derived_type_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token2] = ACTIONS(1315),
    [aux_sym_type_qualifier_token3] = ACTIONS(1315),
    [aux_sym_type_qualifier_token4] = ACTIONS(1315),
    [aux_sym_type_qualifier_token5] = ACTIONS(1315),
    [aux_sym_type_qualifier_token9] = ACTIONS(1315),
    [aux_sym_type_qualifier_token10] = ACTIONS(1315),
    [aux_sym_type_qualifier_token11] = ACTIONS(1315),
    [aux_sym_type_qualifier_token12] = ACTIONS(1315),
    [aux_sym_type_qualifier_token13] = ACTIONS(1315),
    [aux_sym_type_qualifier_token14] = ACTIONS(1315),
    [aux_sym_type_qualifier_token15] = ACTIONS(1315),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token2] = ACTIONS(1315),
    [aux_sym_subroutine_call_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token2] = ACTIONS(1315),
    [aux_sym_keyword_statement_token3] = ACTIONS(1315),
    [aux_sym_keyword_statement_token4] = ACTIONS(1315),
    [aux_sym_keyword_statement_token6] = ACTIONS(1315),
    [aux_sym_keyword_statement_token7] = ACTIONS(1315),
    [aux_sym_include_statement_token1] = ACTIONS(1315),
    [aux_sym_data_statement_token1] = ACTIONS(1315),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1315),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1315),
    [aux_sym_end_if_statement_token1] = ACTIONS(1315),
    [aux_sym_elseif_clause_token2] = ACTIONS(1315),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1315),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token3] = ACTIONS(1315),
    [aux_sym_select_type_statement_token1] = ACTIONS(1315),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1315),
    [aux_sym_block_construct_token1] = ACTIONS(1315),
    [aux_sym_associate_statement_token1] = ACTIONS(1315),
    [aux_sym_format_statement_token1] = ACTIONS(1315),
    [aux_sym_print_statement_token1] = ACTIONS(1315),
    [aux_sym_open_statement_token1] = ACTIONS(1315),
    [aux_sym_close_statement_token1] = ACTIONS(1315),
    [aux_sym_inquire_statement_token1] = ACTIONS(1315),
    [aux_sym_enum_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token2] = ACTIONS(1315),
    [aux_sym_file_position_statement_token3] = ACTIONS(1315),
    [aux_sym_file_position_statement_token4] = ACTIONS(1315),
    [aux_sym_logical_expression_token5] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1315),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [sym_boolean_literal] = ACTIONS(1317),
    [aux_sym_null_literal_token1] = ACTIONS(1315),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1315),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1317),
    [sym__float_literal] = ACTIONS(1317),
    [sym__boz_literal] = ACTIONS(1317),
    [sym_string_literal] = ACTIONS(1317),
  },
  [353] = {
    [sym_preproc_file_line] = STATE(353),
    [aux_sym_end_program_statement_token1] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [aux_sym_interface_statement_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1319),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1319),
    [aux_sym_contains_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token2] = ACTIONS(1319),
    [aux_sym_implicit_statement_token1] = ACTIONS(1319),
    [aux_sym_implicit_statement_token3] = ACTIONS(1319),
    [aux_sym_implicit_statement_token4] = ACTIONS(1319),
    [aux_sym_save_statement_token1] = ACTIONS(1319),
    [aux_sym_private_statement_token1] = ACTIONS(1319),
    [aux_sym_public_statement_token1] = ACTIONS(1319),
    [aux_sym_namelist_statement_token1] = ACTIONS(1319),
    [aux_sym_common_statement_token1] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [aux_sym_import_statement_token1] = ACTIONS(1319),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1319),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1319),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1319),
    [aux_sym_variable_attributes_token1] = ACTIONS(1319),
    [aux_sym_variable_attributes_token2] = ACTIONS(1319),
    [aux_sym_variable_attributes_token3] = ACTIONS(1319),
    [aux_sym_variable_attributes_token4] = ACTIONS(1319),
    [aux_sym_variable_attributes_token5] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1319),
    [aux_sym_derived_type_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token2] = ACTIONS(1319),
    [aux_sym_type_qualifier_token3] = ACTIONS(1319),
    [aux_sym_type_qualifier_token4] = ACTIONS(1319),
    [aux_sym_type_qualifier_token5] = ACTIONS(1319),
    [aux_sym_type_qualifier_token9] = ACTIONS(1319),
    [aux_sym_type_qualifier_token10] = ACTIONS(1319),
    [aux_sym_type_qualifier_token11] = ACTIONS(1319),
    [aux_sym_type_qualifier_token12] = ACTIONS(1319),
    [aux_sym_type_qualifier_token13] = ACTIONS(1319),
    [aux_sym_type_qualifier_token14] = ACTIONS(1319),
    [aux_sym_type_qualifier_token15] = ACTIONS(1319),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token2] = ACTIONS(1319),
    [aux_sym_subroutine_call_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token2] = ACTIONS(1319),
    [aux_sym_keyword_statement_token3] = ACTIONS(1319),
    [aux_sym_keyword_statement_token4] = ACTIONS(1319),
    [aux_sym_keyword_statement_token6] = ACTIONS(1319),
    [aux_sym_keyword_statement_token7] = ACTIONS(1319),
    [aux_sym_include_statement_token1] = ACTIONS(1319),
    [aux_sym_data_statement_token1] = ACTIONS(1319),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1319),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1319),
    [aux_sym_end_if_statement_token1] = ACTIONS(1319),
    [aux_sym_elseif_clause_token2] = ACTIONS(1319),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1319),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token3] = ACTIONS(1319),
    [aux_sym_select_type_statement_token1] = ACTIONS(1319),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1319),
    [aux_sym_block_construct_token1] = ACTIONS(1319),
    [aux_sym_associate_statement_token1] = ACTIONS(1319),
    [aux_sym_format_statement_token1] = ACTIONS(1319),
    [aux_sym_print_statement_token1] = ACTIONS(1319),
    [aux_sym_open_statement_token1] = ACTIONS(1319),
    [aux_sym_close_statement_token1] = ACTIONS(1319),
    [aux_sym_inquire_statement_token1] = ACTIONS(1319),
    [aux_sym_enum_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token2] = ACTIONS(1319),
    [aux_sym_file_position_statement_token3] = ACTIONS(1319),
    [aux_sym_file_position_statement_token4] = ACTIONS(1319),
    [aux_sym_logical_expression_token5] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [sym_boolean_literal] = ACTIONS(1321),
    [aux_sym_null_literal_token1] = ACTIONS(1319),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1319),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1321),
    [sym__float_literal] = ACTIONS(1321),
    [sym__boz_literal] = ACTIONS(1321),
    [sym_string_literal] = ACTIONS(1321),
  },
  [354] = {
    [sym_preproc_file_line] = STATE(354),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_end_function_statement_token1] = ACTIONS(1265),
    [aux_sym_contains_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [355] = {
    [sym_preproc_file_line] = STATE(355),
    [aux_sym_end_program_statement_token1] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [aux_sym_interface_statement_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1323),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1323),
    [aux_sym_contains_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token2] = ACTIONS(1323),
    [aux_sym_implicit_statement_token1] = ACTIONS(1323),
    [aux_sym_implicit_statement_token3] = ACTIONS(1323),
    [aux_sym_implicit_statement_token4] = ACTIONS(1323),
    [aux_sym_save_statement_token1] = ACTIONS(1323),
    [aux_sym_private_statement_token1] = ACTIONS(1323),
    [aux_sym_public_statement_token1] = ACTIONS(1323),
    [aux_sym_namelist_statement_token1] = ACTIONS(1323),
    [aux_sym_common_statement_token1] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1325),
    [aux_sym_import_statement_token1] = ACTIONS(1323),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1323),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1323),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1323),
    [aux_sym_variable_attributes_token1] = ACTIONS(1323),
    [aux_sym_variable_attributes_token2] = ACTIONS(1323),
    [aux_sym_variable_attributes_token3] = ACTIONS(1323),
    [aux_sym_variable_attributes_token4] = ACTIONS(1323),
    [aux_sym_variable_attributes_token5] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1323),
    [aux_sym_derived_type_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token2] = ACTIONS(1323),
    [aux_sym_type_qualifier_token3] = ACTIONS(1323),
    [aux_sym_type_qualifier_token4] = ACTIONS(1323),
    [aux_sym_type_qualifier_token5] = ACTIONS(1323),
    [aux_sym_type_qualifier_token9] = ACTIONS(1323),
    [aux_sym_type_qualifier_token10] = ACTIONS(1323),
    [aux_sym_type_qualifier_token11] = ACTIONS(1323),
    [aux_sym_type_qualifier_token12] = ACTIONS(1323),
    [aux_sym_type_qualifier_token13] = ACTIONS(1323),
    [aux_sym_type_qualifier_token14] = ACTIONS(1323),
    [aux_sym_type_qualifier_token15] = ACTIONS(1323),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token2] = ACTIONS(1323),
    [aux_sym_subroutine_call_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token2] = ACTIONS(1323),
    [aux_sym_keyword_statement_token3] = ACTIONS(1323),
    [aux_sym_keyword_statement_token4] = ACTIONS(1323),
    [aux_sym_keyword_statement_token6] = ACTIONS(1323),
    [aux_sym_keyword_statement_token7] = ACTIONS(1323),
    [aux_sym_include_statement_token1] = ACTIONS(1323),
    [aux_sym_data_statement_token1] = ACTIONS(1323),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1323),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1323),
    [aux_sym_end_if_statement_token1] = ACTIONS(1323),
    [aux_sym_elseif_clause_token2] = ACTIONS(1323),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1323),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token3] = ACTIONS(1323),
    [aux_sym_select_type_statement_token1] = ACTIONS(1323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1323),
    [aux_sym_block_construct_token1] = ACTIONS(1323),
    [aux_sym_associate_statement_token1] = ACTIONS(1323),
    [aux_sym_format_statement_token1] = ACTIONS(1323),
    [aux_sym_print_statement_token1] = ACTIONS(1323),
    [aux_sym_open_statement_token1] = ACTIONS(1323),
    [aux_sym_close_statement_token1] = ACTIONS(1323),
    [aux_sym_inquire_statement_token1] = ACTIONS(1323),
    [aux_sym_enum_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token2] = ACTIONS(1323),
    [aux_sym_file_position_statement_token3] = ACTIONS(1323),
    [aux_sym_file_position_statement_token4] = ACTIONS(1323),
    [aux_sym_logical_expression_token5] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [sym_boolean_literal] = ACTIONS(1325),
    [aux_sym_null_literal_token1] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1323),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1325),
    [sym__float_literal] = ACTIONS(1325),
    [sym__boz_literal] = ACTIONS(1325),
    [sym_string_literal] = ACTIONS(1325),
  },
  [356] = {
    [sym_preproc_file_line] = STATE(356),
    [aux_sym_end_program_statement_token1] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [aux_sym_interface_statement_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1327),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1327),
    [aux_sym_contains_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token2] = ACTIONS(1327),
    [aux_sym_implicit_statement_token1] = ACTIONS(1327),
    [aux_sym_implicit_statement_token3] = ACTIONS(1327),
    [aux_sym_implicit_statement_token4] = ACTIONS(1327),
    [aux_sym_save_statement_token1] = ACTIONS(1327),
    [aux_sym_private_statement_token1] = ACTIONS(1327),
    [aux_sym_public_statement_token1] = ACTIONS(1327),
    [aux_sym_namelist_statement_token1] = ACTIONS(1327),
    [aux_sym_common_statement_token1] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1329),
    [aux_sym_import_statement_token1] = ACTIONS(1327),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1327),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1327),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1327),
    [aux_sym_variable_attributes_token1] = ACTIONS(1327),
    [aux_sym_variable_attributes_token2] = ACTIONS(1327),
    [aux_sym_variable_attributes_token3] = ACTIONS(1327),
    [aux_sym_variable_attributes_token4] = ACTIONS(1327),
    [aux_sym_variable_attributes_token5] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1327),
    [aux_sym_derived_type_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token2] = ACTIONS(1327),
    [aux_sym_type_qualifier_token3] = ACTIONS(1327),
    [aux_sym_type_qualifier_token4] = ACTIONS(1327),
    [aux_sym_type_qualifier_token5] = ACTIONS(1327),
    [aux_sym_type_qualifier_token9] = ACTIONS(1327),
    [aux_sym_type_qualifier_token10] = ACTIONS(1327),
    [aux_sym_type_qualifier_token11] = ACTIONS(1327),
    [aux_sym_type_qualifier_token12] = ACTIONS(1327),
    [aux_sym_type_qualifier_token13] = ACTIONS(1327),
    [aux_sym_type_qualifier_token14] = ACTIONS(1327),
    [aux_sym_type_qualifier_token15] = ACTIONS(1327),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token2] = ACTIONS(1327),
    [aux_sym_subroutine_call_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token2] = ACTIONS(1327),
    [aux_sym_keyword_statement_token3] = ACTIONS(1327),
    [aux_sym_keyword_statement_token4] = ACTIONS(1327),
    [aux_sym_keyword_statement_token6] = ACTIONS(1327),
    [aux_sym_keyword_statement_token7] = ACTIONS(1327),
    [aux_sym_include_statement_token1] = ACTIONS(1327),
    [aux_sym_data_statement_token1] = ACTIONS(1327),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1327),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1327),
    [aux_sym_end_if_statement_token1] = ACTIONS(1327),
    [aux_sym_elseif_clause_token2] = ACTIONS(1327),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1327),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token3] = ACTIONS(1327),
    [aux_sym_select_type_statement_token1] = ACTIONS(1327),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1327),
    [aux_sym_block_construct_token1] = ACTIONS(1327),
    [aux_sym_associate_statement_token1] = ACTIONS(1327),
    [aux_sym_format_statement_token1] = ACTIONS(1327),
    [aux_sym_print_statement_token1] = ACTIONS(1327),
    [aux_sym_open_statement_token1] = ACTIONS(1327),
    [aux_sym_close_statement_token1] = ACTIONS(1327),
    [aux_sym_inquire_statement_token1] = ACTIONS(1327),
    [aux_sym_enum_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token2] = ACTIONS(1327),
    [aux_sym_file_position_statement_token3] = ACTIONS(1327),
    [aux_sym_file_position_statement_token4] = ACTIONS(1327),
    [aux_sym_logical_expression_token5] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_boolean_literal] = ACTIONS(1329),
    [aux_sym_null_literal_token1] = ACTIONS(1327),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1327),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1329),
    [sym__float_literal] = ACTIONS(1329),
    [sym__boz_literal] = ACTIONS(1329),
    [sym_string_literal] = ACTIONS(1329),
  },
  [357] = {
    [sym_preproc_file_line] = STATE(357),
    [aux_sym_end_program_statement_token1] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1331),
    [aux_sym_interface_statement_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1331),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1331),
    [aux_sym_contains_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token2] = ACTIONS(1331),
    [aux_sym_implicit_statement_token1] = ACTIONS(1331),
    [aux_sym_implicit_statement_token3] = ACTIONS(1331),
    [aux_sym_implicit_statement_token4] = ACTIONS(1331),
    [aux_sym_save_statement_token1] = ACTIONS(1331),
    [aux_sym_private_statement_token1] = ACTIONS(1331),
    [aux_sym_public_statement_token1] = ACTIONS(1331),
    [aux_sym_namelist_statement_token1] = ACTIONS(1331),
    [aux_sym_common_statement_token1] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [aux_sym_import_statement_token1] = ACTIONS(1331),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1331),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1331),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1331),
    [aux_sym_variable_attributes_token1] = ACTIONS(1331),
    [aux_sym_variable_attributes_token2] = ACTIONS(1331),
    [aux_sym_variable_attributes_token3] = ACTIONS(1331),
    [aux_sym_variable_attributes_token4] = ACTIONS(1331),
    [aux_sym_variable_attributes_token5] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1331),
    [aux_sym_derived_type_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token2] = ACTIONS(1331),
    [aux_sym_type_qualifier_token3] = ACTIONS(1331),
    [aux_sym_type_qualifier_token4] = ACTIONS(1331),
    [aux_sym_type_qualifier_token5] = ACTIONS(1331),
    [aux_sym_type_qualifier_token9] = ACTIONS(1331),
    [aux_sym_type_qualifier_token10] = ACTIONS(1331),
    [aux_sym_type_qualifier_token11] = ACTIONS(1331),
    [aux_sym_type_qualifier_token12] = ACTIONS(1331),
    [aux_sym_type_qualifier_token13] = ACTIONS(1331),
    [aux_sym_type_qualifier_token14] = ACTIONS(1331),
    [aux_sym_type_qualifier_token15] = ACTIONS(1331),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token2] = ACTIONS(1331),
    [aux_sym_subroutine_call_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token2] = ACTIONS(1331),
    [aux_sym_keyword_statement_token3] = ACTIONS(1331),
    [aux_sym_keyword_statement_token4] = ACTIONS(1331),
    [aux_sym_keyword_statement_token6] = ACTIONS(1331),
    [aux_sym_keyword_statement_token7] = ACTIONS(1331),
    [aux_sym_include_statement_token1] = ACTIONS(1331),
    [aux_sym_data_statement_token1] = ACTIONS(1331),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1331),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1331),
    [aux_sym_end_if_statement_token1] = ACTIONS(1331),
    [aux_sym_elseif_clause_token2] = ACTIONS(1331),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1331),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token3] = ACTIONS(1331),
    [aux_sym_select_type_statement_token1] = ACTIONS(1331),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1331),
    [aux_sym_block_construct_token1] = ACTIONS(1331),
    [aux_sym_associate_statement_token1] = ACTIONS(1331),
    [aux_sym_format_statement_token1] = ACTIONS(1331),
    [aux_sym_print_statement_token1] = ACTIONS(1331),
    [aux_sym_open_statement_token1] = ACTIONS(1331),
    [aux_sym_close_statement_token1] = ACTIONS(1331),
    [aux_sym_inquire_statement_token1] = ACTIONS(1331),
    [aux_sym_enum_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token2] = ACTIONS(1331),
    [aux_sym_file_position_statement_token3] = ACTIONS(1331),
    [aux_sym_file_position_statement_token4] = ACTIONS(1331),
    [aux_sym_logical_expression_token5] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [sym_boolean_literal] = ACTIONS(1333),
    [aux_sym_null_literal_token1] = ACTIONS(1331),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1331),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1333),
    [sym__float_literal] = ACTIONS(1333),
    [sym__boz_literal] = ACTIONS(1333),
    [sym_string_literal] = ACTIONS(1333),
  },
  [358] = {
    [sym_preproc_file_line] = STATE(358),
    [aux_sym_end_program_statement_token1] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [aux_sym_interface_statement_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1335),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1335),
    [aux_sym_contains_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token2] = ACTIONS(1335),
    [aux_sym_implicit_statement_token1] = ACTIONS(1335),
    [aux_sym_implicit_statement_token3] = ACTIONS(1335),
    [aux_sym_implicit_statement_token4] = ACTIONS(1335),
    [aux_sym_save_statement_token1] = ACTIONS(1335),
    [aux_sym_private_statement_token1] = ACTIONS(1335),
    [aux_sym_public_statement_token1] = ACTIONS(1335),
    [aux_sym_namelist_statement_token1] = ACTIONS(1335),
    [aux_sym_common_statement_token1] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [aux_sym_import_statement_token1] = ACTIONS(1335),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1335),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1335),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1335),
    [aux_sym_variable_attributes_token1] = ACTIONS(1335),
    [aux_sym_variable_attributes_token2] = ACTIONS(1335),
    [aux_sym_variable_attributes_token3] = ACTIONS(1335),
    [aux_sym_variable_attributes_token4] = ACTIONS(1335),
    [aux_sym_variable_attributes_token5] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1335),
    [aux_sym_derived_type_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token2] = ACTIONS(1335),
    [aux_sym_type_qualifier_token3] = ACTIONS(1335),
    [aux_sym_type_qualifier_token4] = ACTIONS(1335),
    [aux_sym_type_qualifier_token5] = ACTIONS(1335),
    [aux_sym_type_qualifier_token9] = ACTIONS(1335),
    [aux_sym_type_qualifier_token10] = ACTIONS(1335),
    [aux_sym_type_qualifier_token11] = ACTIONS(1335),
    [aux_sym_type_qualifier_token12] = ACTIONS(1335),
    [aux_sym_type_qualifier_token13] = ACTIONS(1335),
    [aux_sym_type_qualifier_token14] = ACTIONS(1335),
    [aux_sym_type_qualifier_token15] = ACTIONS(1335),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token2] = ACTIONS(1335),
    [aux_sym_subroutine_call_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token2] = ACTIONS(1335),
    [aux_sym_keyword_statement_token3] = ACTIONS(1335),
    [aux_sym_keyword_statement_token4] = ACTIONS(1335),
    [aux_sym_keyword_statement_token6] = ACTIONS(1335),
    [aux_sym_keyword_statement_token7] = ACTIONS(1335),
    [aux_sym_include_statement_token1] = ACTIONS(1335),
    [aux_sym_data_statement_token1] = ACTIONS(1335),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1335),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1335),
    [aux_sym_end_if_statement_token1] = ACTIONS(1335),
    [aux_sym_elseif_clause_token2] = ACTIONS(1335),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1335),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token3] = ACTIONS(1335),
    [aux_sym_select_type_statement_token1] = ACTIONS(1335),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1335),
    [aux_sym_block_construct_token1] = ACTIONS(1335),
    [aux_sym_associate_statement_token1] = ACTIONS(1335),
    [aux_sym_format_statement_token1] = ACTIONS(1335),
    [aux_sym_print_statement_token1] = ACTIONS(1335),
    [aux_sym_open_statement_token1] = ACTIONS(1335),
    [aux_sym_close_statement_token1] = ACTIONS(1335),
    [aux_sym_inquire_statement_token1] = ACTIONS(1335),
    [aux_sym_enum_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token2] = ACTIONS(1335),
    [aux_sym_file_position_statement_token3] = ACTIONS(1335),
    [aux_sym_file_position_statement_token4] = ACTIONS(1335),
    [aux_sym_logical_expression_token5] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [sym_boolean_literal] = ACTIONS(1337),
    [aux_sym_null_literal_token1] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1335),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1337),
    [sym__float_literal] = ACTIONS(1337),
    [sym__boz_literal] = ACTIONS(1337),
    [sym_string_literal] = ACTIONS(1337),
  },
  [359] = {
    [sym_preproc_file_line] = STATE(359),
    [aux_sym_end_program_statement_token1] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [aux_sym_interface_statement_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1339),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1339),
    [aux_sym_contains_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token2] = ACTIONS(1339),
    [aux_sym_implicit_statement_token1] = ACTIONS(1339),
    [aux_sym_implicit_statement_token3] = ACTIONS(1339),
    [aux_sym_implicit_statement_token4] = ACTIONS(1339),
    [aux_sym_save_statement_token1] = ACTIONS(1339),
    [aux_sym_private_statement_token1] = ACTIONS(1339),
    [aux_sym_public_statement_token1] = ACTIONS(1339),
    [aux_sym_namelist_statement_token1] = ACTIONS(1339),
    [aux_sym_common_statement_token1] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1341),
    [aux_sym_import_statement_token1] = ACTIONS(1339),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1339),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1339),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1339),
    [aux_sym_variable_attributes_token1] = ACTIONS(1339),
    [aux_sym_variable_attributes_token2] = ACTIONS(1339),
    [aux_sym_variable_attributes_token3] = ACTIONS(1339),
    [aux_sym_variable_attributes_token4] = ACTIONS(1339),
    [aux_sym_variable_attributes_token5] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1339),
    [aux_sym_derived_type_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token2] = ACTIONS(1339),
    [aux_sym_type_qualifier_token3] = ACTIONS(1339),
    [aux_sym_type_qualifier_token4] = ACTIONS(1339),
    [aux_sym_type_qualifier_token5] = ACTIONS(1339),
    [aux_sym_type_qualifier_token9] = ACTIONS(1339),
    [aux_sym_type_qualifier_token10] = ACTIONS(1339),
    [aux_sym_type_qualifier_token11] = ACTIONS(1339),
    [aux_sym_type_qualifier_token12] = ACTIONS(1339),
    [aux_sym_type_qualifier_token13] = ACTIONS(1339),
    [aux_sym_type_qualifier_token14] = ACTIONS(1339),
    [aux_sym_type_qualifier_token15] = ACTIONS(1339),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token2] = ACTIONS(1339),
    [aux_sym_subroutine_call_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token2] = ACTIONS(1339),
    [aux_sym_keyword_statement_token3] = ACTIONS(1339),
    [aux_sym_keyword_statement_token4] = ACTIONS(1339),
    [aux_sym_keyword_statement_token6] = ACTIONS(1339),
    [aux_sym_keyword_statement_token7] = ACTIONS(1339),
    [aux_sym_include_statement_token1] = ACTIONS(1339),
    [aux_sym_data_statement_token1] = ACTIONS(1339),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1339),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1339),
    [aux_sym_end_if_statement_token1] = ACTIONS(1339),
    [aux_sym_elseif_clause_token2] = ACTIONS(1339),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1339),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token3] = ACTIONS(1339),
    [aux_sym_select_type_statement_token1] = ACTIONS(1339),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1339),
    [aux_sym_block_construct_token1] = ACTIONS(1339),
    [aux_sym_associate_statement_token1] = ACTIONS(1339),
    [aux_sym_format_statement_token1] = ACTIONS(1339),
    [aux_sym_print_statement_token1] = ACTIONS(1339),
    [aux_sym_open_statement_token1] = ACTIONS(1339),
    [aux_sym_close_statement_token1] = ACTIONS(1339),
    [aux_sym_inquire_statement_token1] = ACTIONS(1339),
    [aux_sym_enum_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token2] = ACTIONS(1339),
    [aux_sym_file_position_statement_token3] = ACTIONS(1339),
    [aux_sym_file_position_statement_token4] = ACTIONS(1339),
    [aux_sym_logical_expression_token5] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [sym_boolean_literal] = ACTIONS(1341),
    [aux_sym_null_literal_token1] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1339),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1341),
    [sym__float_literal] = ACTIONS(1341),
    [sym__boz_literal] = ACTIONS(1341),
    [sym_string_literal] = ACTIONS(1341),
  },
  [360] = {
    [sym_preproc_file_line] = STATE(360),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_contains_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [361] = {
    [sym_preproc_file_line] = STATE(361),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_contains_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [362] = {
    [sym_preproc_file_line] = STATE(362),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_contains_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [363] = {
    [sym_preproc_file_line] = STATE(363),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_contains_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [364] = {
    [sym_preproc_file_line] = STATE(364),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_contains_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [365] = {
    [sym_preproc_file_line] = STATE(365),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_contains_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [366] = {
    [sym_preproc_file_line] = STATE(366),
    [aux_sym_end_program_statement_token1] = ACTIONS(1331),
    [aux_sym_end_program_statement_token2] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1331),
    [aux_sym_interface_statement_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1331),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1331),
    [aux_sym_contains_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token2] = ACTIONS(1331),
    [aux_sym_implicit_statement_token1] = ACTIONS(1331),
    [aux_sym_implicit_statement_token3] = ACTIONS(1331),
    [aux_sym_implicit_statement_token4] = ACTIONS(1331),
    [aux_sym_save_statement_token1] = ACTIONS(1331),
    [aux_sym_private_statement_token1] = ACTIONS(1331),
    [aux_sym_public_statement_token1] = ACTIONS(1331),
    [aux_sym_namelist_statement_token1] = ACTIONS(1331),
    [aux_sym_common_statement_token1] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [aux_sym_import_statement_token1] = ACTIONS(1331),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1331),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1331),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1331),
    [aux_sym_variable_attributes_token1] = ACTIONS(1331),
    [aux_sym_variable_attributes_token2] = ACTIONS(1331),
    [aux_sym_variable_attributes_token3] = ACTIONS(1331),
    [aux_sym_variable_attributes_token4] = ACTIONS(1331),
    [aux_sym_variable_attributes_token5] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1331),
    [aux_sym_derived_type_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token2] = ACTIONS(1331),
    [aux_sym_type_qualifier_token3] = ACTIONS(1331),
    [aux_sym_type_qualifier_token4] = ACTIONS(1331),
    [aux_sym_type_qualifier_token5] = ACTIONS(1331),
    [aux_sym_type_qualifier_token9] = ACTIONS(1331),
    [aux_sym_type_qualifier_token10] = ACTIONS(1331),
    [aux_sym_type_qualifier_token11] = ACTIONS(1331),
    [aux_sym_type_qualifier_token12] = ACTIONS(1331),
    [aux_sym_type_qualifier_token13] = ACTIONS(1331),
    [aux_sym_type_qualifier_token14] = ACTIONS(1331),
    [aux_sym_type_qualifier_token15] = ACTIONS(1331),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token2] = ACTIONS(1331),
    [aux_sym_subroutine_call_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token2] = ACTIONS(1331),
    [aux_sym_keyword_statement_token3] = ACTIONS(1331),
    [aux_sym_keyword_statement_token4] = ACTIONS(1331),
    [aux_sym_keyword_statement_token6] = ACTIONS(1331),
    [aux_sym_keyword_statement_token7] = ACTIONS(1331),
    [aux_sym_include_statement_token1] = ACTIONS(1331),
    [aux_sym_data_statement_token1] = ACTIONS(1331),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1331),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1331),
    [aux_sym_end_if_statement_token1] = ACTIONS(1331),
    [aux_sym_elseif_clause_token2] = ACTIONS(1331),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1331),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token3] = ACTIONS(1331),
    [aux_sym_select_type_statement_token1] = ACTIONS(1331),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1331),
    [aux_sym_block_construct_token1] = ACTIONS(1331),
    [aux_sym_associate_statement_token1] = ACTIONS(1331),
    [aux_sym_format_statement_token1] = ACTIONS(1331),
    [aux_sym_print_statement_token1] = ACTIONS(1331),
    [aux_sym_open_statement_token1] = ACTIONS(1331),
    [aux_sym_close_statement_token1] = ACTIONS(1331),
    [aux_sym_inquire_statement_token1] = ACTIONS(1331),
    [aux_sym_enum_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token2] = ACTIONS(1331),
    [aux_sym_file_position_statement_token3] = ACTIONS(1331),
    [aux_sym_file_position_statement_token4] = ACTIONS(1331),
    [aux_sym_logical_expression_token5] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [sym_boolean_literal] = ACTIONS(1333),
    [aux_sym_null_literal_token1] = ACTIONS(1331),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1331),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1333),
    [sym__float_literal] = ACTIONS(1333),
    [sym__boz_literal] = ACTIONS(1333),
    [sym_string_literal] = ACTIONS(1333),
  },
  [367] = {
    [sym_preproc_file_line] = STATE(367),
    [aux_sym_end_program_statement_token1] = ACTIONS(1275),
    [aux_sym_end_program_statement_token2] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [aux_sym_interface_statement_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1275),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1275),
    [aux_sym_contains_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token2] = ACTIONS(1275),
    [aux_sym_implicit_statement_token1] = ACTIONS(1275),
    [aux_sym_implicit_statement_token3] = ACTIONS(1275),
    [aux_sym_implicit_statement_token4] = ACTIONS(1275),
    [aux_sym_save_statement_token1] = ACTIONS(1275),
    [aux_sym_private_statement_token1] = ACTIONS(1275),
    [aux_sym_public_statement_token1] = ACTIONS(1275),
    [aux_sym_namelist_statement_token1] = ACTIONS(1275),
    [aux_sym_common_statement_token1] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1277),
    [aux_sym_import_statement_token1] = ACTIONS(1275),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1275),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1275),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1275),
    [aux_sym_variable_attributes_token1] = ACTIONS(1275),
    [aux_sym_variable_attributes_token2] = ACTIONS(1275),
    [aux_sym_variable_attributes_token3] = ACTIONS(1275),
    [aux_sym_variable_attributes_token4] = ACTIONS(1275),
    [aux_sym_variable_attributes_token5] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1275),
    [aux_sym_derived_type_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token2] = ACTIONS(1275),
    [aux_sym_type_qualifier_token3] = ACTIONS(1275),
    [aux_sym_type_qualifier_token4] = ACTIONS(1275),
    [aux_sym_type_qualifier_token5] = ACTIONS(1275),
    [aux_sym_type_qualifier_token9] = ACTIONS(1275),
    [aux_sym_type_qualifier_token10] = ACTIONS(1275),
    [aux_sym_type_qualifier_token11] = ACTIONS(1275),
    [aux_sym_type_qualifier_token12] = ACTIONS(1275),
    [aux_sym_type_qualifier_token13] = ACTIONS(1275),
    [aux_sym_type_qualifier_token14] = ACTIONS(1275),
    [aux_sym_type_qualifier_token15] = ACTIONS(1275),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token2] = ACTIONS(1275),
    [aux_sym_subroutine_call_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token2] = ACTIONS(1275),
    [aux_sym_keyword_statement_token3] = ACTIONS(1275),
    [aux_sym_keyword_statement_token4] = ACTIONS(1275),
    [aux_sym_keyword_statement_token6] = ACTIONS(1275),
    [aux_sym_keyword_statement_token7] = ACTIONS(1275),
    [aux_sym_include_statement_token1] = ACTIONS(1275),
    [aux_sym_data_statement_token1] = ACTIONS(1275),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1275),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1275),
    [aux_sym_end_if_statement_token1] = ACTIONS(1275),
    [aux_sym_elseif_clause_token2] = ACTIONS(1275),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1275),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token3] = ACTIONS(1275),
    [aux_sym_select_type_statement_token1] = ACTIONS(1275),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1275),
    [aux_sym_block_construct_token1] = ACTIONS(1275),
    [aux_sym_associate_statement_token1] = ACTIONS(1275),
    [aux_sym_format_statement_token1] = ACTIONS(1275),
    [aux_sym_print_statement_token1] = ACTIONS(1275),
    [aux_sym_open_statement_token1] = ACTIONS(1275),
    [aux_sym_close_statement_token1] = ACTIONS(1275),
    [aux_sym_inquire_statement_token1] = ACTIONS(1275),
    [aux_sym_enum_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token2] = ACTIONS(1275),
    [aux_sym_file_position_statement_token3] = ACTIONS(1275),
    [aux_sym_file_position_statement_token4] = ACTIONS(1275),
    [aux_sym_logical_expression_token5] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [sym_boolean_literal] = ACTIONS(1277),
    [aux_sym_null_literal_token1] = ACTIONS(1275),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1275),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1277),
    [sym__float_literal] = ACTIONS(1277),
    [sym__boz_literal] = ACTIONS(1277),
    [sym_string_literal] = ACTIONS(1277),
  },
  [368] = {
    [sym_preproc_file_line] = STATE(368),
    [aux_sym_end_program_statement_token1] = ACTIONS(1287),
    [aux_sym_end_program_statement_token2] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [aux_sym_interface_statement_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1287),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1287),
    [aux_sym_contains_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token2] = ACTIONS(1287),
    [aux_sym_implicit_statement_token1] = ACTIONS(1287),
    [aux_sym_implicit_statement_token3] = ACTIONS(1287),
    [aux_sym_implicit_statement_token4] = ACTIONS(1287),
    [aux_sym_save_statement_token1] = ACTIONS(1287),
    [aux_sym_private_statement_token1] = ACTIONS(1287),
    [aux_sym_public_statement_token1] = ACTIONS(1287),
    [aux_sym_namelist_statement_token1] = ACTIONS(1287),
    [aux_sym_common_statement_token1] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1289),
    [aux_sym_import_statement_token1] = ACTIONS(1287),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1287),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1287),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1287),
    [aux_sym_variable_attributes_token1] = ACTIONS(1287),
    [aux_sym_variable_attributes_token2] = ACTIONS(1287),
    [aux_sym_variable_attributes_token3] = ACTIONS(1287),
    [aux_sym_variable_attributes_token4] = ACTIONS(1287),
    [aux_sym_variable_attributes_token5] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1287),
    [aux_sym_derived_type_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token2] = ACTIONS(1287),
    [aux_sym_type_qualifier_token3] = ACTIONS(1287),
    [aux_sym_type_qualifier_token4] = ACTIONS(1287),
    [aux_sym_type_qualifier_token5] = ACTIONS(1287),
    [aux_sym_type_qualifier_token9] = ACTIONS(1287),
    [aux_sym_type_qualifier_token10] = ACTIONS(1287),
    [aux_sym_type_qualifier_token11] = ACTIONS(1287),
    [aux_sym_type_qualifier_token12] = ACTIONS(1287),
    [aux_sym_type_qualifier_token13] = ACTIONS(1287),
    [aux_sym_type_qualifier_token14] = ACTIONS(1287),
    [aux_sym_type_qualifier_token15] = ACTIONS(1287),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token2] = ACTIONS(1287),
    [aux_sym_subroutine_call_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token2] = ACTIONS(1287),
    [aux_sym_keyword_statement_token3] = ACTIONS(1287),
    [aux_sym_keyword_statement_token4] = ACTIONS(1287),
    [aux_sym_keyword_statement_token6] = ACTIONS(1287),
    [aux_sym_keyword_statement_token7] = ACTIONS(1287),
    [aux_sym_include_statement_token1] = ACTIONS(1287),
    [aux_sym_data_statement_token1] = ACTIONS(1287),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1287),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1287),
    [aux_sym_end_if_statement_token1] = ACTIONS(1287),
    [aux_sym_elseif_clause_token2] = ACTIONS(1287),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1287),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token3] = ACTIONS(1287),
    [aux_sym_select_type_statement_token1] = ACTIONS(1287),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1287),
    [aux_sym_block_construct_token1] = ACTIONS(1287),
    [aux_sym_associate_statement_token1] = ACTIONS(1287),
    [aux_sym_format_statement_token1] = ACTIONS(1287),
    [aux_sym_print_statement_token1] = ACTIONS(1287),
    [aux_sym_open_statement_token1] = ACTIONS(1287),
    [aux_sym_close_statement_token1] = ACTIONS(1287),
    [aux_sym_inquire_statement_token1] = ACTIONS(1287),
    [aux_sym_enum_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token2] = ACTIONS(1287),
    [aux_sym_file_position_statement_token3] = ACTIONS(1287),
    [aux_sym_file_position_statement_token4] = ACTIONS(1287),
    [aux_sym_logical_expression_token5] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [sym_boolean_literal] = ACTIONS(1289),
    [aux_sym_null_literal_token1] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1287),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1289),
    [sym__float_literal] = ACTIONS(1289),
    [sym__boz_literal] = ACTIONS(1289),
    [sym_string_literal] = ACTIONS(1289),
  },
  [369] = {
    [sym_preproc_file_line] = STATE(369),
    [aux_sym_end_program_statement_token1] = ACTIONS(1279),
    [aux_sym_end_program_statement_token2] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [aux_sym_interface_statement_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1279),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1279),
    [aux_sym_contains_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token2] = ACTIONS(1279),
    [aux_sym_implicit_statement_token1] = ACTIONS(1279),
    [aux_sym_implicit_statement_token3] = ACTIONS(1279),
    [aux_sym_implicit_statement_token4] = ACTIONS(1279),
    [aux_sym_save_statement_token1] = ACTIONS(1279),
    [aux_sym_private_statement_token1] = ACTIONS(1279),
    [aux_sym_public_statement_token1] = ACTIONS(1279),
    [aux_sym_namelist_statement_token1] = ACTIONS(1279),
    [aux_sym_common_statement_token1] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1281),
    [aux_sym_import_statement_token1] = ACTIONS(1279),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1279),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1279),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1279),
    [aux_sym_variable_attributes_token1] = ACTIONS(1279),
    [aux_sym_variable_attributes_token2] = ACTIONS(1279),
    [aux_sym_variable_attributes_token3] = ACTIONS(1279),
    [aux_sym_variable_attributes_token4] = ACTIONS(1279),
    [aux_sym_variable_attributes_token5] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1279),
    [aux_sym_derived_type_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token2] = ACTIONS(1279),
    [aux_sym_type_qualifier_token3] = ACTIONS(1279),
    [aux_sym_type_qualifier_token4] = ACTIONS(1279),
    [aux_sym_type_qualifier_token5] = ACTIONS(1279),
    [aux_sym_type_qualifier_token9] = ACTIONS(1279),
    [aux_sym_type_qualifier_token10] = ACTIONS(1279),
    [aux_sym_type_qualifier_token11] = ACTIONS(1279),
    [aux_sym_type_qualifier_token12] = ACTIONS(1279),
    [aux_sym_type_qualifier_token13] = ACTIONS(1279),
    [aux_sym_type_qualifier_token14] = ACTIONS(1279),
    [aux_sym_type_qualifier_token15] = ACTIONS(1279),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token2] = ACTIONS(1279),
    [aux_sym_subroutine_call_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token2] = ACTIONS(1279),
    [aux_sym_keyword_statement_token3] = ACTIONS(1279),
    [aux_sym_keyword_statement_token4] = ACTIONS(1279),
    [aux_sym_keyword_statement_token6] = ACTIONS(1279),
    [aux_sym_keyword_statement_token7] = ACTIONS(1279),
    [aux_sym_include_statement_token1] = ACTIONS(1279),
    [aux_sym_data_statement_token1] = ACTIONS(1279),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1279),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1279),
    [aux_sym_end_if_statement_token1] = ACTIONS(1279),
    [aux_sym_elseif_clause_token2] = ACTIONS(1279),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1279),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token3] = ACTIONS(1279),
    [aux_sym_select_type_statement_token1] = ACTIONS(1279),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1279),
    [aux_sym_block_construct_token1] = ACTIONS(1279),
    [aux_sym_associate_statement_token1] = ACTIONS(1279),
    [aux_sym_format_statement_token1] = ACTIONS(1279),
    [aux_sym_print_statement_token1] = ACTIONS(1279),
    [aux_sym_open_statement_token1] = ACTIONS(1279),
    [aux_sym_close_statement_token1] = ACTIONS(1279),
    [aux_sym_inquire_statement_token1] = ACTIONS(1279),
    [aux_sym_enum_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token2] = ACTIONS(1279),
    [aux_sym_file_position_statement_token3] = ACTIONS(1279),
    [aux_sym_file_position_statement_token4] = ACTIONS(1279),
    [aux_sym_logical_expression_token5] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [sym_boolean_literal] = ACTIONS(1281),
    [aux_sym_null_literal_token1] = ACTIONS(1279),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1279),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1281),
    [sym__float_literal] = ACTIONS(1281),
    [sym__boz_literal] = ACTIONS(1281),
    [sym_string_literal] = ACTIONS(1281),
  },
  [370] = {
    [sym_preproc_file_line] = STATE(370),
    [aux_sym_end_program_statement_token1] = ACTIONS(1283),
    [aux_sym_end_program_statement_token2] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [aux_sym_interface_statement_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1283),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1283),
    [aux_sym_contains_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token2] = ACTIONS(1283),
    [aux_sym_implicit_statement_token1] = ACTIONS(1283),
    [aux_sym_implicit_statement_token3] = ACTIONS(1283),
    [aux_sym_implicit_statement_token4] = ACTIONS(1283),
    [aux_sym_save_statement_token1] = ACTIONS(1283),
    [aux_sym_private_statement_token1] = ACTIONS(1283),
    [aux_sym_public_statement_token1] = ACTIONS(1283),
    [aux_sym_namelist_statement_token1] = ACTIONS(1283),
    [aux_sym_common_statement_token1] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1285),
    [aux_sym_import_statement_token1] = ACTIONS(1283),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1283),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1283),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1283),
    [aux_sym_variable_attributes_token1] = ACTIONS(1283),
    [aux_sym_variable_attributes_token2] = ACTIONS(1283),
    [aux_sym_variable_attributes_token3] = ACTIONS(1283),
    [aux_sym_variable_attributes_token4] = ACTIONS(1283),
    [aux_sym_variable_attributes_token5] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1283),
    [aux_sym_derived_type_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token2] = ACTIONS(1283),
    [aux_sym_type_qualifier_token3] = ACTIONS(1283),
    [aux_sym_type_qualifier_token4] = ACTIONS(1283),
    [aux_sym_type_qualifier_token5] = ACTIONS(1283),
    [aux_sym_type_qualifier_token9] = ACTIONS(1283),
    [aux_sym_type_qualifier_token10] = ACTIONS(1283),
    [aux_sym_type_qualifier_token11] = ACTIONS(1283),
    [aux_sym_type_qualifier_token12] = ACTIONS(1283),
    [aux_sym_type_qualifier_token13] = ACTIONS(1283),
    [aux_sym_type_qualifier_token14] = ACTIONS(1283),
    [aux_sym_type_qualifier_token15] = ACTIONS(1283),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token2] = ACTIONS(1283),
    [aux_sym_subroutine_call_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token2] = ACTIONS(1283),
    [aux_sym_keyword_statement_token3] = ACTIONS(1283),
    [aux_sym_keyword_statement_token4] = ACTIONS(1283),
    [aux_sym_keyword_statement_token6] = ACTIONS(1283),
    [aux_sym_keyword_statement_token7] = ACTIONS(1283),
    [aux_sym_include_statement_token1] = ACTIONS(1283),
    [aux_sym_data_statement_token1] = ACTIONS(1283),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1283),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1283),
    [aux_sym_end_if_statement_token1] = ACTIONS(1283),
    [aux_sym_elseif_clause_token2] = ACTIONS(1283),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1283),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token3] = ACTIONS(1283),
    [aux_sym_select_type_statement_token1] = ACTIONS(1283),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1283),
    [aux_sym_block_construct_token1] = ACTIONS(1283),
    [aux_sym_associate_statement_token1] = ACTIONS(1283),
    [aux_sym_format_statement_token1] = ACTIONS(1283),
    [aux_sym_print_statement_token1] = ACTIONS(1283),
    [aux_sym_open_statement_token1] = ACTIONS(1283),
    [aux_sym_close_statement_token1] = ACTIONS(1283),
    [aux_sym_inquire_statement_token1] = ACTIONS(1283),
    [aux_sym_enum_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token2] = ACTIONS(1283),
    [aux_sym_file_position_statement_token3] = ACTIONS(1283),
    [aux_sym_file_position_statement_token4] = ACTIONS(1283),
    [aux_sym_logical_expression_token5] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [sym_boolean_literal] = ACTIONS(1285),
    [aux_sym_null_literal_token1] = ACTIONS(1283),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1285),
    [sym__float_literal] = ACTIONS(1285),
    [sym__boz_literal] = ACTIONS(1285),
    [sym_string_literal] = ACTIONS(1285),
  },
  [371] = {
    [sym_preproc_file_line] = STATE(371),
    [aux_sym_end_program_statement_token1] = ACTIONS(1335),
    [aux_sym_end_program_statement_token2] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [aux_sym_interface_statement_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1335),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1335),
    [aux_sym_contains_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token2] = ACTIONS(1335),
    [aux_sym_implicit_statement_token1] = ACTIONS(1335),
    [aux_sym_implicit_statement_token3] = ACTIONS(1335),
    [aux_sym_implicit_statement_token4] = ACTIONS(1335),
    [aux_sym_save_statement_token1] = ACTIONS(1335),
    [aux_sym_private_statement_token1] = ACTIONS(1335),
    [aux_sym_public_statement_token1] = ACTIONS(1335),
    [aux_sym_namelist_statement_token1] = ACTIONS(1335),
    [aux_sym_common_statement_token1] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [aux_sym_import_statement_token1] = ACTIONS(1335),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1335),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1335),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1335),
    [aux_sym_variable_attributes_token1] = ACTIONS(1335),
    [aux_sym_variable_attributes_token2] = ACTIONS(1335),
    [aux_sym_variable_attributes_token3] = ACTIONS(1335),
    [aux_sym_variable_attributes_token4] = ACTIONS(1335),
    [aux_sym_variable_attributes_token5] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1335),
    [aux_sym_derived_type_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token2] = ACTIONS(1335),
    [aux_sym_type_qualifier_token3] = ACTIONS(1335),
    [aux_sym_type_qualifier_token4] = ACTIONS(1335),
    [aux_sym_type_qualifier_token5] = ACTIONS(1335),
    [aux_sym_type_qualifier_token9] = ACTIONS(1335),
    [aux_sym_type_qualifier_token10] = ACTIONS(1335),
    [aux_sym_type_qualifier_token11] = ACTIONS(1335),
    [aux_sym_type_qualifier_token12] = ACTIONS(1335),
    [aux_sym_type_qualifier_token13] = ACTIONS(1335),
    [aux_sym_type_qualifier_token14] = ACTIONS(1335),
    [aux_sym_type_qualifier_token15] = ACTIONS(1335),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token2] = ACTIONS(1335),
    [aux_sym_subroutine_call_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token2] = ACTIONS(1335),
    [aux_sym_keyword_statement_token3] = ACTIONS(1335),
    [aux_sym_keyword_statement_token4] = ACTIONS(1335),
    [aux_sym_keyword_statement_token6] = ACTIONS(1335),
    [aux_sym_keyword_statement_token7] = ACTIONS(1335),
    [aux_sym_include_statement_token1] = ACTIONS(1335),
    [aux_sym_data_statement_token1] = ACTIONS(1335),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1335),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1335),
    [aux_sym_end_if_statement_token1] = ACTIONS(1335),
    [aux_sym_elseif_clause_token2] = ACTIONS(1335),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1335),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token3] = ACTIONS(1335),
    [aux_sym_select_type_statement_token1] = ACTIONS(1335),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1335),
    [aux_sym_block_construct_token1] = ACTIONS(1335),
    [aux_sym_associate_statement_token1] = ACTIONS(1335),
    [aux_sym_format_statement_token1] = ACTIONS(1335),
    [aux_sym_print_statement_token1] = ACTIONS(1335),
    [aux_sym_open_statement_token1] = ACTIONS(1335),
    [aux_sym_close_statement_token1] = ACTIONS(1335),
    [aux_sym_inquire_statement_token1] = ACTIONS(1335),
    [aux_sym_enum_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token2] = ACTIONS(1335),
    [aux_sym_file_position_statement_token3] = ACTIONS(1335),
    [aux_sym_file_position_statement_token4] = ACTIONS(1335),
    [aux_sym_logical_expression_token5] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [sym_boolean_literal] = ACTIONS(1337),
    [aux_sym_null_literal_token1] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1335),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1337),
    [sym__float_literal] = ACTIONS(1337),
    [sym__boz_literal] = ACTIONS(1337),
    [sym_string_literal] = ACTIONS(1337),
  },
  [372] = {
    [sym_preproc_file_line] = STATE(372),
    [aux_sym_end_program_statement_token1] = ACTIONS(1307),
    [aux_sym_end_program_statement_token2] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [aux_sym_interface_statement_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1307),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1307),
    [aux_sym_contains_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token2] = ACTIONS(1307),
    [aux_sym_implicit_statement_token1] = ACTIONS(1307),
    [aux_sym_implicit_statement_token3] = ACTIONS(1307),
    [aux_sym_implicit_statement_token4] = ACTIONS(1307),
    [aux_sym_save_statement_token1] = ACTIONS(1307),
    [aux_sym_private_statement_token1] = ACTIONS(1307),
    [aux_sym_public_statement_token1] = ACTIONS(1307),
    [aux_sym_namelist_statement_token1] = ACTIONS(1307),
    [aux_sym_common_statement_token1] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1309),
    [aux_sym_import_statement_token1] = ACTIONS(1307),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1307),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1307),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1307),
    [aux_sym_variable_attributes_token1] = ACTIONS(1307),
    [aux_sym_variable_attributes_token2] = ACTIONS(1307),
    [aux_sym_variable_attributes_token3] = ACTIONS(1307),
    [aux_sym_variable_attributes_token4] = ACTIONS(1307),
    [aux_sym_variable_attributes_token5] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1307),
    [aux_sym_derived_type_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token2] = ACTIONS(1307),
    [aux_sym_type_qualifier_token3] = ACTIONS(1307),
    [aux_sym_type_qualifier_token4] = ACTIONS(1307),
    [aux_sym_type_qualifier_token5] = ACTIONS(1307),
    [aux_sym_type_qualifier_token9] = ACTIONS(1307),
    [aux_sym_type_qualifier_token10] = ACTIONS(1307),
    [aux_sym_type_qualifier_token11] = ACTIONS(1307),
    [aux_sym_type_qualifier_token12] = ACTIONS(1307),
    [aux_sym_type_qualifier_token13] = ACTIONS(1307),
    [aux_sym_type_qualifier_token14] = ACTIONS(1307),
    [aux_sym_type_qualifier_token15] = ACTIONS(1307),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token2] = ACTIONS(1307),
    [aux_sym_subroutine_call_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token2] = ACTIONS(1307),
    [aux_sym_keyword_statement_token3] = ACTIONS(1307),
    [aux_sym_keyword_statement_token4] = ACTIONS(1307),
    [aux_sym_keyword_statement_token6] = ACTIONS(1307),
    [aux_sym_keyword_statement_token7] = ACTIONS(1307),
    [aux_sym_include_statement_token1] = ACTIONS(1307),
    [aux_sym_data_statement_token1] = ACTIONS(1307),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1307),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1307),
    [aux_sym_end_if_statement_token1] = ACTIONS(1307),
    [aux_sym_elseif_clause_token2] = ACTIONS(1307),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1307),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token3] = ACTIONS(1307),
    [aux_sym_select_type_statement_token1] = ACTIONS(1307),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1307),
    [aux_sym_block_construct_token1] = ACTIONS(1307),
    [aux_sym_associate_statement_token1] = ACTIONS(1307),
    [aux_sym_format_statement_token1] = ACTIONS(1307),
    [aux_sym_print_statement_token1] = ACTIONS(1307),
    [aux_sym_open_statement_token1] = ACTIONS(1307),
    [aux_sym_close_statement_token1] = ACTIONS(1307),
    [aux_sym_inquire_statement_token1] = ACTIONS(1307),
    [aux_sym_enum_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token2] = ACTIONS(1307),
    [aux_sym_file_position_statement_token3] = ACTIONS(1307),
    [aux_sym_file_position_statement_token4] = ACTIONS(1307),
    [aux_sym_logical_expression_token5] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [sym_boolean_literal] = ACTIONS(1309),
    [aux_sym_null_literal_token1] = ACTIONS(1307),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1307),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1309),
    [sym__float_literal] = ACTIONS(1309),
    [sym__boz_literal] = ACTIONS(1309),
    [sym_string_literal] = ACTIONS(1309),
  },
  [373] = {
    [sym_preproc_file_line] = STATE(373),
    [aux_sym_end_program_statement_token1] = ACTIONS(1311),
    [aux_sym_end_program_statement_token2] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_interface_statement_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1311),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1311),
    [aux_sym_contains_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token2] = ACTIONS(1311),
    [aux_sym_implicit_statement_token1] = ACTIONS(1311),
    [aux_sym_implicit_statement_token3] = ACTIONS(1311),
    [aux_sym_implicit_statement_token4] = ACTIONS(1311),
    [aux_sym_save_statement_token1] = ACTIONS(1311),
    [aux_sym_private_statement_token1] = ACTIONS(1311),
    [aux_sym_public_statement_token1] = ACTIONS(1311),
    [aux_sym_namelist_statement_token1] = ACTIONS(1311),
    [aux_sym_common_statement_token1] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1313),
    [aux_sym_import_statement_token1] = ACTIONS(1311),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1311),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1311),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1311),
    [aux_sym_variable_attributes_token1] = ACTIONS(1311),
    [aux_sym_variable_attributes_token2] = ACTIONS(1311),
    [aux_sym_variable_attributes_token3] = ACTIONS(1311),
    [aux_sym_variable_attributes_token4] = ACTIONS(1311),
    [aux_sym_variable_attributes_token5] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1311),
    [aux_sym_derived_type_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token2] = ACTIONS(1311),
    [aux_sym_type_qualifier_token3] = ACTIONS(1311),
    [aux_sym_type_qualifier_token4] = ACTIONS(1311),
    [aux_sym_type_qualifier_token5] = ACTIONS(1311),
    [aux_sym_type_qualifier_token9] = ACTIONS(1311),
    [aux_sym_type_qualifier_token10] = ACTIONS(1311),
    [aux_sym_type_qualifier_token11] = ACTIONS(1311),
    [aux_sym_type_qualifier_token12] = ACTIONS(1311),
    [aux_sym_type_qualifier_token13] = ACTIONS(1311),
    [aux_sym_type_qualifier_token14] = ACTIONS(1311),
    [aux_sym_type_qualifier_token15] = ACTIONS(1311),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token2] = ACTIONS(1311),
    [aux_sym_subroutine_call_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token2] = ACTIONS(1311),
    [aux_sym_keyword_statement_token3] = ACTIONS(1311),
    [aux_sym_keyword_statement_token4] = ACTIONS(1311),
    [aux_sym_keyword_statement_token6] = ACTIONS(1311),
    [aux_sym_keyword_statement_token7] = ACTIONS(1311),
    [aux_sym_include_statement_token1] = ACTIONS(1311),
    [aux_sym_data_statement_token1] = ACTIONS(1311),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1311),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1311),
    [aux_sym_end_if_statement_token1] = ACTIONS(1311),
    [aux_sym_elseif_clause_token2] = ACTIONS(1311),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token3] = ACTIONS(1311),
    [aux_sym_select_type_statement_token1] = ACTIONS(1311),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1311),
    [aux_sym_block_construct_token1] = ACTIONS(1311),
    [aux_sym_associate_statement_token1] = ACTIONS(1311),
    [aux_sym_format_statement_token1] = ACTIONS(1311),
    [aux_sym_print_statement_token1] = ACTIONS(1311),
    [aux_sym_open_statement_token1] = ACTIONS(1311),
    [aux_sym_close_statement_token1] = ACTIONS(1311),
    [aux_sym_inquire_statement_token1] = ACTIONS(1311),
    [aux_sym_enum_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token2] = ACTIONS(1311),
    [aux_sym_file_position_statement_token3] = ACTIONS(1311),
    [aux_sym_file_position_statement_token4] = ACTIONS(1311),
    [aux_sym_logical_expression_token5] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [sym_boolean_literal] = ACTIONS(1313),
    [aux_sym_null_literal_token1] = ACTIONS(1311),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1311),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1313),
    [sym__float_literal] = ACTIONS(1313),
    [sym__boz_literal] = ACTIONS(1313),
    [sym_string_literal] = ACTIONS(1313),
  },
  [374] = {
    [sym_preproc_file_line] = STATE(374),
    [aux_sym_end_program_statement_token1] = ACTIONS(1315),
    [aux_sym_end_program_statement_token2] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [aux_sym_interface_statement_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1315),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1315),
    [aux_sym_contains_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token2] = ACTIONS(1315),
    [aux_sym_implicit_statement_token1] = ACTIONS(1315),
    [aux_sym_implicit_statement_token3] = ACTIONS(1315),
    [aux_sym_implicit_statement_token4] = ACTIONS(1315),
    [aux_sym_save_statement_token1] = ACTIONS(1315),
    [aux_sym_private_statement_token1] = ACTIONS(1315),
    [aux_sym_public_statement_token1] = ACTIONS(1315),
    [aux_sym_namelist_statement_token1] = ACTIONS(1315),
    [aux_sym_common_statement_token1] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1317),
    [aux_sym_import_statement_token1] = ACTIONS(1315),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1315),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1315),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1315),
    [aux_sym_variable_attributes_token1] = ACTIONS(1315),
    [aux_sym_variable_attributes_token2] = ACTIONS(1315),
    [aux_sym_variable_attributes_token3] = ACTIONS(1315),
    [aux_sym_variable_attributes_token4] = ACTIONS(1315),
    [aux_sym_variable_attributes_token5] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1315),
    [aux_sym_derived_type_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token2] = ACTIONS(1315),
    [aux_sym_type_qualifier_token3] = ACTIONS(1315),
    [aux_sym_type_qualifier_token4] = ACTIONS(1315),
    [aux_sym_type_qualifier_token5] = ACTIONS(1315),
    [aux_sym_type_qualifier_token9] = ACTIONS(1315),
    [aux_sym_type_qualifier_token10] = ACTIONS(1315),
    [aux_sym_type_qualifier_token11] = ACTIONS(1315),
    [aux_sym_type_qualifier_token12] = ACTIONS(1315),
    [aux_sym_type_qualifier_token13] = ACTIONS(1315),
    [aux_sym_type_qualifier_token14] = ACTIONS(1315),
    [aux_sym_type_qualifier_token15] = ACTIONS(1315),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token2] = ACTIONS(1315),
    [aux_sym_subroutine_call_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token2] = ACTIONS(1315),
    [aux_sym_keyword_statement_token3] = ACTIONS(1315),
    [aux_sym_keyword_statement_token4] = ACTIONS(1315),
    [aux_sym_keyword_statement_token6] = ACTIONS(1315),
    [aux_sym_keyword_statement_token7] = ACTIONS(1315),
    [aux_sym_include_statement_token1] = ACTIONS(1315),
    [aux_sym_data_statement_token1] = ACTIONS(1315),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1315),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1315),
    [aux_sym_end_if_statement_token1] = ACTIONS(1315),
    [aux_sym_elseif_clause_token2] = ACTIONS(1315),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1315),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token3] = ACTIONS(1315),
    [aux_sym_select_type_statement_token1] = ACTIONS(1315),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1315),
    [aux_sym_block_construct_token1] = ACTIONS(1315),
    [aux_sym_associate_statement_token1] = ACTIONS(1315),
    [aux_sym_format_statement_token1] = ACTIONS(1315),
    [aux_sym_print_statement_token1] = ACTIONS(1315),
    [aux_sym_open_statement_token1] = ACTIONS(1315),
    [aux_sym_close_statement_token1] = ACTIONS(1315),
    [aux_sym_inquire_statement_token1] = ACTIONS(1315),
    [aux_sym_enum_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token2] = ACTIONS(1315),
    [aux_sym_file_position_statement_token3] = ACTIONS(1315),
    [aux_sym_file_position_statement_token4] = ACTIONS(1315),
    [aux_sym_logical_expression_token5] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1315),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [sym_boolean_literal] = ACTIONS(1317),
    [aux_sym_null_literal_token1] = ACTIONS(1315),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1315),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1317),
    [sym__float_literal] = ACTIONS(1317),
    [sym__boz_literal] = ACTIONS(1317),
    [sym_string_literal] = ACTIONS(1317),
  },
  [375] = {
    [sym_preproc_file_line] = STATE(375),
    [aux_sym_end_program_statement_token1] = ACTIONS(1319),
    [aux_sym_end_program_statement_token2] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [aux_sym_interface_statement_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1319),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1319),
    [aux_sym_contains_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token2] = ACTIONS(1319),
    [aux_sym_implicit_statement_token1] = ACTIONS(1319),
    [aux_sym_implicit_statement_token3] = ACTIONS(1319),
    [aux_sym_implicit_statement_token4] = ACTIONS(1319),
    [aux_sym_save_statement_token1] = ACTIONS(1319),
    [aux_sym_private_statement_token1] = ACTIONS(1319),
    [aux_sym_public_statement_token1] = ACTIONS(1319),
    [aux_sym_namelist_statement_token1] = ACTIONS(1319),
    [aux_sym_common_statement_token1] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [aux_sym_import_statement_token1] = ACTIONS(1319),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1319),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1319),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1319),
    [aux_sym_variable_attributes_token1] = ACTIONS(1319),
    [aux_sym_variable_attributes_token2] = ACTIONS(1319),
    [aux_sym_variable_attributes_token3] = ACTIONS(1319),
    [aux_sym_variable_attributes_token4] = ACTIONS(1319),
    [aux_sym_variable_attributes_token5] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1319),
    [aux_sym_derived_type_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token2] = ACTIONS(1319),
    [aux_sym_type_qualifier_token3] = ACTIONS(1319),
    [aux_sym_type_qualifier_token4] = ACTIONS(1319),
    [aux_sym_type_qualifier_token5] = ACTIONS(1319),
    [aux_sym_type_qualifier_token9] = ACTIONS(1319),
    [aux_sym_type_qualifier_token10] = ACTIONS(1319),
    [aux_sym_type_qualifier_token11] = ACTIONS(1319),
    [aux_sym_type_qualifier_token12] = ACTIONS(1319),
    [aux_sym_type_qualifier_token13] = ACTIONS(1319),
    [aux_sym_type_qualifier_token14] = ACTIONS(1319),
    [aux_sym_type_qualifier_token15] = ACTIONS(1319),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token2] = ACTIONS(1319),
    [aux_sym_subroutine_call_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token2] = ACTIONS(1319),
    [aux_sym_keyword_statement_token3] = ACTIONS(1319),
    [aux_sym_keyword_statement_token4] = ACTIONS(1319),
    [aux_sym_keyword_statement_token6] = ACTIONS(1319),
    [aux_sym_keyword_statement_token7] = ACTIONS(1319),
    [aux_sym_include_statement_token1] = ACTIONS(1319),
    [aux_sym_data_statement_token1] = ACTIONS(1319),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1319),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1319),
    [aux_sym_end_if_statement_token1] = ACTIONS(1319),
    [aux_sym_elseif_clause_token2] = ACTIONS(1319),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1319),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token3] = ACTIONS(1319),
    [aux_sym_select_type_statement_token1] = ACTIONS(1319),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1319),
    [aux_sym_block_construct_token1] = ACTIONS(1319),
    [aux_sym_associate_statement_token1] = ACTIONS(1319),
    [aux_sym_format_statement_token1] = ACTIONS(1319),
    [aux_sym_print_statement_token1] = ACTIONS(1319),
    [aux_sym_open_statement_token1] = ACTIONS(1319),
    [aux_sym_close_statement_token1] = ACTIONS(1319),
    [aux_sym_inquire_statement_token1] = ACTIONS(1319),
    [aux_sym_enum_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token2] = ACTIONS(1319),
    [aux_sym_file_position_statement_token3] = ACTIONS(1319),
    [aux_sym_file_position_statement_token4] = ACTIONS(1319),
    [aux_sym_logical_expression_token5] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [sym_boolean_literal] = ACTIONS(1321),
    [aux_sym_null_literal_token1] = ACTIONS(1319),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1319),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1321),
    [sym__float_literal] = ACTIONS(1321),
    [sym__boz_literal] = ACTIONS(1321),
    [sym_string_literal] = ACTIONS(1321),
  },
  [376] = {
    [sym_preproc_file_line] = STATE(376),
    [aux_sym_end_program_statement_token1] = ACTIONS(1339),
    [aux_sym_end_program_statement_token2] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [aux_sym_interface_statement_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1339),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1339),
    [aux_sym_contains_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token2] = ACTIONS(1339),
    [aux_sym_implicit_statement_token1] = ACTIONS(1339),
    [aux_sym_implicit_statement_token3] = ACTIONS(1339),
    [aux_sym_implicit_statement_token4] = ACTIONS(1339),
    [aux_sym_save_statement_token1] = ACTIONS(1339),
    [aux_sym_private_statement_token1] = ACTIONS(1339),
    [aux_sym_public_statement_token1] = ACTIONS(1339),
    [aux_sym_namelist_statement_token1] = ACTIONS(1339),
    [aux_sym_common_statement_token1] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1341),
    [aux_sym_import_statement_token1] = ACTIONS(1339),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1339),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1339),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1339),
    [aux_sym_variable_attributes_token1] = ACTIONS(1339),
    [aux_sym_variable_attributes_token2] = ACTIONS(1339),
    [aux_sym_variable_attributes_token3] = ACTIONS(1339),
    [aux_sym_variable_attributes_token4] = ACTIONS(1339),
    [aux_sym_variable_attributes_token5] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1339),
    [aux_sym_derived_type_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token2] = ACTIONS(1339),
    [aux_sym_type_qualifier_token3] = ACTIONS(1339),
    [aux_sym_type_qualifier_token4] = ACTIONS(1339),
    [aux_sym_type_qualifier_token5] = ACTIONS(1339),
    [aux_sym_type_qualifier_token9] = ACTIONS(1339),
    [aux_sym_type_qualifier_token10] = ACTIONS(1339),
    [aux_sym_type_qualifier_token11] = ACTIONS(1339),
    [aux_sym_type_qualifier_token12] = ACTIONS(1339),
    [aux_sym_type_qualifier_token13] = ACTIONS(1339),
    [aux_sym_type_qualifier_token14] = ACTIONS(1339),
    [aux_sym_type_qualifier_token15] = ACTIONS(1339),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token2] = ACTIONS(1339),
    [aux_sym_subroutine_call_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token2] = ACTIONS(1339),
    [aux_sym_keyword_statement_token3] = ACTIONS(1339),
    [aux_sym_keyword_statement_token4] = ACTIONS(1339),
    [aux_sym_keyword_statement_token6] = ACTIONS(1339),
    [aux_sym_keyword_statement_token7] = ACTIONS(1339),
    [aux_sym_include_statement_token1] = ACTIONS(1339),
    [aux_sym_data_statement_token1] = ACTIONS(1339),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1339),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1339),
    [aux_sym_end_if_statement_token1] = ACTIONS(1339),
    [aux_sym_elseif_clause_token2] = ACTIONS(1339),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1339),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token3] = ACTIONS(1339),
    [aux_sym_select_type_statement_token1] = ACTIONS(1339),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1339),
    [aux_sym_block_construct_token1] = ACTIONS(1339),
    [aux_sym_associate_statement_token1] = ACTIONS(1339),
    [aux_sym_format_statement_token1] = ACTIONS(1339),
    [aux_sym_print_statement_token1] = ACTIONS(1339),
    [aux_sym_open_statement_token1] = ACTIONS(1339),
    [aux_sym_close_statement_token1] = ACTIONS(1339),
    [aux_sym_inquire_statement_token1] = ACTIONS(1339),
    [aux_sym_enum_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token2] = ACTIONS(1339),
    [aux_sym_file_position_statement_token3] = ACTIONS(1339),
    [aux_sym_file_position_statement_token4] = ACTIONS(1339),
    [aux_sym_logical_expression_token5] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [sym_boolean_literal] = ACTIONS(1341),
    [aux_sym_null_literal_token1] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1339),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1341),
    [sym__float_literal] = ACTIONS(1341),
    [sym__boz_literal] = ACTIONS(1341),
    [sym_string_literal] = ACTIONS(1341),
  },
  [377] = {
    [sym_preproc_file_line] = STATE(377),
    [aux_sym_end_program_statement_token1] = ACTIONS(1343),
    [aux_sym_end_program_statement_token2] = ACTIONS(1343),
    [anon_sym_LPAREN] = ACTIONS(1343),
    [aux_sym_interface_statement_token1] = ACTIONS(1343),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1343),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1343),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1343),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1343),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1343),
    [aux_sym_contains_statement_token1] = ACTIONS(1343),
    [aux_sym_use_statement_token1] = ACTIONS(1343),
    [aux_sym_use_statement_token2] = ACTIONS(1343),
    [aux_sym_implicit_statement_token1] = ACTIONS(1343),
    [aux_sym_implicit_statement_token3] = ACTIONS(1343),
    [aux_sym_implicit_statement_token4] = ACTIONS(1343),
    [aux_sym_save_statement_token1] = ACTIONS(1343),
    [aux_sym_private_statement_token1] = ACTIONS(1343),
    [aux_sym_public_statement_token1] = ACTIONS(1343),
    [aux_sym_namelist_statement_token1] = ACTIONS(1343),
    [aux_sym_common_statement_token1] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [aux_sym_import_statement_token1] = ACTIONS(1343),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1343),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1343),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1343),
    [aux_sym_variable_attributes_token1] = ACTIONS(1343),
    [aux_sym_variable_attributes_token2] = ACTIONS(1343),
    [aux_sym_variable_attributes_token3] = ACTIONS(1343),
    [aux_sym_variable_attributes_token4] = ACTIONS(1343),
    [aux_sym_variable_attributes_token5] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1343),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1343),
    [aux_sym_derived_type_token1] = ACTIONS(1343),
    [aux_sym_type_qualifier_token1] = ACTIONS(1343),
    [aux_sym_type_qualifier_token2] = ACTIONS(1343),
    [aux_sym_type_qualifier_token3] = ACTIONS(1343),
    [aux_sym_type_qualifier_token4] = ACTIONS(1343),
    [aux_sym_type_qualifier_token5] = ACTIONS(1343),
    [aux_sym_type_qualifier_token9] = ACTIONS(1343),
    [aux_sym_type_qualifier_token10] = ACTIONS(1343),
    [aux_sym_type_qualifier_token11] = ACTIONS(1343),
    [aux_sym_type_qualifier_token12] = ACTIONS(1343),
    [aux_sym_type_qualifier_token13] = ACTIONS(1343),
    [aux_sym_type_qualifier_token14] = ACTIONS(1343),
    [aux_sym_type_qualifier_token15] = ACTIONS(1343),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1343),
    [aux_sym_stop_statement_token1] = ACTIONS(1343),
    [aux_sym_stop_statement_token2] = ACTIONS(1343),
    [aux_sym_subroutine_call_token1] = ACTIONS(1343),
    [aux_sym_keyword_statement_token1] = ACTIONS(1343),
    [aux_sym_keyword_statement_token2] = ACTIONS(1343),
    [aux_sym_keyword_statement_token3] = ACTIONS(1343),
    [aux_sym_keyword_statement_token4] = ACTIONS(1343),
    [aux_sym_keyword_statement_token6] = ACTIONS(1343),
    [aux_sym_keyword_statement_token7] = ACTIONS(1343),
    [aux_sym_include_statement_token1] = ACTIONS(1343),
    [aux_sym_data_statement_token1] = ACTIONS(1343),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1343),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1343),
    [aux_sym_end_if_statement_token1] = ACTIONS(1343),
    [aux_sym_elseif_clause_token2] = ACTIONS(1343),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1343),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1343),
    [aux_sym_select_case_statement_token1] = ACTIONS(1343),
    [aux_sym_select_case_statement_token3] = ACTIONS(1343),
    [aux_sym_select_type_statement_token1] = ACTIONS(1343),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1343),
    [aux_sym_block_construct_token1] = ACTIONS(1343),
    [aux_sym_associate_statement_token1] = ACTIONS(1343),
    [aux_sym_format_statement_token1] = ACTIONS(1343),
    [aux_sym_print_statement_token1] = ACTIONS(1343),
    [aux_sym_open_statement_token1] = ACTIONS(1343),
    [aux_sym_close_statement_token1] = ACTIONS(1343),
    [aux_sym_inquire_statement_token1] = ACTIONS(1343),
    [aux_sym_enum_statement_token1] = ACTIONS(1343),
    [aux_sym_file_position_statement_token1] = ACTIONS(1343),
    [aux_sym_file_position_statement_token2] = ACTIONS(1343),
    [aux_sym_file_position_statement_token3] = ACTIONS(1343),
    [aux_sym_file_position_statement_token4] = ACTIONS(1343),
    [aux_sym_logical_expression_token5] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1343),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1345),
    [sym_boolean_literal] = ACTIONS(1345),
    [aux_sym_null_literal_token1] = ACTIONS(1343),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1343),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1345),
    [sym__float_literal] = ACTIONS(1345),
    [sym__boz_literal] = ACTIONS(1345),
    [sym_string_literal] = ACTIONS(1345),
  },
  [378] = {
    [sym_preproc_file_line] = STATE(378),
    [aux_sym_end_program_statement_token1] = ACTIONS(1347),
    [aux_sym_end_program_statement_token2] = ACTIONS(1347),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [aux_sym_interface_statement_token1] = ACTIONS(1347),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1347),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1347),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1347),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1347),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1347),
    [aux_sym_contains_statement_token1] = ACTIONS(1347),
    [aux_sym_use_statement_token1] = ACTIONS(1347),
    [aux_sym_use_statement_token2] = ACTIONS(1347),
    [aux_sym_implicit_statement_token1] = ACTIONS(1347),
    [aux_sym_implicit_statement_token3] = ACTIONS(1347),
    [aux_sym_implicit_statement_token4] = ACTIONS(1347),
    [aux_sym_save_statement_token1] = ACTIONS(1347),
    [aux_sym_private_statement_token1] = ACTIONS(1347),
    [aux_sym_public_statement_token1] = ACTIONS(1347),
    [aux_sym_namelist_statement_token1] = ACTIONS(1347),
    [aux_sym_common_statement_token1] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1349),
    [aux_sym_import_statement_token1] = ACTIONS(1347),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1347),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1347),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1347),
    [aux_sym_variable_attributes_token1] = ACTIONS(1347),
    [aux_sym_variable_attributes_token2] = ACTIONS(1347),
    [aux_sym_variable_attributes_token3] = ACTIONS(1347),
    [aux_sym_variable_attributes_token4] = ACTIONS(1347),
    [aux_sym_variable_attributes_token5] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1347),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1347),
    [aux_sym_derived_type_token1] = ACTIONS(1347),
    [aux_sym_type_qualifier_token1] = ACTIONS(1347),
    [aux_sym_type_qualifier_token2] = ACTIONS(1347),
    [aux_sym_type_qualifier_token3] = ACTIONS(1347),
    [aux_sym_type_qualifier_token4] = ACTIONS(1347),
    [aux_sym_type_qualifier_token5] = ACTIONS(1347),
    [aux_sym_type_qualifier_token9] = ACTIONS(1347),
    [aux_sym_type_qualifier_token10] = ACTIONS(1347),
    [aux_sym_type_qualifier_token11] = ACTIONS(1347),
    [aux_sym_type_qualifier_token12] = ACTIONS(1347),
    [aux_sym_type_qualifier_token13] = ACTIONS(1347),
    [aux_sym_type_qualifier_token14] = ACTIONS(1347),
    [aux_sym_type_qualifier_token15] = ACTIONS(1347),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1347),
    [aux_sym_stop_statement_token1] = ACTIONS(1347),
    [aux_sym_stop_statement_token2] = ACTIONS(1347),
    [aux_sym_subroutine_call_token1] = ACTIONS(1347),
    [aux_sym_keyword_statement_token1] = ACTIONS(1347),
    [aux_sym_keyword_statement_token2] = ACTIONS(1347),
    [aux_sym_keyword_statement_token3] = ACTIONS(1347),
    [aux_sym_keyword_statement_token4] = ACTIONS(1347),
    [aux_sym_keyword_statement_token6] = ACTIONS(1347),
    [aux_sym_keyword_statement_token7] = ACTIONS(1347),
    [aux_sym_include_statement_token1] = ACTIONS(1347),
    [aux_sym_data_statement_token1] = ACTIONS(1347),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1347),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1347),
    [aux_sym_end_if_statement_token1] = ACTIONS(1347),
    [aux_sym_elseif_clause_token2] = ACTIONS(1347),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1347),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1347),
    [aux_sym_select_case_statement_token1] = ACTIONS(1347),
    [aux_sym_select_case_statement_token3] = ACTIONS(1347),
    [aux_sym_select_type_statement_token1] = ACTIONS(1347),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1347),
    [aux_sym_block_construct_token1] = ACTIONS(1347),
    [aux_sym_associate_statement_token1] = ACTIONS(1347),
    [aux_sym_format_statement_token1] = ACTIONS(1347),
    [aux_sym_print_statement_token1] = ACTIONS(1347),
    [aux_sym_open_statement_token1] = ACTIONS(1347),
    [aux_sym_close_statement_token1] = ACTIONS(1347),
    [aux_sym_inquire_statement_token1] = ACTIONS(1347),
    [aux_sym_enum_statement_token1] = ACTIONS(1347),
    [aux_sym_file_position_statement_token1] = ACTIONS(1347),
    [aux_sym_file_position_statement_token2] = ACTIONS(1347),
    [aux_sym_file_position_statement_token3] = ACTIONS(1347),
    [aux_sym_file_position_statement_token4] = ACTIONS(1347),
    [aux_sym_logical_expression_token5] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1347),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [sym_boolean_literal] = ACTIONS(1349),
    [aux_sym_null_literal_token1] = ACTIONS(1347),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1347),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1349),
    [sym__float_literal] = ACTIONS(1349),
    [sym__boz_literal] = ACTIONS(1349),
    [sym_string_literal] = ACTIONS(1349),
  },
  [379] = {
    [sym_preproc_file_line] = STATE(379),
    [aux_sym_end_program_statement_token1] = ACTIONS(1351),
    [aux_sym_end_program_statement_token2] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [aux_sym_interface_statement_token1] = ACTIONS(1351),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1351),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1351),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1351),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1351),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1351),
    [aux_sym_contains_statement_token1] = ACTIONS(1351),
    [aux_sym_use_statement_token1] = ACTIONS(1351),
    [aux_sym_use_statement_token2] = ACTIONS(1351),
    [aux_sym_implicit_statement_token1] = ACTIONS(1351),
    [aux_sym_implicit_statement_token3] = ACTIONS(1351),
    [aux_sym_implicit_statement_token4] = ACTIONS(1351),
    [aux_sym_save_statement_token1] = ACTIONS(1351),
    [aux_sym_private_statement_token1] = ACTIONS(1351),
    [aux_sym_public_statement_token1] = ACTIONS(1351),
    [aux_sym_namelist_statement_token1] = ACTIONS(1351),
    [aux_sym_common_statement_token1] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1353),
    [aux_sym_import_statement_token1] = ACTIONS(1351),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1351),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1351),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1351),
    [aux_sym_variable_attributes_token1] = ACTIONS(1351),
    [aux_sym_variable_attributes_token2] = ACTIONS(1351),
    [aux_sym_variable_attributes_token3] = ACTIONS(1351),
    [aux_sym_variable_attributes_token4] = ACTIONS(1351),
    [aux_sym_variable_attributes_token5] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1351),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1351),
    [aux_sym_derived_type_token1] = ACTIONS(1351),
    [aux_sym_type_qualifier_token1] = ACTIONS(1351),
    [aux_sym_type_qualifier_token2] = ACTIONS(1351),
    [aux_sym_type_qualifier_token3] = ACTIONS(1351),
    [aux_sym_type_qualifier_token4] = ACTIONS(1351),
    [aux_sym_type_qualifier_token5] = ACTIONS(1351),
    [aux_sym_type_qualifier_token9] = ACTIONS(1351),
    [aux_sym_type_qualifier_token10] = ACTIONS(1351),
    [aux_sym_type_qualifier_token11] = ACTIONS(1351),
    [aux_sym_type_qualifier_token12] = ACTIONS(1351),
    [aux_sym_type_qualifier_token13] = ACTIONS(1351),
    [aux_sym_type_qualifier_token14] = ACTIONS(1351),
    [aux_sym_type_qualifier_token15] = ACTIONS(1351),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1351),
    [aux_sym_stop_statement_token1] = ACTIONS(1351),
    [aux_sym_stop_statement_token2] = ACTIONS(1351),
    [aux_sym_subroutine_call_token1] = ACTIONS(1351),
    [aux_sym_keyword_statement_token1] = ACTIONS(1351),
    [aux_sym_keyword_statement_token2] = ACTIONS(1351),
    [aux_sym_keyword_statement_token3] = ACTIONS(1351),
    [aux_sym_keyword_statement_token4] = ACTIONS(1351),
    [aux_sym_keyword_statement_token6] = ACTIONS(1351),
    [aux_sym_keyword_statement_token7] = ACTIONS(1351),
    [aux_sym_include_statement_token1] = ACTIONS(1351),
    [aux_sym_data_statement_token1] = ACTIONS(1351),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1351),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1351),
    [aux_sym_end_if_statement_token1] = ACTIONS(1351),
    [aux_sym_elseif_clause_token2] = ACTIONS(1351),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1351),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1351),
    [aux_sym_select_case_statement_token1] = ACTIONS(1351),
    [aux_sym_select_case_statement_token3] = ACTIONS(1351),
    [aux_sym_select_type_statement_token1] = ACTIONS(1351),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1351),
    [aux_sym_block_construct_token1] = ACTIONS(1351),
    [aux_sym_associate_statement_token1] = ACTIONS(1351),
    [aux_sym_format_statement_token1] = ACTIONS(1351),
    [aux_sym_print_statement_token1] = ACTIONS(1351),
    [aux_sym_open_statement_token1] = ACTIONS(1351),
    [aux_sym_close_statement_token1] = ACTIONS(1351),
    [aux_sym_inquire_statement_token1] = ACTIONS(1351),
    [aux_sym_enum_statement_token1] = ACTIONS(1351),
    [aux_sym_file_position_statement_token1] = ACTIONS(1351),
    [aux_sym_file_position_statement_token2] = ACTIONS(1351),
    [aux_sym_file_position_statement_token3] = ACTIONS(1351),
    [aux_sym_file_position_statement_token4] = ACTIONS(1351),
    [aux_sym_logical_expression_token5] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [sym_boolean_literal] = ACTIONS(1353),
    [aux_sym_null_literal_token1] = ACTIONS(1351),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1351),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1353),
    [sym__float_literal] = ACTIONS(1353),
    [sym__boz_literal] = ACTIONS(1353),
    [sym_string_literal] = ACTIONS(1353),
  },
  [380] = {
    [sym_preproc_file_line] = STATE(380),
    [aux_sym_end_program_statement_token1] = ACTIONS(1355),
    [aux_sym_end_program_statement_token2] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [aux_sym_interface_statement_token1] = ACTIONS(1355),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1355),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1355),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1355),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1355),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1355),
    [aux_sym_contains_statement_token1] = ACTIONS(1355),
    [aux_sym_use_statement_token1] = ACTIONS(1355),
    [aux_sym_use_statement_token2] = ACTIONS(1355),
    [aux_sym_implicit_statement_token1] = ACTIONS(1355),
    [aux_sym_implicit_statement_token3] = ACTIONS(1355),
    [aux_sym_implicit_statement_token4] = ACTIONS(1355),
    [aux_sym_save_statement_token1] = ACTIONS(1355),
    [aux_sym_private_statement_token1] = ACTIONS(1355),
    [aux_sym_public_statement_token1] = ACTIONS(1355),
    [aux_sym_namelist_statement_token1] = ACTIONS(1355),
    [aux_sym_common_statement_token1] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1357),
    [aux_sym_import_statement_token1] = ACTIONS(1355),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1355),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1355),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1355),
    [aux_sym_variable_attributes_token1] = ACTIONS(1355),
    [aux_sym_variable_attributes_token2] = ACTIONS(1355),
    [aux_sym_variable_attributes_token3] = ACTIONS(1355),
    [aux_sym_variable_attributes_token4] = ACTIONS(1355),
    [aux_sym_variable_attributes_token5] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1355),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1355),
    [aux_sym_derived_type_token1] = ACTIONS(1355),
    [aux_sym_type_qualifier_token1] = ACTIONS(1355),
    [aux_sym_type_qualifier_token2] = ACTIONS(1355),
    [aux_sym_type_qualifier_token3] = ACTIONS(1355),
    [aux_sym_type_qualifier_token4] = ACTIONS(1355),
    [aux_sym_type_qualifier_token5] = ACTIONS(1355),
    [aux_sym_type_qualifier_token9] = ACTIONS(1355),
    [aux_sym_type_qualifier_token10] = ACTIONS(1355),
    [aux_sym_type_qualifier_token11] = ACTIONS(1355),
    [aux_sym_type_qualifier_token12] = ACTIONS(1355),
    [aux_sym_type_qualifier_token13] = ACTIONS(1355),
    [aux_sym_type_qualifier_token14] = ACTIONS(1355),
    [aux_sym_type_qualifier_token15] = ACTIONS(1355),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1355),
    [aux_sym_stop_statement_token1] = ACTIONS(1355),
    [aux_sym_stop_statement_token2] = ACTIONS(1355),
    [aux_sym_subroutine_call_token1] = ACTIONS(1355),
    [aux_sym_keyword_statement_token1] = ACTIONS(1355),
    [aux_sym_keyword_statement_token2] = ACTIONS(1355),
    [aux_sym_keyword_statement_token3] = ACTIONS(1355),
    [aux_sym_keyword_statement_token4] = ACTIONS(1355),
    [aux_sym_keyword_statement_token6] = ACTIONS(1355),
    [aux_sym_keyword_statement_token7] = ACTIONS(1355),
    [aux_sym_include_statement_token1] = ACTIONS(1355),
    [aux_sym_data_statement_token1] = ACTIONS(1355),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1355),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1355),
    [aux_sym_end_if_statement_token1] = ACTIONS(1355),
    [aux_sym_elseif_clause_token2] = ACTIONS(1355),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1355),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1355),
    [aux_sym_select_case_statement_token1] = ACTIONS(1355),
    [aux_sym_select_case_statement_token3] = ACTIONS(1355),
    [aux_sym_select_type_statement_token1] = ACTIONS(1355),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1355),
    [aux_sym_block_construct_token1] = ACTIONS(1355),
    [aux_sym_associate_statement_token1] = ACTIONS(1355),
    [aux_sym_format_statement_token1] = ACTIONS(1355),
    [aux_sym_print_statement_token1] = ACTIONS(1355),
    [aux_sym_open_statement_token1] = ACTIONS(1355),
    [aux_sym_close_statement_token1] = ACTIONS(1355),
    [aux_sym_inquire_statement_token1] = ACTIONS(1355),
    [aux_sym_enum_statement_token1] = ACTIONS(1355),
    [aux_sym_file_position_statement_token1] = ACTIONS(1355),
    [aux_sym_file_position_statement_token2] = ACTIONS(1355),
    [aux_sym_file_position_statement_token3] = ACTIONS(1355),
    [aux_sym_file_position_statement_token4] = ACTIONS(1355),
    [aux_sym_logical_expression_token5] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_DOT] = ACTIONS(1355),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1357),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [sym_boolean_literal] = ACTIONS(1357),
    [aux_sym_null_literal_token1] = ACTIONS(1355),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1355),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1357),
    [sym__float_literal] = ACTIONS(1357),
    [sym__boz_literal] = ACTIONS(1357),
    [sym_string_literal] = ACTIONS(1357),
  },
  [381] = {
    [sym_preproc_file_line] = STATE(381),
    [aux_sym_end_program_statement_token1] = ACTIONS(1359),
    [aux_sym_end_program_statement_token2] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [aux_sym_interface_statement_token1] = ACTIONS(1359),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1359),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1359),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1359),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1359),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1359),
    [aux_sym_contains_statement_token1] = ACTIONS(1359),
    [aux_sym_use_statement_token1] = ACTIONS(1359),
    [aux_sym_use_statement_token2] = ACTIONS(1359),
    [aux_sym_implicit_statement_token1] = ACTIONS(1359),
    [aux_sym_implicit_statement_token3] = ACTIONS(1359),
    [aux_sym_implicit_statement_token4] = ACTIONS(1359),
    [aux_sym_save_statement_token1] = ACTIONS(1359),
    [aux_sym_private_statement_token1] = ACTIONS(1359),
    [aux_sym_public_statement_token1] = ACTIONS(1359),
    [aux_sym_namelist_statement_token1] = ACTIONS(1359),
    [aux_sym_common_statement_token1] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1361),
    [aux_sym_import_statement_token1] = ACTIONS(1359),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1359),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1359),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1359),
    [aux_sym_variable_attributes_token1] = ACTIONS(1359),
    [aux_sym_variable_attributes_token2] = ACTIONS(1359),
    [aux_sym_variable_attributes_token3] = ACTIONS(1359),
    [aux_sym_variable_attributes_token4] = ACTIONS(1359),
    [aux_sym_variable_attributes_token5] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1359),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1359),
    [aux_sym_derived_type_token1] = ACTIONS(1359),
    [aux_sym_type_qualifier_token1] = ACTIONS(1359),
    [aux_sym_type_qualifier_token2] = ACTIONS(1359),
    [aux_sym_type_qualifier_token3] = ACTIONS(1359),
    [aux_sym_type_qualifier_token4] = ACTIONS(1359),
    [aux_sym_type_qualifier_token5] = ACTIONS(1359),
    [aux_sym_type_qualifier_token9] = ACTIONS(1359),
    [aux_sym_type_qualifier_token10] = ACTIONS(1359),
    [aux_sym_type_qualifier_token11] = ACTIONS(1359),
    [aux_sym_type_qualifier_token12] = ACTIONS(1359),
    [aux_sym_type_qualifier_token13] = ACTIONS(1359),
    [aux_sym_type_qualifier_token14] = ACTIONS(1359),
    [aux_sym_type_qualifier_token15] = ACTIONS(1359),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1359),
    [aux_sym_stop_statement_token1] = ACTIONS(1359),
    [aux_sym_stop_statement_token2] = ACTIONS(1359),
    [aux_sym_subroutine_call_token1] = ACTIONS(1359),
    [aux_sym_keyword_statement_token1] = ACTIONS(1359),
    [aux_sym_keyword_statement_token2] = ACTIONS(1359),
    [aux_sym_keyword_statement_token3] = ACTIONS(1359),
    [aux_sym_keyword_statement_token4] = ACTIONS(1359),
    [aux_sym_keyword_statement_token6] = ACTIONS(1359),
    [aux_sym_keyword_statement_token7] = ACTIONS(1359),
    [aux_sym_include_statement_token1] = ACTIONS(1359),
    [aux_sym_data_statement_token1] = ACTIONS(1359),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1359),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1359),
    [aux_sym_end_if_statement_token1] = ACTIONS(1359),
    [aux_sym_elseif_clause_token2] = ACTIONS(1359),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1359),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1359),
    [aux_sym_select_case_statement_token1] = ACTIONS(1359),
    [aux_sym_select_case_statement_token3] = ACTIONS(1359),
    [aux_sym_select_type_statement_token1] = ACTIONS(1359),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1359),
    [aux_sym_block_construct_token1] = ACTIONS(1359),
    [aux_sym_associate_statement_token1] = ACTIONS(1359),
    [aux_sym_format_statement_token1] = ACTIONS(1359),
    [aux_sym_print_statement_token1] = ACTIONS(1359),
    [aux_sym_open_statement_token1] = ACTIONS(1359),
    [aux_sym_close_statement_token1] = ACTIONS(1359),
    [aux_sym_inquire_statement_token1] = ACTIONS(1359),
    [aux_sym_enum_statement_token1] = ACTIONS(1359),
    [aux_sym_file_position_statement_token1] = ACTIONS(1359),
    [aux_sym_file_position_statement_token2] = ACTIONS(1359),
    [aux_sym_file_position_statement_token3] = ACTIONS(1359),
    [aux_sym_file_position_statement_token4] = ACTIONS(1359),
    [aux_sym_logical_expression_token5] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1361),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [sym_boolean_literal] = ACTIONS(1361),
    [aux_sym_null_literal_token1] = ACTIONS(1359),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1359),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1361),
    [sym__float_literal] = ACTIONS(1361),
    [sym__boz_literal] = ACTIONS(1361),
    [sym_string_literal] = ACTIONS(1361),
  },
  [382] = {
    [sym_preproc_file_line] = STATE(382),
    [aux_sym_end_program_statement_token1] = ACTIONS(1295),
    [aux_sym_end_program_statement_token2] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [aux_sym_interface_statement_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1295),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1295),
    [aux_sym_contains_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token2] = ACTIONS(1295),
    [aux_sym_implicit_statement_token1] = ACTIONS(1295),
    [aux_sym_implicit_statement_token3] = ACTIONS(1295),
    [aux_sym_implicit_statement_token4] = ACTIONS(1295),
    [aux_sym_save_statement_token1] = ACTIONS(1295),
    [aux_sym_private_statement_token1] = ACTIONS(1295),
    [aux_sym_public_statement_token1] = ACTIONS(1295),
    [aux_sym_namelist_statement_token1] = ACTIONS(1295),
    [aux_sym_common_statement_token1] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1297),
    [aux_sym_import_statement_token1] = ACTIONS(1295),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1295),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1295),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1295),
    [aux_sym_variable_attributes_token1] = ACTIONS(1295),
    [aux_sym_variable_attributes_token2] = ACTIONS(1295),
    [aux_sym_variable_attributes_token3] = ACTIONS(1295),
    [aux_sym_variable_attributes_token4] = ACTIONS(1295),
    [aux_sym_variable_attributes_token5] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1295),
    [aux_sym_derived_type_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token2] = ACTIONS(1295),
    [aux_sym_type_qualifier_token3] = ACTIONS(1295),
    [aux_sym_type_qualifier_token4] = ACTIONS(1295),
    [aux_sym_type_qualifier_token5] = ACTIONS(1295),
    [aux_sym_type_qualifier_token9] = ACTIONS(1295),
    [aux_sym_type_qualifier_token10] = ACTIONS(1295),
    [aux_sym_type_qualifier_token11] = ACTIONS(1295),
    [aux_sym_type_qualifier_token12] = ACTIONS(1295),
    [aux_sym_type_qualifier_token13] = ACTIONS(1295),
    [aux_sym_type_qualifier_token14] = ACTIONS(1295),
    [aux_sym_type_qualifier_token15] = ACTIONS(1295),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token2] = ACTIONS(1295),
    [aux_sym_subroutine_call_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token2] = ACTIONS(1295),
    [aux_sym_keyword_statement_token3] = ACTIONS(1295),
    [aux_sym_keyword_statement_token4] = ACTIONS(1295),
    [aux_sym_keyword_statement_token6] = ACTIONS(1295),
    [aux_sym_keyword_statement_token7] = ACTIONS(1295),
    [aux_sym_include_statement_token1] = ACTIONS(1295),
    [aux_sym_data_statement_token1] = ACTIONS(1295),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1295),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1295),
    [aux_sym_end_if_statement_token1] = ACTIONS(1295),
    [aux_sym_elseif_clause_token2] = ACTIONS(1295),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1295),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token3] = ACTIONS(1295),
    [aux_sym_select_type_statement_token1] = ACTIONS(1295),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1295),
    [aux_sym_block_construct_token1] = ACTIONS(1295),
    [aux_sym_associate_statement_token1] = ACTIONS(1295),
    [aux_sym_format_statement_token1] = ACTIONS(1295),
    [aux_sym_print_statement_token1] = ACTIONS(1295),
    [aux_sym_open_statement_token1] = ACTIONS(1295),
    [aux_sym_close_statement_token1] = ACTIONS(1295),
    [aux_sym_inquire_statement_token1] = ACTIONS(1295),
    [aux_sym_enum_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token2] = ACTIONS(1295),
    [aux_sym_file_position_statement_token3] = ACTIONS(1295),
    [aux_sym_file_position_statement_token4] = ACTIONS(1295),
    [aux_sym_logical_expression_token5] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1295),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_boolean_literal] = ACTIONS(1297),
    [aux_sym_null_literal_token1] = ACTIONS(1295),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1295),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1297),
    [sym__float_literal] = ACTIONS(1297),
    [sym__boz_literal] = ACTIONS(1297),
    [sym_string_literal] = ACTIONS(1297),
  },
  [383] = {
    [sym_preproc_file_line] = STATE(383),
    [aux_sym_end_program_statement_token1] = ACTIONS(1323),
    [aux_sym_end_program_statement_token2] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [aux_sym_interface_statement_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1323),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1323),
    [aux_sym_contains_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token2] = ACTIONS(1323),
    [aux_sym_implicit_statement_token1] = ACTIONS(1323),
    [aux_sym_implicit_statement_token3] = ACTIONS(1323),
    [aux_sym_implicit_statement_token4] = ACTIONS(1323),
    [aux_sym_save_statement_token1] = ACTIONS(1323),
    [aux_sym_private_statement_token1] = ACTIONS(1323),
    [aux_sym_public_statement_token1] = ACTIONS(1323),
    [aux_sym_namelist_statement_token1] = ACTIONS(1323),
    [aux_sym_common_statement_token1] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1325),
    [aux_sym_import_statement_token1] = ACTIONS(1323),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1323),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1323),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1323),
    [aux_sym_variable_attributes_token1] = ACTIONS(1323),
    [aux_sym_variable_attributes_token2] = ACTIONS(1323),
    [aux_sym_variable_attributes_token3] = ACTIONS(1323),
    [aux_sym_variable_attributes_token4] = ACTIONS(1323),
    [aux_sym_variable_attributes_token5] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1323),
    [aux_sym_derived_type_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token2] = ACTIONS(1323),
    [aux_sym_type_qualifier_token3] = ACTIONS(1323),
    [aux_sym_type_qualifier_token4] = ACTIONS(1323),
    [aux_sym_type_qualifier_token5] = ACTIONS(1323),
    [aux_sym_type_qualifier_token9] = ACTIONS(1323),
    [aux_sym_type_qualifier_token10] = ACTIONS(1323),
    [aux_sym_type_qualifier_token11] = ACTIONS(1323),
    [aux_sym_type_qualifier_token12] = ACTIONS(1323),
    [aux_sym_type_qualifier_token13] = ACTIONS(1323),
    [aux_sym_type_qualifier_token14] = ACTIONS(1323),
    [aux_sym_type_qualifier_token15] = ACTIONS(1323),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token2] = ACTIONS(1323),
    [aux_sym_subroutine_call_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token2] = ACTIONS(1323),
    [aux_sym_keyword_statement_token3] = ACTIONS(1323),
    [aux_sym_keyword_statement_token4] = ACTIONS(1323),
    [aux_sym_keyword_statement_token6] = ACTIONS(1323),
    [aux_sym_keyword_statement_token7] = ACTIONS(1323),
    [aux_sym_include_statement_token1] = ACTIONS(1323),
    [aux_sym_data_statement_token1] = ACTIONS(1323),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1323),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1323),
    [aux_sym_end_if_statement_token1] = ACTIONS(1323),
    [aux_sym_elseif_clause_token2] = ACTIONS(1323),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1323),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token3] = ACTIONS(1323),
    [aux_sym_select_type_statement_token1] = ACTIONS(1323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1323),
    [aux_sym_block_construct_token1] = ACTIONS(1323),
    [aux_sym_associate_statement_token1] = ACTIONS(1323),
    [aux_sym_format_statement_token1] = ACTIONS(1323),
    [aux_sym_print_statement_token1] = ACTIONS(1323),
    [aux_sym_open_statement_token1] = ACTIONS(1323),
    [aux_sym_close_statement_token1] = ACTIONS(1323),
    [aux_sym_inquire_statement_token1] = ACTIONS(1323),
    [aux_sym_enum_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token2] = ACTIONS(1323),
    [aux_sym_file_position_statement_token3] = ACTIONS(1323),
    [aux_sym_file_position_statement_token4] = ACTIONS(1323),
    [aux_sym_logical_expression_token5] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [sym_boolean_literal] = ACTIONS(1325),
    [aux_sym_null_literal_token1] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1323),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1325),
    [sym__float_literal] = ACTIONS(1325),
    [sym__boz_literal] = ACTIONS(1325),
    [sym_string_literal] = ACTIONS(1325),
  },
  [384] = {
    [sym_preproc_file_line] = STATE(384),
    [aux_sym_end_program_statement_token1] = ACTIONS(1327),
    [aux_sym_end_program_statement_token2] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [aux_sym_interface_statement_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1327),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1327),
    [aux_sym_contains_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token2] = ACTIONS(1327),
    [aux_sym_implicit_statement_token1] = ACTIONS(1327),
    [aux_sym_implicit_statement_token3] = ACTIONS(1327),
    [aux_sym_implicit_statement_token4] = ACTIONS(1327),
    [aux_sym_save_statement_token1] = ACTIONS(1327),
    [aux_sym_private_statement_token1] = ACTIONS(1327),
    [aux_sym_public_statement_token1] = ACTIONS(1327),
    [aux_sym_namelist_statement_token1] = ACTIONS(1327),
    [aux_sym_common_statement_token1] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1329),
    [aux_sym_import_statement_token1] = ACTIONS(1327),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1327),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1327),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1327),
    [aux_sym_variable_attributes_token1] = ACTIONS(1327),
    [aux_sym_variable_attributes_token2] = ACTIONS(1327),
    [aux_sym_variable_attributes_token3] = ACTIONS(1327),
    [aux_sym_variable_attributes_token4] = ACTIONS(1327),
    [aux_sym_variable_attributes_token5] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1327),
    [aux_sym_derived_type_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token2] = ACTIONS(1327),
    [aux_sym_type_qualifier_token3] = ACTIONS(1327),
    [aux_sym_type_qualifier_token4] = ACTIONS(1327),
    [aux_sym_type_qualifier_token5] = ACTIONS(1327),
    [aux_sym_type_qualifier_token9] = ACTIONS(1327),
    [aux_sym_type_qualifier_token10] = ACTIONS(1327),
    [aux_sym_type_qualifier_token11] = ACTIONS(1327),
    [aux_sym_type_qualifier_token12] = ACTIONS(1327),
    [aux_sym_type_qualifier_token13] = ACTIONS(1327),
    [aux_sym_type_qualifier_token14] = ACTIONS(1327),
    [aux_sym_type_qualifier_token15] = ACTIONS(1327),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token2] = ACTIONS(1327),
    [aux_sym_subroutine_call_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token2] = ACTIONS(1327),
    [aux_sym_keyword_statement_token3] = ACTIONS(1327),
    [aux_sym_keyword_statement_token4] = ACTIONS(1327),
    [aux_sym_keyword_statement_token6] = ACTIONS(1327),
    [aux_sym_keyword_statement_token7] = ACTIONS(1327),
    [aux_sym_include_statement_token1] = ACTIONS(1327),
    [aux_sym_data_statement_token1] = ACTIONS(1327),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1327),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1327),
    [aux_sym_end_if_statement_token1] = ACTIONS(1327),
    [aux_sym_elseif_clause_token2] = ACTIONS(1327),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1327),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token3] = ACTIONS(1327),
    [aux_sym_select_type_statement_token1] = ACTIONS(1327),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1327),
    [aux_sym_block_construct_token1] = ACTIONS(1327),
    [aux_sym_associate_statement_token1] = ACTIONS(1327),
    [aux_sym_format_statement_token1] = ACTIONS(1327),
    [aux_sym_print_statement_token1] = ACTIONS(1327),
    [aux_sym_open_statement_token1] = ACTIONS(1327),
    [aux_sym_close_statement_token1] = ACTIONS(1327),
    [aux_sym_inquire_statement_token1] = ACTIONS(1327),
    [aux_sym_enum_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token2] = ACTIONS(1327),
    [aux_sym_file_position_statement_token3] = ACTIONS(1327),
    [aux_sym_file_position_statement_token4] = ACTIONS(1327),
    [aux_sym_logical_expression_token5] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_boolean_literal] = ACTIONS(1329),
    [aux_sym_null_literal_token1] = ACTIONS(1327),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1327),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1329),
    [sym__float_literal] = ACTIONS(1329),
    [sym__boz_literal] = ACTIONS(1329),
    [sym_string_literal] = ACTIONS(1329),
  },
  [385] = {
    [sym_preproc_file_line] = STATE(385),
    [aux_sym_end_program_statement_token1] = ACTIONS(1363),
    [aux_sym_end_program_statement_token2] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1363),
    [aux_sym_interface_statement_token1] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1363),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1363),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1363),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1363),
    [aux_sym_contains_statement_token1] = ACTIONS(1363),
    [aux_sym_use_statement_token1] = ACTIONS(1363),
    [aux_sym_use_statement_token2] = ACTIONS(1363),
    [aux_sym_implicit_statement_token1] = ACTIONS(1363),
    [aux_sym_implicit_statement_token3] = ACTIONS(1363),
    [aux_sym_implicit_statement_token4] = ACTIONS(1363),
    [aux_sym_save_statement_token1] = ACTIONS(1363),
    [aux_sym_private_statement_token1] = ACTIONS(1363),
    [aux_sym_public_statement_token1] = ACTIONS(1363),
    [aux_sym_namelist_statement_token1] = ACTIONS(1363),
    [aux_sym_common_statement_token1] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1365),
    [aux_sym_import_statement_token1] = ACTIONS(1363),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1363),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1363),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1363),
    [aux_sym_variable_attributes_token1] = ACTIONS(1363),
    [aux_sym_variable_attributes_token2] = ACTIONS(1363),
    [aux_sym_variable_attributes_token3] = ACTIONS(1363),
    [aux_sym_variable_attributes_token4] = ACTIONS(1363),
    [aux_sym_variable_attributes_token5] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1363),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1363),
    [aux_sym_derived_type_token1] = ACTIONS(1363),
    [aux_sym_type_qualifier_token1] = ACTIONS(1363),
    [aux_sym_type_qualifier_token2] = ACTIONS(1363),
    [aux_sym_type_qualifier_token3] = ACTIONS(1363),
    [aux_sym_type_qualifier_token4] = ACTIONS(1363),
    [aux_sym_type_qualifier_token5] = ACTIONS(1363),
    [aux_sym_type_qualifier_token9] = ACTIONS(1363),
    [aux_sym_type_qualifier_token10] = ACTIONS(1363),
    [aux_sym_type_qualifier_token11] = ACTIONS(1363),
    [aux_sym_type_qualifier_token12] = ACTIONS(1363),
    [aux_sym_type_qualifier_token13] = ACTIONS(1363),
    [aux_sym_type_qualifier_token14] = ACTIONS(1363),
    [aux_sym_type_qualifier_token15] = ACTIONS(1363),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1363),
    [aux_sym_stop_statement_token1] = ACTIONS(1363),
    [aux_sym_stop_statement_token2] = ACTIONS(1363),
    [aux_sym_subroutine_call_token1] = ACTIONS(1363),
    [aux_sym_keyword_statement_token1] = ACTIONS(1363),
    [aux_sym_keyword_statement_token2] = ACTIONS(1363),
    [aux_sym_keyword_statement_token3] = ACTIONS(1363),
    [aux_sym_keyword_statement_token4] = ACTIONS(1363),
    [aux_sym_keyword_statement_token6] = ACTIONS(1363),
    [aux_sym_keyword_statement_token7] = ACTIONS(1363),
    [aux_sym_include_statement_token1] = ACTIONS(1363),
    [aux_sym_data_statement_token1] = ACTIONS(1363),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1363),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1363),
    [aux_sym_end_if_statement_token1] = ACTIONS(1363),
    [aux_sym_elseif_clause_token2] = ACTIONS(1363),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1363),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1363),
    [aux_sym_select_case_statement_token1] = ACTIONS(1363),
    [aux_sym_select_case_statement_token3] = ACTIONS(1363),
    [aux_sym_select_type_statement_token1] = ACTIONS(1363),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1363),
    [aux_sym_block_construct_token1] = ACTIONS(1363),
    [aux_sym_associate_statement_token1] = ACTIONS(1363),
    [aux_sym_format_statement_token1] = ACTIONS(1363),
    [aux_sym_print_statement_token1] = ACTIONS(1363),
    [aux_sym_open_statement_token1] = ACTIONS(1363),
    [aux_sym_close_statement_token1] = ACTIONS(1363),
    [aux_sym_inquire_statement_token1] = ACTIONS(1363),
    [aux_sym_enum_statement_token1] = ACTIONS(1363),
    [aux_sym_file_position_statement_token1] = ACTIONS(1363),
    [aux_sym_file_position_statement_token2] = ACTIONS(1363),
    [aux_sym_file_position_statement_token3] = ACTIONS(1363),
    [aux_sym_file_position_statement_token4] = ACTIONS(1363),
    [aux_sym_logical_expression_token5] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1363),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1365),
    [sym_boolean_literal] = ACTIONS(1365),
    [aux_sym_null_literal_token1] = ACTIONS(1363),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1363),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1365),
    [sym__float_literal] = ACTIONS(1365),
    [sym__boz_literal] = ACTIONS(1365),
    [sym_string_literal] = ACTIONS(1365),
  },
  [386] = {
    [sym_preproc_file_line] = STATE(386),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [aux_sym_end_program_statement_token2] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_contains_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [387] = {
    [sym_preproc_file_line] = STATE(387),
    [aux_sym_end_program_statement_token1] = ACTIONS(1299),
    [aux_sym_end_program_statement_token2] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [aux_sym_interface_statement_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1299),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1299),
    [aux_sym_contains_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token2] = ACTIONS(1299),
    [aux_sym_implicit_statement_token1] = ACTIONS(1299),
    [aux_sym_implicit_statement_token3] = ACTIONS(1299),
    [aux_sym_implicit_statement_token4] = ACTIONS(1299),
    [aux_sym_save_statement_token1] = ACTIONS(1299),
    [aux_sym_private_statement_token1] = ACTIONS(1299),
    [aux_sym_public_statement_token1] = ACTIONS(1299),
    [aux_sym_namelist_statement_token1] = ACTIONS(1299),
    [aux_sym_common_statement_token1] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1301),
    [aux_sym_import_statement_token1] = ACTIONS(1299),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1299),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1299),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1299),
    [aux_sym_variable_attributes_token1] = ACTIONS(1299),
    [aux_sym_variable_attributes_token2] = ACTIONS(1299),
    [aux_sym_variable_attributes_token3] = ACTIONS(1299),
    [aux_sym_variable_attributes_token4] = ACTIONS(1299),
    [aux_sym_variable_attributes_token5] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1299),
    [aux_sym_derived_type_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token2] = ACTIONS(1299),
    [aux_sym_type_qualifier_token3] = ACTIONS(1299),
    [aux_sym_type_qualifier_token4] = ACTIONS(1299),
    [aux_sym_type_qualifier_token5] = ACTIONS(1299),
    [aux_sym_type_qualifier_token9] = ACTIONS(1299),
    [aux_sym_type_qualifier_token10] = ACTIONS(1299),
    [aux_sym_type_qualifier_token11] = ACTIONS(1299),
    [aux_sym_type_qualifier_token12] = ACTIONS(1299),
    [aux_sym_type_qualifier_token13] = ACTIONS(1299),
    [aux_sym_type_qualifier_token14] = ACTIONS(1299),
    [aux_sym_type_qualifier_token15] = ACTIONS(1299),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token2] = ACTIONS(1299),
    [aux_sym_subroutine_call_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token2] = ACTIONS(1299),
    [aux_sym_keyword_statement_token3] = ACTIONS(1299),
    [aux_sym_keyword_statement_token4] = ACTIONS(1299),
    [aux_sym_keyword_statement_token6] = ACTIONS(1299),
    [aux_sym_keyword_statement_token7] = ACTIONS(1299),
    [aux_sym_include_statement_token1] = ACTIONS(1299),
    [aux_sym_data_statement_token1] = ACTIONS(1299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1299),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1299),
    [aux_sym_end_if_statement_token1] = ACTIONS(1299),
    [aux_sym_elseif_clause_token2] = ACTIONS(1299),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1299),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token3] = ACTIONS(1299),
    [aux_sym_select_type_statement_token1] = ACTIONS(1299),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1299),
    [aux_sym_block_construct_token1] = ACTIONS(1299),
    [aux_sym_associate_statement_token1] = ACTIONS(1299),
    [aux_sym_format_statement_token1] = ACTIONS(1299),
    [aux_sym_print_statement_token1] = ACTIONS(1299),
    [aux_sym_open_statement_token1] = ACTIONS(1299),
    [aux_sym_close_statement_token1] = ACTIONS(1299),
    [aux_sym_inquire_statement_token1] = ACTIONS(1299),
    [aux_sym_enum_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token2] = ACTIONS(1299),
    [aux_sym_file_position_statement_token3] = ACTIONS(1299),
    [aux_sym_file_position_statement_token4] = ACTIONS(1299),
    [aux_sym_logical_expression_token5] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [sym_boolean_literal] = ACTIONS(1301),
    [aux_sym_null_literal_token1] = ACTIONS(1299),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1299),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1301),
    [sym__float_literal] = ACTIONS(1301),
    [sym__boz_literal] = ACTIONS(1301),
    [sym_string_literal] = ACTIONS(1301),
  },
  [388] = {
    [sym_preproc_file_line] = STATE(388),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [aux_sym_end_program_statement_token2] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_contains_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [389] = {
    [sym_preproc_file_line] = STATE(389),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [aux_sym_end_program_statement_token2] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_contains_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [390] = {
    [sym_preproc_file_line] = STATE(390),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [aux_sym_end_program_statement_token2] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_contains_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [391] = {
    [sym_preproc_file_line] = STATE(391),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [aux_sym_end_program_statement_token2] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_contains_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [392] = {
    [sym_preproc_file_line] = STATE(392),
    [aux_sym_end_program_statement_token1] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [aux_sym_interface_statement_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1295),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_end_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1295),
    [aux_sym_contains_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token2] = ACTIONS(1295),
    [aux_sym_implicit_statement_token1] = ACTIONS(1295),
    [aux_sym_implicit_statement_token3] = ACTIONS(1295),
    [aux_sym_implicit_statement_token4] = ACTIONS(1295),
    [aux_sym_save_statement_token1] = ACTIONS(1295),
    [aux_sym_private_statement_token1] = ACTIONS(1295),
    [aux_sym_public_statement_token1] = ACTIONS(1295),
    [aux_sym_namelist_statement_token1] = ACTIONS(1295),
    [aux_sym_common_statement_token1] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1297),
    [aux_sym_import_statement_token1] = ACTIONS(1295),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1295),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1295),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1295),
    [aux_sym_variable_attributes_token1] = ACTIONS(1295),
    [aux_sym_variable_attributes_token2] = ACTIONS(1295),
    [aux_sym_variable_attributes_token3] = ACTIONS(1295),
    [aux_sym_variable_attributes_token4] = ACTIONS(1295),
    [aux_sym_variable_attributes_token5] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1295),
    [aux_sym_derived_type_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token2] = ACTIONS(1295),
    [aux_sym_type_qualifier_token3] = ACTIONS(1295),
    [aux_sym_type_qualifier_token4] = ACTIONS(1295),
    [aux_sym_type_qualifier_token5] = ACTIONS(1295),
    [aux_sym_type_qualifier_token9] = ACTIONS(1295),
    [aux_sym_type_qualifier_token10] = ACTIONS(1295),
    [aux_sym_type_qualifier_token11] = ACTIONS(1295),
    [aux_sym_type_qualifier_token12] = ACTIONS(1295),
    [aux_sym_type_qualifier_token13] = ACTIONS(1295),
    [aux_sym_type_qualifier_token14] = ACTIONS(1295),
    [aux_sym_type_qualifier_token15] = ACTIONS(1295),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token2] = ACTIONS(1295),
    [aux_sym_subroutine_call_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token2] = ACTIONS(1295),
    [aux_sym_keyword_statement_token3] = ACTIONS(1295),
    [aux_sym_keyword_statement_token4] = ACTIONS(1295),
    [aux_sym_keyword_statement_token6] = ACTIONS(1295),
    [aux_sym_keyword_statement_token7] = ACTIONS(1295),
    [aux_sym_include_statement_token1] = ACTIONS(1295),
    [aux_sym_data_statement_token1] = ACTIONS(1295),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1295),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1295),
    [aux_sym_end_if_statement_token1] = ACTIONS(1295),
    [aux_sym_elseif_clause_token2] = ACTIONS(1295),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1295),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token3] = ACTIONS(1295),
    [aux_sym_select_type_statement_token1] = ACTIONS(1295),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1295),
    [aux_sym_block_construct_token1] = ACTIONS(1295),
    [aux_sym_associate_statement_token1] = ACTIONS(1295),
    [aux_sym_format_statement_token1] = ACTIONS(1295),
    [aux_sym_print_statement_token1] = ACTIONS(1295),
    [aux_sym_open_statement_token1] = ACTIONS(1295),
    [aux_sym_close_statement_token1] = ACTIONS(1295),
    [aux_sym_inquire_statement_token1] = ACTIONS(1295),
    [aux_sym_enum_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token2] = ACTIONS(1295),
    [aux_sym_file_position_statement_token3] = ACTIONS(1295),
    [aux_sym_file_position_statement_token4] = ACTIONS(1295),
    [aux_sym_logical_expression_token5] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1295),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_boolean_literal] = ACTIONS(1297),
    [aux_sym_null_literal_token1] = ACTIONS(1295),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1295),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1297),
    [sym__float_literal] = ACTIONS(1297),
    [sym__boz_literal] = ACTIONS(1297),
    [sym_string_literal] = ACTIONS(1297),
  },
  [393] = {
    [sym_preproc_file_line] = STATE(393),
    [aux_sym_end_program_statement_token1] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [aux_sym_interface_statement_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1215),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1215),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1215),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1215),
    [aux_sym_use_statement_token1] = ACTIONS(1215),
    [aux_sym_use_statement_token2] = ACTIONS(1215),
    [aux_sym_implicit_statement_token1] = ACTIONS(1215),
    [aux_sym_implicit_statement_token3] = ACTIONS(1215),
    [aux_sym_implicit_statement_token4] = ACTIONS(1215),
    [aux_sym_save_statement_token1] = ACTIONS(1215),
    [aux_sym_private_statement_token1] = ACTIONS(1215),
    [aux_sym_public_statement_token1] = ACTIONS(1215),
    [aux_sym_namelist_statement_token1] = ACTIONS(1215),
    [aux_sym_common_statement_token1] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1213),
    [aux_sym_import_statement_token1] = ACTIONS(1215),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1215),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1215),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1215),
    [aux_sym_variable_attributes_token1] = ACTIONS(1215),
    [aux_sym_variable_attributes_token2] = ACTIONS(1215),
    [aux_sym_variable_attributes_token3] = ACTIONS(1215),
    [aux_sym_variable_attributes_token4] = ACTIONS(1215),
    [aux_sym_variable_attributes_token5] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1215),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1215),
    [aux_sym_derived_type_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token1] = ACTIONS(1215),
    [aux_sym_type_qualifier_token2] = ACTIONS(1215),
    [aux_sym_type_qualifier_token3] = ACTIONS(1215),
    [aux_sym_type_qualifier_token4] = ACTIONS(1215),
    [aux_sym_type_qualifier_token5] = ACTIONS(1215),
    [aux_sym_type_qualifier_token9] = ACTIONS(1215),
    [aux_sym_type_qualifier_token10] = ACTIONS(1215),
    [aux_sym_type_qualifier_token11] = ACTIONS(1215),
    [aux_sym_type_qualifier_token12] = ACTIONS(1215),
    [aux_sym_type_qualifier_token13] = ACTIONS(1215),
    [aux_sym_type_qualifier_token14] = ACTIONS(1215),
    [aux_sym_type_qualifier_token15] = ACTIONS(1215),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token1] = ACTIONS(1215),
    [aux_sym_stop_statement_token2] = ACTIONS(1215),
    [aux_sym_subroutine_call_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token1] = ACTIONS(1215),
    [aux_sym_keyword_statement_token2] = ACTIONS(1215),
    [aux_sym_keyword_statement_token3] = ACTIONS(1215),
    [aux_sym_keyword_statement_token4] = ACTIONS(1215),
    [aux_sym_keyword_statement_token6] = ACTIONS(1215),
    [aux_sym_keyword_statement_token7] = ACTIONS(1215),
    [aux_sym_include_statement_token1] = ACTIONS(1215),
    [aux_sym_data_statement_token1] = ACTIONS(1215),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1215),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1215),
    [aux_sym_end_if_statement_token1] = ACTIONS(1215),
    [aux_sym_elseif_clause_token2] = ACTIONS(1215),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1215),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token1] = ACTIONS(1215),
    [aux_sym_select_case_statement_token3] = ACTIONS(1215),
    [aux_sym_select_type_statement_token1] = ACTIONS(1215),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1215),
    [aux_sym_block_construct_token1] = ACTIONS(1215),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1215),
    [aux_sym_associate_statement_token1] = ACTIONS(1215),
    [aux_sym_format_statement_token1] = ACTIONS(1215),
    [aux_sym_print_statement_token1] = ACTIONS(1215),
    [aux_sym_open_statement_token1] = ACTIONS(1215),
    [aux_sym_close_statement_token1] = ACTIONS(1215),
    [aux_sym_inquire_statement_token1] = ACTIONS(1215),
    [aux_sym_enum_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token1] = ACTIONS(1215),
    [aux_sym_file_position_statement_token2] = ACTIONS(1215),
    [aux_sym_file_position_statement_token3] = ACTIONS(1215),
    [aux_sym_file_position_statement_token4] = ACTIONS(1215),
    [aux_sym_logical_expression_token5] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [sym_boolean_literal] = ACTIONS(1213),
    [aux_sym_null_literal_token1] = ACTIONS(1215),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1215),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1213),
    [sym__float_literal] = ACTIONS(1213),
    [sym__boz_literal] = ACTIONS(1213),
    [sym_string_literal] = ACTIONS(1213),
  },
  [394] = {
    [sym_preproc_file_line] = STATE(394),
    [aux_sym_end_program_statement_token1] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [aux_sym_interface_statement_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1135),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1135),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1135),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1135),
    [aux_sym_use_statement_token1] = ACTIONS(1135),
    [aux_sym_use_statement_token2] = ACTIONS(1135),
    [aux_sym_implicit_statement_token1] = ACTIONS(1135),
    [aux_sym_implicit_statement_token3] = ACTIONS(1135),
    [aux_sym_implicit_statement_token4] = ACTIONS(1135),
    [aux_sym_save_statement_token1] = ACTIONS(1135),
    [aux_sym_private_statement_token1] = ACTIONS(1135),
    [aux_sym_public_statement_token1] = ACTIONS(1135),
    [aux_sym_namelist_statement_token1] = ACTIONS(1135),
    [aux_sym_common_statement_token1] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1133),
    [aux_sym_import_statement_token1] = ACTIONS(1135),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1135),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1135),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1135),
    [aux_sym_variable_attributes_token1] = ACTIONS(1135),
    [aux_sym_variable_attributes_token2] = ACTIONS(1135),
    [aux_sym_variable_attributes_token3] = ACTIONS(1135),
    [aux_sym_variable_attributes_token4] = ACTIONS(1135),
    [aux_sym_variable_attributes_token5] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1135),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1135),
    [aux_sym_derived_type_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token1] = ACTIONS(1135),
    [aux_sym_type_qualifier_token2] = ACTIONS(1135),
    [aux_sym_type_qualifier_token3] = ACTIONS(1135),
    [aux_sym_type_qualifier_token4] = ACTIONS(1135),
    [aux_sym_type_qualifier_token5] = ACTIONS(1135),
    [aux_sym_type_qualifier_token9] = ACTIONS(1135),
    [aux_sym_type_qualifier_token10] = ACTIONS(1135),
    [aux_sym_type_qualifier_token11] = ACTIONS(1135),
    [aux_sym_type_qualifier_token12] = ACTIONS(1135),
    [aux_sym_type_qualifier_token13] = ACTIONS(1135),
    [aux_sym_type_qualifier_token14] = ACTIONS(1135),
    [aux_sym_type_qualifier_token15] = ACTIONS(1135),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token1] = ACTIONS(1135),
    [aux_sym_stop_statement_token2] = ACTIONS(1135),
    [aux_sym_subroutine_call_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token1] = ACTIONS(1135),
    [aux_sym_keyword_statement_token2] = ACTIONS(1135),
    [aux_sym_keyword_statement_token3] = ACTIONS(1135),
    [aux_sym_keyword_statement_token4] = ACTIONS(1135),
    [aux_sym_keyword_statement_token6] = ACTIONS(1135),
    [aux_sym_keyword_statement_token7] = ACTIONS(1135),
    [aux_sym_include_statement_token1] = ACTIONS(1135),
    [aux_sym_data_statement_token1] = ACTIONS(1135),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1135),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1135),
    [aux_sym_end_if_statement_token1] = ACTIONS(1135),
    [aux_sym_elseif_clause_token2] = ACTIONS(1135),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1135),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token1] = ACTIONS(1135),
    [aux_sym_select_case_statement_token3] = ACTIONS(1135),
    [aux_sym_select_type_statement_token1] = ACTIONS(1135),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1135),
    [aux_sym_block_construct_token1] = ACTIONS(1135),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1135),
    [aux_sym_associate_statement_token1] = ACTIONS(1135),
    [aux_sym_format_statement_token1] = ACTIONS(1135),
    [aux_sym_print_statement_token1] = ACTIONS(1135),
    [aux_sym_open_statement_token1] = ACTIONS(1135),
    [aux_sym_close_statement_token1] = ACTIONS(1135),
    [aux_sym_inquire_statement_token1] = ACTIONS(1135),
    [aux_sym_enum_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token1] = ACTIONS(1135),
    [aux_sym_file_position_statement_token2] = ACTIONS(1135),
    [aux_sym_file_position_statement_token3] = ACTIONS(1135),
    [aux_sym_file_position_statement_token4] = ACTIONS(1135),
    [aux_sym_logical_expression_token5] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [sym_boolean_literal] = ACTIONS(1133),
    [aux_sym_null_literal_token1] = ACTIONS(1135),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1135),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1133),
    [sym__float_literal] = ACTIONS(1133),
    [sym__boz_literal] = ACTIONS(1133),
    [sym_string_literal] = ACTIONS(1133),
  },
  [395] = {
    [sym_preproc_file_line] = STATE(395),
    [aux_sym_end_program_statement_token1] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [aux_sym_interface_statement_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1147),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1147),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1147),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1147),
    [aux_sym_use_statement_token1] = ACTIONS(1147),
    [aux_sym_use_statement_token2] = ACTIONS(1147),
    [aux_sym_implicit_statement_token1] = ACTIONS(1147),
    [aux_sym_implicit_statement_token3] = ACTIONS(1147),
    [aux_sym_implicit_statement_token4] = ACTIONS(1147),
    [aux_sym_save_statement_token1] = ACTIONS(1147),
    [aux_sym_private_statement_token1] = ACTIONS(1147),
    [aux_sym_public_statement_token1] = ACTIONS(1147),
    [aux_sym_namelist_statement_token1] = ACTIONS(1147),
    [aux_sym_common_statement_token1] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1145),
    [aux_sym_import_statement_token1] = ACTIONS(1147),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1147),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1147),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1147),
    [aux_sym_variable_attributes_token1] = ACTIONS(1147),
    [aux_sym_variable_attributes_token2] = ACTIONS(1147),
    [aux_sym_variable_attributes_token3] = ACTIONS(1147),
    [aux_sym_variable_attributes_token4] = ACTIONS(1147),
    [aux_sym_variable_attributes_token5] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1147),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1147),
    [aux_sym_derived_type_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token1] = ACTIONS(1147),
    [aux_sym_type_qualifier_token2] = ACTIONS(1147),
    [aux_sym_type_qualifier_token3] = ACTIONS(1147),
    [aux_sym_type_qualifier_token4] = ACTIONS(1147),
    [aux_sym_type_qualifier_token5] = ACTIONS(1147),
    [aux_sym_type_qualifier_token9] = ACTIONS(1147),
    [aux_sym_type_qualifier_token10] = ACTIONS(1147),
    [aux_sym_type_qualifier_token11] = ACTIONS(1147),
    [aux_sym_type_qualifier_token12] = ACTIONS(1147),
    [aux_sym_type_qualifier_token13] = ACTIONS(1147),
    [aux_sym_type_qualifier_token14] = ACTIONS(1147),
    [aux_sym_type_qualifier_token15] = ACTIONS(1147),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token1] = ACTIONS(1147),
    [aux_sym_stop_statement_token2] = ACTIONS(1147),
    [aux_sym_subroutine_call_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token1] = ACTIONS(1147),
    [aux_sym_keyword_statement_token2] = ACTIONS(1147),
    [aux_sym_keyword_statement_token3] = ACTIONS(1147),
    [aux_sym_keyword_statement_token4] = ACTIONS(1147),
    [aux_sym_keyword_statement_token6] = ACTIONS(1147),
    [aux_sym_keyword_statement_token7] = ACTIONS(1147),
    [aux_sym_include_statement_token1] = ACTIONS(1147),
    [aux_sym_data_statement_token1] = ACTIONS(1147),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1147),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1147),
    [aux_sym_end_if_statement_token1] = ACTIONS(1147),
    [aux_sym_elseif_clause_token2] = ACTIONS(1147),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1147),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token1] = ACTIONS(1147),
    [aux_sym_select_case_statement_token3] = ACTIONS(1147),
    [aux_sym_select_type_statement_token1] = ACTIONS(1147),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1147),
    [aux_sym_block_construct_token1] = ACTIONS(1147),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1147),
    [aux_sym_associate_statement_token1] = ACTIONS(1147),
    [aux_sym_format_statement_token1] = ACTIONS(1147),
    [aux_sym_print_statement_token1] = ACTIONS(1147),
    [aux_sym_open_statement_token1] = ACTIONS(1147),
    [aux_sym_close_statement_token1] = ACTIONS(1147),
    [aux_sym_inquire_statement_token1] = ACTIONS(1147),
    [aux_sym_enum_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token1] = ACTIONS(1147),
    [aux_sym_file_position_statement_token2] = ACTIONS(1147),
    [aux_sym_file_position_statement_token3] = ACTIONS(1147),
    [aux_sym_file_position_statement_token4] = ACTIONS(1147),
    [aux_sym_logical_expression_token5] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_boolean_literal] = ACTIONS(1145),
    [aux_sym_null_literal_token1] = ACTIONS(1147),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1147),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1145),
    [sym__float_literal] = ACTIONS(1145),
    [sym__boz_literal] = ACTIONS(1145),
    [sym_string_literal] = ACTIONS(1145),
  },
  [396] = {
    [sym_preproc_file_line] = STATE(396),
    [aux_sym_end_program_statement_token1] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1319),
    [aux_sym_interface_statement_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1319),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1319),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1319),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1319),
    [aux_sym_use_statement_token1] = ACTIONS(1319),
    [aux_sym_use_statement_token2] = ACTIONS(1319),
    [aux_sym_implicit_statement_token1] = ACTIONS(1319),
    [aux_sym_implicit_statement_token3] = ACTIONS(1319),
    [aux_sym_implicit_statement_token4] = ACTIONS(1319),
    [aux_sym_save_statement_token1] = ACTIONS(1319),
    [aux_sym_private_statement_token1] = ACTIONS(1319),
    [aux_sym_public_statement_token1] = ACTIONS(1319),
    [aux_sym_namelist_statement_token1] = ACTIONS(1319),
    [aux_sym_common_statement_token1] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [aux_sym_import_statement_token1] = ACTIONS(1319),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1319),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1319),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1319),
    [aux_sym_variable_attributes_token1] = ACTIONS(1319),
    [aux_sym_variable_attributes_token2] = ACTIONS(1319),
    [aux_sym_variable_attributes_token3] = ACTIONS(1319),
    [aux_sym_variable_attributes_token4] = ACTIONS(1319),
    [aux_sym_variable_attributes_token5] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1319),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1319),
    [aux_sym_derived_type_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token1] = ACTIONS(1319),
    [aux_sym_type_qualifier_token2] = ACTIONS(1319),
    [aux_sym_type_qualifier_token3] = ACTIONS(1319),
    [aux_sym_type_qualifier_token4] = ACTIONS(1319),
    [aux_sym_type_qualifier_token5] = ACTIONS(1319),
    [aux_sym_type_qualifier_token9] = ACTIONS(1319),
    [aux_sym_type_qualifier_token10] = ACTIONS(1319),
    [aux_sym_type_qualifier_token11] = ACTIONS(1319),
    [aux_sym_type_qualifier_token12] = ACTIONS(1319),
    [aux_sym_type_qualifier_token13] = ACTIONS(1319),
    [aux_sym_type_qualifier_token14] = ACTIONS(1319),
    [aux_sym_type_qualifier_token15] = ACTIONS(1319),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token1] = ACTIONS(1319),
    [aux_sym_stop_statement_token2] = ACTIONS(1319),
    [aux_sym_subroutine_call_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token1] = ACTIONS(1319),
    [aux_sym_keyword_statement_token2] = ACTIONS(1319),
    [aux_sym_keyword_statement_token3] = ACTIONS(1319),
    [aux_sym_keyword_statement_token4] = ACTIONS(1319),
    [aux_sym_keyword_statement_token6] = ACTIONS(1319),
    [aux_sym_keyword_statement_token7] = ACTIONS(1319),
    [aux_sym_include_statement_token1] = ACTIONS(1319),
    [aux_sym_data_statement_token1] = ACTIONS(1319),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1319),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1319),
    [aux_sym_end_if_statement_token1] = ACTIONS(1319),
    [aux_sym_elseif_clause_token2] = ACTIONS(1319),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1319),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token1] = ACTIONS(1319),
    [aux_sym_select_case_statement_token3] = ACTIONS(1319),
    [aux_sym_select_type_statement_token1] = ACTIONS(1319),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1319),
    [aux_sym_block_construct_token1] = ACTIONS(1319),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1319),
    [aux_sym_associate_statement_token1] = ACTIONS(1319),
    [aux_sym_format_statement_token1] = ACTIONS(1319),
    [aux_sym_print_statement_token1] = ACTIONS(1319),
    [aux_sym_open_statement_token1] = ACTIONS(1319),
    [aux_sym_close_statement_token1] = ACTIONS(1319),
    [aux_sym_inquire_statement_token1] = ACTIONS(1319),
    [aux_sym_enum_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token1] = ACTIONS(1319),
    [aux_sym_file_position_statement_token2] = ACTIONS(1319),
    [aux_sym_file_position_statement_token3] = ACTIONS(1319),
    [aux_sym_file_position_statement_token4] = ACTIONS(1319),
    [aux_sym_logical_expression_token5] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [sym_boolean_literal] = ACTIONS(1321),
    [aux_sym_null_literal_token1] = ACTIONS(1319),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1319),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1321),
    [sym__float_literal] = ACTIONS(1321),
    [sym__boz_literal] = ACTIONS(1321),
    [sym_string_literal] = ACTIONS(1321),
  },
  [397] = {
    [sym_preproc_file_line] = STATE(397),
    [aux_sym_end_program_statement_token1] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [aux_sym_interface_statement_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1323),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1323),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1323),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1323),
    [aux_sym_use_statement_token1] = ACTIONS(1323),
    [aux_sym_use_statement_token2] = ACTIONS(1323),
    [aux_sym_implicit_statement_token1] = ACTIONS(1323),
    [aux_sym_implicit_statement_token3] = ACTIONS(1323),
    [aux_sym_implicit_statement_token4] = ACTIONS(1323),
    [aux_sym_save_statement_token1] = ACTIONS(1323),
    [aux_sym_private_statement_token1] = ACTIONS(1323),
    [aux_sym_public_statement_token1] = ACTIONS(1323),
    [aux_sym_namelist_statement_token1] = ACTIONS(1323),
    [aux_sym_common_statement_token1] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1325),
    [aux_sym_import_statement_token1] = ACTIONS(1323),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1323),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1323),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1323),
    [aux_sym_variable_attributes_token1] = ACTIONS(1323),
    [aux_sym_variable_attributes_token2] = ACTIONS(1323),
    [aux_sym_variable_attributes_token3] = ACTIONS(1323),
    [aux_sym_variable_attributes_token4] = ACTIONS(1323),
    [aux_sym_variable_attributes_token5] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1323),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1323),
    [aux_sym_derived_type_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token1] = ACTIONS(1323),
    [aux_sym_type_qualifier_token2] = ACTIONS(1323),
    [aux_sym_type_qualifier_token3] = ACTIONS(1323),
    [aux_sym_type_qualifier_token4] = ACTIONS(1323),
    [aux_sym_type_qualifier_token5] = ACTIONS(1323),
    [aux_sym_type_qualifier_token9] = ACTIONS(1323),
    [aux_sym_type_qualifier_token10] = ACTIONS(1323),
    [aux_sym_type_qualifier_token11] = ACTIONS(1323),
    [aux_sym_type_qualifier_token12] = ACTIONS(1323),
    [aux_sym_type_qualifier_token13] = ACTIONS(1323),
    [aux_sym_type_qualifier_token14] = ACTIONS(1323),
    [aux_sym_type_qualifier_token15] = ACTIONS(1323),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token1] = ACTIONS(1323),
    [aux_sym_stop_statement_token2] = ACTIONS(1323),
    [aux_sym_subroutine_call_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token1] = ACTIONS(1323),
    [aux_sym_keyword_statement_token2] = ACTIONS(1323),
    [aux_sym_keyword_statement_token3] = ACTIONS(1323),
    [aux_sym_keyword_statement_token4] = ACTIONS(1323),
    [aux_sym_keyword_statement_token6] = ACTIONS(1323),
    [aux_sym_keyword_statement_token7] = ACTIONS(1323),
    [aux_sym_include_statement_token1] = ACTIONS(1323),
    [aux_sym_data_statement_token1] = ACTIONS(1323),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1323),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1323),
    [aux_sym_end_if_statement_token1] = ACTIONS(1323),
    [aux_sym_elseif_clause_token2] = ACTIONS(1323),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1323),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token1] = ACTIONS(1323),
    [aux_sym_select_case_statement_token3] = ACTIONS(1323),
    [aux_sym_select_type_statement_token1] = ACTIONS(1323),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1323),
    [aux_sym_block_construct_token1] = ACTIONS(1323),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1323),
    [aux_sym_associate_statement_token1] = ACTIONS(1323),
    [aux_sym_format_statement_token1] = ACTIONS(1323),
    [aux_sym_print_statement_token1] = ACTIONS(1323),
    [aux_sym_open_statement_token1] = ACTIONS(1323),
    [aux_sym_close_statement_token1] = ACTIONS(1323),
    [aux_sym_inquire_statement_token1] = ACTIONS(1323),
    [aux_sym_enum_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token1] = ACTIONS(1323),
    [aux_sym_file_position_statement_token2] = ACTIONS(1323),
    [aux_sym_file_position_statement_token3] = ACTIONS(1323),
    [aux_sym_file_position_statement_token4] = ACTIONS(1323),
    [aux_sym_logical_expression_token5] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [sym_boolean_literal] = ACTIONS(1325),
    [aux_sym_null_literal_token1] = ACTIONS(1323),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1323),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1325),
    [sym__float_literal] = ACTIONS(1325),
    [sym__boz_literal] = ACTIONS(1325),
    [sym_string_literal] = ACTIONS(1325),
  },
  [398] = {
    [sym_preproc_file_line] = STATE(398),
    [aux_sym_end_program_statement_token1] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [aux_sym_interface_statement_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1327),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1327),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1327),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1327),
    [aux_sym_use_statement_token1] = ACTIONS(1327),
    [aux_sym_use_statement_token2] = ACTIONS(1327),
    [aux_sym_implicit_statement_token1] = ACTIONS(1327),
    [aux_sym_implicit_statement_token3] = ACTIONS(1327),
    [aux_sym_implicit_statement_token4] = ACTIONS(1327),
    [aux_sym_save_statement_token1] = ACTIONS(1327),
    [aux_sym_private_statement_token1] = ACTIONS(1327),
    [aux_sym_public_statement_token1] = ACTIONS(1327),
    [aux_sym_namelist_statement_token1] = ACTIONS(1327),
    [aux_sym_common_statement_token1] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1329),
    [aux_sym_import_statement_token1] = ACTIONS(1327),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1327),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1327),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1327),
    [aux_sym_variable_attributes_token1] = ACTIONS(1327),
    [aux_sym_variable_attributes_token2] = ACTIONS(1327),
    [aux_sym_variable_attributes_token3] = ACTIONS(1327),
    [aux_sym_variable_attributes_token4] = ACTIONS(1327),
    [aux_sym_variable_attributes_token5] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1327),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1327),
    [aux_sym_derived_type_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token1] = ACTIONS(1327),
    [aux_sym_type_qualifier_token2] = ACTIONS(1327),
    [aux_sym_type_qualifier_token3] = ACTIONS(1327),
    [aux_sym_type_qualifier_token4] = ACTIONS(1327),
    [aux_sym_type_qualifier_token5] = ACTIONS(1327),
    [aux_sym_type_qualifier_token9] = ACTIONS(1327),
    [aux_sym_type_qualifier_token10] = ACTIONS(1327),
    [aux_sym_type_qualifier_token11] = ACTIONS(1327),
    [aux_sym_type_qualifier_token12] = ACTIONS(1327),
    [aux_sym_type_qualifier_token13] = ACTIONS(1327),
    [aux_sym_type_qualifier_token14] = ACTIONS(1327),
    [aux_sym_type_qualifier_token15] = ACTIONS(1327),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token1] = ACTIONS(1327),
    [aux_sym_stop_statement_token2] = ACTIONS(1327),
    [aux_sym_subroutine_call_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token1] = ACTIONS(1327),
    [aux_sym_keyword_statement_token2] = ACTIONS(1327),
    [aux_sym_keyword_statement_token3] = ACTIONS(1327),
    [aux_sym_keyword_statement_token4] = ACTIONS(1327),
    [aux_sym_keyword_statement_token6] = ACTIONS(1327),
    [aux_sym_keyword_statement_token7] = ACTIONS(1327),
    [aux_sym_include_statement_token1] = ACTIONS(1327),
    [aux_sym_data_statement_token1] = ACTIONS(1327),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1327),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1327),
    [aux_sym_end_if_statement_token1] = ACTIONS(1327),
    [aux_sym_elseif_clause_token2] = ACTIONS(1327),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1327),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token1] = ACTIONS(1327),
    [aux_sym_select_case_statement_token3] = ACTIONS(1327),
    [aux_sym_select_type_statement_token1] = ACTIONS(1327),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1327),
    [aux_sym_block_construct_token1] = ACTIONS(1327),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1327),
    [aux_sym_associate_statement_token1] = ACTIONS(1327),
    [aux_sym_format_statement_token1] = ACTIONS(1327),
    [aux_sym_print_statement_token1] = ACTIONS(1327),
    [aux_sym_open_statement_token1] = ACTIONS(1327),
    [aux_sym_close_statement_token1] = ACTIONS(1327),
    [aux_sym_inquire_statement_token1] = ACTIONS(1327),
    [aux_sym_enum_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token1] = ACTIONS(1327),
    [aux_sym_file_position_statement_token2] = ACTIONS(1327),
    [aux_sym_file_position_statement_token3] = ACTIONS(1327),
    [aux_sym_file_position_statement_token4] = ACTIONS(1327),
    [aux_sym_logical_expression_token5] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [sym_boolean_literal] = ACTIONS(1329),
    [aux_sym_null_literal_token1] = ACTIONS(1327),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1327),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1329),
    [sym__float_literal] = ACTIONS(1329),
    [sym__boz_literal] = ACTIONS(1329),
    [sym_string_literal] = ACTIONS(1329),
  },
  [399] = {
    [sym_preproc_file_line] = STATE(399),
    [aux_sym_end_program_statement_token1] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1331),
    [aux_sym_interface_statement_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1331),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1331),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1331),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1331),
    [aux_sym_use_statement_token1] = ACTIONS(1331),
    [aux_sym_use_statement_token2] = ACTIONS(1331),
    [aux_sym_implicit_statement_token1] = ACTIONS(1331),
    [aux_sym_implicit_statement_token3] = ACTIONS(1331),
    [aux_sym_implicit_statement_token4] = ACTIONS(1331),
    [aux_sym_save_statement_token1] = ACTIONS(1331),
    [aux_sym_private_statement_token1] = ACTIONS(1331),
    [aux_sym_public_statement_token1] = ACTIONS(1331),
    [aux_sym_namelist_statement_token1] = ACTIONS(1331),
    [aux_sym_common_statement_token1] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [aux_sym_import_statement_token1] = ACTIONS(1331),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1331),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1331),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1331),
    [aux_sym_variable_attributes_token1] = ACTIONS(1331),
    [aux_sym_variable_attributes_token2] = ACTIONS(1331),
    [aux_sym_variable_attributes_token3] = ACTIONS(1331),
    [aux_sym_variable_attributes_token4] = ACTIONS(1331),
    [aux_sym_variable_attributes_token5] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1331),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1331),
    [aux_sym_derived_type_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token1] = ACTIONS(1331),
    [aux_sym_type_qualifier_token2] = ACTIONS(1331),
    [aux_sym_type_qualifier_token3] = ACTIONS(1331),
    [aux_sym_type_qualifier_token4] = ACTIONS(1331),
    [aux_sym_type_qualifier_token5] = ACTIONS(1331),
    [aux_sym_type_qualifier_token9] = ACTIONS(1331),
    [aux_sym_type_qualifier_token10] = ACTIONS(1331),
    [aux_sym_type_qualifier_token11] = ACTIONS(1331),
    [aux_sym_type_qualifier_token12] = ACTIONS(1331),
    [aux_sym_type_qualifier_token13] = ACTIONS(1331),
    [aux_sym_type_qualifier_token14] = ACTIONS(1331),
    [aux_sym_type_qualifier_token15] = ACTIONS(1331),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token1] = ACTIONS(1331),
    [aux_sym_stop_statement_token2] = ACTIONS(1331),
    [aux_sym_subroutine_call_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token1] = ACTIONS(1331),
    [aux_sym_keyword_statement_token2] = ACTIONS(1331),
    [aux_sym_keyword_statement_token3] = ACTIONS(1331),
    [aux_sym_keyword_statement_token4] = ACTIONS(1331),
    [aux_sym_keyword_statement_token6] = ACTIONS(1331),
    [aux_sym_keyword_statement_token7] = ACTIONS(1331),
    [aux_sym_include_statement_token1] = ACTIONS(1331),
    [aux_sym_data_statement_token1] = ACTIONS(1331),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1331),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1331),
    [aux_sym_end_if_statement_token1] = ACTIONS(1331),
    [aux_sym_elseif_clause_token2] = ACTIONS(1331),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1331),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token1] = ACTIONS(1331),
    [aux_sym_select_case_statement_token3] = ACTIONS(1331),
    [aux_sym_select_type_statement_token1] = ACTIONS(1331),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1331),
    [aux_sym_block_construct_token1] = ACTIONS(1331),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1331),
    [aux_sym_associate_statement_token1] = ACTIONS(1331),
    [aux_sym_format_statement_token1] = ACTIONS(1331),
    [aux_sym_print_statement_token1] = ACTIONS(1331),
    [aux_sym_open_statement_token1] = ACTIONS(1331),
    [aux_sym_close_statement_token1] = ACTIONS(1331),
    [aux_sym_inquire_statement_token1] = ACTIONS(1331),
    [aux_sym_enum_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token1] = ACTIONS(1331),
    [aux_sym_file_position_statement_token2] = ACTIONS(1331),
    [aux_sym_file_position_statement_token3] = ACTIONS(1331),
    [aux_sym_file_position_statement_token4] = ACTIONS(1331),
    [aux_sym_logical_expression_token5] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [sym_boolean_literal] = ACTIONS(1333),
    [aux_sym_null_literal_token1] = ACTIONS(1331),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1331),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1333),
    [sym__float_literal] = ACTIONS(1333),
    [sym__boz_literal] = ACTIONS(1333),
    [sym_string_literal] = ACTIONS(1333),
  },
  [400] = {
    [sym_preproc_file_line] = STATE(400),
    [aux_sym_end_program_statement_token1] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [aux_sym_interface_statement_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1265),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1265),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1265),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1265),
    [aux_sym_use_statement_token1] = ACTIONS(1265),
    [aux_sym_use_statement_token2] = ACTIONS(1265),
    [aux_sym_implicit_statement_token1] = ACTIONS(1265),
    [aux_sym_implicit_statement_token3] = ACTIONS(1265),
    [aux_sym_implicit_statement_token4] = ACTIONS(1265),
    [aux_sym_save_statement_token1] = ACTIONS(1265),
    [aux_sym_private_statement_token1] = ACTIONS(1265),
    [aux_sym_public_statement_token1] = ACTIONS(1265),
    [aux_sym_namelist_statement_token1] = ACTIONS(1265),
    [aux_sym_common_statement_token1] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [aux_sym_import_statement_token1] = ACTIONS(1265),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1265),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1265),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1265),
    [aux_sym_variable_attributes_token1] = ACTIONS(1265),
    [aux_sym_variable_attributes_token2] = ACTIONS(1265),
    [aux_sym_variable_attributes_token3] = ACTIONS(1265),
    [aux_sym_variable_attributes_token4] = ACTIONS(1265),
    [aux_sym_variable_attributes_token5] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1265),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1265),
    [aux_sym_derived_type_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token1] = ACTIONS(1265),
    [aux_sym_type_qualifier_token2] = ACTIONS(1265),
    [aux_sym_type_qualifier_token3] = ACTIONS(1265),
    [aux_sym_type_qualifier_token4] = ACTIONS(1265),
    [aux_sym_type_qualifier_token5] = ACTIONS(1265),
    [aux_sym_type_qualifier_token9] = ACTIONS(1265),
    [aux_sym_type_qualifier_token10] = ACTIONS(1265),
    [aux_sym_type_qualifier_token11] = ACTIONS(1265),
    [aux_sym_type_qualifier_token12] = ACTIONS(1265),
    [aux_sym_type_qualifier_token13] = ACTIONS(1265),
    [aux_sym_type_qualifier_token14] = ACTIONS(1265),
    [aux_sym_type_qualifier_token15] = ACTIONS(1265),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token1] = ACTIONS(1265),
    [aux_sym_stop_statement_token2] = ACTIONS(1265),
    [aux_sym_subroutine_call_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token1] = ACTIONS(1265),
    [aux_sym_keyword_statement_token2] = ACTIONS(1265),
    [aux_sym_keyword_statement_token3] = ACTIONS(1265),
    [aux_sym_keyword_statement_token4] = ACTIONS(1265),
    [aux_sym_keyword_statement_token6] = ACTIONS(1265),
    [aux_sym_keyword_statement_token7] = ACTIONS(1265),
    [aux_sym_include_statement_token1] = ACTIONS(1265),
    [aux_sym_data_statement_token1] = ACTIONS(1265),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1265),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1265),
    [aux_sym_end_if_statement_token1] = ACTIONS(1265),
    [aux_sym_elseif_clause_token2] = ACTIONS(1265),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1265),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token1] = ACTIONS(1265),
    [aux_sym_select_case_statement_token3] = ACTIONS(1265),
    [aux_sym_select_type_statement_token1] = ACTIONS(1265),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1265),
    [aux_sym_block_construct_token1] = ACTIONS(1265),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1265),
    [aux_sym_associate_statement_token1] = ACTIONS(1265),
    [aux_sym_format_statement_token1] = ACTIONS(1265),
    [aux_sym_print_statement_token1] = ACTIONS(1265),
    [aux_sym_open_statement_token1] = ACTIONS(1265),
    [aux_sym_close_statement_token1] = ACTIONS(1265),
    [aux_sym_inquire_statement_token1] = ACTIONS(1265),
    [aux_sym_enum_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token1] = ACTIONS(1265),
    [aux_sym_file_position_statement_token2] = ACTIONS(1265),
    [aux_sym_file_position_statement_token3] = ACTIONS(1265),
    [aux_sym_file_position_statement_token4] = ACTIONS(1265),
    [aux_sym_logical_expression_token5] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [sym_boolean_literal] = ACTIONS(1263),
    [aux_sym_null_literal_token1] = ACTIONS(1265),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1265),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__float_literal] = ACTIONS(1263),
    [sym__boz_literal] = ACTIONS(1263),
    [sym_string_literal] = ACTIONS(1263),
  },
  [401] = {
    [sym_preproc_file_line] = STATE(401),
    [aux_sym_end_program_statement_token1] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1335),
    [aux_sym_interface_statement_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1335),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1335),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1335),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1335),
    [aux_sym_use_statement_token1] = ACTIONS(1335),
    [aux_sym_use_statement_token2] = ACTIONS(1335),
    [aux_sym_implicit_statement_token1] = ACTIONS(1335),
    [aux_sym_implicit_statement_token3] = ACTIONS(1335),
    [aux_sym_implicit_statement_token4] = ACTIONS(1335),
    [aux_sym_save_statement_token1] = ACTIONS(1335),
    [aux_sym_private_statement_token1] = ACTIONS(1335),
    [aux_sym_public_statement_token1] = ACTIONS(1335),
    [aux_sym_namelist_statement_token1] = ACTIONS(1335),
    [aux_sym_common_statement_token1] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [aux_sym_import_statement_token1] = ACTIONS(1335),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1335),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1335),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1335),
    [aux_sym_variable_attributes_token1] = ACTIONS(1335),
    [aux_sym_variable_attributes_token2] = ACTIONS(1335),
    [aux_sym_variable_attributes_token3] = ACTIONS(1335),
    [aux_sym_variable_attributes_token4] = ACTIONS(1335),
    [aux_sym_variable_attributes_token5] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1335),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1335),
    [aux_sym_derived_type_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token1] = ACTIONS(1335),
    [aux_sym_type_qualifier_token2] = ACTIONS(1335),
    [aux_sym_type_qualifier_token3] = ACTIONS(1335),
    [aux_sym_type_qualifier_token4] = ACTIONS(1335),
    [aux_sym_type_qualifier_token5] = ACTIONS(1335),
    [aux_sym_type_qualifier_token9] = ACTIONS(1335),
    [aux_sym_type_qualifier_token10] = ACTIONS(1335),
    [aux_sym_type_qualifier_token11] = ACTIONS(1335),
    [aux_sym_type_qualifier_token12] = ACTIONS(1335),
    [aux_sym_type_qualifier_token13] = ACTIONS(1335),
    [aux_sym_type_qualifier_token14] = ACTIONS(1335),
    [aux_sym_type_qualifier_token15] = ACTIONS(1335),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token1] = ACTIONS(1335),
    [aux_sym_stop_statement_token2] = ACTIONS(1335),
    [aux_sym_subroutine_call_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token1] = ACTIONS(1335),
    [aux_sym_keyword_statement_token2] = ACTIONS(1335),
    [aux_sym_keyword_statement_token3] = ACTIONS(1335),
    [aux_sym_keyword_statement_token4] = ACTIONS(1335),
    [aux_sym_keyword_statement_token6] = ACTIONS(1335),
    [aux_sym_keyword_statement_token7] = ACTIONS(1335),
    [aux_sym_include_statement_token1] = ACTIONS(1335),
    [aux_sym_data_statement_token1] = ACTIONS(1335),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1335),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1335),
    [aux_sym_end_if_statement_token1] = ACTIONS(1335),
    [aux_sym_elseif_clause_token2] = ACTIONS(1335),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1335),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token1] = ACTIONS(1335),
    [aux_sym_select_case_statement_token3] = ACTIONS(1335),
    [aux_sym_select_type_statement_token1] = ACTIONS(1335),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1335),
    [aux_sym_block_construct_token1] = ACTIONS(1335),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1335),
    [aux_sym_associate_statement_token1] = ACTIONS(1335),
    [aux_sym_format_statement_token1] = ACTIONS(1335),
    [aux_sym_print_statement_token1] = ACTIONS(1335),
    [aux_sym_open_statement_token1] = ACTIONS(1335),
    [aux_sym_close_statement_token1] = ACTIONS(1335),
    [aux_sym_inquire_statement_token1] = ACTIONS(1335),
    [aux_sym_enum_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token1] = ACTIONS(1335),
    [aux_sym_file_position_statement_token2] = ACTIONS(1335),
    [aux_sym_file_position_statement_token3] = ACTIONS(1335),
    [aux_sym_file_position_statement_token4] = ACTIONS(1335),
    [aux_sym_logical_expression_token5] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [sym_boolean_literal] = ACTIONS(1337),
    [aux_sym_null_literal_token1] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1335),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1337),
    [sym__float_literal] = ACTIONS(1337),
    [sym__boz_literal] = ACTIONS(1337),
    [sym_string_literal] = ACTIONS(1337),
  },
  [402] = {
    [sym_preproc_file_line] = STATE(402),
    [aux_sym_end_program_statement_token1] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [aux_sym_interface_statement_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1339),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1339),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1339),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1339),
    [aux_sym_use_statement_token1] = ACTIONS(1339),
    [aux_sym_use_statement_token2] = ACTIONS(1339),
    [aux_sym_implicit_statement_token1] = ACTIONS(1339),
    [aux_sym_implicit_statement_token3] = ACTIONS(1339),
    [aux_sym_implicit_statement_token4] = ACTIONS(1339),
    [aux_sym_save_statement_token1] = ACTIONS(1339),
    [aux_sym_private_statement_token1] = ACTIONS(1339),
    [aux_sym_public_statement_token1] = ACTIONS(1339),
    [aux_sym_namelist_statement_token1] = ACTIONS(1339),
    [aux_sym_common_statement_token1] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1341),
    [aux_sym_import_statement_token1] = ACTIONS(1339),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1339),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1339),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1339),
    [aux_sym_variable_attributes_token1] = ACTIONS(1339),
    [aux_sym_variable_attributes_token2] = ACTIONS(1339),
    [aux_sym_variable_attributes_token3] = ACTIONS(1339),
    [aux_sym_variable_attributes_token4] = ACTIONS(1339),
    [aux_sym_variable_attributes_token5] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1339),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1339),
    [aux_sym_derived_type_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token1] = ACTIONS(1339),
    [aux_sym_type_qualifier_token2] = ACTIONS(1339),
    [aux_sym_type_qualifier_token3] = ACTIONS(1339),
    [aux_sym_type_qualifier_token4] = ACTIONS(1339),
    [aux_sym_type_qualifier_token5] = ACTIONS(1339),
    [aux_sym_type_qualifier_token9] = ACTIONS(1339),
    [aux_sym_type_qualifier_token10] = ACTIONS(1339),
    [aux_sym_type_qualifier_token11] = ACTIONS(1339),
    [aux_sym_type_qualifier_token12] = ACTIONS(1339),
    [aux_sym_type_qualifier_token13] = ACTIONS(1339),
    [aux_sym_type_qualifier_token14] = ACTIONS(1339),
    [aux_sym_type_qualifier_token15] = ACTIONS(1339),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token1] = ACTIONS(1339),
    [aux_sym_stop_statement_token2] = ACTIONS(1339),
    [aux_sym_subroutine_call_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token1] = ACTIONS(1339),
    [aux_sym_keyword_statement_token2] = ACTIONS(1339),
    [aux_sym_keyword_statement_token3] = ACTIONS(1339),
    [aux_sym_keyword_statement_token4] = ACTIONS(1339),
    [aux_sym_keyword_statement_token6] = ACTIONS(1339),
    [aux_sym_keyword_statement_token7] = ACTIONS(1339),
    [aux_sym_include_statement_token1] = ACTIONS(1339),
    [aux_sym_data_statement_token1] = ACTIONS(1339),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1339),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1339),
    [aux_sym_end_if_statement_token1] = ACTIONS(1339),
    [aux_sym_elseif_clause_token2] = ACTIONS(1339),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1339),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token1] = ACTIONS(1339),
    [aux_sym_select_case_statement_token3] = ACTIONS(1339),
    [aux_sym_select_type_statement_token1] = ACTIONS(1339),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1339),
    [aux_sym_block_construct_token1] = ACTIONS(1339),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1339),
    [aux_sym_associate_statement_token1] = ACTIONS(1339),
    [aux_sym_format_statement_token1] = ACTIONS(1339),
    [aux_sym_print_statement_token1] = ACTIONS(1339),
    [aux_sym_open_statement_token1] = ACTIONS(1339),
    [aux_sym_close_statement_token1] = ACTIONS(1339),
    [aux_sym_inquire_statement_token1] = ACTIONS(1339),
    [aux_sym_enum_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token1] = ACTIONS(1339),
    [aux_sym_file_position_statement_token2] = ACTIONS(1339),
    [aux_sym_file_position_statement_token3] = ACTIONS(1339),
    [aux_sym_file_position_statement_token4] = ACTIONS(1339),
    [aux_sym_logical_expression_token5] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [sym_boolean_literal] = ACTIONS(1341),
    [aux_sym_null_literal_token1] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1339),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1341),
    [sym__float_literal] = ACTIONS(1341),
    [sym__boz_literal] = ACTIONS(1341),
    [sym_string_literal] = ACTIONS(1341),
  },
  [403] = {
    [sym_preproc_file_line] = STATE(403),
    [aux_sym_end_program_statement_token1] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1287),
    [aux_sym_interface_statement_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1287),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1287),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1287),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1287),
    [aux_sym_use_statement_token1] = ACTIONS(1287),
    [aux_sym_use_statement_token2] = ACTIONS(1287),
    [aux_sym_implicit_statement_token1] = ACTIONS(1287),
    [aux_sym_implicit_statement_token3] = ACTIONS(1287),
    [aux_sym_implicit_statement_token4] = ACTIONS(1287),
    [aux_sym_save_statement_token1] = ACTIONS(1287),
    [aux_sym_private_statement_token1] = ACTIONS(1287),
    [aux_sym_public_statement_token1] = ACTIONS(1287),
    [aux_sym_namelist_statement_token1] = ACTIONS(1287),
    [aux_sym_common_statement_token1] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1289),
    [aux_sym_import_statement_token1] = ACTIONS(1287),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1287),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1287),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1287),
    [aux_sym_variable_attributes_token1] = ACTIONS(1287),
    [aux_sym_variable_attributes_token2] = ACTIONS(1287),
    [aux_sym_variable_attributes_token3] = ACTIONS(1287),
    [aux_sym_variable_attributes_token4] = ACTIONS(1287),
    [aux_sym_variable_attributes_token5] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1287),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1287),
    [aux_sym_derived_type_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token1] = ACTIONS(1287),
    [aux_sym_type_qualifier_token2] = ACTIONS(1287),
    [aux_sym_type_qualifier_token3] = ACTIONS(1287),
    [aux_sym_type_qualifier_token4] = ACTIONS(1287),
    [aux_sym_type_qualifier_token5] = ACTIONS(1287),
    [aux_sym_type_qualifier_token9] = ACTIONS(1287),
    [aux_sym_type_qualifier_token10] = ACTIONS(1287),
    [aux_sym_type_qualifier_token11] = ACTIONS(1287),
    [aux_sym_type_qualifier_token12] = ACTIONS(1287),
    [aux_sym_type_qualifier_token13] = ACTIONS(1287),
    [aux_sym_type_qualifier_token14] = ACTIONS(1287),
    [aux_sym_type_qualifier_token15] = ACTIONS(1287),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token1] = ACTIONS(1287),
    [aux_sym_stop_statement_token2] = ACTIONS(1287),
    [aux_sym_subroutine_call_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token1] = ACTIONS(1287),
    [aux_sym_keyword_statement_token2] = ACTIONS(1287),
    [aux_sym_keyword_statement_token3] = ACTIONS(1287),
    [aux_sym_keyword_statement_token4] = ACTIONS(1287),
    [aux_sym_keyword_statement_token6] = ACTIONS(1287),
    [aux_sym_keyword_statement_token7] = ACTIONS(1287),
    [aux_sym_include_statement_token1] = ACTIONS(1287),
    [aux_sym_data_statement_token1] = ACTIONS(1287),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1287),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1287),
    [aux_sym_end_if_statement_token1] = ACTIONS(1287),
    [aux_sym_elseif_clause_token2] = ACTIONS(1287),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1287),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token1] = ACTIONS(1287),
    [aux_sym_select_case_statement_token3] = ACTIONS(1287),
    [aux_sym_select_type_statement_token1] = ACTIONS(1287),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1287),
    [aux_sym_block_construct_token1] = ACTIONS(1287),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1287),
    [aux_sym_associate_statement_token1] = ACTIONS(1287),
    [aux_sym_format_statement_token1] = ACTIONS(1287),
    [aux_sym_print_statement_token1] = ACTIONS(1287),
    [aux_sym_open_statement_token1] = ACTIONS(1287),
    [aux_sym_close_statement_token1] = ACTIONS(1287),
    [aux_sym_inquire_statement_token1] = ACTIONS(1287),
    [aux_sym_enum_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token1] = ACTIONS(1287),
    [aux_sym_file_position_statement_token2] = ACTIONS(1287),
    [aux_sym_file_position_statement_token3] = ACTIONS(1287),
    [aux_sym_file_position_statement_token4] = ACTIONS(1287),
    [aux_sym_logical_expression_token5] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [sym_boolean_literal] = ACTIONS(1289),
    [aux_sym_null_literal_token1] = ACTIONS(1287),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1287),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1289),
    [sym__float_literal] = ACTIONS(1289),
    [sym__boz_literal] = ACTIONS(1289),
    [sym_string_literal] = ACTIONS(1289),
  },
  [404] = {
    [sym_preproc_file_line] = STATE(404),
    [aux_sym_end_program_statement_token1] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [aux_sym_interface_statement_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1295),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1295),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1295),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1295),
    [aux_sym_use_statement_token1] = ACTIONS(1295),
    [aux_sym_use_statement_token2] = ACTIONS(1295),
    [aux_sym_implicit_statement_token1] = ACTIONS(1295),
    [aux_sym_implicit_statement_token3] = ACTIONS(1295),
    [aux_sym_implicit_statement_token4] = ACTIONS(1295),
    [aux_sym_save_statement_token1] = ACTIONS(1295),
    [aux_sym_private_statement_token1] = ACTIONS(1295),
    [aux_sym_public_statement_token1] = ACTIONS(1295),
    [aux_sym_namelist_statement_token1] = ACTIONS(1295),
    [aux_sym_common_statement_token1] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1297),
    [aux_sym_import_statement_token1] = ACTIONS(1295),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1295),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1295),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1295),
    [aux_sym_variable_attributes_token1] = ACTIONS(1295),
    [aux_sym_variable_attributes_token2] = ACTIONS(1295),
    [aux_sym_variable_attributes_token3] = ACTIONS(1295),
    [aux_sym_variable_attributes_token4] = ACTIONS(1295),
    [aux_sym_variable_attributes_token5] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1295),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1295),
    [aux_sym_derived_type_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token1] = ACTIONS(1295),
    [aux_sym_type_qualifier_token2] = ACTIONS(1295),
    [aux_sym_type_qualifier_token3] = ACTIONS(1295),
    [aux_sym_type_qualifier_token4] = ACTIONS(1295),
    [aux_sym_type_qualifier_token5] = ACTIONS(1295),
    [aux_sym_type_qualifier_token9] = ACTIONS(1295),
    [aux_sym_type_qualifier_token10] = ACTIONS(1295),
    [aux_sym_type_qualifier_token11] = ACTIONS(1295),
    [aux_sym_type_qualifier_token12] = ACTIONS(1295),
    [aux_sym_type_qualifier_token13] = ACTIONS(1295),
    [aux_sym_type_qualifier_token14] = ACTIONS(1295),
    [aux_sym_type_qualifier_token15] = ACTIONS(1295),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token1] = ACTIONS(1295),
    [aux_sym_stop_statement_token2] = ACTIONS(1295),
    [aux_sym_subroutine_call_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token1] = ACTIONS(1295),
    [aux_sym_keyword_statement_token2] = ACTIONS(1295),
    [aux_sym_keyword_statement_token3] = ACTIONS(1295),
    [aux_sym_keyword_statement_token4] = ACTIONS(1295),
    [aux_sym_keyword_statement_token6] = ACTIONS(1295),
    [aux_sym_keyword_statement_token7] = ACTIONS(1295),
    [aux_sym_include_statement_token1] = ACTIONS(1295),
    [aux_sym_data_statement_token1] = ACTIONS(1295),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1295),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1295),
    [aux_sym_end_if_statement_token1] = ACTIONS(1295),
    [aux_sym_elseif_clause_token2] = ACTIONS(1295),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1295),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token1] = ACTIONS(1295),
    [aux_sym_select_case_statement_token3] = ACTIONS(1295),
    [aux_sym_select_type_statement_token1] = ACTIONS(1295),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1295),
    [aux_sym_block_construct_token1] = ACTIONS(1295),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1295),
    [aux_sym_associate_statement_token1] = ACTIONS(1295),
    [aux_sym_format_statement_token1] = ACTIONS(1295),
    [aux_sym_print_statement_token1] = ACTIONS(1295),
    [aux_sym_open_statement_token1] = ACTIONS(1295),
    [aux_sym_close_statement_token1] = ACTIONS(1295),
    [aux_sym_inquire_statement_token1] = ACTIONS(1295),
    [aux_sym_enum_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token1] = ACTIONS(1295),
    [aux_sym_file_position_statement_token2] = ACTIONS(1295),
    [aux_sym_file_position_statement_token3] = ACTIONS(1295),
    [aux_sym_file_position_statement_token4] = ACTIONS(1295),
    [aux_sym_logical_expression_token5] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1295),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_boolean_literal] = ACTIONS(1297),
    [aux_sym_null_literal_token1] = ACTIONS(1295),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1295),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1297),
    [sym__float_literal] = ACTIONS(1297),
    [sym__boz_literal] = ACTIONS(1297),
    [sym_string_literal] = ACTIONS(1297),
  },
  [405] = {
    [sym_preproc_file_line] = STATE(405),
    [aux_sym_end_program_statement_token1] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [aux_sym_interface_statement_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1275),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1275),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1275),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1275),
    [aux_sym_use_statement_token1] = ACTIONS(1275),
    [aux_sym_use_statement_token2] = ACTIONS(1275),
    [aux_sym_implicit_statement_token1] = ACTIONS(1275),
    [aux_sym_implicit_statement_token3] = ACTIONS(1275),
    [aux_sym_implicit_statement_token4] = ACTIONS(1275),
    [aux_sym_save_statement_token1] = ACTIONS(1275),
    [aux_sym_private_statement_token1] = ACTIONS(1275),
    [aux_sym_public_statement_token1] = ACTIONS(1275),
    [aux_sym_namelist_statement_token1] = ACTIONS(1275),
    [aux_sym_common_statement_token1] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1277),
    [aux_sym_import_statement_token1] = ACTIONS(1275),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1275),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1275),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1275),
    [aux_sym_variable_attributes_token1] = ACTIONS(1275),
    [aux_sym_variable_attributes_token2] = ACTIONS(1275),
    [aux_sym_variable_attributes_token3] = ACTIONS(1275),
    [aux_sym_variable_attributes_token4] = ACTIONS(1275),
    [aux_sym_variable_attributes_token5] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1275),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1275),
    [aux_sym_derived_type_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token1] = ACTIONS(1275),
    [aux_sym_type_qualifier_token2] = ACTIONS(1275),
    [aux_sym_type_qualifier_token3] = ACTIONS(1275),
    [aux_sym_type_qualifier_token4] = ACTIONS(1275),
    [aux_sym_type_qualifier_token5] = ACTIONS(1275),
    [aux_sym_type_qualifier_token9] = ACTIONS(1275),
    [aux_sym_type_qualifier_token10] = ACTIONS(1275),
    [aux_sym_type_qualifier_token11] = ACTIONS(1275),
    [aux_sym_type_qualifier_token12] = ACTIONS(1275),
    [aux_sym_type_qualifier_token13] = ACTIONS(1275),
    [aux_sym_type_qualifier_token14] = ACTIONS(1275),
    [aux_sym_type_qualifier_token15] = ACTIONS(1275),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token1] = ACTIONS(1275),
    [aux_sym_stop_statement_token2] = ACTIONS(1275),
    [aux_sym_subroutine_call_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token1] = ACTIONS(1275),
    [aux_sym_keyword_statement_token2] = ACTIONS(1275),
    [aux_sym_keyword_statement_token3] = ACTIONS(1275),
    [aux_sym_keyword_statement_token4] = ACTIONS(1275),
    [aux_sym_keyword_statement_token6] = ACTIONS(1275),
    [aux_sym_keyword_statement_token7] = ACTIONS(1275),
    [aux_sym_include_statement_token1] = ACTIONS(1275),
    [aux_sym_data_statement_token1] = ACTIONS(1275),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1275),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1275),
    [aux_sym_end_if_statement_token1] = ACTIONS(1275),
    [aux_sym_elseif_clause_token2] = ACTIONS(1275),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1275),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token1] = ACTIONS(1275),
    [aux_sym_select_case_statement_token3] = ACTIONS(1275),
    [aux_sym_select_type_statement_token1] = ACTIONS(1275),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1275),
    [aux_sym_block_construct_token1] = ACTIONS(1275),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1275),
    [aux_sym_associate_statement_token1] = ACTIONS(1275),
    [aux_sym_format_statement_token1] = ACTIONS(1275),
    [aux_sym_print_statement_token1] = ACTIONS(1275),
    [aux_sym_open_statement_token1] = ACTIONS(1275),
    [aux_sym_close_statement_token1] = ACTIONS(1275),
    [aux_sym_inquire_statement_token1] = ACTIONS(1275),
    [aux_sym_enum_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token1] = ACTIONS(1275),
    [aux_sym_file_position_statement_token2] = ACTIONS(1275),
    [aux_sym_file_position_statement_token3] = ACTIONS(1275),
    [aux_sym_file_position_statement_token4] = ACTIONS(1275),
    [aux_sym_logical_expression_token5] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [sym_boolean_literal] = ACTIONS(1277),
    [aux_sym_null_literal_token1] = ACTIONS(1275),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1275),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1277),
    [sym__float_literal] = ACTIONS(1277),
    [sym__boz_literal] = ACTIONS(1277),
    [sym_string_literal] = ACTIONS(1277),
  },
  [406] = {
    [sym_preproc_file_line] = STATE(406),
    [aux_sym_end_program_statement_token1] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [aux_sym_interface_statement_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1299),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1299),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1299),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1299),
    [aux_sym_use_statement_token1] = ACTIONS(1299),
    [aux_sym_use_statement_token2] = ACTIONS(1299),
    [aux_sym_implicit_statement_token1] = ACTIONS(1299),
    [aux_sym_implicit_statement_token3] = ACTIONS(1299),
    [aux_sym_implicit_statement_token4] = ACTIONS(1299),
    [aux_sym_save_statement_token1] = ACTIONS(1299),
    [aux_sym_private_statement_token1] = ACTIONS(1299),
    [aux_sym_public_statement_token1] = ACTIONS(1299),
    [aux_sym_namelist_statement_token1] = ACTIONS(1299),
    [aux_sym_common_statement_token1] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1301),
    [aux_sym_import_statement_token1] = ACTIONS(1299),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1299),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1299),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1299),
    [aux_sym_variable_attributes_token1] = ACTIONS(1299),
    [aux_sym_variable_attributes_token2] = ACTIONS(1299),
    [aux_sym_variable_attributes_token3] = ACTIONS(1299),
    [aux_sym_variable_attributes_token4] = ACTIONS(1299),
    [aux_sym_variable_attributes_token5] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1299),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1299),
    [aux_sym_derived_type_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token1] = ACTIONS(1299),
    [aux_sym_type_qualifier_token2] = ACTIONS(1299),
    [aux_sym_type_qualifier_token3] = ACTIONS(1299),
    [aux_sym_type_qualifier_token4] = ACTIONS(1299),
    [aux_sym_type_qualifier_token5] = ACTIONS(1299),
    [aux_sym_type_qualifier_token9] = ACTIONS(1299),
    [aux_sym_type_qualifier_token10] = ACTIONS(1299),
    [aux_sym_type_qualifier_token11] = ACTIONS(1299),
    [aux_sym_type_qualifier_token12] = ACTIONS(1299),
    [aux_sym_type_qualifier_token13] = ACTIONS(1299),
    [aux_sym_type_qualifier_token14] = ACTIONS(1299),
    [aux_sym_type_qualifier_token15] = ACTIONS(1299),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token1] = ACTIONS(1299),
    [aux_sym_stop_statement_token2] = ACTIONS(1299),
    [aux_sym_subroutine_call_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token1] = ACTIONS(1299),
    [aux_sym_keyword_statement_token2] = ACTIONS(1299),
    [aux_sym_keyword_statement_token3] = ACTIONS(1299),
    [aux_sym_keyword_statement_token4] = ACTIONS(1299),
    [aux_sym_keyword_statement_token6] = ACTIONS(1299),
    [aux_sym_keyword_statement_token7] = ACTIONS(1299),
    [aux_sym_include_statement_token1] = ACTIONS(1299),
    [aux_sym_data_statement_token1] = ACTIONS(1299),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1299),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1299),
    [aux_sym_end_if_statement_token1] = ACTIONS(1299),
    [aux_sym_elseif_clause_token2] = ACTIONS(1299),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1299),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token1] = ACTIONS(1299),
    [aux_sym_select_case_statement_token3] = ACTIONS(1299),
    [aux_sym_select_type_statement_token1] = ACTIONS(1299),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1299),
    [aux_sym_block_construct_token1] = ACTIONS(1299),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1299),
    [aux_sym_associate_statement_token1] = ACTIONS(1299),
    [aux_sym_format_statement_token1] = ACTIONS(1299),
    [aux_sym_print_statement_token1] = ACTIONS(1299),
    [aux_sym_open_statement_token1] = ACTIONS(1299),
    [aux_sym_close_statement_token1] = ACTIONS(1299),
    [aux_sym_inquire_statement_token1] = ACTIONS(1299),
    [aux_sym_enum_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token1] = ACTIONS(1299),
    [aux_sym_file_position_statement_token2] = ACTIONS(1299),
    [aux_sym_file_position_statement_token3] = ACTIONS(1299),
    [aux_sym_file_position_statement_token4] = ACTIONS(1299),
    [aux_sym_logical_expression_token5] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [sym_boolean_literal] = ACTIONS(1301),
    [aux_sym_null_literal_token1] = ACTIONS(1299),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1299),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1301),
    [sym__float_literal] = ACTIONS(1301),
    [sym__boz_literal] = ACTIONS(1301),
    [sym_string_literal] = ACTIONS(1301),
  },
  [407] = {
    [sym_preproc_file_line] = STATE(407),
    [aux_sym_end_program_statement_token1] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [aux_sym_interface_statement_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1291),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1291),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1291),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1291),
    [aux_sym_use_statement_token1] = ACTIONS(1291),
    [aux_sym_use_statement_token2] = ACTIONS(1291),
    [aux_sym_implicit_statement_token1] = ACTIONS(1291),
    [aux_sym_implicit_statement_token3] = ACTIONS(1291),
    [aux_sym_implicit_statement_token4] = ACTIONS(1291),
    [aux_sym_save_statement_token1] = ACTIONS(1291),
    [aux_sym_private_statement_token1] = ACTIONS(1291),
    [aux_sym_public_statement_token1] = ACTIONS(1291),
    [aux_sym_namelist_statement_token1] = ACTIONS(1291),
    [aux_sym_common_statement_token1] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1293),
    [aux_sym_import_statement_token1] = ACTIONS(1291),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1291),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1291),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1291),
    [aux_sym_variable_attributes_token1] = ACTIONS(1291),
    [aux_sym_variable_attributes_token2] = ACTIONS(1291),
    [aux_sym_variable_attributes_token3] = ACTIONS(1291),
    [aux_sym_variable_attributes_token4] = ACTIONS(1291),
    [aux_sym_variable_attributes_token5] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1291),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1291),
    [aux_sym_derived_type_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token1] = ACTIONS(1291),
    [aux_sym_type_qualifier_token2] = ACTIONS(1291),
    [aux_sym_type_qualifier_token3] = ACTIONS(1291),
    [aux_sym_type_qualifier_token4] = ACTIONS(1291),
    [aux_sym_type_qualifier_token5] = ACTIONS(1291),
    [aux_sym_type_qualifier_token9] = ACTIONS(1291),
    [aux_sym_type_qualifier_token10] = ACTIONS(1291),
    [aux_sym_type_qualifier_token11] = ACTIONS(1291),
    [aux_sym_type_qualifier_token12] = ACTIONS(1291),
    [aux_sym_type_qualifier_token13] = ACTIONS(1291),
    [aux_sym_type_qualifier_token14] = ACTIONS(1291),
    [aux_sym_type_qualifier_token15] = ACTIONS(1291),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token1] = ACTIONS(1291),
    [aux_sym_stop_statement_token2] = ACTIONS(1291),
    [aux_sym_subroutine_call_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token1] = ACTIONS(1291),
    [aux_sym_keyword_statement_token2] = ACTIONS(1291),
    [aux_sym_keyword_statement_token3] = ACTIONS(1291),
    [aux_sym_keyword_statement_token4] = ACTIONS(1291),
    [aux_sym_keyword_statement_token6] = ACTIONS(1291),
    [aux_sym_keyword_statement_token7] = ACTIONS(1291),
    [aux_sym_include_statement_token1] = ACTIONS(1291),
    [aux_sym_data_statement_token1] = ACTIONS(1291),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1291),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1291),
    [aux_sym_end_if_statement_token1] = ACTIONS(1291),
    [aux_sym_elseif_clause_token2] = ACTIONS(1291),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1291),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token1] = ACTIONS(1291),
    [aux_sym_select_case_statement_token3] = ACTIONS(1291),
    [aux_sym_select_type_statement_token1] = ACTIONS(1291),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1291),
    [aux_sym_block_construct_token1] = ACTIONS(1291),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1291),
    [aux_sym_associate_statement_token1] = ACTIONS(1291),
    [aux_sym_format_statement_token1] = ACTIONS(1291),
    [aux_sym_print_statement_token1] = ACTIONS(1291),
    [aux_sym_open_statement_token1] = ACTIONS(1291),
    [aux_sym_close_statement_token1] = ACTIONS(1291),
    [aux_sym_inquire_statement_token1] = ACTIONS(1291),
    [aux_sym_enum_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token1] = ACTIONS(1291),
    [aux_sym_file_position_statement_token2] = ACTIONS(1291),
    [aux_sym_file_position_statement_token3] = ACTIONS(1291),
    [aux_sym_file_position_statement_token4] = ACTIONS(1291),
    [aux_sym_logical_expression_token5] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [sym_boolean_literal] = ACTIONS(1293),
    [aux_sym_null_literal_token1] = ACTIONS(1291),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1291),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1293),
    [sym__float_literal] = ACTIONS(1293),
    [sym__boz_literal] = ACTIONS(1293),
    [sym_string_literal] = ACTIONS(1293),
  },
  [408] = {
    [sym_preproc_file_line] = STATE(408),
    [aux_sym_end_program_statement_token1] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1227),
    [aux_sym_interface_statement_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1227),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1227),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1227),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1227),
    [aux_sym_use_statement_token1] = ACTIONS(1227),
    [aux_sym_use_statement_token2] = ACTIONS(1227),
    [aux_sym_implicit_statement_token1] = ACTIONS(1227),
    [aux_sym_implicit_statement_token3] = ACTIONS(1227),
    [aux_sym_implicit_statement_token4] = ACTIONS(1227),
    [aux_sym_save_statement_token1] = ACTIONS(1227),
    [aux_sym_private_statement_token1] = ACTIONS(1227),
    [aux_sym_public_statement_token1] = ACTIONS(1227),
    [aux_sym_namelist_statement_token1] = ACTIONS(1227),
    [aux_sym_common_statement_token1] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1225),
    [aux_sym_import_statement_token1] = ACTIONS(1227),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1227),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1227),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1227),
    [aux_sym_variable_attributes_token1] = ACTIONS(1227),
    [aux_sym_variable_attributes_token2] = ACTIONS(1227),
    [aux_sym_variable_attributes_token3] = ACTIONS(1227),
    [aux_sym_variable_attributes_token4] = ACTIONS(1227),
    [aux_sym_variable_attributes_token5] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1227),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1227),
    [aux_sym_derived_type_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token1] = ACTIONS(1227),
    [aux_sym_type_qualifier_token2] = ACTIONS(1227),
    [aux_sym_type_qualifier_token3] = ACTIONS(1227),
    [aux_sym_type_qualifier_token4] = ACTIONS(1227),
    [aux_sym_type_qualifier_token5] = ACTIONS(1227),
    [aux_sym_type_qualifier_token9] = ACTIONS(1227),
    [aux_sym_type_qualifier_token10] = ACTIONS(1227),
    [aux_sym_type_qualifier_token11] = ACTIONS(1227),
    [aux_sym_type_qualifier_token12] = ACTIONS(1227),
    [aux_sym_type_qualifier_token13] = ACTIONS(1227),
    [aux_sym_type_qualifier_token14] = ACTIONS(1227),
    [aux_sym_type_qualifier_token15] = ACTIONS(1227),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token1] = ACTIONS(1227),
    [aux_sym_stop_statement_token2] = ACTIONS(1227),
    [aux_sym_subroutine_call_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token1] = ACTIONS(1227),
    [aux_sym_keyword_statement_token2] = ACTIONS(1227),
    [aux_sym_keyword_statement_token3] = ACTIONS(1227),
    [aux_sym_keyword_statement_token4] = ACTIONS(1227),
    [aux_sym_keyword_statement_token6] = ACTIONS(1227),
    [aux_sym_keyword_statement_token7] = ACTIONS(1227),
    [aux_sym_include_statement_token1] = ACTIONS(1227),
    [aux_sym_data_statement_token1] = ACTIONS(1227),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1227),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1227),
    [aux_sym_end_if_statement_token1] = ACTIONS(1227),
    [aux_sym_elseif_clause_token2] = ACTIONS(1227),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1227),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token1] = ACTIONS(1227),
    [aux_sym_select_case_statement_token3] = ACTIONS(1227),
    [aux_sym_select_type_statement_token1] = ACTIONS(1227),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1227),
    [aux_sym_block_construct_token1] = ACTIONS(1227),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1227),
    [aux_sym_associate_statement_token1] = ACTIONS(1227),
    [aux_sym_format_statement_token1] = ACTIONS(1227),
    [aux_sym_print_statement_token1] = ACTIONS(1227),
    [aux_sym_open_statement_token1] = ACTIONS(1227),
    [aux_sym_close_statement_token1] = ACTIONS(1227),
    [aux_sym_inquire_statement_token1] = ACTIONS(1227),
    [aux_sym_enum_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token1] = ACTIONS(1227),
    [aux_sym_file_position_statement_token2] = ACTIONS(1227),
    [aux_sym_file_position_statement_token3] = ACTIONS(1227),
    [aux_sym_file_position_statement_token4] = ACTIONS(1227),
    [aux_sym_logical_expression_token5] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [sym_boolean_literal] = ACTIONS(1225),
    [aux_sym_null_literal_token1] = ACTIONS(1227),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1227),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1225),
    [sym__float_literal] = ACTIONS(1225),
    [sym__boz_literal] = ACTIONS(1225),
    [sym_string_literal] = ACTIONS(1225),
  },
  [409] = {
    [sym_preproc_file_line] = STATE(409),
    [aux_sym_end_program_statement_token1] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [aux_sym_interface_statement_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1235),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1235),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1235),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1235),
    [aux_sym_use_statement_token1] = ACTIONS(1235),
    [aux_sym_use_statement_token2] = ACTIONS(1235),
    [aux_sym_implicit_statement_token1] = ACTIONS(1235),
    [aux_sym_implicit_statement_token3] = ACTIONS(1235),
    [aux_sym_implicit_statement_token4] = ACTIONS(1235),
    [aux_sym_save_statement_token1] = ACTIONS(1235),
    [aux_sym_private_statement_token1] = ACTIONS(1235),
    [aux_sym_public_statement_token1] = ACTIONS(1235),
    [aux_sym_namelist_statement_token1] = ACTIONS(1235),
    [aux_sym_common_statement_token1] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [aux_sym_import_statement_token1] = ACTIONS(1235),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1235),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1235),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1235),
    [aux_sym_variable_attributes_token1] = ACTIONS(1235),
    [aux_sym_variable_attributes_token2] = ACTIONS(1235),
    [aux_sym_variable_attributes_token3] = ACTIONS(1235),
    [aux_sym_variable_attributes_token4] = ACTIONS(1235),
    [aux_sym_variable_attributes_token5] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1235),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1235),
    [aux_sym_derived_type_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token1] = ACTIONS(1235),
    [aux_sym_type_qualifier_token2] = ACTIONS(1235),
    [aux_sym_type_qualifier_token3] = ACTIONS(1235),
    [aux_sym_type_qualifier_token4] = ACTIONS(1235),
    [aux_sym_type_qualifier_token5] = ACTIONS(1235),
    [aux_sym_type_qualifier_token9] = ACTIONS(1235),
    [aux_sym_type_qualifier_token10] = ACTIONS(1235),
    [aux_sym_type_qualifier_token11] = ACTIONS(1235),
    [aux_sym_type_qualifier_token12] = ACTIONS(1235),
    [aux_sym_type_qualifier_token13] = ACTIONS(1235),
    [aux_sym_type_qualifier_token14] = ACTIONS(1235),
    [aux_sym_type_qualifier_token15] = ACTIONS(1235),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token1] = ACTIONS(1235),
    [aux_sym_stop_statement_token2] = ACTIONS(1235),
    [aux_sym_subroutine_call_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token1] = ACTIONS(1235),
    [aux_sym_keyword_statement_token2] = ACTIONS(1235),
    [aux_sym_keyword_statement_token3] = ACTIONS(1235),
    [aux_sym_keyword_statement_token4] = ACTIONS(1235),
    [aux_sym_keyword_statement_token6] = ACTIONS(1235),
    [aux_sym_keyword_statement_token7] = ACTIONS(1235),
    [aux_sym_include_statement_token1] = ACTIONS(1235),
    [aux_sym_data_statement_token1] = ACTIONS(1235),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1235),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1235),
    [aux_sym_end_if_statement_token1] = ACTIONS(1235),
    [aux_sym_elseif_clause_token2] = ACTIONS(1235),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1235),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token1] = ACTIONS(1235),
    [aux_sym_select_case_statement_token3] = ACTIONS(1235),
    [aux_sym_select_type_statement_token1] = ACTIONS(1235),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1235),
    [aux_sym_block_construct_token1] = ACTIONS(1235),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1235),
    [aux_sym_associate_statement_token1] = ACTIONS(1235),
    [aux_sym_format_statement_token1] = ACTIONS(1235),
    [aux_sym_print_statement_token1] = ACTIONS(1235),
    [aux_sym_open_statement_token1] = ACTIONS(1235),
    [aux_sym_close_statement_token1] = ACTIONS(1235),
    [aux_sym_inquire_statement_token1] = ACTIONS(1235),
    [aux_sym_enum_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token1] = ACTIONS(1235),
    [aux_sym_file_position_statement_token2] = ACTIONS(1235),
    [aux_sym_file_position_statement_token3] = ACTIONS(1235),
    [aux_sym_file_position_statement_token4] = ACTIONS(1235),
    [aux_sym_logical_expression_token5] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_boolean_literal] = ACTIONS(1233),
    [aux_sym_null_literal_token1] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1235),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1233),
    [sym__float_literal] = ACTIONS(1233),
    [sym__boz_literal] = ACTIONS(1233),
    [sym_string_literal] = ACTIONS(1233),
  },
  [410] = {
    [sym_preproc_file_line] = STATE(410),
    [aux_sym_end_program_statement_token1] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [aux_sym_interface_statement_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1303),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1303),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1303),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1303),
    [aux_sym_use_statement_token1] = ACTIONS(1303),
    [aux_sym_use_statement_token2] = ACTIONS(1303),
    [aux_sym_implicit_statement_token1] = ACTIONS(1303),
    [aux_sym_implicit_statement_token3] = ACTIONS(1303),
    [aux_sym_implicit_statement_token4] = ACTIONS(1303),
    [aux_sym_save_statement_token1] = ACTIONS(1303),
    [aux_sym_private_statement_token1] = ACTIONS(1303),
    [aux_sym_public_statement_token1] = ACTIONS(1303),
    [aux_sym_namelist_statement_token1] = ACTIONS(1303),
    [aux_sym_common_statement_token1] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1305),
    [aux_sym_import_statement_token1] = ACTIONS(1303),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1303),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1303),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1303),
    [aux_sym_variable_attributes_token1] = ACTIONS(1303),
    [aux_sym_variable_attributes_token2] = ACTIONS(1303),
    [aux_sym_variable_attributes_token3] = ACTIONS(1303),
    [aux_sym_variable_attributes_token4] = ACTIONS(1303),
    [aux_sym_variable_attributes_token5] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1303),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1303),
    [aux_sym_derived_type_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token1] = ACTIONS(1303),
    [aux_sym_type_qualifier_token2] = ACTIONS(1303),
    [aux_sym_type_qualifier_token3] = ACTIONS(1303),
    [aux_sym_type_qualifier_token4] = ACTIONS(1303),
    [aux_sym_type_qualifier_token5] = ACTIONS(1303),
    [aux_sym_type_qualifier_token9] = ACTIONS(1303),
    [aux_sym_type_qualifier_token10] = ACTIONS(1303),
    [aux_sym_type_qualifier_token11] = ACTIONS(1303),
    [aux_sym_type_qualifier_token12] = ACTIONS(1303),
    [aux_sym_type_qualifier_token13] = ACTIONS(1303),
    [aux_sym_type_qualifier_token14] = ACTIONS(1303),
    [aux_sym_type_qualifier_token15] = ACTIONS(1303),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token1] = ACTIONS(1303),
    [aux_sym_stop_statement_token2] = ACTIONS(1303),
    [aux_sym_subroutine_call_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token1] = ACTIONS(1303),
    [aux_sym_keyword_statement_token2] = ACTIONS(1303),
    [aux_sym_keyword_statement_token3] = ACTIONS(1303),
    [aux_sym_keyword_statement_token4] = ACTIONS(1303),
    [aux_sym_keyword_statement_token6] = ACTIONS(1303),
    [aux_sym_keyword_statement_token7] = ACTIONS(1303),
    [aux_sym_include_statement_token1] = ACTIONS(1303),
    [aux_sym_data_statement_token1] = ACTIONS(1303),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1303),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1303),
    [aux_sym_end_if_statement_token1] = ACTIONS(1303),
    [aux_sym_elseif_clause_token2] = ACTIONS(1303),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1303),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token1] = ACTIONS(1303),
    [aux_sym_select_case_statement_token3] = ACTIONS(1303),
    [aux_sym_select_type_statement_token1] = ACTIONS(1303),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1303),
    [aux_sym_block_construct_token1] = ACTIONS(1303),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1303),
    [aux_sym_associate_statement_token1] = ACTIONS(1303),
    [aux_sym_format_statement_token1] = ACTIONS(1303),
    [aux_sym_print_statement_token1] = ACTIONS(1303),
    [aux_sym_open_statement_token1] = ACTIONS(1303),
    [aux_sym_close_statement_token1] = ACTIONS(1303),
    [aux_sym_inquire_statement_token1] = ACTIONS(1303),
    [aux_sym_enum_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token1] = ACTIONS(1303),
    [aux_sym_file_position_statement_token2] = ACTIONS(1303),
    [aux_sym_file_position_statement_token3] = ACTIONS(1303),
    [aux_sym_file_position_statement_token4] = ACTIONS(1303),
    [aux_sym_logical_expression_token5] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_boolean_literal] = ACTIONS(1305),
    [aux_sym_null_literal_token1] = ACTIONS(1303),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1303),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1305),
    [sym__float_literal] = ACTIONS(1305),
    [sym__boz_literal] = ACTIONS(1305),
    [sym_string_literal] = ACTIONS(1305),
  },
  [411] = {
    [sym_preproc_file_line] = STATE(411),
    [aux_sym_end_program_statement_token1] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [aux_sym_interface_statement_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1307),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1307),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1307),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1307),
    [aux_sym_use_statement_token1] = ACTIONS(1307),
    [aux_sym_use_statement_token2] = ACTIONS(1307),
    [aux_sym_implicit_statement_token1] = ACTIONS(1307),
    [aux_sym_implicit_statement_token3] = ACTIONS(1307),
    [aux_sym_implicit_statement_token4] = ACTIONS(1307),
    [aux_sym_save_statement_token1] = ACTIONS(1307),
    [aux_sym_private_statement_token1] = ACTIONS(1307),
    [aux_sym_public_statement_token1] = ACTIONS(1307),
    [aux_sym_namelist_statement_token1] = ACTIONS(1307),
    [aux_sym_common_statement_token1] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1309),
    [aux_sym_import_statement_token1] = ACTIONS(1307),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1307),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1307),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1307),
    [aux_sym_variable_attributes_token1] = ACTIONS(1307),
    [aux_sym_variable_attributes_token2] = ACTIONS(1307),
    [aux_sym_variable_attributes_token3] = ACTIONS(1307),
    [aux_sym_variable_attributes_token4] = ACTIONS(1307),
    [aux_sym_variable_attributes_token5] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1307),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1307),
    [aux_sym_derived_type_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token1] = ACTIONS(1307),
    [aux_sym_type_qualifier_token2] = ACTIONS(1307),
    [aux_sym_type_qualifier_token3] = ACTIONS(1307),
    [aux_sym_type_qualifier_token4] = ACTIONS(1307),
    [aux_sym_type_qualifier_token5] = ACTIONS(1307),
    [aux_sym_type_qualifier_token9] = ACTIONS(1307),
    [aux_sym_type_qualifier_token10] = ACTIONS(1307),
    [aux_sym_type_qualifier_token11] = ACTIONS(1307),
    [aux_sym_type_qualifier_token12] = ACTIONS(1307),
    [aux_sym_type_qualifier_token13] = ACTIONS(1307),
    [aux_sym_type_qualifier_token14] = ACTIONS(1307),
    [aux_sym_type_qualifier_token15] = ACTIONS(1307),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token1] = ACTIONS(1307),
    [aux_sym_stop_statement_token2] = ACTIONS(1307),
    [aux_sym_subroutine_call_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token1] = ACTIONS(1307),
    [aux_sym_keyword_statement_token2] = ACTIONS(1307),
    [aux_sym_keyword_statement_token3] = ACTIONS(1307),
    [aux_sym_keyword_statement_token4] = ACTIONS(1307),
    [aux_sym_keyword_statement_token6] = ACTIONS(1307),
    [aux_sym_keyword_statement_token7] = ACTIONS(1307),
    [aux_sym_include_statement_token1] = ACTIONS(1307),
    [aux_sym_data_statement_token1] = ACTIONS(1307),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1307),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1307),
    [aux_sym_end_if_statement_token1] = ACTIONS(1307),
    [aux_sym_elseif_clause_token2] = ACTIONS(1307),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1307),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token1] = ACTIONS(1307),
    [aux_sym_select_case_statement_token3] = ACTIONS(1307),
    [aux_sym_select_type_statement_token1] = ACTIONS(1307),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1307),
    [aux_sym_block_construct_token1] = ACTIONS(1307),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1307),
    [aux_sym_associate_statement_token1] = ACTIONS(1307),
    [aux_sym_format_statement_token1] = ACTIONS(1307),
    [aux_sym_print_statement_token1] = ACTIONS(1307),
    [aux_sym_open_statement_token1] = ACTIONS(1307),
    [aux_sym_close_statement_token1] = ACTIONS(1307),
    [aux_sym_inquire_statement_token1] = ACTIONS(1307),
    [aux_sym_enum_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token1] = ACTIONS(1307),
    [aux_sym_file_position_statement_token2] = ACTIONS(1307),
    [aux_sym_file_position_statement_token3] = ACTIONS(1307),
    [aux_sym_file_position_statement_token4] = ACTIONS(1307),
    [aux_sym_logical_expression_token5] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [sym_boolean_literal] = ACTIONS(1309),
    [aux_sym_null_literal_token1] = ACTIONS(1307),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1307),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1309),
    [sym__float_literal] = ACTIONS(1309),
    [sym__boz_literal] = ACTIONS(1309),
    [sym_string_literal] = ACTIONS(1309),
  },
  [412] = {
    [sym_preproc_file_line] = STATE(412),
    [aux_sym_end_program_statement_token1] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [aux_sym_interface_statement_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1311),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1311),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1311),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1311),
    [aux_sym_use_statement_token1] = ACTIONS(1311),
    [aux_sym_use_statement_token2] = ACTIONS(1311),
    [aux_sym_implicit_statement_token1] = ACTIONS(1311),
    [aux_sym_implicit_statement_token3] = ACTIONS(1311),
    [aux_sym_implicit_statement_token4] = ACTIONS(1311),
    [aux_sym_save_statement_token1] = ACTIONS(1311),
    [aux_sym_private_statement_token1] = ACTIONS(1311),
    [aux_sym_public_statement_token1] = ACTIONS(1311),
    [aux_sym_namelist_statement_token1] = ACTIONS(1311),
    [aux_sym_common_statement_token1] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1313),
    [aux_sym_import_statement_token1] = ACTIONS(1311),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1311),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1311),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1311),
    [aux_sym_variable_attributes_token1] = ACTIONS(1311),
    [aux_sym_variable_attributes_token2] = ACTIONS(1311),
    [aux_sym_variable_attributes_token3] = ACTIONS(1311),
    [aux_sym_variable_attributes_token4] = ACTIONS(1311),
    [aux_sym_variable_attributes_token5] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1311),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1311),
    [aux_sym_derived_type_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token1] = ACTIONS(1311),
    [aux_sym_type_qualifier_token2] = ACTIONS(1311),
    [aux_sym_type_qualifier_token3] = ACTIONS(1311),
    [aux_sym_type_qualifier_token4] = ACTIONS(1311),
    [aux_sym_type_qualifier_token5] = ACTIONS(1311),
    [aux_sym_type_qualifier_token9] = ACTIONS(1311),
    [aux_sym_type_qualifier_token10] = ACTIONS(1311),
    [aux_sym_type_qualifier_token11] = ACTIONS(1311),
    [aux_sym_type_qualifier_token12] = ACTIONS(1311),
    [aux_sym_type_qualifier_token13] = ACTIONS(1311),
    [aux_sym_type_qualifier_token14] = ACTIONS(1311),
    [aux_sym_type_qualifier_token15] = ACTIONS(1311),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token1] = ACTIONS(1311),
    [aux_sym_stop_statement_token2] = ACTIONS(1311),
    [aux_sym_subroutine_call_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token1] = ACTIONS(1311),
    [aux_sym_keyword_statement_token2] = ACTIONS(1311),
    [aux_sym_keyword_statement_token3] = ACTIONS(1311),
    [aux_sym_keyword_statement_token4] = ACTIONS(1311),
    [aux_sym_keyword_statement_token6] = ACTIONS(1311),
    [aux_sym_keyword_statement_token7] = ACTIONS(1311),
    [aux_sym_include_statement_token1] = ACTIONS(1311),
    [aux_sym_data_statement_token1] = ACTIONS(1311),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1311),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1311),
    [aux_sym_end_if_statement_token1] = ACTIONS(1311),
    [aux_sym_elseif_clause_token2] = ACTIONS(1311),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1311),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token1] = ACTIONS(1311),
    [aux_sym_select_case_statement_token3] = ACTIONS(1311),
    [aux_sym_select_type_statement_token1] = ACTIONS(1311),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1311),
    [aux_sym_block_construct_token1] = ACTIONS(1311),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1311),
    [aux_sym_associate_statement_token1] = ACTIONS(1311),
    [aux_sym_format_statement_token1] = ACTIONS(1311),
    [aux_sym_print_statement_token1] = ACTIONS(1311),
    [aux_sym_open_statement_token1] = ACTIONS(1311),
    [aux_sym_close_statement_token1] = ACTIONS(1311),
    [aux_sym_inquire_statement_token1] = ACTIONS(1311),
    [aux_sym_enum_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token1] = ACTIONS(1311),
    [aux_sym_file_position_statement_token2] = ACTIONS(1311),
    [aux_sym_file_position_statement_token3] = ACTIONS(1311),
    [aux_sym_file_position_statement_token4] = ACTIONS(1311),
    [aux_sym_logical_expression_token5] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1313),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [sym_boolean_literal] = ACTIONS(1313),
    [aux_sym_null_literal_token1] = ACTIONS(1311),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1311),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1313),
    [sym__float_literal] = ACTIONS(1313),
    [sym__boz_literal] = ACTIONS(1313),
    [sym_string_literal] = ACTIONS(1313),
  },
  [413] = {
    [sym_preproc_file_line] = STATE(413),
    [aux_sym_end_program_statement_token1] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [aux_sym_interface_statement_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1315),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1315),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1315),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1315),
    [aux_sym_use_statement_token1] = ACTIONS(1315),
    [aux_sym_use_statement_token2] = ACTIONS(1315),
    [aux_sym_implicit_statement_token1] = ACTIONS(1315),
    [aux_sym_implicit_statement_token3] = ACTIONS(1315),
    [aux_sym_implicit_statement_token4] = ACTIONS(1315),
    [aux_sym_save_statement_token1] = ACTIONS(1315),
    [aux_sym_private_statement_token1] = ACTIONS(1315),
    [aux_sym_public_statement_token1] = ACTIONS(1315),
    [aux_sym_namelist_statement_token1] = ACTIONS(1315),
    [aux_sym_common_statement_token1] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1317),
    [aux_sym_import_statement_token1] = ACTIONS(1315),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1315),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1315),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1315),
    [aux_sym_variable_attributes_token1] = ACTIONS(1315),
    [aux_sym_variable_attributes_token2] = ACTIONS(1315),
    [aux_sym_variable_attributes_token3] = ACTIONS(1315),
    [aux_sym_variable_attributes_token4] = ACTIONS(1315),
    [aux_sym_variable_attributes_token5] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1315),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1315),
    [aux_sym_derived_type_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token1] = ACTIONS(1315),
    [aux_sym_type_qualifier_token2] = ACTIONS(1315),
    [aux_sym_type_qualifier_token3] = ACTIONS(1315),
    [aux_sym_type_qualifier_token4] = ACTIONS(1315),
    [aux_sym_type_qualifier_token5] = ACTIONS(1315),
    [aux_sym_type_qualifier_token9] = ACTIONS(1315),
    [aux_sym_type_qualifier_token10] = ACTIONS(1315),
    [aux_sym_type_qualifier_token11] = ACTIONS(1315),
    [aux_sym_type_qualifier_token12] = ACTIONS(1315),
    [aux_sym_type_qualifier_token13] = ACTIONS(1315),
    [aux_sym_type_qualifier_token14] = ACTIONS(1315),
    [aux_sym_type_qualifier_token15] = ACTIONS(1315),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token1] = ACTIONS(1315),
    [aux_sym_stop_statement_token2] = ACTIONS(1315),
    [aux_sym_subroutine_call_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token1] = ACTIONS(1315),
    [aux_sym_keyword_statement_token2] = ACTIONS(1315),
    [aux_sym_keyword_statement_token3] = ACTIONS(1315),
    [aux_sym_keyword_statement_token4] = ACTIONS(1315),
    [aux_sym_keyword_statement_token6] = ACTIONS(1315),
    [aux_sym_keyword_statement_token7] = ACTIONS(1315),
    [aux_sym_include_statement_token1] = ACTIONS(1315),
    [aux_sym_data_statement_token1] = ACTIONS(1315),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1315),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1315),
    [aux_sym_end_if_statement_token1] = ACTIONS(1315),
    [aux_sym_elseif_clause_token2] = ACTIONS(1315),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1315),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token1] = ACTIONS(1315),
    [aux_sym_select_case_statement_token3] = ACTIONS(1315),
    [aux_sym_select_type_statement_token1] = ACTIONS(1315),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1315),
    [aux_sym_block_construct_token1] = ACTIONS(1315),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1315),
    [aux_sym_associate_statement_token1] = ACTIONS(1315),
    [aux_sym_format_statement_token1] = ACTIONS(1315),
    [aux_sym_print_statement_token1] = ACTIONS(1315),
    [aux_sym_open_statement_token1] = ACTIONS(1315),
    [aux_sym_close_statement_token1] = ACTIONS(1315),
    [aux_sym_inquire_statement_token1] = ACTIONS(1315),
    [aux_sym_enum_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token1] = ACTIONS(1315),
    [aux_sym_file_position_statement_token2] = ACTIONS(1315),
    [aux_sym_file_position_statement_token3] = ACTIONS(1315),
    [aux_sym_file_position_statement_token4] = ACTIONS(1315),
    [aux_sym_logical_expression_token5] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1315),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [sym_boolean_literal] = ACTIONS(1317),
    [aux_sym_null_literal_token1] = ACTIONS(1315),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1315),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1317),
    [sym__float_literal] = ACTIONS(1317),
    [sym__boz_literal] = ACTIONS(1317),
    [sym_string_literal] = ACTIONS(1317),
  },
  [414] = {
    [sym_preproc_file_line] = STATE(414),
    [aux_sym_end_program_statement_token1] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1279),
    [aux_sym_interface_statement_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1279),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1279),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1279),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1279),
    [aux_sym_use_statement_token1] = ACTIONS(1279),
    [aux_sym_use_statement_token2] = ACTIONS(1279),
    [aux_sym_implicit_statement_token1] = ACTIONS(1279),
    [aux_sym_implicit_statement_token3] = ACTIONS(1279),
    [aux_sym_implicit_statement_token4] = ACTIONS(1279),
    [aux_sym_save_statement_token1] = ACTIONS(1279),
    [aux_sym_private_statement_token1] = ACTIONS(1279),
    [aux_sym_public_statement_token1] = ACTIONS(1279),
    [aux_sym_namelist_statement_token1] = ACTIONS(1279),
    [aux_sym_common_statement_token1] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1281),
    [aux_sym_import_statement_token1] = ACTIONS(1279),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1279),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1279),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1279),
    [aux_sym_variable_attributes_token1] = ACTIONS(1279),
    [aux_sym_variable_attributes_token2] = ACTIONS(1279),
    [aux_sym_variable_attributes_token3] = ACTIONS(1279),
    [aux_sym_variable_attributes_token4] = ACTIONS(1279),
    [aux_sym_variable_attributes_token5] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1279),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1279),
    [aux_sym_derived_type_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token1] = ACTIONS(1279),
    [aux_sym_type_qualifier_token2] = ACTIONS(1279),
    [aux_sym_type_qualifier_token3] = ACTIONS(1279),
    [aux_sym_type_qualifier_token4] = ACTIONS(1279),
    [aux_sym_type_qualifier_token5] = ACTIONS(1279),
    [aux_sym_type_qualifier_token9] = ACTIONS(1279),
    [aux_sym_type_qualifier_token10] = ACTIONS(1279),
    [aux_sym_type_qualifier_token11] = ACTIONS(1279),
    [aux_sym_type_qualifier_token12] = ACTIONS(1279),
    [aux_sym_type_qualifier_token13] = ACTIONS(1279),
    [aux_sym_type_qualifier_token14] = ACTIONS(1279),
    [aux_sym_type_qualifier_token15] = ACTIONS(1279),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token1] = ACTIONS(1279),
    [aux_sym_stop_statement_token2] = ACTIONS(1279),
    [aux_sym_subroutine_call_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token1] = ACTIONS(1279),
    [aux_sym_keyword_statement_token2] = ACTIONS(1279),
    [aux_sym_keyword_statement_token3] = ACTIONS(1279),
    [aux_sym_keyword_statement_token4] = ACTIONS(1279),
    [aux_sym_keyword_statement_token6] = ACTIONS(1279),
    [aux_sym_keyword_statement_token7] = ACTIONS(1279),
    [aux_sym_include_statement_token1] = ACTIONS(1279),
    [aux_sym_data_statement_token1] = ACTIONS(1279),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1279),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1279),
    [aux_sym_end_if_statement_token1] = ACTIONS(1279),
    [aux_sym_elseif_clause_token2] = ACTIONS(1279),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1279),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token1] = ACTIONS(1279),
    [aux_sym_select_case_statement_token3] = ACTIONS(1279),
    [aux_sym_select_type_statement_token1] = ACTIONS(1279),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1279),
    [aux_sym_block_construct_token1] = ACTIONS(1279),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1279),
    [aux_sym_associate_statement_token1] = ACTIONS(1279),
    [aux_sym_format_statement_token1] = ACTIONS(1279),
    [aux_sym_print_statement_token1] = ACTIONS(1279),
    [aux_sym_open_statement_token1] = ACTIONS(1279),
    [aux_sym_close_statement_token1] = ACTIONS(1279),
    [aux_sym_inquire_statement_token1] = ACTIONS(1279),
    [aux_sym_enum_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token1] = ACTIONS(1279),
    [aux_sym_file_position_statement_token2] = ACTIONS(1279),
    [aux_sym_file_position_statement_token3] = ACTIONS(1279),
    [aux_sym_file_position_statement_token4] = ACTIONS(1279),
    [aux_sym_logical_expression_token5] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [sym_boolean_literal] = ACTIONS(1281),
    [aux_sym_null_literal_token1] = ACTIONS(1279),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1279),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1281),
    [sym__float_literal] = ACTIONS(1281),
    [sym__boz_literal] = ACTIONS(1281),
    [sym_string_literal] = ACTIONS(1281),
  },
  [415] = {
    [sym_preproc_file_line] = STATE(415),
    [aux_sym_end_program_statement_token1] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [aux_sym_interface_statement_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1283),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1283),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1283),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1283),
    [aux_sym_use_statement_token1] = ACTIONS(1283),
    [aux_sym_use_statement_token2] = ACTIONS(1283),
    [aux_sym_implicit_statement_token1] = ACTIONS(1283),
    [aux_sym_implicit_statement_token3] = ACTIONS(1283),
    [aux_sym_implicit_statement_token4] = ACTIONS(1283),
    [aux_sym_save_statement_token1] = ACTIONS(1283),
    [aux_sym_private_statement_token1] = ACTIONS(1283),
    [aux_sym_public_statement_token1] = ACTIONS(1283),
    [aux_sym_namelist_statement_token1] = ACTIONS(1283),
    [aux_sym_common_statement_token1] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1285),
    [aux_sym_import_statement_token1] = ACTIONS(1283),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1283),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1283),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1283),
    [aux_sym_variable_attributes_token1] = ACTIONS(1283),
    [aux_sym_variable_attributes_token2] = ACTIONS(1283),
    [aux_sym_variable_attributes_token3] = ACTIONS(1283),
    [aux_sym_variable_attributes_token4] = ACTIONS(1283),
    [aux_sym_variable_attributes_token5] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1283),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1283),
    [aux_sym_derived_type_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token1] = ACTIONS(1283),
    [aux_sym_type_qualifier_token2] = ACTIONS(1283),
    [aux_sym_type_qualifier_token3] = ACTIONS(1283),
    [aux_sym_type_qualifier_token4] = ACTIONS(1283),
    [aux_sym_type_qualifier_token5] = ACTIONS(1283),
    [aux_sym_type_qualifier_token9] = ACTIONS(1283),
    [aux_sym_type_qualifier_token10] = ACTIONS(1283),
    [aux_sym_type_qualifier_token11] = ACTIONS(1283),
    [aux_sym_type_qualifier_token12] = ACTIONS(1283),
    [aux_sym_type_qualifier_token13] = ACTIONS(1283),
    [aux_sym_type_qualifier_token14] = ACTIONS(1283),
    [aux_sym_type_qualifier_token15] = ACTIONS(1283),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token1] = ACTIONS(1283),
    [aux_sym_stop_statement_token2] = ACTIONS(1283),
    [aux_sym_subroutine_call_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token1] = ACTIONS(1283),
    [aux_sym_keyword_statement_token2] = ACTIONS(1283),
    [aux_sym_keyword_statement_token3] = ACTIONS(1283),
    [aux_sym_keyword_statement_token4] = ACTIONS(1283),
    [aux_sym_keyword_statement_token6] = ACTIONS(1283),
    [aux_sym_keyword_statement_token7] = ACTIONS(1283),
    [aux_sym_include_statement_token1] = ACTIONS(1283),
    [aux_sym_data_statement_token1] = ACTIONS(1283),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1283),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1283),
    [aux_sym_end_if_statement_token1] = ACTIONS(1283),
    [aux_sym_elseif_clause_token2] = ACTIONS(1283),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1283),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token1] = ACTIONS(1283),
    [aux_sym_select_case_statement_token3] = ACTIONS(1283),
    [aux_sym_select_type_statement_token1] = ACTIONS(1283),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1283),
    [aux_sym_block_construct_token1] = ACTIONS(1283),
    [aux_sym_end_block_construct_statement_token1] = ACTIONS(1283),
    [aux_sym_associate_statement_token1] = ACTIONS(1283),
    [aux_sym_format_statement_token1] = ACTIONS(1283),
    [aux_sym_print_statement_token1] = ACTIONS(1283),
    [aux_sym_open_statement_token1] = ACTIONS(1283),
    [aux_sym_close_statement_token1] = ACTIONS(1283),
    [aux_sym_inquire_statement_token1] = ACTIONS(1283),
    [aux_sym_enum_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token1] = ACTIONS(1283),
    [aux_sym_file_position_statement_token2] = ACTIONS(1283),
    [aux_sym_file_position_statement_token3] = ACTIONS(1283),
    [aux_sym_file_position_statement_token4] = ACTIONS(1283),
    [aux_sym_logical_expression_token5] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [sym_boolean_literal] = ACTIONS(1285),
    [aux_sym_null_literal_token1] = ACTIONS(1283),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1283),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1285),
    [sym__float_literal] = ACTIONS(1285),
    [sym__boz_literal] = ACTIONS(1285),
    [sym_string_literal] = ACTIONS(1285),
  },
  [416] = {
    [sym_end_module_statement] = STATE(263),
    [sym_interface] = STATE(629),
    [sym_interface_statement] = STATE(766),
    [sym_internal_procedures] = STATE(2012),
    [sym_contains_statement] = STATE(2638),
    [sym__specification_part] = STATE(628),
    [sym_use_statement] = STATE(2643),
    [sym_implicit_statement] = STATE(2643),
    [sym_save_statement] = STATE(2643),
    [sym_private_statement] = STATE(2643),
    [sym_public_statement] = STATE(2643),
    [sym_namelist_statement] = STATE(2643),
    [sym_common_statement] = STATE(2643),
    [sym_import_statement] = STATE(2643),
    [sym_derived_type_definition] = STATE(629),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(928),
    [sym_variable_declaration] = STATE(2643),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2643),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2643),
    [sym_equivalence_statement] = STATE(2643),
    [sym_statement_label] = STATE(2017),
    [sym_include_statement] = STATE(2643),
    [sym_data_statement] = STATE(2643),
    [sym_enum] = STATE(629),
    [sym_enum_statement] = STATE(1848),
    [sym_preproc_file_line] = STATE(416),
    [aux_sym_program_repeat1] = STATE(419),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(1367),
    [aux_sym_end_module_statement_token1] = ACTIONS(1369),
    [aux_sym_interface_statement_token1] = ACTIONS(1371),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1373),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1375),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1377),
    [aux_sym_contains_statement_token1] = ACTIONS(1379),
    [aux_sym_use_statement_token1] = ACTIONS(1381),
    [aux_sym_use_statement_token2] = ACTIONS(1377),
    [aux_sym_implicit_statement_token1] = ACTIONS(1383),
    [aux_sym_implicit_statement_token3] = ACTIONS(1385),
    [aux_sym_implicit_statement_token4] = ACTIONS(1377),
    [aux_sym_save_statement_token1] = ACTIONS(1387),
    [aux_sym_private_statement_token1] = ACTIONS(1389),
    [aux_sym_public_statement_token1] = ACTIONS(1391),
    [aux_sym_namelist_statement_token1] = ACTIONS(1393),
    [aux_sym_common_statement_token1] = ACTIONS(1395),
    [aux_sym_import_statement_token1] = ACTIONS(1397),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1399),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1401),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1377),
    [aux_sym_variable_attributes_token1] = ACTIONS(1377),
    [aux_sym_variable_attributes_token2] = ACTIONS(1377),
    [aux_sym_variable_attributes_token3] = ACTIONS(1377),
    [aux_sym_variable_attributes_token4] = ACTIONS(1377),
    [aux_sym_variable_attributes_token5] = ACTIONS(1377),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1405),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1407),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1403),
    [aux_sym_derived_type_token1] = ACTIONS(1409),
    [aux_sym_type_qualifier_token1] = ACTIONS(1377),
    [aux_sym_type_qualifier_token2] = ACTIONS(1377),
    [aux_sym_type_qualifier_token3] = ACTIONS(1411),
    [aux_sym_type_qualifier_token4] = ACTIONS(1377),
    [aux_sym_type_qualifier_token5] = ACTIONS(1413),
    [aux_sym_type_qualifier_token9] = ACTIONS(1377),
    [aux_sym_type_qualifier_token10] = ACTIONS(1415),
    [aux_sym_type_qualifier_token11] = ACTIONS(1377),
    [aux_sym_type_qualifier_token12] = ACTIONS(1377),
    [aux_sym_type_qualifier_token13] = ACTIONS(1377),
    [aux_sym_type_qualifier_token14] = ACTIONS(1377),
    [aux_sym_type_qualifier_token15] = ACTIONS(1377),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1417),
    [aux_sym_include_statement_token1] = ACTIONS(1419),
    [aux_sym_data_statement_token1] = ACTIONS(1421),
    [aux_sym_enum_statement_token1] = ACTIONS(1423),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1425),
  },
  [417] = {
    [sym_end_submodule_statement] = STATE(265),
    [sym_interface] = STATE(648),
    [sym_interface_statement] = STATE(763),
    [sym_internal_procedures] = STATE(2050),
    [sym_contains_statement] = STATE(2381),
    [sym__specification_part] = STATE(606),
    [sym_use_statement] = STATE(2382),
    [sym_implicit_statement] = STATE(2382),
    [sym_save_statement] = STATE(2382),
    [sym_private_statement] = STATE(2382),
    [sym_public_statement] = STATE(2382),
    [sym_namelist_statement] = STATE(2382),
    [sym_common_statement] = STATE(2382),
    [sym_import_statement] = STATE(2382),
    [sym_derived_type_definition] = STATE(648),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(994),
    [sym_variable_declaration] = STATE(2382),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2382),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2382),
    [sym_equivalence_statement] = STATE(2382),
    [sym_statement_label] = STATE(2217),
    [sym_include_statement] = STATE(2382),
    [sym_data_statement] = STATE(2382),
    [sym_enum] = STATE(648),
    [sym_enum_statement] = STATE(1854),
    [sym_preproc_file_line] = STATE(417),
    [aux_sym_program_repeat1] = STATE(418),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(1427),
    [aux_sym_end_submodule_statement_token1] = ACTIONS(1429),
    [aux_sym_interface_statement_token1] = ACTIONS(1371),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1373),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1375),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1377),
    [aux_sym_contains_statement_token1] = ACTIONS(1379),
    [aux_sym_use_statement_token1] = ACTIONS(1381),
    [aux_sym_use_statement_token2] = ACTIONS(1377),
    [aux_sym_implicit_statement_token1] = ACTIONS(1383),
    [aux_sym_implicit_statement_token3] = ACTIONS(1385),
    [aux_sym_implicit_statement_token4] = ACTIONS(1377),
    [aux_sym_save_statement_token1] = ACTIONS(1387),
    [aux_sym_private_statement_token1] = ACTIONS(1389),
    [aux_sym_public_statement_token1] = ACTIONS(1391),
    [aux_sym_namelist_statement_token1] = ACTIONS(1393),
    [aux_sym_common_statement_token1] = ACTIONS(1395),
    [aux_sym_import_statement_token1] = ACTIONS(1397),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1399),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1401),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1377),
    [aux_sym_variable_attributes_token1] = ACTIONS(1377),
    [aux_sym_variable_attributes_token2] = ACTIONS(1377),
    [aux_sym_variable_attributes_token3] = ACTIONS(1377),
    [aux_sym_variable_attributes_token4] = ACTIONS(1377),
    [aux_sym_variable_attributes_token5] = ACTIONS(1377),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1405),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1407),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1403),
    [aux_sym_derived_type_token1] = ACTIONS(1409),
    [aux_sym_type_qualifier_token1] = ACTIONS(1377),
    [aux_sym_type_qualifier_token2] = ACTIONS(1377),
    [aux_sym_type_qualifier_token3] = ACTIONS(1411),
    [aux_sym_type_qualifier_token4] = ACTIONS(1377),
    [aux_sym_type_qualifier_token5] = ACTIONS(1413),
    [aux_sym_type_qualifier_token9] = ACTIONS(1377),
    [aux_sym_type_qualifier_token10] = ACTIONS(1415),
    [aux_sym_type_qualifier_token11] = ACTIONS(1377),
    [aux_sym_type_qualifier_token12] = ACTIONS(1377),
    [aux_sym_type_qualifier_token13] = ACTIONS(1377),
    [aux_sym_type_qualifier_token14] = ACTIONS(1377),
    [aux_sym_type_qualifier_token15] = ACTIONS(1377),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1417),
    [aux_sym_include_statement_token1] = ACTIONS(1419),
    [aux_sym_data_statement_token1] = ACTIONS(1421),
    [aux_sym_enum_statement_token1] = ACTIONS(1423),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1425),
  },
  [418] = {
    [sym_end_submodule_statement] = STATE(262),
    [sym_interface] = STATE(648),
    [sym_interface_statement] = STATE(763),
    [sym_internal_procedures] = STATE(2031),
    [sym_contains_statement] = STATE(2381),
    [sym__specification_part] = STATE(606),
    [sym_use_statement] = STATE(2382),
    [sym_implicit_statement] = STATE(2382),
    [sym_save_statement] = STATE(2382),
    [sym_private_statement] = STATE(2382),
    [sym_public_statement] = STATE(2382),
    [sym_namelist_statement] = STATE(2382),
    [sym_common_statement] = STATE(2382),
    [sym_import_statement] = STATE(2382),
    [sym_derived_type_definition] = STATE(648),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(994),
    [sym_variable_declaration] = STATE(2382),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2382),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2382),
    [sym_equivalence_statement] = STATE(2382),
    [sym_statement_label] = STATE(2217),
    [sym_include_statement] = STATE(2382),
    [sym_data_statement] = STATE(2382),
    [sym_enum] = STATE(648),
    [sym_enum_statement] = STATE(1854),
    [sym_preproc_file_line] = STATE(418),
    [aux_sym_program_repeat1] = STATE(424),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(1427),
    [aux_sym_end_submodule_statement_token1] = ACTIONS(1429),
    [aux_sym_interface_statement_token1] = ACTIONS(1371),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1373),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1375),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1377),
    [aux_sym_contains_statement_token1] = ACTIONS(1379),
    [aux_sym_use_statement_token1] = ACTIONS(1381),
    [aux_sym_use_statement_token2] = ACTIONS(1377),
    [aux_sym_implicit_statement_token1] = ACTIONS(1383),
    [aux_sym_implicit_statement_token3] = ACTIONS(1385),
    [aux_sym_implicit_statement_token4] = ACTIONS(1377),
    [aux_sym_save_statement_token1] = ACTIONS(1387),
    [aux_sym_private_statement_token1] = ACTIONS(1389),
    [aux_sym_public_statement_token1] = ACTIONS(1391),
    [aux_sym_namelist_statement_token1] = ACTIONS(1393),
    [aux_sym_common_statement_token1] = ACTIONS(1395),
    [aux_sym_import_statement_token1] = ACTIONS(1397),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1399),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1401),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1377),
    [aux_sym_variable_attributes_token1] = ACTIONS(1377),
    [aux_sym_variable_attributes_token2] = ACTIONS(1377),
    [aux_sym_variable_attributes_token3] = ACTIONS(1377),
    [aux_sym_variable_attributes_token4] = ACTIONS(1377),
    [aux_sym_variable_attributes_token5] = ACTIONS(1377),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1405),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1407),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1403),
    [aux_sym_derived_type_token1] = ACTIONS(1409),
    [aux_sym_type_qualifier_token1] = ACTIONS(1377),
    [aux_sym_type_qualifier_token2] = ACTIONS(1377),
    [aux_sym_type_qualifier_token3] = ACTIONS(1411),
    [aux_sym_type_qualifier_token4] = ACTIONS(1377),
    [aux_sym_type_qualifier_token5] = ACTIONS(1413),
    [aux_sym_type_qualifier_token9] = ACTIONS(1377),
    [aux_sym_type_qualifier_token10] = ACTIONS(1415),
    [aux_sym_type_qualifier_token11] = ACTIONS(1377),
    [aux_sym_type_qualifier_token12] = ACTIONS(1377),
    [aux_sym_type_qualifier_token13] = ACTIONS(1377),
    [aux_sym_type_qualifier_token14] = ACTIONS(1377),
    [aux_sym_type_qualifier_token15] = ACTIONS(1377),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1417),
    [aux_sym_include_statement_token1] = ACTIONS(1419),
    [aux_sym_data_statement_token1] = ACTIONS(1421),
    [aux_sym_enum_statement_token1] = ACTIONS(1423),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1425),
  },
  [419] = {
    [sym_end_module_statement] = STATE(254),
    [sym_interface] = STATE(629),
    [sym_interface_statement] = STATE(766),
    [sym_internal_procedures] = STATE(2028),
    [sym_contains_statement] = STATE(2638),
    [sym__specification_part] = STATE(628),
    [sym_use_statement] = STATE(2643),
    [sym_implicit_statement] = STATE(2643),
    [sym_save_statement] = STATE(2643),
    [sym_private_statement] = STATE(2643),
    [sym_public_statement] = STATE(2643),
    [sym_namelist_statement] = STATE(2643),
    [sym_common_statement] = STATE(2643),
    [sym_import_statement] = STATE(2643),
    [sym_derived_type_definition] = STATE(629),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(928),
    [sym_variable_declaration] = STATE(2643),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2643),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2643),
    [sym_equivalence_statement] = STATE(2643),
    [sym_statement_label] = STATE(2017),
    [sym_include_statement] = STATE(2643),
    [sym_data_statement] = STATE(2643),
    [sym_enum] = STATE(629),
    [sym_enum_statement] = STATE(1848),
    [sym_preproc_file_line] = STATE(419),
    [aux_sym_program_repeat1] = STATE(422),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(1367),
    [aux_sym_end_module_statement_token1] = ACTIONS(1369),
    [aux_sym_interface_statement_token1] = ACTIONS(1371),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1373),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1375),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1377),
    [aux_sym_contains_statement_token1] = ACTIONS(1379),
    [aux_sym_use_statement_token1] = ACTIONS(1381),
    [aux_sym_use_statement_token2] = ACTIONS(1377),
    [aux_sym_implicit_statement_token1] = ACTIONS(1383),
    [aux_sym_implicit_statement_token3] = ACTIONS(1385),
    [aux_sym_implicit_statement_token4] = ACTIONS(1377),
    [aux_sym_save_statement_token1] = ACTIONS(1387),
    [aux_sym_private_statement_token1] = ACTIONS(1389),
    [aux_sym_public_statement_token1] = ACTIONS(1391),
    [aux_sym_namelist_statement_token1] = ACTIONS(1393),
    [aux_sym_common_statement_token1] = ACTIONS(1395),
    [aux_sym_import_statement_token1] = ACTIONS(1397),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1399),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1401),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1377),
    [aux_sym_variable_attributes_token1] = ACTIONS(1377),
    [aux_sym_variable_attributes_token2] = ACTIONS(1377),
    [aux_sym_variable_attributes_token3] = ACTIONS(1377),
    [aux_sym_variable_attributes_token4] = ACTIONS(1377),
    [aux_sym_variable_attributes_token5] = ACTIONS(1377),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1405),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1407),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1403),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1403),
    [aux_sym_derived_type_token1] = ACTIONS(1409),
    [aux_sym_type_qualifier_token1] = ACTIONS(1377),
    [aux_sym_type_qualifier_token2] = ACTIONS(1377),
    [aux_sym_type_qualifier_token3] = ACTIONS(1411),
    [aux_sym_type_qualifier_token4] = ACTIONS(1377),
    [aux_sym_type_qualifier_token5] = ACTIONS(1413),
    [aux_sym_type_qualifier_token9] = ACTIONS(1377),
    [aux_sym_type_qualifier_token10] = ACTIONS(1415),
    [aux_sym_type_qualifier_token11] = ACTIONS(1377),
    [aux_sym_type_qualifier_token12] = ACTIONS(1377),
    [aux_sym_type_qualifier_token13] = ACTIONS(1377),
    [aux_sym_type_qualifier_token14] = ACTIONS(1377),
    [aux_sym_type_qualifier_token15] = ACTIONS(1377),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1417),
    [aux_sym_include_statement_token1] = ACTIONS(1419),
    [aux_sym_data_statement_token1] = ACTIONS(1421),
    [aux_sym_enum_statement_token1] = ACTIONS(1423),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1425),
  },
  [420] = {
    [sym_preproc_file_line] = STATE(420),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [anon_sym_COMMA] = ACTIONS(1365),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1436),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [anon_sym_SLASH] = ACTIONS(1363),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1438),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1363),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1433),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
    [sym__end_of_statement] = ACTIONS(1365),
  },
  [421] = {
    [sym_variable_attributes] = STATE(458),
    [sym__declaration_targets] = STATE(2695),
    [sym_type_qualifier] = STATE(458),
    [sym_assignment_statement] = STATE(2175),
    [sym_pointer_association_statement] = STATE(2175),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1033),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(421),
    [sym_identifier] = STATE(940),
    [aux_sym_variable_modification_repeat1] = STATE(440),
    [aux_sym_end_program_statement_token1] = ACTIONS(1441),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1443),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1443),
    [aux_sym_procedure_attributes_token1] = ACTIONS(387),
    [aux_sym_procedure_attributes_token3] = ACTIONS(35),
    [aux_sym_use_statement_token2] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1445),
    [aux_sym_implicit_statement_token4] = ACTIONS(35),
    [aux_sym_save_statement_token1] = ACTIONS(35),
    [aux_sym_private_statement_token1] = ACTIONS(35),
    [aux_sym_public_statement_token1] = ACTIONS(35),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_derived_type_definition_token1] = ACTIONS(59),
    [aux_sym_abstract_specifier_token1] = ACTIONS(35),
    [aux_sym_procedure_attribute_token6] = ACTIONS(35),
    [aux_sym_variable_attributes_token1] = ACTIONS(35),
    [aux_sym_variable_attributes_token2] = ACTIONS(35),
    [aux_sym_variable_attributes_token3] = ACTIONS(35),
    [aux_sym_variable_attributes_token4] = ACTIONS(35),
    [aux_sym_variable_attributes_token5] = ACTIONS(35),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1447),
    [aux_sym_type_qualifier_token1] = ACTIONS(35),
    [aux_sym_type_qualifier_token2] = ACTIONS(35),
    [aux_sym_type_qualifier_token3] = ACTIONS(73),
    [aux_sym_type_qualifier_token4] = ACTIONS(35),
    [aux_sym_type_qualifier_token5] = ACTIONS(75),
    [aux_sym_type_qualifier_token9] = ACTIONS(35),
    [aux_sym_type_qualifier_token10] = ACTIONS(35),
    [aux_sym_type_qualifier_token11] = ACTIONS(35),
    [aux_sym_type_qualifier_token12] = ACTIONS(35),
    [aux_sym_type_qualifier_token13] = ACTIONS(1449),
    [aux_sym_type_qualifier_token14] = ACTIONS(1449),
    [aux_sym_type_qualifier_token15] = ACTIONS(35),
    [aux_sym_stop_statement_token1] = ACTIONS(1443),
    [aux_sym_stop_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token3] = ACTIONS(1443),
    [aux_sym_data_statement_token1] = ACTIONS(1443),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1443),
    [aux_sym_end_if_statement_token1] = ACTIONS(1443),
    [aux_sym_elseif_clause_token2] = ACTIONS(1443),
    [aux_sym_select_case_statement_token1] = ACTIONS(1451),
    [aux_sym_block_construct_token1] = ACTIONS(1443),
    [aux_sym_format_statement_token1] = ACTIONS(1443),
    [aux_sym_inquire_statement_token1] = ACTIONS(1443),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(1453),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [422] = {
    [sym_interface] = STATE(629),
    [sym_interface_statement] = STATE(766),
    [sym__specification_part] = STATE(628),
    [sym_use_statement] = STATE(2643),
    [sym_implicit_statement] = STATE(2643),
    [sym_save_statement] = STATE(2643),
    [sym_private_statement] = STATE(2643),
    [sym_public_statement] = STATE(2643),
    [sym_namelist_statement] = STATE(2643),
    [sym_common_statement] = STATE(2643),
    [sym_import_statement] = STATE(2643),
    [sym_derived_type_definition] = STATE(629),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(928),
    [sym_variable_declaration] = STATE(2643),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2643),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2643),
    [sym_equivalence_statement] = STATE(2643),
    [sym_statement_label] = STATE(2017),
    [sym_include_statement] = STATE(2643),
    [sym_data_statement] = STATE(2643),
    [sym_enum] = STATE(629),
    [sym_enum_statement] = STATE(1848),
    [sym_preproc_file_line] = STATE(422),
    [aux_sym_program_repeat1] = STATE(422),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [aux_sym_end_module_statement_token1] = ACTIONS(527),
    [aux_sym_interface_statement_token1] = ACTIONS(1455),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1458),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1461),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1464),
    [aux_sym_contains_statement_token1] = ACTIONS(527),
    [aux_sym_use_statement_token1] = ACTIONS(1467),
    [aux_sym_use_statement_token2] = ACTIONS(1464),
    [aux_sym_implicit_statement_token1] = ACTIONS(1470),
    [aux_sym_implicit_statement_token3] = ACTIONS(1473),
    [aux_sym_implicit_statement_token4] = ACTIONS(1464),
    [aux_sym_save_statement_token1] = ACTIONS(1476),
    [aux_sym_private_statement_token1] = ACTIONS(1479),
    [aux_sym_public_statement_token1] = ACTIONS(1482),
    [aux_sym_namelist_statement_token1] = ACTIONS(1485),
    [aux_sym_common_statement_token1] = ACTIONS(1488),
    [aux_sym_import_statement_token1] = ACTIONS(1491),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1494),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1497),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1464),
    [aux_sym_variable_attributes_token1] = ACTIONS(1464),
    [aux_sym_variable_attributes_token2] = ACTIONS(1464),
    [aux_sym_variable_attributes_token3] = ACTIONS(1464),
    [aux_sym_variable_attributes_token4] = ACTIONS(1464),
    [aux_sym_variable_attributes_token5] = ACTIONS(1464),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1503),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1500),
    [aux_sym_derived_type_token1] = ACTIONS(1506),
    [aux_sym_type_qualifier_token1] = ACTIONS(1464),
    [aux_sym_type_qualifier_token2] = ACTIONS(1464),
    [aux_sym_type_qualifier_token3] = ACTIONS(1509),
    [aux_sym_type_qualifier_token4] = ACTIONS(1464),
    [aux_sym_type_qualifier_token5] = ACTIONS(1512),
    [aux_sym_type_qualifier_token9] = ACTIONS(1464),
    [aux_sym_type_qualifier_token10] = ACTIONS(1515),
    [aux_sym_type_qualifier_token11] = ACTIONS(1464),
    [aux_sym_type_qualifier_token12] = ACTIONS(1464),
    [aux_sym_type_qualifier_token13] = ACTIONS(1464),
    [aux_sym_type_qualifier_token14] = ACTIONS(1464),
    [aux_sym_type_qualifier_token15] = ACTIONS(1464),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1518),
    [aux_sym_include_statement_token1] = ACTIONS(1521),
    [aux_sym_data_statement_token1] = ACTIONS(1524),
    [aux_sym_enum_statement_token1] = ACTIONS(1527),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
  },
  [423] = {
    [sym_preproc_file_line] = STATE(423),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1436),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [anon_sym_SLASH] = ACTIONS(1363),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1438),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1363),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1433),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
  },
  [424] = {
    [sym_interface] = STATE(648),
    [sym_interface_statement] = STATE(763),
    [sym__specification_part] = STATE(606),
    [sym_use_statement] = STATE(2382),
    [sym_implicit_statement] = STATE(2382),
    [sym_save_statement] = STATE(2382),
    [sym_private_statement] = STATE(2382),
    [sym_public_statement] = STATE(2382),
    [sym_namelist_statement] = STATE(2382),
    [sym_common_statement] = STATE(2382),
    [sym_import_statement] = STATE(2382),
    [sym_derived_type_definition] = STATE(648),
    [sym_abstract_specifier] = STATE(2443),
    [sym_derived_type_statement] = STATE(994),
    [sym_variable_declaration] = STATE(2382),
    [sym_procedure_declaration] = STATE(484),
    [sym_variable_modification] = STATE(2382),
    [sym_variable_attributes] = STATE(458),
    [sym__intrinsic_type] = STATE(484),
    [sym_intrinsic_type] = STATE(773),
    [sym_derived_type] = STATE(484),
    [sym_type_qualifier] = STATE(458),
    [sym_parameter_statement] = STATE(2382),
    [sym_equivalence_statement] = STATE(2382),
    [sym_statement_label] = STATE(2217),
    [sym_include_statement] = STATE(2382),
    [sym_data_statement] = STATE(2382),
    [sym_enum] = STATE(648),
    [sym_enum_statement] = STATE(1854),
    [sym_preproc_file_line] = STATE(424),
    [aux_sym_program_repeat1] = STATE(424),
    [aux_sym_variable_modification_repeat1] = STATE(421),
    [aux_sym_end_program_statement_token1] = ACTIONS(489),
    [aux_sym_end_submodule_statement_token1] = ACTIONS(527),
    [aux_sym_interface_statement_token1] = ACTIONS(1455),
    [aux_sym_module_procedure_statement_token1] = ACTIONS(1458),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1461),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1464),
    [aux_sym_contains_statement_token1] = ACTIONS(527),
    [aux_sym_use_statement_token1] = ACTIONS(1467),
    [aux_sym_use_statement_token2] = ACTIONS(1464),
    [aux_sym_implicit_statement_token1] = ACTIONS(1470),
    [aux_sym_implicit_statement_token3] = ACTIONS(1473),
    [aux_sym_implicit_statement_token4] = ACTIONS(1464),
    [aux_sym_save_statement_token1] = ACTIONS(1476),
    [aux_sym_private_statement_token1] = ACTIONS(1479),
    [aux_sym_public_statement_token1] = ACTIONS(1482),
    [aux_sym_namelist_statement_token1] = ACTIONS(1485),
    [aux_sym_common_statement_token1] = ACTIONS(1488),
    [aux_sym_import_statement_token1] = ACTIONS(1491),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1494),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1497),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1464),
    [aux_sym_variable_attributes_token1] = ACTIONS(1464),
    [aux_sym_variable_attributes_token2] = ACTIONS(1464),
    [aux_sym_variable_attributes_token3] = ACTIONS(1464),
    [aux_sym_variable_attributes_token4] = ACTIONS(1464),
    [aux_sym_variable_attributes_token5] = ACTIONS(1464),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token4] = ACTIONS(541),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1503),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1500),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1500),
    [aux_sym_derived_type_token1] = ACTIONS(1506),
    [aux_sym_type_qualifier_token1] = ACTIONS(1464),
    [aux_sym_type_qualifier_token2] = ACTIONS(1464),
    [aux_sym_type_qualifier_token3] = ACTIONS(1509),
    [aux_sym_type_qualifier_token4] = ACTIONS(1464),
    [aux_sym_type_qualifier_token5] = ACTIONS(1512),
    [aux_sym_type_qualifier_token9] = ACTIONS(1464),
    [aux_sym_type_qualifier_token10] = ACTIONS(1515),
    [aux_sym_type_qualifier_token11] = ACTIONS(1464),
    [aux_sym_type_qualifier_token12] = ACTIONS(1464),
    [aux_sym_type_qualifier_token13] = ACTIONS(1464),
    [aux_sym_type_qualifier_token14] = ACTIONS(1464),
    [aux_sym_type_qualifier_token15] = ACTIONS(1464),
    [aux_sym_equivalence_statement_token1] = ACTIONS(1518),
    [aux_sym_include_statement_token1] = ACTIONS(1521),
    [aux_sym_data_statement_token1] = ACTIONS(1524),
    [aux_sym_enum_statement_token1] = ACTIONS(1527),
    [anon_sym_POUND] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(571),
  },
  [425] = {
    [sym_statement_label] = STATE(2260),
    [sym_statement_label_reference] = STATE(2287),
    [sym__io_arguments] = STATE(539),
    [sym_format_identifier] = STATE(2332),
    [sym__io_expressions] = STATE(2287),
    [sym__expression] = STATE(1137),
    [sym_parenthesized_expression] = STATE(1206),
    [sym_derived_type_member_expression] = STATE(1206),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(1206),
    [sym_math_expression] = STATE(1206),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1206),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(425),
    [sym_identifier] = STATE(1206),
    [aux_sym_end_program_statement_token1] = ACTIONS(1441),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1443),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1443),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1532),
    [aux_sym_type_qualifier_token13] = ACTIONS(1443),
    [aux_sym_type_qualifier_token14] = ACTIONS(1443),
    [aux_sym_stop_statement_token1] = ACTIONS(1443),
    [aux_sym_stop_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token3] = ACTIONS(1443),
    [aux_sym_data_statement_token1] = ACTIONS(1443),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1443),
    [aux_sym_end_if_statement_token1] = ACTIONS(1443),
    [aux_sym_elseif_clause_token2] = ACTIONS(1443),
    [aux_sym_select_case_statement_token1] = ACTIONS(1451),
    [aux_sym_block_construct_token1] = ACTIONS(1443),
    [aux_sym_format_statement_token1] = ACTIONS(1443),
    [aux_sym_inquire_statement_token1] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(1453),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1534),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(1536),
  },
  [426] = {
    [sym_preproc_file_line] = STATE(426),
    [aux_sym_end_program_statement_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1538),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1544),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1540),
    [aux_sym_type_qualifier_token13] = ACTIONS(1538),
    [aux_sym_type_qualifier_token14] = ACTIONS(1538),
    [aux_sym_stop_statement_token1] = ACTIONS(1538),
    [aux_sym_stop_statement_token2] = ACTIONS(1538),
    [aux_sym_subroutine_call_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token2] = ACTIONS(1538),
    [aux_sym_keyword_statement_token3] = ACTIONS(1538),
    [aux_sym_keyword_statement_token4] = ACTIONS(1538),
    [aux_sym_keyword_statement_token6] = ACTIONS(1538),
    [aux_sym_keyword_statement_token7] = ACTIONS(1538),
    [aux_sym_include_statement_token1] = ACTIONS(1538),
    [aux_sym_data_statement_token1] = ACTIONS(1538),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1538),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1538),
    [aux_sym_end_if_statement_token1] = ACTIONS(1538),
    [aux_sym_elseif_clause_token2] = ACTIONS(1538),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1538),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1538),
    [aux_sym_end_forall_statement_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token3] = ACTIONS(1538),
    [aux_sym_select_type_statement_token1] = ACTIONS(1538),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1538),
    [aux_sym_block_construct_token1] = ACTIONS(1538),
    [aux_sym_associate_statement_token1] = ACTIONS(1538),
    [aux_sym_format_statement_token1] = ACTIONS(1538),
    [aux_sym_print_statement_token1] = ACTIONS(1538),
    [aux_sym_open_statement_token1] = ACTIONS(1538),
    [aux_sym_close_statement_token1] = ACTIONS(1538),
    [aux_sym_inquire_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token2] = ACTIONS(1538),
    [aux_sym_file_position_statement_token3] = ACTIONS(1538),
    [aux_sym_file_position_statement_token4] = ACTIONS(1538),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [aux_sym_logical_expression_token1] = ACTIONS(1542),
    [aux_sym_logical_expression_token2] = ACTIONS(1542),
    [aux_sym_logical_expression_token3] = ACTIONS(1542),
    [aux_sym_logical_expression_token4] = ACTIONS(1542),
    [aux_sym_logical_expression_token5] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1540),
    [aux_sym_relational_expression_token1] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1540),
    [aux_sym_relational_expression_token2] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token3] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token4] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token5] = ACTIONS(1542),
    [anon_sym_SLASH_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token6] = ACTIONS(1542),
    [anon_sym_SLASH_SLASH] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1538),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [sym_boolean_literal] = ACTIONS(1544),
    [aux_sym_null_literal_token1] = ACTIONS(1538),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1544),
    [sym__float_literal] = ACTIONS(1544),
    [sym__boz_literal] = ACTIONS(1544),
    [sym_string_literal] = ACTIONS(1544),
  },
  [427] = {
    [sym__expression] = STATE(1014),
    [sym_parenthesized_expression] = STATE(1140),
    [sym_derived_type_member_expression] = STATE(1140),
    [sym_logical_expression] = STATE(1140),
    [sym_relational_expression] = STATE(1140),
    [sym_concatenation_expression] = STATE(1140),
    [sym_math_expression] = STATE(1140),
    [sym_unary_expression] = STATE(1140),
    [sym_user_defined_operator] = STATE(706),
    [sym_call_expression] = STATE(1140),
    [sym_implied_do_loop_expression] = STATE(1140),
    [sym_array_literal] = STATE(1140),
    [sym__array_constructor_legacy] = STATE(1127),
    [sym__array_constructor_f2003] = STATE(1128),
    [sym_complex_literal] = STATE(1140),
    [sym_number_literal] = STATE(1140),
    [sym_null_literal] = STATE(1140),
    [sym_preproc_file_line] = STATE(427),
    [sym_identifier] = STATE(1140),
    [aux_sym_end_program_statement_token1] = ACTIONS(1441),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1443),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1443),
    [anon_sym_COMMA] = ACTIONS(1549),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1551),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1363),
    [aux_sym_type_qualifier_token13] = ACTIONS(1443),
    [aux_sym_type_qualifier_token14] = ACTIONS(1443),
    [aux_sym_stop_statement_token1] = ACTIONS(1443),
    [aux_sym_stop_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token3] = ACTIONS(1443),
    [aux_sym_data_statement_token1] = ACTIONS(1443),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1443),
    [aux_sym_end_if_statement_token1] = ACTIONS(1443),
    [aux_sym_elseif_clause_token2] = ACTIONS(1443),
    [aux_sym_select_case_statement_token1] = ACTIONS(1451),
    [aux_sym_block_construct_token1] = ACTIONS(1443),
    [aux_sym_format_statement_token1] = ACTIONS(1443),
    [aux_sym_inquire_statement_token1] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1551),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1559),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [sym_boolean_literal] = ACTIONS(1563),
    [aux_sym_null_literal_token1] = ACTIONS(1565),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1567),
    [sym__float_literal] = ACTIONS(1567),
    [sym__boz_literal] = ACTIONS(1567),
    [sym_string_literal] = ACTIONS(1563),
    [sym__end_of_statement] = ACTIONS(1569),
  },
  [428] = {
    [sym_preproc_file_line] = STATE(428),
    [aux_sym_end_program_statement_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1538),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [aux_sym_implicit_statement_token3] = ACTIONS(1538),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1544),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1540),
    [aux_sym_type_qualifier_token13] = ACTIONS(1538),
    [aux_sym_type_qualifier_token14] = ACTIONS(1538),
    [aux_sym_stop_statement_token1] = ACTIONS(1538),
    [aux_sym_stop_statement_token2] = ACTIONS(1538),
    [aux_sym_subroutine_call_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token2] = ACTIONS(1538),
    [aux_sym_keyword_statement_token3] = ACTIONS(1538),
    [aux_sym_keyword_statement_token4] = ACTIONS(1538),
    [aux_sym_keyword_statement_token6] = ACTIONS(1538),
    [aux_sym_keyword_statement_token7] = ACTIONS(1538),
    [aux_sym_include_statement_token1] = ACTIONS(1538),
    [aux_sym_data_statement_token1] = ACTIONS(1538),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1538),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1538),
    [aux_sym_end_if_statement_token1] = ACTIONS(1538),
    [aux_sym_elseif_clause_token2] = ACTIONS(1538),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1538),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token3] = ACTIONS(1538),
    [aux_sym_select_type_statement_token1] = ACTIONS(1538),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1538),
    [aux_sym_block_construct_token1] = ACTIONS(1538),
    [aux_sym_associate_statement_token1] = ACTIONS(1538),
    [aux_sym_format_statement_token1] = ACTIONS(1538),
    [aux_sym_print_statement_token1] = ACTIONS(1538),
    [aux_sym_open_statement_token1] = ACTIONS(1538),
    [aux_sym_close_statement_token1] = ACTIONS(1538),
    [aux_sym_inquire_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token2] = ACTIONS(1538),
    [aux_sym_file_position_statement_token3] = ACTIONS(1538),
    [aux_sym_file_position_statement_token4] = ACTIONS(1538),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [aux_sym_logical_expression_token1] = ACTIONS(1542),
    [aux_sym_logical_expression_token2] = ACTIONS(1542),
    [aux_sym_logical_expression_token3] = ACTIONS(1542),
    [aux_sym_logical_expression_token4] = ACTIONS(1542),
    [aux_sym_logical_expression_token5] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1540),
    [aux_sym_relational_expression_token1] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1540),
    [aux_sym_relational_expression_token2] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token3] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token4] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token5] = ACTIONS(1542),
    [anon_sym_SLASH_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token6] = ACTIONS(1542),
    [anon_sym_SLASH_SLASH] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1538),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [sym_boolean_literal] = ACTIONS(1544),
    [aux_sym_null_literal_token1] = ACTIONS(1538),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1544),
    [sym__float_literal] = ACTIONS(1544),
    [sym__boz_literal] = ACTIONS(1544),
    [sym_string_literal] = ACTIONS(1544),
  },
  [429] = {
    [sym_preproc_file_line] = STATE(429),
    [aux_sym_end_program_statement_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1538),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1544),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1540),
    [aux_sym_type_qualifier_token13] = ACTIONS(1538),
    [aux_sym_type_qualifier_token14] = ACTIONS(1538),
    [aux_sym_stop_statement_token1] = ACTIONS(1538),
    [aux_sym_stop_statement_token2] = ACTIONS(1538),
    [aux_sym_subroutine_call_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token2] = ACTIONS(1538),
    [aux_sym_keyword_statement_token3] = ACTIONS(1538),
    [aux_sym_keyword_statement_token4] = ACTIONS(1538),
    [aux_sym_keyword_statement_token6] = ACTIONS(1538),
    [aux_sym_keyword_statement_token7] = ACTIONS(1538),
    [aux_sym_include_statement_token1] = ACTIONS(1538),
    [aux_sym_data_statement_token1] = ACTIONS(1538),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1538),
    [aux_sym_end_do_loop_statement_token1] = ACTIONS(1538),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1538),
    [aux_sym_end_if_statement_token1] = ACTIONS(1538),
    [aux_sym_elseif_clause_token2] = ACTIONS(1538),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1538),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token3] = ACTIONS(1538),
    [aux_sym_select_type_statement_token1] = ACTIONS(1538),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1538),
    [aux_sym_block_construct_token1] = ACTIONS(1538),
    [aux_sym_associate_statement_token1] = ACTIONS(1538),
    [aux_sym_format_statement_token1] = ACTIONS(1538),
    [aux_sym_print_statement_token1] = ACTIONS(1538),
    [aux_sym_open_statement_token1] = ACTIONS(1538),
    [aux_sym_close_statement_token1] = ACTIONS(1538),
    [aux_sym_inquire_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token2] = ACTIONS(1538),
    [aux_sym_file_position_statement_token3] = ACTIONS(1538),
    [aux_sym_file_position_statement_token4] = ACTIONS(1538),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [aux_sym_logical_expression_token1] = ACTIONS(1542),
    [aux_sym_logical_expression_token2] = ACTIONS(1542),
    [aux_sym_logical_expression_token3] = ACTIONS(1542),
    [aux_sym_logical_expression_token4] = ACTIONS(1542),
    [aux_sym_logical_expression_token5] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1540),
    [aux_sym_relational_expression_token1] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1540),
    [aux_sym_relational_expression_token2] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token3] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token4] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token5] = ACTIONS(1542),
    [anon_sym_SLASH_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token6] = ACTIONS(1542),
    [anon_sym_SLASH_SLASH] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1538),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [sym_boolean_literal] = ACTIONS(1544),
    [aux_sym_null_literal_token1] = ACTIONS(1538),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1544),
    [sym__float_literal] = ACTIONS(1544),
    [sym__boz_literal] = ACTIONS(1544),
    [sym_string_literal] = ACTIONS(1544),
  },
  [430] = {
    [sym_data_set] = STATE(2154),
    [sym__expression] = STATE(1155),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(1130),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1130),
    [sym_implied_do_loop_expression] = STATE(1130),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(430),
    [sym_identifier] = STATE(1130),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(1363),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [431] = {
    [sym_preproc_file_line] = STATE(431),
    [aux_sym_end_program_statement_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1538),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1544),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1538),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1540),
    [aux_sym_type_qualifier_token13] = ACTIONS(1538),
    [aux_sym_type_qualifier_token14] = ACTIONS(1538),
    [aux_sym_stop_statement_token1] = ACTIONS(1538),
    [aux_sym_stop_statement_token2] = ACTIONS(1538),
    [aux_sym_subroutine_call_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token1] = ACTIONS(1538),
    [aux_sym_keyword_statement_token2] = ACTIONS(1538),
    [aux_sym_keyword_statement_token3] = ACTIONS(1538),
    [aux_sym_keyword_statement_token4] = ACTIONS(1538),
    [aux_sym_keyword_statement_token6] = ACTIONS(1538),
    [aux_sym_keyword_statement_token7] = ACTIONS(1538),
    [aux_sym_include_statement_token1] = ACTIONS(1538),
    [aux_sym_data_statement_token1] = ACTIONS(1538),
    [aux_sym_do_loop_statement_token1] = ACTIONS(1538),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1538),
    [aux_sym_end_if_statement_token1] = ACTIONS(1538),
    [aux_sym_elseif_clause_token2] = ACTIONS(1538),
    [aux_sym__inline_where_statement_token1] = ACTIONS(1538),
    [aux_sym__forall_control_expression_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token1] = ACTIONS(1538),
    [aux_sym_select_case_statement_token3] = ACTIONS(1538),
    [aux_sym_select_type_statement_token1] = ACTIONS(1538),
    [aux_sym_select_rank_statement_token2] = ACTIONS(1538),
    [aux_sym_block_construct_token1] = ACTIONS(1538),
    [aux_sym_associate_statement_token1] = ACTIONS(1538),
    [aux_sym_format_statement_token1] = ACTIONS(1538),
    [aux_sym_print_statement_token1] = ACTIONS(1538),
    [aux_sym_open_statement_token1] = ACTIONS(1538),
    [aux_sym_close_statement_token1] = ACTIONS(1538),
    [aux_sym_inquire_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token1] = ACTIONS(1538),
    [aux_sym_file_position_statement_token2] = ACTIONS(1538),
    [aux_sym_file_position_statement_token3] = ACTIONS(1538),
    [aux_sym_file_position_statement_token4] = ACTIONS(1538),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [aux_sym_logical_expression_token1] = ACTIONS(1542),
    [aux_sym_logical_expression_token2] = ACTIONS(1542),
    [aux_sym_logical_expression_token3] = ACTIONS(1542),
    [aux_sym_logical_expression_token4] = ACTIONS(1542),
    [aux_sym_logical_expression_token5] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1540),
    [aux_sym_relational_expression_token1] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1540),
    [aux_sym_relational_expression_token2] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token3] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token4] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token5] = ACTIONS(1542),
    [anon_sym_SLASH_EQ] = ACTIONS(1542),
    [aux_sym_relational_expression_token6] = ACTIONS(1542),
    [anon_sym_SLASH_SLASH] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1538),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [sym_boolean_literal] = ACTIONS(1544),
    [aux_sym_null_literal_token1] = ACTIONS(1538),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1544),
    [sym__float_literal] = ACTIONS(1544),
    [sym__boz_literal] = ACTIONS(1544),
    [sym_string_literal] = ACTIONS(1544),
  },
  [432] = {
    [sym_preproc_file_line] = STATE(432),
    [aux_sym_end_program_statement_token1] = ACTIONS(1573),
    [aux_sym_module_statement_token1] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_EQ] = ACTIONS(1363),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1573),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1573),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1573),
    [aux_sym_function_statement_token1] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(1578),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1573),
    [anon_sym_COLON_COLON] = ACTIONS(1578),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [aux_sym_implicit_statement_token3] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1580),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1573),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1573),
    [aux_sym_derived_type_token1] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [aux_sym_type_qualifier_token13] = ACTIONS(1573),
    [aux_sym_type_qualifier_token14] = ACTIONS(1573),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1573),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1573),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1573),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1573),
    [aux_sym_stop_statement_token1] = ACTIONS(1573),
    [aux_sym_stop_statement_token2] = ACTIONS(1573),
    [aux_sym_keyword_statement_token2] = ACTIONS(1573),
    [aux_sym_keyword_statement_token3] = ACTIONS(1573),
    [aux_sym_data_statement_token1] = ACTIONS(1573),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1573),
    [aux_sym_end_if_statement_token1] = ACTIONS(1573),
    [aux_sym_elseif_clause_token2] = ACTIONS(1573),
    [aux_sym_select_case_statement_token1] = ACTIONS(1573),
    [aux_sym_block_construct_token1] = ACTIONS(1573),
    [aux_sym_format_statement_token1] = ACTIONS(1573),
    [aux_sym_inquire_statement_token1] = ACTIONS(1573),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [aux_sym_logical_expression_token1] = ACTIONS(1365),
    [aux_sym_logical_expression_token2] = ACTIONS(1365),
    [aux_sym_logical_expression_token3] = ACTIONS(1365),
    [aux_sym_logical_expression_token4] = ACTIONS(1365),
    [aux_sym_logical_expression_token5] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(1363),
    [aux_sym_relational_expression_token1] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1363),
    [aux_sym_relational_expression_token2] = ACTIONS(1365),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token3] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token4] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token5] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [aux_sym_relational_expression_token6] = ACTIONS(1365),
    [anon_sym_SLASH_SLASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1575),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1578),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [sym_boolean_literal] = ACTIONS(1578),
    [aux_sym_null_literal_token1] = ACTIONS(1573),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1573),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1578),
    [sym__float_literal] = ACTIONS(1578),
    [sym__boz_literal] = ACTIONS(1578),
    [sym_string_literal] = ACTIONS(1578),
  },
  [433] = {
    [sym_preproc_file_line] = STATE(433),
    [aux_sym_end_program_statement_token1] = ACTIONS(1583),
    [aux_sym_module_statement_token1] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1583),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1583),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1585),
    [aux_sym_function_statement_token1] = ACTIONS(1585),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1585),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1583),
    [aux_sym_use_statement_token2] = ACTIONS(1583),
    [anon_sym_COLON_COLON] = ACTIONS(1587),
    [aux_sym_implicit_statement_token3] = ACTIONS(1585),
    [aux_sym_implicit_statement_token4] = ACTIONS(1583),
    [aux_sym_save_statement_token1] = ACTIONS(1583),
    [aux_sym_private_statement_token1] = ACTIONS(1583),
    [aux_sym_public_statement_token1] = ACTIONS(1583),
    [anon_sym_DASH] = ACTIONS(1587),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1583),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1583),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1583),
    [aux_sym_variable_attributes_token1] = ACTIONS(1583),
    [aux_sym_variable_attributes_token2] = ACTIONS(1583),
    [aux_sym_variable_attributes_token3] = ACTIONS(1583),
    [aux_sym_variable_attributes_token4] = ACTIONS(1583),
    [aux_sym_variable_attributes_token5] = ACTIONS(1583),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1585),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1585),
    [aux_sym_derived_type_token1] = ACTIONS(1585),
    [aux_sym_type_qualifier_token1] = ACTIONS(1583),
    [aux_sym_type_qualifier_token2] = ACTIONS(1583),
    [aux_sym_type_qualifier_token3] = ACTIONS(1583),
    [aux_sym_type_qualifier_token4] = ACTIONS(1583),
    [aux_sym_type_qualifier_token5] = ACTIONS(1583),
    [aux_sym_type_qualifier_token9] = ACTIONS(1583),
    [aux_sym_type_qualifier_token10] = ACTIONS(1583),
    [aux_sym_type_qualifier_token11] = ACTIONS(1583),
    [aux_sym_type_qualifier_token12] = ACTIONS(1583),
    [aux_sym_type_qualifier_token13] = ACTIONS(1583),
    [aux_sym_type_qualifier_token14] = ACTIONS(1583),
    [aux_sym_type_qualifier_token15] = ACTIONS(1583),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1585),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1585),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1585),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1585),
    [aux_sym_stop_statement_token1] = ACTIONS(1583),
    [aux_sym_stop_statement_token2] = ACTIONS(1583),
    [aux_sym_keyword_statement_token2] = ACTIONS(1583),
    [aux_sym_keyword_statement_token3] = ACTIONS(1583),
    [aux_sym_data_statement_token1] = ACTIONS(1583),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1583),
    [aux_sym_end_if_statement_token1] = ACTIONS(1583),
    [aux_sym_elseif_clause_token2] = ACTIONS(1583),
    [aux_sym_select_case_statement_token1] = ACTIONS(1583),
    [aux_sym_block_construct_token1] = ACTIONS(1583),
    [aux_sym_format_statement_token1] = ACTIONS(1583),
    [aux_sym_inquire_statement_token1] = ACTIONS(1583),
    [aux_sym_logical_expression_token5] = ACTIONS(1587),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DOT] = ACTIONS(1583),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [sym_boolean_literal] = ACTIONS(1587),
    [aux_sym_null_literal_token1] = ACTIONS(1583),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1583),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1587),
    [sym__float_literal] = ACTIONS(1587),
    [sym__boz_literal] = ACTIONS(1587),
    [sym_string_literal] = ACTIONS(1587),
  },
  [434] = {
    [sym__declaration_targets] = STATE(2636),
    [sym_assignment_statement] = STATE(2175),
    [sym_pointer_association_statement] = STATE(2175),
    [sym__expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(1033),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(434),
    [sym_identifier] = STATE(940),
    [aux_sym_end_program_statement_token1] = ACTIONS(1441),
    [aux_sym_module_statement_token1] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1443),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1443),
    [aux_sym_subroutine_statement_token1] = ACTIONS(1589),
    [aux_sym_function_statement_token1] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1591),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1589),
    [anon_sym_COLON_COLON] = ACTIONS(1593),
    [aux_sym_implicit_statement_token3] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1589),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1589),
    [aux_sym_derived_type_token1] = ACTIONS(1589),
    [aux_sym_type_qualifier_token13] = ACTIONS(1443),
    [aux_sym_type_qualifier_token14] = ACTIONS(1443),
    [aux_sym_procedure_qualifier_token1] = ACTIONS(1589),
    [aux_sym_procedure_qualifier_token2] = ACTIONS(1589),
    [aux_sym_procedure_qualifier_token3] = ACTIONS(1589),
    [aux_sym_procedure_qualifier_token4] = ACTIONS(1589),
    [aux_sym_stop_statement_token1] = ACTIONS(1443),
    [aux_sym_stop_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token3] = ACTIONS(1443),
    [aux_sym_data_statement_token1] = ACTIONS(1443),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1443),
    [aux_sym_end_if_statement_token1] = ACTIONS(1443),
    [aux_sym_elseif_clause_token2] = ACTIONS(1443),
    [aux_sym_select_case_statement_token1] = ACTIONS(1451),
    [aux_sym_block_construct_token1] = ACTIONS(1443),
    [aux_sym_format_statement_token1] = ACTIONS(1443),
    [aux_sym_inquire_statement_token1] = ACTIONS(1443),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(1453),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [435] = {
    [sym__intrinsic_type] = STATE(2426),
    [sym_intrinsic_type] = STATE(1371),
    [sym_derived_type] = STATE(2426),
    [sym__expression] = STATE(911),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym__type_spec] = STATE(534),
    [sym__ac_value_list] = STATE(2451),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(435),
    [sym_identifier] = STATE(796),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_statement_token3] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1601),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1603),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1599),
    [aux_sym_derived_type_token1] = ACTIONS(1605),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [436] = {
    [sym__intrinsic_type] = STATE(2426),
    [sym_intrinsic_type] = STATE(1371),
    [sym_derived_type] = STATE(2426),
    [sym__expression] = STATE(911),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym__type_spec] = STATE(534),
    [sym__ac_value_list] = STATE(2493),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(436),
    [sym_identifier] = STATE(796),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_statement_token3] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1601),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1603),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1599),
    [aux_sym_derived_type_token1] = ACTIONS(1605),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [437] = {
    [sym__intrinsic_type] = STATE(2426),
    [sym_intrinsic_type] = STATE(1371),
    [sym_derived_type] = STATE(2426),
    [sym__expression] = STATE(911),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym__type_spec] = STATE(534),
    [sym__ac_value_list] = STATE(2668),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(437),
    [sym_identifier] = STATE(796),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_statement_token3] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1601),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1603),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1599),
    [aux_sym_derived_type_token1] = ACTIONS(1605),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [438] = {
    [sym__intrinsic_type] = STATE(2426),
    [sym_intrinsic_type] = STATE(1371),
    [sym_derived_type] = STATE(2426),
    [sym__expression] = STATE(911),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(700),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym__type_spec] = STATE(534),
    [sym__ac_value_list] = STATE(2673),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(438),
    [sym_identifier] = STATE(796),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_statement_token3] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(55),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token2] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1597),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1601),
    [aux_sym_intrinsic_type_token6] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token7] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token8] = ACTIONS(1603),
    [aux_sym_intrinsic_type_token9] = ACTIONS(1599),
    [aux_sym_intrinsic_type_token10] = ACTIONS(1599),
    [aux_sym_derived_type_token1] = ACTIONS(1605),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(141),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [439] = {
    [sym_preproc_file_line] = STATE(439),
    [sym_identifier] = STATE(1995),
    [aux_sym_end_program_statement_token1] = ACTIONS(1441),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1443),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1443),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1607),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [anon_sym_SLASH] = ACTIONS(1609),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1436),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1443),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1447),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1443),
    [aux_sym_type_qualifier_token14] = ACTIONS(1443),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1443),
    [aux_sym_stop_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token2] = ACTIONS(1443),
    [aux_sym_keyword_statement_token3] = ACTIONS(1443),
    [aux_sym_data_statement_token1] = ACTIONS(1443),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1443),
    [aux_sym_end_if_statement_token1] = ACTIONS(1443),
    [aux_sym_elseif_clause_token2] = ACTIONS(1443),
    [aux_sym_select_case_statement_token1] = ACTIONS(1451),
    [aux_sym_block_construct_token1] = ACTIONS(1443),
    [aux_sym_format_statement_token1] = ACTIONS(1443),
    [aux_sym_inquire_statement_token1] = ACTIONS(1443),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1443),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1443),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
    [sym__end_of_statement] = ACTIONS(1611),
  },
  [440] = {
    [sym_variable_attributes] = STATE(458),
    [sym_type_qualifier] = STATE(458),
    [sym_preproc_file_line] = STATE(440),
    [aux_sym_variable_modification_repeat1] = STATE(440),
    [aux_sym_end_program_statement_token1] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1613),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1613),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1615),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1618),
    [aux_sym_use_statement_token2] = ACTIONS(1618),
    [anon_sym_COLON_COLON] = ACTIONS(1621),
    [aux_sym_implicit_statement_token4] = ACTIONS(1618),
    [aux_sym_save_statement_token1] = ACTIONS(1618),
    [aux_sym_private_statement_token1] = ACTIONS(1618),
    [aux_sym_public_statement_token1] = ACTIONS(1618),
    [anon_sym_DASH] = ACTIONS(1621),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1623),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1618),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1618),
    [aux_sym_variable_attributes_token1] = ACTIONS(1618),
    [aux_sym_variable_attributes_token2] = ACTIONS(1618),
    [aux_sym_variable_attributes_token3] = ACTIONS(1618),
    [aux_sym_variable_attributes_token4] = ACTIONS(1618),
    [aux_sym_variable_attributes_token5] = ACTIONS(1618),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1613),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1613),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1613),
    [aux_sym_type_qualifier_token1] = ACTIONS(1618),
    [aux_sym_type_qualifier_token2] = ACTIONS(1618),
    [aux_sym_type_qualifier_token3] = ACTIONS(1626),
    [aux_sym_type_qualifier_token4] = ACTIONS(1618),
    [aux_sym_type_qualifier_token5] = ACTIONS(1629),
    [aux_sym_type_qualifier_token9] = ACTIONS(1618),
    [aux_sym_type_qualifier_token10] = ACTIONS(1618),
    [aux_sym_type_qualifier_token11] = ACTIONS(1618),
    [aux_sym_type_qualifier_token12] = ACTIONS(1618),
    [aux_sym_type_qualifier_token13] = ACTIONS(1618),
    [aux_sym_type_qualifier_token14] = ACTIONS(1618),
    [aux_sym_type_qualifier_token15] = ACTIONS(1618),
    [aux_sym_stop_statement_token1] = ACTIONS(1613),
    [aux_sym_stop_statement_token2] = ACTIONS(1613),
    [aux_sym_keyword_statement_token2] = ACTIONS(1613),
    [aux_sym_keyword_statement_token3] = ACTIONS(1613),
    [aux_sym_data_statement_token1] = ACTIONS(1613),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1613),
    [aux_sym_end_if_statement_token1] = ACTIONS(1613),
    [aux_sym_elseif_clause_token2] = ACTIONS(1613),
    [aux_sym_select_case_statement_token1] = ACTIONS(1613),
    [aux_sym_block_construct_token1] = ACTIONS(1613),
    [aux_sym_format_statement_token1] = ACTIONS(1613),
    [aux_sym_inquire_statement_token1] = ACTIONS(1613),
    [aux_sym_logical_expression_token5] = ACTIONS(1621),
    [anon_sym_PLUS] = ACTIONS(1621),
    [anon_sym_DOT] = ACTIONS(1613),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [sym_boolean_literal] = ACTIONS(1621),
    [aux_sym_null_literal_token1] = ACTIONS(1613),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1613),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__float_literal] = ACTIONS(1621),
    [sym__boz_literal] = ACTIONS(1621),
    [sym_string_literal] = ACTIONS(1621),
  },
  [441] = {
    [sym_preproc_file_line] = STATE(441),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1632),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1436),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
    [sym__end_of_statement] = ACTIONS(1634),
  },
  [442] = {
    [sym_preproc_file_line] = STATE(442),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1436),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
    [sym__end_of_statement] = ACTIONS(1638),
  },
  [443] = {
    [sym_implicit_range] = STATE(2239),
    [sym__expression] = STATE(907),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(650),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_keyword_argument] = STATE(2113),
    [sym_extent_specifier] = STATE(2113),
    [sym_assumed_size] = STATE(2113),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(443),
    [sym_identifier] = STATE(1049),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_range_token1] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1646),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(1648),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(143),
    [sym_assumed_rank] = ACTIONS(1652),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [444] = {
    [sym_preproc_file_line] = STATE(444),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1431),
    [aux_sym_interface_statement_token1] = ACTIONS(1654),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1436),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1436),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
  },
  [445] = {
    [sym_implicit_range] = STATE(1951),
    [sym__expression] = STATE(907),
    [sym_parenthesized_expression] = STATE(796),
    [sym_derived_type_member_expression] = STATE(796),
    [sym_logical_expression] = STATE(796),
    [sym_relational_expression] = STATE(796),
    [sym_concatenation_expression] = STATE(796),
    [sym_math_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym_user_defined_operator] = STATE(650),
    [sym_call_expression] = STATE(796),
    [sym_implied_do_loop_expression] = STATE(796),
    [sym_keyword_argument] = STATE(2113),
    [sym_extent_specifier] = STATE(2113),
    [sym_assumed_size] = STATE(2113),
    [sym_array_literal] = STATE(796),
    [sym__array_constructor_legacy] = STATE(807),
    [sym__array_constructor_f2003] = STATE(820),
    [sym_complex_literal] = STATE(796),
    [sym_number_literal] = STATE(796),
    [sym_null_literal] = STATE(796),
    [sym_preproc_file_line] = STATE(445),
    [sym_identifier] = STATE(1049),
    [aux_sym_end_program_statement_token1] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(1640),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(107),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(107),
    [aux_sym_implicit_range_token1] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1646),
    [aux_sym_intrinsic_type_token1] = ACTIONS(107),
    [aux_sym_intrinsic_type_token3] = ACTIONS(107),
    [aux_sym_intrinsic_type_token4] = ACTIONS(576),
    [anon_sym_STAR] = ACTIONS(1648),
    [aux_sym_type_qualifier_token13] = ACTIONS(107),
    [aux_sym_type_qualifier_token14] = ACTIONS(107),
    [aux_sym_stop_statement_token1] = ACTIONS(107),
    [aux_sym_stop_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token2] = ACTIONS(107),
    [aux_sym_keyword_statement_token3] = ACTIONS(107),
    [aux_sym_data_statement_token1] = ACTIONS(107),
    [aux_sym__inline_if_statement_token1] = ACTIONS(107),
    [aux_sym_end_if_statement_token1] = ACTIONS(107),
    [aux_sym_elseif_clause_token2] = ACTIONS(107),
    [aux_sym_select_case_statement_token1] = ACTIONS(1571),
    [aux_sym_block_construct_token1] = ACTIONS(107),
    [aux_sym_format_statement_token1] = ACTIONS(107),
    [aux_sym_inquire_statement_token1] = ACTIONS(107),
    [aux_sym_logical_expression_token5] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(143),
    [sym_assumed_rank] = ACTIONS(1652),
    [anon_sym_LPAREN_SLASH] = ACTIONS(145),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_boolean_literal] = ACTIONS(149),
    [aux_sym_null_literal_token1] = ACTIONS(151),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(107),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(155),
    [sym__float_literal] = ACTIONS(155),
    [sym__boz_literal] = ACTIONS(155),
    [sym_string_literal] = ACTIONS(149),
  },
  [446] = {
    [sym_argument_list] = STATE(451),
    [sym_preproc_file_line] = STATE(446),
    [aux_sym_end_program_statement_token1] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1656),
    [aux_sym_defined_io_procedure_token1] = ACTIONS(1431),
    [aux_sym_defined_io_procedure_token2] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token1] = ACTIONS(1431),
    [aux_sym_procedure_attributes_token3] = ACTIONS(1431),
    [aux_sym_use_statement_token2] = ACTIONS(1431),
    [anon_sym_COLON_COLON] = ACTIONS(1436),
    [aux_sym_implicit_statement_token4] = ACTIONS(1431),
    [aux_sym_save_statement_token1] = ACTIONS(1431),
    [aux_sym_private_statement_token1] = ACTIONS(1431),
    [aux_sym_public_statement_token1] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1436),
    [aux_sym_derived_type_definition_token1] = ACTIONS(1431),
    [aux_sym_abstract_specifier_token1] = ACTIONS(1431),
    [aux_sym_procedure_attribute_token6] = ACTIONS(1431),
    [aux_sym_variable_attributes_token1] = ACTIONS(1431),
    [aux_sym_variable_attributes_token2] = ACTIONS(1431),
    [aux_sym_variable_attributes_token3] = ACTIONS(1431),
    [aux_sym_variable_attributes_token4] = ACTIONS(1431),
    [aux_sym_variable_attributes_token5] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token1] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token3] = ACTIONS(1431),
    [aux_sym_intrinsic_type_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token1] = ACTIONS(1431),
    [aux_sym_type_qualifier_token2] = ACTIONS(1431),
    [aux_sym_type_qualifier_token3] = ACTIONS(1431),
    [aux_sym_type_qualifier_token4] = ACTIONS(1431),
    [aux_sym_type_qualifier_token5] = ACTIONS(1431),
    [aux_sym_type_qualifier_token9] = ACTIONS(1431),
    [aux_sym_type_qualifier_token10] = ACTIONS(1431),
    [aux_sym_type_qualifier_token11] = ACTIONS(1431),
    [aux_sym_type_qualifier_token12] = ACTIONS(1431),
    [aux_sym_type_qualifier_token13] = ACTIONS(1431),
    [aux_sym_type_qualifier_token14] = ACTIONS(1431),
    [aux_sym_type_qualifier_token15] = ACTIONS(1431),
    [aux_sym_stop_statement_token1] = ACTIONS(1431),
    [aux_sym_stop_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token2] = ACTIONS(1431),
    [aux_sym_keyword_statement_token3] = ACTIONS(1431),
    [aux_sym_data_statement_token1] = ACTIONS(1431),
    [aux_sym__inline_if_statement_token1] = ACTIONS(1431),
    [aux_sym_end_if_statement_token1] = ACTIONS(1431),
    [aux_sym_elseif_clause_token2] = ACTIONS(1431),
    [aux_sym_select_case_statement_token1] = ACTIONS(1431),
    [aux_sym_block_construct_token1] = ACTIONS(1431),
    [aux_sym_format_statement_token1] = ACTIONS(1431),
    [aux_sym_inquire_statement_token1] = ACTIONS(1431),
    [aux_sym_logical_expression_token5] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN_SLASH] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_boolean_literal] = ACTIONS(1436),
    [aux_sym_null_literal_token1] = ACTIONS(1431),
    [anon_sym_POUND] = ACTIONS(3),
    [aux_sym_identifier_token1] = ACTIONS(1431),
    [sym_comment] = ACTIONS(5),
    [anon_sym_AMP] = ACTIONS(5),
    [sym__integer_literal] = ACTIONS(1436),
    [sym__float_literal] = ACTIONS(1436),
    [sym__boz_literal] = ACTIONS(1436),
    [sym_string_literal] = ACTIONS(1436),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(447), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1660), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1658), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [75] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(448), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1436), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1431), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [150] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(449), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1664), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1662), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [225] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(450), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1436), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1431), 48,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [302] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(451), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1670), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1668), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [377] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(452), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 52,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [452] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(453), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 52,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [527] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(454), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 50,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_type_statement_token2,
      aux_sym_type_statement_token3,
      aux_sym__class_default_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [602] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(455), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 50,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_type_statement_token2,
      aux_sym_type_statement_token3,
      aux_sym__class_default_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [677] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(456), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1680), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1678), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [752] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(457), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1587), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1583), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [827] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(458), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1684), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1682), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [902] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(459), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1688), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1686), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [977] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(460), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1692), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1690), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [1052] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(461), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1696), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1694), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [1127] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(462), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1580), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1575), 3,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_DOT,
    ACTIONS(1363), 5,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1578), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      aux_sym_logical_expression_token5,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1365), 18,
      anon_sym_EQ_GT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_STAR_STAR,
    ACTIONS(1573), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [1210] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(463), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1353), 52,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [1285] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(464), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1700), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1698), 49,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [1360] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(465), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 52,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [1435] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1702), 1,
      anon_sym_RPAREN,
    ACTIONS(1704), 1,
      sym_assumed_rank,
    STATE(466), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(914), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2056), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [1553] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1706), 1,
      anon_sym_RPAREN,
    ACTIONS(1708), 1,
      sym_assumed_rank,
    STATE(467), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(893), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2088), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [1671] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1710), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_assumed_rank,
    STATE(468), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(909), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2139), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [1789] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1710), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_assumed_rank,
    STATE(469), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(912), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2139), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [1907] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1714), 1,
      anon_sym_RPAREN,
    ACTIONS(1716), 1,
      sym_assumed_rank,
    STATE(470), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(908), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2166), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2025] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1642), 1,
      anon_sym_RPAREN,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1652), 1,
      sym_assumed_rank,
    STATE(471), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(907), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2113), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2143] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1642), 1,
      anon_sym_RPAREN,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1652), 1,
      sym_assumed_rank,
    STATE(472), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(905), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2113), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2261] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1702), 1,
      anon_sym_RPAREN,
    ACTIONS(1704), 1,
      sym_assumed_rank,
    STATE(473), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(896), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2056), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2379] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1718), 1,
      anon_sym_RPAREN,
    ACTIONS(1720), 1,
      sym_assumed_rank,
    STATE(474), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(916), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2177), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2497] = 28,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(1724), 1,
      anon_sym_COLON_COLON,
    STATE(475), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(787), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2718), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2616] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1014), 1,
      sym__integer_literal,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      sym_string_literal,
    STATE(476), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1141), 1,
      sym_identifier,
    STATE(1155), 1,
      sym__expression,
    STATE(1473), 1,
      sym_statement_label,
    STATE(2163), 1,
      sym_keyword_argument,
    STATE(2335), 1,
      sym_format_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 2,
      sym__float_literal,
      sym__boz_literal,
    STATE(2283), 2,
      sym_statement_label_reference,
      sym__io_expressions,
    STATE(1160), 5,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
    STATE(796), 8,
      sym_logical_expression,
      sym_relational_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2739] = 28,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1722), 1,
      anon_sym_COMMA,
    ACTIONS(1730), 1,
      anon_sym_COLON_COLON,
    STATE(475), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(477), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2472), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2858] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1732), 1,
      sym_assumed_rank,
    STATE(478), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(960), 1,
      sym__expression,
    STATE(1049), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2304), 3,
      sym_keyword_argument,
      sym_extent_specifier,
      sym_assumed_size,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [2973] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1734), 1,
      anon_sym_COLON,
    STATE(479), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(996), 1,
      sym__expression,
    STATE(1966), 1,
      sym_assumed_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1736), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [3085] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(480), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 47,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym_end_where_statement_token1,
      aux_sym_elsewhere_clause_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3157] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(481), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 47,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym_end_where_statement_token1,
      aux_sym_elsewhere_clause_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3229] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1738), 1,
      anon_sym_COLON,
    STATE(482), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(966), 1,
      sym__expression,
    STATE(2213), 1,
      sym_assumed_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1740), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [3341] = 28,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1534), 1,
      sym__integer_literal,
    ACTIONS(1536), 1,
      sym_string_literal,
    ACTIONS(1742), 1,
      anon_sym_LPAREN,
    ACTIONS(1744), 1,
      anon_sym_STAR,
    STATE(483), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1137), 1,
      sym__expression,
    STATE(2260), 1,
      sym_statement_label,
    STATE(2347), 1,
      sym_format_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 2,
      sym__float_literal,
      sym__boz_literal,
    STATE(2287), 2,
      sym_statement_label_reference,
      sym__io_expressions,
    STATE(1206), 6,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
      sym_identifier,
    STATE(796), 8,
      sym_logical_expression,
      sym_relational_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [3459] = 27,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1593), 1,
      anon_sym_COLON_COLON,
    STATE(484), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2636), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [3575] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(485), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_function_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3646] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(486), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3717] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(487), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3788] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      sym_string_literal,
    STATE(488), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1141), 1,
      sym_identifier,
    STATE(1155), 1,
      sym__expression,
    STATE(1169), 1,
      sym_number_literal,
    STATE(2161), 1,
      sym_keyword_argument,
    STATE(2310), 1,
      sym_unit_identifier,
    STATE(2336), 1,
      sym__io_expressions,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1160), 5,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
    STATE(796), 7,
      sym_logical_expression,
      sym_relational_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [3907] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(489), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_function_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [3978] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(490), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      aux_sym_end_program_statement_token2,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4049] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(491), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4120] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      sym_string_literal,
    STATE(492), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(926), 1,
      sym__expression,
    STATE(1136), 1,
      sym_identifier,
    STATE(1161), 1,
      sym_number_literal,
    STATE(1195), 1,
      sym_unary_expression,
    STATE(2161), 1,
      sym_keyword_argument,
    STATE(2310), 1,
      sym_unit_identifier,
    STATE(2336), 1,
      sym__io_expressions,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1160), 5,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
    STATE(796), 6,
      sym_logical_expression,
      sym_relational_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [4241] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(493), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4312] = 30,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(1746), 1,
      sym_string_literal,
    STATE(494), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(926), 1,
      sym__expression,
    STATE(1152), 1,
      sym_identifier,
    STATE(1173), 1,
      sym_number_literal,
    STATE(1195), 1,
      sym_unary_expression,
    STATE(2006), 1,
      sym_keyword_argument,
    STATE(2336), 1,
      sym__io_expressions,
    STATE(2395), 1,
      sym_unit_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1218), 5,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
    STATE(796), 6,
      sym_logical_expression,
      sym_relational_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [4433] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(495), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      aux_sym_end_program_statement_token2,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_contains_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4504] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1648), 1,
      anon_sym_STAR,
    ACTIONS(1748), 1,
      anon_sym_COLON,
    STATE(496), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1032), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2348), 2,
      sym_assumed_size,
      sym_assumed_shape,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [4613] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(497), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token2,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4684] = 28,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1536), 1,
      sym_string_literal,
    ACTIONS(1744), 1,
      anon_sym_STAR,
    ACTIONS(1750), 1,
      anon_sym_LPAREN,
    STATE(498), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1137), 1,
      sym__expression,
    STATE(1261), 1,
      sym_number_literal,
    STATE(2650), 1,
      sym__file_position_spec,
    STATE(2666), 1,
      sym__io_expressions,
    STATE(2815), 1,
      sym_unit_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1206), 6,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
      sym_identifier,
    STATE(796), 7,
      sym_logical_expression,
      sym_relational_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [4801] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(499), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4872] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(500), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [4943] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(501), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 46,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token2,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_end_select_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5014] = 29,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(149), 1,
      sym_boolean_literal,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1726), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      sym_string_literal,
    STATE(502), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1141), 1,
      sym_identifier,
    STATE(1155), 1,
      sym__expression,
    STATE(1169), 1,
      sym_number_literal,
    STATE(2002), 1,
      sym_keyword_argument,
    STATE(2274), 1,
      sym_unit_identifier,
    STATE(2336), 1,
      sym__io_expressions,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1160), 5,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
    STATE(796), 7,
      sym_logical_expression,
      sym_relational_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [5133] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1754), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      sym__end_of_statement,
    STATE(503), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(925), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2665), 1,
      sym_output_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [5241] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    STATE(504), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2495), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [5351] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(505), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_end_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5421] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(506), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1762), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1760), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5491] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(507), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_end_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5561] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(508), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym_end_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5631] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(509), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_end_forall_statement_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5701] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    STATE(510), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2590), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [5811] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(511), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [5881] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    STATE(512), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2718), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [5991] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(513), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1766), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1764), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6061] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(514), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1690), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1692), 47,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [6131] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(515), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym_end_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6201] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(516), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1770), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1768), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6271] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    STATE(517), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(940), 1,
      sym_identifier,
    STATE(1030), 1,
      sym__expression,
    STATE(1033), 1,
      sym_call_expression,
    STATE(2811), 1,
      sym__declaration_targets,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2175), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [6381] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(518), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(894), 1,
      sym__expression,
    STATE(1978), 1,
      sym_extent_specifier,
    STATE(2518), 1,
      sym_case_value_range_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [6489] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(519), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1774), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1772), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6559] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1778), 1,
      anon_sym_LPAREN,
    ACTIONS(1782), 1,
      anon_sym_STAR,
    STATE(520), 1,
      sym_preproc_file_line,
    STATE(657), 1,
      sym_argument_list,
    STATE(752), 1,
      sym_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1780), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1776), 39,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6637] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(521), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_end_block_construct_statement_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6707] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(522), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6777] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(523), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(894), 1,
      sym__expression,
    STATE(1978), 1,
      sym_extent_specifier,
    STATE(2727), 1,
      sym_case_value_range_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [6885] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(524), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1774), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1772), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym__block_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [6955] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(525), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_end_block_construct_statement_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [7025] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(526), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1678), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1680), 47,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [7095] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(527), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1686), 8,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1688), 47,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      anon_sym_DASH,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [7165] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(528), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1786), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1784), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [7235] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(529), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 45,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_end_forall_statement_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [7305] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1788), 1,
      aux_sym_program_statement_token1,
    ACTIONS(1790), 1,
      sym__end_of_statement,
    STATE(530), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2527), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [7390] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1792), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1794), 1,
      sym__end_of_statement,
    STATE(531), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2757), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [7475] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1796), 1,
      sym__end_of_statement,
    STATE(532), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(925), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2377), 1,
      sym_output_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [7580] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1798), 1,
      sym__end_of_statement,
    STATE(533), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(925), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2391), 1,
      sym_output_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [7685] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(534), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(918), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1800), 2,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [7788] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1802), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1804), 1,
      sym__end_of_statement,
    STATE(535), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2460), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [7873] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1806), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1808), 1,
      sym__end_of_statement,
    STATE(536), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2912), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [7958] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1810), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1812), 1,
      sym__end_of_statement,
    STATE(537), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2387), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8043] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1453), 1,
      aux_sym_null_literal_token1,
    STATE(538), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1030), 1,
      sym__expression,
    STATE(1031), 1,
      sym_identifier,
    STATE(1112), 1,
      sym_call_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2349), 2,
      sym_assignment_statement,
      sym_pointer_association_statement,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [8150] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1814), 1,
      sym__end_of_statement,
    STATE(539), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(985), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2801), 1,
      sym_input_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [8255] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1640), 1,
      anon_sym_COLON,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(540), 1,
      sym_preproc_file_line,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(988), 1,
      sym__expression,
    STATE(2270), 1,
      sym_extent_specifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [8360] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(541), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1672), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(710), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [8429] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(542), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1676), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1674), 44,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_subroutine_call_token1,
      aux_sym_keyword_statement_token1,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_keyword_statement_token4,
      aux_sym_keyword_statement_token6,
      aux_sym_keyword_statement_token7,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
      aux_sym_format_statement_token1,
      aux_sym_print_statement_token1,
      aux_sym_open_statement_token1,
      aux_sym_close_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_file_position_statement_token1,
      aux_sym_file_position_statement_token2,
      aux_sym_file_position_statement_token3,
      aux_sym_file_position_statement_token4,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [8498] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1816), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1818), 1,
      sym__end_of_statement,
    STATE(543), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2827), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8583] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1820), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1822), 1,
      sym__end_of_statement,
    STATE(544), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2842), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8668] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1824), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1826), 1,
      sym__end_of_statement,
    STATE(545), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2365), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8753] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1828), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1830), 1,
      sym__end_of_statement,
    STATE(546), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2436), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8838] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1832), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1834), 1,
      sym__end_of_statement,
    STATE(547), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2439), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [8923] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1836), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1838), 1,
      sym__end_of_statement,
    STATE(548), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2458), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9008] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1840), 1,
      anon_sym_COMMA,
    ACTIONS(1842), 1,
      sym__end_of_statement,
    STATE(549), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1008), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [9113] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1844), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1846), 1,
      sym__end_of_statement,
    STATE(550), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2510), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9198] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1848), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1850), 1,
      sym__end_of_statement,
    STATE(551), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2513), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9283] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1852), 1,
      sym__end_of_statement,
    STATE(552), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(925), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2492), 1,
      sym_output_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [9388] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1854), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1856), 1,
      sym__end_of_statement,
    STATE(553), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2531), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9473] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1858), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1860), 1,
      sym__end_of_statement,
    STATE(554), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2581), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9558] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1862), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1864), 1,
      sym__end_of_statement,
    STATE(555), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2584), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9643] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1866), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1868), 1,
      sym__end_of_statement,
    STATE(556), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2602), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9728] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1870), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1872), 1,
      sym__end_of_statement,
    STATE(557), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2651), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9813] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1874), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1876), 1,
      sym__end_of_statement,
    STATE(558), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2654), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9898] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1878), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1880), 1,
      sym__end_of_statement,
    STATE(559), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2672), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [9983] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1882), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1884), 1,
      sym__end_of_statement,
    STATE(560), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2716), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [10068] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1886), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1888), 1,
      sym__end_of_statement,
    STATE(561), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2719), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [10153] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1890), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1892), 1,
      sym__end_of_statement,
    STATE(562), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2754), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [10238] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COMMA,
    STATE(563), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1040), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [10340] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(564), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1327), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1329), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10408] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(565), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1331), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1333), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10476] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(566), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1335), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1337), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10544] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(567), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1339), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1341), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10612] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(568), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1365), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10680] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(569), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1215), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1213), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [10748] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1896), 1,
      anon_sym_COMMA,
    STATE(570), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1092), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [10850] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(571), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1011), 1,
      sym__expression,
    STATE(2564), 1,
      sym_pointer_association_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [10952] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(572), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1227), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1225), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11020] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(573), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1235), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1233), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11088] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(574), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1096), 1,
      sym__expression,
    STATE(1174), 1,
      sym_identifier,
    STATE(2326), 1,
      sym_concurrent_control,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [11192] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1898), 1,
      sym__end_of_statement,
    STATE(575), 1,
      sym_preproc_file_line,
    STATE(2525), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1365), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [11274] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(576), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1135), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1133), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11342] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(577), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1147), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1145), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11410] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(578), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1315), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1317), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11478] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1900), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(1914), 1,
      aux_sym_intrinsic_type_token4,
    STATE(579), 1,
      sym_preproc_file_line,
    STATE(1023), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    ACTIONS(1911), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(1189), 2,
      sym__generic_procedure,
      sym__name,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 15,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1903), 23,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [11566] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(580), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1319), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1321), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11634] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(581), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1326), 1,
      sym_identifier,
    STATE(2267), 1,
      sym_triplet_spec,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1296), 2,
      sym_logical_expression,
      sym_relational_expression,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [11740] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(582), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1265), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1263), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11808] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(583), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(925), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2629), 1,
      sym_output_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [11910] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(584), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1365), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [11978] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(585), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1345), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12046] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(586), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1349), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12114] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(587), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1353), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12182] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(588), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1359), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1361), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12250] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(589), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(2276), 1,
      sym_data_set,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1130), 4,
      sym_derived_type_member_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_identifier,
    STATE(796), 10,
      sym_parenthesized_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [12354] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(590), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1323), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1325), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12422] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(591), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(2154), 1,
      sym_data_set,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1130), 4,
      sym_derived_type_member_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_identifier,
    STATE(796), 10,
      sym_parenthesized_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [12526] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(592), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1327), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1329), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12594] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(593), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1307), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1309), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12662] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(594), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1331), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1333), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12730] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(595), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1041), 1,
      sym__expression,
    STATE(1174), 1,
      sym_identifier,
    STATE(2326), 1,
      sym_concurrent_control,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [12834] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(596), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1917), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1919), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12902] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(597), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1335), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1337), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [12970] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(1921), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1929), 1,
      aux_sym_intrinsic_type_token4,
    STATE(598), 1,
      sym_preproc_file_line,
    STATE(1023), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    ACTIONS(1926), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(1217), 2,
      sym__generic_procedure,
      sym__name,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 15,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1924), 23,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [13058] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(599), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1339), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1341), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13126] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(600), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1578), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1573), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [13194] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(601), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1932), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1934), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13262] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(602), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1047), 1,
      sym__expression,
    STATE(1174), 1,
      sym_identifier,
    STATE(2326), 1,
      sym_concurrent_control,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [13366] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(603), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1936), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1938), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13434] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(604), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(903), 1,
      sym__expression,
    STATE(1164), 1,
      sym_identifier,
    STATE(2586), 1,
      sym_loop_control_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [13538] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(605), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1055), 1,
      sym__expression,
    STATE(1174), 1,
      sym_identifier,
    STATE(2326), 1,
      sym_concurrent_control,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [13642] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(606), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1279), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1281), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13710] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(607), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1311), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1313), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13778] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(608), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1345), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13846] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(609), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1349), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13914] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(610), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1353), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [13982] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    ACTIONS(1940), 1,
      anon_sym_COMMA,
    STATE(611), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1122), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [14084] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(612), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1359), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1361), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14152] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(613), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1326), 1,
      sym_identifier,
    STATE(2267), 1,
      sym_triplet_spec,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1266), 2,
      sym_logical_expression,
      sym_relational_expression,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [14258] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(614), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1215), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1213), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14326] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(615), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1944), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1942), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [14394] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(616), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1948), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1946), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [14462] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(617), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1275), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1277), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14530] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(618), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1952), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1950), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [14598] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(619), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1287), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1289), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14666] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(620), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1227), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1225), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14734] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(621), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1235), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1233), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [14802] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(622), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(903), 1,
      sym__expression,
    STATE(1164), 1,
      sym_identifier,
    STATE(2896), 1,
      sym_loop_control_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [14906] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(623), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(985), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    STATE(2808), 1,
      sym_input_item_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [15008] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(624), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1295), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1297), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15076] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(625), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1299), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1301), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15144] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(626), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1291), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1293), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15212] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(627), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1303), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1305), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15280] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(628), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1279), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1281), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15348] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(629), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1283), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1285), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15416] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(630), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1135), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1133), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15484] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(631), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1147), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1145), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15552] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(632), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1275), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1277), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15620] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(633), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1307), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1309), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15688] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(634), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1287), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1289), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15756] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(635), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1311), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1313), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15824] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(636), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1315), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1317), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15892] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(637), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1319), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1321), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [15960] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(638), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1265), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1263), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16028] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(639), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1323), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1325), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16096] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(640), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1295), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1297), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16164] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(641), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1299), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1301), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16232] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(642), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1291), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1293), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16300] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(643), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(903), 1,
      sym__expression,
    STATE(1164), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_loop_control_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [16404] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(644), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(903), 1,
      sym__expression,
    STATE(1164), 1,
      sym_identifier,
    STATE(2875), 1,
      sym_loop_control_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 13,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [16508] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(645), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1326), 1,
      sym_identifier,
    STATE(2267), 1,
      sym_triplet_spec,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1228), 2,
      sym_logical_expression,
      sym_relational_expression,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [16614] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(646), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1326), 1,
      sym_identifier,
    STATE(2267), 1,
      sym_triplet_spec,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1233), 2,
      sym_logical_expression,
      sym_relational_expression,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [16720] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(647), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1303), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1305), 51,
      sym__integer_literal,
      aux_sym_end_module_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16788] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(648), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1283), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1285), 51,
      sym__integer_literal,
      aux_sym_end_submodule_statement_token1,
      aux_sym_interface_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_procedure_attributes_token3,
      aux_sym_contains_statement_token1,
      aux_sym_use_statement_token1,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_namelist_statement_token1,
      aux_sym_common_statement_token1,
      aux_sym_import_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token3,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token5,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
      aux_sym_equivalence_statement_token1,
      aux_sym_include_statement_token1,
      aux_sym_data_statement_token1,
      aux_sym_enum_statement_token1,
  [16856] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(649), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1121), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [16955] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(998), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(650), 2,
      sym_user_defined_operator,
      sym_preproc_file_line,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17052] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(651), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1046), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17151] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(652), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1954), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1263), 6,
      sym_unary_expression,
      sym_call_expression,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    STATE(796), 8,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17252] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(653), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1097), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17351] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(654), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(989), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17450] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(655), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1048), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17549] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(656), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1005), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17648] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(657), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1958), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1956), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [17715] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(658), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1018), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [17814] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(659), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1962), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1960), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [17881] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(660), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1966), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1964), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [17948] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(661), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(917), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18047] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(662), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1982), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1980), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [18114] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(663), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1098), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18213] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(664), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1986), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1984), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [18280] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(665), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1034), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18379] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(666), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1009), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18478] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(1019), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18577] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(668), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1088), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18676] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(669), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(838), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18775] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(670), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1079), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18874] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(671), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(839), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [18973] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(672), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(836), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19072] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(673), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(837), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19171] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(674), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1688), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1686), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [19238] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(675), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1035), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19337] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(676), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1015), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19436] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(677), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1153), 2,
      sym_call_expression,
      sym_identifier,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19537] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(678), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(984), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19636] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(679), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1010), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19735] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(680), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(910), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19834] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(681), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(898), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [19933] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(682), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(840), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20032] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(683), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(841), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20131] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(684), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(906), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20230] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(685), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(843), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20329] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(686), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(844), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20428] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(687), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(845), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20527] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(688), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(900), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20626] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(689), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(886), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20725] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(690), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1090), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20824] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(691), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(887), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [20923] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(692), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1001), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21022] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(693), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(903), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21121] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(694), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(889), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21220] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(695), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(890), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21319] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(696), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(846), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21418] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(697), 1,
      sym_preproc_file_line,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(885), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21517] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(698), 1,
      sym_preproc_file_line,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1330), 2,
      sym_call_expression,
      sym_identifier,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21618] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(891), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(699), 2,
      sym_user_defined_operator,
      sym_preproc_file_line,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21715] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(842), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(700), 2,
      sym_user_defined_operator,
      sym_preproc_file_line,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21812] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1978), 1,
      aux_sym_logical_expression_token5,
    STATE(699), 1,
      sym_user_defined_operator,
    STATE(701), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(899), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1972), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1970), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [21911] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(702), 1,
      sym_preproc_file_line,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(967), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22010] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(703), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1004), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22109] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1988), 1,
      sym__end_of_statement,
    STATE(704), 1,
      sym_preproc_file_line,
    STATE(2415), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(1365), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [22188] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(705), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1171), 1,
      sym_number_literal,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1990), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1170), 5,
      sym_unary_expression,
      sym_call_expression,
      sym_complex_literal,
      sym_null_literal,
      sym_identifier,
    STATE(796), 8,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22291] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(931), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(706), 2,
      sym_user_defined_operator,
      sym_preproc_file_line,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22388] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(707), 1,
      sym_preproc_file_line,
    STATE(939), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22487] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(708), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1995), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1992), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [22554] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(709), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1007), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22653] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(710), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1203), 2,
      sym_call_expression,
      sym_identifier,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 12,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22754] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(711), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1080), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22853] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(712), 1,
      sym_preproc_file_line,
    STATE(971), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [22952] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(713), 1,
      sym_preproc_file_line,
    STATE(975), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23051] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(714), 1,
      sym_preproc_file_line,
    STATE(1039), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23150] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(715), 1,
      sym_preproc_file_line,
    STATE(976), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23249] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(716), 1,
      sym_preproc_file_line,
    STATE(977), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23348] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(717), 1,
      sym_preproc_file_line,
    STATE(978), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23447] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(718), 1,
      sym_preproc_file_line,
    STATE(979), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23546] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(719), 1,
      sym_preproc_file_line,
    STATE(980), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23645] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(720), 1,
      sym_preproc_file_line,
    STATE(1040), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23744] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(721), 1,
      sym_preproc_file_line,
    STATE(981), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23843] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(722), 1,
      sym_preproc_file_line,
    STATE(982), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [23942] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(723), 1,
      sym_preproc_file_line,
    STATE(1037), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24041] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(724), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(950), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1195), 3,
      sym_unary_expression,
      sym_number_literal,
      sym_identifier,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24142] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(725), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1680), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1678), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [24209] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(726), 1,
      sym_preproc_file_line,
    STATE(1012), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24308] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(727), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1061), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24407] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1554), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(1559), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(1561), 1,
      anon_sym_LBRACK,
    ACTIONS(1565), 1,
      aux_sym_null_literal_token1,
    ACTIONS(1752), 1,
      anon_sym_LPAREN,
    STATE(706), 1,
      sym_user_defined_operator,
    STATE(728), 1,
      sym_preproc_file_line,
    STATE(1092), 1,
      sym__expression,
    STATE(1127), 1,
      sym__array_constructor_legacy,
    STATE(1128), 1,
      sym__array_constructor_f2003,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1563), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1756), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1567), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1140), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24506] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(729), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(968), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1222), 3,
      sym_unary_expression,
      sym_number_literal,
      sym_identifier,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24607] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(730), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    STATE(1312), 1,
      sym_number_literal,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1998), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1331), 5,
      sym_unary_expression,
      sym_call_expression,
      sym_complex_literal,
      sym_null_literal,
      sym_identifier,
    STATE(796), 8,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24710] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(731), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(945), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24809] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(732), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1103), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [24908] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(733), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2000), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1168), 6,
      sym_unary_expression,
      sym_call_expression,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    STATE(796), 8,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25009] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(734), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1106), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25108] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(735), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2004), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2002), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [25175] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(736), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2008), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2006), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [25242] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(737), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1155), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1327), 4,
      sym_derived_type_member_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_identifier,
    STATE(796), 10,
      sym_parenthesized_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25343] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(738), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1087), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25442] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(739), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(926), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(1195), 3,
      sym_unary_expression,
      sym_number_literal,
      sym_identifier,
    STATE(796), 11,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_null_literal,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25543] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      aux_sym_logical_expression_token5,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(700), 1,
      sym_user_defined_operator,
    STATE(740), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(1111), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(55), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25642] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(741), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1692), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1690), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [25709] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(742), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(952), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25808] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(743), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(956), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [25907] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(744), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(957), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26006] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(745), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(958), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26105] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(746), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(959), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26204] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(747), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(999), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26303] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(748), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(961), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26402] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(749), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(962), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26501] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(750), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(963), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26600] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(145), 1,
      anon_sym_LPAREN_SLASH,
    ACTIONS(147), 1,
      anon_sym_LBRACK,
    ACTIONS(151), 1,
      aux_sym_null_literal_token1,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1650), 1,
      aux_sym_logical_expression_token5,
    STATE(650), 1,
      sym_user_defined_operator,
    STATE(751), 1,
      sym_preproc_file_line,
    STATE(807), 1,
      sym__array_constructor_legacy,
    STATE(820), 1,
      sym__array_constructor_f2003,
    STATE(964), 1,
      sym__expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(149), 2,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(1646), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(796), 14,
      sym_parenthesized_expression,
      sym_derived_type_member_expression,
      sym_logical_expression,
      sym_relational_expression,
      sym_concatenation_expression,
      sym_math_expression,
      sym_unary_expression,
      sym_call_expression,
      sym_implied_do_loop_expression,
      sym_array_literal,
      sym_complex_literal,
      sym_number_literal,
      sym_null_literal,
      sym_identifier,
    ACTIONS(107), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_identifier_token1,
  [26699] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(752), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2012), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2010), 40,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [26766] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(753), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1774), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 27,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      anon_sym_SLASH,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      anon_sym_STAR,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [26831] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2016), 1,
      anon_sym_COMMA,
    ACTIONS(2018), 1,
      anon_sym_COLON_COLON,
    STATE(754), 1,
      sym_preproc_file_line,
    STATE(1074), 1,
      sym_identifier,
    STATE(1165), 1,
      sym__import_names,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
    ACTIONS(2014), 27,
      aux_sym_end_program_statement_token1,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [26905] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2020), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2024), 1,
      aux_sym_end_interface_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    STATE(360), 1,
      sym_end_interface_statement,
    STATE(755), 1,
      sym_preproc_file_line,
    STATE(756), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27004] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2020), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2024), 1,
      aux_sym_end_interface_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    STATE(362), 1,
      sym_end_interface_statement,
    STATE(756), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27103] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2048), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2050), 1,
      aux_sym_end_interface_statement_token1,
    STATE(409), 1,
      sym_end_interface_statement,
    STATE(757), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27202] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2052), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2054), 1,
      aux_sym_end_interface_statement_token1,
    STATE(316), 1,
      sym_end_interface_statement,
    STATE(758), 1,
      sym_preproc_file_line,
    STATE(761), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27301] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2056), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2058), 1,
      aux_sym_end_interface_statement_token1,
    STATE(272), 1,
      sym_end_interface_statement,
    STATE(759), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27400] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2056), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2058), 1,
      aux_sym_end_interface_statement_token1,
    STATE(267), 1,
      sym_end_interface_statement,
    STATE(759), 1,
      aux_sym_interface_repeat1,
    STATE(760), 1,
      sym_preproc_file_line,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27499] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2052), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2054), 1,
      aux_sym_end_interface_statement_token1,
    STATE(321), 1,
      sym_end_interface_statement,
    STATE(761), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27598] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2060), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2062), 1,
      aux_sym_end_interface_statement_token1,
    STATE(386), 1,
      sym_end_interface_statement,
    STATE(762), 1,
      sym_preproc_file_line,
    STATE(765), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27697] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2064), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2066), 1,
      aux_sym_end_interface_statement_token1,
    STATE(569), 1,
      sym_end_interface_statement,
    STATE(763), 1,
      sym_preproc_file_line,
    STATE(764), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27796] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2064), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2066), 1,
      aux_sym_end_interface_statement_token1,
    STATE(573), 1,
      sym_end_interface_statement,
    STATE(764), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27895] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2060), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2062), 1,
      aux_sym_end_interface_statement_token1,
    STATE(389), 1,
      sym_end_interface_statement,
    STATE(765), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [27994] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2068), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2070), 1,
      aux_sym_end_interface_statement_token1,
    STATE(614), 1,
      sym_end_interface_statement,
    STATE(766), 1,
      sym_preproc_file_line,
    STATE(769), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28093] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2072), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2074), 1,
      aux_sym_end_interface_statement_token1,
    STATE(340), 1,
      sym_end_interface_statement,
    STATE(767), 1,
      sym_preproc_file_line,
    STATE(768), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28192] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2072), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2074), 1,
      aux_sym_end_interface_statement_token1,
    STATE(344), 1,
      sym_end_interface_statement,
    STATE(768), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28291] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2068), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2070), 1,
      aux_sym_end_interface_statement_token1,
    STATE(621), 1,
      sym_end_interface_statement,
    STATE(769), 1,
      sym_preproc_file_line,
    STATE(771), 1,
      aux_sym_interface_repeat1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28390] = 26,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2022), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2036), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2048), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2050), 1,
      aux_sym_end_interface_statement_token1,
    STATE(393), 1,
      sym_end_interface_statement,
    STATE(757), 1,
      aux_sym_interface_repeat1,
    STATE(770), 1,
      sym_preproc_file_line,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28489] = 24,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2076), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2078), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2081), 1,
      aux_sym_end_interface_statement_token1,
    ACTIONS(2083), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2089), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2092), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2095), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2098), 1,
      aux_sym_import_statement_token1,
    ACTIONS(2104), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2107), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2110), 1,
      aux_sym_derived_type_token1,
    STATE(857), 1,
      sym__procedure_kind,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2776), 1,
      sym_subroutine_statement,
    STATE(2777), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(771), 2,
      sym_preproc_file_line,
      aux_sym_interface_repeat1,
    ACTIONS(2113), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1182), 4,
      sym_subroutine,
      sym_function,
      sym_import_statement,
      sym_procedure_statement,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2086), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
    ACTIONS(2101), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [28583] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2116), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2125), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2128), 1,
      aux_sym_select_case_statement_token1,
    STATE(596), 1,
      sym__name,
    STATE(612), 1,
      sym_identifier,
    STATE(772), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2122), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    ACTIONS(2118), 16,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    ACTIONS(2120), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28650] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2130), 1,
      anon_sym_LPAREN,
    ACTIONS(2132), 1,
      anon_sym_STAR,
    STATE(773), 1,
      sym_preproc_file_line,
    STATE(818), 1,
      sym_size,
    STATE(831), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1780), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1776), 23,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28712] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2136), 1,
      anon_sym_COMMA,
    STATE(774), 1,
      sym_preproc_file_line,
    STATE(786), 1,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2139), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2134), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28768] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2143), 1,
      anon_sym_COMMA,
    STATE(775), 1,
      sym_preproc_file_line,
    STATE(776), 1,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2146), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2141), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28824] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2150), 1,
      anon_sym_COMMA,
    STATE(776), 1,
      sym_preproc_file_line,
    STATE(786), 1,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2153), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2148), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2157), 1,
      anon_sym_LPAREN,
    STATE(823), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(777), 2,
      sym_preproc_file_line,
      aux_sym_call_expression_repeat1,
    ACTIONS(2155), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2160), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [28936] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(778), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1948), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1946), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [28988] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2164), 1,
      anon_sym_COMMA,
    STATE(779), 1,
      sym_preproc_file_line,
    STATE(786), 1,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2167), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2162), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29044] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(780), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1944), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1942), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29096] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(781), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1952), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1950), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29148] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2171), 1,
      anon_sym_COMMA,
    STATE(779), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(782), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2174), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2169), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29204] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(783), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1578), 13,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_STAR,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1573), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29256] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2130), 1,
      anon_sym_LPAREN,
    STATE(784), 1,
      sym_preproc_file_line,
    STATE(816), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1436), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1431), 23,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29312] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2178), 1,
      anon_sym_COMMA,
    STATE(774), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(785), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2181), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2176), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29368] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(786), 2,
      sym_preproc_file_line,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(2188), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2183), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29422] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2192), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(787), 2,
      sym_preproc_file_line,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2195), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2190), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29476] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(788), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1772), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1774), 30,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym__block_if_statement_token1,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29528] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(777), 1,
      aux_sym_call_expression_repeat1,
    STATE(789), 1,
      sym_preproc_file_line,
    STATE(823), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2197), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2199), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29584] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(790), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2201), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2203), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29635] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(791), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2205), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2207), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29686] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(792), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2209), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2211), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29737] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(793), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2213), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2215), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29788] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(794), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1680), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1678), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29839] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(795), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2219), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2217), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29890] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(796), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [29941] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(797), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1995), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1992), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [29992] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(798), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1692), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1690), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30043] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(799), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2195), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2190), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30094] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(800), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2225), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2227), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [30145] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(801), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1688), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1686), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30196] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(802), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2231), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2229), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30247] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2235), 1,
      anon_sym_LPAREN,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    STATE(803), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2241), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2233), 23,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30302] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(804), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2243), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2245), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [30353] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(805), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2249), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2247), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30404] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(806), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2253), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2251), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30455] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(807), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2255), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2257), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [30506] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(808), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1660), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1658), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30557] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(809), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1436), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1431), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30608] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(810), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1540), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1542), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [30659] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(811), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1664), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1662), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30710] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(812), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2004), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2002), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30761] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
    STATE(813), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2146), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2141), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30814] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(814), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2008), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2006), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30865] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(815), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2188), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2183), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30916] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(816), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1670), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1668), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [30967] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(817), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2264), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_SLASH_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_boolean_literal,
    ACTIONS(2262), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31018] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(818), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2012), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2010), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31069] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(819), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2268), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2266), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31120] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(820), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2255), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2257), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [31171] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(821), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2270), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2272), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [31222] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(822), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2276), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2274), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31273] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(823), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2278), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2280), 29,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [31324] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2282), 1,
      anon_sym_LPAREN,
    STATE(824), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 28,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [31377] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(825), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1962), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1960), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31428] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(826), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1966), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1964), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31479] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(827), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2286), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2284), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31530] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(828), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1982), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1980), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31581] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2290), 1,
      anon_sym_COMMA,
    STATE(829), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2293), 11,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2288), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31634] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(830), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1986), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1984), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31685] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(831), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1958), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1956), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31736] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(832), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2297), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2295), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31787] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(833), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1700), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1698), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31838] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(834), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1696), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(1694), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31889] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(835), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2268), 12,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2266), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [31940] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(836), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [32014] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(837), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [32086] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(838), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32148] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(839), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2323), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32212] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(840), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [32288] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(841), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2329), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2327), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32356] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(842), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2333), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2331), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32414] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(843), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2337), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2335), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32482] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(844), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32542] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(845), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2323), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2321), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [32620] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(846), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
    ACTIONS(2341), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_GT_GT_GT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [32692] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_submodule_statement_token1,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2834), 1,
      sym_module_procedure_statement,
    STATE(2850), 1,
      sym_subroutine_statement,
    STATE(2851), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(847), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1714), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [32775] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(848), 1,
      sym_preproc_file_line,
    STATE(853), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2869), 1,
      sym_module_procedure_statement,
    STATE(2883), 1,
      sym_subroutine_statement,
    STATE(2884), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1567), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [32860] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2387), 1,
      anon_sym_COLON_COLON,
    STATE(849), 1,
      sym_preproc_file_line,
    STATE(874), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(1038), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2690), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [32935] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(850), 1,
      sym_preproc_file_line,
    STATE(864), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2846), 1,
      sym_module_procedure_statement,
    STATE(2862), 1,
      sym_subroutine_statement,
    STATE(2863), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1667), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33020] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2393), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(851), 1,
      sym_preproc_file_line,
    STATE(865), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(1767), 1,
      sym_identifier,
    STATE(1781), 1,
      sym_method_name,
    STATE(2374), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [33095] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_submodule_statement_token1,
    STATE(852), 1,
      sym_preproc_file_line,
    STATE(882), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2834), 1,
      sym_module_procedure_statement,
    STATE(2850), 1,
      sym_subroutine_statement,
    STATE(2851), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1714), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33180] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(853), 1,
      sym_preproc_file_line,
    STATE(859), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2869), 1,
      sym_module_procedure_statement,
    STATE(2883), 1,
      sym_subroutine_statement,
    STATE(2884), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1567), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33265] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2405), 1,
      anon_sym_COLON_COLON,
    STATE(854), 1,
      sym_preproc_file_line,
    STATE(1057), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(1186), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(2599), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [33340] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_program_statement_token2,
    STATE(855), 1,
      sym_preproc_file_line,
    STATE(858), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2476), 1,
      sym_module_procedure_statement,
    STATE(2820), 1,
      sym_subroutine_statement,
    STATE(2821), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1631), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33425] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_function_statement_token1,
    STATE(856), 1,
      sym_preproc_file_line,
    STATE(866), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2858), 1,
      sym_module_procedure_statement,
    STATE(2873), 1,
      sym_subroutine_statement,
    STATE(2874), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1692), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33510] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2407), 1,
      anon_sym_LPAREN,
    ACTIONS(2409), 1,
      anon_sym_COMMA,
    ACTIONS(2411), 1,
      anon_sym_COLON_COLON,
    STATE(857), 1,
      sym_preproc_file_line,
    STATE(1083), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2709), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [33585] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_program_statement_token2,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2476), 1,
      sym_module_procedure_statement,
    STATE(2820), 1,
      sym_subroutine_statement,
    STATE(2821), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(858), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1631), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33668] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_module_procedure_statement_token1,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2869), 1,
      sym_module_procedure_statement,
    STATE(2883), 1,
      sym_subroutine_statement,
    STATE(2884), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(859), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1567), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33751] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_function_statement_token1,
    STATE(856), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(860), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2858), 1,
      sym_module_procedure_statement,
    STATE(2873), 1,
      sym_subroutine_statement,
    STATE(2874), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1692), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33836] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2413), 1,
      anon_sym_LPAREN,
    ACTIONS(2415), 1,
      anon_sym_COMMA,
    ACTIONS(2417), 1,
      anon_sym_COLON_COLON,
    STATE(861), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1789), 1,
      sym_method_name,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2737), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [33911] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_module_statement_token1,
    STATE(862), 1,
      sym_preproc_file_line,
    STATE(869), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2798), 1,
      sym_module_procedure_statement,
    STATE(2838), 1,
      sym_subroutine_statement,
    STATE(2839), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1643), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [33996] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2379), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2383), 1,
      aux_sym_end_program_statement_token2,
    STATE(855), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(863), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2476), 1,
      sym_module_procedure_statement,
    STATE(2820), 1,
      sym_subroutine_statement,
    STATE(2821), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1631), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [34081] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(864), 1,
      sym_preproc_file_line,
    STATE(867), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2846), 1,
      sym_module_procedure_statement,
    STATE(2862), 1,
      sym_subroutine_statement,
    STATE(2863), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1667), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [34166] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2419), 1,
      anon_sym_COLON_COLON,
    STATE(865), 1,
      sym_preproc_file_line,
    STATE(1186), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(1766), 1,
      sym_method_name,
    STATE(1767), 1,
      sym_identifier,
    STATE(2375), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34241] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_function_statement_token1,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2858), 1,
      sym_module_procedure_statement,
    STATE(2873), 1,
      sym_subroutine_statement,
    STATE(2874), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(866), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1692), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [34324] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_subroutine_statement_token1,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2846), 1,
      sym_module_procedure_statement,
    STATE(2862), 1,
      sym_subroutine_statement,
    STATE(2863), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(867), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1667), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [34407] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2421), 1,
      anon_sym_COLON_COLON,
    STATE(868), 1,
      sym_preproc_file_line,
    STATE(879), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(1751), 1,
      sym_method_name,
    STATE(1767), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2889), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34482] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_module_statement_token1,
    STATE(869), 1,
      sym_preproc_file_line,
    STATE(881), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2798), 1,
      sym_module_procedure_statement,
    STATE(2838), 1,
      sym_subroutine_statement,
    STATE(2839), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1643), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [34567] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(870), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    STATE(2707), 1,
      sym__intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2706), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34636] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(871), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    STATE(2715), 1,
      sym__intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2711), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34705] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(872), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    STATE(2747), 1,
      sym__intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2742), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34774] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2427), 1,
      anon_sym_COLON_COLON,
    STATE(854), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(873), 1,
      sym_preproc_file_line,
    STATE(1050), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2780), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34849] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2429), 1,
      anon_sym_COLON_COLON,
    STATE(874), 1,
      sym_preproc_file_line,
    STATE(1084), 1,
      sym_identifier,
    STATE(1120), 1,
      sym_method_name,
    STATE(1186), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(2418), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34924] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2431), 1,
      anon_sym_COMMA,
    ACTIONS(2433), 1,
      aux_sym_while_statement_token1,
    ACTIONS(2435), 1,
      aux_sym_concurrent_header_token1,
    ACTIONS(2437), 1,
      sym__integer_literal,
    ACTIONS(2439), 1,
      sym__end_of_statement,
    STATE(875), 1,
      sym_preproc_file_line,
    STATE(1389), 1,
      sym_statement_label_reference,
    STATE(1473), 1,
      sym_statement_label,
    STATE(1824), 1,
      sym_concurrent_header,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2623), 3,
      sym_while_statement,
      sym_concurrent_statement,
      sym_loop_control_expression,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [34997] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(876), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2403), 1,
      sym__intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2402), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35066] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(877), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2405), 1,
      sym__intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2404), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35135] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2425), 1,
      anon_sym_STAR,
    STATE(878), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2615), 1,
      sym__intrinsic_type,
    STATE(2699), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2601), 2,
      sym__type_name,
      sym_unlimited_polymorphic,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35204] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2441), 1,
      anon_sym_COLON_COLON,
    STATE(879), 1,
      sym_preproc_file_line,
    STATE(1186), 1,
      aux_sym_procedure_statement_repeat1,
    STATE(1767), 1,
      sym_identifier,
    STATE(1780), 1,
      sym_method_name,
    STATE(2363), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35279] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(880), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2445), 10,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
      sym_string_literal,
      anon_sym_DASH,
      aux_sym_logical_expression_token5,
      anon_sym_PLUS,
      anon_sym_LPAREN_SLASH,
      anon_sym_LBRACK,
      sym_boolean_literal,
    ACTIONS(2443), 24,
      aux_sym_end_program_statement_token1,
      anon_sym_LPAREN,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      anon_sym_DOT,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35328] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2345), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2347), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2350), 1,
      aux_sym_end_module_statement_token1,
    ACTIONS(2352), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2355), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2358), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2361), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2367), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2370), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2373), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2798), 1,
      sym_module_procedure_statement,
    STATE(2838), 1,
      sym_subroutine_statement,
    STATE(2839), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(881), 2,
      sym_preproc_file_line,
      aux_sym_internal_procedures_repeat1,
    STATE(1643), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2376), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2364), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [35411] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2026), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(2030), 1,
      aux_sym_function_statement_token1,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(2381), 1,
      aux_sym_module_statement_token1,
    ACTIONS(2401), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2403), 1,
      aux_sym_end_submodule_statement_token1,
    STATE(847), 1,
      aux_sym_internal_procedures_repeat1,
    STATE(882), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      aux_sym__callable_interface_qualifers,
    STATE(2834), 1,
      sym_module_procedure_statement,
    STATE(2850), 1,
      sym_subroutine_statement,
    STATE(2851), 1,
      sym_function_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1714), 3,
      sym_subroutine,
      sym_module_procedure,
      sym_function,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [35496] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2447), 1,
      anon_sym_COMMA,
    ACTIONS(2449), 1,
      anon_sym_COLON_COLON,
    STATE(883), 1,
      sym_preproc_file_line,
    STATE(1084), 1,
      sym_identifier,
    STATE(1119), 1,
      sym_method_name,
    STATE(2413), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35568] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2451), 1,
      anon_sym_COMMA,
    ACTIONS(2453), 1,
      anon_sym_COLON_COLON,
    STATE(884), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1776), 1,
      sym_method_name,
    STATE(2362), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35640] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(885), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 6,
      aux_sym_end_program_statement_token1,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 21,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [35697] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(886), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      aux_sym_end_program_statement_token1,
      anon_sym_DOT,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 7,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [35766] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2469), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2471), 1,
      aux_sym_logical_expression_token2,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(887), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      aux_sym_end_program_statement_token1,
      anon_sym_DOT,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 5,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [35839] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    STATE(888), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(2005), 1,
      sym_concurrent_control,
    STATE(2390), 1,
      sym__intrinsic_type,
    STATE(2397), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [35904] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(889), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2329), 4,
      aux_sym_end_program_statement_token1,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2327), 17,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [35969] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(890), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2337), 4,
      aux_sym_end_program_statement_token1,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2335), 17,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36034] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(891), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2333), 6,
      aux_sym_end_program_statement_token1,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2331), 22,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [36089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(892), 1,
      sym_preproc_file_line,
    STATE(895), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2197), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2199), 24,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [36140] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2477), 1,
      anon_sym_RPAREN,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(893), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2099), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36221] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2499), 1,
      anon_sym_RPAREN,
    ACTIONS(2501), 1,
      anon_sym_COMMA,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(894), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2092), 1,
      aux_sym_case_value_range_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36302] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2503), 1,
      anon_sym_LPAREN,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(895), 2,
      sym_preproc_file_line,
      aux_sym_call_expression_repeat1,
    ACTIONS(2155), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2160), 23,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [36353] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2506), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(896), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2067), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36434] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(897), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 26,
      sym__end_of_statement,
      anon_sym_LPAREN,
      aux_sym_language_binding_token1,
      anon_sym_COMMA,
      aux_sym_function_result_token1,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [36481] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(898), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2323), 4,
      aux_sym_end_program_statement_token1,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [36542] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2469), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2471), 1,
      aux_sym_logical_expression_token2,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(899), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 2,
      aux_sym_end_program_statement_token1,
      anon_sym_DOT,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2321), 3,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36617] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2471), 1,
      aux_sym_logical_expression_token2,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(900), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2303), 2,
      aux_sym_end_program_statement_token1,
      anon_sym_DOT,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 6,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36688] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2512), 1,
      anon_sym_DOT,
    STATE(668), 1,
      sym_user_defined_operator,
    STATE(901), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2510), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2905), 3,
      sym_unary_expression,
      sym_number_literal,
      sym_identifier,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [36749] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(902), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1353), 26,
      sym__end_of_statement,
      anon_sym_LPAREN,
      aux_sym_language_binding_token1,
      anon_sym_COMMA,
      aux_sym_function_result_token1,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [36796] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(903), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2514), 4,
      anon_sym_COMMA,
      anon_sym_GT_GT_GT,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [36871] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2512), 1,
      anon_sym_DOT,
    STATE(668), 1,
      sym_user_defined_operator,
    STATE(904), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2510), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
    STATE(2802), 3,
      sym_unary_expression,
      sym_number_literal,
      sym_identifier,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [36932] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2516), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(905), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2124), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37013] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2333), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2469), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2471), 1,
      aux_sym_logical_expression_token2,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(906), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2331), 3,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37090] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(907), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2124), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37171] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(908), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2173), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37252] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(909), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2151), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37333] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(910), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 6,
      aux_sym_end_program_statement_token1,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [37392] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(911), 1,
      sym_preproc_file_line,
    STATE(1907), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2526), 2,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37471] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2528), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(912), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2151), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37552] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2530), 1,
      aux_sym_intrinsic_type_token5,
    ACTIONS(2532), 1,
      aux_sym_intrinsic_type_token7,
    STATE(913), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 24,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [37603] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2534), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(914), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(2067), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37684] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(915), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 26,
      sym__end_of_statement,
      anon_sym_LPAREN,
      aux_sym_language_binding_token1,
      anon_sym_COMMA,
      aux_sym_function_result_token1,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [37731] = 22,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2536), 1,
      anon_sym_RPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(916), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(1967), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37812] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2455), 1,
      anon_sym_PERCENT,
    ACTIONS(2465), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2467), 1,
      anon_sym_STAR_STAR,
    STATE(701), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(917), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2343), 2,
      aux_sym_end_program_statement_token1,
      anon_sym_DOT,
    ACTIONS(2457), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2459), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2461), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2341), 7,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2463), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37881] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(918), 1,
      sym_preproc_file_line,
    STATE(1918), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2538), 2,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [37960] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(919), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 26,
      sym__end_of_statement,
      anon_sym_LPAREN,
      aux_sym_language_binding_token1,
      anon_sym_COMMA,
      aux_sym_function_result_token1,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [38007] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    STATE(920), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2684), 2,
      sym__intrinsic_type,
      sym_identifier,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38067] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2546), 1,
      sym__end_of_statement,
    STATE(921), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2411), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38131] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2548), 1,
      sym__end_of_statement,
    STATE(922), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2714), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38195] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(923), 1,
      sym_preproc_file_line,
    STATE(1057), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2599), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38261] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(924), 1,
      sym_preproc_file_line,
    STATE(1084), 1,
      sym_identifier,
    STATE(1104), 1,
      sym_method_name,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2774), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38327] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2574), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(925), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1929), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [38405] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    ACTIONS(2578), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(926), 1,
      sym_preproc_file_line,
    STATE(2288), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [38483] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(927), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1780), 1,
      sym_method_name,
    STATE(2363), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38549] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2590), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(634), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(928), 1,
      sym_preproc_file_line,
    STATE(1102), 1,
      sym_public_statement,
    STATE(1180), 1,
      sym_private_statement,
    STATE(1299), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2053), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [38635] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(929), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1768), 1,
      sym_method_name,
    STATE(2370), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38701] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2594), 1,
      sym__end_of_statement,
    STATE(930), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2613), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38765] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(931), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2333), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2331), 22,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [38819] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2596), 1,
      sym__end_of_statement,
    STATE(932), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2741), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38883] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2598), 1,
      sym__end_of_statement,
    STATE(933), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2735), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [38947] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2602), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(299), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(934), 1,
      sym_preproc_file_line,
    STATE(1115), 1,
      sym_public_statement,
    STATE(1202), 1,
      sym_private_statement,
    STATE(1277), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2138), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [39033] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    STATE(935), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2422), 2,
      sym__intrinsic_type,
      sym_identifier,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39093] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2606), 1,
      sym__end_of_statement,
    STATE(936), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2752), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39157] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2608), 1,
      sym__end_of_statement,
    STATE(937), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2434), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39221] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2612), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(318), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(938), 1,
      sym_preproc_file_line,
    STATE(1116), 1,
      sym_public_statement,
    STATE(1210), 1,
      sym_private_statement,
    STATE(1295), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2165), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [39307] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2343), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(939), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2341), 7,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [39375] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(2618), 1,
      anon_sym_STAR,
    ACTIONS(2620), 1,
      sym__end_of_statement,
    STATE(940), 1,
      sym_preproc_file_line,
    STATE(2155), 1,
      aux_sym__declaration_targets_repeat1,
    STATE(2158), 1,
      sym_character_length,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [39431] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(941), 1,
      sym_preproc_file_line,
    STATE(1758), 1,
      sym_method_name,
    STATE(1767), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2819), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39497] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2622), 1,
      sym__end_of_statement,
    STATE(942), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2630), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39561] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    STATE(943), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2424), 2,
      sym__intrinsic_type,
      sym_identifier,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39621] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2624), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2626), 1,
      aux_sym_select_case_statement_token2,
    ACTIONS(2628), 1,
      aux_sym_select_rank_statement_token1,
    STATE(944), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1353), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [39673] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2630), 1,
      anon_sym_COLON,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(945), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2632), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [39749] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2634), 1,
      sym__end_of_statement,
    STATE(946), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2561), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39813] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2636), 1,
      sym__end_of_statement,
    STATE(947), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2489), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39877] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(948), 1,
      sym_preproc_file_line,
    STATE(1084), 1,
      sym_identifier,
    STATE(1120), 1,
      sym_method_name,
    STATE(2418), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [39943] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2638), 1,
      sym__end_of_statement,
    STATE(949), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2649), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [40007] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2578), 1,
      anon_sym_COMMA,
    ACTIONS(2640), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(950), 1,
      sym_preproc_file_line,
    STATE(2288), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40085] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(951), 1,
      sym_preproc_file_line,
    STATE(1084), 1,
      sym_identifier,
    STATE(1157), 1,
      sym_method_name,
    STATE(2500), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [40151] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2343), 1,
      anon_sym_DOT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(952), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2341), 7,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40219] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(953), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1779), 1,
      sym_method_name,
    STATE(2376), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [40285] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(954), 1,
      sym_preproc_file_line,
    STATE(1766), 1,
      sym_method_name,
    STATE(1767), 1,
      sym_identifier,
    STATE(2375), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [40351] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2433), 1,
      aux_sym_while_statement_token1,
    ACTIONS(2435), 1,
      aux_sym_concurrent_header_token1,
    ACTIONS(2642), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      sym__end_of_statement,
    STATE(955), 1,
      sym_preproc_file_line,
    STATE(1824), 1,
      sym_concurrent_header,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2459), 3,
      sym_while_statement,
      sym_concurrent_statement,
      sym_loop_control_expression,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [40415] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(956), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [40473] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(957), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2323), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [40533] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(958), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 6,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40603] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(959), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 7,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40671] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(960), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2646), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40747] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(961), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2329), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2327), 17,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40811] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(962), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2337), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2335), 17,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [40875] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(963), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 21,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [40931] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2323), 1,
      anon_sym_DOT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(964), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41005] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2648), 1,
      sym__end_of_statement,
    STATE(965), 1,
      sym_preproc_file_line,
    STATE(1911), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2084), 2,
      sym__generic_procedure,
      sym_use_alias,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [41069] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2650), 1,
      anon_sym_COLON,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(966), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2652), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41145] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2654), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(2656), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(967), 1,
      sym_preproc_file_line,
    STATE(1159), 1,
      sym_argument_list,
    STATE(2238), 1,
      sym_cuda_kernel_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41223] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    ACTIONS(2658), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(968), 1,
      sym_preproc_file_line,
    STATE(2352), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41301] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2660), 1,
      sym__end_of_statement,
    STATE(969), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2579), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [41365] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2664), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(368), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(970), 1,
      sym_preproc_file_line,
    STATE(1114), 1,
      sym_public_statement,
    STATE(1201), 1,
      sym_private_statement,
    STATE(1281), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2145), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [41451] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(971), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [41509] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(972), 1,
      sym_preproc_file_line,
    STATE(1042), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2457), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [41575] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(973), 1,
      sym_preproc_file_line,
    STATE(1045), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2478), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [41641] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(974), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1790), 1,
      sym_method_name,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2890), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [41707] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(975), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2323), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 20,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
  [41767] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(976), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 6,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41837] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(977), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 7,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41905] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(978), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 5,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [41977] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(979), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2329), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2327), 17,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42041] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(980), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2337), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2335), 17,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42105] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(981), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2323), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2321), 21,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [42161] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2323), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(982), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2321), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_LT_LT_LT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42235] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    STATE(983), 1,
      sym_preproc_file_line,
    STATE(1063), 1,
      sym_method_name,
    STATE(1084), 1,
      sym_identifier,
    STATE(2658), 1,
      sym__generic_procedure,
    STATE(2753), 1,
      sym_binding_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1909), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(107), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [42301] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    ACTIONS(2668), 1,
      anon_sym_GT_GT_GT,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(984), 1,
      sym_preproc_file_line,
    STATE(2219), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42379] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2670), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(985), 1,
      sym_preproc_file_line,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1928), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42457] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2672), 1,
      sym__end_of_statement,
    STATE(986), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2745), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [42521] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1601), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1603), 1,
      aux_sym_intrinsic_type_token8,
    STATE(987), 1,
      sym_preproc_file_line,
    STATE(1371), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2423), 2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
    STATE(2660), 2,
      sym__intrinsic_type,
      sym_identifier,
    ACTIONS(1599), 5,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
    ACTIONS(107), 17,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [42581] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2475), 1,
      anon_sym_COLON,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(988), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2674), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42657] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2676), 1,
      anon_sym_COLON,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(989), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2678), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [42733] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2682), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(403), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(990), 1,
      sym_preproc_file_line,
    STATE(1113), 1,
      sym_public_statement,
    STATE(1198), 1,
      sym_private_statement,
    STATE(1262), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2112), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [42819] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2686), 1,
      sym__end_of_statement,
    STATE(991), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2816), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [42883] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2690), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(342), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(992), 1,
      sym_preproc_file_line,
    STATE(1118), 1,
      sym_public_statement,
    STATE(1214), 1,
      sym_private_statement,
    STATE(1309), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2187), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [42969] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2694), 1,
      sym__end_of_statement,
    STATE(993), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2696), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [43033] = 25,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2698), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(619), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(994), 1,
      sym_preproc_file_line,
    STATE(1110), 1,
      sym_public_statement,
    STATE(1190), 1,
      sym_private_statement,
    STATE(1241), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2086), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [43119] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    ACTIONS(2702), 1,
      sym__end_of_statement,
    STATE(995), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2508), 2,
      sym__generic_procedure,
      sym__name,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [43183] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1738), 1,
      anon_sym_COLON,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(996), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1740), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43259] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1905), 1,
      aux_sym_assignment_token1,
    ACTIONS(1907), 1,
      aux_sym_operator_token1,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(997), 1,
      sym_preproc_file_line,
    STATE(1767), 1,
      sym_identifier,
    STATE(1771), 1,
      sym_method_name,
    STATE(2371), 1,
      sym_binding_name,
    STATE(2658), 1,
      sym__generic_procedure,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2391), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1142), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [43325] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(998), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2333), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2331), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [43379] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2303), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(999), 1,
      sym_preproc_file_line,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2301), 5,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43451] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2704), 1,
      aux_sym_intrinsic_type_token5,
    ACTIONS(2706), 1,
      aux_sym_intrinsic_type_token7,
    STATE(1000), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [43500] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1001), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2708), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43573] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1002), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2278), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2280), 24,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [43618] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2710), 1,
      anon_sym_LPAREN,
    STATE(1003), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1365), 27,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [43665] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1004), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2712), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43738] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2714), 1,
      anon_sym_COMMA,
    ACTIONS(2716), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1005), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43813] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    STATE(1006), 1,
      sym_preproc_file_line,
    STATE(2147), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2298), 2,
      sym__generic_procedure,
      sym_use_alias,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [43874] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1007), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2718), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [43947] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2720), 1,
      anon_sym_COMMA,
    ACTIONS(2722), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1008), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44022] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1009), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2724), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44095] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1010), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2726), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44168] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2728), 1,
      anon_sym_RPAREN,
    ACTIONS(2730), 1,
      anon_sym_EQ_GT,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1011), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44243] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1012), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2514), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44316] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2732), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    STATE(1013), 2,
      sym_preproc_file_line,
      aux_sym_parameters_repeat1,
    ACTIONS(2734), 26,
      aux_sym_module_statement_token1,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [44363] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(1840), 1,
      anon_sym_COMMA,
    ACTIONS(1842), 1,
      sym__end_of_statement,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1014), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44438] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    ACTIONS(2739), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1015), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44513] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2741), 1,
      anon_sym_LPAREN,
    STATE(823), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1016), 2,
      sym_preproc_file_line,
      aux_sym_call_expression_repeat1,
    ACTIONS(2155), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2160), 22,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [44562] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1017), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1678), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1680), 24,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [44607] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1018), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2744), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44680] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1019), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2746), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [44753] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2433), 1,
      aux_sym_while_statement_token1,
    ACTIONS(2435), 1,
      aux_sym_concurrent_header_token1,
    ACTIONS(2748), 1,
      sym__end_of_statement,
    STATE(1020), 1,
      sym_preproc_file_line,
    STATE(1824), 1,
      sym_concurrent_header,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2542), 3,
      sym_while_statement,
      sym_concurrent_statement,
      sym_loop_control_expression,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [44814] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1021), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1690), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1692), 24,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [44859] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1022), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1686), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1688), 24,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [44904] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1023), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1359), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1361), 28,
      aux_sym_module_statement_token1,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      anon_sym_SLASH,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [44949] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(823), 1,
      sym_argument_list,
    STATE(1016), 1,
      aux_sym_call_expression_repeat1,
    STATE(1024), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2197), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2199), 23,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [44998] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1025), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 23,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45043] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1026), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 23,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45088] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1027), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 23,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45133] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1028), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 7,
      aux_sym_end_program_statement_token1,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1353), 23,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45178] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2750), 1,
      aux_sym_intrinsic_type_token5,
    ACTIONS(2752), 1,
      aux_sym_intrinsic_type_token7,
    STATE(1029), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1349), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45227] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2754), 1,
      anon_sym_EQ,
    ACTIONS(2756), 1,
      anon_sym_EQ_GT,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1030), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45302] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2618), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_preproc_file_line,
    STATE(2345), 1,
      sym_character_length,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2758), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45353] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1032), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2760), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45426] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(2620), 1,
      sym__end_of_statement,
    STATE(1033), 1,
      sym_preproc_file_line,
    STATE(2155), 1,
      aux_sym__declaration_targets_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [45477] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1034), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2652), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45550] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1035), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2762), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45623] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2433), 1,
      aux_sym_while_statement_token1,
    ACTIONS(2435), 1,
      aux_sym_concurrent_header_token1,
    ACTIONS(2644), 1,
      sym__end_of_statement,
    STATE(1036), 1,
      sym_preproc_file_line,
    STATE(1824), 1,
      sym_concurrent_header,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2459), 3,
      sym_while_statement,
      sym_concurrent_statement,
      sym_loop_control_expression,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [45684] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2764), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1037), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45756] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1038), 1,
      sym_preproc_file_line,
    STATE(1123), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2766), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2768), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [45804] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2772), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1039), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45876] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2774), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1040), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [45948] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2776), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1041), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [46020] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      sym_preproc_file_line,
    STATE(1051), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2778), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2780), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46068] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1043), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2778), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2780), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46116] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1044), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2782), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2784), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46164] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1045), 1,
      sym_preproc_file_line,
    STATE(1053), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2782), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2784), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46212] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2786), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1046), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [46284] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2788), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1047), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [46356] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2790), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1048), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [46428] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_EQ,
    STATE(1049), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 23,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [46474] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1050), 1,
      sym_preproc_file_line,
    STATE(1058), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2794), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2796), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46522] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1051), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2794), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2796), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46570] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1052), 1,
      sym_preproc_file_line,
    STATE(1059), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2798), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2800), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46618] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1053), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2798), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2800), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46666] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1054), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2766), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2768), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46714] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2802), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1055), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [46786] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2804), 1,
      aux_sym_do_loop_statement_token1,
    STATE(1056), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [46832] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1057), 1,
      sym_preproc_file_line,
    STATE(1062), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2806), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2808), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1058), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2806), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2808), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46928] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1059), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2810), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2812), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [46976] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1060), 1,
      sym_preproc_file_line,
    STATE(1064), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2810), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2812), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47024] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1061), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [47096] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1062), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2816), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2818), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47144] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1063), 1,
      sym_preproc_file_line,
    STATE(1066), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2816), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2818), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47192] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1064), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2820), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2822), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47240] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1065), 1,
      sym_preproc_file_line,
    STATE(1067), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2824), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2826), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47288] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1066), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2824), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2826), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47336] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1067), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2828), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2830), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47384] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1068), 1,
      sym_preproc_file_line,
    STATE(1069), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2828), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2830), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47432] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      sym_preproc_file_line,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2832), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2834), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47480] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1575), 1,
      anon_sym_STAR,
    ACTIONS(1578), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1580), 1,
      anon_sym_LPAREN,
    STATE(1070), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 4,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 22,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [47530] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2282), 1,
      anon_sym_LPAREN,
    STATE(1071), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 22,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [47576] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2840), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2836), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    STATE(1072), 2,
      sym_preproc_file_line,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(2838), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47622] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2843), 1,
      aux_sym_block_construct_token1,
    STATE(1073), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [47668] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1074), 1,
      sym_preproc_file_line,
    STATE(1078), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2845), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2847), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47716] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    STATE(1075), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2095), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [47774] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    STATE(1076), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2100), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [47832] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      sym_preproc_file_line,
    STATE(1082), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2851), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2853), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47880] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameters_repeat1,
    STATE(1078), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2851), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2853), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [47928] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2640), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1079), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48000] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2746), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1080), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48072] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1081), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2732), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2734), 27,
      aux_sym_module_statement_token1,
      anon_sym_RPAREN,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [48116] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameters_repeat1,
    STATE(1082), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2855), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2857), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [48164] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1083), 1,
      sym_preproc_file_line,
    STATE(1108), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2859), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2861), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [48212] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2867), 1,
      anon_sym_EQ_GT,
    STATE(1084), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2863), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2865), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [48258] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2869), 1,
      sym__end_of_statement,
    STATE(1085), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [48304] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1013), 1,
      aux_sym_parameters_repeat1,
    STATE(1086), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2871), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2873), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [48352] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2790), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1087), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48424] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2331), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1088), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48496] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2875), 1,
      aux_sym__forall_control_expression_token1,
    STATE(1089), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [48542] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2877), 1,
      anon_sym_COLON,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(1090), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48614] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2879), 1,
      aux_sym_stop_statement_token2,
    STATE(1091), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [48660] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2881), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1092), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48732] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2883), 1,
      anon_sym_LPAREN,
    STATE(503), 1,
      sym__io_arguments,
    STATE(1093), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 21,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [48780] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1094), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1544), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1540), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1542), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [48826] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2540), 1,
      aux_sym_assignment_token1,
    ACTIONS(2542), 1,
      aux_sym_operator_token1,
    STATE(1095), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2544), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(2297), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(2259), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(1443), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [48884] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2885), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1096), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [48956] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2473), 1,
      anon_sym_LPAREN,
    ACTIONS(2485), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2487), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2495), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2497), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2887), 1,
      anon_sym_COLON,
    STATE(751), 1,
      sym_user_defined_operator,
    STATE(823), 1,
      sym_argument_list,
    STATE(1024), 1,
      aux_sym_call_expression_repeat1,
    STATE(1097), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2481), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2483), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2489), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2491), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [49028] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2889), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1098), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [49100] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2891), 1,
      aux_sym__inline_where_statement_token1,
    STATE(1099), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [49146] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2893), 1,
      aux_sym_assignment_token1,
    ACTIONS(2895), 1,
      aux_sym_operator_token1,
    STATE(1100), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2897), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1466), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(1479), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [49204] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2893), 1,
      aux_sym_assignment_token1,
    ACTIONS(2895), 1,
      aux_sym_operator_token1,
    STATE(1101), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2897), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1410), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(1479), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [49262] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2899), 1,
      aux_sym_derived_type_definition_token1,
    STATE(641), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1102), 1,
      sym_preproc_file_line,
    STATE(1183), 1,
      sym_private_statement,
    STATE(1320), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2063), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [49342] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2901), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [49414] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1054), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1104), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2903), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2905), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [49462] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(2893), 1,
      aux_sym_assignment_token1,
    ACTIONS(2895), 1,
      aux_sym_operator_token1,
    STATE(1105), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2897), 2,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
    STATE(1483), 2,
      sym__generic_procedure,
      sym_identifier,
    STATE(1479), 3,
      sym_assignment,
      sym_operator,
      sym_defined_io_procedure,
    ACTIONS(2395), 17,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [49520] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2907), 1,
      anon_sym_COMMA,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1106), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [49592] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2909), 1,
      anon_sym_LPAREN,
    STATE(196), 1,
      sym_parenthesized_expression,
    STATE(1107), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 21,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [49640] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1108), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2903), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2905), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [49688] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2883), 1,
      anon_sym_LPAREN,
    STATE(533), 1,
      sym__io_arguments,
    STATE(1109), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 21,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [49736] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2911), 1,
      aux_sym_derived_type_definition_token1,
    STATE(625), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1110), 1,
      sym_preproc_file_line,
    STATE(1194), 1,
      sym_private_statement,
    STATE(1246), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2096), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [49816] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1111), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [49888] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1112), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2758), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2221), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [49934] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2913), 1,
      aux_sym_derived_type_definition_token1,
    STATE(406), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1113), 1,
      sym_preproc_file_line,
    STATE(1200), 1,
      sym_private_statement,
    STATE(1265), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2123), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [50014] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2915), 1,
      aux_sym_derived_type_definition_token1,
    STATE(387), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1114), 1,
      sym_preproc_file_line,
    STATE(1219), 1,
      sym_private_statement,
    STATE(1325), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2141), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [50094] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2917), 1,
      aux_sym_derived_type_definition_token1,
    STATE(302), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1115), 1,
      sym_preproc_file_line,
    STATE(1204), 1,
      sym_private_statement,
    STATE(1279), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2149), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [50174] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2919), 1,
      aux_sym_derived_type_definition_token1,
    STATE(323), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1116), 1,
      sym_preproc_file_line,
    STATE(1212), 1,
      sym_private_statement,
    STATE(1298), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2172), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [50254] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2921), 1,
      aux_sym_associate_statement_token1,
    STATE(1117), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50300] = 23,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2923), 1,
      aux_sym_derived_type_definition_token1,
    STATE(345), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1118), 1,
      sym_preproc_file_line,
    STATE(1215), 1,
      sym_private_statement,
    STATE(1311), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2195), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [50380] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1043), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1119), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2925), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2927), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [50428] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1044), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1120), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2929), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2931), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [50476] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2933), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1121), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [50548] = 19,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2560), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2562), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2935), 1,
      sym__end_of_statement,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1122), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2566), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2568), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [50620] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(1072), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1123), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2929), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2931), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [50668] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2937), 1,
      aux_sym__inline_if_statement_token1,
    STATE(1124), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1345), 22,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50714] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2939), 1,
      anon_sym_LPAREN,
    STATE(1125), 1,
      sym_preproc_file_line,
    STATE(2691), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 21,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50762] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1086), 1,
      aux_sym_parameters_repeat1,
    STATE(1126), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2942), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2944), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [50810] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1127), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2255), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2257), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50853] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1128), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2255), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2257), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50896] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1129), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2205), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2207), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50939] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2946), 1,
      anon_sym_COMMA,
    ACTIONS(2948), 1,
      anon_sym_SLASH,
    STATE(1130), 1,
      sym_preproc_file_line,
    STATE(1900), 1,
      aux_sym_data_set_repeat1,
    STATE(2263), 1,
      sym_data_value,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [50990] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1131), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2209), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2211), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51033] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1132), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2213), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2215), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51076] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2950), 1,
      anon_sym_LPAREN,
    STATE(1133), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 22,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51121] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1134), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1540), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1542), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51164] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1135), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2270), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2272), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51207] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_EQ,
    STATE(1136), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51254] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_PERCENT,
    ACTIONS(2570), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2572), 1,
      anon_sym_STAR_STAR,
    STATE(722), 1,
      sym_user_defined_operator,
    STATE(892), 1,
      aux_sym_call_expression_repeat1,
    STATE(1002), 1,
      sym_argument_list,
    STATE(1137), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2554), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2556), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [51323] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2954), 1,
      sym__end_of_statement,
    STATE(1138), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51368] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2956), 1,
      anon_sym_LPAREN,
    STATE(1139), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1365), 21,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51413] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1140), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51456] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_EQ,
    STATE(1141), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51503] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1142), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2958), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2960), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51546] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1143), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1678), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1680), 23,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51589] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1144), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2962), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2964), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51632] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1145), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2966), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2968), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51675] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1146), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2970), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2972), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51718] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1147), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1690), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1692), 23,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51761] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1148), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1686), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1688), 23,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51804] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1149), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2863), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2865), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51847] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1150), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2974), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2976), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [51890] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2978), 1,
      anon_sym_COLON,
    STATE(1151), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 6,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51935] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2792), 1,
      anon_sym_EQ,
    ACTIONS(2952), 1,
      anon_sym_COMMA,
    STATE(1152), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [51982] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2980), 1,
      anon_sym_RPAREN,
    ACTIONS(2982), 1,
      anon_sym_COMMA,
    STATE(1153), 1,
      sym_preproc_file_line,
    STATE(2157), 1,
      aux_sym_equivalence_set_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52031] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1154), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2201), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2203), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52074] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(143), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(2309), 1,
      anon_sym_PERCENT,
    ACTIONS(2311), 1,
      aux_sym_logical_expression_token2,
    ACTIONS(2317), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(2319), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2325), 1,
      aux_sym_logical_expression_token1,
    STATE(687), 1,
      sym_user_defined_operator,
    STATE(789), 1,
      aux_sym_call_expression_repeat1,
    STATE(823), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2305), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2307), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2313), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
    ACTIONS(2315), 10,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
  [52143] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1156), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2225), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2227), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52186] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1157), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2836), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2838), 26,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      anon_sym_COMMA,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [52229] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1158), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2243), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2245), 23,
      sym__end_of_statement,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52272] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2984), 1,
      sym__end_of_statement,
    STATE(1159), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2278), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2280), 21,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_LT_LT_LT,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52316] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1160), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52360] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1161), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2986), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52404] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1162), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [52446] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1163), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [52488] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2988), 1,
      anon_sym_EQ,
    STATE(1164), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52532] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1165), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2990), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2992), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [52574] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1166), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1544), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(1540), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(1542), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52618] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1167), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2996), 3,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(2994), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [52660] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(3000), 1,
      anon_sym_SLASH,
    STATE(1168), 1,
      sym_preproc_file_line,
    STATE(2064), 1,
      aux_sym_data_value_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52708] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1169), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2986), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52752] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(3003), 1,
      anon_sym_SLASH,
    STATE(1170), 1,
      sym_preproc_file_line,
    STATE(2224), 1,
      aux_sym_data_value_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52800] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(3003), 1,
      anon_sym_SLASH,
    ACTIONS(3006), 1,
      anon_sym_STAR,
    STATE(1171), 1,
      sym_preproc_file_line,
    STATE(2225), 1,
      aux_sym_data_value_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52850] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3008), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3014), 1,
      anon_sym_SLASH,
    ACTIONS(3017), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3020), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3023), 1,
      sym__end_of_statement,
    STATE(1319), 1,
      sym_identifier,
    STATE(1518), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1172), 2,
      sym_preproc_file_line,
      aux_sym_common_statement_repeat1,
    ACTIONS(3011), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [52904] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2986), 1,
      anon_sym_COMMA,
    STATE(1173), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52948] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3025), 1,
      anon_sym_EQ,
    STATE(1174), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [52992] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1175), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53034] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1176), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53076] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3029), 1,
      sym__end_of_statement,
    STATE(1177), 1,
      sym_preproc_file_line,
    STATE(1338), 1,
      sym_parenthesized_expression,
    STATE(2782), 1,
      sym_identifier,
    STATE(2855), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [53132] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1178), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53174] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1179), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53216] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2899), 1,
      aux_sym_derived_type_definition_token1,
    STATE(641), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1180), 1,
      sym_preproc_file_line,
    STATE(1320), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2063), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [53290] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1181), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3033), 3,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(3031), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [53332] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1182), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3035), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3037), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53374] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3039), 1,
      aux_sym_derived_type_definition_token1,
    STATE(578), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1183), 1,
      sym_preproc_file_line,
    STATE(1225), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2071), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [53448] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3041), 1,
      anon_sym_LPAREN,
    STATE(1184), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(2266), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [53492] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1185), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3043), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3045), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53534] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2188), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3047), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1186), 2,
      sym_preproc_file_line,
      aux_sym_procedure_statement_repeat1,
    ACTIONS(2183), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [53578] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1187), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2851), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2853), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53620] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3050), 1,
      anon_sym_LPAREN,
    ACTIONS(3052), 1,
      anon_sym_COMMA,
    ACTIONS(3054), 1,
      anon_sym_COLON_COLON,
    STATE(1188), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2750), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [53676] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1189), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1924), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3056), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53718] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2911), 1,
      aux_sym_derived_type_definition_token1,
    STATE(625), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1190), 1,
      sym_preproc_file_line,
    STATE(1246), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2096), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [53792] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1191), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53834] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1192), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53876] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1193), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [53918] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3058), 1,
      aux_sym_derived_type_definition_token1,
    STATE(636), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1194), 1,
      sym_preproc_file_line,
    STATE(1250), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2101), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [53992] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3060), 1,
      anon_sym_COMMA,
    STATE(1195), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [54036] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3065), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(3067), 1,
      aux_sym_type_qualifier_token3,
    ACTIONS(3069), 1,
      aux_sym_type_qualifier_token5,
    STATE(799), 1,
      sym_type_qualifier,
    STATE(1196), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3063), 23,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
  [54084] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1197), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [54126] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2913), 1,
      aux_sym_derived_type_definition_token1,
    STATE(406), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1198), 1,
      sym_preproc_file_line,
    STATE(1265), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2123), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54200] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1199), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [54242] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3071), 1,
      aux_sym_derived_type_definition_token1,
    STATE(413), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1200), 1,
      sym_preproc_file_line,
    STATE(1267), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2126), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54316] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2915), 1,
      aux_sym_derived_type_definition_token1,
    STATE(387), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1201), 1,
      sym_preproc_file_line,
    STATE(1325), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2141), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54390] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2917), 1,
      aux_sym_derived_type_definition_token1,
    STATE(302), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1202), 1,
      sym_preproc_file_line,
    STATE(1279), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2149), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54464] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1203), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3073), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [54508] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3075), 1,
      aux_sym_derived_type_definition_token1,
    STATE(307), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1204), 1,
      sym_preproc_file_line,
    STATE(1282), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2153), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54582] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3065), 1,
      aux_sym_derived_type_definition_token1,
    ACTIONS(3067), 1,
      aux_sym_type_qualifier_token3,
    ACTIONS(3069), 1,
      aux_sym_type_qualifier_token5,
    STATE(477), 1,
      sym_type_qualifier,
    STATE(1205), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3063), 23,
      aux_sym_procedure_attributes_token3,
      aux_sym_use_statement_token2,
      aux_sym_implicit_statement_token4,
      aux_sym_save_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_abstract_specifier_token1,
      aux_sym_procedure_attribute_token6,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
      aux_sym_type_qualifier_token1,
      aux_sym_type_qualifier_token2,
      aux_sym_type_qualifier_token4,
      aux_sym_type_qualifier_token9,
      aux_sym_type_qualifier_token10,
      aux_sym_type_qualifier_token11,
      aux_sym_type_qualifier_token12,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_type_qualifier_token15,
  [54630] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1206), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [54674] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1207), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [54716] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1208), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [54758] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3077), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3081), 1,
      sym__end_of_statement,
    STATE(1209), 1,
      sym_preproc_file_line,
    STATE(2027), 1,
      sym_identifier,
    STATE(2524), 1,
      sym__import_names,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [54814] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2919), 1,
      aux_sym_derived_type_definition_token1,
    STATE(323), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1210), 1,
      sym_preproc_file_line,
    STATE(1298), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2172), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [54888] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1211), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [54930] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3083), 1,
      aux_sym_derived_type_definition_token1,
    STATE(330), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1212), 1,
      sym_preproc_file_line,
    STATE(1301), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2176), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55004] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1213), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [55046] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(2923), 1,
      aux_sym_derived_type_definition_token1,
    STATE(345), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1214), 1,
      sym_preproc_file_line,
    STATE(1311), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2195), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55120] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3085), 1,
      aux_sym_derived_type_definition_token1,
    STATE(352), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1215), 1,
      sym_preproc_file_line,
    STATE(1224), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2197), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55194] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      sym__end_of_statement,
    STATE(1216), 1,
      sym_preproc_file_line,
    STATE(1384), 1,
      sym_parenthesized_expression,
    STATE(2722), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [55250] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1217), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3089), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3091), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [55292] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2952), 1,
      anon_sym_COMMA,
    STATE(1218), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [55336] = 21,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    ACTIONS(3093), 1,
      aux_sym_derived_type_definition_token1,
    STATE(374), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1219), 1,
      sym_preproc_file_line,
    STATE(1252), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2103), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55410] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3095), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3099), 1,
      anon_sym_SLASH,
    ACTIONS(3101), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3103), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3105), 1,
      sym__end_of_statement,
    STATE(1172), 1,
      aux_sym_common_statement_repeat1,
    STATE(1220), 1,
      sym_preproc_file_line,
    STATE(1319), 1,
      sym_identifier,
    STATE(1518), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3097), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [55466] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3052), 1,
      anon_sym_COMMA,
    ACTIONS(3054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3107), 1,
      anon_sym_LPAREN,
    STATE(1221), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2750), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [55522] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3109), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 21,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [55566] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1223), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 25,
      aux_sym_module_statement_token1,
      aux_sym_end_interface_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_import_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [55608] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(356), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1224), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2200), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55679] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(592), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1225), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2073), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55750] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(592), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1226), 1,
      sym_preproc_file_line,
    STATE(1230), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2073), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [55821] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(1227), 1,
      sym_preproc_file_line,
    STATE(1232), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3116), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    ACTIONS(3112), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [55866] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3118), 1,
      anon_sym_RPAREN,
    STATE(1228), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [55909] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1806), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1808), 1,
      sym__end_of_statement,
    STATE(1229), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2912), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [55962] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(594), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1230), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2077), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56033] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(594), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1231), 1,
      sym_preproc_file_line,
    STATE(1234), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2077), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56104] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      sym_preproc_file_line,
    STATE(1285), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3122), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    ACTIONS(3120), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56149] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3124), 1,
      anon_sym_RPAREN,
    STATE(1233), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [56192] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(597), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1234), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2078), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56263] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1828), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1830), 1,
      sym__end_of_statement,
    STATE(1235), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2436), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56316] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1870), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1872), 1,
      sym__end_of_statement,
    STATE(1236), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2651), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56369] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1810), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1812), 1,
      sym__end_of_statement,
    STATE(1237), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2387), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56422] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3126), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3128), 1,
      sym__end_of_statement,
    STATE(1238), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2423), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56475] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1874), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1876), 1,
      sym__end_of_statement,
    STATE(1239), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2654), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56528] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1844), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1846), 1,
      sym__end_of_statement,
    STATE(1240), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2510), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56581] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(625), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1241), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2096), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56652] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1788), 1,
      aux_sym_program_statement_token1,
    ACTIONS(1790), 1,
      sym__end_of_statement,
    STATE(1242), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2527), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56705] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3130), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3132), 1,
      sym__end_of_statement,
    STATE(1243), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2530), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56758] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1878), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1880), 1,
      sym__end_of_statement,
    STATE(1244), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2672), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [56811] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(636), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1245), 1,
      sym_preproc_file_line,
    STATE(1250), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2101), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56882] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(636), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1246), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2101), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [56953] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1848), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1850), 1,
      sym__end_of_statement,
    STATE(1247), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2513), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57006] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1854), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1856), 1,
      sym__end_of_statement,
    STATE(1248), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2531), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57059] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3134), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3136), 1,
      sym__end_of_statement,
    STATE(1249), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2540), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57112] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(564), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1250), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2105), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57183] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(564), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1251), 1,
      sym_preproc_file_line,
    STATE(1253), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2105), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57254] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(384), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1252), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(1964), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57325] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(565), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1253), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2243), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57396] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(565), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1254), 1,
      sym_preproc_file_line,
    STATE(1255), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2243), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57467] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(566), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1255), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2108), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57538] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(384), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1256), 1,
      sym_preproc_file_line,
    STATE(1328), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(1964), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57609] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1832), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1834), 1,
      sym__end_of_statement,
    STATE(1257), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2439), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57662] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1816), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1818), 1,
      sym__end_of_statement,
    STATE(1258), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2827), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57715] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3138), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3140), 1,
      sym__end_of_statement,
    STATE(1259), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2501), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57768] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3095), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3099), 1,
      anon_sym_SLASH,
    ACTIONS(3101), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3103), 1,
      aux_sym_select_case_statement_token1,
    STATE(1220), 1,
      aux_sym_common_statement_repeat1,
    STATE(1260), 1,
      sym_preproc_file_line,
    STATE(1319), 1,
      sym_identifier,
    STATE(1518), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3097), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [57821] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2986), 1,
      sym__end_of_statement,
    STATE(1261), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [57864] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(406), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1262), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2123), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [57935] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3142), 1,
      anon_sym_COMMA,
    ACTIONS(3144), 1,
      anon_sym_SLASH,
    STATE(1263), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [57980] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(413), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1264), 1,
      sym_preproc_file_line,
    STATE(1267), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2126), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58051] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(413), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1265), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2126), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58122] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3147), 1,
      anon_sym_RPAREN,
    STATE(1266), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [58165] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(398), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1267), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2129), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58236] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(398), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1268), 1,
      sym_preproc_file_line,
    STATE(1269), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2129), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58307] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(399), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1269), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2132), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58378] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(399), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1270), 1,
      sym_preproc_file_line,
    STATE(1271), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2132), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58449] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(401), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1271), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2134), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58520] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1882), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1884), 1,
      sym__end_of_statement,
    STATE(1272), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2716), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [58573] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1273), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2253), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(2251), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [58614] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3149), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3151), 1,
      sym__end_of_statement,
    STATE(1274), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2572), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [58667] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1886), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1888), 1,
      sym__end_of_statement,
    STATE(1275), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2719), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [58720] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3153), 1,
      aux_sym_submodule_statement_token1,
    ACTIONS(3155), 1,
      sym__end_of_statement,
    STATE(1276), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2566), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [58773] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(302), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1277), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2149), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58844] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(307), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1278), 1,
      sym_preproc_file_line,
    STATE(1282), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2153), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58915] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(307), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1279), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2153), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [58986] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(366), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1280), 1,
      sym_preproc_file_line,
    STATE(1294), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2020), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59057] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(387), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1281), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2141), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59128] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(310), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1282), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2159), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59199] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(310), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1283), 1,
      sym_preproc_file_line,
    STATE(1287), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2159), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59270] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1792), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1794), 1,
      sym__end_of_statement,
    STATE(1284), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2757), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59323] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2734), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    STATE(1285), 2,
      sym_preproc_file_line,
      aux_sym_parameters_repeat1,
    ACTIONS(2732), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59366] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1820), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1822), 1,
      sym__end_of_statement,
    STATE(1286), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2842), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59419] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(311), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1287), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2160), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59490] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(311), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1288), 1,
      sym_preproc_file_line,
    STATE(1290), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2160), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59561] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1858), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1860), 1,
      sym__end_of_statement,
    STATE(1289), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2581), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59614] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(312), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1290), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2162), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59685] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3160), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3162), 1,
      sym__end_of_statement,
    STATE(1291), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2779), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59738] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3164), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3166), 1,
      sym__end_of_statement,
    STATE(1292), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2642), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59791] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1862), 1,
      aux_sym_function_statement_token1,
    ACTIONS(1864), 1,
      sym__end_of_statement,
    STATE(1293), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2584), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [59844] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(371), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1294), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2122), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59915] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(323), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1295), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2172), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [59986] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3168), 1,
      anon_sym_RPAREN,
    STATE(1296), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [60029] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(330), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1297), 1,
      sym_preproc_file_line,
    STATE(1301), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2176), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60100] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(330), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1298), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2176), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60171] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(641), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1299), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2063), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60242] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1866), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1868), 1,
      sym__end_of_statement,
    STATE(1300), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2602), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [60295] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(334), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1301), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2181), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60366] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(334), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1302), 1,
      sym_preproc_file_line,
    STATE(1303), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2181), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60437] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(335), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1303), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2183), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60508] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(335), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1304), 1,
      sym_preproc_file_line,
    STATE(1305), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2183), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60579] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(336), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1305), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2184), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60650] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3170), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3172), 1,
      sym__end_of_statement,
    STATE(1306), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2708), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [60703] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1307), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2268), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(2266), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [60744] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1824), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1826), 1,
      sym__end_of_statement,
    STATE(1308), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2365), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [60797] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(345), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1309), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2195), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60868] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(352), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1224), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1310), 1,
      sym_preproc_file_line,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2197), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [60939] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(352), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1311), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2197), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61010] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3174), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_SLASH,
    ACTIONS(3179), 1,
      anon_sym_STAR,
    STATE(1312), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [61057] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(578), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1225), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1313), 1,
      sym_preproc_file_line,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2071), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61128] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1802), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1804), 1,
      sym__end_of_statement,
    STATE(1314), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2460), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [61181] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(356), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1315), 1,
      sym_preproc_file_line,
    STATE(1316), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2200), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61252] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(357), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1316), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2201), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61323] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(357), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1317), 1,
      sym_preproc_file_line,
    STATE(1318), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2201), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61394] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(358), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1318), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2203), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61465] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(1319), 1,
      sym_preproc_file_line,
    STATE(1324), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3183), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    ACTIONS(3181), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [61510] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(578), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1320), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2071), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61581] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_COLON_COLON,
    STATE(1321), 1,
      sym_preproc_file_line,
    STATE(2388), 1,
      sym__type_name,
    STATE(2468), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [61634] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(374), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1252), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1322), 1,
      sym_preproc_file_line,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2103), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61705] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1836), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1838), 1,
      sym__end_of_statement,
    STATE(1323), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2458), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [61758] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3114), 1,
      anon_sym_COMMA,
    STATE(1285), 1,
      aux_sym_parameters_repeat1,
    STATE(1324), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3023), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    ACTIONS(3189), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [61803] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(374), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1325), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2103), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [61874] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3191), 1,
      anon_sym_EQ,
    STATE(1326), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [61917] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3193), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_SLASH,
    STATE(1327), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [61962] = 20,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1373), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(1405), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1407), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(1409), 1,
      aux_sym_derived_type_token1,
    ACTIONS(1419), 1,
      aux_sym_include_statement_token1,
    ACTIONS(2582), 1,
      aux_sym_contains_statement_token1,
    ACTIONS(2584), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(366), 1,
      sym_end_type_statement,
    STATE(773), 1,
      sym_intrinsic_type,
    STATE(1328), 1,
      sym_preproc_file_line,
    STATE(1556), 1,
      aux_sym_derived_type_definition_repeat1,
    STATE(1734), 1,
      sym_contains_statement,
    STATE(2020), 1,
      sym_derived_type_procedures,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(1403), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [62033] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1329), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2188), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
    ACTIONS(2183), 24,
      aux_sym_end_program_statement_token1,
      aux_sym_assignment_token1,
      aux_sym_operator_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62074] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3198), 1,
      anon_sym_COMMA,
    STATE(1330), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 5,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [62117] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3174), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_SLASH,
    STATE(1331), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2221), 4,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
    ACTIONS(2223), 20,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PERCENT,
      aux_sym_logical_expression_token1,
      aux_sym_logical_expression_token2,
      aux_sym_logical_expression_token3,
      aux_sym_logical_expression_token4,
      aux_sym_relational_expression_token1,
      aux_sym_relational_expression_token2,
      anon_sym_LT_EQ,
      aux_sym_relational_expression_token3,
      anon_sym_GT_EQ,
      aux_sym_relational_expression_token4,
      anon_sym_EQ_EQ,
      aux_sym_relational_expression_token5,
      anon_sym_SLASH_EQ,
      aux_sym_relational_expression_token6,
      anon_sym_SLASH_SLASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
  [62162] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1890), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(1892), 1,
      sym__end_of_statement,
    STATE(1332), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2754), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62215] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3200), 1,
      sym__end_of_statement,
    STATE(1333), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2726), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62265] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3206), 1,
      anon_sym_COMMA,
    STATE(1334), 1,
      sym_preproc_file_line,
    STATE(1353), 1,
      aux_sym_private_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3202), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3204), 21,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [62309] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3208), 1,
      sym__end_of_statement,
    STATE(1335), 1,
      sym_preproc_file_line,
    STATE(2578), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62359] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3210), 1,
      sym__end_of_statement,
    STATE(1336), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2916), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62409] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3212), 1,
      sym__end_of_statement,
    STATE(1337), 1,
      sym_preproc_file_line,
    STATE(2593), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62459] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3214), 1,
      sym__end_of_statement,
    STATE(1338), 1,
      sym_preproc_file_line,
    STATE(2378), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62509] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1339), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1365), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_SLASH,
    ACTIONS(1363), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62549] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1340), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1343), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1345), 23,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [62589] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1341), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1347), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1349), 23,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [62629] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1342), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1351), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1353), 23,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [62669] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3216), 1,
      sym__end_of_statement,
    STATE(1343), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2814), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62719] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3218), 1,
      sym__end_of_statement,
    STATE(1344), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2809), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62769] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3155), 1,
      sym__end_of_statement,
    STATE(1345), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2566), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62819] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3220), 1,
      sym__end_of_statement,
    STATE(1346), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2494), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62869] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3162), 1,
      sym__end_of_statement,
    STATE(1347), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2779), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62919] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3222), 1,
      sym__end_of_statement,
    STATE(1348), 1,
      sym_preproc_file_line,
    STATE(2637), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [62969] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3224), 1,
      sym__end_of_statement,
    STATE(1349), 1,
      sym_preproc_file_line,
    STATE(2425), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63019] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1818), 1,
      sym__end_of_statement,
    STATE(1350), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2827), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63069] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1822), 1,
      sym__end_of_statement,
    STATE(1351), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2842), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63119] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3226), 1,
      sym__end_of_statement,
    STATE(1352), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2853), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63169] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3232), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3228), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    STATE(1353), 2,
      sym_preproc_file_line,
      aux_sym_private_statement_repeat1,
    ACTIONS(3230), 21,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [63211] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3235), 1,
      sym__end_of_statement,
    STATE(1354), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2918), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63261] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1808), 1,
      sym__end_of_statement,
    STATE(1355), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2912), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63311] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1790), 1,
      sym__end_of_statement,
    STATE(1356), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2527), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63361] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3237), 1,
      sym__end_of_statement,
    STATE(1357), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2891), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63411] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3239), 1,
      sym__end_of_statement,
    STATE(1358), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2902), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63461] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3241), 1,
      sym__end_of_statement,
    STATE(1359), 1,
      sym_preproc_file_line,
    STATE(2728), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63511] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3243), 1,
      sym__end_of_statement,
    STATE(1360), 1,
      sym_preproc_file_line,
    STATE(2748), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63561] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3245), 1,
      sym__end_of_statement,
    STATE(1361), 1,
      sym_preproc_file_line,
    STATE(2751), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63611] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3247), 1,
      sym__end_of_statement,
    STATE(1362), 1,
      sym_preproc_file_line,
    STATE(2756), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63661] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3249), 1,
      sym__end_of_statement,
    STATE(1363), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2632), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63711] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1826), 1,
      sym__end_of_statement,
    STATE(1364), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2365), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63761] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1812), 1,
      sym__end_of_statement,
    STATE(1365), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2387), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63811] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3251), 1,
      sym__end_of_statement,
    STATE(1366), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2372), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63861] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3253), 1,
      sym__end_of_statement,
    STATE(1367), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2903), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63911] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3255), 1,
      sym__end_of_statement,
    STATE(1368), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2823), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [63961] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3262), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(3265), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3271), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3274), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(3277), 1,
      aux_sym_derived_type_token1,
    STATE(1371), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3260), 2,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
    STATE(1369), 2,
      aux_sym__callable_interface_qualifers,
      sym_preproc_file_line,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(3257), 5,
      aux_sym_module_statement_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    ACTIONS(3268), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [64017] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3128), 1,
      sym__end_of_statement,
    STATE(1370), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2423), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64067] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1776), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2299), 1,
      anon_sym_LPAREN,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    STATE(1371), 1,
      sym_preproc_file_line,
    STATE(1562), 1,
      sym_argument_list,
    STATE(1632), 1,
      sym_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1780), 20,
      aux_sym_module_statement_token1,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [64115] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1898), 1,
      sym__end_of_statement,
    STATE(1372), 1,
      sym_preproc_file_line,
    STATE(2525), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64165] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1830), 1,
      sym__end_of_statement,
    STATE(1373), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2436), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64215] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1834), 1,
      sym__end_of_statement,
    STATE(1374), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2439), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64265] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3282), 1,
      sym__end_of_statement,
    STATE(1375), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2442), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64315] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3284), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3286), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(3288), 1,
      aux_sym_function_statement_token1,
    STATE(1369), 1,
      aux_sym__callable_interface_qualifers,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1376), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2046), 4,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [64377] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3290), 1,
      sym__end_of_statement,
    STATE(1377), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2447), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64427] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3292), 1,
      sym__end_of_statement,
    STATE(1378), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2448), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64477] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1838), 1,
      sym__end_of_statement,
    STATE(1379), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2458), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64527] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3294), 1,
      sym__end_of_statement,
    STATE(1380), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2437), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64577] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3296), 1,
      sym__end_of_statement,
    STATE(1381), 1,
      sym_preproc_file_line,
    STATE(2605), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64627] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3298), 1,
      sym__end_of_statement,
    STATE(1382), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2462), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64677] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3300), 1,
      anon_sym_LPAREN,
    STATE(1383), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1365), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [64719] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3302), 1,
      sym__end_of_statement,
    STATE(1384), 1,
      sym_preproc_file_line,
    STATE(2389), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64769] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1846), 1,
      sym__end_of_statement,
    STATE(1385), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2510), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64819] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3136), 1,
      sym__end_of_statement,
    STATE(1386), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2540), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64869] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1850), 1,
      sym__end_of_statement,
    STATE(1387), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2513), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64919] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3304), 1,
      sym__end_of_statement,
    STATE(1388), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2516), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [64969] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3306), 1,
      anon_sym_COMMA,
    STATE(1389), 1,
      sym_preproc_file_line,
    STATE(2498), 1,
      sym_loop_control_expression,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65019] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3308), 1,
      sym__end_of_statement,
    STATE(1390), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2520), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65069] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3310), 1,
      sym__end_of_statement,
    STATE(1391), 1,
      sym_preproc_file_line,
    STATE(2428), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65119] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3312), 1,
      sym__end_of_statement,
    STATE(1392), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2521), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65169] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3314), 1,
      sym__end_of_statement,
    STATE(1393), 1,
      sym_preproc_file_line,
    STATE(2514), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65219] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1856), 1,
      sym__end_of_statement,
    STATE(1394), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2531), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65269] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3316), 1,
      sym__end_of_statement,
    STATE(1395), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2535), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65319] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3318), 1,
      sym__end_of_statement,
    STATE(1396), 1,
      sym_preproc_file_line,
    STATE(2421), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65369] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3320), 1,
      sym__end_of_statement,
    STATE(1397), 1,
      sym_preproc_file_line,
    STATE(2509), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65419] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3151), 1,
      sym__end_of_statement,
    STATE(1398), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2572), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65469] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1860), 1,
      sym__end_of_statement,
    STATE(1399), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2581), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65519] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1864), 1,
      sym__end_of_statement,
    STATE(1400), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2584), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65569] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3322), 1,
      sym__end_of_statement,
    STATE(1401), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2587), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65619] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3324), 1,
      sym__end_of_statement,
    STATE(1402), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2908), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65669] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2032), 1,
      aux_sym_procedure_attributes_token1,
    ACTIONS(2034), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(2044), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3286), 1,
      aux_sym_subroutine_statement_token1,
    ACTIONS(3288), 1,
      aux_sym_function_statement_token1,
    STATE(1369), 1,
      aux_sym__callable_interface_qualifers,
    STATE(1371), 1,
      sym_intrinsic_type,
    STATE(1403), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1730), 4,
      sym_procedure_attributes,
      sym__intrinsic_type,
      sym_derived_type,
      sym_procedure_qualifier,
    ACTIONS(2046), 5,
      aux_sym_module_statement_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [65729] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3326), 1,
      sym__end_of_statement,
    STATE(1404), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2591), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65779] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3328), 1,
      sym__end_of_statement,
    STATE(1405), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2592), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65829] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1868), 1,
      sym__end_of_statement,
    STATE(1406), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2602), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65879] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3330), 1,
      aux_sym_included_items_token1,
    STATE(1407), 1,
      sym_preproc_file_line,
    STATE(2041), 1,
      sym_use_alias,
    STATE(2573), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65929] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1023), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_preproc_file_line,
    STATE(2334), 1,
      sym__name,
    STATE(2570), 1,
      sym_module_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [65979] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3332), 1,
      sym__end_of_statement,
    STATE(1409), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2606), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66029] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3206), 1,
      anon_sym_COMMA,
    STATE(1334), 1,
      aux_sym_private_statement_repeat1,
    STATE(1410), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3334), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3336), 21,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [66073] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3166), 1,
      sym__end_of_statement,
    STATE(1411), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2642), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66123] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3338), 1,
      sym__end_of_statement,
    STATE(1412), 1,
      sym_preproc_file_line,
    STATE(2358), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66173] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1872), 1,
      sym__end_of_statement,
    STATE(1413), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2651), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66223] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1876), 1,
      sym__end_of_statement,
    STATE(1414), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2654), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66273] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3340), 1,
      sym__end_of_statement,
    STATE(1415), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2657), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66323] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3342), 1,
      sym__end_of_statement,
    STATE(1416), 1,
      sym_preproc_file_line,
    STATE(2414), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66373] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3330), 1,
      aux_sym_included_items_token1,
    STATE(1417), 1,
      sym_preproc_file_line,
    STATE(2185), 1,
      sym_use_alias,
    STATE(2573), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66423] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3344), 1,
      sym__end_of_statement,
    STATE(1418), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2661), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66473] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3346), 1,
      sym__end_of_statement,
    STATE(1419), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2662), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66523] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3348), 1,
      sym__end_of_statement,
    STATE(1420), 1,
      sym_preproc_file_line,
    STATE(2449), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66573] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3350), 1,
      sym__end_of_statement,
    STATE(1421), 1,
      sym_preproc_file_line,
    STATE(2736), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66623] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1880), 1,
      sym__end_of_statement,
    STATE(1422), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2672), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66673] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3352), 1,
      sym__end_of_statement,
    STATE(1423), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2676), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66723] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1023), 1,
      sym_identifier,
    STATE(1424), 1,
      sym_preproc_file_line,
    STATE(2289), 1,
      sym_module_name,
    STATE(2334), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66773] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3172), 1,
      sym__end_of_statement,
    STATE(1425), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2708), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66823] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1426), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2734), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_SLASH,
    ACTIONS(2732), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66863] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1884), 1,
      sym__end_of_statement,
    STATE(1427), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2716), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66913] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1888), 1,
      sym__end_of_statement,
    STATE(1428), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2719), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [66963] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3354), 1,
      sym__end_of_statement,
    STATE(1429), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2721), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67013] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3356), 1,
      sym__end_of_statement,
    STATE(1430), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2725), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67063] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3358), 1,
      sym__end_of_statement,
    STATE(1431), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2486), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67113] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1804), 1,
      sym__end_of_statement,
    STATE(1432), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2460), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67163] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1433), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1345), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_SLASH,
    ACTIONS(1343), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67203] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1434), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1349), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_SLASH,
    ACTIONS(1347), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67243] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1892), 1,
      sym__end_of_statement,
    STATE(1435), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2754), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67293] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(1794), 1,
      sym__end_of_statement,
    STATE(1436), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2757), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67343] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1437), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1353), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_SLASH,
    ACTIONS(1351), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67383] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3360), 1,
      sym__end_of_statement,
    STATE(1438), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2759), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67433] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3362), 1,
      sym__end_of_statement,
    STATE(1439), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2760), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67483] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3364), 1,
      sym__end_of_statement,
    STATE(1440), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2677), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67533] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3330), 1,
      aux_sym_included_items_token1,
    STATE(1441), 1,
      sym_preproc_file_line,
    STATE(1948), 1,
      sym_use_alias,
    STATE(2573), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67583] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1442), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1363), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1365), 23,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      anon_sym_EQ_GT,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [67623] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3366), 1,
      anon_sym_COMMA,
    ACTIONS(3368), 1,
      anon_sym_COLON_COLON,
    STATE(1443), 1,
      sym_preproc_file_line,
    STATE(2178), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67673] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3370), 1,
      sym__end_of_statement,
    STATE(1444), 1,
      sym_preproc_file_line,
    STATE(2782), 1,
      sym_identifier,
    STATE(2822), 1,
      sym__block_label,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67723] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3372), 1,
      aux_sym__inline_if_statement_token1,
    ACTIONS(3374), 1,
      sym__end_of_statement,
    STATE(1445), 1,
      sym_preproc_file_line,
    STATE(2598), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 18,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67775] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3376), 1,
      sym__end_of_statement,
    STATE(1446), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2705), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67825] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3378), 1,
      sym__end_of_statement,
    STATE(1447), 1,
      sym_preproc_file_line,
    STATE(2781), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67875] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3132), 1,
      sym__end_of_statement,
    STATE(1448), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2530), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67925] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3380), 1,
      sym__end_of_statement,
    STATE(1449), 1,
      sym_preproc_file_line,
    STATE(2663), 1,
      sym__block_label,
    STATE(2782), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [67975] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3140), 1,
      sym__end_of_statement,
    STATE(1450), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2501), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68025] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1451), 1,
      sym_preproc_file_line,
    STATE(1833), 1,
      sym__name,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68072] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1452), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2810), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68119] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1065), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1453), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68166] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1454), 1,
      sym_preproc_file_line,
    STATE(1750), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68213] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1038), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1455), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68260] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1456), 1,
      sym_preproc_file_line,
    STATE(2144), 1,
      sym_association,
    STATE(2865), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68307] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1457), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2962), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2964), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [68346] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1458), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2966), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2968), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [68385] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1459), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2970), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2972), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [68424] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1460), 1,
      sym_preproc_file_line,
    STATE(2039), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68471] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1461), 1,
      sym_preproc_file_line,
    STATE(1996), 1,
      sym_association,
    STATE(2865), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68518] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1462), 1,
      sym_preproc_file_line,
    STATE(1766), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68565] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1463), 1,
      sym_preproc_file_line,
    STATE(1754), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68612] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1063), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1464), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68659] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3382), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3386), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3388), 1,
      aux_sym_select_case_statement_token1,
    STATE(588), 1,
      sym_identifier,
    STATE(603), 1,
      sym__name,
    STATE(1465), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3384), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68706] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3206), 1,
      anon_sym_COMMA,
    STATE(1466), 1,
      sym_preproc_file_line,
    STATE(1486), 1,
      aux_sym_private_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3390), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3392), 20,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [68749] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1467), 1,
      sym_preproc_file_line,
    STATE(1780), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68796] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1468), 1,
      sym_preproc_file_line,
    STATE(2337), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68843] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1469), 1,
      sym_preproc_file_line,
    STATE(1751), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68890] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1470), 1,
      sym_preproc_file_line,
    STATE(1779), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68937] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1471), 1,
      sym_preproc_file_line,
    STATE(1761), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [68984] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1472), 1,
      sym_preproc_file_line,
    STATE(1773), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69031] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1473), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3396), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3394), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69070] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1474), 1,
      sym_preproc_file_line,
    STATE(2199), 1,
      sym_parameter_assignment,
    STATE(2729), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69117] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1475), 1,
      sym_preproc_file_line,
    STATE(2326), 1,
      sym_concurrent_control,
    STATE(2397), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69164] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1476), 1,
      sym_preproc_file_line,
    STATE(2406), 1,
      sym_loop_control_expression,
    STATE(2653), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69211] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1477), 1,
      sym_preproc_file_line,
    STATE(1916), 1,
      sym_identifier,
    STATE(2485), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69258] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1478), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2511), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69305] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1479), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2958), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2960), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [69344] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1057), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1480), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69391] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3400), 1,
      anon_sym_COLON_COLON,
    STATE(1481), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3398), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1638), 21,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [69432] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1482), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2733), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69479] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1483), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3228), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3230), 22,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [69518] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1484), 1,
      sym_preproc_file_line,
    STATE(2292), 1,
      sym_use_alias,
    STATE(2573), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69565] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
    STATE(1485), 1,
      sym_preproc_file_line,
    STATE(1933), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69612] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3206), 1,
      anon_sym_COMMA,
    STATE(1353), 1,
      aux_sym_private_statement_repeat1,
    STATE(1486), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3404), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3406), 20,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [69655] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1487), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2504), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69702] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1045), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1488), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69749] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1489), 1,
      sym_preproc_file_line,
    STATE(2350), 1,
      sym_association,
    STATE(2865), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69796] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3408), 1,
      anon_sym_SLASH,
    STATE(1490), 1,
      sym_preproc_file_line,
    STATE(2256), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69843] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3410), 1,
      anon_sym_RPAREN,
    STATE(1491), 1,
      sym_preproc_file_line,
    STATE(2659), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69890] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1060), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1492), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69937] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1493), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1544), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1538), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [69976] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1149), 1,
      sym_identifier,
    STATE(1150), 1,
      sym_method_name,
    STATE(1494), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70023] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1495), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2499), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70070] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1496), 1,
      sym_preproc_file_line,
    STATE(2308), 1,
      sym_parameter_assignment,
    STATE(2729), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70117] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1497), 1,
      sym_preproc_file_line,
    STATE(1841), 1,
      sym__name,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70164] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1498), 1,
      sym_preproc_file_line,
    STATE(1801), 1,
      sym__name,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70211] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1499), 1,
      sym_preproc_file_line,
    STATE(2009), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70258] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1500), 1,
      sym_preproc_file_line,
    STATE(2468), 1,
      sym_identifier,
    STATE(2481), 1,
      sym__type_name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70305] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1501), 1,
      sym_preproc_file_line,
    STATE(1804), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70352] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1502), 1,
      sym_preproc_file_line,
    STATE(2604), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70399] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1503), 1,
      sym_preproc_file_line,
    STATE(2013), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70446] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1050), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1504), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70493] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1505), 1,
      sym_preproc_file_line,
    STATE(2267), 1,
      sym_triplet_spec,
    STATE(2502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70540] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1506), 1,
      sym_preproc_file_line,
    STATE(2059), 1,
      sym_triplet_spec,
    STATE(2502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70587] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1068), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1507), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70634] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3412), 1,
      anon_sym_SLASH,
    STATE(1508), 1,
      sym_preproc_file_line,
    STATE(2085), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70681] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1509), 1,
      sym_preproc_file_line,
    STATE(1793), 1,
      sym__name,
    STATE(1916), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70728] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3382), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3386), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3388), 1,
      aux_sym_select_case_statement_token1,
    STATE(588), 1,
      sym_identifier,
    STATE(601), 1,
      sym__name,
    STATE(1510), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3384), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70775] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1511), 1,
      sym_preproc_file_line,
    STATE(2369), 1,
      sym_keyword_argument,
    STATE(2614), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70822] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3414), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3418), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3420), 1,
      aux_sym_select_case_statement_token1,
    STATE(380), 1,
      sym__name,
    STATE(381), 1,
      sym_identifier,
    STATE(1512), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3416), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70869] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3422), 1,
      anon_sym_COLON_COLON,
    STATE(1513), 1,
      sym_preproc_file_line,
    STATE(1847), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1970), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70916] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1514), 1,
      sym_preproc_file_line,
    STATE(2223), 1,
      sym_concurrent_control,
    STATE(2397), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [70963] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1052), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1515), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71010] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1516), 1,
      sym_preproc_file_line,
    STATE(1974), 1,
      sym_triplet_spec,
    STATE(2502), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71057] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1023), 1,
      sym_identifier,
    STATE(1517), 1,
      sym_preproc_file_line,
    STATE(2441), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71104] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1518), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3183), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    ACTIONS(3181), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71143] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1120), 1,
      sym_method_name,
    STATE(1149), 1,
      sym_identifier,
    STATE(1519), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71190] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1023), 1,
      sym_identifier,
    STATE(1520), 1,
      sym_preproc_file_line,
    STATE(2795), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71237] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1521), 1,
      sym_preproc_file_line,
    STATE(2388), 1,
      sym__type_name,
    STATE(2468), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71284] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1522), 1,
      sym_preproc_file_line,
    STATE(1781), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71331] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2389), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2397), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2399), 1,
      aux_sym_select_case_statement_token1,
    STATE(1523), 1,
      sym_preproc_file_line,
    STATE(1771), 1,
      sym_method_name,
    STATE(1806), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2395), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71378] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1524), 1,
      sym_preproc_file_line,
    STATE(2879), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71422] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1525), 1,
      sym_preproc_file_line,
    STATE(2209), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71466] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(821), 1,
      sym_identifier,
    STATE(1526), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71510] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3426), 1,
      anon_sym_COLON_COLON,
    STATE(1527), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3424), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1634), 20,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [71550] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3430), 1,
      sym__end_of_statement,
    STATE(1528), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3428), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71588] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1529), 1,
      sym_preproc_file_line,
    STATE(2300), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71632] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1081), 1,
      sym_identifier,
    STATE(1530), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71676] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1531), 1,
      sym_preproc_file_line,
    STATE(2656), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71720] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3095), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3101), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3103), 1,
      aux_sym_select_case_statement_token1,
    STATE(1227), 1,
      sym_identifier,
    STATE(1532), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3097), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71764] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1533), 1,
      sym_preproc_file_line,
    STATE(2749), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71808] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3095), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3101), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3103), 1,
      aux_sym_select_case_statement_token1,
    STATE(1426), 1,
      sym_identifier,
    STATE(1534), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3097), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71852] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3434), 1,
      sym__end_of_statement,
    STATE(1535), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3432), 22,
      aux_sym_end_program_statement_token1,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token4,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_select_case_statement_token1,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71890] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1426), 1,
      sym_identifier,
    STATE(1536), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71934] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1537), 1,
      sym_preproc_file_line,
    STATE(2182), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [71978] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1538), 1,
      sym_preproc_file_line,
    STATE(2394), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72022] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1539), 1,
      sym_preproc_file_line,
    STATE(2235), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72066] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1540), 1,
      sym_preproc_file_line,
    STATE(2135), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72110] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1077), 1,
      sym_identifier,
    STATE(1541), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72154] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1542), 1,
      sym_preproc_file_line,
    STATE(2683), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72198] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1543), 1,
      sym_preproc_file_line,
    STATE(2817), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72242] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1573), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1544), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1578), 22,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      anon_sym_STAR,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [72280] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1126), 1,
      sym_identifier,
    STATE(1545), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72324] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1546), 1,
      sym_preproc_file_line,
    STATE(2251), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72368] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1547), 1,
      sym_preproc_file_line,
    STATE(2717), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72412] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    STATE(1548), 1,
      sym_preproc_file_line,
    STATE(1845), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1970), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72456] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1950), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1549), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1952), 22,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      anon_sym_STAR,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [72494] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(576), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1010), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1571), 1,
      aux_sym_select_case_statement_token1,
    STATE(1550), 1,
      sym_preproc_file_line,
    STATE(2740), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(107), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72538] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1551), 1,
      sym_preproc_file_line,
    STATE(2019), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72582] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1552), 1,
      sym_preproc_file_line,
    STATE(2305), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72626] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    STATE(1553), 1,
      sym_preproc_file_line,
    STATE(1870), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1970), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72670] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1554), 1,
      sym_preproc_file_line,
    STATE(1919), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72714] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1942), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1555), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1944), 22,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      anon_sym_STAR,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [72752] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3436), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3438), 1,
      aux_sym_module_procedure_statement_token1,
    ACTIONS(3443), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3449), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3452), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(3455), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3458), 1,
      aux_sym_include_statement_token1,
    STATE(773), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3441), 2,
      aux_sym_contains_statement_token1,
      aux_sym_end_type_statement_token1,
    STATE(1556), 2,
      sym_preproc_file_line,
      aux_sym_derived_type_definition_repeat1,
    STATE(2582), 2,
      sym_variable_declaration,
      sym_include_statement,
    STATE(484), 3,
      sym_procedure_declaration,
      sym__intrinsic_type,
      sym_derived_type,
    ACTIONS(3446), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [72810] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1447), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1451), 1,
      aux_sym_select_case_statement_token1,
    STATE(1135), 1,
      sym_identifier,
    STATE(1557), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1443), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72854] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1946), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1558), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1948), 22,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      anon_sym_STAR,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [72892] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1968), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1974), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1976), 1,
      aux_sym_select_case_statement_token1,
    STATE(821), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1970), 19,
      aux_sym_defined_io_procedure_token1,
      aux_sym_defined_io_procedure_token2,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token3,
      aux_sym_type_qualifier_token13,
      aux_sym_type_qualifier_token14,
      aux_sym_stop_statement_token1,
      aux_sym_stop_statement_token2,
      aux_sym_keyword_statement_token2,
      aux_sym_keyword_statement_token3,
      aux_sym_data_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
      aux_sym_block_construct_token1,
      aux_sym_format_statement_token1,
      aux_sym_inquire_statement_token1,
      aux_sym_null_literal_token1,
      aux_sym_identifier_token1,
  [72936] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1992), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1560), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1995), 21,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [72973] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2006), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1561), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2008), 21,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73010] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1956), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1562), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1958), 21,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73047] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2002), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1563), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2004), 21,
      aux_sym_module_statement_token1,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73084] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1564), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73120] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1565), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73156] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1566), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73192] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1567), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73228] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1568), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73264] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1569), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73300] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1570), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73336] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1571), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73372] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1572), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73408] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1573), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73444] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1574), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73480] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1575), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73516] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1576), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73552] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1577), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73588] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1578), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73624] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1579), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73660] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1580), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73696] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1581), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73732] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1582), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73768] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1583), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73804] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1584), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73840] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1585), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73876] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1586), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73912] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1587), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73948] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1588), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [73984] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1589), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74020] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1590), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74056] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1591), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74092] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1592), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74128] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1593), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74164] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1594), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74200] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1595), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74236] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1596), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74272] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1597), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74308] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1598), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74344] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1599), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74380] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1600), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74416] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1601), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74452] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1602), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74488] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1603), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74524] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1604), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74560] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1605), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74596] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1606), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74632] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1607), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74668] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1608), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74704] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1609), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74740] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1610), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74776] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1611), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74812] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1612), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74848] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1613), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74884] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1614), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74920] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1615), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74956] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1616), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [74992] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1617), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75028] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1618), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75064] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1619), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75100] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1620), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75136] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1621), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75172] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1622), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75208] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1623), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75244] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1624), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75280] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1625), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_module_procedure_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75316] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1626), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75352] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1627), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75388] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1628), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75424] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1629), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75460] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1630), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75496] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1631), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75532] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2010), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1632), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2012), 20,
      aux_sym_module_statement_token1,
      anon_sym_RPAREN,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75568] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1633), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75604] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1634), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75640] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1635), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75676] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1636), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75712] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1637), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75748] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1638), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75784] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1639), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75820] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1640), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75856] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1641), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75892] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1642), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75928] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1643), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [75964] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1644), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76000] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1645), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76036] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1646), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76072] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1647), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76108] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1648), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76144] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1649), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76180] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1650), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76216] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1651), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76252] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1652), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76288] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1653), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76324] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1654), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76360] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1655), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76396] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1656), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76432] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1657), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_end_program_statement_token2,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76468] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1658), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76504] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1659), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76540] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1660), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76576] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1661), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76612] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1662), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76648] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1663), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76684] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1664), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76720] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1665), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76756] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1666), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76792] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1667), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76828] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1668), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76864] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1669), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76900] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1670), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76936] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1671), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [76972] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1672), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77008] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1673), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77044] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1674), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77080] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1675), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77116] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1676), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77152] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1677), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77188] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1678), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77224] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1679), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77260] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1680), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77296] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1681), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77332] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1682), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77368] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1683), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77404] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1684), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77440] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1685), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77476] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1686), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77512] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1687), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77548] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1688), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77584] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1689), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3461), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3463), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_end_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77620] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1690), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1243), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1241), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77656] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1691), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1115), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1113), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77692] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1692), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77728] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1693), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1151), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1149), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77764] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1694), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1167), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1165), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77800] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1695), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1179), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1177), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77836] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1696), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1191), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1189), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77872] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1697), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1095), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1093), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77908] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1698), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1099), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1097), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77944] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1699), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1273), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1271), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [77980] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1700), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1219), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1217), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78016] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1701), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1223), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1221), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78052] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1702), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1231), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1229), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78088] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1703), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3469), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3471), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78124] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1704), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1139), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1137), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78160] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1705), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1143), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1141), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78196] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1706), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1159), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1157), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78232] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1707), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1187), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(1185), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78268] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1708), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3473), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3475), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78304] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1709), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3477), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3479), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78340] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1710), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3481), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3483), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78376] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1711), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3485), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3487), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78412] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1712), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3489), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3491), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78448] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1713), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3493), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3495), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_end_function_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78484] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1714), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3465), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3467), 19,
      aux_sym_module_statement_token1,
      aux_sym_end_submodule_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78520] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2118), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3499), 1,
      aux_sym_module_procedure_statement_token1,
    STATE(1715), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3497), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78557] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1960), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1716), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1962), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78592] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1964), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1717), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1966), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78627] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1980), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1718), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1982), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78662] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2118), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3501), 1,
      aux_sym_module_procedure_statement_token1,
    STATE(1719), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3497), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78699] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1984), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1720), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1986), 19,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      anon_sym_COLON_COLON,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78734] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2118), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3503), 1,
      aux_sym_module_procedure_statement_token1,
    STATE(1721), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3497), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78771] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3507), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1722), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3505), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78805] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1723), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3509), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3511), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [78839] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1724), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3513), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3515), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [78873] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1725), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3517), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3519), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [78907] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1585), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1726), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3521), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [78941] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1727), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3523), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3525), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [78975] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1728), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3527), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3529), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [79009] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2118), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1729), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3497), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [79043] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1589), 1,
      aux_sym_intrinsic_type_token4,
    STATE(1730), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3531), 18,
      aux_sym_module_statement_token1,
      aux_sym_subroutine_statement_token1,
      aux_sym_function_statement_token1,
      aux_sym_procedure_attributes_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_procedure_qualifier_token1,
      aux_sym_procedure_qualifier_token2,
      aux_sym_procedure_qualifier_token3,
      aux_sym_procedure_qualifier_token4,
  [79077] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1731), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3533), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3535), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [79111] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1732), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3537), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3539), 17,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_derived_type_definition_token1,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [79145] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1733), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3436), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(3441), 14,
      aux_sym_module_procedure_statement_token1,
      aux_sym_contains_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_end_type_statement_token1,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token8,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
      aux_sym_derived_type_token1,
      aux_sym_include_statement_token1,
  [79176] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(2588), 1,
      aux_sym_public_statement_token1,
    ACTIONS(3541), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3545), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1734), 1,
      sym_preproc_file_line,
    STATE(1736), 1,
      sym_public_statement,
    STATE(1740), 1,
      sym_private_statement,
    STATE(1741), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79224] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1735), 1,
      sym_preproc_file_line,
    STATE(1742), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(2034), 1,
      sym_statement_label,
    STATE(2585), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [79274] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2586), 1,
      aux_sym_private_statement_token1,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3561), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3563), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1736), 1,
      sym_preproc_file_line,
    STATE(1746), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1748), 1,
      sym_private_statement,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79316] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1737), 1,
      sym_preproc_file_line,
    STATE(1742), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(1969), 1,
      sym_statement_label,
    STATE(2474), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [79366] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1738), 1,
      sym_preproc_file_line,
    STATE(1742), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(2128), 1,
      sym_statement_label,
    STATE(2526), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [79416] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1739), 1,
      sym_preproc_file_line,
    STATE(1742), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(2090), 1,
      sym_statement_label,
    STATE(2456), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [79466] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3561), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3563), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1740), 1,
      sym_preproc_file_line,
    STATE(1746), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79502] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3561), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3563), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1741), 1,
      sym_preproc_file_line,
    STATE(1747), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79538] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3565), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3567), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3570), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3575), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3578), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3581), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1817), 1,
      sym_type_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3573), 2,
      sym__integer_literal,
      aux_sym_end_select_statement_token1,
    STATE(1742), 2,
      sym_preproc_file_line,
      aux_sym_select_type_statement_repeat1,
  [79578] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3584), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3586), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1743), 1,
      sym_preproc_file_line,
    STATE(1747), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79614] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    ACTIONS(3588), 1,
      aux_sym_implicit_statement_token2,
    STATE(1744), 1,
      sym_preproc_file_line,
    STATE(1922), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [79646] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2626), 1,
      aux_sym_select_case_statement_token3,
    ACTIONS(3590), 1,
      aux_sym_do_loop_statement_token1,
    ACTIONS(3592), 1,
      aux_sym__inline_if_statement_token1,
    ACTIONS(3594), 1,
      aux_sym__inline_where_statement_token1,
    ACTIONS(3596), 1,
      aux_sym__forall_control_expression_token1,
    ACTIONS(3598), 1,
      aux_sym_select_case_statement_token1,
    ACTIONS(3600), 1,
      aux_sym_select_type_statement_token1,
    ACTIONS(3602), 1,
      aux_sym_select_rank_statement_token2,
    ACTIONS(3604), 1,
      aux_sym_block_construct_token1,
    ACTIONS(3606), 1,
      aux_sym_associate_statement_token1,
    STATE(1745), 1,
      sym_preproc_file_line,
    STATE(2784), 1,
      sym__forall_control_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [79690] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3608), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3610), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1746), 1,
      sym_preproc_file_line,
    STATE(1747), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79726] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3612), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3614), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3620), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1747), 2,
      sym_preproc_file_line,
      aux_sym_derived_type_procedures_repeat1,
    ACTIONS(3617), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79760] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3543), 1,
      aux_sym_module_statement_token1,
    ACTIONS(3608), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3610), 1,
      aux_sym_end_type_statement_token1,
    STATE(861), 1,
      sym__procedure_kind,
    STATE(1743), 1,
      aux_sym_derived_type_procedures_repeat1,
    STATE(1748), 1,
      sym_preproc_file_line,
    STATE(1815), 1,
      sym_procedure_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2028), 5,
      aux_sym_module_procedure_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79796] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1363), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2710), 1,
      anon_sym_LPAREN,
    STATE(1749), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1365), 9,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79824] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2798), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1750), 1,
      sym_preproc_file_line,
    STATE(1752), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2800), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79853] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2766), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1751), 1,
      sym_preproc_file_line,
    STATE(1759), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2768), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79882] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2810), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1752), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2812), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79911] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3624), 1,
      aux_sym_end_program_statement_token1,
    STATE(1753), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3626), 9,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79936] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2810), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1754), 1,
      sym_preproc_file_line,
    STATE(1786), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2812), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79965] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2816), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1755), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2818), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [79994] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2806), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1756), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2808), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80023] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3628), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3632), 1,
      aux_sym_abstract_specifier_token1,
    ACTIONS(3634), 1,
      aux_sym_base_type_specifier_token1,
    STATE(1757), 1,
      sym_preproc_file_line,
    STATE(2258), 1,
      sym_access_specifier,
    STATE(2273), 1,
      sym_base_type_specifier,
    STATE(2285), 1,
      sym__derived_type_qualifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3630), 2,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
    STATE(2252), 2,
      sym_language_binding,
      sym_abstract_specifier,
  [80060] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2903), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1758), 1,
      sym_preproc_file_line,
    STATE(1782), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2905), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80089] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2929), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1759), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2931), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80118] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3638), 1,
      aux_sym_select_case_statement_token1,
    STATE(1760), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3636), 9,
      aux_sym_do_loop_statement_token1,
      aux_sym__inline_if_statement_token1,
      aux_sym__inline_where_statement_token1,
      aux_sym__forall_control_expression_token1,
      aux_sym_select_case_statement_token3,
      aux_sym_select_type_statement_token1,
      aux_sym_select_rank_statement_token2,
      aux_sym_block_construct_token1,
      aux_sym_associate_statement_token1,
  [80143] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2824), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1761), 1,
      sym_preproc_file_line,
    STATE(1772), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2826), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80172] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2824), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2826), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80201] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2903), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2905), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80230] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2040), 1,
      aux_sym_intrinsic_type_token4,
    ACTIONS(2042), 1,
      aux_sym_intrinsic_type_token8,
    STATE(1764), 1,
      sym_preproc_file_line,
    STATE(1915), 1,
      sym_intrinsic_type,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2038), 7,
      aux_sym_intrinsic_type_token1,
      aux_sym_intrinsic_type_token2,
      aux_sym_intrinsic_type_token3,
      aux_sym_intrinsic_type_token6,
      aux_sym_intrinsic_type_token7,
      aux_sym_intrinsic_type_token9,
      aux_sym_intrinsic_type_token10,
  [80259] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(832), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3644), 1,
      aux_sym_elseif_clause_token2,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1765), 1,
      sym_preproc_file_line,
    STATE(1829), 1,
      aux_sym__block_if_statement_repeat1,
    STATE(1882), 1,
      sym_else_clause,
    STATE(1895), 1,
      sym_elseif_clause,
    STATE(1932), 1,
      sym_statement_label,
    STATE(2410), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [80300] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2806), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1755), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1766), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2808), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80329] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2863), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2867), 1,
      anon_sym_EQ_GT,
    STATE(1767), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2865), 8,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80356] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2778), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      sym_preproc_file_line,
    STATE(1783), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2780), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80385] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2778), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1769), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2780), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80414] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2782), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2784), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80443] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2782), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      sym_preproc_file_line,
    STATE(1785), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2784), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80472] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2828), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1772), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2830), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80501] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2828), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1773), 1,
      sym_preproc_file_line,
    STATE(1777), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2830), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80530] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3628), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3632), 1,
      aux_sym_abstract_specifier_token1,
    ACTIONS(3634), 1,
      aux_sym_base_type_specifier_token1,
    STATE(1774), 1,
      sym_preproc_file_line,
    STATE(2081), 1,
      sym__derived_type_qualifier,
    STATE(2258), 1,
      sym_access_specifier,
    STATE(2273), 1,
      sym_base_type_specifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3630), 2,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
    STATE(2252), 2,
      sym_language_binding,
      sym_abstract_specifier,
  [80567] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(832), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3644), 1,
      aux_sym_elseif_clause_token2,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1775), 1,
      sym_preproc_file_line,
    STATE(1829), 1,
      aux_sym__block_if_statement_repeat1,
    STATE(1895), 1,
      sym_elseif_clause,
    STATE(1897), 1,
      sym_else_clause,
    STATE(2075), 1,
      sym_statement_label,
    STATE(2359), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [80608] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2925), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1769), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1776), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2927), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80637] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2832), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1777), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2834), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80666] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3628), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3632), 1,
      aux_sym_abstract_specifier_token1,
    ACTIONS(3634), 1,
      aux_sym_base_type_specifier_token1,
    STATE(1778), 1,
      sym_preproc_file_line,
    STATE(2121), 1,
      sym__derived_type_qualifier,
    STATE(2258), 1,
      sym_access_specifier,
    STATE(2273), 1,
      sym_base_type_specifier,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3630), 2,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
    STATE(2252), 2,
      sym_language_binding,
      sym_abstract_specifier,
  [80703] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2816), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1779), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2818), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80732] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2929), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1780), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2931), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80761] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2794), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1756), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1781), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2796), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80790] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2766), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1782), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2768), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80819] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2794), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1783), 1,
      sym_preproc_file_line,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2796), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80848] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2836), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3648), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1784), 2,
      sym_preproc_file_line,
      aux_sym_procedure_statement_repeat2,
    ACTIONS(2838), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80875] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2798), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1785), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2800), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80904] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2820), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1784), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1786), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2822), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [80933] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(832), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3644), 1,
      aux_sym_elseif_clause_token2,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1787), 1,
      sym_preproc_file_line,
    STATE(1829), 1,
      aux_sym__block_if_statement_repeat1,
    STATE(1884), 1,
      sym_else_clause,
    STATE(1895), 1,
      sym_elseif_clause,
    STATE(1941), 1,
      sym_statement_label,
    STATE(2697), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [80974] = 13,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(832), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3644), 1,
      aux_sym_elseif_clause_token2,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1788), 1,
      sym_preproc_file_line,
    STATE(1829), 1,
      aux_sym__block_if_statement_repeat1,
    STATE(1871), 1,
      sym_else_clause,
    STATE(1895), 1,
      sym_elseif_clause,
    STATE(2171), 1,
      sym_statement_label,
    STATE(2641), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81015] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2859), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3622), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      aux_sym_procedure_statement_repeat2,
    STATE(1789), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2861), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [81044] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2836), 1,
      aux_sym_end_program_statement_token1,
    STATE(1790), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2838), 8,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [81068] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2512), 1,
      anon_sym_DOT,
    STATE(684), 1,
      sym_user_defined_operator,
    STATE(1791), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3651), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1868), 2,
      sym_unary_expression,
      sym_number_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
  [81098] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3653), 1,
      anon_sym_LPAREN,
    ACTIONS(3655), 1,
      anon_sym_RPAREN,
    ACTIONS(3657), 1,
      anon_sym_COMMA,
    ACTIONS(3659), 1,
      sym_edit_descriptor,
    ACTIONS(3661), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3663), 1,
      sym_string_literal,
    STATE(1792), 1,
      sym_preproc_file_line,
    STATE(1798), 1,
      aux_sym__transfer_items_repeat1,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(1849), 1,
      sym__transfer_item,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81136] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3665), 1,
      anon_sym_LPAREN,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3671), 1,
      sym__end_of_statement,
    STATE(1793), 1,
      sym_preproc_file_line,
    STATE(1835), 1,
      aux_sym_function_statement_repeat1,
    STATE(1844), 1,
      sym__parameters,
    STATE(1979), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [81172] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3675), 1,
      aux_sym_procedure_attribute_token2,
    STATE(851), 1,
      sym_procedure_attribute,
    STATE(1794), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3673), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81198] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3675), 1,
      aux_sym_procedure_attribute_token2,
    STATE(1329), 1,
      sym_procedure_attribute,
    STATE(1795), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3673), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81224] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3679), 1,
      aux_sym_procedure_attribute_token2,
    STATE(785), 1,
      sym_procedure_attribute,
    STATE(1796), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3677), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81250] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3679), 1,
      aux_sym_procedure_attribute_token2,
    STATE(815), 1,
      sym_procedure_attribute,
    STATE(1797), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3677), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81276] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3653), 1,
      anon_sym_LPAREN,
    ACTIONS(3657), 1,
      anon_sym_COMMA,
    ACTIONS(3659), 1,
      sym_edit_descriptor,
    ACTIONS(3661), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3663), 1,
      sym_string_literal,
    ACTIONS(3681), 1,
      anon_sym_RPAREN,
    STATE(1798), 1,
      sym_preproc_file_line,
    STATE(1808), 1,
      aux_sym__transfer_items_repeat1,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(1849), 1,
      sym__transfer_item,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81314] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3679), 1,
      aux_sym_procedure_attribute_token2,
    STATE(782), 1,
      sym_procedure_attribute,
    STATE(1799), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3677), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81340] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3675), 1,
      aux_sym_procedure_attribute_token2,
    STATE(873), 1,
      sym_procedure_attribute,
    STATE(1800), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3673), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81366] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3665), 1,
      anon_sym_LPAREN,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3683), 1,
      sym__end_of_statement,
    STATE(1801), 1,
      sym_preproc_file_line,
    STATE(1837), 1,
      sym__parameters,
    STATE(1838), 1,
      aux_sym_function_statement_repeat1,
    STATE(1979), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [81402] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3679), 1,
      aux_sym_procedure_attribute_token2,
    STATE(775), 1,
      sym_procedure_attribute,
    STATE(1802), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3677), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81428] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3675), 1,
      aux_sym_procedure_attribute_token2,
    STATE(849), 1,
      sym_procedure_attribute,
    STATE(1803), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3673), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81454] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2974), 1,
      aux_sym_end_program_statement_token1,
    STATE(1804), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2976), 8,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [81478] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3675), 1,
      aux_sym_procedure_attribute_token2,
    STATE(868), 1,
      sym_procedure_attribute,
    STATE(1805), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3673), 7,
      aux_sym_private_statement_token1,
      aux_sym_public_statement_token1,
      aux_sym_procedure_attribute_token1,
      aux_sym_procedure_attribute_token3,
      aux_sym_procedure_attribute_token4,
      aux_sym_procedure_attribute_token5,
      aux_sym_procedure_attribute_token6,
  [81504] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2863), 1,
      aux_sym_end_program_statement_token1,
    STATE(1806), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2865), 8,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      anon_sym_COMMA,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [81528] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2512), 1,
      anon_sym_DOT,
    STATE(684), 1,
      sym_user_defined_operator,
    STATE(1807), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3651), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1921), 2,
      sym_unary_expression,
      sym_number_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
  [81558] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3685), 1,
      anon_sym_LPAREN,
    ACTIONS(3688), 1,
      anon_sym_RPAREN,
    ACTIONS(3690), 1,
      anon_sym_COMMA,
    ACTIONS(3693), 1,
      sym_edit_descriptor,
    ACTIONS(3696), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3699), 1,
      sym_string_literal,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(1849), 1,
      sym__transfer_item,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1808), 2,
      sym_preproc_file_line,
      aux_sym__transfer_items_repeat1,
  [81594] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2512), 1,
      anon_sym_DOT,
    STATE(684), 1,
      sym_user_defined_operator,
    STATE(1809), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3651), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1886), 2,
      sym_unary_expression,
      sym_number_literal,
    ACTIONS(155), 3,
      sym__integer_literal,
      sym__float_literal,
      sym__boz_literal,
  [81624] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3704), 1,
      aux_sym_procedure_attributes_token3,
    STATE(1810), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3702), 3,
      aux_sym_procedure_attributes_token2,
      aux_sym_procedure_attributes_token4,
      aux_sym_procedure_attributes_token5,
    ACTIONS(3706), 5,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
  [81650] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1811), 1,
      sym_preproc_file_line,
    STATE(1842), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(2036), 1,
      sym_statement_label,
    STATE(2589), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81685] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1812), 1,
      sym_preproc_file_line,
    STATE(1852), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(1971), 1,
      sym_statement_label,
    STATE(2480), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81720] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1738), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1813), 1,
      sym_preproc_file_line,
    STATE(1817), 1,
      sym_type_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81755] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1814), 1,
      sym_preproc_file_line,
    STATE(1852), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(1936), 1,
      sym_statement_label,
    STATE(2440), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81790] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3712), 1,
      aux_sym_end_program_statement_token1,
    STATE(1815), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3714), 7,
      aux_sym_module_statement_token1,
      aux_sym_module_procedure_statement_token1,
      aux_sym_end_type_statement_token1,
      aux_sym__procedure_kind_token1,
      aux_sym__procedure_kind_token2,
      aux_sym__procedure_kind_token3,
      aux_sym__procedure_kind_token4,
  [81813] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1739), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1816), 1,
      sym_preproc_file_line,
    STATE(1817), 1,
      sym_type_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81848] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1817), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3716), 3,
      aux_sym_end_program_statement_token1,
      aux_sym_implicit_statement_token3,
      aux_sym_derived_type_token1,
    ACTIONS(3718), 5,
      sym__integer_literal,
      aux_sym_end_select_statement_token1,
      aux_sym_type_statement_token2,
      aux_sym_type_statement_token3,
      aux_sym__class_default_token1,
  [81871] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1735), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(1818), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81906] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1819), 1,
      sym_preproc_file_line,
    STATE(1852), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(2130), 1,
      sym_statement_label,
    STATE(2529), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81941] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1820), 1,
      sym_preproc_file_line,
    STATE(1842), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(2131), 1,
      sym_statement_label,
    STATE(2532), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [81976] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1821), 1,
      sym_preproc_file_line,
    STATE(1842), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(1973), 1,
      sym_statement_label,
    STATE(2507), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82011] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1425), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1822), 1,
      sym_preproc_file_line,
    STATE(1842), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(2226), 1,
      sym_statement_label,
    STATE(2616), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82046] = 11,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3549), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(3551), 1,
      aux_sym_derived_type_token1,
    ACTIONS(3555), 1,
      aux_sym_type_statement_token2,
    ACTIONS(3557), 1,
      aux_sym_type_statement_token3,
    ACTIONS(3559), 1,
      aux_sym__class_default_token1,
    STATE(1343), 1,
      sym__class_default,
    STATE(1737), 1,
      aux_sym_select_type_statement_repeat1,
    STATE(1817), 1,
      sym_type_statement,
    STATE(1823), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82081] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3722), 1,
      aux_sym_concurrent_locality_token1,
    ACTIONS(3724), 1,
      aux_sym_concurrent_locality_token3,
    ACTIONS(3726), 1,
      sym__end_of_statement,
    STATE(1824), 1,
      sym_preproc_file_line,
    STATE(1826), 1,
      aux_sym_concurrent_statement_repeat1,
    STATE(1888), 1,
      sym_concurrent_locality,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3720), 2,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
  [82111] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(578), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3728), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3730), 1,
      aux_sym_end_where_statement_token1,
    ACTIONS(3732), 1,
      aux_sym_elsewhere_clause_token1,
    STATE(1825), 1,
      sym_preproc_file_line,
    STATE(1840), 1,
      aux_sym__block_where_statement_repeat1,
    STATE(1906), 1,
      sym_elsewhere_clause,
    STATE(2652), 1,
      sym_end_where_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82143] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3722), 1,
      aux_sym_concurrent_locality_token1,
    ACTIONS(3724), 1,
      aux_sym_concurrent_locality_token3,
    ACTIONS(3734), 1,
      sym__end_of_statement,
    STATE(1826), 1,
      sym_preproc_file_line,
    STATE(1830), 1,
      aux_sym_concurrent_statement_repeat1,
    STATE(1888), 1,
      sym_concurrent_locality,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3720), 2,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
  [82173] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3653), 1,
      anon_sym_LPAREN,
    ACTIONS(3659), 1,
      sym_edit_descriptor,
    ACTIONS(3661), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3663), 1,
      sym_string_literal,
    STATE(1792), 1,
      sym__transfer_item,
    STATE(1827), 1,
      sym_preproc_file_line,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(2360), 1,
      sym__transfer_items,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82205] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3653), 1,
      anon_sym_LPAREN,
    ACTIONS(3659), 1,
      sym_edit_descriptor,
    ACTIONS(3661), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3663), 1,
      sym_string_literal,
    STATE(1792), 1,
      sym__transfer_item,
    STATE(1828), 1,
      sym_preproc_file_line,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(2619), 1,
      sym__transfer_items,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82237] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3736), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3740), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3743), 1,
      aux_sym_elseif_clause_token2,
    STATE(1895), 1,
      sym_elseif_clause,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3738), 2,
      sym__integer_literal,
      aux_sym_end_if_statement_token1,
    STATE(1829), 2,
      sym_preproc_file_line,
      aux_sym__block_if_statement_repeat1,
  [82265] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3749), 1,
      aux_sym_concurrent_locality_token1,
    ACTIONS(3752), 1,
      aux_sym_concurrent_locality_token3,
    ACTIONS(3755), 1,
      sym__end_of_statement,
    STATE(1888), 1,
      sym_concurrent_locality,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3746), 2,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
    STATE(1830), 2,
      sym_preproc_file_line,
      aux_sym_concurrent_statement_repeat1,
  [82293] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(578), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3728), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3730), 1,
      aux_sym_end_where_statement_token1,
    ACTIONS(3732), 1,
      aux_sym_elsewhere_clause_token1,
    STATE(1831), 1,
      sym_preproc_file_line,
    STATE(1840), 1,
      aux_sym__block_where_statement_repeat1,
    STATE(1906), 1,
      sym_elsewhere_clause,
    STATE(2379), 1,
      sym_end_where_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82325] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(578), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3728), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3730), 1,
      aux_sym_end_where_statement_token1,
    ACTIONS(3732), 1,
      aux_sym_elsewhere_clause_token1,
    STATE(1832), 1,
      sym_preproc_file_line,
    STATE(1840), 1,
      aux_sym__block_where_statement_repeat1,
    STATE(1906), 1,
      sym_elsewhere_clause,
    STATE(2523), 1,
      sym_end_where_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82357] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3665), 1,
      anon_sym_LPAREN,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3757), 1,
      sym__end_of_statement,
    STATE(1833), 1,
      sym_preproc_file_line,
    STATE(1975), 1,
      sym__parameters,
    STATE(1979), 1,
      sym_parameters,
    STATE(2464), 1,
      sym_language_binding,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82386] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3759), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3762), 1,
      aux_sym_function_result_token1,
    ACTIONS(3765), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1834), 2,
      sym_preproc_file_line,
      aux_sym_function_statement_repeat1,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82411] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3767), 1,
      sym__end_of_statement,
    STATE(1834), 1,
      aux_sym_function_statement_repeat1,
    STATE(1835), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82438] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3771), 1,
      sym_edit_descriptor,
    STATE(1836), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3769), 5,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_hollerith_constant_token1,
  [82459] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3773), 1,
      sym__end_of_statement,
    STATE(1837), 1,
      sym_preproc_file_line,
    STATE(1853), 1,
      aux_sym_function_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82486] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3775), 1,
      sym__end_of_statement,
    STATE(1834), 1,
      aux_sym_function_statement_repeat1,
    STATE(1838), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82513] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1839), 1,
      sym_preproc_file_line,
    STATE(1864), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2886), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82542] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3783), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3785), 1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3788), 1,
      aux_sym_end_where_statement_token1,
    ACTIONS(3790), 1,
      aux_sym_elsewhere_clause_token1,
    STATE(1906), 1,
      sym_elsewhere_clause,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1840), 2,
      sym_preproc_file_line,
      aux_sym__block_where_statement_repeat1,
  [82569] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3665), 1,
      anon_sym_LPAREN,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3793), 1,
      sym__end_of_statement,
    STATE(1841), 1,
      sym_preproc_file_line,
    STATE(1979), 1,
      sym_parameters,
    STATE(2089), 1,
      sym__parameters,
    STATE(2407), 1,
      sym_language_binding,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82598] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3795), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3797), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1901), 1,
      sym_rank_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3800), 2,
      sym__integer_literal,
      aux_sym_end_select_statement_token1,
    STATE(1842), 2,
      sym_preproc_file_line,
      aux_sym_select_rank_statement_repeat1,
  [82623] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3802), 1,
      sym_edit_descriptor,
    STATE(1843), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3688), 5,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_hollerith_constant_token1,
  [82644] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3804), 1,
      sym__end_of_statement,
    STATE(1844), 1,
      sym_preproc_file_line,
    STATE(1865), 1,
      aux_sym_function_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82671] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3806), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3808), 1,
      anon_sym_EQ,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      sym_preproc_file_line,
    STATE(1893), 1,
      aux_sym_enumerator_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3812), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [82698] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3816), 1,
      sym_edit_descriptor,
    STATE(1846), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3814), 5,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_hollerith_constant_token1,
  [82719] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3818), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3820), 1,
      anon_sym_EQ,
    STATE(1847), 1,
      sym_preproc_file_line,
    STATE(1887), 1,
      aux_sym_enumerator_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3822), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [82746] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1848), 1,
      sym_preproc_file_line,
    STATE(1850), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2704), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82775] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3826), 1,
      sym_edit_descriptor,
    STATE(1849), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3824), 5,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_hollerith_constant_token1,
  [82796] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1850), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2791), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82825] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3653), 1,
      anon_sym_LPAREN,
    ACTIONS(3659), 1,
      sym_edit_descriptor,
    ACTIONS(3661), 1,
      aux_sym_hollerith_constant_token1,
    ACTIONS(3663), 1,
      sym_string_literal,
    STATE(1843), 1,
      sym__transfer_item,
    STATE(1846), 1,
      sym_hollerith_constant,
    STATE(1851), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82854] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3828), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3830), 1,
      aux_sym_select_case_statement_token2,
    STATE(1910), 1,
      sym_case_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3833), 2,
      sym__integer_literal,
      aux_sym_end_select_statement_token1,
    STATE(1852), 2,
      sym_preproc_file_line,
      aux_sym_select_case_statement_repeat1,
  [82879] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3835), 1,
      sym__end_of_statement,
    STATE(1834), 1,
      aux_sym_function_statement_repeat1,
    STATE(1853), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [82906] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1854), 1,
      sym_preproc_file_line,
    STATE(1855), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2400), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82935] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1855), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2429), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82964] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1856), 1,
      sym_preproc_file_line,
    STATE(1857), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2484), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [82993] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1857), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2506), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83022] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1858), 1,
      sym_preproc_file_line,
    STATE(1859), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2556), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83051] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1859), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2577), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83080] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1860), 1,
      sym_preproc_file_line,
    STATE(1861), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2625), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83109] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1861), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2647), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83138] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1862), 1,
      sym_preproc_file_line,
    STATE(1863), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2693), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83167] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1863), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2713), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83196] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3777), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3779), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3781), 1,
      aux_sym_end_enum_statement_token1,
    STATE(1864), 1,
      sym_preproc_file_line,
    STATE(1872), 1,
      aux_sym_enum_repeat1,
    STATE(2233), 1,
      sym_enumerator_statement,
    STATE(2655), 1,
      sym_end_enum_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83225] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(3669), 1,
      aux_sym_function_result_token1,
    ACTIONS(3837), 1,
      sym__end_of_statement,
    STATE(1834), 1,
      aux_sym_function_statement_repeat1,
    STATE(1865), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1998), 2,
      sym_language_binding,
      sym_function_result,
  [83252] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3841), 1,
      sym_edit_descriptor,
    STATE(1866), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3839), 5,
      sym_string_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_hollerith_constant_token1,
  [83273] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1867), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3706), 6,
      aux_sym_procedure_attributes_token3,
      aux_sym_variable_attributes_token1,
      aux_sym_variable_attributes_token2,
      aux_sym_variable_attributes_token3,
      aux_sym_variable_attributes_token4,
      aux_sym_variable_attributes_token5,
  [83292] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3843), 1,
      aux_sym_end_program_statement_token1,
    STATE(1868), 1,
      sym_preproc_file_line,
    STATE(1879), 1,
      aux_sym_enumerator_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3845), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83316] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1869), 2,
      sym_preproc_file_line,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(2514), 3,
      anon_sym_GT_GT_GT,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [83336] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3850), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3852), 1,
      anon_sym_EQ,
    STATE(1870), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3854), 3,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83358] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1871), 1,
      sym_preproc_file_line,
    STATE(1932), 1,
      sym_statement_label,
    STATE(2410), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83384] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3856), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3858), 1,
      aux_sym_enumerator_statement_token1,
    ACTIONS(3861), 1,
      aux_sym_end_enum_statement_token1,
    STATE(2233), 1,
      sym_enumerator_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1872), 2,
      sym_preproc_file_line,
      aux_sym_enum_repeat1,
  [83408] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3865), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1873), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3863), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83428] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3869), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1874), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3867), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83448] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3873), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1875), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3871), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83468] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3877), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1876), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3875), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83488] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3881), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1877), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3879), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83508] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3885), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1878), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3883), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83528] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3887), 1,
      aux_sym_end_program_statement_token1,
    STATE(1879), 1,
      sym_preproc_file_line,
    STATE(1881), 1,
      aux_sym_enumerator_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3889), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83552] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3891), 1,
      aux_sym_end_program_statement_token1,
    STATE(1880), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3893), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83572] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3850), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3895), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3854), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
    STATE(1881), 2,
      sym_preproc_file_line,
      aux_sym_enumerator_statement_repeat1,
  [83594] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1882), 1,
      sym_preproc_file_line,
    STATE(1957), 1,
      sym_statement_label,
    STATE(2488), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83620] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3900), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1883), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3898), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83640] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1884), 1,
      sym_preproc_file_line,
    STATE(2075), 1,
      sym_statement_label,
    STATE(2359), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83666] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3904), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1885), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3902), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83686] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3887), 1,
      aux_sym_end_program_statement_token1,
    STATE(1886), 1,
      sym_preproc_file_line,
    STATE(1891), 1,
      aux_sym_enumerator_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3889), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83710] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3806), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1881), 1,
      aux_sym_enumerator_statement_repeat1,
    STATE(1887), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3812), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83734] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3908), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1888), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3906), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83754] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1365), 1,
      anon_sym_EQ,
    ACTIONS(1580), 1,
      anon_sym_RPAREN,
    STATE(1889), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1578), 3,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_STAR,
  [83776] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3912), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1890), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3910), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83796] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3914), 1,
      aux_sym_end_program_statement_token1,
    STATE(1881), 1,
      aux_sym_enumerator_statement_repeat1,
    STATE(1891), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3916), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83820] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3918), 1,
      aux_sym_end_program_statement_token1,
    STATE(1892), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3920), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83840] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    ACTIONS(3843), 1,
      aux_sym_end_program_statement_token1,
    STATE(1881), 1,
      aux_sym_enumerator_statement_repeat1,
    STATE(1893), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3845), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [83864] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3924), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1894), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3922), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83884] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1895), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3926), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3928), 3,
      sym__integer_literal,
      aux_sym_end_if_statement_token1,
      aux_sym_elseif_clause_token2,
  [83904] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1896), 1,
      sym_preproc_file_line,
    STATE(1941), 1,
      sym_statement_label,
    STATE(2697), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83930] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    ACTIONS(3646), 1,
      sym__integer_literal,
    STATE(1897), 1,
      sym_preproc_file_line,
    STATE(2171), 1,
      sym_statement_label,
    STATE(2641), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [83956] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3932), 1,
      aux_sym_concurrent_locality_token1,
    STATE(1898), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3930), 4,
      sym__end_of_statement,
      aux_sym_variable_attributes_token3,
      aux_sym_concurrent_locality_token2,
      aux_sym_concurrent_locality_token3,
  [83976] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3934), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2734), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
    STATE(1899), 2,
      sym_preproc_file_line,
      aux_sym_parameters_repeat1,
  [83995] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2946), 1,
      anon_sym_COMMA,
    ACTIONS(3937), 1,
      anon_sym_SLASH,
    STATE(1900), 1,
      sym_preproc_file_line,
    STATE(1992), 1,
      aux_sym_data_set_repeat1,
    STATE(2306), 1,
      sym_data_value,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84018] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3939), 1,
      aux_sym_end_program_statement_token1,
    STATE(1901), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3941), 3,
      sym__integer_literal,
      aux_sym_select_rank_statement_token1,
      aux_sym_end_select_statement_token1,
  [84037] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3943), 1,
      anon_sym_LPAREN,
    ACTIONS(3945), 1,
      aux_sym_size_token1,
    STATE(812), 1,
      sym_parenthesized_expression,
    STATE(814), 1,
      sym_argument_list,
    STATE(1902), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84060] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3947), 1,
      anon_sym_LPAREN,
    ACTIONS(3949), 1,
      sym__integer_literal,
    STATE(1903), 1,
      sym_preproc_file_line,
    STATE(2260), 1,
      sym_statement_label,
    STATE(2533), 1,
      sym_statement_label_reference,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84083] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1904), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3951), 4,
      aux_sym_procedure_attributes_token2,
      aux_sym_procedure_attributes_token3,
      aux_sym_procedure_attributes_token4,
      aux_sym_procedure_attributes_token5,
  [84100] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1538), 1,
      aux_sym_end_program_statement_token1,
    STATE(1905), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1544), 3,
      aux_sym_implicit_statement_token3,
      aux_sym_end_select_statement_token1,
      aux_sym_format_statement_token1,
  [84119] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1906), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3953), 2,
      aux_sym_end_program_statement_token1,
      aux_sym_elseif_clause_token1,
    ACTIONS(3955), 2,
      aux_sym_end_where_statement_token1,
      aux_sym_elsewhere_clause_token1,
  [84138] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(1869), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    STATE(1907), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3957), 2,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [84159] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1899), 1,
      aux_sym_parameters_repeat1,
    STATE(1908), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3122), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
  [84180] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1909), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3702), 4,
      aux_sym_procedure_attributes_token2,
      aux_sym_procedure_attributes_token3,
      aux_sym_procedure_attributes_token4,
      aux_sym_procedure_attributes_token5,
  [84197] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3961), 1,
      aux_sym_end_program_statement_token1,
    STATE(1910), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3963), 3,
      sym__integer_literal,
      aux_sym_select_case_statement_token2,
      aux_sym_end_select_statement_token1,
  [84216] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    ACTIONS(3967), 1,
      anon_sym_EQ_GT,
    ACTIONS(3969), 1,
      sym__end_of_statement,
    STATE(1911), 1,
      sym_preproc_file_line,
    STATE(2042), 1,
      aux_sym_included_items_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84239] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3971), 1,
      anon_sym_LPAREN,
    ACTIONS(3975), 1,
      aux_sym_size_token1,
    STATE(1912), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3973), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [84260] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3977), 1,
      anon_sym_SLASH,
    ACTIONS(3980), 1,
      sym__end_of_statement,
    STATE(2294), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1913), 2,
      sym_preproc_file_line,
      aux_sym_namelist_statement_repeat1,
  [84281] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3982), 1,
      anon_sym_LPAREN,
    ACTIONS(3984), 1,
      aux_sym_size_token1,
    STATE(735), 1,
      sym_parenthesized_expression,
    STATE(736), 1,
      sym_argument_list,
    STATE(1914), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84304] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(3986), 1,
      anon_sym_LPAREN,
    STATE(1562), 1,
      sym_argument_list,
    STATE(1915), 1,
      sym_preproc_file_line,
    STATE(2576), 1,
      sym_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84327] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1916), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1361), 4,
      sym__end_of_statement,
      anon_sym_LPAREN,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [84344] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3988), 1,
      anon_sym_LPAREN,
    ACTIONS(3990), 1,
      aux_sym_size_token1,
    STATE(1561), 1,
      sym_argument_list,
    STATE(1563), 1,
      sym_parenthesized_expression,
    STATE(1917), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84367] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(1869), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    STATE(1918), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3992), 2,
      anon_sym_SLASH_RPAREN,
      anon_sym_RBRACK,
  [84388] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1908), 1,
      aux_sym_parameters_repeat1,
    STATE(1919), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3116), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
  [84409] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3994), 1,
      anon_sym_LPAREN,
    STATE(1920), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1365), 3,
      sym__end_of_statement,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [84428] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3996), 1,
      aux_sym_end_program_statement_token1,
    STATE(1921), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3998), 3,
      anon_sym_COMMA,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [84447] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3280), 1,
      anon_sym_STAR,
    ACTIONS(4000), 1,
      anon_sym_LPAREN,
    STATE(1562), 1,
      sym_argument_list,
    STATE(1922), 1,
      sym_preproc_file_line,
    STATE(2603), 1,
      sym_size,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84470] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4002), 1,
      anon_sym_SLASH,
    ACTIONS(4004), 1,
      sym__end_of_statement,
    STATE(1913), 1,
      aux_sym_namelist_statement_repeat1,
    STATE(1923), 1,
      sym_preproc_file_line,
    STATE(2294), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84493] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3949), 1,
      sym__integer_literal,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
    STATE(1924), 1,
      sym_preproc_file_line,
    STATE(2260), 1,
      sym_statement_label,
    STATE(2415), 1,
      sym_statement_label_reference,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84516] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1821), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(1925), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84536] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4008), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4010), 1,
      aux_sym_end_program_statement_token2,
    STATE(242), 1,
      sym_end_program_statement,
    STATE(1926), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84556] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4012), 1,
      anon_sym_RPAREN,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    STATE(1927), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84576] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(4016), 1,
      sym__end_of_statement,
    STATE(1928), 1,
      sym_preproc_file_line,
    STATE(2033), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84596] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(4018), 1,
      sym__end_of_statement,
    STATE(1929), 1,
      sym_preproc_file_line,
    STATE(2033), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84616] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1930), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4020), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [84632] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4022), 1,
      anon_sym_RPAREN,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    STATE(1931), 1,
      sym_preproc_file_line,
    STATE(1988), 1,
      aux_sym_keyword_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84652] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    STATE(1932), 1,
      sym_preproc_file_line,
    STATE(2488), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84672] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    ACTIONS(4026), 1,
      anon_sym_RPAREN,
    STATE(1933), 1,
      sym_preproc_file_line,
    STATE(2169), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84692] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4028), 1,
      anon_sym_COMMA,
    ACTIONS(4030), 1,
      sym__end_of_statement,
    STATE(1934), 1,
      sym_preproc_file_line,
    STATE(1989), 1,
      aux_sym_data_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84712] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4032), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4034), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1674), 1,
      sym_end_subroutine_statement,
    STATE(1935), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84732] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(1936), 1,
      sym_preproc_file_line,
    STATE(2597), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84752] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1365), 1,
      sym__end_of_statement,
    ACTIONS(4036), 1,
      anon_sym_LPAREN,
    STATE(1937), 1,
      sym_preproc_file_line,
    STATE(2355), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84772] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4038), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4040), 1,
      aux_sym_end_function_statement_token1,
    STATE(1677), 1,
      sym_end_function_statement,
    STATE(1938), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84792] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4042), 1,
      anon_sym_RPAREN,
    ACTIONS(4044), 1,
      anon_sym_COMMA,
    STATE(1939), 1,
      sym_preproc_file_line,
    STATE(2180), 1,
      aux_sym_procedure_attributes_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84812] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4032), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4034), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1680), 1,
      sym_end_subroutine_statement,
    STATE(1940), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84832] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    STATE(1941), 1,
      sym_preproc_file_line,
    STATE(2359), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84852] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4046), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4048), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1637), 1,
      sym_end_module_procedure_statement,
    STATE(1942), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84872] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4038), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4040), 1,
      aux_sym_end_function_statement_token1,
    STATE(1682), 1,
      sym_end_function_statement,
    STATE(1943), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84892] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4050), 1,
      anon_sym_RPAREN,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    STATE(1944), 1,
      sym_preproc_file_line,
    STATE(2110), 1,
      aux_sym_implicit_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84912] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4050), 1,
      anon_sym_RPAREN,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      sym_preproc_file_line,
    STATE(1960), 1,
      aux_sym_implicit_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84932] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4054), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4056), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1687), 1,
      sym_end_module_procedure_statement,
    STATE(1946), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84952] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4054), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4056), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1689), 1,
      sym_end_module_procedure_statement,
    STATE(1947), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84972] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4060), 1,
      sym__end_of_statement,
    STATE(1948), 1,
      sym_preproc_file_line,
    STATE(2186), 1,
      aux_sym_use_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [84992] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4062), 1,
      anon_sym_RPAREN,
    ACTIONS(4064), 1,
      anon_sym_COMMA,
    STATE(1949), 1,
      sym_preproc_file_line,
    STATE(2188), 1,
      aux_sym_implicit_statement_repeat3,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85012] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4068), 1,
      anon_sym_DASH,
    STATE(1950), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [85030] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4070), 1,
      anon_sym_RPAREN,
    STATE(1951), 1,
      sym_preproc_file_line,
    STATE(2192), 1,
      aux_sym_implicit_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85050] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3949), 1,
      sym__integer_literal,
    STATE(1952), 1,
      sym_preproc_file_line,
    STATE(2260), 1,
      sym_statement_label,
    STATE(2383), 1,
      sym_statement_label_reference,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85070] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    ACTIONS(4074), 1,
      anon_sym_COLON_COLON,
    STATE(1953), 1,
      sym_preproc_file_line,
    STATE(2204), 1,
      aux_sym_derived_type_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85090] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4078), 1,
      sym__end_of_statement,
    STATE(1954), 1,
      sym_preproc_file_line,
    STATE(1956), 1,
      aux_sym_save_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85110] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4078), 1,
      sym__end_of_statement,
    STATE(1955), 1,
      sym_preproc_file_line,
    STATE(2206), 1,
      aux_sym_save_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85130] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    ACTIONS(4083), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1956), 2,
      sym_preproc_file_line,
      aux_sym_save_statement_repeat1,
  [85148] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    STATE(1957), 1,
      sym_preproc_file_line,
    STATE(2393), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85168] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3406), 1,
      sym__end_of_statement,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1958), 1,
      sym_preproc_file_line,
    STATE(2208), 1,
      aux_sym_private_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85188] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3204), 1,
      sym__end_of_statement,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      sym_preproc_file_line,
    STATE(2208), 1,
      aux_sym_private_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85208] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4087), 1,
      anon_sym_RPAREN,
    STATE(1960), 1,
      sym_preproc_file_line,
    STATE(2110), 1,
      aux_sym_implicit_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85228] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4089), 1,
      anon_sym_RPAREN,
    ACTIONS(4091), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1961), 2,
      sym_preproc_file_line,
      aux_sym_associate_statement_repeat1,
  [85246] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2857), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1899), 1,
      aux_sym_parameters_repeat1,
    STATE(1962), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85266] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4094), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4096), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1699), 1,
      sym_end_subroutine_statement,
    STATE(1963), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85286] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(366), 1,
      sym_end_type_statement,
    STATE(1964), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85306] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4098), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4100), 1,
      aux_sym_end_function_statement_token1,
    STATE(1702), 1,
      sym_end_function_statement,
    STATE(1965), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85326] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1738), 1,
      anon_sym_COLON,
    STATE(1966), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(1740), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [85344] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4102), 1,
      anon_sym_RPAREN,
    STATE(1967), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85364] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4104), 1,
      anon_sym_RPAREN,
    ACTIONS(4106), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1968), 2,
      sym_preproc_file_line,
      aux_sym__forall_control_expression_repeat1,
  [85382] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(1969), 1,
      sym_preproc_file_line,
    STATE(2401), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85402] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4094), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4096), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1705), 1,
      sym_end_subroutine_statement,
    STATE(1970), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85422] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(1971), 1,
      sym_preproc_file_line,
    STATE(2408), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85442] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4098), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4100), 1,
      aux_sym_end_function_statement_token1,
    STATE(1707), 1,
      sym_end_function_statement,
    STATE(1972), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85462] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(1973), 1,
      sym_preproc_file_line,
    STATE(2412), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85482] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4109), 1,
      anon_sym_RPAREN,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
    STATE(1974), 1,
      sym_preproc_file_line,
    STATE(2018), 1,
      aux_sym__forall_control_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85502] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(4113), 1,
      sym__end_of_statement,
    STATE(1975), 1,
      sym_preproc_file_line,
    STATE(2580), 1,
      sym_language_binding,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85522] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4115), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4117), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1712), 1,
      sym_end_module_procedure_statement,
    STATE(1976), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85542] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4115), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4117), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1564), 1,
      sym_end_module_procedure_statement,
    STATE(1977), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85562] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2499), 1,
      anon_sym_RPAREN,
    ACTIONS(2501), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      sym_preproc_file_line,
    STATE(2092), 1,
      aux_sym_case_value_range_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85582] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1979), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4119), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [85598] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1814), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(1980), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85618] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4121), 1,
      anon_sym_RPAREN,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    STATE(1981), 1,
      sym_preproc_file_line,
    STATE(2216), 1,
      aux_sym_parameter_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85638] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4002), 1,
      anon_sym_SLASH,
    STATE(1923), 1,
      aux_sym_namelist_statement_repeat1,
    STATE(1982), 1,
      sym_preproc_file_line,
    STATE(2294), 1,
      sym_variable_group,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85658] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4008), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4010), 1,
      aux_sym_end_program_statement_token2,
    STATE(249), 1,
      sym_end_program_statement,
    STATE(1983), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85678] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4125), 1,
      anon_sym_COMMA,
    ACTIONS(4128), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1984), 2,
      sym_preproc_file_line,
      aux_sym_equivalence_statement_repeat1,
  [85696] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1822), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(1985), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85716] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    ACTIONS(4130), 1,
      anon_sym_RPAREN,
    STATE(1986), 1,
      sym_preproc_file_line,
    STATE(2220), 1,
      aux_sym_keyword_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85736] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2437), 1,
      sym__integer_literal,
    STATE(1473), 1,
      sym_statement_label,
    STATE(1987), 1,
      sym_preproc_file_line,
    STATE(2320), 1,
      sym_statement_label_reference,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85756] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    ACTIONS(4130), 1,
      anon_sym_RPAREN,
    STATE(1988), 1,
      sym_preproc_file_line,
    STATE(2222), 1,
      aux_sym_keyword_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85776] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4132), 1,
      anon_sym_COMMA,
    ACTIONS(4135), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1989), 2,
      sym_preproc_file_line,
      aux_sym_data_statement_repeat1,
  [85794] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4137), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4139), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1574), 1,
      sym_end_subroutine_statement,
    STATE(1990), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85814] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4141), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4143), 1,
      aux_sym_end_function_statement_token1,
    STATE(1577), 1,
      sym_end_function_statement,
    STATE(1991), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85834] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3193), 1,
      anon_sym_SLASH,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(1992), 2,
      sym_preproc_file_line,
      aux_sym_data_set_repeat1,
  [85852] = 6,
    ACTIONS(4148), 1,
      aux_sym_size_token1,
    ACTIONS(4150), 1,
      anon_sym_POUND,
    ACTIONS(4154), 1,
      anon_sym_LF,
    STATE(1993), 1,
      sym_preproc_file_line,
    STATE(2920), 1,
      sym__newline,
    ACTIONS(4152), 2,
      sym_comment,
      anon_sym_AMP,
  [85872] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4137), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4139), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1580), 1,
      sym_end_subroutine_statement,
    STATE(1994), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85892] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4156), 1,
      sym__end_of_statement,
    STATE(1995), 1,
      sym_preproc_file_line,
    STATE(2093), 1,
      aux_sym_save_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85912] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4158), 1,
      anon_sym_RPAREN,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    STATE(1996), 1,
      sym_preproc_file_line,
    STATE(2040), 1,
      aux_sym_associate_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85932] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4141), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4143), 1,
      aux_sym_end_function_statement_token1,
    STATE(1582), 1,
      sym_end_function_statement,
    STATE(1997), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85952] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(1998), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4162), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [85968] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
    STATE(1999), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [85988] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4166), 1,
      anon_sym_RPAREN,
    STATE(2000), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86008] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4168), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4170), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1587), 1,
      sym_end_module_procedure_statement,
    STATE(2001), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86028] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      sym_preproc_file_line,
    STATE(2043), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86048] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4168), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4170), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1589), 1,
      sym_end_module_procedure_statement,
    STATE(2003), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86068] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4174), 1,
      aux_sym_end_program_statement_token1,
    STATE(2004), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4176), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [86086] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4178), 1,
      anon_sym_RPAREN,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
    STATE(2005), 1,
      sym_preproc_file_line,
    STATE(2230), 1,
      aux_sym_concurrent_header_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86106] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4182), 1,
      anon_sym_RPAREN,
    STATE(2006), 1,
      sym_preproc_file_line,
    STATE(2045), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86126] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    ACTIONS(4184), 1,
      anon_sym_COLON_COLON,
    STATE(2007), 1,
      sym_preproc_file_line,
    STATE(2204), 1,
      aux_sym_derived_type_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86146] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2437), 1,
      sym__integer_literal,
    STATE(1473), 1,
      sym_statement_label,
    STATE(2008), 1,
      sym_preproc_file_line,
    STATE(2907), 1,
      sym_statement_label_reference,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86166] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4186), 1,
      anon_sym_RPAREN,
    STATE(1999), 1,
      aux_sym__io_arguments_repeat1,
    STATE(2009), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86186] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4044), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_RPAREN,
    STATE(1939), 1,
      aux_sym_procedure_attributes_repeat1,
    STATE(2010), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86206] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4044), 1,
      anon_sym_COMMA,
    ACTIONS(4190), 1,
      anon_sym_RPAREN,
    STATE(1939), 1,
      aux_sym_procedure_attributes_repeat1,
    STATE(2011), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86226] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1367), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1369), 1,
      aux_sym_end_module_statement_token1,
    STATE(254), 1,
      sym_end_module_statement,
    STATE(2012), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86246] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4192), 1,
      anon_sym_RPAREN,
    STATE(2000), 1,
      aux_sym__io_arguments_repeat1,
    STATE(2013), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86266] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4194), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4196), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1599), 1,
      sym_end_subroutine_statement,
    STATE(2014), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86286] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4046), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4048), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1611), 1,
      sym_end_module_procedure_statement,
    STATE(2015), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86306] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4198), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4200), 1,
      aux_sym_end_function_statement_token1,
    STATE(1602), 1,
      sym_end_function_statement,
    STATE(2016), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86326] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2017), 1,
      sym_preproc_file_line,
    STATE(2557), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86346] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4206), 1,
      anon_sym_RPAREN,
    ACTIONS(4208), 1,
      anon_sym_COMMA,
    STATE(1968), 1,
      aux_sym__forall_control_expression_repeat1,
    STATE(2018), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86366] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4210), 1,
      anon_sym_COMMA,
    ACTIONS(4212), 1,
      sym__end_of_statement,
    STATE(2019), 1,
      sym_preproc_file_line,
    STATE(2392), 1,
      sym_included_items,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86386] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(371), 1,
      sym_end_type_statement,
    STATE(2020), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86406] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4194), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4196), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1604), 1,
      sym_end_subroutine_statement,
    STATE(2021), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86426] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4214), 1,
      aux_sym_included_items_token1,
    ACTIONS(4216), 1,
      aux_sym_implicit_statement_token2,
    ACTIONS(4218), 1,
      aux_sym__import_names_token1,
    STATE(2022), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86446] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4198), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4200), 1,
      aux_sym_end_function_statement_token1,
    STATE(1606), 1,
      sym_end_function_statement,
    STATE(2023), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86466] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1812), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(2024), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86486] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4008), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4010), 1,
      aux_sym_end_program_statement_token2,
    STATE(281), 1,
      sym_end_program_statement,
    STATE(2025), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86506] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3710), 1,
      aux_sym_select_case_statement_token2,
    STATE(1819), 1,
      aux_sym_select_case_statement_repeat1,
    STATE(1910), 1,
      sym_case_statement,
    STATE(2026), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86526] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2847), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(2027), 1,
      sym_preproc_file_line,
    STATE(2150), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86546] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1367), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1369), 1,
      aux_sym_end_module_statement_token1,
    STATE(236), 1,
      sym_end_module_statement,
    STATE(2028), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86566] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1820), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(2029), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86586] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4220), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4222), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1618), 1,
      sym_end_subroutine_statement,
    STATE(2030), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86606] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1427), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1429), 1,
      aux_sym_end_submodule_statement_token1,
    STATE(241), 1,
      sym_end_submodule_statement,
    STATE(2031), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86626] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4224), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4226), 1,
      aux_sym_end_function_statement_token1,
    STATE(1621), 1,
      sym_end_function_statement,
    STATE(2032), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86646] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2514), 1,
      sym__end_of_statement,
    ACTIONS(4228), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2033), 2,
      sym_preproc_file_line,
      aux_sym_cuda_kernel_argument_list_repeat1,
  [86664] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2034), 1,
      sym_preproc_file_line,
    STATE(2537), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86684] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4220), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4222), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1623), 1,
      sym_end_subroutine_statement,
    STATE(2035), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86704] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2036), 1,
      sym_preproc_file_line,
    STATE(2544), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86724] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4224), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4226), 1,
      aux_sym_end_function_statement_token1,
    STATE(1625), 1,
      sym_end_function_statement,
    STATE(2037), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86744] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    ACTIONS(4231), 1,
      anon_sym_RPAREN,
    STATE(1961), 1,
      aux_sym_associate_statement_repeat1,
    STATE(2038), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86764] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    STATE(2039), 1,
      sym_preproc_file_line,
    STATE(2136), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86784] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    STATE(1961), 1,
      aux_sym_associate_statement_repeat1,
    STATE(2040), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86804] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4237), 1,
      sym__end_of_statement,
    STATE(2041), 1,
      sym_preproc_file_line,
    STATE(2143), 1,
      aux_sym_use_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86824] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    ACTIONS(4239), 1,
      sym__end_of_statement,
    STATE(2042), 1,
      sym_preproc_file_line,
    STATE(2148), 1,
      aux_sym_included_items_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86844] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4241), 1,
      anon_sym_RPAREN,
    STATE(2043), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86864] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4243), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4245), 1,
      aux_sym_select_case_statement_token2,
    ACTIONS(4247), 1,
      aux_sym_select_rank_statement_token1,
    STATE(2044), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86884] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4249), 1,
      anon_sym_RPAREN,
    STATE(2045), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86904] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4251), 1,
      anon_sym_COMMA,
    ACTIONS(4254), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2046), 2,
      sym_preproc_file_line,
      aux_sym_implicit_statement_repeat2,
  [86922] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4258), 1,
      sym__end_of_statement,
    STATE(2046), 1,
      aux_sym_implicit_statement_repeat2,
    STATE(2047), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86942] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4258), 1,
      sym__end_of_statement,
    STATE(2048), 1,
      sym_preproc_file_line,
    STATE(2152), 1,
      aux_sym_implicit_statement_repeat2,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86962] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4260), 1,
      aux_sym_included_items_token1,
    ACTIONS(4262), 1,
      aux_sym_implicit_statement_token2,
    ACTIONS(4264), 1,
      aux_sym__import_names_token1,
    STATE(2049), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [86982] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1427), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1429), 1,
      aux_sym_end_submodule_statement_token1,
    STATE(262), 1,
      sym_end_submodule_statement,
    STATE(2050), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87002] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4008), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4010), 1,
      aux_sym_end_program_statement_token2,
    STATE(275), 1,
      sym_end_program_statement,
    STATE(2051), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87022] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4266), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4268), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1193), 1,
      sym_end_subroutine_statement,
    STATE(2052), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87042] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(641), 1,
      sym_end_type_statement,
    STATE(2053), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87062] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3073), 1,
      anon_sym_RPAREN,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2054), 2,
      sym_preproc_file_line,
      aux_sym_equivalence_set_repeat1,
  [87080] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4273), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4275), 1,
      aux_sym_end_function_statement_token1,
    STATE(1199), 1,
      sym_end_function_statement,
    STATE(2055), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87100] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2534), 1,
      anon_sym_RPAREN,
    STATE(2056), 1,
      sym_preproc_file_line,
    STATE(2067), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87120] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4277), 1,
      anon_sym_RPAREN,
    STATE(2057), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87140] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2058), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4279), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [87156] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4281), 1,
      anon_sym_RPAREN,
    ACTIONS(4283), 1,
      anon_sym_COMMA,
    STATE(2059), 1,
      sym_preproc_file_line,
    STATE(2068), 1,
      aux_sym__forall_control_expression_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87176] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4285), 1,
      aux_sym_type_qualifier_token6,
    ACTIONS(4287), 1,
      aux_sym_type_qualifier_token7,
    ACTIONS(4289), 1,
      aux_sym_type_qualifier_token8,
    STATE(2060), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87196] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4266), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4268), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1176), 1,
      sym_end_subroutine_statement,
    STATE(2061), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87216] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4273), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4275), 1,
      aux_sym_end_function_statement_token1,
    STATE(1179), 1,
      sym_end_function_statement,
    STATE(2062), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87236] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(578), 1,
      sym_end_type_statement,
    STATE(2063), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87256] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(4291), 1,
      anon_sym_SLASH,
    STATE(2064), 1,
      sym_preproc_file_line,
    STATE(2211), 1,
      aux_sym_data_value_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87276] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2065), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3920), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [87292] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    ACTIONS(4295), 1,
      anon_sym_COMMA,
    STATE(2066), 1,
      sym_preproc_file_line,
    STATE(2231), 1,
      aux_sym_concurrent_header_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87312] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
    STATE(2067), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87332] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    ACTIONS(4301), 1,
      anon_sym_COMMA,
    STATE(1968), 1,
      aux_sym__forall_control_expression_repeat1,
    STATE(2068), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87352] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4303), 1,
      anon_sym_COMMA,
    ACTIONS(4305), 1,
      sym__end_of_statement,
    STATE(2069), 1,
      sym_preproc_file_line,
    STATE(2214), 1,
      aux_sym_equivalence_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87372] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4307), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4309), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(252), 1,
      sym_end_subroutine_statement,
    STATE(2070), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87392] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(592), 1,
      sym_end_type_statement,
    STATE(2071), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87412] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4311), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4313), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1627), 1,
      sym_end_module_procedure_statement,
    STATE(2072), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87432] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(594), 1,
      sym_end_type_statement,
    STATE(2073), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87452] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2074), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4315), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [87468] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    STATE(2075), 1,
      sym_preproc_file_line,
    STATE(2641), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87488] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4266), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4268), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1208), 1,
      sym_end_subroutine_statement,
    STATE(2076), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87508] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(597), 1,
      sym_end_type_statement,
    STATE(2077), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87528] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2580), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2592), 1,
      aux_sym_end_type_statement_token1,
    STATE(599), 1,
      sym_end_type_statement,
    STATE(2078), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87548] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4307), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4309), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(294), 1,
      sym_end_subroutine_statement,
    STATE(2079), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87568] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4273), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4275), 1,
      aux_sym_end_function_statement_token1,
    STATE(1213), 1,
      sym_end_function_statement,
    STATE(2080), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87588] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    ACTIONS(4317), 1,
      anon_sym_COLON_COLON,
    STATE(1953), 1,
      aux_sym_derived_type_statement_repeat1,
    STATE(2081), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87608] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4319), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4321), 1,
      aux_sym_end_function_statement_token1,
    STATE(271), 1,
      sym_end_function_statement,
    STATE(2082), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87628] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4323), 1,
      sym__end_of_statement,
    STATE(2083), 1,
      sym_preproc_file_line,
    STATE(2097), 1,
      aux_sym_use_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87648] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    ACTIONS(3969), 1,
      sym__end_of_statement,
    STATE(2042), 1,
      aux_sym_included_items_repeat1,
    STATE(2084), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87668] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      sym__end_of_statement,
    STATE(1954), 1,
      aux_sym_save_statement_repeat1,
    STATE(2085), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87688] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(625), 1,
      sym_end_type_statement,
    STATE(2086), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87708] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4319), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4321), 1,
      aux_sym_end_function_statement_token1,
    STATE(259), 1,
      sym_end_function_statement,
    STATE(2087), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87728] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2477), 1,
      anon_sym_RPAREN,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    STATE(2088), 1,
      sym_preproc_file_line,
    STATE(2099), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87748] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      aux_sym_language_binding_token1,
    ACTIONS(4327), 1,
      sym__end_of_statement,
    STATE(2089), 1,
      sym_preproc_file_line,
    STATE(2899), 1,
      sym_language_binding,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87768] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2090), 1,
      sym_preproc_file_line,
    STATE(2720), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87788] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4329), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4331), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1644), 1,
      sym_end_subroutine_statement,
    STATE(2091), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87808] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2501), 1,
      anon_sym_COMMA,
    ACTIONS(4333), 1,
      anon_sym_RPAREN,
    STATE(2092), 1,
      sym_preproc_file_line,
    STATE(2194), 1,
      aux_sym_case_value_range_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87828] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4325), 1,
      sym__end_of_statement,
    STATE(1956), 1,
      aux_sym_save_statement_repeat1,
    STATE(2093), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87848] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4335), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4337), 1,
      aux_sym_end_function_statement_token1,
    STATE(1646), 1,
      sym_end_function_statement,
    STATE(2094), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87868] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3392), 1,
      sym__end_of_statement,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1958), 1,
      aux_sym_private_statement_repeat1,
    STATE(2095), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87888] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(636), 1,
      sym_end_type_statement,
    STATE(2096), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87908] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4339), 1,
      anon_sym_COMMA,
    ACTIONS(4342), 1,
      sym__end_of_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2097), 2,
      sym_preproc_file_line,
      aux_sym_use_statement_repeat1,
  [87926] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4311), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4313), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1630), 1,
      sym_end_module_procedure_statement,
    STATE(2098), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87946] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RPAREN,
    STATE(2099), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87966] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3336), 1,
      sym__end_of_statement,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      aux_sym_private_statement_repeat1,
    STATE(2100), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [87986] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(564), 1,
      sym_end_type_statement,
    STATE(2101), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88006] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4346), 1,
      anon_sym_RPAREN,
    ACTIONS(4348), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2102), 2,
      sym_preproc_file_line,
      aux_sym_implicit_statement_repeat3,
  [88024] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(384), 1,
      sym_end_type_statement,
    STATE(2103), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88044] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4351), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4353), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1659), 1,
      sym_end_module_procedure_statement,
    STATE(2104), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88064] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(565), 1,
      sym_end_type_statement,
    STATE(2105), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88084] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4311), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4313), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1634), 1,
      sym_end_module_procedure_statement,
    STATE(2106), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88104] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4355), 1,
      sym__end_of_statement,
    STATE(2046), 1,
      aux_sym_implicit_statement_repeat2,
    STATE(2107), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88124] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(567), 1,
      sym_end_type_statement,
    STATE(2108), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88144] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4355), 1,
      sym__end_of_statement,
    STATE(2047), 1,
      aux_sym_implicit_statement_repeat2,
    STATE(2109), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88164] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4357), 1,
      anon_sym_RPAREN,
    ACTIONS(4359), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2110), 2,
      sym_preproc_file_line,
      aux_sym_implicit_statement_repeat1,
  [88182] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4362), 1,
      anon_sym_RPAREN,
    STATE(2110), 1,
      aux_sym_implicit_statement_repeat1,
    STATE(2111), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88202] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(406), 1,
      sym_end_type_statement,
    STATE(2112), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88222] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2518), 1,
      anon_sym_RPAREN,
    STATE(2113), 1,
      sym_preproc_file_line,
    STATE(2124), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88242] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2758), 1,
      sym__end_of_statement,
    ACTIONS(4364), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2114), 2,
      sym_preproc_file_line,
      aux_sym__declaration_targets_repeat1,
  [88260] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4367), 1,
      sym__end_of_statement,
    STATE(1956), 1,
      aux_sym_save_statement_repeat1,
    STATE(2115), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88280] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4032), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4034), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1669), 1,
      sym_end_subroutine_statement,
    STATE(2116), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88300] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4369), 1,
      anon_sym_LPAREN,
    STATE(2117), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4371), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [88318] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(4373), 1,
      sym__end_of_statement,
    STATE(2114), 1,
      aux_sym__declaration_targets_repeat1,
    STATE(2118), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88338] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4046), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4048), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1639), 1,
      sym_end_module_procedure_statement,
    STATE(2119), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88358] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4038), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4040), 1,
      aux_sym_end_function_statement_token1,
    STATE(1671), 1,
      sym_end_function_statement,
    STATE(2120), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88378] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    ACTIONS(4375), 1,
      anon_sym_COLON_COLON,
    STATE(2007), 1,
      aux_sym_derived_type_statement_repeat1,
    STATE(2121), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88398] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(376), 1,
      sym_end_type_statement,
    STATE(2122), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88418] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(413), 1,
      sym_end_type_statement,
    STATE(2123), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88438] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(2124), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88458] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2873), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1899), 1,
      aux_sym_parameters_repeat1,
    STATE(2125), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88478] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(398), 1,
      sym_end_type_statement,
    STATE(2126), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88498] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4054), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4056), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1684), 1,
      sym_end_module_procedure_statement,
    STATE(2127), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88518] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2128), 1,
      sym_preproc_file_line,
    STATE(2857), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88538] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(399), 1,
      sym_end_type_statement,
    STATE(2129), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88558] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2130), 1,
      sym_preproc_file_line,
    STATE(2864), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88578] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2131), 1,
      sym_preproc_file_line,
    STATE(2868), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88598] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(401), 1,
      sym_end_type_statement,
    STATE(2132), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88618] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2437), 1,
      sym__integer_literal,
    STATE(1473), 1,
      sym_statement_label,
    STATE(1931), 1,
      sym_statement_label_reference,
    STATE(2133), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88638] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2680), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2684), 1,
      aux_sym_end_type_statement_token1,
    STATE(402), 1,
      sym_end_type_statement,
    STATE(2134), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88658] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2853), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_parameters_repeat1,
    STATE(2135), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88678] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(2136), 1,
      sym_preproc_file_line,
    STATE(2164), 1,
      aux_sym__io_arguments_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88698] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2137), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3893), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [88714] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(302), 1,
      sym_end_type_statement,
    STATE(2138), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88734] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
    STATE(2139), 1,
      sym_preproc_file_line,
    STATE(2151), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88754] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3708), 1,
      aux_sym_select_rank_statement_token1,
    STATE(1811), 1,
      aux_sym_select_rank_statement_repeat1,
    STATE(1901), 1,
      sym_rank_statement,
    STATE(2140), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88774] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(374), 1,
      sym_end_type_statement,
    STATE(2141), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88794] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4094), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4096), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1694), 1,
      sym_end_subroutine_statement,
    STATE(2142), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88814] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4381), 1,
      sym__end_of_statement,
    STATE(2097), 1,
      aux_sym_use_statement_repeat1,
    STATE(2143), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88834] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RPAREN,
    STATE(2038), 1,
      aux_sym_associate_statement_repeat1,
    STATE(2144), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88854] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2662), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2666), 1,
      aux_sym_end_type_statement_token1,
    STATE(387), 1,
      sym_end_type_statement,
    STATE(2145), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88874] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4098), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4100), 1,
      aux_sym_end_function_statement_token1,
    STATE(1696), 1,
      sym_end_function_statement,
    STATE(2146), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88894] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3967), 1,
      anon_sym_EQ_GT,
    STATE(2147), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4383), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [88912] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4383), 1,
      sym__end_of_statement,
    ACTIONS(4385), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2148), 2,
      sym_preproc_file_line,
      aux_sym_included_items_repeat1,
  [88930] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(307), 1,
      sym_end_type_statement,
    STATE(2149), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88950] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2853), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(1899), 1,
      aux_sym_parameters_repeat1,
    STATE(2150), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88970] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4388), 1,
      anon_sym_RPAREN,
    STATE(2151), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [88990] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4390), 1,
      sym__end_of_statement,
    STATE(2046), 1,
      aux_sym_implicit_statement_repeat2,
    STATE(2152), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89010] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(310), 1,
      sym_end_type_statement,
    STATE(2153), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89030] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4028), 1,
      anon_sym_COMMA,
    ACTIONS(4392), 1,
      sym__end_of_statement,
    STATE(1934), 1,
      aux_sym_data_statement_repeat1,
    STATE(2154), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89050] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(4394), 1,
      sym__end_of_statement,
    STATE(2114), 1,
      aux_sym__declaration_targets_repeat1,
    STATE(2155), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89070] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4115), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4117), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1709), 1,
      sym_end_module_procedure_statement,
    STATE(2156), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89090] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2982), 1,
      anon_sym_COMMA,
    ACTIONS(4396), 1,
      anon_sym_RPAREN,
    STATE(2054), 1,
      aux_sym_equivalence_set_repeat1,
    STATE(2157), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89110] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(4394), 1,
      sym__end_of_statement,
    STATE(2118), 1,
      aux_sym__declaration_targets_repeat1,
    STATE(2158), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89130] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(311), 1,
      sym_end_type_statement,
    STATE(2159), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89150] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(312), 1,
      sym_end_type_statement,
    STATE(2160), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89170] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4398), 1,
      anon_sym_RPAREN,
    STATE(1927), 1,
      aux_sym__io_arguments_repeat1,
    STATE(2161), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89190] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2600), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2604), 1,
      aux_sym_end_type_statement_token1,
    STATE(313), 1,
      sym_end_type_statement,
    STATE(2162), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89210] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    ACTIONS(4400), 1,
      anon_sym_RPAREN,
    STATE(2057), 1,
      aux_sym__io_arguments_repeat1,
    STATE(2163), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89230] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4402), 1,
      anon_sym_RPAREN,
    ACTIONS(4404), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2164), 2,
      sym_preproc_file_line,
      aux_sym__io_arguments_repeat1,
  [89248] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(323), 1,
      sym_end_type_statement,
    STATE(2165), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89268] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
    STATE(2166), 1,
      sym_preproc_file_line,
    STATE(2173), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89288] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2167), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4407), 3,
      sym__end_of_statement,
      aux_sym_language_binding_token1,
      aux_sym_function_result_token1,
  [89304] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4137), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4139), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1569), 1,
      sym_end_subroutine_statement,
    STATE(2168), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89324] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    ACTIONS(4409), 1,
      anon_sym_RPAREN,
    STATE(1013), 1,
      aux_sym_parameters_repeat1,
    STATE(2169), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89344] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4141), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4143), 1,
      aux_sym_end_function_statement_token1,
    STATE(1571), 1,
      sym_end_function_statement,
    STATE(2170), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89364] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3640), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3642), 1,
      aux_sym_end_if_statement_token1,
    STATE(2171), 1,
      sym_preproc_file_line,
    STATE(2410), 1,
      sym_end_if_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89384] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(330), 1,
      sym_end_type_statement,
    STATE(2172), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89404] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(4411), 1,
      anon_sym_RPAREN,
    STATE(2173), 1,
      sym_preproc_file_line,
    STATE(2212), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89424] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2174), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4413), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [89440] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(2620), 1,
      sym__end_of_statement,
    STATE(2155), 1,
      aux_sym__declaration_targets_repeat1,
    STATE(2175), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89460] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(334), 1,
      sym_end_type_statement,
    STATE(2176), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89480] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2479), 1,
      anon_sym_COMMA,
    ACTIONS(2536), 1,
      anon_sym_RPAREN,
    STATE(1967), 1,
      aux_sym_argument_list_repeat1,
    STATE(2177), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89500] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4415), 1,
      anon_sym_COMMA,
    ACTIONS(4417), 1,
      sym__end_of_statement,
    STATE(2178), 1,
      sym_preproc_file_line,
    STATE(2551), 1,
      sym_included_items,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89520] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4168), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4170), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1584), 1,
      sym_end_module_procedure_statement,
    STATE(2179), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89540] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4419), 1,
      anon_sym_RPAREN,
    ACTIONS(4421), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2180), 2,
      sym_preproc_file_line,
      aux_sym_procedure_attributes_repeat1,
  [89558] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(335), 1,
      sym_end_type_statement,
    STATE(2181), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89578] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4424), 1,
      anon_sym_COMMA,
    ACTIONS(4426), 1,
      sym__end_of_statement,
    STATE(2182), 1,
      sym_preproc_file_line,
    STATE(2380), 1,
      sym_included_items,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89598] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(336), 1,
      sym_end_type_statement,
    STATE(2183), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89618] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2610), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2614), 1,
      aux_sym_end_type_statement_token1,
    STATE(337), 1,
      sym_end_type_statement,
    STATE(2184), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89638] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4428), 1,
      sym__end_of_statement,
    STATE(2083), 1,
      aux_sym_use_statement_repeat1,
    STATE(2185), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89658] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4430), 1,
      sym__end_of_statement,
    STATE(2097), 1,
      aux_sym_use_statement_repeat1,
    STATE(2186), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89678] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(345), 1,
      sym_end_type_statement,
    STATE(2187), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89698] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4064), 1,
      anon_sym_COMMA,
    ACTIONS(4432), 1,
      anon_sym_RPAREN,
    STATE(2102), 1,
      aux_sym_implicit_statement_repeat3,
    STATE(2188), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89718] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4194), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4196), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1594), 1,
      sym_end_subroutine_statement,
    STATE(2189), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89738] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4434), 1,
      sym__end_of_statement,
    STATE(2107), 1,
      aux_sym_implicit_statement_repeat2,
    STATE(2190), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89758] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4198), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4200), 1,
      aux_sym_end_function_statement_token1,
    STATE(1596), 1,
      sym_end_function_statement,
    STATE(2191), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89778] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_RPAREN,
    STATE(2110), 1,
      aux_sym_implicit_statement_repeat1,
    STATE(2192), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89798] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_RPAREN,
    STATE(2111), 1,
      aux_sym_implicit_statement_repeat1,
    STATE(2193), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89818] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2674), 1,
      anon_sym_RPAREN,
    ACTIONS(4438), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2194), 2,
      sym_preproc_file_line,
      aux_sym_case_value_range_list_repeat1,
  [89836] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(352), 1,
      sym_end_type_statement,
    STATE(2195), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89856] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4307), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4309), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(246), 1,
      sym_end_subroutine_statement,
    STATE(2196), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89876] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(356), 1,
      sym_end_type_statement,
    STATE(2197), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89896] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4329), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4331), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1649), 1,
      sym_end_subroutine_statement,
    STATE(2198), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89916] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    ACTIONS(4441), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_parameter_statement_repeat1,
    STATE(2199), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89936] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(357), 1,
      sym_end_type_statement,
    STATE(2200), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89956] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(358), 1,
      sym_end_type_statement,
    STATE(2201), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89976] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4335), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4337), 1,
      aux_sym_end_function_statement_token1,
    STATE(1652), 1,
      sym_end_function_statement,
    STATE(2202), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [89996] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2688), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2692), 1,
      aux_sym_end_type_statement_token1,
    STATE(359), 1,
      sym_end_type_statement,
    STATE(2203), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90016] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    ACTIONS(4446), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2204), 2,
      sym_preproc_file_line,
      aux_sym_derived_type_statement_repeat1,
  [90034] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4448), 1,
      sym__end_of_statement,
    STATE(2115), 1,
      aux_sym_save_statement_repeat1,
    STATE(2205), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90054] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4076), 1,
      anon_sym_COMMA,
    ACTIONS(4448), 1,
      sym__end_of_statement,
    STATE(1956), 1,
      aux_sym_save_statement_repeat1,
    STATE(2206), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90074] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4220), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4222), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1613), 1,
      sym_end_subroutine_statement,
    STATE(2207), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90094] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3230), 1,
      sym__end_of_statement,
    ACTIONS(4450), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2208), 2,
      sym_preproc_file_line,
      aux_sym_private_statement_repeat1,
  [90112] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2944), 1,
      sym__end_of_statement,
    ACTIONS(3959), 1,
      anon_sym_COMMA,
    STATE(2125), 1,
      aux_sym_parameters_repeat1,
    STATE(2209), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90132] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4224), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4226), 1,
      aux_sym_end_function_statement_token1,
    STATE(1615), 1,
      sym_end_function_statement,
    STATE(2210), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90152] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4453), 1,
      anon_sym_COMMA,
    ACTIONS(4456), 1,
      anon_sym_SLASH,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2211), 2,
      sym_preproc_file_line,
      aux_sym_data_value_repeat1,
  [90170] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2646), 1,
      anon_sym_RPAREN,
    ACTIONS(4458), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2212), 2,
      sym_preproc_file_line,
      aux_sym_argument_list_repeat1,
  [90188] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2650), 1,
      anon_sym_COLON,
    STATE(2213), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2652), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [90206] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4303), 1,
      anon_sym_COMMA,
    ACTIONS(4461), 1,
      sym__end_of_statement,
    STATE(1984), 1,
      aux_sym_equivalence_statement_repeat1,
    STATE(2214), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90226] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4463), 1,
      aux_sym_type_qualifier_token6,
    ACTIONS(4465), 1,
      aux_sym_type_qualifier_token7,
    ACTIONS(4467), 1,
      aux_sym_type_qualifier_token8,
    STATE(2215), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90246] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4469), 1,
      anon_sym_RPAREN,
    ACTIONS(4471), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2216), 2,
      sym_preproc_file_line,
      aux_sym_parameter_statement_repeat1,
  [90264] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2217), 1,
      sym_preproc_file_line,
    STATE(2731), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90284] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4329), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4331), 1,
      aux_sym_end_subroutine_statement_token1,
    STATE(1655), 1,
      sym_end_subroutine_statement,
    STATE(2218), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90304] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    ACTIONS(4474), 1,
      anon_sym_GT_GT_GT,
    STATE(1869), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    STATE(2219), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90324] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    STATE(2220), 1,
      sym_preproc_file_line,
    STATE(2222), 1,
      aux_sym_keyword_statement_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90344] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4335), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4337), 1,
      aux_sym_end_function_statement_token1,
    STATE(1657), 1,
      sym_end_function_statement,
    STATE(2221), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90364] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4478), 1,
      anon_sym_RPAREN,
    ACTIONS(4480), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2222), 2,
      sym_preproc_file_line,
      aux_sym_keyword_statement_repeat1,
  [90382] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4483), 1,
      anon_sym_RPAREN,
    ACTIONS(4485), 1,
      anon_sym_COMMA,
    STATE(2066), 1,
      aux_sym_concurrent_header_repeat1,
    STATE(2223), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90402] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(4487), 1,
      anon_sym_SLASH,
    STATE(2211), 1,
      aux_sym_data_value_repeat1,
    STATE(2224), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90422] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2998), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_SLASH,
    STATE(2211), 1,
      aux_sym_data_value_repeat1,
    STATE(2225), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90442] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3547), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(3553), 1,
      aux_sym_end_select_statement_token1,
    STATE(2226), 1,
      sym_preproc_file_line,
    STATE(2778), 1,
      sym_end_select_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90462] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2227), 1,
      sym_preproc_file_line,
    STATE(2409), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90482] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2228), 1,
      sym_preproc_file_line,
    STATE(2487), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90502] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4351), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4353), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1662), 1,
      sym_end_module_procedure_statement,
    STATE(2229), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90522] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4491), 1,
      anon_sym_RPAREN,
    ACTIONS(4493), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_preproc_file_line,
    STATE(2231), 1,
      aux_sym_concurrent_header_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90542] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4495), 1,
      anon_sym_RPAREN,
    ACTIONS(4497), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    STATE(2231), 2,
      sym_preproc_file_line,
      aux_sym_concurrent_header_repeat1,
  [90560] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2232), 1,
      sym_preproc_file_line,
    STATE(2559), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90580] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4500), 1,
      aux_sym_end_program_statement_token1,
    STATE(2233), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4502), 2,
      aux_sym_enumerator_statement_token1,
      aux_sym_end_enum_statement_token1,
  [90598] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2234), 1,
      sym_preproc_file_line,
    STATE(2628), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90618] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    ACTIONS(4504), 1,
      anon_sym_RPAREN,
    STATE(2235), 1,
      sym_preproc_file_line,
    STATE(2241), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90638] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4351), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4353), 1,
      aux_sym_end_module_procedure_statement_token1,
    STATE(1664), 1,
      sym_end_module_procedure_statement,
    STATE(2236), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90658] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4202), 1,
      aux_sym_implicit_statement_token3,
    ACTIONS(4204), 1,
      aux_sym_format_statement_token1,
    STATE(2237), 1,
      sym_preproc_file_line,
    STATE(2694), 1,
      sym_format_statement,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90678] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2550), 1,
      anon_sym_LPAREN,
    ACTIONS(2984), 1,
      sym__end_of_statement,
    STATE(2238), 1,
      sym_preproc_file_line,
    STATE(2648), 1,
      sym_argument_list,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90698] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4052), 1,
      anon_sym_COMMA,
    ACTIONS(4506), 1,
      anon_sym_RPAREN,
    STATE(1944), 1,
      aux_sym_implicit_statement_repeat1,
    STATE(2239), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90718] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4319), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(4321), 1,
      aux_sym_end_function_statement_token1,
    STATE(257), 1,
      sym_end_function_statement,
    STATE(2240), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90738] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
    STATE(1013), 1,
      aux_sym_parameters_repeat1,
    STATE(2241), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90758] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2437), 1,
      sym__integer_literal,
    STATE(1473), 1,
      sym_statement_label,
    STATE(1986), 1,
      sym_statement_label_reference,
    STATE(2242), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90778] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2696), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(2700), 1,
      aux_sym_end_type_statement_token1,
    STATE(566), 1,
      sym_end_type_statement,
    STATE(2243), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90798] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2244), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [90813] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2245), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4128), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [90828] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2883), 1,
      anon_sym_LPAREN,
    STATE(532), 1,
      sym__io_arguments,
    STATE(2246), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90845] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3628), 1,
      aux_sym_language_binding_token1,
    STATE(2004), 1,
      sym_language_binding,
    STATE(2247), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90862] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4036), 1,
      anon_sym_LPAREN,
    STATE(2248), 1,
      sym_preproc_file_line,
    STATE(2355), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90879] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4510), 1,
      anon_sym_LPAREN,
    ACTIONS(4512), 1,
      aux_sym_concurrent_locality_token3,
    STATE(2249), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90896] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2250), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4514), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [90911] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4516), 1,
      anon_sym_RPAREN,
    ACTIONS(4518), 1,
      anon_sym_COMMA,
    STATE(2251), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [90928] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2252), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4520), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [90943] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2253), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4522), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [90958] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2254), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4524), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [90973] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2255), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4419), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [90988] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2256), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4083), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91003] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4526), 1,
      anon_sym_RPAREN,
    ACTIONS(4528), 1,
      aux_sym_type_qualifier_token7,
    STATE(2257), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91020] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2258), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4530), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [91035] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2259), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2960), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91050] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2260), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3396), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91065] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2261), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4532), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91080] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2262), 1,
      sym_preproc_file_line,
    STATE(2528), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91097] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2263), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4536), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91112] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2264), 1,
      sym_preproc_file_line,
    STATE(2743), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91129] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4538), 1,
      anon_sym_LPAREN,
    STATE(223), 1,
      sym_parenthesized_expression,
    STATE(2265), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91146] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2266), 1,
      sym_preproc_file_line,
    STATE(2562), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91163] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2267), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4104), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91178] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2268), 1,
      sym_preproc_file_line,
    STATE(2563), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91195] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2269), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4540), 2,
      aux_sym_defined_io_procedure_token3,
      aux_sym_defined_io_procedure_token4,
  [91210] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2270), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2674), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91225] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2271), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4542), 2,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
  [91240] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4036), 1,
      anon_sym_LPAREN,
    STATE(2272), 1,
      sym_preproc_file_line,
    STATE(2691), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91257] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2273), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4544), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [91272] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
    ACTIONS(4546), 1,
      anon_sym_COMMA,
    STATE(2274), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91289] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4548), 1,
      aux_sym_implicit_range_token1,
    STATE(2275), 1,
      sym_preproc_file_line,
    STATE(2338), 1,
      sym_implicit_range,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91306] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2276), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4135), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91321] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2750), 1,
      aux_sym_intrinsic_type_token5,
    ACTIONS(2752), 1,
      aux_sym_intrinsic_type_token7,
    STATE(2277), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91338] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2278), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4550), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91353] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2279), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2952), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91368] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2280), 1,
      sym_preproc_file_line,
    STATE(2546), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91385] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2281), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4552), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91400] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2282), 1,
      sym_preproc_file_line,
    STATE(2547), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91417] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2283), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4554), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91432] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2284), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4556), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91447] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2285), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4558), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [91462] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4560), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      aux_sym_concurrent_locality_token3,
    STATE(2286), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91479] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2287), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4554), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91494] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    STATE(1869), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    STATE(2288), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91511] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4566), 1,
      anon_sym_COLON,
    ACTIONS(4568), 1,
      anon_sym_RPAREN,
    STATE(2289), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91528] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2290), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4570), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91543] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4548), 1,
      aux_sym_implicit_range_token1,
    STATE(2193), 1,
      sym_implicit_range,
    STATE(2291), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91560] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2292), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4342), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91575] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym_preproc_file_line,
    STATE(2558), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91592] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2294), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4572), 2,
      sym__end_of_statement,
      anon_sym_SLASH,
  [91607] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4574), 1,
      aux_sym_concurrent_locality_token3,
    ACTIONS(4576), 1,
      aux_sym_type_statement_token1,
    STATE(2295), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91624] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2296), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4578), 2,
      aux_sym_implicit_statement_token3,
      aux_sym_implicit_statement_token4,
  [91639] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2297), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(3230), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91654] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2298), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4383), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91669] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2299), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4580), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [91684] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4582), 1,
      anon_sym_RPAREN,
    ACTIONS(4584), 1,
      anon_sym_COMMA,
    STATE(2300), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91701] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4586), 1,
      sym_string_literal,
    ACTIONS(4588), 1,
      sym__end_of_statement,
    STATE(2301), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91718] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4036), 1,
      anon_sym_LPAREN,
    STATE(2302), 1,
      sym_preproc_file_line,
    STATE(2698), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91735] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    STATE(2245), 1,
      sym_equivalence_set,
    STATE(2303), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91752] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2304), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2646), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91767] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2305), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4592), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91782] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2306), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4594), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91797] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2307), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4596), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91812] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2308), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4469), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91827] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2309), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4598), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91842] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4398), 1,
      anon_sym_RPAREN,
    ACTIONS(4600), 1,
      anon_sym_COMMA,
    STATE(2310), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91859] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2311), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4346), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91874] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2312), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4602), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91889] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2313), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4556), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91904] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2314), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4604), 2,
      aux_sym_defined_io_procedure_token3,
      aux_sym_defined_io_procedure_token4,
  [91919] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2315), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4606), 2,
      sym__end_of_statement,
      anon_sym_LPAREN,
  [91934] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2316), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4608), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91949] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2530), 1,
      aux_sym_intrinsic_type_token5,
    ACTIONS(2532), 1,
      aux_sym_intrinsic_type_token7,
    STATE(2317), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91966] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2318), 1,
      sym_preproc_file_line,
    STATE(2687), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [91983] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2319), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2964), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [91998] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2320), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4478), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92013] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2321), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2968), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [92028] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2322), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4610), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92043] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2323), 1,
      sym_preproc_file_line,
    STATE(2688), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92060] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2324), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4612), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [92075] = 5,
    ACTIONS(4150), 1,
      anon_sym_POUND,
    ACTIONS(4614), 1,
      anon_sym_LF,
    STATE(2325), 1,
      sym_preproc_file_line,
    STATE(2919), 1,
      sym__newline,
    ACTIONS(4152), 2,
      sym_comment,
      anon_sym_AMP,
  [92092] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2326), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4495), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92107] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    STATE(2327), 1,
      sym_preproc_file_line,
    STATE(2703), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92124] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    STATE(2069), 1,
      sym_equivalence_set,
    STATE(2328), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92141] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    STATE(2329), 1,
      sym_preproc_file_line,
    STATE(2461), 1,
      sym_parenthesized_expression,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92158] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2330), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2972), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [92173] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2331), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4616), 2,
      aux_sym_defined_io_procedure_token3,
      aux_sym_defined_io_procedure_token4,
  [92188] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4618), 1,
      anon_sym_COMMA,
    ACTIONS(4620), 1,
      sym__end_of_statement,
    STATE(2332), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92205] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1538), 1,
      aux_sym_end_program_statement_token1,
    ACTIONS(1544), 1,
      aux_sym_end_if_statement_token1,
    STATE(2333), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92222] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2334), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4622), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [92237] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4400), 1,
      anon_sym_RPAREN,
    ACTIONS(4624), 1,
      anon_sym_COMMA,
    STATE(2335), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92254] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2336), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2986), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92269] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2337), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4402), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92284] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2338), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4357), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92299] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2339), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4626), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92314] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2340), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4628), 2,
      sym__end_of_statement,
      anon_sym_LPAREN,
  [92329] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2341), 1,
      sym_preproc_file_line,
    STATE(2746), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92346] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2342), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4630), 2,
      aux_sym_use_statement_token2,
      aux_sym_use_statement_token3,
  [92361] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4632), 1,
      anon_sym_LPAREN,
    ACTIONS(4634), 1,
      sym__end_of_statement,
    STATE(2343), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92378] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2344), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4636), 2,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
  [92393] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2345), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4638), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [92408] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4548), 1,
      aux_sym_implicit_range_token1,
    STATE(1945), 1,
      sym_implicit_range,
    STATE(2346), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92425] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4640), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      sym__end_of_statement,
    STATE(2347), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92442] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2348), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2760), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92457] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2349), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(2758), 2,
      sym__end_of_statement,
      anon_sym_COMMA,
  [92472] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(2350), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
    ACTIONS(4089), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [92487] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2351), 1,
      sym_preproc_file_line,
    STATE(2689), 1,
      sym_selector,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92504] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4644), 1,
      anon_sym_COMMA,
    STATE(1869), 1,
      aux_sym_cuda_kernel_argument_list_repeat1,
    STATE(2352), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92521] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4646), 1,
      anon_sym_RPAREN,
    ACTIONS(4648), 1,
      aux_sym_type_qualifier_token7,
    STATE(2353), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92538] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4650), 1,
      aux_sym_interface_statement_token1,
    STATE(2354), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92552] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4652), 1,
      aux_sym__block_if_statement_token1,
    STATE(2355), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92566] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4654), 1,
      anon_sym_COMMA,
    STATE(2356), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92580] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4656), 1,
      sym__end_of_statement,
    STATE(2357), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92594] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4658), 1,
      sym__end_of_statement,
    STATE(2358), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92608] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4660), 1,
      sym__end_of_statement,
    STATE(2359), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92622] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4662), 1,
      anon_sym_RPAREN,
    STATE(2360), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92636] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4664), 1,
      anon_sym_RPAREN,
    STATE(2361), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92650] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4666), 1,
      anon_sym_EQ_GT,
    STATE(2362), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92664] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4668), 1,
      anon_sym_EQ_GT,
    STATE(2363), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92678] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4670), 1,
      anon_sym_STAR,
    STATE(2364), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92692] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4672), 1,
      sym__end_of_statement,
    STATE(2365), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92706] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4674), 1,
      sym__end_of_statement,
    STATE(2366), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92720] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4676), 1,
      anon_sym_DOT,
    STATE(2367), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92734] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4678), 1,
      aux_sym__inline_if_statement_token1,
    STATE(2368), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92748] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4680), 1,
      anon_sym_RPAREN,
    STATE(2369), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92762] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4682), 1,
      anon_sym_EQ_GT,
    STATE(2370), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92776] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4684), 1,
      anon_sym_EQ_GT,
    STATE(2371), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92790] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4686), 1,
      sym__end_of_statement,
    STATE(2372), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92804] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4688), 1,
      sym_string_literal,
    STATE(2373), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92818] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4690), 1,
      anon_sym_EQ_GT,
    STATE(2374), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92832] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4692), 1,
      anon_sym_EQ_GT,
    STATE(2375), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92846] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4694), 1,
      anon_sym_EQ_GT,
    STATE(2376), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92860] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4696), 1,
      sym__end_of_statement,
    STATE(2377), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92874] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4698), 1,
      sym__end_of_statement,
    STATE(2378), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92888] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4700), 1,
      sym__end_of_statement,
    STATE(2379), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92902] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4702), 1,
      sym__end_of_statement,
    STATE(2380), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92916] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4704), 1,
      sym__end_of_statement,
    STATE(2381), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92930] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4706), 1,
      sym__end_of_statement,
    STATE(2382), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92944] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4708), 1,
      sym__end_of_statement,
    STATE(2383), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92958] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4710), 1,
      sym__end_of_statement,
    STATE(2384), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92972] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4712), 1,
      anon_sym_LPAREN,
    STATE(2385), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [92986] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4714), 1,
      sym__end_of_statement,
    STATE(2386), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93000] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4716), 1,
      sym__end_of_statement,
    STATE(2387), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93014] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4718), 1,
      sym__end_of_statement,
    STATE(2388), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93028] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4720), 1,
      sym__end_of_statement,
    STATE(2389), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93042] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4722), 1,
      anon_sym_COLON_COLON,
    STATE(2390), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93056] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4724), 1,
      sym__end_of_statement,
    STATE(2391), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93070] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4726), 1,
      sym__end_of_statement,
    STATE(2392), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93084] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4728), 1,
      sym__end_of_statement,
    STATE(2393), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93098] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4730), 1,
      anon_sym_SLASH,
    STATE(2394), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93112] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4732), 1,
      anon_sym_COMMA,
    STATE(2395), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93126] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1762), 1,
      sym__end_of_statement,
    STATE(2396), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93140] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4734), 1,
      anon_sym_EQ,
    STATE(2397), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93154] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4736), 1,
      sym__end_of_statement,
    STATE(2398), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93168] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4738), 1,
      sym__end_of_statement,
    STATE(2399), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93182] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4740), 1,
      sym__end_of_statement,
    STATE(2400), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93196] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4742), 1,
      sym__end_of_statement,
    STATE(2401), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93210] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4744), 1,
      anon_sym_RPAREN,
    STATE(2402), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93224] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4746), 1,
      anon_sym_RPAREN,
    STATE(2403), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93238] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4748), 1,
      anon_sym_RPAREN,
    STATE(2404), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93252] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4750), 1,
      anon_sym_RPAREN,
    STATE(2405), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93266] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4752), 1,
      sym__end_of_statement,
    STATE(2406), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93280] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4754), 1,
      sym__end_of_statement,
    STATE(2407), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93294] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4756), 1,
      sym__end_of_statement,
    STATE(2408), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93308] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym__end_of_statement,
    STATE(2409), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93322] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4760), 1,
      sym__end_of_statement,
    STATE(2410), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93336] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4762), 1,
      sym__end_of_statement,
    STATE(2411), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93350] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4764), 1,
      sym__end_of_statement,
    STATE(2412), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93364] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4766), 1,
      anon_sym_EQ_GT,
    STATE(2413), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93378] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4768), 1,
      sym__end_of_statement,
    STATE(2414), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93392] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4770), 1,
      sym__end_of_statement,
    STATE(2415), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93406] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4772), 1,
      sym__end_of_statement,
    STATE(2416), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93420] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4774), 1,
      aux_sym_implicit_statement_token2,
    STATE(2417), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93434] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4776), 1,
      anon_sym_EQ_GT,
    STATE(2418), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93448] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4778), 1,
      anon_sym_LPAREN,
    STATE(2419), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93462] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4780), 1,
      anon_sym_LPAREN,
    STATE(2420), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93476] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4782), 1,
      sym__end_of_statement,
    STATE(2421), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93490] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4784), 1,
      anon_sym_RPAREN,
    STATE(2422), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93504] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4786), 1,
      sym__end_of_statement,
    STATE(2423), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93518] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4788), 1,
      anon_sym_RPAREN,
    STATE(2424), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93532] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3320), 1,
      sym__end_of_statement,
    STATE(2425), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93546] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4790), 1,
      anon_sym_COLON_COLON,
    STATE(2426), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93560] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1988), 1,
      sym__end_of_statement,
    STATE(2427), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93574] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4792), 1,
      sym__end_of_statement,
    STATE(2428), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93588] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4794), 1,
      sym__end_of_statement,
    STATE(2429), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93602] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4796), 1,
      anon_sym_RPAREN,
    STATE(2430), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93616] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4798), 1,
      anon_sym_RPAREN,
    STATE(2431), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93630] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4800), 1,
      anon_sym_RPAREN,
    STATE(2432), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93644] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4802), 1,
      sym__end_of_statement,
    STATE(2433), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93658] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4804), 1,
      sym__end_of_statement,
    STATE(2434), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93672] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4806), 1,
      aux_sym__inline_where_statement_token1,
    STATE(2435), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93686] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4808), 1,
      sym__end_of_statement,
    STATE(2436), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93700] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4810), 1,
      sym__end_of_statement,
    STATE(2437), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93714] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1786), 1,
      sym__end_of_statement,
    STATE(2438), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93728] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4812), 1,
      sym__end_of_statement,
    STATE(2439), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93742] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4814), 1,
      sym__end_of_statement,
    STATE(2440), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93756] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4816), 1,
      anon_sym_SLASH,
    STATE(2441), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93770] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4818), 1,
      sym__end_of_statement,
    STATE(2442), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93784] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4820), 1,
      aux_sym_interface_statement_token1,
    STATE(2443), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93798] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4355), 1,
      sym__end_of_statement,
    STATE(2444), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93812] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4822), 1,
      sym__end_of_statement,
    STATE(2445), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93826] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4824), 1,
      anon_sym_RPAREN,
    STATE(2446), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93840] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4826), 1,
      sym__end_of_statement,
    STATE(2447), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93854] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4828), 1,
      sym__end_of_statement,
    STATE(2448), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93868] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4830), 1,
      sym__end_of_statement,
    STATE(2449), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93882] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4832), 1,
      sym__end_of_statement,
    STATE(2450), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93896] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4834), 1,
      anon_sym_SLASH_RPAREN,
    STATE(2451), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93910] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4836), 1,
      anon_sym_COLON_COLON,
    STATE(2452), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93924] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4838), 1,
      sym__end_of_statement,
    STATE(2453), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93938] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4840), 1,
      sym__end_of_statement,
    STATE(2454), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93952] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4842), 1,
      sym__end_of_statement,
    STATE(2455), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93966] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4844), 1,
      sym__end_of_statement,
    STATE(2456), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93980] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4846), 1,
      anon_sym_EQ_GT,
    STATE(2457), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [93994] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4848), 1,
      sym__end_of_statement,
    STATE(2458), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94008] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2748), 1,
      sym__end_of_statement,
    STATE(2459), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94022] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4850), 1,
      sym__end_of_statement,
    STATE(2460), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94036] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4852), 1,
      sym__end_of_statement,
    STATE(2461), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94050] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4854), 1,
      sym__end_of_statement,
    STATE(2462), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94064] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4856), 1,
      sym__end_of_statement,
    STATE(2463), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94078] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4858), 1,
      sym__end_of_statement,
    STATE(2464), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94092] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4860), 1,
      sym__end_of_statement,
    STATE(2465), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94106] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4862), 1,
      sym__end_of_statement,
    STATE(2466), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94120] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4864), 1,
      sym__end_of_statement,
    STATE(2467), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94134] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4866), 1,
      sym__end_of_statement,
    STATE(2468), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94148] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4868), 1,
      sym__end_of_statement,
    STATE(2469), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94162] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4870), 1,
      anon_sym_LPAREN,
    STATE(2470), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94176] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4872), 1,
      sym__end_of_statement,
    STATE(2471), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94190] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4874), 1,
      sym__end_of_statement,
    STATE(2472), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94204] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4876), 1,
      sym__end_of_statement,
    STATE(2473), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94218] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4878), 1,
      sym__end_of_statement,
    STATE(2474), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94232] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4880), 1,
      sym__end_of_statement,
    STATE(2475), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94246] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4882), 1,
      sym__end_of_statement,
    STATE(2476), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94260] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4884), 1,
      anon_sym_COLON,
    STATE(2477), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94274] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4886), 1,
      anon_sym_EQ_GT,
    STATE(2478), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94288] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4888), 1,
      aux_sym_select_case_statement_token1,
    STATE(2479), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94302] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4890), 1,
      sym__end_of_statement,
    STATE(2480), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94316] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4892), 1,
      sym__end_of_statement,
    STATE(2481), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94330] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4894), 1,
      sym__end_of_statement,
    STATE(2482), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94344] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4896), 1,
      sym__end_of_statement,
    STATE(2483), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94358] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4898), 1,
      sym__end_of_statement,
    STATE(2484), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94372] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4900), 1,
      sym__end_of_statement,
    STATE(2485), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94386] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4902), 1,
      sym__end_of_statement,
    STATE(2486), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94400] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4904), 1,
      sym__end_of_statement,
    STATE(2487), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94414] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4906), 1,
      sym__end_of_statement,
    STATE(2488), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94428] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4908), 1,
      sym__end_of_statement,
    STATE(2489), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94442] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4910), 1,
      anon_sym_STAR,
    STATE(2490), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94456] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3626), 1,
      sym__end_of_statement,
    STATE(2491), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94470] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4912), 1,
      sym__end_of_statement,
    STATE(2492), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94484] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4914), 1,
      anon_sym_RBRACK,
    STATE(2493), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94498] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4916), 1,
      sym__end_of_statement,
    STATE(2494), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94512] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4918), 1,
      sym__end_of_statement,
    STATE(2495), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94526] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4920), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94540] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4922), 1,
      sym__end_of_statement,
    STATE(2497), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94554] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4924), 1,
      sym__end_of_statement,
    STATE(2498), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94568] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4926), 1,
      sym__end_of_statement,
    STATE(2499), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94582] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4928), 1,
      anon_sym_EQ_GT,
    STATE(2500), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94596] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4930), 1,
      sym__end_of_statement,
    STATE(2501), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94610] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4932), 1,
      anon_sym_EQ,
    STATE(2502), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94624] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4934), 1,
      anon_sym_RPAREN,
    STATE(2503), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94638] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4936), 1,
      sym__end_of_statement,
    STATE(2504), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94652] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1544), 1,
      sym__end_of_statement,
    STATE(2505), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94666] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4938), 1,
      sym__end_of_statement,
    STATE(2506), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94680] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4940), 1,
      sym__end_of_statement,
    STATE(2507), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94694] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4942), 1,
      sym__end_of_statement,
    STATE(2508), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94708] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4944), 1,
      sym__end_of_statement,
    STATE(2509), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94722] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4946), 1,
      sym__end_of_statement,
    STATE(2510), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94736] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4948), 1,
      sym__end_of_statement,
    STATE(2511), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94750] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4950), 1,
      anon_sym_LPAREN,
    STATE(2512), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94764] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4952), 1,
      sym__end_of_statement,
    STATE(2513), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94778] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4954), 1,
      sym__end_of_statement,
    STATE(2514), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94792] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4956), 1,
      sym__end_of_statement,
    STATE(2515), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94806] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4958), 1,
      sym__end_of_statement,
    STATE(2516), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94820] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4960), 1,
      sym__end_of_statement,
    STATE(2517), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94834] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4962), 1,
      anon_sym_RPAREN,
    STATE(2518), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94848] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4964), 1,
      anon_sym_COLON,
    STATE(2519), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94862] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4966), 1,
      sym__end_of_statement,
    STATE(2520), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94876] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4968), 1,
      sym__end_of_statement,
    STATE(2521), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94890] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3045), 1,
      sym__end_of_statement,
    STATE(2522), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94904] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4970), 1,
      sym__end_of_statement,
    STATE(2523), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94918] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2992), 1,
      sym__end_of_statement,
    STATE(2524), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94932] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4972), 1,
      sym__end_of_statement,
    STATE(2525), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94946] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4974), 1,
      sym__end_of_statement,
    STATE(2526), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94960] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3220), 1,
      sym__end_of_statement,
    STATE(2527), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94974] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4976), 1,
      sym__end_of_statement,
    STATE(2528), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [94988] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4978), 1,
      sym__end_of_statement,
    STATE(2529), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95002] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4980), 1,
      sym__end_of_statement,
    STATE(2530), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95016] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4982), 1,
      sym__end_of_statement,
    STATE(2531), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95030] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4984), 1,
      sym__end_of_statement,
    STATE(2532), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95044] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4986), 1,
      sym__end_of_statement,
    STATE(2533), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95058] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4988), 1,
      aux_sym_type_statement_token1,
    STATE(2534), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95072] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4990), 1,
      sym__end_of_statement,
    STATE(2535), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95086] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4992), 1,
      anon_sym_RPAREN,
    STATE(2536), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95100] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4994), 1,
      sym__end_of_statement,
    STATE(2537), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95114] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4996), 1,
      sym__end_of_statement,
    STATE(2538), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95128] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4714), 1,
      sym__end_of_statement,
    STATE(2539), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95142] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4998), 1,
      sym__end_of_statement,
    STATE(2540), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95156] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5000), 1,
      sym__end_of_statement,
    STATE(2541), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95170] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5002), 1,
      sym__end_of_statement,
    STATE(2542), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95184] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5004), 1,
      sym__end_of_statement,
    STATE(2543), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95198] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5006), 1,
      sym__end_of_statement,
    STATE(2544), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95212] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3503), 1,
      aux_sym_module_procedure_statement_token1,
    STATE(2545), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95226] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5008), 1,
      sym__end_of_statement,
    STATE(2546), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95240] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5010), 1,
      sym__end_of_statement,
    STATE(2547), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95254] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2853), 1,
      sym__end_of_statement,
    STATE(2548), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95268] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5012), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95282] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5014), 1,
      anon_sym_LPAREN,
    STATE(2550), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95296] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5016), 1,
      sym__end_of_statement,
    STATE(2551), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95310] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2956), 1,
      anon_sym_LPAREN,
    STATE(2552), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95324] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5018), 1,
      sym__end_of_statement,
    STATE(2553), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95338] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5020), 1,
      sym__end_of_statement,
    STATE(2554), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95352] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5022), 1,
      sym__end_of_statement,
    STATE(2555), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95366] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5024), 1,
      sym__end_of_statement,
    STATE(2556), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95380] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5026), 1,
      sym__end_of_statement,
    STATE(2557), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95394] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5028), 1,
      sym__end_of_statement,
    STATE(2558), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95408] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4738), 1,
      sym__end_of_statement,
    STATE(2559), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95422] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5030), 1,
      sym__end_of_statement,
    STATE(2560), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95436] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5032), 1,
      sym__end_of_statement,
    STATE(2561), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95450] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5034), 1,
      sym__end_of_statement,
    STATE(2562), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95464] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5036), 1,
      sym__end_of_statement,
    STATE(2563), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95478] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2728), 1,
      anon_sym_RPAREN,
    STATE(2564), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95492] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5038), 1,
      anon_sym_LPAREN,
    STATE(2565), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95506] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5040), 1,
      sym__end_of_statement,
    STATE(2566), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95520] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5042), 1,
      anon_sym_LPAREN,
    STATE(2567), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95534] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5044), 1,
      anon_sym_LPAREN,
    STATE(2568), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95548] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    STATE(2569), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95562] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5048), 1,
      anon_sym_RPAREN,
    STATE(2570), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95576] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5050), 1,
      ts_builtin_sym_end,
    STATE(2571), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95590] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5052), 1,
      sym__end_of_statement,
    STATE(2572), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95604] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3967), 1,
      anon_sym_EQ_GT,
    STATE(2573), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95618] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5054), 1,
      sym__end_of_statement,
    STATE(2574), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95632] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5056), 1,
      sym__end_of_statement,
    STATE(2575), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95646] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5058), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95660] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5060), 1,
      sym__end_of_statement,
    STATE(2577), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95674] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5062), 1,
      sym__end_of_statement,
    STATE(2578), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95688] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5064), 1,
      sym__end_of_statement,
    STATE(2579), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95702] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5066), 1,
      sym__end_of_statement,
    STATE(2580), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95716] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5068), 1,
      sym__end_of_statement,
    STATE(2581), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95730] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5070), 1,
      sym__end_of_statement,
    STATE(2582), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95744] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5072), 1,
      sym__end_of_statement,
    STATE(2583), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95758] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5074), 1,
      sym__end_of_statement,
    STATE(2584), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95772] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5076), 1,
      sym__end_of_statement,
    STATE(2585), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95786] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5078), 1,
      anon_sym_RPAREN,
    STATE(2586), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95800] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5080), 1,
      sym__end_of_statement,
    STATE(2587), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95814] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5082), 1,
      anon_sym_LPAREN,
    STATE(2588), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95828] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5084), 1,
      sym__end_of_statement,
    STATE(2589), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95842] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5086), 1,
      sym__end_of_statement,
    STATE(2590), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95856] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5088), 1,
      sym__end_of_statement,
    STATE(2591), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95870] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5090), 1,
      sym__end_of_statement,
    STATE(2592), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95884] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5092), 1,
      sym__end_of_statement,
    STATE(2593), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95898] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5094), 1,
      sym__end_of_statement,
    STATE(2594), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95912] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5096), 1,
      sym__end_of_statement,
    STATE(2595), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95926] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5098), 1,
      sym__end_of_statement,
    STATE(2596), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95940] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5100), 1,
      sym__end_of_statement,
    STATE(2597), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95954] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5102), 1,
      sym__end_of_statement,
    STATE(2598), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95968] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5104), 1,
      anon_sym_EQ_GT,
    STATE(2599), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95982] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2891), 1,
      aux_sym__inline_where_statement_token1,
    STATE(2600), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [95996] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5106), 1,
      anon_sym_RPAREN,
    STATE(2601), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96010] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5108), 1,
      sym__end_of_statement,
    STATE(2602), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96024] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5110), 1,
      anon_sym_LPAREN,
    STATE(2603), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96038] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5112), 1,
      anon_sym_RPAREN,
    STATE(2604), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96052] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5114), 1,
      sym__end_of_statement,
    STATE(2605), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96066] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5116), 1,
      sym__end_of_statement,
    STATE(2606), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96080] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5118), 1,
      sym__end_of_statement,
    STATE(2607), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96094] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5120), 1,
      anon_sym_RPAREN,
    STATE(2608), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96108] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5122), 1,
      sym__end_of_statement,
    STATE(2609), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96122] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4872), 1,
      sym__end_of_statement,
    STATE(2610), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96136] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5124), 1,
      sym__end_of_statement,
    STATE(2611), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96150] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5126), 1,
      sym__end_of_statement,
    STATE(2612), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96164] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5128), 1,
      sym__end_of_statement,
    STATE(2613), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96178] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5130), 1,
      anon_sym_EQ,
    STATE(2614), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96192] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5132), 1,
      anon_sym_RPAREN,
    STATE(2615), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96206] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5134), 1,
      sym__end_of_statement,
    STATE(2616), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96220] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5136), 1,
      anon_sym_EQ,
    STATE(2617), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96234] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5138), 1,
      anon_sym_LPAREN,
    STATE(2618), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96248] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5140), 1,
      anon_sym_RPAREN,
    STATE(2619), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96262] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1766), 1,
      sym__end_of_statement,
    STATE(2620), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96276] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5142), 1,
      aux_sym_stop_statement_token3,
    STATE(2621), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96290] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5144), 1,
      sym__end_of_statement,
    STATE(2622), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96304] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2644), 1,
      sym__end_of_statement,
    STATE(2623), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96318] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5146), 1,
      sym__end_of_statement,
    STATE(2624), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96332] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5148), 1,
      sym__end_of_statement,
    STATE(2625), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96346] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5150), 1,
      sym__end_of_statement,
    STATE(2626), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96360] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5152), 1,
      sym__end_of_statement,
    STATE(2627), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96374] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4896), 1,
      sym__end_of_statement,
    STATE(2628), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96388] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5154), 1,
      sym__end_of_statement,
    STATE(2629), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96402] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5156), 1,
      sym__end_of_statement,
    STATE(2630), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96416] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5158), 1,
      sym__end_of_statement,
    STATE(2631), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96430] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5160), 1,
      sym__end_of_statement,
    STATE(2632), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96444] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    STATE(2633), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96458] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5164), 1,
      aux_sym_keyword_statement_token5,
    STATE(2634), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96472] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5144), 1,
      sym__end_of_statement,
    STATE(2635), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96486] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5166), 1,
      sym__end_of_statement,
    STATE(2636), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96500] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5168), 1,
      sym__end_of_statement,
    STATE(2637), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96514] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5170), 1,
      sym__end_of_statement,
    STATE(2638), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96528] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5172), 1,
      sym__end_of_statement,
    STATE(2639), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96542] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5174), 1,
      anon_sym_RPAREN,
    STATE(2640), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96556] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5176), 1,
      sym__end_of_statement,
    STATE(2641), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96570] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5178), 1,
      sym__end_of_statement,
    STATE(2642), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96584] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5180), 1,
      sym__end_of_statement,
    STATE(2643), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96598] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5182), 1,
      sym__end_of_statement,
    STATE(2644), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96612] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5184), 1,
      sym__end_of_statement,
    STATE(2645), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96626] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5186), 1,
      sym__end_of_statement,
    STATE(2646), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96640] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5188), 1,
      sym__end_of_statement,
    STATE(2647), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96654] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5190), 1,
      sym__end_of_statement,
    STATE(2648), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96668] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5192), 1,
      sym__end_of_statement,
    STATE(2649), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96682] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5194), 1,
      sym__end_of_statement,
    STATE(2650), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96696] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5196), 1,
      sym__end_of_statement,
    STATE(2651), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96710] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5198), 1,
      sym__end_of_statement,
    STATE(2652), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96724] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5200), 1,
      anon_sym_EQ,
    STATE(2653), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96738] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5202), 1,
      sym__end_of_statement,
    STATE(2654), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96752] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5204), 1,
      sym__end_of_statement,
    STATE(2655), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96766] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5206), 1,
      anon_sym_RPAREN,
    STATE(2656), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96780] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5208), 1,
      sym__end_of_statement,
    STATE(2657), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96794] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2867), 1,
      anon_sym_EQ_GT,
    STATE(2658), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96808] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5210), 1,
      anon_sym_RPAREN,
    STATE(2659), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96822] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5212), 1,
      anon_sym_RPAREN,
    STATE(2660), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96836] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5214), 1,
      sym__end_of_statement,
    STATE(2661), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96850] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5216), 1,
      sym__end_of_statement,
    STATE(2662), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96864] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5218), 1,
      sym__end_of_statement,
    STATE(2663), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96878] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5220), 1,
      anon_sym_LPAREN,
    STATE(2664), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96892] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1852), 1,
      sym__end_of_statement,
    STATE(2665), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96906] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2986), 1,
      sym__end_of_statement,
    STATE(2666), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96920] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2954), 1,
      sym__end_of_statement,
    STATE(2667), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96934] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5222), 1,
      anon_sym_SLASH_RPAREN,
    STATE(2668), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96948] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5224), 1,
      anon_sym_RPAREN,
    STATE(2669), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96962] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5226), 1,
      sym__end_of_statement,
    STATE(2670), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96976] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4526), 1,
      anon_sym_RPAREN,
    STATE(2671), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [96990] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5228), 1,
      sym__end_of_statement,
    STATE(2672), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97004] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5230), 1,
      anon_sym_RBRACK,
    STATE(2673), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97018] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5232), 1,
      anon_sym_RPAREN,
    STATE(2674), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97032] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4864), 1,
      sym__end_of_statement,
    STATE(2675), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97046] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5234), 1,
      sym__end_of_statement,
    STATE(2676), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97060] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5236), 1,
      sym__end_of_statement,
    STATE(2677), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97074] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5238), 1,
      aux_sym_interface_statement_token1,
    STATE(2678), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97088] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5004), 1,
      sym__end_of_statement,
    STATE(2679), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97102] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5240), 1,
      sym__end_of_statement,
    STATE(2680), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97116] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5242), 1,
      sym__end_of_statement,
    STATE(2681), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97130] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5244), 1,
      sym__end_of_statement,
    STATE(2682), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97144] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5246), 1,
      anon_sym_SLASH,
    STATE(2683), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97158] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
    STATE(2684), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97172] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4434), 1,
      sym__end_of_statement,
    STATE(2685), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97186] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5250), 1,
      sym__end_of_statement,
    STATE(2686), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97200] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5252), 1,
      sym__end_of_statement,
    STATE(2687), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97214] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5254), 1,
      sym__end_of_statement,
    STATE(2688), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97228] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5256), 1,
      sym__end_of_statement,
    STATE(2689), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97242] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5258), 1,
      anon_sym_EQ_GT,
    STATE(2690), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97256] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5260), 1,
      aux_sym__block_if_statement_token1,
    STATE(2691), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97270] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5262), 1,
      sym__end_of_statement,
    STATE(2692), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97284] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5264), 1,
      sym__end_of_statement,
    STATE(2693), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97298] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5022), 1,
      sym__end_of_statement,
    STATE(2694), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97312] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5266), 1,
      sym__end_of_statement,
    STATE(2695), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97326] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5268), 1,
      sym__end_of_statement,
    STATE(2696), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97340] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5270), 1,
      sym__end_of_statement,
    STATE(2697), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97354] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5272), 1,
      aux_sym__block_if_statement_token1,
    STATE(2698), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97368] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4866), 1,
      anon_sym_RPAREN,
    STATE(2699), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97382] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5274), 1,
      aux_sym_implicit_range_token1,
    STATE(2700), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97396] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5276), 1,
      sym__end_of_statement,
    STATE(2701), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97410] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4904), 1,
      sym__end_of_statement,
    STATE(2702), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97424] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5278), 1,
      sym__end_of_statement,
    STATE(2703), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97438] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5280), 1,
      sym__end_of_statement,
    STATE(2704), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97452] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5282), 1,
      sym__end_of_statement,
    STATE(2705), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97466] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5284), 1,
      anon_sym_RPAREN,
    STATE(2706), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97480] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5286), 1,
      anon_sym_RPAREN,
    STATE(2707), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97494] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5288), 1,
      sym__end_of_statement,
    STATE(2708), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97508] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5290), 1,
      anon_sym_EQ_GT,
    STATE(2709), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97522] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5292), 1,
      anon_sym_COLON,
    STATE(2710), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97536] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(2711), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97550] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    STATE(2712), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97564] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5298), 1,
      sym__end_of_statement,
    STATE(2713), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97578] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5300), 1,
      sym__end_of_statement,
    STATE(2714), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97592] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(2715), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97606] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5304), 1,
      sym__end_of_statement,
    STATE(2716), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97620] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
    STATE(2717), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97634] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5308), 1,
      sym__end_of_statement,
    STATE(2718), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97648] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5310), 1,
      sym__end_of_statement,
    STATE(2719), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97662] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5312), 1,
      sym__end_of_statement,
    STATE(2720), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97676] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5314), 1,
      sym__end_of_statement,
    STATE(2721), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97690] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3302), 1,
      sym__end_of_statement,
    STATE(2722), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97704] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4646), 1,
      anon_sym_RPAREN,
    STATE(2723), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97718] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5316), 1,
      anon_sym_RPAREN,
    STATE(2724), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97732] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5318), 1,
      sym__end_of_statement,
    STATE(2725), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97746] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5320), 1,
      sym__end_of_statement,
    STATE(2726), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97760] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5322), 1,
      anon_sym_RPAREN,
    STATE(2727), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97774] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5324), 1,
      sym__end_of_statement,
    STATE(2728), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97788] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5326), 1,
      anon_sym_EQ,
    STATE(2729), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97802] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5328), 1,
      anon_sym_COMMA,
    STATE(2730), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97816] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5330), 1,
      sym__end_of_statement,
    STATE(2731), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97830] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5332), 1,
      anon_sym_LPAREN,
    STATE(2732), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97844] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5334), 1,
      sym__end_of_statement,
    STATE(2733), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97858] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5336), 1,
      sym__end_of_statement,
    STATE(2734), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97872] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5338), 1,
      sym__end_of_statement,
    STATE(2735), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97886] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5340), 1,
      sym__end_of_statement,
    STATE(2736), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97900] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5342), 1,
      anon_sym_EQ_GT,
    STATE(2737), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97914] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5344), 1,
      sym__end_of_statement,
    STATE(2738), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97928] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5346), 1,
      sym__end_of_statement,
    STATE(2739), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97942] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5348), 1,
      anon_sym_SLASH,
    STATE(2740), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97956] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5350), 1,
      sym__end_of_statement,
    STATE(2741), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97970] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5352), 1,
      anon_sym_RPAREN,
    STATE(2742), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97984] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5354), 1,
      sym__end_of_statement,
    STATE(2743), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [97998] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(2937), 1,
      aux_sym__inline_if_statement_token1,
    STATE(2744), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98012] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5356), 1,
      sym__end_of_statement,
    STATE(2745), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98026] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5358), 1,
      sym__end_of_statement,
    STATE(2746), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98040] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5360), 1,
      anon_sym_RPAREN,
    STATE(2747), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98054] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5362), 1,
      sym__end_of_statement,
    STATE(2748), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98068] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5364), 1,
      anon_sym_RPAREN,
    STATE(2749), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98082] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5366), 1,
      sym__end_of_statement,
    STATE(2750), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98096] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5368), 1,
      sym__end_of_statement,
    STATE(2751), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98110] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5370), 1,
      sym__end_of_statement,
    STATE(2752), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98124] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5372), 1,
      anon_sym_EQ_GT,
    STATE(2753), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98138] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5374), 1,
      sym__end_of_statement,
    STATE(2754), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98152] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5376), 1,
      sym__end_of_statement,
    STATE(2755), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98166] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5378), 1,
      sym__end_of_statement,
    STATE(2756), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98180] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5380), 1,
      sym__end_of_statement,
    STATE(2757), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98194] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5382), 1,
      sym__end_of_statement,
    STATE(2758), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98208] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5384), 1,
      sym__end_of_statement,
    STATE(2759), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98222] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5386), 1,
      sym__end_of_statement,
    STATE(2760), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98236] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5388), 1,
      sym__end_of_statement,
    STATE(2761), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98250] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5390), 1,
      sym__end_of_statement,
    STATE(2762), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98264] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5392), 1,
      sym__end_of_statement,
    STATE(2763), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98278] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5394), 1,
      sym__end_of_statement,
    STATE(2764), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98292] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5396), 1,
      sym__end_of_statement,
    STATE(2765), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98306] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5398), 1,
      sym__end_of_statement,
    STATE(2766), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98320] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5400), 1,
      sym__end_of_statement,
    STATE(2767), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98334] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5402), 1,
      sym__end_of_statement,
    STATE(2768), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98348] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5404), 1,
      sym__end_of_statement,
    STATE(2769), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98362] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5406), 1,
      sym__end_of_statement,
    STATE(2770), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98376] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5408), 1,
      sym__end_of_statement,
    STATE(2771), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98390] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5410), 1,
      sym__end_of_statement,
    STATE(2772), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98404] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5412), 1,
      anon_sym_LPAREN,
    STATE(2773), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98418] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5414), 1,
      anon_sym_EQ_GT,
    STATE(2774), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98432] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5416), 1,
      anon_sym_LPAREN,
    STATE(2775), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98446] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5418), 1,
      sym__end_of_statement,
    STATE(2776), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98460] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5420), 1,
      sym__end_of_statement,
    STATE(2777), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98474] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5422), 1,
      sym__end_of_statement,
    STATE(2778), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98488] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5424), 1,
      sym__end_of_statement,
    STATE(2779), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98502] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5426), 1,
      anon_sym_EQ_GT,
    STATE(2780), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98516] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5428), 1,
      sym__end_of_statement,
    STATE(2781), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98530] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5430), 1,
      sym__end_of_statement,
    STATE(2782), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98544] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5432), 1,
      sym__end_of_statement,
    STATE(2783), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98558] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5434), 1,
      sym__end_of_statement,
    STATE(2784), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98572] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5436), 1,
      sym__end_of_statement,
    STATE(2785), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98586] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5438), 1,
      sym__end_of_statement,
    STATE(2786), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98600] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5440), 1,
      aux_sym_interface_statement_token1,
    STATE(2787), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98614] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5442), 1,
      sym__end_of_statement,
    STATE(2788), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98628] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5444), 1,
      aux_sym_stop_statement_token3,
    STATE(2789), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98642] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5446), 1,
      sym__end_of_statement,
    STATE(2790), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98656] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5448), 1,
      sym__end_of_statement,
    STATE(2791), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98670] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5450), 1,
      anon_sym_EQ,
    STATE(2792), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98684] = 4,
    ACTIONS(4150), 1,
      anon_sym_POUND,
    ACTIONS(5452), 1,
      aux_sym_operator_token2,
    STATE(2793), 1,
      sym_preproc_file_line,
    ACTIONS(4152), 2,
      sym_comment,
      anon_sym_AMP,
  [98698] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5454), 1,
      anon_sym_RPAREN,
    STATE(2794), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98712] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5456), 1,
      anon_sym_SLASH,
    STATE(2795), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98726] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5458), 1,
      sym__end_of_statement,
    STATE(2796), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98740] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5460), 1,
      sym__end_of_statement,
    STATE(2797), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98754] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5462), 1,
      sym__end_of_statement,
    STATE(2798), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98768] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5464), 1,
      sym__end_of_statement,
    STATE(2799), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98782] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5466), 1,
      anon_sym_EQ,
    STATE(2800), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98796] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5468), 1,
      sym__end_of_statement,
    STATE(2801), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98810] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5470), 1,
      anon_sym_RPAREN,
    STATE(2802), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98824] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5472), 1,
      anon_sym_RPAREN,
    STATE(2803), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98838] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(4758), 1,
      sym__end_of_statement,
    STATE(2804), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98852] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5474), 1,
      anon_sym_RPAREN,
    STATE(2805), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98866] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5476), 1,
      anon_sym_RPAREN,
    STATE(2806), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98880] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5478), 1,
      aux_sym_size_token1,
    STATE(2807), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98894] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5480), 1,
      sym__end_of_statement,
    STATE(2808), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98908] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5482), 1,
      sym__end_of_statement,
    STATE(2809), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98922] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5484), 1,
      sym__end_of_statement,
    STATE(2810), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98936] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5486), 1,
      sym__end_of_statement,
    STATE(2811), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98950] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5488), 1,
      anon_sym_RPAREN,
    STATE(2812), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98964] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5490), 1,
      sym__end_of_statement,
    STATE(2813), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98978] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5492), 1,
      sym__end_of_statement,
    STATE(2814), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [98992] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5494), 1,
      sym__end_of_statement,
    STATE(2815), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99006] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5496), 1,
      sym__end_of_statement,
    STATE(2816), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99020] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5498), 1,
      anon_sym_RPAREN,
    STATE(2817), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99034] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5500), 1,
      sym__end_of_statement,
    STATE(2818), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99048] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5502), 1,
      anon_sym_EQ_GT,
    STATE(2819), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99062] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5504), 1,
      sym__end_of_statement,
    STATE(2820), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99076] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5506), 1,
      sym__end_of_statement,
    STATE(2821), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99090] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5508), 1,
      sym__end_of_statement,
    STATE(2822), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99104] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5510), 1,
      sym__end_of_statement,
    STATE(2823), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99118] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5512), 1,
      sym__end_of_statement,
    STATE(2824), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99132] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5514), 1,
      aux_sym_enum_statement_token1,
    STATE(2825), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99146] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5516), 1,
      anon_sym_LPAREN,
    STATE(2826), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99160] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5518), 1,
      sym__end_of_statement,
    STATE(2827), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99174] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5520), 1,
      aux_sym_interface_statement_token1,
    STATE(2828), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99188] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5522), 1,
      sym__end_of_statement,
    STATE(2829), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99202] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5524), 1,
      anon_sym_LPAREN,
    STATE(2830), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99216] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5526), 1,
      anon_sym_EQ,
    STATE(2831), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99230] = 4,
    ACTIONS(4150), 1,
      anon_sym_POUND,
    ACTIONS(5528), 1,
      aux_sym_operator_token2,
    STATE(2832), 1,
      sym_preproc_file_line,
    ACTIONS(4152), 2,
      sym_comment,
      anon_sym_AMP,
  [99244] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5530), 1,
      sym__end_of_statement,
    STATE(2833), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99258] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5532), 1,
      sym__end_of_statement,
    STATE(2834), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99272] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5534), 1,
      sym__end_of_statement,
    STATE(2835), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99286] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5536), 1,
      sym__end_of_statement,
    STATE(2836), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99300] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(1770), 1,
      sym__end_of_statement,
    STATE(2837), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99314] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5538), 1,
      sym__end_of_statement,
    STATE(2838), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99328] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5540), 1,
      sym__end_of_statement,
    STATE(2839), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99342] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5542), 1,
      sym__end_of_statement,
    STATE(2840), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99356] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5544), 1,
      anon_sym_EQ,
    STATE(2841), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99370] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5546), 1,
      sym__end_of_statement,
    STATE(2842), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99384] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5548), 1,
      aux_sym_interface_statement_token1,
    STATE(2843), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99398] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5550), 1,
      sym__end_of_statement,
    STATE(2844), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99412] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5552), 1,
      aux_sym_user_defined_operator_token1,
    STATE(2845), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99426] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5554), 1,
      sym__end_of_statement,
    STATE(2846), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99440] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5556), 1,
      sym__end_of_statement,
    STATE(2847), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99454] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5558), 1,
      sym__end_of_statement,
    STATE(2848), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99468] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5560), 1,
      sym__end_of_statement,
    STATE(2849), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99482] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5562), 1,
      sym__end_of_statement,
    STATE(2850), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99496] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5564), 1,
      sym__end_of_statement,
    STATE(2851), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99510] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5566), 1,
      anon_sym_EQ,
    STATE(2852), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99524] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5568), 1,
      sym__end_of_statement,
    STATE(2853), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99538] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5570), 1,
      sym__end_of_statement,
    STATE(2854), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99552] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3214), 1,
      sym__end_of_statement,
    STATE(2855), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99566] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5572), 1,
      sym__end_of_statement,
    STATE(2856), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99580] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5574), 1,
      sym__end_of_statement,
    STATE(2857), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99594] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5576), 1,
      sym__end_of_statement,
    STATE(2858), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99608] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5578), 1,
      sym__end_of_statement,
    STATE(2859), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99622] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5580), 1,
      sym__end_of_statement,
    STATE(2860), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99636] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5582), 1,
      aux_sym_stop_statement_token3,
    STATE(2861), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99650] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5584), 1,
      sym__end_of_statement,
    STATE(2862), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99664] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5586), 1,
      sym__end_of_statement,
    STATE(2863), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99678] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5588), 1,
      sym__end_of_statement,
    STATE(2864), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99692] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5590), 1,
      anon_sym_EQ_GT,
    STATE(2865), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99706] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5592), 1,
      aux_sym_interface_statement_token1,
    STATE(2866), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99720] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5594), 1,
      sym__end_of_statement,
    STATE(2867), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99734] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5596), 1,
      sym__end_of_statement,
    STATE(2868), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99748] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5598), 1,
      sym__end_of_statement,
    STATE(2869), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99762] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5600), 1,
      sym__end_of_statement,
    STATE(2870), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99776] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5602), 1,
      sym__end_of_statement,
    STATE(2871), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99790] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5604), 1,
      sym__end_of_statement,
    STATE(2872), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99804] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5606), 1,
      sym__end_of_statement,
    STATE(2873), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99818] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5608), 1,
      sym__end_of_statement,
    STATE(2874), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99832] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5610), 1,
      anon_sym_RPAREN,
    STATE(2875), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99846] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5612), 1,
      anon_sym_LPAREN,
    STATE(2876), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99860] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5614), 1,
      aux_sym_interface_statement_token1,
    STATE(2877), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99874] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5616), 1,
      sym__end_of_statement,
    STATE(2878), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99888] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5618), 1,
      anon_sym_RPAREN,
    STATE(2879), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99902] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5620), 1,
      sym__end_of_statement,
    STATE(2880), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99916] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5622), 1,
      sym__end_of_statement,
    STATE(2881), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99930] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5624), 1,
      anon_sym_RPAREN,
    STATE(2882), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99944] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5626), 1,
      sym__end_of_statement,
    STATE(2883), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99958] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5628), 1,
      sym__end_of_statement,
    STATE(2884), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99972] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5630), 1,
      aux_sym_interface_statement_token1,
    STATE(2885), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [99986] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5632), 1,
      sym__end_of_statement,
    STATE(2886), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100000] = 4,
    ACTIONS(4150), 1,
      anon_sym_POUND,
    ACTIONS(5634), 1,
      aux_sym_operator_token2,
    STATE(2887), 1,
      sym_preproc_file_line,
    ACTIONS(4152), 2,
      sym_comment,
      anon_sym_AMP,
  [100014] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5636), 1,
      anon_sym_LPAREN,
    STATE(2888), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100028] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5638), 1,
      anon_sym_EQ_GT,
    STATE(2889), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100042] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5640), 1,
      anon_sym_EQ_GT,
    STATE(2890), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100056] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5642), 1,
      sym__end_of_statement,
    STATE(2891), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100070] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5644), 1,
      anon_sym_LPAREN,
    STATE(2892), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100084] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5646), 1,
      anon_sym_LPAREN,
    STATE(2893), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100098] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5648), 1,
      anon_sym_LPAREN,
    STATE(2894), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100112] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5650), 1,
      aux_sym_preproc_file_line_token1,
    STATE(2895), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100126] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5652), 1,
      anon_sym_RPAREN,
    STATE(2896), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100140] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5654), 1,
      anon_sym_LPAREN,
    STATE(2897), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100154] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5656), 1,
      anon_sym_LPAREN,
    STATE(2898), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100168] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5658), 1,
      sym__end_of_statement,
    STATE(2899), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100182] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(3107), 1,
      anon_sym_LPAREN,
    STATE(2900), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100196] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5660), 1,
      sym__end_of_statement,
    STATE(2901), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100210] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5662), 1,
      sym__end_of_statement,
    STATE(2902), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100224] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5664), 1,
      sym__end_of_statement,
    STATE(2903), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100238] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5666), 1,
      sym__end_of_statement,
    STATE(2904), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100252] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5668), 1,
      anon_sym_RPAREN,
    STATE(2905), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100266] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    STATE(2906), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100280] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5672), 1,
      anon_sym_COMMA,
    STATE(2907), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100294] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5674), 1,
      sym__end_of_statement,
    STATE(2908), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100308] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5676), 1,
      anon_sym_RPAREN,
    STATE(2909), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100322] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5678), 1,
      sym__end_of_statement,
    STATE(2910), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100336] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5680), 1,
      anon_sym_LPAREN,
    STATE(2911), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100350] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5682), 1,
      sym__end_of_statement,
    STATE(2912), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100364] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5684), 1,
      anon_sym_LPAREN,
    STATE(2913), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100378] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5686), 1,
      anon_sym_LPAREN,
    STATE(2914), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100392] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5688), 1,
      anon_sym_LPAREN,
    STATE(2915), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100406] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5690), 1,
      sym__end_of_statement,
    STATE(2916), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100420] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5692), 1,
      anon_sym_LPAREN,
    STATE(2917), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100434] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(5694), 1,
      sym__end_of_statement,
    STATE(2918), 1,
      sym_preproc_file_line,
    ACTIONS(5), 2,
      sym_comment,
      anon_sym_AMP,
  [100448] = 1,
    ACTIONS(5696), 1,
      ts_builtin_sym_end,
  [100452] = 1,
    ACTIONS(5698), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(447)] = 0,
  [SMALL_STATE(448)] = 75,
  [SMALL_STATE(449)] = 150,
  [SMALL_STATE(450)] = 225,
  [SMALL_STATE(451)] = 302,
  [SMALL_STATE(452)] = 377,
  [SMALL_STATE(453)] = 452,
  [SMALL_STATE(454)] = 527,
  [SMALL_STATE(455)] = 602,
  [SMALL_STATE(456)] = 677,
  [SMALL_STATE(457)] = 752,
  [SMALL_STATE(458)] = 827,
  [SMALL_STATE(459)] = 902,
  [SMALL_STATE(460)] = 977,
  [SMALL_STATE(461)] = 1052,
  [SMALL_STATE(462)] = 1127,
  [SMALL_STATE(463)] = 1210,
  [SMALL_STATE(464)] = 1285,
  [SMALL_STATE(465)] = 1360,
  [SMALL_STATE(466)] = 1435,
  [SMALL_STATE(467)] = 1553,
  [SMALL_STATE(468)] = 1671,
  [SMALL_STATE(469)] = 1789,
  [SMALL_STATE(470)] = 1907,
  [SMALL_STATE(471)] = 2025,
  [SMALL_STATE(472)] = 2143,
  [SMALL_STATE(473)] = 2261,
  [SMALL_STATE(474)] = 2379,
  [SMALL_STATE(475)] = 2497,
  [SMALL_STATE(476)] = 2616,
  [SMALL_STATE(477)] = 2739,
  [SMALL_STATE(478)] = 2858,
  [SMALL_STATE(479)] = 2973,
  [SMALL_STATE(480)] = 3085,
  [SMALL_STATE(481)] = 3157,
  [SMALL_STATE(482)] = 3229,
  [SMALL_STATE(483)] = 3341,
  [SMALL_STATE(484)] = 3459,
  [SMALL_STATE(485)] = 3575,
  [SMALL_STATE(486)] = 3646,
  [SMALL_STATE(487)] = 3717,
  [SMALL_STATE(488)] = 3788,
  [SMALL_STATE(489)] = 3907,
  [SMALL_STATE(490)] = 3978,
  [SMALL_STATE(491)] = 4049,
  [SMALL_STATE(492)] = 4120,
  [SMALL_STATE(493)] = 4241,
  [SMALL_STATE(494)] = 4312,
  [SMALL_STATE(495)] = 4433,
  [SMALL_STATE(496)] = 4504,
  [SMALL_STATE(497)] = 4613,
  [SMALL_STATE(498)] = 4684,
  [SMALL_STATE(499)] = 4801,
  [SMALL_STATE(500)] = 4872,
  [SMALL_STATE(501)] = 4943,
  [SMALL_STATE(502)] = 5014,
  [SMALL_STATE(503)] = 5133,
  [SMALL_STATE(504)] = 5241,
  [SMALL_STATE(505)] = 5351,
  [SMALL_STATE(506)] = 5421,
  [SMALL_STATE(507)] = 5491,
  [SMALL_STATE(508)] = 5561,
  [SMALL_STATE(509)] = 5631,
  [SMALL_STATE(510)] = 5701,
  [SMALL_STATE(511)] = 5811,
  [SMALL_STATE(512)] = 5881,
  [SMALL_STATE(513)] = 5991,
  [SMALL_STATE(514)] = 6061,
  [SMALL_STATE(515)] = 6131,
  [SMALL_STATE(516)] = 6201,
  [SMALL_STATE(517)] = 6271,
  [SMALL_STATE(518)] = 6381,
  [SMALL_STATE(519)] = 6489,
  [SMALL_STATE(520)] = 6559,
  [SMALL_STATE(521)] = 6637,
  [SMALL_STATE(522)] = 6707,
  [SMALL_STATE(523)] = 6777,
  [SMALL_STATE(524)] = 6885,
  [SMALL_STATE(525)] = 6955,
  [SMALL_STATE(526)] = 7025,
  [SMALL_STATE(527)] = 7095,
  [SMALL_STATE(528)] = 7165,
  [SMALL_STATE(529)] = 7235,
  [SMALL_STATE(530)] = 7305,
  [SMALL_STATE(531)] = 7390,
  [SMALL_STATE(532)] = 7475,
  [SMALL_STATE(533)] = 7580,
  [SMALL_STATE(534)] = 7685,
  [SMALL_STATE(535)] = 7788,
  [SMALL_STATE(536)] = 7873,
  [SMALL_STATE(537)] = 7958,
  [SMALL_STATE(538)] = 8043,
  [SMALL_STATE(539)] = 8150,
  [SMALL_STATE(540)] = 8255,
  [SMALL_STATE(541)] = 8360,
  [SMALL_STATE(542)] = 8429,
  [SMALL_STATE(543)] = 8498,
  [SMALL_STATE(544)] = 8583,
  [SMALL_STATE(545)] = 8668,
  [SMALL_STATE(546)] = 8753,
  [SMALL_STATE(547)] = 8838,
  [SMALL_STATE(548)] = 8923,
  [SMALL_STATE(549)] = 9008,
  [SMALL_STATE(550)] = 9113,
  [SMALL_STATE(551)] = 9198,
  [SMALL_STATE(552)] = 9283,
  [SMALL_STATE(553)] = 9388,
  [SMALL_STATE(554)] = 9473,
  [SMALL_STATE(555)] = 9558,
  [SMALL_STATE(556)] = 9643,
  [SMALL_STATE(557)] = 9728,
  [SMALL_STATE(558)] = 9813,
  [SMALL_STATE(559)] = 9898,
  [SMALL_STATE(560)] = 9983,
  [SMALL_STATE(561)] = 10068,
  [SMALL_STATE(562)] = 10153,
  [SMALL_STATE(563)] = 10238,
  [SMALL_STATE(564)] = 10340,
  [SMALL_STATE(565)] = 10408,
  [SMALL_STATE(566)] = 10476,
  [SMALL_STATE(567)] = 10544,
  [SMALL_STATE(568)] = 10612,
  [SMALL_STATE(569)] = 10680,
  [SMALL_STATE(570)] = 10748,
  [SMALL_STATE(571)] = 10850,
  [SMALL_STATE(572)] = 10952,
  [SMALL_STATE(573)] = 11020,
  [SMALL_STATE(574)] = 11088,
  [SMALL_STATE(575)] = 11192,
  [SMALL_STATE(576)] = 11274,
  [SMALL_STATE(577)] = 11342,
  [SMALL_STATE(578)] = 11410,
  [SMALL_STATE(579)] = 11478,
  [SMALL_STATE(580)] = 11566,
  [SMALL_STATE(581)] = 11634,
  [SMALL_STATE(582)] = 11740,
  [SMALL_STATE(583)] = 11808,
  [SMALL_STATE(584)] = 11910,
  [SMALL_STATE(585)] = 11978,
  [SMALL_STATE(586)] = 12046,
  [SMALL_STATE(587)] = 12114,
  [SMALL_STATE(588)] = 12182,
  [SMALL_STATE(589)] = 12250,
  [SMALL_STATE(590)] = 12354,
  [SMALL_STATE(591)] = 12422,
  [SMALL_STATE(592)] = 12526,
  [SMALL_STATE(593)] = 12594,
  [SMALL_STATE(594)] = 12662,
  [SMALL_STATE(595)] = 12730,
  [SMALL_STATE(596)] = 12834,
  [SMALL_STATE(597)] = 12902,
  [SMALL_STATE(598)] = 12970,
  [SMALL_STATE(599)] = 13058,
  [SMALL_STATE(600)] = 13126,
  [SMALL_STATE(601)] = 13194,
  [SMALL_STATE(602)] = 13262,
  [SMALL_STATE(603)] = 13366,
  [SMALL_STATE(604)] = 13434,
  [SMALL_STATE(605)] = 13538,
  [SMALL_STATE(606)] = 13642,
  [SMALL_STATE(607)] = 13710,
  [SMALL_STATE(608)] = 13778,
  [SMALL_STATE(609)] = 13846,
  [SMALL_STATE(610)] = 13914,
  [SMALL_STATE(611)] = 13982,
  [SMALL_STATE(612)] = 14084,
  [SMALL_STATE(613)] = 14152,
  [SMALL_STATE(614)] = 14258,
  [SMALL_STATE(615)] = 14326,
  [SMALL_STATE(616)] = 14394,
  [SMALL_STATE(617)] = 14462,
  [SMALL_STATE(618)] = 14530,
  [SMALL_STATE(619)] = 14598,
  [SMALL_STATE(620)] = 14666,
  [SMALL_STATE(621)] = 14734,
  [SMALL_STATE(622)] = 14802,
  [SMALL_STATE(623)] = 14906,
  [SMALL_STATE(624)] = 15008,
  [SMALL_STATE(625)] = 15076,
  [SMALL_STATE(626)] = 15144,
  [SMALL_STATE(627)] = 15212,
  [SMALL_STATE(628)] = 15280,
  [SMALL_STATE(629)] = 15348,
  [SMALL_STATE(630)] = 15416,
  [SMALL_STATE(631)] = 15484,
  [SMALL_STATE(632)] = 15552,
  [SMALL_STATE(633)] = 15620,
  [SMALL_STATE(634)] = 15688,
  [SMALL_STATE(635)] = 15756,
  [SMALL_STATE(636)] = 15824,
  [SMALL_STATE(637)] = 15892,
  [SMALL_STATE(638)] = 15960,
  [SMALL_STATE(639)] = 16028,
  [SMALL_STATE(640)] = 16096,
  [SMALL_STATE(641)] = 16164,
  [SMALL_STATE(642)] = 16232,
  [SMALL_STATE(643)] = 16300,
  [SMALL_STATE(644)] = 16404,
  [SMALL_STATE(645)] = 16508,
  [SMALL_STATE(646)] = 16614,
  [SMALL_STATE(647)] = 16720,
  [SMALL_STATE(648)] = 16788,
  [SMALL_STATE(649)] = 16856,
  [SMALL_STATE(650)] = 16955,
  [SMALL_STATE(651)] = 17052,
  [SMALL_STATE(652)] = 17151,
  [SMALL_STATE(653)] = 17252,
  [SMALL_STATE(654)] = 17351,
  [SMALL_STATE(655)] = 17450,
  [SMALL_STATE(656)] = 17549,
  [SMALL_STATE(657)] = 17648,
  [SMALL_STATE(658)] = 17715,
  [SMALL_STATE(659)] = 17814,
  [SMALL_STATE(660)] = 17881,
  [SMALL_STATE(661)] = 17948,
  [SMALL_STATE(662)] = 18047,
  [SMALL_STATE(663)] = 18114,
  [SMALL_STATE(664)] = 18213,
  [SMALL_STATE(665)] = 18280,
  [SMALL_STATE(666)] = 18379,
  [SMALL_STATE(667)] = 18478,
  [SMALL_STATE(668)] = 18577,
  [SMALL_STATE(669)] = 18676,
  [SMALL_STATE(670)] = 18775,
  [SMALL_STATE(671)] = 18874,
  [SMALL_STATE(672)] = 18973,
  [SMALL_STATE(673)] = 19072,
  [SMALL_STATE(674)] = 19171,
  [SMALL_STATE(675)] = 19238,
  [SMALL_STATE(676)] = 19337,
  [SMALL_STATE(677)] = 19436,
  [SMALL_STATE(678)] = 19537,
  [SMALL_STATE(679)] = 19636,
  [SMALL_STATE(680)] = 19735,
  [SMALL_STATE(681)] = 19834,
  [SMALL_STATE(682)] = 19933,
  [SMALL_STATE(683)] = 20032,
  [SMALL_STATE(684)] = 20131,
  [SMALL_STATE(685)] = 20230,
  [SMALL_STATE(686)] = 20329,
  [SMALL_STATE(687)] = 20428,
  [SMALL_STATE(688)] = 20527,
  [SMALL_STATE(689)] = 20626,
  [SMALL_STATE(690)] = 20725,
  [SMALL_STATE(691)] = 20824,
  [SMALL_STATE(692)] = 20923,
  [SMALL_STATE(693)] = 21022,
  [SMALL_STATE(694)] = 21121,
  [SMALL_STATE(695)] = 21220,
  [SMALL_STATE(696)] = 21319,
  [SMALL_STATE(697)] = 21418,
  [SMALL_STATE(698)] = 21517,
  [SMALL_STATE(699)] = 21618,
  [SMALL_STATE(700)] = 21715,
  [SMALL_STATE(701)] = 21812,
  [SMALL_STATE(702)] = 21911,
  [SMALL_STATE(703)] = 22010,
  [SMALL_STATE(704)] = 22109,
  [SMALL_STATE(705)] = 22188,
  [SMALL_STATE(706)] = 22291,
  [SMALL_STATE(707)] = 22388,
  [SMALL_STATE(708)] = 22487,
  [SMALL_STATE(709)] = 22554,
  [SMALL_STATE(710)] = 22653,
  [SMALL_STATE(711)] = 22754,
  [SMALL_STATE(712)] = 22853,
  [SMALL_STATE(713)] = 22952,
  [SMALL_STATE(714)] = 23051,
  [SMALL_STATE(715)] = 23150,
  [SMALL_STATE(716)] = 23249,
  [SMALL_STATE(717)] = 23348,
  [SMALL_STATE(718)] = 23447,
  [SMALL_STATE(719)] = 23546,
  [SMALL_STATE(720)] = 23645,
  [SMALL_STATE(721)] = 23744,
  [SMALL_STATE(722)] = 23843,
  [SMALL_STATE(723)] = 23942,
  [SMALL_STATE(724)] = 24041,
  [SMALL_STATE(725)] = 24142,
  [SMALL_STATE(726)] = 24209,
  [SMALL_STATE(727)] = 24308,
  [SMALL_STATE(728)] = 24407,
  [SMALL_STATE(729)] = 24506,
  [SMALL_STATE(730)] = 24607,
  [SMALL_STATE(731)] = 24710,
  [SMALL_STATE(732)] = 24809,
  [SMALL_STATE(733)] = 24908,
  [SMALL_STATE(734)] = 25009,
  [SMALL_STATE(735)] = 25108,
  [SMALL_STATE(736)] = 25175,
  [SMALL_STATE(737)] = 25242,
  [SMALL_STATE(738)] = 25343,
  [SMALL_STATE(739)] = 25442,
  [SMALL_STATE(740)] = 25543,
  [SMALL_STATE(741)] = 25642,
  [SMALL_STATE(742)] = 25709,
  [SMALL_STATE(743)] = 25808,
  [SMALL_STATE(744)] = 25907,
  [SMALL_STATE(745)] = 26006,
  [SMALL_STATE(746)] = 26105,
  [SMALL_STATE(747)] = 26204,
  [SMALL_STATE(748)] = 26303,
  [SMALL_STATE(749)] = 26402,
  [SMALL_STATE(750)] = 26501,
  [SMALL_STATE(751)] = 26600,
  [SMALL_STATE(752)] = 26699,
  [SMALL_STATE(753)] = 26766,
  [SMALL_STATE(754)] = 26831,
  [SMALL_STATE(755)] = 26905,
  [SMALL_STATE(756)] = 27004,
  [SMALL_STATE(757)] = 27103,
  [SMALL_STATE(758)] = 27202,
  [SMALL_STATE(759)] = 27301,
  [SMALL_STATE(760)] = 27400,
  [SMALL_STATE(761)] = 27499,
  [SMALL_STATE(762)] = 27598,
  [SMALL_STATE(763)] = 27697,
  [SMALL_STATE(764)] = 27796,
  [SMALL_STATE(765)] = 27895,
  [SMALL_STATE(766)] = 27994,
  [SMALL_STATE(767)] = 28093,
  [SMALL_STATE(768)] = 28192,
  [SMALL_STATE(769)] = 28291,
  [SMALL_STATE(770)] = 28390,
  [SMALL_STATE(771)] = 28489,
  [SMALL_STATE(772)] = 28583,
  [SMALL_STATE(773)] = 28650,
  [SMALL_STATE(774)] = 28712,
  [SMALL_STATE(775)] = 28768,
  [SMALL_STATE(776)] = 28824,
  [SMALL_STATE(777)] = 28880,
  [SMALL_STATE(778)] = 28936,
  [SMALL_STATE(779)] = 28988,
  [SMALL_STATE(780)] = 29044,
  [SMALL_STATE(781)] = 29096,
  [SMALL_STATE(782)] = 29148,
  [SMALL_STATE(783)] = 29204,
  [SMALL_STATE(784)] = 29256,
  [SMALL_STATE(785)] = 29312,
  [SMALL_STATE(786)] = 29368,
  [SMALL_STATE(787)] = 29422,
  [SMALL_STATE(788)] = 29476,
  [SMALL_STATE(789)] = 29528,
  [SMALL_STATE(790)] = 29584,
  [SMALL_STATE(791)] = 29635,
  [SMALL_STATE(792)] = 29686,
  [SMALL_STATE(793)] = 29737,
  [SMALL_STATE(794)] = 29788,
  [SMALL_STATE(795)] = 29839,
  [SMALL_STATE(796)] = 29890,
  [SMALL_STATE(797)] = 29941,
  [SMALL_STATE(798)] = 29992,
  [SMALL_STATE(799)] = 30043,
  [SMALL_STATE(800)] = 30094,
  [SMALL_STATE(801)] = 30145,
  [SMALL_STATE(802)] = 30196,
  [SMALL_STATE(803)] = 30247,
  [SMALL_STATE(804)] = 30302,
  [SMALL_STATE(805)] = 30353,
  [SMALL_STATE(806)] = 30404,
  [SMALL_STATE(807)] = 30455,
  [SMALL_STATE(808)] = 30506,
  [SMALL_STATE(809)] = 30557,
  [SMALL_STATE(810)] = 30608,
  [SMALL_STATE(811)] = 30659,
  [SMALL_STATE(812)] = 30710,
  [SMALL_STATE(813)] = 30761,
  [SMALL_STATE(814)] = 30814,
  [SMALL_STATE(815)] = 30865,
  [SMALL_STATE(816)] = 30916,
  [SMALL_STATE(817)] = 30967,
  [SMALL_STATE(818)] = 31018,
  [SMALL_STATE(819)] = 31069,
  [SMALL_STATE(820)] = 31120,
  [SMALL_STATE(821)] = 31171,
  [SMALL_STATE(822)] = 31222,
  [SMALL_STATE(823)] = 31273,
  [SMALL_STATE(824)] = 31324,
  [SMALL_STATE(825)] = 31377,
  [SMALL_STATE(826)] = 31428,
  [SMALL_STATE(827)] = 31479,
  [SMALL_STATE(828)] = 31530,
  [SMALL_STATE(829)] = 31581,
  [SMALL_STATE(830)] = 31634,
  [SMALL_STATE(831)] = 31685,
  [SMALL_STATE(832)] = 31736,
  [SMALL_STATE(833)] = 31787,
  [SMALL_STATE(834)] = 31838,
  [SMALL_STATE(835)] = 31889,
  [SMALL_STATE(836)] = 31940,
  [SMALL_STATE(837)] = 32014,
  [SMALL_STATE(838)] = 32086,
  [SMALL_STATE(839)] = 32148,
  [SMALL_STATE(840)] = 32212,
  [SMALL_STATE(841)] = 32288,
  [SMALL_STATE(842)] = 32356,
  [SMALL_STATE(843)] = 32414,
  [SMALL_STATE(844)] = 32482,
  [SMALL_STATE(845)] = 32542,
  [SMALL_STATE(846)] = 32620,
  [SMALL_STATE(847)] = 32692,
  [SMALL_STATE(848)] = 32775,
  [SMALL_STATE(849)] = 32860,
  [SMALL_STATE(850)] = 32935,
  [SMALL_STATE(851)] = 33020,
  [SMALL_STATE(852)] = 33095,
  [SMALL_STATE(853)] = 33180,
  [SMALL_STATE(854)] = 33265,
  [SMALL_STATE(855)] = 33340,
  [SMALL_STATE(856)] = 33425,
  [SMALL_STATE(857)] = 33510,
  [SMALL_STATE(858)] = 33585,
  [SMALL_STATE(859)] = 33668,
  [SMALL_STATE(860)] = 33751,
  [SMALL_STATE(861)] = 33836,
  [SMALL_STATE(862)] = 33911,
  [SMALL_STATE(863)] = 33996,
  [SMALL_STATE(864)] = 34081,
  [SMALL_STATE(865)] = 34166,
  [SMALL_STATE(866)] = 34241,
  [SMALL_STATE(867)] = 34324,
  [SMALL_STATE(868)] = 34407,
  [SMALL_STATE(869)] = 34482,
  [SMALL_STATE(870)] = 34567,
  [SMALL_STATE(871)] = 34636,
  [SMALL_STATE(872)] = 34705,
  [SMALL_STATE(873)] = 34774,
  [SMALL_STATE(874)] = 34849,
  [SMALL_STATE(875)] = 34924,
  [SMALL_STATE(876)] = 34997,
  [SMALL_STATE(877)] = 35066,
  [SMALL_STATE(878)] = 35135,
  [SMALL_STATE(879)] = 35204,
  [SMALL_STATE(880)] = 35279,
  [SMALL_STATE(881)] = 35328,
  [SMALL_STATE(882)] = 35411,
  [SMALL_STATE(883)] = 35496,
  [SMALL_STATE(884)] = 35568,
  [SMALL_STATE(885)] = 35640,
  [SMALL_STATE(886)] = 35697,
  [SMALL_STATE(887)] = 35766,
  [SMALL_STATE(888)] = 35839,
  [SMALL_STATE(889)] = 35904,
  [SMALL_STATE(890)] = 35969,
  [SMALL_STATE(891)] = 36034,
  [SMALL_STATE(892)] = 36089,
  [SMALL_STATE(893)] = 36140,
  [SMALL_STATE(894)] = 36221,
  [SMALL_STATE(895)] = 36302,
  [SMALL_STATE(896)] = 36353,
  [SMALL_STATE(897)] = 36434,
  [SMALL_STATE(898)] = 36481,
  [SMALL_STATE(899)] = 36542,
  [SMALL_STATE(900)] = 36617,
  [SMALL_STATE(901)] = 36688,
  [SMALL_STATE(902)] = 36749,
  [SMALL_STATE(903)] = 36796,
  [SMALL_STATE(904)] = 36871,
  [SMALL_STATE(905)] = 36932,
  [SMALL_STATE(906)] = 37013,
  [SMALL_STATE(907)] = 37090,
  [SMALL_STATE(908)] = 37171,
  [SMALL_STATE(909)] = 37252,
  [SMALL_STATE(910)] = 37333,
  [SMALL_STATE(911)] = 37392,
  [SMALL_STATE(912)] = 37471,
  [SMALL_STATE(913)] = 37552,
  [SMALL_STATE(914)] = 37603,
  [SMALL_STATE(915)] = 37684,
  [SMALL_STATE(916)] = 37731,
  [SMALL_STATE(917)] = 37812,
  [SMALL_STATE(918)] = 37881,
  [SMALL_STATE(919)] = 37960,
  [SMALL_STATE(920)] = 38007,
  [SMALL_STATE(921)] = 38067,
  [SMALL_STATE(922)] = 38131,
  [SMALL_STATE(923)] = 38195,
  [SMALL_STATE(924)] = 38261,
  [SMALL_STATE(925)] = 38327,
  [SMALL_STATE(926)] = 38405,
  [SMALL_STATE(927)] = 38483,
  [SMALL_STATE(928)] = 38549,
  [SMALL_STATE(929)] = 38635,
  [SMALL_STATE(930)] = 38701,
  [SMALL_STATE(931)] = 38765,
  [SMALL_STATE(932)] = 38819,
  [SMALL_STATE(933)] = 38883,
  [SMALL_STATE(934)] = 38947,
  [SMALL_STATE(935)] = 39033,
  [SMALL_STATE(936)] = 39093,
  [SMALL_STATE(937)] = 39157,
  [SMALL_STATE(938)] = 39221,
  [SMALL_STATE(939)] = 39307,
  [SMALL_STATE(940)] = 39375,
  [SMALL_STATE(941)] = 39431,
  [SMALL_STATE(942)] = 39497,
  [SMALL_STATE(943)] = 39561,
  [SMALL_STATE(944)] = 39621,
  [SMALL_STATE(945)] = 39673,
  [SMALL_STATE(946)] = 39749,
  [SMALL_STATE(947)] = 39813,
  [SMALL_STATE(948)] = 39877,
  [SMALL_STATE(949)] = 39943,
  [SMALL_STATE(950)] = 40007,
  [SMALL_STATE(951)] = 40085,
  [SMALL_STATE(952)] = 40151,
  [SMALL_STATE(953)] = 40219,
  [SMALL_STATE(954)] = 40285,
  [SMALL_STATE(955)] = 40351,
  [SMALL_STATE(956)] = 40415,
  [SMALL_STATE(957)] = 40473,
  [SMALL_STATE(958)] = 40533,
  [SMALL_STATE(959)] = 40603,
  [SMALL_STATE(960)] = 40671,
  [SMALL_STATE(961)] = 40747,
  [SMALL_STATE(962)] = 40811,
  [SMALL_STATE(963)] = 40875,
  [SMALL_STATE(964)] = 40931,
  [SMALL_STATE(965)] = 41005,
  [SMALL_STATE(966)] = 41069,
  [SMALL_STATE(967)] = 41145,
  [SMALL_STATE(968)] = 41223,
  [SMALL_STATE(969)] = 41301,
  [SMALL_STATE(970)] = 41365,
  [SMALL_STATE(971)] = 41451,
  [SMALL_STATE(972)] = 41509,
  [SMALL_STATE(973)] = 41575,
  [SMALL_STATE(974)] = 41641,
  [SMALL_STATE(975)] = 41707,
  [SMALL_STATE(976)] = 41767,
  [SMALL_STATE(977)] = 41837,
  [SMALL_STATE(978)] = 41905,
  [SMALL_STATE(979)] = 41977,
  [SMALL_STATE(980)] = 42041,
  [SMALL_STATE(981)] = 42105,
  [SMALL_STATE(982)] = 42161,
  [SMALL_STATE(983)] = 42235,
  [SMALL_STATE(984)] = 42301,
  [SMALL_STATE(985)] = 42379,
  [SMALL_STATE(986)] = 42457,
  [SMALL_STATE(987)] = 42521,
  [SMALL_STATE(988)] = 42581,
  [SMALL_STATE(989)] = 42657,
  [SMALL_STATE(990)] = 42733,
  [SMALL_STATE(991)] = 42819,
  [SMALL_STATE(992)] = 42883,
  [SMALL_STATE(993)] = 42969,
  [SMALL_STATE(994)] = 43033,
  [SMALL_STATE(995)] = 43119,
  [SMALL_STATE(996)] = 43183,
  [SMALL_STATE(997)] = 43259,
  [SMALL_STATE(998)] = 43325,
  [SMALL_STATE(999)] = 43379,
  [SMALL_STATE(1000)] = 43451,
  [SMALL_STATE(1001)] = 43500,
  [SMALL_STATE(1002)] = 43573,
  [SMALL_STATE(1003)] = 43618,
  [SMALL_STATE(1004)] = 43665,
  [SMALL_STATE(1005)] = 43738,
  [SMALL_STATE(1006)] = 43813,
  [SMALL_STATE(1007)] = 43874,
  [SMALL_STATE(1008)] = 43947,
  [SMALL_STATE(1009)] = 44022,
  [SMALL_STATE(1010)] = 44095,
  [SMALL_STATE(1011)] = 44168,
  [SMALL_STATE(1012)] = 44243,
  [SMALL_STATE(1013)] = 44316,
  [SMALL_STATE(1014)] = 44363,
  [SMALL_STATE(1015)] = 44438,
  [SMALL_STATE(1016)] = 44513,
  [SMALL_STATE(1017)] = 44562,
  [SMALL_STATE(1018)] = 44607,
  [SMALL_STATE(1019)] = 44680,
  [SMALL_STATE(1020)] = 44753,
  [SMALL_STATE(1021)] = 44814,
  [SMALL_STATE(1022)] = 44859,
  [SMALL_STATE(1023)] = 44904,
  [SMALL_STATE(1024)] = 44949,
  [SMALL_STATE(1025)] = 44998,
  [SMALL_STATE(1026)] = 45043,
  [SMALL_STATE(1027)] = 45088,
  [SMALL_STATE(1028)] = 45133,
  [SMALL_STATE(1029)] = 45178,
  [SMALL_STATE(1030)] = 45227,
  [SMALL_STATE(1031)] = 45302,
  [SMALL_STATE(1032)] = 45353,
  [SMALL_STATE(1033)] = 45426,
  [SMALL_STATE(1034)] = 45477,
  [SMALL_STATE(1035)] = 45550,
  [SMALL_STATE(1036)] = 45623,
  [SMALL_STATE(1037)] = 45684,
  [SMALL_STATE(1038)] = 45756,
  [SMALL_STATE(1039)] = 45804,
  [SMALL_STATE(1040)] = 45876,
  [SMALL_STATE(1041)] = 45948,
  [SMALL_STATE(1042)] = 46020,
  [SMALL_STATE(1043)] = 46068,
  [SMALL_STATE(1044)] = 46116,
  [SMALL_STATE(1045)] = 46164,
  [SMALL_STATE(1046)] = 46212,
  [SMALL_STATE(1047)] = 46284,
  [SMALL_STATE(1048)] = 46356,
  [SMALL_STATE(1049)] = 46428,
  [SMALL_STATE(1050)] = 46474,
  [SMALL_STATE(1051)] = 46522,
  [SMALL_STATE(1052)] = 46570,
  [SMALL_STATE(1053)] = 46618,
  [SMALL_STATE(1054)] = 46666,
  [SMALL_STATE(1055)] = 46714,
  [SMALL_STATE(1056)] = 46786,
  [SMALL_STATE(1057)] = 46832,
  [SMALL_STATE(1058)] = 46880,
  [SMALL_STATE(1059)] = 46928,
  [SMALL_STATE(1060)] = 46976,
  [SMALL_STATE(1061)] = 47024,
  [SMALL_STATE(1062)] = 47096,
  [SMALL_STATE(1063)] = 47144,
  [SMALL_STATE(1064)] = 47192,
  [SMALL_STATE(1065)] = 47240,
  [SMALL_STATE(1066)] = 47288,
  [SMALL_STATE(1067)] = 47336,
  [SMALL_STATE(1068)] = 47384,
  [SMALL_STATE(1069)] = 47432,
  [SMALL_STATE(1070)] = 47480,
  [SMALL_STATE(1071)] = 47530,
  [SMALL_STATE(1072)] = 47576,
  [SMALL_STATE(1073)] = 47622,
  [SMALL_STATE(1074)] = 47668,
  [SMALL_STATE(1075)] = 47716,
  [SMALL_STATE(1076)] = 47774,
  [SMALL_STATE(1077)] = 47832,
  [SMALL_STATE(1078)] = 47880,
  [SMALL_STATE(1079)] = 47928,
  [SMALL_STATE(1080)] = 48000,
  [SMALL_STATE(1081)] = 48072,
  [SMALL_STATE(1082)] = 48116,
  [SMALL_STATE(1083)] = 48164,
  [SMALL_STATE(1084)] = 48212,
  [SMALL_STATE(1085)] = 48258,
  [SMALL_STATE(1086)] = 48304,
  [SMALL_STATE(1087)] = 48352,
  [SMALL_STATE(1088)] = 48424,
  [SMALL_STATE(1089)] = 48496,
  [SMALL_STATE(1090)] = 48542,
  [SMALL_STATE(1091)] = 48614,
  [SMALL_STATE(1092)] = 48660,
  [SMALL_STATE(1093)] = 48732,
  [SMALL_STATE(1094)] = 48780,
  [SMALL_STATE(1095)] = 48826,
  [SMALL_STATE(1096)] = 48884,
  [SMALL_STATE(1097)] = 48956,
  [SMALL_STATE(1098)] = 49028,
  [SMALL_STATE(1099)] = 49100,
  [SMALL_STATE(1100)] = 49146,
  [SMALL_STATE(1101)] = 49204,
  [SMALL_STATE(1102)] = 49262,
  [SMALL_STATE(1103)] = 49342,
  [SMALL_STATE(1104)] = 49414,
  [SMALL_STATE(1105)] = 49462,
  [SMALL_STATE(1106)] = 49520,
  [SMALL_STATE(1107)] = 49592,
  [SMALL_STATE(1108)] = 49640,
  [SMALL_STATE(1109)] = 49688,
  [SMALL_STATE(1110)] = 49736,
  [SMALL_STATE(1111)] = 49816,
  [SMALL_STATE(1112)] = 49888,
  [SMALL_STATE(1113)] = 49934,
  [SMALL_STATE(1114)] = 50014,
  [SMALL_STATE(1115)] = 50094,
  [SMALL_STATE(1116)] = 50174,
  [SMALL_STATE(1117)] = 50254,
  [SMALL_STATE(1118)] = 50300,
  [SMALL_STATE(1119)] = 50380,
  [SMALL_STATE(1120)] = 50428,
  [SMALL_STATE(1121)] = 50476,
  [SMALL_STATE(1122)] = 50548,
  [SMALL_STATE(1123)] = 50620,
  [SMALL_STATE(1124)] = 50668,
  [SMALL_STATE(1125)] = 50714,
  [SMALL_STATE(1126)] = 50762,
  [SMALL_STATE(1127)] = 50810,
  [SMALL_STATE(1128)] = 50853,
  [SMALL_STATE(1129)] = 50896,
  [SMALL_STATE(1130)] = 50939,
  [SMALL_STATE(1131)] = 50990,
  [SMALL_STATE(1132)] = 51033,
  [SMALL_STATE(1133)] = 51076,
  [SMALL_STATE(1134)] = 51121,
  [SMALL_STATE(1135)] = 51164,
  [SMALL_STATE(1136)] = 51207,
  [SMALL_STATE(1137)] = 51254,
  [SMALL_STATE(1138)] = 51323,
  [SMALL_STATE(1139)] = 51368,
  [SMALL_STATE(1140)] = 51413,
  [SMALL_STATE(1141)] = 51456,
  [SMALL_STATE(1142)] = 51503,
  [SMALL_STATE(1143)] = 51546,
  [SMALL_STATE(1144)] = 51589,
  [SMALL_STATE(1145)] = 51632,
  [SMALL_STATE(1146)] = 51675,
  [SMALL_STATE(1147)] = 51718,
  [SMALL_STATE(1148)] = 51761,
  [SMALL_STATE(1149)] = 51804,
  [SMALL_STATE(1150)] = 51847,
  [SMALL_STATE(1151)] = 51890,
  [SMALL_STATE(1152)] = 51935,
  [SMALL_STATE(1153)] = 51982,
  [SMALL_STATE(1154)] = 52031,
  [SMALL_STATE(1155)] = 52074,
  [SMALL_STATE(1156)] = 52143,
  [SMALL_STATE(1157)] = 52186,
  [SMALL_STATE(1158)] = 52229,
  [SMALL_STATE(1159)] = 52272,
  [SMALL_STATE(1160)] = 52316,
  [SMALL_STATE(1161)] = 52360,
  [SMALL_STATE(1162)] = 52404,
  [SMALL_STATE(1163)] = 52446,
  [SMALL_STATE(1164)] = 52488,
  [SMALL_STATE(1165)] = 52532,
  [SMALL_STATE(1166)] = 52574,
  [SMALL_STATE(1167)] = 52618,
  [SMALL_STATE(1168)] = 52660,
  [SMALL_STATE(1169)] = 52708,
  [SMALL_STATE(1170)] = 52752,
  [SMALL_STATE(1171)] = 52800,
  [SMALL_STATE(1172)] = 52850,
  [SMALL_STATE(1173)] = 52904,
  [SMALL_STATE(1174)] = 52948,
  [SMALL_STATE(1175)] = 52992,
  [SMALL_STATE(1176)] = 53034,
  [SMALL_STATE(1177)] = 53076,
  [SMALL_STATE(1178)] = 53132,
  [SMALL_STATE(1179)] = 53174,
  [SMALL_STATE(1180)] = 53216,
  [SMALL_STATE(1181)] = 53290,
  [SMALL_STATE(1182)] = 53332,
  [SMALL_STATE(1183)] = 53374,
  [SMALL_STATE(1184)] = 53448,
  [SMALL_STATE(1185)] = 53492,
  [SMALL_STATE(1186)] = 53534,
  [SMALL_STATE(1187)] = 53578,
  [SMALL_STATE(1188)] = 53620,
  [SMALL_STATE(1189)] = 53676,
  [SMALL_STATE(1190)] = 53718,
  [SMALL_STATE(1191)] = 53792,
  [SMALL_STATE(1192)] = 53834,
  [SMALL_STATE(1193)] = 53876,
  [SMALL_STATE(1194)] = 53918,
  [SMALL_STATE(1195)] = 53992,
  [SMALL_STATE(1196)] = 54036,
  [SMALL_STATE(1197)] = 54084,
  [SMALL_STATE(1198)] = 54126,
  [SMALL_STATE(1199)] = 54200,
  [SMALL_STATE(1200)] = 54242,
  [SMALL_STATE(1201)] = 54316,
  [SMALL_STATE(1202)] = 54390,
  [SMALL_STATE(1203)] = 54464,
  [SMALL_STATE(1204)] = 54508,
  [SMALL_STATE(1205)] = 54582,
  [SMALL_STATE(1206)] = 54630,
  [SMALL_STATE(1207)] = 54674,
  [SMALL_STATE(1208)] = 54716,
  [SMALL_STATE(1209)] = 54758,
  [SMALL_STATE(1210)] = 54814,
  [SMALL_STATE(1211)] = 54888,
  [SMALL_STATE(1212)] = 54930,
  [SMALL_STATE(1213)] = 55004,
  [SMALL_STATE(1214)] = 55046,
  [SMALL_STATE(1215)] = 55120,
  [SMALL_STATE(1216)] = 55194,
  [SMALL_STATE(1217)] = 55250,
  [SMALL_STATE(1218)] = 55292,
  [SMALL_STATE(1219)] = 55336,
  [SMALL_STATE(1220)] = 55410,
  [SMALL_STATE(1221)] = 55466,
  [SMALL_STATE(1222)] = 55522,
  [SMALL_STATE(1223)] = 55566,
  [SMALL_STATE(1224)] = 55608,
  [SMALL_STATE(1225)] = 55679,
  [SMALL_STATE(1226)] = 55750,
  [SMALL_STATE(1227)] = 55821,
  [SMALL_STATE(1228)] = 55866,
  [SMALL_STATE(1229)] = 55909,
  [SMALL_STATE(1230)] = 55962,
  [SMALL_STATE(1231)] = 56033,
  [SMALL_STATE(1232)] = 56104,
  [SMALL_STATE(1233)] = 56149,
  [SMALL_STATE(1234)] = 56192,
  [SMALL_STATE(1235)] = 56263,
  [SMALL_STATE(1236)] = 56316,
  [SMALL_STATE(1237)] = 56369,
  [SMALL_STATE(1238)] = 56422,
  [SMALL_STATE(1239)] = 56475,
  [SMALL_STATE(1240)] = 56528,
  [SMALL_STATE(1241)] = 56581,
  [SMALL_STATE(1242)] = 56652,
  [SMALL_STATE(1243)] = 56705,
  [SMALL_STATE(1244)] = 56758,
  [SMALL_STATE(1245)] = 56811,
  [SMALL_STATE(1246)] = 56882,
  [SMALL_STATE(1247)] = 56953,
  [SMALL_STATE(1248)] = 57006,
  [SMALL_STATE(1249)] = 57059,
  [SMALL_STATE(1250)] = 57112,
  [SMALL_STATE(1251)] = 57183,
  [SMALL_STATE(1252)] = 57254,
  [SMALL_STATE(1253)] = 57325,
  [SMALL_STATE(1254)] = 57396,
  [SMALL_STATE(1255)] = 57467,
  [SMALL_STATE(1256)] = 57538,
  [SMALL_STATE(1257)] = 57609,
  [SMALL_STATE(1258)] = 57662,
  [SMALL_STATE(1259)] = 57715,
  [SMALL_STATE(1260)] = 57768,
  [SMALL_STATE(1261)] = 57821,
  [SMALL_STATE(1262)] = 57864,
  [SMALL_STATE(1263)] = 57935,
  [SMALL_STATE(1264)] = 57980,
  [SMALL_STATE(1265)] = 58051,
  [SMALL_STATE(1266)] = 58122,
  [SMALL_STATE(1267)] = 58165,
  [SMALL_STATE(1268)] = 58236,
  [SMALL_STATE(1269)] = 58307,
  [SMALL_STATE(1270)] = 58378,
  [SMALL_STATE(1271)] = 58449,
  [SMALL_STATE(1272)] = 58520,
  [SMALL_STATE(1273)] = 58573,
  [SMALL_STATE(1274)] = 58614,
  [SMALL_STATE(1275)] = 58667,
  [SMALL_STATE(1276)] = 58720,
  [SMALL_STATE(1277)] = 58773,
  [SMALL_STATE(1278)] = 58844,
  [SMALL_STATE(1279)] = 58915,
  [SMALL_STATE(1280)] = 58986,
  [SMALL_STATE(1281)] = 59057,
  [SMALL_STATE(1282)] = 59128,
  [SMALL_STATE(1283)] = 59199,
  [SMALL_STATE(1284)] = 59270,
  [SMALL_STATE(1285)] = 59323,
  [SMALL_STATE(1286)] = 59366,
  [SMALL_STATE(1287)] = 59419,
  [SMALL_STATE(1288)] = 59490,
  [SMALL_STATE(1289)] = 59561,
  [SMALL_STATE(1290)] = 59614,
  [SMALL_STATE(1291)] = 59685,
  [SMALL_STATE(1292)] = 59738,
  [SMALL_STATE(1293)] = 59791,
  [SMALL_STATE(1294)] = 59844,
  [SMALL_STATE(1295)] = 59915,
  [SMALL_STATE(1296)] = 59986,
  [SMALL_STATE(1297)] = 60029,
  [SMALL_STATE(1298)] = 60100,
  [SMALL_STATE(1299)] = 60171,
  [SMALL_STATE(1300)] = 60242,
  [SMALL_STATE(1301)] = 60295,
  [SMALL_STATE(1302)] = 60366,
  [SMALL_STATE(1303)] = 60437,
  [SMALL_STATE(1304)] = 60508,
  [SMALL_STATE(1305)] = 60579,
  [SMALL_STATE(1306)] = 60650,
  [SMALL_STATE(1307)] = 60703,
  [SMALL_STATE(1308)] = 60744,
  [SMALL_STATE(1309)] = 60797,
  [SMALL_STATE(1310)] = 60868,
  [SMALL_STATE(1311)] = 60939,
  [SMALL_STATE(1312)] = 61010,
  [SMALL_STATE(1313)] = 61057,
  [SMALL_STATE(1314)] = 61128,
  [SMALL_STATE(1315)] = 61181,
  [SMALL_STATE(1316)] = 61252,
  [SMALL_STATE(1317)] = 61323,
  [SMALL_STATE(1318)] = 61394,
  [SMALL_STATE(1319)] = 61465,
  [SMALL_STATE(1320)] = 61510,
  [SMALL_STATE(1321)] = 61581,
  [SMALL_STATE(1322)] = 61634,
  [SMALL_STATE(1323)] = 61705,
  [SMALL_STATE(1324)] = 61758,
  [SMALL_STATE(1325)] = 61803,
  [SMALL_STATE(1326)] = 61874,
  [SMALL_STATE(1327)] = 61917,
  [SMALL_STATE(1328)] = 61962,
  [SMALL_STATE(1329)] = 62033,
  [SMALL_STATE(1330)] = 62074,
  [SMALL_STATE(1331)] = 62117,
  [SMALL_STATE(1332)] = 62162,
  [SMALL_STATE(1333)] = 62215,
  [SMALL_STATE(1334)] = 62265,
  [SMALL_STATE(1335)] = 62309,
  [SMALL_STATE(1336)] = 62359,
  [SMALL_STATE(1337)] = 62409,
  [SMALL_STATE(1338)] = 62459,
  [SMALL_STATE(1339)] = 62509,
  [SMALL_STATE(1340)] = 62549,
  [SMALL_STATE(1341)] = 62589,
  [SMALL_STATE(1342)] = 62629,
  [SMALL_STATE(1343)] = 62669,
  [SMALL_STATE(1344)] = 62719,
  [SMALL_STATE(1345)] = 62769,
  [SMALL_STATE(1346)] = 62819,
  [SMALL_STATE(1347)] = 62869,
  [SMALL_STATE(1348)] = 62919,
  [SMALL_STATE(1349)] = 62969,
  [SMALL_STATE(1350)] = 63019,
  [SMALL_STATE(1351)] = 63069,
  [SMALL_STATE(1352)] = 63119,
  [SMALL_STATE(1353)] = 63169,
  [SMALL_STATE(1354)] = 63211,
  [SMALL_STATE(1355)] = 63261,
  [SMALL_STATE(1356)] = 63311,
  [SMALL_STATE(1357)] = 63361,
  [SMALL_STATE(1358)] = 63411,
  [SMALL_STATE(1359)] = 63461,
  [SMALL_STATE(1360)] = 63511,
  [SMALL_STATE(1361)] = 63561,
  [SMALL_STATE(1362)] = 63611,
  [SMALL_STATE(1363)] = 63661,
  [SMALL_STATE(1364)] = 63711,
  [SMALL_STATE(1365)] = 63761,
  [SMALL_STATE(1366)] = 63811,
  [SMALL_STATE(1367)] = 63861,
  [SMALL_STATE(1368)] = 63911,
  [SMALL_STATE(1369)] = 63961,
  [SMALL_STATE(1370)] = 64017,
  [SMALL_STATE(1371)] = 64067,
  [SMALL_STATE(1372)] = 64115,
  [SMALL_STATE(1373)] = 64165,
  [SMALL_STATE(1374)] = 64215,
  [SMALL_STATE(1375)] = 64265,
  [SMALL_STATE(1376)] = 64315,
  [SMALL_STATE(1377)] = 64377,
  [SMALL_STATE(1378)] = 64427,
  [SMALL_STATE(1379)] = 64477,
  [SMALL_STATE(1380)] = 64527,
  [SMALL_STATE(1381)] = 64577,
  [SMALL_STATE(1382)] = 64627,
  [SMALL_STATE(1383)] = 64677,
  [SMALL_STATE(1384)] = 64719,
  [SMALL_STATE(1385)] = 64769,
  [SMALL_STATE(1386)] = 64819,
  [SMALL_STATE(1387)] = 64869,
  [SMALL_STATE(1388)] = 64919,
  [SMALL_STATE(1389)] = 64969,
  [SMALL_STATE(1390)] = 65019,
  [SMALL_STATE(1391)] = 65069,
  [SMALL_STATE(1392)] = 65119,
  [SMALL_STATE(1393)] = 65169,
  [SMALL_STATE(1394)] = 65219,
  [SMALL_STATE(1395)] = 65269,
  [SMALL_STATE(1396)] = 65319,
  [SMALL_STATE(1397)] = 65369,
  [SMALL_STATE(1398)] = 65419,
  [SMALL_STATE(1399)] = 65469,
  [SMALL_STATE(1400)] = 65519,
  [SMALL_STATE(1401)] = 65569,
  [SMALL_STATE(1402)] = 65619,
  [SMALL_STATE(1403)] = 65669,
  [SMALL_STATE(1404)] = 65729,
  [SMALL_STATE(1405)] = 65779,
  [SMALL_STATE(1406)] = 65829,
  [SMALL_STATE(1407)] = 65879,
  [SMALL_STATE(1408)] = 65929,
  [SMALL_STATE(1409)] = 65979,
  [SMALL_STATE(1410)] = 66029,
  [SMALL_STATE(1411)] = 66073,
  [SMALL_STATE(1412)] = 66123,
  [SMALL_STATE(1413)] = 66173,
  [SMALL_STATE(1414)] = 66223,
  [SMALL_STATE(1415)] = 66273,
  [SMALL_STATE(1416)] = 66323,
  [SMALL_STATE(1417)] = 66373,
  [SMALL_STATE(1418)] = 66423,
  [SMALL_STATE(1419)] = 66473,
  [SMALL_STATE(1420)] = 66523,
  [SMALL_STATE(1421)] = 66573,
  [SMALL_STATE(1422)] = 66623,
  [SMALL_STATE(1423)] = 66673,
  [SMALL_STATE(1424)] = 66723,
  [SMALL_STATE(1425)] = 66773,
  [SMALL_STATE(1426)] = 66823,
  [SMALL_STATE(1427)] = 66863,
  [SMALL_STATE(1428)] = 66913,
  [SMALL_STATE(1429)] = 66963,
  [SMALL_STATE(1430)] = 67013,
  [SMALL_STATE(1431)] = 67063,
  [SMALL_STATE(1432)] = 67113,
  [SMALL_STATE(1433)] = 67163,
  [SMALL_STATE(1434)] = 67203,
  [SMALL_STATE(1435)] = 67243,
  [SMALL_STATE(1436)] = 67293,
  [SMALL_STATE(1437)] = 67343,
  [SMALL_STATE(1438)] = 67383,
  [SMALL_STATE(1439)] = 67433,
  [SMALL_STATE(1440)] = 67483,
  [SMALL_STATE(1441)] = 67533,
  [SMALL_STATE(1442)] = 67583,
  [SMALL_STATE(1443)] = 67623,
  [SMALL_STATE(1444)] = 67673,
  [SMALL_STATE(1445)] = 67723,
  [SMALL_STATE(1446)] = 67775,
  [SMALL_STATE(1447)] = 67825,
  [SMALL_STATE(1448)] = 67875,
  [SMALL_STATE(1449)] = 67925,
  [SMALL_STATE(1450)] = 67975,
  [SMALL_STATE(1451)] = 68025,
  [SMALL_STATE(1452)] = 68072,
  [SMALL_STATE(1453)] = 68119,
  [SMALL_STATE(1454)] = 68166,
  [SMALL_STATE(1455)] = 68213,
  [SMALL_STATE(1456)] = 68260,
  [SMALL_STATE(1457)] = 68307,
  [SMALL_STATE(1458)] = 68346,
  [SMALL_STATE(1459)] = 68385,
  [SMALL_STATE(1460)] = 68424,
  [SMALL_STATE(1461)] = 68471,
  [SMALL_STATE(1462)] = 68518,
  [SMALL_STATE(1463)] = 68565,
  [SMALL_STATE(1464)] = 68612,
  [SMALL_STATE(1465)] = 68659,
  [SMALL_STATE(1466)] = 68706,
  [SMALL_STATE(1467)] = 68749,
  [SMALL_STATE(1468)] = 68796,
  [SMALL_STATE(1469)] = 68843,
  [SMALL_STATE(1470)] = 68890,
  [SMALL_STATE(1471)] = 68937,
  [SMALL_STATE(1472)] = 68984,
  [SMALL_STATE(1473)] = 69031,
  [SMALL_STATE(1474)] = 69070,
  [SMALL_STATE(1475)] = 69117,
  [SMALL_STATE(1476)] = 69164,
  [SMALL_STATE(1477)] = 69211,
  [SMALL_STATE(1478)] = 69258,
  [SMALL_STATE(1479)] = 69305,
  [SMALL_STATE(1480)] = 69344,
  [SMALL_STATE(1481)] = 69391,
  [SMALL_STATE(1482)] = 69432,
  [SMALL_STATE(1483)] = 69479,
  [SMALL_STATE(1484)] = 69518,
  [SMALL_STATE(1485)] = 69565,
  [SMALL_STATE(1486)] = 69612,
  [SMALL_STATE(1487)] = 69655,
  [SMALL_STATE(1488)] = 69702,
  [SMALL_STATE(1489)] = 69749,
  [SMALL_STATE(1490)] = 69796,
  [SMALL_STATE(1491)] = 69843,
  [SMALL_STATE(1492)] = 69890,
  [SMALL_STATE(1493)] = 69937,
  [SMALL_STATE(1494)] = 69976,
  [SMALL_STATE(1495)] = 70023,
  [SMALL_STATE(1496)] = 70070,
  [SMALL_STATE(1497)] = 70117,
  [SMALL_STATE(1498)] = 70164,
  [SMALL_STATE(1499)] = 70211,
  [SMALL_STATE(1500)] = 70258,
  [SMALL_STATE(1501)] = 70305,
  [SMALL_STATE(1502)] = 70352,
  [SMALL_STATE(1503)] = 70399,
  [SMALL_STATE(1504)] = 70446,
  [SMALL_STATE(1505)] = 70493,
  [SMALL_STATE(1506)] = 70540,
  [SMALL_STATE(1507)] = 70587,
  [SMALL_STATE(1508)] = 70634,
  [SMALL_STATE(1509)] = 70681,
  [SMALL_STATE(1510)] = 70728,
  [SMALL_STATE(1511)] = 70775,
  [SMALL_STATE(1512)] = 70822,
  [SMALL_STATE(1513)] = 70869,
  [SMALL_STATE(1514)] = 70916,
  [SMALL_STATE(1515)] = 70963,
  [SMALL_STATE(1516)] = 71010,
  [SMALL_STATE(1517)] = 71057,
  [SMALL_STATE(1518)] = 71104,
  [SMALL_STATE(1519)] = 71143,
  [SMALL_STATE(1520)] = 71190,
  [SMALL_STATE(1521)] = 71237,
  [SMALL_STATE(1522)] = 71284,
  [SMALL_STATE(1523)] = 71331,
  [SMALL_STATE(1524)] = 71378,
  [SMALL_STATE(1525)] = 71422,
  [SMALL_STATE(1526)] = 71466,
  [SMALL_STATE(1527)] = 71510,
  [SMALL_STATE(1528)] = 71550,
  [SMALL_STATE(1529)] = 71588,
  [SMALL_STATE(1530)] = 71632,
  [SMALL_STATE(1531)] = 71676,
  [SMALL_STATE(1532)] = 71720,
  [SMALL_STATE(1533)] = 71764,
  [SMALL_STATE(1534)] = 71808,
  [SMALL_STATE(1535)] = 71852,
  [SMALL_STATE(1536)] = 71890,
  [SMALL_STATE(1537)] = 71934,
  [SMALL_STATE(1538)] = 71978,
  [SMALL_STATE(1539)] = 72022,
  [SMALL_STATE(1540)] = 72066,
  [SMALL_STATE(1541)] = 72110,
  [SMALL_STATE(1542)] = 72154,
  [SMALL_STATE(1543)] = 72198,
  [SMALL_STATE(1544)] = 72242,
  [SMALL_STATE(1545)] = 72280,
  [SMALL_STATE(1546)] = 72324,
  [SMALL_STATE(1547)] = 72368,
  [SMALL_STATE(1548)] = 72412,
  [SMALL_STATE(1549)] = 72456,
  [SMALL_STATE(1550)] = 72494,
  [SMALL_STATE(1551)] = 72538,
  [SMALL_STATE(1552)] = 72582,
  [SMALL_STATE(1553)] = 72626,
  [SMALL_STATE(1554)] = 72670,
  [SMALL_STATE(1555)] = 72714,
  [SMALL_STATE(1556)] = 72752,
  [SMALL_STATE(1557)] = 72810,
  [SMALL_STATE(1558)] = 72854,
  [SMALL_STATE(1559)] = 72892,
  [SMALL_STATE(1560)] = 72936,
  [SMALL_STATE(1561)] = 72973,
  [SMALL_STATE(1562)] = 73010,
  [SMALL_STATE(1563)] = 73047,
  [SMALL_STATE(1564)] = 73084,
  [SMALL_STATE(1565)] = 73120,
  [SMALL_STATE(1566)] = 73156,
  [SMALL_STATE(1567)] = 73192,
  [SMALL_STATE(1568)] = 73228,
  [SMALL_STATE(1569)] = 73264,
  [SMALL_STATE(1570)] = 73300,
  [SMALL_STATE(1571)] = 73336,
  [SMALL_STATE(1572)] = 73372,
  [SMALL_STATE(1573)] = 73408,
  [SMALL_STATE(1574)] = 73444,
  [SMALL_STATE(1575)] = 73480,
  [SMALL_STATE(1576)] = 73516,
  [SMALL_STATE(1577)] = 73552,
  [SMALL_STATE(1578)] = 73588,
  [SMALL_STATE(1579)] = 73624,
  [SMALL_STATE(1580)] = 73660,
  [SMALL_STATE(1581)] = 73696,
  [SMALL_STATE(1582)] = 73732,
  [SMALL_STATE(1583)] = 73768,
  [SMALL_STATE(1584)] = 73804,
  [SMALL_STATE(1585)] = 73840,
  [SMALL_STATE(1586)] = 73876,
  [SMALL_STATE(1587)] = 73912,
  [SMALL_STATE(1588)] = 73948,
  [SMALL_STATE(1589)] = 73984,
  [SMALL_STATE(1590)] = 74020,
  [SMALL_STATE(1591)] = 74056,
  [SMALL_STATE(1592)] = 74092,
  [SMALL_STATE(1593)] = 74128,
  [SMALL_STATE(1594)] = 74164,
  [SMALL_STATE(1595)] = 74200,
  [SMALL_STATE(1596)] = 74236,
  [SMALL_STATE(1597)] = 74272,
  [SMALL_STATE(1598)] = 74308,
  [SMALL_STATE(1599)] = 74344,
  [SMALL_STATE(1600)] = 74380,
  [SMALL_STATE(1601)] = 74416,
  [SMALL_STATE(1602)] = 74452,
  [SMALL_STATE(1603)] = 74488,
  [SMALL_STATE(1604)] = 74524,
  [SMALL_STATE(1605)] = 74560,
  [SMALL_STATE(1606)] = 74596,
  [SMALL_STATE(1607)] = 74632,
  [SMALL_STATE(1608)] = 74668,
  [SMALL_STATE(1609)] = 74704,
  [SMALL_STATE(1610)] = 74740,
  [SMALL_STATE(1611)] = 74776,
  [SMALL_STATE(1612)] = 74812,
  [SMALL_STATE(1613)] = 74848,
  [SMALL_STATE(1614)] = 74884,
  [SMALL_STATE(1615)] = 74920,
  [SMALL_STATE(1616)] = 74956,
  [SMALL_STATE(1617)] = 74992,
  [SMALL_STATE(1618)] = 75028,
  [SMALL_STATE(1619)] = 75064,
  [SMALL_STATE(1620)] = 75100,
  [SMALL_STATE(1621)] = 75136,
  [SMALL_STATE(1622)] = 75172,
  [SMALL_STATE(1623)] = 75208,
  [SMALL_STATE(1624)] = 75244,
  [SMALL_STATE(1625)] = 75280,
  [SMALL_STATE(1626)] = 75316,
  [SMALL_STATE(1627)] = 75352,
  [SMALL_STATE(1628)] = 75388,
  [SMALL_STATE(1629)] = 75424,
  [SMALL_STATE(1630)] = 75460,
  [SMALL_STATE(1631)] = 75496,
  [SMALL_STATE(1632)] = 75532,
  [SMALL_STATE(1633)] = 75568,
  [SMALL_STATE(1634)] = 75604,
  [SMALL_STATE(1635)] = 75640,
  [SMALL_STATE(1636)] = 75676,
  [SMALL_STATE(1637)] = 75712,
  [SMALL_STATE(1638)] = 75748,
  [SMALL_STATE(1639)] = 75784,
  [SMALL_STATE(1640)] = 75820,
  [SMALL_STATE(1641)] = 75856,
  [SMALL_STATE(1642)] = 75892,
  [SMALL_STATE(1643)] = 75928,
  [SMALL_STATE(1644)] = 75964,
  [SMALL_STATE(1645)] = 76000,
  [SMALL_STATE(1646)] = 76036,
  [SMALL_STATE(1647)] = 76072,
  [SMALL_STATE(1648)] = 76108,
  [SMALL_STATE(1649)] = 76144,
  [SMALL_STATE(1650)] = 76180,
  [SMALL_STATE(1651)] = 76216,
  [SMALL_STATE(1652)] = 76252,
  [SMALL_STATE(1653)] = 76288,
  [SMALL_STATE(1654)] = 76324,
  [SMALL_STATE(1655)] = 76360,
  [SMALL_STATE(1656)] = 76396,
  [SMALL_STATE(1657)] = 76432,
  [SMALL_STATE(1658)] = 76468,
  [SMALL_STATE(1659)] = 76504,
  [SMALL_STATE(1660)] = 76540,
  [SMALL_STATE(1661)] = 76576,
  [SMALL_STATE(1662)] = 76612,
  [SMALL_STATE(1663)] = 76648,
  [SMALL_STATE(1664)] = 76684,
  [SMALL_STATE(1665)] = 76720,
  [SMALL_STATE(1666)] = 76756,
  [SMALL_STATE(1667)] = 76792,
  [SMALL_STATE(1668)] = 76828,
  [SMALL_STATE(1669)] = 76864,
  [SMALL_STATE(1670)] = 76900,
  [SMALL_STATE(1671)] = 76936,
  [SMALL_STATE(1672)] = 76972,
  [SMALL_STATE(1673)] = 77008,
  [SMALL_STATE(1674)] = 77044,
  [SMALL_STATE(1675)] = 77080,
  [SMALL_STATE(1676)] = 77116,
  [SMALL_STATE(1677)] = 77152,
  [SMALL_STATE(1678)] = 77188,
  [SMALL_STATE(1679)] = 77224,
  [SMALL_STATE(1680)] = 77260,
  [SMALL_STATE(1681)] = 77296,
  [SMALL_STATE(1682)] = 77332,
  [SMALL_STATE(1683)] = 77368,
  [SMALL_STATE(1684)] = 77404,
  [SMALL_STATE(1685)] = 77440,
  [SMALL_STATE(1686)] = 77476,
  [SMALL_STATE(1687)] = 77512,
  [SMALL_STATE(1688)] = 77548,
  [SMALL_STATE(1689)] = 77584,
  [SMALL_STATE(1690)] = 77620,
  [SMALL_STATE(1691)] = 77656,
  [SMALL_STATE(1692)] = 77692,
  [SMALL_STATE(1693)] = 77728,
  [SMALL_STATE(1694)] = 77764,
  [SMALL_STATE(1695)] = 77800,
  [SMALL_STATE(1696)] = 77836,
  [SMALL_STATE(1697)] = 77872,
  [SMALL_STATE(1698)] = 77908,
  [SMALL_STATE(1699)] = 77944,
  [SMALL_STATE(1700)] = 77980,
  [SMALL_STATE(1701)] = 78016,
  [SMALL_STATE(1702)] = 78052,
  [SMALL_STATE(1703)] = 78088,
  [SMALL_STATE(1704)] = 78124,
  [SMALL_STATE(1705)] = 78160,
  [SMALL_STATE(1706)] = 78196,
  [SMALL_STATE(1707)] = 78232,
  [SMALL_STATE(1708)] = 78268,
  [SMALL_STATE(1709)] = 78304,
  [SMALL_STATE(1710)] = 78340,
  [SMALL_STATE(1711)] = 78376,
  [SMALL_STATE(1712)] = 78412,
  [SMALL_STATE(1713)] = 78448,
  [SMALL_STATE(1714)] = 78484,
  [SMALL_STATE(1715)] = 78520,
  [SMALL_STATE(1716)] = 78557,
  [SMALL_STATE(1717)] = 78592,
  [SMALL_STATE(1718)] = 78627,
  [SMALL_STATE(1719)] = 78662,
  [SMALL_STATE(1720)] = 78699,
  [SMALL_STATE(1721)] = 78734,
  [SMALL_STATE(1722)] = 78771,
  [SMALL_STATE(1723)] = 78805,
  [SMALL_STATE(1724)] = 78839,
  [SMALL_STATE(1725)] = 78873,
  [SMALL_STATE(1726)] = 78907,
  [SMALL_STATE(1727)] = 78941,
  [SMALL_STATE(1728)] = 78975,
  [SMALL_STATE(1729)] = 79009,
  [SMALL_STATE(1730)] = 79043,
  [SMALL_STATE(1731)] = 79077,
  [SMALL_STATE(1732)] = 79111,
  [SMALL_STATE(1733)] = 79145,
  [SMALL_STATE(1734)] = 79176,
  [SMALL_STATE(1735)] = 79224,
  [SMALL_STATE(1736)] = 79274,
  [SMALL_STATE(1737)] = 79316,
  [SMALL_STATE(1738)] = 79366,
  [SMALL_STATE(1739)] = 79416,
  [SMALL_STATE(1740)] = 79466,
  [SMALL_STATE(1741)] = 79502,
  [SMALL_STATE(1742)] = 79538,
  [SMALL_STATE(1743)] = 79578,
  [SMALL_STATE(1744)] = 79614,
  [SMALL_STATE(1745)] = 79646,
  [SMALL_STATE(1746)] = 79690,
  [SMALL_STATE(1747)] = 79726,
  [SMALL_STATE(1748)] = 79760,
  [SMALL_STATE(1749)] = 79796,
  [SMALL_STATE(1750)] = 79824,
  [SMALL_STATE(1751)] = 79853,
  [SMALL_STATE(1752)] = 79882,
  [SMALL_STATE(1753)] = 79911,
  [SMALL_STATE(1754)] = 79936,
  [SMALL_STATE(1755)] = 79965,
  [SMALL_STATE(1756)] = 79994,
  [SMALL_STATE(1757)] = 80023,
  [SMALL_STATE(1758)] = 80060,
  [SMALL_STATE(1759)] = 80089,
  [SMALL_STATE(1760)] = 80118,
  [SMALL_STATE(1761)] = 80143,
  [SMALL_STATE(1762)] = 80172,
  [SMALL_STATE(1763)] = 80201,
  [SMALL_STATE(1764)] = 80230,
  [SMALL_STATE(1765)] = 80259,
  [SMALL_STATE(1766)] = 80300,
  [SMALL_STATE(1767)] = 80329,
  [SMALL_STATE(1768)] = 80356,
  [SMALL_STATE(1769)] = 80385,
  [SMALL_STATE(1770)] = 80414,
  [SMALL_STATE(1771)] = 80443,
  [SMALL_STATE(1772)] = 80472,
  [SMALL_STATE(1773)] = 80501,
  [SMALL_STATE(1774)] = 80530,
  [SMALL_STATE(1775)] = 80567,
  [SMALL_STATE(1776)] = 80608,
  [SMALL_STATE(1777)] = 80637,
  [SMALL_STATE(1778)] = 80666,
  [SMALL_STATE(1779)] = 80703,
  [SMALL_STATE(1780)] = 80732,
  [SMALL_STATE(1781)] = 80761,
  [SMALL_STATE(1782)] = 80790,
  [SMALL_STATE(1783)] = 80819,
  [SMALL_STATE(1784)] = 80848,
  [SMALL_STATE(1785)] = 80875,
  [SMALL_STATE(1786)] = 80904,
  [SMALL_STATE(1787)] = 80933,
  [SMALL_STATE(1788)] = 80974,
  [SMALL_STATE(1789)] = 81015,
  [SMALL_STATE(1790)] = 81044,
  [SMALL_STATE(1791)] = 81068,
  [SMALL_STATE(1792)] = 81098,
  [SMALL_STATE(1793)] = 81136,
  [SMALL_STATE(1794)] = 81172,
  [SMALL_STATE(1795)] = 81198,
  [SMALL_STATE(1796)] = 81224,
  [SMALL_STATE(1797)] = 81250,
  [SMALL_STATE(1798)] = 81276,
  [SMALL_STATE(1799)] = 81314,
  [SMALL_STATE(1800)] = 81340,
  [SMALL_STATE(1801)] = 81366,
  [SMALL_STATE(1802)] = 81402,
  [SMALL_STATE(1803)] = 81428,
  [SMALL_STATE(1804)] = 81454,
  [SMALL_STATE(1805)] = 81478,
  [SMALL_STATE(1806)] = 81504,
  [SMALL_STATE(1807)] = 81528,
  [SMALL_STATE(1808)] = 81558,
  [SMALL_STATE(1809)] = 81594,
  [SMALL_STATE(1810)] = 81624,
  [SMALL_STATE(1811)] = 81650,
  [SMALL_STATE(1812)] = 81685,
  [SMALL_STATE(1813)] = 81720,
  [SMALL_STATE(1814)] = 81755,
  [SMALL_STATE(1815)] = 81790,
  [SMALL_STATE(1816)] = 81813,
  [SMALL_STATE(1817)] = 81848,
  [SMALL_STATE(1818)] = 81871,
  [SMALL_STATE(1819)] = 81906,
  [SMALL_STATE(1820)] = 81941,
  [SMALL_STATE(1821)] = 81976,
  [SMALL_STATE(1822)] = 82011,
  [SMALL_STATE(1823)] = 82046,
  [SMALL_STATE(1824)] = 82081,
  [SMALL_STATE(1825)] = 82111,
  [SMALL_STATE(1826)] = 82143,
  [SMALL_STATE(1827)] = 82173,
  [SMALL_STATE(1828)] = 82205,
  [SMALL_STATE(1829)] = 82237,
  [SMALL_STATE(1830)] = 82265,
  [SMALL_STATE(1831)] = 82293,
  [SMALL_STATE(1832)] = 82325,
  [SMALL_STATE(1833)] = 82357,
  [SMALL_STATE(1834)] = 82386,
  [SMALL_STATE(1835)] = 82411,
  [SMALL_STATE(1836)] = 82438,
  [SMALL_STATE(1837)] = 82459,
  [SMALL_STATE(1838)] = 82486,
  [SMALL_STATE(1839)] = 82513,
  [SMALL_STATE(1840)] = 82542,
  [SMALL_STATE(1841)] = 82569,
  [SMALL_STATE(1842)] = 82598,
  [SMALL_STATE(1843)] = 82623,
  [SMALL_STATE(1844)] = 82644,
  [SMALL_STATE(1845)] = 82671,
  [SMALL_STATE(1846)] = 82698,
  [SMALL_STATE(1847)] = 82719,
  [SMALL_STATE(1848)] = 82746,
  [SMALL_STATE(1849)] = 82775,
  [SMALL_STATE(1850)] = 82796,
  [SMALL_STATE(1851)] = 82825,
  [SMALL_STATE(1852)] = 82854,
  [SMALL_STATE(1853)] = 82879,
  [SMALL_STATE(1854)] = 82906,
  [SMALL_STATE(1855)] = 82935,
  [SMALL_STATE(1856)] = 82964,
  [SMALL_STATE(1857)] = 82993,
  [SMALL_STATE(1858)] = 83022,
  [SMALL_STATE(1859)] = 83051,
  [SMALL_STATE(1860)] = 83080,
  [SMALL_STATE(1861)] = 83109,
  [SMALL_STATE(1862)] = 83138,
  [SMALL_STATE(1863)] = 83167,
  [SMALL_STATE(1864)] = 83196,
  [SMALL_STATE(1865)] = 83225,
  [SMALL_STATE(1866)] = 83252,
  [SMALL_STATE(1867)] = 83273,
  [SMALL_STATE(1868)] = 83292,
  [SMALL_STATE(1869)] = 83316,
  [SMALL_STATE(1870)] = 83336,
  [SMALL_STATE(1871)] = 83358,
  [SMALL_STATE(1872)] = 83384,
  [SMALL_STATE(1873)] = 83408,
  [SMALL_STATE(1874)] = 83428,
  [SMALL_STATE(1875)] = 83448,
  [SMALL_STATE(1876)] = 83468,
  [SMALL_STATE(1877)] = 83488,
  [SMALL_STATE(1878)] = 83508,
  [SMALL_STATE(1879)] = 83528,
  [SMALL_STATE(1880)] = 83552,
  [SMALL_STATE(1881)] = 83572,
  [SMALL_STATE(1882)] = 83594,
  [SMALL_STATE(1883)] = 83620,
  [SMALL_STATE(1884)] = 83640,
  [SMALL_STATE(1885)] = 83666,
  [SMALL_STATE(1886)] = 83686,
  [SMALL_STATE(1887)] = 83710,
  [SMALL_STATE(1888)] = 83734,
  [SMALL_STATE(1889)] = 83754,
  [SMALL_STATE(1890)] = 83776,
  [SMALL_STATE(1891)] = 83796,
  [SMALL_STATE(1892)] = 83820,
  [SMALL_STATE(1893)] = 83840,
  [SMALL_STATE(1894)] = 83864,
  [SMALL_STATE(1895)] = 83884,
  [SMALL_STATE(1896)] = 83904,
  [SMALL_STATE(1897)] = 83930,
  [SMALL_STATE(1898)] = 83956,
  [SMALL_STATE(1899)] = 83976,
  [SMALL_STATE(1900)] = 83995,
  [SMALL_STATE(1901)] = 84018,
  [SMALL_STATE(1902)] = 84037,
  [SMALL_STATE(1903)] = 84060,
  [SMALL_STATE(1904)] = 84083,
  [SMALL_STATE(1905)] = 84100,
  [SMALL_STATE(1906)] = 84119,
  [SMALL_STATE(1907)] = 84138,
  [SMALL_STATE(1908)] = 84159,
  [SMALL_STATE(1909)] = 84180,
  [SMALL_STATE(1910)] = 84197,
  [SMALL_STATE(1911)] = 84216,
  [SMALL_STATE(1912)] = 84239,
  [SMALL_STATE(1913)] = 84260,
  [SMALL_STATE(1914)] = 84281,
  [SMALL_STATE(1915)] = 84304,
  [SMALL_STATE(1916)] = 84327,
  [SMALL_STATE(1917)] = 84344,
  [SMALL_STATE(1918)] = 84367,
  [SMALL_STATE(1919)] = 84388,
  [SMALL_STATE(1920)] = 84409,
  [SMALL_STATE(1921)] = 84428,
  [SMALL_STATE(1922)] = 84447,
  [SMALL_STATE(1923)] = 84470,
  [SMALL_STATE(1924)] = 84493,
  [SMALL_STATE(1925)] = 84516,
  [SMALL_STATE(1926)] = 84536,
  [SMALL_STATE(1927)] = 84556,
  [SMALL_STATE(1928)] = 84576,
  [SMALL_STATE(1929)] = 84596,
  [SMALL_STATE(1930)] = 84616,
  [SMALL_STATE(1931)] = 84632,
  [SMALL_STATE(1932)] = 84652,
  [SMALL_STATE(1933)] = 84672,
  [SMALL_STATE(1934)] = 84692,
  [SMALL_STATE(1935)] = 84712,
  [SMALL_STATE(1936)] = 84732,
  [SMALL_STATE(1937)] = 84752,
  [SMALL_STATE(1938)] = 84772,
  [SMALL_STATE(1939)] = 84792,
  [SMALL_STATE(1940)] = 84812,
  [SMALL_STATE(1941)] = 84832,
  [SMALL_STATE(1942)] = 84852,
  [SMALL_STATE(1943)] = 84872,
  [SMALL_STATE(1944)] = 84892,
  [SMALL_STATE(1945)] = 84912,
  [SMALL_STATE(1946)] = 84932,
  [SMALL_STATE(1947)] = 84952,
  [SMALL_STATE(1948)] = 84972,
  [SMALL_STATE(1949)] = 84992,
  [SMALL_STATE(1950)] = 85012,
  [SMALL_STATE(1951)] = 85030,
  [SMALL_STATE(1952)] = 85050,
  [SMALL_STATE(1953)] = 85070,
  [SMALL_STATE(1954)] = 85090,
  [SMALL_STATE(1955)] = 85110,
  [SMALL_STATE(1956)] = 85130,
  [SMALL_STATE(1957)] = 85148,
  [SMALL_STATE(1958)] = 85168,
  [SMALL_STATE(1959)] = 85188,
  [SMALL_STATE(1960)] = 85208,
  [SMALL_STATE(1961)] = 85228,
  [SMALL_STATE(1962)] = 85246,
  [SMALL_STATE(1963)] = 85266,
  [SMALL_STATE(1964)] = 85286,
  [SMALL_STATE(1965)] = 85306,
  [SMALL_STATE(1966)] = 85326,
  [SMALL_STATE(1967)] = 85344,
  [SMALL_STATE(1968)] = 85364,
  [SMALL_STATE(1969)] = 85382,
  [SMALL_STATE(1970)] = 85402,
  [SMALL_STATE(1971)] = 85422,
  [SMALL_STATE(1972)] = 85442,
  [SMALL_STATE(1973)] = 85462,
  [SMALL_STATE(1974)] = 85482,
  [SMALL_STATE(1975)] = 85502,
  [SMALL_STATE(1976)] = 85522,
  [SMALL_STATE(1977)] = 85542,
  [SMALL_STATE(1978)] = 85562,
  [SMALL_STATE(1979)] = 85582,
  [SMALL_STATE(1980)] = 85598,
  [SMALL_STATE(1981)] = 85618,
  [SMALL_STATE(1982)] = 85638,
  [SMALL_STATE(1983)] = 85658,
  [SMALL_STATE(1984)] = 85678,
  [SMALL_STATE(1985)] = 85696,
  [SMALL_STATE(1986)] = 85716,
  [SMALL_STATE(1987)] = 85736,
  [SMALL_STATE(1988)] = 85756,
  [SMALL_STATE(1989)] = 85776,
  [SMALL_STATE(1990)] = 85794,
  [SMALL_STATE(1991)] = 85814,
  [SMALL_STATE(1992)] = 85834,
  [SMALL_STATE(1993)] = 85852,
  [SMALL_STATE(1994)] = 85872,
  [SMALL_STATE(1995)] = 85892,
  [SMALL_STATE(1996)] = 85912,
  [SMALL_STATE(1997)] = 85932,
  [SMALL_STATE(1998)] = 85952,
  [SMALL_STATE(1999)] = 85968,
  [SMALL_STATE(2000)] = 85988,
  [SMALL_STATE(2001)] = 86008,
  [SMALL_STATE(2002)] = 86028,
  [SMALL_STATE(2003)] = 86048,
  [SMALL_STATE(2004)] = 86068,
  [SMALL_STATE(2005)] = 86086,
  [SMALL_STATE(2006)] = 86106,
  [SMALL_STATE(2007)] = 86126,
  [SMALL_STATE(2008)] = 86146,
  [SMALL_STATE(2009)] = 86166,
  [SMALL_STATE(2010)] = 86186,
  [SMALL_STATE(2011)] = 86206,
  [SMALL_STATE(2012)] = 86226,
  [SMALL_STATE(2013)] = 86246,
  [SMALL_STATE(2014)] = 86266,
  [SMALL_STATE(2015)] = 86286,
  [SMALL_STATE(2016)] = 86306,
  [SMALL_STATE(2017)] = 86326,
  [SMALL_STATE(2018)] = 86346,
  [SMALL_STATE(2019)] = 86366,
  [SMALL_STATE(2020)] = 86386,
  [SMALL_STATE(2021)] = 86406,
  [SMALL_STATE(2022)] = 86426,
  [SMALL_STATE(2023)] = 86446,
  [SMALL_STATE(2024)] = 86466,
  [SMALL_STATE(2025)] = 86486,
  [SMALL_STATE(2026)] = 86506,
  [SMALL_STATE(2027)] = 86526,
  [SMALL_STATE(2028)] = 86546,
  [SMALL_STATE(2029)] = 86566,
  [SMALL_STATE(2030)] = 86586,
  [SMALL_STATE(2031)] = 86606,
  [SMALL_STATE(2032)] = 86626,
  [SMALL_STATE(2033)] = 86646,
  [SMALL_STATE(2034)] = 86664,
  [SMALL_STATE(2035)] = 86684,
  [SMALL_STATE(2036)] = 86704,
  [SMALL_STATE(2037)] = 86724,
  [SMALL_STATE(2038)] = 86744,
  [SMALL_STATE(2039)] = 86764,
  [SMALL_STATE(2040)] = 86784,
  [SMALL_STATE(2041)] = 86804,
  [SMALL_STATE(2042)] = 86824,
  [SMALL_STATE(2043)] = 86844,
  [SMALL_STATE(2044)] = 86864,
  [SMALL_STATE(2045)] = 86884,
  [SMALL_STATE(2046)] = 86904,
  [SMALL_STATE(2047)] = 86922,
  [SMALL_STATE(2048)] = 86942,
  [SMALL_STATE(2049)] = 86962,
  [SMALL_STATE(2050)] = 86982,
  [SMALL_STATE(2051)] = 87002,
  [SMALL_STATE(2052)] = 87022,
  [SMALL_STATE(2053)] = 87042,
  [SMALL_STATE(2054)] = 87062,
  [SMALL_STATE(2055)] = 87080,
  [SMALL_STATE(2056)] = 87100,
  [SMALL_STATE(2057)] = 87120,
  [SMALL_STATE(2058)] = 87140,
  [SMALL_STATE(2059)] = 87156,
  [SMALL_STATE(2060)] = 87176,
  [SMALL_STATE(2061)] = 87196,
  [SMALL_STATE(2062)] = 87216,
  [SMALL_STATE(2063)] = 87236,
  [SMALL_STATE(2064)] = 87256,
  [SMALL_STATE(2065)] = 87276,
  [SMALL_STATE(2066)] = 87292,
  [SMALL_STATE(2067)] = 87312,
  [SMALL_STATE(2068)] = 87332,
  [SMALL_STATE(2069)] = 87352,
  [SMALL_STATE(2070)] = 87372,
  [SMALL_STATE(2071)] = 87392,
  [SMALL_STATE(2072)] = 87412,
  [SMALL_STATE(2073)] = 87432,
  [SMALL_STATE(2074)] = 87452,
  [SMALL_STATE(2075)] = 87468,
  [SMALL_STATE(2076)] = 87488,
  [SMALL_STATE(2077)] = 87508,
  [SMALL_STATE(2078)] = 87528,
  [SMALL_STATE(2079)] = 87548,
  [SMALL_STATE(2080)] = 87568,
  [SMALL_STATE(2081)] = 87588,
  [SMALL_STATE(2082)] = 87608,
  [SMALL_STATE(2083)] = 87628,
  [SMALL_STATE(2084)] = 87648,
  [SMALL_STATE(2085)] = 87668,
  [SMALL_STATE(2086)] = 87688,
  [SMALL_STATE(2087)] = 87708,
  [SMALL_STATE(2088)] = 87728,
  [SMALL_STATE(2089)] = 87748,
  [SMALL_STATE(2090)] = 87768,
  [SMALL_STATE(2091)] = 87788,
  [SMALL_STATE(2092)] = 87808,
  [SMALL_STATE(2093)] = 87828,
  [SMALL_STATE(2094)] = 87848,
  [SMALL_STATE(2095)] = 87868,
  [SMALL_STATE(2096)] = 87888,
  [SMALL_STATE(2097)] = 87908,
  [SMALL_STATE(2098)] = 87926,
  [SMALL_STATE(2099)] = 87946,
  [SMALL_STATE(2100)] = 87966,
  [SMALL_STATE(2101)] = 87986,
  [SMALL_STATE(2102)] = 88006,
  [SMALL_STATE(2103)] = 88024,
  [SMALL_STATE(2104)] = 88044,
  [SMALL_STATE(2105)] = 88064,
  [SMALL_STATE(2106)] = 88084,
  [SMALL_STATE(2107)] = 88104,
  [SMALL_STATE(2108)] = 88124,
  [SMALL_STATE(2109)] = 88144,
  [SMALL_STATE(2110)] = 88164,
  [SMALL_STATE(2111)] = 88182,
  [SMALL_STATE(2112)] = 88202,
  [SMALL_STATE(2113)] = 88222,
  [SMALL_STATE(2114)] = 88242,
  [SMALL_STATE(2115)] = 88260,
  [SMALL_STATE(2116)] = 88280,
  [SMALL_STATE(2117)] = 88300,
  [SMALL_STATE(2118)] = 88318,
  [SMALL_STATE(2119)] = 88338,
  [SMALL_STATE(2120)] = 88358,
  [SMALL_STATE(2121)] = 88378,
  [SMALL_STATE(2122)] = 88398,
  [SMALL_STATE(2123)] = 88418,
  [SMALL_STATE(2124)] = 88438,
  [SMALL_STATE(2125)] = 88458,
  [SMALL_STATE(2126)] = 88478,
  [SMALL_STATE(2127)] = 88498,
  [SMALL_STATE(2128)] = 88518,
  [SMALL_STATE(2129)] = 88538,
  [SMALL_STATE(2130)] = 88558,
  [SMALL_STATE(2131)] = 88578,
  [SMALL_STATE(2132)] = 88598,
  [SMALL_STATE(2133)] = 88618,
  [SMALL_STATE(2134)] = 88638,
  [SMALL_STATE(2135)] = 88658,
  [SMALL_STATE(2136)] = 88678,
  [SMALL_STATE(2137)] = 88698,
  [SMALL_STATE(2138)] = 88714,
  [SMALL_STATE(2139)] = 88734,
  [SMALL_STATE(2140)] = 88754,
  [SMALL_STATE(2141)] = 88774,
  [SMALL_STATE(2142)] = 88794,
  [SMALL_STATE(2143)] = 88814,
  [SMALL_STATE(2144)] = 88834,
  [SMALL_STATE(2145)] = 88854,
  [SMALL_STATE(2146)] = 88874,
  [SMALL_STATE(2147)] = 88894,
  [SMALL_STATE(2148)] = 88912,
  [SMALL_STATE(2149)] = 88930,
  [SMALL_STATE(2150)] = 88950,
  [SMALL_STATE(2151)] = 88970,
  [SMALL_STATE(2152)] = 88990,
  [SMALL_STATE(2153)] = 89010,
  [SMALL_STATE(2154)] = 89030,
  [SMALL_STATE(2155)] = 89050,
  [SMALL_STATE(2156)] = 89070,
  [SMALL_STATE(2157)] = 89090,
  [SMALL_STATE(2158)] = 89110,
  [SMALL_STATE(2159)] = 89130,
  [SMALL_STATE(2160)] = 89150,
  [SMALL_STATE(2161)] = 89170,
  [SMALL_STATE(2162)] = 89190,
  [SMALL_STATE(2163)] = 89210,
  [SMALL_STATE(2164)] = 89230,
  [SMALL_STATE(2165)] = 89248,
  [SMALL_STATE(2166)] = 89268,
  [SMALL_STATE(2167)] = 89288,
  [SMALL_STATE(2168)] = 89304,
  [SMALL_STATE(2169)] = 89324,
  [SMALL_STATE(2170)] = 89344,
  [SMALL_STATE(2171)] = 89364,
  [SMALL_STATE(2172)] = 89384,
  [SMALL_STATE(2173)] = 89404,
  [SMALL_STATE(2174)] = 89424,
  [SMALL_STATE(2175)] = 89440,
  [SMALL_STATE(2176)] = 89460,
  [SMALL_STATE(2177)] = 89480,
  [SMALL_STATE(2178)] = 89500,
  [SMALL_STATE(2179)] = 89520,
  [SMALL_STATE(2180)] = 89540,
  [SMALL_STATE(2181)] = 89558,
  [SMALL_STATE(2182)] = 89578,
  [SMALL_STATE(2183)] = 89598,
  [SMALL_STATE(2184)] = 89618,
  [SMALL_STATE(2185)] = 89638,
  [SMALL_STATE(2186)] = 89658,
  [SMALL_STATE(2187)] = 89678,
  [SMALL_STATE(2188)] = 89698,
  [SMALL_STATE(2189)] = 89718,
  [SMALL_STATE(2190)] = 89738,
  [SMALL_STATE(2191)] = 89758,
  [SMALL_STATE(2192)] = 89778,
  [SMALL_STATE(2193)] = 89798,
  [SMALL_STATE(2194)] = 89818,
  [SMALL_STATE(2195)] = 89836,
  [SMALL_STATE(2196)] = 89856,
  [SMALL_STATE(2197)] = 89876,
  [SMALL_STATE(2198)] = 89896,
  [SMALL_STATE(2199)] = 89916,
  [SMALL_STATE(2200)] = 89936,
  [SMALL_STATE(2201)] = 89956,
  [SMALL_STATE(2202)] = 89976,
  [SMALL_STATE(2203)] = 89996,
  [SMALL_STATE(2204)] = 90016,
  [SMALL_STATE(2205)] = 90034,
  [SMALL_STATE(2206)] = 90054,
  [SMALL_STATE(2207)] = 90074,
  [SMALL_STATE(2208)] = 90094,
  [SMALL_STATE(2209)] = 90112,
  [SMALL_STATE(2210)] = 90132,
  [SMALL_STATE(2211)] = 90152,
  [SMALL_STATE(2212)] = 90170,
  [SMALL_STATE(2213)] = 90188,
  [SMALL_STATE(2214)] = 90206,
  [SMALL_STATE(2215)] = 90226,
  [SMALL_STATE(2216)] = 90246,
  [SMALL_STATE(2217)] = 90264,
  [SMALL_STATE(2218)] = 90284,
  [SMALL_STATE(2219)] = 90304,
  [SMALL_STATE(2220)] = 90324,
  [SMALL_STATE(2221)] = 90344,
  [SMALL_STATE(2222)] = 90364,
  [SMALL_STATE(2223)] = 90382,
  [SMALL_STATE(2224)] = 90402,
  [SMALL_STATE(2225)] = 90422,
  [SMALL_STATE(2226)] = 90442,
  [SMALL_STATE(2227)] = 90462,
  [SMALL_STATE(2228)] = 90482,
  [SMALL_STATE(2229)] = 90502,
  [SMALL_STATE(2230)] = 90522,
  [SMALL_STATE(2231)] = 90542,
  [SMALL_STATE(2232)] = 90560,
  [SMALL_STATE(2233)] = 90580,
  [SMALL_STATE(2234)] = 90598,
  [SMALL_STATE(2235)] = 90618,
  [SMALL_STATE(2236)] = 90638,
  [SMALL_STATE(2237)] = 90658,
  [SMALL_STATE(2238)] = 90678,
  [SMALL_STATE(2239)] = 90698,
  [SMALL_STATE(2240)] = 90718,
  [SMALL_STATE(2241)] = 90738,
  [SMALL_STATE(2242)] = 90758,
  [SMALL_STATE(2243)] = 90778,
  [SMALL_STATE(2244)] = 90798,
  [SMALL_STATE(2245)] = 90813,
  [SMALL_STATE(2246)] = 90828,
  [SMALL_STATE(2247)] = 90845,
  [SMALL_STATE(2248)] = 90862,
  [SMALL_STATE(2249)] = 90879,
  [SMALL_STATE(2250)] = 90896,
  [SMALL_STATE(2251)] = 90911,
  [SMALL_STATE(2252)] = 90928,
  [SMALL_STATE(2253)] = 90943,
  [SMALL_STATE(2254)] = 90958,
  [SMALL_STATE(2255)] = 90973,
  [SMALL_STATE(2256)] = 90988,
  [SMALL_STATE(2257)] = 91003,
  [SMALL_STATE(2258)] = 91020,
  [SMALL_STATE(2259)] = 91035,
  [SMALL_STATE(2260)] = 91050,
  [SMALL_STATE(2261)] = 91065,
  [SMALL_STATE(2262)] = 91080,
  [SMALL_STATE(2263)] = 91097,
  [SMALL_STATE(2264)] = 91112,
  [SMALL_STATE(2265)] = 91129,
  [SMALL_STATE(2266)] = 91146,
  [SMALL_STATE(2267)] = 91163,
  [SMALL_STATE(2268)] = 91178,
  [SMALL_STATE(2269)] = 91195,
  [SMALL_STATE(2270)] = 91210,
  [SMALL_STATE(2271)] = 91225,
  [SMALL_STATE(2272)] = 91240,
  [SMALL_STATE(2273)] = 91257,
  [SMALL_STATE(2274)] = 91272,
  [SMALL_STATE(2275)] = 91289,
  [SMALL_STATE(2276)] = 91306,
  [SMALL_STATE(2277)] = 91321,
  [SMALL_STATE(2278)] = 91338,
  [SMALL_STATE(2279)] = 91353,
  [SMALL_STATE(2280)] = 91368,
  [SMALL_STATE(2281)] = 91385,
  [SMALL_STATE(2282)] = 91400,
  [SMALL_STATE(2283)] = 91417,
  [SMALL_STATE(2284)] = 91432,
  [SMALL_STATE(2285)] = 91447,
  [SMALL_STATE(2286)] = 91462,
  [SMALL_STATE(2287)] = 91479,
  [SMALL_STATE(2288)] = 91494,
  [SMALL_STATE(2289)] = 91511,
  [SMALL_STATE(2290)] = 91528,
  [SMALL_STATE(2291)] = 91543,
  [SMALL_STATE(2292)] = 91560,
  [SMALL_STATE(2293)] = 91575,
  [SMALL_STATE(2294)] = 91592,
  [SMALL_STATE(2295)] = 91607,
  [SMALL_STATE(2296)] = 91624,
  [SMALL_STATE(2297)] = 91639,
  [SMALL_STATE(2298)] = 91654,
  [SMALL_STATE(2299)] = 91669,
  [SMALL_STATE(2300)] = 91684,
  [SMALL_STATE(2301)] = 91701,
  [SMALL_STATE(2302)] = 91718,
  [SMALL_STATE(2303)] = 91735,
  [SMALL_STATE(2304)] = 91752,
  [SMALL_STATE(2305)] = 91767,
  [SMALL_STATE(2306)] = 91782,
  [SMALL_STATE(2307)] = 91797,
  [SMALL_STATE(2308)] = 91812,
  [SMALL_STATE(2309)] = 91827,
  [SMALL_STATE(2310)] = 91842,
  [SMALL_STATE(2311)] = 91859,
  [SMALL_STATE(2312)] = 91874,
  [SMALL_STATE(2313)] = 91889,
  [SMALL_STATE(2314)] = 91904,
  [SMALL_STATE(2315)] = 91919,
  [SMALL_STATE(2316)] = 91934,
  [SMALL_STATE(2317)] = 91949,
  [SMALL_STATE(2318)] = 91966,
  [SMALL_STATE(2319)] = 91983,
  [SMALL_STATE(2320)] = 91998,
  [SMALL_STATE(2321)] = 92013,
  [SMALL_STATE(2322)] = 92028,
  [SMALL_STATE(2323)] = 92043,
  [SMALL_STATE(2324)] = 92060,
  [SMALL_STATE(2325)] = 92075,
  [SMALL_STATE(2326)] = 92092,
  [SMALL_STATE(2327)] = 92107,
  [SMALL_STATE(2328)] = 92124,
  [SMALL_STATE(2329)] = 92141,
  [SMALL_STATE(2330)] = 92158,
  [SMALL_STATE(2331)] = 92173,
  [SMALL_STATE(2332)] = 92188,
  [SMALL_STATE(2333)] = 92205,
  [SMALL_STATE(2334)] = 92222,
  [SMALL_STATE(2335)] = 92237,
  [SMALL_STATE(2336)] = 92254,
  [SMALL_STATE(2337)] = 92269,
  [SMALL_STATE(2338)] = 92284,
  [SMALL_STATE(2339)] = 92299,
  [SMALL_STATE(2340)] = 92314,
  [SMALL_STATE(2341)] = 92329,
  [SMALL_STATE(2342)] = 92346,
  [SMALL_STATE(2343)] = 92361,
  [SMALL_STATE(2344)] = 92378,
  [SMALL_STATE(2345)] = 92393,
  [SMALL_STATE(2346)] = 92408,
  [SMALL_STATE(2347)] = 92425,
  [SMALL_STATE(2348)] = 92442,
  [SMALL_STATE(2349)] = 92457,
  [SMALL_STATE(2350)] = 92472,
  [SMALL_STATE(2351)] = 92487,
  [SMALL_STATE(2352)] = 92504,
  [SMALL_STATE(2353)] = 92521,
  [SMALL_STATE(2354)] = 92538,
  [SMALL_STATE(2355)] = 92552,
  [SMALL_STATE(2356)] = 92566,
  [SMALL_STATE(2357)] = 92580,
  [SMALL_STATE(2358)] = 92594,
  [SMALL_STATE(2359)] = 92608,
  [SMALL_STATE(2360)] = 92622,
  [SMALL_STATE(2361)] = 92636,
  [SMALL_STATE(2362)] = 92650,
  [SMALL_STATE(2363)] = 92664,
  [SMALL_STATE(2364)] = 92678,
  [SMALL_STATE(2365)] = 92692,
  [SMALL_STATE(2366)] = 92706,
  [SMALL_STATE(2367)] = 92720,
  [SMALL_STATE(2368)] = 92734,
  [SMALL_STATE(2369)] = 92748,
  [SMALL_STATE(2370)] = 92762,
  [SMALL_STATE(2371)] = 92776,
  [SMALL_STATE(2372)] = 92790,
  [SMALL_STATE(2373)] = 92804,
  [SMALL_STATE(2374)] = 92818,
  [SMALL_STATE(2375)] = 92832,
  [SMALL_STATE(2376)] = 92846,
  [SMALL_STATE(2377)] = 92860,
  [SMALL_STATE(2378)] = 92874,
  [SMALL_STATE(2379)] = 92888,
  [SMALL_STATE(2380)] = 92902,
  [SMALL_STATE(2381)] = 92916,
  [SMALL_STATE(2382)] = 92930,
  [SMALL_STATE(2383)] = 92944,
  [SMALL_STATE(2384)] = 92958,
  [SMALL_STATE(2385)] = 92972,
  [SMALL_STATE(2386)] = 92986,
  [SMALL_STATE(2387)] = 93000,
  [SMALL_STATE(2388)] = 93014,
  [SMALL_STATE(2389)] = 93028,
  [SMALL_STATE(2390)] = 93042,
  [SMALL_STATE(2391)] = 93056,
  [SMALL_STATE(2392)] = 93070,
  [SMALL_STATE(2393)] = 93084,
  [SMALL_STATE(2394)] = 93098,
  [SMALL_STATE(2395)] = 93112,
  [SMALL_STATE(2396)] = 93126,
  [SMALL_STATE(2397)] = 93140,
  [SMALL_STATE(2398)] = 93154,
  [SMALL_STATE(2399)] = 93168,
  [SMALL_STATE(2400)] = 93182,
  [SMALL_STATE(2401)] = 93196,
  [SMALL_STATE(2402)] = 93210,
  [SMALL_STATE(2403)] = 93224,
  [SMALL_STATE(2404)] = 93238,
  [SMALL_STATE(2405)] = 93252,
  [SMALL_STATE(2406)] = 93266,
  [SMALL_STATE(2407)] = 93280,
  [SMALL_STATE(2408)] = 93294,
  [SMALL_STATE(2409)] = 93308,
  [SMALL_STATE(2410)] = 93322,
  [SMALL_STATE(2411)] = 93336,
  [SMALL_STATE(2412)] = 93350,
  [SMALL_STATE(2413)] = 93364,
  [SMALL_STATE(2414)] = 93378,
  [SMALL_STATE(2415)] = 93392,
  [SMALL_STATE(2416)] = 93406,
  [SMALL_STATE(2417)] = 93420,
  [SMALL_STATE(2418)] = 93434,
  [SMALL_STATE(2419)] = 93448,
  [SMALL_STATE(2420)] = 93462,
  [SMALL_STATE(2421)] = 93476,
  [SMALL_STATE(2422)] = 93490,
  [SMALL_STATE(2423)] = 93504,
  [SMALL_STATE(2424)] = 93518,
  [SMALL_STATE(2425)] = 93532,
  [SMALL_STATE(2426)] = 93546,
  [SMALL_STATE(2427)] = 93560,
  [SMALL_STATE(2428)] = 93574,
  [SMALL_STATE(2429)] = 93588,
  [SMALL_STATE(2430)] = 93602,
  [SMALL_STATE(2431)] = 93616,
  [SMALL_STATE(2432)] = 93630,
  [SMALL_STATE(2433)] = 93644,
  [SMALL_STATE(2434)] = 93658,
  [SMALL_STATE(2435)] = 93672,
  [SMALL_STATE(2436)] = 93686,
  [SMALL_STATE(2437)] = 93700,
  [SMALL_STATE(2438)] = 93714,
  [SMALL_STATE(2439)] = 93728,
  [SMALL_STATE(2440)] = 93742,
  [SMALL_STATE(2441)] = 93756,
  [SMALL_STATE(2442)] = 93770,
  [SMALL_STATE(2443)] = 93784,
  [SMALL_STATE(2444)] = 93798,
  [SMALL_STATE(2445)] = 93812,
  [SMALL_STATE(2446)] = 93826,
  [SMALL_STATE(2447)] = 93840,
  [SMALL_STATE(2448)] = 93854,
  [SMALL_STATE(2449)] = 93868,
  [SMALL_STATE(2450)] = 93882,
  [SMALL_STATE(2451)] = 93896,
  [SMALL_STATE(2452)] = 93910,
  [SMALL_STATE(2453)] = 93924,
  [SMALL_STATE(2454)] = 93938,
  [SMALL_STATE(2455)] = 93952,
  [SMALL_STATE(2456)] = 93966,
  [SMALL_STATE(2457)] = 93980,
  [SMALL_STATE(2458)] = 93994,
  [SMALL_STATE(2459)] = 94008,
  [SMALL_STATE(2460)] = 94022,
  [SMALL_STATE(2461)] = 94036,
  [SMALL_STATE(2462)] = 94050,
  [SMALL_STATE(2463)] = 94064,
  [SMALL_STATE(2464)] = 94078,
  [SMALL_STATE(2465)] = 94092,
  [SMALL_STATE(2466)] = 94106,
  [SMALL_STATE(2467)] = 94120,
  [SMALL_STATE(2468)] = 94134,
  [SMALL_STATE(2469)] = 94148,
  [SMALL_STATE(2470)] = 94162,
  [SMALL_STATE(2471)] = 94176,
  [SMALL_STATE(2472)] = 94190,
  [SMALL_STATE(2473)] = 94204,
  [SMALL_STATE(2474)] = 94218,
  [SMALL_STATE(2475)] = 94232,
  [SMALL_STATE(2476)] = 94246,
  [SMALL_STATE(2477)] = 94260,
  [SMALL_STATE(2478)] = 94274,
  [SMALL_STATE(2479)] = 94288,
  [SMALL_STATE(2480)] = 94302,
  [SMALL_STATE(2481)] = 94316,
  [SMALL_STATE(2482)] = 94330,
  [SMALL_STATE(2483)] = 94344,
  [SMALL_STATE(2484)] = 94358,
  [SMALL_STATE(2485)] = 94372,
  [SMALL_STATE(2486)] = 94386,
  [SMALL_STATE(2487)] = 94400,
  [SMALL_STATE(2488)] = 94414,
  [SMALL_STATE(2489)] = 94428,
  [SMALL_STATE(2490)] = 94442,
  [SMALL_STATE(2491)] = 94456,
  [SMALL_STATE(2492)] = 94470,
  [SMALL_STATE(2493)] = 94484,
  [SMALL_STATE(2494)] = 94498,
  [SMALL_STATE(2495)] = 94512,
  [SMALL_STATE(2496)] = 94526,
  [SMALL_STATE(2497)] = 94540,
  [SMALL_STATE(2498)] = 94554,
  [SMALL_STATE(2499)] = 94568,
  [SMALL_STATE(2500)] = 94582,
  [SMALL_STATE(2501)] = 94596,
  [SMALL_STATE(2502)] = 94610,
  [SMALL_STATE(2503)] = 94624,
  [SMALL_STATE(2504)] = 94638,
  [SMALL_STATE(2505)] = 94652,
  [SMALL_STATE(2506)] = 94666,
  [SMALL_STATE(2507)] = 94680,
  [SMALL_STATE(2508)] = 94694,
  [SMALL_STATE(2509)] = 94708,
  [SMALL_STATE(2510)] = 94722,
  [SMALL_STATE(2511)] = 94736,
  [SMALL_STATE(2512)] = 94750,
  [SMALL_STATE(2513)] = 94764,
  [SMALL_STATE(2514)] = 94778,
  [SMALL_STATE(2515)] = 94792,
  [SMALL_STATE(2516)] = 94806,
  [SMALL_STATE(2517)] = 94820,
  [SMALL_STATE(2518)] = 94834,
  [SMALL_STATE(2519)] = 94848,
  [SMALL_STATE(2520)] = 94862,
  [SMALL_STATE(2521)] = 94876,
  [SMALL_STATE(2522)] = 94890,
  [SMALL_STATE(2523)] = 94904,
  [SMALL_STATE(2524)] = 94918,
  [SMALL_STATE(2525)] = 94932,
  [SMALL_STATE(2526)] = 94946,
  [SMALL_STATE(2527)] = 94960,
  [SMALL_STATE(2528)] = 94974,
  [SMALL_STATE(2529)] = 94988,
  [SMALL_STATE(2530)] = 95002,
  [SMALL_STATE(2531)] = 95016,
  [SMALL_STATE(2532)] = 95030,
  [SMALL_STATE(2533)] = 95044,
  [SMALL_STATE(2534)] = 95058,
  [SMALL_STATE(2535)] = 95072,
  [SMALL_STATE(2536)] = 95086,
  [SMALL_STATE(2537)] = 95100,
  [SMALL_STATE(2538)] = 95114,
  [SMALL_STATE(2539)] = 95128,
  [SMALL_STATE(2540)] = 95142,
  [SMALL_STATE(2541)] = 95156,
  [SMALL_STATE(2542)] = 95170,
  [SMALL_STATE(2543)] = 95184,
  [SMALL_STATE(2544)] = 95198,
  [SMALL_STATE(2545)] = 95212,
  [SMALL_STATE(2546)] = 95226,
  [SMALL_STATE(2547)] = 95240,
  [SMALL_STATE(2548)] = 95254,
  [SMALL_STATE(2549)] = 95268,
  [SMALL_STATE(2550)] = 95282,
  [SMALL_STATE(2551)] = 95296,
  [SMALL_STATE(2552)] = 95310,
  [SMALL_STATE(2553)] = 95324,
  [SMALL_STATE(2554)] = 95338,
  [SMALL_STATE(2555)] = 95352,
  [SMALL_STATE(2556)] = 95366,
  [SMALL_STATE(2557)] = 95380,
  [SMALL_STATE(2558)] = 95394,
  [SMALL_STATE(2559)] = 95408,
  [SMALL_STATE(2560)] = 95422,
  [SMALL_STATE(2561)] = 95436,
  [SMALL_STATE(2562)] = 95450,
  [SMALL_STATE(2563)] = 95464,
  [SMALL_STATE(2564)] = 95478,
  [SMALL_STATE(2565)] = 95492,
  [SMALL_STATE(2566)] = 95506,
  [SMALL_STATE(2567)] = 95520,
  [SMALL_STATE(2568)] = 95534,
  [SMALL_STATE(2569)] = 95548,
  [SMALL_STATE(2570)] = 95562,
  [SMALL_STATE(2571)] = 95576,
  [SMALL_STATE(2572)] = 95590,
  [SMALL_STATE(2573)] = 95604,
  [SMALL_STATE(2574)] = 95618,
  [SMALL_STATE(2575)] = 95632,
  [SMALL_STATE(2576)] = 95646,
  [SMALL_STATE(2577)] = 95660,
  [SMALL_STATE(2578)] = 95674,
  [SMALL_STATE(2579)] = 95688,
  [SMALL_STATE(2580)] = 95702,
  [SMALL_STATE(2581)] = 95716,
  [SMALL_STATE(2582)] = 95730,
  [SMALL_STATE(2583)] = 95744,
  [SMALL_STATE(2584)] = 95758,
  [SMALL_STATE(2585)] = 95772,
  [SMALL_STATE(2586)] = 95786,
  [SMALL_STATE(2587)] = 95800,
  [SMALL_STATE(2588)] = 95814,
  [SMALL_STATE(2589)] = 95828,
  [SMALL_STATE(2590)] = 95842,
  [SMALL_STATE(2591)] = 95856,
  [SMALL_STATE(2592)] = 95870,
  [SMALL_STATE(2593)] = 95884,
  [SMALL_STATE(2594)] = 95898,
  [SMALL_STATE(2595)] = 95912,
  [SMALL_STATE(2596)] = 95926,
  [SMALL_STATE(2597)] = 95940,
  [SMALL_STATE(2598)] = 95954,
  [SMALL_STATE(2599)] = 95968,
  [SMALL_STATE(2600)] = 95982,
  [SMALL_STATE(2601)] = 95996,
  [SMALL_STATE(2602)] = 96010,
  [SMALL_STATE(2603)] = 96024,
  [SMALL_STATE(2604)] = 96038,
  [SMALL_STATE(2605)] = 96052,
  [SMALL_STATE(2606)] = 96066,
  [SMALL_STATE(2607)] = 96080,
  [SMALL_STATE(2608)] = 96094,
  [SMALL_STATE(2609)] = 96108,
  [SMALL_STATE(2610)] = 96122,
  [SMALL_STATE(2611)] = 96136,
  [SMALL_STATE(2612)] = 96150,
  [SMALL_STATE(2613)] = 96164,
  [SMALL_STATE(2614)] = 96178,
  [SMALL_STATE(2615)] = 96192,
  [SMALL_STATE(2616)] = 96206,
  [SMALL_STATE(2617)] = 96220,
  [SMALL_STATE(2618)] = 96234,
  [SMALL_STATE(2619)] = 96248,
  [SMALL_STATE(2620)] = 96262,
  [SMALL_STATE(2621)] = 96276,
  [SMALL_STATE(2622)] = 96290,
  [SMALL_STATE(2623)] = 96304,
  [SMALL_STATE(2624)] = 96318,
  [SMALL_STATE(2625)] = 96332,
  [SMALL_STATE(2626)] = 96346,
  [SMALL_STATE(2627)] = 96360,
  [SMALL_STATE(2628)] = 96374,
  [SMALL_STATE(2629)] = 96388,
  [SMALL_STATE(2630)] = 96402,
  [SMALL_STATE(2631)] = 96416,
  [SMALL_STATE(2632)] = 96430,
  [SMALL_STATE(2633)] = 96444,
  [SMALL_STATE(2634)] = 96458,
  [SMALL_STATE(2635)] = 96472,
  [SMALL_STATE(2636)] = 96486,
  [SMALL_STATE(2637)] = 96500,
  [SMALL_STATE(2638)] = 96514,
  [SMALL_STATE(2639)] = 96528,
  [SMALL_STATE(2640)] = 96542,
  [SMALL_STATE(2641)] = 96556,
  [SMALL_STATE(2642)] = 96570,
  [SMALL_STATE(2643)] = 96584,
  [SMALL_STATE(2644)] = 96598,
  [SMALL_STATE(2645)] = 96612,
  [SMALL_STATE(2646)] = 96626,
  [SMALL_STATE(2647)] = 96640,
  [SMALL_STATE(2648)] = 96654,
  [SMALL_STATE(2649)] = 96668,
  [SMALL_STATE(2650)] = 96682,
  [SMALL_STATE(2651)] = 96696,
  [SMALL_STATE(2652)] = 96710,
  [SMALL_STATE(2653)] = 96724,
  [SMALL_STATE(2654)] = 96738,
  [SMALL_STATE(2655)] = 96752,
  [SMALL_STATE(2656)] = 96766,
  [SMALL_STATE(2657)] = 96780,
  [SMALL_STATE(2658)] = 96794,
  [SMALL_STATE(2659)] = 96808,
  [SMALL_STATE(2660)] = 96822,
  [SMALL_STATE(2661)] = 96836,
  [SMALL_STATE(2662)] = 96850,
  [SMALL_STATE(2663)] = 96864,
  [SMALL_STATE(2664)] = 96878,
  [SMALL_STATE(2665)] = 96892,
  [SMALL_STATE(2666)] = 96906,
  [SMALL_STATE(2667)] = 96920,
  [SMALL_STATE(2668)] = 96934,
  [SMALL_STATE(2669)] = 96948,
  [SMALL_STATE(2670)] = 96962,
  [SMALL_STATE(2671)] = 96976,
  [SMALL_STATE(2672)] = 96990,
  [SMALL_STATE(2673)] = 97004,
  [SMALL_STATE(2674)] = 97018,
  [SMALL_STATE(2675)] = 97032,
  [SMALL_STATE(2676)] = 97046,
  [SMALL_STATE(2677)] = 97060,
  [SMALL_STATE(2678)] = 97074,
  [SMALL_STATE(2679)] = 97088,
  [SMALL_STATE(2680)] = 97102,
  [SMALL_STATE(2681)] = 97116,
  [SMALL_STATE(2682)] = 97130,
  [SMALL_STATE(2683)] = 97144,
  [SMALL_STATE(2684)] = 97158,
  [SMALL_STATE(2685)] = 97172,
  [SMALL_STATE(2686)] = 97186,
  [SMALL_STATE(2687)] = 97200,
  [SMALL_STATE(2688)] = 97214,
  [SMALL_STATE(2689)] = 97228,
  [SMALL_STATE(2690)] = 97242,
  [SMALL_STATE(2691)] = 97256,
  [SMALL_STATE(2692)] = 97270,
  [SMALL_STATE(2693)] = 97284,
  [SMALL_STATE(2694)] = 97298,
  [SMALL_STATE(2695)] = 97312,
  [SMALL_STATE(2696)] = 97326,
  [SMALL_STATE(2697)] = 97340,
  [SMALL_STATE(2698)] = 97354,
  [SMALL_STATE(2699)] = 97368,
  [SMALL_STATE(2700)] = 97382,
  [SMALL_STATE(2701)] = 97396,
  [SMALL_STATE(2702)] = 97410,
  [SMALL_STATE(2703)] = 97424,
  [SMALL_STATE(2704)] = 97438,
  [SMALL_STATE(2705)] = 97452,
  [SMALL_STATE(2706)] = 97466,
  [SMALL_STATE(2707)] = 97480,
  [SMALL_STATE(2708)] = 97494,
  [SMALL_STATE(2709)] = 97508,
  [SMALL_STATE(2710)] = 97522,
  [SMALL_STATE(2711)] = 97536,
  [SMALL_STATE(2712)] = 97550,
  [SMALL_STATE(2713)] = 97564,
  [SMALL_STATE(2714)] = 97578,
  [SMALL_STATE(2715)] = 97592,
  [SMALL_STATE(2716)] = 97606,
  [SMALL_STATE(2717)] = 97620,
  [SMALL_STATE(2718)] = 97634,
  [SMALL_STATE(2719)] = 97648,
  [SMALL_STATE(2720)] = 97662,
  [SMALL_STATE(2721)] = 97676,
  [SMALL_STATE(2722)] = 97690,
  [SMALL_STATE(2723)] = 97704,
  [SMALL_STATE(2724)] = 97718,
  [SMALL_STATE(2725)] = 97732,
  [SMALL_STATE(2726)] = 97746,
  [SMALL_STATE(2727)] = 97760,
  [SMALL_STATE(2728)] = 97774,
  [SMALL_STATE(2729)] = 97788,
  [SMALL_STATE(2730)] = 97802,
  [SMALL_STATE(2731)] = 97816,
  [SMALL_STATE(2732)] = 97830,
  [SMALL_STATE(2733)] = 97844,
  [SMALL_STATE(2734)] = 97858,
  [SMALL_STATE(2735)] = 97872,
  [SMALL_STATE(2736)] = 97886,
  [SMALL_STATE(2737)] = 97900,
  [SMALL_STATE(2738)] = 97914,
  [SMALL_STATE(2739)] = 97928,
  [SMALL_STATE(2740)] = 97942,
  [SMALL_STATE(2741)] = 97956,
  [SMALL_STATE(2742)] = 97970,
  [SMALL_STATE(2743)] = 97984,
  [SMALL_STATE(2744)] = 97998,
  [SMALL_STATE(2745)] = 98012,
  [SMALL_STATE(2746)] = 98026,
  [SMALL_STATE(2747)] = 98040,
  [SMALL_STATE(2748)] = 98054,
  [SMALL_STATE(2749)] = 98068,
  [SMALL_STATE(2750)] = 98082,
  [SMALL_STATE(2751)] = 98096,
  [SMALL_STATE(2752)] = 98110,
  [SMALL_STATE(2753)] = 98124,
  [SMALL_STATE(2754)] = 98138,
  [SMALL_STATE(2755)] = 98152,
  [SMALL_STATE(2756)] = 98166,
  [SMALL_STATE(2757)] = 98180,
  [SMALL_STATE(2758)] = 98194,
  [SMALL_STATE(2759)] = 98208,
  [SMALL_STATE(2760)] = 98222,
  [SMALL_STATE(2761)] = 98236,
  [SMALL_STATE(2762)] = 98250,
  [SMALL_STATE(2763)] = 98264,
  [SMALL_STATE(2764)] = 98278,
  [SMALL_STATE(2765)] = 98292,
  [SMALL_STATE(2766)] = 98306,
  [SMALL_STATE(2767)] = 98320,
  [SMALL_STATE(2768)] = 98334,
  [SMALL_STATE(2769)] = 98348,
  [SMALL_STATE(2770)] = 98362,
  [SMALL_STATE(2771)] = 98376,
  [SMALL_STATE(2772)] = 98390,
  [SMALL_STATE(2773)] = 98404,
  [SMALL_STATE(2774)] = 98418,
  [SMALL_STATE(2775)] = 98432,
  [SMALL_STATE(2776)] = 98446,
  [SMALL_STATE(2777)] = 98460,
  [SMALL_STATE(2778)] = 98474,
  [SMALL_STATE(2779)] = 98488,
  [SMALL_STATE(2780)] = 98502,
  [SMALL_STATE(2781)] = 98516,
  [SMALL_STATE(2782)] = 98530,
  [SMALL_STATE(2783)] = 98544,
  [SMALL_STATE(2784)] = 98558,
  [SMALL_STATE(2785)] = 98572,
  [SMALL_STATE(2786)] = 98586,
  [SMALL_STATE(2787)] = 98600,
  [SMALL_STATE(2788)] = 98614,
  [SMALL_STATE(2789)] = 98628,
  [SMALL_STATE(2790)] = 98642,
  [SMALL_STATE(2791)] = 98656,
  [SMALL_STATE(2792)] = 98670,
  [SMALL_STATE(2793)] = 98684,
  [SMALL_STATE(2794)] = 98698,
  [SMALL_STATE(2795)] = 98712,
  [SMALL_STATE(2796)] = 98726,
  [SMALL_STATE(2797)] = 98740,
  [SMALL_STATE(2798)] = 98754,
  [SMALL_STATE(2799)] = 98768,
  [SMALL_STATE(2800)] = 98782,
  [SMALL_STATE(2801)] = 98796,
  [SMALL_STATE(2802)] = 98810,
  [SMALL_STATE(2803)] = 98824,
  [SMALL_STATE(2804)] = 98838,
  [SMALL_STATE(2805)] = 98852,
  [SMALL_STATE(2806)] = 98866,
  [SMALL_STATE(2807)] = 98880,
  [SMALL_STATE(2808)] = 98894,
  [SMALL_STATE(2809)] = 98908,
  [SMALL_STATE(2810)] = 98922,
  [SMALL_STATE(2811)] = 98936,
  [SMALL_STATE(2812)] = 98950,
  [SMALL_STATE(2813)] = 98964,
  [SMALL_STATE(2814)] = 98978,
  [SMALL_STATE(2815)] = 98992,
  [SMALL_STATE(2816)] = 99006,
  [SMALL_STATE(2817)] = 99020,
  [SMALL_STATE(2818)] = 99034,
  [SMALL_STATE(2819)] = 99048,
  [SMALL_STATE(2820)] = 99062,
  [SMALL_STATE(2821)] = 99076,
  [SMALL_STATE(2822)] = 99090,
  [SMALL_STATE(2823)] = 99104,
  [SMALL_STATE(2824)] = 99118,
  [SMALL_STATE(2825)] = 99132,
  [SMALL_STATE(2826)] = 99146,
  [SMALL_STATE(2827)] = 99160,
  [SMALL_STATE(2828)] = 99174,
  [SMALL_STATE(2829)] = 99188,
  [SMALL_STATE(2830)] = 99202,
  [SMALL_STATE(2831)] = 99216,
  [SMALL_STATE(2832)] = 99230,
  [SMALL_STATE(2833)] = 99244,
  [SMALL_STATE(2834)] = 99258,
  [SMALL_STATE(2835)] = 99272,
  [SMALL_STATE(2836)] = 99286,
  [SMALL_STATE(2837)] = 99300,
  [SMALL_STATE(2838)] = 99314,
  [SMALL_STATE(2839)] = 99328,
  [SMALL_STATE(2840)] = 99342,
  [SMALL_STATE(2841)] = 99356,
  [SMALL_STATE(2842)] = 99370,
  [SMALL_STATE(2843)] = 99384,
  [SMALL_STATE(2844)] = 99398,
  [SMALL_STATE(2845)] = 99412,
  [SMALL_STATE(2846)] = 99426,
  [SMALL_STATE(2847)] = 99440,
  [SMALL_STATE(2848)] = 99454,
  [SMALL_STATE(2849)] = 99468,
  [SMALL_STATE(2850)] = 99482,
  [SMALL_STATE(2851)] = 99496,
  [SMALL_STATE(2852)] = 99510,
  [SMALL_STATE(2853)] = 99524,
  [SMALL_STATE(2854)] = 99538,
  [SMALL_STATE(2855)] = 99552,
  [SMALL_STATE(2856)] = 99566,
  [SMALL_STATE(2857)] = 99580,
  [SMALL_STATE(2858)] = 99594,
  [SMALL_STATE(2859)] = 99608,
  [SMALL_STATE(2860)] = 99622,
  [SMALL_STATE(2861)] = 99636,
  [SMALL_STATE(2862)] = 99650,
  [SMALL_STATE(2863)] = 99664,
  [SMALL_STATE(2864)] = 99678,
  [SMALL_STATE(2865)] = 99692,
  [SMALL_STATE(2866)] = 99706,
  [SMALL_STATE(2867)] = 99720,
  [SMALL_STATE(2868)] = 99734,
  [SMALL_STATE(2869)] = 99748,
  [SMALL_STATE(2870)] = 99762,
  [SMALL_STATE(2871)] = 99776,
  [SMALL_STATE(2872)] = 99790,
  [SMALL_STATE(2873)] = 99804,
  [SMALL_STATE(2874)] = 99818,
  [SMALL_STATE(2875)] = 99832,
  [SMALL_STATE(2876)] = 99846,
  [SMALL_STATE(2877)] = 99860,
  [SMALL_STATE(2878)] = 99874,
  [SMALL_STATE(2879)] = 99888,
  [SMALL_STATE(2880)] = 99902,
  [SMALL_STATE(2881)] = 99916,
  [SMALL_STATE(2882)] = 99930,
  [SMALL_STATE(2883)] = 99944,
  [SMALL_STATE(2884)] = 99958,
  [SMALL_STATE(2885)] = 99972,
  [SMALL_STATE(2886)] = 99986,
  [SMALL_STATE(2887)] = 100000,
  [SMALL_STATE(2888)] = 100014,
  [SMALL_STATE(2889)] = 100028,
  [SMALL_STATE(2890)] = 100042,
  [SMALL_STATE(2891)] = 100056,
  [SMALL_STATE(2892)] = 100070,
  [SMALL_STATE(2893)] = 100084,
  [SMALL_STATE(2894)] = 100098,
  [SMALL_STATE(2895)] = 100112,
  [SMALL_STATE(2896)] = 100126,
  [SMALL_STATE(2897)] = 100140,
  [SMALL_STATE(2898)] = 100154,
  [SMALL_STATE(2899)] = 100168,
  [SMALL_STATE(2900)] = 100182,
  [SMALL_STATE(2901)] = 100196,
  [SMALL_STATE(2902)] = 100210,
  [SMALL_STATE(2903)] = 100224,
  [SMALL_STATE(2904)] = 100238,
  [SMALL_STATE(2905)] = 100252,
  [SMALL_STATE(2906)] = 100266,
  [SMALL_STATE(2907)] = 100280,
  [SMALL_STATE(2908)] = 100294,
  [SMALL_STATE(2909)] = 100308,
  [SMALL_STATE(2910)] = 100322,
  [SMALL_STATE(2911)] = 100336,
  [SMALL_STATE(2912)] = 100350,
  [SMALL_STATE(2913)] = 100364,
  [SMALL_STATE(2914)] = 100378,
  [SMALL_STATE(2915)] = 100392,
  [SMALL_STATE(2916)] = 100406,
  [SMALL_STATE(2917)] = 100420,
  [SMALL_STATE(2918)] = 100434,
  [SMALL_STATE(2919)] = 100448,
  [SMALL_STATE(2920)] = 100452,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2730),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1512),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1356),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(772),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2775),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(724),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(579),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(425),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1093),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2826),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2491),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1443),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1744),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1188),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(439),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1260),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(700),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1209),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(432),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(600),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1000),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(618),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2568),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1729),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1091),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(702),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2427),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(704),
  [290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2634),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(875),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1107),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(453),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2265),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2773),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(944),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2318),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2323),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1085),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2917),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1139),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2246),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2512),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1109),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2730),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(498),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2301),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(696),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2845),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(435),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(796),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(428),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(579),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2567),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1443),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1744),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1221),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(439),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1260),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1209),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2277),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(781),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2913),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2730),
  [571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1905),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 3, 0, 0), SHIFT(465),
  [589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 3, 0, 0),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 3, 0, 0), SHIFT(431),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 4, 0, 0), SHIFT(465),
  [597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 4, 0, 0),
  [599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 4, 0, 0), SHIFT(431),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 5, 0, 105), SHIFT(465),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 5, 0, 105),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 5, 0, 105), SHIFT(431),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 5, 0, 106), SHIFT(465),
  [613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 5, 0, 106),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 5, 0, 106), SHIFT(431),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 110), SHIFT(465),
  [621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 110),
  [623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 6, 0, 110), SHIFT(431),
  [626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 111), SHIFT(465),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 111),
  [631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 6, 0, 111), SHIFT(431),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 105), SHIFT(465),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 105),
  [639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 6, 0, 105), SHIFT(431),
  [642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 106), SHIFT(465),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 6, 0, 106),
  [647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 6, 0, 106), SHIFT(431),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 111), SHIFT(465),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 111),
  [655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 7, 0, 111), SHIFT(431),
  [658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 105), SHIFT(465),
  [661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 105),
  [663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 7, 0, 105), SHIFT(431),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 110), SHIFT(465),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 110),
  [671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 7, 0, 110), SHIFT(431),
  [674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 8, 0, 111), SHIFT(465),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 8, 0, 111),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 8, 0, 111), SHIFT(431),
  [682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 8, 0, 110), SHIFT(465),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 8, 0, 110),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 8, 0, 110), SHIFT(431),
  [690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 106), SHIFT(465),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 7, 0, 106),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 7, 0, 106), SHIFT(431),
  [698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(465),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(724),
  [704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(425),
  [707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1093),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0),
  [712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(700),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(453),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(452),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1091),
  [724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(427),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(702),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2427),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(704),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2634),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1924),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2373),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(875),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1107),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2265),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2773),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(944),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2318),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2323),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2351),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1085),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2917),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1139),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(483),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2246),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2512),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1109),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(498),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2301),
  [796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(696),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(2845),
  [802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(435),
  [805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(436),
  [808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(796),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(824),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(431),
  [817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(810),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_statement, 2, 0, 0), SHIFT(465),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_statement, 2, 0, 0),
  [825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_statement, 2, 0, 0), SHIFT(431),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 3, 0, 79), SHIFT(465),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 3, 0, 79),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 5, 0, 0), SHIFT(465),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 5, 0, 0),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 6, 0, 79), SHIFT(465),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 6, 0, 79),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 2, 0, 0), SHIFT(465),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 2, 0, 0),
  [856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 3, 0, 0), SHIFT(465),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 3, 0, 0),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 4, 0, 79), SHIFT(465),
  [864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 4, 0, 79),
  [866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 4, 0, 0), SHIFT(465),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 4, 0, 0),
  [871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elsewhere_clause, 5, 0, 79), SHIFT(465),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsewhere_clause, 5, 0, 79),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 3, 0, 83), SHIFT(465),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 3, 0, 83),
  [881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 3, 0, 83), SHIFT(431),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 7, 0, 0), SHIFT(465),
  [891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 7, 0, 0),
  [893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 7, 0, 0), SHIFT(431),
  [896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 7, 0, 0), SHIFT(465),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 7, 0, 0),
  [901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 7, 0, 0), SHIFT(431),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 6, 0, 0), SHIFT(465),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 6, 0, 0),
  [909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 6, 0, 0), SHIFT(431),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 83), SHIFT(465),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 83),
  [923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 83), SHIFT(431),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 6, 0, 0), SHIFT(465),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 6, 0, 0),
  [937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 6, 0, 0), SHIFT(431),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 83), SHIFT(465),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 83),
  [945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 83), SHIFT(431),
  [948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 4, 0, 83), SHIFT(465),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 4, 0, 83),
  [953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 4, 0, 83), SHIFT(431),
  [956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 0), SHIFT(465),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 0),
  [961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 5, 0, 0), SHIFT(431),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 83), SHIFT(465),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 83),
  [969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_statement, 5, 0, 83), SHIFT(431),
  [972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 5, 0, 0), SHIFT(465),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 5, 0, 0),
  [977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 5, 0, 0), SHIFT(431),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_rank_statement, 5, 0, 83), SHIFT(465),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rank_statement, 5, 0, 83),
  [985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rank_statement, 5, 0, 83), SHIFT(431),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 104), SHIFT(465),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 104), SHIFT(453),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 104),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 6, 0, 104), SHIFT(431),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 109), SHIFT(465),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 109), SHIFT(453),
  [1005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 109),
  [1007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 5, 0, 109), SHIFT(431),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [1016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 7, 0, 109), SHIFT(465),
  [1019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 7, 0, 109), SHIFT(453),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 7, 0, 109),
  [1024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 7, 0, 109), SHIFT(431),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 104), SHIFT(465),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 104), SHIFT(453),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 104),
  [1035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 104), SHIFT(431),
  [1038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 109), SHIFT(465),
  [1041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 109), SHIFT(453),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 6, 0, 109),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 6, 0, 109), SHIFT(431),
  [1049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 104), SHIFT(465),
  [1052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 104), SHIFT(453),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 5, 0, 104),
  [1057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_elseif_clause, 5, 0, 104), SHIFT(431),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 78), SHIFT(465),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 78), SHIFT(453),
  [1066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 78), SHIFT(431),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 78), SHIFT(465),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 78), SHIFT(453),
  [1075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 78), SHIFT(431),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 4, 0, 78), SHIFT(465),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_else_clause, 4, 0, 78), SHIFT(453),
  [1084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_else_clause, 4, 0, 78), SHIFT(431),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_subroutine_statement, 3, 0, 70),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_subroutine_statement, 3, 0, 70),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_subroutine_statement, 3, 0, 53),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_subroutine_statement, 3, 0, 53),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_statement, 3, 0, 29),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_statement, 3, 0, 29),
  [1105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 0),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 0),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_program_statement, 2, 0, 0),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_program_statement, 2, 0, 0),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, 0, 0),
  [1115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, 0, 0),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_submodule_statement, 3, 0, 51),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_submodule_statement, 3, 0, 51),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_submodule_statement, 3, 0, 30),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_submodule_statement, 3, 0, 30),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_submodule, 4, 0, 0),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_submodule, 4, 0, 0),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program, 2, 0, 0),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_interface_statement, 3, 0, 52),
  [1135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_interface_statement, 3, 0, 52),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_subroutine_statement, 4, 0, 70),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_subroutine_statement, 4, 0, 70),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine, 6, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine, 6, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_interface_statement, 3, 0, 31),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_interface_statement, 3, 0, 31),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_subroutine_statement, 2, 0, 53),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_subroutine_statement, 2, 0, 53),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program, 3, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_function_statement, 4, 0, 71),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_function_statement, 4, 0, 71),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program, 1, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine, 4, 0, 0),
  [1167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine, 4, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_statement, 2, 0, 29),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_statement, 2, 0, 29),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3, 0, 0),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_function_statement, 2, 0, 54),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_function_statement, 2, 0, 54),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 1, 0, 0),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 1, 0, 0),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, 0, 0),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, 0, 0),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, 0, 0),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, 0, 0),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_submodule_statement, 2, 0, 30),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_submodule_statement, 2, 0, 30),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_submodule, 3, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_submodule, 3, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, 0, 0),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_program_statement, 4, 0, 0),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_program_statement, 4, 0, 0),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_submodule, 2, 0, 0),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_submodule, 2, 0, 0),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 2, 0, 0),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 2, 0, 0),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_function_statement, 3, 0, 71),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_function_statement, 3, 0, 71),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_function_statement, 3, 0, 54),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_function_statement, 3, 0, 54),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_interface_statement, 2, 0, 31),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_interface_statement, 2, 0, 31),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, 0, 0),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, 0, 0),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 3, 0, 0),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface, 3, 0, 0),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_program_statement, 3, 0, 0),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_program_statement, 3, 0, 0),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine, 3, 0, 0),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine, 3, 0, 0),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 5, 0, 0),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program, 5, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_statement, 4, 0, 50),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_statement, 4, 0, 50),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_submodule_statement, 4, 0, 51),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_submodule_statement, 4, 0, 51),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 4, 0, 0),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program, 4, 0, 0),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_interface_statement, 4, 0, 52),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_interface_statement, 4, 0, 52),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_statement, 3, 0, 50),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_statement, 3, 0, 50),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine, 5, 0, 0),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subroutine, 5, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specification_part, 2, 0, 0),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specification_part, 2, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specification_part, 1, 0, 0),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specification_part, 1, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 2, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 2, 0, 0),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specification_part, 3, 0, 0),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specification_part, 3, 0, 0),
  [1295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_type_statement, 2, 0, 34),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_type_statement, 2, 0, 34),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 3, 0, 0),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 3, 0, 0),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 3, 0, 0),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 3, 0, 0),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_type_statement, 3, 0, 56),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_type_statement, 3, 0, 56),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_type_statement, 3, 0, 34),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_type_statement, 3, 0, 34),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 4, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 4, 0, 0),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum, 4, 0, 0),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum, 4, 0, 0),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_type_statement, 4, 0, 56),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_type_statement, 4, 0, 56),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 5, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 5, 0, 0),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 6, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 6, 0, 0),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 7, 0, 0),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 7, 0, 0),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_definition, 8, 0, 0),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_definition, 8, 0, 0),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 2),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 2),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 4),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 4),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 6),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 6),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_program_statement, 2, 0, 8),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program_statement, 2, 0, 8),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1, 0, 9),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1, 0, 9),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [1431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [1433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), REDUCE(sym_identifier, 1, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [1438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), REDUCE(sym_identifier, 1, 0, 0),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [1455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(579),
  [1458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [1461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2567),
  [1464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [1467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1443),
  [1470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1744),
  [1473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1221),
  [1476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(439),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [1485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1982),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1260),
  [1491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1209),
  [1494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [1497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [1500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [1503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(781),
  [1506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2913),
  [1509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [1512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [1515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [1518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [1521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [1524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [1527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2730),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_label, 1, 0, 1),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_label, 1, 0, 1),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0), SHIFT(729),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [1551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0), SHIFT(706),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0), SHIFT(2845),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 1, 0, 0),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intrinsic_type, 1, 0, 0),
  [1575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_intrinsic_type, 1, 0, 0), REDUCE(sym_identifier, 1, 0, 0),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intrinsic_type, 1, 0, 0),
  [1580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_intrinsic_type, 1, 0, 0), REDUCE(sym_identifier, 1, 0, 0),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_attributes, 4, 0, 0),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_attributes, 4, 0, 0),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_attributes, 4, 0, 0),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__callable_interface_qualifers, 1, 0, 0),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 1, 0, 0),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0), SHIFT_REPEAT(2567),
  [1618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [1629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_statement, 1, 0, 0),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_statement, 1, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_specifier, 1, 0, 0),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 5, 0, 63),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 5, 0, 63),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 3),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 3),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 2, 0, 0),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 2, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 3, 0, 0),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 3, 0, 0),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 1, 0),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 1, 0),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_modification_repeat1, 1, 0, 0),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_modification_repeat1, 1, 0, 0),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 1, 0),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 1, 0),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 1, 0),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 1, 0),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 4, 0, 44),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 4, 0, 44),
  [1698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 4, 0, 0),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 4, 0, 0),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extent_specifier, 1, 0, 0),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extent_specifier, 2, 0, 0),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_write_statement, 2, 0, 0),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__forall_control_expression, 6, 0, 0),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_control_expression, 6, 0, 0),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__forall_control_expression, 4, 0, 0),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_control_expression, 4, 0, 0),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__forall_control_expression, 5, 0, 0),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_control_expression, 5, 0, 0),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__intrinsic_type, 1, 0, 0),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__intrinsic_type, 1, 0, 0),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__forall_control_expression, 7, 0, 0),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_control_expression, 7, 0, 0),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [1796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_statement, 2, 0, 0),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inquire_statement, 2, 0, 0),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ac_value_list, 1, 0, 18),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameterized_read_statement, 2, 0, 0),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 2, 0, 0),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_write_statement, 3, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_if_statement, 1, 0, 64),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 1, 0, 0), SHIFT(465),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_statement, 1, 0, 0),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 1, 0, 0), SHIFT(453),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 1, 0, 0), SHIFT(452),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_statement, 2, 0, 0),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_statement, 2, 0, 0),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 2, 0, 0), SHIFT(465),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_statement, 2, 0, 0),
  [1926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 2, 0, 0), SHIFT(453),
  [1929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_interface_statement, 2, 0, 0), SHIFT(452),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_submodule_statement, 7, 0, 90),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_submodule_statement, 7, 0, 90),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_submodule_statement, 5, 0, 58),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_submodule_statement, 5, 0, 58),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intrinsic_type, 2, 0, 0),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intrinsic_type, 2, 0, 0),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intrinsic_type, 2, 0, 15),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intrinsic_type, 2, 0, 15),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intrinsic_type, 1, 0, 5),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intrinsic_type, 1, 0, 5),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_size, 1, 0, 0),
  [1958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_size, 1, 0, 0),
  [1960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type, 4, 0, 0),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type, 4, 0, 0),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type, 4, 1, 0),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type, 4, 1, 0),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type, 4, 0, 43),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type, 4, 0, 43),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type, 4, 1, 43),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type, 4, 1, 43),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 1, 0, 0),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0), REDUCE(sym_argument_list, 3, 1, 0),
  [1995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0), REDUCE(sym_argument_list, 3, 1, 0),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_size, 2, 0, 0),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_size, 2, 0, 0),
  [2006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_size, 2, 0, 35),
  [2008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_size, 2, 0, 35),
  [2010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__intrinsic_type, 2, 0, 0),
  [2012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__intrinsic_type, 2, 0, 0),
  [2014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 1, 0, 0),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0),
  [2078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [2086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [2089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [2092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [2095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(2420),
  [2098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(754),
  [2101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [2104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(2317),
  [2107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1549),
  [2110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [2113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 2, 0, 0), SHIFT_REPEAT(1729),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_qualifier, 1, 0, 0),
  [2120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_procedure_qualifier, 1, 0, 0), SHIFT(568),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_procedure_qualifier, 1, 0, 0), SHIFT(609),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 6, 0, 0),
  [2136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 6, 0, 0), SHIFT(1797),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 6, 0, 0),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 3, 0, 0),
  [2143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 3, 0, 0), SHIFT(1797),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 3, 0, 0),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 4, 0, 0),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 4, 0, 0), SHIFT(1797),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 4, 0, 0),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0),
  [2157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(471),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 7, 0, 42),
  [2164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 7, 0, 42), SHIFT(1797),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 7, 0, 42),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 6, 0, 42),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 6, 0, 42), SHIFT(1797),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 6, 0, 42),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 5, 0, 0),
  [2178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 5, 0, 0), SHIFT(1797),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 5, 0, 0),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_procedure_statement_repeat1, 2, 0, 0),
  [2185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1797),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat1, 2, 0, 0),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1196),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 0),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 0),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implied_do_loop_expression, 5, 0, 0),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implied_do_loop_expression, 5, 0, 0),
  [2205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_constructor_legacy, 3, 0, 28),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_constructor_legacy, 3, 0, 28),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_constructor_f2003, 3, 0, 28),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_constructor_f2003, 3, 0, 28),
  [2213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null_literal, 3, 0, 0),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_literal, 3, 0, 0),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 8, 0, 0),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 8, 0, 0),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex_literal, 5, 0, 0),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_literal, 5, 0, 0),
  [2229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 4, 0, 0),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 4, 0, 0),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 1, 0, 0),
  [2235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_procedure_declaration, 1, 0, 0), SHIFT(1491),
  [2238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 1, 0, 0), SHIFT(1802),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 1, 0, 0),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implied_do_loop_expression, 6, 0, 0),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implied_do_loop_expression, 6, 0, 0),
  [2247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 5, 0, 0),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 5, 0, 0),
  [2251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_attribute, 4, 0, 0),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_attribute, 4, 0, 0),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 1, 0, 7),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 1, 0, 7),
  [2259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 3, 0, 0), SHIFT(1796),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_spec, 2, 0, 0),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_spec, 2, 0, 0),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_attribute, 1, 0, 0),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_attribute, 1, 0, 0),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_member_expression, 3, 0, 40),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_member_expression, 3, 0, 40),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 6, 0, 0),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 6, 0, 0),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_call_expression_repeat1, 1, 0, 0),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 1, 0, 0),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 3, 0, 0),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 3, 0, 0),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_declaration, 4, 0, 42),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_procedure_declaration, 4, 0, 42), SHIFT(1799),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 4, 0, 42),
  [2295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__io_arguments, 7, 0, 0),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_arguments, 7, 0, 0),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_expression, 3, 0, 39),
  [2303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_expression, 3, 0, 39),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_expression, 3, 0, 39),
  [2323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_expression, 3, 0, 39),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_expression, 3, 0, 39),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_expression, 3, 0, 39),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 14),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 14),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation_expression, 3, 0, 39),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation_expression, 3, 0, 39),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_expression, 2, 0, 0),
  [2343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_expression, 2, 0, 0),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0),
  [2347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1715),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0),
  [2352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1451),
  [2355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [2358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [2361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(2420),
  [2364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [2367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(2317),
  [2370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1549),
  [2373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [2376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1729),
  [2379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_procedures, 2, 0, 0),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_procedures, 2, 0, 0),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_procedures, 3, 0, 0),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_procedures, 3, 0, 0),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_operator, 3, 0, 0),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_operator, 3, 0, 0),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_value_range_list, 1, 0, 0),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cuda_kernel_argument_list_repeat1, 2, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ac_value_list, 1, 0, 0),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ac_value_list, 2, 0, 18),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_output_item_list, 1, 0, 0),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_targets, 1, 0, 0),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triplet_spec, 5, 0, 0),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_included_items, 3, 0, 0),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extent_specifier, 3, 0, 0),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_call, 2, 0, 16),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_input_item_list, 1, 0, 0),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_value_range_list_repeat1, 2, 0, 0),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_control, 5, 0, 103),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_association, 3, 0, 69),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [2712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extent_specifier, 4, 0, 0),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_control_expression, 5, 0, 0),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extent_specifier, 5, 0, 0),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 3, 0, 0),
  [2724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triplet_spec, 7, 0, 0),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_control, 7, 0, 113),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [2736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1530),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(470),
  [2744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 38),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_association_statement, 3, 0, 0),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_targets_repeat1, 2, 0, 0),
  [2760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 59),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_assignment, 3, 0, 0),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 6, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 4, 0, 0),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 4, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 7, 0, 0),
  [2774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 7, 0, 0),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 6, 0, 42),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 6, 0, 42),
  [2782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 6, 0, 0),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 6, 0, 0),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 8, 0, 0),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_control_expression, 7, 0, 0),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [2794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 7, 0, 42),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 7, 0, 42),
  [2798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 7, 0, 0),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 7, 0, 0),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [2806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 8, 0, 42),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 8, 0, 42),
  [2810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 8, 0, 0),
  [2812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 8, 0, 0),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 9, 0, 42),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 9, 0, 42),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 9, 0, 0),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 9, 0, 0),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 10, 0, 42),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 10, 0, 42),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 11, 0, 42),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 11, 0, 42),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 12, 0, 42),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 12, 0, 42),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_procedure_statement_repeat2, 2, 0, 0),
  [2838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat2, 2, 0, 0),
  [2840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(951),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 1, 0, 0),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 1, 0, 0),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [2851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 2, 0, 0),
  [2853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 2, 0, 0),
  [2855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 3, 0, 0),
  [2857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 3, 0, 0),
  [2859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 2, 0, 0),
  [2861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 2, 0, 0),
  [2863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_name, 1, 0, 32),
  [2865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_name, 1, 0, 32),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding_name, 1, 0, 0),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 5, 0, 0),
  [2873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 5, 0, 0),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 6, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 3, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 3, 0, 0),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 5, 0, 42),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 5, 0, 42),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_statement, 5, 0, 0),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_statement, 5, 0, 0),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stop_statement, 5, 0, 0),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 5, 0, 0),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0), SHIFT(670),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 4, 0, 0),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 4, 0, 0),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__io_expressions, 1, 0, 0),
  [2954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 1, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__generic_procedure, 1, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_procedure, 1, 0, 0),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 4, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 4, 0, 0),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 4, 0, 0),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 4, 0, 0),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defined_io_procedure, 4, 0, 0),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defined_io_procedure, 4, 0, 0),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_procedure_statement_repeat2, 4, 0, 0),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat2, 4, 0, 0),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_call, 3, 0, 16),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_identifier, 1, 0, 0),
  [2988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2, 0, 0),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procedure_kind, 2, 0, 0),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procedure_kind, 2, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(2312),
  [3003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(2324),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [3008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1433),
  [3011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1339),
  [3014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1520),
  [3017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1434),
  [3020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1437),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procedure_kind, 1, 0, 0),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procedure_kind, 1, 0, 0),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_repeat1, 1, 0, 0),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_repeat1, 1, 0, 0),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_names, 2, 0, 25),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_names, 2, 0, 25),
  [3047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_statement, 2, 0, 0),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [3060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(901),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_equivalence_set_repeat1, 2, 0, 0),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 1, 0, 0),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_statement, 3, 0, 0),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_statement, 3, 0, 0),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_common_statement, 2, 0, 0),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(904),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_group, 4, 0, 0),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_group, 4, 0, 0),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [3120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_group, 5, 0, 0),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_group, 5, 0, 0),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_value_repeat1, 4, 0, 92),
  [3144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(aux_sym_data_value_repeat1, 4, 0, 92),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1534),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_value_repeat1, 2, 0, 0),
  [3176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(aux_sym_data_value_repeat1, 2, 0, 0),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 1, 0, 0),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_common_statement_repeat1, 1, 0, 0),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_common_statement_repeat1, 2, 0, 0),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_set_repeat1, 2, 0, 0),
  [3195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), REDUCE(aux_sym_data_set_repeat1, 2, 0, 0),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_public_statement, 4, 0, 0),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_statement, 4, 0, 0),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_where_statement, 1, 0, 47),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_select_statement, 1, 0, 66),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block_construct_statement, 2, 0, 48),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [3228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_private_statement_repeat1, 2, 0, 0),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_private_statement_repeat1, 2, 0, 0),
  [3232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_private_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1105),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_associate_statement, 2, 0, 95),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_if_statement, 2, 0, 77),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(1729),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0),
  [3262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(2732),
  [3265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(2420),
  [3268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(1544),
  [3271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(2317),
  [3274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(1549),
  [3277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 2, 0, 0), SHIFT_REPEAT(2892),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block_construct_statement, 1, 0, 27),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_forall_statement, 2, 0, 57),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [3314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_forall_statement, 1, 0, 36),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [3318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_select_statement, 2, 0, 84),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [3334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_public_statement, 3, 0, 0),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_statement, 3, 0, 0),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_associate_statement, 1, 0, 85),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_do_loop_statement, 2, 0, 45),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_do_loop_statement, 1, 0, 26),
  [3380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_where_statement, 2, 0, 65),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [3390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_statement, 3, 0, 0),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_statement, 3, 0, 0),
  [3394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_label_reference, 1, 0, 10),
  [3396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_label_reference, 1, 0, 10),
  [3398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_public_statement, 1, 0, 0),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_statement, 4, 0, 0),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_statement, 4, 0, 0),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_statement, 1, 0, 0),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_default, 1, 0, 0),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_default, 1, 0, 0),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_default, 2, 0, 0),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_default, 2, 0, 0),
  [3436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0),
  [3438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2900),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [3449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2277),
  [3452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(781),
  [3455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2913),
  [3458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_procedure, 6, 0, 0),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure, 6, 0, 0),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_internal_procedures_repeat1, 1, 0, 0),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_internal_procedures_repeat1, 1, 0, 0),
  [3469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_procedure, 3, 0, 0),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure, 3, 0, 0),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_procedure_statement, 2, 0, 86),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_procedure_statement, 2, 0, 86),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_procedure, 4, 0, 0),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure, 4, 0, 0),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_procedure_statement, 3, 0, 96),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_procedure_statement, 3, 0, 96),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_procedure_statement, 3, 0, 86),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_procedure_statement, 3, 0, 86),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_procedure, 5, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure, 5, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_module_procedure_statement, 4, 0, 96),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_module_procedure_statement, 4, 0, 96),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_qualifier, 1, 0, 0),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_attributes, 5, 0, 0),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure_attributes, 5, 0, 0),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 7, 0, 97),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 7, 0, 97),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 6, 0, 73),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 6, 0, 73),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 7, 0, 91),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 7, 0, 91),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_attributes, 4, 0, 0),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 3, 0, 0),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 3, 0, 0),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 4, 0, 0),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 4, 0, 0),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__callable_interface_qualifers, 1, 0, 0),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 8, 0, 107),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 8, 0, 107),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_statement, 5, 0, 0),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_statement, 5, 0, 0),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_procedures, 1, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_procedures, 1, 0, 0),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_procedures, 2, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_procedures, 2, 0, 0),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0),
  [3567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2534),
  [3570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2295),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0),
  [3575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [3578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2550),
  [3581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_type_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1528),
  [3584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_procedures, 4, 0, 0),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_procedures, 4, 0, 0),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_derived_type_procedures, 3, 0, 0),
  [3610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_derived_type_procedures, 3, 0, 0),
  [3612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 2, 0, 0),
  [3614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(2545),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [3620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 2, 0, 0),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contains_statement, 1, 0, 0),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contains_statement, 1, 0, 0),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [3636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_label_start_expression, 2, 0, 20),
  [3638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_label_start_expression, 2, 0, 20),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [3648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_procedure_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(974),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transfer_items, 1, 0, 0),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 2, 0, 11),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transfer_items, 2, 0, 0),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 3, 0, 33),
  [3685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1828),
  [3688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0),
  [3690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1851),
  [3693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1846),
  [3696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1836),
  [3699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1846),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 1, 0, 0),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_derived_type_procedures_repeat1, 1, 0, 0),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_type_statement_repeat1, 1, 0, 0),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_type_statement_repeat1, 1, 0, 0),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_statement, 1, 0, 0),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_statement, 2, 0, 0),
  [3736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_if_statement_repeat1, 2, 0, 0),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_if_statement_repeat1, 2, 0, 0),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2368),
  [3743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2272),
  [3746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concurrent_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2565),
  [3749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concurrent_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2565),
  [3752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concurrent_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2569),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concurrent_statement_repeat1, 2, 0, 0),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 2, 0, 11),
  [3759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2385),
  [3762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2876),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_statement_repeat1, 2, 0, 0),
  [3767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 3, 0, 11),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hollerith_constant, 1, 0, 0),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hollerith_constant, 1, 0, 0),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 4, 0, 55),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 4, 0, 33),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_where_statement_repeat1, 2, 0, 0),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_where_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2435),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_where_statement_repeat1, 2, 0, 0),
  [3790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_where_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1177),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 3, 0, 33),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_rank_statement_repeat1, 2, 0, 0),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_rank_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [3800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_rank_statement_repeat1, 2, 0, 0),
  [3802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__transfer_items_repeat1, 2, 0, 0),
  [3804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 3, 0, 21),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_statement, 3, 0, 0),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_statement, 3, 0, 0),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transfer_item, 1, 0, 0),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__transfer_item, 1, 0, 0),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_statement, 2, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_statement, 2, 0, 0),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__transfer_items_repeat1, 1, 0, 0),
  [3826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__transfer_items_repeat1, 1, 0, 0),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_case_statement_repeat1, 2, 0, 0),
  [3830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2286),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_case_statement_repeat1, 2, 0, 0),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 5, 0, 55),
  [3837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_statement, 4, 0, 21),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__transfer_item, 3, 0, 0),
  [3841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__transfer_item, 3, 0, 0),
  [3843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_statement, 4, 0, 0),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_statement, 4, 0, 0),
  [3847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cuda_kernel_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(693),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_statement_repeat1, 2, 0, 0),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_statement_repeat1, 2, 0, 0),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 0),
  [3858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 0), SHIFT_REPEAT(1513),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 2, 0, 0),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 6, 0, 93),
  [3865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 6, 0, 93),
  [3867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 6, 0, 94),
  [3869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 6, 0, 94),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_locality, 4, 0, 0),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_locality, 4, 0, 0),
  [3875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_locality, 4, 0, 76),
  [3877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_locality, 4, 0, 76),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 8, 0, 108),
  [3881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 8, 0, 108),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_locality, 5, 0, 0),
  [3885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_locality, 5, 0, 0),
  [3887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_statement, 5, 0, 0),
  [3889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_statement, 5, 0, 0),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_language_binding, 6, 0, 0),
  [3893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_language_binding, 6, 0, 0),
  [3895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1553),
  [3898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 7, 0, 102),
  [3900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 7, 0, 102),
  [3902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 4, 0, 0),
  [3904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 4, 0, 0),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concurrent_statement_repeat1, 1, 0, 0),
  [3908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concurrent_statement_repeat1, 1, 0, 0),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 9, 0, 112),
  [3912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 9, 0, 112),
  [3914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_statement, 6, 0, 0),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_statement, 6, 0, 0),
  [3918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_language_binding, 4, 0, 0),
  [3920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_language_binding, 4, 0, 0),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 5, 0, 0),
  [3924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 5, 0, 0),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_if_statement_repeat1, 1, 0, 0),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_if_statement_repeat1, 1, 0, 0),
  [3930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concurrent_header, 7, 0, 93),
  [3932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concurrent_header, 7, 0, 93),
  [3934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1536),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [3939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_rank_statement_repeat1, 1, 0, 0),
  [3941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_rank_statement_repeat1, 1, 0, 0),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_where_statement_repeat1, 1, 0, 0),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_where_statement_repeat1, 1, 0, 0),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ac_value_list, 2, 0, 0),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_select_case_statement_repeat1, 1, 0, 0),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_case_statement_repeat1, 1, 0, 0),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_included_items, 4, 0, 0),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [3973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_length, 1, 0, 0),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namelist_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1517),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namelist_statement_repeat1, 2, 0, 0),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ac_value_list, 3, 0, 18),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [3996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_statement_repeat1, 4, 0, 0),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_statement_repeat1, 4, 0, 0),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [4004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namelist_statement, 2, 0, 0),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_input_item_list, 2, 0, 0),
  [4018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_output_item_list, 2, 0, 0),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, 0, 0),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_statement, 3, 0, 0),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 4, 0, 12),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_range, 1, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 4, 0, 0),
  [4080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_save_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1490),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_save_statement_repeat1, 2, 0, 0),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [4089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_associate_statement_repeat1, 2, 0, 0),
  [4091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_associate_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1489),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__forall_control_expression_repeat1, 2, 0, 0),
  [4106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_control_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1505),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 3, 0, 21),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, 0, 0),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_equivalence_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2303),
  [4128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_equivalence_statement_repeat1, 2, 0, 0),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(589),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_statement_repeat1, 2, 0, 0),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [4145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_set_repeat1, 2, 0, 0), SHIFT_REPEAT(737),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [4156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 2, 0, 0),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_statement_repeat1, 1, 0, 0),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [4174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_statement, 3, 0, 0),
  [4176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_statement, 3, 0, 0),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 3, 0, 22),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cuda_kernel_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(726),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [4237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 7, 0, 60),
  [4239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_included_items, 5, 0, 0),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [4251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(1764),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat2, 2, 0, 0),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [4258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_statement, 7, 0, 0),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_equivalence_set_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equivalence_statement, 2, 0, 0),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_result, 4, 0, 0),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 6, 0, 22),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 3, 0, 0),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 4, 0, 55),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_value_range_list, 2, 0, 0),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1484),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_statement_repeat1, 2, 0, 0),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat3, 2, 0, 0),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat3, 2, 0, 0), SHIFT_REPEAT(2271),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_statement, 6, 0, 0),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat1, 2, 0, 0),
  [4359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2275),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [4364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_targets_repeat1, 2, 0, 0), SHIFT_REPEAT(538),
  [4367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 6, 0, 0),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [4371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_length, 2, 0, 0),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_targets, 3, 0, 0),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 8, 0, 60),
  [4383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_included_items_repeat1, 2, 0, 0),
  [4385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_included_items_repeat1, 2, 0, 0), SHIFT_REPEAT(1006),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_statement, 8, 0, 0),
  [4392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_statement, 2, 0, 0),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_targets, 2, 0, 0),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__io_arguments_repeat1, 2, 0, 0),
  [4404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__io_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(1468),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assumed_size, 1, 0, 0),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [4417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 2, 0, 12),
  [4419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_procedure_attributes_repeat1, 2, 0, 0),
  [4421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_procedure_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(1904),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 5, 0, 60),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 5, 0, 22),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 5, 0, 12),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_statement, 5, 0, 0),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_value_range_list_repeat1, 2, 0, 0), SHIFT_REPEAT(540),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [4443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_derived_type_statement_repeat1, 2, 0, 62), SHIFT_REPEAT(1757),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_derived_type_statement_repeat1, 2, 0, 62),
  [4448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_save_statement, 5, 0, 0),
  [4450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_private_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1095),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_value_repeat1, 2, 0, 75), SHIFT_REPEAT(730),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_value_repeat1, 2, 0, 75),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(478),
  [4461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equivalence_statement, 3, 0, 0),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [4469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_statement_repeat1, 2, 0, 0),
  [4471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1496),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_keyword_statement_repeat1, 2, 0, 0),
  [4480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_keyword_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1987),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concurrent_header_repeat1, 2, 0, 0),
  [4497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concurrent_header_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [4500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_repeat1, 1, 0, 0),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_repeat1, 1, 0, 0),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_specifier, 1, 0, 0),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__derived_type_qualifier, 1, 0, 0),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_save_statement_repeat1, 4, 0, 0),
  [4524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat2, 7, 0, 0),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [4530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__derived_type_qualifier, 1, 0, 23),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_length, 5, 0, 0),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_set, 2, 0, 0),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__derived_type_qualifier, 1, 0, 24),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat2, 6, 0, 0),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_length, 4, 0, 0),
  [4554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_identifier, 1, 0, 0),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_value, 4, 0, 74),
  [4558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_derived_type_statement_repeat1, 2, 0, 61),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equivalence_set, 6, 0, 0),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namelist_statement_repeat1, 1, 0, 0),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type_specifier, 4, 0, 0),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_position_statement, 1, 0, 0),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_alias, 3, 0, 72),
  [4594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_set, 3, 0, 0),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implicit_statement_repeat2, 5, 0, 0),
  [4598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equivalence_set, 5, 0, 0),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_value, 5, 0, 92),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [4606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cuda_kernel_argument_list, 3, 0, 0),
  [4608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_value, 6, 0, 101),
  [4610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_range, 3, 0, 0),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_value, 3, 0, 0),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_read_statement, 2, 0, 0),
  [4622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 1, 0, 0),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assumed_shape, 1, 0, 0),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cuda_kernel_argument_list, 4, 0, 0),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_statement, 2, 0, 0),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [4638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_targets_repeat1, 3, 0, 0),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, 0, 0),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__file_position_spec, 5, 0, 0),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 7, 0, 0),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_read_statement, 1, 0, 0),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_statement, 3, 0, 0),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_where_statement, 6, 0, 0),
  [4702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 6, 0, 60),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arithmetic_if_statement, 7, 0, 0),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inquire_statement, 3, 0, 0),
  [4726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 4, 0, 22),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 11, 0, 0),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 7, 0, 80),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_label_statement, 4, 0, 0),
  [4754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 4, 0, 33),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 7, 0, 81),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 9, 0, 0),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 7, 0, 82),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 2, 0, 0),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_construct, 5, 0, 0),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_select_statement, 3, 0, 84),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_forall_statement, 3, 0, 57),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_forall_statement, 5, 0, 0),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 5, 0, 0),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [4822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_where_statement, 4, 0, 0),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_associate_statement, 2, 0, 85),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associate_statement, 7, 0, 0),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_close_statement, 7, 0, 0),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_close_statement, 5, 0, 0),
  [4842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__file_position_spec, 6, 0, 0),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 5, 0, 67),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 2, 0, 0),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__file_position_spec, 4, 0, 0),
  [4858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 3, 0, 11),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 13),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 6, 0, 80),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 6, 0, 81),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure_statement, 4, 0, 87),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 10, 0, 0),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [4912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_write_statement, 4, 0, 0),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 0),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_where_statement, 3, 0, 0),
  [4924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_label_statement, 3, 0, 0),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 6, 0, 82),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_forall_statement, 2, 0, 36),
  [4956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_forall_statement, 4, 0, 0),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 3, 0, 0),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_where_statement, 7, 0, 0),
  [4972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_if_statement, 2, 0, 64),
  [4974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 7, 0, 98),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 7, 0, 99),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [4984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 7, 0, 100),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_statement, 3, 0, 0),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 7, 0, 88),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 7, 0, 89),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_statement, 3, 0, 12),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [5030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_statement, 2, 0, 17),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [5050] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [5054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_statement, 4, 0, 0),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 4, 0, 21),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 3, 0, 0),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 6, 0, 88),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 6, 0, 89),
  [5086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [5092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_select_statement, 2, 0, 66),
  [5094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_construct, 6, 0, 0),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_forall_statement, 6, 0, 0),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 6, 0, 0),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [5114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block_construct_statement, 2, 0, 27),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_construct, 4, 0, 0),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unlimited_polymorphic, 1, 0, 0),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 5, 0, 68),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_statement, 4, 0, 49),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_forall_statement, 3, 0, 0),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, 0, 0),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [5158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_close_statement, 4, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [5166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [5172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_enum_statement, 2, 0, 37),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 8, 0, 0),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [5182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__file_position_spec, 3, 0, 0),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_call, 4, 0, 16),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_position_statement, 2, 0, 0),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [5198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_where_statement, 5, 0, 0),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [5218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_where_statement, 3, 0, 65),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_modification, 2, 0, 0),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 6, 0, 0),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [5308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 0),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [5312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 6, 0, 67),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 1, 0, 0),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_statement, 1, 0, 0),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_associate_statement, 3, 0, 95),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [5382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associate_statement, 8, 0, 0),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 6, 0, 68),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_do_loop_statement, 2, 0, 26),
  [5430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_label, 1, 0, 46),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_statement, 5, 0, 0),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_construct, 3, 0, 0),
  [5438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 4, 0, 0),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 7, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 6, 0, 0),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameterized_read_statement, 3, 0, 0),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_read_statement, 4, 0, 0),
  [5482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block_construct_statement, 3, 0, 48),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_procedure_statement, 3, 0, 33),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_modification, 3, 0, 0),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [5494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__file_position_spec, 1, 0, 0),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [5500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_forall_statement, 2, 0, 0),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_do_loop_statement, 3, 0, 45),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 5, 0, 0),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associate_statement, 6, 0, 0),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_loop_statement, 8, 0, 0),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_enum_statement, 1, 0, 19),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associate_statement, 9, 0, 0),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_type_statement, 8, 0, 98),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_case_statement, 8, 0, 99),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_rank_statement, 8, 0, 100),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall_statement, 1, 0, 0),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subroutine_statement, 5, 0, 55),
  [5660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_if_statement, 5, 0, 0),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [5664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_if_statement, 3, 0, 77),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_if_statement, 3, 0, 0),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_close_statement, 6, 0, 0),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [5690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_where_statement, 2, 0, 47),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [5696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_file_line, 5, 0, 41),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_file_line, 4, 0, 41),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_AMP = 0,
  ts_external_token__integer_literal = 1,
  ts_external_token__float_literal = 2,
  ts_external_token__boz_literal = 3,
  ts_external_token_string_literal = 4,
  ts_external_token__end_of_statement = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_AMP] = anon_sym_AMP,
  [ts_external_token__integer_literal] = sym__integer_literal,
  [ts_external_token__float_literal] = sym__float_literal,
  [ts_external_token__boz_literal] = sym__boz_literal,
  [ts_external_token_string_literal] = sym_string_literal,
  [ts_external_token__end_of_statement] = sym__end_of_statement,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__integer_literal] = true,
    [ts_external_token__float_literal] = true,
    [ts_external_token__boz_literal] = true,
    [ts_external_token_string_literal] = true,
    [ts_external_token__end_of_statement] = true,
  },
  [2] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__integer_literal] = true,
    [ts_external_token__float_literal] = true,
    [ts_external_token__boz_literal] = true,
    [ts_external_token_string_literal] = true,
  },
  [3] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__integer_literal] = true,
  },
  [4] = {
    [ts_external_token_AMP] = true,
  },
  [5] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__end_of_statement] = true,
  },
  [6] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__integer_literal] = true,
    [ts_external_token__end_of_statement] = true,
  },
  [7] = {
    [ts_external_token_AMP] = true,
    [ts_external_token__integer_literal] = true,
    [ts_external_token__float_literal] = true,
    [ts_external_token__boz_literal] = true,
  },
  [8] = {
    [ts_external_token_AMP] = true,
    [ts_external_token_string_literal] = true,
  },
  [9] = {
    [ts_external_token_AMP] = true,
    [ts_external_token_string_literal] = true,
    [ts_external_token__end_of_statement] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_fortran_external_scanner_create(void);
void tree_sitter_fortran_external_scanner_destroy(void *);
bool tree_sitter_fortran_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_fortran_external_scanner_serialize(void *, char *);
void tree_sitter_fortran_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_fortran(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_fortran_external_scanner_create,
      tree_sitter_fortran_external_scanner_destroy,
      tree_sitter_fortran_external_scanner_scan,
      tree_sitter_fortran_external_scanner_serialize,
      tree_sitter_fortran_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
