#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1576
#define LARGE_STATE_COUNT 6
#define SYMBOL_COUNT 271
#define ALIAS_COUNT 1
#define TOKEN_COUNT 95
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 76

enum {
  sym_module_comment = 1,
  sym_statement_comment = 2,
  sym_comment = 3,
  anon_sym_if = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym_erlang = 7,
  anon_sym_javascript = 8,
  anon_sym_AT = 9,
  anon_sym_LPAREN = 10,
  anon_sym_COMMA = 11,
  anon_sym_RPAREN = 12,
  anon_sym_COLON = 13,
  anon_sym_import = 14,
  anon_sym_DOT = 15,
  anon_sym_as = 16,
  anon_sym_SLASH = 17,
  anon_sym_type = 18,
  anon_sym_const = 19,
  anon_sym_EQ = 20,
  anon_sym_POUND = 21,
  anon_sym_LBRACK = 22,
  anon_sym_RBRACK = 23,
  anon_sym_LT_LT = 24,
  anon_sym_GT_GT = 25,
  anon_sym_DASH = 26,
  anon_sym_size = 27,
  anon_sym_fn = 28,
  anon_sym_DASH_GT = 29,
  anon_sym_external = 30,
  anon_sym_PIPE_PIPE = 31,
  anon_sym_AMP_AMP = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_LT = 35,
  anon_sym_LT_EQ = 36,
  anon_sym_LT_DOT = 37,
  anon_sym_LT_EQ_DOT = 38,
  anon_sym_GT = 39,
  anon_sym_GT_EQ = 40,
  anon_sym_GT_DOT = 41,
  anon_sym_GT_EQ_DOT = 42,
  anon_sym_PIPE_GT = 43,
  anon_sym_PLUS = 44,
  anon_sym_PLUS_DOT = 45,
  anon_sym_DASH_DOT = 46,
  anon_sym_STAR = 47,
  anon_sym_STAR_DOT = 48,
  anon_sym_SLASH_DOT = 49,
  anon_sym_PERCENT = 50,
  anon_sym_LT_GT = 51,
  anon_sym_todo = 52,
  anon_sym_panic = 53,
  anon_sym_DOT_DOT = 54,
  anon_sym_case = 55,
  anon_sym_PIPE = 56,
  anon_sym_let = 57,
  anon_sym_assert = 58,
  anon_sym_use = 59,
  anon_sym_LT_DASH = 60,
  anon_sym_BANG = 61,
  sym_visibility_modifier = 62,
  sym_opacity_modifier = 63,
  anon_sym_DQUOTE = 64,
  anon_sym_DQUOTE2 = 65,
  aux_sym_escape_sequence_token1 = 66,
  aux_sym_escape_sequence_token2 = 67,
  sym_float = 68,
  sym__hex = 69,
  sym__decimal = 70,
  sym__octal = 71,
  sym__binary = 72,
  anon_sym_binary = 73,
  anon_sym_bytes = 74,
  anon_sym_int = 75,
  anon_sym_float = 76,
  anon_sym_bit_string = 77,
  anon_sym_bits = 78,
  anon_sym_utf8 = 79,
  anon_sym_utf16 = 80,
  anon_sym_utf32 = 81,
  anon_sym_utf8_codepoint = 82,
  anon_sym_utf16_codepoint = 83,
  anon_sym_utf32_codepoint = 84,
  anon_sym_signed = 85,
  anon_sym_unsigned = 86,
  anon_sym_big = 87,
  anon_sym_little = 88,
  anon_sym_native = 89,
  anon_sym_unit = 90,
  sym__discard_name = 91,
  sym__name = 92,
  sym__upname = 93,
  sym_quoted_content = 94,
  sym_source_file = 95,
  sym__module_statement = 96,
  sym_target_group = 97,
  sym_target = 98,
  sym_attribute = 99,
  sym__attribute_arguments = 100,
  sym_attribute_value = 101,
  sym_import = 102,
  sym_module = 103,
  sym_unqualified_imports = 104,
  sym_unqualified_import = 105,
  sym_constant = 106,
  sym__constant_value = 107,
  sym_constant_tuple = 108,
  sym_constant_list = 109,
  sym__constant_bit_string = 110,
  sym_constant_bit_string_segment = 111,
  sym_constant_bit_string_segment_options = 112,
  sym__constant_bit_string_segment_option = 113,
  sym__constant_bit_string_named_segment_option = 114,
  sym__constant_bit_string_segment_option_size = 115,
  sym_constant_record = 116,
  sym_constant_record_arguments = 117,
  sym_constant_record_argument = 118,
  sym_constant_field_access = 119,
  sym__constant_type = 120,
  sym__constant_type_annotation = 121,
  sym_constant_tuple_type = 122,
  sym_constant_function_type = 123,
  sym_constant_function_parameter_types = 124,
  sym_constant_type = 125,
  sym_constant_type_arguments = 126,
  sym_constant_type_argument = 127,
  sym_external_type = 128,
  sym_external_function = 129,
  sym_external_function_parameters = 130,
  sym_external_function_parameter = 131,
  sym_external_function_body = 132,
  sym_function = 133,
  sym_function_parameters = 134,
  sym_function_parameter = 135,
  sym__labeled_discard_param = 136,
  sym__discard_param = 137,
  sym__labeled_name_param = 138,
  sym__name_param = 139,
  aux_sym__statement_seq = 140,
  sym__statement = 141,
  sym__expression = 142,
  sym_binary_expression = 143,
  sym__expression_unit = 144,
  sym_record = 145,
  sym_todo = 146,
  sym_panic = 147,
  sym_tuple = 148,
  sym_list = 149,
  sym__expression_bit_string = 150,
  sym_expression_bit_string_segment = 151,
  sym_expression_bit_string_segment_options = 152,
  sym__expression_bit_string_segment_option = 153,
  sym__expression_bit_string_named_segment_option = 154,
  sym__expression_bit_string_segment_option_size = 155,
  sym_anonymous_function = 156,
  sym_anonymous_function_parameters = 157,
  sym_anonymous_function_parameter = 158,
  sym_block = 159,
  sym_case = 160,
  sym_case_subjects = 161,
  sym_case_clauses = 162,
  sym_case_clause = 163,
  sym_case_clause_patterns = 164,
  sym_case_clause_pattern = 165,
  sym_case_clause_guard = 166,
  sym__case_clause_guard_expression = 167,
  sym__case_clause_guard_binary_expression = 168,
  sym__case_clause_guard_unit = 169,
  sym__case_clause_tuple_access = 170,
  sym_let_assert = 171,
  sym_let = 172,
  sym_use = 173,
  sym_use_assignments = 174,
  sym_use_assignment = 175,
  sym_assert = 176,
  sym_boolean_negation = 177,
  sym_integer_negation = 178,
  sym__assignment = 179,
  sym_record_update = 180,
  sym_record_update_arguments = 181,
  sym_record_update_argument = 182,
  sym__maybe_tuple_expression = 183,
  sym_tuple_access = 184,
  sym__maybe_record_expression = 185,
  sym_field_access = 186,
  sym__maybe_function_expression = 187,
  sym_arguments = 188,
  sym_argument = 189,
  sym_hole = 190,
  sym_function_call = 191,
  sym__pattern_expression = 192,
  sym__pattern_binary_expression = 193,
  sym__pattern = 194,
  sym_record_pattern = 195,
  sym_record_pattern_arguments = 196,
  sym_record_pattern_argument = 197,
  sym_pattern_spread = 198,
  sym_tuple_pattern = 199,
  sym__pattern_bit_string = 200,
  sym_pattern_bit_string_segment = 201,
  sym_pattern_bit_string_segment_options = 202,
  sym__pattern_bit_string_segment_option = 203,
  sym__pattern_bit_string_named_segment_option = 204,
  sym__pattern_bit_string_segment_option_size = 205,
  sym__pattern_bit_string_segment_argument = 206,
  sym_list_pattern = 207,
  sym_list_pattern_tail = 208,
  sym_type_definition = 209,
  sym_data_constructors = 210,
  sym_data_constructor = 211,
  sym_data_constructor_arguments = 212,
  sym_data_constructor_argument = 213,
  sym_type_alias = 214,
  sym_string = 215,
  sym_escape_sequence = 216,
  sym_integer = 217,
  sym__bit_string_segment_option = 218,
  sym__type = 219,
  sym__type_annotation = 220,
  sym_type_hole = 221,
  sym_tuple_type = 222,
  sym_function_type = 223,
  sym_function_parameter_types = 224,
  sym_type = 225,
  sym_type_arguments = 226,
  sym_type_argument = 227,
  sym_type_var = 228,
  sym_type_name = 229,
  sym_type_parameters = 230,
  sym_type_parameter = 231,
  sym_identifier = 232,
  sym_label = 233,
  sym_discard = 234,
  sym_type_identifier = 235,
  sym_remote_type_identifier = 236,
  sym_constructor_name = 237,
  sym_remote_constructor_name = 238,
  aux_sym_source_file_repeat1 = 239,
  aux_sym_target_group_repeat1 = 240,
  aux_sym__attribute_arguments_repeat1 = 241,
  aux_sym_module_repeat1 = 242,
  aux_sym_unqualified_imports_repeat1 = 243,
  aux_sym_constant_tuple_repeat1 = 244,
  aux_sym__constant_bit_string_repeat1 = 245,
  aux_sym_constant_bit_string_segment_options_repeat1 = 246,
  aux_sym_constant_record_arguments_repeat1 = 247,
  aux_sym_constant_tuple_type_repeat1 = 248,
  aux_sym_constant_type_arguments_repeat1 = 249,
  aux_sym_external_function_parameters_repeat1 = 250,
  aux_sym_function_parameters_repeat1 = 251,
  aux_sym_tuple_repeat1 = 252,
  aux_sym__expression_bit_string_repeat1 = 253,
  aux_sym_expression_bit_string_segment_options_repeat1 = 254,
  aux_sym_anonymous_function_parameters_repeat1 = 255,
  aux_sym_case_clauses_repeat1 = 256,
  aux_sym_case_clause_patterns_repeat1 = 257,
  aux_sym_case_clause_pattern_repeat1 = 258,
  aux_sym_use_assignments_repeat1 = 259,
  aux_sym_record_update_arguments_repeat1 = 260,
  aux_sym_arguments_repeat1 = 261,
  aux_sym_record_pattern_arguments_repeat1 = 262,
  aux_sym__pattern_bit_string_repeat1 = 263,
  aux_sym_pattern_bit_string_segment_options_repeat1 = 264,
  aux_sym_data_constructors_repeat1 = 265,
  aux_sym_data_constructor_arguments_repeat1 = 266,
  aux_sym_string_repeat1 = 267,
  aux_sym_tuple_type_repeat1 = 268,
  aux_sym_type_arguments_repeat1 = 269,
  aux_sym_type_parameters_repeat1 = 270,
  alias_sym_function_body = 271,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_module_comment] = "module_comment",
  [sym_statement_comment] = "statement_comment",
  [sym_comment] = "comment",
  [anon_sym_if] = "if",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_erlang] = "erlang",
  [anon_sym_javascript] = "javascript",
  [anon_sym_AT] = "@",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON] = ":",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_as] = "as",
  [anon_sym_SLASH] = "/",
  [anon_sym_type] = "type",
  [anon_sym_const] = "const",
  [anon_sym_EQ] = "=",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DASH] = "-",
  [anon_sym_size] = "size",
  [anon_sym_fn] = "fn",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_external] = "external",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT_DOT] = "<.",
  [anon_sym_LT_EQ_DOT] = "<=.",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT_DOT] = ">.",
  [anon_sym_GT_EQ_DOT] = ">=.",
  [anon_sym_PIPE_GT] = "|>",
  [anon_sym_PLUS] = "+",
  [anon_sym_PLUS_DOT] = "+.",
  [anon_sym_DASH_DOT] = "-.",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_DOT] = "*.",
  [anon_sym_SLASH_DOT] = "/.",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_todo] = "todo",
  [anon_sym_panic] = "panic",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_case] = "case",
  [anon_sym_PIPE] = "|",
  [anon_sym_let] = "let",
  [anon_sym_assert] = "assert",
  [anon_sym_use] = "use",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_BANG] = "!",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_opacity_modifier] = "opacity_modifier",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE2] = "\"",
  [aux_sym_escape_sequence_token1] = "escape_sequence_token1",
  [aux_sym_escape_sequence_token2] = "escape_sequence_token2",
  [sym_float] = "float",
  [sym__hex] = "_hex",
  [sym__decimal] = "_decimal",
  [sym__octal] = "_octal",
  [sym__binary] = "_binary",
  [anon_sym_binary] = "binary",
  [anon_sym_bytes] = "bytes",
  [anon_sym_int] = "int",
  [anon_sym_float] = "float",
  [anon_sym_bit_string] = "bit_string",
  [anon_sym_bits] = "bits",
  [anon_sym_utf8] = "utf8",
  [anon_sym_utf16] = "utf16",
  [anon_sym_utf32] = "utf32",
  [anon_sym_utf8_codepoint] = "utf8_codepoint",
  [anon_sym_utf16_codepoint] = "utf16_codepoint",
  [anon_sym_utf32_codepoint] = "utf32_codepoint",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_big] = "big",
  [anon_sym_little] = "little",
  [anon_sym_native] = "native",
  [anon_sym_unit] = "unit",
  [sym__discard_name] = "_discard_name",
  [sym__name] = "_name",
  [sym__upname] = "_upname",
  [sym_quoted_content] = "quoted_content",
  [sym_source_file] = "source_file",
  [sym__module_statement] = "_module_statement",
  [sym_target_group] = "target_group",
  [sym_target] = "target",
  [sym_attribute] = "attribute",
  [sym__attribute_arguments] = "arguments",
  [sym_attribute_value] = "attribute_value",
  [sym_import] = "import",
  [sym_module] = "module",
  [sym_unqualified_imports] = "unqualified_imports",
  [sym_unqualified_import] = "unqualified_import",
  [sym_constant] = "constant",
  [sym__constant_value] = "_constant_value",
  [sym_constant_tuple] = "tuple",
  [sym_constant_list] = "list",
  [sym__constant_bit_string] = "bit_string",
  [sym_constant_bit_string_segment] = "bit_string_segment",
  [sym_constant_bit_string_segment_options] = "bit_string_segment_options",
  [sym__constant_bit_string_segment_option] = "_constant_bit_string_segment_option",
  [sym__constant_bit_string_named_segment_option] = "_constant_bit_string_named_segment_option",
  [sym__constant_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym_constant_record] = "record",
  [sym_constant_record_arguments] = "arguments",
  [sym_constant_record_argument] = "argument",
  [sym_constant_field_access] = "field_access",
  [sym__constant_type] = "_constant_type",
  [sym__constant_type_annotation] = "_constant_type_annotation",
  [sym_constant_tuple_type] = "tuple_type",
  [sym_constant_function_type] = "function_type",
  [sym_constant_function_parameter_types] = "function_parameter_types",
  [sym_constant_type] = "type",
  [sym_constant_type_arguments] = "type_arguments",
  [sym_constant_type_argument] = "type_argument",
  [sym_external_type] = "external_type",
  [sym_external_function] = "external_function",
  [sym_external_function_parameters] = "function_parameters",
  [sym_external_function_parameter] = "function_parameter",
  [sym_external_function_body] = "external_function_body",
  [sym_function] = "function",
  [sym_function_parameters] = "function_parameters",
  [sym_function_parameter] = "function_parameter",
  [sym__labeled_discard_param] = "_labeled_discard_param",
  [sym__discard_param] = "_discard_param",
  [sym__labeled_name_param] = "_labeled_name_param",
  [sym__name_param] = "_name_param",
  [aux_sym__statement_seq] = "_statement_seq",
  [sym__statement] = "_statement",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym__expression_unit] = "_expression_unit",
  [sym_record] = "record",
  [sym_todo] = "todo",
  [sym_panic] = "panic",
  [sym_tuple] = "tuple",
  [sym_list] = "list",
  [sym__expression_bit_string] = "bit_string",
  [sym_expression_bit_string_segment] = "bit_string_segment",
  [sym_expression_bit_string_segment_options] = "bit_string_segment_options",
  [sym__expression_bit_string_segment_option] = "_expression_bit_string_segment_option",
  [sym__expression_bit_string_named_segment_option] = "_expression_bit_string_named_segment_option",
  [sym__expression_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym_anonymous_function] = "anonymous_function",
  [sym_anonymous_function_parameters] = "function_parameters",
  [sym_anonymous_function_parameter] = "function_parameter",
  [sym_block] = "block",
  [sym_case] = "case",
  [sym_case_subjects] = "case_subjects",
  [sym_case_clauses] = "case_clauses",
  [sym_case_clause] = "case_clause",
  [sym_case_clause_patterns] = "case_clause_patterns",
  [sym_case_clause_pattern] = "case_clause_pattern",
  [sym_case_clause_guard] = "case_clause_guard",
  [sym__case_clause_guard_expression] = "_case_clause_guard_expression",
  [sym__case_clause_guard_binary_expression] = "binary_expression",
  [sym__case_clause_guard_unit] = "_case_clause_guard_unit",
  [sym__case_clause_tuple_access] = "tuple_access",
  [sym_let_assert] = "let_assert",
  [sym_let] = "let",
  [sym_use] = "use",
  [sym_use_assignments] = "use_assignments",
  [sym_use_assignment] = "use_assignment",
  [sym_assert] = "assert",
  [sym_boolean_negation] = "boolean_negation",
  [sym_integer_negation] = "integer_negation",
  [sym__assignment] = "_assignment",
  [sym_record_update] = "record_update",
  [sym_record_update_arguments] = "record_update_arguments",
  [sym_record_update_argument] = "record_update_argument",
  [sym__maybe_tuple_expression] = "_maybe_tuple_expression",
  [sym_tuple_access] = "tuple_access",
  [sym__maybe_record_expression] = "_maybe_record_expression",
  [sym_field_access] = "field_access",
  [sym__maybe_function_expression] = "_maybe_function_expression",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym_hole] = "hole",
  [sym_function_call] = "function_call",
  [sym__pattern_expression] = "_pattern_expression",
  [sym__pattern_binary_expression] = "binary_expression",
  [sym__pattern] = "_pattern",
  [sym_record_pattern] = "record_pattern",
  [sym_record_pattern_arguments] = "record_pattern_arguments",
  [sym_record_pattern_argument] = "record_pattern_argument",
  [sym_pattern_spread] = "pattern_spread",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym__pattern_bit_string] = "bit_string_pattern",
  [sym_pattern_bit_string_segment] = "bit_string_segment",
  [sym_pattern_bit_string_segment_options] = "bit_string_segment_options",
  [sym__pattern_bit_string_segment_option] = "_pattern_bit_string_segment_option",
  [sym__pattern_bit_string_named_segment_option] = "_pattern_bit_string_named_segment_option",
  [sym__pattern_bit_string_segment_option_size] = "bit_string_segment_option",
  [sym__pattern_bit_string_segment_argument] = "_pattern_bit_string_segment_argument",
  [sym_list_pattern] = "list_pattern",
  [sym_list_pattern_tail] = "list_pattern_tail",
  [sym_type_definition] = "type_definition",
  [sym_data_constructors] = "data_constructors",
  [sym_data_constructor] = "data_constructor",
  [sym_data_constructor_arguments] = "data_constructor_arguments",
  [sym_data_constructor_argument] = "data_constructor_argument",
  [sym_type_alias] = "type_alias",
  [sym_string] = "string",
  [sym_escape_sequence] = "escape_sequence",
  [sym_integer] = "integer",
  [sym__bit_string_segment_option] = "bit_string_segment_option",
  [sym__type] = "_type",
  [sym__type_annotation] = "_type_annotation",
  [sym_type_hole] = "type_hole",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_function_parameter_types] = "function_parameter_types",
  [sym_type] = "type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_argument] = "type_argument",
  [sym_type_var] = "type_var",
  [sym_type_name] = "type_name",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_identifier] = "identifier",
  [sym_label] = "label",
  [sym_discard] = "discard",
  [sym_type_identifier] = "type_identifier",
  [sym_remote_type_identifier] = "remote_type_identifier",
  [sym_constructor_name] = "constructor_name",
  [sym_remote_constructor_name] = "remote_constructor_name",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_target_group_repeat1] = "target_group_repeat1",
  [aux_sym__attribute_arguments_repeat1] = "_attribute_arguments_repeat1",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_unqualified_imports_repeat1] = "unqualified_imports_repeat1",
  [aux_sym_constant_tuple_repeat1] = "constant_tuple_repeat1",
  [aux_sym__constant_bit_string_repeat1] = "_constant_bit_string_repeat1",
  [aux_sym_constant_bit_string_segment_options_repeat1] = "constant_bit_string_segment_options_repeat1",
  [aux_sym_constant_record_arguments_repeat1] = "constant_record_arguments_repeat1",
  [aux_sym_constant_tuple_type_repeat1] = "constant_tuple_type_repeat1",
  [aux_sym_constant_type_arguments_repeat1] = "constant_type_arguments_repeat1",
  [aux_sym_external_function_parameters_repeat1] = "external_function_parameters_repeat1",
  [aux_sym_function_parameters_repeat1] = "function_parameters_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym__expression_bit_string_repeat1] = "_expression_bit_string_repeat1",
  [aux_sym_expression_bit_string_segment_options_repeat1] = "expression_bit_string_segment_options_repeat1",
  [aux_sym_anonymous_function_parameters_repeat1] = "anonymous_function_parameters_repeat1",
  [aux_sym_case_clauses_repeat1] = "case_clauses_repeat1",
  [aux_sym_case_clause_patterns_repeat1] = "case_clause_patterns_repeat1",
  [aux_sym_case_clause_pattern_repeat1] = "case_clause_pattern_repeat1",
  [aux_sym_use_assignments_repeat1] = "use_assignments_repeat1",
  [aux_sym_record_update_arguments_repeat1] = "record_update_arguments_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_record_pattern_arguments_repeat1] = "record_pattern_arguments_repeat1",
  [aux_sym__pattern_bit_string_repeat1] = "_pattern_bit_string_repeat1",
  [aux_sym_pattern_bit_string_segment_options_repeat1] = "pattern_bit_string_segment_options_repeat1",
  [aux_sym_data_constructors_repeat1] = "data_constructors_repeat1",
  [aux_sym_data_constructor_arguments_repeat1] = "data_constructor_arguments_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_function_body] = "function_body",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_module_comment] = sym_module_comment,
  [sym_statement_comment] = sym_statement_comment,
  [sym_comment] = sym_comment,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_erlang] = anon_sym_erlang,
  [anon_sym_javascript] = anon_sym_javascript,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_size] = anon_sym_size,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT_DOT] = anon_sym_LT_DOT,
  [anon_sym_LT_EQ_DOT] = anon_sym_LT_EQ_DOT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT_DOT] = anon_sym_GT_DOT,
  [anon_sym_GT_EQ_DOT] = anon_sym_GT_EQ_DOT,
  [anon_sym_PIPE_GT] = anon_sym_PIPE_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PLUS_DOT] = anon_sym_PLUS_DOT,
  [anon_sym_DASH_DOT] = anon_sym_DASH_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_DOT] = anon_sym_STAR_DOT,
  [anon_sym_SLASH_DOT] = anon_sym_SLASH_DOT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_todo] = anon_sym_todo,
  [anon_sym_panic] = anon_sym_panic,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_opacity_modifier] = sym_opacity_modifier,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [aux_sym_escape_sequence_token1] = aux_sym_escape_sequence_token1,
  [aux_sym_escape_sequence_token2] = aux_sym_escape_sequence_token2,
  [sym_float] = sym_float,
  [sym__hex] = sym__hex,
  [sym__decimal] = sym__decimal,
  [sym__octal] = sym__octal,
  [sym__binary] = sym__binary,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_bytes] = anon_sym_bytes,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_bit_string] = anon_sym_bit_string,
  [anon_sym_bits] = anon_sym_bits,
  [anon_sym_utf8] = anon_sym_utf8,
  [anon_sym_utf16] = anon_sym_utf16,
  [anon_sym_utf32] = anon_sym_utf32,
  [anon_sym_utf8_codepoint] = anon_sym_utf8_codepoint,
  [anon_sym_utf16_codepoint] = anon_sym_utf16_codepoint,
  [anon_sym_utf32_codepoint] = anon_sym_utf32_codepoint,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_big] = anon_sym_big,
  [anon_sym_little] = anon_sym_little,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_unit] = anon_sym_unit,
  [sym__discard_name] = sym__discard_name,
  [sym__name] = sym__name,
  [sym__upname] = sym__upname,
  [sym_quoted_content] = sym_quoted_content,
  [sym_source_file] = sym_source_file,
  [sym__module_statement] = sym__module_statement,
  [sym_target_group] = sym_target_group,
  [sym_target] = sym_target,
  [sym_attribute] = sym_attribute,
  [sym__attribute_arguments] = sym_arguments,
  [sym_attribute_value] = sym_attribute_value,
  [sym_import] = sym_import,
  [sym_module] = sym_module,
  [sym_unqualified_imports] = sym_unqualified_imports,
  [sym_unqualified_import] = sym_unqualified_import,
  [sym_constant] = sym_constant,
  [sym__constant_value] = sym__constant_value,
  [sym_constant_tuple] = sym_tuple,
  [sym_constant_list] = sym_list,
  [sym__constant_bit_string] = sym__constant_bit_string,
  [sym_constant_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_constant_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__constant_bit_string_segment_option] = sym__constant_bit_string_segment_option,
  [sym__constant_bit_string_named_segment_option] = sym__constant_bit_string_named_segment_option,
  [sym__constant_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym_constant_record] = sym_record,
  [sym_constant_record_arguments] = sym_arguments,
  [sym_constant_record_argument] = sym_argument,
  [sym_constant_field_access] = sym_field_access,
  [sym__constant_type] = sym__constant_type,
  [sym__constant_type_annotation] = sym__constant_type_annotation,
  [sym_constant_tuple_type] = sym_tuple_type,
  [sym_constant_function_type] = sym_function_type,
  [sym_constant_function_parameter_types] = sym_function_parameter_types,
  [sym_constant_type] = sym_type,
  [sym_constant_type_arguments] = sym_type_arguments,
  [sym_constant_type_argument] = sym_type_argument,
  [sym_external_type] = sym_external_type,
  [sym_external_function] = sym_external_function,
  [sym_external_function_parameters] = sym_function_parameters,
  [sym_external_function_parameter] = sym_function_parameter,
  [sym_external_function_body] = sym_external_function_body,
  [sym_function] = sym_function,
  [sym_function_parameters] = sym_function_parameters,
  [sym_function_parameter] = sym_function_parameter,
  [sym__labeled_discard_param] = sym__labeled_discard_param,
  [sym__discard_param] = sym__discard_param,
  [sym__labeled_name_param] = sym__labeled_name_param,
  [sym__name_param] = sym__name_param,
  [aux_sym__statement_seq] = aux_sym__statement_seq,
  [sym__statement] = sym__statement,
  [sym__expression] = sym__expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym__expression_unit] = sym__expression_unit,
  [sym_record] = sym_record,
  [sym_todo] = sym_todo,
  [sym_panic] = sym_panic,
  [sym_tuple] = sym_tuple,
  [sym_list] = sym_list,
  [sym__expression_bit_string] = sym__constant_bit_string,
  [sym_expression_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_expression_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__expression_bit_string_segment_option] = sym__expression_bit_string_segment_option,
  [sym__expression_bit_string_named_segment_option] = sym__expression_bit_string_named_segment_option,
  [sym__expression_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym_anonymous_function] = sym_anonymous_function,
  [sym_anonymous_function_parameters] = sym_function_parameters,
  [sym_anonymous_function_parameter] = sym_function_parameter,
  [sym_block] = sym_block,
  [sym_case] = sym_case,
  [sym_case_subjects] = sym_case_subjects,
  [sym_case_clauses] = sym_case_clauses,
  [sym_case_clause] = sym_case_clause,
  [sym_case_clause_patterns] = sym_case_clause_patterns,
  [sym_case_clause_pattern] = sym_case_clause_pattern,
  [sym_case_clause_guard] = sym_case_clause_guard,
  [sym__case_clause_guard_expression] = sym__case_clause_guard_expression,
  [sym__case_clause_guard_binary_expression] = sym_binary_expression,
  [sym__case_clause_guard_unit] = sym__case_clause_guard_unit,
  [sym__case_clause_tuple_access] = sym_tuple_access,
  [sym_let_assert] = sym_let_assert,
  [sym_let] = sym_let,
  [sym_use] = sym_use,
  [sym_use_assignments] = sym_use_assignments,
  [sym_use_assignment] = sym_use_assignment,
  [sym_assert] = sym_assert,
  [sym_boolean_negation] = sym_boolean_negation,
  [sym_integer_negation] = sym_integer_negation,
  [sym__assignment] = sym__assignment,
  [sym_record_update] = sym_record_update,
  [sym_record_update_arguments] = sym_record_update_arguments,
  [sym_record_update_argument] = sym_record_update_argument,
  [sym__maybe_tuple_expression] = sym__maybe_tuple_expression,
  [sym_tuple_access] = sym_tuple_access,
  [sym__maybe_record_expression] = sym__maybe_record_expression,
  [sym_field_access] = sym_field_access,
  [sym__maybe_function_expression] = sym__maybe_function_expression,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym_hole] = sym_hole,
  [sym_function_call] = sym_function_call,
  [sym__pattern_expression] = sym__pattern_expression,
  [sym__pattern_binary_expression] = sym_binary_expression,
  [sym__pattern] = sym__pattern,
  [sym_record_pattern] = sym_record_pattern,
  [sym_record_pattern_arguments] = sym_record_pattern_arguments,
  [sym_record_pattern_argument] = sym_record_pattern_argument,
  [sym_pattern_spread] = sym_pattern_spread,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym__pattern_bit_string] = sym__pattern_bit_string,
  [sym_pattern_bit_string_segment] = sym_constant_bit_string_segment,
  [sym_pattern_bit_string_segment_options] = sym_constant_bit_string_segment_options,
  [sym__pattern_bit_string_segment_option] = sym__pattern_bit_string_segment_option,
  [sym__pattern_bit_string_named_segment_option] = sym__pattern_bit_string_named_segment_option,
  [sym__pattern_bit_string_segment_option_size] = sym__constant_bit_string_segment_option_size,
  [sym__pattern_bit_string_segment_argument] = sym__pattern_bit_string_segment_argument,
  [sym_list_pattern] = sym_list_pattern,
  [sym_list_pattern_tail] = sym_list_pattern_tail,
  [sym_type_definition] = sym_type_definition,
  [sym_data_constructors] = sym_data_constructors,
  [sym_data_constructor] = sym_data_constructor,
  [sym_data_constructor_arguments] = sym_data_constructor_arguments,
  [sym_data_constructor_argument] = sym_data_constructor_argument,
  [sym_type_alias] = sym_type_alias,
  [sym_string] = sym_string,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_integer] = sym_integer,
  [sym__bit_string_segment_option] = sym__constant_bit_string_segment_option_size,
  [sym__type] = sym__type,
  [sym__type_annotation] = sym__type_annotation,
  [sym_type_hole] = sym_type_hole,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_function_parameter_types] = sym_function_parameter_types,
  [sym_type] = sym_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_argument] = sym_type_argument,
  [sym_type_var] = sym_type_var,
  [sym_type_name] = sym_type_name,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_identifier] = sym_identifier,
  [sym_label] = sym_label,
  [sym_discard] = sym_discard,
  [sym_type_identifier] = sym_type_identifier,
  [sym_remote_type_identifier] = sym_remote_type_identifier,
  [sym_constructor_name] = sym_constructor_name,
  [sym_remote_constructor_name] = sym_remote_constructor_name,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_target_group_repeat1] = aux_sym_target_group_repeat1,
  [aux_sym__attribute_arguments_repeat1] = aux_sym__attribute_arguments_repeat1,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_unqualified_imports_repeat1] = aux_sym_unqualified_imports_repeat1,
  [aux_sym_constant_tuple_repeat1] = aux_sym_constant_tuple_repeat1,
  [aux_sym__constant_bit_string_repeat1] = aux_sym__constant_bit_string_repeat1,
  [aux_sym_constant_bit_string_segment_options_repeat1] = aux_sym_constant_bit_string_segment_options_repeat1,
  [aux_sym_constant_record_arguments_repeat1] = aux_sym_constant_record_arguments_repeat1,
  [aux_sym_constant_tuple_type_repeat1] = aux_sym_constant_tuple_type_repeat1,
  [aux_sym_constant_type_arguments_repeat1] = aux_sym_constant_type_arguments_repeat1,
  [aux_sym_external_function_parameters_repeat1] = aux_sym_external_function_parameters_repeat1,
  [aux_sym_function_parameters_repeat1] = aux_sym_function_parameters_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym__expression_bit_string_repeat1] = aux_sym__expression_bit_string_repeat1,
  [aux_sym_expression_bit_string_segment_options_repeat1] = aux_sym_expression_bit_string_segment_options_repeat1,
  [aux_sym_anonymous_function_parameters_repeat1] = aux_sym_anonymous_function_parameters_repeat1,
  [aux_sym_case_clauses_repeat1] = aux_sym_case_clauses_repeat1,
  [aux_sym_case_clause_patterns_repeat1] = aux_sym_case_clause_patterns_repeat1,
  [aux_sym_case_clause_pattern_repeat1] = aux_sym_case_clause_pattern_repeat1,
  [aux_sym_use_assignments_repeat1] = aux_sym_use_assignments_repeat1,
  [aux_sym_record_update_arguments_repeat1] = aux_sym_record_update_arguments_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_record_pattern_arguments_repeat1] = aux_sym_record_pattern_arguments_repeat1,
  [aux_sym__pattern_bit_string_repeat1] = aux_sym__pattern_bit_string_repeat1,
  [aux_sym_pattern_bit_string_segment_options_repeat1] = aux_sym_pattern_bit_string_segment_options_repeat1,
  [aux_sym_data_constructors_repeat1] = aux_sym_data_constructors_repeat1,
  [aux_sym_data_constructor_arguments_repeat1] = aux_sym_data_constructor_arguments_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_function_body] = alias_sym_function_body,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_module_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_erlang] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_javascript] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_size] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_todo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_panic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_opacity_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym__hex] = {
    .visible = false,
    .named = true,
  },
  [sym__decimal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bit_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf8_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf16_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_utf32_codepoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_big] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_little] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unit] = {
    .visible = true,
    .named = false,
  },
  [sym__discard_name] = {
    .visible = false,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym__upname] = {
    .visible = false,
    .named = true,
  },
  [sym_quoted_content] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__module_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_target_group] = {
    .visible = true,
    .named = true,
  },
  [sym_target] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_value] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_unqualified_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_unqualified_import] = {
    .visible = true,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_value] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_list] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_record_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_type] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_function_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_external_type] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_external_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__labeled_discard_param] = {
    .visible = false,
    .named = true,
  },
  [sym__discard_param] = {
    .visible = false,
    .named = true,
  },
  [sym__labeled_name_param] = {
    .visible = false,
    .named = true,
  },
  [sym__name_param] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statement_seq] = {
    .visible = false,
    .named = false,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_unit] = {
    .visible = false,
    .named = true,
  },
  [sym_record] = {
    .visible = true,
    .named = true,
  },
  [sym_todo] = {
    .visible = true,
    .named = true,
  },
  [sym_panic] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_subjects] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clauses] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__case_clause_guard_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__case_clause_guard_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__case_clause_guard_unit] = {
    .visible = false,
    .named = true,
  },
  [sym__case_clause_tuple_access] = {
    .visible = true,
    .named = true,
  },
  [sym_let_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_use] = {
    .visible = true,
    .named = true,
  },
  [sym_use_assignments] = {
    .visible = true,
    .named = true,
  },
  [sym_use_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_negation] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_record_update] = {
    .visible = true,
    .named = true,
  },
  [sym_record_update_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_record_update_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_tuple_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_access] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_record_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym__maybe_function_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hole] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_spread] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_bit_string_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_bit_string_segment_options] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_bit_string_named_segment_option] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_bit_string_segment_option_size] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_bit_string_segment_argument] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern_tail] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__bit_string_segment_option] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_type_hole] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_var] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_remote_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_remote_constructor_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_target_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unqualified_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__constant_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_record_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constant_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_external_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_assignments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_update_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_bit_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pattern_bit_string_segment_options_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructor_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_function_body] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_arguments = 2,
  field_assign = 3,
  field_assignments = 4,
  field_body = 5,
  field_clauses = 6,
  field_constructor = 7,
  field_field = 8,
  field_function = 9,
  field_guard = 10,
  field_imports = 11,
  field_index = 12,
  field_label = 13,
  field_left = 14,
  field_message = 15,
  field_module = 16,
  field_name = 17,
  field_operator = 18,
  field_options = 19,
  field_parameter_types = 20,
  field_parameters = 21,
  field_pattern = 22,
  field_patterns = 23,
  field_record = 24,
  field_return_type = 25,
  field_right = 26,
  field_spread = 27,
  field_subjects = 28,
  field_target = 29,
  field_tuple = 30,
  field_type = 31,
  field_value = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_arguments] = "arguments",
  [field_assign] = "assign",
  [field_assignments] = "assignments",
  [field_body] = "body",
  [field_clauses] = "clauses",
  [field_constructor] = "constructor",
  [field_field] = "field",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_imports] = "imports",
  [field_index] = "index",
  [field_label] = "label",
  [field_left] = "left",
  [field_message] = "message",
  [field_module] = "module",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_options] = "options",
  [field_parameter_types] = "parameter_types",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_record] = "record",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_spread] = "spread",
  [field_subjects] = "subjects",
  [field_target] = "target",
  [field_tuple] = "tuple",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 4},
  [6] = {.index = 8, .length = 3},
  [7] = {.index = 11, .length = 1},
  [8] = {.index = 12, .length = 2},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 1},
  [13] = {.index = 21, .length = 2},
  [14] = {.index = 23, .length = 1},
  [15] = {.index = 24, .length = 2},
  [16] = {.index = 26, .length = 4},
  [17] = {.index = 30, .length = 1},
  [18] = {.index = 31, .length = 2},
  [19] = {.index = 33, .length = 3},
  [20] = {.index = 36, .length = 2},
  [21] = {.index = 38, .length = 2},
  [22] = {.index = 40, .length = 2},
  [23] = {.index = 42, .length = 1},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 1},
  [27] = {.index = 48, .length = 2},
  [28] = {.index = 50, .length = 3},
  [29] = {.index = 53, .length = 2},
  [30] = {.index = 55, .length = 2},
  [31] = {.index = 57, .length = 1},
  [32] = {.index = 58, .length = 1},
  [33] = {.index = 59, .length = 2},
  [34] = {.index = 61, .length = 3},
  [35] = {.index = 64, .length = 2},
  [36] = {.index = 66, .length = 2},
  [37] = {.index = 68, .length = 2},
  [38] = {.index = 70, .length = 3},
  [39] = {.index = 73, .length = 1},
  [40] = {.index = 74, .length = 2},
  [41] = {.index = 76, .length = 3},
  [42] = {.index = 79, .length = 2},
  [43] = {.index = 81, .length = 3},
  [44] = {.index = 84, .length = 1},
  [45] = {.index = 85, .length = 2},
  [46] = {.index = 87, .length = 2},
  [47] = {.index = 89, .length = 1},
  [48] = {.index = 90, .length = 2},
  [49] = {.index = 92, .length = 4},
  [50] = {.index = 96, .length = 4},
  [51] = {.index = 100, .length = 2},
  [52] = {.index = 102, .length = 2},
  [53] = {.index = 104, .length = 3},
  [54] = {.index = 107, .length = 1},
  [55] = {.index = 108, .length = 1},
  [56] = {.index = 109, .length = 3},
  [57] = {.index = 112, .length = 2},
  [58] = {.index = 114, .length = 2},
  [59] = {.index = 116, .length = 2},
  [60] = {.index = 118, .length = 3},
  [61] = {.index = 121, .length = 3},
  [62] = {.index = 124, .length = 3},
  [63] = {.index = 127, .length = 2},
  [64] = {.index = 129, .length = 2},
  [65] = {.index = 131, .length = 1},
  [66] = {.index = 132, .length = 3},
  [67] = {.index = 135, .length = 2},
  [68] = {.index = 137, .length = 3},
  [69] = {.index = 140, .length = 3},
  [70] = {.index = 143, .length = 3},
  [71] = {.index = 146, .length = 2},
  [72] = {.index = 148, .length = 4},
  [73] = {.index = 152, .length = 4},
  [74] = {.index = 152, .length = 4},
  [75] = {.index = 156, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_name, 1},
  [2] =
    {field_module, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_assign, 1, .inherited = true},
    {field_pattern, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [8] =
    {field_left, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [11] =
    {field_assign, 0, .inherited = true},
  [12] =
    {field_arguments, 1},
    {field_function, 0},
  [14] =
    {field_arguments, 1},
    {field_name, 0},
  [16] =
    {field_arguments, 2},
    {field_name, 1},
  [18] =
    {field_name, 0},
    {field_parameters, 1},
  [20] =
    {field_name, 0, .inherited = true},
  [21] =
    {field_name, 1},
    {field_parameters, 2},
  [23] =
    {field_message, 2},
  [24] =
    {field_assign, 0, .inherited = true},
    {field_value, 0},
  [26] =
    {field_assign, 2, .inherited = true},
    {field_pattern, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [30] =
    {field_value, 2},
  [31] =
    {field_assign, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_index, 2},
    {field_tuple, 0},
  [38] =
    {field_field, 2},
    {field_record, 0},
  [40] =
    {field_module, 0},
    {field_name, 2},
  [42] =
    {field_target, 1},
  [43] =
    {field_imports, 3},
    {field_module, 1},
  [45] =
    {field_alias, 3},
    {field_module, 1},
  [47] =
    {field_type, 1},
  [48] =
    {field_name, 1},
    {field_value, 3},
  [50] =
    {field_options, 1},
    {field_options, 2},
    {field_value, 0},
  [53] =
    {field_name, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [55] =
    {field_label, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [57] =
    {field_subjects, 1},
  [58] =
    {field_assign, 1, .inherited = true},
  [59] =
    {field_assign, 1},
    {field_assign, 2},
  [61] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
    {field_value, 2},
  [64] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
  [66] =
    {field_assignments, 1},
    {field_value, 3},
  [68] =
    {field_name, 2},
    {field_parameters, 3},
  [70] =
    {field_name, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [73] =
    {field_spread, 3},
  [74] =
    {field_body, 3},
    {field_parameters, 1},
  [76] =
    {field_label, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [79] =
    {field_label, 0},
    {field_name, 1},
  [81] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [84] =
    {field_type, 0},
  [85] =
    {field_clauses, 3},
    {field_subjects, 1},
  [87] =
    {field_assign, 0, .inherited = true},
    {field_assign, 1, .inherited = true},
  [89] =
    {field_assign, 2, .inherited = true},
  [90] =
    {field_assign, 1, .inherited = true},
    {field_assign, 2, .inherited = true},
  [92] =
    {field_assign, 0, .inherited = true},
    {field_options, 1},
    {field_options, 2},
    {field_value, 0},
  [96] =
    {field_assign, 0, .inherited = true},
    {field_pattern, 0},
    {field_type, 1, .inherited = true},
    {field_value, 3},
  [100] =
    {field_name, 2},
    {field_value, 4},
  [102] =
    {field_label, 0},
    {field_value, 2},
  [104] =
    {field_alias, 5},
    {field_imports, 3},
    {field_module, 1},
  [107] =
    {field_return_type, 2},
  [108] =
    {field_spread, 4},
  [109] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [112] =
    {field_index, 0, .inherited = true},
    {field_tuple, 0, .inherited = true},
  [114] =
    {field_patterns, 0},
    {field_value, 2},
  [116] =
    {field_assign, 2, .inherited = true},
    {field_assign, 3, .inherited = true},
  [118] =
    {field_assign, 2, .inherited = true},
    {field_label, 0},
    {field_pattern, 2},
  [121] =
    {field_name, 2},
    {field_type, 3, .inherited = true},
    {field_value, 5},
  [124] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [127] =
    {field_alias, 2},
    {field_name, 0},
  [129] =
    {field_parameter_types, 1},
    {field_return_type, 3},
  [131] =
    {field_spread, 5},
  [132] =
    {field_body, 5},
    {field_parameters, 1},
    {field_return_type, 3},
  [135] =
    {field_name, 0},
    {field_type, 2},
  [137] =
    {field_guard, 1},
    {field_patterns, 0},
    {field_value, 3},
  [140] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [143] =
    {field_arguments, 5},
    {field_constructor, 0},
    {field_spread, 3},
  [146] =
    {field_alias, 3},
    {field_name, 1},
  [148] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [152] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [156] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [40] = {
    [3] = alias_sym_function_body,
  },
  [56] = {
    [4] = alias_sym_function_body,
  },
  [66] = {
    [5] = alias_sym_function_body,
  },
  [69] = {
    [5] = alias_sym_function_body,
  },
  [72] = {
    [6] = alias_sym_function_body,
  },
  [74] = {
    [7] = alias_sym_function_body,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__statement_seq, 2,
    aux_sym__statement_seq,
    alias_sym_function_body,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(168)
      if (lookahead == '\r') SKIP(168)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(265);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'b') ADVANCE(370);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'f') ADVANCE(381);
      if (lookahead == 'i') ADVANCE(361);
      if (lookahead == 'j') ADVANCE(320);
      if (lookahead == 'l') ADVANCE(353);
      if (lookahead == 'n') ADVANCE(330);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 's') ADVANCE(371);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(386);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('d' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 1:
      if (lookahead == '&') ADVANCE(226);
      END_STATE();
    case 2:
      if (lookahead == '-') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 3:
      if (lookahead == '-') ADVANCE(257);
      if (lookahead == '<') ADVANCE(209);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(257);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(250);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 7:
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(10);
      if (lookahead == '3') ADVANCE(9);
      if (lookahead == '8') ADVANCE(289);
      END_STATE();
    case 9:
      if (lookahead == '2') ADVANCE(293);
      END_STATE();
    case 10:
      if (lookahead == '6') ADVANCE(291);
      END_STATE();
    case 11:
      if (lookahead == '<') ADVANCE(209);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(228);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(227);
      END_STATE();
    case 14:
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 15:
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 16:
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '|') ADVANCE(225);
      END_STATE();
    case 17:
      if (lookahead == '_') ADVANCE(110);
      if (lookahead == 's') ADVANCE(287);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(99);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 22:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(115);
      END_STATE();
    case 26:
      if (lookahead == 'b') ADVANCE(260);
      END_STATE();
    case 27:
      if (lookahead == 'c') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'c') ADVANCE(104);
      END_STATE();
    case 29:
      if (lookahead == 'c') ADVANCE(90);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(303);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(45);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(200);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(31);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(8);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(179);
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 50:
      if (lookahead == 'g') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(20);
      if (lookahead == 't') ADVANCE(17);
      END_STATE();
    case 51:
      if (lookahead == 'g') ADVANCE(183);
      END_STATE();
    case 52:
      if (lookahead == 'g') ADVANCE(285);
      END_STATE();
    case 53:
      if (lookahead == 'g') ADVANCE(77);
      if (lookahead == 'z') ADVANCE(36);
      END_STATE();
    case 54:
      if (lookahead == 'g') ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'y') ADVANCE(111);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(113);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(80);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 67:
      if (lookahead == 'l') ADVANCE(86);
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 70:
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 71:
      if (lookahead == 'm') ADVANCE(92);
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(62);
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(38);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 79:
      if (lookahead == 'n') ADVANCE(43);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 83:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 85:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 86:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(64);
      END_STATE();
    case 89:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 92:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 93:
      if (lookahead == 'p') ADVANCE(19);
      END_STATE();
    case 94:
      if (lookahead == 'p') ADVANCE(37);
      END_STATE();
    case 95:
      if (lookahead == 'p') ADVANCE(87);
      END_STATE();
    case 96:
      if (lookahead == 'p') ADVANCE(117);
      END_STATE();
    case 97:
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 98:
      if (lookahead == 'p') ADVANCE(89);
      END_STATE();
    case 99:
      if (lookahead == 'q') ADVANCE(128);
      END_STATE();
    case 100:
      if (lookahead == 'r') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(132);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(116);
      END_STATE();
    case 106:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(279);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(28);
      END_STATE();
    case 109:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(281);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 118:
      if (lookahead == 't') ADVANCE(295);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(134);
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'e' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(266);
      END_STATE();
    case 127:
      if (lookahead == 'u') ADVANCE(26);
      END_STATE();
    case 128:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 129:
      if (lookahead == 'v') ADVANCE(23);
      END_STATE();
    case 130:
      if (lookahead == 'v') ADVANCE(40);
      END_STATE();
    case 131:
      if (lookahead == 'x') ADVANCE(122);
      END_STATE();
    case 132:
      if (lookahead == 'y') ADVANCE(277);
      END_STATE();
    case 133:
      if (lookahead == 'y') ADVANCE(94);
      END_STATE();
    case 134:
      if (lookahead == '{') ADVANCE(166);
      END_STATE();
    case 135:
      if (lookahead == '}') ADVANCE(267);
      END_STATE();
    case 136:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(135);
      END_STATE();
    case 137:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 138:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 139:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 140:
      if (lookahead == '}') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(139);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(141)
      if (lookahead == '\r') SKIP(141)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 142:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(142)
      if (lookahead == '\r') SKIP(142)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(5);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(3);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(143)
      if (lookahead == '\r') SKIP(143)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '.') ADVANCE(5);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 144:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(144)
      if (lookahead == '\r') SKIP(144)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(146)
      if (lookahead == '\r') SKIP(146)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(265);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(273);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '\\') ADVANCE(126);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'b') ADVANCE(55);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 'j') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 's') ADVANCE(56);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 146:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(146)
      if (lookahead == '\r') SKIP(146)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(273);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'b') ADVANCE(55);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 'j') ADVANCE(18);
      if (lookahead == 'l') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 's') ADVANCE(56);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == 'u') ADVANCE(73);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      END_STATE();
    case 147:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(147)
      if (lookahead == '\r') SKIP(147)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(212);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 148:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(148)
      if (lookahead == '\r') SKIP(148)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 149:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(149)
      if (lookahead == '\r') SKIP(149)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(426);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 150:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(150)
      if (lookahead == '\r') SKIP(150)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 151:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(151)
      if (lookahead == '\r') SKIP(151)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 152:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(152)
      if (lookahead == '\r') SKIP(152)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(3);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 153:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(153)
      if (lookahead == '\r') SKIP(153)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'i') ADVANCE(363);
      if (lookahead == '|') ADVANCE(252);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 154:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(154)
      if (lookahead == '\r') SKIP(154)
      if (lookahead == '!') ADVANCE(12);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(213);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(230);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 155:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(155)
      if (lookahead == '\r') SKIP(155)
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(432);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 156:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(156)
      if (lookahead == '\r') SKIP(156)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(4);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 157:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(157)
      if (lookahead == '\r') SKIP(157)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(14);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(4);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '>') ADVANCE(15);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(93);
      if (lookahead == 'p') ADVANCE(127);
      if (lookahead == 't') ADVANCE(133);
      if (lookahead == '|') ADVANCE(252);
      if (lookahead == '}') ADVANCE(182);
      END_STATE();
    case 158:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(158)
      if (lookahead == '\r') SKIP(158)
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '_') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(385);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 159:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(159)
      if (lookahead == '\r') SKIP(159)
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(314);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 160:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(160)
      if (lookahead == '\r') SKIP(160)
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(273);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(274);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 161:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(161)
      if (lookahead == '\r') SKIP(161)
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == 't') ADVANCE(455);
      if (lookahead == '}') ADVANCE(182);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 162:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(162)
      if (lookahead == '\r') SKIP(162)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'p') ADVANCE(325);
      if (lookahead == 't') ADVANCE(398);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 163:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(276);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(275);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 166:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(140);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(270);
      END_STATE();
    case 168:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(168)
      if (lookahead == '\r') SKIP(168)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == ')') ADVANCE(190);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == ',') ADVANCE(189);
      if (lookahead == '-') ADVANCE(214);
      if (lookahead == '.') ADVANCE(195);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(205);
      if (lookahead == '>') ADVANCE(235);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == ']') ADVANCE(208);
      if (lookahead == '_') ADVANCE(313);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'b') ADVANCE(370);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead == 'f') ADVANCE(381);
      if (lookahead == 'i') ADVANCE(361);
      if (lookahead == 'j') ADVANCE(320);
      if (lookahead == 'l') ADVANCE(353);
      if (lookahead == 'n') ADVANCE(330);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 's') ADVANCE(371);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(386);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(253);
      if (lookahead == '}') ADVANCE(182);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('d' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 169:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(169)
      if (lookahead == '\r') SKIP(169)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 170:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(170)
      if (lookahead == '\r') SKIP(170)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '-') ADVANCE(217);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '=') ADVANCE(204);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 171:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(171)
      if (lookahead == '\r') SKIP(171)
      if (lookahead == '!') ADVANCE(258);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '-') ADVANCE(216);
      if (lookahead == '/') ADVANCE(7);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(11);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(432);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 172:
      if (eof) ADVANCE(173);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == ' ') SKIP(172)
      if (lookahead == '\r') SKIP(172)
      if (lookahead == '!') ADVANCE(259);
      if (lookahead == '"') ADVANCE(264);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '%') ADVANCE(246);
      if (lookahead == '&') ADVANCE(1);
      if (lookahead == '(') ADVANCE(188);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '+') ADVANCE(240);
      if (lookahead == '-') ADVANCE(215);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '0') ADVANCE(271);
      if (lookahead == '<') ADVANCE(229);
      if (lookahead == '=') ADVANCE(13);
      if (lookahead == '>') ADVANCE(234);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(207);
      if (lookahead == '_') ADVANCE(315);
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'e') ADVANCE(453);
      if (lookahead == 'f') ADVANCE(385);
      if (lookahead == 'i') ADVANCE(362);
      if (lookahead == 'l') ADVANCE(354);
      if (lookahead == 'o') ADVANCE(409);
      if (lookahead == 'p') ADVANCE(324);
      if (lookahead == 't') ADVANCE(397);
      if (lookahead == 'u') ADVANCE(424);
      if (lookahead == '{') ADVANCE(181);
      if (lookahead == '|') ADVANCE(16);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(272);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(457);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_module_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_statement_comment);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_statement_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_erlang);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_erlang);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_javascript);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_javascript);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_import);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(250);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '.') ADVANCE(245);
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_type);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_const);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(227);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '>') ADVANCE(222);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '>') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(242);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(6);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_size);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_size);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_fn);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_external);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '.') ADVANCE(232);
      if (lookahead == '<') ADVANCE(209);
      if (lookahead == '=') ADVANCE(231);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '.') ADVANCE(232);
      if (lookahead == '=') ADVANCE(231);
      if (lookahead == '>') ADVANCE(247);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '.') ADVANCE(233);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_LT_DOT);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_LT_EQ_DOT);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '.') ADVANCE(237);
      if (lookahead == '=') ADVANCE(236);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '.') ADVANCE(237);
      if (lookahead == '=') ADVANCE(236);
      if (lookahead == '>') ADVANCE(210);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      if (lookahead == '.') ADVANCE(238);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_GT_DOT);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_GT_EQ_DOT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(241);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '.') ADVANCE(244);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_STAR_DOT);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_SLASH_DOT);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_todo);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_panic);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_case);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '>') ADVANCE(239);
      if (lookahead == '|') ADVANCE(225);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_let);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_assert);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_use);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(228);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_visibility_modifier);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_visibility_modifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_opacity_modifier);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_opacity_modifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token1);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'e') ADVANCE(2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(269);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym__hex);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == '.') ADVANCE(268);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(163);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(272);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym__decimal);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(163);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(274);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym__decimal);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(274);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym__octal);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(275);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym__binary);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(276);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_binary);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_bytes);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_bytes);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_int);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_bit_string);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_bit_string);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_bits);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_bits);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_utf8);
      if (lookahead == '_') ADVANCE(27);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_utf8);
      if (lookahead == '_') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_utf16);
      if (lookahead == '_') ADVANCE(29);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_utf16);
      if (lookahead == '_') ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_utf32);
      if (lookahead == '_') ADVANCE(30);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_utf32);
      if (lookahead == '_') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_utf8_codepoint);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_utf8_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_utf16_codepoint);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_utf16_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_utf32_codepoint);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_utf32_codepoint);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_signed);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_unsigned);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_big);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_big);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_little);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_little);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_native);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_unit);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_unit);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym__discard_name);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(313);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(314);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym__discard_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(314);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '.') ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(315);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '1') ADVANCE(318);
      if (lookahead == '3') ADVANCE(317);
      if (lookahead == '8') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '2') ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '6') ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == '_') ADVANCE(431);
      if (lookahead == 's') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(429);
      if (lookahead == 'o') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(429);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(389);
      if (lookahead == 'u') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(428);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(444);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'a') ADVANCE(437);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'b') ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(249);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'c') ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(304);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(359);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'd') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(310);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(263);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(338);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(434);
      if (lookahead == 'i') ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(434);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'e') ADVANCE(414);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (lookahead == 'm') ADVANCE(408);
      if (lookahead == 'n') ADVANCE(433);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (lookahead == 'm') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'f') ADVANCE(316);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(306);
      if (lookahead == 'n') ADVANCE(326);
      if (lookahead == 't') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(392);
      if (lookahead == 'z') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(456);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'g') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == 'y') ADVANCE(446);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(368);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(435);
      if (lookahead == 's') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'i') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(402);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'l') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(377);
      if (lookahead == 's') ADVANCE(344);
      if (lookahead == 't') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(430);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(441);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(442);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'n') ADVANCE(443);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(340);
      if (lookahead == 'y') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(331);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'o') ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(440);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'p') ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'q') ADVANCE(450);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(383);
      if (lookahead == 'x') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(454);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'r') ADVANCE(439);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(436);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 's') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(312);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(418);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 't') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'u') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'v') ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'v') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'x') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'y') ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym__name);
      if (lookahead == 'y') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym__name);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(456);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym__upname);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(457);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 169},
  [2] = {.lex_state = 169},
  [3] = {.lex_state = 169},
  [4] = {.lex_state = 169},
  [5] = {.lex_state = 169},
  [6] = {.lex_state = 169},
  [7] = {.lex_state = 169},
  [8] = {.lex_state = 141},
  [9] = {.lex_state = 141},
  [10] = {.lex_state = 141},
  [11] = {.lex_state = 141},
  [12] = {.lex_state = 141},
  [13] = {.lex_state = 141},
  [14] = {.lex_state = 141},
  [15] = {.lex_state = 172},
  [16] = {.lex_state = 172},
  [17] = {.lex_state = 141},
  [18] = {.lex_state = 169},
  [19] = {.lex_state = 169},
  [20] = {.lex_state = 141},
  [21] = {.lex_state = 141},
  [22] = {.lex_state = 141},
  [23] = {.lex_state = 141},
  [24] = {.lex_state = 169},
  [25] = {.lex_state = 169},
  [26] = {.lex_state = 169},
  [27] = {.lex_state = 141},
  [28] = {.lex_state = 169},
  [29] = {.lex_state = 141},
  [30] = {.lex_state = 141},
  [31] = {.lex_state = 141},
  [32] = {.lex_state = 169},
  [33] = {.lex_state = 141},
  [34] = {.lex_state = 169},
  [35] = {.lex_state = 141},
  [36] = {.lex_state = 141},
  [37] = {.lex_state = 141},
  [38] = {.lex_state = 169},
  [39] = {.lex_state = 141},
  [40] = {.lex_state = 141},
  [41] = {.lex_state = 141},
  [42] = {.lex_state = 169},
  [43] = {.lex_state = 141},
  [44] = {.lex_state = 141},
  [45] = {.lex_state = 169},
  [46] = {.lex_state = 141},
  [47] = {.lex_state = 169},
  [48] = {.lex_state = 141},
  [49] = {.lex_state = 169},
  [50] = {.lex_state = 141},
  [51] = {.lex_state = 169},
  [52] = {.lex_state = 169},
  [53] = {.lex_state = 141},
  [54] = {.lex_state = 141},
  [55] = {.lex_state = 169},
  [56] = {.lex_state = 169},
  [57] = {.lex_state = 141},
  [58] = {.lex_state = 141},
  [59] = {.lex_state = 169},
  [60] = {.lex_state = 141},
  [61] = {.lex_state = 141},
  [62] = {.lex_state = 141},
  [63] = {.lex_state = 141},
  [64] = {.lex_state = 141},
  [65] = {.lex_state = 141},
  [66] = {.lex_state = 169},
  [67] = {.lex_state = 141},
  [68] = {.lex_state = 141},
  [69] = {.lex_state = 141},
  [70] = {.lex_state = 141},
  [71] = {.lex_state = 169},
  [72] = {.lex_state = 141},
  [73] = {.lex_state = 169},
  [74] = {.lex_state = 141},
  [75] = {.lex_state = 169},
  [76] = {.lex_state = 169},
  [77] = {.lex_state = 169},
  [78] = {.lex_state = 169},
  [79] = {.lex_state = 141},
  [80] = {.lex_state = 169},
  [81] = {.lex_state = 141},
  [82] = {.lex_state = 169},
  [83] = {.lex_state = 141},
  [84] = {.lex_state = 169},
  [85] = {.lex_state = 141},
  [86] = {.lex_state = 169},
  [87] = {.lex_state = 169},
  [88] = {.lex_state = 142},
  [89] = {.lex_state = 142},
  [90] = {.lex_state = 169},
  [91] = {.lex_state = 169},
  [92] = {.lex_state = 169},
  [93] = {.lex_state = 169},
  [94] = {.lex_state = 169},
  [95] = {.lex_state = 142},
  [96] = {.lex_state = 169},
  [97] = {.lex_state = 169},
  [98] = {.lex_state = 169},
  [99] = {.lex_state = 169},
  [100] = {.lex_state = 169},
  [101] = {.lex_state = 169},
  [102] = {.lex_state = 169},
  [103] = {.lex_state = 169},
  [104] = {.lex_state = 169},
  [105] = {.lex_state = 169},
  [106] = {.lex_state = 169},
  [107] = {.lex_state = 169},
  [108] = {.lex_state = 169},
  [109] = {.lex_state = 142},
  [110] = {.lex_state = 169},
  [111] = {.lex_state = 169},
  [112] = {.lex_state = 142},
  [113] = {.lex_state = 169},
  [114] = {.lex_state = 169},
  [115] = {.lex_state = 169},
  [116] = {.lex_state = 169},
  [117] = {.lex_state = 169},
  [118] = {.lex_state = 169},
  [119] = {.lex_state = 169},
  [120] = {.lex_state = 169},
  [121] = {.lex_state = 169},
  [122] = {.lex_state = 169},
  [123] = {.lex_state = 169},
  [124] = {.lex_state = 142},
  [125] = {.lex_state = 142},
  [126] = {.lex_state = 142},
  [127] = {.lex_state = 142},
  [128] = {.lex_state = 142},
  [129] = {.lex_state = 162},
  [130] = {.lex_state = 142},
  [131] = {.lex_state = 142},
  [132] = {.lex_state = 142},
  [133] = {.lex_state = 142},
  [134] = {.lex_state = 142},
  [135] = {.lex_state = 142},
  [136] = {.lex_state = 142},
  [137] = {.lex_state = 142},
  [138] = {.lex_state = 142},
  [139] = {.lex_state = 162},
  [140] = {.lex_state = 162},
  [141] = {.lex_state = 142},
  [142] = {.lex_state = 162},
  [143] = {.lex_state = 142},
  [144] = {.lex_state = 162},
  [145] = {.lex_state = 162},
  [146] = {.lex_state = 162},
  [147] = {.lex_state = 162},
  [148] = {.lex_state = 162},
  [149] = {.lex_state = 162},
  [150] = {.lex_state = 162},
  [151] = {.lex_state = 162},
  [152] = {.lex_state = 162},
  [153] = {.lex_state = 162},
  [154] = {.lex_state = 162},
  [155] = {.lex_state = 162},
  [156] = {.lex_state = 162},
  [157] = {.lex_state = 162},
  [158] = {.lex_state = 162},
  [159] = {.lex_state = 143},
  [160] = {.lex_state = 162},
  [161] = {.lex_state = 162},
  [162] = {.lex_state = 143},
  [163] = {.lex_state = 143},
  [164] = {.lex_state = 162},
  [165] = {.lex_state = 143},
  [166] = {.lex_state = 162},
  [167] = {.lex_state = 143},
  [168] = {.lex_state = 162},
  [169] = {.lex_state = 162},
  [170] = {.lex_state = 162},
  [171] = {.lex_state = 143},
  [172] = {.lex_state = 143},
  [173] = {.lex_state = 143},
  [174] = {.lex_state = 162},
  [175] = {.lex_state = 162},
  [176] = {.lex_state = 143},
  [177] = {.lex_state = 142},
  [178] = {.lex_state = 143},
  [179] = {.lex_state = 162},
  [180] = {.lex_state = 162},
  [181] = {.lex_state = 162},
  [182] = {.lex_state = 143},
  [183] = {.lex_state = 143},
  [184] = {.lex_state = 143},
  [185] = {.lex_state = 143},
  [186] = {.lex_state = 143},
  [187] = {.lex_state = 143},
  [188] = {.lex_state = 162},
  [189] = {.lex_state = 143},
  [190] = {.lex_state = 162},
  [191] = {.lex_state = 162},
  [192] = {.lex_state = 143},
  [193] = {.lex_state = 162},
  [194] = {.lex_state = 162},
  [195] = {.lex_state = 143},
  [196] = {.lex_state = 162},
  [197] = {.lex_state = 162},
  [198] = {.lex_state = 143},
  [199] = {.lex_state = 143},
  [200] = {.lex_state = 143},
  [201] = {.lex_state = 143},
  [202] = {.lex_state = 162},
  [203] = {.lex_state = 162},
  [204] = {.lex_state = 162},
  [205] = {.lex_state = 162},
  [206] = {.lex_state = 162},
  [207] = {.lex_state = 143},
  [208] = {.lex_state = 162},
  [209] = {.lex_state = 143},
  [210] = {.lex_state = 162},
  [211] = {.lex_state = 143},
  [212] = {.lex_state = 162},
  [213] = {.lex_state = 143},
  [214] = {.lex_state = 143},
  [215] = {.lex_state = 143},
  [216] = {.lex_state = 143},
  [217] = {.lex_state = 143},
  [218] = {.lex_state = 162},
  [219] = {.lex_state = 143},
  [220] = {.lex_state = 143},
  [221] = {.lex_state = 143},
  [222] = {.lex_state = 143},
  [223] = {.lex_state = 143},
  [224] = {.lex_state = 143},
  [225] = {.lex_state = 143},
  [226] = {.lex_state = 143},
  [227] = {.lex_state = 143},
  [228] = {.lex_state = 143},
  [229] = {.lex_state = 143},
  [230] = {.lex_state = 143},
  [231] = {.lex_state = 143},
  [232] = {.lex_state = 143},
  [233] = {.lex_state = 143},
  [234] = {.lex_state = 143},
  [235] = {.lex_state = 143},
  [236] = {.lex_state = 143},
  [237] = {.lex_state = 143},
  [238] = {.lex_state = 143},
  [239] = {.lex_state = 143},
  [240] = {.lex_state = 143},
  [241] = {.lex_state = 143},
  [242] = {.lex_state = 143},
  [243] = {.lex_state = 143},
  [244] = {.lex_state = 143},
  [245] = {.lex_state = 143},
  [246] = {.lex_state = 143},
  [247] = {.lex_state = 143},
  [248] = {.lex_state = 143},
  [249] = {.lex_state = 143},
  [250] = {.lex_state = 143},
  [251] = {.lex_state = 143},
  [252] = {.lex_state = 143},
  [253] = {.lex_state = 143},
  [254] = {.lex_state = 143},
  [255] = {.lex_state = 143},
  [256] = {.lex_state = 143},
  [257] = {.lex_state = 143},
  [258] = {.lex_state = 143},
  [259] = {.lex_state = 143},
  [260] = {.lex_state = 143},
  [261] = {.lex_state = 143},
  [262] = {.lex_state = 143},
  [263] = {.lex_state = 143},
  [264] = {.lex_state = 143},
  [265] = {.lex_state = 143},
  [266] = {.lex_state = 143},
  [267] = {.lex_state = 143},
  [268] = {.lex_state = 143},
  [269] = {.lex_state = 143},
  [270] = {.lex_state = 143},
  [271] = {.lex_state = 143},
  [272] = {.lex_state = 143},
  [273] = {.lex_state = 143},
  [274] = {.lex_state = 143},
  [275] = {.lex_state = 143},
  [276] = {.lex_state = 143},
  [277] = {.lex_state = 143},
  [278] = {.lex_state = 143},
  [279] = {.lex_state = 143},
  [280] = {.lex_state = 143},
  [281] = {.lex_state = 143},
  [282] = {.lex_state = 143},
  [283] = {.lex_state = 143},
  [284] = {.lex_state = 143},
  [285] = {.lex_state = 143},
  [286] = {.lex_state = 143},
  [287] = {.lex_state = 143},
  [288] = {.lex_state = 143},
  [289] = {.lex_state = 143},
  [290] = {.lex_state = 144},
  [291] = {.lex_state = 143},
  [292] = {.lex_state = 143},
  [293] = {.lex_state = 143},
  [294] = {.lex_state = 162},
  [295] = {.lex_state = 143},
  [296] = {.lex_state = 143},
  [297] = {.lex_state = 143},
  [298] = {.lex_state = 143},
  [299] = {.lex_state = 143},
  [300] = {.lex_state = 143},
  [301] = {.lex_state = 143},
  [302] = {.lex_state = 143},
  [303] = {.lex_state = 143},
  [304] = {.lex_state = 143},
  [305] = {.lex_state = 143},
  [306] = {.lex_state = 143},
  [307] = {.lex_state = 143},
  [308] = {.lex_state = 143},
  [309] = {.lex_state = 143},
  [310] = {.lex_state = 143},
  [311] = {.lex_state = 143},
  [312] = {.lex_state = 143},
  [313] = {.lex_state = 143},
  [314] = {.lex_state = 143},
  [315] = {.lex_state = 143},
  [316] = {.lex_state = 144},
  [317] = {.lex_state = 143},
  [318] = {.lex_state = 143},
  [319] = {.lex_state = 143},
  [320] = {.lex_state = 143},
  [321] = {.lex_state = 143},
  [322] = {.lex_state = 143},
  [323] = {.lex_state = 143},
  [324] = {.lex_state = 143},
  [325] = {.lex_state = 143},
  [326] = {.lex_state = 143},
  [327] = {.lex_state = 143},
  [328] = {.lex_state = 162},
  [329] = {.lex_state = 143},
  [330] = {.lex_state = 143},
  [331] = {.lex_state = 143},
  [332] = {.lex_state = 162},
  [333] = {.lex_state = 162},
  [334] = {.lex_state = 143},
  [335] = {.lex_state = 143},
  [336] = {.lex_state = 162},
  [337] = {.lex_state = 162},
  [338] = {.lex_state = 162},
  [339] = {.lex_state = 143},
  [340] = {.lex_state = 162},
  [341] = {.lex_state = 162},
  [342] = {.lex_state = 143},
  [343] = {.lex_state = 162},
  [344] = {.lex_state = 143},
  [345] = {.lex_state = 143},
  [346] = {.lex_state = 143},
  [347] = {.lex_state = 143},
  [348] = {.lex_state = 143},
  [349] = {.lex_state = 162},
  [350] = {.lex_state = 162},
  [351] = {.lex_state = 162},
  [352] = {.lex_state = 162},
  [353] = {.lex_state = 162},
  [354] = {.lex_state = 145},
  [355] = {.lex_state = 145},
  [356] = {.lex_state = 145},
  [357] = {.lex_state = 145},
  [358] = {.lex_state = 147},
  [359] = {.lex_state = 145},
  [360] = {.lex_state = 145},
  [361] = {.lex_state = 148},
  [362] = {.lex_state = 148},
  [363] = {.lex_state = 148},
  [364] = {.lex_state = 148},
  [365] = {.lex_state = 148},
  [366] = {.lex_state = 148},
  [367] = {.lex_state = 148},
  [368] = {.lex_state = 148},
  [369] = {.lex_state = 149},
  [370] = {.lex_state = 149},
  [371] = {.lex_state = 148},
  [372] = {.lex_state = 148},
  [373] = {.lex_state = 148},
  [374] = {.lex_state = 148},
  [375] = {.lex_state = 148},
  [376] = {.lex_state = 148},
  [377] = {.lex_state = 148},
  [378] = {.lex_state = 148},
  [379] = {.lex_state = 148},
  [380] = {.lex_state = 148},
  [381] = {.lex_state = 148},
  [382] = {.lex_state = 148},
  [383] = {.lex_state = 148},
  [384] = {.lex_state = 148},
  [385] = {.lex_state = 148},
  [386] = {.lex_state = 148},
  [387] = {.lex_state = 148},
  [388] = {.lex_state = 148},
  [389] = {.lex_state = 148},
  [390] = {.lex_state = 148},
  [391] = {.lex_state = 148},
  [392] = {.lex_state = 148},
  [393] = {.lex_state = 148},
  [394] = {.lex_state = 148},
  [395] = {.lex_state = 148},
  [396] = {.lex_state = 148},
  [397] = {.lex_state = 148},
  [398] = {.lex_state = 148},
  [399] = {.lex_state = 148},
  [400] = {.lex_state = 148},
  [401] = {.lex_state = 148},
  [402] = {.lex_state = 148},
  [403] = {.lex_state = 148},
  [404] = {.lex_state = 148},
  [405] = {.lex_state = 148},
  [406] = {.lex_state = 148},
  [407] = {.lex_state = 148},
  [408] = {.lex_state = 148},
  [409] = {.lex_state = 148},
  [410] = {.lex_state = 148},
  [411] = {.lex_state = 148},
  [412] = {.lex_state = 148},
  [413] = {.lex_state = 148},
  [414] = {.lex_state = 148},
  [415] = {.lex_state = 148},
  [416] = {.lex_state = 148},
  [417] = {.lex_state = 148},
  [418] = {.lex_state = 148},
  [419] = {.lex_state = 148},
  [420] = {.lex_state = 148},
  [421] = {.lex_state = 148},
  [422] = {.lex_state = 148},
  [423] = {.lex_state = 148},
  [424] = {.lex_state = 148},
  [425] = {.lex_state = 172},
  [426] = {.lex_state = 147},
  [427] = {.lex_state = 172},
  [428] = {.lex_state = 172},
  [429] = {.lex_state = 147},
  [430] = {.lex_state = 147},
  [431] = {.lex_state = 147},
  [432] = {.lex_state = 147},
  [433] = {.lex_state = 147},
  [434] = {.lex_state = 147},
  [435] = {.lex_state = 147},
  [436] = {.lex_state = 147},
  [437] = {.lex_state = 147},
  [438] = {.lex_state = 147},
  [439] = {.lex_state = 147},
  [440] = {.lex_state = 147},
  [441] = {.lex_state = 147},
  [442] = {.lex_state = 147},
  [443] = {.lex_state = 170},
  [444] = {.lex_state = 172},
  [445] = {.lex_state = 147},
  [446] = {.lex_state = 147},
  [447] = {.lex_state = 170},
  [448] = {.lex_state = 147},
  [449] = {.lex_state = 147},
  [450] = {.lex_state = 148},
  [451] = {.lex_state = 148},
  [452] = {.lex_state = 147},
  [453] = {.lex_state = 148},
  [454] = {.lex_state = 147},
  [455] = {.lex_state = 148},
  [456] = {.lex_state = 169},
  [457] = {.lex_state = 147},
  [458] = {.lex_state = 148},
  [459] = {.lex_state = 147},
  [460] = {.lex_state = 170},
  [461] = {.lex_state = 169},
  [462] = {.lex_state = 147},
  [463] = {.lex_state = 147},
  [464] = {.lex_state = 172},
  [465] = {.lex_state = 147},
  [466] = {.lex_state = 169},
  [467] = {.lex_state = 147},
  [468] = {.lex_state = 171},
  [469] = {.lex_state = 147},
  [470] = {.lex_state = 171},
  [471] = {.lex_state = 148},
  [472] = {.lex_state = 170},
  [473] = {.lex_state = 147},
  [474] = {.lex_state = 170},
  [475] = {.lex_state = 172},
  [476] = {.lex_state = 170},
  [477] = {.lex_state = 147},
  [478] = {.lex_state = 169},
  [479] = {.lex_state = 147},
  [480] = {.lex_state = 147},
  [481] = {.lex_state = 147},
  [482] = {.lex_state = 147},
  [483] = {.lex_state = 172},
  [484] = {.lex_state = 147},
  [485] = {.lex_state = 147},
  [486] = {.lex_state = 147},
  [487] = {.lex_state = 171},
  [488] = {.lex_state = 147},
  [489] = {.lex_state = 147},
  [490] = {.lex_state = 147},
  [491] = {.lex_state = 147},
  [492] = {.lex_state = 170},
  [493] = {.lex_state = 147},
  [494] = {.lex_state = 147},
  [495] = {.lex_state = 147},
  [496] = {.lex_state = 169},
  [497] = {.lex_state = 147},
  [498] = {.lex_state = 147},
  [499] = {.lex_state = 148},
  [500] = {.lex_state = 172},
  [501] = {.lex_state = 170},
  [502] = {.lex_state = 171},
  [503] = {.lex_state = 148},
  [504] = {.lex_state = 148},
  [505] = {.lex_state = 170},
  [506] = {.lex_state = 171},
  [507] = {.lex_state = 145},
  [508] = {.lex_state = 148},
  [509] = {.lex_state = 147},
  [510] = {.lex_state = 147},
  [511] = {.lex_state = 170},
  [512] = {.lex_state = 147},
  [513] = {.lex_state = 147},
  [514] = {.lex_state = 145},
  [515] = {.lex_state = 145},
  [516] = {.lex_state = 147},
  [517] = {.lex_state = 147},
  [518] = {.lex_state = 147},
  [519] = {.lex_state = 172},
  [520] = {.lex_state = 145},
  [521] = {.lex_state = 172},
  [522] = {.lex_state = 145},
  [523] = {.lex_state = 147},
  [524] = {.lex_state = 145},
  [525] = {.lex_state = 171},
  [526] = {.lex_state = 147},
  [527] = {.lex_state = 169},
  [528] = {.lex_state = 169},
  [529] = {.lex_state = 169},
  [530] = {.lex_state = 169},
  [531] = {.lex_state = 145},
  [532] = {.lex_state = 169},
  [533] = {.lex_state = 169},
  [534] = {.lex_state = 169},
  [535] = {.lex_state = 169},
  [536] = {.lex_state = 150},
  [537] = {.lex_state = 169},
  [538] = {.lex_state = 169},
  [539] = {.lex_state = 169},
  [540] = {.lex_state = 169},
  [541] = {.lex_state = 169},
  [542] = {.lex_state = 169},
  [543] = {.lex_state = 169},
  [544] = {.lex_state = 169},
  [545] = {.lex_state = 169},
  [546] = {.lex_state = 150},
  [547] = {.lex_state = 169},
  [548] = {.lex_state = 169},
  [549] = {.lex_state = 169},
  [550] = {.lex_state = 150},
  [551] = {.lex_state = 169},
  [552] = {.lex_state = 169},
  [553] = {.lex_state = 169},
  [554] = {.lex_state = 169},
  [555] = {.lex_state = 169},
  [556] = {.lex_state = 169},
  [557] = {.lex_state = 169},
  [558] = {.lex_state = 169},
  [559] = {.lex_state = 169},
  [560] = {.lex_state = 150},
  [561] = {.lex_state = 169},
  [562] = {.lex_state = 169},
  [563] = {.lex_state = 169},
  [564] = {.lex_state = 169},
  [565] = {.lex_state = 169},
  [566] = {.lex_state = 169},
  [567] = {.lex_state = 169},
  [568] = {.lex_state = 169},
  [569] = {.lex_state = 145},
  [570] = {.lex_state = 169},
  [571] = {.lex_state = 169},
  [572] = {.lex_state = 169},
  [573] = {.lex_state = 169},
  [574] = {.lex_state = 169},
  [575] = {.lex_state = 150},
  [576] = {.lex_state = 169},
  [577] = {.lex_state = 169},
  [578] = {.lex_state = 169},
  [579] = {.lex_state = 169},
  [580] = {.lex_state = 169},
  [581] = {.lex_state = 169},
  [582] = {.lex_state = 169},
  [583] = {.lex_state = 150},
  [584] = {.lex_state = 169},
  [585] = {.lex_state = 151},
  [586] = {.lex_state = 169},
  [587] = {.lex_state = 145},
  [588] = {.lex_state = 169},
  [589] = {.lex_state = 169},
  [590] = {.lex_state = 150},
  [591] = {.lex_state = 169},
  [592] = {.lex_state = 169},
  [593] = {.lex_state = 169},
  [594] = {.lex_state = 169},
  [595] = {.lex_state = 169},
  [596] = {.lex_state = 169},
  [597] = {.lex_state = 150},
  [598] = {.lex_state = 169},
  [599] = {.lex_state = 169},
  [600] = {.lex_state = 169},
  [601] = {.lex_state = 169},
  [602] = {.lex_state = 169},
  [603] = {.lex_state = 169},
  [604] = {.lex_state = 169},
  [605] = {.lex_state = 150},
  [606] = {.lex_state = 147},
  [607] = {.lex_state = 169},
  [608] = {.lex_state = 150},
  [609] = {.lex_state = 152},
  [610] = {.lex_state = 145},
  [611] = {.lex_state = 148},
  [612] = {.lex_state = 153},
  [613] = {.lex_state = 145},
  [614] = {.lex_state = 145},
  [615] = {.lex_state = 153},
  [616] = {.lex_state = 153},
  [617] = {.lex_state = 153},
  [618] = {.lex_state = 152},
  [619] = {.lex_state = 154},
  [620] = {.lex_state = 148},
  [621] = {.lex_state = 148},
  [622] = {.lex_state = 155},
  [623] = {.lex_state = 148},
  [624] = {.lex_state = 148},
  [625] = {.lex_state = 148},
  [626] = {.lex_state = 148},
  [627] = {.lex_state = 152},
  [628] = {.lex_state = 152},
  [629] = {.lex_state = 155},
  [630] = {.lex_state = 147},
  [631] = {.lex_state = 147},
  [632] = {.lex_state = 154},
  [633] = {.lex_state = 148},
  [634] = {.lex_state = 148},
  [635] = {.lex_state = 154},
  [636] = {.lex_state = 154},
  [637] = {.lex_state = 148},
  [638] = {.lex_state = 147},
  [639] = {.lex_state = 154},
  [640] = {.lex_state = 154},
  [641] = {.lex_state = 148},
  [642] = {.lex_state = 154},
  [643] = {.lex_state = 148},
  [644] = {.lex_state = 154},
  [645] = {.lex_state = 148},
  [646] = {.lex_state = 147},
  [647] = {.lex_state = 148},
  [648] = {.lex_state = 154},
  [649] = {.lex_state = 148},
  [650] = {.lex_state = 154},
  [651] = {.lex_state = 154},
  [652] = {.lex_state = 154},
  [653] = {.lex_state = 148},
  [654] = {.lex_state = 154},
  [655] = {.lex_state = 147},
  [656] = {.lex_state = 154},
  [657] = {.lex_state = 148},
  [658] = {.lex_state = 154},
  [659] = {.lex_state = 148},
  [660] = {.lex_state = 154},
  [661] = {.lex_state = 154},
  [662] = {.lex_state = 148},
  [663] = {.lex_state = 154},
  [664] = {.lex_state = 154},
  [665] = {.lex_state = 154},
  [666] = {.lex_state = 148},
  [667] = {.lex_state = 148},
  [668] = {.lex_state = 147},
  [669] = {.lex_state = 147},
  [670] = {.lex_state = 154},
  [671] = {.lex_state = 154},
  [672] = {.lex_state = 154},
  [673] = {.lex_state = 154},
  [674] = {.lex_state = 154},
  [675] = {.lex_state = 148},
  [676] = {.lex_state = 154},
  [677] = {.lex_state = 154},
  [678] = {.lex_state = 147},
  [679] = {.lex_state = 150},
  [680] = {.lex_state = 154},
  [681] = {.lex_state = 150},
  [682] = {.lex_state = 154},
  [683] = {.lex_state = 154},
  [684] = {.lex_state = 154},
  [685] = {.lex_state = 154},
  [686] = {.lex_state = 147},
  [687] = {.lex_state = 154},
  [688] = {.lex_state = 154},
  [689] = {.lex_state = 150},
  [690] = {.lex_state = 150},
  [691] = {.lex_state = 150},
  [692] = {.lex_state = 147},
  [693] = {.lex_state = 154},
  [694] = {.lex_state = 154},
  [695] = {.lex_state = 148},
  [696] = {.lex_state = 150},
  [697] = {.lex_state = 147},
  [698] = {.lex_state = 150},
  [699] = {.lex_state = 154},
  [700] = {.lex_state = 150},
  [701] = {.lex_state = 150},
  [702] = {.lex_state = 147},
  [703] = {.lex_state = 154},
  [704] = {.lex_state = 154},
  [705] = {.lex_state = 148},
  [706] = {.lex_state = 150},
  [707] = {.lex_state = 154},
  [708] = {.lex_state = 154},
  [709] = {.lex_state = 150},
  [710] = {.lex_state = 150},
  [711] = {.lex_state = 150},
  [712] = {.lex_state = 150},
  [713] = {.lex_state = 148},
  [714] = {.lex_state = 154},
  [715] = {.lex_state = 154},
  [716] = {.lex_state = 147},
  [717] = {.lex_state = 154},
  [718] = {.lex_state = 154},
  [719] = {.lex_state = 154},
  [720] = {.lex_state = 154},
  [721] = {.lex_state = 154},
  [722] = {.lex_state = 148},
  [723] = {.lex_state = 150},
  [724] = {.lex_state = 148},
  [725] = {.lex_state = 150},
  [726] = {.lex_state = 150},
  [727] = {.lex_state = 150},
  [728] = {.lex_state = 154},
  [729] = {.lex_state = 150},
  [730] = {.lex_state = 154},
  [731] = {.lex_state = 150},
  [732] = {.lex_state = 147},
  [733] = {.lex_state = 147},
  [734] = {.lex_state = 154},
  [735] = {.lex_state = 154},
  [736] = {.lex_state = 147},
  [737] = {.lex_state = 147},
  [738] = {.lex_state = 147},
  [739] = {.lex_state = 147},
  [740] = {.lex_state = 154},
  [741] = {.lex_state = 154},
  [742] = {.lex_state = 147},
  [743] = {.lex_state = 150},
  [744] = {.lex_state = 154},
  [745] = {.lex_state = 150},
  [746] = {.lex_state = 154},
  [747] = {.lex_state = 147},
  [748] = {.lex_state = 147},
  [749] = {.lex_state = 154},
  [750] = {.lex_state = 154},
  [751] = {.lex_state = 154},
  [752] = {.lex_state = 154},
  [753] = {.lex_state = 147},
  [754] = {.lex_state = 154},
  [755] = {.lex_state = 154},
  [756] = {.lex_state = 154},
  [757] = {.lex_state = 147},
  [758] = {.lex_state = 147},
  [759] = {.lex_state = 154},
  [760] = {.lex_state = 150},
  [761] = {.lex_state = 150},
  [762] = {.lex_state = 147},
  [763] = {.lex_state = 147},
  [764] = {.lex_state = 154},
  [765] = {.lex_state = 154},
  [766] = {.lex_state = 154},
  [767] = {.lex_state = 154},
  [768] = {.lex_state = 154},
  [769] = {.lex_state = 147},
  [770] = {.lex_state = 154},
  [771] = {.lex_state = 147},
  [772] = {.lex_state = 154},
  [773] = {.lex_state = 150},
  [774] = {.lex_state = 154},
  [775] = {.lex_state = 147},
  [776] = {.lex_state = 154},
  [777] = {.lex_state = 154},
  [778] = {.lex_state = 154},
  [779] = {.lex_state = 150},
  [780] = {.lex_state = 150},
  [781] = {.lex_state = 150},
  [782] = {.lex_state = 154},
  [783] = {.lex_state = 154},
  [784] = {.lex_state = 154},
  [785] = {.lex_state = 150},
  [786] = {.lex_state = 154},
  [787] = {.lex_state = 154},
  [788] = {.lex_state = 150},
  [789] = {.lex_state = 147},
  [790] = {.lex_state = 150},
  [791] = {.lex_state = 147},
  [792] = {.lex_state = 147},
  [793] = {.lex_state = 147},
  [794] = {.lex_state = 147},
  [795] = {.lex_state = 150},
  [796] = {.lex_state = 147},
  [797] = {.lex_state = 150},
  [798] = {.lex_state = 150},
  [799] = {.lex_state = 150},
  [800] = {.lex_state = 150},
  [801] = {.lex_state = 150},
  [802] = {.lex_state = 150},
  [803] = {.lex_state = 150},
  [804] = {.lex_state = 150},
  [805] = {.lex_state = 150},
  [806] = {.lex_state = 150},
  [807] = {.lex_state = 150},
  [808] = {.lex_state = 150},
  [809] = {.lex_state = 156},
  [810] = {.lex_state = 157},
  [811] = {.lex_state = 141},
  [812] = {.lex_state = 141},
  [813] = {.lex_state = 141},
  [814] = {.lex_state = 145},
  [815] = {.lex_state = 145},
  [816] = {.lex_state = 145},
  [817] = {.lex_state = 158},
  [818] = {.lex_state = 158},
  [819] = {.lex_state = 158},
  [820] = {.lex_state = 158},
  [821] = {.lex_state = 158},
  [822] = {.lex_state = 158},
  [823] = {.lex_state = 158},
  [824] = {.lex_state = 158},
  [825] = {.lex_state = 156},
  [826] = {.lex_state = 156},
  [827] = {.lex_state = 156},
  [828] = {.lex_state = 158},
  [829] = {.lex_state = 158},
  [830] = {.lex_state = 158},
  [831] = {.lex_state = 158},
  [832] = {.lex_state = 158},
  [833] = {.lex_state = 158},
  [834] = {.lex_state = 158},
  [835] = {.lex_state = 157},
  [836] = {.lex_state = 158},
  [837] = {.lex_state = 158},
  [838] = {.lex_state = 158},
  [839] = {.lex_state = 158},
  [840] = {.lex_state = 158},
  [841] = {.lex_state = 158},
  [842] = {.lex_state = 158},
  [843] = {.lex_state = 158},
  [844] = {.lex_state = 158},
  [845] = {.lex_state = 158},
  [846] = {.lex_state = 158},
  [847] = {.lex_state = 158},
  [848] = {.lex_state = 156},
  [849] = {.lex_state = 158},
  [850] = {.lex_state = 158},
  [851] = {.lex_state = 156},
  [852] = {.lex_state = 154},
  [853] = {.lex_state = 156},
  [854] = {.lex_state = 158},
  [855] = {.lex_state = 158},
  [856] = {.lex_state = 158},
  [857] = {.lex_state = 158},
  [858] = {.lex_state = 156},
  [859] = {.lex_state = 158},
  [860] = {.lex_state = 158},
  [861] = {.lex_state = 158},
  [862] = {.lex_state = 158},
  [863] = {.lex_state = 158},
  [864] = {.lex_state = 158},
  [865] = {.lex_state = 158},
  [866] = {.lex_state = 156},
  [867] = {.lex_state = 158},
  [868] = {.lex_state = 158},
  [869] = {.lex_state = 158},
  [870] = {.lex_state = 158},
  [871] = {.lex_state = 154},
  [872] = {.lex_state = 158},
  [873] = {.lex_state = 158},
  [874] = {.lex_state = 156},
  [875] = {.lex_state = 156},
  [876] = {.lex_state = 156},
  [877] = {.lex_state = 156},
  [878] = {.lex_state = 158},
  [879] = {.lex_state = 154},
  [880] = {.lex_state = 158},
  [881] = {.lex_state = 158},
  [882] = {.lex_state = 158},
  [883] = {.lex_state = 158},
  [884] = {.lex_state = 156},
  [885] = {.lex_state = 158},
  [886] = {.lex_state = 158},
  [887] = {.lex_state = 147},
  [888] = {.lex_state = 158},
  [889] = {.lex_state = 158},
  [890] = {.lex_state = 158},
  [891] = {.lex_state = 156},
  [892] = {.lex_state = 156},
  [893] = {.lex_state = 158},
  [894] = {.lex_state = 156},
  [895] = {.lex_state = 158},
  [896] = {.lex_state = 158},
  [897] = {.lex_state = 154},
  [898] = {.lex_state = 154},
  [899] = {.lex_state = 154},
  [900] = {.lex_state = 158},
  [901] = {.lex_state = 158},
  [902] = {.lex_state = 145},
  [903] = {.lex_state = 157},
  [904] = {.lex_state = 157},
  [905] = {.lex_state = 157},
  [906] = {.lex_state = 157},
  [907] = {.lex_state = 157},
  [908] = {.lex_state = 154},
  [909] = {.lex_state = 154},
  [910] = {.lex_state = 157},
  [911] = {.lex_state = 154},
  [912] = {.lex_state = 157},
  [913] = {.lex_state = 157},
  [914] = {.lex_state = 157},
  [915] = {.lex_state = 157},
  [916] = {.lex_state = 157},
  [917] = {.lex_state = 157},
  [918] = {.lex_state = 158},
  [919] = {.lex_state = 158},
  [920] = {.lex_state = 157},
  [921] = {.lex_state = 157},
  [922] = {.lex_state = 157},
  [923] = {.lex_state = 157},
  [924] = {.lex_state = 157},
  [925] = {.lex_state = 157},
  [926] = {.lex_state = 157},
  [927] = {.lex_state = 147},
  [928] = {.lex_state = 145},
  [929] = {.lex_state = 158},
  [930] = {.lex_state = 156},
  [931] = {.lex_state = 147},
  [932] = {.lex_state = 157},
  [933] = {.lex_state = 147},
  [934] = {.lex_state = 157},
  [935] = {.lex_state = 157},
  [936] = {.lex_state = 157},
  [937] = {.lex_state = 157},
  [938] = {.lex_state = 147},
  [939] = {.lex_state = 157},
  [940] = {.lex_state = 157},
  [941] = {.lex_state = 154},
  [942] = {.lex_state = 157},
  [943] = {.lex_state = 157},
  [944] = {.lex_state = 158},
  [945] = {.lex_state = 145},
  [946] = {.lex_state = 145},
  [947] = {.lex_state = 156},
  [948] = {.lex_state = 145},
  [949] = {.lex_state = 151},
  [950] = {.lex_state = 151},
  [951] = {.lex_state = 156},
  [952] = {.lex_state = 159},
  [953] = {.lex_state = 156},
  [954] = {.lex_state = 159},
  [955] = {.lex_state = 145},
  [956] = {.lex_state = 157},
  [957] = {.lex_state = 156},
  [958] = {.lex_state = 151},
  [959] = {.lex_state = 156},
  [960] = {.lex_state = 151},
  [961] = {.lex_state = 156},
  [962] = {.lex_state = 159},
  [963] = {.lex_state = 151},
  [964] = {.lex_state = 159},
  [965] = {.lex_state = 151},
  [966] = {.lex_state = 159},
  [967] = {.lex_state = 159},
  [968] = {.lex_state = 156},
  [969] = {.lex_state = 145},
  [970] = {.lex_state = 145},
  [971] = {.lex_state = 145},
  [972] = {.lex_state = 145},
  [973] = {.lex_state = 159},
  [974] = {.lex_state = 160},
  [975] = {.lex_state = 160},
  [976] = {.lex_state = 145},
  [977] = {.lex_state = 145},
  [978] = {.lex_state = 145},
  [979] = {.lex_state = 145},
  [980] = {.lex_state = 156},
  [981] = {.lex_state = 145},
  [982] = {.lex_state = 145},
  [983] = {.lex_state = 145},
  [984] = {.lex_state = 145},
  [985] = {.lex_state = 145},
  [986] = {.lex_state = 145},
  [987] = {.lex_state = 145},
  [988] = {.lex_state = 145},
  [989] = {.lex_state = 145},
  [990] = {.lex_state = 145},
  [991] = {.lex_state = 145},
  [992] = {.lex_state = 157},
  [993] = {.lex_state = 145},
  [994] = {.lex_state = 145},
  [995] = {.lex_state = 145},
  [996] = {.lex_state = 145},
  [997] = {.lex_state = 145},
  [998] = {.lex_state = 145},
  [999] = {.lex_state = 145},
  [1000] = {.lex_state = 145},
  [1001] = {.lex_state = 145},
  [1002] = {.lex_state = 145},
  [1003] = {.lex_state = 160},
  [1004] = {.lex_state = 145},
  [1005] = {.lex_state = 145},
  [1006] = {.lex_state = 145},
  [1007] = {.lex_state = 157},
  [1008] = {.lex_state = 145},
  [1009] = {.lex_state = 157},
  [1010] = {.lex_state = 157},
  [1011] = {.lex_state = 156},
  [1012] = {.lex_state = 145},
  [1013] = {.lex_state = 145},
  [1014] = {.lex_state = 145},
  [1015] = {.lex_state = 156},
  [1016] = {.lex_state = 145},
  [1017] = {.lex_state = 157},
  [1018] = {.lex_state = 159},
  [1019] = {.lex_state = 157},
  [1020] = {.lex_state = 159},
  [1021] = {.lex_state = 159},
  [1022] = {.lex_state = 157},
  [1023] = {.lex_state = 157},
  [1024] = {.lex_state = 159},
  [1025] = {.lex_state = 161},
  [1026] = {.lex_state = 161},
  [1027] = {.lex_state = 161},
  [1028] = {.lex_state = 161},
  [1029] = {.lex_state = 161},
  [1030] = {.lex_state = 157},
  [1031] = {.lex_state = 161},
  [1032] = {.lex_state = 160},
  [1033] = {.lex_state = 160},
  [1034] = {.lex_state = 145},
  [1035] = {.lex_state = 145, .external_lex_state = 1},
  [1036] = {.lex_state = 145, .external_lex_state = 1},
  [1037] = {.lex_state = 145, .external_lex_state = 1},
  [1038] = {.lex_state = 145, .external_lex_state = 1},
  [1039] = {.lex_state = 145, .external_lex_state = 1},
  [1040] = {.lex_state = 145},
  [1041] = {.lex_state = 161},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 160},
  [1044] = {.lex_state = 145, .external_lex_state = 1},
  [1045] = {.lex_state = 145, .external_lex_state = 1},
  [1046] = {.lex_state = 145, .external_lex_state = 1},
  [1047] = {.lex_state = 160},
  [1048] = {.lex_state = 145, .external_lex_state = 1},
  [1049] = {.lex_state = 160},
  [1050] = {.lex_state = 160},
  [1051] = {.lex_state = 145},
  [1052] = {.lex_state = 157},
  [1053] = {.lex_state = 145, .external_lex_state = 1},
  [1054] = {.lex_state = 160},
  [1055] = {.lex_state = 145},
  [1056] = {.lex_state = 145, .external_lex_state = 1},
  [1057] = {.lex_state = 160},
  [1058] = {.lex_state = 145},
  [1059] = {.lex_state = 145},
  [1060] = {.lex_state = 145},
  [1061] = {.lex_state = 160},
  [1062] = {.lex_state = 160},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 145, .external_lex_state = 1},
  [1065] = {.lex_state = 160},
  [1066] = {.lex_state = 160},
  [1067] = {.lex_state = 145},
  [1068] = {.lex_state = 145, .external_lex_state = 1},
  [1069] = {.lex_state = 157},
  [1070] = {.lex_state = 159},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 145},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 157},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 145},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 159},
  [1083] = {.lex_state = 145},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 157},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 156},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 142},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 145},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 160},
  [1095] = {.lex_state = 159},
  [1096] = {.lex_state = 145},
  [1097] = {.lex_state = 160},
  [1098] = {.lex_state = 145},
  [1099] = {.lex_state = 145},
  [1100] = {.lex_state = 145},
  [1101] = {.lex_state = 142},
  [1102] = {.lex_state = 145},
  [1103] = {.lex_state = 157},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 160},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 160},
  [1110] = {.lex_state = 145},
  [1111] = {.lex_state = 159},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 145, .external_lex_state = 1},
  [1115] = {.lex_state = 145},
  [1116] = {.lex_state = 145},
  [1117] = {.lex_state = 159},
  [1118] = {.lex_state = 145},
  [1119] = {.lex_state = 145},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 160},
  [1122] = {.lex_state = 160},
  [1123] = {.lex_state = 145},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 160},
  [1127] = {.lex_state = 160},
  [1128] = {.lex_state = 145},
  [1129] = {.lex_state = 160},
  [1130] = {.lex_state = 142},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 157},
  [1133] = {.lex_state = 145},
  [1134] = {.lex_state = 157},
  [1135] = {.lex_state = 145},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 160},
  [1139] = {.lex_state = 159},
  [1140] = {.lex_state = 145},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 159},
  [1144] = {.lex_state = 160},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 142},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 160},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 145},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 151},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 142},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 169},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 145},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 142},
  [1184] = {.lex_state = 145},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 142},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 142},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 142},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 145},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 142},
  [1198] = {.lex_state = 142},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 142},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 157},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 145},
  [1207] = {.lex_state = 142},
  [1208] = {.lex_state = 142},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 160},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 142},
  [1216] = {.lex_state = 142},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 160},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 145},
  [1228] = {.lex_state = 142},
  [1229] = {.lex_state = 145},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 145},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 142},
  [1238] = {.lex_state = 160},
  [1239] = {.lex_state = 145},
  [1240] = {.lex_state = 142},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 142},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 160},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 142},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 142},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 160},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 142},
  [1278] = {.lex_state = 142},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 142},
  [1283] = {.lex_state = 169},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 145},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 142},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 160},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 145},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 145},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 169},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 169},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 160},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 160},
  [1318] = {.lex_state = 160},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 160},
  [1323] = {.lex_state = 142},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 169},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 160},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 160},
  [1339] = {.lex_state = 142},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 160},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 160},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 169},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 160},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 142},
  [1354] = {.lex_state = 160},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 145},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 169},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 169},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 142},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 160},
  [1377] = {.lex_state = 169},
  [1378] = {.lex_state = 169},
  [1379] = {.lex_state = 160},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 160},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 160},
  [1391] = {.lex_state = 169},
  [1392] = {.lex_state = 169},
  [1393] = {.lex_state = 160},
  [1394] = {.lex_state = 160},
  [1395] = {.lex_state = 169},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 160},
  [1400] = {.lex_state = 160},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 169},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 145},
  [1406] = {.lex_state = 160},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 160},
  [1415] = {.lex_state = 160},
  [1416] = {.lex_state = 142},
  [1417] = {.lex_state = 169},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 169},
  [1421] = {.lex_state = 160},
  [1422] = {.lex_state = 0},
  [1423] = {.lex_state = 0},
  [1424] = {.lex_state = 0},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 0},
  [1428] = {.lex_state = 160},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 0},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 160},
  [1436] = {.lex_state = 145},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 145},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 160},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 142},
  [1446] = {.lex_state = 160},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 0},
  [1449] = {.lex_state = 142},
  [1450] = {.lex_state = 0},
  [1451] = {.lex_state = 0},
  [1452] = {.lex_state = 0},
  [1453] = {.lex_state = 142},
  [1454] = {.lex_state = 0},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 145},
  [1458] = {.lex_state = 142},
  [1459] = {.lex_state = 0},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 0},
  [1472] = {.lex_state = 160},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 142},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 142},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 0},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 142},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 142},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 142},
  [1498] = {.lex_state = 160},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 142},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 142},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 0},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 142},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 0},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 0},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 145},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 0},
  [1537] = {.lex_state = 145},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 145},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 0},
  [1542] = {.lex_state = 142},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 0},
  [1547] = {.lex_state = 142},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 142},
  [1552] = {.lex_state = 0},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 0},
  [1555] = {.lex_state = 142},
  [1556] = {.lex_state = 0},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 0},
  [1559] = {.lex_state = 0},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 0},
  [1564] = {.lex_state = 0},
  [1565] = {.lex_state = 0},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 142},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 0},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
};

enum {
  ts_external_token_quoted_content = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_quoted_content] = sym_quoted_content,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_quoted_content] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_erlang] = ACTIONS(1),
    [anon_sym_javascript] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_size] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_DOT] = ACTIONS(1),
    [anon_sym_LT_EQ_DOT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_DOT] = ACTIONS(1),
    [anon_sym_GT_EQ_DOT] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_DOT] = ACTIONS(1),
    [anon_sym_DASH_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_DOT] = ACTIONS(1),
    [anon_sym_SLASH_DOT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_todo] = ACTIONS(1),
    [anon_sym_panic] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [sym_visibility_modifier] = ACTIONS(1),
    [sym_opacity_modifier] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [aux_sym_escape_sequence_token1] = ACTIONS(1),
    [aux_sym_escape_sequence_token2] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym__hex] = ACTIONS(1),
    [sym__decimal] = ACTIONS(1),
    [sym__octal] = ACTIONS(1),
    [sym__binary] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_bytes] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_bit_string] = ACTIONS(1),
    [anon_sym_bits] = ACTIONS(1),
    [anon_sym_utf8] = ACTIONS(1),
    [anon_sym_utf16] = ACTIONS(1),
    [anon_sym_utf32] = ACTIONS(1),
    [anon_sym_utf8_codepoint] = ACTIONS(1),
    [anon_sym_utf16_codepoint] = ACTIONS(1),
    [anon_sym_utf32_codepoint] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_big] = ACTIONS(1),
    [anon_sym_little] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_unit] = ACTIONS(1),
    [sym__discard_name] = ACTIONS(1),
    [sym__name] = ACTIONS(1),
    [sym__upname] = ACTIONS(1),
    [sym_quoted_content] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(1532),
    [sym__module_statement] = STATE(3),
    [sym_target_group] = STATE(3),
    [sym_attribute] = STATE(3),
    [sym_import] = STATE(3),
    [sym_constant] = STATE(3),
    [sym_external_type] = STATE(3),
    [sym_external_function] = STATE(3),
    [sym_function] = STATE(3),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(576),
    [sym__expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym__expression_unit] = STATE(119),
    [sym_record] = STATE(77),
    [sym_todo] = STATE(119),
    [sym_panic] = STATE(119),
    [sym_tuple] = STATE(76),
    [sym_list] = STATE(119),
    [sym__expression_bit_string] = STATE(119),
    [sym_anonymous_function] = STATE(75),
    [sym_block] = STATE(34),
    [sym_case] = STATE(34),
    [sym_let_assert] = STATE(576),
    [sym_let] = STATE(576),
    [sym_use] = STATE(576),
    [sym_assert] = STATE(119),
    [sym_boolean_negation] = STATE(119),
    [sym_integer_negation] = STATE(119),
    [sym_record_update] = STATE(77),
    [sym__maybe_tuple_expression] = STATE(1531),
    [sym_tuple_access] = STATE(34),
    [sym__maybe_record_expression] = STATE(1530),
    [sym_field_access] = STATE(34),
    [sym__maybe_function_expression] = STATE(1370),
    [sym_function_call] = STATE(34),
    [sym_type_definition] = STATE(3),
    [sym_type_alias] = STATE(3),
    [sym_string] = STATE(119),
    [sym_integer] = STATE(119),
    [sym_identifier] = STATE(38),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_POUND] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_external] = ACTIONS(31),
    [anon_sym_todo] = ACTIONS(33),
    [anon_sym_panic] = ACTIONS(35),
    [anon_sym_case] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_assert] = ACTIONS(41),
    [anon_sym_use] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [sym_visibility_modifier] = ACTIONS(47),
    [sym_opacity_modifier] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [sym__hex] = ACTIONS(55),
    [sym__decimal] = ACTIONS(57),
    [sym__octal] = ACTIONS(55),
    [sym__binary] = ACTIONS(55),
    [sym__name] = ACTIONS(59),
    [sym__upname] = ACTIONS(61),
  },
  [2] = {
    [sym__module_statement] = STATE(2),
    [sym_target_group] = STATE(2),
    [sym_attribute] = STATE(2),
    [sym_import] = STATE(2),
    [sym_constant] = STATE(2),
    [sym_external_type] = STATE(2),
    [sym_external_function] = STATE(2),
    [sym_function] = STATE(2),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(576),
    [sym__expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym__expression_unit] = STATE(119),
    [sym_record] = STATE(77),
    [sym_todo] = STATE(119),
    [sym_panic] = STATE(119),
    [sym_tuple] = STATE(76),
    [sym_list] = STATE(119),
    [sym__expression_bit_string] = STATE(119),
    [sym_anonymous_function] = STATE(75),
    [sym_block] = STATE(34),
    [sym_case] = STATE(34),
    [sym_let_assert] = STATE(576),
    [sym_let] = STATE(576),
    [sym_use] = STATE(576),
    [sym_assert] = STATE(119),
    [sym_boolean_negation] = STATE(119),
    [sym_integer_negation] = STATE(119),
    [sym_record_update] = STATE(77),
    [sym__maybe_tuple_expression] = STATE(1531),
    [sym_tuple_access] = STATE(34),
    [sym__maybe_record_expression] = STATE(1530),
    [sym_field_access] = STATE(34),
    [sym__maybe_function_expression] = STATE(1370),
    [sym_function_call] = STATE(34),
    [sym_type_definition] = STATE(2),
    [sym_type_alias] = STATE(2),
    [sym_string] = STATE(119),
    [sym_integer] = STATE(119),
    [sym_identifier] = STATE(38),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(63),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(68),
    [anon_sym_AT] = ACTIONS(71),
    [anon_sym_import] = ACTIONS(74),
    [anon_sym_type] = ACTIONS(77),
    [anon_sym_const] = ACTIONS(80),
    [anon_sym_POUND] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(86),
    [anon_sym_LT_LT] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(92),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_external] = ACTIONS(98),
    [anon_sym_todo] = ACTIONS(101),
    [anon_sym_panic] = ACTIONS(104),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_let] = ACTIONS(110),
    [anon_sym_assert] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(116),
    [anon_sym_BANG] = ACTIONS(119),
    [sym_visibility_modifier] = ACTIONS(122),
    [sym_opacity_modifier] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(128),
    [sym_float] = ACTIONS(131),
    [sym__hex] = ACTIONS(134),
    [sym__decimal] = ACTIONS(137),
    [sym__octal] = ACTIONS(134),
    [sym__binary] = ACTIONS(134),
    [sym__name] = ACTIONS(140),
    [sym__upname] = ACTIONS(143),
  },
  [3] = {
    [sym__module_statement] = STATE(2),
    [sym_target_group] = STATE(2),
    [sym_attribute] = STATE(2),
    [sym_import] = STATE(2),
    [sym_constant] = STATE(2),
    [sym_external_type] = STATE(2),
    [sym_external_function] = STATE(2),
    [sym_function] = STATE(2),
    [aux_sym__statement_seq] = STATE(5),
    [sym__statement] = STATE(576),
    [sym__expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym__expression_unit] = STATE(119),
    [sym_record] = STATE(77),
    [sym_todo] = STATE(119),
    [sym_panic] = STATE(119),
    [sym_tuple] = STATE(76),
    [sym_list] = STATE(119),
    [sym__expression_bit_string] = STATE(119),
    [sym_anonymous_function] = STATE(75),
    [sym_block] = STATE(34),
    [sym_case] = STATE(34),
    [sym_let_assert] = STATE(576),
    [sym_let] = STATE(576),
    [sym_use] = STATE(576),
    [sym_assert] = STATE(119),
    [sym_boolean_negation] = STATE(119),
    [sym_integer_negation] = STATE(119),
    [sym_record_update] = STATE(77),
    [sym__maybe_tuple_expression] = STATE(1531),
    [sym_tuple_access] = STATE(34),
    [sym__maybe_record_expression] = STATE(1530),
    [sym_field_access] = STATE(34),
    [sym__maybe_function_expression] = STATE(1370),
    [sym_function_call] = STATE(34),
    [sym_type_definition] = STATE(2),
    [sym_type_alias] = STATE(2),
    [sym_string] = STATE(119),
    [sym_integer] = STATE(119),
    [sym_identifier] = STATE(38),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(146),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_POUND] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(27),
    [anon_sym_fn] = ACTIONS(29),
    [anon_sym_external] = ACTIONS(31),
    [anon_sym_todo] = ACTIONS(33),
    [anon_sym_panic] = ACTIONS(35),
    [anon_sym_case] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_assert] = ACTIONS(41),
    [anon_sym_use] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [sym_visibility_modifier] = ACTIONS(47),
    [sym_opacity_modifier] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [sym_float] = ACTIONS(53),
    [sym__hex] = ACTIONS(55),
    [sym__decimal] = ACTIONS(57),
    [sym__octal] = ACTIONS(55),
    [sym__binary] = ACTIONS(55),
    [sym__name] = ACTIONS(59),
    [sym__upname] = ACTIONS(61),
  },
  [4] = {
    [aux_sym__statement_seq] = STATE(4),
    [sym__statement] = STATE(576),
    [sym__expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym__expression_unit] = STATE(119),
    [sym_record] = STATE(77),
    [sym_todo] = STATE(119),
    [sym_panic] = STATE(119),
    [sym_tuple] = STATE(76),
    [sym_list] = STATE(119),
    [sym__expression_bit_string] = STATE(119),
    [sym_anonymous_function] = STATE(75),
    [sym_block] = STATE(34),
    [sym_case] = STATE(34),
    [sym_let_assert] = STATE(576),
    [sym_let] = STATE(576),
    [sym_use] = STATE(576),
    [sym_assert] = STATE(119),
    [sym_boolean_negation] = STATE(119),
    [sym_integer_negation] = STATE(119),
    [sym_record_update] = STATE(77),
    [sym__maybe_tuple_expression] = STATE(1531),
    [sym_tuple_access] = STATE(34),
    [sym__maybe_record_expression] = STATE(1530),
    [sym_field_access] = STATE(34),
    [sym__maybe_function_expression] = STATE(1370),
    [sym_function_call] = STATE(34),
    [sym_string] = STATE(119),
    [sym_integer] = STATE(119),
    [sym_identifier] = STATE(38),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(148),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(150),
    [anon_sym_LBRACE] = ACTIONS(152),
    [anon_sym_AT] = ACTIONS(148),
    [anon_sym_import] = ACTIONS(150),
    [anon_sym_type] = ACTIONS(150),
    [anon_sym_const] = ACTIONS(150),
    [anon_sym_POUND] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(158),
    [anon_sym_LT_LT] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_external] = ACTIONS(150),
    [anon_sym_todo] = ACTIONS(170),
    [anon_sym_panic] = ACTIONS(173),
    [anon_sym_case] = ACTIONS(176),
    [anon_sym_let] = ACTIONS(179),
    [anon_sym_assert] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(185),
    [anon_sym_BANG] = ACTIONS(188),
    [sym_visibility_modifier] = ACTIONS(150),
    [sym_opacity_modifier] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [sym_float] = ACTIONS(194),
    [sym__hex] = ACTIONS(197),
    [sym__decimal] = ACTIONS(200),
    [sym__octal] = ACTIONS(197),
    [sym__binary] = ACTIONS(197),
    [sym__name] = ACTIONS(203),
    [sym__upname] = ACTIONS(206),
  },
  [5] = {
    [aux_sym__statement_seq] = STATE(4),
    [sym__statement] = STATE(576),
    [sym__expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym__expression_unit] = STATE(119),
    [sym_record] = STATE(77),
    [sym_todo] = STATE(119),
    [sym_panic] = STATE(119),
    [sym_tuple] = STATE(76),
    [sym_list] = STATE(119),
    [sym__expression_bit_string] = STATE(119),
    [sym_anonymous_function] = STATE(75),
    [sym_block] = STATE(34),
    [sym_case] = STATE(34),
    [sym_let_assert] = STATE(576),
    [sym_let] = STATE(576),
    [sym_use] = STATE(576),
    [sym_assert] = STATE(119),
    [sym_boolean_negation] = STATE(119),
    [sym_integer_negation] = STATE(119),
    [sym_record_update] = STATE(77),
    [sym__maybe_tuple_expression] = STATE(1531),
    [sym_tuple_access] = STATE(34),
    [sym__maybe_record_expression] = STATE(1530),
    [sym_field_access] = STATE(34),
    [sym__maybe_function_expression] = STATE(1370),
    [sym_function_call] = STATE(34),
    [sym_string] = STATE(119),
    [sym_integer] = STATE(119),
    [sym_identifier] = STATE(38),
    [sym_constructor_name] = STATE(6),
    [sym_remote_constructor_name] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(209),
    [sym_module_comment] = ACTIONS(3),
    [sym_statement_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_if] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(213),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_import] = ACTIONS(211),
    [anon_sym_type] = ACTIONS(211),
    [anon_sym_const] = ACTIONS(211),
    [anon_sym_POUND] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(222),
    [anon_sym_DASH] = ACTIONS(225),
    [anon_sym_fn] = ACTIONS(228),
    [anon_sym_external] = ACTIONS(211),
    [anon_sym_todo] = ACTIONS(231),
    [anon_sym_panic] = ACTIONS(234),
    [anon_sym_case] = ACTIONS(237),
    [anon_sym_let] = ACTIONS(240),
    [anon_sym_assert] = ACTIONS(243),
    [anon_sym_use] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(249),
    [sym_visibility_modifier] = ACTIONS(211),
    [sym_opacity_modifier] = ACTIONS(211),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_float] = ACTIONS(255),
    [sym__hex] = ACTIONS(258),
    [sym__decimal] = ACTIONS(261),
    [sym__octal] = ACTIONS(258),
    [sym__binary] = ACTIONS(258),
    [sym__name] = ACTIONS(264),
    [sym__upname] = ACTIONS(267),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(274), 1,
      anon_sym_LPAREN,
    STATE(66), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(270), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [71] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(278), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(276), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [137] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(282), 1,
      anon_sym_RBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [263] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(320), 1,
      anon_sym_RBRACE,
    STATE(11), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [389] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(322), 1,
      anon_sym_RBRACE,
    STATE(37), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [515] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(324), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [641] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(326), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [767] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(328), 1,
      anon_sym_RBRACE,
    STATE(20), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [893] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(330), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1019] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(336), 1,
      anon_sym_LPAREN,
    ACTIONS(338), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(332), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1089] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(344), 1,
      anon_sym_LPAREN,
    ACTIONS(346), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(342), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(340), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1159] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(348), 1,
      anon_sym_RBRACE,
    STATE(35), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1285] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(350), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1351] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(356), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(354), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1417] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(358), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1543] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(360), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1669] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(362), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1795] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [1921] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(366), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [1987] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(370), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2053] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(374), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2119] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2245] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(380), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2311] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(384), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2437] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(386), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2563] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(388), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2689] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(390), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2755] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(394), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [2881] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(396), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [2951] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(405), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3077] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(407), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3203] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(409), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3329] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(411), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(396), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [3399] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(148), 1,
      anon_sym_RBRACE,
    ACTIONS(415), 1,
      anon_sym_LBRACE,
    ACTIONS(418), 1,
      anon_sym_POUND,
    ACTIONS(421), 1,
      anon_sym_LBRACK,
    ACTIONS(424), 1,
      anon_sym_LT_LT,
    ACTIONS(427), 1,
      anon_sym_DASH,
    ACTIONS(430), 1,
      anon_sym_fn,
    ACTIONS(433), 1,
      anon_sym_todo,
    ACTIONS(436), 1,
      anon_sym_panic,
    ACTIONS(439), 1,
      anon_sym_case,
    ACTIONS(442), 1,
      anon_sym_let,
    ACTIONS(445), 1,
      anon_sym_assert,
    ACTIONS(448), 1,
      anon_sym_use,
    ACTIONS(451), 1,
      anon_sym_BANG,
    ACTIONS(454), 1,
      anon_sym_DQUOTE,
    ACTIONS(457), 1,
      sym_float,
    ACTIONS(463), 1,
      sym__decimal,
    ACTIONS(466), 1,
      sym__name,
    ACTIONS(469), 1,
      sym__upname,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(460), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3525] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(472), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3651] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(474), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3777] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(478), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(476), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [3843] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(480), 1,
      anon_sym_RBRACE,
    STATE(41), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [3969] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(482), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4095] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(486), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(484), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4161] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(488), 1,
      anon_sym_RBRACE,
    STATE(27), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4287] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(492), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(490), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4353] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(494), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4479] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(496), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4545] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(500), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4671] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(504), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(502), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4737] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(508), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(506), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [4803] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(510), 1,
      anon_sym_RBRACE,
    STATE(12), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [4929] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(512), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5055] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(516), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(514), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [5121] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(520), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(518), 29,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [5187] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(522), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5313] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(524), 1,
      anon_sym_RBRACE,
    STATE(39), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5439] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(526), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [5504] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(58), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5627] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(21), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5750] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(22), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [5873] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 20,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(370), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [5938] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(33), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6061] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(14), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6184] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(530), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6249] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(40), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6372] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(44), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6495] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(54), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6618] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(29), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6741] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(534), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6806] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(30), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [6929] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(538), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [6994] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(57), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7117] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(396), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7184] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(396), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7251] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(396), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7318] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(546), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7383] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(8), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7506] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(550), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7571] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(36), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7694] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(554), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7759] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(48), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [7882] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(558), 28,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [7947] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(300), 1,
      anon_sym_let,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(304), 1,
      anon_sym_use,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(310), 1,
      sym_float,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    STATE(23), 1,
      aux_sym__statement_seq,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(812), 4,
      sym__statement,
      sym_let_assert,
      sym_let,
      sym_use,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(352), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8070] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 20,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 21,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8144] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 23,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 23,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8212] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(578), 1,
      anon_sym_RPAREN,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(594), 1,
      anon_sym_DOT_DOT,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1243), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8338] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    ACTIONS(618), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1254), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8464] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(620), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8528] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(562), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8606] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(628), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(630), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8690] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(640), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(638), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [8754] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(642), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(644), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [8838] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(646), 1,
      anon_sym_RPAREN,
    ACTIONS(648), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1193), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [8964] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(650), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(652), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9048] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(654), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9112] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(562), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9192] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(562), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9256] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(658), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(660), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9340] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(664), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(662), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9404] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(666), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9468] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(670), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9532] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(562), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9614] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(676), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(674), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9678] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(680), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(678), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [9742] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(682), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(684), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9826] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(686), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(688), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [9910] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(690), 1,
      anon_sym_RPAREN,
    ACTIONS(692), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1218), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [10036] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(694), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10100] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(698), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10164] = 35,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(702), 1,
      anon_sym_RPAREN,
    ACTIONS(704), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1302), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [10290] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(706), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10354] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(710), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10418] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(716), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10482] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 21,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(564), 21,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10554] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(722), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(720), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10618] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(724), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10682] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(570), 1,
      anon_sym_PIPE_GT,
    ACTIONS(632), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(566), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(568), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(572), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(636), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(574), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(624), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(626), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(728), 12,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(730), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [10766] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(732), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10830] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(738), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(736), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10894] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(740), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [10958] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 25,
      anon_sym_if,
      anon_sym_import,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
    ACTIONS(744), 27,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11022] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(702), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1302), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11145] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(748), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11268] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11391] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1254), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11514] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(752), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11637] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(356), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(354), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [11700] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(578), 1,
      anon_sym_RPAREN,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1243), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11823] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(754), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [11946] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12069] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12192] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(760), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12315] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(762), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12438] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(646), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1193), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12561] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12684] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(766), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [12807] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(374), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [12870] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(496), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [12933] = 34,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(690), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1218), 1,
      sym_argument,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [13056] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(366), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13119] = 33,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(604), 1,
      sym_float,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1426), 1,
      sym_argument,
    STATE(1432), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    STATE(1571), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(716), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [13239] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(768), 1,
      anon_sym_LPAREN,
    STATE(174), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(270), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13305] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(508), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(506), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13366] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(664), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(662), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13427] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(654), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13488] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(520), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(518), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13549] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(396), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13614] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(380), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13675] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(486), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(484), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13736] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(504), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(502), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13797] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(492), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(490), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13858] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(390), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13919] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(478), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(476), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [13980] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(516), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(514), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14041] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(770), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(396), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14106] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(278), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(276), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14167] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(774), 1,
      anon_sym_RBRACK,
    ACTIONS(776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14281] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(546), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14341] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(396), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14403] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(782), 1,
      anon_sym_RBRACK,
    ACTIONS(784), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14517] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(786), 1,
      anon_sym_RBRACK,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14631] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(396), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14693] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(790), 1,
      anon_sym_RBRACK,
    ACTIONS(792), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14807] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(526), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [14867] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(794), 1,
      anon_sym_RBRACK,
    ACTIONS(796), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [14981] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(550), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15041] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(558), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15101] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(538), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15161] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(798), 1,
      anon_sym_RBRACK,
    ACTIONS(800), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15275] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(802), 1,
      anon_sym_RBRACK,
    ACTIONS(804), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15389] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(806), 1,
      anon_sym_RBRACK,
    ACTIONS(808), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15503] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(530), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15563] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(554), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [15623] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(810), 1,
      anon_sym_RBRACK,
    ACTIONS(812), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15737] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(610), 1,
      sym__discard_name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(814), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1422), 1,
      sym_hole,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(732), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15851] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(816), 1,
      anon_sym_RBRACK,
    ACTIONS(818), 1,
      anon_sym_DOT_DOT,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [15965] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(534), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16025] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(396), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16087] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(740), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16146] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(820), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16257] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(822), 1,
      anon_sym_RPAREN,
    ACTIONS(824), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(702), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16368] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(826), 1,
      anon_sym_RBRACK,
    ACTIONS(828), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(668), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16479] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(830), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16590] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(832), 1,
      anon_sym_RBRACK,
    ACTIONS(834), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(631), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16701] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(836), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16812] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(716), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [16871] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(838), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [16982] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(722), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(720), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17041] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(724), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17100] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(840), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17211] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(710), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17270] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(640), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(638), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17329] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(842), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17440] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(666), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17499] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(698), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [17558] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(844), 1,
      anon_sym_RPAREN,
    ACTIONS(846), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(669), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17669] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(848), 1,
      anon_sym_RBRACK,
    ACTIONS(850), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(655), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17780] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(852), 1,
      anon_sym_RPAREN,
    ACTIONS(854), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(692), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [17891] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(856), 1,
      anon_sym_RPAREN,
    ACTIONS(858), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(678), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18002] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(732), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18061] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(738), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(736), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18120] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(744), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18179] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(694), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18238] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(680), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(678), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18297] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(860), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18408] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(706), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18467] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(862), 1,
      anon_sym_RPAREN,
    ACTIONS(864), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(686), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18578] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(620), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18637] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(866), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1490), 1,
      sym_case_subjects,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18748] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(676), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(674), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [18807] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(866), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1474), 1,
      sym_case_subjects,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [18918] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(866), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1504), 1,
      sym_case_subjects,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19029] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(868), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19140] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(870), 1,
      anon_sym_RBRACK,
    ACTIONS(872), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(646), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19251] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(874), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19362] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(670), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [19421] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(866), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1517), 1,
      sym_case_subjects,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19532] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(866), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1529), 1,
      sym_case_subjects,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(697), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19643] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(876), 1,
      anon_sym_RBRACK,
    ACTIONS(878), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(638), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19754] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(880), 1,
      anon_sym_RPAREN,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19865] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(882), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(337), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [19973] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(908), 1,
      sym_float,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(735), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20081] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(918), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(484), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20189] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(920), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(738), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20297] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(922), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(739), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20405] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(924), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(328), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20513] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(926), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(485), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20621] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(928), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(763), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20729] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(930), 1,
      anon_sym_GT_GT,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20841] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(944), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(771), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [20949] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21057] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(946), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(796), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21165] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(948), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(742), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21273] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(974), 1,
      sym_float,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(423), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21381] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(984), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(747), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21489] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(986), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(791), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21597] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(988), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(340), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21705] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(990), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1273), 1,
      sym_expression_bit_string_segment,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21817] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(992), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [21929] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(994), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(748), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22037] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(998), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(108), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22145] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1000), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(350), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22253] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1002), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(92), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22361] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1004), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(351), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22469] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1006), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(353), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22577] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1008), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22689] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1010), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(343), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22797] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1012), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [22909] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1014), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(775), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23017] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1016), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(338), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23125] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1018), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(336), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23233] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1020), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23341] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1023), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(333), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23449] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1025), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1233), 1,
      sym_expression_bit_string_segment,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23561] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1027), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(486), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23669] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1029), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(469), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23777] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1031), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23889] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1033), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(489), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [23997] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1035), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(341), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24105] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1037), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1211), 1,
      sym_expression_bit_string_segment,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24217] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1039), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24329] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1041), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(792), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24437] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1043), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(789), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24545] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1045), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(490), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24653] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1047), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(402), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24761] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1049), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(736), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24869] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1051), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(753), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [24977] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1053), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25089] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1055), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(411), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25197] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1057), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(332), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25305] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1059), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(412), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25413] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1061), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(416), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25521] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1063), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(762), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25629] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1065), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(418), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25737] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1067), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(349), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25845] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1069), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [25957] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1071), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(498), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26065] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1073), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1204), 1,
      sym_expression_bit_string_segment,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26177] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1075), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(783), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26285] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1077), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(482), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26393] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1079), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(116), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26501] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1081), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(86), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26609] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(778), 1,
      sym_float,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1083), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(630), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26717] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1086), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(91), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26825] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1088), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(98), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [26933] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1090), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(104), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27041] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1092), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(87), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27149] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1094), 1,
      anon_sym_LPAREN,
    ACTIONS(1096), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(342), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(340), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [27211] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1098), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(481), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27319] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1100), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(99), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27427] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1102), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(401), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27535] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(350), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [27593] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1104), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27705] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1106), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27817] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1108), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(100), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [27925] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1110), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(756), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28033] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1112), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(755), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28141] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1114), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(757), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28249] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1116), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(733), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28357] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1118), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(754), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28465] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1120), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(752), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28573] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1122), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(751), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28681] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1124), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(750), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28789] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1126), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(749), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [28897] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1128), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(793), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29005] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1130), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(107), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29113] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1132), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(479), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29221] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1134), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(744), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29329] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1136), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(741), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29437] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1138), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(737), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29545] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1140), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(94), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29653] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1142), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(769), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29761] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1144), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(96), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [29869] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1146), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(332), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [29931] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1150), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(400), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30039] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1152), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(414), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30147] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1154), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(480), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30255] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1156), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(421), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30363] = 31,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    ACTIONS(1158), 1,
      anon_sym_GT_GT,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1167), 1,
      sym_expression_bit_string_segment,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30475] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1160), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(758), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30583] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1162), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(396), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30691] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1164), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(794), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30799] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1166), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(422), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [30907] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1168), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(406), 12,
      sym__expression,
      sym_binary_expression,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31015] = 30,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(942), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1440), 1,
      sym_expression_bit_string_segment,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(1166), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31124] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(630), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(628), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31200] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(1190), 1,
      sym_float,
    ACTIONS(1194), 1,
      sym__decimal,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1192), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(208), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31306] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1196), 1,
      sym_float,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(778), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31412] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(884), 1,
      anon_sym_LBRACE,
    ACTIONS(886), 1,
      anon_sym_POUND,
    ACTIONS(888), 1,
      anon_sym_LBRACK,
    ACTIONS(890), 1,
      anon_sym_LT_LT,
    ACTIONS(892), 1,
      anon_sym_DASH,
    ACTIONS(894), 1,
      anon_sym_fn,
    ACTIONS(896), 1,
      anon_sym_todo,
    ACTIONS(898), 1,
      anon_sym_panic,
    ACTIONS(900), 1,
      anon_sym_case,
    ACTIONS(902), 1,
      anon_sym_assert,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1198), 1,
      sym_float,
    ACTIONS(1202), 1,
      sym__decimal,
    STATE(672), 1,
      sym_identifier,
    STATE(718), 1,
      sym_tuple,
    STATE(719), 1,
      sym_anonymous_function,
    STATE(1427), 1,
      sym__maybe_function_expression,
    STATE(1465), 1,
      sym__maybe_tuple_expression,
    STATE(1526), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(665), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(715), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1200), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(676), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(767), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31518] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(684), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(682), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31594] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 18,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31650] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1204), 1,
      sym_float,
    ACTIONS(1208), 1,
      sym__decimal,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1206), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(113), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31756] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(11), 1,
      anon_sym_LBRACE,
    ACTIONS(21), 1,
      anon_sym_POUND,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(25), 1,
      anon_sym_LT_LT,
    ACTIONS(27), 1,
      anon_sym_DASH,
    ACTIONS(33), 1,
      anon_sym_todo,
    ACTIONS(35), 1,
      anon_sym_panic,
    ACTIONS(37), 1,
      anon_sym_case,
    ACTIONS(41), 1,
      anon_sym_assert,
    ACTIONS(45), 1,
      anon_sym_BANG,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(996), 1,
      anon_sym_fn,
    ACTIONS(1210), 1,
      sym_float,
    STATE(38), 1,
      sym_identifier,
    STATE(75), 1,
      sym_anonymous_function,
    STATE(76), 1,
      sym_tuple,
    STATE(1370), 1,
      sym__maybe_function_expression,
    STATE(1530), 1,
      sym__maybe_record_expression,
    STATE(1531), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(6), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(77), 2,
      sym_record,
      sym_record_update,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(34), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(90), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [31862] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 16,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 22,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31922] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(688), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(686), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [31998] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32072] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(932), 1,
      anon_sym_DASH,
    ACTIONS(934), 1,
      anon_sym_todo,
    ACTIONS(936), 1,
      anon_sym_panic,
    ACTIONS(938), 1,
      anon_sym_assert,
    ACTIONS(940), 1,
      anon_sym_BANG,
    ACTIONS(1212), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    STATE(1509), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(210), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32178] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(644), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(642), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32254] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(660), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(658), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32330] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1212), 1,
      sym_float,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(210), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32436] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [32508] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1214), 1,
      sym_float,
    ACTIONS(1218), 1,
      sym__decimal,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1216), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(413), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32614] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1220), 1,
      sym_float,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(509), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32720] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(950), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_POUND,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(956), 1,
      anon_sym_LT_LT,
    ACTIONS(958), 1,
      anon_sym_DASH,
    ACTIONS(960), 1,
      anon_sym_fn,
    ACTIONS(962), 1,
      anon_sym_todo,
    ACTIONS(964), 1,
      anon_sym_panic,
    ACTIONS(966), 1,
      anon_sym_case,
    ACTIONS(968), 1,
      anon_sym_assert,
    ACTIONS(970), 1,
      anon_sym_BANG,
    ACTIONS(972), 1,
      anon_sym_DQUOTE,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(980), 1,
      sym__name,
    ACTIONS(982), 1,
      sym__upname,
    ACTIONS(1222), 1,
      sym_float,
    STATE(378), 1,
      sym_identifier,
    STATE(387), 1,
      sym_anonymous_function,
    STATE(389), 1,
      sym_tuple,
    STATE(1385), 1,
      sym__maybe_function_expression,
    STATE(1467), 1,
      sym__maybe_tuple_expression,
    STATE(1514), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(361), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(392), 2,
      sym_record,
      sym_record_update,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(363), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(419), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32826] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(280), 1,
      anon_sym_LBRACE,
    ACTIONS(284), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_LBRACK,
    ACTIONS(288), 1,
      anon_sym_LT_LT,
    ACTIONS(290), 1,
      anon_sym_DASH,
    ACTIONS(292), 1,
      anon_sym_fn,
    ACTIONS(294), 1,
      anon_sym_todo,
    ACTIONS(296), 1,
      anon_sym_panic,
    ACTIONS(298), 1,
      anon_sym_case,
    ACTIONS(302), 1,
      anon_sym_assert,
    ACTIONS(306), 1,
      anon_sym_BANG,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1190), 1,
      sym_float,
    ACTIONS(1194), 1,
      sym__decimal,
    STATE(157), 1,
      sym_identifier,
    STATE(161), 1,
      sym_anonymous_function,
    STATE(164), 1,
      sym_tuple,
    STATE(1423), 1,
      sym__maybe_function_expression,
    STATE(1464), 1,
      sym__maybe_tuple_expression,
    STATE(1471), 1,
      sym__maybe_record_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(144), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(180), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1192), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(149), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(208), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [32932] = 29,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(576), 1,
      anon_sym_LBRACE,
    ACTIONS(580), 1,
      anon_sym_POUND,
    ACTIONS(582), 1,
      anon_sym_LBRACK,
    ACTIONS(584), 1,
      anon_sym_LT_LT,
    ACTIONS(586), 1,
      anon_sym_DASH,
    ACTIONS(588), 1,
      anon_sym_fn,
    ACTIONS(590), 1,
      anon_sym_todo,
    ACTIONS(592), 1,
      anon_sym_panic,
    ACTIONS(596), 1,
      anon_sym_case,
    ACTIONS(598), 1,
      anon_sym_assert,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1224), 1,
      sym_float,
    ACTIONS(1228), 1,
      sym__decimal,
    STATE(438), 1,
      sym_identifier,
    STATE(448), 1,
      sym_tuple,
    STATE(449), 1,
      sym_anonymous_function,
    STATE(1342), 1,
      sym__maybe_function_expression,
    STATE(1501), 1,
      sym__maybe_record_expression,
    STATE(1566), 1,
      sym__maybe_tuple_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(426), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    STATE(446), 2,
      sym_record,
      sym_record_update,
    ACTIONS(1226), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(435), 5,
      sym_block,
      sym_case,
      sym_tuple_access,
      sym_field_access,
      sym_function_call,
    STATE(513), 10,
      sym__expression_unit,
      sym_todo,
      sym_panic,
      sym_list,
      sym__expression_bit_string,
      sym_assert,
      sym_boolean_negation,
      sym_integer_negation,
      sym_string,
      sym_integer,
  [33038] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(652), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(650), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33114] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 14,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33178] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 14,
      anon_sym_fn,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33244] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1174), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1176), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1178), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(730), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(728), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33320] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1184), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1170), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1172), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1186), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1180), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1182), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1188), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 10,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      anon_sym_BANG,
      sym__decimal,
      sym__name,
    ACTIONS(562), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33390] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(370), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33445] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(366), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33500] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(374), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33555] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(356), 10,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(354), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33610] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(496), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33663] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(664), 9,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(662), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33716] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 9,
      anon_sym_SLASH,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(654), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [33769] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1230), 1,
      anon_sym_LPAREN,
    STATE(386), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(270), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33824] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(380), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33874] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(396), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33928] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(504), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(502), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [33978] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(356), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(354), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34028] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(374), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34078] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(370), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34128] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(366), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34178] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1232), 1,
      anon_sym_LPAREN,
    ACTIONS(1234), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(332), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34232] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1236), 1,
      anon_sym_LPAREN,
    ACTIONS(1238), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(342), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(340), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34286] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(486), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(484), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34336] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(496), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34386] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(390), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34436] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(520), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(518), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34486] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(492), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(490), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34536] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(516), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(514), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34586] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(508), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(506), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34636] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(396), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34690] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(478), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(476), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34740] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(278), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(276), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34790] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(350), 27,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34840] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(538), 26,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34889] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(550), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34938] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(526), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [34987] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(534), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35036] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(530), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35085] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(396), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35136] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(554), 26,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35185] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(396), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35236] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(558), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35285] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(546), 26,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35334] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(396), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35385] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(680), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(678), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35433] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(722), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(720), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35481] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(640), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(638), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35529] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(652), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(650), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35597] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(694), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35645] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(744), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35693] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(738), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(736), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35741] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1266), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1264), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35809] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 7,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(562), 19,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35865] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(684), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(682), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35933] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(664), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(662), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [35981] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(654), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36029] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(724), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36077] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(644), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(642), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36145] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(670), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36193] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(666), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36241] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(732), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36289] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(676), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(674), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36337] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 7,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(562), 18,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36395] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 14,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36457] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(706), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36505] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1270), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1268), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36573] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(710), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36621] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 12,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36685] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(716), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36733] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 11,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36799] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(620), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36847] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(698), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36895] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 9,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(562), 21,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36947] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(562), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [36995] = 14,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1258), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1244), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1246), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1252), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1260), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(630), 3,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(1254), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1256), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1262), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(628), 10,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [37063] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 11,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      sym__decimal,
      sym__discard_name,
      sym__name,
    ACTIONS(740), 25,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [37111] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1276), 1,
      anon_sym_SLASH,
    STATE(425), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1274), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37161] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1279), 1,
      anon_sym_LPAREN,
    STATE(457), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(270), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37211] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1285), 1,
      anon_sym_SLASH,
    STATE(428), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1281), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1283), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37261] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1285), 1,
      anon_sym_SLASH,
    STATE(425), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1287), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1289), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [37311] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(492), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(490), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37356] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(508), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(506), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37401] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(520), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(518), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37446] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(504), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(502), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37491] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1293), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(332), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37540] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(278), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(276), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37585] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37634] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(486), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(484), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37679] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1298), 1,
      anon_sym_LPAREN,
    ACTIONS(1300), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(342), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(340), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37728] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(1302), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37777] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(478), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(476), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37822] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(380), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37867] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(350), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37912] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(390), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [37957] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1310), 1,
      anon_sym_LPAREN,
    STATE(505), 1,
      sym_type_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1306), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1308), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38006] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1274), 19,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_SLASH,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38051] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(516), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(514), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38096] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1312), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38142] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1314), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1316), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38186] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1318), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38232] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38278] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1320), 1,
      anon_sym_RBRACE,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    STATE(1454), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(504), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38362] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1344), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    STATE(1448), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(504), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38446] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(534), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38490] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1346), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    STATE(1518), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(504), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38574] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(554), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38618] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1348), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    STATE(1527), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(504), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38702] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1354), 1,
      anon_sym_LPAREN,
    STATE(580), 1,
      sym_constant_record_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1350), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1352), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38750] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(530), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38794] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1356), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    STATE(1544), 1,
      sym_case_clauses,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(504), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [38878] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(558), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [38922] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1358), 15,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1360), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [38966] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1366), 1,
      anon_sym_LPAREN,
    STATE(559), 1,
      sym__attribute_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1362), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1364), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39014] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(550), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39058] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(526), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39102] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1372), 1,
      anon_sym_DOT,
    ACTIONS(1374), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1368), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1370), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39150] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(546), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39194] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1380), 1,
      anon_sym_LPAREN,
    STATE(563), 1,
      sym_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1376), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1378), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39242] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(538), 24,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39286] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1382), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1384), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39329] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(682), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [39390] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1410), 1,
      anon_sym_LBRACE,
    ACTIONS(1412), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1406), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1408), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39437] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1414), 1,
      anon_sym_RPAREN,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1420), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1171), 1,
      sym_record_pattern_argument,
    STATE(1173), 1,
      sym__pattern,
    STATE(1480), 1,
      sym_label,
    STATE(1496), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [39520] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1428), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1424), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39567] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(724), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39610] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1434), 1,
      anon_sym_LBRACE,
    ACTIONS(1436), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1430), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1432), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39657] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1442), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1438), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1440), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39702] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1444), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1446), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39745] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(666), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [39788] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(370), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1448), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1450), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [39833] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_DOT_DOT,
  [39884] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_DOT_DOT,
  [39937] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DOT_DOT,
  [39992] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_DOT_DOT,
  [40049] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1452), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1454), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40092] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_DOT_DOT,
  [40151] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 6,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
    ACTIONS(562), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_DOT_DOT,
  [40198] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(562), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40241] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    ACTIONS(1462), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1456), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1458), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40288] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(698), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40331] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(642), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [40392] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(650), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [40453] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(694), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40496] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1464), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1466), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40539] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(744), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40582] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(680), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(678), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40625] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(676), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(674), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40668] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1472), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1468), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1470), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40713] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(640), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(638), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [40756] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(628), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [40817] = 23,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1474), 1,
      anon_sym_RBRACE,
    ACTIONS(1476), 1,
      anon_sym_POUND,
    ACTIONS(1479), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_LT_LT,
    ACTIONS(1485), 1,
      anon_sym_DASH,
    ACTIONS(1488), 1,
      anon_sym_DQUOTE,
    ACTIONS(1491), 1,
      sym_float,
    ACTIONS(1497), 1,
      sym__decimal,
    ACTIONS(1500), 1,
      sym__discard_name,
    ACTIONS(1503), 1,
      sym__name,
    ACTIONS(1506), 1,
      sym__upname,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(499), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1494), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [40898] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1509), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1511), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40941] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1513), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1515), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [40984] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1517), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1519), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41027] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1076), 1,
      sym_record_pattern_argument,
    STATE(1173), 1,
      sym__pattern,
    STATE(1480), 1,
      sym_label,
    STATE(1481), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [41110] = 23,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1523), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1134), 1,
      sym_case_clause_pattern,
    STATE(1159), 1,
      sym_case_clause_patterns,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(499), 2,
      sym_case_clause,
      aux_sym_case_clauses_repeat1,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [41191] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1525), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1527), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41234] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1529), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1531), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41277] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1537), 1,
      anon_sym_size,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1533), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1232), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41334] = 24,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1171), 1,
      sym_record_pattern_argument,
    STATE(1173), 1,
      sym__pattern,
    STATE(1452), 1,
      sym_pattern_spread,
    STATE(1480), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [41417] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(620), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41460] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(670), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41503] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1547), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1549), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41546] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(732), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41589] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(706), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41632] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1553), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1551), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1300), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41689] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1557), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1555), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1184), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41746] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(710), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41789] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(716), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41832] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(722), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(720), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [41875] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1559), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1561), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [41918] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1537), 1,
      anon_sym_size,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1563), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1232), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [41975] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1565), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1567), 18,
      anon_sym_if,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42018] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1557), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1569), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1184), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [42075] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(738), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(736), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [42118] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1553), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1571), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1300), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [42175] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1573), 14,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_DASH_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1575), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42218] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(740), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [42261] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1577), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1579), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42303] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1581), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1583), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42347] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1587), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1589), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42389] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1591), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1593), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42431] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1537), 1,
      anon_sym_size,
    ACTIONS(1543), 1,
      anon_sym_unit,
    STATE(1433), 1,
      sym_expression_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1102), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [42487] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1595), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1597), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42529] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1599), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1601), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42571] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1603), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1605), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42613] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1607), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1609), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42655] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1619), 1,
      anon_sym_DASH,
    ACTIONS(1621), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    STATE(887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(938), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [42727] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1623), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1625), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42769] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1627), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1629), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42811] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1631), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1633), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42853] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1635), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1637), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42895] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1639), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1641), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42937] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1643), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1645), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [42979] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1647), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1649), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43021] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1424), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43063] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1651), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1653), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43105] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1655), 1,
      sym_float,
    STATE(852), 1,
      sym_identifier,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(898), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [43177] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1657), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1659), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43219] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1661), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1663), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43261] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1665), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1667), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43303] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1669), 1,
      sym_float,
    STATE(852), 1,
      sym_identifier,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(908), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [43375] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1671), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1673), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43417] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1675), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1677), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43459] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1679), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1681), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43501] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1683), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1685), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43543] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1687), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1689), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43585] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1691), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1693), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43627] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1695), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1697), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1699), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1701), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43711] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1703), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1705), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43753] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1707), 1,
      sym_float,
    STATE(852), 1,
      sym_identifier,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(909), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [43825] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1709), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1711), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43867] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1713), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1715), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43909] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1717), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1719), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43951] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1721), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1723), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [43993] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1725), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1727), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44035] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1729), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1731), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44077] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1733), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1735), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44119] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1737), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1739), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44161] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1553), 1,
      anon_sym_size,
    STATE(1425), 1,
      sym_pattern_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1096), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [44217] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1745), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1741), 12,
      ts_builtin_sym_end,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1743), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44261] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1747), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1749), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44303] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1751), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1753), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44345] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1755), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1757), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44387] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1759), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1761), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44429] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1763), 1,
      sym_float,
    STATE(852), 1,
      sym_identifier,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(911), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [44501] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1765), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1767), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44543] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1769), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1771), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44585] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1773), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1775), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44627] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1777), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1779), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1781), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1783), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44711] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1785), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1787), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44753] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1789), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1791), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44795] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(904), 1,
      anon_sym_BANG,
    ACTIONS(906), 1,
      anon_sym_DQUOTE,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(914), 1,
      sym__name,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1793), 1,
      sym_float,
    STATE(852), 1,
      sym_identifier,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(941), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [44867] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1795), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1797), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44909] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(352), 9,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PIPE,
    ACTIONS(350), 21,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [44951] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1799), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1801), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [44993] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1557), 1,
      anon_sym_size,
    STATE(1351), 1,
      sym_constant_bit_string_segment_options,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1133), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [45049] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1803), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1805), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45091] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1807), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1809), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45133] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1619), 1,
      anon_sym_DASH,
    ACTIONS(1655), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    STATE(887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(898), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [45205] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1811), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1813), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45247] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1815), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1817), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45289] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1819), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1821), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45331] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1823), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1825), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45373] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1827), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1829), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45415] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1831), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1833), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45457] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1619), 1,
      anon_sym_DASH,
    ACTIONS(1835), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    STATE(887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(927), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [45529] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1837), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1839), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45571] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1841), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1843), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45613] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1845), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1847), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45655] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1849), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1851), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45697] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1853), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1855), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45739] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1857), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1859), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45781] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1861), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1863), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45823] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1619), 1,
      anon_sym_DASH,
    ACTIONS(1865), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    STATE(887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(931), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [45895] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(496), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 9,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(370), 20,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [45939] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1867), 13,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
    ACTIONS(1869), 17,
      anon_sym_if,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym_visibility_modifier,
      sym_opacity_modifier,
      sym__decimal,
      sym__name,
  [45981] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(600), 1,
      anon_sym_BANG,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1611), 1,
      anon_sym_LBRACE,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1619), 1,
      anon_sym_DASH,
    ACTIONS(1871), 1,
      sym_float,
    STATE(871), 1,
      sym__case_clause_tuple_access,
    STATE(879), 1,
      sym__case_clause_guard_binary_expression,
    STATE(887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(933), 11,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym__case_clause_guard_expression,
      sym__case_clause_guard_unit,
      sym_boolean_negation,
      sym_string,
      sym_integer,
  [46053] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1873), 1,
      anon_sym_LT_DASH,
    ACTIONS(1875), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1101), 1,
      sym__pattern,
    STATE(1188), 1,
      sym_use_assignment,
    STATE(1453), 1,
      sym_use_assignments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1087), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46130] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1557), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1184), 5,
      sym__constant_bit_string_segment_option,
      sym__constant_bit_string_named_segment_option,
      sym__constant_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46183] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1877), 1,
      anon_sym_RBRACK,
    ACTIONS(1879), 1,
      anon_sym_DOT_DOT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    STATE(1476), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46260] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1881), 1,
      anon_sym_if,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1883), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46335] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1537), 1,
      anon_sym_size,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1232), 5,
      sym__expression_bit_string_segment_option,
      sym__expression_bit_string_named_segment_option,
      sym__expression_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46388] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(1543), 1,
      anon_sym_unit,
    ACTIONS(1553), 1,
      anon_sym_size,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    ACTIONS(1541), 3,
      anon_sym_utf8,
      anon_sym_utf16,
      anon_sym_utf32,
    STATE(1300), 5,
      sym__pattern_bit_string_segment_option,
      sym__pattern_bit_string_named_segment_option,
      sym__pattern_bit_string_segment_option_size,
      sym_integer,
      sym__bit_string_segment_option,
    ACTIONS(1539), 14,
      anon_sym_binary,
      anon_sym_bytes,
      anon_sym_int,
      anon_sym_float,
      anon_sym_bit_string,
      anon_sym_bits,
      anon_sym_utf8_codepoint,
      anon_sym_utf16_codepoint,
      anon_sym_utf32_codepoint,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_big,
      anon_sym_little,
      anon_sym_native,
  [46441] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1885), 1,
      anon_sym_if,
    ACTIONS(1887), 1,
      anon_sym_DASH_GT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1202), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46518] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1889), 1,
      anon_sym_if,
    ACTIONS(1891), 1,
      anon_sym_DASH_GT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1202), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46595] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1893), 1,
      anon_sym_if,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1895), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46670] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1875), 1,
      sym_float,
    ACTIONS(1897), 1,
      anon_sym_LT_DASH,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1101), 1,
      sym__pattern,
    STATE(1188), 1,
      sym_use_assignment,
    STATE(1484), 1,
      sym_use_assignments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1087), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46747] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1899), 1,
      anon_sym_LPAREN,
    STATE(650), 1,
      sym_constant_record_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1352), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1350), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [46792] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1901), 1,
      anon_sym_RBRACK,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1081), 1,
      sym__pattern,
    STATE(1528), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46869] = 22,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1903), 1,
      anon_sym_RBRACK,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    STATE(1499), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [46946] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1905), 1,
      anon_sym_assert,
    STATE(811), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1215), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47020] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1907), 1,
      anon_sym_GT_GT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1253), 1,
      sym__pattern,
    STATE(1430), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47094] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1909), 1,
      anon_sym_GT_GT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1253), 1,
      sym__pattern,
    STATE(1430), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47168] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1911), 1,
      anon_sym_GT_GT,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1253), 1,
      sym__pattern,
    STATE(1259), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47242] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1171), 1,
      sym_record_pattern_argument,
    STATE(1173), 1,
      sym__pattern,
    STATE(1480), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47316] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1875), 1,
      sym_float,
    ACTIONS(1913), 1,
      anon_sym_LT_DASH,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1101), 1,
      sym__pattern,
    STATE(1416), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1087), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47390] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1875), 1,
      sym_float,
    ACTIONS(1915), 1,
      anon_sym_LT_DASH,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1101), 1,
      sym__pattern,
    STATE(1416), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1087), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47464] = 21,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1917), 1,
      anon_sym_assert,
    STATE(554), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1183), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47538] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(1919), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [47596] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1921), 1,
      anon_sym_COMMA,
    ACTIONS(1923), 1,
      anon_sym_RBRACK,
    ACTIONS(1925), 1,
      anon_sym_DOT_DOT,
    STATE(1125), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [47659] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1787), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1785), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47698] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(103), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1183), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47769] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(218), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1215), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47840] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1681), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1679), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47879] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1749), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1747), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [47918] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(510), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1269), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [47989] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1927), 1,
      anon_sym_COMMA,
    ACTIONS(1929), 1,
      anon_sym_RBRACK,
    ACTIONS(1931), 1,
      anon_sym_DOT_DOT,
    STATE(1093), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [48052] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1677), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1675), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48091] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1727), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1725), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48130] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(407), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1228), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48201] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1723), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1721), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48240] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(813), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1215), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48311] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1715), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1713), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48350] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1933), 1,
      anon_sym_RPAREN,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1155), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48421] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1935), 1,
      anon_sym_COMMA,
    ACTIONS(1937), 1,
      anon_sym_RBRACK,
    ACTIONS(1939), 1,
      anon_sym_DOT_DOT,
    STATE(1142), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [48484] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(218), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1269), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48555] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1711), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1709), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48594] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1941), 1,
      anon_sym_RPAREN,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48665] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1783), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1781), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48704] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1625), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1623), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48743] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1629), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1627), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48782] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1085), 1,
      sym__pattern,
    STATE(1202), 1,
      sym_case_clause_pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [48853] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1689), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1687), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48892] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1943), 1,
      anon_sym_COMMA,
    ACTIONS(1945), 1,
      anon_sym_RBRACK,
    ACTIONS(1947), 1,
      anon_sym_DOT_DOT,
    STATE(1141), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [48955] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1791), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1789), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [48994] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    ACTIONS(1949), 1,
      anon_sym_RPAREN,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49065] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1673), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1671), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49104] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1875), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1101), 1,
      sym__pattern,
    STATE(1416), 1,
      sym_use_assignment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1087), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49175] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1579), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1577), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49214] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1637), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1635), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49253] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(578), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1183), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49324] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1649), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1647), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49363] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1653), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1651), 23,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [49402] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(728), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(272), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(270), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49445] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1253), 1,
      sym__pattern,
    STATE(1430), 1,
      sym_pattern_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49516] = 20,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(766), 1,
      sym__assignment,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1200), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49587] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1953), 1,
      anon_sym_COMMA,
    ACTIONS(1955), 1,
      anon_sym_RBRACK,
    ACTIONS(1957), 1,
      anon_sym_DOT_DOT,
    STATE(1106), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49650] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    ACTIONS(1961), 1,
      anon_sym_RPAREN,
    STATE(1191), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49710] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(520), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(518), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49748] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(508), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(506), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49786] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(1963), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49828] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(504), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(502), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49866] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(492), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(490), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [49904] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [49972] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50014] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(278), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(276), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50052] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1967), 1,
      anon_sym_COMMA,
    ACTIONS(1969), 1,
      anon_sym_RPAREN,
    STATE(1221), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50112] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1971), 1,
      anon_sym_RPAREN,
    ACTIONS(1973), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50178] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(376), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(374), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50216] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    ACTIONS(1975), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50282] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(372), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(370), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50320] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(368), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(366), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50358] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1977), 1,
      anon_sym_LPAREN,
    ACTIONS(1979), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(342), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(340), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50400] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1981), 1,
      anon_sym_LPAREN,
    ACTIONS(1983), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(334), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(332), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50442] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1985), 1,
      anon_sym_COMMA,
    ACTIONS(1987), 1,
      anon_sym_RPAREN,
    STATE(1217), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50502] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(356), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(354), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50540] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(516), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(514), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50578] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1989), 1,
      anon_sym_RPAREN,
    ACTIONS(1991), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1413), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50644] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50710] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    ACTIONS(1995), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1175), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [50776] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(1997), 1,
      anon_sym_COMMA,
    ACTIONS(1999), 1,
      anon_sym_RPAREN,
    STATE(1252), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50836] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(498), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(496), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50874] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(486), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(484), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [50912] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1332), 1,
      sym_float,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    STATE(1030), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1052), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [50980] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    ACTIONS(2001), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1413), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51046] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2003), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      anon_sym_COMMA,
    STATE(1241), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51106] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    ACTIONS(2007), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1291), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51172] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(478), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(476), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51210] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    ACTIONS(2009), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1413), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51276] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    ACTIONS(2011), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1413), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51342] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2013), 1,
      anon_sym_COMMA,
    ACTIONS(2015), 1,
      anon_sym_RPAREN,
    STATE(1248), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51402] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(382), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(380), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51440] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(392), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(390), 18,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51478] = 19,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1420), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    STATE(1160), 1,
      sym__pattern,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1011), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [51546] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    ACTIONS(2017), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51612] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(540), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(538), 17,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51649] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(548), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(546), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [51686] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2019), 1,
      anon_sym_GT_GT,
    ACTIONS(2021), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1365), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51749] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    ACTIONS(2023), 1,
      anon_sym_GT_GT,
    STATE(1063), 1,
      sym_identifier,
    STATE(1213), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51812] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    ACTIONS(2025), 1,
      anon_sym_GT_GT,
    STATE(1063), 1,
      sym_identifier,
    STATE(1365), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51875] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    ACTIONS(2027), 1,
      anon_sym_GT_GT,
    STATE(1063), 1,
      sym_identifier,
    STATE(1266), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [51938] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(2029), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(903), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52003] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(552), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(550), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52040] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(544), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52079] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2031), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52134] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(528), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(526), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52171] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(542), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52210] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(400), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(398), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(396), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52249] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(556), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(554), 17,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52286] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(536), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(534), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52323] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(2029), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(980), 1,
      sym_identifier,
    STATE(1015), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(903), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52388] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1413), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52451] = 18,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1322), 1,
      anon_sym_POUND,
    ACTIONS(1324), 1,
      anon_sym_LBRACK,
    ACTIONS(1326), 1,
      anon_sym_LT_LT,
    ACTIONS(1328), 1,
      anon_sym_DASH,
    ACTIONS(1330), 1,
      anon_sym_DQUOTE,
    ACTIONS(1336), 1,
      sym__decimal,
    ACTIONS(1338), 1,
      sym__discard_name,
    ACTIONS(1340), 1,
      sym__name,
    ACTIONS(1342), 1,
      sym__upname,
    ACTIONS(2029), 1,
      sym_float,
    STATE(912), 1,
      sym__pattern_binary_expression,
    STATE(1010), 1,
      sym_identifier,
    STATE(1017), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(835), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(1334), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(903), 7,
      sym__pattern_expression,
      sym_record_pattern,
      sym_tuple_pattern,
      sym__pattern_bit_string,
      sym_list_pattern,
      sym_integer,
      sym_discard,
  [52516] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    ACTIONS(2033), 1,
      anon_sym_GT_GT,
    STATE(1063), 1,
      sym_identifier,
    STATE(1365), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52579] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1284), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52642] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1973), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1408), 1,
      sym_constant_record_argument,
    STATE(1489), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1407), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52705] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(532), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(530), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52742] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    ACTIONS(2035), 1,
      anon_sym_GT_GT,
    STATE(1063), 1,
      sym_identifier,
    STATE(1365), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52805] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(560), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(558), 17,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52842] = 17,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(612), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(1991), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1246), 1,
      sym_attribute_value,
    STATE(1563), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1333), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [52905] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2037), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [52960] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2039), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53015] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(746), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(744), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53051] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(628), 1,
      anon_sym_DASH_GT,
    ACTIONS(2045), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53105] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2061), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53159] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2063), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53213] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2065), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53267] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2067), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53321] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(696), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(694), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53357] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(650), 1,
      anon_sym_DASH_GT,
    ACTIONS(2045), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53411] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2069), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53465] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2071), 1,
      anon_sym_RPAREN,
    ACTIONS(2073), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [53525] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(642), 1,
      anon_sym_DASH_GT,
    ACTIONS(2045), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53579] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2075), 1,
      anon_sym_RBRACK,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [53639] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(664), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(662), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53675] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2077), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53729] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2079), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53783] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(564), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(562), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53819] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(564), 6,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
    ACTIONS(562), 12,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
  [53859] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2047), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(562), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53911] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(562), 3,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [53961] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2081), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54015] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 5,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [54063] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 9,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [54109] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(564), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
    ACTIONS(562), 10,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
  [54153] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2083), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54207] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2085), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54261] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(640), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(638), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54297] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2087), 1,
      anon_sym_RPAREN,
    ACTIONS(2089), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1146), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54357] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2021), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    STATE(1365), 1,
      sym_constant_bit_string_segment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1210), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54417] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2091), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54471] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2093), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54525] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(656), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(654), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54561] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(700), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(698), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54597] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(672), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(670), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54633] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(708), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(706), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(680), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(678), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54705] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2095), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54759] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(676), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(674), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54795] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2097), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54849] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(713), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(710), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54885] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2099), 1,
      anon_sym_RBRACK,
    ACTIONS(2101), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1203), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [54945] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(734), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(732), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [54981] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2103), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55035] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(738), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(736), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55071] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(742), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(740), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55107] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(622), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(620), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55143] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2105), 1,
      anon_sym_RBRACK,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55203] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2107), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55263] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2109), 1,
      anon_sym_RBRACK,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55323] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(718), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(716), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55359] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(682), 1,
      anon_sym_DASH_GT,
    ACTIONS(2045), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2047), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2055), 1,
      anon_sym_PIPE_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2041), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(2043), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2049), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2057), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(2051), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2053), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2059), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55413] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(722), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(720), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55449] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2111), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55509] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(726), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(724), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55545] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(668), 8,
      anon_sym_SLASH,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
    ACTIONS(666), 16,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
      anon_sym_PIPE_GT,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55581] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2113), 1,
      anon_sym_RPAREN,
    ACTIONS(2115), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1285), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55641] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2117), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55695] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2119), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [55755] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2121), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55809] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2123), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55863] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2125), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55917] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2127), 1,
      anon_sym_COMMA,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [55971] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2129), 1,
      anon_sym_RBRACK,
    ACTIONS(2131), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1265), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56031] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1400), 1,
      anon_sym_PIPE_GT,
    ACTIONS(2133), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1386), 2,
      anon_sym_SLASH,
      anon_sym_STAR,
    ACTIONS(1388), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1394), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 2,
      anon_sym_PLUS_DOT,
      anon_sym_DASH_DOT,
    ACTIONS(1396), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1398), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(1404), 4,
      anon_sym_STAR_DOT,
      anon_sym_SLASH_DOT,
      anon_sym_PERCENT,
      anon_sym_LT_GT,
  [56085] = 16,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    ACTIONS(2135), 1,
      anon_sym_RBRACK,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56145] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2137), 1,
      anon_sym_POUND,
    ACTIONS(2139), 1,
      anon_sym_LBRACK,
    ACTIONS(2141), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 1,
      anon_sym_DASH,
    ACTIONS(2145), 1,
      sym_float,
    STATE(496), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(456), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(539), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56202] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2137), 1,
      anon_sym_POUND,
    ACTIONS(2139), 1,
      anon_sym_LBRACK,
    ACTIONS(2141), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 1,
      anon_sym_DASH,
    ACTIONS(2147), 1,
      sym_float,
    STATE(496), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(456), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(572), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56259] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2137), 1,
      anon_sym_POUND,
    ACTIONS(2139), 1,
      anon_sym_LBRACK,
    ACTIONS(2141), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 1,
      anon_sym_DASH,
    ACTIONS(2149), 1,
      sym_float,
    STATE(496), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(456), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(592), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56316] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2137), 1,
      anon_sym_POUND,
    ACTIONS(2139), 1,
      anon_sym_LBRACK,
    ACTIONS(2141), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 1,
      anon_sym_DASH,
    ACTIONS(2151), 1,
      sym_float,
    STATE(496), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(456), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(567), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56373] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2073), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1147), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56430] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2153), 1,
      sym_float,
    STATE(976), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(984), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56487] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2155), 1,
      sym_float,
    STATE(976), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(998), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56544] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2157), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1346), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56601] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2159), 1,
      sym_float,
    STATE(1063), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1412), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56658] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2161), 1,
      sym_float,
    STATE(976), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(994), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56715] = 15,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(1416), 1,
      anon_sym_DASH,
    ACTIONS(1613), 1,
      anon_sym_POUND,
    ACTIONS(1615), 1,
      anon_sym_LBRACK,
    ACTIONS(1617), 1,
      anon_sym_LT_LT,
    ACTIONS(2163), 1,
      sym_float,
    STATE(976), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(619), 2,
      sym_constructor_name,
      sym_remote_constructor_name,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(987), 8,
      sym__constant_value,
      sym_constant_tuple,
      sym_constant_list,
      sym__constant_bit_string,
      sym_constant_record,
      sym_constant_field_access,
      sym_string,
      sym_integer,
  [56772] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(352), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(350), 21,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [56806] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1777), 22,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [56838] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1685), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1683), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56872] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1767), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1765), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56906] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1775), 10,
      anon_sym_DASH,
      anon_sym_fn,
      anon_sym_todo,
      anon_sym_panic,
      anon_sym_case,
      anon_sym_let,
      anon_sym_assert,
      anon_sym_use,
      sym__decimal,
      sym__name,
    ACTIONS(1773), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_LT_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      sym_float,
      sym__hex,
      sym__octal,
      sym__binary,
      sym__upname,
  [56940] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2165), 1,
      anon_sym_RBRACE,
    ACTIONS(2167), 1,
      anon_sym_AT,
    ACTIONS(2169), 1,
      anon_sym_import,
    ACTIONS(2171), 1,
      anon_sym_type,
    ACTIONS(2173), 1,
      anon_sym_const,
    ACTIONS(2175), 1,
      anon_sym_fn,
    ACTIONS(2177), 1,
      anon_sym_external,
    ACTIONS(2179), 1,
      sym_visibility_modifier,
    ACTIONS(2181), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(816), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [56987] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2167), 1,
      anon_sym_AT,
    ACTIONS(2169), 1,
      anon_sym_import,
    ACTIONS(2171), 1,
      anon_sym_type,
    ACTIONS(2173), 1,
      anon_sym_const,
    ACTIONS(2175), 1,
      anon_sym_fn,
    ACTIONS(2177), 1,
      anon_sym_external,
    ACTIONS(2179), 1,
      sym_visibility_modifier,
    ACTIONS(2181), 1,
      sym_opacity_modifier,
    ACTIONS(2183), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(814), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [57034] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2185), 1,
      anon_sym_RBRACE,
    ACTIONS(2187), 1,
      anon_sym_AT,
    ACTIONS(2190), 1,
      anon_sym_import,
    ACTIONS(2193), 1,
      anon_sym_type,
    ACTIONS(2196), 1,
      anon_sym_const,
    ACTIONS(2199), 1,
      anon_sym_fn,
    ACTIONS(2202), 1,
      anon_sym_external,
    ACTIONS(2205), 1,
      sym_visibility_modifier,
    ACTIONS(2208), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(816), 10,
      sym__module_statement,
      sym_attribute,
      sym_import,
      sym_constant,
      sym_external_type,
      sym_external_function,
      sym_function,
      sym_type_definition,
      sym_type_alias,
      aux_sym_target_group_repeat1,
  [57081] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2211), 1,
      anon_sym_RPAREN,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2219), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(1437), 1,
      sym_data_constructor_argument,
    STATE(1477), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1381), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57128] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2219), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2223), 1,
      anon_sym_RPAREN,
    STATE(1437), 1,
      sym_data_constructor_argument,
    STATE(1477), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1381), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57175] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2219), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2225), 1,
      anon_sym_RPAREN,
    STATE(1168), 1,
      sym_data_constructor_argument,
    STATE(1477), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1381), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57222] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1295), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57266] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    STATE(1313), 1,
      sym_external_function_parameter,
    STATE(1371), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1355), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57310] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2233), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57354] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2235), 1,
      anon_sym_RPAREN,
    STATE(1313), 1,
      sym_external_function_parameter,
    STATE(1371), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1355), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57398] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2237), 1,
      anon_sym_RPAREN,
    STATE(1267), 1,
      sym_external_function_parameter,
    STATE(1371), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1355), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57442] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1314), 16,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57468] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2239), 1,
      anon_sym_LPAREN,
    STATE(877), 1,
      sym_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1376), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57498] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(370), 2,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(1448), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [57526] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2219), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(1437), 1,
      sym_data_constructor_argument,
    STATE(1477), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1381), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57570] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2241), 1,
      anon_sym_RPAREN,
    STATE(1367), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57614] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2243), 1,
      anon_sym_RPAREN,
    STATE(1367), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57658] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2245), 1,
      anon_sym_RPAREN,
    STATE(1367), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57702] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2247), 1,
      anon_sym_RPAREN,
    STATE(1367), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57746] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1326), 1,
      sym_constant_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1429), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [57789] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2255), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57830] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2259), 1,
      anon_sym_LPAREN,
    STATE(926), 1,
      sym_record_pattern_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2257), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [57859] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1367), 1,
      sym_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1362), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57900] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2261), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57941] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1313), 1,
      sym_external_function_parameter,
    STATE(1371), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1355), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [57982] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58023] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58064] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2267), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58105] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2269), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1158), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58146] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2271), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58187] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2273), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1294), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58228] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    ACTIONS(2275), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1161), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58269] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2277), 1,
      anon_sym_RPAREN,
    STATE(1326), 1,
      sym_constant_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1429), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58312] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2279), 1,
      anon_sym_RPAREN,
    STATE(1223), 1,
      sym_constant_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1429), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58355] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1358), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [58380] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1548), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58418] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(892), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58456] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1849), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [58480] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2281), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2286), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2283), 9,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [58508] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1695), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [58532] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(570), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58570] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1552), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58608] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(573), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58646] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(593), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58684] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1827), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [58708] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(970), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58746] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1356), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58786] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1130), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58824] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2301), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1356), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58864] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1556), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58902] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2303), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1356), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [58942] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(986), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [58980] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1639), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59004] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(528), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59042] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1555), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59080] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1540), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59118] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1418), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59156] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2307), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2305), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59182] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1456), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59220] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1326), 1,
      sym_constant_type_argument,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1429), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59260] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1853), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59284] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1845), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59308] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1657), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59332] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1717), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59356] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(598), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59394] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2311), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2309), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59420] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1382), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59458] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1279), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59498] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2315), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1189), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [59538] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(996), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59576] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1665), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59600] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(600), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59638] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1312), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59676] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2317), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2286), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2283), 9,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [59704] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(971), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59742] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1000), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59780] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1570), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59818] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1831), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59842] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1819), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59866] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(875), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59904] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1811), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      anon_sym_LT_DASH,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [59928] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1495), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [59966] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2213), 1,
      anon_sym_POUND,
    ACTIONS(2215), 1,
      anon_sym_fn,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2229), 1,
      sym__name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(826), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1497), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [60004] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2321), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2319), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60030] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2325), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2323), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60056] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2329), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2327), 10,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60082] = 11,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    ACTIONS(2331), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1356), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60122] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2289), 1,
      anon_sym_POUND,
    ACTIONS(2291), 1,
      anon_sym_fn,
    ACTIONS(2293), 1,
      sym__discard_name,
    ACTIONS(2295), 1,
      sym__name,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(466), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(586), 6,
      sym__type,
      sym_type_hole,
      sym_tuple_type,
      sym_function_type,
      sym_type,
      sym_type_var,
  [60160] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2333), 1,
      anon_sym_SLASH,
    STATE(902), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60187] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2336), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60210] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2338), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60233] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2336), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60256] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2340), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60279] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2342), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60302] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2344), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2346), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2323), 5,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [60329] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2323), 3,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2344), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2346), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60358] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2350), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60381] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2352), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_DASH_GT,
      anon_sym_PIPE_PIPE,
    ACTIONS(2348), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2344), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2346), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60412] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2354), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60435] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2356), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60458] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2358), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60481] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2360), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60504] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2362), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60527] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2356), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60550] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1356), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60587] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1505), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60624] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2364), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60647] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2366), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60670] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2368), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60693] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2370), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60716] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2372), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60739] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2374), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60762] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2376), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60785] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2378), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2380), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
    ACTIONS(2323), 5,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [60812] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2382), 1,
      anon_sym_SLASH,
    STATE(945), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1281), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60839] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1272), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [60876] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2384), 1,
      anon_sym_LPAREN,
    STATE(947), 1,
      sym_type_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1306), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [60903] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2323), 3,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2378), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2380), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60932] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2388), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [60955] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2323), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
    ACTIONS(2386), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2378), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2380), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [60986] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2392), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61009] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2394), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61032] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2396), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61055] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2398), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61078] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2400), 1,
      anon_sym_RBRACE,
    ACTIONS(2402), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2378), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2380), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [61111] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2404), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61134] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2406), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61157] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2352), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2408), 1,
      anon_sym_DASH_GT,
    ACTIONS(2410), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2344), 4,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(2346), 4,
      anon_sym_LT_DOT,
      anon_sym_LT_EQ_DOT,
      anon_sym_GT_DOT,
      anon_sym_GT_EQ_DOT,
  [61190] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2412), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61213] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2412), 13,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61236] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2217), 1,
      sym__discard_name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2251), 1,
      anon_sym_POUND,
    ACTIONS(2253), 1,
      anon_sym_fn,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1090), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
    STATE(1192), 5,
      sym__constant_type,
      sym_constant_tuple_type,
      sym_constant_function_type,
      sym_constant_type,
      sym_type_hole,
  [61273] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2382), 1,
      anon_sym_SLASH,
    STATE(902), 1,
      aux_sym_module_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1287), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61300] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1274), 1,
      anon_sym_SLASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1272), 11,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61324] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1525), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61345] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2414), 1,
      anon_sym_DOT,
    ACTIONS(2416), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1368), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61370] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1382), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61391] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2418), 1,
      anon_sym_LBRACE,
    ACTIONS(2420), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1406), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61416] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1513), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61437] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2422), 1,
      anon_sym_RPAREN,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1185), 1,
      sym_function_parameter,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61478] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1547), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61499] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    ACTIONS(2428), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1325), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61540] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(995), 1,
      sym__attribute_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1362), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61565] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2432), 11,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [61586] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1464), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61607] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2434), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1456), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61632] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2438), 1,
      anon_sym_LBRACE,
    ACTIONS(2440), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1430), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61657] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1529), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61678] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1444), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_EQ,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61699] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    ACTIONS(2442), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1325), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61740] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1573), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61761] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1325), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61802] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1517), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_DASH_GT,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61823] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    ACTIONS(2446), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1325), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61864] = 13,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    ACTIONS(2448), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1257), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [61905] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2450), 1,
      anon_sym_LBRACE,
    ACTIONS(2452), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61930] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1509), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61950] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2454), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1581), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61972] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1741), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [61994] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2458), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1438), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62016] = 12,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2426), 1,
      sym__name,
    STATE(1107), 1,
      sym__labeled_discard_param,
    STATE(1108), 1,
      sym__discard_param,
    STATE(1112), 1,
      sym__labeled_name_param,
    STATE(1113), 1,
      sym__name_param,
    STATE(1117), 1,
      sym_label,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1325), 1,
      sym_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62054] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(916), 1,
      sym__upname,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    ACTIONS(2462), 1,
      sym__name,
    STATE(644), 1,
      sym_label,
    STATE(687), 1,
      sym_constructor_name,
    STATE(897), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [62088] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(2464), 1,
      anon_sym_DASH,
    ACTIONS(2466), 1,
      sym__name,
    STATE(357), 1,
      sym_constructor_name,
    STATE(644), 1,
      sym_label,
    STATE(897), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [62122] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2468), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1468), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62144] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1559), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62164] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1565), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62184] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1452), 10,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_as,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62204] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2472), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2470), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [62226] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1795), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62245] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1699), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62264] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1643), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62283] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1751), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62302] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1691), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62321] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1799), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62340] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1631), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62359] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1661), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62378] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1807), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62397] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1599), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62416] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1841), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62435] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(370), 9,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62454] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1591), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62473] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1815), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62492] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1703), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62511] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1837), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62530] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1729), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62549] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1733), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62568] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1737), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62587] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1755), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62606] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1857), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62625] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1422), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62644] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    ACTIONS(2474), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
    STATE(1574), 3,
      sym__pattern_bit_string_segment_argument,
      sym_integer,
      sym_identifier,
  [62671] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1803), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62690] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1759), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62709] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1861), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62728] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(374), 9,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62747] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1607), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62766] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(354), 9,
      anon_sym_if,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62785] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2476), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2470), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62806] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2480), 1,
      anon_sym_as,
    ACTIONS(2482), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2478), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_DOT_DOT,
  [62829] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1603), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62848] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1587), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62867] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1769), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62886] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2484), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2470), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
      anon_sym_LT_GT,
      anon_sym_DOT_DOT,
  [62907] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1823), 9,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_import,
      anon_sym_type,
      anon_sym_const,
      anon_sym_fn,
      anon_sym_external,
      sym_visibility_modifier,
      sym_opacity_modifier,
  [62926] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2486), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2470), 7,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62946] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2488), 1,
      anon_sym_RPAREN,
    STATE(1136), 1,
      sym__name_param,
    STATE(1137), 1,
      sym__discard_param,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1434), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [62978] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(662), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [62996] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2490), 1,
      anon_sym_RPAREN,
    STATE(1136), 1,
      sym__name_param,
    STATE(1137), 1,
      sym__discard_param,
    STATE(1234), 1,
      sym_anonymous_function_parameter,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63028] = 10,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2492), 1,
      anon_sym_RPAREN,
    STATE(1136), 1,
      sym__name_param,
    STATE(1137), 1,
      sym__discard_param,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1434), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63060] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(654), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [63078] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(366), 8,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_DASH_GT,
      anon_sym_LT_GT,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
  [63096] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    STATE(1136), 1,
      sym__name_param,
    STATE(1137), 1,
      sym__discard_param,
    STATE(1235), 1,
      sym_identifier,
    STATE(1236), 1,
      sym_discard,
    STATE(1434), 1,
      sym_anonymous_function_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63125] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2494), 1,
      anon_sym_RBRACE,
    ACTIONS(2496), 1,
      anon_sym_type,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1271), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63154] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    ACTIONS(2498), 1,
      anon_sym_RBRACE,
    STATE(1219), 1,
      sym_unqualified_import,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63183] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    ACTIONS(2500), 1,
      anon_sym_RBRACE,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1383), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63212] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    ACTIONS(2502), 1,
      anon_sym_RBRACE,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1383), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63241] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    ACTIONS(2504), 1,
      anon_sym_RBRACE,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1383), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63270] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2506), 7,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
  [63287] = 9,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    ACTIONS(2508), 1,
      anon_sym_RBRACE,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1383), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63316] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1445), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63340] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1374), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63364] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(57), 1,
      sym__decimal,
    ACTIONS(2510), 1,
      anon_sym_DASH,
    STATE(51), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(55), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63386] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2512), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2516), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1068), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63408] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2518), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63430] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(2522), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63452] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(2524), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63474] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2526), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2528), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1036), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63496] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(608), 1,
      sym__decimal,
    ACTIONS(2464), 1,
      anon_sym_DASH,
    STATE(432), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(606), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63518] = 8,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2496), 1,
      anon_sym_type,
    STATE(1227), 1,
      sym_identifier,
    STATE(1229), 1,
      sym_type_identifier,
    STATE(1383), 1,
      sym_unqualified_import,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [63544] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2530), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1919), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [63564] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(990), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63588] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(2533), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63610] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2535), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2537), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1037), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63632] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2539), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2541), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1044), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63654] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(968), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63678] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2543), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2545), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1038), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63700] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2297), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(472), 1,
      sym_type_name,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(443), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63724] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2297), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(544), 1,
      sym_type_name,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(443), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63748] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    STATE(1502), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63770] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2547), 1,
      anon_sym_as,
    ACTIONS(2549), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2478), 4,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [63790] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(2551), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63812] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(959), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63836] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    STATE(1460), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63858] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2553), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2555), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1053), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [63880] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2297), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(533), 1,
      sym_type_name,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(443), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63904] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(912), 1,
      sym__decimal,
    ACTIONS(2460), 1,
      anon_sym_DASH,
    STATE(673), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(910), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63926] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(1535), 1,
      anon_sym_DASH,
    STATE(152), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63948] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(978), 1,
      sym__decimal,
    ACTIONS(2557), 1,
      anon_sym_DASH,
    STATE(364), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(976), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [63970] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1323), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [63994] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1002), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [64018] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2559), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1468), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT_GT,
  [64036] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2561), 1,
      anon_sym_DQUOTE2,
    ACTIONS(2566), 1,
      sym_quoted_content,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2563), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [64058] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2297), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(474), 1,
      sym_type_name,
    STATE(1519), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(443), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [64082] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1353), 1,
      sym_type_name,
    STATE(1477), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(930), 2,
      sym_type_identifier,
      sym_remote_type_identifier,
  [64106] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(314), 1,
      sym__decimal,
    ACTIONS(2569), 1,
      anon_sym_DASH,
    STATE(152), 1,
      sym_integer,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(312), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64128] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2520), 1,
      sym_quoted_content,
    ACTIONS(2571), 1,
      anon_sym_DQUOTE2,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2514), 2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
    STATE(1064), 2,
      sym_escape_sequence,
      aux_sym_string_repeat1,
  [64150] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2575), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2573), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64169] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(496), 1,
      sym__discard_name,
    ACTIONS(498), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(370), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [64188] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1569), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64209] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1520), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64230] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1414), 1,
      anon_sym_RPAREN,
    ACTIONS(1418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2577), 1,
      anon_sym_COMMA,
    STATE(1131), 1,
      aux_sym_record_pattern_arguments_repeat1,
    STATE(1496), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64253] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1538), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64274] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1094), 1,
      anon_sym_LPAREN,
    ACTIONS(1300), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(340), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT_GT,
  [64293] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1418), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2579), 1,
      anon_sym_COMMA,
    ACTIONS(2581), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_record_pattern_arguments_repeat1,
    STATE(1461), 1,
      sym_pattern_spread,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64316] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2585), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2583), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64335] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1575), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64356] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2588), 1,
      anon_sym_type,
    ACTIONS(2590), 1,
      anon_sym_const,
    ACTIONS(2592), 1,
      anon_sym_fn,
    ACTIONS(2594), 1,
      anon_sym_external,
    ACTIONS(2596), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64379] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(2598), 1,
      anon_sym_RBRACE,
    STATE(1104), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1088), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64400] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2600), 1,
      anon_sym_COMMA,
    ACTIONS(2602), 1,
      anon_sym_RBRACK,
    STATE(1086), 1,
      aux_sym_case_clause_pattern_repeat1,
    STATE(1564), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64423] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(2604), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1468), 2,
      sym_identifier,
      sym_discard,
  [64444] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2606), 1,
      anon_sym_type,
    ACTIONS(2608), 1,
      anon_sym_const,
    ACTIONS(2610), 1,
      anon_sym_fn,
    ACTIONS(2612), 1,
      anon_sym_external,
    ACTIONS(2614), 1,
      sym_opacity_modifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64467] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1536), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64488] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2618), 1,
      anon_sym_COMMA,
    STATE(1069), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2616), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [64507] = 7,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2620), 1,
      anon_sym_COMMA,
    ACTIONS(2622), 1,
      anon_sym_RBRACK,
    STATE(1089), 1,
      aux_sym_case_clause_pattern_repeat1,
    STATE(1478), 1,
      sym_list_pattern_tail,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64530] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2547), 1,
      anon_sym_as,
    ACTIONS(2624), 1,
      anon_sym_LT_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2478), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_DASH,
  [64549] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2626), 1,
      anon_sym_RBRACE,
    ACTIONS(2628), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1088), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64570] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2631), 1,
      anon_sym_COMMA,
    STATE(1089), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2583), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [64589] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2634), 1,
      anon_sym_LPAREN,
    STATE(1292), 1,
      sym_constant_type_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2636), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [64608] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(1104), 1,
      sym_constructor_name,
    STATE(1553), 1,
      sym_data_constructors,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1080), 2,
      sym_data_constructor,
      aux_sym_data_constructors_repeat1,
  [64629] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1146), 1,
      anon_sym_LPAREN,
    ACTIONS(1293), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(332), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_GT_GT,
  [64648] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(798), 1,
      anon_sym_RBRACK,
    ACTIONS(800), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64668] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1151), 1,
      sym_record_update_argument,
    STATE(1550), 1,
      sym_record_update_arguments,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64688] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(2642), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(599), 2,
      sym_identifier,
      sym_discard,
  [64706] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2646), 1,
      anon_sym_DASH,
    STATE(1116), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2644), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64724] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    ACTIONS(2640), 1,
      sym__name,
    STATE(129), 1,
      sym_constructor_name,
    STATE(644), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64744] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2650), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2648), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64760] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2654), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2652), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64776] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2658), 1,
      anon_sym_DASH,
    STATE(1100), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2656), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64794] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1339), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2661), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [64812] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2667), 1,
      anon_sym_DASH,
    STATE(1115), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2665), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [64830] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2671), 1,
      anon_sym_PIPE,
    STATE(1103), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2669), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [64848] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2676), 1,
      anon_sym_LPAREN,
    STATE(1372), 1,
      sym_data_constructor_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2674), 2,
      anon_sym_RBRACE,
      sym__upname,
  [64866] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(614), 1,
      sym__upname,
    ACTIONS(2466), 1,
      sym__name,
    STATE(357), 1,
      sym_constructor_name,
    STATE(644), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64886] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(786), 1,
      anon_sym_RBRACK,
    ACTIONS(788), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2678), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64906] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1329), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [64924] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1398), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2682), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [64942] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    STATE(1403), 1,
      sym_record_update_argument,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [64962] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2688), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2686), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [64978] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(1001), 2,
      sym_identifier,
      sym_discard,
  [64996] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1335), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65014] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1336), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2682), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65032] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2690), 4,
      sym_quoted_content,
      anon_sym_DQUOTE2,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
  [65046] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2692), 1,
      anon_sym_DASH,
    STATE(1128), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1533), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65064] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2694), 1,
      anon_sym_DASH,
    STATE(1119), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1551), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65082] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(316), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    STATE(1274), 1,
      sym_discard,
    STATE(1281), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65102] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2698), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2696), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65118] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2702), 1,
      anon_sym_DASH,
    STATE(1119), 1,
      aux_sym_pattern_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2700), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65136] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2705), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2708), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [65154] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    ACTIONS(2710), 1,
      anon_sym_RPAREN,
    STATE(1403), 1,
      sym_record_update_argument,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65174] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1151), 1,
      sym_record_update_argument,
    STATE(1450), 1,
      sym_record_update_arguments,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65194] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2714), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2712), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65210] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(370), 1,
      anon_sym_DOT,
    ACTIONS(496), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1448), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65228] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(774), 1,
      anon_sym_RBRACK,
    ACTIONS(776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2716), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65248] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1151), 1,
      sym_record_update_argument,
    STATE(1516), 1,
      sym_record_update_arguments,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65268] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1151), 1,
      sym_record_update_argument,
    STATE(1473), 1,
      sym_record_update_arguments,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65288] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2720), 1,
      anon_sym_DASH,
    STATE(1128), 1,
      aux_sym_expression_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2718), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65306] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1151), 1,
      sym_record_update_argument,
    STATE(1462), 1,
      sym_record_update_arguments,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65326] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2723), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_LT_DASH,
  [65340] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    STATE(1131), 1,
      aux_sym_record_pattern_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2728), 2,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [65358] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2730), 1,
      anon_sym_PIPE,
    STATE(1103), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1891), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [65376] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2734), 1,
      anon_sym_DASH,
    STATE(1140), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2732), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65394] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2738), 1,
      anon_sym_PIPE,
    STATE(1132), 1,
      aux_sym_case_clause_patterns_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2736), 2,
      anon_sym_if,
      anon_sym_DASH_GT,
  [65412] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2742), 1,
      sym__decimal,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2740), 3,
      sym__hex,
      sym__octal,
      sym__binary,
  [65428] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1444), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2744), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65446] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    STATE(1310), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2744), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [65464] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(61), 1,
      sym__upname,
    ACTIONS(2746), 1,
      sym__name,
    STATE(19), 1,
      sym_constructor_name,
    STATE(562), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65484] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(780), 1,
      sym__name,
    ACTIONS(2424), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(991), 2,
      sym_identifier,
      sym_discard,
  [65502] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2748), 1,
      anon_sym_DASH,
    STATE(1100), 1,
      aux_sym_constant_bit_string_segment_options_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(1555), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65520] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(782), 1,
      anon_sym_RBRACK,
    ACTIONS(784), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2750), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65540] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(794), 1,
      anon_sym_RBRACK,
    ACTIONS(796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2752), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65560] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(59), 1,
      sym__name,
    ACTIONS(2642), 1,
      sym__discard_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    STATE(603), 2,
      sym_identifier,
      sym_discard,
  [65578] = 6,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1384), 1,
      sym_anonymous_function_parameters,
    STATE(1387), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65598] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2277), 1,
      anon_sym_RPAREN,
    ACTIONS(2756), 1,
      anon_sym_COMMA,
    STATE(1150), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65615] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2758), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_RPAREN,
    STATE(1149), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65632] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2708), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [65645] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2762), 1,
      anon_sym_COMMA,
    ACTIONS(2765), 1,
      anon_sym_LT_DASH,
    STATE(1148), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65662] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2071), 1,
      anon_sym_RPAREN,
    ACTIONS(2767), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65679] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2769), 1,
      anon_sym_COMMA,
    ACTIONS(2772), 1,
      anon_sym_RPAREN,
    STATE(1150), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65696] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_RPAREN,
    STATE(1288), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65713] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2778), 1,
      anon_sym_COMMA,
    ACTIONS(2781), 1,
      anon_sym_RPAREN,
    STATE(1152), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65730] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2783), 1,
      anon_sym_COMMA,
    ACTIONS(2786), 1,
      anon_sym_RPAREN,
    STATE(1153), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65747] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2788), 1,
      anon_sym_RPAREN,
    ACTIONS(2790), 1,
      sym__name,
    STATE(1358), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65764] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2792), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_RPAREN,
    STATE(1226), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65781] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2796), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [65794] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
    ACTIONS(2800), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65811] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2802), 1,
      anon_sym_COMMA,
    ACTIONS(2804), 1,
      anon_sym_RPAREN,
    STATE(1178), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65828] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2806), 1,
      anon_sym_if,
    ACTIONS(2808), 1,
      anon_sym_DASH_GT,
    STATE(1511), 1,
      sym_case_clause_guard,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65845] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2810), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [65858] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2812), 1,
      anon_sym_COMMA,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(1180), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65875] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1909), 1,
      anon_sym_GT_GT,
    ACTIONS(2816), 1,
      anon_sym_COMMA,
    STATE(1201), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65892] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2818), 1,
      anon_sym_COMMA,
    ACTIONS(2821), 1,
      anon_sym_GT_GT,
    STATE(1163), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65909] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1975), 1,
      anon_sym_RPAREN,
    ACTIONS(2823), 1,
      anon_sym_COMMA,
    STATE(1153), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65926] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2825), 1,
      anon_sym_COLON,
    ACTIONS(2827), 1,
      anon_sym_EQ,
    STATE(1491), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65943] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2831), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2829), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [65958] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2833), 1,
      anon_sym_COMMA,
    ACTIONS(2835), 1,
      anon_sym_GT_GT,
    STATE(1224), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65975] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2837), 1,
      anon_sym_COMMA,
    ACTIONS(2839), 1,
      anon_sym_RPAREN,
    STATE(1299), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [65992] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(604), 1,
      sym_external_function_body,
    STATE(1348), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66009] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2841), 1,
      anon_sym_RBRACE,
    ACTIONS(2843), 1,
      anon_sym_COMMA,
    STATE(1170), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66026] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2728), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [66039] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2500), 1,
      anon_sym_RBRACE,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    STATE(1170), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66056] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2848), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
  [66069] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2852), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2850), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66084] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2854), 1,
      anon_sym_COMMA,
    ACTIONS(2856), 1,
      anon_sym_RPAREN,
    STATE(1164), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66101] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2858), 1,
      anon_sym_COMMA,
    ACTIONS(2861), 1,
      anon_sym_RPAREN,
    STATE(1176), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66118] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2863), 1,
      anon_sym_COMMA,
    ACTIONS(2866), 1,
      anon_sym_RPAREN,
    STATE(1177), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66135] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
    ACTIONS(2868), 1,
      anon_sym_COMMA,
    STATE(1242), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66152] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2035), 1,
      anon_sym_GT_GT,
    ACTIONS(2870), 1,
      anon_sym_COMMA,
    STATE(1163), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66169] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    ACTIONS(2872), 1,
      anon_sym_COMMA,
    STATE(1242), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66186] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2109), 1,
      anon_sym_RBRACK,
    ACTIONS(2874), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66203] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2876), 1,
      anon_sym_COMMA,
    ACTIONS(2879), 1,
      anon_sym_RPAREN,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66220] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    ACTIONS(2881), 1,
      anon_sym_EQ,
    STATE(1551), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66237] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2656), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [66250] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2883), 1,
      anon_sym_COMMA,
    ACTIONS(2885), 1,
      anon_sym_RPAREN,
    STATE(1297), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66267] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    ACTIONS(2887), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66284] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2488), 1,
      anon_sym_RPAREN,
    ACTIONS(2889), 1,
      anon_sym_COMMA,
    STATE(1301), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66301] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2891), 1,
      anon_sym_COMMA,
    ACTIONS(2893), 1,
      anon_sym_LT_DASH,
    STATE(1277), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66318] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2895), 1,
      anon_sym_COMMA,
    ACTIONS(2897), 1,
      anon_sym_RPAREN,
    STATE(1264), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66335] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2899), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66348] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(836), 1,
      anon_sym_RPAREN,
    ACTIONS(2901), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66365] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2903), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66378] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2905), 1,
      anon_sym_COMMA,
    ACTIONS(2907), 1,
      anon_sym_RPAREN,
    STATE(1186), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66395] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    STATE(1521), 1,
      sym_target,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2909), 2,
      anon_sym_erlang,
      anon_sym_javascript,
  [66410] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1104), 1,
      anon_sym_GT_GT,
    ACTIONS(2911), 1,
      anon_sym_COMMA,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66427] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2913), 1,
      anon_sym_COMMA,
    ACTIONS(2916), 1,
      anon_sym_GT_GT,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66444] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2918), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66457] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2920), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66470] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(748), 1,
      anon_sym_RPAREN,
    ACTIONS(2922), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66487] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    ACTIONS(2924), 1,
      anon_sym_EQ,
    STATE(1449), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66504] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2926), 1,
      anon_sym_COMMA,
    ACTIONS(2929), 1,
      anon_sym_GT_GT,
    STATE(1201), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66521] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2669), 3,
      anon_sym_if,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [66534] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2931), 1,
      anon_sym_COMMA,
    ACTIONS(2933), 1,
      anon_sym_RBRACK,
    STATE(1181), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66551] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2935), 1,
      anon_sym_COMMA,
    ACTIONS(2937), 1,
      anon_sym_GT_GT,
    STATE(1195), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66568] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2939), 1,
      anon_sym_COMMA,
    ACTIONS(2942), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66585] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2944), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [66598] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2946), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66611] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2825), 1,
      anon_sym_COLON,
    ACTIONS(2948), 1,
      anon_sym_EQ,
    STATE(1503), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66628] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(762), 1,
      anon_sym_RPAREN,
    ACTIONS(2950), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66645] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2954), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2952), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [66660] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2956), 1,
      anon_sym_COMMA,
    ACTIONS(2958), 1,
      anon_sym_GT_GT,
    STATE(1231), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66677] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    ACTIONS(2960), 1,
      anon_sym_RPAREN,
    STATE(1251), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66694] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2962), 1,
      anon_sym_COMMA,
    ACTIONS(2964), 1,
      anon_sym_GT_GT,
    STATE(1179), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66711] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1989), 1,
      anon_sym_RPAREN,
    ACTIONS(2966), 1,
      anon_sym_COMMA,
    STATE(1176), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66728] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    ACTIONS(2968), 1,
      anon_sym_EQ,
    STATE(1512), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66745] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2970), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [66758] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(880), 1,
      anon_sym_RPAREN,
    ACTIONS(2972), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66775] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2974), 1,
      anon_sym_COMMA,
    ACTIONS(2976), 1,
      anon_sym_RPAREN,
    STATE(1209), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66792] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2978), 1,
      anon_sym_RBRACE,
    ACTIONS(2980), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66809] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1053), 1,
      anon_sym_GT_GT,
    ACTIONS(2982), 1,
      anon_sym_COMMA,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66826] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(838), 1,
      anon_sym_RPAREN,
    ACTIONS(2984), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66843] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2245), 1,
      anon_sym_RPAREN,
    ACTIONS(2986), 1,
      anon_sym_COMMA,
    STATE(1247), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66860] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2988), 1,
      anon_sym_COMMA,
    ACTIONS(2990), 1,
      anon_sym_RPAREN,
    STATE(1145), 1,
      aux_sym_constant_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66877] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1031), 1,
      anon_sym_GT_GT,
    ACTIONS(2992), 1,
      anon_sym_COMMA,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66894] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    ACTIONS(2994), 1,
      anon_sym_RPAREN,
    STATE(1250), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66911] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2996), 1,
      anon_sym_COMMA,
    ACTIONS(2998), 1,
      anon_sym_RPAREN,
    STATE(1089), 1,
      aux_sym_case_clause_pattern_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66928] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3002), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3000), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66943] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    ACTIONS(3004), 1,
      anon_sym_EQ,
    STATE(1486), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66960] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3006), 1,
      anon_sym_as,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3000), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66975] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3008), 1,
      anon_sym_LPAREN,
    ACTIONS(3010), 1,
      anon_sym_DASH_GT,
    STATE(1568), 1,
      sym_constant_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [66992] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(992), 1,
      anon_sym_GT_GT,
    ACTIONS(3012), 1,
      anon_sym_COMMA,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67009] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2718), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67022] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3014), 1,
      anon_sym_COMMA,
    ACTIONS(3016), 1,
      anon_sym_GT_GT,
    STATE(1220), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67039] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3018), 1,
      anon_sym_COMMA,
    ACTIONS(3020), 1,
      anon_sym_RPAREN,
    STATE(1187), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67056] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3022), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67069] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3024), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67082] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3026), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67095] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(1403), 1,
      sym_record_update_argument,
    STATE(1567), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67112] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3028), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67125] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2825), 1,
      anon_sym_COLON,
    ACTIONS(3030), 1,
      anon_sym_EQ,
    STATE(1547), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67142] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3032), 1,
      anon_sym_LBRACE,
    ACTIONS(3034), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67159] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3036), 1,
      anon_sym_COMMA,
    ACTIONS(3039), 1,
      anon_sym_RPAREN,
    STATE(1242), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67176] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3041), 1,
      anon_sym_COMMA,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
    STATE(1263), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67193] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    ACTIONS(3045), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67210] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2303), 1,
      anon_sym_RPAREN,
    ACTIONS(3047), 1,
      anon_sym_COMMA,
    STATE(1261), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67227] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3049), 1,
      anon_sym_COMMA,
    ACTIONS(3051), 1,
      anon_sym_RPAREN,
    STATE(1268), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67244] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3053), 1,
      anon_sym_COMMA,
    ACTIONS(3056), 1,
      anon_sym_RPAREN,
    STATE(1247), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67261] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(840), 1,
      anon_sym_RPAREN,
    ACTIONS(3058), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67278] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3060), 1,
      anon_sym_LPAREN,
    ACTIONS(3062), 1,
      anon_sym_DASH_GT,
    STATE(1558), 1,
      sym_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67295] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3064), 1,
      anon_sym_COMMA,
    ACTIONS(3066), 1,
      anon_sym_RPAREN,
    STATE(1276), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67312] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3068), 1,
      anon_sym_COMMA,
    ACTIONS(3070), 1,
      anon_sym_RPAREN,
    STATE(1262), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67329] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(830), 1,
      anon_sym_RPAREN,
    ACTIONS(3072), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67346] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3076), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3074), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [67361] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3078), 1,
      anon_sym_COMMA,
    ACTIONS(3080), 1,
      anon_sym_RPAREN,
    STATE(1244), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67378] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3060), 1,
      anon_sym_LPAREN,
    ACTIONS(3082), 1,
      anon_sym_DASH_GT,
    STATE(1533), 1,
      sym_function_parameter_types,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67395] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3084), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67408] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3086), 1,
      anon_sym_COMMA,
    ACTIONS(3088), 1,
      anon_sym_RPAREN,
    STATE(1280), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67425] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    ACTIONS(3090), 1,
      anon_sym_RPAREN,
    STATE(1358), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67442] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3092), 1,
      anon_sym_COMMA,
    ACTIONS(3094), 1,
      anon_sym_GT_GT,
    STATE(1162), 1,
      aux_sym__pattern_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67459] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1008), 1,
      anon_sym_GT_GT,
    ACTIONS(3096), 1,
      anon_sym_COMMA,
    STATE(1196), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67476] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3098), 1,
      anon_sym_COMMA,
    ACTIONS(3101), 1,
      anon_sym_RPAREN,
    STATE(1261), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67493] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3090), 1,
      anon_sym_RPAREN,
    ACTIONS(3103), 1,
      anon_sym_COMMA,
    STATE(1152), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67510] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(754), 1,
      anon_sym_RPAREN,
    ACTIONS(3105), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67527] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    ACTIONS(3107), 1,
      anon_sym_COMMA,
    STATE(1261), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67544] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3109), 1,
      anon_sym_COMMA,
    ACTIONS(3111), 1,
      anon_sym_RBRACK,
    STATE(1287), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67561] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3113), 1,
      anon_sym_COMMA,
    ACTIONS(3115), 1,
      anon_sym_GT_GT,
    STATE(1289), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67578] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3117), 1,
      anon_sym_COMMA,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(1270), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67595] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2009), 1,
      anon_sym_RPAREN,
    ACTIONS(3121), 1,
      anon_sym_COMMA,
    STATE(1176), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67612] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2663), 1,
      anon_sym_COLON,
    ACTIONS(3123), 1,
      anon_sym_EQ,
    STATE(1542), 1,
      sym__type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67629] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    ACTIONS(3125), 1,
      anon_sym_COMMA,
    STATE(1308), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67646] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3127), 1,
      anon_sym_RBRACE,
    ACTIONS(3129), 1,
      anon_sym_COMMA,
    STATE(1293), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67663] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3131), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67676] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3133), 1,
      anon_sym_COMMA,
    ACTIONS(3135), 1,
      anon_sym_GT_GT,
    STATE(1260), 1,
      aux_sym__expression_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67693] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3137), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67706] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    STATE(1358), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67723] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    ACTIONS(3141), 1,
      anon_sym_COMMA,
    STATE(1152), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67740] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1913), 1,
      anon_sym_LT_DASH,
    ACTIONS(3143), 1,
      anon_sym_COMMA,
    STATE(1148), 1,
      aux_sym_use_assignments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67757] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3145), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67770] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3147), 1,
      anon_sym_COMMA,
    ACTIONS(3149), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      aux_sym_constant_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67787] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    STATE(1290), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67804] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3153), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [67817] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2825), 1,
      anon_sym_COLON,
    ACTIONS(3155), 1,
      anon_sym_EQ,
    STATE(1458), 1,
      sym__constant_type_annotation,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67834] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1006), 1,
      sym_external_function_body,
    STATE(1328), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67851] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3157), 1,
      anon_sym_COMMA,
    ACTIONS(3159), 1,
      anon_sym_RPAREN,
    STATE(1214), 1,
      aux_sym__attribute_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67868] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3161), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    STATE(1306), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67885] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3165), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [67898] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2105), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67915] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2710), 1,
      anon_sym_RPAREN,
    ACTIONS(3169), 1,
      anon_sym_COMMA,
    STATE(1177), 1,
      aux_sym_record_update_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67932] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2019), 1,
      anon_sym_GT_GT,
    ACTIONS(3171), 1,
      anon_sym_COMMA,
    STATE(1163), 1,
      aux_sym__constant_bit_string_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67949] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3173), 1,
      anon_sym_COMMA,
    ACTIONS(3176), 1,
      anon_sym_RPAREN,
    STATE(1290), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67966] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3178), 1,
      anon_sym_COMMA,
    ACTIONS(3180), 1,
      anon_sym_RPAREN,
    STATE(1309), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [67983] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3182), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [67996] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2502), 1,
      anon_sym_RBRACE,
    ACTIONS(3184), 1,
      anon_sym_COMMA,
    STATE(1170), 1,
      aux_sym_unqualified_imports_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68013] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3186), 1,
      anon_sym_COMMA,
    ACTIONS(3188), 1,
      anon_sym_RPAREN,
    STATE(1307), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68030] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3190), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RPAREN,
    STATE(1304), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68047] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    ACTIONS(3194), 1,
      anon_sym_RPAREN,
    STATE(1358), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68064] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2446), 1,
      anon_sym_RPAREN,
    ACTIONS(3196), 1,
      anon_sym_COMMA,
    STATE(1290), 1,
      aux_sym_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68081] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3198), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [68094] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2223), 1,
      anon_sym_RPAREN,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    STATE(1205), 1,
      aux_sym_data_constructor_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68111] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2700), 3,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_DASH,
  [68124] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3202), 1,
      anon_sym_COMMA,
    ACTIONS(3205), 1,
      anon_sym_RPAREN,
    STATE(1301), 1,
      aux_sym_anonymous_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68141] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3207), 1,
      anon_sym_COMMA,
    ACTIONS(3209), 1,
      anon_sym_RPAREN,
    STATE(1199), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68158] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1012), 1,
      sym_external_function_body,
    STATE(1328), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68175] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2243), 1,
      anon_sym_RPAREN,
    ACTIONS(3211), 1,
      anon_sym_COMMA,
    STATE(1247), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68192] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(534), 1,
      sym_external_function_body,
    STATE(1348), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68209] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2119), 1,
      anon_sym_RPAREN,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      aux_sym_constant_tuple_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68226] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2255), 1,
      anon_sym_RPAREN,
    ACTIONS(3215), 1,
      anon_sym_COMMA,
    STATE(1242), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68243] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3217), 1,
      anon_sym_COMMA,
    ACTIONS(3220), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym_external_function_parameters_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68260] = 5,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    ACTIONS(3222), 1,
      anon_sym_COMMA,
    STATE(1153), 1,
      aux_sym_constant_record_arguments_repeat1,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68277] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3224), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68289] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(1360), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68303] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3226), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68315] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3220), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68327] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3228), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [68339] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1319), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68353] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3230), 2,
      anon_sym_RBRACE,
      sym__upname,
  [68365] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1321), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68379] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1410), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68393] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3232), 1,
      anon_sym_LPAREN,
    STATE(1562), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68407] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3234), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68419] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3232), 1,
      anon_sym_LPAREN,
    STATE(1561), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68433] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3236), 1,
      sym__name,
    STATE(461), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68447] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1428), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68461] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(318), 1,
      sym__upname,
    STATE(129), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68475] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3176), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68487] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2772), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68499] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1347), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68513] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(602), 1,
      anon_sym_DQUOTE,
    STATE(1014), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68527] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3238), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68539] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1342), 1,
      sym__upname,
    STATE(1009), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68553] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(848), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68567] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1442), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68581] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3240), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68593] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3242), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [68605] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3238), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68617] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68629] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3246), 1,
      anon_sym_LPAREN,
    STATE(470), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68643] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3248), 1,
      sym__name,
    STATE(464), 1,
      sym_module,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68657] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3250), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [68669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1349), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68683] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1384), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68697] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    STATE(431), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68711] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1165), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68725] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1352), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68739] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3254), 1,
      sym__name,
    STATE(905), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68753] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3256), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68765] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3258), 1,
      anon_sym_LBRACE,
    ACTIONS(3260), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68779] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68793] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3262), 1,
      anon_sym_LBRACE,
    ACTIONS(3264), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68807] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2466), 1,
      sym__name,
    STATE(429), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68821] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3266), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [68833] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3268), 1,
      anon_sym_LBRACE,
    ACTIONS(3270), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68847] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3272), 1,
      anon_sym_LBRACE,
    ACTIONS(3274), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68861] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(956), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68875] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3276), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68887] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3101), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68899] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3278), 1,
      anon_sym_type,
    ACTIONS(3280), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68913] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2781), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68925] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(982), 1,
      sym__upname,
    STATE(365), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68939] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3282), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68951] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(614), 1,
      sym__upname,
    STATE(357), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [68965] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3284), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68977] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3286), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [68989] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3288), 1,
      anon_sym_LBRACE,
    ACTIONS(3290), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69003] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2821), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69015] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1483), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69029] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3056), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69041] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1493), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69055] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3292), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [69067] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3294), 1,
      anon_sym_LPAREN,
    STATE(56), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69081] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3296), 1,
      anon_sym_COLON,
    ACTIONS(3298), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69095] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3300), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69107] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    STATE(1364), 1,
      sym_anonymous_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69121] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2450), 1,
      anon_sym_LBRACE,
    ACTIONS(2452), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69135] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    STATE(950), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69149] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3304), 1,
      sym__name,
    STATE(905), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69163] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1492), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69177] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1494), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69191] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3306), 1,
      sym__name,
    STATE(948), 1,
      sym_module,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69205] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3232), 1,
      anon_sym_LPAREN,
    STATE(1510), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69219] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3308), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69231] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3039), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69243] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2841), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69255] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    ACTIONS(3312), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69269] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3314), 1,
      anon_sym_LPAREN,
    STATE(374), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69283] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3304), 1,
      sym__name,
    STATE(956), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69297] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3246), 1,
      anon_sym_LPAREN,
    STATE(487), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69311] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3316), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69323] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(1401), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69337] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2790), 1,
      sym__name,
    STATE(1358), 1,
      sym_type_parameter,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69351] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1545), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69365] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1546), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69379] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3318), 1,
      sym__name,
    STATE(375), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69393] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1380), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69407] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1515), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69421] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3320), 2,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [69433] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    STATE(972), 1,
      sym_unqualified_imports,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69447] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69459] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1401), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69473] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2640), 1,
      sym__name,
    STATE(153), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69487] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3324), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [69499] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1447), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69513] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2866), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69525] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3326), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69537] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3328), 1,
      anon_sym_type,
    ACTIONS(3330), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69551] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1282), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69565] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3332), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69577] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2786), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69589] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2221), 1,
      sym__upname,
    STATE(1174), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69603] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3302), 1,
      anon_sym_LPAREN,
    STATE(958), 1,
      sym_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69617] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2297), 1,
      sym__upname,
    STATE(460), 1,
      sym_type_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69631] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3334), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69643] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2861), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69655] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1375), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69669] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1240), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69683] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2765), 2,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
  [69695] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1507), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69709] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3336), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69721] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3338), 1,
      anon_sym_LBRACE,
    STATE(475), 1,
      sym_unqualified_imports,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69735] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(308), 1,
      anon_sym_DQUOTE,
    STATE(1506), 1,
      sym_string,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69749] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1208), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69763] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2037), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69775] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3340), 1,
      anon_sym_LPAREN,
    STATE(148), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69789] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(61), 1,
      sym__upname,
    STATE(19), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69803] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3342), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69815] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2879), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69827] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    STATE(670), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69841] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2746), 1,
      sym__name,
    STATE(47), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69855] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3346), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69867] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2929), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69879] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3348), 2,
      anon_sym_RBRACE,
      sym__upname,
  [69891] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2031), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69903] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3350), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [69915] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3205), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69927] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2462), 1,
      sym__name,
    STATE(674), 1,
      sym_label,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69941] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3352), 1,
      anon_sym_type,
    ACTIONS(3354), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69955] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2942), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69967] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(916), 1,
      sym__upname,
    STATE(687), 1,
      sym_constructor_name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69981] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3356), 1,
      anon_sym_type,
    ACTIONS(3358), 1,
      anon_sym_fn,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [69995] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(2916), 2,
      anon_sym_COMMA,
      anon_sym_GT_GT,
  [70007] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2474), 1,
      sym__name,
    STATE(1337), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70021] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3232), 1,
      anon_sym_LPAREN,
    STATE(1455), 1,
      sym_external_function_parameters,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70035] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3360), 1,
      anon_sym_COMMA,
    ACTIONS(3362), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70049] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
    ACTIONS(3224), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70061] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3364), 1,
      anon_sym_LBRACE,
    ACTIONS(3366), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70075] = 4,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3254), 1,
      sym__name,
    STATE(955), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70089] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3368), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70100] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3370), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70111] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3372), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70122] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3374), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70133] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3376), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70144] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3378), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70155] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3380), 1,
      anon_sym_LT_DASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70166] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3382), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70177] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3384), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70188] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3386), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70199] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3388), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70210] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3390), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70221] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3392), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70232] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70243] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1414), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70254] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70265] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3398), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70276] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3400), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70287] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3402), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70298] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3404), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70309] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3406), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70320] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3408), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70331] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3410), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70342] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3412), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70353] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3414), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70364] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3416), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70375] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70386] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3420), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70397] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3422), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70408] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3424), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70419] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3298), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70430] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3426), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70441] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3428), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70452] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3430), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70463] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(2581), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70474] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3432), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70485] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3434), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70496] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3436), 1,
      anon_sym_LT_DASH,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70507] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3438), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70518] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3440), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70529] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3442), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70540] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3444), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70551] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3446), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70562] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3448), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70573] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3450), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70584] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3452), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70595] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3454), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70606] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3456), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70617] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3458), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70628] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70639] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3460), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70650] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3462), 1,
      sym__name,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70661] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3464), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70672] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70683] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3468), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70694] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3470), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70705] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3472), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70716] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3474), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70727] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3476), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70738] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3478), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70749] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3480), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70760] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3482), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70771] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3484), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70782] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3486), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70793] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3488), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70804] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3490), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70815] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3492), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70826] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3494), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70837] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3496), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70848] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70859] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3500), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70870] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3502), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70881] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3504), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70892] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3506), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70903] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3508), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70914] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3510), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70925] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3512), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70936] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3514), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70947] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3516), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70958] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3518), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70969] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3520), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70980] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3522), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [70991] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3524), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71002] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3526), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71013] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3528), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71024] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3530), 1,
      ts_builtin_sym_end,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71035] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3532), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71046] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3534), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71057] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3536), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71068] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3538), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71079] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3540), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71090] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3542), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71101] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3544), 1,
      anon_sym_type,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71112] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3546), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71123] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3548), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71134] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3550), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71145] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3552), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71156] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3554), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71167] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3556), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71178] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3558), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71189] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3560), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71200] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3562), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71211] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3564), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71222] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3566), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71233] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3568), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71244] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3570), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71255] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3572), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71266] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3574), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71277] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3576), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71288] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3578), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71299] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3580), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71310] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3582), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71321] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3584), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71332] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3586), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71343] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3588), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71354] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3590), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71365] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3592), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71376] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3594), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71387] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3596), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71398] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3598), 1,
      anon_sym_DOT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71409] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3600), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71420] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3602), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71431] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3604), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71442] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3606), 1,
      anon_sym_EQ,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71453] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3608), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71464] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3610), 1,
      anon_sym_LPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71475] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3612), 1,
      anon_sym_DASH_GT,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71486] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3614), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
  [71497] = 3,
    ACTIONS(3), 1,
      sym_module_comment,
    ACTIONS(3616), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_statement_comment,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(6)] = 0,
  [SMALL_STATE(7)] = 71,
  [SMALL_STATE(8)] = 137,
  [SMALL_STATE(9)] = 263,
  [SMALL_STATE(10)] = 389,
  [SMALL_STATE(11)] = 515,
  [SMALL_STATE(12)] = 641,
  [SMALL_STATE(13)] = 767,
  [SMALL_STATE(14)] = 893,
  [SMALL_STATE(15)] = 1019,
  [SMALL_STATE(16)] = 1089,
  [SMALL_STATE(17)] = 1159,
  [SMALL_STATE(18)] = 1285,
  [SMALL_STATE(19)] = 1351,
  [SMALL_STATE(20)] = 1417,
  [SMALL_STATE(21)] = 1543,
  [SMALL_STATE(22)] = 1669,
  [SMALL_STATE(23)] = 1795,
  [SMALL_STATE(24)] = 1921,
  [SMALL_STATE(25)] = 1987,
  [SMALL_STATE(26)] = 2053,
  [SMALL_STATE(27)] = 2119,
  [SMALL_STATE(28)] = 2245,
  [SMALL_STATE(29)] = 2311,
  [SMALL_STATE(30)] = 2437,
  [SMALL_STATE(31)] = 2563,
  [SMALL_STATE(32)] = 2689,
  [SMALL_STATE(33)] = 2755,
  [SMALL_STATE(34)] = 2881,
  [SMALL_STATE(35)] = 2951,
  [SMALL_STATE(36)] = 3077,
  [SMALL_STATE(37)] = 3203,
  [SMALL_STATE(38)] = 3329,
  [SMALL_STATE(39)] = 3399,
  [SMALL_STATE(40)] = 3525,
  [SMALL_STATE(41)] = 3651,
  [SMALL_STATE(42)] = 3777,
  [SMALL_STATE(43)] = 3843,
  [SMALL_STATE(44)] = 3969,
  [SMALL_STATE(45)] = 4095,
  [SMALL_STATE(46)] = 4161,
  [SMALL_STATE(47)] = 4287,
  [SMALL_STATE(48)] = 4353,
  [SMALL_STATE(49)] = 4479,
  [SMALL_STATE(50)] = 4545,
  [SMALL_STATE(51)] = 4671,
  [SMALL_STATE(52)] = 4737,
  [SMALL_STATE(53)] = 4803,
  [SMALL_STATE(54)] = 4929,
  [SMALL_STATE(55)] = 5055,
  [SMALL_STATE(56)] = 5121,
  [SMALL_STATE(57)] = 5187,
  [SMALL_STATE(58)] = 5313,
  [SMALL_STATE(59)] = 5439,
  [SMALL_STATE(60)] = 5504,
  [SMALL_STATE(61)] = 5627,
  [SMALL_STATE(62)] = 5750,
  [SMALL_STATE(63)] = 5873,
  [SMALL_STATE(64)] = 5938,
  [SMALL_STATE(65)] = 6061,
  [SMALL_STATE(66)] = 6184,
  [SMALL_STATE(67)] = 6249,
  [SMALL_STATE(68)] = 6372,
  [SMALL_STATE(69)] = 6495,
  [SMALL_STATE(70)] = 6618,
  [SMALL_STATE(71)] = 6741,
  [SMALL_STATE(72)] = 6806,
  [SMALL_STATE(73)] = 6929,
  [SMALL_STATE(74)] = 6994,
  [SMALL_STATE(75)] = 7117,
  [SMALL_STATE(76)] = 7184,
  [SMALL_STATE(77)] = 7251,
  [SMALL_STATE(78)] = 7318,
  [SMALL_STATE(79)] = 7383,
  [SMALL_STATE(80)] = 7506,
  [SMALL_STATE(81)] = 7571,
  [SMALL_STATE(82)] = 7694,
  [SMALL_STATE(83)] = 7759,
  [SMALL_STATE(84)] = 7882,
  [SMALL_STATE(85)] = 7947,
  [SMALL_STATE(86)] = 8070,
  [SMALL_STATE(87)] = 8144,
  [SMALL_STATE(88)] = 8212,
  [SMALL_STATE(89)] = 8338,
  [SMALL_STATE(90)] = 8464,
  [SMALL_STATE(91)] = 8528,
  [SMALL_STATE(92)] = 8606,
  [SMALL_STATE(93)] = 8690,
  [SMALL_STATE(94)] = 8754,
  [SMALL_STATE(95)] = 8838,
  [SMALL_STATE(96)] = 8964,
  [SMALL_STATE(97)] = 9048,
  [SMALL_STATE(98)] = 9112,
  [SMALL_STATE(99)] = 9192,
  [SMALL_STATE(100)] = 9256,
  [SMALL_STATE(101)] = 9340,
  [SMALL_STATE(102)] = 9404,
  [SMALL_STATE(103)] = 9468,
  [SMALL_STATE(104)] = 9532,
  [SMALL_STATE(105)] = 9614,
  [SMALL_STATE(106)] = 9678,
  [SMALL_STATE(107)] = 9742,
  [SMALL_STATE(108)] = 9826,
  [SMALL_STATE(109)] = 9910,
  [SMALL_STATE(110)] = 10036,
  [SMALL_STATE(111)] = 10100,
  [SMALL_STATE(112)] = 10164,
  [SMALL_STATE(113)] = 10290,
  [SMALL_STATE(114)] = 10354,
  [SMALL_STATE(115)] = 10418,
  [SMALL_STATE(116)] = 10482,
  [SMALL_STATE(117)] = 10554,
  [SMALL_STATE(118)] = 10618,
  [SMALL_STATE(119)] = 10682,
  [SMALL_STATE(120)] = 10766,
  [SMALL_STATE(121)] = 10830,
  [SMALL_STATE(122)] = 10894,
  [SMALL_STATE(123)] = 10958,
  [SMALL_STATE(124)] = 11022,
  [SMALL_STATE(125)] = 11145,
  [SMALL_STATE(126)] = 11268,
  [SMALL_STATE(127)] = 11391,
  [SMALL_STATE(128)] = 11514,
  [SMALL_STATE(129)] = 11637,
  [SMALL_STATE(130)] = 11700,
  [SMALL_STATE(131)] = 11823,
  [SMALL_STATE(132)] = 11946,
  [SMALL_STATE(133)] = 12069,
  [SMALL_STATE(134)] = 12192,
  [SMALL_STATE(135)] = 12315,
  [SMALL_STATE(136)] = 12438,
  [SMALL_STATE(137)] = 12561,
  [SMALL_STATE(138)] = 12684,
  [SMALL_STATE(139)] = 12807,
  [SMALL_STATE(140)] = 12870,
  [SMALL_STATE(141)] = 12933,
  [SMALL_STATE(142)] = 13056,
  [SMALL_STATE(143)] = 13119,
  [SMALL_STATE(144)] = 13239,
  [SMALL_STATE(145)] = 13305,
  [SMALL_STATE(146)] = 13366,
  [SMALL_STATE(147)] = 13427,
  [SMALL_STATE(148)] = 13488,
  [SMALL_STATE(149)] = 13549,
  [SMALL_STATE(150)] = 13614,
  [SMALL_STATE(151)] = 13675,
  [SMALL_STATE(152)] = 13736,
  [SMALL_STATE(153)] = 13797,
  [SMALL_STATE(154)] = 13858,
  [SMALL_STATE(155)] = 13919,
  [SMALL_STATE(156)] = 13980,
  [SMALL_STATE(157)] = 14041,
  [SMALL_STATE(158)] = 14106,
  [SMALL_STATE(159)] = 14167,
  [SMALL_STATE(160)] = 14281,
  [SMALL_STATE(161)] = 14341,
  [SMALL_STATE(162)] = 14403,
  [SMALL_STATE(163)] = 14517,
  [SMALL_STATE(164)] = 14631,
  [SMALL_STATE(165)] = 14693,
  [SMALL_STATE(166)] = 14807,
  [SMALL_STATE(167)] = 14867,
  [SMALL_STATE(168)] = 14981,
  [SMALL_STATE(169)] = 15041,
  [SMALL_STATE(170)] = 15101,
  [SMALL_STATE(171)] = 15161,
  [SMALL_STATE(172)] = 15275,
  [SMALL_STATE(173)] = 15389,
  [SMALL_STATE(174)] = 15503,
  [SMALL_STATE(175)] = 15563,
  [SMALL_STATE(176)] = 15623,
  [SMALL_STATE(177)] = 15737,
  [SMALL_STATE(178)] = 15851,
  [SMALL_STATE(179)] = 15965,
  [SMALL_STATE(180)] = 16025,
  [SMALL_STATE(181)] = 16087,
  [SMALL_STATE(182)] = 16146,
  [SMALL_STATE(183)] = 16257,
  [SMALL_STATE(184)] = 16368,
  [SMALL_STATE(185)] = 16479,
  [SMALL_STATE(186)] = 16590,
  [SMALL_STATE(187)] = 16701,
  [SMALL_STATE(188)] = 16812,
  [SMALL_STATE(189)] = 16871,
  [SMALL_STATE(190)] = 16982,
  [SMALL_STATE(191)] = 17041,
  [SMALL_STATE(192)] = 17100,
  [SMALL_STATE(193)] = 17211,
  [SMALL_STATE(194)] = 17270,
  [SMALL_STATE(195)] = 17329,
  [SMALL_STATE(196)] = 17440,
  [SMALL_STATE(197)] = 17499,
  [SMALL_STATE(198)] = 17558,
  [SMALL_STATE(199)] = 17669,
  [SMALL_STATE(200)] = 17780,
  [SMALL_STATE(201)] = 17891,
  [SMALL_STATE(202)] = 18002,
  [SMALL_STATE(203)] = 18061,
  [SMALL_STATE(204)] = 18120,
  [SMALL_STATE(205)] = 18179,
  [SMALL_STATE(206)] = 18238,
  [SMALL_STATE(207)] = 18297,
  [SMALL_STATE(208)] = 18408,
  [SMALL_STATE(209)] = 18467,
  [SMALL_STATE(210)] = 18578,
  [SMALL_STATE(211)] = 18637,
  [SMALL_STATE(212)] = 18748,
  [SMALL_STATE(213)] = 18807,
  [SMALL_STATE(214)] = 18918,
  [SMALL_STATE(215)] = 19029,
  [SMALL_STATE(216)] = 19140,
  [SMALL_STATE(217)] = 19251,
  [SMALL_STATE(218)] = 19362,
  [SMALL_STATE(219)] = 19421,
  [SMALL_STATE(220)] = 19532,
  [SMALL_STATE(221)] = 19643,
  [SMALL_STATE(222)] = 19754,
  [SMALL_STATE(223)] = 19865,
  [SMALL_STATE(224)] = 19973,
  [SMALL_STATE(225)] = 20081,
  [SMALL_STATE(226)] = 20189,
  [SMALL_STATE(227)] = 20297,
  [SMALL_STATE(228)] = 20405,
  [SMALL_STATE(229)] = 20513,
  [SMALL_STATE(230)] = 20621,
  [SMALL_STATE(231)] = 20729,
  [SMALL_STATE(232)] = 20841,
  [SMALL_STATE(233)] = 20949,
  [SMALL_STATE(234)] = 21057,
  [SMALL_STATE(235)] = 21165,
  [SMALL_STATE(236)] = 21273,
  [SMALL_STATE(237)] = 21381,
  [SMALL_STATE(238)] = 21489,
  [SMALL_STATE(239)] = 21597,
  [SMALL_STATE(240)] = 21705,
  [SMALL_STATE(241)] = 21817,
  [SMALL_STATE(242)] = 21929,
  [SMALL_STATE(243)] = 22037,
  [SMALL_STATE(244)] = 22145,
  [SMALL_STATE(245)] = 22253,
  [SMALL_STATE(246)] = 22361,
  [SMALL_STATE(247)] = 22469,
  [SMALL_STATE(248)] = 22577,
  [SMALL_STATE(249)] = 22689,
  [SMALL_STATE(250)] = 22797,
  [SMALL_STATE(251)] = 22909,
  [SMALL_STATE(252)] = 23017,
  [SMALL_STATE(253)] = 23125,
  [SMALL_STATE(254)] = 23233,
  [SMALL_STATE(255)] = 23341,
  [SMALL_STATE(256)] = 23449,
  [SMALL_STATE(257)] = 23561,
  [SMALL_STATE(258)] = 23669,
  [SMALL_STATE(259)] = 23777,
  [SMALL_STATE(260)] = 23889,
  [SMALL_STATE(261)] = 23997,
  [SMALL_STATE(262)] = 24105,
  [SMALL_STATE(263)] = 24217,
  [SMALL_STATE(264)] = 24329,
  [SMALL_STATE(265)] = 24437,
  [SMALL_STATE(266)] = 24545,
  [SMALL_STATE(267)] = 24653,
  [SMALL_STATE(268)] = 24761,
  [SMALL_STATE(269)] = 24869,
  [SMALL_STATE(270)] = 24977,
  [SMALL_STATE(271)] = 25089,
  [SMALL_STATE(272)] = 25197,
  [SMALL_STATE(273)] = 25305,
  [SMALL_STATE(274)] = 25413,
  [SMALL_STATE(275)] = 25521,
  [SMALL_STATE(276)] = 25629,
  [SMALL_STATE(277)] = 25737,
  [SMALL_STATE(278)] = 25845,
  [SMALL_STATE(279)] = 25957,
  [SMALL_STATE(280)] = 26065,
  [SMALL_STATE(281)] = 26177,
  [SMALL_STATE(282)] = 26285,
  [SMALL_STATE(283)] = 26393,
  [SMALL_STATE(284)] = 26501,
  [SMALL_STATE(285)] = 26609,
  [SMALL_STATE(286)] = 26717,
  [SMALL_STATE(287)] = 26825,
  [SMALL_STATE(288)] = 26933,
  [SMALL_STATE(289)] = 27041,
  [SMALL_STATE(290)] = 27149,
  [SMALL_STATE(291)] = 27211,
  [SMALL_STATE(292)] = 27319,
  [SMALL_STATE(293)] = 27427,
  [SMALL_STATE(294)] = 27535,
  [SMALL_STATE(295)] = 27593,
  [SMALL_STATE(296)] = 27705,
  [SMALL_STATE(297)] = 27817,
  [SMALL_STATE(298)] = 27925,
  [SMALL_STATE(299)] = 28033,
  [SMALL_STATE(300)] = 28141,
  [SMALL_STATE(301)] = 28249,
  [SMALL_STATE(302)] = 28357,
  [SMALL_STATE(303)] = 28465,
  [SMALL_STATE(304)] = 28573,
  [SMALL_STATE(305)] = 28681,
  [SMALL_STATE(306)] = 28789,
  [SMALL_STATE(307)] = 28897,
  [SMALL_STATE(308)] = 29005,
  [SMALL_STATE(309)] = 29113,
  [SMALL_STATE(310)] = 29221,
  [SMALL_STATE(311)] = 29329,
  [SMALL_STATE(312)] = 29437,
  [SMALL_STATE(313)] = 29545,
  [SMALL_STATE(314)] = 29653,
  [SMALL_STATE(315)] = 29761,
  [SMALL_STATE(316)] = 29869,
  [SMALL_STATE(317)] = 29931,
  [SMALL_STATE(318)] = 30039,
  [SMALL_STATE(319)] = 30147,
  [SMALL_STATE(320)] = 30255,
  [SMALL_STATE(321)] = 30363,
  [SMALL_STATE(322)] = 30475,
  [SMALL_STATE(323)] = 30583,
  [SMALL_STATE(324)] = 30691,
  [SMALL_STATE(325)] = 30799,
  [SMALL_STATE(326)] = 30907,
  [SMALL_STATE(327)] = 31015,
  [SMALL_STATE(328)] = 31124,
  [SMALL_STATE(329)] = 31200,
  [SMALL_STATE(330)] = 31306,
  [SMALL_STATE(331)] = 31412,
  [SMALL_STATE(332)] = 31518,
  [SMALL_STATE(333)] = 31594,
  [SMALL_STATE(334)] = 31650,
  [SMALL_STATE(335)] = 31756,
  [SMALL_STATE(336)] = 31862,
  [SMALL_STATE(337)] = 31922,
  [SMALL_STATE(338)] = 31998,
  [SMALL_STATE(339)] = 32072,
  [SMALL_STATE(340)] = 32178,
  [SMALL_STATE(341)] = 32254,
  [SMALL_STATE(342)] = 32330,
  [SMALL_STATE(343)] = 32436,
  [SMALL_STATE(344)] = 32508,
  [SMALL_STATE(345)] = 32614,
  [SMALL_STATE(346)] = 32720,
  [SMALL_STATE(347)] = 32826,
  [SMALL_STATE(348)] = 32932,
  [SMALL_STATE(349)] = 33038,
  [SMALL_STATE(350)] = 33114,
  [SMALL_STATE(351)] = 33178,
  [SMALL_STATE(352)] = 33244,
  [SMALL_STATE(353)] = 33320,
  [SMALL_STATE(354)] = 33390,
  [SMALL_STATE(355)] = 33445,
  [SMALL_STATE(356)] = 33500,
  [SMALL_STATE(357)] = 33555,
  [SMALL_STATE(358)] = 33610,
  [SMALL_STATE(359)] = 33663,
  [SMALL_STATE(360)] = 33716,
  [SMALL_STATE(361)] = 33769,
  [SMALL_STATE(362)] = 33824,
  [SMALL_STATE(363)] = 33874,
  [SMALL_STATE(364)] = 33928,
  [SMALL_STATE(365)] = 33978,
  [SMALL_STATE(366)] = 34028,
  [SMALL_STATE(367)] = 34078,
  [SMALL_STATE(368)] = 34128,
  [SMALL_STATE(369)] = 34178,
  [SMALL_STATE(370)] = 34232,
  [SMALL_STATE(371)] = 34286,
  [SMALL_STATE(372)] = 34336,
  [SMALL_STATE(373)] = 34386,
  [SMALL_STATE(374)] = 34436,
  [SMALL_STATE(375)] = 34486,
  [SMALL_STATE(376)] = 34536,
  [SMALL_STATE(377)] = 34586,
  [SMALL_STATE(378)] = 34636,
  [SMALL_STATE(379)] = 34690,
  [SMALL_STATE(380)] = 34740,
  [SMALL_STATE(381)] = 34790,
  [SMALL_STATE(382)] = 34840,
  [SMALL_STATE(383)] = 34889,
  [SMALL_STATE(384)] = 34938,
  [SMALL_STATE(385)] = 34987,
  [SMALL_STATE(386)] = 35036,
  [SMALL_STATE(387)] = 35085,
  [SMALL_STATE(388)] = 35136,
  [SMALL_STATE(389)] = 35185,
  [SMALL_STATE(390)] = 35236,
  [SMALL_STATE(391)] = 35285,
  [SMALL_STATE(392)] = 35334,
  [SMALL_STATE(393)] = 35385,
  [SMALL_STATE(394)] = 35433,
  [SMALL_STATE(395)] = 35481,
  [SMALL_STATE(396)] = 35529,
  [SMALL_STATE(397)] = 35597,
  [SMALL_STATE(398)] = 35645,
  [SMALL_STATE(399)] = 35693,
  [SMALL_STATE(400)] = 35741,
  [SMALL_STATE(401)] = 35809,
  [SMALL_STATE(402)] = 35865,
  [SMALL_STATE(403)] = 35933,
  [SMALL_STATE(404)] = 35981,
  [SMALL_STATE(405)] = 36029,
  [SMALL_STATE(406)] = 36077,
  [SMALL_STATE(407)] = 36145,
  [SMALL_STATE(408)] = 36193,
  [SMALL_STATE(409)] = 36241,
  [SMALL_STATE(410)] = 36289,
  [SMALL_STATE(411)] = 36337,
  [SMALL_STATE(412)] = 36395,
  [SMALL_STATE(413)] = 36457,
  [SMALL_STATE(414)] = 36505,
  [SMALL_STATE(415)] = 36573,
  [SMALL_STATE(416)] = 36621,
  [SMALL_STATE(417)] = 36685,
  [SMALL_STATE(418)] = 36733,
  [SMALL_STATE(419)] = 36799,
  [SMALL_STATE(420)] = 36847,
  [SMALL_STATE(421)] = 36895,
  [SMALL_STATE(422)] = 36947,
  [SMALL_STATE(423)] = 36995,
  [SMALL_STATE(424)] = 37063,
  [SMALL_STATE(425)] = 37111,
  [SMALL_STATE(426)] = 37161,
  [SMALL_STATE(427)] = 37211,
  [SMALL_STATE(428)] = 37261,
  [SMALL_STATE(429)] = 37311,
  [SMALL_STATE(430)] = 37356,
  [SMALL_STATE(431)] = 37401,
  [SMALL_STATE(432)] = 37446,
  [SMALL_STATE(433)] = 37491,
  [SMALL_STATE(434)] = 37540,
  [SMALL_STATE(435)] = 37585,
  [SMALL_STATE(436)] = 37634,
  [SMALL_STATE(437)] = 37679,
  [SMALL_STATE(438)] = 37728,
  [SMALL_STATE(439)] = 37777,
  [SMALL_STATE(440)] = 37822,
  [SMALL_STATE(441)] = 37867,
  [SMALL_STATE(442)] = 37912,
  [SMALL_STATE(443)] = 37957,
  [SMALL_STATE(444)] = 38006,
  [SMALL_STATE(445)] = 38051,
  [SMALL_STATE(446)] = 38096,
  [SMALL_STATE(447)] = 38142,
  [SMALL_STATE(448)] = 38186,
  [SMALL_STATE(449)] = 38232,
  [SMALL_STATE(450)] = 38278,
  [SMALL_STATE(451)] = 38362,
  [SMALL_STATE(452)] = 38446,
  [SMALL_STATE(453)] = 38490,
  [SMALL_STATE(454)] = 38574,
  [SMALL_STATE(455)] = 38618,
  [SMALL_STATE(456)] = 38702,
  [SMALL_STATE(457)] = 38750,
  [SMALL_STATE(458)] = 38794,
  [SMALL_STATE(459)] = 38878,
  [SMALL_STATE(460)] = 38922,
  [SMALL_STATE(461)] = 38966,
  [SMALL_STATE(462)] = 39014,
  [SMALL_STATE(463)] = 39058,
  [SMALL_STATE(464)] = 39102,
  [SMALL_STATE(465)] = 39150,
  [SMALL_STATE(466)] = 39194,
  [SMALL_STATE(467)] = 39242,
  [SMALL_STATE(468)] = 39286,
  [SMALL_STATE(469)] = 39329,
  [SMALL_STATE(470)] = 39390,
  [SMALL_STATE(471)] = 39437,
  [SMALL_STATE(472)] = 39520,
  [SMALL_STATE(473)] = 39567,
  [SMALL_STATE(474)] = 39610,
  [SMALL_STATE(475)] = 39657,
  [SMALL_STATE(476)] = 39702,
  [SMALL_STATE(477)] = 39745,
  [SMALL_STATE(478)] = 39788,
  [SMALL_STATE(479)] = 39833,
  [SMALL_STATE(480)] = 39884,
  [SMALL_STATE(481)] = 39937,
  [SMALL_STATE(482)] = 39992,
  [SMALL_STATE(483)] = 40049,
  [SMALL_STATE(484)] = 40092,
  [SMALL_STATE(485)] = 40151,
  [SMALL_STATE(486)] = 40198,
  [SMALL_STATE(487)] = 40241,
  [SMALL_STATE(488)] = 40288,
  [SMALL_STATE(489)] = 40331,
  [SMALL_STATE(490)] = 40392,
  [SMALL_STATE(491)] = 40453,
  [SMALL_STATE(492)] = 40496,
  [SMALL_STATE(493)] = 40539,
  [SMALL_STATE(494)] = 40582,
  [SMALL_STATE(495)] = 40625,
  [SMALL_STATE(496)] = 40668,
  [SMALL_STATE(497)] = 40713,
  [SMALL_STATE(498)] = 40756,
  [SMALL_STATE(499)] = 40817,
  [SMALL_STATE(500)] = 40898,
  [SMALL_STATE(501)] = 40941,
  [SMALL_STATE(502)] = 40984,
  [SMALL_STATE(503)] = 41027,
  [SMALL_STATE(504)] = 41110,
  [SMALL_STATE(505)] = 41191,
  [SMALL_STATE(506)] = 41234,
  [SMALL_STATE(507)] = 41277,
  [SMALL_STATE(508)] = 41334,
  [SMALL_STATE(509)] = 41417,
  [SMALL_STATE(510)] = 41460,
  [SMALL_STATE(511)] = 41503,
  [SMALL_STATE(512)] = 41546,
  [SMALL_STATE(513)] = 41589,
  [SMALL_STATE(514)] = 41632,
  [SMALL_STATE(515)] = 41689,
  [SMALL_STATE(516)] = 41746,
  [SMALL_STATE(517)] = 41789,
  [SMALL_STATE(518)] = 41832,
  [SMALL_STATE(519)] = 41875,
  [SMALL_STATE(520)] = 41918,
  [SMALL_STATE(521)] = 41975,
  [SMALL_STATE(522)] = 42018,
  [SMALL_STATE(523)] = 42075,
  [SMALL_STATE(524)] = 42118,
  [SMALL_STATE(525)] = 42175,
  [SMALL_STATE(526)] = 42218,
  [SMALL_STATE(527)] = 42261,
  [SMALL_STATE(528)] = 42303,
  [SMALL_STATE(529)] = 42347,
  [SMALL_STATE(530)] = 42389,
  [SMALL_STATE(531)] = 42431,
  [SMALL_STATE(532)] = 42487,
  [SMALL_STATE(533)] = 42529,
  [SMALL_STATE(534)] = 42571,
  [SMALL_STATE(535)] = 42613,
  [SMALL_STATE(536)] = 42655,
  [SMALL_STATE(537)] = 42727,
  [SMALL_STATE(538)] = 42769,
  [SMALL_STATE(539)] = 42811,
  [SMALL_STATE(540)] = 42853,
  [SMALL_STATE(541)] = 42895,
  [SMALL_STATE(542)] = 42937,
  [SMALL_STATE(543)] = 42979,
  [SMALL_STATE(544)] = 43021,
  [SMALL_STATE(545)] = 43063,
  [SMALL_STATE(546)] = 43105,
  [SMALL_STATE(547)] = 43177,
  [SMALL_STATE(548)] = 43219,
  [SMALL_STATE(549)] = 43261,
  [SMALL_STATE(550)] = 43303,
  [SMALL_STATE(551)] = 43375,
  [SMALL_STATE(552)] = 43417,
  [SMALL_STATE(553)] = 43459,
  [SMALL_STATE(554)] = 43501,
  [SMALL_STATE(555)] = 43543,
  [SMALL_STATE(556)] = 43585,
  [SMALL_STATE(557)] = 43627,
  [SMALL_STATE(558)] = 43669,
  [SMALL_STATE(559)] = 43711,
  [SMALL_STATE(560)] = 43753,
  [SMALL_STATE(561)] = 43825,
  [SMALL_STATE(562)] = 43867,
  [SMALL_STATE(563)] = 43909,
  [SMALL_STATE(564)] = 43951,
  [SMALL_STATE(565)] = 43993,
  [SMALL_STATE(566)] = 44035,
  [SMALL_STATE(567)] = 44077,
  [SMALL_STATE(568)] = 44119,
  [SMALL_STATE(569)] = 44161,
  [SMALL_STATE(570)] = 44217,
  [SMALL_STATE(571)] = 44261,
  [SMALL_STATE(572)] = 44303,
  [SMALL_STATE(573)] = 44345,
  [SMALL_STATE(574)] = 44387,
  [SMALL_STATE(575)] = 44429,
  [SMALL_STATE(576)] = 44501,
  [SMALL_STATE(577)] = 44543,
  [SMALL_STATE(578)] = 44585,
  [SMALL_STATE(579)] = 44627,
  [SMALL_STATE(580)] = 44669,
  [SMALL_STATE(581)] = 44711,
  [SMALL_STATE(582)] = 44753,
  [SMALL_STATE(583)] = 44795,
  [SMALL_STATE(584)] = 44867,
  [SMALL_STATE(585)] = 44909,
  [SMALL_STATE(586)] = 44951,
  [SMALL_STATE(587)] = 44993,
  [SMALL_STATE(588)] = 45049,
  [SMALL_STATE(589)] = 45091,
  [SMALL_STATE(590)] = 45133,
  [SMALL_STATE(591)] = 45205,
  [SMALL_STATE(592)] = 45247,
  [SMALL_STATE(593)] = 45289,
  [SMALL_STATE(594)] = 45331,
  [SMALL_STATE(595)] = 45373,
  [SMALL_STATE(596)] = 45415,
  [SMALL_STATE(597)] = 45457,
  [SMALL_STATE(598)] = 45529,
  [SMALL_STATE(599)] = 45571,
  [SMALL_STATE(600)] = 45613,
  [SMALL_STATE(601)] = 45655,
  [SMALL_STATE(602)] = 45697,
  [SMALL_STATE(603)] = 45739,
  [SMALL_STATE(604)] = 45781,
  [SMALL_STATE(605)] = 45823,
  [SMALL_STATE(606)] = 45895,
  [SMALL_STATE(607)] = 45939,
  [SMALL_STATE(608)] = 45981,
  [SMALL_STATE(609)] = 46053,
  [SMALL_STATE(610)] = 46130,
  [SMALL_STATE(611)] = 46183,
  [SMALL_STATE(612)] = 46260,
  [SMALL_STATE(613)] = 46335,
  [SMALL_STATE(614)] = 46388,
  [SMALL_STATE(615)] = 46441,
  [SMALL_STATE(616)] = 46518,
  [SMALL_STATE(617)] = 46595,
  [SMALL_STATE(618)] = 46670,
  [SMALL_STATE(619)] = 46747,
  [SMALL_STATE(620)] = 46792,
  [SMALL_STATE(621)] = 46869,
  [SMALL_STATE(622)] = 46946,
  [SMALL_STATE(623)] = 47020,
  [SMALL_STATE(624)] = 47094,
  [SMALL_STATE(625)] = 47168,
  [SMALL_STATE(626)] = 47242,
  [SMALL_STATE(627)] = 47316,
  [SMALL_STATE(628)] = 47390,
  [SMALL_STATE(629)] = 47464,
  [SMALL_STATE(630)] = 47538,
  [SMALL_STATE(631)] = 47596,
  [SMALL_STATE(632)] = 47659,
  [SMALL_STATE(633)] = 47698,
  [SMALL_STATE(634)] = 47769,
  [SMALL_STATE(635)] = 47840,
  [SMALL_STATE(636)] = 47879,
  [SMALL_STATE(637)] = 47918,
  [SMALL_STATE(638)] = 47989,
  [SMALL_STATE(639)] = 48052,
  [SMALL_STATE(640)] = 48091,
  [SMALL_STATE(641)] = 48130,
  [SMALL_STATE(642)] = 48201,
  [SMALL_STATE(643)] = 48240,
  [SMALL_STATE(644)] = 48311,
  [SMALL_STATE(645)] = 48350,
  [SMALL_STATE(646)] = 48421,
  [SMALL_STATE(647)] = 48484,
  [SMALL_STATE(648)] = 48555,
  [SMALL_STATE(649)] = 48594,
  [SMALL_STATE(650)] = 48665,
  [SMALL_STATE(651)] = 48704,
  [SMALL_STATE(652)] = 48743,
  [SMALL_STATE(653)] = 48782,
  [SMALL_STATE(654)] = 48853,
  [SMALL_STATE(655)] = 48892,
  [SMALL_STATE(656)] = 48955,
  [SMALL_STATE(657)] = 48994,
  [SMALL_STATE(658)] = 49065,
  [SMALL_STATE(659)] = 49104,
  [SMALL_STATE(660)] = 49175,
  [SMALL_STATE(661)] = 49214,
  [SMALL_STATE(662)] = 49253,
  [SMALL_STATE(663)] = 49324,
  [SMALL_STATE(664)] = 49363,
  [SMALL_STATE(665)] = 49402,
  [SMALL_STATE(666)] = 49445,
  [SMALL_STATE(667)] = 49516,
  [SMALL_STATE(668)] = 49587,
  [SMALL_STATE(669)] = 49650,
  [SMALL_STATE(670)] = 49710,
  [SMALL_STATE(671)] = 49748,
  [SMALL_STATE(672)] = 49786,
  [SMALL_STATE(673)] = 49828,
  [SMALL_STATE(674)] = 49866,
  [SMALL_STATE(675)] = 49904,
  [SMALL_STATE(676)] = 49972,
  [SMALL_STATE(677)] = 50014,
  [SMALL_STATE(678)] = 50052,
  [SMALL_STATE(679)] = 50112,
  [SMALL_STATE(680)] = 50178,
  [SMALL_STATE(681)] = 50216,
  [SMALL_STATE(682)] = 50282,
  [SMALL_STATE(683)] = 50320,
  [SMALL_STATE(684)] = 50358,
  [SMALL_STATE(685)] = 50400,
  [SMALL_STATE(686)] = 50442,
  [SMALL_STATE(687)] = 50502,
  [SMALL_STATE(688)] = 50540,
  [SMALL_STATE(689)] = 50578,
  [SMALL_STATE(690)] = 50644,
  [SMALL_STATE(691)] = 50710,
  [SMALL_STATE(692)] = 50776,
  [SMALL_STATE(693)] = 50836,
  [SMALL_STATE(694)] = 50874,
  [SMALL_STATE(695)] = 50912,
  [SMALL_STATE(696)] = 50980,
  [SMALL_STATE(697)] = 51046,
  [SMALL_STATE(698)] = 51106,
  [SMALL_STATE(699)] = 51172,
  [SMALL_STATE(700)] = 51210,
  [SMALL_STATE(701)] = 51276,
  [SMALL_STATE(702)] = 51342,
  [SMALL_STATE(703)] = 51402,
  [SMALL_STATE(704)] = 51440,
  [SMALL_STATE(705)] = 51478,
  [SMALL_STATE(706)] = 51546,
  [SMALL_STATE(707)] = 51612,
  [SMALL_STATE(708)] = 51649,
  [SMALL_STATE(709)] = 51686,
  [SMALL_STATE(710)] = 51749,
  [SMALL_STATE(711)] = 51812,
  [SMALL_STATE(712)] = 51875,
  [SMALL_STATE(713)] = 51938,
  [SMALL_STATE(714)] = 52003,
  [SMALL_STATE(715)] = 52040,
  [SMALL_STATE(716)] = 52079,
  [SMALL_STATE(717)] = 52134,
  [SMALL_STATE(718)] = 52171,
  [SMALL_STATE(719)] = 52210,
  [SMALL_STATE(720)] = 52249,
  [SMALL_STATE(721)] = 52286,
  [SMALL_STATE(722)] = 52323,
  [SMALL_STATE(723)] = 52388,
  [SMALL_STATE(724)] = 52451,
  [SMALL_STATE(725)] = 52516,
  [SMALL_STATE(726)] = 52579,
  [SMALL_STATE(727)] = 52642,
  [SMALL_STATE(728)] = 52705,
  [SMALL_STATE(729)] = 52742,
  [SMALL_STATE(730)] = 52805,
  [SMALL_STATE(731)] = 52842,
  [SMALL_STATE(732)] = 52905,
  [SMALL_STATE(733)] = 52960,
  [SMALL_STATE(734)] = 53015,
  [SMALL_STATE(735)] = 53051,
  [SMALL_STATE(736)] = 53105,
  [SMALL_STATE(737)] = 53159,
  [SMALL_STATE(738)] = 53213,
  [SMALL_STATE(739)] = 53267,
  [SMALL_STATE(740)] = 53321,
  [SMALL_STATE(741)] = 53357,
  [SMALL_STATE(742)] = 53411,
  [SMALL_STATE(743)] = 53465,
  [SMALL_STATE(744)] = 53525,
  [SMALL_STATE(745)] = 53579,
  [SMALL_STATE(746)] = 53639,
  [SMALL_STATE(747)] = 53675,
  [SMALL_STATE(748)] = 53729,
  [SMALL_STATE(749)] = 53783,
  [SMALL_STATE(750)] = 53819,
  [SMALL_STATE(751)] = 53859,
  [SMALL_STATE(752)] = 53911,
  [SMALL_STATE(753)] = 53961,
  [SMALL_STATE(754)] = 54015,
  [SMALL_STATE(755)] = 54063,
  [SMALL_STATE(756)] = 54109,
  [SMALL_STATE(757)] = 54153,
  [SMALL_STATE(758)] = 54207,
  [SMALL_STATE(759)] = 54261,
  [SMALL_STATE(760)] = 54297,
  [SMALL_STATE(761)] = 54357,
  [SMALL_STATE(762)] = 54417,
  [SMALL_STATE(763)] = 54471,
  [SMALL_STATE(764)] = 54525,
  [SMALL_STATE(765)] = 54561,
  [SMALL_STATE(766)] = 54597,
  [SMALL_STATE(767)] = 54633,
  [SMALL_STATE(768)] = 54669,
  [SMALL_STATE(769)] = 54705,
  [SMALL_STATE(770)] = 54759,
  [SMALL_STATE(771)] = 54795,
  [SMALL_STATE(772)] = 54849,
  [SMALL_STATE(773)] = 54885,
  [SMALL_STATE(774)] = 54945,
  [SMALL_STATE(775)] = 54981,
  [SMALL_STATE(776)] = 55035,
  [SMALL_STATE(777)] = 55071,
  [SMALL_STATE(778)] = 55107,
  [SMALL_STATE(779)] = 55143,
  [SMALL_STATE(780)] = 55203,
  [SMALL_STATE(781)] = 55263,
  [SMALL_STATE(782)] = 55323,
  [SMALL_STATE(783)] = 55359,
  [SMALL_STATE(784)] = 55413,
  [SMALL_STATE(785)] = 55449,
  [SMALL_STATE(786)] = 55509,
  [SMALL_STATE(787)] = 55545,
  [SMALL_STATE(788)] = 55581,
  [SMALL_STATE(789)] = 55641,
  [SMALL_STATE(790)] = 55695,
  [SMALL_STATE(791)] = 55755,
  [SMALL_STATE(792)] = 55809,
  [SMALL_STATE(793)] = 55863,
  [SMALL_STATE(794)] = 55917,
  [SMALL_STATE(795)] = 55971,
  [SMALL_STATE(796)] = 56031,
  [SMALL_STATE(797)] = 56085,
  [SMALL_STATE(798)] = 56145,
  [SMALL_STATE(799)] = 56202,
  [SMALL_STATE(800)] = 56259,
  [SMALL_STATE(801)] = 56316,
  [SMALL_STATE(802)] = 56373,
  [SMALL_STATE(803)] = 56430,
  [SMALL_STATE(804)] = 56487,
  [SMALL_STATE(805)] = 56544,
  [SMALL_STATE(806)] = 56601,
  [SMALL_STATE(807)] = 56658,
  [SMALL_STATE(808)] = 56715,
  [SMALL_STATE(809)] = 56772,
  [SMALL_STATE(810)] = 56806,
  [SMALL_STATE(811)] = 56838,
  [SMALL_STATE(812)] = 56872,
  [SMALL_STATE(813)] = 56906,
  [SMALL_STATE(814)] = 56940,
  [SMALL_STATE(815)] = 56987,
  [SMALL_STATE(816)] = 57034,
  [SMALL_STATE(817)] = 57081,
  [SMALL_STATE(818)] = 57128,
  [SMALL_STATE(819)] = 57175,
  [SMALL_STATE(820)] = 57222,
  [SMALL_STATE(821)] = 57266,
  [SMALL_STATE(822)] = 57310,
  [SMALL_STATE(823)] = 57354,
  [SMALL_STATE(824)] = 57398,
  [SMALL_STATE(825)] = 57442,
  [SMALL_STATE(826)] = 57468,
  [SMALL_STATE(827)] = 57498,
  [SMALL_STATE(828)] = 57526,
  [SMALL_STATE(829)] = 57570,
  [SMALL_STATE(830)] = 57614,
  [SMALL_STATE(831)] = 57658,
  [SMALL_STATE(832)] = 57702,
  [SMALL_STATE(833)] = 57746,
  [SMALL_STATE(834)] = 57789,
  [SMALL_STATE(835)] = 57830,
  [SMALL_STATE(836)] = 57859,
  [SMALL_STATE(837)] = 57900,
  [SMALL_STATE(838)] = 57941,
  [SMALL_STATE(839)] = 57982,
  [SMALL_STATE(840)] = 58023,
  [SMALL_STATE(841)] = 58064,
  [SMALL_STATE(842)] = 58105,
  [SMALL_STATE(843)] = 58146,
  [SMALL_STATE(844)] = 58187,
  [SMALL_STATE(845)] = 58228,
  [SMALL_STATE(846)] = 58269,
  [SMALL_STATE(847)] = 58312,
  [SMALL_STATE(848)] = 58355,
  [SMALL_STATE(849)] = 58380,
  [SMALL_STATE(850)] = 58418,
  [SMALL_STATE(851)] = 58456,
  [SMALL_STATE(852)] = 58480,
  [SMALL_STATE(853)] = 58508,
  [SMALL_STATE(854)] = 58532,
  [SMALL_STATE(855)] = 58570,
  [SMALL_STATE(856)] = 58608,
  [SMALL_STATE(857)] = 58646,
  [SMALL_STATE(858)] = 58684,
  [SMALL_STATE(859)] = 58708,
  [SMALL_STATE(860)] = 58746,
  [SMALL_STATE(861)] = 58786,
  [SMALL_STATE(862)] = 58824,
  [SMALL_STATE(863)] = 58864,
  [SMALL_STATE(864)] = 58902,
  [SMALL_STATE(865)] = 58942,
  [SMALL_STATE(866)] = 58980,
  [SMALL_STATE(867)] = 59004,
  [SMALL_STATE(868)] = 59042,
  [SMALL_STATE(869)] = 59080,
  [SMALL_STATE(870)] = 59118,
  [SMALL_STATE(871)] = 59156,
  [SMALL_STATE(872)] = 59182,
  [SMALL_STATE(873)] = 59220,
  [SMALL_STATE(874)] = 59260,
  [SMALL_STATE(875)] = 59284,
  [SMALL_STATE(876)] = 59308,
  [SMALL_STATE(877)] = 59332,
  [SMALL_STATE(878)] = 59356,
  [SMALL_STATE(879)] = 59394,
  [SMALL_STATE(880)] = 59420,
  [SMALL_STATE(881)] = 59458,
  [SMALL_STATE(882)] = 59498,
  [SMALL_STATE(883)] = 59538,
  [SMALL_STATE(884)] = 59576,
  [SMALL_STATE(885)] = 59600,
  [SMALL_STATE(886)] = 59638,
  [SMALL_STATE(887)] = 59676,
  [SMALL_STATE(888)] = 59704,
  [SMALL_STATE(889)] = 59742,
  [SMALL_STATE(890)] = 59780,
  [SMALL_STATE(891)] = 59818,
  [SMALL_STATE(892)] = 59842,
  [SMALL_STATE(893)] = 59866,
  [SMALL_STATE(894)] = 59904,
  [SMALL_STATE(895)] = 59928,
  [SMALL_STATE(896)] = 59966,
  [SMALL_STATE(897)] = 60004,
  [SMALL_STATE(898)] = 60030,
  [SMALL_STATE(899)] = 60056,
  [SMALL_STATE(900)] = 60082,
  [SMALL_STATE(901)] = 60122,
  [SMALL_STATE(902)] = 60160,
  [SMALL_STATE(903)] = 60187,
  [SMALL_STATE(904)] = 60210,
  [SMALL_STATE(905)] = 60233,
  [SMALL_STATE(906)] = 60256,
  [SMALL_STATE(907)] = 60279,
  [SMALL_STATE(908)] = 60302,
  [SMALL_STATE(909)] = 60329,
  [SMALL_STATE(910)] = 60358,
  [SMALL_STATE(911)] = 60381,
  [SMALL_STATE(912)] = 60412,
  [SMALL_STATE(913)] = 60435,
  [SMALL_STATE(914)] = 60458,
  [SMALL_STATE(915)] = 60481,
  [SMALL_STATE(916)] = 60504,
  [SMALL_STATE(917)] = 60527,
  [SMALL_STATE(918)] = 60550,
  [SMALL_STATE(919)] = 60587,
  [SMALL_STATE(920)] = 60624,
  [SMALL_STATE(921)] = 60647,
  [SMALL_STATE(922)] = 60670,
  [SMALL_STATE(923)] = 60693,
  [SMALL_STATE(924)] = 60716,
  [SMALL_STATE(925)] = 60739,
  [SMALL_STATE(926)] = 60762,
  [SMALL_STATE(927)] = 60785,
  [SMALL_STATE(928)] = 60812,
  [SMALL_STATE(929)] = 60839,
  [SMALL_STATE(930)] = 60876,
  [SMALL_STATE(931)] = 60903,
  [SMALL_STATE(932)] = 60932,
  [SMALL_STATE(933)] = 60955,
  [SMALL_STATE(934)] = 60986,
  [SMALL_STATE(935)] = 61009,
  [SMALL_STATE(936)] = 61032,
  [SMALL_STATE(937)] = 61055,
  [SMALL_STATE(938)] = 61078,
  [SMALL_STATE(939)] = 61111,
  [SMALL_STATE(940)] = 61134,
  [SMALL_STATE(941)] = 61157,
  [SMALL_STATE(942)] = 61190,
  [SMALL_STATE(943)] = 61213,
  [SMALL_STATE(944)] = 61236,
  [SMALL_STATE(945)] = 61273,
  [SMALL_STATE(946)] = 61300,
  [SMALL_STATE(947)] = 61324,
  [SMALL_STATE(948)] = 61345,
  [SMALL_STATE(949)] = 61370,
  [SMALL_STATE(950)] = 61391,
  [SMALL_STATE(951)] = 61416,
  [SMALL_STATE(952)] = 61437,
  [SMALL_STATE(953)] = 61478,
  [SMALL_STATE(954)] = 61499,
  [SMALL_STATE(955)] = 61540,
  [SMALL_STATE(956)] = 61565,
  [SMALL_STATE(957)] = 61586,
  [SMALL_STATE(958)] = 61607,
  [SMALL_STATE(959)] = 61632,
  [SMALL_STATE(960)] = 61657,
  [SMALL_STATE(961)] = 61678,
  [SMALL_STATE(962)] = 61699,
  [SMALL_STATE(963)] = 61740,
  [SMALL_STATE(964)] = 61761,
  [SMALL_STATE(965)] = 61802,
  [SMALL_STATE(966)] = 61823,
  [SMALL_STATE(967)] = 61864,
  [SMALL_STATE(968)] = 61905,
  [SMALL_STATE(969)] = 61930,
  [SMALL_STATE(970)] = 61950,
  [SMALL_STATE(971)] = 61972,
  [SMALL_STATE(972)] = 61994,
  [SMALL_STATE(973)] = 62016,
  [SMALL_STATE(974)] = 62054,
  [SMALL_STATE(975)] = 62088,
  [SMALL_STATE(976)] = 62122,
  [SMALL_STATE(977)] = 62144,
  [SMALL_STATE(978)] = 62164,
  [SMALL_STATE(979)] = 62184,
  [SMALL_STATE(980)] = 62204,
  [SMALL_STATE(981)] = 62226,
  [SMALL_STATE(982)] = 62245,
  [SMALL_STATE(983)] = 62264,
  [SMALL_STATE(984)] = 62283,
  [SMALL_STATE(985)] = 62302,
  [SMALL_STATE(986)] = 62321,
  [SMALL_STATE(987)] = 62340,
  [SMALL_STATE(988)] = 62359,
  [SMALL_STATE(989)] = 62378,
  [SMALL_STATE(990)] = 62397,
  [SMALL_STATE(991)] = 62416,
  [SMALL_STATE(992)] = 62435,
  [SMALL_STATE(993)] = 62454,
  [SMALL_STATE(994)] = 62473,
  [SMALL_STATE(995)] = 62492,
  [SMALL_STATE(996)] = 62511,
  [SMALL_STATE(997)] = 62530,
  [SMALL_STATE(998)] = 62549,
  [SMALL_STATE(999)] = 62568,
  [SMALL_STATE(1000)] = 62587,
  [SMALL_STATE(1001)] = 62606,
  [SMALL_STATE(1002)] = 62625,
  [SMALL_STATE(1003)] = 62644,
  [SMALL_STATE(1004)] = 62671,
  [SMALL_STATE(1005)] = 62690,
  [SMALL_STATE(1006)] = 62709,
  [SMALL_STATE(1007)] = 62728,
  [SMALL_STATE(1008)] = 62747,
  [SMALL_STATE(1009)] = 62766,
  [SMALL_STATE(1010)] = 62785,
  [SMALL_STATE(1011)] = 62806,
  [SMALL_STATE(1012)] = 62829,
  [SMALL_STATE(1013)] = 62848,
  [SMALL_STATE(1014)] = 62867,
  [SMALL_STATE(1015)] = 62886,
  [SMALL_STATE(1016)] = 62907,
  [SMALL_STATE(1017)] = 62926,
  [SMALL_STATE(1018)] = 62946,
  [SMALL_STATE(1019)] = 62978,
  [SMALL_STATE(1020)] = 62996,
  [SMALL_STATE(1021)] = 63028,
  [SMALL_STATE(1022)] = 63060,
  [SMALL_STATE(1023)] = 63078,
  [SMALL_STATE(1024)] = 63096,
  [SMALL_STATE(1025)] = 63125,
  [SMALL_STATE(1026)] = 63154,
  [SMALL_STATE(1027)] = 63183,
  [SMALL_STATE(1028)] = 63212,
  [SMALL_STATE(1029)] = 63241,
  [SMALL_STATE(1030)] = 63270,
  [SMALL_STATE(1031)] = 63287,
  [SMALL_STATE(1032)] = 63316,
  [SMALL_STATE(1033)] = 63340,
  [SMALL_STATE(1034)] = 63364,
  [SMALL_STATE(1035)] = 63386,
  [SMALL_STATE(1036)] = 63408,
  [SMALL_STATE(1037)] = 63430,
  [SMALL_STATE(1038)] = 63452,
  [SMALL_STATE(1039)] = 63474,
  [SMALL_STATE(1040)] = 63496,
  [SMALL_STATE(1041)] = 63518,
  [SMALL_STATE(1042)] = 63544,
  [SMALL_STATE(1043)] = 63564,
  [SMALL_STATE(1044)] = 63588,
  [SMALL_STATE(1045)] = 63610,
  [SMALL_STATE(1046)] = 63632,
  [SMALL_STATE(1047)] = 63654,
  [SMALL_STATE(1048)] = 63678,
  [SMALL_STATE(1049)] = 63700,
  [SMALL_STATE(1050)] = 63724,
  [SMALL_STATE(1051)] = 63748,
  [SMALL_STATE(1052)] = 63770,
  [SMALL_STATE(1053)] = 63790,
  [SMALL_STATE(1054)] = 63812,
  [SMALL_STATE(1055)] = 63836,
  [SMALL_STATE(1056)] = 63858,
  [SMALL_STATE(1057)] = 63880,
  [SMALL_STATE(1058)] = 63904,
  [SMALL_STATE(1059)] = 63926,
  [SMALL_STATE(1060)] = 63948,
  [SMALL_STATE(1061)] = 63970,
  [SMALL_STATE(1062)] = 63994,
  [SMALL_STATE(1063)] = 64018,
  [SMALL_STATE(1064)] = 64036,
  [SMALL_STATE(1065)] = 64058,
  [SMALL_STATE(1066)] = 64082,
  [SMALL_STATE(1067)] = 64106,
  [SMALL_STATE(1068)] = 64128,
  [SMALL_STATE(1069)] = 64150,
  [SMALL_STATE(1070)] = 64169,
  [SMALL_STATE(1071)] = 64188,
  [SMALL_STATE(1072)] = 64209,
  [SMALL_STATE(1073)] = 64230,
  [SMALL_STATE(1074)] = 64253,
  [SMALL_STATE(1075)] = 64274,
  [SMALL_STATE(1076)] = 64293,
  [SMALL_STATE(1077)] = 64316,
  [SMALL_STATE(1078)] = 64335,
  [SMALL_STATE(1079)] = 64356,
  [SMALL_STATE(1080)] = 64379,
  [SMALL_STATE(1081)] = 64400,
  [SMALL_STATE(1082)] = 64423,
  [SMALL_STATE(1083)] = 64444,
  [SMALL_STATE(1084)] = 64467,
  [SMALL_STATE(1085)] = 64488,
  [SMALL_STATE(1086)] = 64507,
  [SMALL_STATE(1087)] = 64530,
  [SMALL_STATE(1088)] = 64549,
  [SMALL_STATE(1089)] = 64570,
  [SMALL_STATE(1090)] = 64589,
  [SMALL_STATE(1091)] = 64608,
  [SMALL_STATE(1092)] = 64629,
  [SMALL_STATE(1093)] = 64648,
  [SMALL_STATE(1094)] = 64668,
  [SMALL_STATE(1095)] = 64688,
  [SMALL_STATE(1096)] = 64706,
  [SMALL_STATE(1097)] = 64724,
  [SMALL_STATE(1098)] = 64744,
  [SMALL_STATE(1099)] = 64760,
  [SMALL_STATE(1100)] = 64776,
  [SMALL_STATE(1101)] = 64794,
  [SMALL_STATE(1102)] = 64812,
  [SMALL_STATE(1103)] = 64830,
  [SMALL_STATE(1104)] = 64848,
  [SMALL_STATE(1105)] = 64866,
  [SMALL_STATE(1106)] = 64886,
  [SMALL_STATE(1107)] = 64906,
  [SMALL_STATE(1108)] = 64924,
  [SMALL_STATE(1109)] = 64942,
  [SMALL_STATE(1110)] = 64962,
  [SMALL_STATE(1111)] = 64978,
  [SMALL_STATE(1112)] = 64996,
  [SMALL_STATE(1113)] = 65014,
  [SMALL_STATE(1114)] = 65032,
  [SMALL_STATE(1115)] = 65046,
  [SMALL_STATE(1116)] = 65064,
  [SMALL_STATE(1117)] = 65082,
  [SMALL_STATE(1118)] = 65102,
  [SMALL_STATE(1119)] = 65118,
  [SMALL_STATE(1120)] = 65136,
  [SMALL_STATE(1121)] = 65154,
  [SMALL_STATE(1122)] = 65174,
  [SMALL_STATE(1123)] = 65194,
  [SMALL_STATE(1124)] = 65210,
  [SMALL_STATE(1125)] = 65228,
  [SMALL_STATE(1126)] = 65248,
  [SMALL_STATE(1127)] = 65268,
  [SMALL_STATE(1128)] = 65288,
  [SMALL_STATE(1129)] = 65306,
  [SMALL_STATE(1130)] = 65326,
  [SMALL_STATE(1131)] = 65340,
  [SMALL_STATE(1132)] = 65358,
  [SMALL_STATE(1133)] = 65376,
  [SMALL_STATE(1134)] = 65394,
  [SMALL_STATE(1135)] = 65412,
  [SMALL_STATE(1136)] = 65428,
  [SMALL_STATE(1137)] = 65446,
  [SMALL_STATE(1138)] = 65464,
  [SMALL_STATE(1139)] = 65484,
  [SMALL_STATE(1140)] = 65502,
  [SMALL_STATE(1141)] = 65520,
  [SMALL_STATE(1142)] = 65540,
  [SMALL_STATE(1143)] = 65560,
  [SMALL_STATE(1144)] = 65578,
  [SMALL_STATE(1145)] = 65598,
  [SMALL_STATE(1146)] = 65615,
  [SMALL_STATE(1147)] = 65632,
  [SMALL_STATE(1148)] = 65645,
  [SMALL_STATE(1149)] = 65662,
  [SMALL_STATE(1150)] = 65679,
  [SMALL_STATE(1151)] = 65696,
  [SMALL_STATE(1152)] = 65713,
  [SMALL_STATE(1153)] = 65730,
  [SMALL_STATE(1154)] = 65747,
  [SMALL_STATE(1155)] = 65764,
  [SMALL_STATE(1156)] = 65781,
  [SMALL_STATE(1157)] = 65794,
  [SMALL_STATE(1158)] = 65811,
  [SMALL_STATE(1159)] = 65828,
  [SMALL_STATE(1160)] = 65845,
  [SMALL_STATE(1161)] = 65858,
  [SMALL_STATE(1162)] = 65875,
  [SMALL_STATE(1163)] = 65892,
  [SMALL_STATE(1164)] = 65909,
  [SMALL_STATE(1165)] = 65926,
  [SMALL_STATE(1166)] = 65943,
  [SMALL_STATE(1167)] = 65958,
  [SMALL_STATE(1168)] = 65975,
  [SMALL_STATE(1169)] = 65992,
  [SMALL_STATE(1170)] = 66009,
  [SMALL_STATE(1171)] = 66026,
  [SMALL_STATE(1172)] = 66039,
  [SMALL_STATE(1173)] = 66056,
  [SMALL_STATE(1174)] = 66069,
  [SMALL_STATE(1175)] = 66084,
  [SMALL_STATE(1176)] = 66101,
  [SMALL_STATE(1177)] = 66118,
  [SMALL_STATE(1178)] = 66135,
  [SMALL_STATE(1179)] = 66152,
  [SMALL_STATE(1180)] = 66169,
  [SMALL_STATE(1181)] = 66186,
  [SMALL_STATE(1182)] = 66203,
  [SMALL_STATE(1183)] = 66220,
  [SMALL_STATE(1184)] = 66237,
  [SMALL_STATE(1185)] = 66250,
  [SMALL_STATE(1186)] = 66267,
  [SMALL_STATE(1187)] = 66284,
  [SMALL_STATE(1188)] = 66301,
  [SMALL_STATE(1189)] = 66318,
  [SMALL_STATE(1190)] = 66335,
  [SMALL_STATE(1191)] = 66348,
  [SMALL_STATE(1192)] = 66365,
  [SMALL_STATE(1193)] = 66378,
  [SMALL_STATE(1194)] = 66395,
  [SMALL_STATE(1195)] = 66410,
  [SMALL_STATE(1196)] = 66427,
  [SMALL_STATE(1197)] = 66444,
  [SMALL_STATE(1198)] = 66457,
  [SMALL_STATE(1199)] = 66470,
  [SMALL_STATE(1200)] = 66487,
  [SMALL_STATE(1201)] = 66504,
  [SMALL_STATE(1202)] = 66521,
  [SMALL_STATE(1203)] = 66534,
  [SMALL_STATE(1204)] = 66551,
  [SMALL_STATE(1205)] = 66568,
  [SMALL_STATE(1206)] = 66585,
  [SMALL_STATE(1207)] = 66598,
  [SMALL_STATE(1208)] = 66611,
  [SMALL_STATE(1209)] = 66628,
  [SMALL_STATE(1210)] = 66645,
  [SMALL_STATE(1211)] = 66660,
  [SMALL_STATE(1212)] = 66677,
  [SMALL_STATE(1213)] = 66694,
  [SMALL_STATE(1214)] = 66711,
  [SMALL_STATE(1215)] = 66728,
  [SMALL_STATE(1216)] = 66745,
  [SMALL_STATE(1217)] = 66758,
  [SMALL_STATE(1218)] = 66775,
  [SMALL_STATE(1219)] = 66792,
  [SMALL_STATE(1220)] = 66809,
  [SMALL_STATE(1221)] = 66826,
  [SMALL_STATE(1222)] = 66843,
  [SMALL_STATE(1223)] = 66860,
  [SMALL_STATE(1224)] = 66877,
  [SMALL_STATE(1225)] = 66894,
  [SMALL_STATE(1226)] = 66911,
  [SMALL_STATE(1227)] = 66928,
  [SMALL_STATE(1228)] = 66943,
  [SMALL_STATE(1229)] = 66960,
  [SMALL_STATE(1230)] = 66975,
  [SMALL_STATE(1231)] = 66992,
  [SMALL_STATE(1232)] = 67009,
  [SMALL_STATE(1233)] = 67022,
  [SMALL_STATE(1234)] = 67039,
  [SMALL_STATE(1235)] = 67056,
  [SMALL_STATE(1236)] = 67069,
  [SMALL_STATE(1237)] = 67082,
  [SMALL_STATE(1238)] = 67095,
  [SMALL_STATE(1239)] = 67112,
  [SMALL_STATE(1240)] = 67125,
  [SMALL_STATE(1241)] = 67142,
  [SMALL_STATE(1242)] = 67159,
  [SMALL_STATE(1243)] = 67176,
  [SMALL_STATE(1244)] = 67193,
  [SMALL_STATE(1245)] = 67210,
  [SMALL_STATE(1246)] = 67227,
  [SMALL_STATE(1247)] = 67244,
  [SMALL_STATE(1248)] = 67261,
  [SMALL_STATE(1249)] = 67278,
  [SMALL_STATE(1250)] = 67295,
  [SMALL_STATE(1251)] = 67312,
  [SMALL_STATE(1252)] = 67329,
  [SMALL_STATE(1253)] = 67346,
  [SMALL_STATE(1254)] = 67361,
  [SMALL_STATE(1255)] = 67378,
  [SMALL_STATE(1256)] = 67395,
  [SMALL_STATE(1257)] = 67408,
  [SMALL_STATE(1258)] = 67425,
  [SMALL_STATE(1259)] = 67442,
  [SMALL_STATE(1260)] = 67459,
  [SMALL_STATE(1261)] = 67476,
  [SMALL_STATE(1262)] = 67493,
  [SMALL_STATE(1263)] = 67510,
  [SMALL_STATE(1264)] = 67527,
  [SMALL_STATE(1265)] = 67544,
  [SMALL_STATE(1266)] = 67561,
  [SMALL_STATE(1267)] = 67578,
  [SMALL_STATE(1268)] = 67595,
  [SMALL_STATE(1269)] = 67612,
  [SMALL_STATE(1270)] = 67629,
  [SMALL_STATE(1271)] = 67646,
  [SMALL_STATE(1272)] = 67663,
  [SMALL_STATE(1273)] = 67676,
  [SMALL_STATE(1274)] = 67693,
  [SMALL_STATE(1275)] = 67706,
  [SMALL_STATE(1276)] = 67723,
  [SMALL_STATE(1277)] = 67740,
  [SMALL_STATE(1278)] = 67757,
  [SMALL_STATE(1279)] = 67770,
  [SMALL_STATE(1280)] = 67787,
  [SMALL_STATE(1281)] = 67804,
  [SMALL_STATE(1282)] = 67817,
  [SMALL_STATE(1283)] = 67834,
  [SMALL_STATE(1284)] = 67851,
  [SMALL_STATE(1285)] = 67868,
  [SMALL_STATE(1286)] = 67885,
  [SMALL_STATE(1287)] = 67898,
  [SMALL_STATE(1288)] = 67915,
  [SMALL_STATE(1289)] = 67932,
  [SMALL_STATE(1290)] = 67949,
  [SMALL_STATE(1291)] = 67966,
  [SMALL_STATE(1292)] = 67983,
  [SMALL_STATE(1293)] = 67996,
  [SMALL_STATE(1294)] = 68013,
  [SMALL_STATE(1295)] = 68030,
  [SMALL_STATE(1296)] = 68047,
  [SMALL_STATE(1297)] = 68064,
  [SMALL_STATE(1298)] = 68081,
  [SMALL_STATE(1299)] = 68094,
  [SMALL_STATE(1300)] = 68111,
  [SMALL_STATE(1301)] = 68124,
  [SMALL_STATE(1302)] = 68141,
  [SMALL_STATE(1303)] = 68158,
  [SMALL_STATE(1304)] = 68175,
  [SMALL_STATE(1305)] = 68192,
  [SMALL_STATE(1306)] = 68209,
  [SMALL_STATE(1307)] = 68226,
  [SMALL_STATE(1308)] = 68243,
  [SMALL_STATE(1309)] = 68260,
  [SMALL_STATE(1310)] = 68277,
  [SMALL_STATE(1311)] = 68289,
  [SMALL_STATE(1312)] = 68303,
  [SMALL_STATE(1313)] = 68315,
  [SMALL_STATE(1314)] = 68327,
  [SMALL_STATE(1315)] = 68339,
  [SMALL_STATE(1316)] = 68353,
  [SMALL_STATE(1317)] = 68365,
  [SMALL_STATE(1318)] = 68379,
  [SMALL_STATE(1319)] = 68393,
  [SMALL_STATE(1320)] = 68407,
  [SMALL_STATE(1321)] = 68419,
  [SMALL_STATE(1322)] = 68433,
  [SMALL_STATE(1323)] = 68447,
  [SMALL_STATE(1324)] = 68461,
  [SMALL_STATE(1325)] = 68475,
  [SMALL_STATE(1326)] = 68487,
  [SMALL_STATE(1327)] = 68499,
  [SMALL_STATE(1328)] = 68513,
  [SMALL_STATE(1329)] = 68527,
  [SMALL_STATE(1330)] = 68539,
  [SMALL_STATE(1331)] = 68553,
  [SMALL_STATE(1332)] = 68567,
  [SMALL_STATE(1333)] = 68581,
  [SMALL_STATE(1334)] = 68593,
  [SMALL_STATE(1335)] = 68605,
  [SMALL_STATE(1336)] = 68617,
  [SMALL_STATE(1337)] = 68629,
  [SMALL_STATE(1338)] = 68643,
  [SMALL_STATE(1339)] = 68657,
  [SMALL_STATE(1340)] = 68669,
  [SMALL_STATE(1341)] = 68683,
  [SMALL_STATE(1342)] = 68697,
  [SMALL_STATE(1343)] = 68711,
  [SMALL_STATE(1344)] = 68725,
  [SMALL_STATE(1345)] = 68739,
  [SMALL_STATE(1346)] = 68753,
  [SMALL_STATE(1347)] = 68765,
  [SMALL_STATE(1348)] = 68779,
  [SMALL_STATE(1349)] = 68793,
  [SMALL_STATE(1350)] = 68807,
  [SMALL_STATE(1351)] = 68821,
  [SMALL_STATE(1352)] = 68833,
  [SMALL_STATE(1353)] = 68847,
  [SMALL_STATE(1354)] = 68861,
  [SMALL_STATE(1355)] = 68875,
  [SMALL_STATE(1356)] = 68887,
  [SMALL_STATE(1357)] = 68899,
  [SMALL_STATE(1358)] = 68913,
  [SMALL_STATE(1359)] = 68925,
  [SMALL_STATE(1360)] = 68939,
  [SMALL_STATE(1361)] = 68951,
  [SMALL_STATE(1362)] = 68965,
  [SMALL_STATE(1363)] = 68977,
  [SMALL_STATE(1364)] = 68989,
  [SMALL_STATE(1365)] = 69003,
  [SMALL_STATE(1366)] = 69015,
  [SMALL_STATE(1367)] = 69029,
  [SMALL_STATE(1368)] = 69041,
  [SMALL_STATE(1369)] = 69055,
  [SMALL_STATE(1370)] = 69067,
  [SMALL_STATE(1371)] = 69081,
  [SMALL_STATE(1372)] = 69095,
  [SMALL_STATE(1373)] = 69107,
  [SMALL_STATE(1374)] = 69121,
  [SMALL_STATE(1375)] = 69135,
  [SMALL_STATE(1376)] = 69149,
  [SMALL_STATE(1377)] = 69163,
  [SMALL_STATE(1378)] = 69177,
  [SMALL_STATE(1379)] = 69191,
  [SMALL_STATE(1380)] = 69205,
  [SMALL_STATE(1381)] = 69219,
  [SMALL_STATE(1382)] = 69231,
  [SMALL_STATE(1383)] = 69243,
  [SMALL_STATE(1384)] = 69255,
  [SMALL_STATE(1385)] = 69269,
  [SMALL_STATE(1386)] = 69283,
  [SMALL_STATE(1387)] = 69297,
  [SMALL_STATE(1388)] = 69311,
  [SMALL_STATE(1389)] = 69323,
  [SMALL_STATE(1390)] = 69337,
  [SMALL_STATE(1391)] = 69351,
  [SMALL_STATE(1392)] = 69365,
  [SMALL_STATE(1393)] = 69379,
  [SMALL_STATE(1394)] = 69393,
  [SMALL_STATE(1395)] = 69407,
  [SMALL_STATE(1396)] = 69421,
  [SMALL_STATE(1397)] = 69433,
  [SMALL_STATE(1398)] = 69447,
  [SMALL_STATE(1399)] = 69459,
  [SMALL_STATE(1400)] = 69473,
  [SMALL_STATE(1401)] = 69487,
  [SMALL_STATE(1402)] = 69499,
  [SMALL_STATE(1403)] = 69513,
  [SMALL_STATE(1404)] = 69525,
  [SMALL_STATE(1405)] = 69537,
  [SMALL_STATE(1406)] = 69551,
  [SMALL_STATE(1407)] = 69565,
  [SMALL_STATE(1408)] = 69577,
  [SMALL_STATE(1409)] = 69589,
  [SMALL_STATE(1410)] = 69603,
  [SMALL_STATE(1411)] = 69617,
  [SMALL_STATE(1412)] = 69631,
  [SMALL_STATE(1413)] = 69643,
  [SMALL_STATE(1414)] = 69655,
  [SMALL_STATE(1415)] = 69669,
  [SMALL_STATE(1416)] = 69683,
  [SMALL_STATE(1417)] = 69695,
  [SMALL_STATE(1418)] = 69709,
  [SMALL_STATE(1419)] = 69721,
  [SMALL_STATE(1420)] = 69735,
  [SMALL_STATE(1421)] = 69749,
  [SMALL_STATE(1422)] = 69763,
  [SMALL_STATE(1423)] = 69775,
  [SMALL_STATE(1424)] = 69789,
  [SMALL_STATE(1425)] = 69803,
  [SMALL_STATE(1426)] = 69815,
  [SMALL_STATE(1427)] = 69827,
  [SMALL_STATE(1428)] = 69841,
  [SMALL_STATE(1429)] = 69855,
  [SMALL_STATE(1430)] = 69867,
  [SMALL_STATE(1431)] = 69879,
  [SMALL_STATE(1432)] = 69891,
  [SMALL_STATE(1433)] = 69903,
  [SMALL_STATE(1434)] = 69915,
  [SMALL_STATE(1435)] = 69927,
  [SMALL_STATE(1436)] = 69941,
  [SMALL_STATE(1437)] = 69955,
  [SMALL_STATE(1438)] = 69967,
  [SMALL_STATE(1439)] = 69981,
  [SMALL_STATE(1440)] = 69995,
  [SMALL_STATE(1441)] = 70007,
  [SMALL_STATE(1442)] = 70021,
  [SMALL_STATE(1443)] = 70035,
  [SMALL_STATE(1444)] = 70049,
  [SMALL_STATE(1445)] = 70061,
  [SMALL_STATE(1446)] = 70075,
  [SMALL_STATE(1447)] = 70089,
  [SMALL_STATE(1448)] = 70100,
  [SMALL_STATE(1449)] = 70111,
  [SMALL_STATE(1450)] = 70122,
  [SMALL_STATE(1451)] = 70133,
  [SMALL_STATE(1452)] = 70144,
  [SMALL_STATE(1453)] = 70155,
  [SMALL_STATE(1454)] = 70166,
  [SMALL_STATE(1455)] = 70177,
  [SMALL_STATE(1456)] = 70188,
  [SMALL_STATE(1457)] = 70199,
  [SMALL_STATE(1458)] = 70210,
  [SMALL_STATE(1459)] = 70221,
  [SMALL_STATE(1460)] = 70232,
  [SMALL_STATE(1461)] = 70243,
  [SMALL_STATE(1462)] = 70254,
  [SMALL_STATE(1463)] = 70265,
  [SMALL_STATE(1464)] = 70276,
  [SMALL_STATE(1465)] = 70287,
  [SMALL_STATE(1466)] = 70298,
  [SMALL_STATE(1467)] = 70309,
  [SMALL_STATE(1468)] = 70320,
  [SMALL_STATE(1469)] = 70331,
  [SMALL_STATE(1470)] = 70342,
  [SMALL_STATE(1471)] = 70353,
  [SMALL_STATE(1472)] = 70364,
  [SMALL_STATE(1473)] = 70375,
  [SMALL_STATE(1474)] = 70386,
  [SMALL_STATE(1475)] = 70397,
  [SMALL_STATE(1476)] = 70408,
  [SMALL_STATE(1477)] = 70419,
  [SMALL_STATE(1478)] = 70430,
  [SMALL_STATE(1479)] = 70441,
  [SMALL_STATE(1480)] = 70452,
  [SMALL_STATE(1481)] = 70463,
  [SMALL_STATE(1482)] = 70474,
  [SMALL_STATE(1483)] = 70485,
  [SMALL_STATE(1484)] = 70496,
  [SMALL_STATE(1485)] = 70507,
  [SMALL_STATE(1486)] = 70518,
  [SMALL_STATE(1487)] = 70529,
  [SMALL_STATE(1488)] = 70540,
  [SMALL_STATE(1489)] = 70551,
  [SMALL_STATE(1490)] = 70562,
  [SMALL_STATE(1491)] = 70573,
  [SMALL_STATE(1492)] = 70584,
  [SMALL_STATE(1493)] = 70595,
  [SMALL_STATE(1494)] = 70606,
  [SMALL_STATE(1495)] = 70617,
  [SMALL_STATE(1496)] = 70628,
  [SMALL_STATE(1497)] = 70639,
  [SMALL_STATE(1498)] = 70650,
  [SMALL_STATE(1499)] = 70661,
  [SMALL_STATE(1500)] = 70672,
  [SMALL_STATE(1501)] = 70683,
  [SMALL_STATE(1502)] = 70694,
  [SMALL_STATE(1503)] = 70705,
  [SMALL_STATE(1504)] = 70716,
  [SMALL_STATE(1505)] = 70727,
  [SMALL_STATE(1506)] = 70738,
  [SMALL_STATE(1507)] = 70749,
  [SMALL_STATE(1508)] = 70760,
  [SMALL_STATE(1509)] = 70771,
  [SMALL_STATE(1510)] = 70782,
  [SMALL_STATE(1511)] = 70793,
  [SMALL_STATE(1512)] = 70804,
  [SMALL_STATE(1513)] = 70815,
  [SMALL_STATE(1514)] = 70826,
  [SMALL_STATE(1515)] = 70837,
  [SMALL_STATE(1516)] = 70848,
  [SMALL_STATE(1517)] = 70859,
  [SMALL_STATE(1518)] = 70870,
  [SMALL_STATE(1519)] = 70881,
  [SMALL_STATE(1520)] = 70892,
  [SMALL_STATE(1521)] = 70903,
  [SMALL_STATE(1522)] = 70914,
  [SMALL_STATE(1523)] = 70925,
  [SMALL_STATE(1524)] = 70936,
  [SMALL_STATE(1525)] = 70947,
  [SMALL_STATE(1526)] = 70958,
  [SMALL_STATE(1527)] = 70969,
  [SMALL_STATE(1528)] = 70980,
  [SMALL_STATE(1529)] = 70991,
  [SMALL_STATE(1530)] = 71002,
  [SMALL_STATE(1531)] = 71013,
  [SMALL_STATE(1532)] = 71024,
  [SMALL_STATE(1533)] = 71035,
  [SMALL_STATE(1534)] = 71046,
  [SMALL_STATE(1535)] = 71057,
  [SMALL_STATE(1536)] = 71068,
  [SMALL_STATE(1537)] = 71079,
  [SMALL_STATE(1538)] = 71090,
  [SMALL_STATE(1539)] = 71101,
  [SMALL_STATE(1540)] = 71112,
  [SMALL_STATE(1541)] = 71123,
  [SMALL_STATE(1542)] = 71134,
  [SMALL_STATE(1543)] = 71145,
  [SMALL_STATE(1544)] = 71156,
  [SMALL_STATE(1545)] = 71167,
  [SMALL_STATE(1546)] = 71178,
  [SMALL_STATE(1547)] = 71189,
  [SMALL_STATE(1548)] = 71200,
  [SMALL_STATE(1549)] = 71211,
  [SMALL_STATE(1550)] = 71222,
  [SMALL_STATE(1551)] = 71233,
  [SMALL_STATE(1552)] = 71244,
  [SMALL_STATE(1553)] = 71255,
  [SMALL_STATE(1554)] = 71266,
  [SMALL_STATE(1555)] = 71277,
  [SMALL_STATE(1556)] = 71288,
  [SMALL_STATE(1557)] = 71299,
  [SMALL_STATE(1558)] = 71310,
  [SMALL_STATE(1559)] = 71321,
  [SMALL_STATE(1560)] = 71332,
  [SMALL_STATE(1561)] = 71343,
  [SMALL_STATE(1562)] = 71354,
  [SMALL_STATE(1563)] = 71365,
  [SMALL_STATE(1564)] = 71376,
  [SMALL_STATE(1565)] = 71387,
  [SMALL_STATE(1566)] = 71398,
  [SMALL_STATE(1567)] = 71409,
  [SMALL_STATE(1568)] = 71420,
  [SMALL_STATE(1569)] = 71431,
  [SMALL_STATE(1570)] = 71442,
  [SMALL_STATE(1571)] = 71453,
  [SMALL_STATE(1572)] = 71464,
  [SMALL_STATE(1573)] = 71475,
  [SMALL_STATE(1574)] = 71486,
  [SMALL_STATE(1575)] = 71497,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1194),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(68),
  [71] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1322),
  [74] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1338),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1065),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1343),
  [83] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1554),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(216),
  [89] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(321),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(334),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1144),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1357),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(15),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(16),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(211),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(629),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(633),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(609),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(335),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1083),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1534),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1048),
  [131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(119),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(24),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(24),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(25),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(26),
  [146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2),
  [152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(68),
  [155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1554),
  [158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(216),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(321),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(334),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1341),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(15),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(16),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(211),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(629),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(633),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(609),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(335),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1048),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(119),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(24),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(24),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(25),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(26),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(68),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1554),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(216),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(321),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(334),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1341),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(15),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(16),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(211),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(629),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(633),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(609),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(335),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(1048),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(119),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(24),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(24),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(25),
  [267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT(26),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 1, .production_id = 1),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record, 1, .production_id = 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 1),
  [334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 1),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 1),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 1),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 2),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 2),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remote_constructor_name, 3, .production_id = 22),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_remote_constructor_name, 3, .production_id = 22),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_name, 1),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_name, 1),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, .production_id = 45),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, .production_id = 45),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_unit, 1),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_unit, 1),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_function_expression, 1),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [411] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1424),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(69),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1470),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(221),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(262),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(347),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1373),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(316),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(290),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(213),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(622),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(634),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(618),
  [451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(342),
  [454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(1045),
  [457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(352),
  [460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(142),
  [463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(142),
  [466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(63),
  [469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_seq, 2), SHIFT_REPEAT(139),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, .production_id = 31),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, .production_id = 31),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 21),
  [492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 21),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 1),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 1),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_access, 3, .production_id = 20),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_access, 3, .production_id = 20),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, .production_id = 8),
  [520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, .production_id = 8),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 6),
  [528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 6),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 2, .production_id = 9),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record, 2, .production_id = 9),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 5),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 5),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 7, .production_id = 66),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 7, .production_id = 66),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__maybe_record_expression, 1),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 4),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 4),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update, 7, .production_id = 70),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_update, 7, .production_id = 70),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function, 5, .production_id = 40),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function, 5, .production_id = 40),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 19),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 19),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_negation, 2),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_negation, 2),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment, 3, .production_id = 34),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment, 3, .production_id = 34),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 3, .production_id = 14),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 3, .production_id = 14),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 3, .production_id = 14),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 3, .production_id = 14),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use, 3, .production_id = 17),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use, 3, .production_id = 17),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 7, .production_id = 65),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 7, .production_id = 65),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert, 2, .production_id = 5),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert, 2, .production_id = 5),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_panic, 4, .production_id = 14),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_panic, 4, .production_id = 14),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_todo, 4, .production_id = 14),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_todo, 4, .production_id = 14),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment, 4, .production_id = 50),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment, 4, .production_id = 50),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use, 4, .production_id = 36),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use, 4, .production_id = 36),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 3),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 3),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 4),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 4),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_negation, 2),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_negation, 2),
  [710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_integer, 1), REDUCE(sym_integer, 2),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_integer, 1), REDUCE(sym_integer, 2),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 2),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 2),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 6, .production_id = 55),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 6, .production_id = 55),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5, .production_id = 39),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5, .production_id = 39),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 5),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 5),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string, 5),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_bit_string, 5),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [770] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1324),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_subjects, 2), SHIFT(64),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_case_subjects, 3), SHIFT(64),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1240] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1359),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, .production_id = 68),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 4, .production_id = 68),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 3, .production_id = 58),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause, 3, .production_id = 58),
  [1272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2),
  [1276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1472),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 1),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1302] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1361),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 1),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__maybe_record_expression, 1),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_identifier, 1),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_identifier, 1),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__maybe_tuple_expression, 1),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record, 1, .production_id = 1),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record, 1, .production_id = 1),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remote_type_identifier, 3, .production_id = 22),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_remote_type_identifier, 3, .production_id = 22),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 2),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2, .production_id = 2),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 2, .production_id = 3),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 2, .production_id = 3),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, .production_id = 1),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, .production_id = 1),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 5),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 5),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 37),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 37),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 3),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 3),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 2),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 2),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, .production_id = 24),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 4, .production_id = 24),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_var, 1),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_var, 1),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 3),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 3),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 13),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 13),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 2),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 2),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_value, 1),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_value, 1),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2),
  [1476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1488),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(620),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(625),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1118),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1046),
  [1491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1052),
  [1494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1023),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1023),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(810),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(992),
  [1506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clauses_repeat1, 2), SHIFT_REPEAT(1007),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 4),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 4),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 2),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 2),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clauses, 1),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 2, .production_id = 11),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 2, .production_id = 11),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 3),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 3),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 2),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 2),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 2),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 2),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 2),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 3),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_imports, 5),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unqualified_imports, 5),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 3),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 3),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameters, 4),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_parameters, 4),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 4),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 4),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 43),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 43),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 8, .production_id = 62),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 8, .production_id = 62),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 56),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 56),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_group, 5, .production_id = 23),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_group, 5, .production_id = 23),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_type, 4),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_type, 4),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function, 8, .production_id = 73),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function, 8, .production_id = 73),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 8, .production_id = 72),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 8, .production_id = 72),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 5),
  [1625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 5),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 6),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 6),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 5, .production_id = 51),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 5, .production_id = 51),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 5),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 5),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 13),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 13),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 5),
  [1649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 5),
  [1651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 5),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 5),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 3),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 3),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 6),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 6),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 3),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 3),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 4),
  [1677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 4),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 4),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 4),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2, .production_id = 5),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 2, .production_id = 5),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 4),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 4),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 7),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 7),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 10),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 10),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_arguments, 2),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record_arguments, 2),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_field_access, 3, .production_id = 21),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_field_access, 3, .production_id = 21),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, .production_id = 9),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, .production_id = 9),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 3),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 3),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 3),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 3),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 6, .production_id = 61),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 6, .production_id = 61),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 37),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 37),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 6, .production_id = 62),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 6, .production_id = 62),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple, 3),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_tuple, 3),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 5, .production_id = 38),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 5, .production_id = 38),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 6),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 6),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 7, .production_id = 69),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 7, .production_id = 69),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_seq, 1),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_seq, 1),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_body, 2),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function_body, 2),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_assert, 3, .production_id = 16),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_assert, 3, .production_id = 16),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard, 1),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard, 1),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record, 2, .production_id = 9),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_record, 2, .production_id = 9),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string, 2),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constant_bit_string, 2),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_list, 2),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_list, 2),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 5),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 5),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 5),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 7, .production_id = 43),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 7, .production_id = 43),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_arguments, 4),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_arguments, 4),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant, 4, .production_id = 27),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 4, .production_id = 27),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 54),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 54),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 9, .production_id = 74),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 9, .production_id = 74),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 4),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 4),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, .production_id = 53),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 6, .production_id = 53),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 64),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 64),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_hole, 1),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_hole, 1),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, .production_id = 25),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 4, .production_id = 25),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function, 9, .production_id = 75),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_external_function, 9, .production_id = 75),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target_group, 4, .production_id = 23),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_target_group, 4, .production_id = 23),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 7),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 7),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_patterns, 3),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 3),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_patterns, 2),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 2),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_clause_pattern, 3, .production_id = 46),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 3, .production_id = 46),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 2),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 3),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1963] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__maybe_tuple_expression, 1), REDUCE(sym__maybe_record_expression, 1), SHIFT(1438),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_subjects, 1),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, .production_id = 4),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, .production_id = 52),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_argument, 3, .production_id = 52),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2),
  [2187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1446),
  [2190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1379),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1054),
  [2196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1421),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1318),
  [2202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1436),
  [2205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1079),
  [2208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_target_group_repeat1, 2), SHIFT_REPEAT(1537),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 1, .production_id = 1),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constant_value, 1), REDUCE(sym__case_clause_guard_unit, 1),
  [2286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constant_value, 1), REDUCE(sym__case_clause_guard_unit, 1),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_unit, 1, .production_id = 57),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_unit, 1, .production_id = 57),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_expression, 1, .production_id = 6),
  [2311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_expression, 1, .production_id = 6),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_tuple_access, 3, .production_id = 20),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_tuple_access, 3, .production_id = 20),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_binary_expression, 3, .production_id = 19),
  [2325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_binary_expression, 3, .production_id = 19),
  [2327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__case_clause_guard_unit, 3),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__case_clause_guard_unit, 3),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1498),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_binary_expression, 3, .production_id = 19),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 4),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 6),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 2),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 5),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expression, 1, .production_id = 6),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, .production_id = 48),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 3),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, .production_id = 32),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, .production_id = 32),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 2),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, .production_id = 59),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, .production_id = 47),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 2, .production_id = 9),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, .production_id = 48),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 5),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 6, .production_id = 48),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 6, .production_id = 59),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_arguments, 3),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, .production_id = 47),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string, 4),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_guard, 2),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, .production_id = 32),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 3, .production_id = 33),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expression, 1),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 32),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(233),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [2563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1114),
  [2566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1064),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 2, .production_id = 46),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 46),
  [2585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 46), SHIFT_REPEAT(695),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructors, 1),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern_tail, 1),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_pattern, 1, .production_id = 7),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2),
  [2628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2), SHIFT_REPEAT(139),
  [2631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_pattern_repeat1, 2, .production_id = 46), SHIFT_REPEAT(675),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type, 1, .production_id = 1),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment_options, 1),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_bit_string_segment_options_repeat1, 2),
  [2658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(610),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignment, 1, .production_id = 7),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment_options, 1),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_patterns_repeat1, 2),
  [2671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_patterns_repeat1, 2), SHIFT_REPEAT(653),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, .production_id = 1),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 1, .production_id = 30),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 1, .production_id = 12),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 3),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pattern_bit_string_segment_options_repeat1, 2),
  [2702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pattern_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(614),
  [2705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_tuple_repeat1, 2), SHIFT_REPEAT(802),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_tuple_repeat1, 2),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 2),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_bit_string_segment_options_repeat1, 2),
  [2720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_bit_string_segment_options_repeat1, 2), SHIFT_REPEAT(613),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 2, .production_id = 26),
  [2725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_arguments_repeat1, 2), SHIFT_REPEAT(626),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_arguments_repeat1, 2),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment_options, 1),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause_patterns, 1),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [2744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameter, 1, .production_id = 12),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_assignments_repeat1, 2), SHIFT_REPEAT(659),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_assignments_repeat1, 2),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_type_arguments_repeat1, 2), SHIFT_REPEAT(873),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_type_arguments_repeat1, 2),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update_arguments, 1),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1390),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_record_arguments_repeat1, 2), SHIFT_REPEAT(727),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_record_arguments_repeat1, 2),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_bit_string_segment_option_size, 4),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_argument, 3, .production_id = 60),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__constant_bit_string_repeat1, 2), SHIFT_REPEAT(761),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__constant_bit_string_repeat1, 2),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment, 1, .production_id = 4),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unqualified_imports_repeat1, 2),
  [2843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unqualified_imports_repeat1, 2), SHIFT_REPEAT(1041),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern_argument, 1, .production_id = 35),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 2, .production_id = 2),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_arguments_repeat1, 2), SHIFT_REPEAT(723),
  [2861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_arguments_repeat1, 2),
  [2863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_update_arguments_repeat1, 2), SHIFT_REPEAT(1238),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_update_arguments_repeat1, 2),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(143),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignments, 1),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 4),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_type, 3, .production_id = 54),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_bit_string_repeat1, 2), SHIFT_REPEAT(327),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_bit_string_repeat1, 2),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 3),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 2),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_bit_string_repeat1, 2), SHIFT_REPEAT(666),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_bit_string_repeat1, 2),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_arguments_repeat1, 2), SHIFT_REPEAT(828),
  [2942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructor_arguments_repeat1, 2),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string_segment_option, 1),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 6),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment, 1, .production_id = 4),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 5),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 1, .production_id = 1),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_param, 1, .production_id = 1),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__discard_param, 1, .production_id = 1),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 4),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_bit_string_segment_option_size, 4),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_subjects, 2),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(880),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [3053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(836),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment, 1, .production_id = 15),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_tuple_type, 5),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constant_tuple_type_repeat1, 2), SHIFT_REPEAT(918),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constant_tuple_type_repeat1, 2),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_type, 4, .production_id = 64),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__labeled_discard_param, 2, .production_id = 42),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_arguments, 3),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__labeled_name_param, 2, .production_id = 42),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_bit_string_segment_option_size, 4),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2), SHIFT_REPEAT(973),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameters_repeat1, 2),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type, 2, .production_id = 9),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bit_string_segment_option, 4),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_parameters_repeat1, 2), SHIFT_REPEAT(1024),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_parameters_repeat1, 2),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [3217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_external_function_parameters_repeat1, 2), SHIFT_REPEAT(838),
  [3220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_external_function_parameters_repeat1, 2),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameter, 2, .production_id = 29),
  [3226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameter, 3, .production_id = 67),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 3),
  [3230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 5),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hole, 1),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, .production_id = 41),
  [3240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 1),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 4),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter, 2, .production_id = 29),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_assignment, 2, .production_id = 18),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_argument, 3, .production_id = 52),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_bit_string_segment, 3, .production_id = 28),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameter, 1, .production_id = 44),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 4, .production_id = 71),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 1),
  [3286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 5),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, .production_id = 9),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_argument, 1, .production_id = 4),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 2),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_parameters, 2),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unqualified_import, 3, .production_id = 63),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 3),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_record_argument, 1, .production_id = 4),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_value, 3, .production_id = 52),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_argument, 3, .production_id = 52),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_bit_string_segment, 3, .production_id = 49),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type_argument, 1),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_arguments, 4),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_bit_string_segment, 3, .production_id = 28),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_spread, 1),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 2),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_spread, 2),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 3),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern_tail, 2),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 5),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 5),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constant_type_annotation, 2, .production_id = 26),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_target, 1),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 4),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [3530] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_types, 2),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 3),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_function_parameter_types, 4),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 2),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 5),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 3),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_external_function_parameters, 4),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_gleam_external_scanner_create(void);
void tree_sitter_gleam_external_scanner_destroy(void *);
bool tree_sitter_gleam_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_gleam_external_scanner_serialize(void *, char *);
void tree_sitter_gleam_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_gleam(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_gleam_external_scanner_create,
      tree_sitter_gleam_external_scanner_destroy,
      tree_sitter_gleam_external_scanner_scan,
      tree_sitter_gleam_external_scanner_serialize,
      tree_sitter_gleam_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
